c***********************  problem name: usmap **************************
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine a1xy(x,y,u,ux,uy,rl,itag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(*) :: values
            character(len=80) :: su
            common /val0/k0,ku,kx,ky,kl
            common /atest2/iu(100),a1x,a1y,a1u,a2x,a2y,a2u,
     +          bux,buy,cu0,cu1,ru(90),su(100)
cy
        values(k0)=a1x*ux+a1y*uy+a1u*u
        values(ku)=a1u
        values(kx)=a1x
        values(ky)=a1y
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine a2xy(x,y,u,ux,uy,rl,itag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(*) :: values
            character(len=80) :: su
            common /val0/k0,ku,kx,ky,kl
            common /atest2/iu(100),a1x,a1y,a1u,a2x,a2y,a2u,
     +          bux,buy,cu0,cu1,ru(90),su(100)
cy
        values(k0)=a2x*ux+a2y*uy+a2u*u
        values(ku)=a2u
        values(kx)=a2x
        values(ky)=a2y
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine fxy(x,y,u,ux,uy,rl,itag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(*) :: values
            character(len=80) :: su
            common /val0/k0,ku,kx,ky,kl
            common /atest2/iu(100),a1x,a1y,a1u,a2x,a2y,a2u,
     +          bux,buy,cu0,cu1,ru(90),su(100)
cy
        values(k0)= - bux*ux - buy*uy - cu0 - cu1*u
        values(ku)= - cu1
        values(kx) = - bux
        values(ky) = - buy
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine gnxy(x,y,u,rl,itag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(*) :: values
            common /val1/k0,ku,kl
cy
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine gdxy(x,y,rl,itag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(*) :: values
            common /val2/k0,kl,klb,kub,kic,kim,kil
cy
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine p1xy(x,y,u,ux,uy,rl,itag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(*) :: values
            common /val0/k0,ku,kx,ky,kl
cy
        values(k0)=1.0e0_rknd
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine p2xy(x,y,dx,dy,u,ux,uy,rl,itag,jtag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(*) :: values
            common /val0/k0,ku,kx,ky,kl
cy
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine qxy(x,y,u,ux,uy,rl,itag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(*) :: values
            common /val3/kf,kf1,kf2,kad
cy
        s=x**2+y**2
        values(kf)=real(itag,rknd)
        values(kad)=s
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine sxy(rl,s,itag,values)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            real(kind=rknd), dimension(2,*) :: values
            common /val4/j0,js,jl
cy
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine usrcmd(vx,vy,sf,itnode,ibndry,ip,rp,sp,iu,ru,su)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(5,*) :: itnode
            integer(kind=iknd), dimension(7,*) :: ibndry
            integer(kind=iknd), dimension(100) :: ip,iu
            real(kind=rknd), dimension(*) :: vx,vy
            real(kind=rknd), dimension(2,*) :: sf
            real(kind=rknd), dimension(100) :: rp,ru
            character(len=80), dimension(100) :: sp,su
cy
        istate=iu(1)
        icty=iu(2)
        isle=iu(3)
        eps=ru(11)
c
        call usrset(iu,ru,su)
c
        if(istate/=iu(1)) ip(41)=-1
        if(icty/=iu(2)) ip(41)=-1
        if(isle/=iu(3)) ip(41)=-1
        if(eps/=ru(12)) ip(41)=-1
c
        ispd=ip(8)
        a1x=ru(1)
        a1y=ru(2)
        a1u=ru(3)
        a2x=ru(4)
        a2y=ru(5)
        a2u=ru(6)
        bux=ru(7)
        buy=ru(8)
        cu0=ru(9)
        cu1=ru(10)
        if(ispd==1) then
            if((a1y/=a2x).or.(a1u/=0.0e0_rknd).or.
     +      (a2u/=0.0e0_rknd).or.(bux/=0.0e0_rknd).or.
     1      (buy/=0.0e0_rknd)) ip(8)=0
        else
            if((a1y==a2x).and.(a1u==0.0e0_rknd).and.
     +      (a2u==0.0e0_rknd).and.(bux==0.0e0_rknd).and.
     1      (buy==0.0e0_rknd)) ip(8)=1
        endif
        if(ispd/=ip(8)) ip(5)=max(ip(5),1)
c
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine usrfil(file,len)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), save :: len0
            character(len=80), save, dimension(100) :: file0
            character(len=80), dimension(*) :: file
cy
            data (file0(i),i=  1, 10)/
     +  'n i= 1,n=istate,a=is,t=i',
     1  'n i= 2,n=icty  ,a=ic,t=i',
     2  'n i= 3,n=isle  ,a=il,t=i',
     3  'n i= 1,n=a1x,   a=x1,t=r',
     4  'n i= 2,n=a1y,   a=y1,t=r',
     5  'n i= 3,n=a1u,   a=u1,t=r',
     6  'n i= 4,n=a2x,   a=x2,t=r',
     7  'n i= 5,n=a2y,   a=y2,t=r',
     8  'n i= 6,n=a2u,   a=u2,t=r',
     9  'n i= 7,n=bux,   a=bx,t=r'/
            data (file0(i),i= 11, 20)/
     +  'n i= 8,n=buy,   a=by,t=r',
     1  'n i= 9,n=cu0,   a=c0,t=r',
     2  'n i=10,n=cu1,   a=c1,t=r',
     3  's n=istate,v= 1,l="alabama"',
     4  's n=istate,v= 2,l="alaska"',
     5  's n=istate,v= 3,l="arizona"',
     6  's n=istate,v= 4,l="arkansas"',
     7  's n=istate,v= 5,l="california"',
     8  's n=istate,v= 6,l="colorado"',
     9  's n=istate,v= 7,l="connecticut"'/
            data (file0(i),i= 21, 30)/
     +  's n=istate,v= 8,l="deleware"',
     1  's n=istate,v= 9,l="florida"',
     2  's n=istate,v=10,l="georgia"',
     3  's n=istate,v=11,l="hawaii"',
     4  's n=istate,v=12,l="idaho"',
     5  's n=istate,v=13,l="illinois"',
     6  's n=istate,v=14,l="indiana"',
     7  's n=istate,v=15,l="iowa"',
     8  's n=istate,v=16,l="kansas"',
     9  's n=istate,v=17,l="kentucky"'/
            data (file0(i),i= 31, 40)/
     +  's n=istate,v=18,l="louisiana"',
     1  's n=istate,v=19,l="maine"',
     2  's n=istate,v=20,l="maryland"',
     3  's n=istate,v=21,l="massachusetts"',
     4  's n=istate,v=22,l="michigan"',
     5  's n=istate,v=23,l="minnesota"',
     6  's n=istate,v=24,l="mississippi"',
     7  's n=istate,v=25,l="missouri"',
     8  's n=istate,v=26,l="montana"',
     9  's n=istate,v=27,l="nebraska"'/
            data (file0(i),i= 41, 50)/
     +  's n=istate,v=28,l="nevada"',
     1  's n=istate,v=29,l="new hampshire"',
     2  's n=istate,v=30,l="new jersey"',
     3  's n=istate,v=31,l="new mexico"',
     4  's n=istate,v=32,l="new york"',
     5  's n=istate,v=33,l="north carolina"',
     6  's n=istate,v=34,l="north dakota"',
     7  's n=istate,v=35,l="ohio"',
     8  's n=istate,v=36,l="oklahoma"',
     9  's n=istate,v=37,l="oregon"'/
            data (file0(i),i= 51, 60)/
     +  's n=istate,v=38,l="pennsylvania"',
     1  's n=istate,v=39,l="rhode island"',
     2  's n=istate,v=40,l="south carolina"',
     3  's n=istate,v=41,l="south dakota"',
     4  's n=istate,v=42,l="tennessee"',
     5  's n=istate,v=43,l="texas"',
     6  's n=istate,v=44,l="utah"',
     7  's n=istate,v=45,l="vermont"',
     8  's n=istate,v=46,l="virginia"',
     9  's n=istate,v=47,l="washington"'/
            data (file0(i),i= 61, 69)/
     +  's n=istate,v=48,l="west virginia"',
     1  's n=istate,v=49,l="wisconsin"',
     2  's n=istate,v=50,l="wyoming"',
     3  's n=istate,v=51,l="united states"',
     4  's n=icty  ,v=0,l="no county lines"',
     5  's n=icty  ,v=1,l="county lines"',
     6  's n=isle  ,v=0,l="no small islands"',
     7  's n=isle  ,v=1,l="small islands"',
     8  'n i=11,n=eps,   a=e,t=r'/
c
            data len0/69/
c
        len=len0
        do i=1,len
            file(i)=file0(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine gdata(vx,vy,sf,itnode,ibndry,ip,rp,sp,iu,ru,su,sxy)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(5,*) :: itnode
            integer(kind=iknd), dimension(7,*) :: ibndry
            integer(kind=iknd), dimension(100) :: ip,iu
            integer(kind=iknd), dimension(7000) :: ix,iy,ib1,ib2
            integer(kind=iknd), dimension(5) :: ib,jb,jv
            integer(kind=iknd), save :: ifirst
            real(kind=rknd), dimension(*) :: vx,vy
            real(kind=rknd), dimension(2,*) :: sf
            real(kind=rknd), dimension(100) :: rp,ru
            real(kind=rknd), save :: hmax,grade
            character(len=80), dimension(100) :: sp,su
            character(len=80) :: state
cy
c       map of states in the united states
c
            external sxy
            data hmax,grade/0.1e0_rknd,1.5e0_rknd/
            data ifirst/1/
c
c
        if(ip(41)==1) then
             iu(1)=51
             iu(2)=1
             iu(3)=0
c
c       initialize as laplacian with dirichlet b.c.
c
            do i=1,10
                ru(i)=0.0e0_rknd
            enddo
            ru(1)=1.0e0_rknd
            ru(5)=1.0e0_rknd
            ru(9)=1.0e0_rknd
            ru(11)=1.0e-2_rknd
            ip(8)=1
c
            sp(4)='usmap'
            sp(5)='usmap_figxxx.ext'
            sp(6)='usmap_mpixxx.rw'
            sp(7)='usmap.jnl'
            sp(9)='usmap_mpixxx.out'
        endif
c
        ip(5)=max(ip(5),ifirst)
        ip(6)=1
c
c
        istate=iu(1)
        if(istate<1.or.istate>51) istate=51
        icty=iu(2)
        if(icty/=0) icty=1
        isle=iu(3)
        if(isle/=1) isle=0
c
        if (istate==1) then
            call al(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==2) then
            call ak(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
c
c       fixup for alaska
c
            if(isle==0) then
                isle=1
                npart=1
            endif
        else if (istate==3) then
            call az(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==4) then
            call ar(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==5) then
            call ca(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==6) then
            call co(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==7) then
            call ct(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==8) then
            call de(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==9) then
            call fl(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==10) then
            call ga(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==11) then
            call hi(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
c
c       fixup for hawaii
c
            isle=1
        else if (istate==12) then
            call id(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==13) then
            call il(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==14) then
            call in(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==15) then
            call ia(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==16) then
            call ks(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==17) then
            call ky(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==18) then
            call la(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==19) then
            call me(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==20) then
            call ml(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==21) then
            call ma(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==22) then
            call mi(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==23) then
            call mn(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==24) then
            call ms(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==25) then
            call mo(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==26) then
            call mt(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==27) then
            call nb(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==28) then
            call nv(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==29) then
            call nh(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==30) then
            call nj(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==31) then
            call nm(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==32) then
            call ny(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==33) then
            call nc(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==34) then
            call nd(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==35) then
            call oh(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==36) then
            call ok(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==37) then
            call og(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==38) then
            call pa(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==39) then
            call ri(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==40) then
            call sc(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==41) then
            call sd(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==42) then
            call tn(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==43) then
            call tx(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==44) then
c***        call ut(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
c
c       fixup for salt lake
c
            call uh(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
            if(icty==1) ib(1)=ib(1)+208
        else if (istate==45) then
            call vt(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==46) then
            call va(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==47) then
            call wa(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==48) then
            call wv(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==49) then
            call wi(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==50) then
            call wy(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        else if (istate==51) then
            call us(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
        endif
c
        sp(2)=state
        sp(1)=state
        sp(3)=state
c
        nvf=0
        nbf=0
        ntf=1
        do nn=1,npart
            nvf0=nvf
            nbf0=nbf
            nbound=nbf0+ib(nn)
            if(jb(nn+1)-jb(nn)==ib(nn).and.isle==0) cycle
            if(icty==1) then
                j1=jv(nn+1)-1
                j2=jb(nn+1)-1
            else
                j1=jv(nn)+ib(nn)-1
                j2=jb(nn)+ib(nn)-1
            endif
            if(irot==0) then
                do j=jv(nn),j1
                    nvf=nvf+1
                    vx(nvf)=real(ix(j),rknd)
                    vy(nvf)=real(iy(j),rknd)
                enddo
            else
                do j=jv(nn),j1
                    nvf=nvf+1
                    vx(nvf)=real(iy(j),rknd)
                    vy(nvf)=-real(ix(j),rknd)
                enddo
            endif
            do j=jb(nn),j2
                nbf=nbf+1
                ibndry(1,nbf)=ib1(j)+nvf0
                ibndry(2,nbf)=ib2(j)+nvf0
                ibndry(3,nbf)=0
                ibndry(4,nbf)=2
                if(nbf>nbound) ibndry(4,nbf)=0
                ibndry(5,nbf)=0
                ibndry(6,nbf)=0
                ibndry(7,nbf)=0
            enddo
        enddo
        do i=1,nbf
            sf(1,i)=0.0e0_rknd
            sf(2,i)=0.0e0_rknd
        enddo
c
        eps=ru(11)
        call fixdg2(nvf,nbf,vx,vy,sf,ibndry,eps)
        ip(1)=ntf
        ip(2)=nvf
        ip(3)=nbf
        ip(20)=5
        rp(12)=hmax
        rp(13)=grade
c
c       make itnode
c
        call sklutl(0_iknd,vx,vy,sf,itnode,ibndry,ip,rp,iflag,sxy)
c
c
        nvf=ip(2)
        nbf=ip(3)
        call box(nvf,vx,vy,nbf,ibndry,sf)
c
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine box(nvf,vx,vy,nbf,ibndry,sf)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(7,*) :: ibndry
            real(kind=rknd), dimension(*) :: vx,vy
            real(kind=rknd), dimension(2,*) :: sf
cy
c       rescale domain to lie inside the unit square
c
        xmin=vx(1)
        xmax=xmin
        ymin=vy(1)
        ymax=ymin
        do i=1,nvf
            xmin=min(xmin,vx(i))
            xmax=max(xmax,vx(i))
            ymin=min(ymin,vy(i))
            ymax=max(ymax,vy(i))
        enddo
c
c       compute scaled coordinates
c
        xmid=(xmin+xmax)/2.0e0_rknd
        ymid=(ymin+ymax)/2.0e0_rknd
        scale=1.0e0_rknd/max(xmax-xmin,ymax-ymin)
        do i=1,nvf
            vx(i)=0.5e0_rknd+scale*(vx(i)-xmid)
            vy(i)=0.5e0_rknd+scale*(vy(i)-ymid)
        enddo
        do i=1,nbf
            if(ibndry(3,i)==0) cycle
            sf(1,i)=0.5e0_rknd+scale*(sf(1,i)-xmid)
            sf(2,i)=0.5e0_rknd+scale*(sf(2,i)-ymid)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine al(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1960) :: jx,jy
            integer(kind=iknd), save, dimension(2020) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'alabama       '/
            data jrot,ipart/0,2/
            data kv/   1,1879,1952,   0,   0/
            data kb/   1,1945,2018,   0,   0/
            data iib/ 309,  73,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  10416,18864,27408,22920, 9984,35088,34344, 9624,36264, 9288,
     1   8544,37272,38040, 7848,39024,40416, 6936,39936,39312, 6432,
     2  39792, 6672,35904,14904,28944,23976,10800,10152, 9912, 9432,
     3   9456,34128,38544,38592,38760,38832,38712,38712,39144,38976,
     4  40176,39648,39624,39528,39576,39360,39504,39504,39264,39216,
     5  39264,39192,40488,40704,40776,40632,40728,40560,40704,40608,
     6  40584,40392,40392,41040,41520,41352,41184,41184,41280,41184,
     7  40728,40656,40824,40368,39888,40008,39936,39960,39816,39840,
     8  39672,39696,39408,39456,39432,39216,39264,39168,39240,39168,
     9   6360,39384,39336,39768,39744,39960,40032,40176,40128,39936/
            data (jx(i),i=  101,  200)/
     +  39960,39864,39864,39720,39816,39744,39576,39528,39720,39624,
     1  39720,39744,39912,40416,40440,40608,40704,23136,14880,16512,
     2  16584,16416,16392,16584,16704,16800,16896,16896,16776,16368,
     3  16104,16056,15864,15552,15408,15072,14880,14832,14640,14592,
     4  14520,14976,14976, 6864, 7080, 7032, 7104, 7176, 7200, 7272,
     5   7488, 7680, 7728, 7680, 7800, 7896, 8016, 7992, 8256, 8592,
     6   8736, 8976, 9000, 8928, 8856, 8928, 8880, 9288, 9240, 9360,
     7   9384, 9480, 9504, 9360, 9456, 9744, 9816, 9768, 9792, 9744,
     8   9864, 9816,10032, 9984, 9792, 9720, 9552, 9576, 9672, 9744,
     9   9864, 9744, 9840,10008,10272,10272,10320,10320,10536,10512/
            data (jx(i),i=  201,  300)/
     +  10656,12792,11136,10512,10632,11160,11232,11280,11208,11328,
     1  11304,11400,11520,11664,11832,12144,12576,13032,13152,13368,
     2  13440,13416,13512,13608,13488,13440,13320,13248,13128,12720,
     3  12504,12456,12504,12672,12576,12504,12384,12360,12432,12360,
     4  12144,11736,11616,11472,11808,11808,11688,11736,11664,11688,
     5  11592,11616,11496,11568,11544,11400,14640,15240,15240,15096,
     6  15240,15216,15432,15696,15696,15624,15360,15240,15000,14712,
     7  14712,14880,14784,14784,14688,14808,14688,14832,14952,15000,
     8  15120,15000,15072,15168,15240,15288,15408,15480,15648,15720,
     9  15624,15600,15672,15672,15768,15768,15816,15840,15888,15936/
            data (jx(i),i=  301,  400)/
     +  16008,16200,16344,16368,16536,16848,16920,16536,16464,16800,
     1  16224,16008,15984,15672,15288,15168,14112,13896,13632,13176,
     2  12864,12096,11952,11808,11616,10968,10608,18816,18432,18240,
     3  18240,18384,17520,17688,17952,18144,15816,16008,15960,16056,
     4  16296,16272,16464,16608,16560,16800,16728,16848,16800,16896,
     5  16872,16752,18672,19152,19584,19680,19872,19800,27408,27888,
     6  27912,27840,27576,27408,27288,27288,27408,27144,27144,27048,
     7  27240,27096,27192,27120,27192,26976,26976,27312,27240,27288,
     8  23904,23712,23592,23184,22872,20400,20544,21576,21984,15816,
     9  22440,25176,25080,24888,24576,24240,24024,29880,29616,29568/
            data (jx(i),i=  401,  500)/
     +  29496,29496,29376,29328,29280,29208,29040,28992,31968,31944,
     1  32280,32280,32640,33552,33624,34008,33984,34080,34008,34128,
     2  34200,34272,34248,34368,34344,34464,34440,34536,34464,34632,
     3  34656,34776,34872,34992,34992,30408,30792,31008,32448,33312,
     4  33528,33648,33888,33936,34176,25320,25656,25944,26112,26352,
     5  26496,26640,26712,26688,26784,26904,27024,27240,27288,27240,
     6  27456,27480,27264,27264,27552,27480,27504,15792,14784,24864,
     7  24864,19824,26112,26136,26064,26040,25872,25872,19416,19800,
     8  29376,29448,27552,28656,29448,26208,26184,26568,14760,16056,
     9  18600,18792,18936,19032,19200,31992,32064,32280,32424,32472/
            data (jx(i),i=  501,  600)/
     +  32424,33024,33000,35016,35352,35352,36024,36024,35016,27288,
     1  26904,27288,27288,27384,11376,11376,11712,11712,14736,34992,
     2  34344,34344,33984,34008,34488,34488,34344,34344,34152,34152,
     3  34008,34008,33936,33936,33864,33864,33528,33528,33192,33192,
     4  33024,33000,32496,25800,25680,25488,25416,25416,25296,25200,
     5  25248,25152,25200,25128,25224,24960,24864,24792,24816,24696,
     6  24672,24720,24576,24480,24336,24336,24216,24168,24048,24000,
     7  23880,23832,23712,23904,23880,23784,23712,23664,23736,23640,
     8  23568,23520,23328,23352,23160,23208,23160,23016,23064,22968,
     9  22872,22920,22872,22584,22584,22464,22392,22224,22224,22032/
            data (jx(i),i=  601,  700)/
     +  21960,22008,21960,21768,21672,21600,21648,21456,21336,21384,
     1  21240,21264,21216,19536,19560,19824,19800,19848,20016,20088,
     2  19896,19992,20808,20808,27408,27360,27432,27816,27912,28056,
     3  28344,28560,28872,28896,29088,29136,29208,29256,29448,29424,
     4  29520,29520,29712,29808,29904,29976,29880,32976,32304,31968,
     5  31968,31632,31632,31464,31464,31128,31128,30960,30960,30792,
     6  30792,30624,30624,30552,30552,30288,30288,30024,30024,21216,
     7  21312,21312,27144,27168,26376,26088,25896,25728,25584,25488,
     8  24936,24936,21480,21984,23184,24264,24264,29856,30000,29880,
     9  29880,30072,30096,29952,29712,29568,29400,29352,29208,29136/
            data (jx(i),i=  701,  800)/
     +  29112,16776,16776,15768,15744,14736,32520,30576,30576,30336,
     1  30264,30120,30048,25272,25272,25368,25368,25440,25464,25368,
     2  25368,25296,25296,25200,25200,25296,25296,25536,25536,11712,
     3  12744,14760,14760,14424,14424,13680,21312,21144,21144,20808,
     4  20808,20640,20640,20568,20568,20472,20472,20328,20304,19968,
     5  19968,19464,19464,19128,19128,18960,18888,18960,19080,18936,
     6  18816,18576,18432,18360,18312,18240,18216,18288,17784,17784,
     7  17280,17280,32496,31968,31968,31800,31800,31632,31632,32640,
     8  32640,32808,32808,33984,36888,36864,36792,36792,28992,28896,
     9  28848,28776,28584,28560,28848,28944,28896,28608,28608,28752/
            data (jx(i),i=  801,  900)/
     +  28704,28464,28392,28512,28680,28680,28392,28272,28056,27984,
     1  27960,27816,27768,27768,27672,27576,27432,27192,27024,26880,
     2  25872,25872,26880,18336,18312,18192,18072,18096,18000,17952,
     3  17832,17688,17568,17616,17616,17832,17832,18120,18120,18288,
     4  18288,18408,18408,18456,18456,18624,18624,18792,18792,18960,
     5  18960,19128,19128,19296,19296,19632,19632,20016,20016,20232,
     6  20232,20616,25536,25296,25296,25128,25128,25032,25032,24864,
     7  24864,24792,24768,24696,24696,24024,24024,23856,23856,23760,
     8  23760,23592,23592,23256,23256,23184,23184,23016,23016,22752,
     9  22680,22512,22512,22008,22008,21912,21840,21744,21744,21576/
            data (jx(i),i=  901, 1000)/
     +  21576,21360,21384,21168,21168,21024,21048,12744,31464,31464,
     1  31296,31296,31128,31128,30792,30768,29424,29400,28896,28896,
     2  34536,33960,33960,34032,34032,34008,34032,33960,25824,26904,
     3  27144,27240,27192,27000,27000,27072,26688,26520,26352,26448,
     4  26352,26184,26040,26088,26040,25848,25776,25680,25848,25896,
     5  26088,26112,25872,30504,30840,30840,30504,20616,20664,20616,
     6  21168,21168,21336,21336,21504,21504,21648,21672,21864,21864,
     7  22032,20112,19848,19680,19680,19416,19320,19320,18936,18936,
     8  18144,17832,17760,16752,25560,25536,25680,25608,22008,24648,
     9  24576,24600,24744,24768,25080,25128,25272,25368,12720,12792/
            data (jx(i),i= 1001, 1100)/
     +  12768,13944,13896, 9456, 9504, 9744, 9696, 9768,10008,10104,
     1  10344,10416,10488,10680,10800,10776,10848,10896,11472,11592,
     2  11640,16776,20688,22080,22056,17760,17760,16752,16272,16248,
     3  15744,15744,30552,30480,30552,30552,25512,25632,25560,25584,
     4  25680,25824,25944,26208,26256,26112,26160,26304,26280,26448,
     5  26592,26784,26952,27336,27336,27504,27504,37608,37560,36432,
     6  36432,36336,36336,36192,36192,35688,35688,35592,35592,34848,
     7  34848,34752,34752,34608,20688,26592,26592,27000,20712,21672,
     8  23664,23664,34440,34440,33744,33768,33600,33624,16224,16728,
     9  16728,19776,19920,20088,20064,20496,20400,20424,20568,20544/
            data (jx(i),i= 1101, 1200)/
     +  12528,12432,12312,12336,12096,12120,12288,12456,12408,12480,
     1  12528,12648,12480,12288,12024,11880,11784,11280,10560,10320,
     2  10320,10560,10584,10536,10704,10584,10512,10200, 9960,10272,
     3  10320,10104,10032,10128,10368,10488,10392,10128, 9816, 9744,
     4   9648, 9552, 9384, 9336, 9504, 9624, 9360, 9288, 9096, 9192,
     5   9384, 9456, 9456, 9360, 9288, 9360, 9504, 9600, 9480,12912,
     6  13056,13056,13176,13176,13224,13344,13368,13488,13680,13560,
     7  13200,13056,12912,12960,13320,13512,13608,13536,13344,13176,
     8  13104,13200,13104,13104,12984,12912,12816,12768,12792,12984,
     9  13032,12840,12720,12720,12456,12384,12432,12576,12888,12888/
            data (jx(i),i= 1201, 1300)/
     +  12936,12888,12912,12864,12912,12744,12792,12888,12768,12744,
     1  12888,12864,12960,12912,13008,13032,13224,13296,13392,13464,
     2  13320,13320,13416,13464,13560,13512,13656,13752,13752,13584,
     3  13680,13608,13560,13728,13800,13968,13992,12888,12816,12816,
     4  12888,12792,12600,33456,33456,32616,32640,31776,30888,30888,
     5  31056,31080,31800,31800,31656,31704,31536,31488,31608,31728,
     6  31680,31776,31704,13752,13728,31920,32088,31872,31800,31848,
     7  31728,31344,31104,30888,30840,30912,30816,30744,30696,30744,
     8  30720,30576,30432,39840,39864,37176,37224,36192,36144,35592,
     9  33960,33960,33624,26640,30288,30216,29904,29808,29520,29496/
            data (jx(i),i= 1301, 1400)/
     +  29400,29424,29208,29136,29016,28920,28800,28752,28896,28800,
     1  28680,28584,28464,28416,28488,28416,28344,28320,28080,28056,
     2  28104,27912,27840,27744,27672,27576,27648,27480,27672,27624,
     3  27528,27216,26760,26784,26376,26160,26136,26016,25848,25872,
     4  25776,21648,21840,21816,22008,22008,22152,22224,22176,22344,
     5  22584,22416,22368,22416,22656,22752,22680,22632,22632,22728,
     6  22848,22920,23088,22992,23016,23064,23352,23592,23640,23616,
     7  23688,24000,24240,24264,24552,24648,24648,24840,24960,25032,
     8  25296,25464,12648,12624,12528,12000,11616,11448,11328,11136,
     9  10704,10632,10896,11208,11352,11424,11544,11640,11736,15720/
            data (jx(i),i= 1401, 1500)/
     +  30552,30528,30720,30768,30984,31152,31464,16248,36240,31656,
     1  31656,31872,31944,31896,32112,16464,16560,16608,16896,16992,
     2  17064,17064,17184,17232,17688,17712,17928,18024,18072,18384,
     3  18288,18384,18528,18576,18672,19032,18984,19128,19104,21792,
     4  36480,36312,39504,39504,39408,39408,38736,38616,38592,38304,
     5  38184,37968,37968,30816,30816,30672,30720,25800,25944,25920,
     6  25992,25848,25968,26184,26352,26448,26520,26664,26712,22344,
     7  22344,22584,22272,22200,22488,22584,22728,22728,21768,11760,
     8  11712,11592,11688,11640,11400,11328,11256,11160,10992,11016,
     9  10872,10848,10968,10896,10968,10920,10992,10872,10824,10656/
            data (jx(i),i= 1501, 1600)/
     +  10536,10608,10368,10128, 9888, 9936, 9888, 9936,10128,10152,
     1  10296,15888,15720,15744,14736,14736,14304,14304,30744,28824,
     2  27744,27720,26304,26736,22272,22272,36480,36312,36312,36000,
     3  35976,35904,35904,35496,35496,35328,35280,34752,34512,34152,
     4  34080,32784,32784,31848,31848,31752,31752,31560,31560,31176,
     5  31200,31056,31080,30912,30888,30864,10368,10272,10320,10224,
     6  10152,10080, 9816, 9864,10008,10128,10344,10488,10440,10272,
     7  10152, 9768, 9600, 9480, 9360, 9216, 9432, 9624, 9840, 9960,
     8  10080,10128,21768,21792,14304,14592,14736,14760,15936,36504,
     9  36504,38448,38592,38736,39024,21792,33240,33336,33480,33504/
            data (jx(i),i= 1601, 1700)/
     +  33600,33648,33984,34032,33936,33936,33984,32832,29304,28992,
     1  29016,28920,28920,28776,28776,29256,29280,29280,29160,29112,
     2  28968,28968,26328,26400,26400,26328,26328,26376,26376,26328,
     3  26304,25800,25824,23808,22464,22416,22200,21768,32856,28848,
     4  28824,29208,29208,29328,26808,26784,27024,27168,27408,27816,
     5  27984,28008,28176,28176,36552,15936,15768,15768,15264,15288,
     6  14712,14880,15312,15192,14928,14832,14712,14544,14400,14280,
     7  14064,13896,13680,13704,13560,13416,13416,13392,13296,13296,
     8  13104,13128,13296,21480,21264,21168,20736,20400,20256,20304,
     9  20256,20136,19968,19560,19488,19320,19200,19200,18888,18768/
            data (jx(i),i= 1701, 1800)/
     +  18576,18144,17952,17688,17592,17448,17280,16896,16656,16632,
     1  13584,13800,14328,14544,14760,15168,15432,15648,16008,33648,
     2  33768,33840,34008,33984,34200,34632,35880,35880,36552,11472,
     3  11448,11544,11616,11496,11352,11256,11064,11208,11400,11424,
     4  11376,11472,11328,11304,11520,11664,11736,11856,11784,11808,
     5  11880,12072,11928,11856,11736,11784,11688,11544,11496,11616,
     6  11664,11856,11904,11808,11688,11856,11760,11616,11808,11784,
     7  11904,11712,11544,11232,11184,10680,10584,10800,10752,10488,
     8  10200,10248,10152,10104,10224,28872,23832,23832,23856,24120,
     9  24192,24096,23832,13224,13008,12888,12840,13080,12936,12672/
            data (jx(i),i= 1801, 1900)/
     +  12600,12408,12552,12480,12576,12528,12384,12288,12432,12336,
     1  12240,12192,12168,12072,11952,11880,11808,29640,29640,29544,
     2  29544,23208,23112,23208,23136,23184,23136,23232,23184,23280,
     3  23448,23520,23496,23664,23640,11520,11208,11040,10728, 7656,
     4   7656,35880,14736,23856,23976,11280,11544,11472,11160,11304,
     5  11472,11520,11520,11352,11424,11280,11352,11280,11448,11520,
     6  11640,11664,11400,11328,11088,11040,11112,11400,11448,11040,
     7  10992,10776,10680,10704,10656,10752,10776,10896,10656,10728,
     8  10632,10584,15336,15528,15504,15360, 9792, 9648, 9600, 9624,
     9   9672, 9888, 9912, 9480, 9408, 9480,15960,16248,16224,15528/
            data (jx(i),i= 1901, 1960)/
     +  15792, 8568, 8640, 8616, 8544, 8688, 8712, 8736, 8736, 8256,
     1   8208, 8232, 8208, 8232, 8328, 7056, 6984, 7056, 6888, 6888,
     2   6960, 7896, 7824, 7872, 7080, 7152, 7104, 9816, 9816, 9744,
     3   9648,10224,10200,10296,10320, 9840, 9456, 8952, 7824, 7656,
     4   9120, 9552, 9552, 9648, 9840, 9984,10056,10056, 7368, 7368,
     5   7536,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  60720,61848,61776,61776,57096,56472,60360,54072,50016,51048,
     1  45000,44472,40152,38736,36000,33288,30864,28104,24648,23832,
     2  19392,17088,15744,15648,15624,15624,12024,60840,61080,61944,
     3  62016,61776,37320,37248,37248,37128,36984,36696,36360,36192,
     4  33648,34248,34464,34608,34728,34800,34992,35040,35400,35688,
     5  35880,35952,32664,32472,32328,32136,31944,31872,31752,31704,
     6  31584,31368,31200,30888,30456,30336,30312,30240,30216,29976,
     7  29904,29784,29688,29496,28944,28440,28320,27600,27336,27048,
     8  26904,26688,26376,26304,26184,26112,25968,25512,25200,24864,
     9  26160,24312,23904,23400,23232,23064,22464,22128,21816,21360/
            data (jy(i),i=  101,  200)/
     +  20832,20760,20424,20040,19608,19224,19104,18984,18456,18024,
     1  17952,17712,17664,16968,16704,16440,15864,15672,15696, 9744,
     2   9768, 9984,10200,10584,10656,11088,11184,11688,11952,12216,
     3  12288,12432,12480,12744,13176,13536,13632,13776,13920,14088,
     4  14160,15168,15360, 8688, 8664, 8736, 8808, 8784, 8688, 8856,
     5   8856, 8712, 8592, 8472, 8496, 8784, 8688, 8640, 8616, 8472,
     6   8352, 8424, 8376, 8160, 8112, 7992, 7848, 7944, 8112, 8160,
     7   8040, 8184, 8088, 7896, 7752, 8400, 9072, 9360, 9456, 9504,
     8   9600,10008,10440,10680,10776,10944,10896,11088,11088,11280,
     9  11280,11040,10872,10752,11136,11592,11664,11760,11904,12120/
            data (jy(i),i=  201,  300)/
     +  12120, 6792, 6792, 6696, 6864, 6936, 6888, 6936, 7008, 7032,
     1   7104, 7152, 7152, 6984, 6912, 6912, 7056, 7104, 7152, 7488,
     2   7392, 7176, 7176, 7296, 7464, 7608, 7584, 7512, 7704, 7992,
     3   8256, 8424, 8568, 8640, 8904, 8952, 8760, 8688, 8520, 8496,
     4   8592, 8904, 9600, 9720,10440,10680,10944,11232,11448,11520,
     5  11568,11664,11760,11808,11880,11880, 7080, 7272, 7344, 7320,
     6   7392, 7488, 7488, 7608, 7680, 7704, 7560, 7608, 7512, 7560,
     7   7632, 7824, 7920, 8016, 8064, 8160, 8232, 8328, 8016, 8160,
     8   8160, 7848, 7656, 7776, 7728, 7872, 7680, 7872, 7848, 8064,
     9   8040, 8112, 8160, 8304, 8280, 8064, 8064, 8376, 8400, 8136/
            data (jy(i),i=  301,  400)/
     +   8088, 8280, 8520, 8736, 8928, 9024, 9216, 9504, 9648,59544,
     1  59712,59832,59904,59904,59784,59616,59232,58944,58824,58776,
     2  58920,59640,60144,60360,60552,60840,60696,59736,59424,59328,
     3  59256,59064,59592,59472,59112,58992,56784,57048,57240,57456,
     4  57696,57792,57792,57888,58272,58512,58728,58896,58968,59136,
     5  59184,59280,59136,58944,58632,58416,58224,53928,61608,61248,
     6  61032,60984,61248,61128,61152,61056,60864,60648,60552,60408,
     7  59904,59640,59448,59280,59064,58824,57624,57360,57336,57264,
     8  57048,57120,57096,56712,56664,57816,57840,57096,56928,56880,
     9  56736,56616,56880,57024,57000,56640,56712,55848,55728,55920/
            data (jy(i),i=  401,  500)/
     +  55992,56352,56352,56448,56400,56496,56400,57264,52680,53184,
     1  53136,53376,53376,54360,54528,54696,54792,54864,54984,54960,
     2  55152,55200,55272,55296,55368,55488,55824,55800,55992,56064,
     3  56208,56184,56328,56376,56496,55896,56136,56424,57576,58968,
     4  58992,59136,59616,59976,60240,56112,55896,55824,55920,55848,
     5  56040,56064,56136,56328,56352,56256,56352,56208,56256,56304,
     6  56544,56832,56856,56952,57024,57048,57192,53832,53880,54624,
     7  53832,53760,53328,53496,53496,53664,53664,53808,50232,50208,
     8  55272,52656,51480,52464,52488,53304,53208,52656,50352,50280,
     9  50256,50232,50136,50352,50376,51648,51648,51816,51864,51816/
            data (jy(i),i=  501,  600)/
     +  51528,50256,50016,49728,49752,49920,49920,49968,49896,49440,
     1  49560,50160,50880,51168,50952,50616,50616,49416,49344,49128,
     2  49128,48960,48960,48624,48624,48120,48120,47952,47952,47784,
     3  47784,46344,46344,46248,46200,46080,46104,45912,45936,45768,
     4  45768,45240,45264,53328,53208,53232,53064,52968,52896,52824,
     5  52776,52680,52608,52512,52464,52224,52008,52008,51888,51840,
     6  51744,51696,51624,51744,51624,51552,51552,51360,51288,51336,
     7  51240,51384,51240,50928,50904,51024,50976,50856,50736,50640,
     8  50688,50520,50424,50304,50256,50184,50016,49968,49920,49968,
     9  49872,49824,49752,49824,49632,49728,49728,49560,49488,49584/
            data (jy(i),i=  601,  700)/
     +  49536,49440,49344,49296,49344,49248,48840,48768,48816,48720,
     1  48792,48672,48672,50040,49920,49824,49728,49560,49416,49224,
     2  49152,49032,49032,48696,49560,49632,49800,50256,50040,49968,
     3  50184,50208,49872,49488,49392,49200,49152,49224,49224,49032,
     4  48912,48768,48744,48792,48768,48552,48528,49632,49752,49872,
     5  49800,49800,49704,49704,49272,49272,49440,49440,49368,49368,
     6  49128,49128,48960,48960,48792,48816,48648,48648,48528,48504,
     7  48528,48168,49344,49008,48264,48264,48168,48168,48144,48024,
     8  48024,47592,48168,48504,48480,47712,47616,48480,48360,48144,
     9  48000,47712,47616,47592,47352,47304,47160,47016,47064,46992/
            data (jy(i),i=  701,  800)/
     +  46632,45720,46728,46776,48792,48864,45600,45576,45744,45744,
     1  46272,46368,46584,47616,47256,47256,47088,47112,46344,46344,
     2  46104,46104,45936,45936,45264,45264,45168,45168,45072,44856,
     3  44856,45816,45480,45480,44808,44784,48000,48024,47832,47856,
     4  47688,47688,47352,47352,47184,47184,46680,46680,46344,46344,
     5  46008,46008,45840,45840,45672,45672,45432,45264,45168,45096,
     6  44952,45000,44688,44736,44880,44880,44760,44688,44688,45552,
     7  45552,45720,45096,44592,44496,44496,44328,44328,44232,44256,
     8  44424,44424,44592,44568,44616,44688,44664,44568,46560,46608,
     9  46776,46872,46824,46632,46440,46104,45936,45864,45768,45648/
            data (jy(i),i=  801,  900)/
     +  45624,45648,45576,45264,45168,45048,44832,44496,44424,44496,
     1  44736,44688,44592,44424,44352,44040,43920,43512,43464,43296,
     2  45072,44568,44592,44616,44520,44568,44520,44304,44304,44424,
     3  44400,44448,44208,44208,44040,44016,43872,43848,43680,43656,
     4  43584,43584,43512,43512,43344,43320,42984,42984,42912,42888,
     5  42720,42720,42480,42480,42312,42288,42120,42120,42000,41952,
     6  41616,41616,44832,44832,44736,44760,44664,44664,44568,44496,
     7  44328,44328,44256,44232,44160,44160,43992,43992,43896,43848,
     8  43728,43728,43560,43584,43368,43320,43248,43248,43008,43008,
     9  42936,42936,42600,42600,42528,42528,42312,42312,42264,42192/
            data (jy(i),i=  901, 1000)/
     +  41976,41928,41856,41856,41760,41688,41592,40560,44568,44064,
     1  44064,43392,43392,43224,43224,42216,42216,41040,41064,40008,
     2  40104,40080,42384,42384,42504,42504,42576,42576,39960,43224,
     3  43080,42888,42792,42744,42456,42168,41928,41952,42048,41784,
     4  41568,41592,41424,41088,41040,41112,41040,40800,40704,40464,
     5  40320,40224,40080,39840,39864,40032,40008,41184,41160,40680,
     6  40584,39912,39912,39672,39672,39504,39504,39432,39432,39336,
     7  39336,41616,41328,41328,41496,41496,41376,41328,40944,40272,
     8  40296,39840,38832,38832,39024,39432,39552,39768,39600,39576,
     9  39480,39384,39408,39312,39096,39000,39000,39048,39864,39864/
            data (jy(i),i= 1001, 1100)/
     +  39000,39000,38856,38784,38976,39144,39240,39288,39312,39240,
     1  39240,39408,39408,39240,39288,39504,39432,39552,39744,39840,
     2  40032,37320,36888,36864,39336,37320,36816,36816,36816,34800,
     3  34800,32784,36768,36720,36648,35976,38808,38616,38448,37968,
     4  37776,37704,37296,37200,37056,36840,36624,36624,36528,36384,
     5  36336,36000,35952,35952,36096,36096,35928,35952,35784,35760,
     6  35856,35832,35928,35928,35760,35760,35832,35832,35760,35736,
     7  35808,35808,35736,35712,35640,35400,35904,35904,34872,34872,
     8  35376,34872,35712,35544,35520,35352,35352,34176,30768,30792,
     9  32808,32856,33240,33504,33840,34176,34416,34632,35016,35160/
            data (jy(i),i= 1101, 1200)/
     +  33384,33408,33528,33816,34080,34224,34296,34248,34152,34056,
     1  34080,34248,34416,34440,34344,34536,34560,34296,34104,34416,
     2  34632,34728,34896,35040,35232,35328,35232,35160,35328,35448,
     3  35592,35856,36168,36288,36192,36408,36576,36456,36888,36888,
     4  36792,36864,36840,36936,36960,37152,37368,37800,37944,38088,
     5  38040,38088,38160,38208,38352,38400,38304,38376,38520,33312,
     6  33480,33720,33744,33984,34008,33936,33792,33960,34032,34320,
     7  34224,34296,34560,34608,34656,34560,34776,34848,34752,34800,
     8  34944,35112,35304,35496,35496,35400,35400,35472,35688,35712,
     9  35856,36096,36120,36024,36000,36048,36192,36168,36432,36552/
            data (jy(i),i= 1201, 1300)/
     +  36576,36672,36744,36792,36864,36984,37056,37056,37104,37200,
     1  37224,37416,37368,37536,37488,37608,37584,37656,37608,37704,
     2  37872,37944,37920,38040,37968,38040,38040,38184,38232,38232,
     3  38328,38376,38520,38496,38640,38640,38760,33240,33264,33360,
     4  33456,33528,33576,34176,34008,33984,33000,32976,35976,36144,
     5  36144,35976,35976,35808,35664,35544,35352,35160,34896,34752,
     6  34200,33552,33096,33288,32784,32832,32784,32736,32520,32472,
     7  32448,32520,32352,32496,32472,32424,32328,32496,32400,32280,
     8  32208,32208,32112,33288,32856,32736,32088,32064,33072,33072,
     9  33864,34032,34008,31968,32136,31944,32016,32136,32064,32160/
            data (jy(i),i= 1301, 1400)/
     +  32136,32256,32160,32280,32328,32328,32232,32328,32400,32520,
     1  32448,32712,32640,32664,32784,32904,32856,32952,33024,32952,
     2  32880,32856,32712,32736,32880,32856,32640,32352,32088,31992,
     3  32088,32232,32160,32016,31848,31896,31584,31440,31440,31272,
     4  31200,34824,33840,33336,32952,32784,32496,32496,32256,32280,
     5  32112,32040,31944,31800,31536,31320,31152,31080,30840,30768,
     6  30792,30840,31152,31488,31752,31776,31728,31896,31848,31512,
     7  31392,31296,31560,31800,31920,31848,31536,31392,31560,31560,
     8  31488,31128,33312,33240,33192,33288,32928,32640,32544,32520,
     9  32184,31608,31536,31224,31248,31104,31056,30888,30840,30768/
            data (jy(i),i= 1401, 1500)/
     +  31920,31704,31416,31152,31104,30720,30432,30288,30024,30432,
     1  30792,30648,30528,30096,29952,30360,30312,30216,29976,30000,
     2  29952,29880,29784,29616,29520,29400,29136,29112,28944,28848,
     3  28632,28656,28560,28392,28320,28224,28080,27960,27768,27768,
     4  29016,29016,28104,28176,28176,28104,28080,28176,28320,28512,
     5  28824,28992,29064,30408,30144,30144,27864,31152,31152,31104,
     6  31056,30720,30408,30384,30240,30216,30096,30048,27816,31008,
     7  30792,30744,30504,30360,29976,29928,29952,29808,29808,30576,
     8  30504,30552,30744,30792,30696,30792,30792,30672,30672,30528,
     9  30552,30408,30216,30024,29784,29616,29400,28992,28920,28920/
            data (jy(i),i= 1501, 1600)/
     +  28440,28224,27984,28104,27912,27696,27456,27312,27192,27360,
     1  27168,30336,30168,28752,28776,27312,27264,27144,26904,26856,
     2  26832,27840,26832,26808,26784,27792,28944,28944,27504,27480,
     3  27576,27576,27480,27480,27312,27312,27264,27264,26712,26256,
     4  25920,25896,26904,26904,27072,27144,27816,27816,27912,27888,
     5  27984,27888,27720,27720,27864,27816,27072,26976,26784,26736,
     6  26856,26880,26688,26568,26592,26376,26544,26424,26352,26376,
     7  26232,26208,25680,25608,25320,25176,24576,24408,24552,24504,
     8  24240,23808,26784,25272,25800,25800,25728,25248,25272,22944,
     9  23952,23928,24432,24480,24768,24360,22872,22944,23256,23760/
            data (jy(i),i= 1601, 1700)/
     +  23880,24264,24600,24816,25080,25488,25776,22872,22848,26448,
     1  26016,25680,25368,25032,24816,24840,24528,23352,23328,23112,
     2  22920,22824,25512,25416,25320,25296,24624,24624,24456,24456,
     3  23256,23256,21744,21744,21744,21840,21984,22968,18000,20784,
     4  21816,21816,21912,21912,21768,20904,21072,21312,21360,21816,
     5  21816,20952,20952,20784,19416,25080,25080,23736,23736,22080,
     6  21624,21456,21192,20688,20424,20400,20424,20592,20616,20592,
     7  20400,20352,20016,19632,19536,19584,19824,19896,19896,19704,
     8  19488,19272,19128,24288,24120,24120,23904,23952,23760,23496,
     9  23424,23400,23208,23088,22560,22344,21840,21672,21120,20976/
            data (jy(i),i= 1701, 1800)/
     +  20928,20424,20304,20016,19824,19728,19344,19104,18840,18696,
     1  19200,19176,18600,18504,18504,18360,18336,18504,18672,18000,
     2  18144,18432,18624,18720,18936,18936,18624,19080,19080,17928,
     3  18096,18144,18360,18528,18576,18696,18696,18840,18792,18840,
     4  18984,19128,19248,19344,19344,19296,19632,19560,19512,19440,
     5  19440,19872,20208,20232,20184,20040,20112,20040,20064,20136,
     6  20280,20256,20328,20424,20400,20616,20736,20808,20880,21120,
     7  21408,21528,21792,21864,21936,22200,22344,22320,22440,22464,
     8  22680,22848,23040,23304,23424,17904,17904,19584,19680,19896,
     9  20328,20712,20712,19080,19152,19392,19248,18888,18816,18912/
            data (jy(i),i= 1801, 1900)/
     +  18696,18696,18552,18456,18384,18312,18456,18360,18096,18072,
     1  18192,18192,18000,18072,17976,18000,17856,17928,17808,17808,
     2  17928,18696,18552,18264,18120,18048,18000,17952,17784,17904,
     3  17928,17856,17832,17808,17880,17592,17592,17712,17376,17400,
     4  17064,18072,15672,15672,15672,17424,17400,17112,16704,16488,
     5  16488,16368,16272,16080,15936,15816,15624,15336,15288,15144,
     6  15072,14976,14856,14640,14400,14280,14136,13920,13728,13536,
     7  13296,13224,13128,13008,12816,12696,12432,12264,12024,11856,
     8  11808,11952, 7272, 7320, 7344, 7344, 7296, 7392, 7320, 7272,
     9   7296, 7152, 7176, 7584, 7560, 7536, 7584, 7656, 7608, 7416/
            data (jy(i),i= 1901, 1960)/
     +   7584, 7920, 7896, 7848, 7872, 7872, 7920, 7896, 7824, 7920,
     1   7968, 8160, 8208, 8472, 8088, 8352, 8304, 8400, 8256, 8328,
     2   8328, 8496, 8496, 8544, 6720, 6672, 6648, 6672, 6624, 6648,
     3   6816, 6360, 6432, 6480, 6408, 6936, 7008, 7008, 6792, 6864,
     4   7104, 7080, 7152, 7176, 7080, 7128, 7056, 6984, 8760, 8688,
     5   8688,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,   28,   29,   30,    2,    2,    3,    7,    3,    1,
     1      6,    5,    8,    6,   10,    9,   12,   13,   33,   34,
     2     35,   36,   37,   38,   39,   15,   11,   16,   41,   42,
     3     43,   44,   45,   46,   47,   48,   49,   50,   51,   15,
     4     16,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     5     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     6     72,   73,   74,   75,   76,   18,   14,   18,   78,   79,
     7     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     8     19,   17,   20,   19,   92,   93,   94,   95,   96,   97,
     9     98,   99,  100,  101,  102,  103,  104,   21,   20,   21/
            data (jb1(i),i=  101,  200)/
     +    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     1    116,   23,   26,  118,   24,   23,   25,  120,  121,  122,
     2    123,  124,  125,  126,  127,  128,  129,  130,  131,  132,
     3    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     4     24,   22,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,   27/
            data (jb1(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     4    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     5    252,  253,  254,  255,   27,  202,  257,  258,  259,  260,
     6    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     7    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     8    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     9    291,  292,  293,  294,  295,  296,  297,  298,  299,  300/
            data (jb1(i),i=  301,  400)/
     +    301,  302,  303,  304,  305,  306,  307,  308,  120,  310,
     1    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     2    321,  322,  323,  324,  325,  326,  327,    2,  328,  329,
     3    330,  331,  310,  333,  334,  335,  332,  337,  338,  339,
     4    340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
     5    350,  351,  310,  332,  353,  354,  355,  356,  357,    3,
     6    359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
     7    369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
     8    379,  381,  382,  383,  384,  357,  386,  387,  388,  385,
     9    337,  390,  385,  389,  392,  393,  394,  395,  396,  381/
            data (jb1(i),i=  401,  500)/
     +    398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
     1    380,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     2    418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
     3    428,  429,  430,  431,  432,  433,  434,  435,  398,  436,
     4    437,  438,  439,  440,  441,  442,  443,  444,  445,  392,
     5    446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
     6    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     7    466,  380,  337,  469,  468,  392,  470,  358,  468,  358,
     8    473,  474,  475,  476,  477,  471,  479,  472,  398,  481,
     9    409,  483,  484,  482,  473,  486,  487,  483,  469,  489/
            data (jb1(i),i=  501,  600)/
     +    490,  491,  492,  493,  494,  479,  409,  496,  497,  498,
     1    499,  500,  501,  502,  504,  505,  506,  507,  508,  503,
     2    504,  510,  511,  512,  513,  483,   10,  515,  516,  517,
     3    489,  518,  504,  520,  521,  522,  523,  524,  525,  526,
     4    527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     5    537,  538,  539,  540,  541,  542,  473,  544,  545,  546,
     6    547,  548,  549,  550,  551,  552,  553,  554,  555,  556,
     7    557,  558,  559,  560,  561,  562,  563,  564,  565,  566,
     8    567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
     9    577,  578,  579,  580,  581,  582,  583,  584,  585,  586/
            data (jb1(i),i=  601,  700)/
     +    587,  588,  589,  590,  591,  592,  593,  594,  595,  596,
     1    597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
     2    607,  608,  609,  610,  611,  612,  479,  614,  615,  616,
     3    617,  618,  619,  620,  621,  622,  623,  613,  510,  625,
     4    626,  627,  628,  629,  630,  631,  632,  633,  634,  635,
     5    636,  637,  638,  639,  640,  641,  642,  643,  644,  645,
     6    646,  503,  648,  649,  650,  651,  652,  653,  654,  655,
     7    656,  657,  658,  659,  660,  661,  662,  663,  664,  665,
     8    666,  667,  668,  647,  613,  670,  671,  510,  673,  674,
     9    675,  676,  677,  678,  679,  680,  681,  672,  683,  684/
            data (jb1(i),i=  701,  800)/
     +    685,  686,  682,  647,  688,  689,  690,  691,  692,  693,
     1    694,  695,  696,  697,  698,  699,  700,  702,  703,  704,
     2    705,  519,  543,  707,  708,  709,  710,  711,  712,  701,
     3    682,  714,  715,  716,  717,  718,  719,  720,  721,  722,
     4    723,  724,  725,  726,  727,  728,  730,  518,  730,  702,
     5    732,  733,  734,  735,  731,  672,  737,  738,  739,  740,
     6    741,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     7    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     8    761,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     9    771,  702,  543,  773,  774,  775,  776,  777,  778,  779/
            data (jb1(i),i=  801,  900)/
     +    780,  781,  782,  783,   12,  785,  786,  787,  784,  701,
     1    789,  790,  791,  792,  793,  794,  795,  796,  797,  798,
     2    799,  800,  801,  802,  803,  804,  805,  806,  807,  808,
     3    809,  810,  811,  812,  813,  814,  815,  816,  817,  818,
     4    819,  729,  821,  822,  820,  768,  824,  825,  826,  827,
     5    828,  829,  830,  831,  832,  833,  834,  835,  836,  837,
     6    838,  839,  840,  841,  842,  843,  844,  845,  846,  847,
     7    848,  849,  850,  851,  852,  853,  854,  855,  856,  857,
     8    858,  859,  860,  861,  729,  863,  864,  865,  866,  867,
     9    868,  869,  870,  871,  872,  873,  874,  875,  876,  877/
            data (jb1(i),i=  901, 1000)/
     +    878,  879,  880,  881,  882,  883,  884,  885,  886,  887,
     1    888,  889,  890,  891,  892,  893,  894,  895,  896,  897,
     2    898,  899,  900,  901,  902,  903,  904,  905,  906,  862,
     3    731,  774,  909,  910,  911,  912,  913,  914,  915,  916,
     4    917,  918,  919,  921,  921,  922,  923,  924,  925,  926,
     5    927,  784,  920,  820,  930,  931,  932,  933,  934,  935,
     6    936,  937,  938,  939,  940,  941,  942,  943,  944,  945,
     7    946,  947,  948,  949,  950,  951,  952,  929,  954,  955,
     8    922,  920,  954,  862,  958,  959,  960,  961,  962,  963,
     9    964,  965,  966,  967,  968,  969,  970,  861,  972,  973/
            data (jb1(i),i= 1001, 1100)/
     +    974,  975,  976,  977,  978,  979,  980,  981,  982,  983,
     1    985,  986,  987,  929,  971,  989,  990,  991,  992,  993,
     2    994,  995,  996,  997,  985,  908,  999, 1000, 1001, 1002,
     3    984, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012,
     4   1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020,  908, 1004,
     5    984, 1023, 1024,  971, 1022, 1026, 1023, 1022, 1028, 1029,
     6   1030, 1031,  954, 1033, 1034, 1035,  985, 1037, 1038, 1039,
     7   1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049,
     8   1050, 1051, 1052, 1053, 1054, 1055, 1056, 1036,   15, 1058,
     9   1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068/
            data (jb1(i),i= 1101, 1200)/
     +   1069, 1070, 1071, 1072, 1073,  921, 1023, 1076, 1077, 1053,
     1   1075, 1079, 1076, 1081, 1080, 1074, 1083, 1084, 1085, 1086,
     2   1087, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097,
     3   1098, 1099, 1075, 1101, 1102, 1103, 1104, 1105, 1106, 1107,
     4   1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117,
     5   1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127,
     6   1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136, 1137,
     7   1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146, 1147,
     8   1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156, 1157,
     9   1158, 1004, 1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167/
            data (jb1(i),i= 1201, 1300)/
     +   1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177,
     1   1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185, 1186, 1187,
     2   1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197,
     3   1198, 1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207,
     4   1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217,
     5   1218, 1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227,
     6   1228, 1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236, 1003,
     7   1160, 1238, 1239, 1240, 1241, 1242, 1101, 1088, 1244, 1245,
     8   1246, 1247, 1036, 1249, 1250, 1251, 1252, 1253, 1254, 1255,
     9   1256, 1257, 1258, 1259, 1260, 1261, 1262, 1248, 1160, 1264/
            data (jb1(i),i= 1301, 1400)/
     +   1032, 1248, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273,
     1   1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282,   16,
     2   1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1088,
     3   1076, 1283, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302,
     4   1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312,
     5   1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322,
     6   1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332,
     7   1333, 1294, 1294, 1335, 1336, 1337, 1338, 1339, 1340, 1080,
     8   1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351,
     9   1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361/
            data (jb1(i),i= 1401, 1500)/
     +   1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371,
     1   1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381,
     2   1341, 1101, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390,
     3   1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1089,
     4   1032, 1283, 1401, 1402, 1403, 1404, 1405, 1406, 1089, 1288,
     5   1407, 1410, 1411, 1412, 1413, 1414, 1409, 1408, 1416, 1417,
     6   1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427,
     7   1428, 1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437,
     8   1438, 1439, 1441, 1409,   18, 1443, 1444, 1445, 1446, 1447,
     9   1448, 1449, 1450, 1451, 1452, 1441, 1407, 1454, 1455, 1456/
            data (jb1(i),i= 1501, 1600)/
     +   1341, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466,
     1   1467, 1468, 1357, 1470, 1471, 1472, 1473, 1474, 1475, 1476,
     2   1477, 1478, 1440, 1399, 1480, 1481, 1482, 1483, 1484, 1485,
     3   1486, 1487, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495,
     4   1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505,
     5   1506, 1507, 1508, 1509, 1510, 1408, 1512, 1513, 1514, 1515,
     6   1516, 1517, 1511, 1457, 1519, 1520, 1521, 1469, 1523, 1469,
     7   1525, 1440, 1523, 1441, 1527, 1528, 1529, 1530, 1531, 1532,
     8   1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542,
     9   1543, 1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552/
            data (jb1(i),i= 1601, 1700)/
     +   1553, 1554, 1555, 1457, 1511, 1557, 1558, 1559, 1560, 1561,
     1   1562, 1563, 1564, 1565, 1566, 1567, 1568, 1569, 1570, 1571,
     2   1572, 1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581,
     3   1525, 1583, 1518, 1585, 1586, 1587, 1588, 1584, 1590, 1591,
     4   1592, 1593, 1594, 1595, 1584, 1582, 1590, 1597, 1598, 1599,
     5   1600, 1601, 1602, 1603, 1604, 1605, 1606, 1541, 1597, 1608,
     6   1520, 1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618,
     7   1619, 1620, 1621, 1609, 1523, 1623, 1624, 1625, 1626, 1627,
     8   1628, 1629, 1630, 1631, 1632, 1633, 1634, 1635, 1636, 1637,
     9   1596, 1608, 1640, 1641, 1642, 1643, 1609, 1633, 1645, 1646/
            data (jb1(i),i= 1701, 1800)/
     +   1647, 1648, 1649, 1650, 1651, 1652, 1653, 1640, 1590, 1655,
     1   1589, 1656, 1657, 1658, 1659, 1660, 1661, 1662, 1663, 1664,
     2   1665, 1666, 1667, 1668, 1669, 1670, 1671, 1672, 1673, 1674,
     3   1675, 1676, 1677, 1678, 1679, 1680, 1681, 1682, 1596, 1684,
     4   1685, 1686, 1687, 1688, 1689, 1690, 1691, 1692, 1693, 1694,
     5   1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702, 1703, 1704,
     6   1705, 1706, 1707, 1708, 1709, 1683, 1711, 1712, 1713, 1714,
     7   1715, 1716, 1717, 1718, 1710, 1720, 1721, 1722, 1723, 1724,
     8   1725, 1726, 1727, 1728, 1655, 1639, 1730, 1731, 1732, 1733,
     9   1734, 1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742, 1743/
            data (jb1(i),i= 1801, 1900)/
     +   1744, 1745, 1746, 1747, 1748, 1749, 1750, 1751, 1752, 1753,
     1   1754, 1755, 1756, 1757, 1758, 1759, 1760, 1761, 1762, 1763,
     2   1764, 1765, 1766, 1767, 1768, 1769, 1770, 1771, 1772, 1773,
     3   1774, 1775, 1776, 1777, 1778, 1779, 1780, 1781, 1782, 1783,
     4   1784, 1582, 1640, 1787, 1788, 1789, 1790, 1791, 1792, 1634,
     5   1683, 1794, 1795, 1796, 1797, 1798, 1799, 1800, 1801, 1802,
     6   1803, 1804, 1805, 1806, 1807, 1808, 1809, 1810, 1811, 1812,
     7   1813, 1814, 1815, 1816, 1730, 1639, 1818, 1819, 1820, 1786,
     8   1710, 1822, 1823, 1824, 1825, 1826, 1827, 1828, 1829, 1830,
     9   1831, 1832, 1833, 1834, 1787, 1730, 1836, 1837, 1838, 1839/
            data (jb1(i),i= 1901, 2000)/
     +   1840, 1841,   23, 1720, 1715, 1843, 1786, 1787, 1844, 1845,
     1   1837, 1846, 1847, 1848, 1849, 1850, 1851, 1852, 1853, 1854,
     2   1855, 1856, 1857, 1858, 1859, 1860, 1861, 1862, 1863, 1864,
     3   1865, 1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873, 1874,
     4   1875, 1876, 1877, 1878,    1,    2,    3,    1,    5,    6,
     5      7,    5,    9,   10,   11,   12,   13,   14,    9,   16,
     6     17,   16,   19,   20,   21,   22,   19,   24,   25,   26,
     7     24,   28,   29,   30,   28,   32,   33,   34,   35,   36,
     8     32,   38,   39,   38,   41,   42,   41,   44,   45,   44,
     9     47,   48,   47,   50,   51,   52,   50,   54,   55,   56/
            data (jb1(i),i= 2001, 2020)/
     +     54,   58,   59,   60,   61,   62,   63,   64,   65,   66,
     1     67,   68,   69,   58,   71,   72,   71,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     28,   29,   30,   31,   31,    4,    4,   32,   32,    5,
     1      7,    8,   10,    9,   11,   12,   13,   33,   34,   35,
     2     36,   37,   38,   39,   40,   40,   14,   41,   42,   43,
     3     44,   45,   46,   47,   48,   49,   50,   51,   52,   52,
     4     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     5     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     6     73,   74,   75,   76,   77,   77,   17,   78,   79,   80,
     7     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     8     90,   91,   91,   92,   93,   94,   95,   96,   97,   98,
     9     99,  100,  101,  102,  103,  104,  105,  105,   22,  106/
            data (jb2(i),i=  101,  200)/
     +    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     1    117,  117,  118,  119,  119,   25,   26,  121,  122,  123,
     2    124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
     3    134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
     4    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     5    153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     6    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     7    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     8    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     9    193,  194,  195,  196,  197,  198,  199,  200,  201,  201/
            data (jb2(i),i=  201,  300)/
     +    203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
     1    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     2    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     3    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     4    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     5    253,  254,  255,  256,  256,  257,  258,  259,  260,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     9    292,  293,  294,  295,  296,  297,  298,  299,  300,  301/
            data (jb2(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  309,  311,
     1    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,    1,  328,  329,  330,
     3    331,  332,  333,  334,  335,  336,  336,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  352,  353,  354,  355,  356,  357,  358,  359,
     6    360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
     7    370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
     8    380,  382,  383,  384,  385,  386,  387,  388,  389,    4,
     9    390,    5,  391,  391,  393,  394,  395,  396,  397,  397/
            data (jb2(i),i=  401,  500)/
     +    399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
     1    408,  410,  411,  412,  413,  414,  415,  416,  417,  418,
     2    419,  420,  421,  422,  423,  424,  425,  426,  427,  428,
     3    429,  430,  431,  432,  433,  434,  435,    6,  436,  437,
     4    438,  439,  440,  441,  442,  443,  444,  445,    7,  446,
     5    447,  448,  449,  450,  451,  452,  453,  454,  455,  456,
     6    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     7    467,  467,  468,    8,  469,  470,  471,  471,  472,  472,
     8    474,  475,  476,  477,  478,  478,  480,  480,  481,  482,
     9    482,  484,  485,  485,  486,  487,  488,  488,  489,  490/
            data (jb2(i),i=  501,  600)/
     +    491,  492,  493,  494,  495,  495,  496,  497,  498,  499,
     1    500,  501,  502,  503,  505,  506,  507,  508,    9,  509,
     2    509,  511,  512,  513,  514,  514,  515,  516,  517,  518,
     3    519,  519,  520,  521,  522,  523,  524,  525,  526,  527,
     4    528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
     5    538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
     6    548,  549,  550,  551,  552,  553,  554,  555,  556,  557,
     7    558,  559,  560,  561,  562,  563,  564,  565,  566,  567,
     8    568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
     9    578,  579,  580,  581,  582,  583,  584,  585,  586,  587/
            data (jb2(i),i=  601,  700)/
     +    588,  589,  590,  591,  592,  593,  594,  595,  596,  597,
     1    598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
     2    608,  609,  610,  611,  612,  613,  614,  615,  616,  617,
     3    618,  619,  620,  621,  622,  623,  624,  624,  625,  626,
     4    627,  628,  629,  630,  631,  632,  633,  634,  635,  636,
     5    637,  638,  639,  640,  641,  642,  643,  644,  645,  646,
     6    647,  648,  649,  650,  651,  652,  653,  654,  655,  656,
     7    657,  658,  659,  660,  661,  662,  663,  664,  665,  666,
     8    667,  668,  669,  669,  670,  671,  672,  673,  674,  675,
     9    676,  677,  678,  679,  680,  681,  682,  683,  684,  685/
            data (jb2(i),i=  701,  800)/
     +    686,  687,  687,  688,  689,  690,  691,  692,  693,  694,
     1    695,  696,  697,  698,  699,  700,  701,  703,  704,  705,
     2    706,  706,  707,  708,  709,  710,  711,  712,  713,  713,
     3    714,  715,  716,  717,  718,  719,  720,  721,  722,  723,
     4    724,  725,  726,  727,  728,  729,  731,  730,   11,  732,
     5    733,  734,  735,  736,  736,  737,  738,  739,  740,  741,
     6    742,  743,  744,  745,  746,  747,  748,  749,  750,  751,
     7    752,  753,  754,  755,  756,  757,  758,  759,  760,  761,
     8    762,  763,  764,  765,  766,  767,  768,  769,  770,  771,
     9    772,  772,  773,  774,  775,  776,  777,  778,  779,  780/
            data (jb2(i),i=  801,  900)/
     +    781,  782,  783,  784,  785,  786,  787,  788,  788,  789,
     1    790,  791,  792,  793,  794,  795,  796,  797,  798,  799,
     2    800,  801,  802,  803,  804,  805,  806,  807,  808,  809,
     3    810,  811,  812,  813,  814,  815,  816,  817,  818,  819,
     4    820,  821,  822,  823,  823,  824,  825,  826,  827,  828,
     5    829,  830,  831,  832,  833,  834,  835,  836,  837,  838,
     6    839,  840,  841,  842,  843,  844,  845,  846,  847,  848,
     7    849,  850,  851,  852,  853,  854,  855,  856,  857,  858,
     8    859,  860,  861,  862,  863,  864,  865,  866,  867,  868,
     9    869,  870,  871,  872,  873,  874,  875,  876,  877,  878/
            data (jb2(i),i=  901, 1000)/
     +    879,  880,  881,  882,  883,  884,  885,  886,  887,  888,
     1    889,  890,  891,  892,  893,  894,  895,  896,  897,  898,
     2    899,  900,  901,  902,  903,  904,  905,  906,  907,  907,
     3    908,  909,  910,  911,  912,  913,  914,  915,  916,  917,
     4    918,  919,  920,   13,  922,  923,  924,  925,  926,  927,
     5    928,  928,  929,  930,  931,  932,  933,  934,  935,  936,
     6    937,  938,  939,  940,  941,  942,  943,  944,  945,  946,
     7    947,  948,  949,  950,  951,  952,  953,  953,  955,  956,
     8    956,  957,  957,  958,  959,  960,  961,  962,  963,  964,
     9    965,  966,  967,  968,  969,  970,  971,  972,  973,  974/
            data (jb2(i),i= 1001, 1100)/
     +    975,  976,  977,  978,  979,  980,  981,  982,  983,  984,
     1    986,  987,  988,  988,  989,  990,  991,  992,  993,  994,
     2    995,  996,  997,  998,  998,  999, 1000, 1001, 1002, 1003,
     3   1003, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013,
     4   1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1021,   14,
     5   1022, 1024, 1025, 1025, 1026, 1027, 1027, 1028, 1029, 1030,
     6   1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040,
     7   1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050,
     8   1051, 1052, 1053, 1054, 1055, 1056, 1057, 1057, 1058, 1059,
     9   1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069/
            data (jb2(i),i= 1101, 1200)/
     +   1070, 1071, 1072, 1073, 1074, 1074, 1075, 1077, 1078, 1078,
     1   1079, 1080, 1081, 1082, 1082, 1083, 1084, 1085, 1086, 1087,
     2   1088, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098,
     3   1099, 1100, 1100, 1102, 1103, 1104, 1105, 1106, 1107, 1108,
     4   1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118,
     5   1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128,
     6   1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136, 1137, 1138,
     7   1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148,
     8   1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158,
     9   1159, 1159, 1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168/
            data (jb2(i),i= 1201, 1300)/
     +   1169, 1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178,
     1   1179, 1180, 1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188,
     2   1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198,
     3   1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208,
     4   1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218,
     5   1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228,
     6   1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1237,
     7   1238, 1239, 1240, 1241, 1242, 1243, 1243, 1244, 1245, 1246,
     8   1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254, 1255, 1256,
     9   1257, 1258, 1259, 1260, 1261, 1262, 1263, 1263, 1264, 1265/
            data (jb2(i),i= 1301, 1400)/
     +   1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274,
     1   1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284,
     2   1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1293,
     3   1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303,
     4   1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313,
     5   1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323,
     6   1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333,
     7   1334, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342,
     8   1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352,
     9   1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362/
            data (jb2(i),i= 1401, 1500)/
     +   1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372,
     1   1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382,
     2   1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391,
     3   1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399,   17, 1400,
     4   1400, 1401, 1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409,
     5   1410, 1411, 1412, 1413, 1414, 1415, 1415, 1416, 1417, 1418,
     6   1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428,
     7   1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438,
     8   1439, 1440, 1442, 1442, 1443, 1444, 1445, 1446, 1447, 1448,
     9   1449, 1450, 1451, 1452, 1453, 1453, 1454, 1455, 1456, 1457/
            data (jb2(i),i= 1501, 1600)/
     +   1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467,
     1   1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477,
     2   1478, 1479, 1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486,
     3   1487, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496,
     4   1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506,
     5   1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516,
     6   1517, 1518, 1518, 1519, 1520, 1521, 1522, 1522, 1524, 1524,
     7   1526, 1526, 1525, 1527, 1528, 1529, 1530, 1531, 1532, 1533,
     8   1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543,
     9   1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553/
            data (jb2(i),i= 1601, 1700)/
     +   1554, 1555, 1556, 1556, 1557, 1558, 1559, 1560, 1561, 1562,
     1   1563, 1564, 1565, 1566, 1567, 1568, 1569, 1570, 1571, 1572,
     2   1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582,
     3   1583, 1584, 1585, 1586, 1587, 1588, 1589, 1589, 1591, 1592,
     4   1593, 1594, 1595,   19, 1596,   20, 1597, 1598, 1599, 1600,
     5   1601, 1602, 1603, 1604, 1605, 1606, 1607, 1607, 1608, 1609,
     6   1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618, 1619,
     7   1620, 1621, 1622, 1622, 1623, 1624, 1625, 1626, 1627, 1628,
     8   1629, 1630, 1631, 1632, 1633, 1634, 1635, 1636, 1637, 1638,
     9   1638, 1639, 1641, 1642, 1643, 1644, 1644, 1645, 1646, 1647/
            data (jb2(i),i= 1701, 1800)/
     +   1648, 1649, 1650, 1651, 1652, 1653, 1654, 1654, 1655,   21,
     1   1656, 1657, 1658, 1659, 1660, 1661, 1662, 1663, 1664, 1665,
     2   1666, 1667, 1668, 1669, 1670, 1671, 1672, 1673, 1674, 1675,
     3   1676, 1677, 1678, 1679, 1680, 1681, 1682, 1683, 1684, 1685,
     4   1686, 1687, 1688, 1689, 1690, 1691, 1692, 1693, 1694, 1695,
     5   1696, 1697, 1698, 1699, 1700, 1701, 1702, 1703, 1704, 1705,
     6   1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713, 1714, 1715,
     7   1716, 1717, 1718, 1719, 1719, 1721, 1722, 1723, 1724, 1725,
     8   1726, 1727, 1728, 1729, 1729, 1720, 1731, 1732, 1733, 1734,
     9   1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742, 1743, 1744/
            data (jb2(i),i= 1801, 1900)/
     +   1745, 1746, 1747, 1748, 1749, 1750, 1751, 1752, 1753, 1754,
     1   1755, 1756, 1757, 1758, 1759, 1760, 1761, 1762, 1763, 1764,
     2   1765, 1766, 1767, 1768, 1769, 1770, 1771, 1772, 1773, 1774,
     3   1775, 1776, 1777, 1778, 1779, 1780, 1781, 1782, 1783, 1784,
     4   1785, 1785, 1786, 1788, 1789, 1790, 1791, 1792, 1793, 1793,
     5   1794, 1795, 1796, 1797, 1798, 1799, 1800, 1801, 1802, 1803,
     6   1804, 1805, 1806, 1807, 1808, 1809, 1810, 1811, 1812, 1813,
     7   1814, 1815, 1816, 1817, 1817, 1818, 1819, 1820, 1821, 1821,
     8   1822, 1823, 1824, 1825, 1826, 1827, 1828, 1829, 1830, 1831,
     9   1832, 1833, 1834, 1835, 1835, 1836, 1837, 1838, 1839, 1840/
            data (jb2(i),i= 1901, 2000)/
     +   1841,   22, 1842, 1842, 1843,   24,   25, 1844, 1845,   26,
     1   1846, 1847, 1848, 1849, 1850, 1851, 1852, 1853, 1854, 1855,
     2   1856, 1857, 1858, 1859, 1860, 1861, 1862, 1863, 1864, 1865,
     3   1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873, 1874, 1875,
     4   1876, 1877, 1878,   27,    2,    3,    4,    4,    6,    7,
     5      8,    8,   10,   11,   12,   13,   14,   15,   15,   17,
     6     18,   18,   20,   21,   22,   23,   23,   25,   26,   27,
     7     27,   29,   30,   31,   31,   33,   34,   35,   36,   37,
     8     37,   39,   40,   40,   42,   43,   43,   45,   46,   46,
     9     48,   49,   49,   51,   52,   53,   53,   55,   56,   57/
            data (jb2(i),i= 2001, 2020)/
     +     57,   59,   60,   61,   62,   63,   64,   65,   66,   67,
     1     68,   69,   70,   70,   72,   73,   73,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ak(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1900) :: jx,jy,jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'alaska        '/
            data jrot,ipart/0,2/
            data kv/   1,1172,1901,   0,   0/
            data kb/   1,1172,1901,   0,   0/
            data iib/1171, 729,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  11304,11304,11184,11280,11352,11304,11328,11304,11376,11304,
     1  11304,11280,11256,11280,11280,11304,11376,11256,11280,11280,
     2  11304,11256,11256,11232,11250,11232,11304,11304,11400,11352,
     3  11328,11328,11304,11232,11232,11184,11208,11160,11232,11184,
     4  11136,11112,10968,10752,10752,10776,10704,10656,10656,10632,
     5  10560,10536,10584,10608,10536,10488,10608,10608,10656,10656,
     6  10704,10704,10704,10800,10800,10728,10872,10920,10896,10992,
     7  10992,11016,10896,10992,10944,10968,10872,10728,10728,10656,
     8  10656,10632,10608,10584,10704,10656,10632,10608,10560,10608,
     9  10608,10632,10632,10704,10752,10584,10588,10550,10550,10536/
            data (jx(i),i=  101,  200)/
     +  10488,10488,10512,10440,10440,10488,10488,10464,10392,10392,
     1  10416,10416,10512,10440,10440,10560,10536,10560,10752,10790,
     2  10790,10848,10848,10848,10800,10824,10800,10920,10824,10824,
     3  10848,10824,10872,10968,10920,10968,11040,11112,11136,11160,
     4  11088,11160,11208,11280,11376,11376,11472,11472,11544,11496,
     5  11736,11832,11856,11832,11832,11784,11784,11712,11736,11832,
     6  11808,11880,11904,11832,11808,11760,11736,11688,11640,11592,
     7  11472,11472,11424,11400,11424,11376,11352,11304,11376,11328,
     8  11256,11088,10992,11016,10968,10968,10944,10982,10920,10680,
     9  10632,10656,10608,10584,10584,10608,10594,10632,10656,10680/
            data (jx(i),i=  201,  300)/
     +  10680,10704,10776,10656,10488,10368,10368,10440,10392,10392,
     1  10440,10512,10512,10560,10632,10656,10656,10680,10704,10824,
     2  10896,10968,10896,10944,11064,11088,11184,11232,11256,11352,
     3  11400,11328,11376,11328,11328,11256,11304,11328,11352,11544,
     4  11568,11688,11736,11736,11760,11832,11904,11904,11928,11904,
     5  11784,11756,11760,11736,11736,11760,11760,11712,11640,11640,
     6  11664,11688,11760,11736,11832,11904,11976,12096,12120,12096,
     7  12120,12048,11976,11928,11904,11832,11760,11808,11856,11808,
     8  11712,11664,11712,11712,11640,11424,11424,11400,11280,11184,
     9  11064,11016,10920,11016,11016,11064,11064,11088,11448,11616/
            data (jx(i),i=  301,  400)/
     +  11688,11664,11712,11736,11712,11760,11760,11760,11976,12024,
     1  12000,12000,11976,11952,12024,12048,12168,12168,12312,12360,
     2  12360,12312,12360,12312,12336,12360,12360,12384,12408,12480,
     3  12384,12380,12336,12408,12480,12504,12504,12456,12480,12480,
     4  12528,12528,12600,12648,12624,12744,12840,12936,12984,13008,
     5  12970,12984,13056,13056,13056,13080,13128,13152,13104,13032,
     6  13056,13056,13080,13080,13128,13152,13176,13200,13200,13224,
     7  13224,13248,13320,13296,13272,13392,13440,13560,13632,13704,
     8  13728,13680,13680,13752,13656,13824,13800,13824,13776,13920,
     9  13920,13992,14064,14064,14160,14232,14376,14400,14448,14520/
            data (jx(i),i=  401,  500)/
     +  14568,14904,14952,15072,15216,15264,15360,15504,15576,15672,
     1  15744,15768,15768,15768,15816,15936,16200,16608,16776,16896,
     2  16920,17040,17112,17256,17256,17400,17448,17784,17856,17976,
     3  18048,18048,18072,18024,18096,18048,18192,18240,18384,18408,
     4  18384,18432,18432,18456,18528,18576,18600,18648,18696,18816,
     5  18984,19008,19080,19104,19440,19488,19488,19584,19584,19656,
     6  19704,19776,19944,19968,20040,20088,20160,20184,20280,20328,
     7  20328,20376,20448,20424,20424,20376,20376,20352,20304,20328,
     8  20304,20280,20256,20208,20256,20280,20256,20232,20184,20160,
     9  20184,20280,20256,20208,20136,20088,20112,20088,19992,20016/
            data (jx(i),i=  501,  600)/
     +  19968,19920,19824,19800,19824,19824,19776,19800,19824,19728,
     1  19680,19704,19728,19704,19728,19714,19728,19734,19824,19704,
     2  19656,19608,19584,19536,19536,19488,19488,19464,19488,19464,
     3  19368,19296,19344,19320,19296,19224,19224,19200,19176,19176,
     4  19104,19104,19176,19200,19176,19104,19104,19080,19056,19104,
     5  19032,18990,18984,19008,18984,18984,18960,18960,18936,18864,
     6  18840,18840,18840,18850,18864,18816,18816,18696,18624,18624,
     7  18528,18552,18528,18504,18456,18432,18336,18336,18288,18340,
     8  18384,18336,18312,18360,18384,18480,18480,18552,18576,18504,
     9  18432,18456,18408,18336,18336,18312,18336,18312,18336,18240/
            data (jx(i),i=  601,  700)/
     +  18288,18240,18240,18216,18168,18192,18216,18192,18144,18168,
     1  18120,18096,18072,18072,17948,18000,17952,17952,17976,18072,
     2  18120,18144,18120,18168,18144,18192,18192,18264,18240,18264,
     3  18312,18288,18240,18216,18168,18168,18192,18216,18144,18168,
     4  18168,18144,18144,18096,18072,18072,18048,18024,17856,17880,
     5  17832,17736,17712,17616,17544,17568,17520,17352,17376,17328,
     6  17328,17160,17208,17232,17184,17184,17256,17256,17294,17280,
     7  17304,17304,17266,17376,17280,17164,17164,17112,16992,16824,
     8  16704,16728,16728,16680,16704,16632,16344,16056,15984,16032,
     9  15960,15960,15864,15816,15768,15792,15792,15768,15792,15768/
            data (jx(i),i=  701,  800)/
     +  15696,15648,15576,15504,15552,15528,15504,15504,15480,15480,
     1  15408,15456,15456,15408,15384,15336,15288,15288,15432,15384,
     2  15360,15288,15288,15264,15312,15264,15288,15312,15288,15384,
     3  15360,15288,15216,15192,15192,15168,15144,15120,15144,15120,
     4  15096,15096,15096,15072,15072,15048,15048,15024,15024,15000,
     5  14976,14928,15000,15000,14928,14904,14832,14856,14832,14904,
     6  14880,14856,14880,14880,14856,14784,14832,14784,14784,14784,
     7  14856,14856,14904,14904,14880,14832,14808,14856,14904,14904,
     8  14904,14928,14928,14976,14952,14928,14928,14904,14928,14904,
     9  14904,14880,14952,14928,14952,14952,14928,14904,14904,14880/
            data (jx(i),i=  801,  900)/
     +  14880,14856,14736,14712,14736,14712,14688,14664,14640,14640,
     1  14602,14616,14592,14592,14568,14568,14544,14496,14544,14544,
     2  14472,14496,14496,14472,14448,14448,14424,14424,14376,14424,
     3  14352,14328,14352,14304,14328,14304,14328,14232,14256,14232,
     4  14208,14160,14184,14112,14040,14016,13968,13968,13992,13968,
     5  14040,14112,14088,14160,14160,14208,14088,14112,13992,14016,
     6  14088,14088,14112,14112,14088,14160,14328,14424,14472,14688,
     7  14640,14592,14424,14496,14616,14496,14448,14424,14304,14280,
     8  14280,14184,14184,14136,13992,13968,14016,13968,13920,13848,
     9  13848,13872,13824,13776,13704,13704,13800,13752,13632,13680/
            data (jx(i),i=  901, 1000)/
     +  13680,13632,13570,13608,13560,13560,13488,13536,13488,13488,
     1  13368,13440,13392,13392,13344,13368,13368,13416,13488,13584,
     2  13608,13584,13608,13584,13560,13464,13440,13464,13416,13440,
     3  13344,13416,13368,13392,13392,13368,13368,13344,13344,13296,
     4  13320,13272,13296,13272,13248,13224,13152,13128,13128,13080,
     5  13080,12984,12984,12984,12936,12960,12864,12864,12840,12864,
     6  12816,12720,12720,12768,12720,12744,12744,12720,12696,12672,
     7  12696,12624,12600,12576,12576,12528,12504,12504,12480,12432,
     8  12432,12384,12408,12408,12360,12336,12240,12216,12216,12144,
     9  12072,12096,12096,12120,12192,12144,12144,12216,12144,12120/
            data (jx(i),i= 1001, 1100)/
     +  12072,12072,12048,12048,12024,12048,12048,12000,11976,11832,
     1  11808,11808,11784,11760,11736,11712,11736,11760,11736,11760,
     2  11688,11688,11640,11616,11592,11592,11520,11520,11472,11472,
     3  11400,11448,11424,11400,11376,11256,11184,11184,11232,11304,
     4  11184,11136,11112,11040,11016,11016,10992,10992,10944,10944,
     5  10872,10848,10896,10848,10848,10800,10848,10824,10776,10752,
     6  10704,10728,10656,10656,10680,10584,10584,10632,10608,10608,
     7  10608,10704,10848,10848,10800,11088,11256,11208,11232,11352,
     8  11352,11304,11328,11328,11352,11376,11376,11448,11472,11544,
     9  11712,11904,11880,11880,12000,11976,12024,12048,12048,12072/
            data (jx(i),i= 1101, 1200)/
     +  12168,12240,12288,12360,12360,12384,12432,12384,12360,12384,
     1  12456,12528,12480,12432,12408,12408,12504,12600,12552,12600,
     2  12624,12648,12624,12604,12552,12528,12240,12264,12240,12240,
     3  12168,12192,12216,12216,12288,12336,12312,12216,12192,12216,
     4  12144,12130,12144,12120,12120,12120,12096,12110,12096,12072,
     5  12120,12096,12024,11952,11880,11904,11856,11856,11808,11784,
     6  11736,11712,11736,11712,11568,11544,11448,11448,11424,11400,
     7  11424,19008,18840,18864,18840,18840,18816,18816,18792,18816,
     8  18768,18768,18744,18696,18672,18696,18648,18624,18648,18624,
     9  18624,18576,18538,18552,18558,18600,18600,18576,18648,18648/
            data (jx(i),i= 1201, 1300)/
     +  18696,18720,18696,18720,18768,18912,18552,18528,18552,18528,
     1  18504,18552,18600,18576,18600,18600,19176,19128,19128,19104,
     2  19104,19080,19080,19080,19104,19104,19128,19128,19108,19056,
     3  19104,19056,19056,19032,19008,18984,19032,19008,19080,19008,
     4  19104,19128,19135,19128,19152,19152,19200,19176,19224,19224,
     5  19152,19176,19176,19224,19200,19224,19176,19200,19224,19224,
     6  19224,19200,19176,19176,19152,19176,13752,13632,13632,13728,
     7  13656,13680,13752,13752,13728,13776,13776,13824,13848,13872,
     8  13944,13920,13968,13968,13944,13920,13896,13872,13896,13872,
     9  13896,13824,13824,13800,13752, 8640, 8712, 8784, 8784, 8832/
            data (jx(i),i= 1301, 1400)/
     +   8928, 8904, 8952, 9072, 9120, 9096, 8952, 8856, 6024, 6024,
     1   6096, 6072, 6120, 6120, 6144, 6144, 6216, 6192, 6168, 6216,
     2   6216, 6192, 6072, 6072, 6792, 6600, 6696, 6744, 6840, 6864,
     3   6864, 6960, 6912, 7032, 7056, 7008, 6984, 6984, 6888, 6912,
     4   6888, 6864, 6864, 9144, 9096, 9144, 9192, 9216, 9264, 9264,
     5   9312, 9312, 9384, 9336, 9384, 9360, 9384, 9408, 9432, 9432,
     6   9480, 9384, 9360, 9504, 9528, 9528, 9528, 9576, 9600, 9600,
     7   9648, 9648, 9624, 9528, 9552, 9528, 9552, 9576, 9576, 9600,
     8   9600, 9528, 9504, 9480, 9480, 9456, 9456, 9432, 9432, 9408,
     9   9312, 9192, 9634, 9610, 9682, 5736, 5688, 5736, 5688, 5784/
            data (jx(i),i= 1401, 1500)/
     +   5784, 5856, 5808,10176,10104,10080,10176,10248,10344,10368,
     1  10488,10560,10584,10656,10680,10584,10560,10488,10320,10248,
     2  19800,19752,19704,19704,19608,19584,19608,19560,19584,19656,
     3  19608,19752,19776,19752,13416,13368,13488,13416,13488,13464,
     4  13392,13392,13416,13296,13296,13296,13344,13392,13368,13344,
     5  13320,13320,13272,13272,13248,13200,13200,13224,13200,13272,
     6  13272,13296,13320,13368,13416,13416,13392,13440,13440,13512,
     7  13464,13464,13512,13440,13536,13440,13440,13512,13560,13560,
     8  13584,13560,13608,13560,13632,13656,13632,13680,13608,13752,
     9  13728,13728,13738,13800,13800,13896,13824,13848,13848,13872/
            data (jx(i),i= 1501, 1600)/
     +  13848,13944,13896,13704,13728,13680,13752,13824,13800,13752,
     1  13728,13656,13656,13704,13584,13584,13560,13536,13560,13488,
     2  13512,13536,13536,13512,13488,13512,19992,19896,19920,19872,
     3  19896,19848,19824,19824,19800,19800,19776,19776,19800,19752,
     4  19752,19704,19728,19728,19680,19656,19608,19632,19536,19512,
     5  19536,19632,19584,19560,19584,19536,19536,19488,19440,19416,
     6  19464,19464,19440,19392,19272,19272,19272,19272,19344,19368,
     7  19392,19440,19464,19440,19464,19560,19656,19704,19752,19824,
     8  19824,19680,19680,19704,19680,19728,19800,19728,19800,19824,
     9  19872,19824,19848,19872,19896,19896,19920,19896,19920,19872/
            data (jx(i),i= 1601, 1700)/
     +  19944,19944,19968,19944,19992,19968,19992,19944,19920,19920,
     1  19992,19968,20064,20040,20064,20016,20040,20088,20112,20088,
     2  20064,20064,20136,20098,20112,20088,20088,20040,20064,20016,
     3  20050,20040,19992,19992,20016,20016,19992,19920,19944,19944,
     4  19920,19920,19944,19896,19944,19872,19944,19896,19982,20136,
     5  20160,20136,20160,19320,19272,19296,19344,19296,19392,19392,
     6  19344,19680,19656,19656,19584,19560,19536,19560,19560,19608,
     7  19608,19608,19632,19688,19664,19702,19678,19698,19632,19632,
     8  19584,19656,19704,19752,19488,19416,19440,19488,19536,19526,
     9  19248,19254,19230,19224,19216,19152,19152,19104,19152,19056/
            data (jx(i),i= 1701, 1800)/
     +  19080,19248,19272,19248,19280,19348,19368,19392,19392,19248,
     1  19296,19320,19320,19344,19368,19368,19296,19296,19464,19416,
     2  19398,19416,19388,19416,19512,19464,19488,18888,18864,18840,
     3  18888,18840,18888,18840,18912,18912,18864,18816,18864,18816,
     4  18768,18672,18672,18624,18624,18600,18576,18624,18696,18816,
     5  18840,18960,18984,19008,18960,18864,18840,18792,18816,18816,
     6  18840,18864,18936,18936,18960,19032,18960,18960,18984,18984,
     7  19008,19032,19008,18936,18984,18936,18792,18696,18672,18696,
     8  15024,15072,15048,15072,15192,15168,15240,15216,15240,15192,
     9  15144,15168,15120,15144,10248,10008, 9960, 9936,10104,10104/
            data (jx(i),i= 1801, 1900)/
     +  10200,10224,10296,10296,10392,10368,10392,10368,10416,10368,
     1  10200,10248,15336,15312,15360,15288,15336,15456, 8736, 8640,
     2   8568, 8568, 8616, 8616, 8712, 9720, 9696, 9672, 9624, 9504,
     3   9456, 9360, 9288, 9288, 9336, 9360, 9360, 9384, 9360, 9384,
     4   9408, 9504, 9576, 9648, 9696, 9696, 9672, 9864, 9984, 9936,
     5   9816,18384,18552,18576,18576,18696,18768,18720,18456,18480,
     6  18456,18528,18528,18552,18552,18528,18480,18432,18504,18408,
     7  18384,18384,18336,18264,18264,18264,18384,18600,18648,18672,
     8  18648,18672,18648,18504,18456,18408,18456,18408,18456,18480,
     9  18384,18360,18312,18288,18336,18288,18264,18240,18264,18240/
            data (jy(i),i=    1,  100)/
     +  14304,14328,14352,14352,14424,14424,14520,14544,14568,14592,
     1  14568,14616,14688,14688,14664,14736,14784,15096,15144,15168,
     2  15192,15192,15144,15144,15168,15240,15336,15360,15432,15408,
     3  15456,15408,15384,15288,15264,15240,15216,15216,15168,15072,
     4  15096,15048,15000,15048,15120,15144,15192,15288,15336,15312,
     5  15384,15408,15408,15456,15432,15480,15528,15576,15600,15624,
     6  15624,15600,15576,15552,15504,15432,15528,15504,15432,15456,
     7  15504,15504,15576,15576,15600,15624,15576,15600,15648,15648,
     8  15672,15648,15648,15672,15744,15744,15720,15768,15816,15840,
     9  15864,15888,15912,15936,16008,15888,15840,15816,15792,15744/
            data (jy(i),i=  101,  200)/
     +  15768,15840,15864,15888,15936,15960,15984,16008,16008,16056,
     1  16104,16080,16080,16104,16152,16152,16248,16296,16488,16488,
     2  16440,16416,16440,16464,16464,16488,16488,16584,16512,16608,
     3  16608,16632,16728,16704,16776,16824,16824,16800,16752,16752,
     4  16680,16728,16680,16704,16776,16800,16896,16920,16872,16848,
     5  16872,16992,17040,17160,17256,17328,17352,17352,17424,17400,
     6  17424,17448,17496,17616,17616,17544,17520,17568,17520,17520,
     7  17448,17376,17352,17424,17424,17472,17520,17496,17448,17400,
     8  17496,17520,17496,17520,17496,17520,17496,17486,17472,17616,
     9  17688,17760,17832,17904,17952,18000,17928,17904,17904,17928/
            data (jy(i),i=  201,  300)/
     +  17952,17952,17952,18024,18096,18192,18240,18288,18240,18216,
     1  18264,18240,18288,18312,18312,18336,18360,18336,18384,18432,
     2  18360,18384,18432,18480,18528,18504,18552,18576,18576,18576,
     3  18528,18552,18528,18456,18384,18360,18360,18312,18288,18264,
     4  18216,18240,18168,18192,18240,18336,18312,18240,18312,18360,
     5  18408,18384,18336,18336,18360,18432,18480,18576,18600,18672,
     6  18696,18696,18600,18552,18408,18456,18360,18360,18432,18480,
     7  18504,18480,18504,18504,18476,18456,18576,18672,18696,18744,
     8  18720,18720,18792,18816,18744,18816,18960,19056,19224,19344,
     9  19416,19512,19560,19560,19584,19656,19728,19824,19776,19872/
            data (jy(i),i=  301,  400)/
     +  19992,19944,19968,20064,20088,20136,20160,20184,20424,20400,
     1  20400,20376,20376,20352,20352,20400,20400,20424,20544,20544,
     2  20496,20472,20472,20400,20424,20328,20424,20462,20472,20496,
     3  20472,20554,20554,20640,20664,20664,20640,20616,20568,20616,
     4  20616,20640,20616,20616,20640,20640,20736,20856,20904,20904,
     5  20880,20832,20832,20808,20784,20808,20784,20760,20712,20664,
     6  20640,20568,20592,20616,20616,20664,20712,20688,20736,20736,
     7  20760,20760,20712,20664,20640,20592,20640,20664,20640,20640,
     8  20592,20544,20520,20496,20472,20472,20448,20448,20424,20376,
     9  20424,20448,20448,20400,20472,20472,20424,20376,20400,20400/
            data (jy(i),i=  401,  500)/
     +  20352,20352,20304,20280,20352,20376,20400,20352,20304,20280,
     1  20208,20208,20232,20256,20232,19608,18288,16248,15432,15408,
     2  15456,15408,15504,15552,15408,15336,15288,15072,14904,15096,
     3  15096,15168,15168,15264,15312,15336,15456,15504,15432,15360,
     4  15336,15336,15312,15288,15288,15240,15240,15168,15120,15096,
     5  14976,14904,14856,14856,14520,14472,14400,14400,14304,14304,
     6  14208,14232,14184,14184,14184,14160,14160,14112,14136,14040,
     7  13944,13848,13728,13704,13512,13440,13464,13416,13512,13416,
     8  13392,13392,13488,13488,13560,13560,13584,13536,13536,13584,
     9  13632,13680,13704,13656,13848,13872,13896,13896,13944,14040/
            data (jy(i),i=  501,  600)/
     +  13944,13944,13824,13752,13752,13704,13728,13680,13632,13656,
     1  13728,13728,13728,13776,13776,13848,13872,13968,14040,14016,
     2  14064,14064,14088,14112,14184,14160,14184,14184,14256,14208,
     3  14232,14280,14304,14352,14304,14328,14352,14352,14352,14304,
     4  14328,14400,14400,14472,14424,14424,14472,14472,14520,14568,
     5  14520,14544,14592,14640,14712,14736,14760,14808,14712,14736,
     6  14832,14880,14904,14976,15000,14952,14784,14856,14832,14904,
     7  14976,14976,15048,15000,15048,15120,15240,15264,15264,15216,
     8  15144,15192,15216,15144,15096,14928,14904,14832,14736,14736,
     9  14832,14784,14784,14760,14784,14784,14808,14856,14880,14952/
            data (jy(i),i=  601,  700)/
     +  15024,15024,14976,15024,15072,15024,14976,14928,14928,14952,
     1  14952,15000,14976,14952,15024,14952,14952,14880,14928,14928,
     2  14880,14856,14904,14880,14832,14832,14856,14832,14808,14808,
     3  14736,14712,14688,14736,14736,14712,14712,14688,14688,14640,
     4  14616,14640,14664,14664,14688,14664,14688,14664,14736,14784,
     5  14760,14832,14880,14952,14952,15000,14952,15000,15024,15048,
     6  15024,15096,15144,15192,15288,15336,15288,15216,15158,15144,
     7  15144,15168,15264,15288,15288,15360,15312,15240,15144,15168,
     8  15192,15240,15288,15312,15264,15216,15240,15120,15144,15144,
     9  15192,15240,15216,15240,15264,15336,15360,15336,15456,15408/
            data (jy(i),i=  701,  800)/
     +  15288,15264,15312,15312,15432,15408,15408,15432,15384,15432,
     1  15384,15456,15480,15432,15456,15408,15408,15432,15504,15528,
     2  15480,15480,15504,15528,15528,15552,15576,15576,15600,15624,
     3  15648,15624,15528,15528,15552,15552,15576,15576,15528,15504,
     4  15504,15552,15576,15528,15600,15648,15552,15576,15600,15552,
     5  15552,15600,15744,15768,15624,15672,15648,15648,15600,15648,
     6  15600,15600,15576,15528,15528,15504,15504,15480,15456,15432,
     7  15504,15408,15504,15432,15384,15384,15336,15370,15336,15360,
     8  15384,15360,15408,15336,15312,15312,15288,15288,15264,15216,
     9  15192,15168,15216,15192,15168,15144,15168,15072,15048,15072/
            data (jy(i),i=  801,  900)/
     +  15048,15024,15024,15048,15072,15072,14976,15048,15120,15048,
     1  14952,14904,14904,15000,15024,14952,14880,14880,14856,14784,
     2  14856,14808,14784,14760,14808,14736,14736,14712,14688,14808,
     3  14664,14712,14736,14712,14688,14664,14664,14592,14568,14520,
     4  14568,14592,14544,14544,14496,14544,14568,14592,14592,14640,
     5  14664,14640,14688,14736,14760,14832,14760,14736,14808,14952,
     6  15048,15144,15144,15240,15336,15360,15504,15432,15480,15432,
     7  15480,15466,15576,15696,15768,15744,15696,15624,15624,15672,
     8  15624,15600,15576,15504,15432,15384,15336,15336,15288,15192,
     9  15168,15144,15096,15048,15072,15048,14976,14904,14856,14856/
            data (jy(i),i=  901, 1000)/
     +  14784,14736,14760,14784,14832,14736,14736,14688,14688,14640,
     1  14616,14592,14568,14520,14472,14472,14424,14448,14448,14400,
     2  14352,14328,14328,14256,14208,14208,14160,14136,14136,14088,
     3  14040,14016,14016,13992,13968,13968,13944,13968,13920,13992,
     4  13920,13944,13920,13896,13920,13872,13896,13848,13824,13800,
     5  13752,13776,13728,13704,13704,13656,13656,13632,13632,13584,
     6  13608,13536,13512,13512,13488,13464,13440,13440,13392,13392,
     7  13344,13392,13320,13368,13320,13272,13296,13272,13248,13296,
     8  13248,13224,13200,13176,13176,13224,13152,13128,13104,13104,
     9  13008,13008,13032,13056,13008,12984,12960,12984,12936,12960/
            data (jy(i),i= 1001, 1100)/
     +  12984,12960,12936,12912,12888,12888,12840,12888,12840,12816,
     1  12768,12840,12840,12792,12744,12768,12792,12816,12840,12864,
     2  12888,12864,12864,12816,12840,12792,12792,12768,12720,12792,
     3  12768,12744,12720,12720,12744,12672,12696,12744,12792,12768,
     4  12816,12768,12720,12624,12648,12576,12552,12528,12504,12456,
     5  12480,12528,12504,12600,12624,12576,12552,12504,12456,12432,
     6  12480,12480,12552,12504,12456,12408,12432,12456,12456,12480,
     7  12552,12600,12644,12672,12672,12888,12912,12888,12888,12912,
     8  12864,12864,12840,12816,12744,12792,12840,12816,12840,13008,
     9  13128,13200,13200,13224,13296,13272,13248,13224,13344,13368/
            data (jy(i),i= 1101, 1200)/
     +  13512,13536,13584,13622,13584,13536,13536,13608,13632,13848,
     1  13910,13896,13920,13920,13968,14016,14136,14184,14208,14280,
     2  14328,14400,14376,14328,14256,14256,14136,14232,14256,14304,
     3  14352,14424,14424,14448,14448,14376,14448,14496,14544,14472,
     4  14376,14424,14448,14448,14400,14328,14304,14352,14352,14328,
     5  14184,14136,14160,14352,14376,14448,14448,14400,14352,14424,
     6  14424,14472,14472,14520,14424,14448,14424,14400,14376,14352,
     7  14328,13728,13872,13968,13944,13992,13892,13920,13944,13992,
     8  13944,14016,13992,14016,14064,14112,14112,14136,14160,14146,
     9  14208,14232,14256,14280,14304,14352,14328,14280,14328,14304/
            data (jy(i),i= 1201, 1300)/
     +  14304,14280,14280,14256,14232,13992,14040,14112,14160,14136,
     1  14208,14232,14184,14184,14136,14064,13704,13728,13776,13800,
     2  13848,13824,13848,13896,13872,13896,13872,13944,13920,13944,
     3  13992,13968,14016,13992,14016,14064,14064,14112,14088,14136,
     4  14112,14088,14040,13992,14064,14088,14088,14040,14016,13992,
     5  13992,13982,13944,13920,13896,13824,13872,13824,13800,13776,
     6  13728,13728,13824,13752,13752,13728,13876,13968,13992,13968,
     7  14016,14040,14016,14064,14088,14112,14136,14136,14064,14136,
     8  14088,14040,14088,14064,13992,13992,14040,14040,14016,14016,
     9  13968,13944,14016,13944,13944,11712,11756,11808,11856,11904/
            data (jy(i),i= 1301, 1400)/
     +  11880,11928,11976,12000,11952,11904,11856,11784,11808,11832,
     1  11880,11904,11880,11904,11904,11952,11952,11928,11904,11880,
     2  11808,11832,11784,11856,11784,11832,11818,11856,11808,11808,
     3  11832,11856,11904,11928,11856,11808,11832,11760,11808,11784,
     4  11760,11798,11760,11808,11856,11904,11880,11904,11880,11904,
     5  11904,11928,11928,11976,11976,12000,12024,12000,11952,12000,
     6  12000,12048,12096,12168,12120,12096,12048,12072,12144,12096,
     7  12120,12096,12072,12024,12024,12000,11976,12000,11976,12024,
     8  11952,11952,11904,11928,11904,11928,11880,11928,11880,11904,
     9  11880,11808,11976,12024,12024,11904,11976,12000,12096,12072/
            data (jy(i),i= 1401, 1500)/
     +  12024,12000,12000,12240,12264,12360,12384,12504,12480,12504,
     1  12552,12528,12384,12360,12312,12360,12336,12312,12336,12264,
     2  13152,13152,13200,13224,13248,13320,13344,13368,13416,13320,
     3  13320,13224,13200,13176,13224,13224,13344,13344,13416,13440,
     4  13344,13368,13416,13416,13392,13368,13406,13406,13320,13296,
     5  13272,13320,13344,13440,13488,13512,13536,13536,13584,13632,
     6  13656,13656,13680,13704,13680,13656,13632,13632,13560,13488,
     7  13560,13656,13632,13680,13680,13728,13776,13824,13680,13728,
     8  13728,13752,13728,13800,13776,13728,13824,13800,13872,13848,
     9  13800,13728,13800,13800,13848,13776,13728,13728,13704,13728/
            data (jy(i),i= 1501, 1600)/
     +  13680,13680,13584,13632,13608,13584,13608,13560,13512,13488,
     1  13536,13536,13512,13488,13464,13440,13416,13440,13392,13368,
     2  13368,13344,13320,13344,13296,13272,13224,13224,13272,13248,
     3  13296,13320,13368,13296,13344,13296,13320,13344,13368,13392,
     4  13416,13464,13416,13392,13416,13440,13392,13440,13416,13440,
     5  13464,13488,13488,13512,13512,13536,13584,13560,13560,13632,
     6  13656,13728,13728,13848,13848,13872,13896,13920,13920,13896,
     7  13944,13920,13872,13848,13824,13824,13752,13656,13632,13608,
     8  13584,13656,13608,13608,13560,13584,13584,13536,13560,13560,
     9  13512,13488,13464,13488,13536,13512,13440,13440,13392,13368/
            data (jy(i),i= 1601, 1700)/
     +  13386,13368,13344,13320,13296,13272,13488,13512,13584,13608,
     1  13560,13536,13416,13488,13512,13560,13560,13560,13464,13440,
     2  13488,13464,13584,13584,13608,13656,13584,13584,13680,13776,
     3  13656,13608,13704,13680,13608,13584,13584,13632,13704,13728,
     4  13728,13752,13800,13776,13824,13824,13872,13872,13944,13824,
     5  13680,13680,13608,13704,13680,13776,13800,13800,13824,13752,
     6  13752,13800,13824,13872,13848,13872,13944,13944,14016,14016,
     7  13968,13944,13958,13934,13920,13848,13848,13944,13968,13992,
     8  14078,13990,14004,13992,13920,13968,14016,14040,14016,13944,
     9  13968,14016,14016,14040,14094,14160,14136,14160,14184,14208/
            data (jy(i),i= 1701, 1800)/
     +  14256,14256,14232,14280,14280,14232,14208,14112,14088,14184,
     1  14126,14126,14088,14088,14040,14016,14016,13992,14064,14064,
     2  14088,14112,14184,14208,14136,14088,14064,14160,14232,14256,
     3  14280,14304,14328,14352,14352,14376,14376,14400,14448,14424,
     4  14448,14664,14688,14736,14760,14784,14832,14808,14736,14780,
     5  14736,14616,14544,14520,14544,14688,14712,14736,14712,14688,
     6  14592,14616,14544,14520,14520,14448,14448,14424,14424,14400,
     7  14424,14400,14352,14376,14328,14208,14784,14784,14808,14832,
     8  14904,14952,14976,15000,15144,15216,15216,15168,15192,15096,
     9  15024,15000,15000,14952,15096,15264,15312,15384,15360,15408/
            data (jy(i),i= 1801, 1900)/
     +  15432,15408,15432,15384,15360,15288,15240,15240,15192,15144,
     1  15144,15120,15168,15192,15240,15240,15288,15264,15744,15768,
     2  15888,15912,15936,15864,15792,16920,17016,17040,17136,17256,
     3  17256,17208,17256,17352,17424,17472,17424,17400,17376,17376,
     4  17376,17328,17352,17352,17280,17256,17232,17088,17064,16992,
     5  17040,14544,14496,14472,14448,14520,14376,14352,14448,14400,
     6  14376,14376,14352,14352,14304,14256,14256,14304,14280,14352,
     7  14352,14376,14424,14424,14448,14520,14562,14496,14520,14544,
     8  14568,14592,14640,14664,14554,14568,14592,14592,14616,14664,
     9  14712,14640,14664,14640,14568,14568,14640,14640,14592,14558/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     1     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     2     21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
     3     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     4     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     5     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     7     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     8     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     9     91,   92,   93,   94,   95,   96,   97,   98,   99,  100/
            data (jb1(i),i=  101,  200)/
     +    101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
     1    111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
     2    121,  122,  123,  124,  125,  126,  127,  128,  129,  130,
     3    131,  132,  133,  134,  135,  136,  137,  138,  139,  140,
     4    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     5    151,  152,  153,  154,  155,  156,  157,  158,  159,  160,
     6    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     7    171,  172,  173,  174,  175,  176,  177,  178,  179,  180,
     8    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     9    191,  192,  193,  194,  195,  196,  197,  198,  199,  200/
            data (jb1(i),i=  201,  300)/
     +    201,  202,  203,  204,  205,  206,  207,  208,  209,  210,
     1    211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
     2    221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
     3    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     4    241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
     5    251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
     6    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     7    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     8    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     9    291,  292,  293,  294,  295,  296,  297,  298,  299,  300/
            data (jb1(i),i=  301,  400)/
     +    301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
     1    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     2    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     3    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     7    371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
     8    381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
     9    391,  392,  393,  394,  395,  396,  397,  398,  399,  400/
            data (jb1(i),i=  401,  500)/
     +    401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
     1    411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
     2    421,  422,  423,  424,  425,  426,  427,  428,  429,  430,
     3    431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
     4    441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
     5    451,  452,  453,  454,  455,  456,  457,  458,  459,  460,
     6    461,  462,  463,  464,  465,  466,  467,  468,  469,  470,
     7    471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
     8    481,  482,  483,  484,  485,  486,  487,  488,  489,  490,
     9    491,  492,  493,  494,  495,  496,  497,  498,  499,  500/
            data (jb1(i),i=  501,  600)/
     +    501,  502,  503,  504,  505,  506,  507,  508,  509,  510,
     1    511,  512,  513,  514,  515,  516,  517,  518,  519,  520,
     2    521,  522,  523,  524,  525,  526,  527,  528,  529,  530,
     3    531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
     4    541,  542,  543,  544,  545,  546,  547,  548,  549,  550,
     5    551,  552,  553,  554,  555,  556,  557,  558,  559,  560,
     6    561,  562,  563,  564,  565,  566,  567,  568,  569,  570,
     7    571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
     8    581,  582,  583,  584,  585,  586,  587,  588,  589,  590,
     9    591,  592,  593,  594,  595,  596,  597,  598,  599,  600/
            data (jb1(i),i=  601,  700)/
     +    601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
     1    611,  612,  613,  614,  615,  616,  617,  618,  619,  620,
     2    621,  622,  623,  624,  625,  626,  627,  628,  629,  630,
     3    631,  632,  633,  634,  635,  636,  637,  638,  639,  640,
     4    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     5    651,  652,  653,  654,  655,  656,  657,  658,  659,  660,
     6    661,  662,  663,  664,  665,  666,  667,  668,  669,  670,
     7    671,  672,  673,  674,  675,  676,  677,  678,  679,  680,
     8    681,  682,  683,  684,  685,  686,  687,  688,  689,  690,
     9    691,  692,  693,  694,  695,  696,  697,  698,  699,  700/
            data (jb1(i),i=  701,  800)/
     +    701,  702,  703,  704,  705,  706,  707,  708,  709,  710,
     1    711,  712,  713,  714,  715,  716,  717,  718,  719,  720,
     2    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     3    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     4    741,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     5    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     6    761,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     7    771,  772,  773,  774,  775,  776,  777,  778,  779,  780,
     8    781,  782,  783,  784,  785,  786,  787,  788,  789,  790,
     9    791,  792,  793,  794,  795,  796,  797,  798,  799,  800/
            data (jb1(i),i=  801,  900)/
     +    801,  802,  803,  804,  805,  806,  807,  808,  809,  810,
     1    811,  812,  813,  814,  815,  816,  817,  818,  819,  820,
     2    821,  822,  823,  824,  825,  826,  827,  828,  829,  830,
     3    831,  832,  833,  834,  835,  836,  837,  838,  839,  840,
     4    841,  842,  843,  844,  845,  846,  847,  848,  849,  850,
     5    851,  852,  853,  854,  855,  856,  857,  858,  859,  860,
     6    861,  862,  863,  864,  865,  866,  867,  868,  869,  870,
     7    871,  872,  873,  874,  875,  876,  877,  878,  879,  880,
     8    881,  882,  883,  884,  885,  886,  887,  888,  889,  890,
     9    891,  892,  893,  894,  895,  896,  897,  898,  899,  900/
            data (jb1(i),i=  901, 1000)/
     +    901,  902,  903,  904,  905,  906,  907,  908,  909,  910,
     1    911,  912,  913,  914,  915,  916,  917,  918,  919,  920,
     2    921,  922,  923,  924,  925,  926,  927,  928,  929,  930,
     3    931,  932,  933,  934,  935,  936,  937,  938,  939,  940,
     4    941,  942,  943,  944,  945,  946,  947,  948,  949,  950,
     5    951,  952,  953,  954,  955,  956,  957,  958,  959,  960,
     6    961,  962,  963,  964,  965,  966,  967,  968,  969,  970,
     7    971,  972,  973,  974,  975,  976,  977,  978,  979,  980,
     8    981,  982,  983,  984,  985,  986,  987,  988,  989,  990,
     9    991,  992,  993,  994,  995,  996,  997,  998,  999, 1000/
            data (jb1(i),i= 1001, 1100)/
     +   1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010,
     1   1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020,
     2   1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030,
     3   1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040,
     4   1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050,
     5   1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060,
     6   1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070,
     7   1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080,
     8   1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090,
     9   1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100/
            data (jb1(i),i= 1101, 1200)/
     +   1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110,
     1   1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120,
     2   1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130,
     3   1131, 1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140,
     4   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150,
     5   1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160,
     6   1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170,
     7      1,    1,    2,    3,    4,    5,    6,    7,    8,    9,
     8     10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
     9     20,   21,   22,   23,   24,   25,   26,   27,   28,   29/
            data (jb1(i),i= 1201, 1300)/
     +     30,   31,   32,   33,   34,    1,   36,   37,   38,   39,
     1     40,   41,   42,   43,   44,   36,   46,   47,   48,   49,
     2     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     3     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     4     70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
     5     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     6     90,   91,   92,   93,   94,   46,   96,   97,   98,   99,
     7    100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
     8    110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
     9    120,  121,  122,  123,   96,  125,  126,  127,  128,  129/
            data (jb1(i),i= 1301, 1400)/
     +    130,  131,  132,  133,  134,  135,  136,  125,  138,  139,
     1    140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
     2    150,  151,  152,  138,  154,  155,  156,  157,  158,  159,
     3    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     4    170,  171,  154,  173,  174,  175,  176,  177,  178,  179,
     5    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     6    190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
     7    200,  201,  202,  203,  204,  205,  206,  207,  208,  209,
     8    210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
     9    220,  173,  222,  223,  222,  225,  226,  227,  228,  229/
            data (jb1(i),i= 1401, 1500)/
     +    230,  231,  225,  233,  234,  235,  236,  237,  238,  239,
     1    240,  241,  242,  243,  244,  245,  246,  247,  248,  233,
     2    250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
     3    260,  261,  262,  250,  264,  265,  266,  267,  268,  269,
     4    270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
     5    280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
     6    290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
     7    300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
     8    310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
     9    320,  321,  322,  323,  324,  325,  326,  327,  328,  329/
            data (jb1(i),i= 1501, 1600)/
     +    330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
     1    340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
     2    350,  351,  352,  353,  354,  264,  356,  357,  358,  359,
     3    360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
     4    370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
     5    380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     6    390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
     7    400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
     8    410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
     9    420,  421,  422,  423,  424,  425,  426,  427,  428,  429/
            data (jb1(i),i= 1601, 1700)/
     +    430,  431,  432,  433,  434,  356,  436,  437,  438,  439,
     1    440,  436,  442,  443,  444,  445,  446,  447,  448,  449,
     2    450,  442,  452,  453,  454,  455,  456,  457,  458,  459,
     3    460,  461,  462,  463,  464,  465,  466,  467,  468,  469,
     4    470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
     5    480,  481,  452,  483,  484,  485,  486,  487,  488,  489,
     6    483,  491,  492,  493,  494,  495,  496,  497,  498,  499,
     7    500,  501,  502,  503,  504,  505,  491,  507,  508,  509,
     8    510,  511,  512,  507,  514,  515,  516,  517,  518,  514,
     9    520,  521,  522,  523,  524,  525,  526,  527,  528,  529/
            data (jb1(i),i= 1701, 1800)/
     +    530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
     1    540,  541,  542,  543,  544,  545,  546,  520,  548,  549,
     2    550,  551,  552,  553,  554,  555,  548,  557,  558,  559,
     3    560,  561,  562,  563,  564,  565,  566,  567,  568,  569,
     4    570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
     5    580,  581,  582,  583,  584,  585,  586,  587,  588,  589,
     6    590,  591,  592,  593,  594,  595,  596,  597,  598,  599,
     7    600,  601,  602,  603,  604,  557,  606,  607,  608,  606,
     8    610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
     9    620,  621,  622,  610,  624,  625,  626,  627,  628,  629/
            data (jb1(i),i= 1801, 1900)/
     +    630,  631,  632,  633,  634,  635,  636,  637,  638,  639,
     1    640,  624,  642,  643,  644,  645,  646,  642,  648,  649,
     2    650,  651,  652,  653,  648,  655,  656,  657,  658,  659,
     3    660,  661,  662,  663,  664,  665,  666,  667,  668,  669,
     4    670,  671,  672,  673,  674,  675,  676,  677,  678,  679,
     5    655,  681,  682,  683,  684,  685,  686,  687,  688,  689,
     6    690,  691,  692,  693,  694,  695,  696,  697,  698,  699,
     7    700,  701,  702,  703,  704,  681,  706,  707,  708,  709,
     8    710,  711,  712,  713,  714,  715,  716,  717,  718,  719,
     9    720,  721,  722,  723,  724,  725,  726,  727,  728,  706/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   97,   98,   99,  100,  101/
            data (jb2(i),i=  101,  200)/
     +    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     1    112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
     2    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     3    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     4    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb2(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     4    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     5    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     9    292,  293,  294,  295,  296,  297,  298,  299,  300,  301/
            data (jb2(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     1    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     5    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     6    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     7    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     8    382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
     9    392,  393,  394,  395,  396,  397,  398,  399,  400,  401/
            data (jb2(i),i=  401,  500)/
     +    402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
     1    412,  413,  414,  415,  416,  417,  418,  419,  420,  421,
     2    422,  423,  424,  425,  426,  427,  428,  429,  430,  431,
     3    432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
     4    442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
     5    452,  453,  454,  455,  456,  457,  458,  459,  460,  461,
     6    462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
     7    472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
     8    482,  483,  484,  485,  486,  487,  488,  489,  490,  491,
     9    492,  493,  494,  495,  496,  497,  498,  499,  500,  501/
            data (jb2(i),i=  501,  600)/
     +    502,  503,  504,  505,  506,  507,  508,  509,  510,  511,
     1    512,  513,  514,  515,  516,  517,  518,  519,  520,  521,
     2    522,  523,  524,  525,  526,  527,  528,  529,  530,  531,
     3    532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
     4    542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
     5    552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
     6    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     7    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     8    582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
     9    592,  593,  594,  595,  596,  597,  598,  599,  600,  601/
            data (jb2(i),i=  601,  700)/
     +    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     1    612,  613,  614,  615,  616,  617,  618,  619,  620,  621,
     2    622,  623,  624,  625,  626,  627,  628,  629,  630,  631,
     3    632,  633,  634,  635,  636,  637,  638,  639,  640,  641,
     4    642,  643,  644,  645,  646,  647,  648,  649,  650,  651,
     5    652,  653,  654,  655,  656,  657,  658,  659,  660,  661,
     6    662,  663,  664,  665,  666,  667,  668,  669,  670,  671,
     7    672,  673,  674,  675,  676,  677,  678,  679,  680,  681,
     8    682,  683,  684,  685,  686,  687,  688,  689,  690,  691,
     9    692,  693,  694,  695,  696,  697,  698,  699,  700,  701/
            data (jb2(i),i=  701,  800)/
     +    702,  703,  704,  705,  706,  707,  708,  709,  710,  711,
     1    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     2    722,  723,  724,  725,  726,  727,  728,  729,  730,  731,
     3    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     4    742,  743,  744,  745,  746,  747,  748,  749,  750,  751,
     5    752,  753,  754,  755,  756,  757,  758,  759,  760,  761,
     6    762,  763,  764,  765,  766,  767,  768,  769,  770,  771,
     7    772,  773,  774,  775,  776,  777,  778,  779,  780,  781,
     8    782,  783,  784,  785,  786,  787,  788,  789,  790,  791,
     9    792,  793,  794,  795,  796,  797,  798,  799,  800,  801/
            data (jb2(i),i=  801,  900)/
     +    802,  803,  804,  805,  806,  807,  808,  809,  810,  811,
     1    812,  813,  814,  815,  816,  817,  818,  819,  820,  821,
     2    822,  823,  824,  825,  826,  827,  828,  829,  830,  831,
     3    832,  833,  834,  835,  836,  837,  838,  839,  840,  841,
     4    842,  843,  844,  845,  846,  847,  848,  849,  850,  851,
     5    852,  853,  854,  855,  856,  857,  858,  859,  860,  861,
     6    862,  863,  864,  865,  866,  867,  868,  869,  870,  871,
     7    872,  873,  874,  875,  876,  877,  878,  879,  880,  881,
     8    882,  883,  884,  885,  886,  887,  888,  889,  890,  891,
     9    892,  893,  894,  895,  896,  897,  898,  899,  900,  901/
            data (jb2(i),i=  901, 1000)/
     +    902,  903,  904,  905,  906,  907,  908,  909,  910,  911,
     1    912,  913,  914,  915,  916,  917,  918,  919,  920,  921,
     2    922,  923,  924,  925,  926,  927,  928,  929,  930,  931,
     3    932,  933,  934,  935,  936,  937,  938,  939,  940,  941,
     4    942,  943,  944,  945,  946,  947,  948,  949,  950,  951,
     5    952,  953,  954,  955,  956,  957,  958,  959,  960,  961,
     6    962,  963,  964,  965,  966,  967,  968,  969,  970,  971,
     7    972,  973,  974,  975,  976,  977,  978,  979,  980,  981,
     8    982,  983,  984,  985,  986,  987,  988,  989,  990,  991,
     9    992,  993,  994,  995,  996,  997,  998,  999, 1000, 1001/
            data (jb2(i),i= 1001, 1100)/
     +   1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011,
     1   1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021,
     2   1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031,
     3   1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041,
     4   1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051,
     5   1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061,
     6   1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071,
     7   1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081,
     8   1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091,
     9   1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101/
            data (jb2(i),i= 1101, 1200)/
     +   1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111,
     1   1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121,
     2   1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     3   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141,
     4   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151,
     5   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     6   1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171,
     7   1171,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     8     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     9     21,   22,   23,   24,   25,   26,   27,   28,   29,   30/
            data (jb2(i),i= 1201, 1300)/
     +     31,   32,   33,   34,   35,   35,   37,   38,   39,   40,
     1     41,   42,   43,   44,   45,   45,   47,   48,   49,   50,
     2     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     3     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     4     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     5     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     6     91,   92,   93,   94,   95,   95,   97,   98,   99,  100,
     7    101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
     8    111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
     9    121,  122,  123,  124,  124,  126,  127,  128,  129,  130/
            data (jb2(i),i= 1301, 1400)/
     +    131,  132,  133,  134,  135,  136,  137,  137,  139,  140,
     1    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     2    151,  152,  153,  153,  155,  156,  157,  158,  159,  160,
     3    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     4    171,  172,  172,  174,  175,  176,  177,  178,  179,  180,
     5    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     6    191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
     7    201,  202,  203,  204,  205,  206,  207,  208,  209,  210,
     8    211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
     9    221,  221,  223,  224,  224,  226,  227,  228,  229,  230/
            data (jb2(i),i= 1401, 1500)/
     +    231,  232,  232,  234,  235,  236,  237,  238,  239,  240,
     1    241,  242,  243,  244,  245,  246,  247,  248,  249,  249,
     2    251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
     3    261,  262,  263,  263,  265,  266,  267,  268,  269,  270,
     4    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     5    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     6    291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
     7    301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
     8    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     9    321,  322,  323,  324,  325,  326,  327,  328,  329,  330/
            data (jb2(i),i= 1501, 1600)/
     +    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     1    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     2    351,  352,  353,  354,  355,  355,  357,  358,  359,  360,
     3    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     4    371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
     5    381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
     6    391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
     7    401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
     8    411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
     9    421,  422,  423,  424,  425,  426,  427,  428,  429,  430/
            data (jb2(i),i= 1601, 1700)/
     +    431,  432,  433,  434,  435,  435,  437,  438,  439,  440,
     1    441,  441,  443,  444,  445,  446,  447,  448,  449,  450,
     2    451,  451,  453,  454,  455,  456,  457,  458,  459,  460,
     3    461,  462,  463,  464,  465,  466,  467,  468,  469,  470,
     4    471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
     5    481,  482,  482,  484,  485,  486,  487,  488,  489,  490,
     6    490,  492,  493,  494,  495,  496,  497,  498,  499,  500,
     7    501,  502,  503,  504,  505,  506,  506,  508,  509,  510,
     8    511,  512,  513,  513,  515,  516,  517,  518,  519,  519,
     9    521,  522,  523,  524,  525,  526,  527,  528,  529,  530/
            data (jb2(i),i= 1701, 1800)/
     +    531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
     1    541,  542,  543,  544,  545,  546,  547,  547,  549,  550,
     2    551,  552,  553,  554,  555,  556,  556,  558,  559,  560,
     3    561,  562,  563,  564,  565,  566,  567,  568,  569,  570,
     4    571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
     5    581,  582,  583,  584,  585,  586,  587,  588,  589,  590,
     6    591,  592,  593,  594,  595,  596,  597,  598,  599,  600,
     7    601,  602,  603,  604,  605,  605,  607,  608,  609,  609,
     8    611,  612,  613,  614,  615,  616,  617,  618,  619,  620,
     9    621,  622,  623,  623,  625,  626,  627,  628,  629,  630/
            data (jb2(i),i= 1801, 1900)/
     +    631,  632,  633,  634,  635,  636,  637,  638,  639,  640,
     1    641,  641,  643,  644,  645,  646,  647,  647,  649,  650,
     2    651,  652,  653,  654,  654,  656,  657,  658,  659,  660,
     3    661,  662,  663,  664,  665,  666,  667,  668,  669,  670,
     4    671,  672,  673,  674,  675,  676,  677,  678,  679,  680,
     5    680,  682,  683,  684,  685,  686,  687,  688,  689,  690,
     6    691,  692,  693,  694,  695,  696,  697,  698,  699,  700,
     7    701,  702,  703,  704,  705,  705,  707,  708,  709,  710,
     8    711,  712,  713,  714,  715,  716,  717,  718,  719,  720,
     9    721,  722,  723,  724,  725,  726,  727,  728,  729,  729/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine az(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(530) :: jx,jy
            integer(kind=iknd), save, dimension(540) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'arizona       '/
            data jrot,ipart/1,1/
            data kv/   1, 525,   0,   0,   0/
            data kb/   1, 539,   0,   0,   0/
            data iib/ 173,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  16032,16080,16104,34392,43104,50088,54480,55104,15840,21384,
     1  21480,21864,21936,22056,22512,22608,22536,22368,22272,22152,
     2  21960,21696,21648,21792,21672,21768,21696,21648,21600,21600,
     3  21720,21648,21840,21888,22008,22200,22320,22392,22512,22680,
     4  22992,23088,23280,23496,23640,23784,23952,24264,24624,24792,
     5  25032,25320,25416,25488,25824,26064,27144,28296,28632,28680,
     6  28776,29040,29256,29928,30336,30576,30840,38208,16032,34032,
     7  33936,33336,33336,33288,32784,32472,32328,32208,31896,31824,
     8  31512,31152,34656,34680,35040,35160,35232,35256,35472,35712,
     9  35952,36240,36336,36432,36672,36744,36888,37056,37104,37296/
            data (jx(i),i=  101,  200)/
     +  37392,37608,37680,38064,38232,38448,38640,38736,38784,39072,
     1  39216,39456,39600,39744,39864,40368,40416,40368,40464,40632,
     2  40896,41184,41304,41352,41448,41568,41760,42144,42432,42648,
     3  42672,43056,42936,43080,43104,43032,47496,43200,43512,43464,
     4  43512,43776,43968,44376,44688,44976,44976,45024,45000,45120,
     5  45120,45144,45024,45048,45648,45840,45888,46056,46272,46248,
     6  46296,46368,46536,46632,46656,46728,47952,47880,47952,47976,
     7  48024,55008,55128,26088,24264,24072,23808,23592,23400,23088,
     8  22944,22800,22608,22488,22176,22248,22200,22080,21864,21744,
     9  21696,21720,21600,21456,21264,21288,21240,21120,21144,20952/
            data (jx(i),i=  201,  300)/
     +  20976,20928,20952,20712,20712,20568,20520,20472,20544,20280,
     1  20232,20088,19848,19656,19632,19536,19560,19464,19224,19104,
     2  19080,18840,18120,17592,17496,16968,16800,16704,16320,29496,
     3  29928,34968,26088,26256,26280,26472,27072,27360,27552,27696,
     4  27648,27792,27744,27816,27912,28152,28176,28176,28032,28800,
     5  28800,30024,30000,31224,31248,33552,34416,39624,38256,38256,
     6  35856,35856,34056,33456,32880,32280,31056,31056,25296,25296,
     7  36768,36504,36456,36360,36312,36096,35976,35856,35856,35712,
     8  35712,35640,35496,35496,35448,35472,35400,35424,35352,35280,
     9  35208,35040,34896,34800,34752,34704,34776,34704,34584,34104/
            data (jx(i),i=  301,  400)/
     +  33960,33888,33840,33720,34992,34800,34704,34656,34728,34632,
     1  34728,34632,34728,34656,34776,34824,34848,34920,34872,34680,
     2  34584,34272,34272,34200,34272,34416,34416,34344,34200,34152,
     3  34152,34056,34128,34080,34176,33984,33888,33648,33864,33840,
     4  33744,33744,33840,33816,33936,33936,34080,34176,34056,33768,
     5  33816,33720,33696,33912,33912,33744,33768,33888,33816,33912,
     6  33912,33864,33816,33840,33768,33816,33696,33744,33624,33648,
     7  33576,33624,33528,33384,33336,33312,33480,34512,34728,34656,
     8  34752,34800,35016,34920,34968,34896,35088,35112,34992,34968,
     9  34464,34608,34512,34416,36600,36672,37536,37464,37368,37296/
            data (jx(i),i=  401,  500)/
     +  37296,37032,36912,36624,36600,36480,36432,36408,36744,36720,
     1  36864,36984,37296,37344,37272,37320,37560,37728,37896,37968,
     2  38112,38184,38304,38472,38544,38688,38904,39096,39360,39360,
     3  39480,39264,38976,40440,40872,39024,43080,44640,44640,45264,
     4  45720,46056,46776,46872,47184,47208,47496,36768,36744,39648,
     5  39672,39576,40776,40200,40128,43128,39264,39264,39336,39528,
     6  39504,39600,39720,39960,40272,40224,40080,39912,39864,39792,
     7  40440,42216,42192,42048,41952,41856,41808,41496,46992,46896,
     8  42312,42360,42552,42504,42576,42600,42696,42672,43008,43080,
     9  43152,43320,43464,43584,43776,41904,41088,40416,40416,40536/
            data (jx(i),i=  501,  530)/
     +  40608,40704,40824,40824,40944,41232,41856,42240,42312,46968,
     1  47064,46992,47568,52368,53808,53808,52416,38208,38448,38520,
     2  38664,38640,38760,38976,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  36432,46464,50472,27048,24576,31272,42816,48168,28104,27936,
     1  27840,27624,27504,27552,27360,26928,26736,26664,26424,26496,
     2  26376,26160,25992,25752,25608,25392,25368,25416,25368,25008,
     3  24792,24696,24408,24072,23976,24072,24048,24144,24024,24000,
     4  24072,24168,24216,24432,24192,24240,24144,24216,24144,24264,
     5  24240,24408,24384,24288,24360,24240,24648,24768,24720,24432,
     6  24312,24576,24384,24384,24336,24576,24672,56184,55752,26808,
     7  26568,25944,25728,25680,25704,25560,25416,25488,25320,25344,
     8  25224,24840,27072,26904,26520,26496,26352,26160,25944,25392,
     9  25272,25272,25104,25152,24912,24744,24696,24840,24744,24864/
            data (jy(i),i=  101,  200)/
     +  24696,24744,24720,24840,24792,24888,24648,24744,24648,24672,
     1  24576,24648,24480,24408,24216,23976,23880,23688,23472,23568,
     2  23592,23400,23472,23664,23736,23640,23712,23688,23544,23496,
     3  23592,23736,23832,24024,24168,24288,56328,24648,24720,24816,
     4  24840,24768,24864,24816,24456,24456,24384,24384,24240,24144,
     5  23928,23928,23448,23400,23088,22944,22776,22824,22728,22848,
     6  22872,22800,22728,22800,22704,22728,56352,56232,56280,56256,
     7  56352,56472,44520,31824,31872,31896,32016,32016,31920,31992,
     8  31872,31896,31800,31848,32064,32376,32568,32736,32712,32856,
     9  32928,33096,33216,33480,33672,33912,34128,34248,34416,34584/
            data (jy(i),i=  201,  300)/
     +  34704,34776,34920,35184,35376,35376,35448,35568,35640,35808,
     1  35904,35928,35808,35952,35808,35832,35736,35784,35664,35712,
     2  35784,35976,35880,36024,36000,36216,36264,36360,36504,46416,
     3  46368,46368,32208,32472,32736,32856,33816,34008,34776,35088,
     4  35400,35592,35760,35832,35808,36048,36168,36648,36840,36816,
     5  37416,37416,40560,40560,41832,41832,31632,51360,51336,51528,
     6  51480,51552,51552,51528,51432,51504,51480,51528,51528,50568,
     7  42120,42120,42240,42240,42312,42168,42264,42216,42120,42216,
     8  40872,40824,40920,40992,40968,40896,40896,40968,41016,40920,
     9  40920,40968,41088,41040,41160,41160,41088,41040,41160,41184/
            data (jy(i),i=  301,  400)/
     +  41448,41520,41688,41808,46296,46344,46200,46200,46176,46152,
     1  46080,46056,46032,45840,45984,45888,45936,45888,45648,45528,
     2  45168,44904,44832,44832,44760,44784,44688,44616,44736,44712,
     3  44520,44448,44328,44232,44112,44016,43680,43512,43104,42936,
     4  42960,42816,42720,42696,42672,42600,42768,42624,42528,42528,
     5  42624,42672,42480,42288,42216,42288,42120,42144,42096,42000,
     6  41880,41808,41880,41928,41928,41976,42000,42072,42168,42240,
     7  42264,41880,42024,42024,42096,42000,41976,27432,27624,27672,
     8  27768,28632,28752,28872,29088,29328,29496,29640,29856,30096,
     9  30504,31416,31536,31584,31584,34968,37632,37632,37824,37824/
            data (jy(i),i=  401,  500)/
     +  37872,37848,38088,38184,38304,38280,38352,38280,40800,42360,
     1  42456,42360,42360,42456,42504,42624,42576,42744,42696,42816,
     2  42720,42792,42720,42744,42888,43008,43032,43296,43440,43536,
     3  43680,43752,44064,44760,31488,53616,53688,54624,54720,55128,
     4  55344,55392,55296,55440,55656,55752,55920,46392,50688,50712,
     5  51120,50904,27888,27912,26112,26016,53424,53160,52992,52896,
     6  52752,52584,52656,52272,52128,51840,51840,51768,51624,51624,
     7  41616,41592,38736,38640,38400,38352,38160,38016,37944,31344,
     8  48168,47760,47616,47520,47496,47328,47280,47016,46680,46728,
     9  46536,46560,46512,46368,46248,45288,45024,50712,49728,49632/
            data (jy(i),i=  501,  530)/
     +  48888,48744,48696,48336,48192,48120,48120,48312,48288,48168,
     1  44040,44040,48168,48192,42792,44016,44016,54408,54360,54408,
     2  54168,53928,53736,53712,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    9,   10,   11,   12,   13,   14,   15,   16,   17,
     1     18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
     2     28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
     3     38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
     4     48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
     5     58,   59,   60,   61,   62,   63,   64,   65,   66,    1,
     6      2,   68,    3,    4,   70,   71,   72,   73,   74,   75,
     7     76,   77,   78,   79,   80,   81,   67,    4,   83,   84,
     8     85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
     9     95,   96,   97,   98,   99,  100,  101,  102,  103,  104/
            data (jb1(i),i=  101,  200)/
     +    105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
     1    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     2    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     3    135,    5,   68,    5,  138,  139,  140,  141,  142,  143,
     4    144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
     5    154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
     6    164,  165,    6,  137,  167,  168,  169,  170,  171,    8,
     7      6,    7,    8,  174,  175,  176,  177,  178,  179,  180,
     8    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     9    191,  192,  193,  194,  195,  196,  197,  198,  199,  200/
            data (jb1(i),i=  201,  300)/
     +    201,  202,  203,  204,  205,  206,  207,  208,  209,  210,
     1    211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
     2    221,  222,  223,  224,  225,  226,  227,  228,  229,    2,
     3    230,  231,  174,  233,  234,  235,  236,  237,  238,  239,
     4    240,  241,  242,  243,  244,  245,  246,  247,  248,  249,
     5    250,  251,  252,  253,  254,  255,  174,  258,  259,  260,
     6    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     7    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     8    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     9    291,  292,  293,  294,  295,  296,  297,  298,  299,  300/
            data (jb1(i),i=  301,  400)/
     +    301,  302,  303,  256,  232,  305,  306,  307,  308,  309,
     1    310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
     2    320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
     3    330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
     4    340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
     5    350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
     6    360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
     7    370,  371,  372,  373,  374,  375,  376,  256,    4,  378,
     8    379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
     9    389,  390,  391,  392,  393,  257,  257,  395,  396,  397/
            data (jb1(i),i=  401,  500)/
     +    398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
     1    408,  271,  271,  410,  411,  412,  413,  414,  415,  416,
     2    417,  418,  419,  420,  421,  422,  423,  424,  425,  426,
     3    427,  428,  429,  430,  431,  432,  433,  395,  436,  437,
     4    438,  439,  440,  441,  442,  443,  444,  445,  446,  232,
     5    448,  449,  258,  451,  450,  435,  453,  454,  455,  456,
     6    436,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     7    466,  467,  468,  469,  258,  434,  471,  472,  473,  474,
     8    475,  476,  477,  478,  435,  481,  482,  483,  484,  485,
     9    486,  487,  488,  489,  490,  491,  492,  493,  494,  495/
            data (jb1(i),i=  501,  540)/
     +    496,  434,  450,  498,  499,  500,  501,  502,  503,  504,
     1    505,  506,  507,  508,  481,  481,  479,  479,  511,  510,
     2    480,  447,  510,  513,    7,  515,  516,  514,  514,   68,
     3    518,  519,  520,  521,  522,  523,  436,  447,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
     1     19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
     2     29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
     3     39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     4     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     5     59,   60,   61,   62,   63,   64,   65,   66,   67,    2,
     6      3,   69,   69,   70,   71,   72,   73,   74,   75,   76,
     7     77,   78,   79,   80,   81,   82,   82,   83,   84,   85,
     8     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     9     96,   97,   98,   99,  100,  101,  102,  103,  104,  105/
            data (jb2(i),i=  101,  200)/
     +    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     1    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     2    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     3    136,  136,  137,  138,  139,  140,  141,  142,  143,  144,
     4    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     5    155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
     6    165,  166,  166,  167,  168,  169,  170,  171,  172,  172,
     7      7,  173,  173,  175,  176,  177,  178,  179,  180,  181,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb2(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,    1,  230,
     3    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     4    241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
     5    251,  252,  253,  254,  255,  256,  257,  259,  260,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,    3,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     9    292,  293,  294,  295,  296,  297,  298,  299,  300,  301/
            data (jb2(i),i=  301,  400)/
     +    302,  303,  304,  304,  305,  306,  307,  308,  309,  310,
     1    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     2    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     3    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     7    371,  372,  373,  374,  375,  376,  377,  377,  378,  379,
     8    380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     9    390,  391,  392,  393,  394,  394,  395,  396,  397,  398/
            data (jb2(i),i=  401,  500)/
     +    399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
     1    409,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     2    418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
     3    428,  429,  430,  431,  432,  433,  434,  435,  437,  438,
     4    439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
     5    449,  450,  451,  452,  452,  453,  454,  455,  456,    5,
     6    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     7    467,  468,  469,  470,  470,  471,  472,  473,  474,  475,
     8    476,  477,  478,  479,  480,  482,  483,  484,  485,  486,
     9    487,  488,  489,  490,  491,  492,  493,  494,  495,  496/
            data (jb2(i),i=  501,  540)/
     +    497,  497,  498,  499,  500,  501,  502,  503,  504,  505,
     1    506,  507,  508,  509,  509,  510,  480,  511,  512,  512,
     2      6,  513,  513,  514,  515,  516,  517,  517,    8,  518,
     3    519,  520,  521,  522,  523,  524,  524,  137,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ar(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1980) :: jx,jy
            integer(kind=iknd), save, dimension(2050) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'arkansas      '/
            data jrot,ipart/0,1/
            data kv/   1,1974,   0,   0,   0/
            data kb/   1,2048,   0,   0,   0/
            data iib/ 414,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  23376,19008,13392,26568,30240,43728,37536,37176, 6648,49608,
     1  47856, 7128,48744,50376, 7656, 7416,47928, 7320,46200, 7056,
     2  42672, 6960,11304,39888,31512,13584,16920,22056,37704,49896,
     3  49848,49968,50088,50016,50088,50088,50328,50616,50784,50808,
     4  50712,50712,50664,50808,50808,50688,50328,50208,50256, 6048,
     5  50520,50664,50856,51072,51072,51144,51096,51168,51744,51768,
     6  51696,51432,51312,51360,51480,51864,52104,52224,52536,52656,
     7  52320,52200,52200,52320,53088,53184,53136,53040,52776,52656,
     8  52368,52152,52128,52536,52752,53208,53544,53664,53736,53856,
     9  54000,54312,54576,54624,54528,53952,53904,54024,54336,55008/
            data (jx(i),i=  101,  200)/
     +  55104,55128,54984,54360,54384,49272,49176,48816,48648,48552,
     1  48432,48384,48264,48240,50112,50016,50088,50424,50352,50400,
     2  50496,50688,51024,50760,50808,50784,50232,50208,50400,50664,
     3  50856,51216,51240,51024,50880,50472,50208,50136,50064,50136,
     4  50040,49944,49608,49224,48960,48840,48864,48984,49488,49560,
     5  49536,49416,48960,48936,48864,48528,48120,47832,47808,47568,
     6  47352,47160,47136,47400,47304,47280,47568,47568,47472,47232,
     7  47064,46824,46800,46992,46992,46872,46704,46584,46536,46608,
     8  46488,46344,46416,46632,47376,47400,47328,46896,46680,46536,
     9  46464,46632,46560,46416,46272,46416,46728,46800,46728,46344/
            data (jx(i),i=  201,  300)/
     +  46176,46176,46344,46296,45840,45528,45456,45528,45432,45288,
     1  45192,45336,45312,44928,44640,44472,44424,44640,44688,44568,
     2  44424,44160,43920,43824,43752,43632,43344,42984,42816,42768,
     3  42816,43104,43320,43800,44040,44088,43944,43680,43488,43152,
     4  42792,42624,42528,42552,43056,43416,43464,43248,42912,42696,
     5  42504,42408,42576,42552,42432,42312,42192,42048,41784,41448,
     6  41328,41256,41280,41376,41952,41952,41640,41568,41952,42312,
     7  42336,42216,42000,41784,41592,41472,41184,41040,40920,40776,
     8  40848,40824,40920,41064,41256,41424,41568,41640,41904,41928,
     9  41496,41328,40968,40536,40152,40008,40032,40704,40776,40800/
            data (jx(i),i=  301,  400)/
     +  40680,40512,40392,39984,39912, 6816, 6984, 7128, 7200, 7056,
     1   7128, 6960, 6984, 7176, 7320, 7584, 7824, 7896, 7872, 7632,
     2   7896, 8136, 8160, 8232, 8304, 8448, 8568, 8664, 8784, 8880,
     3   8760, 8904, 9120, 9288, 9336, 9336, 9168, 9360, 9480, 9648,
     4   9792, 9768, 9600, 9552, 9720, 9960,10128,10152,10296,10224,
     5  10392,10440,10512,10560,10872,11040,11160,11136,10992,10992,
     6  11232,39936,40104,40392,40440,40320,39864,39888,40128,40464,
     7  40560,40536,40656,41040,41136,41040,40896,40272,40200,40272,
     8  40608,40920,41256,41376,41616,41736,41712,41352,41160,40920,
     9  40872,40896,41088,41352,41472,41568,41736,41880,41880,41808/
            data (jx(i),i=  401,  500)/
     +  41424,41496,41376,41112,40752,40536,40392,40320,40368,41088,
     1  41160,41016,40824,40752,23352,23304,23040,23016,18960,13368,
     2  26520,26376,26304,25920,26064,26520,26568,26544,26256,26160,
     3  26112,26376,26592,26616,26424,26472,26688,26904,27144,27096,
     4  27216,27024,27144,27360,27456,27600,27600,27768,27768,27576,
     5  27600,27768,27744,30216,43848,43776,43872,43776,43944,43968,
     6  43896,43896,44064,44088,43824,43752,43680,43560,43560,37536,
     7  37632,37632,37800,37800,37968,37968,38064,38040,38088,38112,
     8  38160,38160,38496,38520,38688,38688,38880,38880,39048,39024,
     9  34824,37176,36096,36072, 8232, 8232, 8736, 8784,11952,11952/
            data (jx(i),i=  501,  600)/
     +  13176,13368,48360,48336,43176,43176,43248,43224,43296,43176,
     1  43152,43296,43272,43416,43440,43944,43920,44160,43560,39216,
     2  39216,39288,39288,39384,39456,40080,40344,40872,40824,40896,
     3  41016,41064,41160,30216,29712,29688,29880,17208,16488,16488,
     4  16152,16152,15888,15912,15816,15840,15624,15600,15696,15624,
     5  15384,15360,15432,15456,15408,22488,23544,23544,27744,22416,
     6  22536,22488,47784,47784,29856,28800,28800,34824,34992,34968,
     7  34872,34872,34968,34968,34656,34656,29928,30144,30312,30408,
     8  30696,30960,31200,31176,30912,30840,30984,30744,30696,30744,
     9  30888,31080,31464,31584,31704,31992,32112,32808,33168,33312/
            data (jx(i),i=  601,  700)/
     +  16776,16800,16728,16776,16968,16992,17136,17136,17304,17304,
     1  17472,17520,17184,39024,38328,38328,38160,38160,39768,37128,
     2  37128,41400,42840,42984,43080,43008,43032,34272,12600,12504,
     3  12408,12384,27720,15024,10776,10776,12888,12888,16752,20304,
     4  48864,46728,44976,41424,48816,23808,25608,25584,18936,19008,
     5  19704,19728,20256,29472,27696,33480,33480,33192,33120,33264,
     6  14880,11280,11592,11424,11592,11688,11592,11616,11736,11760,
     7  11232,11280,12168,12192,12336,12360,12888,12888,13080,13104,
     8  29376,23784,23424,23424,33768,33960,33936,36048,39768,39600,
     9  39672,39600,39600,39504,39432,39288,39432,39432,39144,39192/
            data (jx(i),i=  701,  800)/
     +  39312,39312,39072,38976,38928,38976,38856,38712,38688,38472,
     1  38472,38400,38352,38256,38256,38328,38328,38400,38448,38592,
     2  38592,38568,38184,38136,38136,48960,46824,27120,27096,45720,
     3  45720,44688,44688,41472,38376,36024,11640,11496,11496,11328,
     4  11328,11160,22704,23304,23376,14640,14424,14016,13896,13848,
     5  12792,12744,11664, 7848, 8160, 8472, 8568, 8520, 8544, 8760,
     6   9096, 9480, 9936,10080,10344,10584,10608,10368,10488,10656,
     7  11112,38376,39336,39360,41472,30792,33912,33744,33672,33600,
     8  33528,33384,33360,18648,18312,18048,17952,18048,17880,17640,
     9  17376,17256,17136,16968,16608,16296,16104,15720,15384,15216/
            data (jx(i),i=  801,  900)/
     +  15072,19152,14880,14880,15312,15312,16632,16656,16824,16824,
     1  16992,16992,17088,17112,17184,17184,17376,17376,19128,19392,
     2  19488,20088,20448,20568,20688,20856,21048,21096,21144,21000,
     3  21000,21216,21432,21576,21648,21624,21672,22584,10512,10536,
     4  11616,46896,44688,41496,27096,27024,26784,26880,26808,26760,
     5  26616,26688,26640,26904,26880,26808,26856,26712,26592,26472,
     6  26328,38304,38424,38376,38304,38256,38232,38184,38160,37872,
     7  38016,37896,37776,37632,37752,37752,37536,37488,37608,37440,
     8  37632,37536,37584,37512,37536,37656,37752,37776,37896,37992,
     9  38088,38136,38208,38016,38016,38088,37944,38088,38016,38088/
            data (jx(i),i=  901, 1000)/
     +  38088,37968,37920,37824,37752,37608,37584,37656,37560,37344,
     1  37296,37320,37560,37608,37560,37440,37392,37512,37488,37632,
     2  37704,37656,37416,37392,37320,37272,21504,21672,21528,21528,
     3  22128,22200,22368,26040,25872,25584,25488,25488,25704,25656,
     4  25440,25200,24792,30744,33936,33768,33216,33000,32856,32688,
     5  32280,32160,31896,31776,31416,31296,31128,30984,11184,11208,
     6  10488,10368,10368,10176,10128,10008, 9984, 9720, 9720, 9456,
     7   9456, 9648, 9624, 9024, 8736, 8592, 8232, 7992, 7800, 7560,
     8  36072,36072,35928,35832,35544,35448,35280,35160,34944,34848,
     9  34104,38280,39024,39024,39576,39576,40440,30720,41520,14808/
            data (jx(i),i= 1001, 1100)/
     +  19032,19032,18864,18864,19032,19032,19200,19224,19392,19392,
     1  19584,19584,19752,19752,19920,19944,20112,20112,20304,20328,
     2  20520,20520,20688,20712,20880,20880,21072,21072,21240,21240,
     3  21408,21432,26472,26520,26424,26160,26016,25944,26160,26496,
     4  47904,47904,29688,29640,27768,27792,27744,27504,27528,27480,
     5  27384,27312,27384,27144,38304,37536,37536,37296,37152,37152,
     6  37368,37440,38256,38256,37896,37896,37536,37536,38256,38280,
     7  38208,38256,38376,38424,38328,38448,38520,38520,38448,38376,
     8  38256,38088,38160,38256,43632,40992,40968,40800,40800,40464,
     9  26496,25440,25440,24384,24384,24552,21168,21168,23616,24120/
            data (jx(i),i= 1101, 1200)/
     +  24360,24528,24000,24024,23856,23856,23184,23184,22128,22128,
     1  22224,22248,17976,17976, 8712, 8712,11520,11520,12576,12576,
     2  14448,14448,14088,14088,13728,13728,13224,13224,13128,13128,
     3  41520,17976,17904,17880,17832,40968,41520,12504,25416,25392,
     4  26448,26424,26952,26952,27528,27504,28512,28488,29520,29520,
     5  29904,31224,31200,31056,30984,30840,31680,31680,34968,33912,
     6  35040,34992,35232,35568,35568,35376,35448,35592,35712,35664,
     7  35328,35208,35256,36072,36072,41544,41304,41160,41016,41040,
     8  40800,40704,40560,40416,40536,40464,40368,40320,40272,40152,
     9  40032,39912,39888,39960,40008,39864,39960,39888,39768,39648/
            data (jx(i),i= 1201, 1300)/
     +  39528,39552,39408,39432,39072,39144,24576,24552,25080,25104,
     1  25272,25800,25728,25944,25992,26064,27936,27936,22800,22800,
     2  22464,22440,41520,42072,42072,42072,17832, 9360, 9360, 9216,
     3   9264,17112,12456,12576,12576,13632,13608,41568,41448,41568,
     4  41544,41472,41520,41472,41400,41352,41376,41496,41448,41328,
     5  41472,41520,41424,41256,41208,41304,41256,41328,41160,41160,
     6  41016,40944,23088,21672,21576,21504,21504,21672,21672,21576,
     7  21624,21528,21576,21120,21120,21024,20976,19920,19920,18336,
     8  18336,10872,10920,10800,10872,10872,10824,10968,10896,10992,
     9  10872,10968,11064,10920,10992,10944,10992,11088,11088,11184/
            data (jx(i),i= 1301, 1400)/
     +  11088,11064,11136,11256,11256,11592,11544,11592,11688,11784,
     1  12048,12168,12144,12192,12216,25200,34944,36096,36168,36168,
     2  36288,36360,36696,36792,36864,36960,36912,36960,37152,37224,
     3  37368,37560,37656,37728,37656,32520,32520,34632,34632,34824,
     4  34800,35304,35688,36120,36192,36192,36024,36264,36624,36912,
     5  37080,37272,37296,37224,37320,37464,37512,29712,29904,29688,
     6  28656,27024,27072,27192,27288,27432,27408,27696,27864,27960,
     7  27960,28104,28176,28296,28440,28560,40944,40848,40704,40608,
     8  40464,40320,40320,40248,40272,40200,40200,40320,40320,40488,
     9  40608,40608,40920,40872,40800,40776,40656,40824,40800,40464/
            data (jx(i),i= 1401, 1500)/
     +  40512,40392,40080,39840,39840,39912,39864,39504,39480,39312,
     1  39240,39024,38616,38544,38544,38688,38928,39024,39024,38952,
     2  38832,38736,38304,38160,38136,37944,37752,37752,37992,17088,
     3  16872,16848,17040,17280,17328,17472,17280,17352,17328,17448,
     4  17304,17328,17424,17376,17448,17472,17520,17544,17784,17832,
     5  17880,17880,18048,18096,18216,18048,17952,17736,17304,14544,
     6  14616,14856,15024,15384,15672,15936,16392,16560,16584,16872,
     7  16944,17088,17112,23016,22440,22344,22440,22536,22584,22656,
     8  22608,22680,22776,22752,22872,22848,23016,22824,22920,22920,
     9  22896,22944,23088,23184,23136,23016,23064,22944,22992,26160/
            data (jx(i),i= 1501, 1600)/
     +  28704,28608,28632,28416,28128,28104,27984,27600,27456,27240,
     1  27288,32328,32256,32544,37944,37464,37464,36624,36600,35496,
     2  18240,18312,18384,18456,18528,18672,18648,18912,18840,18912,
     3  18984,19152,19224,19320,19680,19728,19992,20112,20184,20232,
     4  20472,20544,20640,20856,21048,21240,21552,21888,21984,22128,
     5  22536,22560,22656,22680,22776,11328,11352,10920,10536,10536,
     6  10416,10344,10128,10056,10008, 9864, 9816, 9888, 9864, 9576,
     7   9528, 9408, 9360, 9216, 9216, 9048, 8880, 8760, 8688, 8736,
     8   8664, 8688, 8472, 8496, 8376, 8328, 8352, 7992, 8112, 7824,
     9   7872, 7776, 7728, 7896, 7872, 7632, 7512, 7584, 7536, 7416/
            data (jx(i),i= 1601, 1700)/
     +   7224, 7080,13464,28728,28680,28656,28704,28704,28752,32352,
     1  12264,12192,12144,12072,12168,12192,12240,12264,12216,12264,
     2  12120,12168,12096,12120,12312,12384,12480,12456,12648,12624,
     3  12768,12624,12720,12864,12936,13032,13128,13200,13272,13368,
     4  13440,13536,37656,37680,11640,11712,11784,11760,11928,12024,
     5  12024,11928,11976,12144,12192,12264,12456,12528,12720,12744,
     6  12624,12672,12768,12840,13152,13416,13536,38736,38736,38904,
     7  38904,39000,39000,39792,39816,14592,14256,14352,14352,14136,
     8  14232,14184,14064,13992,14112,13968,13872,13824,13968,13896,
     9  13824,13728,13776,13512,13656,13608,17256,17160,17136,17016/
            data (jx(i),i= 1701, 1800)/
     +  20736,18216,16992,19680,19656,32352,32040,32160,32064,32112,
     1  31992,32040,32208,32112,32256,37680,22152,20712,26160,25800,
     2  25656,25464,25176,25008,24816,24672,24624,24888,24816,24672,
     3  24576,24504,24312,24216,24240,24384,24336,24360,24264,24432,
     4  24336,24336,24456,24576,24648,24816,24720,24816,24888,24936,
     5  24936,25464,25464,25560,25560,25656,25608,25512,25536,25632,
     6  25824,25920,26136,26184,26232,26328,26352,26184,26064,25992,
     7  25800,25560,25344,25176,25104,24936,24720,24384,24000,28728,
     8  28824,28752,28848,28800,28968,28824,28896,28872,28752,28776,
     9  28680,28656,28488,28464,28368,28296,28296,28248,28272,28416/
            data (jx(i),i= 1801, 1900)/
     +  28488,28536,26400,26544,26592,26688,26736,26832,26760,26784,
     1  27000,27072,27120,27240,27336,27456,27432,27336,27456,27456,
     2  27312,27432,27528,27624,27720,27744,28248,30744,30816,30792,
     3  30840,30744,30864,31008,30984,31176,31272,31248,31440,31416,
     4  31536,31608,31680,31680,31776,31752,31848,31872,32136,32064,
     5  32088,32208,32232,32376,32424,32256,32448,32472,32568,32280,
     6  28488,28704,28800,28824,28968,28968,29136,29160,29328,29400,
     7  29400,29640,29712,29856,29856,29760,29976,29880,29880,30024,
     8  30168,30336,30384,30312,30456,30480,30408,30504,30528,30648,
     9  30648,31008,31080,30960,31008,30936,30864,30720,30792,30840/
            data (jx(i),i= 1901, 1980)/
     +  31008,31080,31272,31344,31392,13632,13464,13560,13536,13368,
     1  13320,13368,13080,13176,13272,13416,13608,13656,13800,13872,
     2  13896,13992,13992,14064,14352,14424,14448,14208,14184,14472,
     3  14496,14376,14448,14760,14784,14520,14496,14760,14520,14472,
     4  14616,14760,14880,14880,15096,15144,15072,14712,14712,14808,
     5  15048,15048,14952,14856,14736,14592,14568,14808,14496,14664,
     6  14664,14568,14448,14352,14376,14544,14424,17016,17520,17544,
     7  17616,17568,17712,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  61920,61944,61992,61944,61968,62184,62064,62064,57264,58752,
     1  56184,53064,56232,49440,48696,43056,42000,40536,39648,33984,
     2  33192,30936,26160,26376,19560,19680,19656,19608,19584,62328,
     3  62136,62040,61656,61440,61440,61344,61224,61200,61032,60792,
     4  60576,60360,60264,60096,59976,59688,59496,59232,59136,62088,
     5  49584,49920,49992,49848,49392,49200,49152,49008,49416,49704,
     6  49848,50088,50328,50832,50904,50976,50808,50544,50496,50856,
     7  51024,51216,51384,51528,51912,52104,52296,52368,52176,52152,
     8  52296,52560,53040,53400,53352,53400,53544,53640,53952,54072,
     9  54120,54048,54216,54384,54576,54744,54984,55200,55296,55032/
            data (jy(i),i=  101,  200)/
     +  55080,55272,55560,56040,56448,58392,57960,57672,57624,57456,
     1  57360,57144,57024,56832,49224,48816,48720,48720,48984,49152,
     2  49200,49128,48816,48360,48048,47928,47760,47520,47256,47280,
     3  47184,46128,45888,45600,45600,45792,45648,45552,45264,44904,
     4  44712,44592,44520,44568,44520,44184,43992,43824,43488,43224,
     5  43008,42792,42552,42312,42216,42360,42168,41976,42024,42672,
     6  42744,42648,42408,41904,41760,41544,41064,40968,40824,40728,
     7  40728,40824,40920,41160,41304,41592,41640,41544,41400,40992,
     8  40992,40704,40536,40416,40344,40176,40032,39600,39528,39600,
     9  39720,40152,40272,40344,39240,38952,38760,38616,38472,38184/
            data (jy(i),i=  201,  300)/
     +  37896,37704,37176,36888,36576,36480,36144,35784,35664,35712,
     1  35832,36288,36360,36240,36336,36312,36120,35928,35712,35280,
     2  35184,35352,35280,35088,34488,34368,34392,34752,34728,34560,
     3  34440,34128,34056,34104,34008,33864,33600,33480,33552,33816,
     4  33792,33696,33528,33336,32928,32952,32832,32232,32160,32016,
     5  31968,31872,31536,31344,31272,31296,31344,31656,31608,31824,
     6  31824,31704,31584,31464,31032,30744,30360,30024,29448,29256,
     7  29064,28920,28872,28944,29160,29184,28920,29064,29112,28920,
     8  28608,28392,28248,28176,28176,28224,28368,28344,28056,27816,
     9  27600,27576,27768,28200,28200,28008,27816,27240,27024,26808/
            data (jy(i),i=  301,  400)/
     +  26592,26520,26520,26688,26568,27312,27288,27360,27288,27192,
     1  27048,26904,26808,26712,26712,26400,26592,26592,26448,26304,
     2  26112,26136,26304,26400,26376,26184,26208,26448,26568,26520,
     3  26304,26256,26568,26664,26616,26520,26304,26184,26208,26352,
     4  26232,26424,26448,26544,26544,26640,26592,26472,26520,26352,
     5  26376,26184,26208,26352,26472,26424,26328,26256,26256,26184,
     6  19704,26232,26040,25848,25704,25416,25056,24912,24840,24936,
     7  25152,25560,25704,25488,25200,24936,24792,24600,24504,24384,
     8  24192,24216,24432,25128,25128,24936,24744,24360,24048,23832,
     9  23640,23280,22824,22536,22920,23040,23088,23016,22752,22584/
            data (jy(i),i=  401,  500)/
     +  22200,21288,21144,21096,21264,21288,21216,21048,20856,20352,
     1  20112,19920,19872,19632,61512,61608,61776,57264,57360,59664,
     2  60624,60600,60480,60216,60048,60168,60120,59928,59976,59808,
     3  59616,59712,59568,59376,59160,59064,59136,58992,58992,58656,
     4  58536,58272,58080,57960,57888,58008,57888,57840,57720,57720,
     5  57552,57528,56664,59112,62040,61464,61392,61320,61320,61272,
     6  61248,61152,61152,59568,59592,59688,59616,59616,59352,61944,
     7  61944,61872,61848,61776,61776,61680,61680,61536,61536,61368,
     8  61368,61200,61200,60816,60792,60624,60624,60120,60120,59184,
     9  59040,60072,60096,59040,57192,57720,57696,58584,58464,58824/
            data (jy(i),i=  501,  600)/
     +  58776,58776,58704,59400,55728,55776,55800,55872,55896,55992,
     1  56136,56400,56592,56784,57048,57480,57648,57936,57936,59184,
     2  58752,58824,59016,58968,58824,58536,58056,57912,57696,57624,
     3  57672,57840,57936,58032,58056,57552,57480,57408,57432,57792,
     4  57792,58152,58176,58344,58344,59088,59136,59160,59280,59328,
     5  59256,59352,59376,59520,59616,57288,57264,56736,55584,52536,
     6  56760,56760,55800,56112,56640,56640,55584,58488,58488,56184,
     7  56160,56112,56112,55992,55968,55248,57192,57168,57312,57288,
     8  56688,56616,56376,56256,56184,56064,55560,55320,55152,55056,
     9  55008,55008,55224,54960,54888,55152,55152,54528,54504,54336/
            data (jy(i),i=  601,  700)/
     +  53016,53736,53760,54456,54456,54984,54984,55344,55320,55512,
     1  55512,56856,56880,58992,58992,58848,58848,54696,54720,54672,
     2  55224,54672,54672,55008,55008,55200,55392,55272,57048,53904,
     3  53904,53016,53352,53088,53088,52920,53016,53184,52656,52584,
     4  52608,52632,52560,52536,54720,52512,53352,52464,47712,49440,
     5  49416,51000,51000,52416,52440,52368,52896,53160,53640,54000,
     6  48336,49200,49416,49560,49656,49944,50208,50376,50544,50760,
     7  50784,51840,51816,52344,52320,52680,52656,52824,52824,52992,
     8  48168,50400,50400,49368,52368,52488,50280,50280,54648,54624,
     9  54384,54312,54216,54168,54024,54024,53928,53808,53688,53640/
            data (jy(i),i=  701,  800)/
     +  53640,53592,53448,53472,53376,53304,53184,53160,53064,52872,
     1  52608,52560,52608,52464,52368,52272,51936,51936,51768,51720,
     2  51672,51624,51672,51648,50256,49416,49392,49272,48216,49392,
     3  49464,49464,49392,49296,49200,49200,46368,46392,46200,46200,
     4  46392,46392,45792,45816,45768,48168,48192,48648,48936,47568,
     5  47640,46560,46584,49248,49224,48984,48816,48552,48432,48216,
     6  48048,48072,48216,48504,48384,48456,48696,49080,49224,49272,
     7  49152,49272,49296,48216,48216,48168,49344,49320,49272,49320,
     8  49152,49104,48144,47880,47760,47760,47856,48120,48216,48768,
     9  48864,48840,48672,48552,48696,48624,48432,48360,48528,48552/
            data (jy(i),i=  801,  900)/
     +  48504,47592,43992,45384,45384,45600,45576,45720,45696,45864,
     1  45840,45936,45936,46176,46176,46272,46272,46368,46296,47376,
     2  47112,46968,46416,46008,45864,45816,45936,45888,45696,45456,
     3  45384,45192,45144,45240,45408,45576,45696,45816,45000,45528,
     4  45480,45768,45792,45720,47160,46992,46848,46656,46680,46560,
     5  46464,46344,46056,45864,45528,45480,45360,45120,45120,45240,
     6  45072,49104,49008,48840,48816,48888,49080,49104,48792,48624,
     7  48408,48432,48552,48408,48336,48240,48360,48312,48168,48048,
     8  47880,47712,47640,47544,47424,47424,47544,47088,47088,46920,
     9  46968,47088,47016,46776,46680,46536,46512,46464,46296,46248/
            data (jy(i),i=  901, 1000)/
     +  46176,46176,46416,46440,46200,46200,46152,46008,45888,45888,
     1  45816,45720,45696,45504,45480,45552,45480,45264,45168,45192,
     2  45144,45072,45048,44928,44976,44928,44640,44808,44952,45048,
     3  45144,45360,45432,44928,44712,44640,44664,44736,44928,45072,
     4  45000,44688,44592,44568,44304,44160,44136,44208,44136,44352,
     5  44376,44496,44568,44688,44592,44664,44640,44544,44112,44424,
     6  44472,45000,44928,44928,44832,44832,44760,44760,44688,44592,
     7  44496,44496,43392,43296,43320,43224,43368,43200,43200,43032,
     8  44928,44136,44136,44064,44136,44376,44448,44424,44544,44544,
     9  44256,42768,42792,43680,43680,43920,43920,43920,43896,40680/
            data (jy(i),i= 1001, 1100)/
     +  40968,42024,42024,42192,42192,42360,42360,42528,42528,42744,
     1  42720,42888,42912,43080,43080,43248,43248,43440,43416,43584,
     2  43584,43800,43800,43968,43968,44136,44136,44304,44304,44496,
     3  44496,44640,44904,44688,44304,43968,43872,43680,43392,43176,
     4  45864,42888,43944,42864,42888,42792,42672,42504,42120,41976,
     5  41976,42096,42600,43104,44472,44496,44568,44472,44544,44616,
     6  44616,44688,38544,38928,38928,39096,39120,39792,39792,41712,
     7  41832,41952,41976,42120,42264,42240,42312,42360,42336,42384,
     8  42576,42672,42720,42672,42792,42816,42288,42288,42816,42792,
     9  42960,42984,42624,42648,41952,41952,40944,42000,41952,41760/
            data (jy(i),i= 1101, 1200)/
     +  41808,41640,37680,38400,38400,38736,38760,39288,39312,39888,
     1  39888,40944,40968,40608,40488,40128,40032,39912,39888,39696,
     2  40680,40488,40512,40320,40320,40248,40272,39984,40008,39672,
     3  39576,39912,39912,39672,36408,40680,40656,35856,41928,40872,
     4  40824,39936,39936,39768,39744,39216,39192,38664,38640,37584,
     5  37584,43896,40512,40272,39624,39168,39168,37560,37512,42840,
     6  42816,39816,39696,39432,39240,38712,38568,38568,38496,38304,
     7  37968,37680,37512,38544,37488,35832,36000,35952,36096,36192,
     8  36384,36648,36672,36792,36888,37008,37032,37200,37200,37104,
     9  37152,37104,37248,37224,37272,37392,37608,37632,37560,37656/
            data (jy(i),i= 1201, 1300)/
     +  37680,37848,37896,38136,38184,38544,37680,37320,37320,36600,
     1  36600,36600,36744,36912,37056,37104,37080,37608,37704,37008,
     2  37032,36312,37464,37464,36744,35856,35712,33984,34920,34920,
     3  35952,35712,34800,34800,33888,33816,31704,35712,35640,35616,
     4  35520,35544,35304,35256,35376,35208,35064,34872,34800,34800,
     5  34632,34416,34176,34200,34032,33696,33600,33504,33432,33360,
     6  33288,33192,33456,33504,33432,33528,33720,34008,34128,34176,
     7  34248,34272,34440,34416,34464,34440,34536,34560,34944,34968,
     8  35688,33936,33864,33576,33528,33336,33264,33168,33000,32832,
     9  32568,32472,32448,32256,32184,32064,31872,31728,31344,31248/
            data (jy(i),i= 1301, 1400)/
     +  31104,30744,30528,30456,30288,30048,29880,29784,29736,29544,
     1  29328,28968,28776,28776,28560,33384,34488,34488,34440,34272,
     2  34272,34392,34392,34296,33864,33768,33672,33432,33504,33240,
     3  33336,33336,33264,32808,32664,32376,32784,32832,32424,32424,
     4  33768,33648,33312,33480,33432,33264,32904,32856,32976,32712,
     5  32688,32856,32760,32496,32400,32472,32712,32328,34392,34392,
     6  32304,33336,33216,33192,33240,33192,33144,33120,32976,32976,
     7  32880,32832,32736,32472,32400,32424,33096,33024,33072,32808,
     8  32904,32760,32664,32640,32520,32352,32184,32088,31968,31872,
     9  31704,31512,31152,31128,31248,31080,31104,30840,30840,30912/
            data (jy(i),i= 1401, 1500)/
     +  31152,31248,31200,31104,31248,31440,31464,31224,31032,31128,
     1  31392,31200,31224,31296,31392,31440,31320,31392,31584,31680,
     2  31776,31752,31440,31512,31728,31872,32496,32208,32064,34656,
     3  34656,34200,34104,34080,34128,34080,33864,33792,33456,33360,
     4  33288,33192,33168,33072,33000,32496,32400,32160,31920,31728,
     5  31704,31656,31488,31200,30984,31080,31008,30984,31080,31608,
     6  31560,31512,31392,31368,31080,31152,30984,31032,30888,30912,
     7  31032,31032,31104,31344,31368,31248,31152,31176,30960,30888,
     8  30768,30720,30768,30672,30576,30480,30432,30288,30120,29976,
     9  29904,29832,29832,29640,29592,29544,29424,29376,29256,29160/
            data (jy(i),i= 1501, 1600)/
     +  29064,29256,29496,29856,30024,30264,30600,31104,31200,31200,
     1  32256,29064,31320,31320,31680,31728,31392,31392,29016,29112,
     2  30936,30912,30792,30792,30576,30552,30456,30288,30048,29760,
     3  29688,29568,29616,29496,29496,29400,29328,29160,29232,29184,
     4  29328,29280,29040,28848,28848,28992,28776,28896,28872,28992,
     5  29136,29256,29400,29352,29376,28608,28968,28992,29112,29016,
     6  29064,28968,29016,29160,29088,29016,29064,29136,29352,29256,
     7  29424,29232,29232,29352,29424,29424,29592,29472,29472,29568,
     8  29712,29832,29904,29976,29976,30096,30216,30216,30312,30408,
     9  30672,30696,30792,30816,30936,31032,31008,30888,30792,30864/
            data (jy(i),i= 1601, 1700)/
     +  30840,31032,28536,28800,28728,28488,28368,28104,28008,27984,
     1  28440,28392,28440,28296,28104,28296,28296,28224,28104,28032,
     2  28008,27888,27696,27576,27480,27360,27408,27504,27504,27456,
     3  27336,27096,27192,27216,27072,27144,27120,26928,26904,26952,
     4  26808,26856,29016,26400,26328,26304,26208,26016,25944,26112,
     5  26208,26328,26376,26376,26160,26136,26496,26496,26352,26496,
     6  26592,26640,26664,26520,26856,26760,26784,26400,26016,26016,
     7  25944,25944,25824,25824,26376,25296,25704,25800,25920,25680,
     8  25536,25488,25488,25776,25896,25848,25872,25968,26136,26184,
     9  26040,26016,26304,26376,26688,26880,29448,29448,29376,25200/
            data (jy(i),i= 1701, 1800)/
     +  24936,24816,24864,24936,24768,25896,25872,25560,25440,25224,
     1  24984,24912,24768,24552,24264,24240,23976,24024,28344,27912,
     2  27840,27456,27432,27312,27336,27144,26952,26544,26160,26232,
     3  26160,26040,26136,26040,25920,25872,25776,25704,25632,25512,
     4  25464,25416,25296,25296,25416,25296,25080,24912,24912,24984,
     5  24648,24696,24576,24576,24480,24432,24360,24312,24264,24240,
     6  24408,24312,24288,24000,23952,24024,23856,23856,23928,23808,
     7  23760,23880,23736,23808,23880,23880,24072,24120,23904,27816,
     8  27288,26784,26544,26352,26088,25872,25704,25176,24960,24840,
     9  24768,24528,24288,24024,24048,23976,23760,23688,23280,23136/
            data (jy(i),i= 1801, 1900)/
     +  23160,23088,23808,23856,23784,23760,23520,23472,23376,23280,
     1  23400,23376,23256,23400,23256,23304,23232,23136,23136,23112,
     2  23016,22848,22896,22728,22776,22704,22800,21432,21552,21672,
     3  21696,21768,21960,21984,22152,22152,22296,22344,22392,22512,
     4  22584,22536,22560,22680,22728,22872,22896,22824,22920,23088,
     5  23136,23160,23088,23112,23400,23640,23688,23904,24048,24168,
     6  22872,22776,22824,22632,22632,22728,22848,22656,22680,22656,
     7  22560,22488,22560,22512,22416,22272,22176,22104,22008,21912,
     8  21912,22032,21816,21720,21696,21552,21432,21408,21504,21528,
     9  21408,21384,21264,21192,21072,20928,20904,20664,20616,20328/
            data (jy(i),i= 1901, 1980)/
     +  20280,19800,19848,19800,19632,19776,19848,19968,20040,20088,
     1  20160,20376,20616,20664,21192,21216,21072,21336,21384,21384,
     2  21192,21144,21360,21456,21288,21312,21408,21504,21600,21648,
     3  21744,21816,21984,22128,22200,22176,22248,22488,22704,22800,
     4  22896,22800,22800,23280,23328,23400,23520,23592,23736,23904,
     5  23976,24024,24144,24120,23952,24024,24096,24120,24528,24672,
     6  24744,24768,24624,24744,24840,24816,25032,22560,22536,22920,
     7  23088,23280,23784,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      6,    7,    2,    5,    4,    1,    1,    6,   30,   31,
     1     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     2     42,   43,   44,   45,   46,   47,   48,   10,    9,    3,
     3     14,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     4     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     5     70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
     6     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     7     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     8    100,  101,  102,  103,  104,   13,   11,   10,  106,  107,
     9    108,  109,  110,  111,  112,  113,   11,    9,   12,   15/
            data (jb1(i),i=  101,  200)/
     +     14,  115,  116,  117,  118,  119,  120,  121,  122,  123,
     1    124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
     2    134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
     3    144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
     4    154,  155,  156,   17,   16,   18,   17,  158,  159,  160,
     5    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     6    171,  172,  173,  174,  175,  176,  177,  178,  179,  180,
     7    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     8    191,  192,  193,   19,   19,  195,  196,  197,  198,  199,
     9    200,  201,  202,  203,  204,  205,  206,  207,  208,  209/
            data (jb1(i),i=  201,  300)/
     +    210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
     1    220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
     2    230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
     3    240,  241,  242,  243,   21,   20,   21,  245,  246,  247,
     4    248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
     5    258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
     6    268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
     7    278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
     8    288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
     9    298,  299,  300,  301,  302,  303,  304,   24,   22,  306/
            data (jb1(i),i=  301,  400)/
     +    307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
     1    317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
     2    327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
     3    337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
     4    347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
     5    357,  358,  359,   23,   23,   26,   26,   27,   24,  362,
     6    363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
     7    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     8    383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
     9    393,  394,  395,  396,  397,  398,  399,  400,  401,  402/
            data (jb1(i),i=  401,  500)/
     +    403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
     1    413,   29,   25,   25,    1,  415,  416,  417,    2,    3,
     2      4,  421,  422,  423,  424,  425,  426,  427,  428,  429,
     3    430,  431,  432,  433,  434,  435,  436,  437,  438,  439,
     4    440,  441,  442,  443,  444,  445,  446,  447,  448,  449,
     5    450,  451,  452,  454,    6,  455,  456,  457,  458,  459,
     6    460,  461,  462,  463,  464,  465,  466,  467,  468,    7,
     7    470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
     8    480,  481,  482,  483,  484,  485,  486,  487,  488,  489,
     9    454,    8,  492,  493,  491,    9,  495,  496,  497,  498/
            data (jb1(i),i=  501,  600)/
     +    499,  500,  420,  501,   10,  503,  469,  505,  506,  507,
     1    508,  509,  510,  511,  512,  513,  514,  515,  516,  517,
     2    518,  469,  490,  520,  521,  522,  523,  524,  525,  526,
     3    527,  528,  529,  530,  531,  532,  519,  454,  534,  535,
     4    536,  538,  539,  540,  541,  542,  543,  544,  545,  546,
     5    547,  548,  549,  550,  551,  552,  553,  554,  420,  419,
     6    419,  418,  418,  557,  453,  453,  560,  561,  556,  505,
     7    563,  564,  537,  565,  566,  559,  491,  568,  569,  570,
     8    571,  572,  573,  574,  575,  537,  577,  578,  579,  580,
     9    581,  582,  583,  584,  585,  586,  587,  588,  589,  590/
            data (jb1(i),i=  601,  700)/
     +    591,  592,  593,  594,  595,  596,  597,  598,  599,  601,
     1    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     2    612,  538,  490,  614,  615,  616,  617,  618,  618,  620,
     3    576,  619,  622,  623,  624,  625,  626,  505,  576,  600,
     4    501,  629,  630,  631,  559,  601,  632,  635,  636,  637,
     5    634,  632,  601,  639,  641,  642,  643,   13,  641,  560,
     6    560,  622,  633,  647,  646,  649,  650,  651,  652,  640,
     7    654,  633,  656,  657,  658,  659,  600,  654,  634,  662,
     8    663,  664,  665,  666,  667,  668,  669,  670,  671,  672,
     9    673,  674,  675,  676,  677,  678,  679,  637,  654,  646/
            data (jb1(i),i=  701,  800)/
     +    682,  683,  656,  685,  686,  687,  619,  689,  690,  691,
     1    692,  693,  694,  695,  696,  697,  698,  699,  700,  701,
     2    702,  703,  704,  705,  706,  707,  708,  709,  710,  711,
     3    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     4    722,  723,  724,  688,   14,  641,  726,  684,  728,  727,
     5    730,  731,  732,  733,  644,  735,  688,  737,  738,  739,
     6    740,  741,  662,  743,  744,  684,  661,  746,  747,  748,
     7    749,  750,  751,  752,  737,   15,  754,  755,  756,  757,
     8    758,  759,  760,  761,  762,  763,  764,  765,  766,  767,
     9    768,  769,  770,  662,  735,  772,  773,  774,  734,  681/
            data (jb1(i),i=  801,  900)/
     +    681,  687,  777,  778,  779,  780,  781,  782,  776,  649,
     1    784,  785,  786,  787,  788,  789,  790,  791,  792,  793,
     2    794,  795,  796,  797,  798,  799,  800,  661,  649,  803,
     3    804,  805,  806,  807,  808,  809,  810,  811,  812,  813,
     4    814,  815,  816,  817,  818,  802,  802,  820,  821,  822,
     5    823,  824,  825,  826,  827,  828,  829,  830,  831,  832,
     6    833,  834,  835,  836,  837,  743,  839,  840,  737,  727,
     7    842,  843,  775,  729,  845,  846,  847,  848,  849,  850,
     8    851,  852,  853,  854,  855,  856,  857,  858,  859,  860,
     9    735,  862,  863,  864,  865,  866,  867,  868,  869,  870/
            data (jb1(i),i=  901, 1000)/
     +    871,  872,  873,  874,  875,  876,  877,  878,  879,  880,
     1    881,  882,  883,  884,  885,  886,  887,  888,  889,  890,
     2    891,  892,  893,  894,  895,  896,  897,  898,  899,  900,
     3    901,  902,  903,  904,  905,  906,  907,  908,  909,  910,
     4    911,  912,  913,  914,  915,  916,  917,  918,  919,  920,
     5    921,  922,  923,  924,  925,  927,  928,  929,  930,  931,
     6    932,  743,  861,  934,  935,  936,  937,  938,  939,  940,
     7    941,  942,  927,  776,  945,  946,  947,  948,  949,  950,
     8    951,  952,  953,  954,  955,  956,  957,  944,  803,  959,
     9    960,  839,  839,  962,  963,  964,  965,  966,  967,  968/
            data (jb1(i),i= 1001, 1100)/
     +    969,  970,  971,  972,  973,  974,  975,  976,  977,  978,
     1    979,  980,  926,  981,  982,  983,  984,  985,  986,  987,
     2    988,  989,  990,  945,  992,  993,  994,  995,  996,  944,
     3    844,  997,  803, 1001, 1002, 1003, 1004, 1005, 1006, 1007,
     4   1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017,
     5   1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027,
     6   1028, 1029, 1030, 1031,  927,  861, 1033, 1034, 1035, 1036,
     7   1037, 1038, 1039,  842, 1041,  998, 1043, 1044, 1045, 1046,
     8   1047, 1048, 1049, 1050, 1051, 1052, 1053, 1040,  992, 1055,
     9   1056, 1057, 1058, 1059, 1060, 1061,  926, 1063, 1064, 1065/
            data (jb1(i),i= 1101, 1200)/
     +   1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075,
     1   1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083,  992, 1042,
     2   1085, 1086, 1087, 1088, 1089,  997, 1040, 1091, 1092, 1093,
     3   1094, 1095, 1097, 1098, 1099, 1100, 1101, 1096, 1042, 1103,
     4   1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1097, 1001,
     5   1001, 1113, 1000,   18, 1115, 1116, 1117, 1118, 1119, 1000,
     6   1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1120,
     7   1131, 1114, 1132, 1133, 1134, 1087, 1136, 1131, 1120, 1096,
     8   1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148,
     9   1149, 1150,  998, 1152, 1153, 1154, 1155, 1156, 1157, 1151/
            data (jb1(i),i= 1201, 1300)/
     +   1158,  945, 1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167,
     1   1168, 1169, 1170, 1171, 1172, 1159, 1063, 1174, 1173, 1176,
     2   1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185, 1186,
     3   1187, 1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196,
     4   1197, 1198, 1199, 1200, 1201, 1202, 1203, 1204, 1205, 1063,
     5   1103, 1207, 1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215,
     6   1216, 1217, 1150, 1103, 1219, 1220, 1221, 1135, 1131, 1223,
     7   1224, 1225, 1176, 1135, 1228, 1229, 1230, 1138, 1138, 1138,
     8   1233, 1234, 1235, 1236, 1227, 1176, 1238, 1239, 1240, 1241,
     9   1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251/
            data (jb1(i),i= 1301, 1400)/
     +   1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261,
     1   1263, 1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272,
     2   1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280, 1227, 1228,
     3   1228, 1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290,
     4   1291, 1292, 1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300,
     5   1301, 1302, 1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310,
     6   1311, 1312, 1313, 1314, 1211, 1263, 1262, 1159, 1317, 1318,
     7   1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328,
     8   1329, 1330, 1331, 1332, 1333, 1334, 1336, 1337, 1338, 1339,
     9   1340, 1341, 1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349/
            data (jb1(i),i= 1401, 1500)/
     +   1350, 1351, 1352, 1353, 1354, 1355, 1356, 1335, 1336, 1151,
     1   1359, 1358, 1358, 1316, 1362, 1363, 1364, 1365, 1366, 1367,
     2   1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375, 1361, 1262,
     3   1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384, 1385, 1386,
     4   1387, 1388, 1389, 1390, 1391, 1392, 1393, 1394, 1395, 1396,
     5   1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404, 1405, 1406,
     6   1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416,
     7   1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1335,
     8   1427, 1428, 1426, 1232, 1430, 1431, 1432, 1433, 1434, 1435,
     9   1436, 1437, 1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445/
            data (jb1(i),i= 1501, 1600)/
     +   1446, 1447, 1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455,
     1   1456, 1457, 1458, 1237, 1460, 1461, 1462, 1463, 1464, 1465,
     2   1466, 1467, 1468, 1469, 1470, 1471, 1472, 1459, 1263, 1474,
     3   1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482, 1483, 1484,
     4   1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492, 1493, 1494,
     5   1495, 1496, 1497, 1498, 1499, 1501, 1502, 1503, 1504, 1505,
     6   1506, 1507, 1508, 1509, 1510, 1361, 1500, 1512, 1513, 1336,
     7   1426, 1515, 1516, 1517, 1518, 1519, 1512, 1455, 1521, 1522,
     8   1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530, 1531, 1532,
     9   1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542/
            data (jb1(i),i= 1601, 1700)/
     +   1543, 1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552,
     1   1553, 1554, 1499, 1315, 1556, 1557, 1558, 1559, 1560, 1561,
     2   1562, 1563, 1564, 1565, 1566, 1567, 1568, 1569, 1570, 1571,
     3   1572, 1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581,
     4   1582, 1583, 1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591,
     5   1592, 1593, 1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601,
     6   1602, 1237, 1315, 1501, 1604, 1605, 1606, 1607, 1608, 1512,
     7   1609, 1315, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618,
     8   1619, 1620, 1621, 1622, 1623, 1624, 1625, 1626, 1627, 1628,
     9   1629, 1630, 1631, 1632, 1633, 1634, 1635, 1636, 1637, 1638/
            data (jb1(i),i= 1701, 1800)/
     +   1639, 1640, 1641, 1519, 1643,   23, 1645, 1646, 1647, 1648,
     1   1649, 1650, 1651, 1652, 1653, 1654, 1655, 1656, 1657, 1658,
     2   1659, 1660, 1661, 1662, 1663, 1664, 1665, 1666, 1642, 1644,
     3   1668, 1669, 1670, 1671, 1672, 1673, 1674, 1675, 1676, 1677,
     4   1678, 1679, 1680, 1681, 1682, 1683, 1684, 1685, 1686, 1687,
     5   1688, 1689, 1690, 1691, 1692, 1693, 1694, 1695, 1642, 1459,
     6   1697, 1698, 1699, 1676, 1544, 1702, 1700, 1701, 1704, 1702,
     7   1610, 1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713, 1714,
     8   1644, 1715, 1717, 1701, 1500, 1719, 1720, 1721, 1722, 1723,
     9   1724, 1725, 1726, 1727, 1728, 1729, 1730, 1731, 1732, 1733/
            data (jb1(i),i= 1801, 1900)/
     +   1734, 1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742, 1743,
     1   1744, 1745, 1746, 1747, 1748, 1749, 1750, 1751, 1752, 1753,
     2   1754, 1755, 1756, 1757, 1758, 1759, 1760, 1761, 1762, 1763,
     3   1764, 1765, 1766, 1767, 1768, 1769, 1770, 1771, 1772, 1773,
     4   1774, 1775, 1776, 1777, 1778, 1717, 1609, 1780, 1781, 1782,
     5   1783, 1784, 1785, 1786, 1787, 1788, 1789, 1790, 1791, 1792,
     6   1793, 1794, 1795, 1796, 1797, 1798, 1799, 1800, 1801, 1767,
     7   1803, 1804, 1805, 1806, 1807, 1808, 1809, 1810, 1811, 1812,
     8   1813, 1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822,
     9   1823, 1824, 1825, 1826, 1802, 1828, 1829, 1830, 1831, 1832/
            data (jb1(i),i= 1901, 2000)/
     +   1833, 1834, 1835, 1836, 1837, 1838, 1839, 1840, 1841, 1842,
     1   1843, 1844, 1845, 1846, 1847, 1848, 1849, 1850, 1851, 1852,
     2   1853, 1854, 1855, 1856, 1857, 1858, 1859, 1715, 1802, 1861,
     3   1862, 1863, 1864, 1865, 1866, 1867, 1868, 1869, 1870, 1871,
     4   1872, 1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881,
     5   1882, 1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890, 1828,
     6   1828, 1892, 1893, 1894, 1895, 1896, 1897, 1898, 1899, 1900,
     7   1901, 1902, 1903, 1904, 1905,   26, 1906, 1907, 1908, 1909,
     8   1910, 1911, 1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919,
     9   1920, 1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929/
            data (jb1(i),i= 2001, 2050)/
     +   1930, 1931, 1932, 1933, 1934, 1935, 1936, 1937, 1938, 1939,
     1   1940, 1941, 1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949,
     2   1950, 1951, 1952, 1953, 1954, 1955, 1956, 1957, 1958, 1959,
     3   1960, 1961, 1962, 1963, 1964, 1965, 1966, 1676,   27, 1968,
     4   1969, 1970, 1971, 1972, 1702, 1717, 1716,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      7,    8,    3,    8,    5,    4,    2,   30,   31,   32,
     1     33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
     2     43,   44,   45,   46,   47,   48,   49,   49,   50,   50,
     3     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     4     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     5     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     6     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     7     91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
     8    101,  102,  103,  104,  105,  105,   13,  106,  107,  108,
     9    109,  110,  111,  112,  113,  114,  114,   12,   15,   16/
            data (jb2(i),i=  101,  200)/
     +    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     1    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     2    135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
     3    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     4    155,  156,  157,  157,   18,   20,  158,  159,  160,  161,
     5    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     6    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     7    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     8    192,  193,  194,  194,  195,  196,  197,  198,  199,  200,
     9    201,  202,  203,  204,  205,  206,  207,  208,  209,  210/
            data (jb2(i),i=  201,  300)/
     +    211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
     1    221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
     2    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     3    241,  242,  243,  244,  244,   22,  245,  246,  247,  248,
     4    249,  250,  251,  252,  253,  254,  255,  256,  257,  258,
     5    259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
     6    269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
     7    279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
     8    289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
     9    299,  300,  301,  302,  303,  304,  305,  305,  306,  307/
            data (jb2(i),i=  301,  400)/
     +    308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
     1    318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
     2    328,  329,  330,  331,  332,  333,  334,  335,  336,  337,
     3    338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
     4    348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
     5    358,  359,  360,  360,  361,  361,   27,   28,  362,  363,
     6    364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
     7    374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
     8    384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
     9    394,  395,  396,  397,  398,  399,  400,  401,  402,  403/
            data (jb2(i),i=  401,  500)/
     +    404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
     1    414,  414,   29,   28,  415,  416,  417,  418,  419,  420,
     2    421,  422,  423,  424,  425,  426,  427,  428,  429,  430,
     3    431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
     4    441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
     5    451,  452,  453,    5,  455,  456,  457,  458,  459,  460,
     6    461,  462,  463,  464,  465,  466,  467,  468,  469,  470,
     7    471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
     8    481,  482,  483,  484,  485,  486,  487,  488,  489,  490,
     9    491,  492,  493,  494,  494,  495,  496,  497,  498,  499/
            data (jb2(i),i=  501,  600)/
     +    500,  501,  502,  502,  503,  504,  504,  506,  507,  508,
     1    509,  510,  511,  512,  513,  514,  515,  516,  517,  518,
     2    519,  519,  520,  521,  522,  523,  524,  525,  526,  527,
     3    528,  529,  530,  531,  532,  533,  533,  534,  535,  536,
     4    537,  539,  540,  541,  542,  543,  544,  545,  546,  547,
     5    548,  549,  550,  551,  552,  553,  554,  555,  555,  538,
     6    556,  556,  557,  558,  558,  559,  561,  562,  562,  563,
     7    564,   11,  565,  566,  567,  567,  568,  569,  570,  571,
     8    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     9    582,  583,  584,  585,  586,  587,  588,  589,  590,  591/
            data (jb2(i),i=  601,  700)/
     +    592,  593,  594,  595,  596,  597,  598,  599,  600,  602,
     1    603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
     2    613,  613,  614,  615,  616,  617,  618,  619,  620,  621,
     3    621,  622,  623,  624,  625,  626,  627,  627,  628,  628,
     4    629,  630,  631,  632,  633,  634,  635,  636,   12,  638,
     5    638,  637,  639,  640,  642,  643,  644,  645,  645,  640,
     6    646,  644,  647,  648,  648,  650,  651,  652,  653,  653,
     7    655,  655,  657,  658,  659,  660,  660,  656,  661,  663,
     8    664,  665,  666,  667,  668,  669,  670,  671,  672,  673,
     9    674,  675,  676,  677,  678,  679,  680,  680,  681,  682/
            data (jb2(i),i=  701,  800)/
     +    683,  684,  685,  686,  687,  688,  689,  690,  691,  692,
     1    693,  694,  695,  696,  697,  698,  699,  700,  701,  702,
     2    703,  704,  705,  706,  707,  708,  709,  710,  711,  712,
     3    713,  714,  715,  716,  717,  718,  719,  720,  721,  722,
     4    723,  724,  725,  725,  726,  726,  727,  728,  729,  730,
     5    731,  732,  733,  734,  734,  736,  736,  738,  739,  740,
     6    741,  742,  742,  744,  745,  745,  746,  747,  748,  749,
     7    750,  751,  752,  753,  753,  754,  755,  756,  757,  758,
     8    759,  760,  761,  762,  763,  764,  765,  766,  767,  768,
     9    769,  770,  771,  771,  772,  773,  774,  775,  775,  729/
            data (jb2(i),i=  801,  900)/
     +    776,  777,  778,  779,  780,  781,  782,  783,  783,  784,
     1    785,  786,  787,  788,  789,  790,  791,  792,  793,  794,
     2    795,  796,  797,  798,  799,  800,  801,  801,  802,  804,
     3    805,  806,  807,  808,  809,  810,  811,  812,  813,  814,
     4    815,  816,  817,  818,  819,  819,  820,  821,  822,  823,
     5    824,  825,  826,  827,  828,  829,  830,  831,  832,  833,
     6    834,  835,  836,  837,  838,  838,  840,  841,  841,  842,
     7    843,  844,  844,  845,  846,  847,  848,  849,  850,  851,
     8    852,  853,  854,  855,  856,  857,  858,  859,  860,  861,
     9    862,  863,  864,  865,  866,  867,  868,  869,  870,  871/
            data (jb2(i),i=  901, 1000)/
     +    872,  873,  874,  875,  876,  877,  878,  879,  880,  881,
     1    882,  883,  884,  885,  886,  887,  888,  889,  890,  891,
     2    892,  893,  894,  895,  896,  897,  898,  899,  900,  901,
     3    902,  903,  904,  905,  906,  907,  908,  909,  910,  911,
     4    912,  913,  914,  915,  916,  917,  918,  919,  920,  921,
     5    922,  923,  924,  925,  926,  928,  929,  930,  931,  932,
     6    933,  933,  934,  935,  936,  937,  938,  939,  940,  941,
     7    942,  943,  943,  944,  946,  947,  948,  949,  950,  951,
     8    952,  953,  954,  955,  956,  957,  958,  958,  959,  960,
     9    961,  961,  962,  963,  964,  965,  966,  967,  968,  969/
            data (jb2(i),i= 1001, 1100)/
     +    970,  971,  972,  973,  974,  975,  976,  977,  978,  979,
     1    980,   16,  981,  982,  983,  984,  985,  986,  987,  988,
     2    989,  990,  991,  991,  993,  994,  995,  996,  997,  998,
     3    999,  999, 1000, 1002, 1003, 1004, 1005, 1006, 1007, 1008,
     4   1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018,
     5   1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028,
     6   1029, 1030, 1031, 1032, 1032, 1033, 1034, 1035, 1036, 1037,
     7   1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047,
     8   1048, 1049, 1050, 1051, 1052, 1053, 1054, 1054, 1055, 1056,
     9   1057, 1058, 1059, 1060, 1061, 1062, 1062, 1064, 1065, 1066/
            data (jb2(i),i= 1101, 1200)/
     +   1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,
     1   1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1084, 1085,
     2   1086, 1087, 1088, 1089, 1090, 1090, 1091, 1092, 1093, 1094,
     3   1095, 1096, 1098, 1099, 1100, 1101, 1102, 1102,   17, 1104,
     4   1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1112, 1097,
     5   1113, 1114, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121,
     6   1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1130,
     7     19, 1132, 1133, 1134, 1135, 1136, 1137, 1137, 1138, 1139,
     8   1140, 1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149,
     9   1150, 1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1158/
            data (jb2(i),i= 1201, 1300)/
     +   1159, 1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168,
     1   1169, 1170, 1171, 1172, 1173, 1173, 1174, 1175, 1175, 1177,
     2   1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185, 1186, 1187,
     3   1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197,
     4   1198, 1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206, 1206,
     5   1207, 1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216,
     6   1217, 1218, 1218, 1219, 1220, 1221, 1222, 1222, 1223, 1224,
     7   1225, 1226, 1226, 1227, 1229, 1230, 1231, 1231, 1232, 1233,
     8   1234, 1235, 1236, 1237, 1232, 1238, 1239, 1240, 1241, 1242,
     9   1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252/
            data (jb2(i),i= 1301, 1400)/
     +   1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262,
     1   1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273,
     2   1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1281,   20,
     3   1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291,
     4   1292, 1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301,
     5   1302, 1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311,
     6   1312, 1313, 1314, 1315, 1316, 1316,   21, 1317, 1318, 1319,
     7   1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329,
     8   1330, 1331, 1332, 1333, 1334, 1335, 1337, 1338, 1339, 1340,
     9   1341, 1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350/
            data (jb2(i),i= 1401, 1500)/
     +   1351, 1352, 1353, 1354, 1355, 1356, 1357, 1357, 1358, 1359,
     1   1360, 1360, 1361, 1362, 1363, 1364, 1365, 1366, 1367, 1368,
     2   1369, 1370, 1371, 1372, 1373, 1374, 1375, 1376, 1376, 1377,
     3   1378, 1379, 1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387,
     4   1388, 1389, 1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397,
     5   1398, 1399, 1400, 1401, 1402, 1403, 1404, 1405, 1406, 1407,
     6   1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417,
     7   1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427,
     8   1428, 1429, 1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436,
     9   1437, 1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446/
            data (jb2(i),i= 1501, 1600)/
     +   1447, 1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456,
     1   1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466,
     2   1467, 1468, 1469, 1470, 1471, 1472, 1473, 1473, 1474, 1475,
     3   1476, 1477, 1478, 1479, 1480, 1481, 1482, 1483, 1484, 1485,
     4   1486, 1487, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495,
     5   1496, 1497, 1498, 1499, 1500, 1502, 1503, 1504, 1505, 1506,
     6   1507, 1508, 1509, 1510, 1511, 1511, 1501, 1513, 1514, 1514,
     7   1515, 1516, 1517, 1518, 1519, 1520, 1520, 1521, 1522, 1523,
     8   1524, 1525, 1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533,
     9   1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543/
            data (jb2(i),i= 1601, 1700)/
     +   1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553,
     1   1554, 1555, 1555, 1556, 1557, 1558, 1559, 1560, 1561, 1562,
     2   1563, 1564, 1565, 1566, 1567, 1568, 1569, 1570, 1571, 1572,
     3   1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582,
     4   1583, 1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592,
     5   1593, 1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601, 1602,
     6     22, 1603, 1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610,
     7   1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618, 1619,
     8   1620, 1621, 1622, 1623, 1624, 1625, 1626, 1627, 1628, 1629,
     9   1630, 1631, 1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639/
            data (jb2(i),i= 1701, 1800)/
     +   1640, 1641, 1642, 1643, 1644, 1645, 1646, 1647, 1648, 1649,
     1   1650, 1651, 1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659,
     2   1660, 1661, 1662, 1663, 1664, 1665, 1666, 1667, 1667, 1668,
     3   1669, 1670, 1671, 1672, 1673, 1674, 1675,   24, 1677, 1678,
     4   1679, 1680, 1681, 1682, 1683, 1684, 1685, 1686, 1687, 1688,
     5   1689, 1690, 1691, 1692, 1693, 1694, 1695, 1696, 1696, 1697,
     6   1698, 1699, 1700, 1700, 1701, 1703, 1703, 1704, 1705, 1705,
     7   1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713, 1714, 1715,
     8   1716, 1716, 1718, 1718, 1719, 1720, 1721, 1722, 1723, 1724,
     9   1725, 1726, 1727, 1728, 1729, 1730, 1731, 1732, 1733, 1734/
            data (jb2(i),i= 1801, 1900)/
     +   1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742, 1743, 1744,
     1   1745, 1746, 1747, 1748, 1749, 1750, 1751, 1752, 1753, 1754,
     2   1755, 1756, 1757, 1758, 1759, 1760, 1761, 1762, 1763, 1764,
     3   1765, 1766, 1767, 1768, 1769, 1770, 1771, 1772, 1773, 1774,
     4   1775, 1776, 1777, 1778, 1779, 1779, 1780, 1781, 1782, 1783,
     5   1784, 1785, 1786, 1787, 1788, 1789, 1790, 1791, 1792, 1793,
     6   1794, 1795, 1796, 1797, 1798, 1799, 1800, 1801, 1802, 1803,
     7   1804, 1805, 1806, 1807, 1808, 1809, 1810, 1811, 1812, 1813,
     8   1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822, 1823,
     9   1824, 1825, 1826, 1827, 1827, 1829, 1830, 1831, 1832, 1833/
            data (jb2(i),i= 1901, 2000)/
     +   1834, 1835, 1836, 1837, 1838, 1839, 1840, 1841, 1842, 1843,
     1   1844, 1845, 1846, 1847, 1848, 1849, 1850, 1851, 1852, 1853,
     2   1854, 1855, 1856, 1857, 1858, 1859, 1860, 1860, 1861, 1862,
     3   1863, 1864, 1865, 1866, 1867, 1868, 1869, 1870, 1871, 1872,
     4   1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881, 1882,
     5   1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890, 1891, 1891,
     6   1892, 1893, 1894, 1895, 1896, 1897, 1898, 1899, 1900, 1901,
     7   1902, 1903, 1904, 1905,   25, 1906, 1907, 1908, 1909, 1910,
     8   1911, 1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920,
     9   1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929, 1930/
            data (jb2(i),i= 2001, 2050)/
     +   1931, 1932, 1933, 1934, 1935, 1936, 1937, 1938, 1939, 1940,
     1   1941, 1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950,
     2   1951, 1952, 1953, 1954, 1955, 1956, 1957, 1958, 1959, 1960,
     3   1961, 1962, 1963, 1964, 1965, 1966, 1967, 1967, 1968, 1969,
     4   1970, 1971, 1972, 1973, 1973,   28,   29,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ca(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1820) :: jx,jy
            integer(kind=iknd), save, dimension(1870) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'california    '/
            data jrot,ipart/0,2/
            data kv/   1,1708,1812,   0,   0/
            data kb/   1,1765,1869,   0,   0/
            data iib/ 346, 104,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  12120,20976, 9480,27000, 9000,26712,26640,26616,26592,10632,
     1  27000,28464,12864,14832,14904,36192,15672,17832,19656,46344,
     2  22776,28200,30720,52272,34656,31152,31392,31488,31704,32520,
     3  32712,33024,33360,33360,33192,33264,33504,33816,34248,37128,
     4  51432,44352, 9456, 9384, 9384, 9240, 9240, 9168, 8976, 8808,
     5   8952, 9072, 9096,13728,27168, 8928, 8760, 8760, 8664, 8328,
     6   8208, 7608, 7704, 7632, 7488, 7632, 8136, 8736, 8928, 9072,
     7   9000, 8904, 8880, 9000, 9168, 9408, 9192, 9816, 9792, 9864,
     8   9984,10056, 9960, 9888, 9888, 9744, 9768, 9648, 9696, 9624,
     9   9672, 9576, 9672, 9648, 9912, 9840, 9888, 9864, 9720, 9672/
            data (jx(i),i=  101,  200)/
     +   9456, 9360, 9240,26568,10344,10344,10176,10104,12720,12576,
     1  12504,12552,12312,11808,11568,11448,11448,11304,11328,11016,
     2  10704,12984,12960,12864,13032,12816,12648,12912,12840,12984,
     3  13368,13656,13728,13920,13968,14064,14184,14328,14400,14664,
     4  15456,15456,15384,15360,15216,15168,15144,15264,15096,15072,
     5  14952,14856,14760,14784,14904,17592,17400,17280,17088,16944,
     6  16728,16488,15960,17904,18000,17904,17664,17424,17184,16968,
     7  17184,17184,17064,17112,17256,17232,17280,17232,17448,17568,
     8  17760,18048,18336,18696,19008,19176,51192,51216,51432,51624,
     9  52008,52080,52248,52176,52320,52464,52440,52512,52680,53232/
            data (jx(i),i=  201,  300)/
     +  53424,53640,53688,53544,53232,52944,52776,52656,52584,52368,
     1  22896,22824,22440,22344,22320,22272,21864,21672,21864,21840,
     2  21864,21768,21672,21480,21384,21216,20784,20520,19944,19920,
     3  19824,19776,22680,22776,22824,22944,22800,22944,22680,22800,
     4  23040,23328,23520,23592,24360,25080,25320,25704,25968,26136,
     5  26328,26496,26544,26712,27120,27288,27672,27840,28320,28632,
     6  28704,28920,29160,29448,29472,29472,29880,30048,52272,52128,
     7  52176,51984,51864,51816,51936,51864,51984,51840,51888,51864,
     8  51984,51960,52056,51864,51936,51864,51912,51840,51912,51576,
     9  51336,51144,50976,51096,50952,51024,51192,51240,51168,51240/
            data (jx(i),i=  301,  400)/
     +  51216,51096,51168,51288,51360,51384,51552,51768,51984,52080,
     1  52152,52272,52200,52296,52296,52008,52008,51960,51840,51744,
     2  51576,51168,51072,36864,36720,36576,36264,35832,35568,35088,
     3  34824,37656,38112,38424,38664,38784,38784,38640,38784,38760,
     4  38832,38880,39048,39192,39360,39408,11232,11304,11280,11400,
     5  11472,11352,11328,11184,11208,11064,11184,11256,11232,11352,
     6  11376,11304,11280,11352,11232,11376,11520,11664,11760,11904,
     7  12024,12024,20736,20880,10752,10776,12216,12048,12096,12096,
     8  12024,12048,11976,12000,11880,16176,16080,16152,16200,16320,
     9  16200,16056,16008,15912,15840,15600,15528,15288,15192,15048/
            data (jx(i),i=  401,  500)/
     +  14856,14760,14688,14472,14280,14160,14184,14088,14088,14280,
     1  14376,14304,14184,14088,13776,13704,13512,13464,12912,12672,
     2  12576,12456,12312,21240,21048,11112,11448,11376,11400,11184,
     3  11328,11472,11544,11808,11856,11952,11952,12144,12168,12072,
     4  11952,11952,12048,12120,13344,13368,13464,13704,13704,13968,
     5  14016,14136,14256,14376,14400,14616,14688,14880,14976,15072,
     6  15048,14928,14976,14880,15024,15072,15312,15312,15624,15576,
     7  15648,15984,16008,15960,16056,16344,16392,20280,20016,19632,
     8  19440,18696,18336,18024,17616,17280,17280,17064,16704,16200,
     9  16128,15768,15168,14832,14832,14760,14280,14208,13992,13728/
            data (jx(i),i=  501,  600)/
     +  22200,22152,22248,22248,22656,22800,22920,23016,23136,23256,
     1  23352,23496,23568,23736,23808,24072,24288,24288,24408,24408,
     2  24576,24576,24672,24696,24816,24840,24984,25008,25128,25128,
     3  25224,25296,25704,25704,25872,25896,25968,26040,26208,26208,
     4  26280,26280,26328,26232,26160,26088,26088,20448,20472,20616,
     5  20784,20784,20856,20808,20952,20784,20400,20328,20376,13824,
     6  13752,13776,13680,13728,13704,13632,13728,13728,13560,13392,
     7  17688,17592,17616,17568,17712,18864,19032,19056,19272,19512,
     8  19608,19752,19776,20184,20280,20448,11112,21912,21840,21840,
     9  21672,21672,21600,21528,21456,21456,21360,21360,21288,21288/
            data (jx(i),i=  601,  700)/
     +  21192,21192,21120,21120,21048,21048,20904,20856,20784,20736,
     1  20520,20520,20448,20448,20544,20520,20616,20616,20712,20784,
     2  20736,20736,20616,20616,13728,13656,13728,13848,13896,13824,
     3  26664,26664,22224,22464,22608,22872,23040,23088,23136,23376,
     4  23688,23808,23832,13872,13896,13824,13824,13704,22128,22080,
     5  22008,21960,22128,19392,19464,19536,19680,19848,19968,20064,
     6  20376,20520,20616,20712,20736,20832,20904,21192,21192,21360,
     7  21552,21600,21792,21792,21912,14448,14544,13896,13584,13584,
     8  13512,13344,13344,13224,13200,13032,13032,12912,12888,12744,
     9  12864,13008,13176,13248,13224,13176,13176,13104,13056,12960/
            data (jx(i),i=  701,  800)/
     +  13056,13248,13248,13632,13632,13848,18240,17712,17736,17160,
     1  17136,22320,22464,23136,23424,23568,23784,24096,24192,24288,
     2  24288,24432,16032,15744,15792,15672,15528,15432,15480,15432,
     3  15552,15528,15384,15384,15144,14904,14736,14592,14352,14280,
     4  14448,14256,17760,17736,17904,18000,18096,18024,18024,17832,
     5  17976,17856,17904,17808,17832,17808,17904,18456,18312,18336,
     6  18120,22104,21864,21648,21504,21408,21336,21288,21024,21000,
     7  20976,20928,20856,19368,18336,18360,18528,18432,18360,18168,
     8  18048,17952,18048,17928,18000,17928,23760,23520,23112,23040,
     9  22920,22848,22728,22584,22560,22176,22104,21912,21768,21480/
            data (jx(i),i=  801,  900)/
     +  21312,21096,25968,25920,21360,21624,21624,21672,21672,21816,
     1  21816,21864,21840,21912,22272,22344,22368,22704,22752,22824,
     2  22872,22968,23232,23376,23520,23544,23904,24024,24288,24480,
     3  24624,25776,25920,20712,20232,15816,15696,15864,19392,19344,
     4  19320,19344,19392,19344,19416,19440,19512,19392,19440,19512,
     5  19464,19488,19656,19920,15768,15888,15888,15768,15744,15456,
     6  14688,16992,16896,16848,16776,16776,16656,16608,16536,16296,
     7  16128,15984,12720,12720,12480,12456,11424,11400,10800,10704,
     8  14616,14424,14208,18504,18384,18456,18552,18672,18792,18792,
     9  18936,18912,19008,18984,19080,19056,19128,19128,19176,19224/
            data (jx(i),i=  901, 1000)/
     +  19368,19296,19872,19872,19920,19968,20232,26184,26760,26976,
     1  27120,27096,21864,21504,21432,28128,28128,28248,28200,28464,
     2  28416,28560,28344,28248,28272,26160,19248,19416,19488,19608,
     3  19536,19680,19680,19536,19464,19512,19608,19584,19680,19632,
     4  19728,19656,19536,19464,19344,19152,21960,22056,22248,22296,
     5  22416,22488,22536,22584,22680,22848,22944,23232,23424,23760,
     6  24168,24816,25104,25464,25560,25872,25992,25968,26016,15528,
     7  16464,16392,16488,16416,16512,16416,16536,16464,17136,17088,
     8  16872,26400,26232,26136,25992,25920,25320,24984,24768,24576,
     9  24408,24384,21960,22056,22248,22440,22824,23016,23112,23592/
            data (jx(i),i= 1001, 1100)/
     +  23712,24120,24216,27936,27816,27768,27360,27312,27048,18816,
     1  18864,18768,18432,18096,17736,17376,17184,21816,29688,30000,
     2  29928,30024,29928,30000,29904,29760,29736,29544,29496,29520,
     3  29616,29736,29808,30048,29760,29784,29688,29424,29328,29088,
     4  29064,28848,28992,29040,28944,28968,28872,28728,28656,28704,
     5  28680,28368,28320,28104,28176,28248,28200,28224,28104,28104,
     6  28080,14664,14568,14616,14856,14904,15000,15072,15240,15264,
     7  15168,15432,15384,15552,15624,15576,15648,15648,15744,15792,
     8  15696,15672,15528,24168,24288,24552,24552,24672,24744,24888,
     9  25656,25776,26040,15720,13056,13320,14016,14520,14760,14808/
            data (jx(i),i= 1101, 1200)/
     +  14976,15096,21696,21624,21480,21168,20880,20640,20568,20328,
     1  20088,19992,19992,19752,19608,19608,19488,19464,19224,19200,
     2  19296,19248,19104,18888,18768,18648,18480,18240,18000,17952,
     3  17880,17736,17064,16656,16464,22200,19056,18960,18840,18696,
     4  18312,18120,15312,15288,24000,24072,15552,23376,23928,23952,
     5  24048,19560,20664,20712,20784,20856,20928,20952,21000,21072,
     6  21240,21288,21456,21528,21576,21648,21696,21744,21840,21984,
     7  22152,15360,15072,15048,14856,19272,19368,19344,19176,19296,
     8  19200,19248,19224,19320,19272,19200,19272,15936,15672,29496,
     9  29208,29088,28992,28896,28920,28824,28752,28488,28344,28272/
            data (jx(i),i= 1201, 1300)/
     +  28200,27816,27672,27216,27144,27024,26952,26784,26616,26256,
     1  26136,26112,26016,25800,25584,25512,25272,25152,25080,25056,
     2  24936,24792,24936,24840,24744,24576,24552,24624,24552,17400,
     3  17232,17184,17256,17064,16608,16560,16416,16272,16056,29616,
     4  25992,27360,27888,27888,28056,28056,28200,28224,30792,30768,
     5  30624,30600,30384,30024,29904,29784,29712,31896,31800,31536,
     6  31512,31272,31128,30984,16656,16776,19464,19368,19200,29400,
     7  29400,29352,29400,29304,29352,29280,29328,29160,29040,28872,
     8  28824,28704,28632,28512,28416,28296,28248,28200,28344,28248,
     9  28248,28032,27912,27888,27816,27792,27624,27456,27408,27432/
            data (jx(i),i= 1301, 1400)/
     +  27192,27168,27024,26904,26832,26712,26448,26328,26256,26040,
     1  25776,25464,25368,25296,25176,25080,24864,24840,24600,24456,
     2  24432,24120,24048,24120,23856,23736,23712,17784,17496,17376,
     3  16920,20592,20328,20304,20184,19992,19824,19776,19728,19584,
     4  19584,19824,19776,19824,19632,19560,19608,19512,16704,16608,
     5  16560,16416,16272,16200,16296,16224,16248,16344,16392,15600,
     6  15936,15936,16368,25848,25440,25440,25008,25008,33696,33696,
     7  33600,33744,33696,33744,33480,33408,33192,32976,32736,32712,
     8  32424,32304,32280,32352,32256,32160,32040,31848,31920,31824,
     9  31872,31920,31968,21864,21768,21816,21720,21768,24024,24480/
            data (jx(i),i= 1401, 1500)/
     +  24696,24912,25752,20616,20472,20544,20496,20592,20592,20664,
     1  20520,20640,18912,18864,18720,18600,18552,18384,18408,18288,
     2  18312,18168,17928,17784,17088,16824,16632,18600,18696,19680,
     3  19560,19464,19344,19008,18984,17928,18024,18120,18336,18336,
     4  18432,18552,21936,20952,20736,20544,20520,28080,28584,29352,
     5  29376,30840,30864,32832,32832,22920,22896,22992,23328,23352,
     6  35280,35256,35304,35280,35352,35424,35424,35256,35328,35184,
     7  35112,35040,35016,35088,34872,34824,34800,34848,34896,34896,
     8  34800,34632,34704,34728,34632,34392,34368,34224,34272,34200,
     9  34032,34104,33840,33888,33792,33720,33816,33840,22632,22584/
            data (jx(i),i= 1501, 1600)/
     +  22800,22776,22728,22536,22056,21936,21816,21648,21504,21480,
     1  21312,21312,21240,21240,20496,20400,20376,20040,20112,19968,
     2  20016,19944,19848,19680,19632,19368,19296,19464,19344,19200,
     3  18720,24528,25440,25440,25512,26256,26304,27216,27264,27456,
     4  27624,27672,24336,24096,24000,23784,23640,23568,23568,23304,
     5  23256,23064,22944,22944,23016,23136,22920,24984,24960,24840,
     6  24792,24864,24864,24720,25080,28152,28272,28512,28536,28296,
     7  28296,37032,43392,45912,45936,35712,35688,36840,37008,37032,
     8  37128,37128,36960,36960,37032,25056,25560,25536,25704,25704,
     9  25776,25776,25848,25848,25944,25920,26472,26472,26808,26784/
            data (jx(i),i= 1601, 1700)/
     +  27456,27456,27984,27936,28272,28272,28344,28320,22824,22968,
     1  23088,23496,23760,24072,24384,24456,24432,24264,24648,24840,
     2  24960,25008,25200,25488,25560,25896,26208,26352,26448,26640,
     3  27048,27408,27528,27744,28032,28464,28752,28752,29256,29232,
     4  29400,29400,30672,30672,31104,28392,28344,28392,31056,36264,
     5  36168,36264,36336,36336,36504,36936,36840,32232,32232,32064,
     6  32064,31488,30744,36792,36792,36888,36888,37104,37104,37344,
     7  37344,38208,38208,38928,38928,40344,40344,48072,48048,36768,
     8  36840,37224,37440,37440,37752,38040,37608,37560,37560,35352,
     9  35328,35232,34944,34920,34776,34800,34680,44424,38856,38856/
            data (jx(i),i= 1701, 1800)/
     +  38232,38256,37224,37416,37560,44352,44448,32712,32784,33048,
     1  33096,33264,33480,32760,32472,32448,32400,32256,32256,32352,
     2  32568,27864,28080,28248,28320,28152,27792,27672,27576,27672,
     3  32880,32832,32928,32856,32760,32808,32496,32304,32616,32808,
     4  32904,33096,33432,33408,33720,33672,33312,33000,30216,30120,
     5  30096,30288,30360,26880,26592,26376,26088,25992,25944,26184,
     6  26136,26184,26520,27024,27336,27840,28056,28008,27792,27576,
     7  27432,27216,27120,28296,28584,28776,28848,28776,28584,28416,
     8  28296,24216,24360,24264,23928,23736,23496,23448,23472,23688,
     9  23784,23928,24048,24192,24480,24600,24744,25080,25440,25680/
            data (jx(i),i= 1801, 1820)/
     +  25848,25920,25848,25536,25560,25488,25224,25008,24816,24528,
     1  24408,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  61776,61200,58848,56208,50400,47808,46224,45528,44040,43200,
     1  43296,41928,40296,37440,36792,34680,33288,31728,25560,25200,
     2  20688,17088,15144,15432,13248,15072,14856,14976,15048,15072,
     3  15048,14688,13944,13728,13560,13368,13344,13128,13248,11304,
     4  11688, 6864,59352,59496,59664,60096,60384,60504,60576,60768,
     5  61008,61440,62016,61704,60912,50544,50640,50856,51072,51264,
     6  51456,52056,52392,52776,53088,53520,54456,55392,55872,56400,
     7  56520,56544,57000,57072,57504,58344,50160,44184,44352,44376,
     8  44544,44880,45360,45408,45504,45744,45912,46224,46344,46368,
     9  46440,46632,47088,47160,47784,48072,48408,48576,48792,49392/
            data (jy(i),i=  101,  200)/
     +  49608,49896,49992,43704,43440,43512,43680,43824,40440,40368,
     1  40512,40776,41256,41616,41904,41976,42072,42216,42264,42792,
     2  43032,40080,39960,40008,39480,38880,38592,38544,38664,38784,
     3  38688,38448,38256,38112,37968,37920,37992,37944,37824,37656,
     4  33384,33480,33576,33696,33744,33864,34128,34752,35184,35496,
     5  35616,35592,35808,36144,36240,32184,32448,32472,32352,32424,
     6  32328,32400,32808,31464,31488,31440,30552,30288,30528,30192,
     7  30024,29880,29856,29760,29040,28896,28776,28608,28440,28224,
     8  28152,27936,27600,26904,26760,26088,20664,19944,19728,19344,
     9  19056,18720,18456,18360,18240,18000,17592,17544,17568,17088/
            data (jy(i),i=  201,  300)/
     +  17016,16752,16512,16488,16080,15960,15768,15744,15672,15600,
     1  21264,21672,21888,21888,21792,21816,22080,22296,22968,23016,
     2  23160,23400,23472,23472,23544,23568,24096,24576,24792,24960,
     3  25080,25416,20304,20280,20160,20040,19464,19152,18432,18288,
     4  18288,18096,17664,17616,17760,17736,17664,17640,17496,17472,
     5  17328,17304,17376,17376,17232,17352,17352,17304,17064,16752,
     6  16752,16560,16464,15744,15792,15744,15456,15456,15096,15024,
     7  14952,14736,14712,14544,14424,14376,14208,14112,13944,13872,
     8  13584,13440,13248,13080,13008,12960,12720,12600,12408,12024,
     9  11568,11592,11496,11208,10920,10824,10776,10680,10584,10440/
            data (jy(i),i=  301,  400)/
     +  10080, 9696, 9672, 9384, 9384, 9456, 9360, 9408, 9384, 9288,
     1   9048, 9024, 8808, 8664, 8328, 8040, 7800, 7776, 7752, 7680,
     2   7632, 7704, 7560,11640,11712,11712,12168,12456,12552,12936,
     3  13248,10896,10296, 9768, 9120, 8472, 8256, 8112, 7824, 7464,
     4   7152, 7248, 7272, 7152, 6840, 6360,58272,58320,58440,58488,
     5  58656,58776,59112,59160,59448,59472,59664,59688,59904,60000,
     6  60168,60288,60528,60600,60816,60840,61128,61080,61200,61224,
     7  61488,61656,56472,60072,58296,58728,56976,57312,57408,57528,
     8  57600,57744,57840,58056,58200,56736,56880,57312,57432,57504,
     9  57648,57648,57744,57792,57576,57576,57384,57288,57144,57096/
            data (jy(i),i=  401,  500)/
     +  56928,56952,56928,56952,56808,56832,56664,56424,56304,56184,
     1  55944,55776,55752,55872,55848,56088,56184,56280,56328,56712,
     2  56736,56856,56808,56424,52176,50256,54480,54624,55104,55608,
     3  55584,55704,55584,55488,55608,55632,55752,55992,56088,56304,
     4  56352,56472,56472,56880,51792,52056,52080,52344,52464,52512,
     5  52608,52608,52824,52872,52968,52992,53160,53208,53328,53304,
     6  53592,53640,53712,53952,54000,54264,54480,54720,55128,55224,
     7  55536,55752,55992,56088,56184,56232,56568,52224,52248,52176,
     8  52272,52320,52200,52296,52224,52152,52056,52128,52056,52128,
     9  52104,52248,51888,52032,52080,52152,52032,52080,51864,51912/
            data (jy(i),i=  501,  600)/
     +  52128,51048,51048,50904,50760,50640,50688,50928,50928,51120,
     1  51144,51336,51336,51216,51288,51144,51120,51000,51000,50952,
     2  50904,50808,50808,50640,50640,50472,50424,50304,50256,50184,
     3  50184,50112,50040,49920,49896,49488,49488,49248,49104,49056,
     4  49056,48888,48888,48072,47904,47904,47736,50520,50760,50736,
     5  50856,51048,51144,51336,51408,51576,51672,51912,52080,49920,
     6  50040,50352,50496,50568,50904,50952,51168,51480,51624,51648,
     7  48696,48792,48840,48960,49200,49152,49248,49392,49632,49608,
     8  49920,49992,50232,50256,50376,50400,50112,47328,47328,47424,
     9  47448,47616,47640,47784,47808,47880,47880,48024,48024,48120/
            data (jy(i),i=  601,  700)/
     +  48120,48192,48216,48288,48288,48360,48456,48624,48648,48816,
     1  48912,49080,49080,49176,49152,49728,49824,49944,49944,50136,
     2  50136,50256,50304,50520,48936,49176,49512,49560,49656,49752,
     3  47736,47808,47544,47712,48144,48288,48096,48120,47928,47952,
     4  47664,47712,47808,47688,48384,48384,48600,48600,46152,46800,
     5  46848,46968,47112,45696,45840,45744,45768,45816,45792,45888,
     6  45912,46056,46296,46392,46560,46608,46872,46824,46896,46896,
     7  46848,47040,47112,47208,47208,46440,47640,43464,43608,43680,
     8  43728,43752,43872,44016,44304,44304,44376,44472,44712,44760,
     9  45360,45336,45672,45672,45912,45912,46176,46272,46680,46680/
            data (jy(i),i=  701,  800)/
     +  47232,47256,47304,47280,47352,47328,46272,46296,46464,46512,
     1  46296,46272,46248,46368,46512,46704,46824,46800,46728,46560,
     2  46464,46344,43752,44040,44256,44304,44496,44544,44664,44928,
     3  45024,45216,45312,45432,45408,45552,45504,45720,45888,46056,
     4  46320,46488,48696,48552,48336,48360,48072,48048,47976,47928,
     5  47832,47784,47616,47424,47376,47208,47136,47160,47016,46656,
     6  45840,46080,46104,46032,45768,45816,45768,45552,45456,45288,
     7  45312,45192,44136,45768,43632,43872,44016,44088,44424,44472,
     8  44760,44856,44928,45120,45240,45504,45624,45528,45240,45192,
     9  45120,45072,44904,44856,44832,44496,44184,43944,43920,44088/
            data (jy(i),i=  801,  900)/
     +  43992,43992,44064,44040,42240,42672,42768,42792,42912,43008,
     1  43224,43248,43296,43368,43512,43488,43656,43560,43680,43680,
     2  43776,43848,43872,43728,43752,43584,43440,43296,43416,43584,
     3  43944,43872,43944,44208,43968,43368,43608,43752,45528,45504,
     4  45408,45336,45336,45168,45096,44592,44544,44328,44064,44016,
     5  43968,43536,43824,43944,43344,43152,43056,43008,42864,42504,
     6  42360,41304,41832,41928,41904,42096,42192,42360,42360,43200,
     7  43248,43200,43536,43464,43464,43296,43368,43200,43248,43152,
     8  42552,42576,43128,43512,43368,43272,43224,43296,43224,42912,
     9  42840,42696,42624,42552,42624,42672,42648,42720,42696,42768/
            data (jy(i),i=  901, 1000)/
     +  42672,42480,42432,42552,42528,43536,43536,42000,42456,42864,
     1  42912,43128,41040,42264,42192,39840,39936,40008,40152,40272,
     2  40392,40656,41256,41400,41688,40896,40056,40248,40272,40512,
     3  40728,40776,40896,40992,41136,41208,41232,41280,41352,41472,
     4  41640,41712,41688,41976,41952,42192,41112,41088,41160,41064,
     5  41160,41112,41232,41160,41304,41328,41256,41208,41040,40944,
     6  40968,41160,41160,41400,41592,41616,41856,41928,42024,39336,
     7  39312,39456,39672,39864,39888,39936,39960,40224,40224,40416,
     8  40824,40464,40560,40536,40872,40800,40800,40680,40656,40728,
     9  40632,40608,39384,39336,39408,39384,39720,39744,39840,40008/
            data (jy(i),i= 1001, 1100)/
     +  40320,40464,40584,39984,40320,40344,40272,40176,40032,40056,
     1  41256,41376,41304,41424,41400,41160,41304,39840,36360,36648,
     2  36792,36912,36960,37128,37296,37320,37392,37512,37656,37728,
     3  37680,37776,37536,37632,37896,38040,38352,38400,38568,38664,
     4  38808,38952,39048,39168,39192,39360,39456,39408,39144,39000,
     5  38640,38760,38904,39024,39192,39216,39312,39384,39504,39672,
     6  39744,42096,41976,41808,41640,41496,41496,41184,41088,41016,
     7  40896,40584,40512,40368,40176,40008,39984,39864,39816,39528,
     8  39480,39360,39384,38040,38088,38520,38616,38688,38880,39000,
     9  40104,40200,40272,38832,40392,40416,39696,39528,39576,39408/
            data (jy(i),i= 1101, 1200)/
     +  39312,39096,39792,39864,39816,39600,39576,39648,39552,39504,
     1  39528,39576,39672,39696,39528,39408,39360,39120,38952,38904,
     2  38832,38808,39408,39336,39144,38784,38784,38640,38712,38688,
     3  38616,38592,38736,38568,38712,38544,38856,38784,38808,38544,
     4  38400,38448,38040,38328,37896,37824,37776,37104,37560,37728,
     5  37752,35256,36240,36240,36384,36432,36360,36480,36432,36528,
     6  36576,36672,36624,36696,36624,36648,36720,36696,36744,36624,
     7  36648,37608,37512,37464,37488,37200,37344,37416,37440,37800,
     8  38160,38280,38304,38352,38472,38496,38712,36744,37368,36600,
     9  36912,36888,37056,37032,37080,37104,37032,37296,37296,37248/
            data (jy(i),i= 1201, 1300)/
     +  37080,36888,36696,36504,36576,36528,36600,36528,36552,36840,
     1  36864,36936,36960,36696,36792,36624,36624,36456,36504,36432,
     2  36456,36408,36000,35976,36120,36168,36120,36000,35904,36720,
     3  36816,36936,37008,37176,37248,37320,37344,37680,37872,36360,
     4  33264,34560,34536,34800,34776,34968,34968,35376,35424,35640,
     5  35808,36000,36240,36312,36216,36312,36264,34752,34848,34776,
     6  34944,35208,35304,35256,35496,35352,35496,35496,35592,34104,
     7  34056,34032,33984,33864,33576,33408,33336,33120,33000,33096,
     8  32976,32976,32784,33024,32904,33000,32976,32856,32736,32664,
     9  32568,32568,32304,32424,32424,32208,32208,32064,31992,31872/
            data (jy(i),i= 1301, 1400)/
     +  31608,31488,31320,31392,31344,31392,31272,31248,31296,31176,
     1  31224,31080,31104,30960,31056,30936,30960,30912,31080,31056,
     2  31224,31488,31680,31776,32352,32424,32568,35352,35184,35280,
     3  35256,33216,33480,33408,33408,33504,33312,33384,33696,33912,
     4  34104,34272,34512,34680,34752,34896,35064,35184,35280,35328,
     5  35232,35256,35136,34728,34512,34488,34416,34416,34296,33768,
     6  33744,33912,33864,33480,33744,33912,34680,34872,30600,30864,
     7  31056,31152,31320,31368,31944,32352,32472,32664,32736,32808,
     8  32856,33264,33432,33576,33768,33912,33864,34008,34152,34344,
     9  34488,34488,34560,34344,34488,34536,34608,34680,32832,33000/
            data (jy(i),i= 1401, 1500)/
     +  33000,33144,33192,32208,32328,32424,32592,32640,32712,32784,
     1  32928,33120,31920,32088,32160,32136,32304,32376,32448,32520,
     2  32592,32832,32928,33096,33432,33816,33936,31920,32016,32232,
     3  32400,32352,32400,32016,31896,31896,31896,31992,32064,32016,
     4  31992,32040,30864,31440,31896,31968,32040,29208,29688,29664,
     5  30168,30096,30624,30552,30600,28104,28248,28344,28440,29376,
     6  25056,25176,25272,25464,25560,25560,25896,26016,26160,26352,
     7  26760,26832,27072,27264,27504,27720,27936,28104,28152,28248,
     8  28272,28536,28584,28680,28752,28752,28872,29016,29256,29400,
     9  29520,29736,30024,30120,30144,30240,30288,30384,28368,28368/
            data (jy(i),i= 1501, 1600)/
     +  27888,27768,27720,27744,28296,28296,28416,28224,28320,28224,
     1  28152,28224,28224,28512,29400,29400,29568,29592,29736,29904,
     2  30216,30384,30480,30480,30600,30672,30840,30888,31104,31128,
     3  31632,25992,26784,26856,26856,27504,28752,28728,28848,28896,
     4  28896,28824,26328,26400,26352,26592,26712,26688,26736,26928,
     5  27144,27168,27360,27528,27552,27744,27984,25296,25464,25488,
     6  25632,25752,25800,25968,25296,25200,27936,27936,28680,28704,
     7  29184,25104,25080,25128,25200,25056,25128,19512,19536,24264,
     8  24264,24432,24432,24600,24600,24312,24288,23784,23688,23592,
     9  23592,23520,23520,23424,23448,23256,23232,22728,22728,22224/
            data (jy(i),i= 1601, 1700)/
     +  22200,21696,21720,21192,21192,21120,21120,20112,20640,20688,
     1  20640,20784,20760,20544,20256,20352,20496,20856,20928,20904,
     2  20976,21120,21312,21408,21288,21120,21048,20928,20952,20760,
     3  20568,20544,20424,20352,20088,20088,20088,19968,19968,19848,
     4  19824,19584,19536,19416,19392,17256,17400,17424,19560,14496,
     5  14664,14832,14832,14928,14928,16464,18000,16464,16248,16224,
     6  15816,15840,15312,14064,14160,14160,14376,14376,14640,14736,
     7  15000,14976,14904,14904,14808,14832,15000,15072,15336,13992,
     8  13992,13464,13416,13152,13104,12840,12216,12216,11952,14496,
     9  14256,14136,13944,13776,13584,13440,13344,11520,11544,11616/
            data (jy(i),i= 1701, 1800)/
     +  11880,11952,11664,11664,11760, 9504, 9504, 8352, 8208, 8040,
     1   7944, 8088, 8064, 8736, 9144, 9264, 9312, 9288, 9192, 9144,
     2   8568,10512,10440,10440,10512,10680,10848,10776,10824,10608,
     3  11088,11184,11304,11496,11568,11616,11592,11856,11856,11640,
     4  11664,11544,11448,11376,10944,10848,10944,10944,11760,11808,
     5  11952,12048,11880,15384,15384,15504,15528,15480,15312,15144,
     6  15024,14856,14664,14664,14808,14880,15120,15240,15360,15312,
     7  15144,15168,15288,14976,14880,14928,15024,15120,15072,15120,
     8  15072,15384,15216,15096,15072,15168,15168,15240,15360,15480,
     9  15456,15600,15504,15504,14976,14856,14544,14352,14448,14592/
            data (jy(i),i= 1801, 1820)/
     +  14592,14664,14952,15048,15240,15312,15216,15264,15168,15192,
     1  15096,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +     23,   26,   27,   28,   29,   30,   31,   32,   33,   34,
     1     35,   36,   37,   38,   25,    3,   43,   44,   45,   46,
     2     47,   48,   49,   50,   51,   52,    1,    1,    2,    2,
     3      4,    5,   56,   57,   58,   59,   60,   61,   62,   63,
     4     64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
     5     74,   75,    3,    4,    5,    6,    7,    8,   78,   79,
     6     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     7     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     8    100,  101,  102,   77,    9,   11,   10,  105,  106,  107,
     9     78,   11,   12,   13,  109,  110,  111,  112,  113,  114/
            data (jb1(i),i=  101,  200)/
     +    115,  116,  117,  118,  119,  120,   10,   13,  122,  123,
     1    124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
     2    134,  135,  136,  137,  138,  139,   14,   14,   16,   17,
     3    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     4    151,  152,  153,  154,   15,   18,  156,  157,  158,  159,
     5    160,  161,  162,   17,   18,  164,  165,  166,  167,  168,
     6    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     7    179,  180,  181,  182,  183,  184,  185,   19,   20,  187,
     8    188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
     9    198,  199,  200,  201,  202,  203,  204,  205,  206,  207/
            data (jb1(i),i=  201,  300)/
     +    208,  209,   24,   21,  211,  212,  213,  214,  215,  216,
     1    217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
     2    227,  228,  229,  230,  231,   19,   21,  233,  234,  235,
     3    236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
     4    246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
     5    256,  257,   22,   22,  259,  260,  261,  262,  263,  264,
     6    265,  266,  267,   23,   24,  269,  270,  271,  272,  273,
     7    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     8    284,  285,  286,  287,  288,  289,   41,   41,  291,  292,
     9    293,  294,  295,  296,  297,  298,  299,  300,  301,  302/
            data (jb1(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
     1    313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
     2     42,   40,  324,  325,  326,  327,  328,  329,  330,   25,
     3     40,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,   42,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     7    371,  372,  373,  374,  347,  375,  376,  377,  378,  379,
     8    380,  381,  382,  383,  384,  347,  386,  387,  388,  389,
     9    390,  391,  392,  393,  394,  395,  396,  397,  398,  399/
            data (jb1(i),i=  401,  500)/
     +    400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
     1    410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
     2    420,  421,  422,  377,  373,  373,  424,  424,  426,  427,
     3    428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
     4    438,  439,  440,  441,  442,  443,  377,  445,  446,  447,
     5    448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
     6    458,  459,  460,  461,  462,  463,  464,  465,  466,  467,
     7    468,  469,  470,  471,  472,  473,  474,  475,  476,  386,
     8    478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
     9    488,  489,  490,  491,  492,  493,  494,  495,  496,  497/
            data (jb1(i),i=  501,  600)/
     +    498,  499,  445,  425,  425,  501,  502,  503,  504,  505,
     1    506,  507,  508,  509,  510,  511,  512,  513,  514,  515,
     2    516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
     3    526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
     4    536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
     5    546,  548,  549,  550,  551,  552,  553,  554,  555,  556,
     6    557,  558,  478,  560,  561,  562,  563,  564,  565,  566,
     7    567,  568,  569,  445,  426,  571,  572,  573,  574,  575,
     8    576,  577,  578,  579,  580,  581,  582,  583,  584,  585,
     9    548,  560,  426,  588,  589,  590,  591,  592,  593,  594/
            data (jb1(i),i=  601,  700)/
     +    595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
     1    605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
     2    615,  616,  617,  618,  619,  620,  621,  622,  623,  548,
     3    625,  626,  627,  628,  629,  560,  571,  547,  631,  632,
     4    633,  634,  635,  636,  637,  638,  639,  640,  641,  642,
     5    547,  644,  645,  646,  647,  625,  588,  649,  650,  651,
     6    652,  633,  654,  655,  656,  657,  658,  659,  660,  661,
     7    662,  663,  664,  665,  666,  667,  668,  669,  670,  671,
     8    672,  673,  674,  588,  676,  644,  678,  679,  680,  681,
     9    682,  683,  684,  685,  686,  687,  688,  689,  690,  691/
            data (jb1(i),i=  701,  800)/
     +    692,  693,  694,  695,  696,  697,  698,  699,  700,  701,
     1    702,  703,  704,  705,  644,  707,  708,  709,  710,  676,
     2    649,  712,  713,  714,  715,  716,  717,  718,  719,  720,
     3    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     4    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     5    741,  676,  571,  743,  744,  745,  746,  747,  748,  749,
     6    750,  751,  752,  753,  754,  755,  756,  757,  758,  759,
     7    707,  707,  649,  762,  763,  764,  765,  766,  767,  768,
     8    769,  770,  771,  772,  654,  761,  775,  776,  777,  778,
     9    779,  780,  781,  782,  783,  784,  785,  761,    8,  787/
            data (jb1(i),i=  801,  900)/
     +    788,  789,  790,  791,  792,  793,  794,  795,  796,  797,
     1    798,  799,  800,  801,  773,  803,  803,  805,  806,  807,
     2    808,  809,  810,  811,  812,  813,  814,  815,  816,  817,
     3    818,  819,  820,  821,  822,  823,  824,  825,  826,  827,
     4    828,  829,  830,  831,  832,  804,  773,  834,  836,  837,
     5    723,  723,  654,  839,  840,  841,  842,  843,  844,  845,
     6    846,  847,  848,  849,  850,  851,  852,  853,  835,  836,
     7    855,  856,  857,  858,  859,  860,  862,  863,  864,  865,
     8    866,  867,  868,  869,  870,  871,  836,  678,  873,  874,
     9    875,  876,  877,  878,  879,  880,  861,  881,  882,  678/
            data (jb1(i),i=  901, 1000)/
     +    775,  884,  885,  886,  887,  888,  889,  890,  891,  892,
     1    893,  894,  895,  896,  897,  898,  899,  900,  901,  903,
     2    904,  905,  906,  835,  902,  908,  909,  910,  911,  912,
     3    805,  913,  914,  805,  916,  917,  918,  919,  920,  921,
     4    922,  923,  924,  925,  908,  927,  928,  929,  930,  931,
     5    932,  933,  934,  935,  936,  937,  938,  939,  940,  941,
     6    942,  943,  944,  945,  902,  913,  947,  948,  949,  950,
     7    951,  952,  953,  954,  955,  956,  957,  958,  959,  960,
     8    961,  962,  963,  964,  965,  966,  967,  968,  908,  970,
     9    971,  972,  973,  974,  975,  976,  977,  978,  979,  980/
            data (jb1(i),i= 1001, 1100)/
     +    862,  982,  983,  926,  926,  985,  986,  987,  988,  989,
     1    990,  991,  993,  994,  995,  996,  997,  998,  999, 1000,
     2   1001, 1002,  992,  916, 1004, 1005, 1006, 1007, 1008,  982,
     3    927, 1010, 1011, 1012, 1013, 1014, 1015, 1016,  862,  913,
     4   1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028,
     5   1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038,
     6   1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048,
     7   1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058,
     8   1059, 1060,  916,  861, 1062, 1063, 1064, 1065, 1066, 1067,
     9   1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077/
            data (jb1(i),i= 1101, 1200)/
     +   1078, 1079, 1080, 1081, 1082,  970, 1084, 1085, 1086, 1087,
     1   1088, 1089, 1090, 1091, 1092,  982,  993,  970,   13, 1095,
     2   1096, 1097, 1098, 1099, 1100, 1101, 1094, 1018, 1103, 1104,
     3   1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114,
     4   1115, 1116, 1117, 1118, 1119, 1120, 1121,  927, 1123, 1124,
     5   1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134,
     6   1094,  993, 1122, 1137, 1138, 1139, 1140, 1141, 1130, 1143,
     7   1094, 1084, 1145, 1143, 1148, 1149, 1150, 1146, 1152, 1153,
     8   1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163,
     9   1164, 1165, 1166, 1167, 1168, 1169, 1170, 1136, 1143, 1172/
            data (jb1(i),i= 1201, 1300)/
     +   1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182,
     1   1183, 1184, 1185, 1186, 1122, 1188, 1147, 1136, 1190, 1191,
     2   1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201,
     3   1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211,
     4   1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221,
     5   1222, 1223, 1224, 1225, 1226, 1227, 1228, 1176, 1230, 1231,
     6   1232, 1233, 1234, 1235, 1236, 1237, 1238, 1147, 1188, 1019,
     7   1190, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1190, 1249,
     8   1250, 1251, 1252, 1253, 1254, 1255, 1256, 1019, 1148, 1258,
     9   1259, 1260, 1261, 1262, 1263, 1249, 1188, 1265, 1152, 1267/
            data (jb1(i),i= 1301, 1400)/
     +   1268, 1176, 1249, 1270, 1271, 1272, 1273, 1274, 1275, 1276,
     1   1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286,
     2   1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296,
     3   1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306,
     4   1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315, 1316,
     5   1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326,
     6   1152, 1328, 1329, 1330, 1266, 1332, 1333, 1334, 1335, 1336,
     7   1337, 1338, 1339, 1340, 1341, 1342, 1343, 1344, 1345, 1346,
     8   1347, 1152, 1258, 1266, 1349, 1350, 1351, 1352, 1353, 1354,
     9   1355, 1356, 1357, 1358,   17, 1360, 1361, 1362, 1359, 1241/
            data (jb1(i),i= 1401, 1500)/
     +   1364, 1365, 1366, 1367, 1229, 1369, 1370, 1371, 1372, 1373,
     1   1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383,
     2   1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391, 1392, 1258,
     3   1332, 1394, 1395, 1396, 1397, 1229, 1327, 1399, 1400, 1401,
     4   1402, 1241, 1404, 1405, 1406, 1407, 1408, 1409, 1410, 1411,
     5   1332, 1413, 1414, 1415, 1416, 1417, 1418, 1419, 1420, 1421,
     6   1422, 1423, 1424, 1425, 1426, 1359, 1428, 1413, 1404, 1430,
     7   1431, 1432, 1433, 1434, 1413,   18, 1436, 1437, 1438, 1439,
     8   1440, 1441, 1428, 1327, 1443, 1444, 1445, 1446, 1404, 1448,
     9   1449, 1450, 1451, 1452, 1453, 1454, 1369, 1456, 1457, 1458/
            data (jb1(i),i= 1501, 1600)/
     +   1459, 1443, 1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468,
     1   1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478,
     2   1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488,
     3   1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1369,
     4   1456, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507,
     5   1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517,
     6   1518, 1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527,
     7   1528, 1529, 1530, 1428, 1532, 1533, 1534, 1535, 1536, 1537,
     8   1538, 1539, 1540, 1541, 1448, 1532, 1543, 1544, 1545, 1546,
     9   1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556/
            data (jb1(i),i= 1601, 1700)/
     +   1456,   19, 1558, 1559, 1560, 1561, 1562, 1563, 1532, 1558,
     1   1565, 1566, 1567, 1568, 1569, 1570, 1448, 1572, 1573, 1574,
     2   1575, 1461, 1576, 1572, 1461, 1578, 1579, 1580, 1581, 1582,
     3   1583, 1584, 1572, 1565, 1586, 1587, 1588, 1589, 1590, 1591,
     4   1592, 1593, 1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601,
     5   1602, 1603, 1604, 1605, 1606, 1607,   21, 1609, 1610, 1611,
     6   1612, 1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621,
     7   1622, 1623, 1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631,
     8   1632, 1633, 1634, 1608, 1636, 1637, 1638, 1639, 1640, 1641,
     9   1642, 1643, 1644, 1608,   22, 1646, 1647, 1636, 1645, 1578/
            data (jb1(i),i= 1701, 1800)/
     +   1650, 1651, 1652, 1653, 1654, 1655, 1656, 1578, 1645, 1658,
     1   1659, 1660, 1661, 1662, 1663, 1664, 1665, 1666, 1667, 1668,
     2   1669, 1670, 1671, 1672, 1673, 1674, 1675, 1676, 1677, 1678,
     3   1679, 1650, 1664, 1680, 1681, 1682, 1683, 1684, 1685, 1686,
     4   1687, 1688, 1650, 1690, 1691, 1692, 1693, 1694, 1695, 1696,
     5   1697, 1698, 1699, 1700, 1701, 1689,   40, 1703, 1704, 1689,
     6   1698,   42, 1706, 1698,    1,    2,    3,    4,    5,    6,
     7      7,    8,    9,   10,   11,   12,   13,    1,   15,   16,
     8     17,   18,   19,   20,   21,   22,   15,   24,   25,   26,
     9     27,   28,   29,   30,   31,   32,   33,   34,   35,   36/
            data (jb1(i),i= 1801, 1870)/
     +     37,   38,   39,   40,   24,   42,   43,   44,   45,   42,
     1     47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
     2     57,   58,   59,   60,   61,   62,   63,   64,   65,   47,
     3     67,   68,   69,   70,   71,   72,   73,   67,   75,   76,
     4     77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
     5     75,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     6     97,   98,   99,  100,  101,  102,  103,   88,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     1     36,   37,   38,   39,   39,   43,   44,   45,   46,   47,
     2     48,   49,   50,   51,   52,   53,   53,   54,   54,   55,
     3     55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
     4     65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
     5     75,   76,   76,    6,   77,    7,    8,    9,   79,   80,
     6     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     7     91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
     8    101,  102,  103,  103,  104,  104,  105,  106,  107,  108,
     9    108,   12,   16,  109,  110,  111,  112,  113,  114,  115/
            data (jb2(i),i=  101,  200)/
     +    116,  117,  118,  119,  120,  121,  121,  122,  123,  124,
     1    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     2    135,  136,  137,  138,  139,  140,  140,   15,   20,  141,
     3    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     4    152,  153,  154,  155,  155,  156,  157,  158,  159,  160,
     5    161,  162,  163,  163,  164,  165,  166,  167,  168,  169,
     6    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     7    180,  181,  182,  183,  184,  185,  186,  186,  187,  188,
     8    189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
     9    199,  200,  201,  202,  203,  204,  205,  206,  207,  208/
            data (jb2(i),i=  201,  300)/
     +    209,  210,  210,  211,  212,  213,  214,  215,  216,  217,
     1    218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
     2    228,  229,  230,  231,  232,  232,  233,  234,  235,  236,
     3    237,  238,  239,  240,  241,  242,  243,  244,  245,  246,
     4    247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
     5    257,  258,  258,  259,  260,  261,  262,  263,  264,  265,
     6    266,  267,  268,  268,  269,  270,  271,  272,  273,  274,
     7    275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
     8    285,  286,  287,  288,  289,  290,  290,  291,  292,  293,
     9    294,  295,  296,  297,  298,  299,  300,  301,  302,  303/
            data (jb2(i),i=  301,  400)/
     +    304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
     1    314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
     2    323,  324,  325,  326,  327,  328,  329,  330,  331,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4    342,  343,  344,  345,  346,  346,  348,  349,  350,  351,
     5    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     6    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     7    372,    1,  374,    2,  375,  376,    3,  378,  379,  380,
     8    381,  382,  383,  384,  385,  385,  387,  388,  389,  390,
     9    391,  392,  393,  394,  395,  396,  397,  398,  399,  400/
            data (jb2(i),i=  401,  500)/
     +    401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
     1    411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
     2    421,  422,  423,  423,  386,  424,    4,  425,  427,  428,
     3    429,  430,  431,  432,  433,  434,  435,  436,  437,  438,
     4    439,  440,  441,  442,  443,  444,  444,  446,  447,  448,
     5    449,  450,  451,  452,  453,  454,  455,  456,  457,  458,
     6    459,  460,  461,  462,  463,  464,  465,  466,  467,  468,
     7    469,  470,  471,  472,  473,  474,  475,  476,  477,  477,
     8    479,  480,  481,  482,  483,  484,  485,  486,  487,  488,
     9    489,  490,  491,  492,  493,  494,  495,  496,  497,  498/
            data (jb2(i),i=  501,  600)/
     +    499,  500,  500,  478,  501,  502,  503,  504,  505,  506,
     1    507,  508,  509,  510,  511,  512,  513,  514,  515,  516,
     2    517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     3    527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     4    537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
     5    547,  549,  550,  551,  552,  553,  554,  555,  556,  557,
     6    558,  559,  559,  561,  562,  563,  564,  565,  566,  567,
     7    568,  569,  570,  570,    5,  572,  573,  574,  575,  576,
     8    577,  578,  579,  580,  581,  582,  583,  584,  585,  586,
     9    586,  587,  587,  589,  590,  591,  592,  593,  594,  595/
            data (jb2(i),i=  601,  700)/
     +    596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
     1    606,  607,  608,  609,  610,  611,  612,  613,  614,  615,
     2    616,  617,  618,  619,  620,  621,  622,  623,  624,  624,
     3    626,  627,  628,  629,  630,  630,  625,  631,  632,    6,
     4    634,  635,  636,  637,  638,  639,  640,  641,  642,  643,
     5    643,  645,  646,  647,  648,  648,  633,  650,  651,  652,
     6    653,  653,  655,  656,  657,  658,  659,  660,  661,  662,
     7    663,  664,  665,  666,  667,  668,  669,  670,  671,  672,
     8    673,  674,  675,  675,  677,  677,  679,  680,  681,  682,
     9    683,  684,  685,  686,  687,  688,  689,  690,  691,  692/
            data (jb2(i),i=  701,  800)/
     +    693,  694,  695,  696,  697,  698,  699,  700,  701,  702,
     1    703,  704,  705,  706,  706,  708,  709,  710,  711,  711,
     2    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     3    722,    7,  724,  725,  726,  727,  728,  729,  730,  731,
     4    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     5    742,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     6    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     7    760,  761,  762,  763,  764,  765,  766,  767,  768,  769,
     8    770,  771,  772,  773,  774,  774,  776,  777,  778,  779,
     9    780,  781,  782,  783,  784,  785,  786,  786,  787,  788/
            data (jb2(i),i=  801,  900)/
     +    789,  790,  791,  792,  793,  794,  795,  796,  797,  798,
     1    799,  800,  801,  802,  802,    9,  804,  806,  807,  808,
     2    809,  810,  811,  812,  813,  814,  815,  816,  817,  818,
     3    819,  820,  821,  822,  823,  824,  825,  826,  827,  828,
     4    829,  830,  831,  832,  833,  833,  834,  835,  837,  838,
     5    838,  775,  839,  840,  841,  842,  843,  844,  845,  846,
     6    847,  848,  849,  850,  851,  852,  853,  854,  854,  855,
     7    856,  857,  858,  859,  860,  861,  863,  864,  865,  866,
     8    867,  868,  869,  870,  871,  872,  872,  873,  874,  875,
     9    876,  877,  878,  879,  880,   10,  881,  882,  883,  883/
            data (jb2(i),i=  901, 1000)/
     +    884,  885,  886,  887,  888,  889,  890,  891,  892,  893,
     1    894,  895,  896,  897,  898,  899,  900,  901,  902,  904,
     2    905,  906,  907,  907,  903,  909,  910,  911,  912,   11,
     3    903,  914,  915,  915,  917,  918,  919,  920,  921,  922,
     4    923,  924,  925,   12,  926,  928,  929,  930,  931,  932,
     5    933,  934,  935,  936,  937,  938,  939,  940,  941,  942,
     6    943,  944,  945,  946,  946,  947,  948,  949,  950,  951,
     7    952,  953,  954,  955,  956,  957,  958,  959,  960,  961,
     8    962,  963,  964,  965,  966,  967,  968,  969,  969,  971,
     9    972,  973,  974,  975,  976,  977,  978,  979,  980,  981/
            data (jb2(i),i= 1001, 1100)/
     +    981,  983,  984,  984,  985,  986,  987,  988,  989,  990,
     1    991,  992,  994,  995,  996,  997,  998,  999, 1000, 1001,
     2   1002, 1003, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1009,
     3   1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1017, 1018,
     4   1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029,
     5   1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039,
     6   1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049,
     7   1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059,
     8   1060, 1061, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068,
     9   1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078/
            data (jb2(i),i= 1101, 1200)/
     +   1079, 1080, 1081, 1082, 1083, 1083, 1085, 1086, 1087, 1088,
     1   1089, 1090, 1091, 1092, 1093, 1093, 1018, 1094, 1095, 1096,
     2   1097, 1098, 1099, 1100, 1101, 1102, 1102, 1103, 1104, 1105,
     3   1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115,
     4   1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125,
     5   1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135,
     6   1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142, 1142, 1144,
     7   1144, 1145, 1146, 1147, 1149, 1150, 1151, 1151, 1153, 1154,
     8   1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163, 1164,
     9   1165, 1166, 1167, 1168, 1169, 1170, 1171, 1171, 1172, 1173/
            data (jb2(i),i= 1201, 1300)/
     +   1174, 1175,   14, 1177, 1178, 1179, 1180, 1181, 1182, 1183,
     1   1184, 1185, 1186, 1187, 1187, 1189, 1189, 1148, 1191, 1192,
     2   1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202,
     3   1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212,
     4   1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222,
     5   1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232,
     6   1233, 1234, 1235, 1236, 1237, 1238, 1239, 1239,   15, 1240,
     7   1240, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1248, 1250,
     8   1251, 1252, 1253, 1254, 1255, 1256, 1257, 1257, 1229, 1259,
     9   1260, 1261, 1262, 1263, 1264, 1264, 1265, 1266, 1267, 1268/
            data (jb2(i),i= 1301, 1400)/
     +   1269, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277,
     1   1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287,
     2   1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296, 1297,
     3   1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306, 1307,
     4   1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315, 1316, 1317,
     5   1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327,
     6   1328, 1329, 1330, 1331, 1331, 1333, 1334, 1335, 1336, 1337,
     7   1338, 1339, 1340, 1341, 1342, 1343, 1344, 1345, 1346, 1347,
     8   1348, 1348,   16, 1349, 1350, 1351, 1352, 1353, 1354, 1355,
     9   1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1363, 1364/
            data (jb2(i),i= 1401, 1500)/
     +   1365, 1366, 1367, 1368, 1368, 1370, 1371, 1372, 1373, 1374,
     1   1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384,
     2   1385, 1386, 1387, 1388, 1389, 1390, 1391, 1392, 1393, 1393,
     3   1394, 1395, 1396, 1397, 1398, 1398, 1399, 1400, 1401, 1402,
     4   1403, 1403, 1405, 1406, 1407, 1408, 1409, 1410, 1411, 1412,
     5   1412, 1414, 1415, 1416, 1417, 1418, 1419, 1420, 1421, 1422,
     6   1423, 1424, 1425, 1426, 1427, 1427, 1429, 1429, 1430, 1431,
     7   1432, 1433, 1434, 1435, 1435, 1436, 1437, 1438, 1439, 1440,
     8   1441, 1442, 1442, 1443, 1444, 1445, 1446, 1447, 1447, 1449,
     9   1450, 1451, 1452, 1453, 1454, 1455, 1455, 1457, 1458, 1459/
            data (jb2(i),i= 1501, 1600)/
     +   1460, 1460, 1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469,
     1   1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478, 1479,
     2   1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488, 1489,
     3   1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1498,
     4   1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508,
     5   1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517, 1518,
     6   1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528,
     7   1529, 1530, 1531, 1531, 1533, 1534, 1535, 1536, 1537, 1538,
     8   1539, 1540, 1541, 1542, 1542, 1543, 1544, 1545, 1546, 1547,
     9   1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556, 1557/
            data (jb2(i),i= 1601, 1700)/
     +   1557, 1558, 1559, 1560, 1561, 1562, 1563, 1564, 1564, 1565,
     1   1566, 1567, 1568, 1569, 1570, 1571, 1571, 1573, 1574, 1575,
     2     20, 1576, 1577, 1577, 1566, 1579, 1580, 1581, 1582, 1583,
     3   1584, 1585, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592,
     4   1593, 1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601, 1602,
     5   1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612,
     6   1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622,
     7   1623, 1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631, 1632,
     8   1633, 1634, 1635, 1635, 1637, 1638, 1639, 1640, 1641, 1642,
     9   1643, 1644, 1645, 1636, 1646, 1647, 1648, 1648, 1649, 1649/
            data (jb2(i),i= 1701, 1800)/
     +   1651, 1652, 1653, 1654, 1655, 1656, 1657, 1657, 1658, 1659,
     1   1660, 1661, 1662, 1663,   23, 1665, 1666, 1667, 1668, 1669,
     2   1670, 1671, 1672, 1673, 1674, 1675, 1676, 1677, 1678, 1679,
     3     24, 1664, 1680, 1681, 1682, 1683, 1684, 1685, 1686, 1687,
     4   1688, 1689, 1690, 1691, 1692, 1693, 1694, 1695, 1696, 1697,
     5     25, 1699, 1700, 1701, 1702, 1702, 1703, 1704, 1705, 1705,
     6     41, 1706, 1707, 1707,    2,    3,    4,    5,    6,    7,
     7      8,    9,   10,   11,   12,   13,   14,   14,   16,   17,
     8     18,   19,   20,   21,   22,   23,   23,   25,   26,   27,
     9     28,   29,   30,   31,   32,   33,   34,   35,   36,   37/
            data (jb2(i),i= 1801, 1870)/
     +     38,   39,   40,   41,   41,   43,   44,   45,   46,   46,
     1     48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
     2     58,   59,   60,   61,   62,   63,   64,   65,   66,   66,
     3     68,   69,   70,   71,   72,   73,   74,   74,   76,   77,
     4     78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
     5     87,   89,   90,   91,   92,   93,   94,   95,   96,   97,
     6     98,   99,  100,  101,  102,  103,  104,  104,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine co(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(910) :: jx,jy
            integer(kind=iknd), save, dimension(970) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'colorado      '/
            data jrot,ipart/0,1/
            data kv/   1, 904,   0,   0,   0/
            data kb/   1, 966,   0,   0,   0/
            data iib/  35,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  19032,22032,26472,43824, 7224,34776, 7008, 6888, 6480, 6504,
     1   6360, 6216,23928,47808,10704,29352,33384,17016, 7560,12024,
     2  49944,54000,53928,54096,54360,54528,54648, 6408,54768,54936,
     3   6024,55128,21264,21216,39072,18048,18048,18120,18192,18600,
     4  18600,18984,22128,22008,22008,22128,22296,22416,22584,22680,
     5  22800,22848,23040,23136,23208,23208,23400,23352,23472,23520,
     6  23496,23328,23232,23280,23184,23136,23184,23040,23088,23256,
     7  23256,23328,23352,23280,23352,23352,28704,28656,28536,28320,
     8  28320,28224,28200,28080,28080,27912,27792,27792,27600,27360,
     9  27192,27048,26904,26880,26544,26544,43872,43848,43896,29016/
            data (jx(i),i=  101,  200)/
     +  28968,29184,29712,29856,30000,23400,23544,23664,23952,24144,
     1  24216,24456,24720,24912,25056,25104,25320,25464,25656,25728,
     2  25752,25944,26184,26448,26568,26784,27024,27144,27576,27672,
     3  27840,27984,28128,28080,28272,28344,28416,44664,49224,44640,
     4  23400,23424,23352,23424,23328,34008,34008,34776,20712,20736,
     5  30024,29928,29856,29928,30096,30192,30144,30120,30024,30120,
     6  30000,29808,29760,29808,29736,29856, 8064, 8064,10320,10344,
     7  14544,14568,17976,18000,18768,18792,18864,18888,20760,43080,
     8  44688,40104,40080,34032,20040,20184,24744,28176,28032,27984,
     9  27672,27480,27264,27072,26784,26664,26424,25992,25008,25008/
            data (jx(i),i=  201,  300)/
     +  31272,31464,31728,31728,34032,24744,25032,25200,25344,25464,
     1  25608,25704,25872,25872,25920,26016,26040,26160,26160,26376,
     2  26448,26400,26232,26184,26208,26280,26184,26016,25872,25944,
     3  25920,26088,26064,26184,26184,31728,29760,29712,30120,30216,
     4  30360,30504,30528,30720,30792,31104,31512,31560,28296,28440,
     5  28464,28392,28416,28608,28680,28848,29016,29304,29448,29592,
     6  29712,34032,34872,34896,35160,35160,35304,35304,35784,35808,
     7  35928,35928,36048,36048,36168,36192,35352,35352,35160,35160,
     8  43128,35424,35424,35544,35544,38904,34032,34032,34176,34176,
     9  34272,34536,34800,34920,34992,35184,35160,35472,35064,35040/
            data (jx(i),i=  301,  400)/
     +  35160,35160,35304,28800,28752,28896,29160,29088,28752,28584,
     1  28392,28224,28152,33672,33672,33816,33960,33960,34032,43152,
     2  46896,43104,31704,34080,36672,34056,31704,32136,33912,33792,
     3  33624,33504,33552,33528,33264,33264,33072,33072,33000,32928,
     4  32760,32664,32616,32520,32184,17928,26664,24768,26088,25968,
     5  25656,25464,25176,25080,24936,26952,27240,27480,27504,27936,
     6  27864,27984,28032,28272,28392,28512,28584,28512,28560,28704,
     7  28848,28872,26304,26400,26328,26448,26448,26352,26352,26424,
     8  26568,26664,26568,23640,23592,23784,23760,23832,24096,24240,
     9  24216,24336,24312,24192,24192,24360,24384,24600,24672,24648/
            data (jx(i),i=  401,  500)/
     +  18168,18264,18096,17712,17688,17880,17904,17832,17616,17520,
     1  17376,17232,17256,17136,17064,16824,16752,16368,16152,16152,
     2  15936,15528,15360,14976,14640,14064,13296,13320,13056,12936,
     3  12936,11280,11232,23496,23376,23184,23112,22944,22824,22488,
     4  22512,22248,22224,22104,21888,21696,21576,21576,21456,21120,
     5  21048,21000,20808,20784,20856,20856,20328,18888,18792,18648,
     6  18432,18240,18264,36672,34176,26232,26232,26112,25848,25728,
     7  25776,25968,26040,26184,26136,17256,32112,23544,23520,23640,
     8  26136,26352,26424,26424,26280,26352,26280,26472,26736,26832,
     9  26832,27096,27264,27432,27576,27720,27792,27720,27768,27984/
            data (jx(i),i=  501,  600)/
     +  28056,27984,28176,27984,27936,27792,40848,43152,40848,25824,
     1  25824,25680,25656,25560,25392,25248,25152,25176,25104,25176,
     2  25032,24912,24936,24624,24480,24528,24624,24696,24744,24696,
     3  24744,24936,25080,25152,25368,25392,25320,25008,24960,24792,
     4  24696,24576,24384,23976,23976,23808,23784,23616,23520,32760,
     5  32760,32856,32856,33120,33120,34032,34776,34800,33936,33936,
     6  34200,11184,16248,17160,34776,27432,27936,28152,28152,28320,
     7  28272,28368,28320,28152,28128,28032,40896,43920,43920,44640,
     8  26952,27144,20592,20640,34056,34800,13920,14064,14064,14136,
     9  14136,14064,14064,13968,13968,13824,13848,13152,13152,13032/
            data (jx(i),i=  601,  700)/
     +  13056,12840,12864,16296,16392,16536,16608,16704,16680,28920,
     1  28560,28224,27936,27792,27552,34056,16488,16560,16824,16872,
     2  16968,16968,17064,16872,16752,16680,16704,16632,40896,41040,
     3  41352,41520,41736,41832,41904,41928,42024,42240,42480,43944,
     4  43920,44688,44664,44736,20544,15432,15480,15384,15144,15096,
     5  14736,14736,14664,14424,14352,14424,14016,14040,13920,31128,
     6  30840,30672,30528,30360,30360,30264,30288,29856,29880,29760,
     7  29784,29592,29184,28968,15696,15960,16104,16152,22632,22632,
     8  22368,22224,21960,21624,21312,21120,20952,20784, 7920, 7968,
     9   8064,11832,12144,12624,12816,12936,13128,13224,13392,13632/
            data (jx(i),i=  701,  800)/
     +  13800,13968,14088,14544,19584,19656,19512,19608,19752,19848,
     1  19944,20112,20232,20472,16872,16848,16920,16848,16920,16968,
     2  17184,17280,17352,17256,17160,17136,45480,45432,31344,31536,
     3  31776,32136,32256,32424,32592,33000,33048,33264,33336,33360,
     4  33480,33552,33672,33864,33960,33960,34296,34584,34704,31104,
     5  31344,31416,31392,31296,31296,31224,36792,38880,14712,14808,
     6  14784,15024,15144,27192,23400,23400,40920, 7176,13752,31008,
     7  30912,31056,31056,31248,14424,14232,13800,13752,13848,47760,
     8  40920,31224,31344,31512,31656,31800,32112,32328,32616,32760,
     9  33072,33024,33048,32976,32904,33024,33144,33192,33144,33216/
            data (jx(i),i=  801,  900)/
     +  33192,33336,33480,33240,33240,33288,17112,29208,29088,27144,
     1  22488,22488,22632,19584,22704,22680,23232,23280,23808,33432,
     2  33600,33792,34224,34248,34464,34920,35208,35544,36120,36240,
     3  36528,36504,36600,36840,37008,37488,37488,38184,47784,47832,
     4  13368,13368,13272,13224,13128,12960,12768,12720,12672,12384,
     5  12192,12048,11928,11976,11928,11640,11400,11328,11328,11232,
     6  11040,10776,27144,29160,29136,29232,29304,29352,29328,29232,
     7  29184,29280,29232,29256,29160,29184,29016,28992,29040,29112,
     8  29184,29304,50016,50016,49944,50040,49272,50712,49248,49152,
     9  49224,49176,46920,46920,46968,46944,46920,46920,46968,44640/
            data (jx(i),i=  901,  910)/
     +  46944,49968,50064,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  61944,61872,61752,61824,55488,61704,50688,48000,40464,37416,
     1  35040,31512,26760,26856,27144,26736,26712,26952,62328,62136,
     2  61944,59856,62064,57144,49560,44952,41160,38520,38136,32688,
     3  27336,27000,26808,26856,26688,55104,56088,56088,57936,57936,
     4  58416,58416,61776,61632,61440,61224,61224,60912,60984,60888,
     5  60888,60696,60696,60816,60816,60696,60480,60312,60216,60120,
     6  59952,59736,59280,59112,59016,58800,58728,58440,57936,57744,
     7  57624,57576,57312,57192,57144,57072,57240,57480,57552,57576,
     8  57936,58056,58296,58416,58584,59088,59232,59352,59616,60144,
     9  60264,60528,60648,60864,61224,61416,57600,59184,59184,57048/
            data (jy(i),i=  101,  200)/
     +  56712,56256,55800,55344,55248,56856,56808,56352,56352,56232,
     1  56400,56640,56088,56088,55968,56088,56160,55992,55920,55944,
     2  56136,56160,55848,55896,56016,55896,56088,56040,56256,56160,
     3  56136,56016,56184,56328,56472,56472,57096,56856,56976,57624,
     4  52392,53136,53136,56040,56040,55248,56016,56016,53928,55080,
     5  55200,55032,54696,54360,54264,54000,53952,53664,53520,53352,
     6  53136,53088,53040,52848,52464,52368,50616,50520,50400,50784,
     7  50592,51744,51672,52464,52440,53160,53160,54000,52440,53040,
     8  53064,52992,57576,52968,47544,52440,52368,50352,50280,50304,
     9  50232,50280,50616,51312,51648,51600,51720,52248,52296,52368/
            data (jy(i),i=  201,  300)/
     +  52344,52416,52392,52200,52200,51912,51000,50856,50904,50664,
     1  50568,50400,50400,50256,50208,50208,50064,50040,49992,49968,
     2  49824,49536,49536,49392,49200,49128,48888,49080,48936,48744,
     3  48384,48072,47904,47904,47592,50784,51672,52008,51600,51456,
     4  51384,51408,51240,51096,50952,50856,50808,50736,50616,50712,
     5  50904,51072,51216,51216,51144,51120,51264,51216,51288,51552,
     6  51576,51120,51120,51048,51048,50952,50952,51192,51192,51072,
     7  51072,51192,51192,51336,51336,50952,50952,50808,50808,50688,
     8  50736,50688,50808,50808,50688,50664,49560,49776,49776,49944,
     9  50040,50040,49848,49848,49680,49680,49752,49992,50016,50280/
            data (jy(i),i=  301,  400)/
     +  50280,50400,50424,49176,49272,49320,49536,49728,49824,50040,
     1  49992,50064,50160,49560,49752,49752,49872,50040,50040,49224,
     2  49296,49224,49152,49176,49176,49176,45360,45360,48936,48504,
     3  48456,48336,48192,47976,47760,47376,46968,46872,46800,46512,
     4  46320,46320,46056,46008,45360,47592,47568,47472,47592,47472,
     5  47376,47448,47400,47520,47616,47568,47400,47424,47640,47856,
     6  48072,48096,48240,48264,48456,48576,48672,48792,48864,48840,
     7  48936,49056,45336,45480,46104,46248,46320,46392,46704,47040,
     8  47064,47208,47448,44808,45144,45264,45624,45696,45696,46056,
     9  46368,46560,46680,46800,46920,47088,46992,47088,47064,47376/
            data (jy(i),i=  401,  500)/
     +  46656,46800,46968,47136,47232,47448,46656,46488,46440,46488,
     1  46392,46272,46176,46152,45984,45984,45888,45624,45360,45240,
     2  45192,44880,45048,45216,45096,45072,44400,44256,43920,43896,
     3  43752,43128,41736,44280,44280,44496,44664,44688,44808,44688,
     4  44544,44328,44208,44136,44136,44400,44400,44304,44232,44496,
     5  44496,44616,44664,44760,44832,44952,45408,45480,45696,45840,
     6  45912,46152,46512,45360,45360,45432,45672,45744,45696,45360,
     7  45120,44976,44856,44832,44784,41544,41568,44400,44664,44736,
     8  45168,45168,45072,44976,44904,44616,44448,44184,44184,44136,
     9  43728,43680,43752,43680,43536,43536,43416,43296,43200,43248/
            data (jy(i),i=  501,  600)/
     +  43152,42840,42504,42240,41832,41544,43080,43104,45360,39216,
     1  39360,39408,39504,39528,39864,39864,39960,40080,40296,40488,
     2  40896,40992,41112,41232,41640,41736,41736,41904,42312,42624,
     3  42744,42720,42984,42984,43272,43392,43488,43464,43560,43488,
     4  43656,43536,43488,43896,44088,44232,44304,44208,44208,41568,
     5  41400,41400,41280,41280,41136,41160,41136,42432,42432,43056,
     6  43056,40272,38376,38352,40008,39432,39888,39912,40248,40464,
     7  40584,40752,40920,41016,41208,41400,40080,40128,40080,40080,
     8  39216,39480,36912,39264,37728,37752,37128,37128,37320,37320,
     9  37704,37704,37776,37776,37848,37848,37968,38064,38304,38304/
            data (jy(i),i=  601,  700)/
     +  38568,38616,38736,38616,38016,37920,37728,37128,36984,37824,
     1  38064,38544,38760,39048,39192,34704,35472,35712,35736,35976,
     2  36096,36192,36216,36408,36432,36552,36816,36912,36816,36744,
     3  36792,36672,36624,36672,36624,36696,36600,36648,36504,36552,
     4  37056,37080,37872,37872,35232,34920,35136,35304,35448,35592,
     5  35712,35808,35856,35856,36288,36792,36792,37056,37080,34560,
     6  34944,35088,35040,35184,35352,35448,35664,36360,36528,36744,
     7  36840,36960,37488,37608,34800,34896,35016,35376,34128,34464,
     8  34608,34560,34800,34872,35280,35304,35208,35352,34968,35112,
     9  35112,34968,34320,34392,34536,34416,34464,34440,34536,34536/
            data (jy(i),i=  701,  800)/
     +  34344,34344,34296,33792,30576,32688,32688,35064,35112,35208,
     1  35184,35280,35184,35136,35208,35040,34824,34632,34512,34200,
     2  34152,34056,33888,33648,33648,32544,32448,37896,34584,34536,
     3  34752,34920,34896,34608,34944,35400,35544,35664,35616,35448,
     4  35256,35040,34968,35064,34968,34752,34440,34440,34440,34464,
     5  34344,34128,33768,33720,33504,33312,34584,33888,33816,33960,
     6  34104,34224,34560,33312,33360,34128,33168,32808,32640,31776,
     7  32112,32544,32808,33120,33312,33312,33120,33024,32712,32496,
     8  32400,31872,32064,32136,32112,32304,32352,32472,32304,32160,
     9  32136,32016,31944,31944,31824,31728,31560,31320,30912,30792/
            data (jy(i),i=  801,  900)/
     +  30720,30672,30336,30096,29256,29256,30672,29856,29856,30264,
     1  30288,32640,32640,30336,30312,28848,28536,28152,27096,29328,
     2  29304,29496,29688,29832,30000,30168,30096,30216,30264,30432,
     3  30600,30792,31032,31056,31320,31728,32040,33264,30192,30216,
     4  32232,31896,31704,31032,30936,30912,30648,30432,30384,30264,
     5  30264,30192,30000,29904,29640,29208,29040,28776,28392,28272,
     6  27624,27336,29880,29832,29760,29400,29400,29280,29160,29064,
     7  28752,28320,28200,28104,27888,27648,27336,27168,27000,27000,
     8  26880,26880,59712,57000,59352,59352,49368,49392,56232,56232,
     9  53184,53184,44688,45456,45456,40944,41544,41640,41640,40128/
            data (jy(i),i=  901,  910)/
     +  40176,37992,32544,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      5,   19,    1,    1,    2,    4,    4,    3,   22,   21,
     1     22,    5,    7,   24,   25,    8,   26,    9,   10,   27,
     2     10,   11,   29,   12,   15,   15,   14,   30,   13,   33,
     3     18,   13,   16,   17,   14,   36,   37,   38,   39,   40,
     4     41,   42,    2,   43,   44,   45,   46,   47,   48,   49,
     5     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     6     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     7     70,   71,   72,   73,   74,   75,   77,   78,   79,   80,
     8     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     9     91,   92,   93,   94,   95,   96,   97,   98,   99,   77/
            data (jb1(i),i=  101,  200)/
     +    100,  101,  102,  103,  104,   76,  106,  107,  108,  109,
     1    110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
     2    120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
     3    130,  131,  132,  133,  134,  135,  136,   77,  138,   97,
     4    138,  141,  142,  143,  144,   76,   36,  105,  146,  147,
     5    148,  149,   36,  105,  151,  152,  153,  154,  155,  156,
     6    157,  158,  159,  160,  161,  162,  163,  164,  165,    7,
     7    167,  168,  169,  170,  171,  172,  173,  174,  175,  176,
     8    177,  149,  149,  180,  138,  180,  182,   97,  182,  146,
     9    185,  179,  141,  141,  188,  189,  190,  191,  192,  193/
            data (jb1(i),i=  201,  300)/
     +    194,  195,  196,  197,  198,  199,  187,  166,  201,  202,
     1    203,  184,  204,  187,  206,  207,  208,  209,  210,  211,
     2    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     3    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     4    232,  233,  234,  204,  237,  166,  237,  239,  240,  241,
     5    242,  243,  244,  245,  246,  247,  236,  188,  249,  250,
     6    251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
     7    237,  205,  262,  263,  264,  265,  266,  267,  268,  269,
     8    270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
     9    180,  280,  282,  283,  284,  285,  281,  287,  288,  289/
            data (jb1(i),i=  301,  400)/
     +    290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
     1    300,  301,  302,  280,  304,  305,  306,  307,  308,  309,
     2    310,  311,  312,  188,  287,  314,  315,  316,  317,  318,
     3    262,  320,  281,  320,  304,  324,  324,  287,  236,  322,
     4    323,  327,  324,  329,  330,  331,  332,  333,  334,  335,
     5    336,  337,  338,  339,  340,  341,  342,  343,  344,    8,
     6    235,  185,  185,  235,  349,  350,  351,  352,  353,  354,
     7    348,  347,  356,  357,  358,  359,  360,  361,  362,  363,
     8    364,  365,  366,  367,  368,  369,  370,  371,  304,  373,
     9    374,  375,  376,  377,  378,  379,  380,  381,  382,  347/
            data (jb1(i),i=  401,  500)/
     +    384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
     1    394,  395,  396,  397,  398,  399,  348,  401,  402,  403,
     2    404,  405,  346,  401,  407,  408,  409,  410,  411,  412,
     3    413,  414,  415,  416,  417,  418,  419,  420,  421,  422,
     4    423,  424,  425,  426,  427,  428,  429,  430,  431,  432,
     5    434,  435,  436,  437,  438,  439,  440,  441,  442,  443,
     6    444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
     7    454,  455,  456,  457,  458,  459,  460,  461,  462,  401,
     8    325,  328,  464,  345,  373,  466,  467,  468,  469,  470,
     9    471,  472,  473,  474,  384,  411,  328,  434,  478,  479/
            data (jb1(i),i=  501,  600)/
     +    384,  373,  481,  482,  483,  484,  485,  486,  487,  488,
     1    489,  490,  491,  492,  493,  494,  495,  496,  497,  498,
     2    499,  500,  501,  502,  503,  504,  505,  507,  322,  507,
     3    464,  510,  511,  512,  513,  514,  515,  516,  517,  518,
     4    519,  520,  521,  522,  523,  524,  525,  526,  527,  528,
     5    529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
     6    539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
     7    434,  433,  477,  550,  551,  552,  553,  554,  555,  556,
     8    477,  557,  558,  559,  560,  465,    9,  433,  563,  476,
     9    557,  566,  567,  568,  569,  570,  571,  572,  573,  574/
            data (jb1(i),i=  601,  700)/
     +    575,  506,  507,  577,  578,  579,  565,  510,  581,  566,
     1    583,  510,  585,  565,  587,  588,  589,  590,  591,  592,
     2    593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
     3    603,  563,  563,  605,  606,  607,  608,  585,  610,  611,
     4    612,  613,  614,  566,  587,  585,  583,  617,  618,  619,
     5    620,  621,  622,  623,  624,  625,  626,  627,  609,  577,
     6    629,  630,  631,  632,  633,  634,  635,  636,  637,  638,
     7    639,  640,  641,  642,  643,  583,  646,  647,  648,  649,
     8    650,  651,  652,  653,  654,  655,  656,  657,  658,  587,
     9    660,  661,  662,  663,  664,  665,  666,  667,  668,  669/
            data (jb1(i),i=  701,  800)/
     +    670,  671,  672,  673,  610,  646,  675,  676,  677,  617,
     1    679,  680,  681,  682,  683,  684,  685,  686,  687,  645,
     2     11,  689,  690,  691,  692,  693,  694,  695,  696,  697,
     3    698,  699,  700,  701,  702,  703,  705,  706,  707,  708,
     4    709,  710,  711,  712,  713,  645,  617,  715,  716,  717,
     5    718,  719,  720,  721,  722,  723,  724,  725,  727,  660,
     6    729,  730,  731,  732,  733,  734,  735,  736,  737,  738,
     7    739,  740,  741,  742,  743,  744,  745,  616,  616,  747,
     8    748,  660,  750,  751,  752,  753,  754,  755,  749,  757,
     9    704,  759,  760,  761,  762,  646,  764,  765,  679,  756/
            data (jb1(i),i=  801,  900)/
     +    629,  758,   12,  768,  770,  771,  772,  773,  756,  704,
     1    775,  776,  777,  778,  769,  726,  727,  767,  727,  770,
     2    782,  783,  784,  785,  786,  787,  788,  789,  790,  791,
     3    792,  793,  794,  795,  796,  797,  798,  799,  800,  801,
     4    802,  803,  804,  805,  726,  770,  808,  764,  811,  812,
     5    679,  705,  705,  811,  810,  811,  815,  816,  817,  818,
     6    819,  806,  820,  821,  822,  823,  824,  825,  826,  827,
     7    828,  829,  830,  831,  832,  833,  834,  835,  836,  837,
     8    758,   14,  839,  780,  769,  841,  842,  843,  844,  845,
     9    846,  847,  848,  849,  850,  851,  852,  853,  854,  855/
            data (jb1(i),i=  901,  970)/
     +    856,  857,  858,  859,  860,  861,  862,  810,  809,  809,
     1    864,  865,  866,  867,  868,  869,  870,  871,  872,  873,
     2    874,  875,  876,  877,  878,  879,  880,  881,  882,  806,
     3    807,   22,   21,   24,  884,  885,  883,  139,  887,   25,
     4    139,  889,  890,  891,  887,  321,   26,  893,  894,  321,
     5     27,  896,  897,  898,  893,  580,  900,  896,   29,  728,
     6    644,  580,   30,  902,  780,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     19,   20,   20,    2,    3,   21,    6,    6,   23,   23,
     1     24,    7,    8,   25,   26,    9,   27,   28,   28,   29,
     2     11,   12,   30,   31,   31,   18,   32,   32,   33,   34,
     3     34,   16,   17,   35,   35,   37,   38,   39,   40,   41,
     4     42,    1,   43,   44,   45,   46,   47,   48,   49,   50,
     5     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     7     71,   72,   73,   74,   75,   76,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,    3,   98,   99,    4,  100/
            data (jb2(i),i=  101,  200)/
     +    101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
     1    111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
     2    121,  122,  123,  124,  125,  126,  127,  128,  129,  130,
     3    131,  132,  133,  134,  135,  136,  137,  137,  139,  140,
     4    140,  142,  143,  144,  145,  145,    5,  146,  147,  148,
     5      6,  150,  150,  151,  152,  153,  154,  155,  156,  157,
     6    158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
     7    168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
     8    178,  178,  179,  181,  181,  182,  183,  183,  184,  184,
     9    186,  186,  179,  187,  189,  190,  191,  192,  193,  194/
            data (jb2(i),i=  201,  300)/
     +    195,  196,  197,  198,  199,  200,  200,  201,  202,  203,
     1    204,  205,  205,  206,  207,  208,  209,  210,  211,  212,
     2    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     3    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     4    233,  234,  235,  236,  238,  238,  239,  240,  241,  242,
     5    243,  244,  245,  246,  247,  248,  248,  249,  250,  251,
     6    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     7    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     8    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     9    281,  282,  283,  284,  285,  286,  286,  288,  289,  290/
            data (jb2(i),i=  301,  400)/
     +    291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
     1    301,  302,  303,  303,  305,  306,  307,  308,  309,  310,
     2    311,  312,  313,  313,  314,  315,  316,  317,  318,  319,
     3    319,  321,  320,  322,  323,  325,  326,  326,  323,  325,
     4    327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
     5    337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
     6    347,  346,  348,  349,  350,  351,  352,  353,  354,  355,
     7    355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
     8    365,  366,  367,  368,  369,  370,  371,  372,  372,  374,
     9    375,  376,  377,  378,  379,  380,  381,  382,  383,  383/
            data (jb2(i),i=  401,  500)/
     +    385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
     1    395,  396,  397,  398,  399,  400,  400,  402,  403,  404,
     2    405,  406,  406,  407,  408,  409,  410,  411,  412,  413,
     3    414,  415,  416,  417,  418,  419,  420,  421,  422,  423,
     4    424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
     5    435,  436,  437,  438,  439,  440,  441,  442,  443,  444,
     6    445,  446,  447,  448,  449,  450,  451,  452,  453,  454,
     7    455,  456,  457,  458,  459,  460,  461,  462,  463,  463,
     8    464,  345,  465,  465,  466,  467,  468,  469,  470,  471,
     9    472,  473,  474,  475,  475,  476,  477,  478,  479,  480/
            data (jb2(i),i=  501,  600)/
     +    480,  481,  482,  483,  484,  485,  486,  487,  488,  489,
     1    490,  491,  492,  493,  494,  495,  496,  497,  498,  499,
     2    500,  501,  502,  503,  504,  505,  506,  508,  508,  509,
     3    509,  511,  512,  513,  514,  515,  516,  517,  518,  519,
     4    520,  521,  522,  523,  524,  525,  526,  527,  528,  529,
     5    530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
     6    540,  541,  542,  543,  544,  545,  546,  547,  548,  549,
     7    549,  476,  550,  551,  552,  553,  554,  555,  556,  557,
     8    506,  558,  559,  560,  561,  561,  562,  562,  564,  564,
     9    565,  567,  568,  569,  570,  571,  572,  573,  574,  575/
            data (jb2(i),i=  601,  700)/
     +    576,  576,  577,  578,  579,  580,  577,  581,  582,  582,
     1    584,  584,  586,  586,  588,  589,  590,  591,  592,  593,
     2    594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
     3    604,  604,  605,  606,  607,  608,  609,  610,  611,  612,
     4    613,  614,  615,  615,   10,  616,  609,  618,  619,  620,
     5    621,  622,  623,  624,  625,  626,  627,  628,  628,  629,
     6    630,  631,  632,  633,  634,  635,  636,  637,  638,  639,
     7    640,  641,  642,  643,  644,  645,  647,  648,  649,  650,
     8    651,  652,  653,  654,  655,  656,  657,  658,  659,  659,
     9    661,  662,  663,  664,  665,  666,  667,  668,  669,  670/
            data (jb2(i),i=  701,  800)/
     +    671,  672,  673,  674,  674,  675,  676,  677,  678,  678,
     1    680,  681,  682,  683,  684,  685,  686,  687,  688,  688,
     2    689,  690,  691,  692,  693,  694,  695,  696,  697,  698,
     3    699,  700,  701,  702,  703,  704,  706,  707,  708,  709,
     4    710,  711,  712,  713,  714,  714,  715,  716,  717,  718,
     5    719,  720,  721,  722,  723,  724,  725,  726,  728,  729,
     6    730,  731,  732,  733,  734,  735,  736,  737,  738,  739,
     7    740,  741,  742,  743,  744,  745,  746,  746,  747,  748,
     8    749,  750,  751,  752,  753,  754,  755,  756,  757,  758,
     9    759,  760,  761,  762,  763,  763,  765,  766,  766,  764/
            data (jb2(i),i=  801,  900)/
     +    767,  767,  768,  769,  771,  772,  773,  774,  774,  775,
     1    776,  777,  778,  779,  779,  769,  780,  781,  781,  782,
     2    783,  784,  785,  786,  787,  788,  789,  790,  791,  792,
     3    793,  794,  795,  796,  797,  798,  799,  800,  801,  802,
     4    803,  804,  805,  806,  807,  808,  809,  810,  812,  813,
     5    813,  807,  814,  814,  815,  815,  816,  817,  818,  819,
     6     13,  820,  821,  822,  823,  824,  825,  826,  827,  828,
     7    829,  830,  831,  832,  833,  834,  835,  836,  837,  838,
     8    838,  839,  840,  840,  841,  842,  843,  844,  845,  846,
     9    847,  848,  849,  850,  851,  852,  853,  854,  855,  856/
            data (jb2(i),i=  901,  970)/
     +    857,  858,  859,  860,  861,  862,   15,  863,  863,  864,
     1    865,  866,  867,  868,  869,  870,  871,  872,  873,  874,
     2    875,  876,  877,  878,  879,  880,  881,  882,   16,   17,
     3     18,  883,  883,  884,  885,  886,  886,  884,  888,  888,
     4    889,  890,  891,  892,  892,  887,  893,  894,  895,  895,
     5    896,  897,  898,  899,  899,  900,  901,  901,  902,  902,
     6    728,  644,  903,  903,  903,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ct(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(650) :: jx,jy
            integer(kind=iknd), save, dimension(660) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'connecticut   '/
            data jrot,ipart/1,2/
            data kv/   1, 642, 650,   0,   0/
            data kb/   1, 650, 658,   0,   0/
            data iib/ 394,   8,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  16536,30000,16848,16680,30264,39024,39120,40080,37824,37920,
     1  37800,37848,38208,38352,38760,39168,39888,40488,40680,40776,
     2  41112,41256,40920,40800,40848,40656,40656,40896,40968,41112,
     3  40776,40728,40800,41112,41160,40848,40872,40776,40848,40464,
     4  40512,41544,41472,41520,41640,41856,41952,41976,41592,41352,
     5  41256,41376,41496,41736,41736,41616,41592,41400,41376,41688,
     6  41496,41136,39984,39552,40320,40800,40872,41136,41448,42096,
     7  42336,42600,42600,42840,43248,43248,43152,42984,43008,42648,
     8  42480,42408,42480,42384,42600,42696,42840,42864,42768,42312,
     9  41856,41640,41616,42144,42072,41952,41832,41880,42192,42264/
            data (jx(i),i=  101,  200)/
     +  42216,42000,41832,41616,41400,40992,40128,39192,38952,40296,
     1  40440,40464,40368,40128,40296,40440,40632,41040,41184,41088,
     2  41208,41400,41808,42456,42696,42672,42840,42960,42912,43080,
     3  43128,43224,43200,43440,43488,43392,43440,43584,43608,43776,
     4  43752,43920,43464,43320,43320,43392,43296,43344,43728,43632,
     5  43800,43968,44184,44088,43800,43728,43848,44016,44232,47640,
     6  47568,46968,46752,46680,46584,46224,46152,46440,46344,46296,
     7  46392,46296,46032,45792,45648,45288,45288,44784,44544,44376,
     8  44040,43944,43896,43824,43632,43392,43080,42792,42696,43032,
     9  43152,43464,43920,44328,44424,44544,44712,44904,44904,44784/
            data (jx(i),i=  201,  300)/
     +  44400,44352,44568,44616,44568,44112,44184,44136,44184,44304,
     1  44472,44568,44616,44568,44376,44232,44064,44064,43920,43992,
     2  44208,44208,44376,44232,44352,44208,44280,44424,44568,44712,
     3  44592,44616,44304,44352,44304,44016,43896,43800,43944,43944,
     4  43728,43776,43728,43824,44016,44472,44376,47928,48072,48168,
     5  48240,48408,48456,48432,48264,48216,48240,48144,48000,48000,
     6  48072,48048,47928,47616,47688,47640,47496,47568,47664,47856,
     7  48024,48168,48360,48672,48624,48504,48072,47928,47952,48192,
     8  48432,48600,48648,48600,49104,49536,49512,49176,49272,49536,
     9  49656,49656,49776,49872,49776,49968,50112,49896,50136,50232/
            data (jx(i),i=  301,  400)/
     +  50352,50448,50784,50856,50688,50520,50664,50808,51072,51168,
     1  51096,51384,51576,51480,51840,51840,51720,51672,51840,51936,
     2  51744,51768,52320,52416,52104,52320,51960,51864,51864,52296,
     3  52464,52464,52632,52752,53040,53064,52608,52584,52776,52968,
     4  53088,53616,53760,53832,53832,53640,53520,53352,53112,53016,
     5  53040,53256,53352,53232,52968,52896,53232,53280,53424,53472,
     6  53472,53568,53712,53808,53712,53952,54168,54528,54384,53952,
     7  53496,50376,46296,43512,16704,16896,17088,17088,16896,16896,
     8  16752,16800,17088,17280,17952,18216,16800,16872,16464,16488,
     9  16440,16704,16752,18984,19008,19128,23472,23448,26328,26376/
            data (jx(i),i=  401,  500)/
     +  26424,26256,26256,26304,26856,27000,27072,27144,27144,27264,
     1  27288,27432,27456,27648,27792,29904,30336,29616,29424,29448,
     2  29712,19440,19128,21840,21912,23352,23568,23784,23760,23832,
     3  25056,25368,30960,19752,19848,22968,22824,24624,24504,26712,
     4  29448,29784,30552,30720,30864,31080,31896,32136,32328,32088,
     5  32064,31872,31944,31944,31704,31224,30360,29976,29304,29328,
     6  29136,28800,28656,28560,28608,28368,28056,27888,32304,32568,
     7  32952,32472,32352,32136,31992,31560,31344,31200,30696,30960,
     8  30384,33192,33600,33864,33840,33528,33600,33288,33432,34224,
     9  34080,33936,33600,33864,32040,30768,37200,36936,36624,36456/
            data (jx(i),i=  501,  600)/
     +  36360,35904,35592,35736,35496,33960,33936,33840,33480,32880,
     1  32808,32376,32184,31848,31872,31416,31368,30312,30480,30552,
     2  30480,30768,30960,31080,31248,31272,35280,36456,36192,36072,
     3  35592,35712,35880,36048,36504,36744,36960,37176,37248,39120,
     4  39192,39192,38760,38496,38400,34656,34224,34752,36168,36168,
     5  37656,38136,38232,38184,38616,38952,39120,39264,39408,39432,
     6  39504,36336,36240,37920,38448,37848,37968,37944,38160,38424,
     7  38568,38688,38760,39144,39672,39864,40104,40320,40584,41184,
     8  41280,41736,41688,41880,41832,42360,42936,43296,43368,43608,
     9  43920,44040,37080,37152,37320,37536,37896,37920,37752,37776/
            data (jx(i),i=  601,  650)/
     +  38064,38304,38376,38400,38232,38184,38640,38640,38496,38544,
     1  39096,39240,39480,39624,39864,40104,40128,40320,40896,41160,
     2  41256,41400,41904,42288,42528,42600,42744,43008,43200,43392,
     3  43680,44016,44616,44904,45168,45528,45912,46176,46488,47112,
     4  47376,41160,40848,40728,40800,40776,40968,41136,41352,    0/
            data (jy(i),i=    1,  100)/
     +  48528,57312,24648,37800,11424,49560,49608,42144,57360,57288,
     1  56832,56736,56232,56160,56208,56424,56304,56568,56520,56472,
     2  56040,55728,55632,55416,55272,55200,55056,54840,54624,54528,
     3  54432,54312,54240,54216,54096,53736,53400,53304,53208,53112,
     4  52800,52392,52248,52128,52032,52056,51984,51864,51720,51720,
     5  51600,51528,51552,51384,51264,51048,50808,50832,50784,50424,
     6  50136,49968,49848,49632,42120,42336,42600,42936,43032,42912,
     7  42960,43128,43224,43440,43512,43800,44304,44808,45168,45504,
     8  45504,45864,45960,46152,46320,46488,46536,46656,46800,46704,
     9  46728,46944,47376,47712,47832,47808,47928,48096,48312,48528/
            data (jy(i),i=  101,  200)/
     +  49080,49536,49632,49680,49656,49392,49512,49392,49512,41952,
     1  41976,41904,41784,41688,41616,41640,41760,41832,41952,42240,
     2  42408,42552,42696,42672,42600,42408,42360,42408,42744,42888,
     3  42864,42624,42408,42312,42408,42888,42960,43008,42720,42408,
     4  42120,41832,41616,41472,41112,40800,40296,40080,39672,39264,
     5  38880,38736,38640,38376,38352,38280,38184,37944,37896,22704,
     6  22872,23256,23472,23760,23832,24048,24192,24528,24576,24960,
     7  25032,25200,25368,25440,25728,25896,26160,26472,26760,27240,
     8  27528,27576,27552,27216,27264,27600,27792,28368,28464,28344,
     9  28152,28080,28104,28344,28320,28176,28128,28440,28824,29232/
            data (jy(i),i=  201,  300)/
     +  29568,29760,29832,29928,30000,30120,30264,30528,30600,30576,
     1  30384,30408,30456,30648,30744,31128,31248,31608,32016,32160,
     2  32208,32544,32616,32904,33096,33384,33432,33408,33264,33360,
     3  33600,33840,33984,34080,34176,34224,34416,34464,34680,34824,
     4  35472,36336,36768,37008,37248,37656,37848,22680,22872,22944,
     5  22896,22416,22008,21792,21600,21648,21792,21912,21864,21720,
     6  21624,21456,21336,21264,21120,20928,20808,20664,20664,20808,
     7  20808,20520,20328,20136,20040,20040,20304,20280,20232,19848,
     8  19776,19560,19440,19320,19128,18600,18360,17952,17760,17544,
     9  17352,17112,16920,16872,16440,16344,16152,15648,15600,15864/
            data (jy(i),i=  301,  400)/
     +  15840,15432,15192,15072,15096,15024,14928,14688,14832,14712,
     1  14424,14352,14160,14040,14064,13896,13824,13680,13632,13344,
     2  13368,13176,13008,12888,12768,12600,12432,12264,12144,12168,
     3  12096,11736,11760,11832,11808,11616,11400,11136,11160,11136,
     4  10896,10584,10440,10200,10032,10104,10320,10464,10440,10320,
     5  10224,10176, 9984, 9864, 9816, 9720, 9576, 9504, 9432, 9336,
     6   9000, 9024, 8976, 8856, 8448, 8376, 8160, 8136, 8064, 8040,
     7   8136, 6144,12648,10776,37368,36144,35832,35232,35184,34368,
     8  32568,31272,31296,31128,31008,29712,29736,26472,51144,52728,
     9  56520,15240,11976,11952,48696,45600,45720,47136,47448,47400/
            data (jy(i),i=  401,  500)/
     +  46968,46872,46704,46584,46416,46440,46536,46536,46392,46368,
     1  44904,44928,45048,45120,45264,55464,52992,49056,47664,47592,
     2  47520,24168,27912,27240,26568,26256,26256,26328,26568,26736,
     3  26424,24648,25656,38352,37776,37752,38304,38112,38928,39264,
     4  39816,40296,40704,40728,40848,40920,40872,41136,41568,41640,
     5  41736,41784,42192,42672,43056,43152,42864,43656,44304,44544,
     6  44616,44520,44376,44376,44664,44712,45120,45120,40704,39408,
     7  31824,31800,32352,32400,32784,32880,32760,32808,35064,35016,
     8  38328,30552,30336,30096,29904,29904,29784,29832,29280,29424,
     9  28776,28752,28464,26712,27000,26832,17112,16848,16656,16704/
            data (jy(i),i=  501,  600)/
     +  16632,16848,18888,19896,21168,20904,21432,21792,22824,23064,
     1  23736,23640,23664,24264,24720,24648,25128,11760,11832,11976,
     2  12120,12216,12360,12072,12072,12024,13464,13608,13944,14232,
     3  15024,15120,15000,15264,15360,15816,16416,16656,17040,49656,
     4  49680,49872,49824,49872,49512,40440,43248,43272,43536,43608,
     5  43848,41256,40608,40440,40680,40704,40656,40704,40944,41328,
     6  41760,32160,32400,32304,32136,34560,34608,34704,34896,34728,
     7  34704,34848,35184,35256,35736,35688,35832,35856,35736,35784,
     8  35736,35784,36192,36360,36504,36504,37056,37296,37584,37632,
     9  37560,37632,17256,17400,17424,17376,17448,17544,17976,18096/
            data (jy(i),i=  601,  650)/
     +  18264,18312,18384,18528,18720,18864,19008,19128,19368,19584,
     1  20064,20448,20472,20400,20544,20784,21192,21216,21720,21768,
     2  21840,22104,22368,22992,23208,23376,23400,23712,23760,23664,
     3  23280,23136,23208,23112,22800,22608,22680,22608,22656,22320,
     4  22344,53016,53064,53016,52896,52824,52800,52728,52968,    0/
            data (jb1(i),i=    1,  100)/
     +      6,    2,    9,   10,   11,   12,   13,   14,   15,   16,
     1     17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
     2     27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
     3     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     4     47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
     5     57,   58,   59,   60,   61,   62,   63,    7,    8,   65,
     6     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     7     76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
     8     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     9     96,   97,   98,   99,  100,  101,  102,  103,  104,  105/
            data (jb1(i),i=  101,  200)/
     +    106,  107,  108,    6,    8,  110,  111,  112,  113,  114,
     1    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     2    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     3    135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
     4    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     5    155,  156,  157,  158,  160,  161,  162,  163,  164,  165,
     6    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     7    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     8    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     9    196,  197,  198,  199,  200,  201,  202,  203,  204,  205/
            data (jb1(i),i=  201,  300)/
     +    206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
     1    216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
     2    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     3    236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
     4    246,  159,  160,  248,  249,  250,  251,  252,  253,  254,
     5    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     6    265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
     7    275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
     8    285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
     9    295,  296,  297,  298,  299,  300,  301,  302,  303,  304/
            data (jb1(i),i=  301,  400)/
     +    305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
     1    315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
     2    325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
     3    335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
     4    345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
     5    355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
     6    365,  366,  367,  368,  369,  370,  371,  372,  373,    5,
     7      1,    4,  375,  376,  377,  378,  379,  380,  381,  382,
     8    383,  384,  385,  386,  387,    3,    1,  389,  390,    2,
     9      3,  392,  393,    5,    1,  395,  396,  397,  398,  399/
            data (jb1(i),i=  401,  500)/
     +    400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
     1    410,  411,  412,  413,  414,    2,  416,  417,  418,  419,
     2    420,  415,    3,  422,  423,  424,  425,  426,  427,  428,
     3    429,  430,  431,  432,    4,  434,  435,  436,  437,  438,
     4    439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
     5    449,  450,  451,  452,  453,  454,  455,  456,  457,  458,
     6    459,  460,  461,  462,  463,  464,  465,  466,  467,  415,
     7    447,  469,  471,  472,  473,  474,  475,  476,  477,  478,
     8    479,  480,  470,  471,  482,  483,  484,  485,  486,  487,
     9    488,  489,  490,  491,  492,  493,  494,  495,  433,  497/
            data (jb1(i),i=  501,  600)/
     +    498,  499,  500,  501,  502,  503,  504,  505,  506,  507,
     1    508,  509,  510,  511,  512,  513,  514,  515,  516,  433,
     2      5,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     3    527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     4    537,  538,  497,    7,  540,  541,  542,  543,  544,    6,
     5    470,  546,  547,  548,  549,  550,  551,  552,  553,  554,
     6    555,  556,  557,  558,  559,  560,  561,  471,  562,  563,
     7    564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
     8    574,  575,  576,  577,  578,  579,  580,  581,  582,  583,
     9    584,  585,  586,  587,  588,  589,  590,  591,  159,  497/
            data (jb1(i),i=  601,  660)/
     +    593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
     1    603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
     2    613,  614,  615,  616,  617,  618,  619,  620,  621,  622,
     3    623,  624,  625,  626,  627,  628,  629,  630,  631,  632,
     4    633,  634,  635,  636,  637,  638,  639,  640,  160,    1,
     5      2,    3,    4,    5,    6,    7,    1,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      7,    9,   10,   11,   12,   13,   14,   15,   16,   17,
     1     18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
     2     28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
     3     38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
     4     48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
     5     58,   59,   60,   61,   62,   63,   64,   64,   65,   66,
     6     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     7     77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
     8     87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     9     97,   98,   99,  100,  101,  102,  103,  104,  105,  106/
            data (jb2(i),i=  101,  200)/
     +    107,  108,  109,  109,  110,  111,  112,  113,  114,  115,
     1    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     2    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     3    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     4    146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
     5    156,  157,  158,  159,  161,  162,  163,  164,  165,  166,
     6    167,  168,  169,  170,  171,  172,  173,  174,  175,  176,
     7    177,  178,  179,  180,  181,  182,  183,  184,  185,  186,
     8    187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
     9    197,  198,  199,  200,  201,  202,  203,  204,  205,  206/
            data (jb2(i),i=  201,  300)/
     +    207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
     1    217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
     2    227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
     3    237,  238,  239,  240,  241,  242,  243,  244,  245,  246,
     4    247,  247,  248,  249,  250,  251,  252,  253,  254,  255,
     5    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     6    266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
     7    276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
     8    286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
     9    296,  297,  298,  299,  300,  301,  302,  303,  304,  305/
            data (jb2(i),i=  301,  400)/
     +    306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
     1    316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
     2    326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
     3    336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
     4    346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
     5    356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
     6    366,  367,  368,  369,  370,  371,  372,  373,  374,  374,
     7      4,  375,  376,  377,  378,  379,  380,  381,  382,  383,
     8    384,  385,  386,  387,  388,  388,  389,  390,  391,  391,
     9    392,  393,  394,  394,  395,  396,  397,  398,  399,  400/
            data (jb2(i),i=  401,  500)/
     +    401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
     1    411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
     2    421,  421,  422,  423,  424,  425,  426,  427,  428,  429,
     3    430,  431,  432,  433,  434,  435,  436,  437,  438,  439,
     4    440,  441,  442,  443,  444,  445,  446,  447,  448,  449,
     5    450,  451,  452,  453,  454,  455,  456,  457,  458,  459,
     6    460,  461,  462,  463,  464,  465,  466,  467,  468,  468,
     7    469,  470,  472,  473,  474,  475,  476,  477,  478,  479,
     8    480,  481,  481,  482,  483,  484,  485,  486,  487,  488,
     9    489,  490,  491,  492,  493,  494,  495,  496,  496,  498/
            data (jb2(i),i=  501,  600)/
     +    499,  500,  501,  502,  503,  504,  505,  506,  507,  508,
     1    509,  510,  511,  512,  513,  514,  515,  516,  517,  517,
     2    518,  519,  520,  521,  522,  523,  524,  525,  526,  527,
     3    528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
     4    538,  539,  539,  540,  541,  542,  543,  544,  545,  545,
     5    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     6    556,  557,  558,  559,  560,  561,    8,  562,  563,  564,
     7    565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
     8    575,  576,  577,  578,  579,  580,  581,  582,  583,  584,
     9    585,  586,  587,  588,  589,  590,  591,  592,  592,  593/
            data (jb2(i),i=  601,  660)/
     +    594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
     1    604,  605,  606,  607,  608,  609,  610,  611,  612,  613,
     2    614,  615,  616,  617,  618,  619,  620,  621,  622,  623,
     3    624,  625,  626,  627,  628,  629,  630,  631,  632,  633,
     4    634,  635,  636,  637,  638,  639,  640,  641,  641,    2,
     5      3,    4,    5,    6,    7,    8,    8,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine de(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(400) :: jx,jy,jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'deleware      '/
            data jrot,ipart/0,1/
            data kv/   1, 398,   0,   0,   0/
            data kb/   1, 400,   0,   0,   0/
            data iib/ 333,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  27456,27384,27528,27504,27240,27192,27096,26856,26616,26784,
     1  27048,27192,27096,27024,26880,26784,26736,26568,26256,26136,
     2  26112,26424,26064,25968,26112,27096,27000,27096,27144,26952,
     3  26952,27240,27432,27672,27600,27360,27048,26856,26352,26256,
     4  26112,26208,26328,26688,26952,27192,27504,27600,27768,28080,
     5  28272,28536,28584,28704,29184,30144,30936,30408,29424,27552,
     6  26616,25656,25080,24000,22536,21288,20664,20136,19776,19584,
     7  19128,19080,19848,33840,33888,34032,34008,33912,33696,33432,
     8  33312,33288,33312,33000,32880,32256,31296,31056,30960,31032,
     9  30912,31008,31008,30768,30768,30624,30840,31128,31296,31176/
            data (jx(i),i=  101,  200)/
     +  30912,30888,31176,31152,30960,30912,30936,30192,29880,29760,
     1  29592,29352,29256,29040,28728,28488,28392,28440,28392,28296,
     2  28080,27768,27888,27816,28104,28032,27744,20832,33696,34032,
     3  34680,35496,35736,35880,36312,36528,36720,37008,37344,37464,
     4  37800,38856,39432,39960,40224,40368,40632,40704,40848,41016,
     5  41112,41496,41520,41448,41568,41568,41424,41208,40968,40992,
     6  41232,41208,41112,40968,40920,40968,41136,41040,41064,40848,
     7  40632,40704,40608,40296,40152,40008,39744,39696,39672,39264,
     8  39240,39096,38880,38832,38928,39312,39360,39624,39504,39600,
     9  39264,39216,38904,38784,38640,38544,38184,38016,37920,37848/
            data (jx(i),i=  201,  300)/
     +  37992,37848,38808,38808,38880,39024,38952,39024,39240,39408,
     1  39576,39576,39720,39744,39936,40224,40512,40656,40416,40224,
     2  40296,40224,40008,39888,39528,38856,38616,38520,38472,38496,
     3  38400,38352,38136,38064,37944,37512,37272,37080,36768,36480,
     4  36336,36048,35952,35736,35520,35208,34656,34704,34872,35088,
     5  35208,35328,35496,35856,36552,36720,36744,36984,37320,37464,
     6  37608,37728,37536,37224,37080,37104,37200,37104,37128,37248,
     7  37368,37488,37824,37920,38016,38232,38520,38664,38784,38904,
     8  39000,39144,39432,39648,39864,39960,39864,39912,40032,40104,
     9  40248,40152,40176,40272,40392,40416,40536,40584,40632,40584/
            data (jx(i),i=  301,  400)/
     +  40632,40728,40824,40824,40992,41160,41304,41232,41280,41232,
     1  41112,41184,41640,41832,41976,42000,41928,41952,42096,41976,
     2  41328,41256,41016,40704,40536,40512,40608,40512,40536,33120,
     3  21624,21360,21264,21264,22104,22344,22680,22968,23232,23568,
     4  23808,24024,24120,24336,25296,25560,25608,25800,25800,25920,
     5  26088,26136,26088,26160,26280,26256,26424,26544,26616,26784,
     6  26904,27048,27048,27096,27336,33672,33528,32952,32736,32520,
     7  32328,32040,31944,31608,31488,31488,31296,31032,31104,31056,
     8  31032,30936,30912,30456,29976,29832,29592,29280,29040,28440,
     9  28320,27960,27576,27120,26736,26568,26088,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  43032,43200,43488,43608,43968,44136,44208,44160,44304,44376,
     1  44352,44448,44664,44760,44808,44928,45264,45504,45672,45888,
     2  46104,46296,46680,47736,48312,48384,48768,49104,49824,49992,
     3  50160,50448,50736,51336,51552,51720,51840,52176,52512,52680,
     4  53424,53712,53904,54240,54360,54768,55104,55320,56256,56568,
     5  57048,57024,57072,57720,58896,59856,60264,60672,61248,61920,
     6  62016,62016,61944,61680,61056,60096,59448,58680,58032,57360,
     7  57360,54480,40320,26208,26712,27048,27264,27600,27912,28128,
     8  28344,28584,28896,29304,29592,30216,30888,31248,32160,32760,
     9  32976,33144,33264,33648,33984,34608,35496,36048,36672,37104/
            data (jy(i),i=  101,  200)/
     +  37320,37464,37824,37968,38160,38304,38688,39840,40608,41088,
     1  41208,41256,41376,41760,41832,42048,42048,41712,41544,41568,
     2  41856,41880,42168,42432,42432,42600,43008,21648,25896,25008,
     3  24528,23712,23328,22920,22104,22056,21648,21456,21024,20736,
     4  20640,19896,19728,19896,19752,19752,20496,20496,20376,19608,
     5  17304,15240,14904,14592,13848,13560,13368,13296,13296,13464,
     6  13536,13680,13776,13728,13920,14448,14784,15456,15888,16224,
     7  16224,15984,15888,16128,16104,15984,16176,16128,15888,15960,
     8  16248,16152,16128,16008,15888,15648,15000,14736,14640,14256,
     9  14328,14784,14640,14664,14712,14856,14976,15192,15216,15168/
            data (jy(i),i=  201,  300)/
     +  14928,14664,14472,14256,14184,14136,13968,13896,13968,13848,
     1  13824,13632,13656,13776,13872,13800,13632,13416,13368,13416,
     2  13176,13128,13224,13056,13152,12936,13080,13056,12864,12624,
     3  12576,12648,12648,12288,12240,12168,12264,12264,12120,12168,
     4  12096,12168,12120,12120,12192,12096,12240,11976,11856,11832,
     5  11688,11712,11904,11832,12000,11880,11784,11808,11784,11904,
     6  11928,11448,11328,11352,11088,10992,10944,10320,10152,10080,
     7  10272,10968,11112,11400,11472,11568,11544,11640,11952,11952,
     8  12096,12168,12192,12120,12168,12072,11640,11496,11496,11616,
     9  11592,11160,11088,11184,11136,10920,10752,10752,10824,11208/
            data (jy(i),i=  301,  400)/
     +  11496,11520,11664,11904,11928,11712,11760,12120,12504,12744,
     1  12816,12936,13104,10464, 9744, 9312, 8856, 7776, 6888, 6360,
     2   6360, 6456, 6552, 7008, 7080, 6840, 6696, 6408, 6384, 6432,
     3   6840,11640,12360,40416,40344,40128,40056,40176,40176,40536,
     4  40536,40656,40752,40824,40824,40896,41136,41352,41568,41736,
     5  41784,41856,42192,42336,42336,42528,42552,42432,42624,42456,
     6  42552,42528,42672,42768,42816,26472,26568,26328,26568,26376,
     7  26640,26592,26808,26808,26760,26664,26568,26328,25824,25752,
     8  25512,25368,25104,25152,24864,24840,24984,24840,24888,24576,
     9  24168,23688,23592,22632,22488,22248,21888,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     1     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     2     21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
     3     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     4     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     5     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     7     71,   72,   74,   75,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   97,   98,   99,  100,  101/
            data (jb1(i),i=  101,  200)/
     +    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     1    112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
     2    122,  123,  124,  125,  126,    1,   74,  129,  130,  131,
     3    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     4    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb1(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     4    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     5    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     9    292,  293,  294,  295,  296,  297,  298,  299,  300,  301/
            data (jb1(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     1    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     3    332,  128,   73,   73,  334,  335,  336,  337,  338,  339,
     4    340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
     5    350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
     6    360,  361,  362,  363,  364,    1,   74,  366,  367,  368,
     7    369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
     8    379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
     9    389,  390,  391,  392,  393,  394,  395,  396,  397,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   75,   76,   77,   78,   79,   80,   81,   82,
     8     83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
     9     93,   94,   95,   96,   97,   98,   99,  100,  101,  102/
            data (jb2(i),i=  101,  200)/
     +    103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
     1    113,  114,  115,  116,  117,  118,  119,  120,  121,  122,
     2    123,  124,  125,  126,  127,  127,  129,  130,  131,  132,
     3    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     4    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     5    153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     6    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     7    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     8    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     9    193,  194,  195,  196,  197,  198,  199,  200,  201,  202/
            data (jb2(i),i=  201,  300)/
     +    203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
     1    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     2    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     3    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     4    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     5    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     6    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     7    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     8    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     9    293,  294,  295,  296,  297,  298,  299,  300,  301,  302/
            data (jb2(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
     1    313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
     2    323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
     3    333,  333,  128,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,  362,  363,  364,  365,  365,  366,  367,  368,  369,
     7    370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
     8    380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     9    390,  391,  392,  393,  394,  395,  396,  397,  128,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine fl(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(3780) :: jx,jy
            integer(kind=iknd), save, dimension(3850) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'florida       '/
            data jrot,ipart/0,2/
            data kv/   1,2525,3773,   0,   0/
            data kb/   1,2603,3851,   0,   0/
            data iib/1783,1248,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  19824,14112,13896,16392,11568,11256,23808, 9168, 8808,11760,
     1  12576,12648,12624,12360,12456,12552,12624,12528,12576,12552,
     2  12600,12624,12648,12720,12672,12840,12960,13200,13368,13272,
     3  13440,13536,13560,13776,13752,13608,13584,13728,13800,44808,
     4  44880,45072,45096,45000,45144,45216,45480,45456,45528,45552,
     5  45456,45456,45312,45600,45576,45744,45672,45696,45648,45408,
     6  45432,45576,45624,45672,45624,45504,45528,45456,45528,45384,
     7  45336,45336,45408,45384,45264,45360,45264,45120,45048,44952,
     8  44976,44928,44904,44856,44736,44568,44760,44592,44400,44304,
     9  43944,44304,44256,44328,44568,44640,44616,44376,44040,44088/
            data (jx(i),i=  101,  200)/
     +  44184,44256,44400,44400,44232, 9456, 8760, 8616, 8808, 8784,
     1   8976, 9096, 9408, 9816,10056,10392,10536,10776,10536,10464,
     2  10320, 9864, 9960, 9936,10056,10008,10080,10008,10128,10008,
     3   9912, 9864, 9840, 9984, 9912, 9768, 9552, 9432, 9360, 9360,
     4   9144, 9144, 9240, 9240, 9168, 9096, 9096, 9024, 8832, 8856,
     5  13848,13848, 6336, 6384, 6048, 6264, 6576, 6672, 6984, 7056,
     6   7176, 7464, 7512, 7488, 7128, 7296, 7488, 7656, 7752, 7392,
     7   7224, 7200, 7104, 7152, 7224, 7296, 7248, 7248, 7104, 7176,
     8   6720, 6720, 7008, 7008, 6456, 7824, 7920, 7872, 7272, 7224,
     9   7392, 7728, 7872, 7968, 8232, 8232, 7872, 7992, 8136, 8136/
            data (jx(i),i=  201,  300)/
     +   8184, 8496, 8616, 8712, 8736, 8640, 8784, 8760, 8832, 9024,
     1   8904,27576,39264,33912,44760,44664,44496,44352,44376,44520,
     2  44568,44544,44664,44640,44376,44424,44400,44784,44808,44856,
     3  44856,44712,44688,45192,45264,45312,45240,45432,45600,45672,
     4  45576,45600,45696,45792,45792,45888,45936,45984,45864,45864,
     5  45792,45960,46008,45984,46104,46104,46224,16416,31872,37776,
     6  29328,41880,28776,29304,26400,26400,26328,26400,26496,27024,
     7  27024,26928,26832,26808,26856,26736,26760,26808,26784,26880,
     8  26904,27000,27048,27144,27144,27312,27432,27456,27504,27672,
     9  27648,27744,27888,27936,28032,28128,28080,28176,28440,28584/
            data (jx(i),i=  301,  400)/
     +  28584,28776,28944,29184,29256,20256,29376,29376,29712,29808,
     1  29784,29832,30192,30336,30432,30552,30672,30672,30792,30888,
     2  30984,31056,31176,31344,31320,31584,31680,31872,31872,31944,
     3  31920,32040,32136,32448,32544,32760,32856,33048,21264,20232,
     4  20232,44760,44736,44640,44784,44736,44448,44352,44208,44208,
     5  44040,44208,44208,44088,44040,43944,43896,43752,43920,44064,
     6  44208,45216,45312,45096,45048,45096,44976,44832,44856,44976,
     7  44976,45120,45120,45048,44976,44760,44688,44400,44376,44424,
     8  44544,44520,47304,44256,34920,44880,44952,44976,45096,44904,
     9  44616,44448,44472,44592,44592,44784,44736,44640,44424,44208/
            data (jx(i),i=  401,  500)/
     +  44136,44112,44208,44208,44136,44136,44328,44328,44232,33096,
     1  33024,33048,33144,33024,33024,33072,33000,33048,33048,33096,
     2  33048,33192,33192,33264,33312,33384,33456,33504,33624,33720,
     3  33864,33912,34128,34152,34200,34224,34272,34296,34416,34296,
     4  34392,34416,34512,34464,34632,34608,34752,44928,45144,45144,
     5  44952,44568,44640,44736,44688,44808,44784,44616,44424,44280,
     6  44160,44280,44256,44328,44256,44448,44424,44568,44664,44760,
     7  44376,44376,44256,44232,44472,48024,34872,34728,34608,34752,
     8  34848,35040,35184,35160,35256,35160,35184,35328,35232,35352,
     9  35544,35616,35616,35736,35760,35904,36072,36072,36288,36408/
            data (jx(i),i=  501,  600)/
     +  36576,36720,36912,36864,36888,37056,36960,36936,37080,37008,
     1  37080,37224,37176,37248,37176,37176,45048,45216,45120,45240,
     2  44952,45072,45096,44544,44496,44664,44640,44712,44928,44952,
     3  48864,49176,49176,49104,48912,48960,48672,48096,48024,48120,
     4  48840,48840,48912,48912,48840,48792,48840,48984,49128,49248,
     5  49584,50424,49728,49584,49608,37344,37296,37368,37488,37704,
     6  37608,37776,37872,37992,37968,37872,37920,37944,37800,37584,
     7  37584,37728,37680,37800,37776,37896,37944,37896,37824,37920,
     8  50424,50496,50496,50568,50544,50592,50616,50688,50784,50808,
     9  50904,50928,51120,51144,51216,51216,51144,51024,50880,50832/
            data (jx(i),i=  601,  700)/
     +  50904,50832,50784,50904,51192,51168,51216,51144,51192,51072,
     1  51192,51168,51120,51192,51144,51144,51240,51432,51336,51360,
     2  51264,51312,51096,51168,51144,50880,50808,50856,50664,50568,
     3  50184,50016,50040,50160,50040,50064,50112,50136,50184,50208,
     4  50232,50376,50304,50160,50040,50040,49872,49944,37920,37848,
     5  37968,37800,37800,37872,37872,37752,37800,37896,37800,37848,
     6  37728,37776,37704,37680,37728,37632,37704,37704,51168,51360,
     7  51552,51768,51744,51504,51360,51192,51336,51240,51312,51480,
     8  51624,52296,52248,52224,52152,52080,51912,51864,51936,51888,
     9  51768,51792,51528,51288,51144,50880,50472,50496,50400,37776/
            data (jx(i),i=  701,  800)/
     +  36912,37776,37776,38304,38304,51888,38352,52920,53400,53736,
     1  38256,42048,42144,40296,39480,39552,39624,40296,41544,54864,
     2  42960,54600,43056,43080,43224,43104,43200,43176,43224,43224,
     3  43272,43272,43320,43368,43440,43536,43608,43608,43656,43896,
     4  43872,43680,43704,43752,43752,43920,44040,43968,43824,43872,
     5  44136,44208,44184,44064,44112,44016,43848,43776,43776,43728,
     6  43656,43752,43824,43920,43968,44232,44304,44256,44328,44400,
     7  44448,44424,44520,44520,44664,44592,44784,44784,44688,44736,
     8  44856,44856,45024,45048,45168,45120,45216,45264,45480,45576,
     9  45576,45504,45600,45528,45840,46296,46464,46440,46536,46728/
            data (jx(i),i=  801,  900)/
     +  46968,46944,49608,49752,49848,49944,49896,50040,49992,50088,
     1  50160,50160,50232,50280,50376,50520,50376,50496,50664,50688,
     2  50808,50808,50856,50976,50832,50952,51024,51120,51072,50928,
     3  50976,51120,51312,51240,51408,51504,51576,51528,51600,51672,
     4  51648,51792,51792,51696,51480,51528,51600,51744,51768,51816,
     5  51888,52032,52032,51840,51816,51960,52032,52152,52248,52296,
     6  52392,52368,52440,52464,52344,52320,52128,52080,52416,52368,
     7  52488,52584,52752,52800,52656,52608,52536,52584,52488,52608,
     8  52728,52704,52848,52920,53112,53304,53328,53256,53160,53160,
     9  53232,53160,53088,53160,53280,53352,53304,49344,49320,48840/
            data (jx(i),i=  901, 1000)/
     +  48648,48384,48072,47880,47688,47640,47496,47544,47592,47592,
     1  47688,47856,48096,48072,48192,48216,48360,48528,48648,48936,
     2  48960,49152,49296,49272,49176,49128,49128,49032,48960,48864,
     3  48912,48792,48792,48672,48504,48480,48336,48168,48048,48072,
     4  48000,47664,47664,47712,47520,47520,47616,47544,47496,47352,
     5  47232,47280,47424,47616,47664,47712,47688,47952,48048,48096,
     6  48264,48288,48168,48432,48432,48288,48504,48264,48192,47952,
     7  47928,47784,47808,47928,47832,47712,47544,47136,47088,47184,
     8  47040,47064,46992,46992,46872,46800,46848,46752,46776,47184,
     9  47256,47280,47424,47448,47328,47400,47352,47400,47304,47304/
            data (jx(i),i= 1001, 1100)/
     +  47040,47016,46920,23016,23016,23160,23136,23424,23400,23448,
     1  23376,23496,23640,40800,40680,40920,40872,40968,41136,41520,
     2  41784,14328,14520,14760,14904,14880,14928,15048,15192,15216,
     3  15144,15144,15240,15408,15600,15576,15456,15552,15408,15432,
     4  15624,15576,15696,15648,15744,15648,15384,15336,15288,15120,
     5  14856,14712,14736,14760,14928,14832,14616,14544,14400,14304,
     6  14112,13608,13536,13296,13272,13224,13104,13320,41976,41928,
     7  42096,42096,42168,41904,41880,41976,41952,42072,42144,42072,
     8  42120,42216,42336,42408,42480,42552,42840,42840,43080,43464,
     9  43584,43632,43752,44016,44328,44352,44280,44400,44376,44472/
            data (jx(i),i= 1101, 1200)/
     +  44448,44640,44736,44784,44832,44928,45192,45240,45384,45144,
     1  45072,44856,44928,45048,45072,45288,45480,45264,45288,45528,
     2  45432,45504,45408,45432,45360,45384,45288,45240,45288,45168,
     3  45096,44952,44904,14688,17304,18048,18120,17808,18096,18144,
     4  18216,18144,17976,18024,17856,17952,17664,17520,17544,17376,
     5  17328,17376,17256,17448,17592,17640,17832,17904,17928,18024,
     6  18144,18096,18096,18168,18168,18216,18312,18576,18720,18672,
     7  18768,18816,18936,19008,19008,19104,19080,19248,19104,19008,
     8  19056,18936,18960,18888,18792,18768,18456,18504,18432,18432,
     9  18336,18288,18144,18096,18576,18648,18696,18768,18768,19056/
            data (jx(i),i= 1201, 1300)/
     +  19128,19104,19176,19224,19296,19368,19512,19584,19488,19440,
     1  19632,19656,19608,19680,19896,19920,20016,19992,20184,20136,
     2  19992,19968,20088,19728,19680,19512,19464,19296,19320,19128,
     3  19008,18840,18768,18696,18768,18720,18600,18528,18480,18480,
     4  18360,18456,19248,19320,19608,19560,19560,19392,19056,19152,
     5  19368,19560,19968,20232,20376,22056,22344,22464,22728,22848,
     6  22776,22920,22824,23040,23232,23088,23112,23232,23424,23520,
     7  23472,23616,23664,23712,23544,23400,23232,23256,23352,23424,
     8  23640,24312,24600,25800,25968,26016,26184,26352,26880,26784,
     9  26472,26784,26976,27048,27048,26712,26376,20352,20544,20664/
            data (jx(i),i= 1301, 1400)/
     +  20760,20664,20328,20088,20064,20184,20184,20112,20016,20016,
     1  20232,20352,20688,21168,21240,21024,47256,47232,47064,47088,
     2  47184,47016,46944,46848,46776,46728,46728,46800,46872,46968,
     3  46896,46800,46608,46656,46560,46656,46632,46680,46440,46488,
     4  46416,46320,46272,46248,46176,46224,46296,46320,46368,46344,
     5  46560,46728,46776,46800,37488,37488,37560,37416,37440,37344,
     6  37416,37272,37248,37248,37344,37272,37176,37200,37128,37200,
     7  37104,37104,37056,37008,36912,36816,37704,37680,37656,37464,
     8  37584,37440,37872,37896,37320,37248,37464,37488,37728,37968,
     9  38184,38376,37824,37896,37944,38088,38352,37992,37968,38304/
            data (jx(i),i= 1401, 1500)/
     +  38376,38568,38544,38472,38544,38400,38472,38544,38712,38904,
     1  38952,38832,38880,38832,39000,39120,39192,39216,39312,39408,
     2  39336,39240,39336,39264,39336,39432,39408,39456,39504,39408,
     3  39432,39144,39000,38904,38928,39120,39120,39072,39024,38832,
     4  38640,38760,38664,38616,38520,49776,49944,49896,49968,50088,
     5  50064,50208,50304,50952,52008,37128,37056,37008,36984,36792,
     6  36960,36888,36960,36816,36816,36504,36528,36648,36528,36408,
     7  36552,37008,37128,37128,37176,37272,37200,37176,36960,36624,
     8  36552,36696,36840,36864,36984,36984,36912,37008,37080,37008,
     9  37152,37392,37464,37464,37536,37608,37608,37848,37824,37872/
            data (jx(i),i= 1501, 1600)/
     +  37824,37944,37872,37896,37872,38040,37944,37944,38016,38040,
     1  38112,38016,37992,37872,37944,37872,38040,38088,38136,38016,
     2  52008,52080,52728,38304,38424,38400,38232,38208,38232,37992,
     3  38112,38088,38280,38256,38064,38016,37800,37800,38232,38520,
     4  38928,39096,39048,39192,39144,38952,38784,38808,38760,38616,
     5  38616,38760,38760,38592,38520,38184,37992,37752,37512,37608,
     6  37704,37776,37776,37680,37488,37464,37920,38184,53208,53352,
     7  53112,53400,53544,53616,53880,54048,53496,53496,53592,53640,
     8  53568,53784,53856,54024,54096,54216,54288,54816,42096,40224,
     9  40176,40176,54480,54432,54552,54600,54576,54600,38376,38352/
            data (jx(i),i= 1601, 1700)/
     +  38448,38448,38376,38376,38328,38232,38448,38568,38616,38496,
     1  38640,38760,38664,38616,39024,39360,39336,39600,54840,54720,
     2  40416,40440,40584,40704,40704,40776,40824,40752,40872,40824,
     3  41040,41064,40968,40968,41184,41184,41496,41568,41640,41856,
     4  42048,42072,39600,39672,39720,39624,39624,39672,39768,39720,
     5  39912,39864,39768,39744,40056,40080,39912,40080,40032,40200,
     6  40080,40128,40248,40296,40344,40368,40488,40560,40584,40680,
     7  40824,40920,40848,40824,40872,40968,40992,40944,40848,40728,
     8  40392,40368,42120,42192,42000,42048,41328,41352,41592,41640,
     9  41592,41640,42912,42960,43008,43056,42984,43008,42936,42960/
            data (jx(i),i= 1701, 1800)/
     +  42864,42768,42720,42720,42816,42744,42600,42552,42480,42504,
     1  42312,42264,41880,41904,42000,41880,41976,42096,42336,42456,
     2  42480,42648,42768,43488,43032,42744,42672,42672,42528,42552,
     3  42456,42312,42168,42120,42024,42000,41976,41688,41664,41568,
     4  41496,41640,41592,41424,41472,41400,41472,41424,54552,54840,
     5  55128,55080,55056,54960,54936,54984,54960,54984,55056,54648,
     6  54648,54576,54552,54528,54576,54648,54600,54480,54408,54480,
     7  54552,54480,54504,54456,54288,54168,54096,53760,53712,53568,
     8  53688,53496,53448,19632,19608,19488,19320,19128,19104,18984,
     9  18984,18240,18240,18144,18144,17688,17736,17640,17640,17520/
            data (jx(i),i= 1801, 1900)/
     +  16272,23856,23640,23544,23352, 8808, 8736, 8712, 8640, 8640,
     1   8544, 8448, 8328, 8328, 8232, 8136, 8184, 8256, 8112, 8160,
     2   8088, 8160, 8352, 8400, 8664,19896,19872,20184,20112,20448,
     3  21864,21816,41880,43440,43536,43680,43752,43896,43920,43992,
     4  44304,44400,44448,44760,44760,44688,44760,19800,19728,17376,
     5  17184,17016,16920,16800,16704,16464,16536,16752,16992,17064,
     6  17352,17304,17232,17208,17256,17232,17184,17184,17040,17064,
     7  17352,17400,23664,23664,24096,24096,24312,24288,24720,24720,
     8  24936,24936,27432,27432,27216,26928,26808,26736,26784,26736,
     9  26616,26352,26136,25944,25920,25728,25512,25320,25152,39240/
            data (jx(i),i= 1901, 2000)/
     +  34656,34608,34368,34368,34224,34248,34128,34128,34056,24696,
     1  24792,24696,24960,24816,37080,37008,36768,36456,36480,36360,
     2  36240,35856,35304,35256,34776,28800,27744,27696,30456,30480,
     3  30648,30672,30552,30552,30672,30720,30888,30936,31128,31056,
     4  31104,31248,31248,31464,31464,31680,31680,31800,31800,31896,
     5  31920,31872,37560,37608,37536,37728,37728,37848,37824,37920,
     6  37896,37992,38040,38040,37968,37920,37800,37752,37584,37536,
     7  37392,37296,37128,29352,29472,29496,29088,29064,28848,33384,
     8  32712,32736,34128,34536,34536,34392,34392,34272,34224,25728,
     9  25440,25368,25152,25032,25056,24936,24960,24888,24864,24768/
            data (jx(i),i= 2001, 2100)/
     +  24744,24528,24600,20304,23280,23280,23136,23160,22944,22920,
     1  22872,22968,22872,23016,22656,22704,22776,22680,22752,22776,
     2  22608,22608,22704,22608,22536,22560,22632,22536,22536,22488,
     3  22464,22392,22320,22296,22248,22176,22104,22104,22056,22080,
     4  41880,29592,29760,29832,30072,30336,41880,41280,45840,45840,
     5  45168,45168,22728,22608,21912,21960,21912,21960,21864,21960,
     6  21840,21864,21792,21912,21912,22032,22128,22128,22392,22440,
     7  22584,26280,26256,26184,26064,25920,25920,25848,25848,25728,
     8  22656,22608,22560,22464,22416,22584,22440,22272,22200,22008,
     9  21360,39264,39240,38856,38712,38712,38496,38496,38616,38736/
            data (jx(i),i= 2101, 2200)/
     +  38760,37032,37272,37272,36984,41256,41064,41016,40728,40512,
     1  40416,40200,39984,39936,39504,39432,39336,39120,38880,36768,
     2  36624,36480,34104,34200,34128,34248,34200,34272,34272,34536,
     3  34680,34872,34944,34992,35280,35280,35568,35688,35832,35952,
     4  36024,36168,36216,36192,36264,36240,36288,36360,33288,33408,
     5  33408,33624,37896,37680,37440,37200,37200,36216,38712,38448,
     6  38448,38328,38352,38112,38016,36384,36504,41832,39624,40032,
     7  40368,40584,40848,40920,41040,41400,41448,41520,41664,41640,
     8  41760,43392,43056,42672,42552,42144,41976,33600,33432,33408,
     9  33312,45240,46536,46536,46632,46704,46896,46944,47040,47184/
            data (jx(i),i= 2201, 2300)/
     +  36096,36216,36096,36000,36072,36000,36048,35952,36096,35952,
     1  35928,35976,35952,35832,35832,35952,36072,37896,37248,37248,
     2  37128,37128,43824,43824,43608,43608,43176,43176,42888,42816,
     3  42744,42600,42384,42072,41784,39504,38520,38544,37896,36000,
     4  35808,35856,35760,35736,35640,35496,35544,35472,35496,35400,
     5  35448,35208,35232,35160,35232,35184,40776,40920,40776,40752,
     6  40800,40992,41472,41544,41784,45816,45696,45528,45480,45288,
     7  45744,45912,45936,47664,47640,44472,44352,44352,42408,45240,
     8  45408,45672,45744,45912,46032,46200,46320,46248,46344,46320,
     9  46248,39504,38640,38616,37464,37608,38136,38208,38856,39000/
            data (jx(i),i= 2301, 2400)/
     +  39144,39360,39504,39720,40032,40080,45936,45912,40368,39360,
     1  39360,40176,40320,40512,40584,40896,40944,40992,40872,40896,
     2  40728,40464,46272,46344,46296,46560,47160,47280,47376,47472,
     3  47496,47808,47880,48144,48288,48240,48528,48504,48600,48600,
     4  48720,48720,46512,46488,45648,45648,45792,45912,48864,48888,
     5  40296,40392,40392,40680,41016,41112,41232,41376,41472,41664,
     6  41736,41712,40416,40416,44424,44424,44328,44328,44400,44352,
     7  44328,43440,43464,43008,43008,42360,49560,49392,49416,49320,
     8  49320,49488,49440,49056,49104,48984,41712,41928,42096,42168,
     9  42360,41712,41376,41376,37776,49512,41688,41664,44928,47712/
            data (jx(i),i= 2401, 2500)/
     +  44328,44976,45192,45192,45648,45648,46368,46344,46248,46248,
     1  46176,46152,46056,45816,45720,45648,45624,45768,45888,46104,
     2  46176,46320,46344,46416,46416,46368,46392,46584,46656,46872,
     3  47064,47208,47520,47472,47568,47544,47664,47712,47784,49440,
     4  49488,50760,50112,50112,49032,48960,48888,48768,48648,48648,
     5  48480,48360,48360,48432,48384,48192,47880,47712,47664,47520,
     6  47448,47304,47256,47328,47592,47712,41640,44904,53400,41640,
     7  40320,40344,50784,41616,44904,47520,47520,46872,46872,46440,
     8  46440,46368,46368,40296,49080,49248,49248,49416,49512,49464,
     9  40296,44880,45576,45576,45744,45744,49128,44880,49440,53808/
            data (jx(i),i= 2501, 2600)/
     +  53976,54672,49416,49464,44880,44232,44256,43176,43176,46824,
     1  46848,49512,50808,50808,53376,53376,49512,49512,49512,49584,
     2  53400,50784,54360,54360,53976,53328,53208,53352,53304,53424,
     3  53520,53592,53664,53568,53712,53880,53976,54048,54192,54168,
     4  54240,54216,53064,52992,52920,52824,52704,52728,52488,52464,
     5  52344,52392,52272,52344,52776,52968,53088,53160,53328,53280,
     6  53208,53232,53184,53136,53112,53160,53064,45960,45912,45936,
     7  46608,46584,46488,46416,46368,46392,46536,46632,37824,37704,
     8  37512,37464,37752,38112,38160,37968,37968,40464,40512,40584,
     9  40344,40344,40392,40152,40224,40224,40320,40224,40176,40200/
            data (jx(i),i= 2601, 2700)/
     +  36624,36624,36552,36528,36504,36456,36504,48048,48072,47808,
     1  47808,48456,48384,48192,48072,45408,45408,45504,43224,43224,
     2  43296,43272,43560,43512,43200,43128,43248,43368,43632,43752,
     3  43656,43632,43584,49776,49968,50016,50016,50112,50064,49680,
     4  49656,49296,49176,49272,48648,48816,49080,49056,48648,48456,
     5  48624,48528,48504,47952,48000,47952,47856,51336,51288,51408,
     6  51432,50664,50712,50712,51144,50976,50952,51216,51264,50616,
     7  50400,50424,50664,50760,50304,50232,50280,50328,53712,53664,
     8  53736,53832,53784,54168,54192,54216,54144,54024,54192,54024,
     9  53880,53856,53976,54072,54048,54144,54264,54408,54360,54192/
            data (jx(i),i= 2701, 2800)/
     +  54384,54336,54264,54168,54264,54168,54312,54480,54432,54408,
     1  54456,45048,45000,44976,45072,45288,45240,45168,45288,45312,
     2  44064,43992,43848,43824,43968,43992,44136,44088,44040,44952,
     3  44904,44952,45096,44712,44664,44712,45240,45288,45264,45144,
     4  45096,45168,44952,44904,44976,45360,45360,45408,44880,44856,
     5  44952,44328,44256,44304,44448,44520,44520,44400,44040,43992,
     6  44088,45072,45024,45072,44616,44544,44592,44664,44208,44064,
     7  44090,44208,44136,44112,43968,44112,43968,43944,44016,44568,
     8  44568,44592,44712,44568,44112,44184,44112,44016,44904,44880,
     9  44952,43536,43560,43656,43656,43464,43320,43344,43464,43728/
            data (jx(i),i= 2801, 2900)/
     +  43632,42888,42912,42840,42384,42168,42168,42624,42696,42648,
     1  42576,42744,42792,42840,42768,42936,42960,42816,41760,41712,
     2  41808,41232,41136,41064,41136,41064,40872,40872,40752,40920,
     3  41112,41160,41208,41208,41400,41424,41520,41328,41784,41736,
     4  41832,41256,41280,41352,41112,41112,41184,41016,40992,41040,
     5  41544,41616,41544,41496,41448,41280,41376,41496,40560,40560,
     6  40632,40584,40488,41472,41424,41400,41448,55104,55104,55056,
     7  55032,55080,55104,40968,40968,40920,40320,40368,40536,40488,
     8  40248,40272,41424,41376,41424,40584,40512,40560,40728,40728,
     9  40656,40656,40512,40440,40440,40752,40704,40728,40776,41424/
            data (jx(i),i= 2901, 3000)/
     +  41352,41400,40800,40776,40872,40848,40944,40848,40776,41400,
     1  41376,41400,40776,40752,40800,40608,40560,40632,40416,40512,
     2  40416,40344,40560,40512,40584,40680,40632,40704,40392,40344,
     3  40392,40584,40560,40656,40752,40704,40752,41568,41520,41544,
     4  38160,38208,38280,38232,38136,37440,37464,37416,37320,37128,
     5  37272,37224,37392,37704,37728,37656,37632,37488,37512,37608,
     6  37512,37536,38040,37968,37872,37344,37440,37392,37152,37128,
     7  37200,37224,37272,37296,38136,38064,38064,37056,36984,37032,
     8  37056,37584,37536,37560,37272,37320,37296,37248,37536,37536,
     9  37584,37608,37920,37968,37944,38760,38808,38808,38712,38688/
            data (jx(i),i= 3001, 3100)/
     +  38760,39120,39120,39072,39024,39048,36648,36648,36600,36600,
     1  36624,36648,36672,36600,37752,37704,37752,37680,37512,37512,
     2  37416,37392,37560,37608,37608,37704,37752,37680,37728,37848,
     3  37896,37776,37752,37488,37392,37392,37536,37872,37824,37896,
     4  37872,37632,37584,37632,37680,36816,36792,36864,36888,36912,
     5  36960,36888,36840,35184,35184,35112,35112,35064,35016,34992,
     6  35328,35400,35256,35304,35232,35256,35304,35280,35592,35520,
     7  35520,35232,35208,35160,35208,33192,33120,33192,24000,24024,
     8  23904,23184,23208,23016,22560,22344,22032,22320,22536,24120,
     9  24648,24648,24600,24456,24144,24120,24192,33024,32976,33000/
            data (jx(i),i= 3101, 3200)/
     +  21240,21576,21912,21744,21960,22224,22056,21888,22992,22872,
     1  22992,25488,25440,25152,24936,24840,25104,25296,25416,25440,
     2  27048,27120,27024,26952,26904,26952,26976,27072,18384,18576,
     3  18360,18096,18120,18744,18792,18840,18768,45864,45864,45960,
     4  45912,45720,45720,45624,45528,45504,45552,45648,45600,45720,
     5  45648,45696,45840,45864,45792,45552,45624,45504,45504,45432,
     6  45552,45624,45552,45504,45552,45360,45168,45312,45456,45624,
     7  45528,45456,45528,40968,41160,41064,41088,41208,41184,40992,
     8  40896,40776,40824,40848,40776,35952,35880,35904,35832,35808,
     9  35808,42384,42432,42408,44136,44256,44256,44088,44280,44040/
            data (jx(i),i= 3201, 3300)/
     +  43776,43872,43824,43872,43968,44016,44112,46776,46872,47016,
     1  45984,45984,46032,46008,36096,36048,36096,46536,46536,46656,
     2  45840,45768,45840,45936,45648,45504,45624,45720,45000,45192,
     3  45192,44520,44472,44592,44496,44400,44352,44496,44424,44424,
     4  44592,44472,44544,44688,44664,44544,44592,44664,44712,44760,
     5  44832,44880,44832,45048,45120,45096,45024,44976,44808,44808,
     6  44880,45840,45816,45888,45936,44376,44352,44256,44184,45168,
     7  45120,45240,45360,45432,45456,45408,45168,45144,44160,44112,
     8  44064,44112,45384,45456,45504,45480,45384,46032,46200,46272,
     9  46272,46416,46392,46224,46344,46296,46152,46152,45936,45984/
            data (jx(i),i= 3301, 3400)/
     +  46464,46440,46560,46608,44640,44712,44760,44664,46392,46512,
     1  46536,46488,46416,46344,46344,45624,45576,45552,45600,51096,
     2  51000,51048,50448,50424,50496,50496,50760,50664,50712,48504,
     3  48552,48576,50256,50328,50328,50496,50448,50496,49824,49752,
     4  49800,46656,46680,46752,45600,45552,45576,45648,45672,46128,
     5  46080,45984,46080,45360,45288,45288,45360,45744,45888,45912,
     6  45720,45672,45792,45768,45600,45600,50904,50880,50952,51048,
     7  52152,52200,52200,52128,51072,51072,51144,51096,49440,49488,
     8  49440,51312,51384,51456,51336,51624,51576,51552,52296,52320,
     9  52368,52488,52488,52344,50640,50664,50592,50592,50040,50088/
            data (jx(i),i= 3401, 3500)/
     +  50136,49776,49800,49848,50808,50760,50832,53664,53712,53664,
     1  53568,53520,53016,52944,52944,53040,52920,52872,52608,52656,
     2  52416,52296,52104,52056,51816,51624,51480,51432,51624,51720,
     3  51720,51912,51936,52296,52176,52248,52344,52392,52488,52416,
     4  52560,52560,52680,52872,52824,52920,53016,53136,53160,52944,
     5  53184,53280,53448,53568,48240,48168,48168,48240,48312,48336,
     6  48240,48192,48864,48888,48864,48816,49008,49008,49104,49056,
     7  48336,48432,48336,48192,48840,48792,48888,49008,49104,49176,
     8  49104,48984,49032,49032,48912,48504,48384,48648,48648,48504,
     9  48600,48576,48648,48720,48744,48840,48840,48672,48264,48216/
            data (jx(i),i= 3501, 3600)/
     +  48216,48288,48000,47976,48048,47952,47832,48000,48024,47928,
     1  47856,47976,48168,48120,48192,47928,47880,48048,48048,48240,
     2  48192,48192,48288,47856,47952,47928,47832,47640,47712,48024,
     3  48000,48024,48648,48744,48624,47832,47880,47784,47736,48000,
     4  48024,47880,47952,46800,46872,46968,46920,46992,46872,46752,
     5  46776,46488,46320,46416,46344,46416,46320,46272,46248,46152,
     6  46200,46536,46728,46776,46680,46776,46800,46656,46680,46632,
     7  46608,46536,46200,46272,46272,46152,46056,46080,46800,46848,
     8  46872,46800,46152,46104,46152,46296,46224,46296,47112,47136,
     9  47064,47040,45984,45960,46032,45504,45408,45432,45552,45360/
            data (jx(i),i= 3601, 3700)/
     +  45408,45432,45360,45552,45504,45456,45480,45576,45768,45864,
     1  45888,45408,45384,45432,45456,45648,45648,45528,45576,45696,
     2  45672,45816,45936,45792,45744,40896,40968,41160,41256,41256,
     3  41376,41352,41424,41544,41568,41520,41544,41784,41400,41112,
     4  40728,40632,40680,40800,41088,41016,41040,41184,41112,41088,
     5  41232,41184,41184,50496,50568,50520,50448,37632,37608,37656,
     6  37752,37704,37752,37584,37536,37584,37488,37440,37512,37704,
     7  37632,37680,37776,37776,37584,37608,37560,37632,37728,37680,
     8  37728,37608,37536,37608,37656,37608,37656,37584,37632,37752,
     9  37584,37560,37656,37824,37752,37824,37704,37656,37704,35112/
            data (jx(i),i= 3701, 3780)/
     +  35040,35040,34584,34536,34560,44496,44472,44424,44448,44568,
     1  44304,44328,44376,27960,27888,27888,45864,45768,45696,45744,
     2  45816,45960,44904,45072,45192,45312,45192,45168,45096,45960,
     3  46008,45984,46056,45984,45936,45960,45912,45888,45816,45648,
     4  45696,45912,45840,45192,45168,45192,45408,45360,45288,45432,
     5  45432,45336,10920, 8448, 8184, 7968, 8304, 8544, 8928, 8952,
     6   8976, 9072, 9648, 9696,11256,12192,12744,13080,12192,11256,
     7  10920,10920,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  58176,58416,54384,58320,58584,54168,55896,58728,55368,54192,
     1  54096,54144,54240,54312,54336,54288,54384,54432,54480,54528,
     2  54528,54672,54528,54528,54312,54264,54432,54456,54576,54936,
     3  54648,54696,54840,54792,54744,54768,54696,54384,54456,54384,
     4  54192,54192,54072,54000,53880,53928,53880,53808,53736,53904,
     5  54000,54192,54312,54096,53928,53544,53400,53256,53136,53136,
     6  53232,53328,53208,53280,53352,53376,53448,53448,53520,53472,
     7  53520,53448,53400,53232,53256,53328,53352,53256,53136,53232,
     8  53328,53328,53472,53280,53448,53472,53280,53160,53184,53328,
     9  53328,53280,53136,53160,53088,52896,52632,52608,52368,52248/
            data (jy(i),i=  101,  200)/
     +  52272,52032,51960,51840,51624,54048,53832,53976,54024,54072,
     1  54024,54120,54240,54216,54312,54576,54456,54432,54528,54624,
     2  54672,54984,55032,55128,55128,55224,55248,55272,55464,55560,
     3  55728,55752,55632,55464,55296,55248,54600,54576,54624,55176,
     4  55224,55296,55320,55440,55344,55392,55464,55584,55632,55392,
     5  53832,54000,58872,58536,57912,57552,57240,56952,56736,56592,
     6  56568,56376,56208,55896,55200,54816,54720,54720,54528,54336,
     7  54360,54144,54096,54000,54120,54096,54048,53928,53808,53760,
     8  53760,53736,53688,53592,53448,53664,53736,53760,53616,53640,
     9  53736,53808,53784,53880,53880,54048,54072,54144,54096,54168/
            data (jy(i),i=  201,  300)/
     +  54096,54336,54288,54384,54528,54696,54600,54408,54432,54912,
     1  55272,55608,54576,55032,51168,51240,51168,51288,51384,51456,
     2  51624,51696,51840,51960,52272,52416,52536,52560,52416,52392,
     3  52584,52608,53088,52848,52872,53016,53136,53064,53112,53016,
     4  53064,52920,52968,52848,52560,52488,52296,52368,52608,52800,
     5  53016,53136,53136,53064,53136,52608,52080,52920,55224,54720,
     6  55464,52920,51288,51096,50376,50496,50520,50544,50400,50280,
     7  50376,50400,50592,50544,50472,50496,50784,50736,50640,50640,
     8  50928,51000,51072,51048,51096,50928,51024,50952,51288,51288,
     9  51192,51144,51288,51408,51216,51216,51048,51024,51192,51144/
            data (jy(i),i=  301,  400)/
     +  51264,51168,51216,51168,51264,51144,51192,51024,50736,50808,
     1  50712,50640,50472,50304,50328,50256,50376,50208,50112,50136,
     2  49968,50016,49872,49848,49728,49512,49200,49056,48912,48816,
     3  48624,48600,48360,48240,48048,47952,47976,47904,48408,50976,
     4  50160,49008,49368,49464,49752,49920,50088,50112,50328,50472,
     5  50568,50760,51240,51312,51168,51144,50904,51048,51312,51384,
     6  51360,48432,48480,48744,49056,49176,49224,49512,49656,49728,
     7  49920,49920,49968,50160,50040,50136,50328,50448,50568,50784,
     8  50880,51072,47736,45528,45336,48744,48720,48624,48480,48120,
     9  48096,48024,47832,47712,47496,47472,47280,47208,47256,47208/
            data (jy(i),i=  401,  500)/
     +  47040,46824,46560,46368,46296,46032,45864,45696,45720,47760,
     1  47520,47400,47352,47352,47256,47208,47160,47136,46944,46944,
     2  46776,46752,46656,46632,46680,46536,46536,46440,46440,46200,
     3  46080,46200,46128,46032,46080,46008,46032,45792,45792,45720,
     4  45696,45576,45600,45480,45360,45216,45336,45360,48384,48120,
     5  48000,47952,47736,47640,47544,47472,47232,47136,47208,47160,
     6  46872,46632,46224,46200,46032,45936,45720,45648,45504,45552,
     7  45432,45312,45312,45192,44856,45936,45240,45240,45072,45072,
     8  44976,44952,44832,44688,44616,44592,44400,44424,44352,44160,
     9  44184,44136,44208,44232,44160,44256,44208,44136,44136,44064/
            data (jy(i),i=  501,  600)/
     +  44136,44040,44136,44040,43800,43728,43680,43560,43416,43368,
     1  43320,43320,43176,43056,43032,42816,45120,45000,44808,44520,
     2  44328,44280,44160,44688,44592,44496,44352,44304,44280,44208,
     3  43968,43416,43344,43368,43656,43680,44232,45552,45384,45384,
     4  43680,43584,43584,43464,43464,43416,43392,43440,43224,43272,
     5  42624,41208,41208,41304,41208,42768,42648,42504,42336,42216,
     6  42144,42144,42024,42024,41664,41592,41544,41232,41472,41424,
     7  41352,41328,41256,41160,41040,41088,41064,40824,40872,40560,
     8  39168,39480,39312,39384,39264,39288,39624,39648,39576,39624,
     9  39672,39792,39744,39600,39648,39456,39168,39072,38640,38208/
            data (jy(i),i=  601,  700)/
     +  37608,37848,37896,37248,36576,37152,37320,37632,37704,37848,
     1  37872,38184,38232,38256,38304,38448,38496,39408,39528,39600,
     2  39720,39768,39936,39840,39816,39936,39816,39720,39696,39792,
     3  39840,39984,40224,40344,40320,40464,40488,40416,40488,40416,
     4  40560,40584,40584,40848,40872,40992,41016,41064,40440,40416,
     5  40296,40248,40176,40176,40080,39912,39816,39816,39672,39360,
     6  39336,39240,39216,39120,39000,38832,38784,38616,40008,39816,
     7  39216,38784,38664,38592,38376,38376,38328,37824,36912,36072,
     8  35712,34344,34296,34392,34392,34680,34824,34944,34944,35064,
     9  35208,35280,35760,36408,36528,37080,38184,38832,38976,35568/
            data (jy(i),i=  701,  800)/
     +  36696,35232,35136,34608,34488,34032,32760,32064,29640,29880,
     1  30864,28176,28200,27984,27552,27552,27552,27912,26232,22872,
     2  22944,20304,22680,22776,22608,22560,22080,21840,21768,21192,
     3  21144,21216,21216,21576,20904,20880,20952,20784,20760,20832,
     4  20736,20592,20496,20448,20520,20448,20472,20424,20424,20304,
     5  20424,20400,20208,20208,20112,20040,20232,20208,20304,20232,
     6  20280,19848,19896,19824,19992,19872,19920,20016,20016,19920,
     7  19992,20064,20112,20016,20016,19896,19920,19776,19800,19704,
     8  19704,19872,19920,19752,19848,19752,19800,19656,19752,19704,
     9  19656,19656,19584,19536,19488,19176,19392,19320,19176,19032/
            data (jy(i),i=  801,  900)/
     +  19080,19008,14376,14376,14256,14352,14424,14424,14208,14280,
     1  14256,14112,14280,14256,14112,14136,14232,14304,14112,14280,
     2  14352,14280,14352,14304,14160,14136,14328,14376,14400,14400,
     3  14496,14496,14592,14424,14496,14616,14592,14520,14520,14568,
     4  14640,14544,14664,14736,14688,14856,14880,14808,14880,14784,
     5  14856,14856,14712,14736,14688,14688,14568,14664,14664,14568,
     6  14544,14376,14400,14568,14592,14712,14688,14760,14880,14760,
     7  14736,14520,14448,14568,14592,14760,14760,14832,14880,15072,
     8  15072,15192,15264,15480,15528,15840,15960,15936,16032,16248,
     9  16320,16368,16584,16992,17064,17304,17568,14280,14112,14064/
            data (jy(i),i=  901, 1000)/
     +  13968,14016,13920,14136,14232,14568,14736,15072,15096,15264,
     1  15480,15480,15216,15072,15072,14880,14784,14760,14640,14592,
     2  14688,14688,14928,15048,15024,15072,15192,15144,15312,15336,
     3  15456,15504,15600,15624,15504,15576,15576,15744,15768,15840,
     4  15888,15912,16056,16104,16440,16560,16608,16680,16608,16656,
     5  16824,17064,17184,17208,17304,17256,17160,17208,17184,17064,
     6  17160,17112,16992,16920,17016,17232,17232,17352,17304,17400,
     7  17520,17520,17592,17568,17664,17592,17256,17208,17328,17352,
     8  17472,17592,17664,17760,17904,17856,18024,18120,18192,18432,
     9  18360,18144,18144,18264,18264,18336,18408,18504,18408,18528/
            data (jy(i),i= 1001, 1100)/
     +  18720,18792,18768,58104,57888,57792,57600,57216,57000,56904,
     1  56760,56232,56208,54456,54240,53832,53376,53040,52896,52944,
     2  52872,54552,54504,54576,54696,54552,54504,54528,54696,54600,
     3  54528,54480,54336,54336,54552,54432,54336,54336,54288,54168,
     4  54120,54048,53904,53880,53808,53736,53784,53880,53856,53928,
     5  54168,54096,54000,54048,53952,53904,53976,53928,54192,53880,
     6  53904,54072,54024,54144,54096,54120,54024,53880,53016,53280,
     7  53760,54120,54456,55104,55248,55488,55800,55824,55896,56040,
     8  56088,56088,55992,56040,56280,56352,56280,56376,56112,56088,
     9  56016,55872,55968,55752,55704,55752,55776,55800,55752,55728/
            data (jy(i),i= 1101, 1200)/
     +  55632,55680,55536,55608,55536,55584,55464,55560,55536,55392,
     1  55464,55488,55416,55416,55344,55248,55272,55104,55032,55176,
     2  54960,54864,54744,54648,54528,54456,54408,54312,54264,54144,
     3  54288,54216,54360,53616,52392,51768,51816,52080,51936,51840,
     4  51936,52056,52080,52440,52512,52632,52728,52632,52560,52584,
     5  52800,52944,53184,52992,52992,53064,52992,53088,53232,52920,
     6  52920,52896,52776,52776,52584,52584,52800,52824,52944,52776,
     7  52800,52896,52824,52944,53160,53208,53088,52920,53040,52824,
     8  52752,52776,52632,52680,52632,52728,52680,52584,52584,52464,
     9  52464,52296,52296,52200,51984,51816,51984,51912,51840,51672/
            data (jy(i),i= 1201, 1300)/
     +  51696,51792,51864,51720,51744,51696,51816,51792,51744,51528,
     1  51480,51384,51360,51096,51096,51312,51336,51168,51072,51048,
     2  51096,51000,50976,50880,50952,51000,51168,51240,51384,51528,
     3  51504,51552,51504,51648,51696,51744,51720,51792,51744,51864,
     4  51744,51624,51024,50856,50592,50616,50544,50664,51096,50856,
     5  50616,50496,50376,51072,50880,48576,48552,48480,48528,48648,
     6  48768,48720,48840,48744,48960,49032,49128,49032,49008,49080,
     7  49200,49152,49224,49080,49056,48744,48672,48624,48624,48552,
     8  48744,49008,49224,49896,49920,49848,49968,50016,49800,49752,
     9  49800,49704,49728,49848,50088,50232,50232,50040,49632,49512/
            data (jy(i),i= 1301, 1400)/
     +  49104,48408,48360,49104,49464,49776,49800,49776,49608,49320,
     1  48408,48240,48336,48288,48360,48384,48000,47808,48072,48144,
     2  48096,48576,49272,49464,49488,49416,48960,48840,48840,48456,
     3  48456,48720,48912,49008,49272,49296,49464,49584,50016,50088,
     4  50256,50280,50448,50904,51144,51168,51000,50760,50688,50520,
     5  50136,49584,49536,49584,38520,38472,38424,38352,38136,37992,
     6  37896,37824,37704,37632,37680,37560,37512,37320,37296,37200,
     7  37200,37032,37080,36960,36984,36816,35424,35424,35616,35736,
     8  35448,35232,35136,35208,35088,34944,34824,34848,34752,34536,
     9  34536,34584,35544,35424,35520,35328,35256,35256,35160,35112/
            data (jy(i),i= 1401, 1500)/
     +  35184,34920,34656,34608,34488,34368,34344,34128,34152,34056,
     1  34224,34416,34560,34776,34968,34968,34872,34992,35040,34992,
     2  34848,34872,34752,34680,34656,34488,34320,34296,34152,33984,
     3  33864,33600,33504,33504,33336,33312,33096,33072,33240,33240,
     4  33096,33048,32952,33000,33000,40176,39912,39840,39480,39312,
     5  39120,38832,38376,36672,34320,36576,36576,36480,36576,36696,
     6  36240,36072,36000,35640,35352,34608,34920,35112,35088,34464,
     7  34128,33600,33360,33072,33048,33120,33168,33432,33816,34104,
     8  34248,34176,34008,34032,33960,34080,34224,34128,34248,34032,
     9  33600,33456,33480,33312,33168,33168,33216,33240,33480,33552/
            data (jy(i),i= 1501, 1600)/
     +  33624,33648,33696,33792,33864,33864,33936,34080,34056,33984,
     1  34056,34128,34200,34200,34272,34320,34320,34176,34248,34416,
     2  34200,34176,32904,32544,32472,32424,32472,32400,32328,32304,
     3  32232,32136,32232,32064,31896,31968,32016,31944,31776,31776,
     4  31944,31920,31872,31848,31776,31848,31776,31824,31848,31752,
     5  31680,31536,31464,31584,31728,31704,31752,31896,31872,31632,
     6  31728,31728,31512,31464,31536,31488,31152,31080,31032,29712,
     7  29760,29496,29424,29520,29520,29208,29424,29304,29088,29136,
     8  29352,29448,29424,29136,29136,28992,29064,27696,28272,28128,
     9  28128,27984,27696,27696,27696,27696,27792,27576,30600,30456/
            data (jy(i),i= 1601, 1700)/
     +  30432,30168,30072,30216,30240,30048,29856,29544,29592,29904,
     1  29712,29352,29472,29472,28416,27816,27936,27648,27552,27552,
     2  27936,27744,27672,27696,27792,27792,27720,27624,27576,27480,
     3  27384,27432,27432,27480,27528,27672,27600,27600,27696,27672,
     4  27912,28032,27264,27240,27264,27336,27480,27480,27480,27408,
     5  27024,27048,27192,27120,26640,26688,26928,26808,27024,27120,
     6  26976,26808,26640,26616,26736,26568,26520,26664,26544,26496,
     7  26688,26592,26568,26424,26352,26376,26472,26832,27240,27504,
     8  27696,27840,28008,27984,27792,27648,27360,27120,27024,26952,
     9  26712,26520,23160,23184,23088,23136,23496,23640,23760,23856/
            data (jy(i),i= 1701, 1800)/
     +  23856,24120,24120,24000,23856,23760,23832,23952,23952,23832,
     1  24048,24024,24120,24192,24168,24312,24384,24264,24480,24480,
     2  24672,24840,25272,25776,25632,25416,25440,25344,25176,25008,
     3  24888,24504,24528,24456,24456,24576,24480,24408,24576,24552,
     4  24744,24912,25224,25416,25488,25632,25680,25824,27504,27480,
     5  26472,26304,26544,26808,26736,25536,24600,24528,24552,21288,
     6  21192,21216,21288,21264,21120,21168,19224,18792,18912,19320,
     7  19368,19560,20112,19800,19608,19296,18720,18432,18216,18216,
     8  18144,17736,17784,58008,57744,57720,57480,56976,56712,56520,
     9  56328,56376,56592,56592,56712,56736,56688,56496,56256,56088/
            data (jy(i),i= 1801, 1900)/
     +  56160,55800,55536,55248,55128,58440,58440,58512,58464,58368,
     1  58248,58272,58200,57912,57888,57648,57600,57360,57192,57048,
     2  56784,56688,56640,55872,55416,56928,56616,56592,54960,54960,
     3  55200,54888,52248,53808,53976,53976,54168,54144,54312,54408,
     4  54360,54288,54456,54552,54408,54360,54336,54984,54000,54144,
     5  53928,53904,53976,53928,53952,53784,54072,54192,54144,54192,
     6  54504,54648,54624,54792,54864,55032,55056,55200,55344,55608,
     7  55800,56016,55128,54576,54576,54456,54456,54024,54000,53688,
     8  53664,53472,55512,55248,54960,54792,54360,54312,54144,54072,
     9  53976,53928,53952,53880,53808,53784,53616,53616,53448,51264/
            data (jy(i),i= 1901, 2000)/
     +  53184,53376,53472,53784,53928,54240,54456,54768,54960,52824,
     1  52944,53040,53304,53472,52776,52824,52824,53064,53160,53136,
     2  53208,53472,53472,53592,53424,52488,52512,52752,52680,52752,
     3  52776,52848,52992,53184,53304,53232,53256,53448,53640,54216,
     4  54288,54288,54384,54384,54504,54504,54600,54600,54720,54696,
     5  55128,55128,54456,54216,54168,53904,53808,53760,53688,53640,
     6  53568,53496,53352,53208,53184,52992,52944,52752,52656,52752,
     7  52632,52728,52704,54792,54576,54312,54336,53904,53688,52296,
     8  52296,52632,52272,53112,52944,52896,52632,52536,52272,50616,
     9  50760,50904,51072,51288,51432,51504,51912,51984,52224,52296/
            data (jy(i),i= 2001, 2100)/
     +  52440,52560,52752,52224,55056,54960,54960,54840,54504,54264,
     1  54192,54096,54000,53952,53784,53712,53712,53640,53592,53520,
     2  53424,53376,53352,53304,53160,53016,52968,52968,52896,52920,
     3  52608,52512,52536,52368,52368,52248,52296,52224,52224,52152,
     4  51600,51816,51864,52224,52416,52488,51288,51288,52080,50976,
     5  50976,51096,50736,50448,51960,51864,51768,51744,51600,51528,
     6  51504,51408,51360,51288,51000,50832,50856,50784,50688,50592,
     7  50544,50328,50472,50544,50448,50448,50400,50400,50568,50568,
     8  50256,50280,50160,50088,49896,49200,49008,49080,48936,49008,
     9  48528,51168,51000,50856,50616,50472,50304,50088,49968,49920/
            data (jy(i),i= 2101, 2200)/
     +  49824,50184,50184,50088,49776,51048,50904,50736,50496,50424,
     1  50184,49896,49920,49776,49680,49656,49728,49728,49824,49632,
     2  49632,49440,52104,52008,51720,51576,51456,51360,51168,51024,
     3  51144,51048,51096,51000,50928,50808,50616,50376,50352,50256,
     4  49992,49944,49776,49704,49584,49488,49464,49560,49512,49512,
     5  49032,49032,49008,49032,49224,49536,49728,48984,49728,49608,
     6  49512,49392,49248,49128,48984,49008,49296,48120,49416,49320,
     7  49080,49128,49080,49104,49008,48984,48720,48624,48552,48432,
     8  48384,48984,48720,48624,48336,48288,48120,48696,48432,48072,
     9  47904,47400,47400,47616,47544,47592,47616,47736,47664,47736/
            data (jy(i),i= 2201, 2300)/
     +  48864,48768,48696,48480,48408,48240,48192,48216,48096,48096,
     1  47856,47760,47616,47520,47400,47208,47256,47040,47016,47136,
     2  47136,47184,45528,45960,45960,46392,46392,46656,46584,46608,
     3  46536,46632,46536,46488,46296,46416,46392,46824,46824,47016,
     4  46872,46752,46704,46344,46320,46056,46008,45984,45840,45816,
     5  45744,45648,45576,45504,45480,45432,46392,46176,46128,46056,
     6  45960,45912,46056,45960,46080,45720,45648,45720,46080,46416,
     7  45600,45744,44712,44736,45816,43128,43128,42480,42480,44040,
     8  43512,43464,43224,43056,43032,42720,42672,42528,42192,41928,
     9  41856,44424,44424,43152,43080,43104,42912,43032,43128,43200/
            data (jy(i),i= 2301, 2400)/
     +  43152,42960,42936,42816,42600,42504,41184,41424,40344,40320,
     1  40560,42432,42048,41880,41736,41496,41328,41280,41136,41040,
     2  40968,40704,41760,41736,41640,41520,41520,41304,41208,41256,
     3  41160,41280,41472,41400,41136,40896,40488,40344,40248,40056,
     4  39960,39888,39864,40080,40104,40632,40680,40848,41208,39816,
     5  40248,40200,40104,39648,39576,39600,39432,39384,39264,39288,
     6  39240,38928,38928,38592,41184,41064,41040,39768,39672,39576,
     7  37920,37920,38040,38040,37920,37920,37920,38208,38352,38544,
     8  38760,38832,39072,39312,39528,39768,37680,37776,37728,37632,
     9  37656,37296,37296,36648,36696,34008,36624,32736,32712,32688/
            data (jy(i),i= 2401, 2500)/
     +  37272,37272,36840,36408,36408,35976,35976,35832,35832,35616,
     1  35544,35424,35544,35640,35784,35760,35640,35592,35328,35352,
     2  35184,35088,34992,34968,34896,34896,34824,34752,34320,34224,
     3  34200,34104,33576,33480,33384,33312,33192,32880,32808,34008,
     4  32664,32040,32064,32688,29472,29544,29520,29616,29880,30096,
     5  30168,30384,30480,30504,30600,30744,30816,30984,31248,31344,
     6  31488,31560,31848,31968,32160,32376,30432,30432,29880,29472,
     7  29496,30816,29424,28176,28152,29448,28800,28800,28152,28152,
     8  28200,28200,28152,28176,29376,29304,29208,29136,28992,27600,
     9  27528,26208,26184,26304,26304,26184,26184,24288,22968,22968/
            data (jy(i),i= 2501, 2600)/
     +  22920,22944,25752,22392,23616,23616,22848,22848,22944,24312,
     1  22344,20328,20328,20160,20160,20280,19032,15816,15744,15768,
     2  29448,28824,27696,27600,29880,31416,31320,31296,31152,31104,
     3  30888,30552,30552,30504,30456,29880,29784,29472,29376,29208,
     4  29184,29400,32064,32376,32448,32928,33144,33288,33600,33816,
     5  33888,34032,34224,34272,33336,32568,32376,32040,31512,31440,
     6  31464,31656,31536,31632,31824,31848,31944,19008,19008,18936,
     7  19008,19080,19080,19200,19104,19008,18936,18960,30864,31080,
     8  31248,31200,30864,30432,30480,30672,30792,26328,26376,26256,
     9  26352,26304,26352,26376,26376,26280,26184,25872,25896,26184/
            data (jy(i),i= 2601, 2700)/
     +  35880,36048,35928,36696,36648,36696,36888,10776,10896,10848,
     1  10920,11088,10992,10920,10728,10248,10176,10152, 9984,10056,
     2  10032, 9888, 9792, 9720, 9696, 9720, 9840, 9816, 9960, 9840,
     3   9768, 9864, 9864,11664,11856,11832,11712,11736,11640,11568,
     4  11592,11328,11328,11400,11160,11208,11400,11304,11016,10992,
     5  11088,11064,11112,10800,10824,10752,10800,12624,12672,12744,
     6  12672,12384,12336,12288,12408,12288,12336,12648,12552,12024,
     7  11904,12000,12192,12192,11808,11832,11904,11856,15720,15792,
     8  15816,15960,15696,16896,16968,16896,16776,16368,16752,16152,
     9  16008,16056,16152,18600,18624,18648,18528,18600,18696,18624/
            data (jy(i),i= 2701, 2800)/
     +  18432,18504,18384,18360,18312,18216,18048,19464,19464,19416,
     1  19368,19512,19488,19368,19464,19440,19320,19440,19512,19464,
     2  19440,19440,19656,19752,19632,19680,19608,19344,19368,19632,
     3  19704,19752,19632,19704,19632,19584,19632,19608,19584,19560,
     4  19584,19704,19584,19560,19512,19560,19488,19512,19560,19512,
     5  19440,19848,19824,19752,19896,19992,19872,19752,19752,19728,
     6  19728,19752,19728,19680,19752,19728,19680,19728,19752,19680,
     7  19632,19656,20328,20376,20280,20256,20256,20184,20160,19896,
     8  19944,19872,19848,19800,19920,19824,19776,19824,19848,19752,
     9  19824,20760,20808,20712,20640,20688,20976,21192,20736,20424/
            data (jy(i),i= 2801, 2900)/
     +  20424,23712,23640,23640,23784,23928,24000,23736,23520,23496,
     1  23664,23472,23520,23376,23400,23280,23256,23280,24264,24192,
     2  24240,24504,24792,24888,24984,25296,25416,25536,25560,25680,
     3  25656,25464,25464,25152,24696,24336,24192,24168,24192,24144,
     4  24144,24096,24168,24144,24288,24240,24192,25056,25008,25008,
     5  24888,24936,24960,25128,25200,25176,24840,24816,25008,24888,
     6  24840,24792,24984,24792,24816,24768,24744,25632,24744,24600,
     7  26136,26160,26064,25224,25152,25128,25776,25464,25128,25080,
     8  25608,25752,25536,25536,25464,25488,25440,25368,25392,25368,
     9  25368,25464,25368,25344,25416,25320,25320,25272,25296,25296/
            data (jy(i),i= 2901, 3000)/
     +  25344,25272,25272,25200,25272,25800,25776,25704,25752,25704,
     1  25704,25776,25704,25632,25656,25584,25608,25680,25656,25560,
     2  25560,25656,26424,26400,26352,26400,26376,26352,26520,26472,
     3  26472,26496,26448,26448,26472,26448,26376,26400,26400,26472,
     4  30432,30456,30264,30192,30360,31392,31320,31320,31656,31992,
     5  31920,31872,31656,31320,31272,31272,31320,31656,31776,31632,
     6  31608,31656,32136,32184,32088,32664,32736,32616,32544,32808,
     7  32784,32616,32616,32808,32448,32376,32424,32280,32376,32472,
     8  32424,32976,32952,33072,33024,33048,32880,32904,32760,32904,
     9  32904,32760,33456,33456,33336,33336,33360,33288,34128,34104/
            data (jy(i),i= 3001, 3100)/
     +  34080,34800,34704,34752,34728,34896,35280,35208,35184,35496,
     1  35664,35808,35472,35544,39816,39792,39768,41568,41520,41592,
     2  41544,41640,41736,41664,41784,41784,41712,41664,41592,41712,
     3  41688,41592,41664,41712,41712,41760,41808,41904,41952,41904,
     4  41784,41832,41856,41880,41832,43536,43608,43632,43560,43512,
     5  43464,43416,43488,43632,43584,43584,43632,43800,43776,43872,
     6  44016,43896,43848,43920,43992,44160,44160,44088,44112,44064,
     7  44160,44304,44352,44304,44256,46632,46632,46608,48336,48288,
     8  48240,48000,47976,47856,47688,47712,47880,47592,47616,48264,
     9  48744,48816,48816,48624,48432,48384,48360,47856,47832,47784/
            data (jy(i),i= 3101, 3200)/
     +  48312,48336,48216,48312,48360,48216,47952,47904,48624,48576,
     1  48600,49200,49104,48960,48912,48960,48984,49152,49152,49272,
     2  50760,50808,50904,50856,50688,50640,50736,50736,51528,51408,
     3  51480,51696,51768,51336,51360,51264,51240,53880,53952,53880,
     4  55416,55392,55296,55152,55128,54960,54816,54816,54672,54528,
     5  54408,54216,54024,54120,54480,54576,54504,54504,54312,54456,
     6  54456,54192,54768,54720,54696,55296,55344,55368,55512,55320,
     7  55248,55392,55416,10008, 9960, 9744, 9720, 9888,10008,10104,
     8  10032, 9840, 9840, 9696, 9744,10344,10344,10392,10296,10320,
     9  10272,10128,10128,10080,10128,10128,10056, 9960, 9960, 9768/
            data (jy(i),i= 3201, 3300)/
     +   9792, 9912, 9984,10080, 9984,10056,10056,10488,10608,10656,
     1  10632,10728,10632,10488,10488,10488,10464,10440,10488,10488,
     2  10416,10464,10632,10512,10416,10584,10728,10536,10656,10464,
     3  10272, 9984,10008,10080,10080, 9984,10008,10176,10224,10320,
     4  10392,10440,10488,10512,10272,10272,10176,10152,10224,10176,
     5  10272,10272,10440,10272,10320,10536,10464,10584,10632,10728,
     6  10752,10776,10872,10848,10632,10656,10608,10632,10704,10752,
     7  10656,10536,10560,10440,10560,10704,10872,10824,10776,10728,
     8  10824,10848,10872,10896,10800,10728,10776,11088,10872,10848,
     9  10752,10440,10392,10344,10464,10512,10536,10656,11064,11160/
            data (jy(i),i= 3301, 3400)/
     +  11088,11208,11112,10944,10944,10920,11016,11016,10848,10824,
     1  10632,10728,10704,10824,10872,10824,10800,10920,10920,13680,
     2  13704,13776,13584,13632,13584,13536,13512,13488,13560,13392,
     3  13440,13320,13368,13344,13272,13056,13056,13152,12552,12576,
     4  12648,11400,11448,11328,11280,11280,11352,11328,11232,11208,
     5  11184,11280,11280,11136,11160,11232,11208,11256,11208,11136,
     6  11184,11088,10896,10800,11016,11160,13872,13920,13920,13800,
     7  13992,14016,13920,13944,14016,14064,14016,13920,13944,13944,
     8  13896,14304,14256,14280,14352,14160,14136,14208,14088,14352,
     9  14256,14184,14088,14184,14112,14064,14088,14136,14040,14064/
            data (jy(i),i= 3401, 3500)/
     +  13992,13968,14016,13944,14016,13944,13968,15696,15648,15480,
     1  15456,15240,14400,14352,14304,14280,14160,14016,13800,13944,
     2  13608,13608,13344,13224,13032,12744,12672,12768,12840,13056,
     3  13176,13176,13272,13656,13800,13824,13728,13752,13872,13968,
     4  13944,14088,14112,14424,14544,14592,14568,14784,15048,15192,
     5  15192,15240,15408,15648,15288,15288,15240,15216,15240,15192,
     6  15072,15168,15192,15120,15072,15120,15048,15096,15096,15024,
     7  15024,15096,14928,14976,15024,14904,14952,14976,15048,14880,
     8  14880,14856,14856,14784,14736,14832,14904,15168,15096,14952,
     9  14976,14880,14856,14904,14808,14808,14760,14712,15432,15432/
            data (jy(i),i= 3501, 3600)/
     +  15384,15360,15408,15360,15336,15816,15816,15744,15768,15720,
     1  15696,15672,15696,15648,15672,15648,15600,15576,15624,15576,
     2  15576,15528,15552,15600,15528,15504,15552,15552,15624,15504,
     3  15504,15456,15552,15576,15432,17352,17328,17280,17376,17304,
     4  17256,17256,17328,18528,18648,18600,18504,18432,18312,18336,
     5  18504,18384,18456,18504,18576,18696,18768,18720,18792,18792,
     6  18864,18864,18984,18864,18648,18696,18624,18480,18240,18192,
     7  18288,18288,19032,19008,18936,18912,18936,19008,18840,18864,
     8  18720,18744,18720,18672,18624,18696,18600,18624,18528,18504,
     9  18456,18576,19200,19104,19008,19536,19560,19488,19464,19344/
            data (jy(i),i= 3601, 3700)/
     +  19344,19464,19440,19392,19416,19344,19296,19344,19416,19272,
     1  19320,19296,19200,19152,19248,19392,19296,19248,19128,19272,
     2  19416,19248,19224,19104,19200,24048,24048,23880,23880,23952,
     3  23928,23832,23832,23880,23928,23952,23976,23832,23640,23760,
     4  24072,24528,24600,24168,24072,24072,24024,24024,24048,23976,
     5  23976,24000,23952,39696,39648,39528,39672,40368,40296,40296,
     6  40512,40464,40464,40800,40752,40752,40800,40752,40752,40800,
     7  40752,40704,40704,40872,40848,40656,40608,40608,40632,40608,
     8  40584,41016,40968,40968,40944,40920,40896,41136,41256,41088,
     9  41016,41064,41136,40992,40968,40944,41016,40992,40968,44496/
            data (jy(i),i= 3701, 3780)/
     +  44472,44568,45120,45120,45168,45408,45312,45408,45600,45528,
     1  45576,45648,45552,51144,51120,51240,53136,53064,53088,53400,
     2  53472,53232,53112,53064,53256,53184,53184,53040,53016,53784,
     3  53760,53544,53352,53256,53424,53544,53568,53496,53520,53976,
     4  54072,53808,53712,54096,54024,53976,54000,54192,54192,54360,
     5  54312,54384,53976,53640,53640,53784,53688,53712,53784,53760,
     6  53856,53784,53928,53880,54072,54120,54072,53952,54048,54000,
     7  53986,54048,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      6,   10,   11,   12,   13,   14,   15,   16,   17,   18,
     1     19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
     2     29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
     3      3,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     4     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     5     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     6     69,   70,   71,   72,   73,   74,   75,   76,   77,   78,
     7     79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
     8     89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
     9     99,  100,  101,  102,  103,  104,    6,  106,  107,  108/
            data (jb1(i),i=  101,  200)/
     +    109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
     1    119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
     2    129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
     3    139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
     4    149,    9,    8,  153,  154,  155,  156,  157,  158,  159,
     5    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     6    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     7    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     8    190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
     9    200,  201,  202,  203,  204,  205,  206,  207,  208,  209/
            data (jb1(i),i=  201,  300)/
     +    210,    9,  215,  216,  217,  218,  219,  220,  221,  222,
     1    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     2    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     3    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     4    253,  254,  255,  256,  265,  266,  267,  268,  269,  270,
     5    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     6    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     7    291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
     8    263,  263,  302,  303,  304,  264,  264,  307,  308,  309,
     9    310,  311,  312,  313,  314,  315,  316,  317,  318,  319/
            data (jb1(i),i=  301,  400)/
     +    320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
     1    330,  331,  332,  333,  334,  335,  336,  337,  342,  343,
     2    344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
     3    354,  355,  356,  357,  358,  359,  360,  105,  362,  363,
     4    364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
     5    374,  375,  376,  377,  378,  379,  380,  381,  215,  342,
     6    386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
     7    396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
     8    406,  407,  408,  384,  338,  410,  411,  412,  413,  414,
     9    415,  416,  417,  418,  419,  420,  421,  422,  423,  424/
            data (jb1(i),i=  401,  500)/
     +    425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
     1    435,  436,  437,  438,  439,  440,  441,  442,  443,  444,
     2    445,  446,  385,  362,  449,  450,  451,  452,  453,  454,
     3    455,  456,  457,  458,  459,  460,  461,  462,  463,  464,
     4    465,  466,  467,  468,  469,  448,  384,  471,  472,  473,
     5    474,  385,  477,  478,  479,  480,  481,  482,  483,  484,
     6    485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
     7    495,  496,  497,  498,  499,  500,  501,  502,  503,  504,
     8    505,  506,  507,  508,  509,  510,  511,  512,  513,  514,
     9    515,  448,  517,  518,  519,  520,  521,  522,  475,  524/
            data (jb1(i),i=  501,  600)/
     +    525,  526,  527,  528,  529,  523,  476,  531,  532,  533,
     1    534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
     2    544,  545,  546,  547,  548,  549,  550,  551,  553,  554,
     3    516,  556,  557,  558,  559,  560,  561,  562,  563,  564,
     4    565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
     5    575,  576,  577,  578,  579,  581,  582,  583,  584,  585,
     6    586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
     7    596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
     8    606,  607,  608,  609,  610,  611,  612,  613,  614,  615,
     9    616,  617,  618,  619,  620,  621,  622,  623,  624,  625/
            data (jb1(i),i=  601,  700)/
     +    626,  627,  628,  629,  630,  631,  632,  633,  634,  635,
     1    636,  637,  638,  639,  640,  641,  642,  643,  644,  645,
     2    646,  647,  553,  580,  649,  650,  651,  652,  653,  654,
     3    655,  656,  657,  658,  659,  660,  661,  662,  663,  664,
     4    665,  666,  667,  552,  669,  670,  671,  672,  673,  674,
     5    675,  676,  677,  678,  679,  680,  681,  682,  683,  684,
     6    685,  686,  687,  688,  689,  690,  691,  692,  693,  694,
     7    695,  696,  697,  698,  581,  721,  723,  724,  725,  726,
     8    727,  728,  729,  730,  731,  732,  733,  734,  735,  736,
     9    737,  738,  739,  740,  741,  742,  743,  744,  745,  746/
            data (jb1(i),i=  701,  800)/
     +    747,  748,  749,  750,  751,  752,  753,  754,  755,  756,
     1    757,  758,  759,  760,  761,  762,  763,  764,  765,  766,
     2    767,  768,  769,  770,  771,  772,  773,  774,  775,  776,
     3    777,  778,  779,  780,  781,  782,  783,  784,  785,  786,
     4    787,  788,  789,  790,  791,  792,  793,  794,  795,  796,
     5    797,  798,  799,  800,  801,  803,  804,  805,  806,  807,
     6    808,  809,  810,  811,  812,  813,  814,  815,  816,  817,
     7    818,  819,  820,  821,  822,  823,  824,  825,  826,  827,
     8    828,  829,  830,  831,  832,  833,  834,  835,  836,  837,
     9    838,  839,  840,  841,  842,  843,  844,  845,  846,  847/
            data (jb1(i),i=  801,  900)/
     +    848,  849,  850,  851,  852,  853,  854,  855,  856,  857,
     1    858,  859,  860,  861,  862,  863,  864,  865,  866,  867,
     2    868,  869,  870,  871,  872,  873,  874,  875,  876,  877,
     3    878,  879,  880,  881,  882,  883,  884,  885,  886,  887,
     4    888,  889,  890,  891,  892,  893,  894,  895,  896,  803,
     5    898,  899,  900,  901,  902,  903,  904,  905,  906,  907,
     6    908,  909,  910,  911,  912,  913,  914,  915,  916,  917,
     7    918,  919,  920,  921,  922,  923,  924,  925,  926,  927,
     8    928,  929,  930,  931,  932,  933,  934,  935,  936,  937,
     9    938,  939,  940,  941,  942,  943,  944,  945,  946,  947/
            data (jb1(i),i=  901, 1000)/
     +    948,  949,  950,  951,  952,  953,  954,  955,  956,  957,
     1    958,  959,  960,  961,  962,  963,  964,  965,  966,  967,
     2    968,  969,  970,  971,  972,  973,  974,  975,  976,  977,
     3    978,  979,  980,  981,  982,  983,  984,  985,  986,  987,
     4    988,  989,  990,  991,  992,  993,  994,  995,  996,  997,
     5    998,  999, 1000, 1001, 1002,  802,    5,    2,    2,    1,
     6      1, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012,
     7      7,    7,  212,  259,  214,  214,  213,  213, 1014, 1015,
     8   1016, 1017, 1018, 1019, 1020,  262,    3, 1022, 1023, 1024,
     9   1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034/
            data (jb1(i),i= 1001, 1100)/
     +   1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044,
     1   1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054,
     2   1055, 1056, 1057, 1058, 1059, 1060,  152,  152, 1062, 1063,
     3   1064, 1065, 1066, 1067,  151,  262, 1069, 1070, 1071, 1072,
     4   1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082,
     5   1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092,
     6   1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102,
     7   1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112,
     8   1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122,
     9   1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132/
            data (jb1(i),i= 1101, 1200)/
     +     40,  151,  258,  258, 1135, 1136, 1137, 1138, 1139, 1140,
     1   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150,
     2   1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160,
     3   1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170,
     4   1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180,
     5   1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190,
     6   1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200,
     7   1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210,
     8   1211, 1212, 1213, 1214, 1215, 1216, 1217,  306,  340, 1219,
     9   1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229/
            data (jb1(i),i= 1201, 1300)/
     +   1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239,
     1   1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249,
     2   1250, 1251, 1252,  341,  306, 1254,  340,  339, 1256, 1257,
     3   1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266, 1267,
     4   1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277,
     5   1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287,
     6   1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296,  265,
     7    341, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306,
     8   1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315,  339,
     9    383, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325/
            data (jb1(i),i= 1301, 1400)/
     +   1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335,
     1   1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343, 1344, 1345,
     2   1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353,  257,  383,
     3    668, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363,
     4   1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373,
     5   1374, 1375,  701,  700, 1377, 1378, 1379, 1380, 1381,  702,
     6    703, 1383,  702,  703, 1385, 1386, 1387, 1388, 1389, 1390,
     7    704,  705,  704,  700, 1393, 1394, 1395, 1396, 1397, 1398,
     8   1399, 1400, 1401, 1402, 1403, 1404, 1405, 1406, 1407, 1408,
     9   1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418/
            data (jb1(i),i= 1401, 1500)/
     +   1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428,
     1   1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438,
     2   1439, 1440, 1441, 1442, 1443, 1444,  707,  555, 1446, 1447,
     3   1448, 1449, 1450, 1451, 1452, 1453, 1454,  706,  701, 1456,
     4   1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466,
     5   1467, 1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476,
     6   1477, 1478, 1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486,
     7   1487, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496,
     8   1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506,
     9   1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516/
            data (jb1(i),i= 1501, 1600)/
     +   1517, 1518, 1519,  705,  706, 1521, 1522,  708,  707, 1524,
     1   1525, 1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534,
     2   1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544,
     3   1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554,
     4   1555, 1556, 1557, 1558, 1559, 1560, 1561, 1562, 1563, 1564,
     5   1565, 1566, 1567,  711,  708,  710,  709, 1570, 1571,  709,
     6   1573, 1574, 1575,  710, 1572, 1577, 1578, 1579, 1580, 1581,
     7   1582, 1583, 1584, 1585, 1586, 1587,  713,  712,  714, 1590,
     8   1591,  718, 1593, 1596, 1595, 1595, 1593,  711, 1599, 1600,
     9   1601, 1602, 1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610/
            data (jb1(i),i= 1601, 1700)/
     +   1611, 1612, 1613, 1614,  715,  716, 1616, 1617,  717, 1588,
     1   1619, 1596,  714, 1621, 1622, 1623, 1624, 1625, 1626, 1627,
     2   1628, 1629, 1630, 1631, 1632, 1633, 1634, 1635, 1636, 1637,
     3   1638, 1639, 1640, 1641,  712,  715, 1643, 1644, 1645, 1646,
     4    716,  717, 1648, 1649, 1650, 1651, 1652, 1653, 1654, 1655,
     5   1656, 1657, 1658, 1659, 1660, 1661, 1662, 1663, 1664, 1665,
     6   1666, 1667, 1668, 1669, 1670, 1671, 1672, 1673, 1674, 1675,
     7   1676, 1677, 1678, 1679, 1680, 1681,  718,  713, 1683, 1684,
     8   1685, 1686, 1687, 1688, 1689, 1690, 1691,  719,  721, 1693,
     9   1694, 1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702, 1703/
            data (jb1(i),i= 1701, 1800)/
     +   1704, 1705, 1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713,
     1   1714, 1715, 1716, 1717, 1718, 1719, 1720, 1721, 1722, 1723,
     2   1724, 1725, 1726, 1727, 1728, 1729, 1730, 1731, 1732, 1733,
     3   1734, 1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742, 1743,
     4   1744, 1745, 1746, 1747,  719, 1594, 1749, 1750, 1751, 1752,
     5   1753, 1754, 1755, 1756, 1757, 1758,  720,  720, 1760, 1761,
     6   1762, 1763, 1764, 1765,  722,  722, 1767, 1768, 1769, 1770,
     7   1771, 1772, 1773, 1774, 1775, 1776, 1777, 1778, 1779, 1780,
     8   1781, 1782,  897,    1, 1784, 1785, 1786, 1787,    2, 1788,
     9   1789, 1790, 1791, 1792, 1793, 1794, 1795, 1796, 1797, 1798/
            data (jb1(i),i= 1801, 1900)/
     +   1799, 1800, 1801,    5,    7, 1802, 1803, 1804,    8, 1806,
     1   1807, 1808, 1809, 1810, 1811, 1812, 1813, 1814, 1815, 1816,
     2   1817, 1818, 1819, 1820, 1821, 1822, 1823, 1824, 1825, 1788,
     3   1826, 1827, 1828, 1829, 1805, 1831, 1830, 1833, 1834, 1835,
     4   1836, 1837, 1838, 1839, 1840, 1841, 1842, 1843, 1844, 1845,
     5   1846, 1847,  151, 1829, 1848, 1849, 1850, 1851, 1852, 1853,
     6   1854, 1855, 1856, 1857, 1858, 1859, 1860, 1861, 1862, 1863,
     7   1864, 1865, 1866, 1867, 1868, 1869, 1870, 1871, 1800, 1805,
     8   1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881,  212,
     9   1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890, 1891, 1892/
            data (jb1(i),i= 1901, 2000)/
     +   1893, 1894, 1895, 1896, 1897, 1898, 1882, 1900, 1901, 1902,
     1   1903, 1904, 1905, 1906, 1907, 1908, 1909, 1856, 1910, 1911,
     2   1912, 1913, 1882, 1915, 1916, 1917, 1918, 1919, 1920, 1921,
     3   1922, 1923, 1924, 1901, 1926, 1927, 1910, 1929, 1930, 1931,
     4   1932, 1933, 1934, 1935, 1936, 1937, 1938, 1939, 1940, 1941,
     5   1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950, 1951,
     6   1952,  260, 1953, 1954, 1955, 1956, 1957, 1958, 1959, 1960,
     7   1961, 1962, 1963, 1964, 1965, 1966, 1967, 1968, 1969, 1970,
     8   1971, 1972, 1915,  261, 1974, 1975, 1976, 1977, 1978, 1926,
     9   1980, 1981, 1929, 1980, 1901, 1984, 1985, 1986, 1987, 1988/
            data (jb1(i),i= 2001, 2100)/
     +   1983, 1833, 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997,
     1   1998, 1999, 2000, 2001, 2002, 1910, 1830, 1805, 2005, 2006,
     2   2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016,
     3   2017, 2018, 2019, 2020, 2021, 2022, 2023, 2024, 2025, 2026,
     4   2027, 2028, 2029, 2030, 2031, 2032, 2033, 2034, 2035, 2036,
     5   2037, 2038, 2039, 2004,  105, 1833, 1926,  264, 2042, 2043,
     6   2044, 2045, 1929, 2041, 2047, 1900, 2004,  257, 2049, 2050,
     7   2051,  215, 1990, 2053, 2040, 2055, 2056, 2057, 2058, 2059,
     8   2060, 2061, 2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069,
     9   2070, 2054,  265, 2072, 2073, 2074, 2075, 2076, 2077, 2078/
            data (jb1(i),i= 2101, 2200)/
     +   2079, 1990, 2054, 2081, 2082, 2083, 2084, 2085, 2086, 2087,
     1   2088, 2089, 2090, 2091,  340, 1900, 2092, 2093, 2094, 2095,
     2   2096, 2097, 2098, 2099, 2100, 1915, 2102, 2103, 2104, 2048,
     3   2106, 2107, 2108, 2109, 2110, 2111, 2112, 2113, 2114, 2115,
     4   2116, 2117, 2118, 2101, 2105, 2120, 2121, 1983, 2123, 2124,
     5   2125, 2126, 2127, 2128, 2129, 2130, 2131, 2132, 2133, 2134,
     6   2135, 2136, 2137, 2138, 2139, 2140, 2141, 2142, 2143, 2144,
     7   2145, 2146, 2147, 2122, 1980, 2149, 2150, 2151, 2153, 2154,
     8   2155, 2156, 2105, 2152, 2101, 2159, 2160, 2161, 2162, 2163,
     9   2164, 2153, 2158, 2166, 2122, 2047, 2115, 2169, 2170, 2171/
            data (jb1(i),i= 2201, 2300)/
     +   2172, 2173, 2174, 2175, 2176, 2177, 2178, 2179, 2180, 2168,
     1    342, 2182, 2183, 2184, 2185, 2186, 2168, 2152, 2188, 2189,
     2   2190,  338, 2192, 2193, 2194, 2195, 2196, 2197, 2198, 2199,
     3   2200,  362, 2158, 2201, 2202, 2203, 2204, 2205, 2206, 2207,
     4   2208, 2209, 2210, 2211, 2212, 2213, 2214, 2215, 2216, 2153,
     5   2218, 2219, 2220, 2221, 2217,  384, 2223, 2224, 2225, 2226,
     6   2227, 2228, 2229, 2230, 2231, 2232, 2233, 2234, 2236, 2237,
     7   2238, 2218, 2217, 2240, 2241, 2242, 2243, 2244, 2245, 2246,
     8   2247, 2248, 2249, 2250, 2251, 2252, 2253, 2254, 2255, 2256,
     9   2168, 2236, 2257, 2258, 2259, 2260, 2261, 2262, 2263, 2264/
            data (jb1(i),i= 2301, 2400)/
     +   2235, 2266, 2267, 2268, 2269, 2192, 2266, 2271, 2266, 2272,
     1   2273, 2274, 2275,  475, 2276, 2277, 2278,  523, 2280, 2281,
     2   2282, 2283, 2284, 2285, 2286, 2287, 2288, 2289, 2290, 2236,
     3   2292, 2293,  516, 2295, 2296, 2297, 2294, 2294, 2299, 2300,
     4   2301, 2302, 2303, 2304, 2305, 2279,  552, 2307, 2291, 2309,
     5   2310,  580, 2306, 2312, 2313, 2314, 2315, 2316, 2317, 2318,
     6   2319, 2320, 2321, 2309, 2291, 2323, 2324, 2325, 2326, 2327,
     7   2328, 2329, 2330, 2331, 2332, 2333, 2334, 2335, 2336, 2337,
     8   2338, 2339, 2340, 2341, 2342, 2343, 2344, 2345, 2346, 2347,
     9   2307,  555, 2349, 2342, 2309, 2351, 2352, 2353, 2354, 2355/
            data (jb1(i),i= 2401, 2500)/
     +   2356, 2357, 2358, 2359, 2360, 2361, 2362, 2363,  668, 2307,
     1   2365, 2366, 2367, 2368, 2369, 2370, 2371, 2372, 2373, 2374,
     2   2375, 2279, 2377, 2378, 2379, 2380, 2381, 2382, 2383, 2384,
     3   2385, 2350, 2371, 2362, 2387, 2388, 2389, 2390, 2376, 2387,
     4   2392, 2393, 2394, 2395,  702,  704,  706, 2377, 2394, 2397,
     5   2398, 2398, 2399, 2371, 2401, 2402, 2403, 2404, 2405, 2406,
     6   2407, 2408, 2409, 2410, 2411, 2412, 2413, 2414, 2415, 2416,
     7   2417, 2418, 2419, 2420, 2421, 2422, 2423, 2424, 2425, 2426,
     8   2427, 2428, 2429, 2430, 2431, 2432, 2433, 2434, 2435, 2436,
     9   2437, 2438, 2400, 2396, 2440, 2400,  708, 2442, 2443, 2441/
            data (jb1(i),i= 2501, 2600)/
     +   2445, 2446, 2447, 2448, 2449, 2450, 2451, 2452, 2453, 2454,
     1   2455, 2456, 2457, 2458, 2459, 2460, 2461, 2462, 2463, 2464,
     2   2465, 2400, 2398, 2399, 2467,  709, 2469, 2467, 2470, 2471,
     3   2472, 2442, 2470, 2474, 2468, 2475, 2445, 2476, 2477, 2478,
     4   2479, 2480, 2481, 2482, 2475, 2474, 2484, 2445, 2485, 2486,
     5   2487, 2488, 2489,  715,  717, 2491, 2475, 2492, 2492, 2493,
     6   2494, 2495, 2496, 2490, 2492, 2499, 2500, 2501, 2502, 2490,
     7   2499, 2499, 2498, 2505, 2506, 2507, 2508, 2509, 2498, 2510,
     8   2504, 2504, 2512, 2513, 2514, 2515, 2516, 2512,  802, 2517,
     9   2518, 2519, 2520, 2473, 1572, 1593, 1588, 2473, 2490, 1594/
            data (jb1(i),i= 2601, 2700)/
     +   2523, 2490,    1,    2,    3,    4,    5,    6,    7,    8,
     1      9,   10,   11,   12,   13,   14,   15,   16,   17,    1,
     2     19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
     3     29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
     4     39,   40,   41,   42,   19,   44,   45,   44,   47,   48,
     5     49,   50,   51,   52,   53,   47,   55,   56,   57,   58,
     6     59,   60,   61,   62,   55,   64,   65,   64,   67,   68,
     7     67,   70,   71,   72,   73,   74,   75,   70,   77,   78,
     8     77,   80,   81,   82,   80,   84,   85,   86,   87,   88,
     9     89,   90,   84,   92,   93,   92,   95,   96,   97,   95/
            data (jb1(i),i= 2701, 2800)/
     +     99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
     1     99,  110,  111,  112,  113,  114,  115,  116,  110,  118,
     2    119,  118,  121,  122,  123,  124,  125,  126,  127,  128,
     3    121,  130,  131,  132,  130,  134,  135,  136,  134,  138,
     4    139,  138,  141,  142,  143,  144,  141,  146,  147,  148,
     5    149,  146,  151,  152,  153,  151,  155,  156,  157,  158,
     6    155,  160,  161,  162,  160,  164,  165,  166,  167,  168,
     7    164,  170,  171,  170,  173,  174,  175,  173,  177,  178,
     8    179,  180,  181,  182,  177,  184,  185,  186,  184,  188,
     9    189,  190,  188,  192,  193,  194,  195,  192,  197,  198/
            data (jb1(i),i= 2801, 2900)/
     +    199,  200,  201,  202,  203,  204,  197,  206,  207,  208,
     1    206,  210,  211,  210,  213,  214,  215,  216,  217,  213,
     2    219,  220,  219,  222,  223,  222,  225,  226,  225,  228,
     3    229,  228,  231,  232,  233,  231,  235,  236,  235,  238,
     4    239,  238,  241,  242,  243,  241,  245,  246,  247,  245,
     5    249,  250,  251,  249,  253,  254,  253,  256,  257,  258,
     6    259,  256,  261,  262,  263,  261,  265,  266,  265,  268,
     7    269,  270,  268,  272,  273,  274,  275,  276,  272,  278,
     8    279,  278,  281,  282,  283,  284,  285,  286,  281,  288,
     9    289,  290,  288,  292,  293,  292,  295,  296,  295,  298/
            data (jb1(i),i= 2901, 3000)/
     +    299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
     1    309,  310,  311,  312,  313,  298,  315,  316,  315,  318,
     2    319,  318,  321,  322,  321,  324,  325,  324,  327,  328,
     3    327,  330,  331,  332,  333,  330,  335,  336,  337,  338,
     4    335,  340,  341,  342,  340,  344,  345,  346,  347,  348,
     5    344,  350,  351,  350,  353,  354,  355,  356,  357,  353,
     6    359,  360,  359,  362,  363,  362,  365,  366,  367,  365,
     7    369,  370,  369,  372,  373,  374,  372,  376,  377,  376,
     8    379,  380,  379,  382,  383,  384,  382,  386,  387,  386,
     9    389,  390,  389,  392,  393,  392,  395,  396,  397,  395/
            data (jb1(i),i= 3001, 3100)/
     +    399,  400,  399,  402,  403,  402,  405,  406,  405,  408,
     1    409,  408,  411,  412,  411,  414,  415,  414,  417,  418,
     2    419,  420,  417,  422,  423,  424,  425,  426,  427,  428,
     3    422,  430,  431,  432,  430,  434,  435,  436,  437,  434,
     4    439,  440,  439,  442,  443,  444,  445,  446,  447,  448,
     5    449,  442,  451,  452,  451,  454,  455,  456,  454,  458,
     6    459,  458,  461,  462,  463,  461,  465,  466,  467,  465,
     7    469,  470,  469,  472,  473,  472,  475,  476,  475,  478,
     8    479,  480,  481,  478,  483,  484,  485,  483,  487,  488,
     9    489,  487,  491,  492,  491,  494,  495,  496,  497,  498/
            data (jb1(i),i= 3101, 3200)/
     +    499,  500,  501,  502,  503,  504,  494,  506,  507,  508,
     1    506,  510,  511,  512,  510,  514,  515,  516,  514,  518,
     2    519,  520,  518,  522,  523,  524,  522,  526,  527,  528,
     3    526,  530,  531,  532,  530,  534,  535,  534,  537,  538,
     4    539,  540,  537,  542,  543,  542,  545,  546,  545,  548,
     5    549,  550,  548,  552,  553,  552,  555,  556,  557,  558,
     6    559,  560,  561,  562,  563,  564,  565,  566,  567,  568,
     7    569,  570,  571,  572,  555,  574,  575,  574,  577,  578,
     8    579,  580,  581,  582,  583,  577,  585,  586,  585,  588,
     9    589,  590,  591,  592,  593,  594,  595,  588,  597,  598/
            data (jb1(i),i= 3201, 3300)/
     +    599,  600,  601,  602,  603,  597,  605,  606,  607,  608,
     1    605,  610,  611,  612,  610,  614,  615,  614,  617,  618,
     2    619,  620,  621,  622,  623,  624,  625,  626,  627,  628,
     3    629,  630,  617,  632,  633,  632,  635,  636,  637,  635,
     4    639,  640,  639,  642,  643,  644,  642,  646,  647,  648,
     5    646,  650,  651,  652,  653,  654,  655,  656,  650,  658,
     6    659,  660,  658,  662,  663,  662,  665,  666,  665,  668,
     7    669,  668,  671,  672,  673,  674,  675,  676,  677,  678,
     8    679,  680,  681,  682,  671,  684,  685,  684,  687,  688,
     9    689,  687,  691,  692,  691,  694,  695,  694,  697,  698/
            data (jb1(i),i= 3301, 3400)/
     +    699,  697,  701,  702,  703,  701,  705,  706,  707,  708,
     1    709,  710,  711,  712,  713,  714,  715,  716,  717,  718,
     2    719,  720,  721,  722,  723,  724,  725,  726,  727,  728,
     3    729,  730,  731,  732,  733,  734,  735,  736,  705,  738,
     4    739,  740,  738,  742,  743,  744,  742,  746,  747,  748,
     5    749,  750,  751,  752,  753,  746,  755,  756,  757,  755,
     6    759,  760,  761,  762,  759,  764,  765,  766,  767,  768,
     7    769,  770,  771,  772,  773,  774,  775,  764,  777,  778,
     8    779,  777,  781,  782,  783,  781,  785,  786,  787,  788,
     9    789,  790,  785,  792,  793,  794,  792,  796,  797,  796/
            data (jb1(i),i= 3401, 3500)/
     +    799,  800,  801,  799,  803,  804,  803,  806,  807,  806,
     1    809,  810,  809,  812,  813,  812,  815,  816,  815,  818,
     2    819,  818,  821,  822,  823,  824,  821,  826,  827,  828,
     3    826,  830,  831,  832,  830,  834,  835,  836,  834,  838,
     4    839,  840,  841,  838,  843,  844,  845,  843,  847,  848,
     5    849,  847,  851,  852,  853,  851,  855,  856,  855,  858,
     6    859,  860,  858,  862,  863,  862,  865,  866,  867,  868,
     7    869,  865,  871,  872,  873,  871,  875,  876,  875,  878,
     8    879,  878,  881,  882,  881,  884,  885,  886,  887,  888,
     9    889,  890,  891,  892,  893,  894,  895,  896,  897,  898/
            data (jb1(i),i= 3501, 3600)/
     +    899,  900,  901,  902,  903,  904,  905,  906,  907,  908,
     1    909,  910,  911,  912,  913,  914,  915,  916,  917,  918,
     2    919,  920,  921,  922,  923,  924,  925,  926,  927,  928,
     3    929,  884,  931,  932,  931,  934,  935,  936,  937,  934,
     4    939,  940,  941,  939,  943,  944,  945,  943,  947,  948,
     5    949,  947,  951,  952,  951,  954,  955,  956,  954,  958,
     6    959,  960,  958,  962,  963,  964,  965,  966,  967,  968,
     7    969,  970,  971,  972,  973,  962,  975,  976,  977,  975,
     8    979,  980,  979,  982,  983,  984,  982,  986,  987,  986,
     9    989,  990,  989,  992,  993,  994,  992,  996,  997,  998/
            data (jb1(i),i= 3601, 3700)/
     +    996, 1000, 1001, 1002, 1003, 1004, 1000, 1006, 1007, 1006,
     1   1009, 1010, 1009, 1012, 1013, 1014, 1012, 1016, 1017, 1018,
     2   1016, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1020, 1028,
     3   1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038,
     4   1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1028,
     5   1049, 1050, 1051, 1052, 1053, 1049, 1055, 1056, 1057, 1055,
     6   1059, 1060, 1059, 1062, 1063, 1062, 1065, 1066, 1067, 1065,
     7   1069, 1070, 1069, 1072, 1073, 1074, 1072, 1076, 1077, 1078,
     8   1076, 1080, 1081, 1082, 1083, 1080, 1085, 1086, 1085, 1088,
     9   1089, 1090, 1088, 1092, 1093, 1094, 1095, 1096, 1092, 1098/
            data (jb1(i),i= 3701, 3800)/
     +   1099, 1100, 1098, 1102, 1103, 1104, 1105, 1106, 1107, 1108,
     1   1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118,
     2   1119, 1102, 1121, 1122, 1121, 1124, 1125, 1124, 1127, 1128,
     3   1127, 1130, 1131, 1132, 1130, 1134, 1135, 1134, 1137, 1138,
     4   1137, 1140, 1141, 1140, 1143, 1144, 1143, 1146, 1147, 1148,
     5   1149, 1150, 1146, 1152, 1153, 1152, 1155, 1156, 1155, 1158,
     6   1159, 1158, 1161, 1162, 1161, 1164, 1165, 1166, 1167, 1168,
     7   1164, 1170, 1171, 1170, 1173, 1174, 1173, 1176, 1177, 1176,
     8   1179, 1180, 1179, 1182, 1183, 1184, 1185, 1182, 1187, 1188,
     9   1187, 1190, 1191, 1190, 1193, 1194, 1195, 1196, 1197, 1193/
            data (jb1(i),i= 3801, 3850)/
     +   1199, 1200, 1201, 1202, 1203, 1204, 1199, 1206, 1207, 1208,
     1   1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218,
     2   1206, 1220, 1221, 1222, 1223, 1224, 1220, 1226, 1227, 1226,
     3   1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238,
     4   1239, 1229, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1241/
            data (jb2(i),i=    1,  100)/
     +     10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
     1     20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
     2     30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
     3     39,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     4     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     5     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     6     70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
     7     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     8     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     9    100,  101,  102,  103,  104,  105,  106,  107,  108,  109/
            data (jb2(i),i=  101,  200)/
     +    110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
     1    120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
     2    130,  131,  132,  133,  134,  135,  136,  137,  138,  139,
     3    140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
     4    150,  150,  153,  154,  155,  156,  157,  158,  159,  160,
     5    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     6    171,  172,  173,  174,  175,  176,  177,  178,  179,  180,
     7    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     8    191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
     9    201,  202,  203,  204,  205,  206,  207,  208,  209,  210/
            data (jb2(i),i=  201,  300)/
     +    211,  211,  216,  217,  218,  219,  220,  221,  222,  223,
     1    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     2    234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
     3    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     4    254,  255,  256,  257,  266,  267,  268,  269,  270,  271,
     5    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     6    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     7    292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
     8    301,  302,  303,  304,  305,  305,  307,  308,  309,  310,
     9    311,  312,  313,  314,  315,  316,  317,  318,  319,  320/
            data (jb2(i),i=  301,  400)/
     +    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     1    331,  332,  333,  334,  335,  336,  337,  338,  343,  344,
     2    345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
     3    355,  356,  357,  358,  359,  360,  361,  361,  363,  364,
     4    365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
     5    375,  376,  377,  378,  379,  380,  381,  382,  382,  386,
     6    387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
     7    397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
     8    407,  408,  409,  409,  410,  411,  412,  413,  414,  415,
     9    416,  417,  418,  419,  420,  421,  422,  423,  424,  425/
            data (jb2(i),i=  401,  500)/
     +    426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
     1    436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
     2    446,  447,  447,  449,  450,  451,  452,  453,  454,  455,
     3    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     4    466,  467,  468,  469,  470,  470,  471,  472,  473,  474,
     5    475,  477,  478,  479,  480,  481,  482,  483,  484,  485,
     6    486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
     7    496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
     8    506,  507,  508,  509,  510,  511,  512,  513,  514,  515,
     9    516,  517,  518,  519,  520,  521,  522,  523,  524,  525/
            data (jb2(i),i=  501,  600)/
     +    526,  527,  528,  529,  530,  530,  531,  532,  533,  534,
     1    535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     2    545,  546,  547,  548,  549,  550,  551,  552,  554,  555,
     3    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     4    566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
     5    576,  577,  578,  579,  580,  582,  583,  584,  585,  586,
     6    587,  588,  589,  590,  591,  592,  593,  594,  595,  596,
     7    597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
     8    607,  608,  609,  610,  611,  612,  613,  614,  615,  616,
     9    617,  618,  619,  620,  621,  622,  623,  624,  625,  626/
            data (jb2(i),i=  601,  700)/
     +    627,  628,  629,  630,  631,  632,  633,  634,  635,  636,
     1    637,  638,  639,  640,  641,  642,  643,  644,  645,  646,
     2    647,  648,  648,  649,  650,  651,  652,  653,  654,  655,
     3    656,  657,  658,  659,  660,  661,  662,  663,  664,  665,
     4    666,  667,  668,  669,  670,  671,  672,  673,  674,  675,
     5    676,  677,  678,  679,  680,  681,  682,  683,  684,  685,
     6    686,  687,  688,  689,  690,  691,  692,  693,  694,  695,
     7    696,  697,  698,  699,  699,  723,  724,  725,  726,  727,
     8    728,  729,  730,  731,  732,  733,  734,  735,  736,  737,
     9    738,  739,  740,  741,  742,  743,  744,  745,  746,  747/
            data (jb2(i),i=  701,  800)/
     +    748,  749,  750,  751,  752,  753,  754,  755,  756,  757,
     1    758,  759,  760,  761,  762,  763,  764,  765,  766,  767,
     2    768,  769,  770,  771,  772,  773,  774,  775,  776,  777,
     3    778,  779,  780,  781,  782,  783,  784,  785,  786,  787,
     4    788,  789,  790,  791,  792,  793,  794,  795,  796,  797,
     5    798,  799,  800,  801,  802,  804,  805,  806,  807,  808,
     6    809,  810,  811,  812,  813,  814,  815,  816,  817,  818,
     7    819,  820,  821,  822,  823,  824,  825,  826,  827,  828,
     8    829,  830,  831,  832,  833,  834,  835,  836,  837,  838,
     9    839,  840,  841,  842,  843,  844,  845,  846,  847,  848/
            data (jb2(i),i=  801,  900)/
     +    849,  850,  851,  852,  853,  854,  855,  856,  857,  858,
     1    859,  860,  861,  862,  863,  864,  865,  866,  867,  868,
     2    869,  870,  871,  872,  873,  874,  875,  876,  877,  878,
     3    879,  880,  881,  882,  883,  884,  885,  886,  887,  888,
     4    889,  890,  891,  892,  893,  894,  895,  896,  897,  898,
     5    899,  900,  901,  902,  903,  904,  905,  906,  907,  908,
     6    909,  910,  911,  912,  913,  914,  915,  916,  917,  918,
     7    919,  920,  921,  922,  923,  924,  925,  926,  927,  928,
     8    929,  930,  931,  932,  933,  934,  935,  936,  937,  938,
     9    939,  940,  941,  942,  943,  944,  945,  946,  947,  948/
            data (jb2(i),i=  901, 1000)/
     +    949,  950,  951,  952,  953,  954,  955,  956,  957,  958,
     1    959,  960,  961,  962,  963,  964,  965,  966,  967,  968,
     2    969,  970,  971,  972,  973,  974,  975,  976,  977,  978,
     3    979,  980,  981,  982,  983,  984,  985,  986,  987,  988,
     4    989,  990,  991,  992,  993,  994,  995,  996,  997,  998,
     5    999, 1000, 1001, 1002, 1003, 1003,    8,    5,    4,    4,
     6   1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013,
     7   1013,  212,  261,  261,  259,  260,  260, 1014, 1015, 1016,
     8   1017, 1018, 1019, 1020, 1021, 1021, 1022, 1023, 1024, 1025,
     9   1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035/
            data (jb2(i),i= 1001, 1100)/
     +   1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045,
     1   1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055,
     2   1056, 1057, 1058, 1059, 1060, 1061, 1061, 1062, 1063, 1064,
     3   1065, 1066, 1067, 1068, 1068, 1069, 1070, 1071, 1072, 1073,
     4   1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083,
     5   1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093,
     6   1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103,
     7   1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113,
     8   1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123,
     9   1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133/
            data (jb2(i),i= 1101, 1200)/
     +   1133, 1134, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141,
     1   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151,
     2   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     3   1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171,
     4   1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181,
     5   1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191,
     6   1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201,
     7   1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211,
     8   1212, 1213, 1214, 1215, 1216, 1217, 1218, 1218, 1219, 1220,
     9   1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230/
            data (jb2(i),i= 1201, 1300)/
     +   1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240,
     1   1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250,
     2   1251, 1252, 1253, 1253, 1254, 1255, 1255, 1256, 1257, 1258,
     3   1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266, 1267, 1268,
     4   1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277, 1278,
     5   1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288,
     6   1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296, 1297, 1297,
     7   1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306, 1307,
     8   1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315, 1316, 1316,
     9   1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326/
            data (jb2(i),i= 1301, 1400)/
     +   1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336,
     1   1337, 1338, 1339, 1340, 1341, 1342, 1343, 1344, 1345, 1346,
     2   1347, 1348, 1349, 1350, 1351, 1352, 1353, 1354, 1354,  476,
     3   1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1364,
     4   1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374,
     5   1375, 1376, 1376, 1377, 1378, 1379, 1380, 1381, 1382, 1382,
     6   1383, 1384, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391,
     7   1391, 1392, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399,
     8   1400, 1401, 1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409,
     9   1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419/
            data (jb2(i),i= 1401, 1500)/
     +   1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428, 1429,
     1   1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439,
     2   1440, 1441, 1442, 1443, 1444, 1445, 1445, 1446, 1447, 1448,
     3   1449, 1450, 1451, 1452, 1453, 1454, 1455, 1455, 1456, 1457,
     4   1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467,
     5   1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477,
     6   1478, 1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487,
     7   1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497,
     8   1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507,
     9   1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517/
            data (jb2(i),i= 1501, 1600)/
     +   1518, 1519, 1520, 1520, 1521, 1522, 1523, 1523, 1524, 1525,
     1   1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535,
     2   1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545,
     3   1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555,
     4   1556, 1557, 1558, 1559, 1560, 1561, 1562, 1563, 1564, 1565,
     5   1566, 1567, 1568, 1568, 1569, 1569, 1570, 1571, 1572, 1573,
     6   1574, 1575, 1576, 1576, 1577, 1578, 1579, 1580, 1581, 1582,
     7   1583, 1584, 1585, 1586, 1587, 1588, 1589, 1589, 1590, 1591,
     8   1592, 1592, 1594, 1597, 1597, 1598, 1598, 1599, 1600, 1601,
     9   1602, 1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611/
            data (jb2(i),i= 1601, 1700)/
     +   1612, 1613, 1614, 1615, 1615, 1616, 1617, 1618, 1618, 1619,
     1   1620, 1620, 1621, 1622, 1623, 1624, 1625, 1626, 1627, 1628,
     2   1629, 1630, 1631, 1632, 1633, 1634, 1635, 1636, 1637, 1638,
     3   1639, 1640, 1641, 1642, 1642, 1643, 1644, 1645, 1646, 1647,
     4   1647, 1648, 1649, 1650, 1651, 1652, 1653, 1654, 1655, 1656,
     5   1657, 1658, 1659, 1660, 1661, 1662, 1663, 1664, 1665, 1666,
     6   1667, 1668, 1669, 1670, 1671, 1672, 1673, 1674, 1675, 1676,
     7   1677, 1678, 1679, 1680, 1681, 1682, 1682, 1683, 1684, 1685,
     8   1686, 1687, 1688, 1689, 1690, 1691, 1692, 1692, 1693, 1694,
     9   1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702, 1703, 1704/
            data (jb2(i),i= 1701, 1800)/
     +   1705, 1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713, 1714,
     1   1715, 1716, 1717, 1718, 1719, 1720, 1721, 1722, 1723, 1724,
     2   1725, 1726, 1727, 1728, 1729, 1730, 1731, 1732, 1733, 1734,
     3   1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742, 1743, 1744,
     4   1745, 1746, 1747, 1748, 1748, 1749, 1750, 1751, 1752, 1753,
     5   1754, 1755, 1756, 1757, 1758, 1759, 1759, 1760, 1761, 1762,
     6   1763, 1764, 1765, 1766, 1766, 1767, 1768, 1769, 1770, 1771,
     7   1772, 1773, 1774, 1775, 1776, 1777, 1778, 1779, 1780, 1781,
     8   1782, 1783, 1783, 1784, 1785, 1786, 1787, 1788,    3, 1789,
     9   1790, 1791, 1792, 1793, 1794, 1795, 1796, 1797, 1798, 1799/
            data (jb2(i),i= 1801, 1900)/
     +   1800, 1801,    4,    6, 1802, 1803, 1804, 1805, 1806, 1807,
     1   1808, 1809, 1810, 1811, 1812, 1813, 1814, 1815, 1816, 1817,
     2   1818, 1819, 1820, 1821, 1822, 1823, 1824, 1825,    9, 1826,
     3   1827, 1828, 1829, 1830, 1831, 1832, 1832, 1834, 1835, 1836,
     4   1837, 1838, 1839, 1840, 1841, 1842, 1843, 1844, 1845, 1846,
     5   1847,   40,  152, 1848, 1849, 1850, 1851, 1852, 1853, 1854,
     6   1855, 1856, 1857, 1858, 1859, 1860, 1861, 1862, 1863, 1864,
     7   1865, 1866, 1867, 1868, 1869, 1870, 1871, 1872, 1872, 1873,
     8   1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881, 1882, 1883,
     9   1884, 1885, 1886, 1887, 1888, 1889, 1890, 1891, 1892, 1893/
            data (jb2(i),i= 1901, 2000)/
     +   1894, 1895, 1896, 1897, 1898, 1899, 1899,  213, 1902, 1903,
     1   1904, 1905, 1906, 1907, 1908, 1909,  214,  258, 1911, 1912,
     2   1913, 1914, 1914, 1916, 1917, 1918, 1919, 1920, 1921, 1922,
     3   1923, 1924, 1925, 1925, 1927, 1928, 1928, 1930, 1931, 1932,
     4   1933, 1934, 1935, 1936, 1937, 1938, 1939, 1940, 1941, 1942,
     5   1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950, 1951, 1952,
     6    259, 1953, 1954, 1955, 1956, 1957, 1958, 1959, 1960, 1961,
     7   1962, 1963, 1964, 1965, 1966, 1967, 1968, 1969, 1970, 1971,
     8   1972, 1973, 1973, 1974, 1975, 1976, 1977, 1978, 1979, 1979,
     9   1981, 1982, 1982, 1983, 1984, 1985, 1986, 1987, 1988, 1989/
            data (jb2(i),i= 2001, 2100)/
     +   1989,  262, 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
     1   1999, 2000, 2001, 2002, 2003, 2003, 2004, 2005, 2006, 2007,
     2   2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016, 2017,
     3   2018, 2019, 2020, 2021, 2022, 2023, 2024, 2025, 2026, 2027,
     4   2028, 2029, 2030, 2031, 2032, 2033, 2034, 2035, 2036, 2037,
     5   2038, 2039, 2040, 2040, 2041, 2041,  263, 2042, 2043, 2044,
     6   2045, 2046, 2046, 2047, 2048, 2048,  306, 2049, 2050, 2051,
     7   2052, 2052, 2053, 2054, 2055, 2056, 2057, 2058, 2059, 2060,
     8   2061, 2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069, 2070,
     9   2071, 2071, 2072, 2073, 2074, 2075, 2076, 2077, 2078, 2079/
            data (jb2(i),i= 2101, 2200)/
     +   2080, 2080, 2081, 2082, 2083, 2084, 2085, 2086, 2087, 2088,
     1   2089, 2090, 2091,  339,  341, 2092, 2093, 2094, 2095, 2096,
     2   2097, 2098, 2099, 2100, 2101, 2102, 2103, 2104, 2105, 2106,
     3   2107, 2108, 2109, 2110, 2111, 2112, 2113, 2114, 2115, 2116,
     4   2117, 2118, 2119, 2119, 2120, 2121, 2122, 2123, 2124, 2125,
     5   2126, 2127, 2128, 2129, 2130, 2131, 2132, 2133, 2134, 2135,
     6   2136, 2137, 2138, 2139, 2140, 2141, 2142, 2143, 2144, 2145,
     7   2146, 2147, 2148, 2148, 2149, 2150, 2151, 2152, 2154, 2155,
     8   2156, 2157, 2157, 2158, 2159, 2160, 2161, 2162, 2163, 2164,
     9   2165, 2165, 2166, 2167, 2167, 2168, 2169, 2170, 2171, 2172/
            data (jb2(i),i= 2201, 2300)/
     +   2173, 2174, 2175, 2176, 2177, 2178, 2179, 2180, 2181, 2181,
     1   2182, 2183, 2184, 2185, 2186, 2187, 2187, 2188, 2189, 2190,
     2   2191, 2191, 2193, 2194, 2195, 2196, 2197, 2198, 2199, 2200,
     3    383, 2192, 2201, 2202, 2203, 2204, 2205, 2206, 2207, 2208,
     4   2209, 2210, 2211, 2212, 2213, 2214, 2215, 2216, 2217, 2218,
     5   2219, 2220, 2221, 2222, 2222, 2223, 2224, 2225, 2226, 2227,
     6   2228, 2229, 2230, 2231, 2232, 2233, 2234, 2235, 2237, 2238,
     7   2239, 2239, 2240, 2241, 2242, 2243, 2244, 2245, 2246, 2247,
     8   2248, 2249, 2250, 2251, 2252, 2253, 2254, 2255, 2256,  385,
     9   2235, 2257, 2258, 2259, 2260, 2261, 2262, 2263, 2264, 2265/
            data (jb2(i),i= 2301, 2400)/
     +   2265, 2267, 2268, 2269, 2270, 2270, 2271,  448, 2272, 2273,
     1   2274, 2275,  476, 2276, 2277, 2278, 2279, 2280, 2281, 2282,
     2   2283, 2284, 2285, 2286, 2287, 2288, 2289, 2290, 2291, 2292,
     3   2293, 2294, 2295, 2296, 2297, 2298, 2298, 2299, 2300, 2301,
     4   2302, 2303, 2304, 2305, 2306, 2306,  553, 2308, 2308, 2310,
     5   2311, 2311, 2312, 2313, 2314, 2315, 2316, 2317, 2318, 2319,
     6   2320, 2321, 2322, 2322, 2323, 2324, 2325, 2326, 2327, 2328,
     7   2329, 2330, 2331, 2332, 2333, 2334, 2335, 2336, 2337, 2338,
     8   2339, 2340, 2341, 2342, 2343, 2344, 2345, 2346, 2347, 2348,
     9   2348, 2349, 2350, 2350, 2351, 2352, 2353, 2354, 2355, 2356/
            data (jb2(i),i= 2401, 2500)/
     +   2357, 2358, 2359, 2360, 2361, 2362, 2363, 2364, 2364, 2365,
     1   2366, 2367, 2368, 2369, 2370, 2371, 2372, 2373, 2374, 2375,
     2   2376, 2376, 2378, 2379, 2380, 2381, 2382, 2383, 2384, 2385,
     3   2386, 2386, 2377, 2387, 2388, 2389, 2390, 2391, 2391, 2392,
     4   2393, 2394, 2395,  701,  703,  705, 2396, 2396, 2397, 2398,
     5    707, 2399, 2400, 2401, 2402, 2403, 2404, 2405, 2406, 2407,
     6   2408, 2409, 2410, 2411, 2412, 2413, 2414, 2415, 2416, 2417,
     7   2418, 2419, 2420, 2421, 2422, 2423, 2424, 2425, 2426, 2427,
     8   2428, 2429, 2430, 2431, 2432, 2433, 2434, 2435, 2436, 2437,
     9   2438, 2439, 2439, 2440, 2441, 2441, 2442, 2443, 2444, 2444/
            data (jb2(i),i= 2501, 2600)/
     +   2446, 2447, 2448, 2449, 2450, 2451, 2452, 2453, 2454, 2455,
     1   2456, 2457, 2458, 2459, 2460, 2461, 2462, 2463, 2464, 2465,
     2   2466, 2466, 2467, 2468, 2468, 2469,  710, 2470, 2471, 2472,
     3    711, 2473, 2474,  712, 2475,  713, 2476, 2477, 2478, 2479,
     4   2480, 2481, 2482, 2483, 2483, 2484,  714, 2485, 2486, 2487,
     5   2488, 2489, 2490,  716, 2491,  718, 2492,  719, 2493, 2494,
     6   2495, 2496, 2497, 2497, 2498, 2500, 2501, 2502,  720, 2503,
     7   2503, 2504, 2505, 2506, 2507, 2508, 2509,  721, 2510, 2511,
     8   2511, 2512, 2513, 2514, 2515, 2516,  722, 2517, 2517, 2518,
     9   2519, 2520,  803, 2521, 2521, 1595, 1596, 2522, 2522, 2523/
            data (jb2(i),i= 2601, 2700)/
     +   2524, 2524,    2,    3,    4,    5,    6,    7,    8,    9,
     1     10,   11,   12,   13,   14,   15,   16,   17,   18,   18,
     2     20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
     3     30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
     4     40,   41,   42,   43,   43,   45,   46,   46,   48,   49,
     5     50,   51,   52,   53,   54,   54,   56,   57,   58,   59,
     6     60,   61,   62,   63,   63,   65,   66,   66,   68,   69,
     7     69,   71,   72,   73,   74,   75,   76,   76,   78,   79,
     8     79,   81,   82,   83,   83,   85,   86,   87,   88,   89,
     9     90,   91,   91,   93,   94,   94,   96,   97,   98,   98/
            data (jb2(i),i= 2701, 2800)/
     +    100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
     1    109,  111,  112,  113,  114,  115,  116,  117,  117,  119,
     2    120,  120,  122,  123,  124,  125,  126,  127,  128,  129,
     3    129,  131,  132,  133,  133,  135,  136,  137,  137,  139,
     4    140,  140,  142,  143,  144,  145,  145,  147,  148,  149,
     5    150,  150,  152,  153,  154,  154,  156,  157,  158,  159,
     6    159,  161,  162,  163,  163,  165,  166,  167,  168,  169,
     7    169,  171,  172,  172,  174,  175,  176,  176,  178,  179,
     8    180,  181,  182,  183,  183,  185,  186,  187,  187,  189,
     9    190,  191,  191,  193,  194,  195,  196,  196,  198,  199/
            data (jb2(i),i= 2801, 2900)/
     +    200,  201,  202,  203,  204,  205,  205,  207,  208,  209,
     1    209,  211,  212,  212,  214,  215,  216,  217,  218,  218,
     2    220,  221,  221,  223,  224,  224,  226,  227,  227,  229,
     3    230,  230,  232,  233,  234,  234,  236,  237,  237,  239,
     4    240,  240,  242,  243,  244,  244,  246,  247,  248,  248,
     5    250,  251,  252,  252,  254,  255,  255,  257,  258,  259,
     6    260,  260,  262,  263,  264,  264,  266,  267,  267,  269,
     7    270,  271,  271,  273,  274,  275,  276,  277,  277,  279,
     8    280,  280,  282,  283,  284,  285,  286,  287,  287,  289,
     9    290,  291,  291,  293,  294,  294,  296,  297,  297,  299/
            data (jb2(i),i= 2901, 3000)/
     +    300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
     1    310,  311,  312,  313,  314,  314,  316,  317,  317,  319,
     2    320,  320,  322,  323,  323,  325,  326,  326,  328,  329,
     3    329,  331,  332,  333,  334,  334,  336,  337,  338,  339,
     4    339,  341,  342,  343,  343,  345,  346,  347,  348,  349,
     5    349,  351,  352,  352,  354,  355,  356,  357,  358,  358,
     6    360,  361,  361,  363,  364,  364,  366,  367,  368,  368,
     7    370,  371,  371,  373,  374,  375,  375,  377,  378,  378,
     8    380,  381,  381,  383,  384,  385,  385,  387,  388,  388,
     9    390,  391,  391,  393,  394,  394,  396,  397,  398,  398/
            data (jb2(i),i= 3001, 3100)/
     +    400,  401,  401,  403,  404,  404,  406,  407,  407,  409,
     1    410,  410,  412,  413,  413,  415,  416,  416,  418,  419,
     2    420,  421,  421,  423,  424,  425,  426,  427,  428,  429,
     3    429,  431,  432,  433,  433,  435,  436,  437,  438,  438,
     4    440,  441,  441,  443,  444,  445,  446,  447,  448,  449,
     5    450,  450,  452,  453,  453,  455,  456,  457,  457,  459,
     6    460,  460,  462,  463,  464,  464,  466,  467,  468,  468,
     7    470,  471,  471,  473,  474,  474,  476,  477,  477,  479,
     8    480,  481,  482,  482,  484,  485,  486,  486,  488,  489,
     9    490,  490,  492,  493,  493,  495,  496,  497,  498,  499/
            data (jb2(i),i= 3101, 3200)/
     +    500,  501,  502,  503,  504,  505,  505,  507,  508,  509,
     1    509,  511,  512,  513,  513,  515,  516,  517,  517,  519,
     2    520,  521,  521,  523,  524,  525,  525,  527,  528,  529,
     3    529,  531,  532,  533,  533,  535,  536,  536,  538,  539,
     4    540,  541,  541,  543,  544,  544,  546,  547,  547,  549,
     5    550,  551,  551,  553,  554,  554,  556,  557,  558,  559,
     6    560,  561,  562,  563,  564,  565,  566,  567,  568,  569,
     7    570,  571,  572,  573,  573,  575,  576,  576,  578,  579,
     8    580,  581,  582,  583,  584,  584,  586,  587,  587,  589,
     9    590,  591,  592,  593,  594,  595,  596,  596,  598,  599/
            data (jb2(i),i= 3201, 3300)/
     +    600,  601,  602,  603,  604,  604,  606,  607,  608,  609,
     1    609,  611,  612,  613,  613,  615,  616,  616,  618,  619,
     2    620,  621,  622,  623,  624,  625,  626,  627,  628,  629,
     3    630,  631,  631,  633,  634,  634,  636,  637,  638,  638,
     4    640,  641,  641,  643,  644,  645,  645,  647,  648,  649,
     5    649,  651,  652,  653,  654,  655,  656,  657,  657,  659,
     6    660,  661,  661,  663,  664,  664,  666,  667,  667,  669,
     7    670,  670,  672,  673,  674,  675,  676,  677,  678,  679,
     8    680,  681,  682,  683,  683,  685,  686,  686,  688,  689,
     9    690,  690,  692,  693,  693,  695,  696,  696,  698,  699/
            data (jb2(i),i= 3301, 3400)/
     +    700,  700,  702,  703,  704,  704,  706,  707,  708,  709,
     1    710,  711,  712,  713,  714,  715,  716,  717,  718,  719,
     2    720,  721,  722,  723,  724,  725,  726,  727,  728,  729,
     3    730,  731,  732,  733,  734,  735,  736,  737,  737,  739,
     4    740,  741,  741,  743,  744,  745,  745,  747,  748,  749,
     5    750,  751,  752,  753,  754,  754,  756,  757,  758,  758,
     6    760,  761,  762,  763,  763,  765,  766,  767,  768,  769,
     7    770,  771,  772,  773,  774,  775,  776,  776,  778,  779,
     8    780,  780,  782,  783,  784,  784,  786,  787,  788,  789,
     9    790,  791,  791,  793,  794,  795,  795,  797,  798,  798/
            data (jb2(i),i= 3401, 3500)/
     +    800,  801,  802,  802,  804,  805,  805,  807,  808,  808,
     1    810,  811,  811,  813,  814,  814,  816,  817,  817,  819,
     2    820,  820,  822,  823,  824,  825,  825,  827,  828,  829,
     3    829,  831,  832,  833,  833,  835,  836,  837,  837,  839,
     4    840,  841,  842,  842,  844,  845,  846,  846,  848,  849,
     5    850,  850,  852,  853,  854,  854,  856,  857,  857,  859,
     6    860,  861,  861,  863,  864,  864,  866,  867,  868,  869,
     7    870,  870,  872,  873,  874,  874,  876,  877,  877,  879,
     8    880,  880,  882,  883,  883,  885,  886,  887,  888,  889,
     9    890,  891,  892,  893,  894,  895,  896,  897,  898,  899/
            data (jb2(i),i= 3501, 3600)/
     +    900,  901,  902,  903,  904,  905,  906,  907,  908,  909,
     1    910,  911,  912,  913,  914,  915,  916,  917,  918,  919,
     2    920,  921,  922,  923,  924,  925,  926,  927,  928,  929,
     3    930,  930,  932,  933,  933,  935,  936,  937,  938,  938,
     4    940,  941,  942,  942,  944,  945,  946,  946,  948,  949,
     5    950,  950,  952,  953,  953,  955,  956,  957,  957,  959,
     6    960,  961,  961,  963,  964,  965,  966,  967,  968,  969,
     7    970,  971,  972,  973,  974,  974,  976,  977,  978,  978,
     8    980,  981,  981,  983,  984,  985,  985,  987,  988,  988,
     9    990,  991,  991,  993,  994,  995,  995,  997,  998,  999/
            data (jb2(i),i= 3601, 3700)/
     +    999, 1001, 1002, 1003, 1004, 1005, 1005, 1007, 1008, 1008,
     1   1010, 1011, 1011, 1013, 1014, 1015, 1015, 1017, 1018, 1019,
     2   1019, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1027, 1029,
     3   1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039,
     4   1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1048,
     5   1050, 1051, 1052, 1053, 1054, 1054, 1056, 1057, 1058, 1058,
     6   1060, 1061, 1061, 1063, 1064, 1064, 1066, 1067, 1068, 1068,
     7   1070, 1071, 1071, 1073, 1074, 1075, 1075, 1077, 1078, 1079,
     8   1079, 1081, 1082, 1083, 1084, 1084, 1086, 1087, 1087, 1089,
     9   1090, 1091, 1091, 1093, 1094, 1095, 1096, 1097, 1097, 1099/
            data (jb2(i),i= 3701, 3800)/
     +   1100, 1101, 1101, 1103, 1104, 1105, 1106, 1107, 1108, 1109,
     1   1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119,
     2   1120, 1120, 1122, 1123, 1123, 1125, 1126, 1126, 1128, 1129,
     3   1129, 1131, 1132, 1133, 1133, 1135, 1136, 1136, 1138, 1139,
     4   1139, 1141, 1142, 1142, 1144, 1145, 1145, 1147, 1148, 1149,
     5   1150, 1151, 1151, 1153, 1154, 1154, 1156, 1157, 1157, 1159,
     6   1160, 1160, 1162, 1163, 1163, 1165, 1166, 1167, 1168, 1169,
     7   1169, 1171, 1172, 1172, 1174, 1175, 1175, 1177, 1178, 1178,
     8   1180, 1181, 1181, 1183, 1184, 1185, 1186, 1186, 1188, 1189,
     9   1189, 1191, 1192, 1192, 1194, 1195, 1196, 1197, 1198, 1198/
            data (jb2(i),i= 3801, 3850)/
     +   1200, 1201, 1202, 1203, 1204, 1205, 1205, 1207, 1208, 1209,
     1   1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219,
     2   1219, 1221, 1222, 1223, 1224, 1225, 1225, 1227, 1228, 1228,
     3   1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239,
     4   1240, 1240, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1248/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ga(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(4230) :: jx,jy
            integer(kind=iknd), save, dimension(4390) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'georgia       '/
            data jrot,ipart/0,2/
            data kv/   1,4090,4230,   0,   0/
            data kb/   1,4249,4389,   0,   0/
            data iib/ 854, 140,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  16968,10704,23640,21744,13464,27408,29232, 9744, 7896,15120,
     1   7944,31632,29352, 8400,32136,34800, 8712,36792, 8976, 9312,
     2  40176, 9648,42024,10056,43752,10440,46800,11376,48336,12360,
     3  12768,50736,49296,11184,10368,48984,50760,50424,49656,11208,
     4  48024,11232,46752,39720,37704,12768,20712,42984,17688,24192,
     5  28128,30360,36000, 7392,26688,26688,29256,29568,29568,29784,
     6  29736,29856,29928,30072,30120,30264,30288,30384,30384,30552,
     7  30648,30744,30768,31056,31176,31224,31368,31440,31464,31632,
     8  31512,31632,31584,31776,31728,29280,29232,29352,29352,29712,
     9  29856,30192,30336,30768,31032,30984,31104,31320,31440,31824/
            data (jx(i),i=  101,  200)/
     +  31824,31968,32088,32592,32760,32928,33096,33216,33384,33552,
     1  33792,33984,34248,34560,36504,36480,36192,36024,36024,35688,
     2  35328,35088,35112,35016,36936,37248,37512,38160,38448,38760,
     3  38904,39288,39408,39528,39864,40008,40320,40344,40464,40728,
     4  40944,41256,41352,41832,42312,42432,42984,43128,43128,42984,
     5  43008,42840,42936,43032,42984,42840,42816,42912,42888,43176,
     6  43080,43176,43176,43272,43296,43368,43440,43440,43608,43656,
     7  43728,43800,43752,43656,43656,43800,43968,43800,43848,43752,
     8  43992,44160,44208,44448,44472,44568,44664,44544,44592,45024,
     9  45576,45768,46128,46104,46224,46224,46368,46512,46560,46632/
            data (jx(i),i=  201,  300)/
     +  46584,10464,10680,10728,10584,10608,11016,10824,10824,10872,
     1  11040,11088,11040,11088,11304,11136,11352,11304,47112,47064,
     2  47136,47208,47304,47232,47304,47232,47184,47136,47112,47208,
     3  47208,47376,47424,47568,47568,47472,47424,47496,47568,47712,
     4  47640,47760,47808,47904,48000,47928,48000,47952,47928,47976,
     5  47928,48048,47904,48000,48120,48000,48120,48144,48048,48048,
     6  47952,48144,48240,48144,48264,48072,48024,11424,11904,12120,
     7  12168,12456,12288,12384,12192,12216,48384,48504,48576,48648,
     8  48648,48792,49032,49200,49248,49296,49320,49416,49488,49680,
     9  49848,49848,50328,50280,50160,50208,50136,50160,50424,50400/
            data (jx(i),i=  301,  400)/
     +  50640,50616,50760,50904,50832,51000,50952,50736,50736,50640,
     1  12240,12192,12000,11976,12600,13104,12912,12744,12744,12840,
     2  49440,49464,49632,49560,49752,49776,50136,50232,50112,50304,
     3  50496,50664,50856,51120,51264,51312,51240,51000,50808,50712,
     4  50304,50280,50592,50328,50304,50472,50544,50712,50904,51024,
     5  51144,51000,50760,50832,50928,50856,51048,51072,51216,51240,
     6  51480,51816,51984,52200,52200,52272,52920,52536,52320,52344,
     7  52296,52056,52032,52128,52056,51984,51984,51840,51960,52176,
     8  52224,52152,52176,52392,52512,52704,52584,52776,52896,52872,
     9  52728,52728,52536,52752,52968,52992,52872,52968,52920,53400/
            data (jx(i),i=  401,  500)/
     +  53664,53688,53592,53688,53712,53760,53784,53736,53376,53256,
     1  53040,52800,52632,52368,52200,51960,51600,51432,51240,51024,
     2  50952,51024,50880,50976,51096,50976,51048,50664,12720,12240,
     3  12192,12336,11832,11328,11424,11352,11328,50544,50424,50184,
     4  49968,49992,50136,50112,49848,49728,49728,49488,49488,49392,
     5  49368,11208,11016,11016,10704,10728,10488,10536,10392,10464,
     6  50376,50472,50448,50208,50520,50496,50424,50136,49944,49608,
     7  49512,49488,49320,49128,51168,51576,51648,51744,51816,51600,
     8  51552,51264,50808,50640,50472,50544,10488,10560,10488,10512,
     9  10920,10872,11088,11112,11256,49656,49872,49848,49992,50184/
            data (jx(i),i=  501,  600)/
     +  50136,50040,49968,49824,49824,49704,49584,49536,49560,49296,
     1  49080,48984,48936,48936,48768,48648,48528,48504,48576,48816,
     2  48888,48888,49056,49176,49488,49560,49512,49224,49176,49536,
     3  49824,49968,49896,50016,50040,50208,50448,50328,50088,49944,
     4  49848,49848,49656,49416,49320,49176,49104,49080,48936,48816,
     5  48768,48696,48696,48888,48960,48792,48768,48624,48384,48384,
     6  48528,48744,48984,49200,49176,49080,49128,49224,49272,49320,
     7  49296,49056,48888,48792,48408,47808,47568,47304,47328,47568,
     8  47880,48024,48288,48360,48120,48984,49032,49392,49416,49848,
     9  49968,50304,50136,49848,49656,49440,49392,49440,49608,50160/
            data (jx(i),i=  601,  700)/
     +  50496,50232,50376,50592,50664,50832,50880,50832,50760,50880,
     1  50880,50568,50424,50304,50352,50232,50184,50112,50064,49992,
     2  49752,10944,10968,10872,10824,10656,10752,10680,10608,10464,
     3  10416,10560,10536,10464,10464,10560,10536,10752,10968,11136,
     4  11208,48024,48192,48192,48264,48312,48240,48432,48720,49176,
     5  49368,49296,49296,49368,49344,49464,49536,49344,49320,49176,
     6  49032,48816,48768,49032,48528,48456,48480,48288,48144,47976,
     7  47928,48024,48024,47976,47832,47544,47520,47616,47640,47736,
     8  47688,47496,47184,47160,46944,46872,46608,46560,46296,45936,
     9  45960,46056,46488,46584,46752,46752,46584,46584,46704,46872/
            data (jx(i),i=  701,  800)/
     +  47016,47016,46896,46920,47376,47376,47208,47136,46800,11376,
     1  11448,11664,11640,11736,12096,12072,12168,12048,12240,12480,
     2  12504,43104,43200,43344,43464,43656,43944,44136,44232,44376,
     3  44640,44856,45072,45312,45360,45336,45240,45240,45456,45408,
     4  45552,45528,45600,45816,45840,45984,46056,46104,46272,46392,
     5  46440,46584,46704,46800,47088,47136,47088,47208,47184,46704,
     6  46752,46944,46968,46704,46656,46488,46368,46296,46224,46320,
     7  46464,46560,46800,46944,47064,47160,47232,47232,46944,46944,
     8  47280,47352,47640,47592,47400,47280,47184,46896,46824,46704,
     9  46536,46032,45888,45696,45576,45600,45672,45960,46128,46464/
            data (jx(i),i=  801,  900)/
     +  46608,46752,47016,47112,47136,47232,47472,47496,47280,47256,
     1  47088,47016,46800,42984,42912,42696,42648,42456,42384,42384,
     2  42240,42120,41952,41808,41760,41832,41760,41568,41544,41592,
     3  41448,41472,41712,41808,41880,41760,41808,41760,41568,41592,
     4  41496,41592,41448,41280,40800,40296,40128,40008,39840,39888,
     5  39840,39648,39528,39600,16944,16896,11760,11616,11616,11208,
     6  11256,10632,25080,25104,24936,24984,24840,24816,24888,24840,
     7  24720,24528,24528,24624,24624,24384,24384,23808,23784,23640,
     8  23544,21336,21912,22008,22032,21744,21672,21576,21528,21576,
     9  21720,21816,21936,21864,21696,21408,21408,21336,21240,20976/
            data (jx(i),i=  901, 1000)/
     +  20952,20688,20520,20544,20448,20448,20376,20424,19872,19752,
     1  19704,19728,19320,18888,18864,17976,16464,16512,16680,16728,
     2  16680,16992,17232,17184,17064,13464,13296,13272,13104,13008,
     3  12984,12912,12888,12624,12600,12168,12168,12000,12000,11904,
     4  27408,26880,26952,26904,26616,26568,26448,26376,26328,26256,
     5  26280,26352,26064,26184,25464,25824,12600,12648,11496,24648,
     6  24600,24624,24576,24312,26112,26160,26376,26520,26568,26520,
     7  26592,26592,26424,26424,26352,26352,26184,26184,26424,26328,
     8  26400,26400,26616,26592,26424,26136,26112,28920,28752,28560,
     9  28536,28320,28296,28128,28008,27768,27696,27456,27456,27312/
            data (jx(i),i= 1001, 1100)/
     +  27216,27264,27096,26976,26808,26736, 9000, 8808, 8760, 8688,
     1   8640, 8352, 8328,15072,14880,14784,14832,14952,14856,15000,
     2  14880,14760,14808,14736,14640,14664,14544,14616,14736,14760,
     3  14376,14472,14568,14568,14400,14568,14520,14472,14280,14208,
     4  13896,13800,13824,14232,14208,14088,13992,13800,13680,13728,
     5  13824,13848,13968,13944,24288,24144,24168,24096,24144,24120,
     6  24144,24096,24096,24216,24192,24288,24288,24408,24408,24504,
     7  24504,24384,24384,13800,13824,12600,24192,24120,23952,23904,
     8  23520,23064,22968,22656,22584,22512,22536,22440,22224,22200,
     9  22032,21672,21552,21552,21456,21384,21048,21192,21288,12024/
            data (jx(i),i= 1101, 1200)/
     +  20976,12384,12552,12528,16200,16200,15960,15960,15720,15720,
     1  15792,15816,15888,15888,15600,15552,15360,15264,15240,14424,
     2  14424,13992,13992,19488,19488,19608,19584,19656,19824,19872,
     3  20016,20184,20160,20376,20400,20688,20784,16464,19224,19200,
     4  18696,18696,18624,18264,18264,18096,18096,18192,18192,17928,
     5  17928,17856,17832,17760,17760,23016,21792,21864,21720,20976,
     6  21024,12360,12432,12432,12168,12144,11928,12096,12144,12048,
     7  11952,11976,12144,12696,12768,12960,30888,28968,28728,24912,
     8  24912,25032,25008,29112,28128,26592,26688,26856,26928,27120,
     9  27120,27192,27360,11616,11256,10896,10920,10824,10824,10656/
            data (jx(i),i= 1201, 1300)/
     +  10560, 9696, 9312, 9192, 9240, 9144,31680,31536,31656,31536,
     1  31464,24384,24048,24024,23928,23928,23616,23592,23712,23712,
     2  23256,23088,23088,16416,16416,16512,16512,16440,15624,15624,
     3  13440,13464,13296,13272,13200,13200,13104,13104,12960,20280,
     4  20328,19704,19464,17112,17088,18456,18480,18648,18648,18864,
     5  18864,18960,18960,20256,23208,23160,23112,22968,23040,22992,
     6  23016,22968,23088,23040,22968,26496,26328,26208,26136,26040,
     7  26208,26232,26328,26448,26496,30864,30576,30480,30264,30216,
     8  29880,29856,29760,29640,29352,29064,28872,28728,29256,29208,
     9  31800,31440,20184,32376,32664,32592,32736,32904,32952,33384/
            data (jx(i),i= 1301, 1400)/
     +  34152,34272,28896,28608,27864,27768,27720,27648,27048,16200,
     1  16368,16464,16488,16392,23304,23232,23352,23496,23472,23208,
     2  23232,23040,23016,23088,23064,22944,22848,22248,22152,22104,
     3  24504,24000,21696,21528,21624,21912,22104,12408,12480,12696,
     4  12696,12792,12792,12696,12768,12936,11664,11640,11304,11304,
     5  10320,10320,13608,13536,13536,13464,13464,12384,13704,13704,
     6  13872,13872,15432,16032,16032,16080,19512,19416,19248,19152,
     7  18888,18768,18600,18576,16560,16512,16560,16560,16680,16632,
     8  17664,17664,17712,20160,20208,20424,20616,20688,20856,20928,
     9  21288,21384,19992,20088,20040,20088,20088,20184,20304,20520/
            data (jx(i),i= 1401, 1500)/
     +  20688,20688,20784,20880,21000,21120,21432,28992,29040,28848,
     1  28776,28848,28776,28704,28992,32760,32736,32640,32616,32520,
     2  32472,32400,32184,32232,32064,32064,31896,31728,31536,31656,
     3  31632,18576,18720,18744,18960,18960,18816,18240,18288,18096,
     4  18072,18120,17952,16848,32472,32376,32040,31632,31584,31464,
     5  31440,31296,30912,30624,30432,30336,30312,30192,29976,29352,
     6  29616,29736,29904,27216,27600,27552,27744,28728,28656,28728,
     7  28800,24552,24744,24768,25008,25296,25368,25416,25440,25512,
     8  25560,25680,25776,25800,25872,25944,26064,26112,26184,26328,
     9  26472,26616,26880,26904,26976,36408,36168,36048,36048,36000/
            data (jx(i),i= 1501, 1600)/
     +  34680,34080,34032,33840,33816,33624,33480,33432,33216,33072,
     1  33144,32976,35904,35472,35232,34920,12288,12312,13008,10680,
     2  10680,24624,24480,24312,24240,23952,26112,24960,24984,25176,
     3  25272,25560,25824,12360,12408,37584,37272,36648,36456,36576,
     4  36696,36624,36360,29880,29856,29808,29880,29880,29760,29784,
     5  30120,29760,27504,27888,28008,28368,28704,28728,28872,28944,
     6  29064,29256,29256,15360,15528,15456,13704,26232,26304,26736,
     7  26688,26808,26808,27120,27240,27216,27480,14088,15432,22776,
     8  29448,29592,29568,29688,29640,29688,16464,22272,20040,19968,
     9  20112,20352,20616,21072,21288,21480,21864,22128,23424,31272/
            data (jx(i),i= 1601, 1700)/
     +  31968,32304,32496,29544,29568,28440,32952,32856,32592,32688,
     1  32856,33000,33216,33360,33480,33744,33912,34008,34224,34416,
     2  34536,12240,12192,12024,12024,11544,11400,11400,11304, 9792,
     3  27648,27696,27816,27912,28056,28248,28320,32568,19344,19224,
     4  19080,19752,20688,20328,20304,20112,20112,38112,38160,38232,
     5  38232,38304,38328,38424,38424,38640,38640,38760,38760,38856,
     6  38832,38952,39072,39288,39624,39936,40080,22008,21384,21264,
     7  21144,21024,20904,20832,20856,37944,37944,38064,38040,38136,
     8  38232,38232,38016,37968,38496,38328,38352,38496,38496,38568,
     9  38688,38976,38928,39000,39216,39360,37560,37368,37320,37320/
            data (jx(i),i= 1701, 1800)/
     +  37200,37152,37008,36936,36840,36792,36720,36648,36576,36480,
     1  36216,36240,36144,36216,36048,35952,35952,35880,37776,37872,
     2  38040,16776,16704,16560,16320,16296,16104,16104,16056,15504,
     3  15312,15240,15096,15000,14568,14520,13560,13656,13584,13584,
     4  13656,25680,25512,25584,25176,24936,35592,35688,35808,35856,
     5  33600,33672,33600,33672,33888,34056,34152,34272,34848,35136,
     6  35232,35472,35520,18024,17976,28536,28680,28800,28872,28968,
     7  28968,29064,29088,29184,29304,29448,29424,29544,29664,29736,
     8  29616,29592,29664,29616,14352,14280,14424,14304,14064,23376,
     9  23424,23376,23304,23376,23232,22080,20736,21216,21288,21480/
            data (jx(i),i= 1801, 1900)/
     +  21912,21960,25608,25704,25656,16632,16464,16344,16344,16032,
     1  14016,13824,13536,13344,13200,13008,12720,12672,12696,12432,
     2  12408,32256,32544,32544,32280,32520,32400,32544,32616,32688,
     3  32736,32928,32808,32664,23232,22992,23016,22248,22104,21960,
     4  27096,33864,33720,33984,34008,34152,34176,34248,34488,34704,
     5  34896,34968,35160,35136,35352,35352,35424,35496,33552,33456,
     6  32976,32832,32544,26904,23808,23952,24120,24024,24000,24168,
     7  24216,24336,24744,25104,25416,25344,25416,25584,25704,25632,
     8  25584,23352,23496,23520,23664,23712,23784,18600,18528,18528,
     9  18624,18552,18648,18576,18480,18480,18600,18600,18672,18696/
            data (jx(i),i= 1901, 2000)/
     +  18528,18432,18336,18336,18216,18168,19752,19848,19848,19944,
     1  19920,20016,20016,20112,20112,20016,20016,19920,19896,19680,
     2  19680,19584,19560,19464,19464,19272,19272,18960,18936,30744,
     3  30696,30600,30504,30504,30432,30360,30264,30240,30144,30192,
     4  30264,30144,29952,30000,29784,29832,29664,24144,24264,24072,
     5  24264,24072,24144,24000,24024,23808,23856,21408,21408,21696,
     6  21720,21912,21912,22008,22008,22104,22128,22296,22632,22632,
     7  22728,22728,19992,19992,20952,20928,21000,21168,21552,21192,
     8  21240,21192,21168,38760,36504,36816,36888,36840,36984,37344,
     9  37800,38040,38136,38208,38472,16296,16248,16368,16560,16632/
            data (jx(i),i= 2001, 2100)/
     +  16728,16848,17136,17280,17328,17472,18648,18576,18624,18600,
     1  18216,18120,12888,13008,13008,12936,13080,39624,39336,39288,
     2  38976,37992,17400,17376,17424,17352,17472,34776,34992,35304,
     3  35544,35880,36336,36432,36720,33960,34032,34128,34128,34080,
     4  34176,34152,34224,34320,34344,34368,34440,34392,34392,34536,
     5  34488,34704,11280,11280,11376,11376,11472,11472,11568,11568,
     6  11880,12000,12048,13824,13824,13728,13752,13824,13824,15936,
     7  15936,15696,15624,15504,15504,15288,15288,13920,13920,34848,
     8  34848,21984,17496,17448,43680,43416,43248,42936,42768,42456,
     9  42168,42000,41688,41328,41016,40944,40584,19920,18672,18696/
            data (jx(i),i= 2101, 2200)/
     +  18480,18480,17904,17832,17688,17616,20136,20160,21168,23712,
     1  23856,23952,30936,30864,30912,30672,30336,30216,30072,30120,
     2  30072,29976,29832,29832,29736,29616,29616,28032,29424,29304,
     3  29160,29160,29064,29040,28920,28800,28704,28728,28608,28464,
     4  28368,28296,28176,28056,25920,24576,24552,24192,24120,24216,
     5  34944,34896,34992,34920,34920,35112,35280,35400,35688,35880,
     6  35904,36288,36504,36504,36552,36456,36456,34536,34344,34056,
     7  34008,33768,33432,33288,32832,32592,32208,31776,24192,24384,
     8  24600,24864,24960,25056,25104,25032,25128,25080,25080,25224,
     9  25200,31560,31464,31272,31224,31128,31248,31224,31344,31344/
            data (jx(i),i= 2201, 2300)/
     +  29760,19872,19776,19752,19656,19632,17352,17352,17256,17232,
     1  17304,17208,17208,17088,17280,17232,17136,17136,16992,17016,
     2  16968,17088,17040,17136,17064,17280,17448,19344,19344,19416,
     3  19440,21072,21096,21864,21768,21768,31536,31608,31704,31800,
     4  31776,31608,31728,31752,31848,31152,30984,30816,30768,30696,
     5  30504,30648,30240,29592,29640,29520,29400,28704,13680,17232,
     6  17184,17040,17040,17136,17088,16992,13680,28200,44544,13896,
     7  14616,15288,16584,17232,21048,24984,24984,23352,22584,22608,
     8  22488,22488,27120,27096,27024,26616,26496,26304,25704,25656,
     9  25344,25296,39072,39528,39360,39600,39768,39960,39888,39792/
            data (jx(i),i= 2301, 2400)/
     +  35808,35904,35880,36024,36000,36144,36096,36240,36288,36480,
     1  36696,36768,36864,37152,37008,36984,37032,44376,44064,44040,
     2  43944,43656,42672,41424,40992,40752,40776,41376,42168,40656,
     3  40080,39984,39792,39672,39192,19392,19224,19104,19008,18888,
     4  18744,18696,18696,18624,18432,18360,18144,17952,17856,17712,
     5  17616,17520,17448,17376,17544,17328,27360,27264,27312,26448,
     6  26376,26304,26232,26208,26256,26232,26112,26232,32760,34224,
     7  34248,34488,34536,35112,35424,35568,36120,36624,31656,31776,
     8  31752,31992,32256,32520,32544,32688,32664,32640,37488,37704,
     9  37872,38040,38112,38232,38232,38136,38112,38040,38064,38304/
            data (jx(i),i= 2401, 2500)/
     +  38544,38688,38760,38976,20256,20280,20760,20952,20952,20040,
     1  19872,19944,19896,19824,19704,19608,32640,32760,25224,25128,
     2  23352,23448,23496,23688,24000,24240,24624,24816,26160,25776,
     3  25560,46704,46416,46224,46128,46032,46008,45912,45792,45720,
     4  45624,45552,45432,45288,45120,45000,44904,44856,44736,44664,
     5  44448,44352,44376,44208,44160,44016,43920,43776,43512,43536,
     6  15360,15312,15360,15360,15408,15408,15312,15288,15240,15192,
     7  15192,15288,15240,13104,13104,19320,19200,19008,18864,18840,
     8  18576,18456,18288,18120,18096,17736,29928,31632,15216,15504,
     9  15360,15384,15216,17256,17256,17112,17112,16848,16848,16752/
            data (jx(i),i= 2501, 2600)/
     +  16752,16656,16632,16512,16536,16296,16200,16104,15960,15792,
     1  15648,15384,22152,22632,22632,22728,22728,22896,22896,22992,
     2  24552,22032,22008,21936,21816,21720,21720,21672,21696,21552,
     3  21456,21624,21552,21480,21264,21168,21168,20904,20784,20592,
     4  41880,22152,21984,33600,34344,34272,35520,35424,35688,35880,
     5  36144,36168,36216,36264,36336,36552,36288,36240,37080,37008,
     6  37224,37272,37560,37296,37224,37512,37680,23688,23616,23424,
     7  23376,23136,22920,22920,22848,22944,22848,22848,22464,22464,
     8  22296,22296,46800,27168,28080,28056,28128,28176,26328,26400,
     9  26592,26760,26784,26712,26832,26832,26712,26688,26784,26832/
            data (jx(i),i= 2601, 2700)/
     +  26952,26928,27024,27264,27240,25128,25128,24936,24936,25008,
     1  25008,25056,25008,24960,24696,24672,24384,24384,24288,24288,
     2  24192,24168,23976,23976,23856,23880,23712,17736,17640,17640,
     3  17736,17736,17832,17808,17904,17904,18048,18024,18168,18192,
     4  18312,30768,12624,13368,13920,14040,14184,14328,14400,14568,
     5  14712,14904,27168,27288,27312,27264,21984,21816,21816,21624,
     6  21624,21432,21432,21048,21048,20928,20160,19656,19584,19560,
     7  18312,18504,18480,18576,18576,18672,18672,18888,18864,35976,
     8  36552,36840,37200,37896,37968,38232,38352,38232,38208,38064,
     9  38064,15768,15576,15456,41376,40704,40368,40296,39624,39768/
            data (jx(i),i= 2701, 2800)/
     +  39768,39840,23616,23640,23544,23568,23760,23760,23784,23688,
     1  34920,34848,34824,34680,34800,34872,34848,34896,34992,34992,
     2  35088,35184,35136,35256,35232,35328,35544,35688,35832,35832,
     3  35616,25944,26904,27096,25104,25104,24912,24912,35592,35640,
     4  35184,35448,35472,39360,38616,38568,38376,38208,38136,30432,
     5  29088,29280,28776,28728,28656,28704,28656,15552,41904,13992,
     6  13992,13896,13896,42480,42384,42432,42528,42552,42768,42816,
     7  42984,42600,42480,44352,44352,44232,44136,44112,43992,43752,
     8  43608,43224,43008,42624,42528,20256,19872,19896,19536,20736,
     9  20712,21168,21336,21576,21768,47808,47856,47808,47784,47688/
            data (jx(i),i= 2801, 2900)/
     +  47712,47640,47640,47520,47520,47304,47280,47112,47088,46944,
     1  46968,46848,46848,46728,46824,46800,46920,46872,46776,46824,
     2  18312,18192,18192,17952,17952,17760,17736,17832,17832,17736,
     3  17736,33264,33336,33408,33480,33528,34440,34512,34584,34512,
     4  23136,23112,22416,22224,21936,21768,19248,19224,19344,19344,
     5  19440,19416,20208,17712,16728,16752,16656,16656,16560,16560,
     6  16368,16368,16032,16032,15936,15936,15816,15840,32184,33384,
     7  32808,25968,26016,25920,25944,26040,26040,28368,29184,28824,
     8  29064,28704,28512,28536,28392,27912,27912,27720,27720,26640,
     9  26640,26544,26544,44976,44760,44592,44592,44376,50232,48288/
            data (jx(i),i= 2901, 3000)/
     +  47928,47880,48048,48000,48072,48048,48168,48096,48120,48144,
     1  48312,48480,48432,48504,48504,48792,48816,48936,48936,48984,
     2  48960,49008,49032,49128,49080,49104,49296,22392,22392,22320,
     3  22320,22224,22248,22152,22272,22128,22152,22056,21912,21960,
     4  21840,21720,11280,11280,11496,11496,11784,11784,11904,11904,
     5  12384,12384,12264,12264,12360,12336,12552,12528,12720,12720,
     6  12840,25944,44544,43248,42336,43896,43992,17640,17568,17520,
     7  37296,37728,37752,43728,43512,43392,43248,43320,43320,43176,
     8  43200,43008,42912,42672,42576,42312,42312,42408,15360,15384,
     9  15480,15480,15384,15384,15480,15480,15384,15384,15408,15504/
            data (jx(i),i= 3001, 3100)/
     +  15552,15576,15480,15480,15576,15624,15696,15720,15624,15624,
     1  15552,13800,13800,13896,13896,15048,15072,15168,15168,15912,
     2  37512,37776,36648,36696,36624,36528,36504,36432,36144,36144,
     3  36072,36120,36024,36000,36072,35952,36024,35880,35976,35928,
     4  36000,35904,35808,35976,35976,35880,35832,35808,35880,35760,
     5  35784,35640,35760,35664,35664,35616,35664,17472,17400,17400,
     6  37152,37104,37296,37200,36768,22488,22536,22728,22704,22776,
     7  22752,48336,48336,48216,48240,48120,48168,48096,47928,47520,
     8  47400,47304,47208,47136,47040,46968,46800,46632,46512,46368,
     9  46248,46224,46152,46128,45984,45960,45792,45648,45552,45432/
            data (jx(i),i= 3101, 3200)/
     +  45384,45288,45264,45024,35616,35136,34824,34416,34248,34008,
     1  33720,33528,33384,33216,33072,33048,32928,32712,36408,36144,
     2  36072,35952,32760,32832,32760,32544,32664,29976,28824,28896,
     3  28992,29088,29040,29040,28968,29088,29064,29160,29064,29256,
     4  29256,29136,29136,29184,29184,29400,29568,29664,29664,29760,
     5  29736,29832,29880,39912,40080,40200,40320,40200,40080,40008,
     6  40032,39888,38016,38016,38088,38088,38232,38208,38256,38376,
     7  38328,38448,38952,39048,39096,39192,39264,39432,39528,39624,
     8  39744,39792,18552,18552,17736,18096,18336,40200,40200,40512,
     9  40632,40776,40752,40920,40944,40992,41040,40944,41040,41280/
            data (jx(i),i= 3201, 3300)/
     +  41616,47232,45720,45696,45528,45192,45000,44856,44784,44616,
     1  44472,44472,44688,44712,44640,44160,22560,22584,22680,22608,
     2  22680,22632,25848,27192,30240,30192,30240,30192,30120,30048,
     3  29976,30192,29904,11064,11064,11544,11568,12240,12720,23904,
     4  23784,23688,23496,23496,23400,23400,25824,33672,33696,33840,
     5  33960,33960,34176,34152,34248,34296,34488,34632,34968,35064,
     6  35112,35184,35304,35256,49032,48888,48912,48816,48720,48840,
     7  48744,48768,48600,48624,48696,48720,48600,48648,48552,48504,
     8  48456,48456,50616,50568,50448,33480,33408,33264,33120,33000,
     9  32856,32688,32472,32232,32064,31968,31872,31728,31608,31632/
            data (jx(i),i= 3301, 3400)/
     +  31464,31272,31200,31152,31032,30936,30888,30696,30672,30504,
     1  30504,41832,41952,42024,42144,42120,42336,27432,27384,27240,
     2  27216,27144,37776,36864,36864,36552,36552,36840,36840,32016,
     3  21696,21768,21672,21696,21648,21576,21840,21888,21984,22056,
     4  21984,22008,21840,21840,22032,22152,22128,22272,22344,22488,
     5  35760,33648,36816,13608,12336,12360,12480,12480,12384,12384,
     6  12288,12312,12216,15840,16224,16176,16488,16416,16464,16344,
     7  16248,16248,16128,16128,16032,16032,15936,15936,15840,15840,
     8  15744,15744,15576,15576,15432,15456,15312,15312,15240,15240,
     9  28272,28272,28584,28584,28728,28704,29304,29304,30192,30216/
            data (jx(i),i= 3401, 3500)/
     +  17304,18864,18888,18696,18720,18912,19032,19320,19272,19320,
     1  18960,21432,21528,49512,49176,49008,48768,48624,48528,48480,
     2  48408,48192,48000,47808,47712,47592,47472,47544,47496,26904,
     3  26928,27000,27048,27336,27432,27288,27408,25392,25416,25344,
     4  25248,25200,25200,25128,25056,24912,24840,23928,23952,46464,
     5  45480,13536,13536,13632,13632,13536,13560,13656,13656,13776,
     6  13584,13584,13488,13488,13584,11424,11400,11832,11976,12096,
     7  12336,45408,45312,45288,45168,45120,45144,45144,45096,44904,
     8  44856,44808,44736,44664,44688,44520,44424,44400,44472,44208,
     9  44256,44160,44136,44040,43992,43944,43992,43896,43800,43824/
            data (jx(i),i= 3501, 3600)/
     +  43608,43632,43440,43344,43056,42984,43008,42912,42864,42792,
     1  42672,42672,42600,42576,45432,45456,45600,45552,45672,45648,
     2  45720,45888,45984,45888,37080,37320,37512,37536,37704,37968,
     3  38400,38904,39336,39432,39624,39792,26904,27216,27192,27720,
     4  27936,28104,28080,28128,28272,28512,30480,31992,31872,31848,
     5  31680,31680,31536,31536,31392,31344,31104,30984,30816,30744,
     6  15360,13800,13824,13680,13656,13752,13752,13656,13656,13536,
     7  17352,17232,17280,17232,17304,17400,17544,17496,17640,17496,
     8  17448,21840,21840,22008,22008,21840,21888,22032,22032,21888,
     9  21912,21744,21744,21840,21840,21936,21936,20376,35736,36048/
            data (jx(i),i= 3601, 3700)/
     +  36024,41304,41232,41232,41040,41016,41208,41208,40752,40728,
     1  40584,40584,40752,40728,19680,19656,17280,17280,16944,16944,
     2  16848,16824,16608,16608,16512,16488,16392,16392,16272,16272,
     3  40584,40392,39840,30408,30528,30528,39648,39672,39480,39480,
     4  39360,39336,39024,39024,38880,38880,38736,38736,38568,38568,
     5  37992,37992,37800,37056,37080,37200,37200,41664,41616,41496,
     6  41520,41496,41136,40872,35688,35712,32352,32352,33504,33576,
     7  33600,33768,28512,28200,28176,28032,28032,27888,27888,27720,
     8  27720,27576,27528,21792,25296,25344,25176,25224,25368,26712,
     9  27408,27408,27264,27240,24216,24216,24672,24672,44784,44088/
            data (jx(i),i= 3701, 3800)/
     +  42840,41736,44856,45120,45048,45192,45456,46008,46080,46344,
     1  46512,46656,46608,46752,46776,46872,46968,47088,47304,47448,
     2  47592,47760,47784,48000,15240,15312,15408,15408,15312,39168,
     3  38880,38808,38496,38400,38304,38328,38136,38136,37968,37968,
     4  37800,37800,37968,37968,37800,39288,39768,40104,40296,40512,
     5  40608,40608,40632,40704,40896,41112,41424,41976,42072,42144,
     6  41928,41664,31416,31368,31440,31392,31560,31416,31224,31152,
     7  31056,30912,30792,30744,30504,32184,35232,35040,34920,34968,
     8  35328,35592,35664,44760,44616,44400,44256,44256,44400,14928,
     9  14808,14784,14688,14712,14592,14592,14496,14256,14256,14160/
            data (jx(i),i= 3801, 3900)/
     +  14136,12432,12312,16176,16296,16512,16584,16560,16632,16560,
     1  16752,16824,16800,16968,16944,17064,17160,17472,17448,17544,
     2  17640,17592,17616,17904,18024,18096,18312,18360,18312,18456,
     3  18552,18624,18984,19056,19200,19296,19344,19488,19656,19752,
     4  19824,19944,19944,19992,19992,20208,20232,14256,17880,15120,
     5  15120,20520,21672,21576,21552,21672,21648,26016,26088,26088,
     6  26208,26232,26352,26376,26496,26712,26688,26784,26688,46704,
     7  46536,46368,46536,46464,46392,46320,46224,45984,45888,45768,
     8  45672,45624,45456,45216,44856,44472,26016,24360,23904,23904,
     9  23760,23760,21648,26256,26376,26520,26688,26760,26808,27024/
            data (jx(i),i= 3901, 4000)/
     +  44400,44280,44232,44136,44160,44040,43776,43656,43416,43248,
     1  43176,42888,42768,42792,42672,42720,42672,28848,28968,28944,
     2  29016,28848,28776,28704,28608,28584,28752,28776,28656,28512,
     3  28512,28464,28512,28392,28200,27984,27768,27624,27528,27456,
     4  27528,29832,29856,30168,30192,31488,39792,40464,40176,37704,
     5  37800,40680,40368,39912,39912,39720,39528,39168,41208,41400,
     6  31560,31608,31536,31464,31392,30000,30024,29928,29952,36000,
     7  36432,36720,37032,36960,37560,37560,37608,37584,37704,14232,
     8  14136,14136,14016,13944,13824,13776,13776,13608,13560,13392,
     9  13320,13056,13032,12912,12912,12816,12816,12744,12696,20448/
            data (jx(i),i= 4001, 4100)/
     +  20640,20880,20808,20880,20784,32112,31992,31896,31752,31704,
     1  43104,43056,42960,42912,42864,43128,42912,42864,42984,42936,
     2  42984,28056,28056,27768,27720,27552,27504,27312,27216,27144,
     3  27000,27024,26856,27024,27144,27120,27192,27264,27216,27408,
     4  27576,27792,27936,28008,28152,28248,28272,28056,27744,27648,
     5  27600,27504,27360,27384,27456,27336,27336,27216,30384,30576,
     6  30576,30384,30408,30456,30408,30408,30456,30528,30744,30744,
     7  30912,30912,33384,33384,33552,33480,33504,33672,33768,33888,
     8  34176,34536,34920,35112,35808,35976,36072,36000,36072,51456,
     9  51576,51648,51408,51360,47544,47568,47496,47496,47976,48096/
            data (jx(i),i= 4101, 4200)/
     +  48072,48024,48048,48024,47880,47784,47496,47496,47640,47616,
     1  47568,47592,47496,47256,47064,47184,47400,47328,47376,47352,
     2  47424,47304,47400,46776,46824,46872,46776,47112,47160,47064,
     3  47280,47208,47256,47304,47040,47016,47160,47112,46488,46536,
     4  46416,46344,46392,47160,47112,47232,47928,48120,48048,48000,
     5  47880,47736,47880,47760,47832,47784,47712,47496,47448,47448,
     6  47352,47256,47232,47088,47088,47016,47136,47112,47232,47376,
     7  47496,47640,47712,47424,47376,47520,47496,46944,46872,46872,
     8  47112,47088,49128,49104,49224,49176,49224,49272,47928,47856,
     9  47952,47568,47712,47736,47808,47736,47568,49344,49296,49056/
            data (jx(i),i= 4201, 4230)/
     +  49224,48864,48864,48912,48984,48960,49104,49080,47976,48096,
     1  48048,48432,48408,48600,48504,48912,48912,48840,49800,49848,
     2  49896,49944,50088,50112,49824,49752,49512,49488,49632,    0/
            data (jy(i),i=    1,  100)/
     +  61680,61872,61440,61488,61800,61392,58056,61896,57720,61728,
     1  57288,55896,57720,53688,55416,52920,51240,48936,49056,46152,
     2  45720,43464,44016,39912,40488,36840,38088,33672,32760,30936,
     3  29160,28392,25104,26400,23928,23448,23976,23352,21432,20784,
     4  17616,15552,14832, 8880, 9048,11184,10512,11928,10776,10200,
     5   9840, 9672, 9192,62016,61344,61392,58248,58560,58944,59136,
     6  59280,59256,59328,59304,59616,59592,59832,59856,59976,60000,
     7  60072,60024,60144,60432,60408,60576,60528,60576,60648,60648,
     8  60816,60816,61008,61272,61392,57960,57888,57792,57648,57504,
     9  57312,57096,56880,56736,56736,56592,56544,56208,56184,55824/
            data (jy(i),i=  101,  200)/
     +  55632,55512,55488,55128,55224,55248,55176,55248,55200,55272,
     1  55176,54864,53832,53544,49608,49824,50232,50304,50568,51024,
     2  51288,52008,52320,52656,48840,48768,48408,47880,47784,47520,
     3  47496,47136,46848,46824,46488,45912,45504,45192,44952,44808,
     4  44592,44640,44520,44256,43656,43320,43080,42840,42720,42648,
     5  42432,42360,42240,41976,41928,41976,41928,41784,41640,41640,
     6  41520,41448,41352,41520,41376,41304,41304,41184,41256,41160,
     7  41208,41184,41088,41088,40968,40896,40632,40704,40560,40536,
     8  40248,40200,40056,40032,40176,40104,39864,39672,39504,39024,
     9  38808,38640,38664,38496,38544,38424,38376,38184,38256,38232/
            data (jy(i),i=  201,  300)/
     +  38088,36672,36624,36528,36384,36096,35712,35568,35472,35328,
     1  35304,35208,35016,34728,34344,34104,34008,33912,37872,37800,
     2  37656,37704,37632,37560,37488,37152,37104,37152,37128,36888,
     3  36792,36648,36336,36336,36288,36264,36144,36096,36120,36000,
     4  35712,35784,35664,35688,35568,35496,35352,35280,35160,35088,
     5  34968,34896,34824,34800,34656,34560,34560,34512,34368,34152,
     6  34032,33912,33552,33528,33432,33288,33168,33456,32880,32520,
     7  31848,31536,31296,31104,31032,30984,32688,32712,32568,32592,
     8  32520,32424,32376,32400,32304,32376,32304,32304,32016,31872,
     9  31848,31656,31224,31128,31056,30984,30888,30744,30384,30216/
            data (jy(i),i=  301,  400)/
     +  29832,29760,29880,29712,29592,29112,28992,28824,28704,28584,
     1  30864,30720,30528,30360,30024,29544,29400,29400,29352,29304,
     2  25104,24960,24912,24744,24672,24576,24864,24768,24528,24624,
     3  24552,24216,24072,24144,24096,24192,24360,24336,24432,24768,
     4  24864,24912,24864,25104,25152,25176,25008,24960,24552,24456,
     5  24480,24888,25056,25224,25296,25056,25008,24888,24816,24576,
     6  24240,24240,24144,24144,24048,24048,24648,24720,24912,24960,
     7  25032,25224,25392,25704,25752,25728,25896,25968,25968,25776,
     8  25560,25344,25224,25128,25008,25200,25368,25296,25416,25776,
     9  25872,25992,26136,26064,25848,25392,25248,25152,25056,25176/
            data (jy(i),i=  401,  500)/
     +  25392,25488,25704,25704,25584,25632,25824,26016,25944,26208,
     1  26232,26352,26544,26640,26880,26880,26736,26832,27024,27072,
     2  27336,27504,27672,27744,27768,27936,28008,28344,29040,29016,
     3  28872,28776,28608,28032,27528,27432,26712,24144,24504,24528,
     4  24456,24552,24696,24768,24456,24480,24648,24672,24864,24888,
     5  25008,26160,26016,25800,25464,25272,25224,25056,24600,24192,
     6  23304,23136,23112,23184,22728,22536,22512,22632,22776,22872,
     7  22968,23280,23352,23328,23928,23616,23568,23640,23568,23064,
     8  22992,22848,22440,22776,22896,23112,23760,23352,23088,22896,
     9  22392,22248,22008,21432,21096,21336,21216,21024,21072,20928/
            data (jy(i),i=  501,  600)/
     +  20688,20568,20520,20592,20472,20472,20688,20664,20448,20616,
     1  20472,20712,20616,20424,20448,20376,20400,20280,20232,20376,
     2  20328,20280,20256,20112,20256,20184,20040,19824,19680,19776,
     3  20184,20160,20040,20016,20160,20280,20064,19968,19464,19296,
     4  19272,19104,18864,18432,18480,18744,18912,19104,19032,19104,
     5  19224,19224,19056,18912,18792,18672,18480,18648,18576,18384,
     6  18432,18360,18528,18336,18264,18240,17976,18000,18216,18168,
     7  17736,17760,17952,17856,17952,17976,18288,18192,18072,18024,
     8  17856,17784,17832,17712,17568,23376,23256,23208,22872,22680,
     9  22512,22272,21984,22056,21960,21960,21888,21816,21720,21696/
            data (jy(i),i=  601,  700)/
     +  21840,21888,22032,22080,22176,22152,21672,21480,21480,21360,
     1  21288,20640,20472,20688,20904,21216,21264,21216,21240,21432,
     2  21456,20280,19824,19728,19296,18960,18528,18216,18096,18024,
     3  17928,17400,17208,17064,16944,16800,16632,16536,16104,15936,
     4  15744,17400,17280,17016,17040,17136,17496,17664,17640,17352,
     5  17352,17256,17088,17088,16992,17112,17040,16896,16776,16488,
     6  16560,17040,16800,16416,15816,15936,15696,15528,15504,15624,
     7  15792,15912,16056,16320,16536,16200,15960,15816,15648,15528,
     8  15360,15240,15480,15672,15744,16152,16368,16560,16536,16416,
     9  16344,16320,16440,16200,16056,15600,15696,15648,15480,15408/
            data (jy(i),i=  701,  800)/
     +  15264,15120,15072,14928,14496,14424,14472,14616,14712,15192,
     1  14352,14208,13848,13800,13272,12912,12768,12576,11688,11616,
     2  11472,11856,11616,11520,11520,11448,11472,11352,11112,11280,
     3  11160,10944,10944,10848,10872,10944,10920,10968,11016,10920,
     4  10896,10752,10704,10800,10704,10584,10728,10608,10656,10608,
     5  10536,10560,10464,10656,10680,10752,10992,10992,11304,11736,
     6  11832,11832,11952,11952,12096,12120,12312,12192,12264,12360,
     7  12360,12168,12168,12096,12096,12024,12048,12120,12456,12600,
     8  12888,13056,13320,13536,13584,13416,13392,13464,13632,13632,
     9  13488,13632,13776,13800,13680,13800,13872,13848,13704,13824/
            data (jy(i),i=  801,  900)/
     +  13800,13848,13656,13632,13848,13728,13920,14040,14040,14304,
     1  14400,14520,14616,11808,11784,11832,11904,11856,11760,11568,
     2  11328,11328,11472,11472,11376,11136,11040,11016,10728,10512,
     3  10128, 9912, 9312, 9216, 8784, 8328, 8208, 7752, 7320, 7128,
     4   7008, 6576, 6408, 6360, 6480, 6384, 6456, 6624, 7080, 7872,
     5   7992, 8208, 8520, 8784,60072,60120,59256,59256,59328,59352,
     6  60288,60312,59088,59376,59472,59688,59904,60096,60264,60432,
     7  60528,60480,60432,60432,60360,60360,60528,60720,60912,61152,
     8  61224,57456,58416,58416,59280,59232,59256,59376,59736,59904,
     9  60048,60048,60312,60336,60648,60816,60912,60936,61080,57288/
            data (jy(i),i=  901, 1000)/
     +  57384,57528,57720,57768,57888,58272,58272,58368,59328,59328,
     1  59400,59448,59616,59832,59904,59928,56880,58608,58896,59112,
     2  59184,59328,59664,59856,59904,61608,61608,61248,60768,60768,
     3  60432,60432,60360,60336,59832,59832,59760,59760,59856,59856,
     4  60840,60768,60528,60456,60432,60240,60216,60096,60072,59664,
     5  59496,59400,59160,59208,59160,59040,57480,58656,58704,58944,
     6  58776,58560,58368,58272,58992,59016,58800,58776,58704,58560,
     7  58488,58296,57984,57720,57648,57576,57480,57408,57024,56904,
     8  56688,56544,56208,56088,55920,55752,55632,58320,58248,58320,
     9  58440,58416,58296,58296,58200,58320,58296,58392,58488,58512/
            data (jy(i),i= 1001, 1100)/
     +  58896,58944,59064,59352,59448,59400,60648,60144,59280,59184,
     1  58944,58584,58224,61536,61248,60912,60792,60720,60648,60336,
     2  60216,60240,60144,60144,59976,59856,59688,59592,59568,59496,
     3  59280,59016,58944,58824,58728,58632,58512,58440,58512,58416,
     4  58560,58512,58392,58080,57960,57936,58128,58080,58128,57984,
     5  57984,57792,57648,57528,57960,57768,57600,57528,57504,57360,
     6  57312,57168,56928,56856,56232,56256,56136,56136,56016,56016,
     7  55920,55920,55704,57480,57384,57408,58320,58296,58320,58392,
     8  58512,58200,57792,57720,57504,57504,57384,57360,57456,57552,
     9  57504,57672,57624,57552,57480,57528,57264,57360,57312,57096/
            data (jy(i),i= 1101, 1200)/
     +  57120,57072,57480,57072,56904,56976,57000,57096,57096,57264,
     1  57264,57168,57168,57384,57384,57216,57312,57288,57240,57264,
     2  57360,57360,57528,56496,56568,56592,56712,56736,56664,56712,
     3  56568,56544,56616,56544,56880,56880,57024,56472,56520,56352,
     4  56376,56472,56376,56400,56544,56568,56472,56472,56400,56424,
     5  56568,56568,56496,56496,56424,54720,55320,55344,55392,56208,
     6  56928,56832,56832,56472,56496,55608,55608,55344,55152,55128,
     7  55008,54912,54864,54864,54744,54744,55224,55176,55056,55680,
     8  55776,55776,55680,57600,55320,54768,54936,54960,55128,55272,
     9  55344,55344,55464,56280,55320,55272,55176,55152,55104,55104/
            data (jy(i),i= 1201, 1300)/
     +  54960,54600,54072,53832,53760,53640,54456,53616,53640,52848,
     1  52800,55608,55272,55176,55176,55296,55296,55200,55176,55080,
     2  54936,54840,54768,54864,55368,55368,55464,55464,54888,54696,
     3  54816,54624,54648,54816,54816,54648,54648,54840,54888,54360,
     4  55368,55392,56352,54840,54456,54408,54504,54480,54408,54384,
     5  54312,54312,54384,53808,53712,53808,53784,54000,54048,54120,
     6  54240,54312,54528,54624,54648,54624,54576,54432,54144,54024,
     7  53808,53472,53328,53280,53160,52392,52512,52464,52488,52440,
     8  52536,52584,52584,52728,52536,52248,54672,53448,52680,52440,
     9  52176,52656,52056,52296,52176,52128,52008,52128,52104,52440/
            data (jy(i),i= 1301, 1400)/
     +  52680,52656,52056,51936,52728,52680,52728,52680,52656,50904,
     1  54096,54072,54168,54192,53640,53496,53256,53136,53064,52944,
     2  52584,52464,52416,52368,52296,52296,52080,52056,51960,51768,
     3  51216,50904,50376,50568,50952,51552,51696,51240,52632,52632,
     4  53064,53064,53160,53160,54192,54192,51288,51120,51144,51312,
     5  51384,51120,51048,51072,51000,51024,51072,51096,51048,50976,
     6  51000,51048,50952,50904,50976,50904,52080,51984,51936,51360,
     7  51312,51192,51192,50760,50880,51024,51024,50976,50976,50880,
     8  50832,50856,50808,51144,51072,50976,51000,50904,50808,50664,
     9  50448,50496,49320,49440,49512,49536,49680,49704,49848,49896/
            data (jy(i),i= 1401, 1500)/
     +  49800,49728,49704,49776,50136,50184,50184,51480,50976,50592,
     1  50544,50448,50400,50208,50088,50040,50112,50160,50280,50352,
     2  50472,50448,50688,50880,50976,51072,51384,51384,51552,51792,
     3  51960,50520,50328,49992,49752,49608,49392,48864,48624,48168,
     4  48000,47880,47880,46920,49896,49944,49728,49944,49872,49872,
     5  49992,50112,49968,49704,49608,49584,49680,49752,49584,49920,
     6  49680,49632,49656,49248,49488,49608,49560,49968,50016,50064,
     7  49992,51048,50880,50736,50472,50472,50376,50424,50352,50352,
     8  50232,50328,50328,50232,50304,50256,50304,50232,50280,50208,
     9  50232,50088,50112,50040,50040,49224,49248,49152,49248,49296/
            data (jy(i),i= 1501, 1600)/
     +  49152,49416,49296,49320,49392,49536,49560,49656,49608,49728,
     1  49848,49968,49368,49272,49296,49152,49032,49560,49536,49080,
     2  49008,48888,49176,49320,49536,49776,48576,48600,48456,48552,
     3  48504,48576,48720,47904,49032,45240,45696,46992,47472,47568,
     4  47880,47976,47808,49584,49368,49320,49248,49152,49056,48912,
     5  48456,47784,48840,48816,48744,48744,48408,48360,48264,48144,
     6  48168,48048,47904,49392,49392,47712,47472,48504,48312,48264,
     7  48072,47928,47880,47688,47568,47544,47496,47376,47400,47232,
     8  47376,47352,47208,47088,46872,46776,47664,46800,49248,49200,
     9  48840,48696,48336,48072,47856,47520,47136,47016,46728,45984/
            data (jy(i),i= 1601, 1700)/
     +  46176,45888,45912,46560,46440,46056,46368,46584,46944,47184,
     1  47304,47712,47784,48072,48168,48600,48648,48792,48816,48912,
     2  48888,47904,46752,46752,46704,46512,46512,46608,46608,46104,
     3  47328,47352,47040,46968,46344,46272,46128,46056,49536,49512,
     4  45720,45696,45648,45672,45480,45480,45672,45312,45384,45336,
     5  45480,45480,45552,45456,45576,45600,45672,45600,45696,45672,
     6  45840,45744,45864,45888,45672,45792,45696,46560,45240,45456,
     7  45456,45624,45552,45576,45648,45168,45072,44928,44808,44688,
     8  44688,44616,44328,44136,43872,43728,43440,43272,43128,43008,
     9  42936,42552,42360,42312,41928,41808,45168,45360,45336,45432/
            data (jy(i),i= 1701, 1800)/
     +  45360,45264,45312,45192,45240,45168,45264,45192,45360,45168,
     1  45120,45048,44976,44880,44880,44952,44832,44856,45144,45312,
     2  45360,46752,46752,46560,46440,46272,46248,46056,45936,45816,
     3  45696,45552,45648,45480,45168,45000,45024,46776,46776,46872,
     4  46872,44928,45072,45168,45504,45528,44760,44808,44760,44880,
     5  45024,45048,45096,45216,45216,45384,45360,45432,44952,44928,
     6  44832,45000,44808,45768,44592,45960,45600,45504,45144,45048,
     7  44856,44856,44736,44688,44472,44424,44352,44208,44208,44088,
     8  43944,43800,43608,43488,44880,44688,44376,44280,44280,46464,
     9  46344,46296,46344,46080,45648,44184,45432,44664,44616,44664/
            data (jy(i),i= 1801, 1900)/
     +  44424,44232,44832,44616,44088,44280,44088,44088,44184,44208,
     1  44088,44064,43848,43512,43440,43464,43680,43632,43512,43392,
     2  43320,43248,43512,43848,44568,44832,45048,45144,44976,45048,
     3  45288,45480,45696,45744,43224,43560,43656,43800,44016,44088,
     4  42960,42936,43200,43440,43560,43632,43800,43848,43704,43752,
     5  43704,43920,44064,44232,44520,44616,44664,44640,42960,42864,
     6  42936,43056,43008,39864,42264,42336,42552,42672,42816,42816,
     7  43080,43056,43224,43560,43632,43728,43776,43584,43632,43704,
     8  43896,42864,42744,42600,42528,42384,42384,42240,42336,42504,
     9  42504,42720,42816,43032,43032,43224,43224,43320,43320,43536/
            data (jy(i),i= 1901, 2000)/
     +  43824,43920,43920,44112,44280,44592,45600,45600,45504,45504,
     1  45216,45216,45120,45096,45024,45024,44904,44904,44520,44520,
     2  43752,43776,43200,43200,43104,43104,43200,43224,42216,41928,
     3  42120,42264,42312,42384,42432,42360,42336,42264,42240,42408,
     4  42480,42552,42480,42720,43008,43152,43248,40056,40176,40440,
     5  40848,41112,41376,41664,41784,41952,42096,41520,41544,41544,
     6  41736,41712,41880,41856,41976,41976,42216,42216,42552,42624,
     7  42624,42720,42192,42000,41952,41688,41736,41544,41352,40968,
     8  40872,40848,40392,41304,42960,42552,42072,41808,41856,41616,
     9  41640,41544,41544,41400,41304,43800,43344,42936,42624,42360/
            data (jy(i),i= 2001, 2100)/
     +  42360,42168,42096,41856,41448,41136,42120,42024,41928,41832,
     1  41472,41112,41616,41592,41400,41400,40920,40752,40872,41016,
     2  41256,40872,40728,40776,40848,41040,41088,40656,40704,40896,
     3  40896,41208,41328,41448,41496,42792,42816,42720,42408,42336,
     4  42240,42120,42000,42000,41952,41592,41472,41448,41352,41280,
     5  40848,40680,40272,40440,40440,40632,40632,40536,40512,40344,
     6  40488,40440,40536,40872,40680,40680,40536,40584,40488,40776,
     7  40872,40896,40800,40800,40920,40920,40824,40872,40488,40488,
     8  40584,40368,40440,40272,40464,40656,40656,40560,40416,40248,
     9  40344,40320,40440,40296,40536,40848,41088,40248,40320,40416/
            data (jy(i),i= 2101, 2200)/
     +  40440,40536,40560,40464,40464,40344,40248,40128,40104,40296,
     1  40200,40224,41760,41544,41400,41304,41064,41088,41040,40920,
     2  40800,40872,40824,40536,40248,40152,39984,39984,40032,39912,
     3  39936,39792,39840,39768,39792,39912,39912,39792,39816,39984,
     4  39960,39984,39912,40008,39744,39456,39504,39456,39816,39648,
     5  40248,40176,40080,40008,39720,39672,39384,39360,39144,39096,
     6  39144,39120,39072,39360,39456,39552,39672,40488,40296,40176,
     7  40080,40008,39336,39216,38976,39000,38664,38664,39360,39264,
     8  38832,38616,38376,38280,38136,38040,37896,37824,37608,37464,
     9  37320,38496,38472,38328,38568,38712,39144,39240,39312,39528/
            data (jy(i),i= 2201, 2300)/
     +  39984,38496,38496,38400,38400,37920,40176,40080,39840,39744,
     1  39648,39552,39336,39264,39096,39024,39048,38760,38544,38448,
     2  38232,38112,37944,37824,37776,37800,38040,37944,38040,38040,
     3  37944,37176,37872,37344,37344,37152,37104,37416,37440,37560,
     4  37776,38040,38160,38304,38424,37416,37824,37848,37704,37776,
     5  37608,37392,37560,37296,37224,37080,37200,36912,36720,36696,
     6  37080,37104,37272,37512,37656,37680,36672,36600,36480,36672,
     7  36648,36336,36288,36648,36216,37320,37176,36120,36144,36240,
     8  36264,36168,36000,36024,35952,36384,36240,36528,36528,36672,
     9  36864,37200,35664,36864,38352,39408,39576,40320,40344,40584/
            data (jy(i),i= 2301, 2400)/
     +  38856,38832,38640,38496,38424,38376,38256,38160,38040,37992,
     1  37800,37872,37008,36648,36048,35664,35544,36696,36816,36912,
     2  36888,37008,36672,36600,36216,35448,35376,33600,32928,35400,
     3  35280,35376,35400,35520,35568,35040,35232,35160,35232,35208,
     4  35496,35496,35376,35448,35472,35544,36120,36168,36024,36072,
     5  36360,36384,36360,36408,36648,36720,35736,35568,35520,34752,
     6  34824,34752,34824,34776,34680,34344,34248,33888,34872,35424,
     7  35352,35256,34968,35112,35256,35088,35256,35520,36912,36600,
     8  36456,36024,36000,35784,35616,35352,35304,34872,34992,34848,
     9  34824,34896,34872,34992,35064,35088,35208,35256,35424,35472/
            data (jy(i),i= 2401, 2500)/
     +  35424,35568,35568,35736,34272,34512,35640,35640,36216,34704,
     1  34776,34848,34920,34920,34800,34944,34248,34584,34224,34224,
     2  35784,35760,35616,35472,34848,34656,34488,34296,33840,34008,
     3  34008,31512,31776,31704,31824,31824,31944,31920,32016,31968,
     4  32112,32088,32208,32208,32424,32424,32520,32664,32736,32856,
     5  32928,33000,33072,33144,33360,33384,33456,33408,33792,33576,
     6  36144,35112,35112,35016,34992,34896,34896,34728,34728,34632,
     7  34440,34440,33240,33600,33312,34896,34896,34752,34752,34248,
     8  34272,33792,33576,33480,32904,32904,32856,33792,33000,33000,
     9  32760,32664,32472,32928,32760,32760,32688,32712,32784,32808/
            data (jy(i),i= 2501, 2600)/
     +  32712,32712,32784,32688,32544,32496,32496,32640,32592,32640,
     1  32640,32472,32424,32784,32640,32640,32856,32976,33048,33048,
     2  34248,32496,32616,32592,32736,32712,32808,32856,32928,33000,
     3  33552,33624,33696,33672,33984,34128,34248,34152,34272,34176,
     4  32136,32328,32112,34320,33984,33672,33072,32040,31896,31992,
     5  31992,31872,32136,32160,32016,32112,32400,32664,33216,33312,
     6  33408,33312,33456,33648,33912,34224,34296,31632,31704,31752,
     7  31872,31992,31992,31824,31824,32160,32160,32088,32112,32208,
     8  32208,32112,31752,31344,31848,31920,31944,31896,33864,33768,
     9  33792,33432,33336,33288,32928,32832,32784,32664,32544,32136/
            data (jy(i),i= 2601, 2700)/
     +  32040,31968,31848,31752,31440,34032,33744,33744,33576,33552,
     1  33264,33264,33120,32208,32376,32040,32040,32136,32136,31944,
     2  31944,31344,31368,31272,31272,31488,31536,32664,32688,32568,
     3  32568,32400,32400,32088,32088,31992,31992,31512,31440,31224,
     4  31224,30912,30864,31296,31296,31368,31272,31392,31368,31704,
     5  31872,32352,30744,30792,30840,31200,32016,32016,32208,32208,
     6  32304,32328,32232,32232,32136,32136,30936,30936,30888,30600,
     7  31296,31296,30936,30936,30792,30792,30936,30936,30624,31800,
     8  31800,31680,31704,31296,31200,31104,31008,30672,30384,30144,
     9  29976,32184,32184,29088,32376,31920,31368,30888,29928,29856/
            data (jy(i),i= 2701, 2800)/
     +  29616,29544,29520,30312,30312,30600,30600,30984,31272,31272,
     1  29496,29520,29640,29784,29880,30048,30144,30120,30240,30480,
     2  30504,30648,30960,31080,31200,31272,31272,31368,31584,31680,
     3  31848,29448,30744,30600,29472,29400,29400,29472,29352,29520,
     4  29328,29328,29424,29256,29256,29568,29784,29784,29952,31272,
     5  30000,29784,29328,29400,29328,29256,29184,29088,29064,29112,
     6  28992,29016,29112,31824,31680,31296,31248,31104,30912,30744,
     7  30648,29136,28920,27552,27816,28008,28080,28344,28560,28608,
     8  28752,28992,28992,28896,28968,28896,28920,29688,29712,28872,
     9  28368,28416,28320,28320,28152,28584,28608,28656,28920,29064/
            data (jy(i),i= 2801, 2900)/
     +  29136,29160,29352,29424,29616,29688,29880,29928,30096,30216,
     1  30360,30360,30528,30672,30720,30864,31056,31248,31248,31416,
     2  31152,31152,29760,29760,28992,28992,28560,28536,28320,28320,
     3  28224,28176,28248,28176,28248,28176,29040,28968,29040,29112,
     4  29544,29424,29064,28752,28512,28296,28152,28104,28104,28176,
     5  28176,28080,28056,27840,27888,28080,28080,28176,28176,28368,
     6  28392,28560,28584,28800,28896,28992,28992,29088,27648,28032,
     7  27480,27432,28848,28896,28992,28992,29424,28920,28080,27744,
     8  27504,27216,27216,27288,27528,27552,27456,27480,27384,27408,
     9  27504,27504,27408,26784,26952,26976,27072,27312,28512,26928/
            data (jy(i),i= 2901, 3000)/
     +  28416,28272,28176,28056,27912,27600,27480,27336,27144,26976,
     1  26688,26544,26496,26400,26304,26112,25992,25968,25896,25896,
     2  25800,25848,25776,25728,25680,25512,25440,26472,26544,26568,
     3  26664,26640,26856,26976,27216,27240,27312,27312,27552,27672,
     4  27744,27960,26376,26304,26304,26184,26184,26280,26280,26184,
     5  26136,26040,26064,25872,25848,25752,25752,25656,25632,25536,
     6  25536,26352,26304,26352,26712,25896,25920,26760,26760,25872,
     7  25464,28392,29304,25776,25440,25368,25152,24912,24768,24576,
     8  24504,24408,24000,23808,23520,23448,23304,23280,25416,25872,
     9  25872,25968,25968,26064,26064,26136,26160,26328,26664,26664/
            data (jy(i),i= 3001, 3100)/
     +  27504,28128,28128,28224,28224,28416,28416,28488,28512,28992,
     1  28992,25488,25584,25584,25464,25392,25512,25488,25416,25392,
     2  25392,25416,25344,25464,25608,25584,25728,25704,25968,26040,
     3  26088,26184,26208,26304,26376,26544,26712,26808,26856,27024,
     4  27096,27120,27384,27600,27744,27816,28008,28152,28272,28464,
     5  28608,28728,29016,29112,29208,29232,29304,25392,25392,25320,
     6  25440,25344,25320,25224,25368,26304,25944,25512,25344,25200,
     7  25080,24024,24240,24336,24480,24744,24888,25056,24984,25128,
     8  25416,25344,25344,25272,25344,25248,25296,25224,25248,25392,
     9  25392,25608,25656,25848,25992,26088,26208,26424,26400,26496/
            data (jy(i),i= 3101, 3200)/
     +  26616,26664,26760,26832,24888,25344,25896,25992,26112,26448,
     1  26592,26616,26760,26832,27024,27240,27360,27384,25320,25032,
     2  25104,24984,27552,27624,27696,27480,27360,24768,27168,26976,
     3  27024,26856,26808,26616,26544,26400,26304,26280,26088,25896,
     4  25848,25848,25776,25776,25656,25392,25320,25344,25248,25200,
     5  25128,25056,24888,24744,26688,27456,27744,28152,28272,28488,
     6  28656,29064,25296,25200,25224,25344,25200,25296,25344,25248,
     7  25128,25128,24984,25056,25008,25104,25104,24936,24984,24792,
     8  24840,24744,24744,25248,25584,25272,24888,24672,24600,24648,
     9  24576,24672,24504,24432,24576,24600,24408,24144,24168,23904/
            data (jy(i),i= 3201, 3300)/
     +  23736,22176,22968,23232,23376,23520,23784,23856,24000,24096,
     1  24264,24408,24984,25296,25440,25512,24312,24432,24504,24720,
     2  24768,24888,24312,24192,24144,24264,24432,24504,24456,24528,
     3  24624,24192,24120,23880,23784,23760,23856,23808,23784,23760,
     4  23856,23832,24048,23952,23952,24168,23712,23640,23712,23688,
     5  23784,23856,23928,24120,24120,24216,24192,24384,24528,24696,
     6  24648,24672,24792,24912,23568,23616,23712,23832,23784,23760,
     7  23688,23568,23520,23592,23568,23664,23712,23808,23784,23904,
     8  23832,23904,23832,23616,23496,23496,23328,23352,23280,23376,
     9  23328,23376,23328,23448,23304,23232,23304,23280,23376,23424/
            data (jy(i),i= 3301, 3400)/
     +  23424,23568,23568,23688,23640,23784,23688,23688,23856,23856,
     1  23928,23568,23688,23400,23400,23328,23208,23136,23568,23736,
     2  24000,24048,23904,23904,22848,22872,22704,22704,22392,22032,
     3  22008,22176,22416,22488,22704,22776,22992,23232,23280,23376,
     4  23496,23592,23688,23784,23856,23808,23904,24168,24168,24336,
     5  21960,21984,21960,21888,21936,22368,22368,22560,22560,22656,
     6  22656,23040,23064,23616,23592,23400,22512,22320,22104,21816,
     7  21816,21912,21912,21816,21840,22008,22032,21840,21840,22032,
     8  22032,21912,21936,22032,22056,22104,22128,22056,22056,21864,
     9  23088,23256,23232,23088,23088,22200,22176,21864,21816,22128/
            data (jy(i),i= 3401, 3500)/
     +  21792,21744,22440,22440,22560,22560,23736,23736,23952,24168,
     1  24624,21696,21912,21600,21576,21696,21552,21648,21648,21576,
     2  21624,21504,21624,21480,21648,21696,21936,22008,22104,21192,
     3  21504,21504,22416,22392,22560,22944,23040,20928,21264,20976,
     4  20904,20952,21264,21336,21288,21360,21552,21624,23712,20760,
     5  20280,20496,20712,20712,20832,20856,21048,21048,21144,21240,
     6  21264,21576,21576,21696,21696,20784,20400,20400,20496,20448,
     7  20568,20400,20328,20448,20448,20592,20592,20760,20832,20904,
     8  21024,21024,21120,21024,21144,21264,21192,21264,21312,21408,
     9  21504,21528,21648,21672,21768,21768,21648,21624,21696,21768/
            data (jy(i),i= 3501, 3600)/
     +  21816,21936,22104,22344,22512,22680,22824,22920,22824,22944,
     1  22920,22992,23064,23256,20280,20208,20160,19920,19848,19776,
     2  19680,19632,19488,19272,22392,22032,21888,21816,21792,21552,
     3  21432,20976,20760,20616,20568,20232,20928,20904,20760,20712,
     4  20448,20040,19896,19848,19896,19776,19680,21888,21888,21600,
     5  21600,21456,21456,21312,21312,20760,20184,20088,19752,19704,
     6  19632,19728,19920,20016,20160,20160,20496,20496,20376,20376,
     7  21600,21360,21216,20928,20880,20472,20256,20112,19848,19728,
     8  19608,19560,19776,19776,19920,19944,20832,20832,20976,20976,
     9  21696,21696,21792,21816,21888,21888,21984,19560,20616,20616/
            data (jy(i),i= 3601, 3700)/
     +  19560,23736,23664,23400,23400,23232,23232,23088,23088,20688,
     1  20688,20544,20544,19536,19584,19536,19608,19752,19776,19608,
     2  19608,19512,19560,19656,19680,19584,19584,19680,19680,19584,
     3  19512,19584,20112,19536,19344,19080,20232,20088,20088,19944,
     4  19944,19800,19800,19488,19512,19368,19368,19200,19200,19056,
     5  19080,18912,18912,19536,19224,19248,18936,18360,18600,18792,
     6  19056,19392,19632,19608,18312,19560,19008,18840,18816,18792,
     7  18624,18360,19656,19656,18912,18888,18768,18768,18624,18600,
     8  18456,18480,18312,18264,18120,19344,19368,19944,19944,18048,
     9  18312,18144,18120,18048,18168,18024,18000,18168,17832,18216/
            data (jy(i),i= 3701, 3800)/
     +  18024,18264,17784,18216,18360,18648,18648,19200,18960,18648,
     1  18504,18480,18360,18360,18264,18240,18120,18096,17880,17928,
     2  17760,17832,17592,17520,17568,18432,18432,18528,18528,16632,
     3  16656,16776,17016,17208,17256,17376,17472,18240,18240,18456,
     4  18456,18600,18600,18720,18744,16560,16584,16368,16536,16584,
     5  16776,16968,17016,16968,17160,17232,17160,17232,17352,17592,
     6  17688,18216,16272,16536,16704,16824,17376,17448,18120,18192,
     7  18192,18288,18480,18696,18864,16248,16200,16680,16680,17304,
     8  17424,17256,17256,17424,17256,16320,15936,15888,15936,17592,
     9  17568,17496,17496,17568,17568,17496,17520,17520,17592,17592/
            data (jy(i),i= 3801, 3900)/
     +  17520,17640,15456,15408,17496,15384,15504,15744,15840,15912,
     1  16104,16104,16296,16392,16440,16416,16584,16752,16632,16656,
     2  16824,16920,17016,17232,17256,17472,17688,17856,18024,18120,
     3  18096,18240,18288,18432,18360,18408,18384,18576,18624,18576,
     4  19008,19080,19008,18984,19200,19296,19248,15360,15360,15312,
     5  15456,15264,15648,15648,15528,15528,15216,15120,15264,15360,
     6  15504,15840,15936,16296,16344,16632,16968,17424,17736,14904,
     7  14880,15048,15360,15456,15432,15288,15312,15240,15312,15192,
     8  15312,15264,15408,15384,15696,15720,14592,14688,14712,14568,
     9  14568,14712,14808,14832,14808,14832,14760,14808,14664,14568/
            data (jy(i),i= 3901, 4000)/
     +  15888,15840,15624,15648,15864,15696,15600,15408,15312,15096,
     1  15120,15048,14856,14664,14664,14616,14496,14472,14616,14736,
     2  14880,14976,15216,15216,15288,15552,15864,16128,16200,16416,
     3  16704,16800,16968,17136,17088,17208,17544,17664,17664,17928,
     4  18120,14424,14856,14856,15864,15816, 8880,11400,11496,11568,
     5  14160,14088,14544,14976,15984,15960,16128,16248,14088,14856,
     6  12336,12936,13080,13104,13464,13536,14112,14136,14424,14232,
     7  14016,13584,13560,11880,11880,10512,10344, 9408, 9432,15120,
     8  15144,15024,15024,13200,13200,13080,12600,12432,12216,12168,
     9  12000,11952,11880,11880,11784,11784,11664,11616,11424,13968/
            data (jy(i),i= 4001, 4100)/
     +  13584,13296,12864,12720,12600,12528,12576,12432,12432,12336,
     1  12864,12840,12912,12864,12936,13464,13632,13776,13920,14064,
     2  14400, 9912,10104,10248,10344,10320,10488,10488,10584,10752,
     3  10848,11016,11256,11400,11400,11640,11664,11880,12024,11976,
     4  12144,12096,12144,12264,12240,12288,12432,12792,12792,12912,
     5  12864,12888,13032,13440,13560,13848,13992,14088, 9912, 9912,
     6  10056,10080,10824,10824,10872,11472,11688,11784,11784,12096,
     7  12096,12336,12096,12000,11808,11688,11496,11400,11112,10992,
     8  10896,10848,10896,10776,10632,10536,10368,10176, 9984,23952,
     9  23880,24048,24096,24024,10536,10584,10920,11232,12480,13176/
            data (jy(i),i= 4101, 4200)/
     +  13248,13200,13296,13632,13560,13176,12936,12816,12744,12600,
     1  12600,12672,12768,12768,12504,12336,12264,12072,11952,11496,
     2  11208,10728,10608,12024,12000,12072,12072,11952,11856,11928,
     3  11760,11664,11616,11664,11808,11664,11616,11808,13608,13704,
     4  13728,13632,13560,13560,13512,13512,14208,14928,15336,15360,
     5  15144,15048,14544,14136,14088,14400,14352,14472,14568,14664,
     6  14784,14808,14856,14832,14928,15000,15048,15288,15240,15024,
     7  15000,14808,14856,14256,14160,14160,14256,15672,15672,15576,
     8  15432,15576,17616,17496,17400,16368,16344,16416,15984,15840,
     9  15960,15960,15792,15816,16080,16272,16080,20424,20496,20400/
            data (jy(i),i= 4201, 4230)/
     +  20256,18576,18672,18672,18648,18600,18528,18624,17880,17880,
     1  17832,17808,17736,17760,17832,17784,17712,17688,21336,21360,
     2  21312,21816,21792,21864,21960,21864,21912,21864,21792,    0/
            data (jb1(i),i=    1,  100)/
     +      9,    8,    2,    2,    5,    1,    1,    3,    3,   55,
     1      6,    7,   57,   58,   59,   60,   61,   62,   63,   64,
     2     65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
     3     75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
     4      6,    7,   86,   87,   13,    9,   13,   89,   90,   91,
     5     92,   93,   94,   95,   96,   97,   98,   12,   12,  100,
     6    101,  102,   15,   15,  104,  105,  106,  107,  108,  109,
     7    110,  111,  112,  113,   16,   11,   14,   18,  115,  116,
     8    117,  118,  119,  120,  121,  122,  123,   16,   17,   19,
     9     18,  125,  126,  127,  128,  129,  130,  131,  132,  133/
            data (jb1(i),i=  101,  200)/
     +    134,  135,   21,   21,  137,  138,  139,  140,  141,  142,
     1    143,   23,   20,   23,  145,  146,  147,  148,  149,  150,
     2    151,  152,  153,  154,  155,  156,  157,  158,  159,  160,
     3    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     4    171,  172,  173,  174,  175,  176,  177,  178,  179,   25,
     5     22,   24,   25,  181,  182,  183,  184,  185,  186,  187,
     6    188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
     7    198,  199,  200,   27,   26,  202,  203,  204,  205,  206,
     8    207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
     9    217,   28,   27,  219,  220,  221,  222,  223,  224,  225/
            data (jb1(i),i=  201,  300)/
     +    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     1    236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
     2    246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
     3    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     4    266,   29,   28,  268,  269,  270,  271,  272,  273,  274,
     5    275,   30,   29,  277,  278,  279,  280,  281,  282,  283,
     6    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     7    294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
     8    304,  305,  306,  307,  308,  309,   32,   30,  311,  312,
     9    313,  314,  315,  316,  317,  318,  319,   31,   33,  321/
            data (jb1(i),i=  301,  400)/
     +    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     1    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     2    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     3    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     4    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     5    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     6    382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
     7    392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
     8    402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
     9    412,  413,  414,  415,  416,  417,  418,  419,  420,  421/
            data (jb1(i),i=  401,  500)/
     +    422,  423,  424,  425,  426,  427,   32,   31,  429,  430,
     1    431,  432,  433,  434,  435,  436,   34,   37,  438,  439,
     2    440,  441,  442,  443,  444,  445,  446,  447,  448,  449,
     3    450,   33,   34,  452,  453,  454,  455,  456,  457,  458,
     4    459,   35,   38,  461,  462,  463,  464,  465,  466,  467,
     5    468,  469,  470,  471,  472,  473,   36,   37,  475,  476,
     6    477,  478,  479,  480,  481,  482,  483,  484,  485,   38,
     7     35,  487,  488,  489,  490,  491,  492,  493,  494,   40,
     8     39,  496,  497,  498,  499,  500,  501,  502,  503,  504,
     9    505,  506,  507,  508,  509,  510,  511,  512,  513,  514/
            data (jb1(i),i=  501,  600)/
     +    515,  516,  517,  518,  519,  520,  521,  522,  523,  524,
     1    525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
     2    535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     3    545,  546,  547,  548,  549,  550,  551,  552,  553,  554,
     4    555,  556,  557,  558,  559,  560,  561,  562,  563,  564,
     5    565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
     6    575,  576,  577,  578,  579,  580,  581,  582,  583,  584,
     7     41,   36,  586,  587,  588,  589,  590,  591,  592,  593,
     8    594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
     9    604,  605,  606,  607,  608,  609,  610,  611,  612,  613/
            data (jb1(i),i=  601,  700)/
     +    614,  615,  616,  617,  618,  619,  620,   39,   40,  622,
     1    623,  624,  625,  626,  627,  628,  629,  630,  631,  632,
     2    633,  634,  635,  636,  637,  638,  639,  640,   42,   41,
     3    642,  643,  644,  645,  646,  647,  648,  649,  650,  651,
     4    652,  653,  654,  655,  656,  657,  658,  659,  660,  661,
     5    662,  663,  664,  665,  666,  667,  668,  669,  670,  671,
     6    672,  673,  674,  675,  676,  677,  678,  679,  680,  681,
     7    682,  683,  684,  685,  686,  687,  688,  689,  690,  691,
     8    692,  693,  694,  695,  696,  697,  698,  699,  700,  701,
     9    702,  703,  704,  705,  706,  707,  708,   43,   42,  710/
            data (jb1(i),i=  701,  800)/
     +    711,  712,  713,  714,  715,  716,  717,  718,  719,  720,
     1     46,   48,  722,  723,  724,  725,  726,  727,  728,  729,
     2    730,  731,  732,  733,  734,  735,  736,  737,  738,  739,
     3    740,  741,  742,  743,  744,  745,  746,  747,  748,  749,
     4    750,  751,  752,  753,  754,  755,  756,  757,  758,  759,
     5    760,  761,  762,  763,  764,  765,  766,  767,  768,  769,
     6    770,  771,  772,  773,  774,  775,  776,  777,  778,  779,
     7    780,  781,  782,  783,  784,  785,  786,  787,  788,  789,
     8    790,  791,  792,  793,  794,  795,  796,  797,  798,  799,
     9    800,  801,  802,  803,  804,  805,  806,  807,  808,  809/
            data (jb1(i),i=  801,  900)/
     +    810,  811,  812,   43,   46,   47,   47,   50,   51,   52,
     1     45,   44,   48,  814,  815,  816,  817,  818,  819,  820,
     2    821,  822,  823,  824,  825,  826,  827,  828,  829,  830,
     3    831,  832,  833,  834,  835,  836,  837,  838,  839,  840,
     4    841,  842,  843,  844,  845,  846,  847,  848,  849,  850,
     5    851,  852,  853,   44,  855,  856,  857,  858,  859,  860,
     6    861,  862,  863,  864,  865,  866,  867,  868,  869,  870,
     7    871,  872,  873,  874,  875,  876,  877,  878,  879,  880,
     8    881,  882,  883,  884,  885,  886,  887,  888,  889,  890,
     9    891,  892,  893,  894,  895,  896,  897,  898,  899,  900/
            data (jb1(i),i=  901, 1000)/
     +    901,  902,  903,  904,  905,  906,  907,  908,  909,  910,
     1    911,  912,  913,  914,  915,  855,  917,  918,  919,  920,
     2    921,  922,  923,  924,  855,    5,  926,  927,  928,  929,
     3    930,  931,  932,  933,  934,  935,  936,  937,  938,  939,
     4    857,    6,  941,  942,  943,  944,  945,  946,  947,  948,
     5    949,  950,  951,  953,  952,  863,  955,  953,  957,  958,
     6    857,  863,  960,  961,  962,  963,  953,  965,  966,  967,
     7    968,  969,  970,  971,  972,  973,  974,  975,  976,  977,
     8    978,  979,  980,  981,  982,  983,  984,  985,  986,    7,
     9    988,  989,  990,  991,  992,  993,  994,  995,  996,  997/
            data (jb1(i),i= 1001, 1100)/
     +    998,  999, 1000, 1001, 1002, 1003, 1004, 1005,  952,    8,
     1   1007, 1008, 1009, 1010, 1011, 1012, 1013,   10, 1014, 1015,
     2   1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025,
     3   1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035,
     4   1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045,
     5   1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053,  964, 1055,
     6   1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065,
     7   1066, 1067, 1068, 1069, 1070, 1071, 1072, 1054, 1074, 1075,
     8    957,  964, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084,
     9   1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094/
            data (jb1(i),i= 1101, 1200)/
     +   1095,  882,  900, 1097, 1098,  882,   11,  900, 1100,  957,
     1   1103, 1102,  917, 1105, 1106, 1107, 1108, 1109, 1110, 1111,
     2   1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121,
     3   1122, 1054, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     4   1132, 1133, 1134, 1135, 1136, 1101,  917, 1124, 1139, 1140,
     5   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150,
     6   1151, 1152, 1153, 1154, 1138, 1156, 1157, 1158, 1159, 1160,
     7   1101, 1102, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169,
     8   1170, 1171, 1172, 1173, 1174, 1175,   12, 1177, 1178, 1073,
     9   1180, 1181, 1182,  987,   13, 1184, 1186, 1187, 1188, 1189/
            data (jb1(i),i= 1201, 1300)/
     +   1190, 1191, 1192, 1185, 1100, 1194, 1195, 1196, 1197, 1198,
     1   1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206,   15, 1207,
     2   1208, 1209, 1210, 1073, 1212, 1213, 1214, 1215, 1216, 1217,
     3   1218, 1219, 1220, 1221, 1222, 1156, 1179, 1224, 1225, 1226,
     4   1227, 1138,  987, 1224, 1229, 1230, 1231, 1232, 1233, 1234,
     5   1235, 1236, 1237, 1238, 1176, 1240, 1241, 1242, 1124, 1224,
     6   1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252, 1240,
     7   1240, 1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262,
     8   1263, 1264, 1156, 1186, 1266, 1267, 1268, 1269, 1270, 1271,
     9   1272, 1273, 1274, 1211, 1276, 1277, 1278, 1279, 1280, 1281/
            data (jb1(i),i= 1301, 1400)/
     +   1282, 1283, 1284, 1285, 1179, 1287, 1288, 1289, 1286, 1291,
     1   1211, 1254, 1291, 1294, 1295, 1296, 1297, 1298, 1299, 1300,
     2   1301, 1302, 1286, 1303, 1304, 1305, 1306, 1307, 1308, 1275,
     3   1310, 1311, 1312, 1313, 1224, 1255, 1315, 1316, 1317, 1318,
     4   1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328,
     5   1329, 1331, 1330, 1333, 1334, 1335, 1336, 1330, 1338, 1339,
     6   1340, 1341, 1342, 1343, 1344, 1345, 1176, 1275, 1338, 1347,
     7   1348, 1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357,
     8   1338, 1353, 1359, 1360, 1361, 1362, 1363, 1364, 1365, 1310,
     9   1293, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1310, 1375/
            data (jb1(i),i= 1401, 1500)/
     +   1376, 1377, 1378, 1379, 1380, 1381, 1382, 1374, 1293, 1384,
     1   1385, 1386, 1387, 1388, 1389, 1390, 1391, 1333, 1393, 1394,
     2   1395, 1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404,
     3   1405, 1406, 1333, 1304, 1408, 1409, 1410, 1411, 1412, 1413,
     4   1414, 1416, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424,
     5   1425, 1426, 1427, 1428, 1429, 1430, 1291, 1374, 1432, 1433,
     6   1434, 1435, 1436, 1437, 1438, 1439, 1440, 1441, 1442, 1443,
     7   1416, 1445, 1446, 1447, 1448, 1449, 1450, 1451, 1452, 1453,
     8   1454, 1455, 1456, 1457, 1458, 1415, 1460, 1461, 1462, 1459,
     9   1464, 1465, 1466, 1467, 1468, 1469, 1470, 1415, 1331, 1472/
            data (jb1(i),i= 1501, 1600)/
     +   1473, 1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482,
     1   1483, 1484, 1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492,
     2   1493, 1494, 1464,   18, 1496, 1497, 1498, 1499, 1501, 1502,
     3   1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1416,
     4   1500, 1513, 1514, 1515, 1501, 1517, 1518, 1353, 1517, 1520,
     5   1521, 1522, 1523, 1524, 1525, 1331, 1464, 1522, 1528, 1529,
     6   1530, 1531, 1532, 1527, 1534, 1517, 1536, 1537, 1538, 1539,
     7   1540, 1541, 1542, 1500, 1459, 1544, 1545, 1546, 1547, 1548,
     8   1549, 1550, 1551, 1464, 1553, 1554, 1555, 1556, 1557, 1558,
     9   1559, 1560, 1561, 1562, 1552, 1363, 1564, 1565, 1534, 1527/
            data (jb1(i),i= 1601, 1700)/
     +   1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1567,
     1   1578, 1566, 1522, 1552, 1581, 1582, 1583, 1584, 1585, 1566,
     2   1444, 1580, 1393, 1589, 1590, 1591, 1592, 1593, 1594, 1595,
     3   1596, 1597, 1588, 1580, 1586, 1600, 1601, 1602, 1586, 1604,
     4   1605, 1607, 1608, 1609, 1610, 1611, 1612, 1613, 1614, 1615,
     5   1616, 1617, 1618, 1619, 1620, 1501, 1534, 1622, 1623, 1624,
     6   1625, 1626, 1627, 1628, 1629, 1630, 1577, 1631, 1632, 1633,
     7   1634, 1635, 1636, 1606, 1607, 1603, 1393, 1639, 1640, 1641,
     8   1643, 1644, 1645, 1646, 1642, 1648, 1649, 1650, 1651, 1652,
     9   1653, 1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661, 1662/
            data (jb1(i),i= 1701, 1800)/
     +   1663, 1664, 1665, 1666, 1667, 1588, 1668, 1669, 1670, 1671,
     1   1672, 1673, 1674, 1643, 1648, 1676, 1677, 1678, 1679, 1680,
     2   1681, 1682, 1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690,
     3   1691, 1692, 1693, 1694, 1695, 1536, 1697, 1698, 1699, 1700,
     4   1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709, 1710,
     5   1711, 1712, 1713, 1714, 1715, 1716, 1717, 1536, 1719, 1720,
     6   1648, 1444, 1722, 1723, 1724, 1725, 1726, 1727, 1728, 1729,
     7   1730, 1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739,
     8   1740, 1567, 1577, 1742, 1743, 1744, 1745, 1599, 1747, 1748,
     9   1749, 1718, 1607, 1751, 1752, 1753, 1754, 1755, 1756, 1757/
            data (jb1(i),i= 1801, 1900)/
     +   1758, 1759, 1760, 1761, 1762, 1747, 1641, 1764, 1606, 1766,
     1   1767, 1768, 1769, 1770, 1771, 1772, 1773, 1774, 1775, 1776,
     2   1777, 1778, 1779, 1780, 1781, 1782, 1783, 1736, 1785, 1786,
     3   1787, 1788, 1599, 1790, 1791, 1792, 1793, 1794, 1795, 1643,
     4   1797, 1798, 1799, 1800, 1801, 1796, 1742, 1803, 1804, 1765,
     5   1806, 1807, 1808, 1809, 1789, 1789, 1811, 1812, 1813, 1814,
     6   1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822, 1823, 1824,
     7   1825, 1826, 1827, 1828, 1829, 1830, 1831, 1832, 1833, 1603,
     8   1835, 1836, 1837, 1838, 1839, 1796, 1784, 1805, 1842, 1843,
     9   1844, 1845, 1846, 1847, 1848, 1849, 1850, 1851, 1852, 1853/
            data (jb1(i),i= 1901, 2000)/
     +   1854, 1855, 1856, 1857, 1747, 1842, 1859, 1860, 1861, 1862,
     1   1822, 1696, 1841, 1865, 1866, 1867, 1868, 1869, 1870, 1871,
     2   1872, 1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880, 1805,
     3   1835, 1882, 1883, 1884, 1885, 1886, 1865, 1888, 1889, 1890,
     4   1891, 1892, 1893, 1894, 1895, 1896, 1897, 1898, 1899, 1900,
     5   1901, 1902, 1903, 1904, 1905, 1765, 1642, 1907, 1908, 1909,
     6   1910, 1911, 1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919,
     7   1920, 1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928, 1888,
     8   1822, 1930, 1931, 1932, 1933, 1934, 1935, 1936, 1937, 1938,
     9   1939, 1940, 1941, 1942, 1943, 1944, 1945, 1946, 1784, 1948/
            data (jb1(i),i= 2001, 2100)/
     +   1949, 1950, 1951, 1952, 1953, 1954, 1955, 1956, 1865, 1958,
     1   1959, 1960, 1961, 1962, 1963, 1964, 1965, 1966, 1967, 1968,
     2   1969, 1970, 1971, 1835, 1929, 1973, 1974, 1975, 1976, 1977,
     3   1958, 1958, 1979, 1980, 1981, 1982, 1696, 1718, 1985, 1986,
     4   1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1984, 1807,
     5   1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
     6   1888, 2007, 2008, 2009, 2010, 2011, 2006, 1821, 2013, 2014,
     7   2015, 2016, 2018, 2019, 2020, 1984, 1995, 2023, 2024, 2025,
     8   2026, 2006, 2028, 2029, 2030, 2031, 2032, 2033, 2034, 2022,
     9   1842, 2036, 2037, 2038, 2039, 2040, 2041, 2042, 2043, 2044/
            data (jb1(i),i= 2101, 2200)/
     +   2045, 2046, 2047, 2048, 2049, 2050, 2051, 2028,   24, 2053,
     1   2054, 2055, 2056, 2057, 2058, 2059, 2060, 2061, 2062, 2017,
     2   2017, 2064, 2065, 2066, 2067, 2068, 2023, 2070, 2071, 2072,
     3   2073, 2074, 2075, 2076, 2077, 2078, 2069, 2080, 2028, 1983,
     4   2023, 2083,   25, 2085, 2086, 2087, 2088, 2089, 2090, 2091,
     5   2092, 2093, 2094, 2095, 2096, 2018, 2098, 2099, 2100, 2101,
     6   2102, 2103, 2104, 2105, 2084, 2098, 2107, 2108, 1983, 2082,
     7   2110, 2111, 1948, 1930, 2113, 2114, 2115, 2116, 2117, 2118,
     8   2119, 2120, 2121, 2122, 2123, 2124, 2125, 2126, 1864, 2127,
     9   2129, 2130, 2131, 2132, 2133, 2134, 2135, 2136, 2137, 2138/
            data (jb1(i),i= 2201, 2300)/
     +   2139, 2140, 2141, 2142, 2143, 2128, 1864, 2145, 2146, 2147,
     1   1948, 2149, 2148, 2080, 2151, 2152, 2153, 2154, 2155, 2156,
     2   2157, 2158, 2159, 2160, 2161, 2162, 2163, 2164, 2165, 2166,
     3   2022, 2080, 2168, 2169, 2170, 2171, 2172, 2173, 2174, 2175,
     4   2176, 2177, 2148, 2179, 2180, 2181, 2182, 2183, 2184, 2185,
     5   2186, 2187, 2188, 2189, 2190, 2178, 2192, 2193, 2194, 2195,
     6   2196, 2197, 2198, 2199, 2200, 2127, 2098, 2202, 2203, 2204,
     7   2205, 2084, 2207, 2208, 2209, 2210, 2211, 2212, 2213, 2214,
     8   2215, 2216, 2217, 2218, 2219, 2220, 2221, 2222, 2223, 2224,
     9   2225, 2226, 2227, 2228, 2229, 2230, 2206, 2232, 2206, 2082/
            data (jb1(i),i= 2301, 2400)/
     +   2234, 2235, 2232, 2237, 2238, 2239, 2240, 2241, 2242, 2243,
     1   2244, 2178, 2237, 2246, 2247, 2248, 2249, 2250, 2251, 2252,
     2   2253, 2254, 2255, 2256, 2257, 2128, 2069, 2260, 2261, 2262,
     3   2263, 2264, 2265, 2225,   26, 2259, 2258,   27, 2259, 2270,
     4   2271, 2272, 2273, 2260, 2232, 2191, 2276, 2277, 2278, 2279,
     5   2280, 2281, 2275, 2268, 2283, 2284, 2285, 2286, 2287, 2288,
     6   2289, 2290, 2291, 2191, 2293, 2294, 2295, 2296, 2297, 2298,
     7   2299, 2018, 2159, 2301, 2302, 2303, 2304, 2305, 2306, 2307,
     8   2308, 2309, 2310, 2311, 2312, 2313, 2314, 2315, 2316, 2269,
     9   2318, 2319, 2320, 2321, 2322, 2323, 2324, 2325, 2326, 2327/
            data (jb1(i),i= 2401, 2500)/
     +   2328, 2327, 2330, 2331, 2332, 2333, 2334, 2293, 2336, 2337,
     1   2338, 2339, 2340, 2341, 2342, 2343, 2344, 2345, 2346, 2347,
     2   2348, 2349, 2350, 2351, 2352, 2353, 2354, 2355, 2260, 2283,
     3   2357, 2358, 2359, 2360, 2361, 2362, 2363, 2364, 2365, 2366,
     4   2367, 2369, 2370, 2371, 2372, 2373, 2374, 2375, 2376, 2377,
     5   2317, 2237, 2379, 2380, 2381, 2382, 2383, 2384, 2385, 2386,
     6   2387, 2369, 2317, 2389, 2390, 2391, 2392, 2393, 2394, 2395,
     7   2396, 2397, 2398, 2399, 2400, 2401, 2402, 2403, 2293, 2405,
     8   2406, 2407, 2408, 2275, 2405, 2410, 2411, 2412, 2413, 2414,
     9   2415, 2336, 2417, 2369, 2419, 2278, 2421, 2422, 2423, 2424/
            data (jb1(i),i= 2501, 2600)/
     +   2425, 2426, 2427, 2420, 2368, 2429, 2430, 2419, 2432, 2433,
     1   2434, 2435, 2436, 2437, 2438, 2439, 2440, 2441, 2442, 2443,
     2   2444, 2445, 2446, 2447, 2448, 2449, 2450, 2451, 2452, 2453,
     3   2454, 2455, 2456, 2457, 2269, 2459, 2458, 2272, 2461, 2462,
     4   2463, 2464, 2465, 2466, 2467, 2468, 2469, 2470, 2471, 2472,
     5     28, 2474, 2473, 2329, 2336, 2476, 2477, 2478, 2479, 2480,
     6   2481, 2482, 2483, 2484, 2485, 2487, 2417, 2268, 2473, 2489,
     7   2490, 2491, 2492, 2486, 2494, 2495, 2496, 2497, 2498, 2499,
     8   2500, 2501, 2502, 2503, 2504, 2505, 2506, 2507, 2508, 2509,
     9   2510, 2511, 2493, 2513, 2514, 2515, 2516, 2517, 2518, 2519/
            data (jb1(i),i= 2601, 2700)/
     +   2520, 2420, 2513, 2522, 2523, 2524, 2525, 2526, 2527, 2528,
     1   2529, 2530, 2531, 2532, 2533, 2534, 2535, 2536, 2537, 2538,
     2   2539, 2405, 2329, 2513, 2542, 2417, 2544, 2545, 2546, 2547,
     3   2548, 2549, 2550, 2551, 2552, 2553, 2554, 2555, 2556, 2557,
     4   2558, 2559, 2560, 2561, 2562, 2563, 2564, 2565, 2566, 2391,
     5   2568, 2569, 2570, 2571, 2572, 2573, 2574, 2575, 2576, 2577,
     6   2578, 2579, 2580, 2581, 2543,   29, 2432, 2584, 2585, 2586,
     7   2587, 2487, 2368, 2589, 2590, 2591, 2592, 2593, 2594, 2595,
     8   2596, 2597, 2598, 2599, 2600, 2601, 2602, 2603, 2604, 2584,
     9   2419, 2606, 2607, 2608, 2609, 2610, 2611, 2612, 2613, 2614/
            data (jb1(i),i= 2701, 2800)/
     +   2615, 2616, 2617, 2618, 2619, 2620, 2621, 2622, 2623, 2624,
     1   2625, 2626, 2568, 2486, 2628, 2629, 2630, 2631, 2632, 2633,
     2   2634, 2635, 2636, 2637, 2638, 2639, 2640, 2487,   30, 2643,
     3   2644, 2645, 2646, 2647, 2648, 2649, 2650, 2651, 2493, 2653,
     4   2654, 2655, 2584, 2543, 2657, 2658, 2659, 2660, 2661, 2662,
     5   2663, 2664, 2665, 2666, 2667, 2668, 2669, 2641, 2671, 2672,
     6   2673, 2674, 2675, 2676, 2677, 2678, 2670, 2549, 2680, 2681,
     7   2682, 2683, 2684, 2685, 2686, 2687, 2688, 2689, 2690, 2510,
     8   2692, 2693, 2541, 2695, 2696, 2697, 2698, 2699, 2700, 2701,
     9   2703, 2704, 2705, 2706, 2707, 2708, 2709, 2568, 2711, 2712/
            data (jb1(i),i= 2801, 2900)/
     +   2713, 2714, 2715, 2716, 2717, 2718, 2719, 2720, 2721, 2722,
     1   2723, 2724, 2725, 2726, 2727, 2728, 2729, 2730, 2549, 2732,
     2   2733, 2653, 2732, 2735, 2736, 2737, 2703, 2739, 2691, 2711,
     3   2741, 2742, 2739, 2702, 2744, 2745, 2746, 2747, 2748, 2691,
     4   2642, 2750, 2751, 2752, 2753, 2754, 2755, 2756, 2653, 2694,
     5   2702, 2694, 2760, 2761, 2762, 2763, 2541, 2764, 2765, 2766,
     6   2767, 2768, 2769, 2770, 2771, 2772, 2759, 2774, 2775, 2776,
     7   2777, 2778, 2779, 2780, 2781, 2782, 2783, 2784, 2773, 2786,
     8   2787, 2788, 2670, 2786, 2790, 2791, 2792, 2793, 2794, 2796,
     9   2797, 2798, 2799, 2800, 2801, 2802, 2803, 2804, 2805, 2806/
            data (jb1(i),i= 2901, 3000)/
     +   2807, 2808, 2809, 2810, 2811, 2812, 2813, 2814, 2815, 2816,
     1   2817, 2818, 2819, 2432, 2641, 2821, 2822, 2823, 2824, 2825,
     2   2826, 2827, 2828, 2829, 2830, 2832, 2833, 2834, 2835, 2836,
     3   2837, 2838, 2839, 2711, 2703, 2841, 2842, 2843, 2844, 2845,
     4   2795, 2831, 2847, 2848, 2849, 2850, 2851, 2852, 2786, 2831,
     5   2854, 2855, 2856, 2857, 2858, 2859, 2860, 2861, 2862, 2863,
     6   2864, 2865, 2866, 2867, 2758, 2642, 2832, 2774, 2832, 2870,
     7   2872, 2873, 2874, 2875, 2876, 2732, 2757, 2878, 2879, 2880,
     8   2881, 2882, 2883, 2884, 2885, 2886, 2887, 2888, 2889, 2890,
     9   2891, 2892, 2872, 2894, 2895, 2896, 2897, 2774,   32, 2899/
            data (jb1(i),i= 3001, 3100)/
     +   2796, 2901, 2902, 2903, 2904, 2905, 2906, 2907, 2908, 2909,
     1   2900, 2900, 2911, 2912, 2913, 2914, 2915, 2916, 2917, 2918,
     2   2919, 2920, 2921, 2922, 2923, 2924, 2925, 2926, 2927, 2928,
     3   2929, 2930, 2931, 2932, 2933, 2934, 2935, 2936, 2937, 2938,
     4   2939, 2940, 2941, 2795,   34, 2943, 2944, 2945, 2946, 2947,
     5   2948, 2949, 2950, 2951, 2952, 2953, 2954, 2955, 2956, 2957,
     6   2958, 2959, 2960, 2872, 2928, 2963, 2964, 2759, 2894, 2966,
     7   2963, 2854, 2968, 2969, 2971, 2972, 2691, 2966, 2974, 2975,
     8   2976, 2977, 2978, 2979, 2980, 2981, 2982, 2983, 2984, 2985,
     9   2986, 2987, 2989, 2990, 2991, 2992, 2993, 2994, 2995, 2996/
            data (jb1(i),i= 3101, 3200)/
     +   2997, 2998, 2999, 3000, 3001, 3002, 3003, 3004, 3005, 3006,
     1   3007, 3008, 3009, 3010, 2758, 2961, 3012, 3013, 3014, 3015,
     2   3016, 3017, 3018, 2989, 2989, 2971, 3021, 3023, 3024, 3025,
     3   3026, 3027, 3028, 3029, 3030, 3031, 3032, 3033, 3034, 3035,
     4   3036, 3037, 3038, 3039, 3040, 3041, 3042, 3043, 3044, 3045,
     5   3046, 3047, 3048, 3049, 3050, 3051, 3052, 3053, 3054, 3055,
     6   3056, 2739, 2970, 3058, 3059, 3020, 2971, 3061, 3062, 3063,
     7   3064, 3023, 2928, 3066, 3067, 3068, 3069, 3070, 3072, 3073,
     8   3074, 3075, 3076, 3077, 3078, 3079, 3080, 3081, 3082, 3083,
     9   3084, 3085, 3086, 3087, 3088, 3089, 3090, 3091, 3092, 3093/
            data (jb1(i),i= 3201, 3300)/
     +   3094, 3095, 3096, 3097, 3098, 3099, 3100, 3101, 3102, 3103,
     1   2894, 3105, 3106, 3107, 3108, 3109, 3110, 3111, 3112, 3113,
     2   3114, 3115, 3116, 3117, 2871, 3023, 3119, 3120, 3121, 3105,
     3   2871, 3123, 3124, 3125, 3126, 3127, 2882, 3129, 3130, 3131,
     4   3132, 3133, 3134, 3135, 3136, 3137, 3138, 3139, 3140, 3141,
     5   3142, 3143, 3144, 3145, 3146, 3147, 3148, 3149, 3150, 3151,
     6   3152, 3128, 3154, 3155, 3156, 3157, 3158, 3159, 3160, 3161,
     7   2702, 3022, 3163, 3164, 3165, 3166, 3167, 3168, 3169, 3170,
     8   3171, 3172, 3173, 3174, 3175, 3176, 3177, 3178, 3179, 3180,
     9   3181, 3154, 3183, 3071, 2970, 3185, 3186, 3183, 3154, 3188/
            data (jb1(i),i= 3301, 3400)/
     +   3189, 3190, 3191, 3192, 3193, 3194, 3195, 3196, 3197, 3198,
     1   3199, 3200, 3202, 3203, 3204, 3205, 3206, 3207, 3208, 3209,
     2   3210, 3211, 3212, 3213, 3214, 3215, 2966, 3217, 3218, 3219,
     3   3220, 3221, 3071, 2962, 3223, 3225, 3226, 3227, 3228, 3229,
     4   3230, 3128, 3225, 3232, 3224,   35, 3234, 3235, 3236, 3237,
     5   2961, 3238, 3240, 3241, 3242, 3243, 3244, 3245, 3217, 3240,
     6   3223, 3248, 3249, 3250, 3251, 3252, 3253, 3254, 3255, 3256,
     7   3257, 3258, 3259, 3260, 3261, 3262, 3263, 3105,   36, 3265,
     8   3266, 3267, 3268, 3269, 3270, 3271, 3272, 3273, 3274, 3275,
     9   3276, 3277, 3278, 3279, 3280, 3281, 3072,   37, 3283, 3284/
            data (jb1(i),i= 3401, 3500)/
     +   3285, 3248, 3286, 3287, 3288, 3289, 3290, 3291, 3292, 3293,
     1   3294, 3295, 3296, 3297, 3298, 3299, 3300, 3301, 3302, 3303,
     2   3304, 3305, 3306, 3307, 3308, 3309, 3310, 3225, 3201, 3312,
     3   3313, 3314, 3315, 3316, 2988, 3318, 3319, 3320, 3321, 3224,
     4   3022, 3323, 3324, 3325, 3326, 3327, 3328, 3295, 3331, 3332,
     5   3333, 3334, 3335, 3336, 3337, 3338, 3339, 3340, 3341, 3342,
     6   3343, 3344, 3345, 3346, 3347, 3348, 3349, 3217, 3351, 3248,
     7   3329, 3351, 3354, 3355, 3356, 3357, 3358, 3359, 3360, 3361,
     8   3362, 3238, 3020, 3364, 3365, 3366, 3367, 3368, 3369, 3370,
     9   3371, 3372, 3373, 3374, 3375, 3376, 3377, 3378, 3379, 3380/
            data (jb1(i),i= 3501, 3600)/
     +   3381, 3382, 3383, 3384, 3385, 3386, 3387, 3388, 3389, 3354,
     1   3318, 3391, 3392, 3393, 3394, 3395, 3396, 3397, 3398, 3399,
     2   3330, 3370, 3402, 3403, 3404, 3405, 3406, 3407, 3408, 3409,
     3   3410, 3183, 3401, 3402, 3412, 3331,   39, 3414, 3415, 3416,
     4   3417, 3418, 3419, 3420, 3421, 3422, 3423, 3424, 3425, 3426,
     5   3427, 3428, 3202, 3430, 3431, 3432, 3433, 3434, 3435, 3436,
     6   3318, 3438, 3430, 3438, 3440, 3441, 3442, 3443, 3444, 3445,
     7   3446, 3447, 3448, 3240, 3202, 3450, 3452, 3453, 3454, 3455,
     8   3456, 3457, 3458, 3459, 3460, 3461, 3462, 3463, 3464, 3354,
     9     40, 3466, 3467, 3468, 3469, 3470, 3452, 3451, 3472, 3473/
            data (jb1(i),i= 3601, 3700)/
     +   3474, 3475, 3476, 3477, 3478, 3479, 3480, 3481, 3482, 3483,
     1   3484, 3485, 3486, 3487, 3488, 3489, 3490, 3491, 3492, 3493,
     2   3494, 3495, 3496, 3497, 3498, 3499, 3500, 3501, 3502, 3503,
     3   3504, 3505, 3506, 3507, 3508, 3509, 3510, 3511, 3512, 3513,
     4   2988, 3451, 3515, 3516, 3517, 3518, 3519, 3520, 3521, 3522,
     5   3523, 3329, 3525, 3526, 3527, 3528, 3529, 3530, 3531, 3532,
     6   3533, 3534, 3535, 3430, 3537, 3538, 3539, 3540, 3541, 3542,
     7   3543, 3544, 3545, 3546, 3330, 3548, 3549, 3550, 3551, 3552,
     8   3553, 3554, 3555, 3556, 3557, 3558, 3559, 3547, 3561, 3562,
     9   3563, 3564, 3565, 3566, 3567, 3568, 3569, 3452, 3401, 3571/
            data (jb1(i),i= 3701, 3800)/
     +   3572, 3573, 3574, 3575, 3576, 3577, 3578, 3579, 3580, 3582,
     1   3583, 3584, 3585, 3586, 3587, 3588, 3589, 3590, 3591, 3592,
     2   3593, 3594, 3595, 3596, 3331, 3582, 3351, 3599, 3600, 3201,
     3   3602, 3603, 3604, 3605, 3606, 3607, 3608, 3609, 3610, 3611,
     4   3612, 3613, 3598, 3615, 3581, 3581, 3617, 3618, 3619, 3620,
     5   3621, 3622, 3623, 3624, 3625, 3626, 3627, 3628, 3629, 3561,
     6   3614, 3631, 3632, 3536, 3547, 3634, 3635, 3536, 3637, 3638,
     7   3639, 3640, 3641, 3642, 3643, 3644, 3645, 3646, 3647, 3648,
     8   3649, 3650, 3651, 3652, 3601, 3654, 3655, 3656, 3653, 3658,
     9   3659, 3660, 3661, 3662, 3663, 3614, 3665, 3601, 3636, 3667/
            data (jb1(i),i= 3801, 3900)/
     +   3668, 3669, 3670, 3671, 3665, 3546, 3673, 3674, 3675, 3676,
     1   3677, 3678, 3679, 3680, 3681, 3682, 3582, 3685, 3686, 3687,
     2   3688, 3438, 3685, 3683, 3691, 3692, 3693, 3690, 3684, 3695,
     3   3696, 3697, 3685, 3699, 3700, 3701, 3658, 3699, 3703, 3704,
     4   3705, 3706, 3524, 3524, 3708, 3709, 3710, 3711, 3712, 3713,
     5   3714, 3715, 3716, 3717, 3718, 3719, 3720, 3721, 3722, 3723,
     6   3724, 3725, 3726, 3727, 3728, 3561, 3730, 3731, 3732, 3733,
     7   3734, 3735, 3736, 3737, 3738, 3739, 3740, 3741, 3742, 3743,
     8   3744, 3653, 3730, 3746, 3747, 3748, 3749, 3750, 3751, 3752,
     9   3753, 3754, 3755, 3756, 3757, 3758, 3759, 3760, 3761, 3658/
            data (jb1(i),i= 3901, 4000)/
     +   3763, 3764, 3765, 3766, 3767, 3768, 3769, 3770, 3771, 3772,
     1   3773, 3774, 3636, 3763, 3777, 3778, 3779, 3780, 3781, 3782,
     2   3665, 3776, 3699, 3784, 3785, 3786, 3787, 3788, 3725, 3790,
     3   3791, 3792, 3793, 3794, 3795, 3796, 3797, 3798, 3799, 3800,
     4   3801, 3802, 3803, 3804, 3725, 3806, 3807, 3808, 3809, 3810,
     5   3811, 3812, 3813, 3814, 3815, 3816, 3817, 3818, 3819, 3820,
     6   3821, 3822, 3823, 3824, 3825, 3826, 3827, 3828, 3829, 3830,
     7   3831, 3832, 3833, 3834, 3835, 3836, 3837, 3838, 3839, 3840,
     8   3841, 3842, 3843, 3844, 3845, 3846, 3598, 3804, 3803, 3806,
     9   3848, 3850, 3804, 3849, 3684, 3853, 3854, 3855, 3856, 3852/
            data (jb1(i),i= 4001, 4100)/
     +   3858, 3859, 3860, 3861, 3862, 3863, 3864, 3865, 3866, 3867,
     1   3868, 3690,   43, 3870, 3871, 3872, 3873, 3874, 3875, 3876,
     2   3877, 3878, 3879, 3880, 3881, 3882, 3883, 3884, 3885, 3789,
     3   3858, 3887, 3888, 3889, 3890, 3891, 3892, 3857, 3858, 3894,
     4   3895, 3896, 3897, 3898, 3899, 3789, 3901, 3902, 3903, 3904,
     5   3905, 3906, 3907, 3908, 3909, 3910, 3911, 3912, 3913, 3914,
     6   3915, 3916, 3918, 3919, 3920, 3921, 3922, 3923, 3924, 3925,
     7   3926, 3927, 3928, 3929, 3930, 3931, 3932, 3933, 3934, 3935,
     8   3936, 3937, 3938, 3939, 3940, 3683, 3900, 3942, 3943, 3944,
     9   3945, 3763, 3918,   44, 3947, 3948, 3949, 3950, 3951, 3952/
            data (jb1(i),i= 4101, 4200)/
     +   3953, 3954, 3955, 3956, 3957, 3730, 3952, 3959, 3917, 3961,
     1   3962, 3963, 3964, 3965, 3966, 3967, 3968, 3942, 3777, 3970,
     2   3971, 3972, 3973, 3974, 3975, 3976, 3977, 3978, 3979, 3848,
     3   3980, 3981, 3982, 3983, 3984, 3985, 3986, 3987, 3988, 3989,
     4   3990, 3991, 3992, 3993, 3994, 3995, 3996, 3997, 3998, 3999,
     5   3852, 4000, 4001, 4002, 4003, 4004, 4005, 3776, 4006, 4007,
     6   4008, 4009, 3961,   48, 4011, 4012, 4013, 4014, 4015, 4016,
     7   4017, 4018, 4019, 4020, 3917, 3849, 3888, 4022, 4023, 4024,
     8   4025, 4026, 4027, 4028, 4029, 4030, 4031, 4032, 4033, 4034,
     9   4035, 4036, 4037, 4038, 4039, 4040, 4041, 4042, 4043, 4044/
            data (jb1(i),i= 4201, 4300)/
     +   4045, 4046, 4047, 4048, 4049, 4050, 4051, 4052, 4053, 4054,
     1   4055, 4056, 4057, 3900, 4022,   52, 4059, 4060, 4061, 4062,
     2   4063, 4064, 4065, 4066, 4067, 4068, 4069, 4070, 4071, 3961,
     3   4006, 4073, 4074, 4075, 4076, 4077, 4078, 4079, 4080, 4081,
     4   4082, 4083, 4084, 4085, 4086, 4087, 4088, 4089,    1,    2,
     5      3,    4,    1,    6,    7,    8,    9,   10,   11,   12,
     6     13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
     7     23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
     8     33,    6,   35,   36,   37,   35,   39,   40,   39,   42,
     9     43,   44,   42,   46,   47,   48,   46,   50,   51,   52/
            data (jb1(i),i= 4301, 4390)/
     +     53,   50,   55,   56,   55,   58,   59,   60,   61,   62,
     1     63,   64,   65,   58,   67,   68,   69,   70,   71,   72,
     2     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     3     83,   67,   85,   86,   87,   85,   89,   90,   91,   92,
     4     89,   94,   95,   94,   97,   98,   97,  100,  101,  100,
     5    103,  104,  105,  106,  107,  103,  109,  110,  111,  109,
     6    113,  114,  113,  116,  117,  118,  116,  120,  121,  120,
     7    123,  124,  125,  123,  127,  128,  127,  130,  131,  130,
     8    133,  134,  135,  136,  137,  138,  139,  133,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     54,   54,    8,    5,   10,   10,    4,    4,   55,   56,
     1     56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
     2     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     3     76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
     4     85,   86,   87,   88,   88,   11,   89,   90,   91,   92,
     5     93,   94,   95,   96,   97,   98,   99,   99,  100,  101,
     6    102,  103,  103,  104,  105,  106,  107,  108,  109,  110,
     7    111,  112,  113,  114,  114,   14,   17,  115,  116,  117,
     8    118,  119,  120,  121,  122,  123,  124,  124,   19,   20,
     9    125,  126,  127,  128,  129,  130,  131,  132,  133,  134/
            data (jb2(i),i=  101,  200)/
     +    135,  136,  136,  137,  138,  139,  140,  141,  142,  143,
     1    144,  144,   22,  145,  146,  147,  148,  149,  150,  151,
     2    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     3    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     4    172,  173,  174,  175,  176,  177,  178,  179,  180,  180,
     5     24,   26,  181,  182,  183,  184,  185,  186,  187,  188,
     6    189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
     7    199,  200,  201,  201,  202,  203,  204,  205,  206,  207,
     8    208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
     9    218,  218,  219,  220,  221,  222,  223,  224,  225,  226/
            data (jb2(i),i=  201,  300)/
     +    227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
     1    237,  238,  239,  240,  241,  242,  243,  244,  245,  246,
     2    247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
     3    257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
     4    267,  267,  268,  269,  270,  271,  272,  273,  274,  275,
     5    276,  276,  277,  278,  279,  280,  281,  282,  283,  284,
     6    285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
     7    295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
     8    305,  306,  307,  308,  309,  310,  310,  311,  312,  313,
     9    314,  315,  316,  317,  318,  319,  320,  320,  321,  322/
            data (jb2(i),i=  301,  400)/
     +    323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
     1    333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
     2    343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
     3    353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
     4    363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
     5    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     6    383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
     7    393,  394,  395,  396,  397,  398,  399,  400,  401,  402,
     8    403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
     9    413,  414,  415,  416,  417,  418,  419,  420,  421,  422/
            data (jb2(i),i=  401,  500)/
     +    423,  424,  425,  426,  427,  428,  428,  429,  430,  431,
     1    432,  433,  434,  435,  436,  437,  437,  438,  439,  440,
     2    441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
     3    451,  451,  452,  453,  454,  455,  456,  457,  458,  459,
     4    460,  460,  461,  462,  463,  464,  465,  466,  467,  468,
     5    469,  470,  471,  472,  473,  474,  474,  475,  476,  477,
     6    478,  479,  480,  481,  482,  483,  484,  485,  486,  486,
     7    487,  488,  489,  490,  491,  492,  493,  494,  495,  495,
     8    496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
     9    506,  507,  508,  509,  510,  511,  512,  513,  514,  515/
            data (jb2(i),i=  501,  600)/
     +    516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
     1    526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
     2    536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
     3    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     4    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     5    566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
     6    576,  577,  578,  579,  580,  581,  582,  583,  584,  585,
     7    585,  586,  587,  588,  589,  590,  591,  592,  593,  594,
     8    595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
     9    605,  606,  607,  608,  609,  610,  611,  612,  613,  614/
            data (jb2(i),i=  601,  700)/
     +    615,  616,  617,  618,  619,  620,  621,  621,  622,  623,
     1    624,  625,  626,  627,  628,  629,  630,  631,  632,  633,
     2    634,  635,  636,  637,  638,  639,  640,  641,  641,  642,
     3    643,  644,  645,  646,  647,  648,  649,  650,  651,  652,
     4    653,  654,  655,  656,  657,  658,  659,  660,  661,  662,
     5    663,  664,  665,  666,  667,  668,  669,  670,  671,  672,
     6    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     7    683,  684,  685,  686,  687,  688,  689,  690,  691,  692,
     8    693,  694,  695,  696,  697,  698,  699,  700,  701,  702,
     9    703,  704,  705,  706,  707,  708,  709,  709,  710,  711/
            data (jb2(i),i=  701,  800)/
     +    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     1    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     2    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     3    741,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     4    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     5    761,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     6    771,  772,  773,  774,  775,  776,  777,  778,  779,  780,
     7    781,  782,  783,  784,  785,  786,  787,  788,  789,  790,
     8    791,  792,  793,  794,  795,  796,  797,  798,  799,  800,
     9    801,  802,  803,  804,  805,  806,  807,  808,  809,  810/
            data (jb2(i),i=  801,  900)/
     +    811,  812,  813,  813,   49,   49,   50,   51,   52,   53,
     1     53,   45,  814,  815,  816,  817,  818,  819,  820,  821,
     2    822,  823,  824,  825,  826,  827,  828,  829,  830,  831,
     3    832,  833,  834,  835,  836,  837,  838,  839,  840,  841,
     4    842,  843,  844,  845,  846,  847,  848,  849,  850,  851,
     5    852,  853,  854,  854,  856,    1,  858,  859,  860,  861,
     6    862,    2,  864,  865,  866,  867,  868,  869,  870,  871,
     7    872,  873,  874,  875,  876,  877,  878,  879,  880,  881,
     8      3,  883,  884,  885,  886,  887,  888,  889,  890,  891,
     9    892,  893,  894,  895,  896,  897,  898,  899,    4,  901/
            data (jb2(i),i=  901, 1000)/
     +    902,  903,  904,  905,  906,  907,  908,  909,  910,  911,
     1    912,  913,  914,  915,  916,  916,  918,  919,  920,  921,
     2    922,  923,  924,  925,  925,  926,  927,  928,  929,  930,
     3    931,  932,  933,  934,  935,  936,  937,  938,  939,  940,
     4    940,  941,  942,  943,  944,  945,  946,  947,  948,  949,
     5    950,  951,  952,  954,  954,  955,  956,  956,  958,  959,
     6    959,  960,  961,  962,  963,  964,  965,  966,  967,  968,
     7    969,  970,  971,  972,  973,  974,  975,  976,  977,  978,
     8    979,  980,  981,  982,  983,  984,  985,  986,  987,  988,
     9    989,  990,  991,  992,  993,  994,  995,  996,  997,  998/
            data (jb2(i),i= 1001, 1100)/
     +    999, 1000, 1001, 1002, 1003, 1004, 1005, 1006, 1006, 1007,
     1   1008, 1009, 1010, 1011, 1012, 1013,    9, 1014, 1015, 1016,
     2   1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026,
     3   1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036,
     4   1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046,
     5   1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056,
     6   1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066,
     7   1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,
     8   1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085,
     9   1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095/
            data (jb2(i),i= 1101, 1200)/
     +   1096, 1096, 1097, 1098, 1099, 1099, 1100, 1101, 1102, 1103,
     1   1104, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112,
     2   1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122,
     3   1123, 1123, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132,
     4   1133, 1134, 1135, 1136, 1137, 1137, 1138, 1139, 1140, 1141,
     5   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151,
     6   1152, 1153, 1154, 1155, 1155, 1157, 1158, 1159, 1160, 1161,
     7   1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170,
     8   1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180,
     9   1181, 1182, 1183, 1183, 1184, 1185, 1187, 1188, 1189, 1190/
            data (jb2(i),i= 1201, 1300)/
     +   1191, 1192, 1193, 1193, 1194, 1195, 1196, 1197, 1198, 1199,
     1   1200, 1201, 1202, 1203, 1204, 1205, 1206,   14, 1207, 1208,
     2   1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218,
     3   1219, 1220, 1221, 1222, 1223, 1223, 1185, 1225, 1226, 1227,
     4   1228, 1228, 1186, 1229, 1230, 1231, 1232, 1233, 1234, 1235,
     5   1236, 1237, 1238, 1239, 1239, 1241, 1242, 1243, 1243, 1244,
     6   1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253, 1253,
     7   1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263,
     8   1264, 1265, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272,
     9   1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282/
            data (jb2(i),i= 1301, 1400)/
     +   1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290, 1290, 1292,
     1   1292, 1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301,
     2   1302,   16, 1303, 1304, 1305, 1306, 1307, 1308, 1309, 1309,
     3   1311, 1312, 1313, 1314, 1314, 1315, 1316, 1317, 1318, 1319,
     4   1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329,
     5   1330, 1332, 1332, 1334, 1335, 1336, 1337, 1337, 1339, 1340,
     6   1341, 1342, 1343, 1344, 1345, 1346, 1346, 1331, 1347, 1348,
     7   1349, 1350, 1351, 1352,   17, 1354, 1355, 1356, 1357, 1358,
     8   1358, 1359, 1360, 1361, 1362, 1363, 1364, 1365, 1366, 1366,
     9   1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375, 1376/
            data (jb2(i),i= 1401, 1500)/
     +   1377, 1378, 1379, 1380, 1381, 1382, 1383, 1383, 1384, 1385,
     1   1386, 1387, 1388, 1389, 1390, 1391, 1392, 1392, 1394, 1395,
     2   1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404, 1405,
     3   1406, 1407, 1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414,
     4   1415, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425,
     5   1426, 1427, 1428, 1429, 1430, 1431, 1431, 1432, 1433, 1434,
     6   1435, 1436, 1437, 1438, 1439, 1440, 1441, 1442, 1443, 1444,
     7   1445, 1446, 1447, 1448, 1449, 1450, 1451, 1452, 1453, 1454,
     8   1455, 1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463, 1463,
     9   1465, 1466, 1467, 1468, 1469, 1470, 1471, 1471, 1472, 1473/
            data (jb2(i),i= 1501, 1600)/
     +   1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482, 1483,
     1   1484, 1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492, 1493,
     2   1494, 1495, 1495, 1496, 1497, 1498, 1499, 1500, 1502, 1503,
     3   1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512, 1512,
     4   1513, 1514, 1515, 1516, 1516, 1518, 1519, 1519, 1520, 1521,
     5     19, 1523, 1524, 1525, 1526, 1526, 1527, 1528, 1529, 1530,
     6   1531, 1532, 1533, 1533, 1535, 1535, 1537, 1538, 1539, 1540,
     7   1541, 1542, 1543, 1543, 1544, 1545, 1546, 1547, 1548, 1549,
     8   1550, 1551, 1552, 1553, 1554, 1555, 1556, 1557, 1558, 1559,
     9   1560, 1561, 1562, 1563, 1563, 1564, 1565, 1566, 1567, 1568/
            data (jb2(i),i= 1601, 1700)/
     +   1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577, 1578,
     1   1579, 1579, 1580, 1581, 1582, 1583, 1584, 1585, 1586, 1587,
     2   1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, 1595, 1596,
     3   1597, 1598, 1598, 1599, 1600, 1601, 1602, 1603, 1604, 1605,
     4   1606, 1608, 1609, 1610, 1611, 1612, 1613, 1614, 1615, 1616,
     5   1617, 1618, 1619, 1620, 1621, 1621, 1622, 1623, 1624, 1625,
     6   1626, 1627, 1628, 1629, 1630,   20, 1631, 1632, 1633, 1634,
     7   1635, 1636, 1637, 1637, 1638, 1638, 1639, 1640, 1641, 1642,
     8   1644, 1645, 1646, 1647, 1647, 1649, 1650, 1651, 1652, 1653,
     9   1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661, 1662, 1663/
            data (jb2(i),i= 1701, 1800)/
     +   1664, 1665, 1666, 1667,   21, 1668, 1669, 1670, 1671, 1672,
     1   1673, 1674, 1675, 1675, 1676, 1677, 1678, 1679, 1680, 1681,
     2   1682, 1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691,
     3   1692, 1693, 1694, 1695, 1696, 1697, 1698, 1699, 1700, 1701,
     4   1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709, 1710, 1711,
     5   1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719, 1720, 1721,
     6   1721, 1722, 1723, 1724, 1725, 1726, 1727, 1728, 1729, 1730,
     7   1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740,
     8   1741, 1741, 1742, 1743, 1744, 1745, 1746, 1746, 1748, 1749,
     9   1750, 1750, 1751, 1752, 1753, 1754, 1755, 1756, 1757, 1758/
            data (jb2(i),i= 1801, 1900)/
     +   1759, 1760, 1761, 1762, 1763, 1763, 1764, 1765, 1766, 1767,
     1   1768, 1769, 1770, 1771, 1772, 1773, 1774, 1775, 1776, 1777,
     2   1778, 1779, 1780, 1781, 1782, 1783, 1784, 1785, 1786, 1787,
     3   1788, 1789, 1790, 1791, 1792, 1793, 1794, 1795, 1796, 1797,
     4   1798, 1799, 1800, 1801, 1802, 1802, 1803, 1804, 1805, 1806,
     5   1807, 1808, 1809, 1810, 1810, 1811, 1812, 1813, 1814, 1815,
     6   1816, 1817, 1818, 1819, 1820, 1821,   22, 1823, 1824, 1825,
     7   1826, 1827, 1828, 1829, 1830, 1831, 1832, 1833, 1834, 1834,
     8   1836, 1837, 1838, 1839, 1840, 1840, 1841, 1841, 1843, 1844,
     9   1845, 1846, 1847, 1848, 1849, 1850, 1851, 1852, 1853, 1854/
            data (jb2(i),i= 1901, 2000)/
     +   1855, 1856, 1857, 1858, 1858, 1859, 1860, 1861, 1862, 1863,
     1   1863,   23, 1864, 1866, 1867, 1868, 1869, 1870, 1871, 1872,
     2   1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881, 1881,
     3   1882, 1883, 1884, 1885, 1886, 1887, 1887, 1889, 1890, 1891,
     4   1892, 1893, 1894, 1895, 1896, 1897, 1898, 1899, 1900, 1901,
     5   1902, 1903, 1904, 1905, 1906, 1906, 1907, 1908, 1909, 1910,
     6   1911, 1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920,
     7   1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929, 1929,
     8   1930, 1931, 1932, 1933, 1934, 1935, 1936, 1937, 1938, 1939,
     9   1940, 1941, 1942, 1943, 1944, 1945, 1946, 1947, 1947, 1949/
            data (jb2(i),i= 2001, 2100)/
     +   1950, 1951, 1952, 1953, 1954, 1955, 1956, 1957, 1957, 1959,
     1   1960, 1961, 1962, 1963, 1964, 1965, 1966, 1967, 1968, 1969,
     2   1970, 1971, 1972, 1972, 1973, 1974, 1975, 1976, 1977, 1978,
     3   1978, 1979, 1980, 1981, 1982, 1983, 1984, 1985, 1986, 1987,
     4   1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1995, 1996,
     5   1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006,
     6   2007, 2008, 2009, 2010, 2011, 2012, 2012, 2013, 2014, 2015,
     7   2016, 2017, 2019, 2020, 2021, 2021, 2022, 2024, 2025, 2026,
     8   2027, 2027, 2029, 2030, 2031, 2032, 2033, 2034, 2035, 2035,
     9   2036, 2037, 2038, 2039, 2040, 2041, 2042, 2043, 2044, 2045/
            data (jb2(i),i= 2101, 2200)/
     +   2046, 2047, 2048, 2049, 2050, 2051, 2052, 2052, 2053, 2054,
     1   2055, 2056, 2057, 2058, 2059, 2060, 2061, 2062, 2063, 2063,
     2   2064, 2065, 2066, 2067, 2068, 2069, 2070, 2071, 2072, 2073,
     3   2074, 2075, 2076, 2077, 2078, 2079, 2079, 2081, 2081, 2082,
     4   2083, 2084, 2085, 2086, 2087, 2088, 2089, 2090, 2091, 2092,
     5   2093, 2094, 2095, 2096, 2097, 2097, 2099, 2100, 2101, 2102,
     6   2103, 2104, 2105, 2106, 2106, 2107, 2108, 2109, 2109, 2110,
     7   2111, 2112, 2112, 2113, 2114, 2115, 2116, 2117, 2118, 2119,
     8   2120, 2121, 2122, 2123, 2124, 2125, 2126, 2127, 2128, 2129,
     9   2130, 2131, 2132, 2133, 2134, 2135, 2136, 2137, 2138, 2139/
            data (jb2(i),i= 2201, 2300)/
     +   2140, 2141, 2142, 2143, 2144, 2144, 2145, 2146, 2147, 2148,
     1   2149, 2150, 2150, 2151, 2152, 2153, 2154, 2155, 2156, 2157,
     2   2158, 2159, 2160, 2161, 2162, 2163, 2164, 2165, 2166, 2167,
     3   2167, 2168, 2169, 2170, 2171, 2172, 2173, 2174, 2175, 2176,
     4   2177, 2178, 2179, 2180, 2181, 2182, 2183, 2184, 2185, 2186,
     5   2187, 2188, 2189, 2190, 2191, 2192, 2193, 2194, 2195, 2196,
     6   2197, 2198, 2199, 2200, 2201, 2201, 2202, 2203, 2204, 2205,
     7   2206, 2207, 2208, 2209, 2210, 2211, 2212, 2213, 2214, 2215,
     8   2216, 2217, 2218, 2219, 2220, 2221, 2222, 2223, 2224, 2225,
     9   2226, 2227, 2228, 2229, 2230, 2231, 2231, 2233, 2233, 2234/
            data (jb2(i),i= 2301, 2400)/
     +   2235, 2236, 2236, 2238, 2239, 2240, 2241, 2242, 2243, 2244,
     1   2245, 2245, 2246, 2247, 2248, 2249, 2250, 2251, 2252, 2253,
     2   2254, 2255, 2256, 2257, 2258, 2258, 2259, 2261, 2262, 2263,
     3   2264, 2265, 2266, 2266, 2267, 2267, 2268, 2269, 2270, 2271,
     4   2272, 2273, 2274, 2274, 2275, 2276, 2277, 2278, 2279, 2280,
     5   2281, 2282, 2282, 2283, 2284, 2285, 2286, 2287, 2288, 2289,
     6   2290, 2291, 2292, 2292, 2294, 2295, 2296, 2297, 2298, 2299,
     7   2300, 2300, 2301, 2302, 2303, 2304, 2305, 2306, 2307, 2308,
     8   2309, 2310, 2311, 2312, 2313, 2314, 2315, 2316, 2317, 2318,
     9   2319, 2320, 2321, 2322, 2323, 2324, 2325, 2326, 2327, 2328/
            data (jb2(i),i= 2401, 2500)/
     +   2329, 2330, 2331, 2332, 2333, 2334, 2335, 2335, 2337, 2338,
     1   2339, 2340, 2341, 2342, 2343, 2344, 2345, 2346, 2347, 2348,
     2   2349, 2350, 2351, 2352, 2353, 2354, 2355, 2356, 2356, 2357,
     3   2358, 2359, 2360, 2361, 2362, 2363, 2364, 2365, 2366, 2367,
     4   2368, 2370, 2371, 2372, 2373, 2374, 2375, 2376, 2377, 2378,
     5   2378, 2379, 2380, 2381, 2382, 2383, 2384, 2385, 2386, 2387,
     6   2388, 2388, 2389, 2390, 2391, 2392, 2393, 2394, 2395, 2396,
     7   2397, 2398, 2399, 2400, 2401, 2402, 2403, 2404, 2404, 2406,
     8   2407, 2408, 2409, 2409, 2410, 2411, 2412, 2413, 2414, 2415,
     9   2416, 2416, 2418, 2418, 2420, 2421, 2422, 2423, 2424, 2425/
            data (jb2(i),i= 2501, 2600)/
     +   2426, 2427, 2428, 2428, 2429, 2430, 2431, 2431, 2433, 2434,
     1   2435, 2436, 2437, 2438, 2439, 2440, 2441, 2442, 2443, 2444,
     2   2445, 2446, 2447, 2448, 2449, 2450, 2451, 2452, 2453, 2454,
     3   2455, 2456, 2457, 2458, 2459, 2460, 2460, 2461, 2462, 2463,
     4   2464, 2465, 2466, 2467, 2468, 2469, 2470, 2471, 2472, 2473,
     5   2474, 2475, 2475, 2458, 2476, 2477, 2478, 2479, 2480, 2481,
     6   2482, 2483, 2484, 2485, 2486, 2488, 2488, 2487, 2489, 2490,
     7   2491, 2492, 2493, 2494, 2495, 2496, 2497, 2498, 2499, 2500,
     8   2501, 2502, 2503, 2504, 2505, 2506, 2507, 2508, 2509, 2510,
     9   2511, 2512, 2512, 2514, 2515, 2516, 2517, 2518, 2519, 2520/
            data (jb2(i),i= 2601, 2700)/
     +   2521, 2521, 2522, 2523, 2524, 2525, 2526, 2527, 2528, 2529,
     1   2530, 2531, 2532, 2533, 2534, 2535, 2536, 2537, 2538, 2539,
     2   2540, 2540, 2541, 2542, 2543, 2544, 2545, 2546, 2547, 2548,
     3   2549, 2550, 2551, 2552, 2553, 2554, 2555, 2556, 2557, 2558,
     4   2559, 2560, 2561, 2562, 2563, 2564, 2565, 2566, 2567, 2567,
     5   2569, 2570, 2571, 2572, 2573, 2574, 2575, 2576, 2577, 2578,
     6   2579, 2580, 2581, 2582, 2582, 2583, 2583, 2585, 2586, 2587,
     7   2588, 2588, 2589, 2590, 2591, 2592, 2593, 2594, 2595, 2596,
     8   2597, 2598, 2599, 2600, 2601, 2602, 2603, 2604, 2605, 2605,
     9   2606, 2607, 2608, 2609, 2610, 2611, 2612, 2613, 2614, 2615/
            data (jb2(i),i= 2701, 2800)/
     +   2616, 2617, 2618, 2619, 2620, 2621, 2622, 2623, 2624, 2625,
     1   2626, 2627, 2627, 2628, 2629, 2630, 2631, 2632, 2633, 2634,
     2   2635, 2636, 2637, 2638, 2639, 2640, 2641, 2642, 2643, 2644,
     3   2645, 2646, 2647, 2648, 2649, 2650, 2651, 2652, 2652, 2654,
     4   2655, 2656, 2656, 2657, 2658, 2659, 2660, 2661, 2662, 2663,
     5   2664, 2665, 2666, 2667, 2668, 2669, 2670, 2671, 2672, 2673,
     6   2674, 2675, 2676, 2677, 2678, 2679, 2679, 2680, 2681, 2682,
     7   2683, 2684, 2685, 2686, 2687, 2688, 2689, 2690, 2691, 2692,
     8   2693, 2694, 2695, 2696, 2697, 2698, 2699, 2700, 2701, 2702,
     9   2704, 2705, 2706, 2707, 2708, 2709, 2710, 2710, 2712, 2713/
            data (jb2(i),i= 2801, 2900)/
     +   2714, 2715, 2716, 2717, 2718, 2719, 2720, 2721, 2722, 2723,
     1   2724, 2725, 2726, 2727, 2728, 2729, 2730, 2731, 2731, 2733,
     2   2734, 2734, 2735, 2736, 2737, 2738, 2738, 2740, 2740, 2741,
     3   2742, 2743, 2743, 2744, 2745, 2746, 2747, 2748, 2749, 2749,
     4   2750, 2751, 2752, 2753, 2754, 2755, 2756, 2757, 2757, 2758,
     5   2759, 2760, 2761, 2762, 2763,   31, 2764, 2765, 2766, 2767,
     6   2768, 2769, 2770, 2771, 2772, 2773, 2773, 2775, 2776, 2777,
     7   2778, 2779, 2780, 2781, 2782, 2783, 2784, 2785, 2785, 2787,
     8   2788, 2789, 2789, 2790, 2791, 2792, 2793, 2794, 2795, 2797,
     9   2798, 2799, 2800, 2801, 2802, 2803, 2804, 2805, 2806, 2807/
            data (jb2(i),i= 2901, 3000)/
     +   2808, 2809, 2810, 2811, 2812, 2813, 2814, 2815, 2816, 2817,
     1   2818, 2819, 2820, 2820, 2821, 2822, 2823, 2824, 2825, 2826,
     2   2827, 2828, 2829, 2830, 2831, 2833, 2834, 2835, 2836, 2837,
     3   2838, 2839, 2840, 2840, 2841, 2842, 2843, 2844, 2845, 2846,
     4   2846, 2847, 2848, 2849, 2850, 2851, 2852, 2853, 2853, 2854,
     5   2855, 2856, 2857, 2858, 2859, 2860, 2861, 2862, 2863, 2864,
     6   2865, 2866, 2867, 2868, 2868, 2869, 2869, 2796, 2870, 2871,
     7   2873, 2874, 2875, 2876, 2877, 2877, 2878, 2879, 2880, 2881,
     8   2882, 2883, 2884, 2885, 2886, 2887, 2888, 2889, 2890, 2891,
     9   2892, 2893, 2893, 2895, 2896, 2897, 2898, 2898, 2899, 2900/
            data (jb2(i),i= 3001, 3100)/
     +   2901, 2902, 2903, 2904, 2905, 2906, 2907, 2908, 2909, 2910,
     1   2910, 2911, 2912, 2913, 2914, 2915, 2916, 2917, 2918, 2919,
     2   2920, 2921, 2922, 2923, 2924, 2925, 2926, 2927,   33, 2929,
     3   2930, 2931, 2932, 2933, 2934, 2935, 2936, 2937, 2938, 2939,
     4   2940, 2941, 2942, 2942, 2943, 2944, 2945, 2946, 2947, 2948,
     5   2949, 2950, 2951, 2952, 2953, 2954, 2955, 2956, 2957, 2958,
     6   2959, 2960, 2961, 2962, 2962, 2964, 2965, 2965, 2963, 2967,
     7   2967, 2968, 2969, 2970, 2972, 2973, 2973, 2974, 2975, 2976,
     8   2977, 2978, 2979, 2980, 2981, 2982, 2983, 2984, 2985, 2986,
     9   2987, 2988, 2990, 2991, 2992, 2993, 2994, 2995, 2996, 2997/
            data (jb2(i),i= 3101, 3200)/
     +   2998, 2999, 3000, 3001, 3002, 3003, 3004, 3005, 3006, 3007,
     1   3008, 3009, 3010, 3011, 3011, 3012, 3013, 3014, 3015, 3016,
     2   3017, 3018, 3019, 3019, 3020, 3021, 3022, 3024, 3025, 3026,
     3   3027, 3028, 3029, 3030, 3031, 3032, 3033, 3034, 3035, 3036,
     4   3037, 3038, 3039, 3040, 3041, 3042, 3043, 3044, 3045, 3046,
     5   3047, 3048, 3049, 3050, 3051, 3052, 3053, 3054, 3055, 3056,
     6   3057, 3057, 3058, 3059, 3060, 3060, 3061, 3062, 3063, 3064,
     7   3065, 3065, 3066, 3067, 3068, 3069, 3070, 3071, 3073, 3074,
     8   3075, 3076, 3077, 3078, 3079, 3080, 3081, 3082, 3083, 3084,
     9   3085, 3086, 3087, 3088, 3089, 3090, 3091, 3092, 3093, 3094/
            data (jb2(i),i= 3201, 3300)/
     +   3095, 3096, 3097, 3098, 3099, 3100, 3101, 3102, 3103, 3104,
     1   3104, 3106, 3107, 3108, 3109, 3110, 3111, 3112, 3113, 3114,
     2   3115, 3116, 3117, 3118, 3118, 3119, 3120, 3121, 3122, 3122,
     3   3123, 3124, 3125, 3126, 3127, 3128, 3129, 3130, 3131, 3132,
     4   3133, 3134, 3135, 3136, 3137, 3138, 3139, 3140, 3141, 3142,
     5   3143, 3144, 3145, 3146, 3147, 3148, 3149, 3150, 3151, 3152,
     6   3153, 3153, 3155, 3156, 3157, 3158, 3159, 3160, 3161, 3162,
     7   3162, 3163, 3164, 3165, 3166, 3167, 3168, 3169, 3170, 3171,
     8   3172, 3173, 3174, 3175, 3176, 3177, 3178, 3179, 3180, 3181,
     9   3182, 3182, 3184, 3184, 3185, 3186, 3187, 3187, 3188, 3189/
            data (jb2(i),i= 3301, 3400)/
     +   3190, 3191, 3192, 3193, 3194, 3195, 3196, 3197, 3198, 3199,
     1   3200, 3201, 3203, 3204, 3205, 3206, 3207, 3208, 3209, 3210,
     2   3211, 3212, 3213, 3214, 3215, 3216, 3216, 3218, 3219, 3220,
     3   3221, 3222, 3222, 3223, 3224, 3226, 3227, 3228, 3229, 3230,
     4   3231, 3231, 3232, 3233, 3233, 3234, 3235, 3236, 3237, 3238,
     5   3239, 3239, 3241, 3242, 3243, 3244, 3245, 3246, 3246, 3247,
     6   3247, 3249, 3250, 3251, 3252, 3253, 3254, 3255, 3256, 3257,
     7   3258, 3259, 3260, 3261, 3262, 3263, 3264, 3264, 3265, 3266,
     8   3267, 3268, 3269, 3270, 3271, 3272, 3273, 3274, 3275, 3276,
     9   3277, 3278, 3279, 3280, 3281, 3282, 3282, 3283, 3284, 3285/
            data (jb2(i),i= 3401, 3500)/
     +     38, 3286, 3287, 3288, 3289, 3290, 3291, 3292, 3293, 3294,
     1   3295, 3296, 3297, 3298, 3299, 3300, 3301, 3302, 3303, 3304,
     2   3305, 3306, 3307, 3308, 3309, 3310, 3311, 3311, 3312, 3313,
     3   3314, 3315, 3316, 3317, 3317, 3319, 3320, 3321, 3322, 3322,
     4   3323, 3324, 3325, 3326, 3327, 3328, 3329, 3330, 3332, 3333,
     5   3334, 3335, 3336, 3337, 3338, 3339, 3340, 3341, 3342, 3343,
     6   3344, 3345, 3346, 3347, 3348, 3349, 3350, 3350, 3352, 3352,
     7   3353, 3353, 3355, 3356, 3357, 3358, 3359, 3360, 3361, 3362,
     8   3363, 3363, 3364, 3365, 3366, 3367, 3368, 3369, 3370, 3371,
     9   3372, 3373, 3374, 3375, 3376, 3377, 3378, 3379, 3380, 3381/
            data (jb2(i),i= 3501, 3600)/
     +   3382, 3383, 3384, 3385, 3386, 3387, 3388, 3389, 3390, 3390,
     1   3391, 3392, 3393, 3394, 3395, 3396, 3397, 3398, 3399, 3400,
     2   3400, 3401, 3403, 3404, 3405, 3406, 3407, 3408, 3409, 3410,
     3   3411, 3411, 3402, 3412, 3413, 3413, 3414, 3415, 3416, 3417,
     4   3418, 3419, 3420, 3421, 3422, 3423, 3424, 3425, 3426, 3427,
     5   3428, 3429, 3429, 3431, 3432, 3433, 3434, 3435, 3436, 3437,
     6   3437, 3439, 3439, 3440, 3441, 3442, 3443, 3444, 3445, 3446,
     7   3447, 3448, 3449, 3449, 3450, 3451, 3453, 3454, 3455, 3456,
     8   3457, 3458, 3459, 3460, 3461, 3462, 3463, 3464, 3465, 3465,
     9   3466, 3467, 3468, 3469, 3470, 3471, 3471, 3472, 3473, 3474/
            data (jb2(i),i= 3601, 3700)/
     +   3475, 3476, 3477, 3478, 3479, 3480, 3481, 3482, 3483, 3484,
     1   3485, 3486, 3487, 3488, 3489, 3490, 3491, 3492, 3493, 3494,
     2   3495, 3496, 3497, 3498, 3499, 3500, 3501, 3502, 3503, 3504,
     3   3505, 3506, 3507, 3508, 3509, 3510, 3511, 3512, 3513, 3514,
     4   3514, 3515, 3516, 3517, 3518, 3519, 3520, 3521, 3522, 3523,
     5   3524, 3525, 3526, 3527, 3528, 3529, 3530, 3531, 3532, 3533,
     6   3534, 3535, 3536, 3537, 3538, 3539, 3540, 3541, 3542, 3543,
     7   3544, 3545, 3546, 3547, 3548, 3549, 3550, 3551, 3552, 3553,
     8   3554, 3555, 3556, 3557, 3558, 3559, 3560, 3560, 3562, 3563,
     9   3564, 3565, 3566, 3567, 3568, 3569, 3570, 3570, 3571, 3572/
            data (jb2(i),i= 3701, 3800)/
     +   3573, 3574, 3575, 3576, 3577, 3578, 3579, 3580, 3581, 3583,
     1   3584, 3585, 3586, 3587, 3588, 3589, 3590, 3591, 3592, 3593,
     2   3594, 3595, 3596, 3597, 3597, 3598, 3599, 3600, 3601, 3602,
     3   3603, 3604, 3605, 3606, 3607, 3608, 3609, 3610, 3611, 3612,
     4   3613, 3614, 3615, 3616, 3616, 3617, 3618, 3619, 3620, 3621,
     5   3622, 3623, 3624, 3625, 3626, 3627, 3628, 3629, 3630, 3630,
     6   3631, 3632, 3633, 3633, 3634, 3635, 3636, 3637, 3638, 3639,
     7   3640, 3641, 3642, 3643, 3644, 3645, 3646, 3647, 3648, 3649,
     8   3650, 3651, 3652, 3653, 3654, 3655, 3656, 3657, 3657, 3659,
     9   3660, 3661, 3662, 3663, 3664, 3664, 3666, 3666, 3667, 3668/
            data (jb2(i),i= 3801, 3900)/
     +   3669, 3670, 3671, 3672, 3672, 3673, 3674, 3675, 3676, 3677,
     1   3678, 3679, 3680, 3681, 3682, 3683, 3684, 3686, 3687, 3688,
     2   3689, 3689, 3690, 3691, 3692, 3693, 3694, 3694, 3695, 3696,
     3   3697, 3698, 3698, 3700, 3701, 3702, 3702, 3703, 3704, 3705,
     4   3706, 3707, 3707, 3708, 3709, 3710, 3711, 3712, 3713, 3714,
     5   3715, 3716, 3717, 3718, 3719, 3720, 3721, 3722, 3723, 3724,
     6     41, 3726, 3727, 3728, 3729, 3729, 3731, 3732, 3733, 3734,
     7   3735, 3736, 3737, 3738, 3739, 3740, 3741, 3742, 3743, 3744,
     8   3745, 3745, 3746, 3747, 3748, 3749, 3750, 3751, 3752, 3753,
     9   3754, 3755, 3756, 3757, 3758, 3759, 3760, 3761, 3762, 3762/
            data (jb2(i),i= 3901, 4000)/
     +   3764, 3765, 3766, 3767, 3768, 3769, 3770, 3771, 3772, 3773,
     1   3774, 3775, 3775, 3776, 3778, 3779, 3780, 3781, 3782, 3783,
     2   3783, 3777, 3784, 3785, 3786, 3787, 3788, 3789, 3790, 3791,
     3   3792, 3793, 3794, 3795, 3796, 3797, 3798, 3799, 3800, 3801,
     4   3802, 3803,   42, 3805, 3805, 3807, 3808, 3809, 3810, 3811,
     5   3812, 3813, 3814, 3815, 3816, 3817, 3818, 3819, 3820, 3821,
     6   3822, 3823, 3824, 3825, 3826, 3827, 3828, 3829, 3830, 3831,
     7   3832, 3833, 3834, 3835, 3836, 3837, 3838, 3839, 3840, 3841,
     8   3842, 3843, 3844, 3845, 3846, 3847, 3847, 3806, 3848, 3849,
     9   3850, 3851, 3851, 3852, 3853, 3854, 3855, 3856, 3857, 3857/
            data (jb2(i),i= 4001, 4100)/
     +   3859, 3860, 3861, 3862, 3863, 3864, 3865, 3866, 3867, 3868,
     1   3869, 3869, 3870, 3871, 3872, 3873, 3874, 3875, 3876, 3877,
     2   3878, 3879, 3880, 3881, 3882, 3883, 3884, 3885, 3886, 3886,
     3   3887, 3888, 3889, 3890, 3891, 3892, 3893, 3893, 3894, 3895,
     4   3896, 3897, 3898, 3899, 3900, 3901, 3902, 3903, 3904, 3905,
     5   3906, 3907, 3908, 3909, 3910, 3911, 3912, 3913, 3914, 3915,
     6   3916, 3917, 3919, 3920, 3921, 3922, 3923, 3924, 3925, 3926,
     7   3927, 3928, 3929, 3930, 3931, 3932, 3933, 3934, 3935, 3936,
     8   3937, 3938, 3939, 3940, 3941, 3941, 3918, 3943, 3944, 3945,
     9   3946, 3946, 3942, 3947, 3948, 3949, 3950, 3951, 3952, 3953/
            data (jb2(i),i= 4101, 4200)/
     +   3954, 3955, 3956, 3957, 3958, 3958, 3959, 3960, 3960, 3962,
     1   3963, 3964, 3965, 3966, 3967, 3968, 3969, 3969, 3970, 3971,
     2   3972, 3973, 3974, 3975, 3976, 3977, 3978, 3979,   45, 3980,
     3   3981, 3982, 3983, 3984, 3985, 3986, 3987, 3988, 3989, 3990,
     4   3991, 3992, 3993, 3994, 3995, 3996, 3997, 3998, 3999,   46,
     5   4000, 4001, 4002, 4003, 4004, 4005,   47, 4006, 4007, 4008,
     6   4009, 4010, 4010, 4011, 4012, 4013, 4014, 4015, 4016, 4017,
     7   4018, 4019, 4020, 4021, 4021,   49,   50, 4023, 4024, 4025,
     8   4026, 4027, 4028, 4029, 4030, 4031, 4032, 4033, 4034, 4035,
     9   4036, 4037, 4038, 4039, 4040, 4041, 4042, 4043, 4044, 4045/
            data (jb2(i),i= 4201, 4300)/
     +   4046, 4047, 4048, 4049, 4050, 4051, 4052, 4053, 4054, 4055,
     1   4056, 4057, 4058, 4058,   51, 4059, 4060, 4061, 4062, 4063,
     2   4064, 4065, 4066, 4067, 4068, 4069, 4070, 4071, 4072, 4072,
     3   4073, 4074, 4075, 4076, 4077, 4078, 4079, 4080, 4081, 4082,
     4   4083, 4084, 4085, 4086, 4087, 4088, 4089,   53,    2,    3,
     5      4,    5,    5,    7,    8,    9,   10,   11,   12,   13,
     6     14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
     7     24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
     8     34,   34,   36,   37,   38,   38,   40,   41,   41,   43,
     9     44,   45,   45,   47,   48,   49,   49,   51,   52,   53/
            data (jb2(i),i= 4301, 4390)/
     +     54,   54,   56,   57,   57,   59,   60,   61,   62,   63,
     1     64,   65,   66,   66,   68,   69,   70,   71,   72,   73,
     2     74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
     3     84,   84,   86,   87,   88,   88,   90,   91,   92,   93,
     4     93,   95,   96,   96,   98,   99,   99,  101,  102,  102,
     5    104,  105,  106,  107,  108,  108,  110,  111,  112,  112,
     6    114,  115,  115,  117,  118,  119,  119,  121,  122,  122,
     7    124,  125,  126,  126,  128,  129,  129,  131,  132,  132,
     8    134,  135,  136,  137,  138,  139,  140,  140,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine hi(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(660) :: jx,jy,jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'hawaii        '/
            data jrot,ipart/1,1/
            data kv/   1, 653,   0,   0,   0/
            data kb/   1, 653,   0,   0,   0/
            data iib/ 652,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  19584,19728,19800,19920,19992,20088,20136,20280,20688,20688,
     1  20568,20784,20736,20808,20712,20808,20760,20976,20904,20736,
     2  20592,20592,20520,20472,20400,20184,20064,20064,19992,20016,
     3  19920,19992,20016,19704,19584,19608,19560,19536,18936,18912,
     4  18312,18216,17856,17808,17808,17592,17496,17472,17328,17280,
     5  17208,17064,16992,16944,16920,16824,16896,16896,16968,16920,
     6  16944,16872,16944,17160,17112,16800,16872,16896,17376,17376,
     7  17568,17592,17712,17712,17880,18288,18624,18912,19032,19200,
     8  26448,26328,26352,26472,26352,26400,26544,26568,26856,26760,
     9  26712,26640,26688,26448,26496,26592,26616,26712,26712,26808/
            data (jx(i),i=  101,  200)/
     +  27072,27168,27384,27432,27120,26568,26376,26208,25752,25584,
     1  25584,25392,25392,24768,24648,24240,24168,24096,24168,24096,
     2  24192,24120,24000,23952,23880,23568,23424,22992,22704,22776,
     3  22896,23040,23112,23136,23352,23376,23592,23784,23832,24144,
     4  24192,24384,24432,24360,24384,24576,24792,24960,25008,25056,
     5  25488,25464,25560,25560,25800,25920,25896,26040,26016,25800,
     6  25728,25584,25536,25632,25512,25656,25704,25992,26160,26184,
     7  26376,26568,26856,27096,27192,27192,27408,27672,27768,27792,
     8  27624,27552,27648,27864,27840,27792,27624,27504,27528,27480,
     9  27408,27408,27168,27192,27072,27120,27000,27120,27240,27264/
            data (jx(i),i=  201,  300)/
     +  27216,27192,26952,26784,26712,26712,26640,26544,19128,19104,
     1  19152,19224,19128,19104,19368,19440,19416,19368,19464,19896,
     2  20064,20112,20208,20256,20664,20952,21240,21552,21576,21648,
     3  21696,21840,21864,22008,21936,21816,21696,21576,21480,20880,
     4  20808,20832,20736,20664,20568,20352,19944,19896,19728,19728,
     5  19632,26712,26568,26544,26592,27240,27312,27264,27168,28584,
     6  28536,28440,28464,28392,28464,28392,28416,28152,28224,28128,
     7  28488,28632,28752,28944,29088,29160,29496,29640,29712,29616,
     8  29592,29424,29520,29544,29616,29808,29784,30192,30096,30120,
     9  29928,29856,29664,29424,29232,29232,28776,28824,28728,28656/
            data (jx(i),i=  301,  400)/
     +  28680,28776,28656,28800,28752,28824,28776,28824,28752,28824,
     1  28728,28776,28656,28296,28176,28296,28536,28608,31752,31992,
     2  32016,32256,32688,32832,33432,33408,33696,33624,33720,33696,
     3  33744,33696,33744,33384,33192,32712,32352,32232,32232,32064,
     4  31968,31704,31536,31464,31536,31536,34464,34536,34512,34680,
     5  34656,34872,34872,34776,34824,35184,35208,35304,35352,35448,
     6  35376,35400,35232,35160,35232,35208,35064,34944,34728,34680,
     7  34104,33384,33048,32928,33192,33000,32976,32784,32808,32496,
     8  32472,32088,31920,31776,31656,31320,30600,30528,30456,30432,
     9  30312,30336,30240,30240,30408,30480,30648,30600,30792,30816/
            data (jx(i),i=  401,  500)/
     +  31008,31200,31344,31368,31608,31632,31848,31848,31752,31752,
     1  31656,31656,31488,31296,31296,31200,31176,31248,31200,31320,
     2  31272,31344,31296,31368,31608,31584,31656,31800,31872,31896,
     3  32016,32112,32160,32112,32208,32496,32544,32472,32664,32664,
     4  32808,32952,33048,33144,33120,33288,33288,33384,33840,34032,
     5  34152,34248,34344,34560,35424,35616,35736,35928,36096,36240,
     6  36312,36360,36264,36144,36192,36312,36168,36216,36072,36288,
     7  36144,36120,36168,36000,35904,35904,35856,35568,35544,35400,
     8  35280,35160,35160,45744,45864,45984,46392,46800,46848,46968,
     9  46992,47088,47304,47592,47664,47760,47976,48336,48552,48648/
            data (jx(i),i=  501,  600)/
     +  48864,48912,49296,50160,50304,51192,51480,51456,51552,51672,
     1  51912,52296,52320,52464,52464,52800,52920,52992,53472,53736,
     2  53880,54168,54048,54072,53928,53832,53736,53688,53496,53472,
     3  53112,53040,52872,52632,52200,52128,51912,51792,51696,51576,
     4  51528,51264,50808,50160,49488,49320,49008,48552,47808,47400,
     5  47376,47160,47112,46776,46512,46272,46128,45960,45816,45432,
     6  45168,44712,44616,44664,44616,44808,44688,44808,44808,44304,
     7  43920,43848,43584,43320,43152,43032,42864,42768,42576,42552,
     8  42288,42168,42048,41904,41568,41448,41328,41208,41160,40704,
     9  40632,40656,40512,40512,40392,40296,40440,40344,40176,40128/
            data (jx(i),i=  601,  660)/
     +  39936,39504,39264,39216,39120,38976,38904,38832,38760,38760,
     1  39096,39696,39768,40104,40632,40680,40968,41016,41136,41184,
     2  41520,41832,42192,42144,42144,42408,42480,42456,42552,42552,
     3  42768,42864,42936,42960,43080,43224,43464,43488,43584,43800,
     4  43896,43896,44088,44232,44256,44400,44496,44904,44952,45000,
     5  45120,45360,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  15528,15672,15960,16056,16536,16608,16728,16776,17184,17256,
     1  17328,17856,17904,18048,18120,18360,18456,18912,18912,19224,
     2  19344,19488,19464,19536,19560,19896,19896,19776,19800,19872,
     3  19920,19944,20088,20088,20136,20040,20016,20088,20040,20208,
     4  20400,20496,20472,20448,20328,20328,20280,20304,20232,20064,
     5  20064,19896,19512,19536,19416,19320,19272,19104,19032,18936,
     6  18696,18456,18336,18312,18072,17736,17664,17472,16848,16680,
     7  16368,16152,16032,15960,15864,15744,15312,15264,15168,15240,
     8  34896,34704,34536,34560,34392,34344,34416,34512,34584,34512,
     9  34392,34392,34296,34176,34056,34080,34032,34104,34272,34464/
            data (jy(i),i=  101,  200)/
     +  34584,34560,33672,33144,32952,32760,32640,32352,32232,32016,
     1  31944,31872,31752,31752,31680,31248,31944,32064,32184,32808,
     2  32952,32976,33120,33048,33072,33528,33504,33936,34344,34632,
     3  34776,34848,34992,34944,35088,35184,35088,35208,35328,35472,
     4  35544,35592,35616,35688,35832,35952,36000,35976,35856,35832,
     5  35976,36024,36120,36192,36264,36384,36504,36576,36672,36816,
     6  36648,36648,36744,37008,37128,37152,37032,36960,37080,37272,
     7  37368,37320,37440,37848,37872,37992,37896,37464,37536,37320,
     8  37296,37200,36744,36408,36240,36120,36048,35952,35856,35784,
     9  35832,35616,35688,35592,35520,35424,35400,35160,35112,34992/
            data (jy(i),i=  201,  300)/
     +  34944,34704,34608,34632,34704,34896,34848,34920,12096,12048,
     1  12024,12048,12144,12120,12336,12240,12168,12144,11928,11760,
     2  11520,11304,11304,11040,10656,10584,10416,10392,10488,10464,
     3  10560,10632,10752,10896,10968,10920,11064,11016,11064,11448,
     4  11688,11952,12024,12216,12288,12192,12216,12312,12360,12432,
     5  12504,34632,34752,34728,34608,35448,35448,35592,35448,44688,
     6  44064,43872,43680,43536,43320,43176,42912,42624,42480,42120,
     7  42240,42216,42168,41832,41808,41712,41568,41640,42168,42768,
     8  43488,43872,43944,44328,44568,44712,44880,46272,46392,46488,
     9  46848,47160,47376,47640,47760,47808,48000,47664,47664,47616/
            data (jy(i),i=  301,  400)/
     +  47232,47088,46968,46632,46536,46320,46296,46152,46008,45984,
     1  45696,45672,45432,45288,45168,45048,45000,44928,46152,46344,
     2  46464,46704,46992,46992,46632,46464,46080,46056,45696,45624,
     3  45504,45432,45288,45072,45024,45024,44832,44640,44496,44352,
     4  44304,44352,44664,45048,45288,45720,55104,54912,54816,54648,
     5  54528,54264,53760,53592,53376,52824,52608,52560,51936,51720,
     6  51576,51240,51216,51120,51072,51024,50928,50928,50808,50904,
     7  50856,50736,50592,50256,49944,49632,49392,49152,48912,48768,
     8  48672,48336,48264,48288,48192,48192,48456,48696,48768,48720,
     9  48768,49080,49176,49272,49344,49656,49680,49752,49896,49968/
            data (jy(i),i=  401,  500)/
     +  50016,50184,50184,50280,50376,50496,50592,50616,50640,50856,
     1  51096,51264,51600,51840,51960,52056,52248,52320,52584,52728,
     2  52824,52896,52920,53184,53184,53328,53352,53520,53496,53544,
     3  53856,53856,53976,54192,54264,54360,54432,54696,54960,55104,
     4  55488,55608,55776,55800,55848,55800,55848,55848,55728,55608,
     5  55344,55272,55368,55224,48984,48816,48480,48288,48216,48432,
     6  48432,48600,48768,48816,48864,48864,49152,49248,49344,49440,
     7  49584,49800,49872,50016,50016,49800,49776,49848,49920,49896,
     8  49824,49608,49416,55536,55560,55920,56112,56184,56256,56208,
     9  56304,56328,56256,56400,56400,56688,56640,56736,56856,56784/
            data (jy(i),i=  501,  600)/
     +  56904,57000,57120,57096,57024,56976,56880,56928,56928,56856,
     1  56832,56952,57048,57120,57168,57240,57408,57984,58680,59256,
     2  59400,59400,59616,59664,59760,59928,59928,60024,60072,60288,
     3  60432,60504,60528,60768,60792,60912,61032,61272,61248,61416,
     4  61752,61992,64343,66287,66743,66575,67079,67463,68399,68663,
     5  68615,68639,68783,68279,67655,67439,67199,67175,66887,66839,
     6  66887,66671,66551,66479,66071,65951,65927,65807,65711,65615,
     7  65663,65591,65687,65639,65543,65327,65255,65111,65063,64919,
     8  64679,64415,64319,64031,63599,63167,63095,62831,62568,61824,
     9  61584,61464,61176,61008,60792,60432,60144,60000,59928,59688/
            data (jy(i),i=  601,  660)/
     +  59472,58656,58608,58416,58416,57912,57864,57552,57504,57192,
     1  56808,56736,56808,56832,56952,57048,57216,57288,57312,57408,
     2  57624,57624,57552,57480,57384,57168,57192,57096,57096,57024,
     3  56976,56880,56904,56832,56784,56592,56592,56256,56040,55872,
     4  55872,55776,55656,55512,55392,55296,55272,55296,55200,55200,
     5  55296,55344,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     1     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     2     21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
     3     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     4     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     5     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     7     71,   72,   73,   74,   75,   76,   77,   78,   79,    1,
     8     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     9     91,   92,   93,   94,   95,   96,   97,   98,   99,  100/
            data (jb1(i),i=  101,  200)/
     +    101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
     1    111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
     2    121,  122,  123,  124,  125,  126,  127,  128,  129,  130,
     3    131,  132,  133,  134,  135,  136,  137,  138,  139,  140,
     4    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     5    151,  152,  153,  154,  155,  156,  157,  158,  159,  160,
     6    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     7    171,  172,  173,  174,  175,  176,  177,  178,  179,  180,
     8    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     9    191,  192,  193,  194,  195,  196,  197,  198,  199,  200/
            data (jb1(i),i=  201,  300)/
     +    201,  202,  203,  204,  205,  206,  207,   81,  209,  210,
     1    211,  212,  213,  209,  215,  216,  217,  218,  219,  220,
     2    221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
     3    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     4    241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
     5    215,  252,  253,  254,  252,  256,  257,  258,  256,  260,
     6    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     7    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     8    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     9    291,  292,  293,  294,  295,  296,  297,  298,  299,  300/
            data (jb1(i),i=  301,  400)/
     +    301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
     1    311,  312,  313,  314,  315,  316,  317,  260,  319,  320,
     2    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     3    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  319,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     7    371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
     8    381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
     9    391,  392,  393,  394,  395,  396,  397,  398,  399,  400/
            data (jb1(i),i=  401,  500)/
     +    401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
     1    411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
     2    421,  422,  423,  424,  425,  426,  427,  428,  429,  430,
     3    431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
     4    441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
     5    451,  452,  453,  347,  455,  456,  457,  458,  459,  460,
     6    461,  462,  463,  464,  465,  466,  467,  468,  469,  470,
     7    471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
     8    481,  482,  455,  484,  485,  486,  487,  488,  489,  490,
     9    491,  492,  493,  494,  495,  496,  497,  498,  499,  500/
            data (jb1(i),i=  501,  600)/
     +    501,  502,  503,  504,  505,  506,  507,  508,  509,  510,
     1    511,  512,  513,  514,  515,  516,  517,  518,  519,  520,
     2    521,  522,  523,  524,  525,  526,  527,  528,  529,  530,
     3    531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
     4    541,  542,  543,  544,  545,  546,  547,  548,  549,  550,
     5    551,  552,  553,  554,  555,  556,  557,  558,  559,  560,
     6    561,  562,  563,  564,  565,  566,  567,  568,  569,  570,
     7    571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
     8    581,  582,  583,  584,  585,  586,  587,  588,  589,  590,
     9    591,  592,  593,  594,  595,  596,  597,  598,  599,  600/
            data (jb1(i),i=  601,  660)/
     +    601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
     1    611,  612,  613,  614,  615,  616,  617,  618,  619,  620,
     2    621,  622,  623,  624,  625,  626,  627,  628,  629,  630,
     3    631,  632,  633,  634,  635,  636,  637,  638,  639,  640,
     4    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     5    651,  484,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   74,   75,   76,   77,   78,   79,   80,   80,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   97,   98,   99,  100,  101/
            data (jb2(i),i=  101,  200)/
     +    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     1    112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
     2    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     3    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     4    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb2(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  208,  210,  211,
     1    212,  213,  214,  214,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     4    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     5    251,  253,  254,  255,  255,  257,  258,  259,  259,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     9    292,  293,  294,  295,  296,  297,  298,  299,  300,  301/
            data (jb2(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     1    312,  313,  314,  315,  316,  317,  318,  318,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4    342,  343,  344,  345,  346,  346,  348,  349,  350,  351,
     5    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     6    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     7    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     8    382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
     9    392,  393,  394,  395,  396,  397,  398,  399,  400,  401/
            data (jb2(i),i=  401,  500)/
     +    402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
     1    412,  413,  414,  415,  416,  417,  418,  419,  420,  421,
     2    422,  423,  424,  425,  426,  427,  428,  429,  430,  431,
     3    432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
     4    442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
     5    452,  453,  454,  454,  456,  457,  458,  459,  460,  461,
     6    462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
     7    472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
     8    482,  483,  483,  485,  486,  487,  488,  489,  490,  491,
     9    492,  493,  494,  495,  496,  497,  498,  499,  500,  501/
            data (jb2(i),i=  501,  600)/
     +    502,  503,  504,  505,  506,  507,  508,  509,  510,  511,
     1    512,  513,  514,  515,  516,  517,  518,  519,  520,  521,
     2    522,  523,  524,  525,  526,  527,  528,  529,  530,  531,
     3    532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
     4    542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
     5    552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
     6    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     7    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     8    582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
     9    592,  593,  594,  595,  596,  597,  598,  599,  600,  601/
            data (jb2(i),i=  601,  660)/
     +    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     1    612,  613,  614,  615,  616,  617,  618,  619,  620,  621,
     2    622,  623,  624,  625,  626,  627,  628,  629,  630,  631,
     3    632,  633,  634,  635,  636,  637,  638,  639,  640,  641,
     4    642,  643,  644,  645,  646,  647,  648,  649,  650,  651,
     5    652,  652,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine id(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1310) :: jx,jy
            integer(kind=iknd), save, dimension(1350) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'idaho         '/
            data jrot,ipart/0,1/
            data kv/   1,1305,   0,   0,   0/
            data kb/   1,1348,   0,   0,   0/
            data iib/ 428,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  13464,18648,13416,18720,13416,13416,24744,13440,26784,14808,
     1  27240,15432,14256,44208,37440,14232,13752,13488,25248,29736,
     2  37320,42600,13488,18600,24456,24240,24120,24048,23904,23784,
     3  23736,23592,23424,23136,23064,22848,22896,22752,22728,22248,
     4  22152,22032,21744,21624,21456,21216,21096,20928,20856,20520,
     5  20352,20352,20496,20688,20880,20952,21000,20880,20808,20712,
     6  20592,20640,20352,20448,20688,20640,20448,20472,20304,20208,
     7  20160,20088,19896,19824,19776,19608,19536,19008,18864,26688,
     8  26544,26616,26448,26232,26136,26016,25872,25848,25728,25848,
     9  25800,25704,25488,25272,25104,25080,24936,24936,24840,24936/
            data (jx(i),i=  101,  200)/
     +  24888,24960,27096,27192,27312,27504,27648,28056,28248,28296,
     1  28296,28200,28248,28176,28200,28128,27960,27888,27888,28056,
     2  27984,27816,27864,27768,27792,27600,27576,27696,27720,27600,
     3  27408,27312,27360,27576,27672,27624,27504,27456,27624,27552,
     4  27600,27720,27984,28008,27888,28152,28008,27864,27624,27528,
     5  27480,27168,27192,27288,27336,27552,27576,27504,27576,27528,
     6  27216,27360,14448,14376,14256,14256,14136,13944,13752,13776,
     7  13896,14088,13848,13848,13704,13704,13560,13488,13344,13296,
     8  13464,15504,15504,15912,15960,16152,16152,16272,16320,16536,
     9  16632,16272,16176,15840,15552,15288,14904,14856,37464,37272/
            data (jx(i),i=  201,  300)/
     +  37128,37056,36960,36696,36384,36240,36312,36096,36144,35856,
     1  36024,36024,35952,35928,35736,35688,35496,35520,35280,35136,
     2  34848,34320,34272,34296,34248,34056,33864,33840,33648,33408,
     3  33696,33672,33720,33600,33624,33408,33384,33216,33288,33192,
     4  33048,32904,32928,32784,32784,32520,32376,32232,32184,32256,
     5  31920,31920,31680,31776,31680,31632,31752,31680,31584,31320,
     6  31416,31512,31488,31368,31248,31176,30912,30936,30744,30696,
     7  30528,30432,30264,30192,30264,30000,29880,29688,29616,29376,
     8  29304,29016,29016,28896,28752,28536,28416,28320,28032,27960,
     9  27816,27816,27576,27432,27312,15360,15168,14880,14880,14784/
            data (jx(i),i=  301,  400)/
     +  14544,14472,14496,14568,14616,14496,14592,14568,14448,14256,
     1  14208,13992,13824,13824,13752,13464,13344,13008,12792,12552,
     2  12408,12576,12288,12432,12384,12528,12600,12816,12840,12936,
     3  12960,13296,13320,13488,13680,14016,14064,43728,43656,43464,
     4  43392,43152,43056,42912,42768,42336,42120,41832,41880,41688,
     5  41448,41280,40824,40704,40536,40272,40032,40032,39912,39624,
     6  39456,39216,38976,38832,38640,38280,37944,37800,37608,37368,
     7  37320,44400,44616,44808,44904,45096,45072,44808,44832,44736,
     8  44712,44808,44736,44880,44976,44880,45144,45288,45360,45360,
     9  45432,45576,45768,46128,46104,46200,46440,46320,46392,46632/
            data (jx(i),i=  401,  500)/
     +  46728,46968,46992,47088,47472,47784,48072,13872,13824,13872,
     1  13776,14016,13968,14016,13992,13824,13800,14112,13488,13608,
     2  13752,19608,13464,48336,48600,46176,48888,32280,14760,14784,
     3  15600,15600,16296,16296,17256,18408,18288,18120,17928,17736,
     4  17568,17256,17280,15864,15864,15648,15648,15072,15072,14904,
     5  14904,14664,14664,17304,16584,16584,14544,14544,14400,14232,
     6  14040,13896,13776,13848,13776,13632,17304,17328,16608,16632,
     7  16800,17088,17088,15696,15312,15216,18192,18072,17448,17376,
     8  18336,18432,18528,18840,19008,19296,19680,20280,20496,20616,
     9  20640,20832,20880,21072,21168,16872,16896,17112,17160,17112/
            data (jx(i),i=  501,  600)/
     +  16536,16464,16440,15192,15384,15264,15264,15576,15624,15960,
     1  16248,16272,16320,16320,16512,16536,16680,16728,16848,16992,
     2  17376,17472,17616,18096,18168,18384,18432,18720,18960,19104,
     3  18960,18912,18696,18480,15048,15024,15120,15024,26592,26688,
     4  27120,26976,26760,26664,26664,26472,26424,26304,26136,25992,
     5  25944,26064,26328,26568,26592,26712,26904,27024,17328,17592,
     6  17544,17592,17664,17688,17568,17568,18456,18576,18792,18960,
     7  19368,19440,19392,26016,26136,26256,26280,26448,26496,26424,
     8  26496,26400,26472,26424,26472,26400,26472,26376,26424,18432,
     9  18288,18408,18288,18312,18120,18216,18384,18408,18552,18624/
            data (jx(i),i=  601,  700)/
     +  18528,18576,18672,18696,18768,18648,18480,14688,14688,14808,
     1  14808,15768,15792,15936,15888,16320,16344,17016,17616,34680,
     2  34560,34584,34368,34104,34080,33912,33816,33720,33576,33384,
     3  33264,33120,32640,32496,31896,31560,31128,30816,30672,30624,
     4  30528,30360,30168,29856,29424,29376,29472,29520,29472,29352,
     5  29136,29040,28872,28824,28728,28608,28584,28416,28320,28368,
     6  28512,28440,28488,28176,28128,27912,27720,27624,27480,27264,
     7  27288,27048,26904,26496,26400,26184,26112,25992,26088,23376,
     8  23640,23760,23688,23736,23616,23424,23352,23280,23400,23520,
     9  23544,23712,23712,23856,24024,24168,24120,24480,24792,24792/
            data (jx(i),i=  701,  800)/
     +  24864,24912,25008,25200,25416,25440,41376,42096,42048,42744,
     1  42720,43032,43008,43344,43320,44304,17688,17976,18096,18264,
     2  16800,17328,17328,17400,17376,37488,37560,36528,25200,25200,
     3  25320,25200,25224,25104,24936,24816,24888,24984,25080,25104,
     4  25104,24936,24816,24984,24912,24768,24744,24576,24480,24360,
     5  24264,24144,24072,24168,24072,24024,23976,23880,23832,23688,
     6  23640,23424,34104,34176,33912,34056,34008,34056,33960,34008,
     7  34248,34368,34512,34512,34248,34080,34080,33864,33480,33336,
     8  32784,32544,32376,32136,18456,18480,18120,18144,18672,18744,
     9  21984,22392,22824,22872,23088,22992,23040,23184,38328,36624/
            data (jx(i),i=  801,  900)/
     +  17760,17808,17784,38304,42480,42456,41424,20784,20856,21000,
     1  21120,21432,21600,21528,21528,21648,21720,21936,22032,22032,
     2  22128,22152,22272,22440,22968,23208,23520,23544,23784,23976,
     3  23760,24120,24240,24288,24264,24480,24600,24624,24576,24720,
     4  24672,24768,24888,24984,16776,16320,16320,16080,16104,15288,
     5  15312,45792,45672,45528,45240,44880,44880,44112,44088,43296,
     6  43272,44664,44640,44088,43968,43776,43488,43248,43128,43008,
     7  42816,42552,32088,32040,31896,31728,31512,31416,31104,30768,
     8  30720,30624,30576,30240,30048,29928,29376,29280,29232,28896,
     9  28800,28512,28152,28056,27912,27888,27672,27552,27504,27360/
            data (jx(i),i=  901, 1000)/
     +  26952,26184,26160,25824,25632,25440,25296,25152,25296,25200,
     1  14832,14832,14496,14496,14280,14280,14160,14160,13920,13920,
     2  28872,28848,28752,28728,28680,27912,27960,27936,27840,27816,
     3  28032,27984,27792,27672,27528,27576,27528,27312,27120,27000,
     4  27120,27096,27024,26976,27024,26976,27000,27096,26952,26904,
     5  26832,26784,26736,26616,26472,26352,26040,25968,26016,25776,
     6  25416,16440,24768,24696,24864,25008,24960,25128,25080,24936,
     7  24936,24960,25128,16464,16464,16704,16704,16464,18288,18288,
     8  18432,18600,18600,18720,18744,18840,18840,18960,18960,19368,
     9  19440,39480,38472,20616,39528,36792,37152,37128,37200,37152/
            data (jx(i),i= 1001, 1100)/
     +  38856,38808,34752,34728,33144,33144,33312,33360,33168,32928,
     1  32904,32784,32736,32664,32520,32376,19704,19776,20208,19872,
     2  20520,19464,19536,19680,19584,17928,39576,41976,42000,42336,
     3  42360,43632,43680,45048,45144,16392,16104,15816,15576,15168,
     4  14952,14928,14712,14520,14304,14208,13920,13800,17736,17520,
     5  17232,17256,17088,17016,32712,34488,34608,34272,34296,27648,
     6  32808,32568,32592,31584,36864,35832,35712,35688,36048,36000,
     7  35664,35496,24936,24816,42432,38424,38088,36936,38496,38664,
     8  38880,25104,22680,22680,22752,22728,22416,22176,21864,21576,
     9  21312,20808,20664,20640,20424,20184,20016,19896,19656,19704/
            data (jx(i),i= 1101, 1200)/
     +  19392,19176,18984,18792,18600,18624,18384,18264,18312,18240,
     1  18048,27696,38568,38448,38544,38568,38616,38736,38688,38760,
     2  39024,39408,39576,39816,39840,39960,39984,40176,40200,40464,
     3  40488,40704,40704,40512,40536,43752,43728,43632,43608,43488,
     4  43464,43248,43248,43152,43176,43080,42576,42384,42312,42240,
     5  42120,42048,42144,42144,42000,42024,42072,42240,42336,42504,
     6  27624,27384,27240,26808,26472,26400,26352,26232,26256,26184,
     7  25872,25704,25728,25848,25896,25800,25704,25512,25032,25032,
     8  24936,24936,25104,30888,30864,29160,29136,29016,29016,27576,
     9  31656,34056,33744,33336,33096,32736,32616,32496,32256,31968/
            data (jx(i),i= 1201, 1300)/
     +  34896,35280,35544,35592,37200,37080,36072,36048,31200,30960,
     1  30480,30288,30144,29856,29304,29040,28536,28200,27720,40080,
     2  40128,39192,39240,40728,40752,41064,41232,41304,41352,41160,
     3  41208,41304,41448,41568,41952,42168,42384,29616,30888,30840,
     4  30888,31200,43200,43200,43752,43656,42576,42624,42720,42744,
     5  42504,47184,46992,46896,46848,46728,46320,46224,46176,46080,
     6  46056,45960,46872,47136,47472,47664,47904,45432,45528,45456,
     7  45384,45168,45240,45144,45288,46824,46920,47208,47376,47544,
     8  47520,47400,47520,47880,47952,48192,48480,48504,44784,44784,
     9  44568,44568,46080,45576,45624,45360,45432,45648,45504,45648/
            data (jx(i),i= 1301, 1310)/
     +  45672,45552,45504,45408,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  60744,58056,53832,53832,48984,47088,45696,42456,43392,37008,
     1  34848,32352,28944,27624,26088,23472,21312,19728, 6480, 6576,
     2   6912, 7176,61968,62016,46008,45984,46416,46560,46632,46776,
     3  46992,47040,47280,47424,47616,47688,47928,48072,48216,48264,
     4  48384,48360,48432,48552,48912,49128,49176,49200,49344,49512,
     5  49488,49560,49680,49752,49752,49800,49896,49920,50016,49992,
     6  50256,50376,50472,50640,50856,51120,51288,51696,51816,51840,
     7  52032,52128,52104,52344,52680,52848,52800,53472,53760,43416,
     8  43608,43968,44160,44184,44016,43992,43848,43920,43968,44232,
     9  44376,44472,44520,44736,44664,44808,44904,45048,45144,45264/
            data (jy(i),i=  101,  200)/
     +  45408,45552,43512,43440,43464,43392,43584,43704,43608,43512,
     1  43248,43080,42936,42768,42480,42408,42384,42336,42216,41856,
     2  41640,41472,41064,40824,40632,40512,40416,40224,39744,39672,
     3  39696,39504,39336,39264,39120,38856,38760,38592,38568,38376,
     4  38304,38328,38184,38016,37848,37464,37200,37272,37152,37176,
     5  37128,36576,36480,36432,36288,36120,35976,35856,35784,35640,
     6  35472,35232,37440,37776,37848,37968,38112,38664,38808,38880,
     7  38976,39480,39744,40104,40320,40488,40632,40824,40896,40968,
     8  41424,32448,32784,33456,33696,33936,34248,34392,34608,34776,
     9  35088,35688,36192,36432,36432,36768,36744,36792,25848,25704/
            data (jy(i),i=  201,  300)/
     +  25848,26040,25992,26112,26400,26712,26976,27144,27288,27576,
     1  27768,27864,27936,28176,28344,28584,28776,28920,28992,29136,
     2  29280,28968,29016,29088,29208,29352,29352,29472,29592,30168,
     3  30312,30576,30696,30960,31080,31128,31224,31296,31512,31536,
     4  31488,31608,31728,31848,32064,32280,32520,32616,32712,32808,
     5  33192,33648,33792,33936,34008,34176,34416,34656,34704,34656,
     6  35064,35184,35232,35400,35400,35472,35448,35664,35856,36048,
     7  35976,36096,36024,35880,35688,35496,35160,35088,34920,34824,
     8  34728,34800,34608,34296,34248,34080,34176,34368,34464,34632,
     9  34752,34896,34824,34944,34824,32184,31344,30960,30840,30672/
            data (jy(i),i=  301,  400)/
     +  30432,30024,30000,30096,30072,29904,29688,29568,29256,23592,
     1  23664,23784,23808,24096,24192,24240,24096,24480,24288,24408,
     2  24648,24912,25344,25656,26088,26184,26376,26496,26784,26856,
     3  27120,27864,28032,28224,28272,28464,28656,27672,27552,27480,
     4  27384,27360,27240,27384,27672,27552,27384,27432,27312,27360,
     5  27240,27336,27336,27528,27552,27312,27240,26880,26568,26592,
     6  26760,26640,26808,26760,26808,26784,26904,26760,26712,26400,
     7  26208,27720,27696,27552,27624,27624,27720,27768,27864,28008,
     8  28176,28296,28392,28416,28632,28920,29064,28992,29112,29280,
     9  29328,29160,29136,28704,28536,28560,28344,28272,28008,27960/
            data (jy(i),i=  401,  500)/
     +  27792,27696,27504,27384,27264,23376,19512,21672,21768,21888,
     1  21984,22152,22296,22368,22512,22656,22920,23088,20736,21048,
     2  21192, 6384, 6384,15696,11688, 7440, 7608, 6648,60744,58008,
     3  53832,53952,53952,53160,53160,54264,54312,54240,54360,54576,
     4  54552,54168,49368,49368,49272,49272,49032,49032,49152,49152,
     5  49104,49104,48984,46272,46272,46392,46368,46440,46512,46704,
     6  46752,46632,46800,46968,47064,47112,45552,43152,43128,42024,
     7  42072,42072,41880,43128,42768,42456,41136,41424,41424,41640,
     8  41112,40992,41040,41016,40752,40512,40512,40320,40440,40848,
     9  41112,41304,41304,41568,41952,41856,41688,41472,41160,40896/
            data (jy(i),i=  501,  600)/
     +  40920,40896,40728,40728,40128,40032,38136,38136,38472,38376,
     1  38184,38352,38376,39192,39120,39336,39696,39744,39792,39672,
     2  39624,39528,39552,39384,39624,39864,39888,39840,39888,39960,
     3  40056,40176,40272,40464,37848,37608,37344,37128,31920,32256,
     4  32760,32808,33024,33144,33264,33408,33528,33528,33792,33816,
     5  34392,34440,34224,34248,34152,34080,34584,34608,32328,31680,
     6  31608,31416,31392,31272,31176,31080,31080,31488,31464,31536,
     7  31968,31920,31776,28848,29088,29136,29376,29424,29496,29784,
     8  29880,30024,30432,30912,31080,31128,31320,31584,31800,26256,
     9  27024,27912,28032,28224,28416,29304,29496,29784,29784,30024/
            data (jy(i),i=  601,  700)/
     +  30264,30408,30480,30648,30720,30816,30840,28944,28992,28992,
     1  28920,28944,27528,27312,27120,27144,26184,25800,25800,24576,
     2  24768,24984,25488,25752,25944,26064,26304,26280,26016,26040,
     3  26040,26160,26232,26352,26424,26784,27096,27480,27552,27696,
     4  27744,28104,28272,28440,28440,28488,28704,29064,29352,29448,
     5  29280,29112,29040,28872,28848,28656,28440,28440,28296,28176,
     6  28128,27912,27816,27600,27336,27144,27264,27096,27024,27192,
     7  27384,27648,27696,27624,27888,28128,28104,28320,28728,25056,
     8  25416,26040,26064,26136,26496,26472,26616,26952,27192,27192,
     9  27264,27264,27384,27336,27528,28056,28152,28512,28320,28200/
            data (jy(i),i=  701,  800)/
     +  28320,28080,28176,28104,28248,28392,23520,23568,24264,24312,
     1  24672,24696,25680,25704,26376,26448,25872,25968,26304,26208,
     2  23472,23472,23880,24024,24840,26088,24696,24672,21984,22104,
     3  22248,22320,22488,22560,22536,22752,22944,23016,22992,23064,
     4  23136,23184,23352,23496,23664,23688,23664,23808,23736,23904,
     5  23880,23976,24240,24312,24672,24720,24624,24624,24792,24792,
     6  24936,24984,24552,23160,23136,22512,22272,22128,21792,21696,
     7  21600,21504,21216,21144,21240,21144,20904,20616,20376,20232,
     8  19944,19680,19656,19200,26256,24864,24864,23472,23472,24168,
     9  24192,24240,24480,24648,24840,25080,25104,25128,22680,22584/
            data (jy(i),i=  801,  900)/
     +  20736,20736,23496,23352,22536,22896,22824,19536,19488,19632,
     1  19656,19944,20160,20184,20328,20592,20688,20688,20760,21168,
     2  21216,21360,21480,21504,21720,21720,21888,22104,22464,22920,
     3  23136,23040,22824,22560,22392,22152,22200,22104,22056,22032,
     4  21960,21936,22080,22008,22776,22776,22320,22320,22128,22128,
     5  20736,22752,22656,22656,22752,22512,22368,22296,22416,22368,
     6  22584,20304,20520,20496,20568,20592,20904,20976,21144,21144,
     7  21288,21168,19176,19368,19464,19776,19800,19992,20232,20856,
     8  20712,20664,20472,20472,20736,20760,21096,21216,21600,21624,
     9  21504,21624,21648,21720,21624,21264,21216,21264,21480,21624/
            data (jy(i),i=  901, 1000)/
     +  21864,21840,22392,22368,22248,21984,21912,21696,21336,21288,
     1  20688,20592,20616,20736,20736,20856,20856,20976,20976,21312,
     2  16128,16560,16536,17016,17160,17136,17616,17688,17736,17976,
     3  18264,18456,18456,18576,18768,18888,19032,19080,19272,19176,
     4  19632,19800,19824,19968,20016,20136,20280,20400,20472,20784,
     5  20904,20952,20880,20904,20760,20856,20736,20808,20952,21000,
     6  21240,20736,16008,19248,19224,19392,19776,20040,20184,20328,
     7  20520,20808,21048,16584,17976,17952,19296,19896,20208,20064,
     8  20064,19896,19728,19728,19608,19608,19488,19464,19128,19128,
     9  19080,19992,19896,19464,19392,17136,17160,17808,17808,18456/
            data (jy(i),i= 1001, 1100)/
     +  18528,19344,17040,17712,17640,18144,18264,18432,18576,18600,
     1  18768,18960,19224,19344,19368,19248,19104,19152,19080,19056,
     2  19320,19056,18984,19032,15288,15240,18384,18528,18408,18432,
     3  18072,18144,17472,17568,15504,16680,16776,17256,17400,17904,
     4  18072,18480,18888,19056,19056,19104,19368,19656,15264,15600,
     5  15840,16224,16416,16632,16248,16320,13560,13536,12096,16104,
     6  13488,13488,12816,12768,15768,11880,11880,12216,12240,12936,
     7  12936,15696,13752,13800,15360,14568,13848,13752,14880,14928,
     8  15144,12624,12552,13224,13224,13872,13848,13920,13872,14040,
     9  13896,13896,13968,14160,14112,14256,14208,14400,14184,13920/
            data (jy(i),i= 1101, 1200)/
     +  13944,14232,14232,14424,14472,14616,14688,14784,15024,15096,
     1  15096,13320,14496,14280,14184,14304,14280,14400,14544,14472,
     2  14520,14784,14640,14280,13344,13368,12912,12912,12576,12576,
     3  12240,12264,11568,11568,11112,10584,11160,11160,11496,11496,
     4  12288,12264,12624,12624,12744,12936,12936,12720,12744,12984,
     5  13104,13536,13680,13776,14280,14568,14688,14760,14976,15048,
     6  11736,11808,11808,11904,11808,11880,12168,12216,12456,12528,
     7  12648,12624,13008,13128,13248,13536,13536,13776,13752,13632,
     8  13632,13392,13392,12768,13080,13032,13128,13128,13368,13320,
     9  10944,12096,11928,11088,10896,10896,11112,11136,10968,11064/
            data (jy(i),i= 1201, 1300)/
     +  12216,11832,11856,11760, 9528,11592,11568,11856,10872,10872,
     1  10608,10704,10944,11064,11184,11352,11352,11592,11664,11088,
     2  10392,10344, 9648,11112,11016,10680,10800,10704,10296, 9912,
     3   9696, 9744, 9672, 9960, 9984, 9552, 9480, 9960, 9984,10680,
     4  10776,10824, 9528, 9288, 9312,10584, 9336, 9192, 9144, 8568,
     5   8544,23064,22896,22968,22944,23016,22776,22776,22872,22872,
     6  22944,20352,20400,19800,19848,19704,19728,10704,10800,10968,
     7  11184,11424,11616,11856,12072,12168,11976,11880,12288,12024,
     8  11664,11472,11328,11328,11448,11400,11520,11640,10656,10776,
     9  10752,10632, 7992, 8160, 8496, 8928, 9360, 9528, 9936,10128/
            data (jy(i),i= 1301, 1310)/
     +  10248,10368,10512,10512,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,   23,    2,    2,    1,    3,    7,   25,   26,   27,
     1     28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
     2     38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
     3     48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
     4     58,   59,   60,   61,   62,   63,   64,   65,   66,   67,
     5     68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
     6     78,    4,    5,    9,   80,   81,   82,   83,   84,   85,
     7     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     8     96,   97,   98,   99,  100,  101,    7,    9,  103,  104,
     9    105,  106,  107,  108,  109,  110,  111,  112,  113,  114/
            data (jb1(i),i=  101,  200)/
     +    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     1    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     2    135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
     3    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     4    155,  156,  157,  158,  159,  160,  161,   11,    6,   10,
     5    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     6    173,  174,  175,  176,  177,  178,  179,  180,    8,   12,
     7    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     8    192,  193,  194,  195,  196,  197,   10,   15,  199,  200,
     9    201,  202,  203,  204,  205,  206,  207,  208,  209,  210/
            data (jb1(i),i=  201,  300)/
     +    211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
     1    221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
     2    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     3    241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
     4    251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
     5    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     6    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     7    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     8    291,  292,  293,  294,   11,   12,  296,  297,  298,  299,
     9    300,  301,  302,  303,  304,  305,  306,  307,  308,   13/
            data (jb1(i),i=  301,  400)/
     +     16,  310,  311,  312,  313,  314,  315,  316,  317,  318,
     1    319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
     2    329,  330,  331,  332,  333,  334,  335,  336,   13,   14,
     3    338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
     4    348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
     5    358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
     6    368,  369,  370,   15,   14,  372,  373,  374,  375,  376,
     7    377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
     8    387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
     9    397,  398,  399,  400,  401,  402,  403,  404,  405,  406/
            data (jb1(i),i=  401,  500)/
     +     17,  408,  409,  410,  411,  412,  413,  414,  415,  416,
     1    417,   16,   18,  419,  420,   17,   19,  422,   18,  407,
     2    424,  426,  425,   22,   21,   20,   21,   19,    1,  429,
     3    430,    3,  431,  432,  433,  434,    4,  436,  437,  438,
     4    439,  440,  441,  435,  435,  443,  444,  445,  446,  447,
     5    448,  449,  450,  451,  452,  453,  443,  454,  455,  456,
     6    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     7    467,  454,  467,  468,  469,  470,  471,  472,  469,  474,
     8    475,  476,  477,  478,  479,  473,  477,  481,  482,  483,
     9    484,  485,  486,  487,  488,  489,  490,  491,  492,  493/
            data (jb1(i),i=  501,  600)/
     +    494,  495,  473,  496,  497,  498,  499,  500,  501,  502,
     1    503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
     2    513,  514,  515,  516,  517,  518,  519,  520,  521,  522,
     3    523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
     4    533,  477,  507,  535,  536,  537,  538,  539,  540,  541,
     5    542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
     6    552,  553,  554,  555,  556,  557,  558,   12,  559,  560,
     7    561,  562,  563,  564,  565,  566,  567,  568,  569,  570,
     8    571,  572,  539,  574,  575,  576,  577,  578,  579,  580,
     9    581,  582,  583,  584,  585,  586,  587,  588,  539,  590/
            data (jb1(i),i=  601,  700)/
     +    591,  592,  593,  594,  595,  596,  597,  598,  599,  600,
     1    601,  602,  603,  604,  605,  606,  567,   13,  608,  609,
     2    610,  611,  612,  613,  614,  615,  616,  617,  618,  620,
     3    621,  622,  623,  624,  625,  626,  627,  628,  629,  630,
     4    631,  632,  633,  634,  635,  636,  637,  638,  639,  640,
     5    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     6    651,  652,  653,  654,  655,  656,  657,  658,  659,  660,
     7    661,  662,  663,  664,  665,  666,  667,  668,  669,  670,
     8    671,  672,  673,  674,  675,  676,  677,  678,  574,  680,
     9    681,  682,  683,  684,  685,  686,  687,  688,  689,  690/
            data (jb1(i),i=  701,  800)/
     +    691,  692,  693,  694,  695,  696,  697,  698,  699,  700,
     1    701,  702,  703,  704,  705,  574,  707,  708,  709,  710,
     2    711,  712,  713,  714,  715,  716,  619,  717,  718,  719,
     3    590,  721,  722,  723,  724,  619,   15,  726,  727,  620,
     4    729,  730,  731,  732,  733,  734,  735,  736,  737,  738,
     5    739,  740,  741,  742,  743,  744,  745,  746,  747,  748,
     6    749,  750,  751,  752,  753,  754,  755,  756,  757,  758,
     7    759,  760,  761,  680,  620,  763,  764,  765,  766,  767,
     8    768,  769,  770,  771,  772,  773,  774,  775,  776,  777,
     9    778,  779,  780,  781,  782,  783,  590,  785,  786,  787/
            data (jb1(i),i=  801,  900)/
     +    788,  789,  790,  791,  792,  793,  794,  795,  796,  797,
     1    680,  799,  728,  721,  801,  802,  788,  707,  799,  805,
     2    806,  707,  808,  809,  810,  811,  812,  813,  814,  815,
     3    816,  817,  818,  819,  820,  821,  822,  823,  824,  825,
     4    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     5    836,  837,  838,  839,  840,  841,  842,  843,  729,  721,
     6    845,  846,  847,  848,  849,  850,  852,  853,  854,  855,
     7    856,  857,  858,  859,  860,  805,  862,  863,  864,  865,
     8    866,  867,  868,  869,  870,  871,  805,  784,  873,  874,
     9    875,  876,  877,  878,  879,  880,  881,  882,  883,  884/
            data (jb1(i),i=  901, 1000)/
     +    885,  886,  887,  888,  889,  890,  891,  892,  893,  894,
     1    895,  896,  897,  898,  899,  900,  901,  902,  903,  904,
     2    905,  906,  729,  907,  908,  909,  851,  911,  912,  913,
     3    914,  915,  916,  917,  918,  919,  920,  921,  922,  923,
     4    924,  925,  926,  927,  928,  929,  930,  931,  932,  933,
     5    934,  935,  936,  937,  938,  939,  940,  941,  942,  943,
     6    944,  945,  946,  947,  948,  949,  950,  951,  952,  953,
     7    954,  955,  956,  957,  958,  959,  960,  910,  801,  851,
     8    963,  964,  965,  966,  967,  968,  969,  970,  971,  972,
     9    910,  974,  975,  976,  977,  962,  801,  979,  980,  981/
            data (jb1(i),i= 1001, 1100)/
     +    982,  983,  984,  985,  986,  987,  988,  989,  990,  862,
     1    799,  992,  808,  992,  996,  997,  998,  999, 1000, 1001,
     2    995,  996, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010,
     3   1011, 1012, 1013, 1014, 1015,  784, 1017, 1019, 1018,  994,
     4   1019,  991, 1022, 1023, 1017, 1023, 1025,  995, 1027, 1028,
     5   1029, 1030, 1031, 1032, 1033, 1034,  974, 1036, 1037, 1038,
     6   1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048,
     7   1026, 1049, 1050, 1051, 1052, 1053,  974, 1055, 1056, 1057,
     8   1058,  921,  921,  963, 1055, 1061, 1062, 1063,  996, 1066,
     9   1067, 1068, 1069, 1070, 1071, 1065, 1073,  963, 1035, 1076/
            data (jb1(i),i= 1101, 1200)/
     +   1077, 1065, 1076, 1079, 1080, 1075, 1082, 1083, 1084, 1085,
     1   1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095,
     2   1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105,
     3   1106, 1107, 1108, 1109, 1110, 1026, 1060, 1076, 1113, 1114,
     4   1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123, 1124,
     5   1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134,
     6   1136, 1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145,
     7   1146, 1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155,
     8   1156, 1157, 1158, 1159, 1075, 1161, 1162, 1163, 1164, 1165,
     9   1166, 1167, 1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175/
            data (jb1(i),i= 1201, 1300)/
     +   1176, 1177, 1073, 1073, 1179, 1180, 1181, 1182, 1082, 1064,
     1   1184, 1185, 1186, 1187, 1188, 1112, 1161, 1112, 1064, 1059,
     2   1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1191, 1059,
     3   1201, 1202, 1203, 1066, 1205, 1206, 1207, 1066, 1082, 1209,
     4   1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1161,
     5   1135, 1220, 1221, 1222, 1205, 1191, 1135, 1224, 1225, 1226,
     6   1227, 1228, 1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236,
     7     20, 1238, 1239, 1240, 1241, 1209, 1237, 1243, 1244, 1245,
     8   1136, 1205, 1237, 1247, 1248, 1249, 1250, 1251,  406, 1252,
     9   1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260,  852,  852/
            data (jb1(i),i= 1301, 1350)/
     +    862, 1262, 1263, 1264, 1265, 1266,  407, 1035, 1268, 1269,
     1   1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277, 1278, 1279,
     2   1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287,  425, 1268,
     3   1289, 1290, 1291, 1136,  426, 1293, 1294, 1295, 1296, 1297,
     4   1298, 1299, 1300, 1301, 1302, 1303, 1268,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     23,   24,   24,    4,    3,    5,   25,   26,   27,   28,
     1     29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
     2     39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     3     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     4     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     5     69,   70,   71,   72,   73,   74,   75,   76,   77,   78,
     6     79,   79,    6,   80,   81,   82,   83,   84,   85,   86,
     7     87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     8     97,   98,   99,  100,  101,  102,  102,  103,  104,  105,
     9    106,  107,  108,  109,  110,  111,  112,  113,  114,  115/
            data (jb2(i),i=  101,  200)/
     +    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     1    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     2    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     3    146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
     4    156,  157,  158,  159,  160,  161,  162,  162,    8,  163,
     5    164,  165,  166,  167,  168,  169,  170,  171,  172,  173,
     6    174,  175,  176,  177,  178,  179,  180,  181,  181,  182,
     7    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     8    193,  194,  195,  196,  197,  198,  198,  199,  200,  201,
     9    202,  203,  204,  205,  206,  207,  208,  209,  210,  211/
            data (jb2(i),i=  201,  300)/
     +    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     1    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     2    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     3    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     4    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     5    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     6    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     7    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     8    292,  293,  294,  295,  295,  296,  297,  298,  299,  300,
     9    301,  302,  303,  304,  305,  306,  307,  308,  309,  309/
            data (jb2(i),i=  301,  400)/
     +    310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
     1    320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
     2    330,  331,  332,  333,  334,  335,  336,  337,  337,  338,
     3    339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
     4    349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
     5    359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
     6    369,  370,  371,  371,  372,  373,  374,  375,  376,  377,
     7    378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
     8    388,  389,  390,  391,  392,  393,  394,  395,  396,  397,
     9    398,  399,  400,  401,  402,  403,  404,  405,  406,  407/
            data (jb2(i),i=  401,  500)/
     +    408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     1    418,  418,  419,  420,  421,  421,  422,  423,  423,  424,
     2    425,  427,  427,  426,   22,  428,  428,   20,  429,  430,
     3      2,  431,  432,  433,  434,  435,  436,  437,  438,  439,
     4    440,  441,  442,  442,  443,  444,  445,  446,  447,  448,
     5    449,  450,  451,  452,  453,    5,  454,  455,  456,  457,
     6    458,  459,  460,  461,  462,  463,  464,  465,  466,    6,
     7      7,  467,  468,  469,  470,  471,  472,  473,  474,  475,
     8    476,    8,  478,  479,  480,  480,  481,  482,  483,  484,
     9    485,  486,  487,  488,  489,  490,  491,  492,  493,  494/
            data (jb2(i),i=  501,  600)/
     +    495,    9,  496,  497,  498,  499,  500,  501,  502,  503,
     1    504,  505,  506,  507,  508,  509,  510,  511,  512,  513,
     2    514,  515,  516,  517,  518,  519,  520,  521,  522,  523,
     3    524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
     4    534,  534,  535,  536,  537,  538,   10,  540,  541,  542,
     5    543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
     6    553,  554,  555,  556,  557,  558,   11,  559,  560,  561,
     7    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     8    572,  573,  573,  575,  576,  577,  578,  579,  580,  581,
     9    582,  583,  584,  585,  586,  587,  588,  589,  589,  591/
            data (jb2(i),i=  601,  700)/
     +    592,  593,  594,  595,  596,  597,  598,  599,  600,  601,
     1    602,  603,  604,  605,  606,  607,  607,  608,  609,  610,
     2    611,  612,  613,  614,  615,  616,  617,  618,  619,  621,
     3    622,  623,  624,  625,  626,  627,  628,  629,  630,  631,
     4    632,  633,  634,  635,  636,  637,  638,  639,  640,  641,
     5    642,  643,  644,  645,  646,  647,  648,  649,  650,  651,
     6    652,  653,  654,  655,  656,  657,  658,  659,  660,  661,
     7    662,  663,  664,  665,  666,  667,  668,  669,  670,  671,
     8    672,  673,  674,  675,  676,  677,  678,  679,  679,  681,
     9    682,  683,  684,  685,  686,  687,  688,  689,  690,  691/
            data (jb2(i),i=  701,  800)/
     +    692,  693,  694,  695,  696,  697,  698,  699,  700,  701,
     1    702,  703,  704,  705,  706,  706,  708,  709,  710,  711,
     2    712,  713,  714,  715,  716,   14,  717,  718,  719,  720,
     3    720,  722,  723,  724,  725,  725,  726,  727,  728,  728,
     4    730,  731,  732,  733,  734,  735,  736,  737,  738,  739,
     5    740,  741,  742,  743,  744,  745,  746,  747,  748,  749,
     6    750,  751,  752,  753,  754,  755,  756,  757,  758,  759,
     7    760,  761,  762,  762,  763,  764,  765,  766,  767,  768,
     8    769,  770,  771,  772,  773,  774,  775,  776,  777,  778,
     9    779,  780,  781,  782,  783,  784,  785,  786,  787,  788/
            data (jb2(i),i=  801,  900)/
     +    789,  790,  791,  792,  793,  794,  795,  796,  797,  798,
     1    798,  800,  800,   16,  802,  803,  803,  804,  804,  806,
     2    807,  807,  809,  810,  811,  812,  813,  814,  815,  816,
     3    817,  818,  819,  820,  821,  822,  823,  824,  825,  826,
     4    827,  828,  829,  830,  831,  832,  833,  834,  835,  836,
     5    837,  838,  839,  840,  841,  842,  843,  844,  844,  845,
     6    846,  847,  848,  849,  850,  851,  853,  854,  855,  856,
     7    857,  858,  859,  860,  861,  861,  863,  864,  865,  866,
     8    867,  868,  869,  870,  871,  872,  872,  873,  874,  875,
     9    876,  877,  878,  879,  880,  881,  882,  883,  884,  885/
            data (jb2(i),i=  901, 1000)/
     +    886,  887,  888,  889,  890,  891,  892,  893,  894,  895,
     1    896,  897,  898,  899,  900,  901,  902,  903,  904,  905,
     2    906,  907,  907,  908,  909,  910,  911,  912,  913,  914,
     3    915,  916,  917,  918,  919,  920,   17,  922,  923,  924,
     4    925,  926,  927,  928,  929,  930,  931,  932,  933,  934,
     5    935,  936,  937,  938,  939,  940,  941,  942,  943,  944,
     6    945,  946,  947,  948,  949,  950,  951,  952,  953,  954,
     7    955,  956,  957,  958,  959,  960,  961,  961,  962,  962,
     8    964,  965,  966,  967,  968,  969,  970,  971,  972,  973,
     9    973,  975,  976,  977,  978,  978,  979,  980,  981,  982/
            data (jb2(i),i= 1001, 1100)/
     +    983,  984,  985,  986,  987,  988,  989,  990,  991,  992,
     1    993,  993,  994,  995,  997,  998,  999, 1000, 1001, 1002,
     2   1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011,
     3   1012, 1013, 1014, 1015, 1016, 1016, 1018, 1020, 1020, 1021,
     4   1021, 1022, 1023, 1024, 1024, 1025, 1026, 1027, 1028, 1029,
     5   1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039,
     6   1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048,   18,
     7   1049, 1050, 1051, 1052, 1053, 1054, 1054, 1056, 1057, 1058,
     8   1059, 1055, 1060, 1060, 1061, 1062, 1063, 1064, 1065, 1067,
     9   1068, 1069, 1070, 1071, 1072, 1072, 1074, 1074, 1075, 1077/
            data (jb2(i),i= 1101, 1200)/
     +   1078, 1078, 1079, 1080, 1081, 1081, 1083, 1084, 1085, 1086,
     1   1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096,
     2   1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106,
     3   1107, 1108, 1109, 1110, 1111, 1111, 1112, 1113, 1114, 1115,
     4   1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125,
     5   1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135,
     6   1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146,
     7   1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156,
     8   1157, 1158, 1159, 1160, 1160, 1162, 1163, 1164, 1165, 1166,
     9   1167, 1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175, 1176/
            data (jb2(i),i= 1201, 1300)/
     +   1177, 1178, 1178, 1179, 1180, 1181, 1182, 1183, 1183, 1184,
     1   1185, 1186, 1187, 1188, 1189, 1189, 1190, 1190, 1191, 1192,
     2   1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1200, 1201,
     3   1202, 1203, 1204, 1204, 1206, 1207, 1208, 1208,   19, 1210,
     4   1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219, 1219,
     5   1220, 1221, 1222, 1223, 1223, 1209, 1224, 1225, 1226, 1227,
     6   1228, 1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237,
     7   1238, 1239, 1240, 1241, 1242, 1242, 1243, 1244, 1245, 1246,
     8   1246,   21, 1247, 1248, 1249, 1250, 1251,   22, 1252, 1253,
     9   1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261, 1261, 1262/
            data (jb2(i),i= 1301, 1350)/
     +   1262, 1263, 1264, 1265, 1266, 1267, 1267,  424, 1269, 1270,
     1   1271, 1272, 1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280,
     2   1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288, 1288, 1289,
     3   1290, 1291, 1292, 1292, 1293, 1294, 1295, 1296, 1297, 1298,
     4   1299, 1300, 1301, 1302, 1303, 1304, 1304,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine il(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1050) :: jx,jy
            integer(kind=iknd), save, dimension(1150) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'illinois      '/
            data jrot,ipart/0,1/
            data kv/   1,1047,   0,   0,   0/
            data kb/   1,1148,   0,   0,   0/
            data iib/ 439,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  25152,28200,32064,35496,37200,40968,44184,26280,25560,45864,
     1  19176,45840,19968,45840,18000,45792,15336,45720,16200,45696,
     2  19320,44952,22944,24264,45672,24912,44712,42048,24216,24528,
     3  41208,28608,29784,40896,38568,30048,37920,34440,32448,24792,
     4  24504,24408,24504,24120,23544,23448,23088,22848,22824,22920,
     5  43872,43920,43848,43776,43728,43632,43632,43776,43824,43944,
     6  25920,26040,26256,26304,26256,26448,26352,26232,26304,26040,
     7  26016,25176,25008,24984,24864,24768,24744,24240,23880,23664,
     8  23160,22896,22776,22704,22320,21624,20904,20304,19848,19464,
     9  19416,19344,19224,45888,45840,45768,45672,45576,45528,45576/
            data (jx(i),i=  101,  200)/
     +  45528,45528,45312,45264,45312,45240,45240,45264,45360,45192,
     1  45216,45072,45144,44976,44784,44448,19152,18816,18936,19008,
     2  19176,19248,19392,19560,19704,19992,18408,18552,18600,18792,
     3  18768,18792,19056,19464,19800,19896,19872,19992,15360,15480,
     4  15456,15768,16008,16416,16488,16392,16560,16440,16200,16272,
     5  16752,17016,17496,16200,16032,15720,15624,15648,15864,15336,
     6  15360,15240,15264,19248,18888,18600,18432,18168,18024,17712,
     7  17616,17544,17160,16824,16248,16152,45696,45624,45504,45312,
     8  45120,45024,45168,45096,45216,45336,45384,45336,45120,45024,
     9  45000,44832,23448,23904,22776,22536,22104,21912,21528,21264/
            data (jx(i),i=  201,  300)/
     +  21192,21192,20928,21144,21192,21000,20904,20376,19920,19416,
     1  45504,45648,45576,45768,45696,45768,45744,45816,45624,45312,
     2  45408,45312,45408,45312,45360,45192,45000,45048,44808,44736,
     3  44760,44904,44712,44760,24696,24696,25104,25440,25560,25488,
     4  24888,24672,44784,44832,45000,44904,44952,45072,45120,45672,
     5  45768,45936,45888,45912,45792,45912,45912,45696,45744,24888,
     6  24768,24408,42096,42264,42312,42384,42336,42456,42576,42672,
     7  42600,42672,42960,43032,43032,43080,43176,43272,43320,43464,
     8  43728,43968,43992,44088,43920,43920,44016,44256,44424,44544,
     9  44640,44736,44736,44568,44688,24264,23976,23688,23544,23376/
            data (jx(i),i=  301,  400)/
     +  23280,23304,23448,24000,41256,41424,41736,41808,41760,41424,
     1  41376,41448,41568,41664,41664,41832,41712,41856,41640,41592,
     2  41640,41928,42240,42288,42240,41856,41808,41904,42096,42192,
     3  42360,42600,42552,42432,42408,42240,42120,28344,28056,27744,
     4  27576,27336,27216,26880,26544,26304,26352,26568,26544,26088,
     5  25704,25272,25152,40800,40656,40656,40944,41472,41616,41688,
     6  41640,41400,41256,41232,41280,41568,41688,41712,41400,28752,
     7  28656,28680,29064,29256,29736,29880,29856,30096,30144,30096,
     8  29856,41280,41328,41304,41184,39528,39288,39072,38976,38688,
     9  29808,30000,30384,30528,30432,29808,29736,29880,30192,30120/
            data (jx(i),i=  401,  500)/
     +  30192,30432,30816,30744,31320,31488,31584,31728,31752,31656,
     1  31392,31344,31824,31920,32208,32256,32424,32736,32568,32400,
     2  32376,38328,38088,38016,37752,37776,38280,38448,38376,38160,
     3  33960,33576,33216,32928,37488,36840,36264,35976,35472,28152,
     4  29856,31992,35400,33672,33672,37128,38016,40896,40608,40608,
     5  40416,40392,29784,30216,30192,35328,32208,32208,31896,31800,
     6  31704,31752,31704,31464,31392,31296,40368,25536,25584,25536,
     7  25608,25536,25656,25584,26136,26040,26136,26064,25896,37992,
     8  37896,37800,42984,42984,42576,42096,42096,35304,37824,28368,
     9  30096,33576,33552,43896,43872,43008,42984,42096,40416,37824/
            data (jx(i),i=  501,  600)/
     +  23976,24048,24480,24528,24600,24768,24936,25008,25488,25680,
     1  25824,25944,33528,28296,42168,42168,40440,23856,27264,28200,
     2  28176,29928,29904,31200,31224,32064,32208,32208,32712,21216,
     3  33480,32160,32088,32184,32256,40440,40368,37824,23832,27216,
     4  29856,41256,40392,31104,31224,31320,34344,34344,34296,34296,
     5  35232,35184,30888,30432,30384,30456,35160,23640,27120,20136,
     6  21000,23592,37800,37824,38712,40416,34728,34728,34272,34272,
     7  33840,33816,33576,33576,32544,32112,32112,32544,27936,28704,
     8  28944,29256,29376,29496,29616,29592,29928,29952,30408,30480,
     9  27072,27960,42672,41280,27864,27816,27648,27528,27288,27024/
            data (jx(i),i=  601,  700)/
     +  26592,26496,26376,26328,26040,25896,25632,25488,25296,38664,
     1  42696,29928,29064,29088,19920,32520,23424,42696,42600,42600,
     2  33384,32520,37776,38640,19872,23400,24120,24264,24480,24768,
     3  25224,25296,19824,29880,29664,29376,29232,29184,28920,28728,
     4  28488,28296,27816,27624,27552,27504,27408,27240,27096,27024,
     5  26952,26928,26976,26856,26832,26832,26784,26736,26592,26568,
     6  26520,26472,26424,26328,26184,26136,26088,26016,25848,25776,
     7  25656,25536,25368,25320,25176,25080,25032,24864,24792,24600,
     8  24576,24480,24504,24408,24240,24168,33360,36888,36864,36432,
     9  36432,23928,23784,23520,23448,22920,22824,21480,21384,21504/
            data (jx(i),i=  701,  800)/
     +  21648,21624,21720,21792,21960,22128,22152,22056,22056,22176,
     1  22128,22608,22728,22728,29880,30048,30024,22248,22608,22656,
     2  22824,26808,32760,31344,31320,30720,30744,29112,29064,28536,
     3  28536,33336,26784,19680,22320,22248,38544,45360,45528,45096,
     4  45096,22104,22344,32736,19632,36360,38472,38544,42600,42360,
     5  42360,34200,33288,33312,32976,36288,36264,35856,35832,38448,
     6  41592,41616,36360,35832,36528,36528,36528,22032,21696,22152,
     7  22200,22128,22992,22968,23832,23784,24072,24072,24336,24288,
     8  25416,26760,26832,26832,27240,27192,28944,30240,30240,30672,
     9  30696,31104,31128,31200,31392,31584,31608,31632,31872,31872/
            data (jx(i),i=  801,  900)/
     +  32064,32064,32184,32184,32400,32472,36528,37176,37104,37104,
     1  36528,38424,37536,37536,37416,37392,37248,37248,42384,44496,
     2  44520,21888,21816,41952,41952,38400,33216,30192,34128,25368,
     3  33192,35784,38400,42432,41976,39240,38400,24960,24960,24096,
     4  24072,22752,22656,22536,22152,22128,22080,22008,22032,21936,
     5  21936,21792,21768,21888,21816,21888,21912,21744,44736,44736,
     6  44016,44016,32328,32280,25320,28800,29256,29688,29664,22752,
     7  22392,22224,21960,22008,21888,21936,24312,36600,35736,39192,
     8  39984,39168,42432,42744,36576,32184,29232,29520,29520,33096,
     9  33120,28632,29496,36504,39960,39744,39744,39840,39624,39720/
            data (jx(i),i=  901, 1000)/
     +  39720,39816,39816,39984,39984,40824,40824,42336,42672,33000,
     1  33000,36456,28584,31800,31320,31224,31176,30888,30720,30312,
     2  30240,30240,30096,29952,29832,29664,29664,29376,29184,29160,
     3  29040,28896,28872,28824,28776,28656,28632,36408,42336,42432,
     4  42336,42408,42360,42240,42168,42216,42120,42264,42288,42336,
     5  42336,42312,42120,42144,42024,42000,39024,40752,41712,25128,
     6  25128,25944,25944,26904,26976,26904,26856,26904,26832,26808,
     7  26904,27024,27000,28512,29400,32880,32856,33000,34752,34464,
     8  36360,25920,25896,29304,32952,33096,33072,32904,32880,32928,
     9  32856,32712,32592,36336,38952,41136,41040,40848,40824,32808/
            data (jx(i),i= 1001, 1050)/
     +  32784,28728,28608,36312,32712,38928,36264,30384,30216,29952,
     1  29904,33600,38616,40368,40536,40632,33552,31920,36216,34680,
     2  34704,34464,33528,33792,34152,34176,37920,32112,32208,32232,
     3  32184,32088,31920,31824,31728,31824,31704,31704,31776,31776,
     4  31704,31632,31776,31920,31920,32304,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  58800,61776,61608,61488,61440,61392,57912,56088,54648,51072,
     1  50424,49344,47760,46512,43512,41304,39264,35232,34800,31176,
     2  31080,28008,26616,26136,24960,23448,22128,19032,22080,17760,
     3  15480,14808,12432,12216,10776,10080, 7200, 8880, 7344,58968,
     4  59328,59688,60120,60672,61056,61272,61464,61656,61848,62016,
     5  61320,60960,60240,60024,60048,59424,59232,58656,58656,58272,
     6  58392,58104,58032,57960,57288,56856,56568,56376,55920,55248,
     7  54864,54408,54192,53784,53664,53352,52752,52536,52152,52056,
     8  52152,52056,51984,51816,51528,51456,51552,51264,51360,51288,
     9  51240,50928,50712,53496,53832,53952,53976,54144,54144,54192/
            data (jy(i),i=  101,  200)/
     +  54216,54336,54744,54912,55032,55056,55152,55272,55296,55392,
     1  55488,55944,55992,56184,57048,57456,50184,49536,49320,49104,
     2  48936,48768,48696,48720,48624,48024,43752,43920,44448,44904,
     3  45192,45336,45552,46080,46296,46608,46824,47256,39648,39816,
     4  39984,40704,40968,41088,41184,41568,42192,42480,42696,42888,
     5  43272,43368,43536,35184,35424,35616,35904,36144,36480,37560,
     6  37848,38544,39024,31176,31344,31584,31776,32448,32544,32616,
     7  32784,33144,33408,33840,34392,34584,29928,29952,29832,29832,
     8  29544,29496,29448,29280,28920,28992,28944,28536,28296,28296,
     9  28176,28080,26496,26208,26544,26064,25680,25656,25896,26280/
            data (jy(i),i=  201,  300)/
     +  26568,26904,27504,27888,28056,28488,29496,30144,30576,30936,
     1  25080,25248,25392,25488,25584,25704,25848,25968,26184,26328,
     2  26376,26448,26640,26832,27000,27240,27288,27480,27504,27552,
     3  27600,27600,27768,27936,23928,24096,24600,24840,25248,25368,
     4  25752,25968,22200,22368,22320,22512,22848,22920,23088,23328,
     5  23592,23856,23928,24096,24144,24216,24288,24624,24696,23016,
     6  22800,22440,19056,18888,19032,19080,19224,19416,19464,19440,
     7  19224,19152,19584,19536,19296,19224,19248,19440,19896,20064,
     8  20184,20520,20808,20952,21000,21144,21240,21264,21336,21528,
     9  21480,21528,21624,21888,22008,18024,18552,18720,18888,19272/
            data (jy(i),i=  301,  400)/
     +  19704,20136,20568,21288,15576,15456,15408,15456,15624,15672,
     1  15720,15840,15744,15792,16056,16200,16584,16776,16824,16920,
     2  16992,17016,17184,17328,17496,17328,17472,17544,17568,17784,
     3  17784,18072,18168,18096,18240,18312,18456,14976,15312,15432,
     4  15648,15816,15792,15504,15576,16032,16128,16320,16416,16488,
     5  16920,17160,17448,12360,12864,13176,13608,13944,14184,14472,
     6  14592,14544,14640,14784,14832,14736,14784,14880,15072,14592,
     7  14328,14256,14136,13872,13704,13608,13104,12792,12600,12528,
     8  12528,11808,11688,11448,11280,11016,10896,10632,10584,10776,
     9  12144,11640,11088,10632,10176, 9840, 9480, 9264, 9192, 8880/
            data (jy(i),i=  401,  500)/
     +   8568, 8064, 7608, 7152, 6768, 6576, 6552, 6696, 6864, 6984,
     1   7152, 7320, 7296, 7080, 6840, 6432, 6360, 6480, 6624, 6888,
     2   7152,10704,10464,10008, 9384, 9192, 8544, 8040, 7776, 7392,
     3   8904, 8712, 8352, 7848, 7224, 7728, 7968, 8016, 8424,58704,
     4  58680,58632,58056,58608,58080,58032,58008,57960,57960,57096,
     5  57096,56304,55968,55944,55656,55440,55488,55608,55608,55464,
     6  55536,55608,55680,55728,55728,55656,53664,54456,54456,54336,
     7  54072,53856,53712,53616,53256,53184,53088,52752,52656,57120,
     8  57144,53664,56328,53568,53280,53280,53688,52800,52800,52560,
     9  52512,52848,52416,51096,51984,51960,52824,52824,51072,51024/
            data (jy(i),i=  501,  600)/
     +  50136,51432,51648,51840,51912,51960,51912,51984,52056,52176,
     1  52200,52488,49656,49056,49344,48480,48456,48408,48240,49056,
     2  48216,48984,48144,48120,48960,48936,49368,49584,49800,47688,
     3  47616,47640,47688,47784,48096,47592,47592,47568,47520,46512,
     4  46416,46392,46368,45840,45960,46368,47592,47160,47136,45816,
     5  47592,45816,45384,44664,44448,44136,44064,44040,43872,43416,
     6  43344,43176,44040,42648,42624,42624,44088,43200,43200,42840,
     7  42816,42696,42696,42552,42552,44088,42768,42768,41856,42240,
     8  42216,42312,42192,42288,42456,42672,43128,43296,43680,43848,
     9  43032,42984,41280,41304,41784,41496,41232,41112,40992,40704/
            data (jy(i),i=  601,  700)/
     +  40464,40056,39936,39720,39384,39072,38976,38784,38640,40440,
     1  40416,39888,39888,41064,39864,39864,39672,38664,38664,35208,
     2  39408,39432,39312,39288,38976,38808,38112,38232,38256,38400,
     3  38328,38400,38088,37896,38208,38304,38232,38112,38136,37968,
     4  38016,37944,38088,38040,38136,38088,38160,38064,38208,38040,
     5  38040,37968,37920,37872,37896,37800,37872,37776,37824,37896,
     6  37824,37872,37776,37800,37608,37632,37584,37608,37560,37440,
     7  37488,37416,37464,37368,37416,37344,37416,37416,37488,37416,
     8  37560,37632,37680,38016,38088,38040,37080,37944,37512,37512,
     9  37080,38064,37680,37512,37128,36912,36768,38016,37872,37752/
            data (jy(i),i=  701,  800)/
     +  37752,37440,37416,37320,37224,37248,37176,37152,37104,36960,
     1  36768,36768,36768,36816,37608,37608,36432,35688,36120,36312,
     2  36600,35808,35760,35832,35952,35976,36432,36456,35856,35880,
     3  35736,35736,35496,35496,35328,35472,35256,35232,35112,35088,
     4  35208,34824,35208,34704,34608,34416,34392,34392,34344,34368,
     5  33312,33096,33120,34560,34752,34416,33936,33936,33072,33000,
     6  33288,32976,32304,32328,32256,32304,31992,34608,34008,32592,
     7  32448,32160,34800,34440,34416,33528,33528,33240,33240,32064,
     8  32016,34632,34632,33960,32352,31992,31944,31920,33072,33048,
     9  33504,33480,34248,34104,34080,34224,34200,34320,34248,34320/
            data (jy(i),i=  801,  900)/
     +  34344,34488,34512,34584,34656,34824,31776,31584,31584,31704,
     1  31728,30960,30984,31272,31272,31416,31416,31584,31272,31176,
     2  31296,31536,30912,31272,30240,30240,30072,30144,30024,29448,
     3  28776,28704,28632,28200,28200,28200,28224,29424,29112,29136,
     4  28632,28680,28536,28776,28800,28872,28728,28800,28632,28560,
     5  28416,28176,30600,29880,29544,29352,28968,28584,28008,28152,
     6  28152,28224,28776,26880,26808,26712,26712,26976,26688,26616,
     7  26496,26592,27048,27240,27456,27600,26856,25680,25656,25608,
     8  24960,25008,24960,24960,24792,24048,25464,25440,24120,23976,
     9  24840,23304,23256,22608,23784,23760,23304,23136,22848,22752/
            data (jy(i),i=  901, 1000)/
     +  22680,22680,22632,22536,22488,22464,22176,22152,22152,21648,
     1  21360,21288,20928,21720,21840,21672,21696,21576,21648,21408,
     2  21480,21432,21432,21528,21456,21504,21552,21480,21360,21240,
     3  21168,21192,21072,21096,21000,21000,20904,19128,21912,21816,
     4  21648,21072,20688,20616,20472,20400,20304,19968,19704,19680,
     5  19584,19392,19296,19224,19224,19080,19080,19056,19032,21120,
     6  20952,20064,19920,19872,19632,19560,19584,19656,19656,19560,
     7  19176,19104,19008,18936,18912,18768,17904,17880,17856,17856,
     8  17808,19056,18192,16272,17664,17592,17256,17112,16968,16824,
     9  16488,16224,16152,15648,15624,15408,15552,15672,15624,16152/
            data (jy(i),i= 1001, 1050)/
     +  15288,15072,14976,15216,12648,12552,12576,12696,12336,12432,
     1  12480,12600,12552,12528,12456,12288, 9936,10032, 9960, 9960,
     2   9816, 9672, 9576, 9744, 9648, 9600, 8112, 9984, 9888, 9648,
     3   9480, 9480, 9336, 9000, 8928, 8568, 8472, 8304, 8280, 8184,
     4   8040, 7872, 7608, 7608, 7536, 7488,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     1     49,    2,    2,    3,    4,    5,    6,   51,   52,   53,
     2     54,   55,   56,   57,   58,   59,    7,    1,   61,   62,
     3     63,   64,   65,   66,   67,    8,    8,   69,   70,    9,
     4      9,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     5     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     6     91,   92,   11,   10,   94,   95,   96,   97,   98,   99,
     7    100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
     8    110,  111,  112,  113,  114,  115,    7,   10,   11,  117,
     9    118,  119,  120,  121,  122,  123,  124,  125,   13,   12/
            data (jb1(i),i=  101,  200)/
     +     15,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     1    136,  137,   13,   14,   17,  139,  140,  141,  142,  143,
     2    144,  145,  146,  147,  148,  149,  150,  151,  152,   15,
     3     16,   19,  154,  155,  156,  157,  158,  159,  160,  161,
     4    162,   17,   18,   21,  164,  165,  166,  167,  168,  169,
     5    170,  171,  172,  173,  174,  175,   19,   20,  177,  178,
     6    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     7    189,  190,  191,   22,   23,  193,   24,   23,  195,  196,
     8    197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
     9    207,  208,  209,   21,   25,  211,  212,  213,  214,  215/
            data (jb1(i),i=  201,  300)/
     +    216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
     1    226,  227,  228,  229,  230,  231,  232,  233,   22,   26,
     2    235,  236,  237,  238,  239,  240,  241,   24,   27,  243,
     3    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     4    254,  255,  256,  257,  258,   25,   26,  260,  261,   29,
     5     28,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     6    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     7    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     8    292,  293,  294,   27,   30,  296,  297,  298,  299,  300,
     9    301,  302,  303,   29,   31,  305,  306,  307,  308,  309/
            data (jb1(i),i=  301,  400)/
     +    310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
     1    320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
     2    330,  331,  332,  333,  334,  335,  336,   28,   32,  338,
     3    339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
     4    349,  350,  351,  352,   30,   34,  354,  355,  356,  357,
     5    358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
     6    368,   31,   32,  370,  371,  372,  373,  374,  375,  376,
     7    377,  378,  379,  380,   33,   34,  382,  383,  384,  385,
     8    386,  387,  388,  389,   35,   33,  391,  392,  393,  394,
     9     36,   36,  396,  397,  398,  399,  400,  401,  402,  403/
            data (jb1(i),i=  401,  500)/
     +    404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
     1    414,  415,  416,  417,  418,  419,  420,   39,   35,  422,
     2    423,  424,  425,  426,  427,  428,  429,   37,   38,  431,
     3    432,  433,   39,   37,  435,  436,  437,  438,   38,  440,
     4    440,  440,    3,  441,    4,  442,  444,  443,    5,  443,
     5    446,    6,  448,  447,  448,  449,  450,  451,  453,  441,
     6    453,  454,  443,  456,  457,  458,  459,  460,  461,  462,
     7    463,  464,  465,  455,  452,    9,  468,  469,  470,  471,
     8    472,  473,  474,  475,  476,  477,  478,  447,  480,  481,
     9    467,  452,  483,  484,  485,  486,  467,  456,  482,  488/
            data (jb1(i),i=  501,  600)/
     +    479,  455,  490,  488,  492,  491,   10,  494,  495,  496,
     1    497,  486,  467,  499,  489,  501,  502,  503,  504,  505,
     2    506,  507,  508,  509,  510,  511,  479,  501,  493,  490,
     3     12,  515,  516,  499,  501,  518,  514,  520,  519,  514,
     4    522,  524,  525,  526,  527,  528,  513,  523,  530,  513,
     5    531,  532,  533,  534,  524,  517,  536,  500,  537,  518,
     6    530,  519,  523,  540,   14,  542,  537,  544,  545,  541,
     7    531,  547,  548,  549,  544,  538,  551,  550,  544,  553,
     8    554,  555,  552,  539,  540,  558,  560,  530,  560,  558,
     9    561,  557,  563,  564,  543,  565,  557,  567,  568,  569/
            data (jb1(i),i=  601,  700)/
     +    570,  571,  572,  573,  574,  556,  576,  577,  575,  579,
     1    580,  581,  582,  583,  584,  585,  586,  587,  588,  589,
     2    556,  559,  591,  579,  593,  542,  593,  579,  595,  596,
     3    597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
     4    607,  608,  565,  593,  610,  612,  613,  598,  560,  575,
     5    612,  562,  615,  611,  618,  619,  621,  616,  621,  610,
     6    623,  615,  625,  609,  617,  627,  628,  629,  630,  631,
     7    609,  625,  612,  634,  635,  636,  637,  638,  639,  640,
     8    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     9    651,  652,  653,  654,  655,  656,  657,  658,  659,  660/
            data (jb1(i),i=  701,  800)/
     +    661,  662,  663,  664,  665,  666,  667,  668,  669,  670,
     1    671,  672,  673,  674,  675,  676,  677,  678,  679,  680,
     2    681,  682,  683,  684,  685,  627,  621,  623,  688,  689,
     3    690,  687,  627,  692,  693,  694,  695,  696,  633,  698,
     4    699,  700,  701,  702,  703,  704,  705,  706,  707,  708,
     5    709,  710,  711,  712,  713,  697,  634,  715,  716,  718,
     6    719,  720,  697,  654,  723,  724,  725,  726,  717,  717,
     7    728,  729,  730,  722,  687,  723,  718,  722,  633,  735,
     8    718,  734,  624,  620,   18,  738,  739,  740,  620,  742,
     9    735,  723,  734,  745,  691,  746,  737,  747,  620,  749/
            data (jb1(i),i=  801,  900)/
     +    750,  752,  753,  754,  744,  746,  756,  757,  758,  752,
     1    747,  751,  761,  760,  763,  759,  765,  763,  765,  742,
     2    768,  769,  770,  771,  742,  773,  774,  775,  776,  777,
     3    778,  779,  772,  780,  733,  782,  783,  784,  785,  781,
     4    786,  788,  789,  790,  791,  792,  793,  794,  795,  796,
     5    797,  798,  799,  800,  801,  802,  803,  804,  805,  744,
     6    787,  767,  808,  809,  810,  807,  812,  813,  814,  815,
     7    816,  817,  808,  751,   20,  820,  819,  760,  772,  822,
     8    823,  819,  824,  812,  825,  827,  788,  752,  827,  781,
     9    827,  831,  826,  832,  834,  825,  836,  833,  835,  830/
            data (jb1(i),i=  901, 1000)/
     +    838,  839,  840,  841,  842,  843,  844,  845,  846,  847,
     1    848,  849,  850,  851,  823,  853,  854,  855,  856,  857,
     2    852,   22,  859,  860,  861,  834,  831,  863,  830,  787,
     3    865,  866,  864,  868,  867,   23,  870,  871,  872,  873,
     4    874,  875,  852,  865,  877,  878,  832,  836,  878,  881,
     5    880,  834,  883,  884,  881,  878,  864,  867,  887,  888,
     6    886,  886,  885,  890,  892,  889,  892,  885,  881,  895,
     7    896,  897,  898,  899,  900,  901,  902,  903,  904,  894,
     8    905,  906,  907,  884,  908,  909,  890,  910,  894,  911,
     9    892,  910,  914,  915,  916,  917,  918,  919,  920,  921/
            data (jb1(i),i= 1001, 1100)/
     +    922,  923,  924,  925,  926,  927,  928,  929,  930,  931,
     1    932,  933,  934,  935,  936,  913,  912,  908,  939,  940,
     2    941,  942,  943,  944,  945,  946,  947,  948,  949,  950,
     3    951,  952,  953,  954,  955,  938,  907,  957,  956,  956,
     4    958,   29,  960,  961,  962,  963,  964,  965,  966,  967,
     5    968,  969,  970,  971,  972,  913,  973,  974,  911,  975,
     6    976,  977,  979,  979,  978,  938,  973,  982,  983,  975,
     7    978,  985,  986,  987,  988,  989,  990,  991,  992,  984,
     8    981,  957,  994,   31,  996,  997,  998,  995,  993, 1000,
     9    984, 1002, 1003,  994, 1001, 1001,  995, 1004, 1005, 1008/
            data (jb1(i),i= 1101, 1150)/
     +   1009, 1010, 1011, 1005, 1007, 1007, 1006, 1006, 1014, 1015,
     1   1016, 1012, 1013, 1018, 1007, 1019, 1020, 1021, 1017, 1017,
     2   1023, 1024, 1025, 1022, 1019, 1027, 1018, 1028, 1029, 1030,
     3   1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040,
     4   1022, 1041, 1042, 1043, 1044, 1045, 1046,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     1     50,   50,    3,    4,    5,    6,   51,   52,   53,   54,
     2     55,   56,   57,   58,   59,   60,   60,   61,   62,   63,
     3     64,   65,   66,   67,   68,   68,   69,   70,   71,   71,
     4     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     5     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     6     92,   93,   93,   94,   95,   96,   97,   98,   99,  100,
     7    101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
     8    111,  112,  113,  114,  115,  116,  116,   12,  117,  118,
     9    119,  120,  121,  122,  123,  124,  125,  126,  126,   14/
            data (jb2(i),i=  101,  200)/
     +    127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
     1    137,  138,  138,   16,  139,  140,  141,  142,  143,  144,
     2    145,  146,  147,  148,  149,  150,  151,  152,  153,  153,
     3     18,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     4    163,  163,   20,  164,  165,  166,  167,  168,  169,  170,
     5    171,  172,  173,  174,  175,  176,  176,  177,  178,  179,
     6    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     7    190,  191,  192,  192,  193,  194,  194,  195,  196,  197,
     8    198,  199,  200,  201,  202,  203,  204,  205,  206,  207,
     9    208,  209,  210,  210,  211,  212,  213,  214,  215,  216/
            data (jb2(i),i=  201,  300)/
     +    217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
     1    227,  228,  229,  230,  231,  232,  233,  234,  234,  235,
     2    236,  237,  238,  239,  240,  241,  242,  242,  243,  244,
     3    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     4    255,  256,  257,  258,  259,  259,  260,  261,  262,  262,
     5    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     6    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     7    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     8    293,  294,  295,  295,  296,  297,  298,  299,  300,  301,
     9    302,  303,  304,  304,  305,  306,  307,  308,  309,  310/
            data (jb2(i),i=  301,  400)/
     +    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     1    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     2    331,  332,  333,  334,  335,  336,  337,  337,  338,  339,
     3    340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
     4    350,  351,  352,  353,  353,  354,  355,  356,  357,  358,
     5    359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
     6    369,  369,  370,  371,  372,  373,  374,  375,  376,  377,
     7    378,  379,  380,  381,  381,  382,  383,  384,  385,  386,
     8    387,  388,  389,  390,  390,  391,  392,  393,  394,  395,
     9    395,  396,  397,  398,  399,  400,  401,  402,  403,  404/
            data (jb2(i),i=  401,  500)/
     +    405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
     1    415,  416,  417,  418,  419,  420,  421,  421,  422,  423,
     2    424,  425,  426,  427,  428,  429,  430,  430,  431,  432,
     3    433,  434,  434,  435,  436,  437,  438,  439,  439,    1,
     4      2,  441,  442,  442,  443,  444,  445,  445,  446,  446,
     5    447,  448,  449,  449,    7,  450,  451,  452,    8,  453,
     6    454,  455,  456,  457,  458,  459,  460,  461,  462,  463,
     7    464,  465,  466,  466,  467,  468,  469,  470,  471,  472,
     8    473,  474,  475,  476,  477,  478,  479,  480,  481,  482,
     9    482,  483,  484,  485,  486,  487,  487,  488,  489,  489/
            data (jb2(i),i=  501,  600)/
     +    490,  491,  491,  492,  493,  493,  494,  495,  496,  497,
     1    498,  498,  499,  500,  500,  502,  503,  504,  505,  506,
     2    507,  508,  509,  510,  511,  512,  512,   11,  513,  514,
     3    515,  516,  517,  517,  518,  519,  520,  521,  521,  522,
     4    523,  525,  526,  527,  528,  529,  529,  524,   13,  531,
     5    532,  533,  534,  535,  535,  536,  537,  538,  538,  539,
     6    539,  540,  541,  541,  542,  543,  543,  545,  546,  546,
     7    547,  548,  549,  550,  550,  551,  552,  552,  553,  554,
     8    555,  556,  557,  558,  559,  559,   15,  561,  561,  562,
     9    562,  563,  564,  565,  566,  566,  567,  568,  569,  570/
            data (jb2(i),i=  601,  700)/
     +    571,  572,  573,  574,  575,  576,  577,  578,  578,  580,
     1    581,  582,  583,  584,  585,  586,  587,  588,  589,  590,
     2    590,  591,  592,  592,  594,  594,   16,  595,  596,  597,
     3    598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
     4    608,  609,  610,  611,  611,  613,  614,  614,  615,  616,
     5    616,  617,  617,  618,  619,  620,  622,  622,  623,  624,
     6    624,  625,   17,  626,  626,  628,  629,  630,  631,  632,
     7    632,  633,  634,  635,  636,  637,  638,  639,  640,  641,
     8    642,  643,  644,  645,  646,  647,  648,  649,  650,  651,
     9    652,  653,  654,  655,  656,  657,  658,  659,  660,  661/
            data (jb2(i),i=  701,  800)/
     +    662,  663,  664,  665,  666,  667,  668,  669,  670,  671,
     1    672,  673,  674,  675,  676,  677,  678,  679,  680,  681,
     2    682,  683,  684,  685,  686,  686,  687,  688,  689,  690,
     3    691,  691,  692,  693,  694,  695,  696,  697,  698,  699,
     4    700,  701,  702,  703,  704,  705,  706,  707,  708,  709,
     5    710,  711,  712,  713,  714,  714,  715,  716,  717,  719,
     6    720,  721,  721,  722,  724,  725,  726,  727,  727,  728,
     7    729,  730,  731,  731,  732,  732,  733,  733,  734,  736,
     8    736,  735,  737,  737,  738,  739,  740,  741,  741,  743,
     9    743,  744,  745,   19,  746,  747,  748,  748,  749,  750/
            data (jb2(i),i=  801,  900)/
     +    751,  753,  754,  755,  755,  756,  757,  758,  759,  759,
     1    760,  761,  762,  762,  764,  764,  766,  766,  767,  768,
     2    769,  770,  771,  772,  773,  774,  775,  776,  777,  778,
     3    779,  780,  780,  781,  782,  783,  784,  785,  786,  786,
     4    787,  789,  790,  791,  792,  793,  794,  795,  796,  797,
     5    798,  799,  800,  801,  802,  803,  804,  805,  806,  806,
     6    788,  807,  809,  810,  811,  811,  813,  814,  815,  816,
     7    817,  818,  818,  819,  820,  821,  821,  812,  822,  823,
     8     21,  824,  825,  826,  826,  828,  828,  829,  829,  830,
     9    831,  832,  833,  833,  835,  835,  837,  837,  836,  838/
            data (jb2(i),i=  901, 1000)/
     +    839,  840,  841,  842,  843,  844,  845,  846,  847,  848,
     1    849,  850,  851,  852,  853,  854,  855,  856,  857,  858,
     2    858,  859,  860,  861,  862,  862,  863,  864,  865,  866,
     3    866,  867,  868,  869,  869,  870,  871,  872,  873,  874,
     4    875,  876,  876,  877,   24,  879,  879,  880,  880,  882,
     5    882,  883,  884,   25,  883,  885,  886,  887,  888,  889,
     6    889,  890,  891,  891,   26,  893,  893,  894,  895,  896,
     7    897,  898,  899,  900,  901,  902,  903,  904,  905,  905,
     8    906,  907,  908,  909,  909,   27,  910,  911,  912,  912,
     9    913,  914,  915,  916,  917,  918,  919,  920,  921,  922/
            data (jb2(i),i= 1001, 1100)/
     +    923,  924,  925,  926,  927,  928,  929,  930,  931,  932,
     1    933,  934,  935,  936,  937,  937,  938,  939,  940,  941,
     2    942,  943,  944,  945,  946,  947,  948,  949,  950,  951,
     3    952,  953,  954,  955,  956,  957,  958,  958,   28,  959,
     4    959,  960,  961,  962,  963,  964,  965,  966,  967,  968,
     5    969,  970,  971,  972,  973,  974,  974,  975,  976,  976,
     6    977,  978,  980,  981,  980,  981,  982,  983,   30,  984,
     7    985,  986,  987,  988,  989,  990,  991,  992,  993,  993,
     8    994,  995,  995,  996,  997,  998,  999,  999, 1000, 1001,
     9   1002, 1003,   32, 1004, 1004, 1005, 1006, 1007, 1008, 1009/
            data (jb2(i),i= 1101, 1150)/
     +   1010, 1011,   33, 1012, 1012, 1013, 1013, 1014, 1015, 1016,
     1     34, 1017,   35,   36, 1019, 1020, 1021, 1022, 1018, 1023,
     2   1024, 1025, 1026, 1026, 1027,   37, 1028, 1029, 1030, 1031,
     3   1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041,
     4     38, 1042, 1043, 1044, 1045, 1046,   39,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine in(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1130) :: jx,jy
            integer(kind=iknd), save, dimension(1220) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'indiana       '/
            data jrot,ipart/0,1/
            data kv/   1,1122,   0,   0,   0/
            data kb/   1,1213,   0,   0,   0/
            data iib/ 389,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  19080,19248,19320,20184,23328,17400,16056,12840,12912,13248,
     1  13560,13680,13776,13944,14016,13776,13968,14112,14496,14952,
     2  15072,41280,37128,32304,28128,41400,41544,12816,41640,12792,
     3  41712,12696,41736,41808,12672,41880,41904,11880,41400,41592,
     4  12744,37944,35520,10248,31584,24264,30456,25704, 7608,20352,
     5  13416,10656,15408,41184,12648,12552,12408,12072,11832,11688,
     6  11712,11856,11904,11808,41208,41208,41976,41784,41880,41856,
     7  41400,41448,11976,12096,12192,12144,12144,12024,11904,11832,
     8  11712,11664,11448,11616,11400,11280,11544,11328,11304,11400,
     9  11736,11664,11688,11952,12168,12120,12216,12120,12240,12096/
            data (jx(i),i=  101,  200)/
     +  12576,12792,12720,12768,12648,38256,38544,39336,40200,40728,
     1  41400,42024,42120,42144,41952,42120,42336,42408,42360,42096,
     2  37704,37416,37272,36744,36216,35736,35496,35352,35184,35208,
     3  35400,35400,31800,31944,32136,32832,33216,33288,33288,33552,
     4  33864,34392,34752,34920,35064,35568,35640,35664,12552,12456,
     5  12552,12456,12456,12360,12624,12696,12648,12936,12960,12768,
     6  12960,12912,12960,12744,12624,12456,11952,11808,11736,11616,
     7  11640,11544,11664,11664,11520,11448,11400,11376,11280,11232,
     8  11064,11304,11304,11184,11040,10872,10632,10320,10176,10128,
     9  10344,10392,10272, 7560, 7632, 7776, 7848, 7920, 8040, 7968/
            data (jx(i),i=  201,  300)/
     +   8064, 8136, 8256, 8424, 8328, 8376, 8448, 8832, 8928, 8928,
     1   9000, 9144, 9240, 9264, 9360, 9528, 9888,31224,31152,31008,
     2  30624,30360,30432,30216,30024,29040,28968,28968,28848,28752,
     3  28464,28344,27960,27408,27096,26424,26304,26256,26352,26304,
     4  26088,24384,24528,24960,25200,25632,25752,25824,25776,25320,
     5  25224,25248,25392,24312,24576,24624,24384,23784,23640,23592,
     6  23784,23784,23568,22968,22848,22776,22776,22680,22392,22128,
     7  22056,22200,22176,21912,21504,21336,21024,20616,15072,14592,
     8  14040,13680,10824,11016,11016,10848,10896,11040,11328,11520,
     9  11712,11904,11832,11568,11448,11520,11688,11808,11880,11976/
            data (jx(i),i=  301,  400)/
     +  12192,12744,12864,15984,16536,16704,16896,17136,17304,17448,
     1  17640,17880,17880,18072,18528,19320,19896, 7608, 7728, 8040,
     2   8112, 8280, 8328, 7992, 7848, 7704, 7656, 7344, 7224, 7248,
     3   7296, 7824, 7896, 7800, 7296, 7056, 6912, 7008, 7200, 7272,
     4   7104, 7248, 7200, 7032, 7056, 7008, 6888, 6720, 6600, 6672,
     5   7152, 7224, 7152, 6984, 6792, 6456, 6384, 6360, 6672, 7032,
     6   7080, 7056, 6888, 6552, 6456, 6432, 6504, 6672, 6960, 7032,
     7   7056, 7200, 7296, 7752, 7872, 8088, 8280, 8376, 8328, 8040,
     8   8016, 8088, 8496, 8736, 9120, 9264, 9720,10056,10440,19104,
     9  16080,37224,32424,28200,32424,28224,23952,23952,23352,23304/
            data (jx(i),i=  401,  500)/
     +  23712,23736,23616,23568,23328,32496,37320,36096,33696,33696,
     1  22128,21816,21480,21432,21144,21096,20856,20640,20328,19728,
     2  19200,19008,18648,17760,16992,16368,15984,15480,28296,28056,
     3  23976,19104,14976,14376,14232,14016,13656,13560,32520,32160,
     4  32208,29472,28704,28704,28080,36096,35808,35904,32640,32232,
     5  29472,38664,35928,19104,27144,27120,22800,23976,32784,15456,
     6  15456,15552,15552,18504,18504,17328,17328,22800,29592,30384,
     7  27144,27216,36000,34800,38832,37440,34848,30408,17352,20976,
     8  20928,21024,20928,21000,20904,21048,20952,20784,20784,25008,
     9  23400,23400,24984,17376,25008,21600,21600,30456,37416,37272/
            data (jx(i),i=  501,  600)/
     +  34896,33480,30456,26424,26424,26016,26016,25704,25704,17400,
     1  37320,30504,26424,17400,21600,26448,21600,17328,17232,16968,
     2  16536,15912,15768,15720,15360,15216,15024,14976,14664,13896,
     3  13704,13776,14040,14040,13128,13152,37416,33576,37584,37440,
     4  13872,13776,13656,13800,13704,13824,13752,13920,33576,17400,
     5  30528,30528,29736,26520,25584,21648,18264,17400,21648,37632,
     6  37416,37440,36576,33408,33624,33384,14256,14112,14280,14232,
     7  14304,14232,14352,14280,14280,14400,14568,14304,14424,14328,
     8  13992,13944,14040,14016,13872,13728,13728,13848,39456,39456,
     9  37848,37848,33024,33024,29616,29568,29736,29616,26448,25608/
            data (jx(i),i=  601,  700)/
     +  16224,18240,24120,24120,22080,21744,21744,22224,22224,39504,
     1  36672,21744,19008,18240,22152,21912,21744,36696,33120,33144,
     2  32568,29664,28248,26472,22320,22344,25032,22344,39264,37608,
     3  36768,16224,15840,15792,28320,35232,15792,18984,17784,17784,
     4  22128,22080,21768,21816,33888,32568,25752,25200,25152,25056,
     5  31368,31392,35256,31176,30912,30696,30720,28344,25776,21792,
     6  31464,26256,26184,38592,41136,40992,40848,40728,40680,40632,
     7  40656,40560,40080,39984,39840,39792,39624,39432,39432,39240,
     8  39168,39024,38952,38856,38760,38760,38832,38568,37872,37872,
     9  34224,34248,33840,33864,33456,33480,33264,33264,33168,33168/
            data (jx(i),i=  701,  800)/
     +  32664,32664,38520,15744,21792,19392,17304,15744,21816,19416,
     1  19200,19200,32472,32424,32328,32280,32160,32040,31920,31824,
     2  31752,31728,31656,31608,26376,26448,26472,26616,26784,26904,
     3  26928,27024,27192,27240,27360,27456,27768,27984,28128,28176,
     4  28248,28464,28560,28800,29088,29088,29256,29328,29400,29400,
     5  29448,29496,29664,29784,29784,29928,29952,30048,30024,30336,
     6  30384,30336,30456,31344,31368,31200,31080,31080,30960,30960,
     7  30720,30624,26112,26088,25872,25896,21840,32688,32904,32904,
     8  33096,33096,33504,33528,33936,33960,34752,34752,34944,34968,
     9  31512,31536,31416,31416,31320,31320,31224,31224,30936,30528/
            data (jx(i),i=  801,  900)/
     +  30912,17328,17232,16992,17064,17016,16896,16920,16992,16992,
     1  16776,16848,16800,16392,16368,16464,16512,16344,16320,16248,
     2  16224,16296,16272,16152,16176,16080,16056,15984,16032,15960,
     3  15936,15888,15912,15768,15840,15768,15696,15744,15768,15576,
     4  15576,15600,15768,15696,15624,15768,15672,15600,15672,15528,
     5  15576,15432,15456,15336,15528,15384,15504,15528,15648,15696,
     6  15552,15600,15768,15768,15624,15624,15792,15744,15648,15624,
     7  15744,15768,15648,15600,15768,15648,15696,15648,15696,15792,
     8  15768,15672,15792,15672,15768,15720,20136,20160,20064,19776,
     9  19680,19560,19464,19296,17592,17424,17472,17352,17184,17064/
            data (jx(i),i=  901, 1000)/
     +  17064,17016,16896,16848,16872,16704,16656,16680,16608,16512,
     1  16488,16368,16152,15960,13296,13512,13608,13656,13728,13776,
     2  13896,13944,14136,14232,14232,14328,14424,14328,14448,15000,
     3  15072,15216,15600,15648,19080,19008,18912,18840,18840,18600,
     4  18432,18336,18240,18096,17976,17856,17688,21840,26520,25920,
     5  30936,30720,30744,30552,30552,29760,29760,29352,29352,28944,
     6  13224,13008,12960,12768,12576,12576,12504,12408,12360,12456,
     7  12120,12000,11952,12024,11832,11688,11592,11424,11376,11208,
     8  11112,11016,11136,11016,10920,10632,25944,21864,29352,31392,
     9  31920,31824,31704,31680,31536,31560,31680,31560,31632,31536/
            data (jx(i),i= 1001, 1100)/
     +  31608,24264,23064,23064,14904,14904,14592,13920,13920,13512,
     1  13512,13296,17568,15096,15096,21864,20640,20640,18192,17568,
     2  28944,29160,29160,29352,29376,29616,29616,29808,29880,30456,
     3  26400,26544,26544,26616,26448,26472,26592,26592,26496,26352,
     4  26280,26352,26280,26304,26208,26136,26280,26472,26424,26424,
     5  26544,26544,26496,26400,26376,26304,26280,26208,26112,26064,
     6  26160,26088,26160,25944,25920,25848,25944,25896,25752, 9600,
     7   9600,10824,10824,14904,13248,13248,20640,20520,20616,20496,
     8  20568,20688,20760,20856,20904,20904,20784,20952,20784,20760,
     9  20880,20736,20568,20472,13176,13416,10800,10728,15432,15720/
            data (jx(i),i= 1101, 1130)/
     +  15816,15840,15912,16224,16512,16512,16680,16680,16536,16584,
     1  16680,16680,16752,16920,16992,17400,17304,17376,17544,17568,
     2  18192,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  61056,61104,61248,61728,61728,60240,59832,53472,61080,60720,
     1  60504,60528,60408,60624,60552,60288,60120,60120,59952,59856,
     2  59784,58824,61920,61848,61800,55200,50352,47520,45504,43944,
     3  41856,39360,37632,33744,31848,30888,27888,27024,24096,22272,
     4  22056,19248,17760,15264,13536,11064,12024,12000,12744, 9456,
     5   8640, 8064, 7752,62016,28272,28296,28152,28104,27720,27672,
     6  27624,27624,27576,27384,24336,24480,25128,23544,23280,23088,
     7  22560,22392,26832,26952,26904,26760,26376,26160,26088,25992,
     8  25992,25800,25680,25560,25536,25296,25056,25032,24936,24864,
     9  24864,24672,24576,24504,24192,23952,23688,23400,23304,23256/
            data (jy(i),i=  101,  200)/
     +  23040,22752,22584,22392,22200,19224,19344,19992,20520,20496,
     1  20760,20640,20688,20880,21264,21528,21696,22008,22104,22224,
     2  19416,19824,19896,19920,19776,19848,19800,19680,19296,19128,
     3  18744,18096,13536,13368,13296,13704,14304,14592,14952,15624,
     4  15864,15936,16080,16296,16656,16992,17136,17424,21936,21936,
     5  21744,21672,21552,21480,21312,21000,20856,20448,20328,20184,
     6  20136,19896,19800,19440,19056,18936,18792,18672,18480,18408,
     7  18240,17904,17784,17688,17688,17736,17712,17496,17400,17232,
     8  17088,16680,16560,16488,16560,16296,16176,16152,16032,15864,
     9  15792,15720,15576,13128,13128,12912,12888,13080,13152,13368/
            data (jy(i),i=  201,  300)/
     +  13464,13608,13704,13632,13392,13248,13272,13872,13728,13440,
     1  13344,13392,13584,13992,14328,14544,14712,13416,13320,12696,
     2  12288,11640,10920, 9888, 9648, 9408, 9264, 9048, 8952, 9024,
     3   9504, 9624, 9720, 9648, 9792,10272,10464,10728,11352,11496,
     4  11760,11232,11232,10944,11256,11280,11352,11520,11640,11808,
     5  11976,12168,12240,10872,10704,10536,10176,10104, 9960, 9120,
     6   8688, 8496, 8328, 8376, 8328, 8136, 7632, 7488, 7296, 7272,
     7   7392, 8064, 8208, 8280, 7992, 7992, 8304, 9288, 8016, 8256,
     8   8640, 8712, 8160, 8016, 7848, 7512, 7176, 7080, 7056, 7128,
     9   7272, 7632, 7968, 8184, 8424, 8592, 8784, 9120, 9120, 9024/
            data (jy(i),i=  301,  400)/
     +   8568, 8184, 8232, 7344, 7224, 7032, 6528, 6456, 6480, 6576,
     1   6792, 7632, 8016, 8232, 8472, 8640, 9264,12480,12168,12000,
     2  11784,11880,11736,11328,11376,11304,11064,11016,10896,10752,
     3  10704,10944,10704,10512,10248,10272,10128,10008,10008, 9960,
     4   9672, 9192, 9072, 8976, 8592, 8544, 8520, 8616, 8496, 8400,
     5   8328, 8136, 8040, 8088, 8064, 8256, 8256, 8136, 7584, 7368,
     6   7296, 7176, 7104, 7248, 7224, 7104, 6912, 6840, 6912, 6864,
     7   6744, 6792, 6768, 6384, 6384, 6696, 6816, 6936, 7368, 7728,
     8   7848, 8064, 8520, 8448, 7896, 7800, 7800, 8016, 7992,54456,
     9  54528,58680,58560,57864,57360,57288,57792,57192,57192,60192/
            data (jy(i),i=  401,  500)/
     +  60192,59184,59040,58416,58392,55368,55032,55008,54984,55392,
     1  57192,56904,56736,56448,55872,55632,55440,55128,54960,54840,
     2  54552,54336,54216,54888,55128,54840,54432,54192,53616,53616,
     3  53544,53544,53760,53568,53424,53424,53592,53544,53760,53736,
     4  51912,51816,51792,52416,52392,53808,53808,51408,51288,51288,
     5  51216,50232,50160,49944,51144,49944,49944,49920,46464,50328,
     6  49944,49944,47520,49944,48936,48936,47520,47496,46392,46416,
     7  47232,45120,46536,46488,45384,45336,45288,45216,45096,47520,
     8  47328,47256,47016,46848,46752,46704,46512,46512,45072,45072,
     9  47472,46896,46896,43872,43272,43272,45096,42984,42720,42720/
            data (jy(i),i=  501,  600)/
     +  42672,42648,42600,42888,42480,42480,42672,42672,43272,42360,
     1  41712,40392,40272,40272,40248,39792,39744,42360,42192,41976,
     2  41904,41592,41568,41424,41136,40824,40728,40608,40272,39936,
     3  39552,39408,39264,39072,39096,39360,38520,38448,37512,37512,
     4  36624,36624,36720,36984,37608,37824,37920,38136,36624,36624,
     5  36552,36336,36312,36264,36216,36192,35424,35424,35376,35712,
     6  35712,34512,34488,34392,35616,35616,31848,32424,33000,33120,
     7  33192,33360,34200,34632,34992,35016,35352,35544,35664,35904,
     8  36072,36144,36216,36264,36240,36312,36360,36480,33720,33528,
     9  33504,34536,34392,33192,33120,35520,35520,32280,32208,32160/
            data (jy(i),i=  601,  700)/
     +  31824,31752,32136,31728,31704,35376,32112,32136,31992,30912,
     1  30840,29904,29928,29952,31080,30792,30672,29832,29760,28368,
     2  28344,28248,28200,28152,29904,28200,28104,28104,27864,27840,
     3  27264,30600,30600,27000,24120,26232,25776,28128,28128,25728,
     4  28320,27960,28056,25680,25320,25272,24072,24048,26880,26904,
     5  25248,24408,22320,24408,24312,24120,24000,23904,23304,23280,
     6  20784,20112,23304,22848,23808,23880,23832,23688,23736,23712,
     7  23616,23544,23544,23280,23352,23232,23256,22992,22872,22872,
     8  22920,22680,22752,22680,22704,22800,22968,22584,22584,22392,
     9  22296,21864,21840,21456,21432,21048,21048,20928,20928,21048/
            data (jy(i),i=  701,  800)/
     +  21024,20904,22224,22128,22080,22080,22056,22056,19008,20856,
     1  20856,16488,20904,21024,21072,21000,21024,20928,20952,20856,
     2  20880,20808,20856,20760,20136,20232,20160,20136,20328,20232,
     3  20328,20376,20304,20376,20256,20280,20112,20160,20136,20352,
     4  20400,20280,20328,20088,20160,20040,20088,20184,20160,20064,
     5  20088,19992,20160,20112,20016,20136,20016,20040,19992,20016,
     6  19968,19848,19752,20520,20376,20328,20136,19992,19896,19824,
     7  19680,19656,19968,19728,19680,19056,16776,19824,19848,19728,
     8  19728,19416,19416,19008,19008,18024,18048,17832,17832,17760,
     9  17952,17760,17760,17664,17640,17544,17544,17376,17376,17544/
            data (jy(i),i=  801,  900)/
     +  17544,21984,21984,21768,21576,21552,21624,21480,21456,21408,
     1  21528,21288,21120,21240,21192,21168,21000,21072,20928,21024,
     2  20976,20904,20784,20952,20784,20688,20904,20904,20760,20736,
     3  20640,20664,20760,20736,20808,20856,20688,20616,20328,20280,
     4  20160,20088,20136,19992,19968,19776,19800,19704,19560,19680,
     5  19464,19296,19200,19104,19032,18936,18840,18720,18912,18888,
     6  18648,18552,18624,18480,18528,18456,18312,18264,18312,18240,
     7  18048,17952,18024,18000,17880,17784,17736,17640,17568,17544,
     8  17472,17376,17280,17256,17160,17040,16776,16728,16608,16488,
     9  16344,16344,16440,16368,16608,16584,16704,16728,16944,16896/
            data (jy(i),i=  901, 1000)/
     +  16776,16752,16872,16776,16680,16632,16704,16800,16872,16848,
     1  16992,17088,17136,16968,16872,16872,16824,16968,16992,16848,
     2  16800,16992,16968,16872,16632,16584,16752,16944,17040,16680,
     3  16560,16584,16800,16992,16488,16320,16272,16296,16464,16440,
     4  16608,16536,16584,16512,16584,16560,16416,15000,15360,15360,
     5  17160,17136,16752,16752,16536,16512,16320,16320,15336,15336,
     6  16656,16512,16368,16488,16416,16632,16680,16656,16584,16320,
     7  16320,16416,16344,16200,15744,15696,15744,15648,15816,15864,
     8  15720,15696,15504,15456,15504,15312,15024,13128,15120,15168,
     9  14424,14328,14328,14160,14184,14064,14016,13944,13848,13824/
            data (jy(i),i= 1001, 1100)/
     +  13728,12384,12384,13152,12888,14712,14808,14760,15528,15552,
     1  15960,15960,12696,12696,12888,12936,12936,12336,12336,12336,
     2  14112,14112,13728,13728,13344,13368,13152,13152,12120,12120,
     3  15216,15144,14976,14880,14808,14592,14568,14496,14424,14520,
     4  14352,14232,14232,13944,14016,13896,13800,13752,13728,13584,
     5  13608,13560,13440,13488,13368,13368,12648,12576,12624,12552,
     6  12480,12408,12312,12288,12120,12120,12024,11976,12024,12672,
     7  12288,12312,11832,12312,12312,11784,12096,12000,11664,11448,
     8  11400,10944,10872,10944,10872,10680,10560,10272,10224,10152,
     9   9480, 9480, 9600, 9480,10008,10008,11232,11256, 8448, 8808/
            data (jy(i),i= 1101, 1130)/
     +   8808, 9000, 9096, 9312, 9648, 9720, 9744, 9816, 9864, 9912,
     1   9912,10224,10296,10248,10080,10152,10320,10632,10824,11160,
     2  11160,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    1,    6,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,    7,
     2     23,   24,    5,   23,   22,   22,   26,    8,   27,   28,
     3     29,   30,   31,   33,   32,   34,   36,   35,   55,   56,
     4     57,   58,   59,   60,   61,   62,   63,   38,   39,   65,
     5     66,   37,   39,   68,   69,   70,   71,   40,   38,   73,
     6     74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
     7     84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
     8     94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
     9    104,   41,   42,  106,  107,  108,  109,  110,  111,  112/
            data (jb1(i),i=  101,  200)/
     +    113,  114,  115,  116,  117,  118,  119,   40,   42,  121,
     1    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     2     43,   45,  133,  134,  135,  136,  137,  138,  139,  140,
     3    141,  142,  143,  144,  145,  146,  147,   43,   41,  149,
     4    150,  151,  152,  153,  154,  155,  156,  157,  158,  159,
     5    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     6    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     7    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     8    190,  191,  192,   44,   49,  194,  195,  196,  197,  198,
     9    199,  200,  201,  202,  203,  204,  205,  206,  207,  208/
            data (jb1(i),i=  201,  300)/
     +    209,  210,  211,  212,  213,  214,  215,  216,   44,   45,
     1    218,  219,  220,   47,   47,  222,  223,  224,  225,  226,
     2    227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
     3    237,  238,  239,  240,   48,   46,  242,  243,  244,  245,
     4    246,  247,  248,  249,  250,  251,  252,   48,   46,  254,
     5    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     6    265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
     7    275,  276,  277,   50,   53,  279,  280,  281,   51,   52,
     8    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     9    293,  294,  295,  296,  297,  298,  299,  300,  301,  302/
            data (jb1(i),i=  301,  400)/
     +     51,   53,  304,  305,  306,  307,  308,  309,  310,  311,
     1    312,  313,  314,  315,  316,   50,   49,  318,  319,  320,
     2    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     3    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     7    371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
     8    381,  382,  383,  384,  385,  386,  387,  388,   52,    1,
     9      7,   22,  392,  392,  393,   25,  393,  395,  394,  394/
            data (jb1(i),i=  401,  500)/
     +    397,  398,    5,  400,  401,  402,  403,  404,  399,  395,
     1     26,  392,  407,  408,  409,  406,  399,  411,  412,  413,
     2    414,  415,  416,  417,  418,  419,  420,  390,  390,  422,
     3    423,  424,  425,  391,  391,  427,  396,  429,  430,  398,
     4    431,  390,  428,  433,  434,  435,  436,  437,    8,  406,
     5    439,  440,  441,  442,  443,  444,  430,  408,  446,  447,
     6    448,  449,  441,  442,   27,  452,  448,  432,  451,  455,
     7    454,  456,  431,  457,  449,  428,  460,  461,  462,  463,
     8    454,  464,  465,  466,  463,  457,  451,  469,  456,  471,
     9    453,  473,  459,  459,   29,  452,  475,  476,  474,  470/
            data (jb1(i),i=  501,  600)/
     +    472,  467,  468,  480,  481,  482,  483,  484,  485,  486,
     1    487,  488,  472,  468,  491,  492,  490,  479,  479,  494,
     2    490,  495,  489,  496,  478,  476,  499,  500,  477,  501,
     3    502,  498,  498,  504,  505,  506,  507,  508,  495,  494,
     4     31,  500,  503,  512,  505,  510,  496,  514,  513,  516,
     5    515,  510,  518,  519,  520,  521,  522,  523,  524,  525,
     6    526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
     7    536,  511,  537,  502,   33,  537,  539,  541,  542,  543,
     8    544,  545,  546,  547,  534,  538,  514,  541,  549,  512,
     9    551,  552,  553,  516,  554,  555,  517,  557,  550,  556/
            data (jb1(i),i=  601,  700)/
     +    557,  539,  560,  561,  562,  563,  549,  565,  564,  567,
     1    568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
     2    578,  579,  580,  581,  582,  583,  584,  585,  586,  587,
     3    541,   34,  589,  590,  591,  562,  564,  593,  594,  595,
     4    596,  553,  595,  598,  599,  555,  567,  567,  557,  601,
     5    600,  603,  604,  559,  606,  607,  608,  605,  590,  610,
     6    610,  563,  612,  613,  602,  605,  615,  616,  612,  611,
     7    618,  594,  619,  620,  621,  598,  622,  623,  612,  625,
     8    599,  624,  626,  627,   37,  629,  630,  618,  601,  632,
     9    633,  634,  623,  631,  634,  613,  638,  639,  637,  626/
            data (jb1(i),i=  701,  800)/
     +    641,  642,  643,  640,  636,  645,  621,  647,  648,  649,
     1    627,  646,  651,  636,  635,  652,  654,  655,  656,  657,
     2    635,  647,  659,  644,  652,  662,  659,  629,   39,  665,
     3    666,  667,  668,  669,  670,  671,  672,  673,  674,  675,
     4    676,  677,  678,  679,  680,  681,  682,  683,  684,  685,
     5    686,  664,  664,  688,  689,  653,  653,  691,  692,  693,
     6    694,  695,  696,  697,  698,  699,  700,  701,   40,  688,
     7    637,  660,  705,  704,  706,  704,  708,  705,  706,  710,
     8    711,  702,  713,  714,  715,  716,  717,  718,  719,  720,
     9    721,  722,  723,  661,  662,  725,  726,  727,  728,  729/
            data (jb1(i),i=  801,  900)/
     +    730,  731,  732,  733,  734,  735,  736,  737,  738,  739,
     1    740,  741,  742,  743,  744,  745,  746,  747,  748,  749,
     2    750,  751,  752,  753,  754,  755,  756,  757,  758,  759,
     3    760,  761,  762,  661,  764,  765,  766,  767,  768,  769,
     4    770,  771,  763,  690,  662,  773,  774,  775,  709,  709,
     5    702,  778,  779,  780,  781,  782,  783,  784,  785,  786,
     6    787,  788,  789,  790,  786,  791,  792,  793,  794,  795,
     7    796,  797,  798,  763,  800,  799,  707,  802,  803,  804,
     8    805,  806,  807,  808,  809,  810,  811,  812,  813,  814,
     9    815,  816,  817,  818,  819,  820,  821,  822,  823,  824/
            data (jb1(i),i=  901, 1000)/
     +    825,  826,  827,  828,  829,  830,  831,  832,  833,  834,
     1    835,  836,  837,  838,  839,  840,  841,  842,  843,  844,
     2    845,  846,  847,  848,  849,  850,  851,  852,  853,  854,
     3    855,  856,  857,  858,  859,  860,  861,  862,  863,  864,
     4    865,  866,  867,  868,  869,  870,  871,  872,  873,  874,
     5    875,  876,  877,  878,  879,  880,  881,  882,  883,  884,
     6    885,  777,  887,  888,  889,  890,  891,  892,  893,  712,
     7    895,  896,  897,  898,  899,  900,  901,  902,  903,  904,
     8    905,  906,  907,  908,  909,  910,  911,  912,  913,  886,
     9    915,  916,  917,  918,  919,  920,  921,  922,  923,  924/
            data (jb1(i),i= 1001, 1100)/
     +    925,  926,  927,  928,  929,  930,  931,  932,  933,  886,
     1    712,  935,  936,  937,  938,  939,  940,  941,  942,  943,
     2    944,  945,  946,  895,  777,  949,  776,  799,  951,  952,
     3    953,  954,  955,  956,  957,  958,  959,  949,  915,  961,
     4    962,  963,  964,  965,  966,  967,  968,  969,  970,  971,
     5    972,  973,  974,  975,  976,  977,  978,  979,  980,  981,
     6    982,  983,  984,  985,  986,  948,  950,  948,  959,  989,
     7    990,  991,  992,  993,  994,  995,  996,  997,  998,  999,
     8   1000, 1001,   46, 1002, 1003,  988, 1005, 1006, 1007, 1008,
     9   1009, 1010, 1011,  915,  895, 1013, 1014, 1005,  988, 1016/
            data (jb1(i),i= 1101, 1200)/
     +   1017, 1018, 1019, 1013,  960, 1021, 1022, 1023, 1024, 1025,
     1   1026, 1027, 1028, 1029, 1030,  949, 1031, 1032, 1033, 1034,
     2   1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044,
     3   1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054,
     4   1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064,
     5   1065, 1066, 1067, 1068, 1069,   49, 1070, 1071, 1072, 1005,
     6   1074, 1075, 1073, 1018, 1077, 1078, 1079, 1080, 1081, 1082,
     7   1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092,
     8   1093, 1094, 1076, 1095, 1096, 1073, 1097, 1098,   53, 1099,
     9   1100, 1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109/
            data (jb1(i),i= 1201, 1220)/
     +   1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119,
     1   1120, 1019,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    9,   10,   11,   12,
     1     13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
     2     24,   25,   25,   54,   54,   26,   27,   28,   29,   30,
     3     31,   32,   33,   34,   35,   36,   37,   55,   56,   57,
     4     58,   59,   60,   61,   62,   63,   64,   64,   65,   66,
     5     67,   67,   68,   69,   70,   71,   72,   72,   73,   74,
     6     75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
     7     85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
     8     95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
     9    105,  105,  106,  107,  108,  109,  110,  111,  112,  113/
            data (jb2(i),i=  101,  200)/
     +    114,  115,  116,  117,  118,  119,  120,  120,  121,  122,
     1    123,  124,  125,  126,  127,  128,  129,  130,  131,  132,
     2    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     3    142,  143,  144,  145,  146,  147,  148,  148,  149,  150,
     4    151,  152,  153,  154,  155,  156,  157,  158,  159,  160,
     5    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     6    171,  172,  173,  174,  175,  176,  177,  178,  179,  180,
     7    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     8    191,  192,  193,  193,  194,  195,  196,  197,  198,  199,
     9    200,  201,  202,  203,  204,  205,  206,  207,  208,  209/
            data (jb2(i),i=  201,  300)/
     +    210,  211,  212,  213,  214,  215,  216,  217,  217,  218,
     1    219,  220,  221,  221,  222,  223,  224,  225,  226,  227,
     2    228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
     3    238,  239,  240,  241,  241,  242,  243,  244,  245,  246,
     4    247,  248,  249,  250,  251,  252,  253,  253,  254,  255,
     5    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     6    266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
     7    276,  277,  278,  278,  279,  280,  281,  282,  282,  283,
     8    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     9    294,  295,  296,  297,  298,  299,  300,  301,  302,  303/
            data (jb2(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
     1    313,  314,  315,  316,  317,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     5    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     6    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     7    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     8    382,  383,  384,  385,  386,  387,  388,  389,  389,  390,
     9    391,  392,   23,  393,   24,  394,  395,  396,  396,  397/
            data (jb2(i),i=  401,  500)/
     +    398,  399,  400,  401,  402,  403,  404,  405,  405,  406,
     1    407,  407,  408,  409,  410,  410,  411,  412,  413,  414,
     2    415,  416,  417,  418,  419,  420,  421,  421,  422,  423,
     3    424,  425,  426,  426,  427,  428,  429,  430,  431,  431,
     4    432,  432,  433,  434,  435,  436,  437,  438,  438,  439,
     5    440,  441,  442,  443,  444,  445,  445,  446,  447,  448,
     6    449,  450,  450,  451,  452,  453,  453,  454,  455,  456,
     7    457,  458,  458,  458,  459,  460,  461,  462,  463,   28,
     8    464,  465,  466,  467,  467,  468,  469,  470,  471,  472,
     9    473,  474,  474,  470,  475,  475,  476,  477,  477,  478/
            data (jb2(i),i=  501,  600)/
     +    478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
     1    488,  489,  490,  491,  492,  493,  493,  489,  494,   30,
     2    495,  496,  497,  497,  498,  499,  500,  501,  501,  502,
     3    503,  503,  504,  505,  506,  507,  508,  509,  509,  510,
     4    511,  511,  512,  513,  513,  514,  515,  515,  516,  517,
     5    517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     6    527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     7     32,  537,  538,  538,  539,  540,  540,  542,  543,  544,
     8    545,  546,  547,  548,  548,  549,  550,  550,  551,  551,
     9    552,  553,  554,  554,  555,  556,  556,  558,  558,  559/
            data (jb2(i),i=  601,  700)/
     +    559,  560,  561,  562,  563,  564,  565,  566,  566,  568,
     1    569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
     2    579,  580,  581,  582,  583,  584,  585,  586,  587,  588,
     3    588,  589,  590,  591,  592,  592,  593,  594,  595,  596,
     4    597,  597,  598,  599,  600,  600,   35,  601,  602,  602,
     5    603,  604,  605,  606,  607,  608,  609,  609,  610,   36,
     6    611,  611,  613,  614,  614,  615,  616,  617,  617,  618,
     7    619,  619,  620,  621,  622,  622,  623,  624,  625,  626,
     8    624,  627,  628,  628,  629,  630,  631,  631,  632,  633,
     9    634,   38,  635,  636,  637,  638,  639,  640,  640,  641/
            data (jb2(i),i=  701,  800)/
     +    642,  643,  644,  644,  645,  646,  646,  648,  649,  650,
     1    650,  651,  652,  653,  647,  654,  655,  656,  657,  658,
     2    658,  659,  660,  660,  661,  663,  663,  664,  665,  666,
     3    667,  668,  669,  670,  671,  672,  673,  674,  675,  676,
     4    677,  678,  679,  680,  681,  682,  683,  684,  685,  686,
     5    687,  687,  688,  689,  690,  690,  691,  692,  693,  694,
     6    695,  696,  697,  698,  699,  700,  701,  702,  703,  703,
     7    704,  705,  706,  707,  707,  708,   41,  709,  710,  711,
     8    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     9    722,  723,  724,  724,  725,  726,  727,  728,  729,  730/
            data (jb2(i),i=  801,  900)/
     +    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     1    741,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     2    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     3    761,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     4    771,  772,  772,   42,  773,  774,  775,  776,  776,  777,
     5    778,  779,  780,  781,  782,  783,  784,  785,  786,  787,
     6    788,  789,  790,   43,  791,  792,  793,  794,  795,  796,
     7    797,  798,  799,  800,  801,  801,  802,  803,  804,  805,
     8    806,  807,  808,  809,  810,  811,  812,  813,  814,  815,
     9    816,  817,  818,  819,  820,  821,  822,  823,  824,  825/
            data (jb2(i),i=  901, 1000)/
     +    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     1    836,  837,  838,  839,  840,  841,  842,  843,  844,  845,
     2    846,  847,  848,  849,  850,  851,  852,  853,  854,  855,
     3    856,  857,  858,  859,  860,  861,  862,  863,  864,  865,
     4    866,  867,  868,  869,  870,  871,  872,  873,  874,  875,
     5    876,  877,  878,  879,  880,  881,  882,  883,  884,  885,
     6    886,  887,  888,  889,  890,  891,  892,  893,  894,  894,
     7    896,  897,  898,  899,  900,  901,  902,  903,  904,  905,
     8    906,  907,  908,  909,  910,  911,  912,  913,  914,  914,
     9    916,  917,  918,  919,  920,  921,  922,  923,  924,  925/
            data (jb2(i),i= 1001, 1100)/
     +    926,  927,  928,  929,  930,  931,  932,  933,  934,  934,
     1    935,  936,  937,  938,  939,  940,  941,  942,  943,  944,
     2    945,  946,  947,  947,  948,  950,  950,  951,  952,  953,
     3    954,  955,  956,  957,  958,  959,  960,  960,  961,  962,
     4    963,  964,  965,  966,  967,  968,  969,  970,  971,  972,
     5    973,  974,  975,  976,  977,  978,  979,  980,  981,  982,
     6    983,  984,  985,  986,   44,  987,  987,  988,  989,  990,
     7    991,  992,  993,  994,  995,  996,  997,  998,  999, 1000,
     8   1001,   45, 1002, 1003, 1004, 1004, 1006, 1007, 1008, 1009,
     9   1010, 1011, 1012, 1012, 1013, 1014, 1015, 1015, 1016, 1017/
            data (jb2(i),i= 1101, 1200)/
     +   1018, 1019, 1020, 1020, 1021, 1022, 1023, 1024, 1025, 1026,
     1   1027, 1028, 1029, 1030,   47, 1031, 1032, 1033, 1034, 1035,
     2   1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045,
     3   1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055,
     4   1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065,
     5   1066, 1067, 1068, 1069,   48, 1070, 1071, 1072, 1073, 1074,
     6   1075, 1076, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083,
     7   1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093,
     8   1094,   50, 1095, 1096,   51, 1097, 1098,   52, 1099, 1100,
     9   1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110/
            data (jb2(i),i= 1201, 1220)/
     +   1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120,
     1   1121, 1121,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ia(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(580) :: jx,jy
            integer(kind=iknd), save, dimension(680) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'iowa          '/
            data jrot,ipart/0,1/
            data kv/   1, 574,   0,   0,   0/
            data kb/   1, 672,   0,   0,   0/
            data iib/ 343,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  12144, 6864,15648,19176,22680,26184,29688,33192,40200,36696,
     1  46992,43704, 6864,49200, 7008,52464, 7920,55008, 9456,53856,
     2  10440,50352,48192,11184,49200,11640,32616,48024,43344,14928,
     3  39744,36168,18480,29040,21936,25464,47016,47184,47400,47832,
     4  47520,47184,46752,46680,46776,46704,46512,46584, 6672, 6720,
     5   6648, 7056, 7200, 6960, 6864, 6840, 6648, 6768, 6744, 6672,
     6  47016,47184,47160,47256,47280,47592,47712,47808,47832,47928,
     7  48024,48168,48216,48624, 6960, 7008, 7032, 7104, 7176, 7056,
     8   7056, 7224, 7200, 7080, 7128, 7032, 7392, 7488, 7560, 7536,
     9   7680, 7704, 7656, 7512, 7536, 7464, 7392, 7152, 7032, 6840/
            data (jx(i),i=  101,  200)/
     +   6792, 6912,50424,50640,51000,51168,51216,51096,51120,51384,
     1  51768,51888, 6840, 6912, 6816, 6840, 6768, 6816, 6696, 6648,
     2   6528, 6504, 6384, 6408, 6072, 6072, 6192, 6096, 6048, 6120,
     3   6072, 6168, 6312, 6480, 6456, 6552, 6600, 6720, 6744, 6888,
     4   6768, 6936, 7056, 7032, 7104, 7008,52944,52872,52992,53208,
     5  53424,54504,54648,54912,54912, 8136, 8064, 8136, 7896, 7728,
     6   7464, 7488, 7608, 7608, 7824, 7824, 7704, 7344, 7152, 7152,
     7   7032, 7032, 7152, 7128,55128,54960,55080,54840,54864,54816,
     8  54552,54024, 9312, 9480, 9456, 9528, 9456, 9168, 9096, 8976,
     9   8856, 8784, 8856, 8520, 8568, 8472, 8520, 8400, 8232, 8184/
            data (jx(i),i=  201,  300)/
     +   7992,53880,53760,53688,53712,53616,53208,52752,52584,52128,
     1  51816,51696,51312,50712,10464,10344,10200,10128, 9984, 9768,
     2   9648, 9696, 9840, 9792, 9552, 9528, 9720, 9528, 9600, 9888,
     3   9888, 9696, 9672, 9960, 9984, 9912, 9696, 9648,10272,10272,
     4  10656,10872,11016,10896,10896,10824,10896,10680,10872,11184,
     5  11280,11232,11016,11040,10920,10848,10968,10824,10848,10944,
     6  11352,11496,11448,11256,49872,49248,48840,48432,48360,48336,
     7  48216,48192,47904,47904,48144,48312,48384,48528,48744,48840,
     8  49176,11184,11280,11304,11136,11328,11232,11256,11496,11448,
     9  49248,49152,49104,48816,48408,48168,48192,48024,43560,43608/
            data (jx(i),i=  301,  400)/
     +  44088,44136,44328,44496,44880,44880,44808,44904,44880,45120,
     1  45192,45336,45384,45528,45696,45984,46128,46008,46104,45984,
     2  45720,45768,46296,46896,47472,47904,11616,11376,11328,11400,
     3  11352,11424,11328,11064,10992,11256,11328,11712,11808,12024,
     4  12024,11928,43248,12024,15576,19104,22608,26136,29664,33192,
     5  40224,36696,33192,43824,40248,11952,15480,19008,22536,26088,
     6  40248,29640,33192,36720,47424,49200,22488,43872,26064,40272,
     7  36720,11832,12720,15360,18936,22488,26040,29616,33168,36720,
     8  51000,51024,49296,47544,45768,43992,43968,43896,42216,40440,
     9  40440,40296,38688,36888,36744,36888,13128,13224,12696,15768/
            data (jx(i),i=  401,  500)/
     +  15840,15360,17520,18912,19344,19272,21024,22776,22824,22488,
     1  24528,26040,26328,26304,35112,35136,28056,33360,33168,33360,
     2  29856,29880,29592,31608,49368,49368,45816,12984,13872,17400,
     3  20064,20952,45816,23616,24504,42288,27144,38712,28032,30720,
     4  31584,35160,27288,27312,27144,49416,53712,53544,53328,53184,
     5  53136,53040,52968,52824,52728,52632,52512,52080,51864,51768,
     6  51576,51456,51312,51192,51096,51024,50928,50784,50712,50448,
     7  50280,49440,45888,14232,13800,14256,16848,17712,17736,17352,
     8  42360,20328,20352,20016,41448,38736,37872,23856,23880,23568,
     9  35232,35232,35160,34344,30696,30840,30840,26472,30840,29064/
            data (jx(i),i=  501,  580)/
     +  30000,30048,30144,30192,30144,30288,30288,30408,30576,30648,
     1  30768,50328,45888,45024,44664,44736,44808,44856,44784,44760,
     2  44904,44856,45912,15000,16752,18504,45024,20256,43272,41496,
     3  22032,39672,27264,23784,37920,29064,36120,30840,34368,32616,
     4  25560,26424,45936,45936,14928,18432,21984,43296,39720,25512,
     5  29064,36168,32616,45696,45960,43296,47712,47640,47520,47472,
     6  47304,46992,46704,46608,46440,46392,46128,46056,45840,14880,
     7  14976,18504,18408,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  50160,47904,50064,49968,49896,49872,49824,49800,49824,49800,
     1  45624,49896,44328,41568,40752,38640,37176,35184,33528,32040,
     2  29832,29112,27840,26256,25200,23616,20040,21336,20280,20256,
     3  20232,20112,20112,19992,19992,19968,46224,46344,46896,47448,
     4  48024,48264,48408,48480,48912,49176,49464,49944,48024,48240,
     5  48264,48312,49224,49368,49512,49656,49752,50112,50280,50376,
     6  45240,44760,44616,44424,43920,43632,43272,43176,42792,42312,
     7  42192,42144,42048,41760,44544,44520,44640,44664,44808,45000,
     8  45072,45264,45408,45504,45624,45648,45864,45864,46032,46200,
     9  46392,46488,46608,46752,46992,47448,47520,47472,47544,47544/
            data (jy(i),i=  101,  200)/
     +  47688,47760,41304,41184,40416,40248,40080,39744,39552,39384,
     1  39216,39000,44208,44136,44064,43968,43920,43728,43680,43488,
     2  43584,43440,43272,43200,42888,42840,42768,42720,42552,42384,
     3  42288,42168,42144,41976,41904,41904,41760,41760,41640,41448,
     4  41280,41280,41016,40944,40896,40848,38088,37608,37320,37056,
     5  36888,36432,36144,36048,35496,37344,37512,37776,37992,38376,
     6  38568,38688,38856,39216,39456,39792,39960,39984,40080,40224,
     7  40248,40344,40416,40704,34872,34416,33936,33216,32904,32832,
     8  32712,32352,33984,34104,34344,34608,34680,34752,35040,35040,
     9  34896,34920,35280,35448,35712,36000,36168,36288,36360,36552/
            data (jy(i),i=  201,  300)/
     +  36672,31728,31536,31224,30648,30552,30360,29856,29832,29904,
     1  29760,29520,29208,29088,29976,30240,30216,30024,29952,30048,
     2  30264,30408,30552,30648,30840,30936,31296,31680,31848,31872,
     3  31992,32136,32208,32712,32808,32928,33048,33384,29712,29568,
     4  29376,29400,29232,29040,28824,28680,28416,28176,27960,27888,
     5  27744,27552,27432,27720,27720,27648,27072,26760,26640,26544,
     6  26544,26424,26328,26352,29112,28776,28872,28752,28656,28392,
     7  28152,27600,27024,26880,26424,26328,26160,26112,26136,26064,
     8  25512,26136,25896,25512,25272,25008,24744,24600,24432,23880,
     9  24672,23760,23664,23472,22872,22632,22200,21720,20112,19824/
            data (jy(i),i=  301,  400)/
     +  19680,19368,19200,18912,18840,18744,18672,18576,18384,18264,
     1  18120,18096,18000,18120,18048,18120,18264,18624,19296,19584,
     2  19776,19968,20424,20688,20736,21024,23424,23304,23208,23016,
     3  22728,22416,22272,22104,21864,21576,21360,21168,21048,20712,
     4  20496,20400,20400,47688,47544,47448,47376,47352,47304,47280,
     5  46896,46848,46848,45600,45552,44112,43992,43896,43824,43752,
     6  43752,43752,43728,43728,41208,41256,41136,41136,41088,41040,
     7  41016,40560,40536,40440,40344,40248,40200,40176,40152,40152,
     8  38616,37728,37656,37632,37608,37584,39336,39336,37584,37536,
     9  39288,39288,37536,37512,39264,39264,36936,39624,39648,36864/
            data (jy(i),i=  401,  500)/
     +  39552,39576,36816,39480,39456,36768,36720,36696,39384,39384,
     1  36672,39336,39312,36648,37488,36624,36624,36600,39264,39264,
     2  36600,39264,39288,36600,34992,34128,34056,33384,33360,33264,
     3  33192,33192,33168,33144,33144,33120,33096,33096,33096,33072,
     4  33072,33072,29520,30408,30408,32352,32136,32016,32112,32016,
     5  32136,32112,32304,32376,32304,32448,32376,32376,32280,32400,
     6  32280,32328,32232,32328,32232,32232,32040,32040,31944,32304,
     7  32352,30552,30504,29712,30696,30672,29616,29592,30576,30600,
     8  29544,29544,30528,30528,29544,29496,29472,29472,30456,30456,
     9  29472,30408,30408,29448,30408,30408,29448,29424,29280,29496/
            data (jy(i),i=  501,  580)/
     +  29448,29400,29472,29400,29304,29376,29232,29304,29232,29352,
     1  29184,30576,28704,28680,29592,29448,29496,29256,29232,29160,
     2  29064,28968,27816,26160,26112,26040,26040,26016,25992,25992,
     3  25968,25944,25944,25944,25944,25920,25920,25896,25896,25896,
     4  25896,25872,25152,26040,23520,23424,23352,23328,23280,23256,
     5  23256,23232,23232,22464,22488,22440,21432,21600,21576,21504,
     6  21552,21840,21888,22080,22080,22152,22272,22248,22440,21768,
     7  21744,21672,21672,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    3,    4,   11,   37,   38,   39,   40,   41,   42,
     1     43,   44,   45,   46,   47,   12,    5,    9,    6,    9,
     2      7,    8,    2,   49,   50,   51,   52,   53,   54,   55,
     3     56,   57,   58,   59,    1,   11,   61,   62,   63,   64,
     4     65,   66,   67,   68,   69,   70,   71,   72,   73,   14,
     5     13,   75,   76,   77,   78,   79,   80,   81,   82,   83,
     6     84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
     7     94,   95,   96,   97,   98,   99,  100,  101,    2,   14,
     8    103,  104,  105,  106,  107,  108,  109,  110,  111,   16,
     9     13,  113,  114,  115,  116,  117,  118,  119,  120,  121/
            data (jb1(i),i=  101,  200)/
     +    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     1    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     2    142,  143,  144,  145,   15,   16,  147,  148,  149,  150,
     3    151,  152,  153,  154,   18,   17,  156,  157,  158,  159,
     4    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     5    170,  171,  172,  173,   15,   18,  175,  176,  177,  178,
     6    179,  180,  181,   20,   19,  183,  184,  185,  186,  187,
     7    188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
     8    198,  199,  200,   17,   20,  202,  203,  204,  205,  206,
     9    207,  208,  209,  210,  211,  212,  213,   22,   21,  215/
            data (jb1(i),i=  201,  300)/
     +    216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
     1    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     2    236,  237,   19,   21,  239,  240,  241,  242,  243,  244,
     3    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     4    255,  256,  257,  258,  259,  260,  261,  262,  263,   24,
     5     22,  265,  266,  267,  268,  269,  270,   23,   23,  272,
     6    273,  274,  275,  276,  277,  278,  279,  280,   25,   24,
     7    282,  283,  284,  285,  286,  287,  288,  289,   26,   25,
     8    291,  292,  293,  294,  295,  296,  297,   28,   29,  299,
     9    300,  301,  302,  303,  304,  305,  306,  307,  308,  309/
            data (jb1(i),i=  301,  400)/
     +    310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
     1    320,  321,  322,  323,  324,  325,   28,   26,  327,  328,
     2    329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
     3    339,  340,  341,   30,   29,   31,   31,   30,   27,   27,
     4     33,   34,   35,  344,  344,  345,  344,  346,  345,  347,
     5    346,  348,  349,  348,  350,  349,  351,  351,  352,  352,
     6    350,   11,  354,  354,  351,  344,  356,  345,  356,  346,
     7    357,  347,  358,  348,  359,  355,  349,  360,  353,  362,
     8    361,  352,  363,  365,  366,  359,  365,  354,  360,  367,
     9    368,  361,  370,  364,  356,  372,  372,  357,  373,  358/
            data (jb1(i),i=  401,  500)/
     +    374,  367,  375,  369,  362,  377,  363,  378,  371,  379,
     1     16,  381,  382,  383,  365,  384,  385,  386,  387,  368,
     2    386,  389,  390,  391,  370,  390,  393,  380,  395,  394,
     3    397,  397,  398,  373,  400,  401,  374,  397,  400,  375,
     4    404,  405,  403,  406,  408,  409,  376,  407,  408,  377,
     5    412,  413,  411,  394,  415,  414,  416,  379,  419,  418,
     6    421,  422,  378,  417,  418,  421,   18,  383,  425,  426,
     7    385,  397,  428,  428,  403,  429,  430,  407,  431,  427,
     8    432,  411,  434,  433,  389,  435,  436,  393,  417,  437,
     9    439,  424,  440,  438,  416,  441,  443,  444,  437,  426/
            data (jb1(i),i=  501,  600)/
     +     20,  447,  448,  449,  450,  451,  452,  453,  454,  455,
     1    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     2    466,  467,  468,  469,  470,  446,  446,  472,  433,  474,
     3    429,  475,  474,  474,  478,  479,  430,  477,  436,  482,
     4    483,  431,  478,  481,  485,  438,  486,  488,  489,  434,
     5    482,  491,  492,  442,  487,  491,  440,  495,  496,  494,
     6    443,  488,  497,  443,  500,  501,  502,  503,  504,  505,
     7    506,  507,  508,  509,  510,  499,  472,  512,  473,  513,
     8    481,  515,  516,  517,  518,  519,  520,  521,  514,  513,
     9    523,  524,  477,  524,  525,  514,  482,  526,  527,  485/
            data (jb1(i),i=  601,  680)/
     +    529,  528,  530,  443,  488,  531,  532,  487,  533,  535,
     1    499,  536,  537,  494,  538,  534,  539,  533,  541,  543,
     2    527,  543,  524,  545,  526,  545,  531,  546,  529,  548,
     3    532,  541,  547,  536,  550,  549,  537,  552,  551,  540,
     4    553,  554,  543,  554,  548,   28,  557,  558,  559,  560,
     5    561,  562,  563,  564,  565,  566,  567,  568,  554,  556,
     6    545,  570,  571,  549,  552,   33,  572,  546,  551,  547,
     7    550,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      3,    4,    5,   37,   38,   39,   40,   41,   42,   43,
     1     44,   45,   46,   47,   48,   48,    6,   12,    7,   10,
     2      8,   10,   49,   50,   51,   52,   53,   54,   55,   56,
     3     57,   58,   59,   60,   60,   61,   62,   63,   64,   65,
     4     66,   67,   68,   69,   70,   71,   72,   73,   74,   74,
     5     75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
     6     85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
     7     95,   96,   97,   98,   99,  100,  101,  102,  102,  103,
     8    104,  105,  106,  107,  108,  109,  110,  111,  112,  112,
     9    113,  114,  115,  116,  117,  118,  119,  120,  121,  122/
            data (jb2(i),i=  101,  200)/
     +    123,  124,  125,  126,  127,  128,  129,  130,  131,  132,
     1    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     2    143,  144,  145,  146,  146,  147,  148,  149,  150,  151,
     3    152,  153,  154,  155,  155,  156,  157,  158,  159,  160,
     4    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     5    171,  172,  173,  174,  174,  175,  176,  177,  178,  179,
     6    180,  181,  182,  182,  183,  184,  185,  186,  187,  188,
     7    189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
     8    199,  200,  201,  201,  202,  203,  204,  205,  206,  207,
     9    208,  209,  210,  211,  212,  213,  214,  214,  215,  216/
            data (jb2(i),i=  201,  300)/
     +    217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
     1    227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
     2    237,  238,  238,  239,  240,  241,  242,  243,  244,  245,
     3    246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
     4    256,  257,  258,  259,  260,  261,  262,  263,  264,  264,
     5    265,  266,  267,  268,  269,  270,  271,  271,  272,  273,
     6    274,  275,  276,  277,  278,  279,  280,  281,  281,  282,
     7    283,  284,  285,  286,  287,  288,  289,  290,  290,  291,
     8    292,  293,  294,  295,  296,  297,  298,  298,  299,  300,
     9    301,  302,  303,  304,  305,  306,  307,  308,  309,  310/
            data (jb2(i),i=  301,  400)/
     +    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     1    321,  322,  323,  324,  325,  326,  326,  327,  328,  329,
     2    330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
     3    340,  341,  342,  342,  343,  343,   32,   33,   32,   34,
     4     35,   36,   36,    1,    2,    3,  345,    4,  346,    5,
     5    347,    6,    7,  349,    8,  350,    9,  352,   10,  353,
     6    353,  354,   12,  355,  355,  356,   13,  357,  357,  358,
     7    358,  359,  359,  360,  360,  361,  362,  362,  363,  363,
     8    364,  364,  364,  366,   14,  367,  368,  368,  369,  369,
     9    370,  370,  371,  371,  372,   15,  373,  374,  374,  375/
            data (jb2(i),i=  401,  500)/
     +    375,  376,  376,  377,  378,  378,  379,  379,  380,  380,
     1    381,  382,  383,  384,  384,  385,  386,  387,  388,  388,
     2    389,  390,  391,  392,  392,  393,  394,  395,  396,  396,
     3     17,  398,  399,  399,  401,  402,  402,  400,  403,  404,
     4    405,  406,  406,  407,  409,  410,  410,  408,  411,  412,
     5    413,  414,  414,  415,  416,  417,  418,  419,  420,  420,
     6    422,  423,  423,  421,  424,  424,  425,  425,  426,  427,
     7    427,  428,   19,  429,  430,  430,  431,  432,  432,  433,
     8    434,  435,  435,  436,  436,  437,  438,  438,  439,  439,
     9    440,  441,  441,  442,  442,  442,  444,  445,  445,  446/
            data (jb2(i),i=  501,  600)/
     +    447,  448,  449,  450,  451,  452,  453,  454,  455,  456,
     1    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     2    467,  468,  469,  470,  471,  471,  472,  473,  473,   21,
     3    475,  476,  476,  477,  479,  480,  480,  478,  481,  483,
     4    484,  484,  482,  485,  486,  486,  487,  489,  490,  490,
     5    488,  492,  493,  493,  491,  494,  495,  496,  497,  497,
     6    498,  498,  499,  500,  501,  502,  503,  504,  505,  506,
     7    507,  508,  509,  510,  511,  511,  512,   22,  513,  514,
     8    515,  516,  517,  518,  519,  520,  521,  522,  522,  523,
     9     23,   24,  525,  525,  526,  527,  528,  528,  529,  530/
            data (jb2(i),i=  601,  680)/
     +    530,  531,  532,  533,  534,  534,  535,  535,  536,  537,
     1    538,  538,  539,  539,  540,  541,  540,  542,  542,   25,
     2    544,  544,  545,   26,  546,  546,  547,  547,  548,  549,
     3    549,  550,  550,  551,  551,  552,  552,  553,  553,  553,
     4     27,  555,  555,  556,  556,  557,  558,  559,  560,  561,
     5    562,  563,  564,  565,  566,  567,  568,  569,  569,   29,
     6    570,  571,   30,   31,   32,  572,  573,  573,   34,   35,
     7     36,    0,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ks(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(420) :: jx,jy
            integer(kind=iknd), save, dimension(520) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'kansas        '/
            data jrot,ipart/0,1/
            data kv/   1, 416,   0,   0,   0/
            data kb/   1, 520,   0,   0,   0/
            data iib/ 104,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  49392,46560,51336,36504,32952,43680,10872, 6696,40080,15120,
     1  18696,22200,29304,25728,51960, 6600,54408,53256,54528, 6480,
     2  54648, 6360,54768, 6240,54888, 6144,55008, 9264,46224,52128,
     3  49152,42504,12480,38424,15360,34080,18960,30480,22584,26160,
     4  49560,49632,49992,50256,50280,50424,50640,50712,50976,51336,
     5  51504,51936,52032,51960,52008,52344,52344,52080,52032,52200,
     6  52440,52488,52464,52344,52272,51960,51888,51816,51504, 6816,
     7  51384,51360,51216,51024,50976,51048,51360,51480,51792,52080,
     8  52128,52200,52416,52488,52512,52368,52416,52512,52896,52920,
     9  52872,53016,53208,53448,53664,53928,54000,54024,54096,54432/
            data (jx(i),i=  101,  200)/
     +  54480,54384, 6048,55128,49488,48072,46632,50928,51072,36576,
     1  32976,45072,46656,43776,10752,10896,41616,40176,39168,15048,
     2  15168,36576,18624,18744,32976,22152,22320,29304,25728,25872,
     3  29448,50616,48096,42912,42456,42480,42408,42312,42216,42168,
     4  42096,42120,41904,41904,42072,42000,41904,41784,41664,41640,
     5  41736,41688,41640,41376,40992,40704,40752,40920,40968,41064,
     6  41112,41208,41208,41256,41280,41520,39240,36600,33024,48048,
     7  47976,45192,39960,39960,40632,40680,40896,40896,42216,42216,
     8  33024,39240,29424,45216,42984,43128,43128,43224,43440,43680,
     9  43896,44088,44184,44256,44328,44544,44640,44712,44808,44904/
            data (jx(i),i=  201,  300)/
     +  45048,44856,44832,45024,45096,10248,10800,14520,15120,36624,
     1  18672,18792,22272,22368,29424,25848,25920,48648,48528,48120,
     2  48048,48024,48072,39744,39528,39504,39264,50688,49080,49728,
     3  49992,50064,50040,42936,52512,52608,52776,53160,52440,52488,
     4  52464,51552,51720,51792,51984,52176,52344,52440,52416,50712,
     5  50784,50856,51360,51408,51360,36624,48720,33072,29472,29472,
     6  45840,45816,45624,45480,45480,45312,42264,33072,51624,48768,
     7  45864,43248,43008,43008,42288, 9552,10104,12408,14424,15240,
     8  18096,18696,22296,29472,22392,25896,25944,39552,39528,39768,
     9  36696,33120,43296,40272,39576,33120,29520,29520,48792,48720/
            data (jx(i),i=  301,  400)/
     +  48768,45936,51696,51600,51648,48816,45960,22368,25944, 9480,
     1   9648,12336,12480,15216,18072,18192,22368,25944,26712,29520,
     2  29592,29592,43368,36768,34608,33168,31248,31248,31752,31752,
     3  29616,43392,42288,40248,40176,40320,51744,51720,51768,38184,
     4  38184,48864,48840,48912,22464,22464,45984,18144,23880,23880,
     5  26016,26712,38232,18144,34632,22440,26064,26016,46056,51816,
     6  51744,51792,48912, 9600, 9648, 9552,12480,12504,12408,15336,
     7  15360,15264,15312,33960,34680,51816,29664,22512,26064,34008,
     8  46104,42384,42408,38304,15312,18168,18192,18120,18888,29664,
     9  26064,22512,51912,49056,49008,46152, 9336, 9552,52008,52008/
            data (jx(i),i=  401,  420)/
     +  12432,12552,15288,34008,30432,29664,26064,22584,22512,46176,
     1  42456,15408,18984,18888,26160,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  46800,46680,43752,46440,46368,46584,46560,43080,46488,46440,
     1  46392,46344,46344,46320,42096,39504,39096,40344,36576,35880,
     2  33696,32304,30792,27984,27792,25104,25032,21744,21888,22104,
     3  21984,21792,21696,21672,21648,21624,21600,21600,21576,21576,
     4  46800,46656,46392,46344,46056,46008,46056,45864,45744,45768,
     5  46056,46056,45936,45744,45648,45504,45264,45168,45048,44952,
     6  45024,44880,44760,44664,44640,44808,44784,44304,44136,46680,
     7  43584,43488,43392,43392,43176,43032,42768,42456,42336,42024,
     8  41880,41832,41904,41832,41736,41496,41232,41064,40776,40656,
     9  40488,40416,40392,40128,40128,40224,40200,40080,40008,40056/
            data (jy(i),i=  101,  200)/
     +  39960,39744,21816,22248,43920,43872,43824,43992,43752,43560,
     1  43512,43056,43104,43008,42960,42960,42936,42912,42888,42864,
     2  42840,42840,42792,42792,42792,42744,42744,42744,42744,42744,
     3  42744,42048,41952,39720,39864,39696,39648,39768,39648,39648,
     4  39744,39840,39768,39840,39960,40032,40056,40248,40200,40296,
     5  40296,40368,40320,40584,41256,41592,42000,42048,42216,42168,
     6  42384,42408,42480,42480,42624,42744,40032,40680,40632,40272,
     7  41952,40176,40032,38928,38952,38904,39000,38832,38856,38640,
     8  39912,39312,39888,39384,39648,39744,39600,39600,39936,39792,
     9  40056,39984,40080,40056,39960,39936,39888,40032,39936,39960/
            data (jy(i),i=  201,  300)/
     +  39696,39744,39648,39528,39552,39384,39384,39264,39264,39264,
     1  39192,39192,39168,39168,39168,39168,39168,38976,39072,38928,
     2  39024,39456,39648,37152,37152,37992,38040,38928,39096,38808,
     3  38904,38808,38928,38664,38592,38928,39144,39072,39720,39720,
     4  40320,38472,38424,38616,38616,38496,38640,38640,38520,38280,
     5  38304,38424,38256,38280,38448,37824,37416,37776,37008,39168,
     6  37320,39120,39288,39312,39432,39336,37224,37032,36456,36336,
     7  36240,36168,36168,36864,36864,35832,35808,35736,35736,35712,
     8  35616,35616,35568,35568,35568,35568,35568,34992,36672,36672,
     9  34944,34896,34368,34296,34296,34176,34128,35568,33816,35976/
            data (jy(i),i=  301,  400)/
     +  35976,33744,33576,36096,36096,33456,31560,32712,32688,32208,
     1  32208,32160,32136,32088,32016,32016,31992,31968,31968,31968,
     2  31968,31248,31488,31344,31296,31296,31272,31152,31152,31272,
     3  28392,30768,30744,30696,32856,32856,30672,32448,32472,30648,
     4  31368,30552,32304,32304,30552,31968,30480,29880,30528,29832,
     5  29832,29808,29208,29160,29160,29112,28392,28392,27960,28872,
     6  28872,28152,28032,27864,28632,28632,27792,28560,28560,27744,
     7  28488,28512,29928,27672,27696,27672,27624,27648,27624,25536,
     8  26856,26784,25704,25608,25584,25536,28440,28464,25536,25464,
     9  25464,25440,25272,25152,25152,25080,25008,25008,24936,25272/
            data (jy(i),i=  401,  420)/
     +  24912,24912,24864,24816,24768,24744,24744,24744,24744,24360,
     1  24288,24864,24792,24792,24744,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    1,   41,   42,   43,   44,   45,   46,   47,   48,
     1     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     2     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     3      3,    2,    6,    7,    4,   10,    4,    5,   11,   13,
     4     12,    8,    7,    3,   71,   72,   73,   74,   75,   76,
     5     77,   78,   15,   15,   80,   81,   82,   83,   84,   85,
     6     86,   87,   88,   89,   90,   91,   92,   18,    8,   18,
     7     94,   95,   96,   97,   98,   99,  100,  101,   17,   17,
     8     16,   19,   20,   21,   22,   23,   24,   25,   28,   26,
     9     30,   27,   30,   29,   29,   28,   32,   33,   34,   35/
            data (jb1(i),i=  101,  200)/
     +     36,   37,   38,   39,  105,  105,  106,  107,  105,  108,
     1    109,  110,  110,  111,  112,  107,  112,  114,  115,  115,
     2    115,  114,  117,  118,  118,  120,  116,  120,  119,  110,
     3    123,  121,  123,  111,  126,  124,  126,  128,  129,  129,
     4    127,  125,  128,  128,  132,  132,  106,  134,  135,  136,
     5    137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
     6    147,  148,  149,  150,  151,  152,  153,  154,  155,  156,
     7    157,  158,  159,  160,  161,  162,  163,  164,  165,  117,
     8    119,  122,  168,  125,  170,  133,  170,  112,  167,  173,
     9    174,  175,  176,  177,  178,  179,  169,  167,  181,  131/
            data (jb1(i),i=  201,  300)/
     +    172,  134,  185,  186,  187,  188,  189,  190,  191,  192,
     1    193,  194,  195,  196,  197,  198,  199,  200,  201,  202,
     2    203,  204,  184,   16,  116,  206,  207,  121,  208,  182,
     3    168,  124,  209,  211,  127,  212,  213,  183,  130,  214,
     4    215,  216,  218,  219,  220,  221,  222,  170,  224,  225,
     5    226,  182,  132,  218,  229,  230,  231,  232,  228,  180,
     6    134,  235,  236,  237,  238,  235,  239,  240,  241,  242,
     7    243,  244,  245,  246,  247,  248,  235,  228,  250,  251,
     8    252,  253,  254,  242,  210,  218,  256,  181,  259,  215,
     9    257,  261,  262,  263,  264,  265,  184,  180,  224,  258/
            data (jb1(i),i=  301,  400)/
     +    259,  269,  242,  269,  257,  261,  271,  272,  273,  274,
     1    267,   20,  206,  276,  277,  208,  278,  279,  280,  212,
     2    281,  214,  282,  259,  283,  286,  217,  285,  284,  288,
     3    289,  224,  288,  256,  291,  268,  272,  293,  294,  288,
     4    292,  296,  297,  284,  299,  300,  270,  299,  271,  303,
     5    303,  304,  269,  303,  299,  302,  285,  287,  308,  276,
     6    310,  310,  278,  311,  312,  280,  313,  315,  281,  314,
     7    308,  316,  309,  318,  297,  319,  320,  321,  307,  293,
     8    291,  324,  325,  296,  322,  327,  328,  329,  326,  322,
     9    323,  332,  333,  334,  335,  294,  337,  337,  338,  303/
            data (jb1(i),i=  401,  500)/
     +    334,  340,  324,  337,  342,  343,  306,  345,  317,  342,
     1    307,  316,  345,  349,  350,  351,  319,  340,  348,  353,
     2    325,  345,  354,  331,  357,  351,  347,  337,  360,  361,
     3    362,  342,  359,  364,  365,  311,  364,  367,  368,  313,
     4    364,  370,  371,  372,  348,  367,  374,  355,  376,  362,
     5    374,  356,  331,  357,  378,  374,  359,  381,  333,  382,
     6    383,  353,  370,  386,  387,  354,  385,  380,  386,  377,
     7    390,  379,  378,  389,  376,  393,  394,  363,  395,  381,
     8     26,  364,  397,  399,  399,  393,  367,  398,  401,  385,
     9    402,  380,  404,  405,  390,  391,  408,  392,  407,  396/
            data (jb1(i),i=  501,  520)/
     +    410,  383,  397,  410,  399,  394,  411,  402,  384,   35,
     1    403,  404,   37,  413,  389,  405,  408,   40,  407,    0/
            data (jb2(i),i=    1,  100)/
     +      2,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     1     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     2     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     3     69,    6,    9,   10,    9,   11,    5,   13,   12,   14,
     4     14,   70,   70,   71,   72,   73,   74,   75,   76,   77,
     5     78,   79,   79,   80,   81,   82,   83,   84,   85,   86,
     6     87,   88,   89,   90,   91,   92,   93,   93,   16,   94,
     7     95,   96,   97,   98,   99,  100,  101,  102,  102,   19,
     8     20,   21,   22,   23,   24,   25,   26,   27,  103,  103,
     9    104,  104,   31,   31,   32,   33,   34,   35,   36,   37/
            data (jb2(i),i=  101,  200)/
     +     38,   39,   40,   40,    1,  106,  107,    2,  108,  109,
     1      3,    4,  111,    5,  113,  113,  114,    6,    7,    8,
     2    116,  117,  118,    9,  119,   10,  120,  121,  122,  122,
     3     11,  123,  124,  125,   12,  126,  127,   13,  130,   14,
     4    129,  131,  131,  130,   15,  133,  133,  135,  136,  137,
     5    138,  139,  140,  141,  142,  143,  144,  145,  146,  147,
     6    148,  149,  150,  151,  152,  153,  154,  155,  156,  157,
     7    158,  159,  160,  161,  162,  163,  164,  165,  166,  166,
     8    167,  168,  169,  169,  171,  171,  172,  172,  173,  174,
     9    175,  176,  177,  178,  179,  180,  181,  182,  183,  183/
            data (jb2(i),i=  201,  300)/
     +    184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
     1    194,  195,  196,  197,  198,  199,  200,  201,  202,  203,
     2    204,  205,  205,  206,  207,  207,  208,  209,  209,  210,
     3    210,  211,  211,  212,  213,  213,  214,  215,  216,  216,
     4    217,  217,  219,  220,  221,  222,  223,  223,  225,  226,
     5    227,  227,  228,  229,  230,  231,  232,  233,  233,  234,
     6    234,  236,  237,  238,   17,  239,  240,  241,   18,  243,
     7    244,  245,  246,  247,  248,  249,  249,  250,  251,  252,
     8    253,  254,  255,  255,  256,  257,  258,  258,  260,  260,
     9    261,  262,  263,  264,  265,  266,  266,  267,  267,  268/
            data (jb2(i),i=  301,  400)/
     +    268,   19,  269,  270,  270,  271,  272,  273,  274,  275,
     1    275,  276,  277,  277,  278,  279,  279,  280,  281,  282,
     2    282,  283,  283,  284,  285,  287,  286,  286,  287,  289,
     3    290,  290,  291,  291,  292,  292,  293,  294,  295,  295,
     4    296,  297,  298,  298,  300,  301,  301,  302,  302,   21,
     5    304,  305,  305,  306,  306,  307,  308,  309,  309,  310,
     6     22,  311,  312,  312,  313,  314,  314,  316,  315,  315,
     7    317,  317,  318,  319,  320,  320,  321,  322,  323,  323,
     8    324,  325,  326,  326,  327,  328,  329,  330,  330,  331,
     9    332,  333,  334,  335,  336,  336,   23,  338,  339,  339/
            data (jb2(i),i=  401,  500)/
     +    340,  341,  341,  342,  343,  344,  344,  346,  346,  347,
     1    347,  348,  349,  350,  351,  352,  352,  353,  354,  355,
     2    355,  356,  356,  357,  358,  358,  359,  360,  361,  362,
     3    363,  363,  363,  365,  366,  366,   24,  368,  369,  369,
     4    367,  371,  372,  373,  373,  370,  375,  375,   25,  376,
     5    377,  378,  377,  379,  379,  380,  381,  382,  382,  383,
     6    384,  384,  385,  387,  388,  388,  386,  384,  389,  390,
     7    391,  391,  392,  392,  393,  394,  395,  395,  396,  396,
     8    397,  398,  398,   27,  400,  400,  401,  401,  402,  403,
     9    403,  404,  405,  406,  406,  407,  409,  409,  408,  410/
            data (jb2(i),i=  501,  520)/
     +    411,  411,   28,   29,   30,   31,   32,   33,   34,  412,
     1    412,   36,  413,  414,  414,   38,   39,  415,  415,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ky(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(2970) :: jx,jy
            integer(kind=iknd), save, dimension(3080) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'kentucky      '/
            data jrot,ipart/1,2/
            data kv/   1,2952,2962,   0,   0/
            data kb/   1,3071,3081,   0,   0/
            data iib/ 465,  10,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  21672,23976,21912,24264,25344,25032,24480,25680,26376,25200,
     1  27984,27432,30216,29544,33600,33696,33384,33240,35496,34464,
     2  34824,35424,34728,38976,41472,40008,43992,43488,41856,44880,
     3  48480,48384,46608,48480,47496,48360,47880,48216,48240,48288,
     4  48312,48360,48408,48456,48456,48024,49656,49656,49728,21840,
     5  21624,21696,21384,21384,21552,21912,22080,22152,22224,22392,
     6  22632,23088,23736,21720,21600,21216,21144,21216,21480,21600,
     7  22104,22272,22584,23016,23184,23544,23688,23808,23832,23928,
     8  24600,24720,25008,25008,24816,24384,24600,24888,25032,25080,
     9  24984,25152,25176,25728,26088,26160,26088,25752,25656,25632/
            data (jx(i),i=  101,  200)/
     +  25128,25536,25728,26208,26280,26472,26016,25872,25608,25656,
     1  25920,25992,26064,26232,26544,26664,26328,26448,26376,26208,
     2  25824,25560,25128,25176,24912,24840,25032,25512,25776,26328,
     3  26544,26736,26880,26880,27024,25728,25704,25824,26040,26256,
     4  26544,27192,27576,27792,28128,28488,28632,28776,28848,29088,
     5  27576,27768,28320,29040,29352,29616,30024,30168,30360,30504,
     6  30576,30984,31032,31344,31392,31512,31560,31656,31848,32040,
     7  32448,32712,32784,32808,32928,32976,33120,33240,29832,30120,
     8  30528,30768,30552,30624,30696,31224,31536,31872,32664,33384,
     9  33768,33840,34032,34128,33600,33528,33576,33168,33024,32736/
            data (jx(i),i=  201,  300)/
     +  32160,31944,31584,31680,31872,32040,32208,32304,32328,32568,
     1  32376,32352,32448,32592,32760,32952,33168,35280,34800,34704,
     2  34656,34848,34872,34632,33864,33744,33888,34368,33264,33408,
     3  33984,34344,34464,34584,34560,34608,34752,35208,35400,33456,
     4  33480,33528,33576,33672,33720,33816,33696,33984,34128,34176,
     5  34248,34320,34392,34608,34776,34704,34848,35016,35136,35160,
     6  35232,35256,34416,34320,34344,34704,34416,34080,33984,34008,
     7  34248,34536,34704,34896,35136,35472,35592,35496,35352,34920,
     8  34752,34848,34848,35040,34992,34560,34464,34488,34632,34800,
     9  35136,35784,35952,36048,36000,35616,35448,35352,34968,35352/
            data (jx(i),i=  301,  400)/
     +  35736,35856,36120,35808,35832,36144,36408,36768,37248,37440,
     1  38136,38712,39288,39552,39696,35568,35832,35904,36000,36072,
     2  36168,36168,36264,36168,36360,36312,36408,36648,36696,36648,
     3  36456,36432,36624,36720,36720,36840,36864,37008,36984,37056,
     4  37224,37296,37464,37344,37416,37392,37560,37656,37464,37560,
     5  37536,37584,37512,37512,37440,37488,40392,40464,40560,40920,
     6  43104,42840,42816,42384,40008,39792,39912,40032,40224,40656,
     7  41280,41496,42168,42720,42960,43200,43560,43680,43656,41928,
     8  42360,42672,42768,42888,43152,43176,43344,43368,43560,43608,
     9  43776,41832,42048,42432,42984,43440,43632,43944,44160,44448/
            data (jx(i),i=  401,  500)/
     +  44544,44664,45288,45792,45912,45936,46056,46272,46440,46512,
     1  44208,44832,45048,45240,45288,45384,45312,45360,45480,45600,
     2  45840,46128,46416,46560,46632,47208,47424,48360,48048,46824,
     3  46920,46848,46944,47088,47304,47592,47832,48192,48312,48264,
     4  48384,48192,47448,47520,47760,47784,48024,48456,48504,49536,
     5  49608,48336,48240,48168,48240,48840,48936,48912,48816,48696,
     6  48216,48840,49416,49728,49848,21912,22080,22224,22464,22608,
     7  22704,22992,23040,22824,22872,23184,23232,23688,24168,24264,
     8  24408,24600,24624,24528,24504,24744,24672,24000,24840,24936,
     9  24960,24888,24960,25104,25104,24288,24384,24384,24552,25272/
            data (jx(i),i=  501,  600)/
     +  25752,25704,25800,25848,25944,25848,26016,25992,26112,26136,
     1  26232,26232,26328,26280,26400,26208,26928,24528,26928,26856,
     2  27024,27048,27096,26520,26544,26496,26568,26688,26760,26736,
     3  26832,26952,26976,27048,27168,27144,27264,27336,27168,27096,
     4  26928,26832,25800,27024,26976,27024,26904,27048,27048,26904,
     5  26952,26904,26832,26952,26880,26904,26832,26904,26784,26904,
     6  27024,27072,27192,27216,27288,27432,27384,27336,27360,27456,
     7  27336,27264,26616,27552,27600,25488,25632,25752,25848,25872,
     8  26112,26208,26448,26664,26928,27120,27264,27312,27624,27384,
     9  27336,27408,27408,27552,27576,27648,27720,27984,27576,27024/
            data (jx(i),i=  601,  700)/
     +  26976,28152,27960,27912,27960,28248,28224,28296,28032,28032,
     1  28128,28128,27816,28368,28368,28248,27744,27816,27744,27696,
     2  27624,27528,27480,26832,27552,27624,28008,27960,28032,28056,
     3  28128,28080,28176,28224,28152,28224,28296,28392,28584,28440,
     4  28800,28776,28560,28680,28512,28584,28416,28440,28896,28656,
     5  28392,28248,28656,28656,28728,27984,27624,27600,27744,27792,
     6  27744,27912,27960,28080,28416,28560,28704,28752,28704,28800,
     7  28800,29040,29352,29664,29616,29208,29160,28944,28872,27672,
     8  28008,28080,28152,28176,28296,28488,29112,29232,29424,29616,
     9  29520,29544,29664,27336,27480,27360,27504,27576,27648,28104/
            data (jx(i),i=  701,  800)/
     +  28128,27984,27984,28272,28488,28608,28824,28920,28920,28656,
     1  28560,28536,28584,28680,28776,28872,29016,29448,29544,29688,
     2  29688,29496,28824,28656,28824,29256,29736,29856,29736,29760,
     3  29664,29688,29736,29688,29496,29928,31008,31032,30864,30768,
     4  30840,30672,30384,30024,29952,28752,29160,29400,29352,29376,
     5  29472,29544,29376,29520,29496,29688,29616,29784,29880,30072,
     6  29160,29280,29328,29280,29400,29664,29760,30096,30216,30288,
     7  30432,30600,30840,30888,30840,31128,31128,31200,29016,29184,
     8  30288,30288,30336,30336,30192,30144,30048,29952,30000,28416,
     9  28512,28608,28776,29208,29352,29688,30096,30384,30000,29976/
            data (jx(i),i=  801,  900)/
     +  30024,30216,30216,30336,30216,30360,30408,30312,30408,30264,
     1  30336,30288,30336,30456,30360,30336,30456,30336,30480,30552,
     2  30000,30024,29976,29952,30864,30816,30888,30840,30936,31080,
     3  30960,30624,30504,30528,30216,30192,30336,30360,30576,30792,
     4  30960,31080,30984,30840,30864,30576,30480,30408,31152,31104,
     5  31128,31056,30936,30936,30552,30648,31008,31080,31176,31224,
     6  31200,31104,31056,31008,30936,30936,31128,30936,30960,30792,
     7  30744,30552,30576,30456,30384,30408,30456,30528,30552,30432,
     8  30384,30264,30240,30120,30048,30072,29544,30000,30024,30216,
     9  30264,30120,30096,30168,30072,30192,30168,30072,30072,30168/
            data (jx(i),i=  901, 1000)/
     +  30192,30408,30336,30336,30432,30504,30600,30528,30408,30480,
     1  30600,30720,30816,31080,31104,30960,30912,31104,31032,31368,
     2  31392,31080,31056,31176,31176,31248,31368,31656,31680,31824,
     3  32616,32424,32448,32256,32208,32424,32208,32160,31992,31872,
     4  31968,31920,31776,31608,31608,31752,31872,31800,31776,31608,
     5  31464,31488,31368,31368,31176,31296,31320,32928,32904,33000,
     6  33024,32856,33048,32928,32904,32496,32544,32448,32280,32016,
     7  31920,30768,32016,31416,31896,32088,29952,30576,31656,31800,
     8  32160,32064,32208,31464,31488,31608,31536,31632,31656,31584,
     9  31488,31560,31584,31560,31728,31704,31752,31752,31872,31848/
            data (jx(i),i= 1001, 1100)/
     +  32016,32016,32136,32184,32112,32208,32256,31992,32256,32328,
     1  32160,32160,32376,32400,31128,31296,31488,31680,31968,32208,
     2  32472,32472,32400,32496,32568,32664,32256,32352,32520,32424,
     3  32256,33264,33312,33120,33192,33120,33096,32904,32952,32928,
     4  33072,33048,32544,32712,32736,32712,32616,32640,32760,34656,
     5  34344,33768,32904,32640,32424,32448,31992,31728,31512,31272,
     6  32616,32856,32880,32784,32928,32976,32928,32808,32616,33168,
     7  32256,32880,33120,31296,31608,31656,31560,31632,31656,31704,
     8  31800,32376,32808,33192,33384,33336,33192,33432,33696,33216,
     9  32712,32832,32496,32568,33504,33504,33720,33768,33984,34296/
            data (jx(i),i= 1101, 1200)/
     +  34224,34296,34488,34536,34728,34848,34824,34944,35184,35160,
     1  35328,35400,35664,35016,35640,35856,32544,32424,32520,32616,
     2  32760,32832,32904,32952,33024,33168,33408,33504,33696,33792,
     3  33816,33864,33576,33552,33648,33696,33528,33552,33456,33336,
     4  34056,34128,34008,33912,33384,33360,33408,33216,33312,33576,
     5  33576,33672,33816,33936,34128,33072,32952,32976,33264,33768,
     6  34032,34248,34056,33912,34248,34296,34296,34176,34176,34008,
     7  34152,34248,34368,34800,34896,34872,34992,34992,35088,35088,
     8  34512,34320,34080,34104,33912,32952,33024,33168,33384,33768,
     9  33744,33792,33864,33888,33960,34056,34128,34224,34224,34320/
            data (jx(i),i= 1201, 1300)/
     +  34392,34488,34560,34656,34152,34080,34200,34152,34056,34080,
     1  34032,34032,34224,34440,34632,34704,34656,34704,34728,34728,
     2  34464,34536,34704,34752,34776,34680,34272,34512,34704,34584,
     3  34776,34656,34704,34848,34776,34944,34824,34920,34968,34752,
     4  35040,35112,35064,35136,35040,34968,35088,34080,34200,34464,
     5  34800,34728,35064,33600,34080,34296,34416,34824,35064,34800,
     6  34800,35064,34968,34872,34536,34464,34512,34680,35136,34992,
     7  34872,34680,34656,34512,34488,34704,34608,34392,34368,34464,
     8  34416,34296,34200,34056,33888,35112,34992,35112,34944,35232,
     9  35232,34992,35064,35232,35376,35472,35616,36288,36144,36120/
            data (jx(i),i= 1301, 1400)/
     +  36048,35832,35976,35928,35808,35784,35880,35928,35880,35448,
     1  34944,34944,34992,34920,35664,35664,35232,35160,35040,34968,
     2  34896,34584,34416,34272,34200,34080,34008,36288,35016,34464,
     3  34680,35160,35160,35256,35448,35640,35712,35784,35856,35928,
     4  35808,35736,35568,35616,35544,35184,35040,35016,35136,34680,
     5  35016,35184,35976,36024,35784,35712,35592,35616,35520,35520,
     6  35688,35640,35832,35832,36144,36048,35976,34248,34392,34416,
     7  34392,34272,34200,34176,34488,34872,34992,35016,35328,35304,
     8  35568,35832,36048,36024,36168,36120,35976,35856,35712,35496,
     9  35424,35448,35232,35280,35136,35088,34920,34848,34824,34752/
            data (jx(i),i= 1401, 1500)/
     +  36000,36168,36216,36144,36120,36120,36216,36264,36192,36336,
     1  36192,36288,36000,35904,35928,35856,35544,35472,35928,36072,
     2  36168,36360,36312,36120,36120,36216,36192,36072,36000,35856,
     3  35712,35640,35712,35616,35520,35736,35808,35688,35304,35328,
     4  34800,34728,34824,34776,34680,34632,34896,35040,35112,35232,
     5  35136,34968,35136,34992,35064,35016,35088,35232,35256,35160,
     6  35328,35400,35496,35520,35640,35808,35880,35880,35952,35928,
     7  36072,36144,36216,36120,36408,36384,36504,35904,35928,36000,
     8  36072,36072,36144,36144,36288,36504,36528,36552,35952,35424,
     9  35472,35568,35544,35448,35376,35256,35136,34992,34944,34776/
            data (jx(i),i= 1501, 1600)/
     +  34704,34824,34872,37056,36792,36648,35640,35640,35688,35760,
     1  35952,36024,36192,36264,36312,36288,36336,36408,36456,36408,
     2  36552,36504,36576,36648,36528,36336,36552,36672,37008,34824,
     3  35112,35304,35304,35496,35520,35664,35736,35880,35928,36024,
     4  36072,36288,36504,36528,36600,36696,36912,37128,36528,36528,
     5  36432,36360,36576,36720,36744,36840,36912,36960,37128,37248,
     6  36984,37344,37392,37416,37344,37320,37176,37296,37392,37344,
     7  37224,37128,37080,37128,37056,36984,36840,36912,36864,36744,
     8  36792,36744,36624,35472,35952,37416,37248,37296,37512,37512,
     9  37560,37344,37272,37104,36960,37584,36240,36168,36144,36288/
            data (jx(i),i= 1601, 1700)/
     +  36336,36336,36264,36216,36576,37248,37992,37200,36912,36792,
     1  36600,36408,36360,36288,36192,36072,35904,35784,35736,35688,
     2  35616,35424,35304,35424,35376,35184,35040,35064,38064,38016,
     3  38112,38496,38112,38064,38112,38256,38232,38472,38352,38424,
     4  38352,38352,38976,39312,39360,39504,39624,39552,39600,36312,
     5  36840,36864,37080,37104,37176,37176,37392,37464,38208,38016,
     6  37800,37896,36840,37008,37272,36984,37128,37224,37248,37176,
     7  37392,37464,37416,37464,37848,37872,38064,38160,38208,38304,
     8  38304,37728,38016,38088,38136,38328,35952,36072,36144,36216,
     9  36288,36360,36552,36576,36696,36672,36840,36936,36888,36984/
            data (jx(i),i= 1701, 1800)/
     +  37080,37176,37152,37272,37296,37344,37368,37512,37536,37728,
     1  37776,37992,38352,38376,38064,37944,37872,37824,37896,37848,
     2  37752,37656,37584,37536,37536,37608,37584,37488,38400,38232,
     3  38016,38064,38136,38136,38016,37992,38016,37872,37776,37800,
     4  37920,37920,38016,38088,38112,38256,38208,38256,38352,38280,
     5  38376,38424,38328,38304,38376,38400,38136,38112,38208,38136,
     6  37800,38352,36984,38424,38448,36864,37224,37488,37560,37752,
     7  37704,38232,38448,38280,38376,38328,38472,36408,36600,36696,
     8  36792,36816,37200,37392,37512,37632,37848,37896,37944,37992,
     9  38112,38328,38424,38496,38400,38472,38496,38544,38568,38400/
            data (jx(i),i= 1801, 1900)/
     +  38376,38352,38472,38376,38400,38520,38520,38592,38496,38544,
     1  38472,36672,36936,36840,36936,37512,37464,37512,37680,37752,
     2  37656,37800,37752,37776,37848,37896,37968,38040,38304,38448,
     3  38568,38496,38544,38616,38760,38688,38664,38424,38328,38328,
     4  38424,38472,38472,38352,38184,38136,38208,38448,38496,38400,
     5  38520,38688,38688,38784,38664,38496,37416,37536,37560,37656,
     6  37752,37728,37824,38880,38904,38976,38640,38688,38880,38952,
     7  38976,39288,39432,39696,39792,39936,40128,40344,39072,38784,
     8  38616,38904,39216,39312,39624,39960,40152,40152,40248,40320,
     9  40344,40416,40392,40536,40584,40656,39288,38904,39168,39216/
            data (jx(i),i= 1901, 2000)/
     +  39312,39456,40104,40248,38472,38616,38832,39072,39360,38976,
     1  38856,38904,38736,38592,38544,38976,39120,39048,39192,39336,
     2  39384,39288,39432,38880,38424,38208,38160,38208,38112,38112,
     3  38304,38280,38352,38304,38376,39336,39432,39504,39408,39192,
     4  39336,37416,37488,37536,37632,37704,37872,38064,38232,38304,
     5  38544,39336,39360,39696,39864,39696,39336,39456,39336,39312,
     6  39216,39240,39312,39360,39312,39456,39672,39864,39816,39576,
     7  39576,39432,39408,39336,39504,39456,39816,39864,39864,39816,
     8  39384,39384,39240,39264,39456,39528,40008,38448,38520,38592,
     9  38688,38616,38568,38520,38376,38376,38496,38496,38568,38640/
            data (jx(i),i= 2001, 2100)/
     +  40224,40392,40272,40248,39840,39888,39840,39912,40104,40080,
     1  40248,40248,39792,39792,39672,39552,39048,39384,38592,38736,
     2  38784,38928,39048,39240,39264,39456,39888,40152,40152,40272,
     3  39432,39720,39864,40032,40104,40056,39960,39912,40128,40224,
     4  40368,40368,40272,40368,40056,40032,40368,40584,40512,40344,
     5  40320,40200,39816,39744,39624,39528,39528,39432,39120,38904,
     6  38784,38496,38208,38160,38184,36672,36432,36288,36264,38544,
     7  38664,38976,39240,39264,39264,39096,39048,39096,39096,39192,
     8  39240,39360,39528,39648,39864,40248,40320,40368,40536,40656,
     9  40512,40488,40584,40704,40728,40752,40896,41016,41040,41184/
            data (jx(i),i= 2101, 2200)/
     +  41352,41352,39216,39504,40680,40512,40512,40584,40656,40776,
     1  40776,40848,40896,40800,40848,40944,41112,41088,40968,40944,
     2  41232,41520,41568,41472,41544,41664,41664,41544,41736,41784,
     3  41856,41928,42024,42120,42192,42312,42408,42504,40632,40728,
     4  41376,41208,41040,40992,40800,40752,40800,40776,40632,40440,
     5  40608,40584,40704,40656,40776,40944,40968,41256,41328,41448,
     6  41376,41544,41520,41664,41688,41640,41736,41736,41856,41928,
     7  42024,42048,42120,42120,42216,42264,42336,42432,42648,42600,
     8  42720,42936,43008,43104,43152,43392,43536,43584,39792,39840,
     9  40080,40080,40176,40248,40200,40224,40200,40296,40248,40536/
            data (jx(i),i= 2201, 2300)/
     +  40608,40656,40680,40776,40728,40656,40656,40728,40656,40824,
     1  40848,40728,40800,40752,40728,40824,40008,40032,40152,40176,
     2  40440,40992,41016,40872,40920,40776,40872,40560,41136,40968,
     3  40968,40848,40848,40344,40152,40104,40200,40272,40464,40560,
     4  40656,40632,40776,40776,40968,41088,41040,41160,41256,41232,
     5  41304,41160,40872,40728,40728,40464,40440,40416,41208,40872,
     6  40968,41184,41184,40992,40944,41136,41352,40176,40488,40584,
     7  40776,41232,41256,41112,41112,41280,41448,41424,41520,41544,
     8  41640,41688,40392,38592,39240,39672,40056,40368,41016,41160,
     9  42120,42648,40848,40800,41040,41208,41496,41544,41664,41688/
            data (jx(i),i= 2301, 2400)/
     +  41880,41712,42408,42192,42096,41976,41808,41784,41304,41352,
     1  41016,40944,40872,40968,41136,41208,40416,40584,40872,40992,
     2  40944,40608,40488,40560,41016,41568,41712,41664,41928,41880,
     3  42048,42072,41016,41400,41448,41496,41544,41520,41688,41736,
     4  41712,41904,42288,39744,40464,41688,41784,41832,41952,41976,
     5  41544,42192,42312,40176,40512,41160,41304,41496,41520,41592,
     6  42432,41880,41952,41928,42048,42144,42192,42408,42480,41856,
     7  42168,42264,42552,42840,42840,42768,42864,42912,43032,43248,
     8  43440,42576,42624,42840,42792,42792,42408,42168,42024,41856,
     9  41784,41736,41424,41280,41256,41112,41040,41136,40848,40488/
            data (jx(i),i= 2401, 2500)/
     +  40416,42840,42744,42600,42432,42144,41976,41880,41472,40776,
     1  40440,40320,40128,40128,42840,42792,42768,42552,42528,42600,
     2  42384,42432,42240,42216,42360,42336,42240,42144,41856,41784,
     3  41568,41328,41232,41016,41040,41208,41016,40776,43776,43872,
     4  43008,43032,42960,42888,42768,42840,42816,42696,42744,42672,
     5  42504,43032,43176,43128,42552,43200,42864,43056,42888,43344,
     6  43128,43032,42960,42792,42888,43272,43320,43248,43296,43632,
     7  43680,43632,43704,42240,42408,42408,42504,42456,42504,42576,
     8  42528,42840,43008,43128,43056,43200,43272,43272,43392,43512,
     9  43632,43728,43584,43776,43632,43320,43416,43536,43584,43680/
            data (jx(i),i= 2501, 2600)/
     +  43824,41952,42072,42432,42528,42672,42792,42912,43104,43272,
     1  43392,43584,43872,43560,43728,43848,43992,43944,44304,44112,
     2  43968,43992,44040,43896,43896,43776,43632,44040,44088,43032,
     3  43392,43488,43824,43920,44112,44400,44592,44064,43800,43680,
     4  43704,43920,43776,44184,44280,44424,44232,44424,44472,44352,
     5  44376,44136,43896,43704,43848,43752,43608,43608,43728,43680,
     6  43584,43584,43440,42672,42840,42672,42816,42840,42816,42408,
     7  42480,42576,42504,42576,42552,42456,42480,42552,42480,42528,
     8  42816,44472,43872,44832,43560,43680,43656,44088,44304,44208,
     9  44328,44328,44568,44496,44544,44448,44472,44424,44448,44544/
            data (jx(i),i= 2601, 2700)/
     +  44568,44472,44472,44568,44640,44736,44784,44688,44712,44640,
     1  44688,44544,44712,44760,44640,44544,44424,44568,44544,44736,
     2  44784,45192,45288,45504,45672,45648,45720,45816,45936,46032,
     3  46080,46032,46200,46200,46248,46440,46536,46656,46632,46752,
     4  46992,47400,41448,41712,42144,42648,42816,43104,43200,43440,
     5  43440,43848,43896,43944,44592,42576,42768,42840,42864,42936,
     6  43056,43128,43176,43200,43296,43416,43560,43704,43704,43920,
     7  43848,43872,44088,44160,44280,44472,44592,44592,44496,44712,
     8  44544,44424,44424,45504,45336,45336,45456,45624,44712,44808,
     9  44832,44832,44712,44712,42552,43704,44880,47112,47184,47160/
            data (jx(i),i= 2701, 2800)/
     +  46992,46800,46728,46632,46152,46080,46152,46056,45864,45768,
     1  45744,45528,45432,45408,45264,45192,45168,44880,44784,44688,
     2  44592,44568,44904,43752,43680,43776,43776,44160,44376,44736,
     3  44976,45072,45096,45024,45168,45048,45048,44736,44856,44928,
     4  45000,44976,44712,45000,43656,44304,44856,45024,43968,44352,
     5  45144,45144,44880,44928,45192,45048,45000,44952,45096,45048,
     6  45120,44856,44808,45192,45840,44880,45336,45360,45840,44712,
     7  44688,44568,44808,44928,45096,45288,45408,45552,45696,45720,
     8  45888,45912,45912,46176,46248,46536,46584,46752,46752,47184,
     9  47664,48120,48288,45720,45096,45504,45432,45672,45888,45936/
            data (jx(i),i= 2801, 2900)/
     +  45888,48240,47976,47904,47856,47688,47592,47472,47376,47328,
     1  46920,46368,46104,42912,43224,43224,43680,46104,45792,45624,
     2  45552,46176,46344,46296,46128,45768,45792,45984,45864,45792,
     3  45504,46176,46224,46776,46728,46584,46464,45288,45144,45168,
     4  45240,45384,45480,45384,45576,45600,45816,46872,46296,46536,
     5  47016,46968,46872,46704,46416,46416,46344,46368,46272,46320,
     6  46248,46104,45936,45840,45816,45720,47064,47136,47136,46488,
     7  47136,45384,45552,46008,46248,46800,47040,47160,46176,46320,
     8  47424,45264,45360,45456,45408,45216,45168,45360,45480,45552,
     9  45600,45576,45888,45840,45696,45504,45480,45528,45600,45600/
            data (jx(i),i= 2901, 2970)/
     +  45744,45792,45984,46272,46344,46512,46512,46656,46680,46800,
     1  46824,46896,47016,46968,47016,47208,44808,45768,47136,47544,
     2  47016,47928,47904,48216,45816,46152,47400,46584,46968,47184,
     3  48072,48168,47688,47256,47208,47256,46920,46824,46848,46776,
     4  48312,48144,47904,47832,47472,48048,48672,48696,48816,48864,
     5  47016,49560,49584,49128,48936,48744,48696,48792,48888,49056,
     6  49320,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  50112,52464,49104,47736,45816,55248,52488,43224,57504,62639,
     1  42432,65831,66479,40728,38136,37704,67559,33528,69071,29352,
     2  26592,32112,21288,20040,67343,17520,64847,15696,12552,11040,
     3  53208,46632,10800,48456,59856,23160,19920,34272,31248,28656,
     4  26280,43968,38088,42744,55800,10296,13248,13416,16248,49488,
     5  49776,49992,50376,50520,50664,50712,50784,50928,51384,51672,
     6  51816,51936,52392,48840,48552,48264,48072,47952,47760,47472,
     7  46872,46896,47160,47376,47376,47040,47040,47136,47496,47760,
     8  52536,52704,53808,54048,54792,47568,47448,47592,47592,47520,
     9  47016,46560,46080,45216,44808,44568,44232,43968,43824,43512/
            data (jy(i),i=  101,  200)/
     +  55656,55848,56256,56448,56880,57336,57576,57672,58512,58680,
     1  59040,59640,59880,60144,60264,60456,60864,61296,61680,61824,
     2  61992,62424,62783,63095,63503,63863,63983,63935,64103,64175,
     3  64247,64463,64751,65303,65567,43008,42528,42336,42216,42216,
     4  42360,42408,42576,42552,42120,41952,41832,41184,41040,40872,
     5  65951,66311,66479,66503,66719,66671,66743,66671,66431,66575,
     6  66575,66455,66215,66263,66383,66455,66599,66695,66743,67031,
     7  67175,67343,67343,67583,67631,67823,67655,67751,40728,40608,
     8  40272,39840,39504,39216,39120,38976,38664,38496,38520,38352,
     9  37440,37392,37392,37296,36912,36624,36168,35496,35352,35304/
            data (jy(i),i=  201,  300)/
     +  35328,35160,34632,34512,34512,34920,34944,34800,34488,34296,
     1  33960,33840,33744,33744,33984,34008,33840,32016,32160,32136,
     2  31920,31608,31464,31248,30912,30720,30384,29928,33336,33264,
     3  33240,33384,33384,33192,32760,32640,32592,32568,32304,67607,
     4  67511,67511,67703,67655,67751,67775,67847,68231,68255,68351,
     5  68231,68279,68279,68447,68447,68567,68663,68975,68999,69119,
     6  69047,69239,25920,25632,25392,24816,24408,24240,24120,24072,
     7  24024,23832,23928,24120,24168,23976,23616,23400,23352,23496,
     8  23400,23040,22752,22416,22056,21768,21576,21480,29040,28824,
     9  28800,28632,28464,28272,28056,27888,27768,27264,21168,21408/
            data (jy(i),i=  301,  400)/
     +  21432,21240,21024,20616,20424,20352,20184,19632,19320,19296,
     1  19488,19992,19872,18096,17856,69191,69287,69383,69359,69407,
     2  69359,69407,69455,69527,69767,69935,70055,70127,70199,70391,
     3  70343,70463,70511,70463,70583,70559,70655,70655,70823,70895,
     4  70919,70775,70895,71111,71159,71351,71471,71639,71663,71735,
     5  71879,71927,72023,72095,72263,72335,69407,69239,69215,68303,
     6  15192,14568,14256,13728,17424,17112,16800,16656,16536,16464,
     7  16200,16200,16704,16920,16896,16776,16560,16320,15888,66791,
     8  66047,66047,66119,66047,66071,65927,65879,65759,65567,65207,
     9  65111,12096,11688,11280,10968,10536,10416,10368,10464,10776/
            data (jy(i),i=  401,  500)/
     +  10992,11040,10872,10776,10632,10416,10344,10344,10392,10488,
     1  64967,64823,64535,64079,63815,63695,63479,63167,63119,62927,
     2  62927,62663,62687,62615,62112,60552,60240,21792,21816,10848,
     3  10776,10368,10224,10152,10152,10344,10416,33432,33144,33096,
     4  32976,32736,59520,59256,58896,58752,58248,57888,42120, 9216,
     5   8184, 8568, 8640, 8856, 9024, 9456, 9672, 9840, 9960,10032,
     6  10128,20160,20232,20136,20016,50208,50184,50280,50256,50376,
     7  50592,50472,50568,50688,50784,50640,50496,50712,50640,50520,
     8  50616,50640,50688,50760,50832,50928,51168,49392,49248,49968,
     9  49416,49032,48912,48936,48888,47856,47904,48024,48096,47880/
            data (jy(i),i=  501,  600)/
     +  47856,47760,47736,47616,47616,47448,47352,47160,47112,46992,
     1  46968,46872,46800,46680,46608,46368,54576,52440,52752,52824,
     2  52872,52776,52776,46584,46464,46416,46296,46272,46128,45936,
     3  45960,45840,45576,45480,45504,45456,44640,44280,44232,44256,
     4  44136,44136,43272,54552,54456,54360,54336,54288,54240,54240,
     5  54072,54120,54072,54024,54000,53952,53928,53856,53808,53808,
     6  53640,53664,53544,53472,53496,53304,53160,53112,53016,52752,
     7  52680,52824,57672,57552,50496,62592,62711,62592,62592,62496,
     8  62496,62328,62280,62352,62136,62064,61944,61776,61584,51144,
     9  51072,51000,50928,50904,50976,50736,50736,55152,54864,54792/
            data (jy(i),i=  601,  700)/
     +  54744,49848,50136,50352,50448,43728,43464,43440,42600,42888,
     1  43008,43104,56904,55752,49656,49248,48984,48864,48840,48912,
     2  48912,48792,48840,47976,53160,53040,52992,53184,53184,53088,
     3  53088,53256,53256,53352,53448,53448,53640,53688,54744,54720,
     4  54672,54576,54576,54504,54408,54312,53952,53832,64607,64679,
     5  64967,64991,63791,63503,63311,62592,57624,57696,57648,57816,
     6  57888,57960,58056,58032,58152,58128,58584,58584,58704,58824,
     7  58968,59232,52944,60192,60048,59856,59736,59664,59568,61488,
     8  61440,61344,61344,61224,61272,61032,61080,61032,61128,60744,
     9  60432,60336,60288,45432,45528,45720,45984,46056,45984,45840/
            data (jy(i),i=  701,  800)/
     +  45936,46080,46272,46176,46488,46512,46416,46488,46632,46632,
     1  46704,46752,46848,46872,46728,46728,47112,46968,47232,47232,
     2  48336,48624,49296,43176,43296,43368,43728,47880,47736,47592,
     3  47496,47136,47112,47040,46920,46152,61080,60912,60696,60696,
     4  60624,60528,60504,60264,60312,55008,55248,55296,55392,55512,
     5  55440,55464,55680,55728,55824,55824,55968,55896,56016,55896,
     6  59112,59160,59112,58992,58848,58944,58824,58752,58800,58680,
     7  58656,58416,58344,58248,58152,57936,57768,57768,65015,64919,
     8  64871,64943,64967,65351,65495,65615,65663,66263,66431,49944,
     9  50064,50112,50088,50616,50688,50688,50904,50880,52224,52104/
            data (jy(i),i=  801,  900)/
     +  51984,51912,51720,51696,51552,51504,51408,51096,50976,43392,
     1  43152,42816,42672,42672,42600,42528,42528,42336,42264,42192,
     2  41376,41256,41160,41304,63047,63047,62927,62807,62735,62711,
     3  62687,62424,62208,62136,61776,61608,61536,61416,61272,61248,
     4  61176,63791,64031,64127,64415,64703,64631,64655,63623,63527,
     5  63359,63239,63239,63095,50928,51048,51096,51072,51240,54840,
     6  54792,54912,54912,54816,54840,54744,54744,54576,54408,54096,
     7  54192,54144,53952,54000,53952,53856,53808,53856,53760,53736,
     8  53616,53736,53616,53520,53568,53496,53184,55968,56136,56208,
     9  56304,56352,56424,56520,56640,56688,56808,56856,56952,56952/
            data (jy(i),i=  901, 1000)/
     +  56880,56856,56952,57096,57120,57024,57120,57216,57264,57312,
     1  57216,57264,57216,57216,57288,57240,57336,57432,57528,57672,
     2  48504,61032,60912,61080,61416,61464,61320,61272,61080,60936,
     3  58968,59112,59256,59256,58896,58824,58776,58656,58800,58656,
     4  58464,58440,58512,58416,58200,58152,58032,58056,57960,57888,
     5  57936,58008,58056,58152,57960,57960,57888,63047,62999,62903,
     6  62759,62639,61992,61896,61560,61224,61080,60936,60888,60984,
     7  60888,42720,42576,54744,54168,54000,46488,46152,46080,46128,
     8  45984,49392,49368,48456,48528,48624,48792,48816,48912,48840,
     9  48912,48912,48960,49152,49080,49176,49224,49128,49176,49248/
            data (jy(i),i= 1001, 1100)/
     +  49152,49224,49296,49272,49224,49128,49152,47328,47328,42528,
     1  60480,60336,60240,60168,51432,51600,51648,51480,51552,51456,
     2  51840,51912,52008,52080,52248,52272,46464,46536,46968,47160,
     3  47256,56760,56784,56952,57120,57168,57360,57600,57672,57840,
     4  58008,58320,58320,59736,59808,59880,59664,59544,59520,59088,
     5  59064,59472,63119,63191,63479,63575,63791,64127,63959,63935,
     6  59280,59136,59184,59328,59232,59280,59376,59400,44208,45336,
     7  45840,45672,45480,54912,54888,54984,55032,55104,55080,55200,
     8  55680,56208,56400,56808,63335,63167,63047,49104,38232,38736,
     9  40128,41448,42480,42192,41856,41808,42048,38496,38544,38520/
            data (jy(i),i= 1101, 1200)/
     +  38880,38976,39000,39144,39168,39312,39096,39072,39264,39408,
     1  39528,39744,39960,37920,37656,36432,47376,47544,47640,47664,
     2  47520,47664,47664,47520,47472,47640,47592,47784,47712,47760,
     3  47952,44784,44760,44832,44832,44928,45000,45120,45168,45120,
     4  55032,56712,56760,56664,56640,56640,56736,67223,66815,66839,
     5  66767,66671,66743,66719,66599,63479,63647,63767,64679,65495,
     6  66095,42816,42600,42264,56568,56352,55824,55728,55536,55080,
     7  56832,56808,56880,57600,57528,57624,57648,57768,57816,57936,
     8  63263,63431,63383,63623,63599,52296,52224,52320,51984,51960,
     9  52080,52080,51984,52104,51912,51864,51840,51936,51864,51792/
            data (jy(i),i= 1201, 1300)/
     +  51840,51792,51888,44928,47208,47088,47064,46992,46992,46872,
     1  46896,46752,46464,46416,46176,46176,46104,45984,44976,45048,
     2  45144,45312,45312,45432,45648,45792,52440,52536,52512,52752,
     3  52896,53184,53304,53352,53616,53808,53976,54096,48720,58896,
     4  58728,58416,58320,58272,58176,58032,57984,54912,54816,54816,
     5  54696,54528,54768,49680,50664,50736,50904,51072,51048,51216,
     6  51264,51456,51624,51648,51480,51504,51648,51816,48240,48168,
     7  48288,48216,48096,48168,48072,47976,47928,47976,47904,47784,
     8  47712,47760,47952,47760,47952,54648,54624,54456,54312,54240,
     9  54168,48864,48888,48624,48600,48672,57648,57192,57192,56952/
            data (jy(i),i= 1301, 1400)/
     +  56808,56688,56304,56256,56280,56232,56016,55944,55632,55104,
     1  55056,54960,54936,54840,57624,40296,40968,41040,41016,41232,
     2  41280,41256,41544,41592,41712,41760,41664,57312,35640,66119,
     3  66335,66119,66191,66311,66263,66407,66383,66479,66431,50304,
     4  50352,50568,50664,50808,50832,50640,50688,50736,50904,63455,
     5  63479,63743,63815,63863,66071,66047,65711,65591,65471,65375,
     6  65351,65183,64679,64487,64223,64151,63983,62951,62903,62807,
     7  62735,62639,62520,62184,62328,61824,61776,61560,61416,61344,
     8  61032,61272,61200,61128,61128,60960,60960,60912,60504,60552,
     9  60504,60408,60216,60024,60024,59664,59544,59424,59184,59232/
            data (jy(i),i= 1401, 1500)/
     +  66599,67103,67103,67175,67535,67703,67679,67751,67943,68039,
     1  68351,68495,68615,68519,68447,68399,68687,68951,50208,50208,
     2  50040,49920,49800,49800,49704,49632,49536,49656,49608,49320,
     3  49320,49440,49584,49584,49152,49248,49104,49008,48984,48864,
     4  44928,44664,44640,44568,44616,44544,44568,44496,44568,44496,
     5  44376,44400,44304,44256,44184,44064,44064,44160,43968,43872,
     6  43872,43704,43704,43632,43560,43632,43536,43392,43368,43224,
     7  43224,43320,43248,43056,43080,42960,42840,39912,40056,39960,
     8  40056,40152,40152,40248,40416,40392,40464,30696,30744,30432,
     9  30144,30096,30000,29904,29928,30000,29952,30096,29952,29952/
            data (jy(i),i= 1501, 1600)/
     +  29760,29544,29328,58920,58104,58008,48672,48744,48720,48792,
     1  48696,48864,48792,48936,48936,48864,48768,48912,48840,48600,
     2  48624,48504,48456,61272,61176,61296,48048,47928,46080,45960,
     3  46248,46224,46176,46152,46200,26424,26592,26544,26640,26664,
     4  26856,26712,26424,26016,25896,25824,25800,25704,61104,60264,
     5  60216,60024,59736,59712,59664,59688,59592,59592,59496,59184,
     6  59160,32280,49224,49152,49152,49248,49224,49032,49056,48912,
     7  49032,48984,48912,48816,48840,49008,48984,48840,48816,48840,
     8  48648,48480,48552,32040,31920,32400,25608,25176,24936,46032,
     9  44088,43632,43272,43080,43128,22896,22224,22248,22416,22368/
            data (jy(i),i= 1601, 1700)/
     +  22440,22536,22488,22608,22752,22728,54096,53760,54072,53976,
     1  54048,54024,53976,54024,53976,54120,54048,54096,53880,53856,
     2  54000,54168,53952,53832,53736,53880,53904,54048,35376,53640,
     3  53400,53160,35496,35616,35712,35760,35952,36216,36336,36480,
     4  36624,36792,37200,37320,37224,37176,37272,37320,37344,56952,
     5  56448,56352,56424,56496,56496,56280,56016,56064,55680,54480,
     6  55176,55392,61536,62112,62280,62663,62783,62807,62855,62855,
     7  62927,63095,63191,63335,63287,63431,63455,63791,63887,63863,
     8  63911,24912,25056,25248,25800,25968,50424,50400,50592,50592,
     9  50520,50640,50688,50760,50880,50976,50856,50952,51048,51024/
            data (jy(i),i= 1701, 1800)/
     +  51096,51024,51144,51264,51216,51216,51312,51240,51408,51456,
     1  51672,51696,51912,47616,48144,48456,48432,48552,48600,48768,
     2  48744,48960,48888,48936,49056,49080,49224,49272,32664,32880,
     3  32808,33024,33024,33144,33264,33192,33096,33144,33360,33456,
     4  33504,33600,33720,33672,33864,33936,34104,34224,34248,34464,
     5  34464,34536,34536,34608,34632,34752,34728,34920,35088,35136,
     6  32256,32592,42432,41856,45984,30336,30744,30336,30096,29856,
     7  29616,29136,28848,28008,28368,28632,55872,63863,63959,64151,
     8  64151,64223,64223,64319,64271,64391,64415,64487,64487,64367,
     9  64391,64247,64247,64103,64031,63983,58512,47184,46296,46296/
            data (jy(i),i= 1801, 1900)/
     +  46080,52128,52176,52272,52320,52296,52488,52584,52752,52872,
     1  53016,40704,40848,41088,41208,41160,41304,41376,41424,41400,
     2  41304,41208,41112,41040,41064,41208,41208,41112,41112,40968,
     3  40968,41160,41232,41208,41472,41520,41616,41592,41640,41808,
     4  58248,58200,58128,58152,58056,57936,57816,57624,57432,57192,
     5  57072,57096,57048,56352,56136,56040,49344,49416,49272,49296,
     6  49440,49536,49560,50832,51000,51072,58488,58584,58632,58776,
     7  58728,58752,58920,58800,58848,58800,58944,58824,51696,51864,
     8  51792,53160,53352,53328,53568,53472,53688,53760,53832,53712,
     9  53808,53784,53712,53784,53688,53784,21192,55896,56064,56208/
            data (jy(i),i= 1901, 2000)/
     +  56280,56280,56616,56784,42000,42096,42096,42264,42336,20160,
     1  20208,20328,20448,20448,20592,20640,20760,20832,20904,20760,
     2  20928,21000,62448,62328,62663,62663,62687,62831,62879,63047,
     3  63191,63335,63455,63599,63671,41328,41496,41808,41808,42048,
     4  42144,39936,39720,39648,39648,39432,39480,39312,39288,39120,
     5  38808,38712,38664,38688,40704,40632,40896,41112,41232,42504,
     6  42552,42888,42912,43056,43392,43536,43944,44016,44184,44400,
     7  44568,44664,44832,44856,45120,45240,45576,45720,45960,45840,
     8  28224,28176,28128,28032,28152,28296,28320,32664,32808,32640,
     9  32640,32520,32544,32448,32376,32256,32208,32064,32016,32088/
            data (jy(i),i= 2001, 2100)/
     +  32520,58920,59040,59208,59424,59544,59664,59688,59880,59952,
     1  60048,60192,60672,60840,60936,61200,61656,61824,26112,26040,
     2  26160,26184,26112,26088,26136,26112,26160,26448,26520,26640,
     3  21096,21144,21120,21216,21528,21672,21744,21912,21936,21792,
     4  21816,21960,22152,22296,28224,27720,27384,66047,66143,66191,
     5  66359,66383,66551,66431,66407,66503,66671,66791,66911,66911,
     6  67007,67007,66935,66839,66695,66839,66671,66815,67079,64103,
     7  64919,64991,64919,64967,65135,65279,65375,65399,65543,65591,
     8  65567,65639,65615,65663,65567,65711,65663,65903,65903,50640,
     9  53856,53928,54024,54048,54144,54024,54144,54336,54552,54480/
            data (jy(i),i= 2101, 2200)/
     +  54936,55464,24912,24096,22200,22224,22152,22056,22080,53760,
     1  53640,53688,53472,53496,53424,53400,53232,53112,53232,53112,
     2  53016,53112,53064,52968,52920,52944,52896,52824,52704,52728,
     3  52656,52752,52584,52608,52728,52416,52512,52512,65927,65879,
     4  59208,59424,59448,59376,59472,59592,59760,59832,59856,60120,
     5  60216,60336,60336,60528,60528,60672,60624,60720,60672,60792,
     6  60912,61008,61128,61200,61344,61416,61464,61536,61632,61872,
     7  61872,61776,61776,61680,61680,61752,61656,61848,61968,62064,
     8  62208,62136,62232,62232,62112,62136,62064,62112,37392,37488,
     9  37392,37536,37608,37488,37440,37392,37296,37296,37176,37224/
            data (jy(i),i= 2201, 2300)/
     +  37152,37224,37152,37152,37056,37080,36984,36984,36864,36888,
     1  36840,36720,36648,36600,36432,36408,45624,45432,45360,45240,
     2  45216,44952,33744,35976,36096,36144,36264,33576,59040,59088,
     3  58992,58944,58824,57696,57792,57912,57936,58056,58200,58200,
     4  58272,58320,58416,58536,58704,58704,58752,58992,55488,55632,
     5  55824,55824,56016,55968,56136,56496,56736,56808,59160,66167,
     6  66167,66311,66407,66623,66767,67031,67151,62592,62544,62592,
     7  62496,62544,62735,62855,62975,62999,63119,63311,63335,63551,
     8  63599,48792,50160,47544,47520,47616,48096,48744,48888,48768,
     9  37368,37296,65327,65111,64727,64655,64391,64199,64103,64007/
            data (jy(i),i= 2301, 2400)/
     +  63791,63743,52488,30048,30168,30168,30288,30432,30696,30816,
     1  30720,30768,30912,31128,31152,31248,28368,28128,28008,28224,
     2  28296,28416,28584,28920,29304,29328,29448,29544,29664,29856,
     3  29880,29976,44760,44712,44664,44232,44184,44064,43848,43752,
     4  43704,43728,43344,41328,42240,43008,43032,42888,42864,43176,
     5  45888,45936,46032,40752,40464,40368,40512,40536,40608,40536,
     6  40488,20136,20136,20040,19824,19896,19824,19872,19752,55512,
     7  55272,55272,55560,55656,55848,56016,56040,56184,56208,56016,
     8  56160,39984,34344,38592,39024,26304,26496,26160,26184,25992,
     9  26064,25848,25896,25872,25992,25920,26040,26208,26280,26616/
            data (jy(i),i= 2401, 2500)/
     +  26520,18912,18960,18936,18696,18864,18816,18864,18720,18048,
     1  17952,18024,17880,17568,23328,23280,23184,23088,23016,22992,
     2  22872,22752,22800,22680,22608,22536,22488,22656,22272,22320,
     3  22296,22368,22248,22344,22128,22128,21864,22008,36816,37152,
     4  18888,18912,19152,19176,19344,19368,19440,19464,19512,19632,
     5  19704,47256,46800,47136,43104,41880,40704,40968,23592,24696,
     6  24936,25968,26064,26088,26304,26448,26568,26592,26736,26760,
     7  26832,26928,26952,30000,30024,29976,30048,30120,30120,30048,
     8  29856,29808,29928,29904,30072,30072,30216,30024,30000,30096,
     9  29688,29688,62304,62639,36144,35928,35712,35592,35400,29376/
            data (jy(i),i= 2501, 2600)/
     +  28728,63311,63311,63119,63119,63239,63215,63311,63287,63047,
     1  63239,63215,62759,64199,63983,63647,63527,63383,62424,62376,
     2  62424,28152,27024,26952,27048,27072,15696,16104,16392,18744,
     3  18696,18576,18696,18624,18600,18744,18480,16536,16920,17448,
     4  17664,17952,47232,47616,47856,22848,23064,58608,58464,58392,
     5  58200,57696,57384,57264,57000,56952,57000,56808,56568,56496,
     6  56544,56280,56280,34248,34248,34008,33960,33840,33768,33528,
     7  33312,33240,33192,33120,33000,32952,32808,32712,32688,32424,
     8  32520,31992,30528,47280,56040,55848,55728,55632,55416,54792,
     9  54720,54552,54288,54192,54120,54072,54000,54000,53904,53904/
            data (jy(i),i= 2601, 2700)/
     +  53832,53856,53760,53760,53664,53688,53520,53448,53352,53304,
     1  53280,53160,53136,53064,52992,52824,52848,52752,52704,52512,
     2  54360,54408,54504,54600,54552,54648,54768,54744,54864,54888,
     3  54984,55056,55128,55272,55320,55344,55248,55272,55416,55488,
     4  55512,56232,59040,59256,58872,58896,59040,58872,58968,58944,
     5  59016,59280,59280,59184,59328,52488,52536,52464,52632,52488,
     6  52608,52560,52584,52440,52416,52248,52320,52320,52440,52344,
     7  52296,52200,52344,52320,52056,52104,51984,59208,48312,48432,
     8  48840,48984,49176,49872,49992,50040,49992,50088,51912,51984,
     9  13512,47208,47088,46920,20208,20784,21624,56304,56400,56496/
            data (jy(i),i= 2701, 2800)/
     +  56616,56640,56808,56784,56976,57264,57336,57384,57624,57624,
     1  57816,57864,58008,58200,58176,58248,58392,58776,58752,58824,
     2  58800,58680,13536,62088,61968,61944,61752,61464,61200,60288,
     3  60312,60216,60000,60000,59808,59640,59496,59328,59520,59376,
     4  59376,21792,22584,16368,41928,42096,42624,42552,45000,44664,
     5  44448,36384,11112,11160,11232,11376,11304,11472,11496,11808,
     6  12024,13104,46848,46800,45912,21504,20640,20592,19176,51504,
     7  51744,51888,52512,52392,52464,52296,52392,52296,52392,52296,
     8  52128,52152,52368,52056,52152,52128,52224,52272,52344,52368,
     9  52536,52872,53112,32544,18888,18984,44088,44352,44376,44520/
            data (jy(i),i= 2801, 2900)/
     +  44616,46488,46536,46512,46440,46464,46320,46320,46392,46320,
     1  46464,46248,45960,39720,39768,39888,39888,40080,44592,44448,
     2  44472,45456,41328,41448,41496,41280,41448,41616,41832,42072,
     3  42360,41160,41256,13488,11304,11352,10992,36192,36096,36048,
     4  36000,36072,35976,35880,35760,35496,35544,34320,32784,34368,
     5  49296,49272,49296,49584,49728,49848,49872,49944,49896,50088,
     6  50040,50112,49968,50136,50040,49992,16320,19344,19488,19416,
     7  19560,59472,59592,59352,59592,59472,59616,59856,39792,39480,
     8  38040,36432,36288,36408,36528,36528,36648,36600,36672,36552,
     9  36600,36744,36912,36984,36888,36984,37152,37248,37248,37152/
            data (jy(i),i= 2901, 2970)/
     +  37224,37176,37152,37344,37272,37200,37440,37392,37488,37536,
     1  37416,37392,37512,37584,37824,37992,23496,23376,23352,19800,
     2  44376,44088,34224,44016,32160,31848,31344,28680,28752,28680,
     3  38280,38280,42216,42432,42336,42000,41808,41832,41568,41400,
     4  55848,55776,55560,55608,56232,10584,11616,12360,12480,12672,
     5  13440, 7104, 7584, 7752, 7704, 7560, 7200, 6960, 6888, 6864,
     6   6936,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +     32,    3,   50,   51,    1,    1,   53,   54,   55,   56,
     1     57,   58,   59,   60,   61,   62,    2,    3,   64,   65,
     2     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     3     76,   77,   78,   79,    4,    2,    7,   81,   82,   83,
     4     84,    6,    4,   86,   87,   88,   89,   90,   91,   92,
     5      5,    5,   94,   95,   96,   97,   98,   99,    8,    6,
     6    101,  102,  103,  104,  105,    9,    9,  107,  108,  109,
     7    110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
     8    120,  121,   10,   10,  123,  124,  125,  126,  127,  128,
     9    129,  130,  131,  132,  133,  134,   12,    8,  136,  137/
            data (jb1(i),i=  101,  200)/
     +    138,  139,  140,  141,  142,  143,   11,   11,  145,  146,
     1    147,  148,  149,   14,   12,  151,  152,  153,  154,  155,
     2    156,  157,   13,   13,  159,  160,  161,  162,  163,  164,
     3    165,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     4    175,  176,  177,   17,   14,  179,  180,  181,  182,  183,
     5    184,  185,  186,  187,  188,  189,   15,   15,   16,  191,
     6    192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
     7    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     8    212,  213,  214,  215,  216,   18,   22,  218,  219,  220,
     9    221,  222,  223,  224,  225,  226,  227,   20,   18,  229/
            data (jb1(i),i=  201,  300)/
     +    230,  231,  232,  233,  234,  235,  236,  237,  238,   22,
     1     17,  240,  241,  242,  243,  244,  245,  246,  247,  248,
     2    249,  250,  251,  252,  253,  254,  255,  256,  257,  258,
     3    259,  260,  261,   19,   21,  263,  264,  265,  266,  267,
     4    268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
     5    278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
     6     23,   20,  289,  290,  291,  292,  293,  294,  295,  296,
     7    297,   21,   23,  299,  300,  301,  302,  303,  304,  305,
     8    306,  307,  308,  309,  310,  311,   24,   24,  313,  314,
     9     26,   19,  316,  317,  318,  319,  320,  321,  322,  323/
            data (jb1(i),i=  301,  400)/
     +    324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
     1    334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
     2    344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
     3    354,  355,  356,  357,  358,  359,   25,   28,  361,  362,
     4    363,   29,   26,  365,  366,  367,  368,  369,  370,  371,
     5    372,  373,  374,  375,  376,  377,  378,   28,   25,  380,
     6    381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
     7     27,   29,  392,  393,  394,  395,  396,  397,  398,  399,
     8    400,  401,   30,   30,  403,  404,  405,  406,  407,  408,
     9    409,   33,   27,  411,  412,  413,  414,  415,  416,  417/
            data (jb1(i),i=  401,  500)/
     +    418,  419,  420,  421,  422,  423,  424,  425,  426,   35,
     1     36,  428,   37,   33,  430,  431,  432,  433,  434,  435,
     2    436,   46,   39,   40,   36,   32,   42,   38,  438,  439,
     3    440,  441,   39,   38,   35,  443,  444,  445,  446,  447,
     4     45,   31,   31,   44,   43,   47,  450,  451,  452,  453,
     5    454,  455,  456,  457,  458,  459,  460,   46,   47,   48,
     6     37,  462,  463,  464,   49,    1,  466,  467,  468,  469,
     7    470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
     8    480,  481,  482,  483,  484,  485,    2,  486,    3,  488,
     9    486,  489,  490,  489,  492,  493,  494,    4,  496,  497/
            data (jb1(i),i=  501,  600)/
     +    498,  495,  495,  500,  501,  502,  503,  504,  505,  506,
     1    507,  508,  509,  510,  511,  512,  513,  514,    5,  515,
     2      6,    7,  518,  519,  520,  521,  522,  515,  524,  525,
     3    526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
     4    536,  537,  538,  539,  540,  541,  542,  543,  517,  544,
     5    545,  546,  547,  548,  549,  550,  551,  552,  553,  554,
     6    555,  556,  557,  558,  559,  560,  561,  562,  563,  564,
     7    565,  566,  567,  568,  569,  570,  571,  523,    9,  573,
     8    490,   10,  576,  577,  578,  579,  580,  581,  582,  583,
     9    584,  585,  586,  587,  588,  523,  590,  591,  592,  593/
            data (jb1(i),i=  601,  700)/
     +    594,  595,  596,  575,  598,  599,  600,  517,  602,  603,
     1    604,  575,  537,  606,  607,   11,  609,  610,  611,  608,
     2    574,  613,  598,  602,  615,  616,  617,  618,  619,  620,
     3    621,  622,  623,  501,  567,  625,  626,  627,  628,  629,
     4    630,  631,  632,  633,  634,  635,  636,  637,  639,  598,
     5    639,  641,  642,  643,  644,  645,  646,  647,  638,  649,
     6    650,  651,  652,  649,  653,  654,  655,  589,  574,  657,
     7    658,  659,  660,  661,  662,  663,  664,  665,  666,  667,
     8    668,  669,  670,  671,  638,  674,  675,  676,  677,  678,
     9    672,  589,  680,  681,  682,  683,  684,  685,  686,  687/
            data (jb1(i),i=  701,  800)/
     +    688,  689,  690,  691,  692,  674,  536,  694,  695,  696,
     1    697,  698,  699,  700,  701,  702,  703,  704,  705,  706,
     2    707,  708,  709,  710,  711,  712,  713,  714,  715,  716,
     3    717,  718,  719,  721,  722,  615,  608,  724,  725,  726,
     4    721,  728,  729,  730,  720,  720,  732,  733,  734,  735,
     5    727,  737,  738,  739,  740,  741,  742,  743,  744,  674,
     6    639,  746,  747,  748,  749,  750,  751,  752,  753,  754,
     7    755,  756,  757,  758,  759,  672,  761,  762,  763,  764,
     8    765,  766,  767,  768,  769,  770,  771,  772,  773,  774,
     9    775,  776,  777,  649,  779,  780,  781,  782,  783,  784/
            data (jb1(i),i=  801,  900)/
     +    785,  786,  787,  788,  789,  602,  790,  791,  792,  793,
     1    794,  795,  796,  797,  673,  799,  800,  801,  802,  803,
     2    804,  805,  806,  807,  808,  798,  727,  810,  811,  812,
     3    813,  814,  815,  816,  817,  818,  819,  820,  821,  822,
     4    823,  824,  825,  826,  827,  828,  829,  830,  831,  832,
     5    833,  834,  835,  836,  837,  838,  839,  840,  737,  842,
     6    843,  844,  845,  846,  847,  781,  842,  849,  850,  851,
     7    852,  853,  825,  798,  855,  856,  857,  858,  760,  860,
     8    861,  862,  863,  864,  865,  866,  867,  868,  869,  870,
     9    871,  872,  873,  874,  875,  876,  877,  878,  879,  880/
            data (jb1(i),i=  901, 1000)/
     +    881,  882,  883,  884,  885,  886,  673,  760,  888,  889,
     1    890,  891,  892,  893,  894,  895,  896,  897,  898,  899,
     2    900,  901,  902,  903,  904,  905,  906,  907,  908,  909,
     3    910,  911,  912,  913,  914,  915,  916,  917,  918,  919,
     4    778,  721,  737,  922,  923,  924,  925,  926,  927,  928,
     5    929,  931,  932,  933,  934,  935,  936,  937,  938,  939,
     6    940,  941,  942,  943,  944,  945,  946,  947,  948,  949,
     7    950,  951,  952,  953,  954,  955,  956,  778,  958,  959,
     8    960,  961,  962,  963,  964,  965,  966,  967,  968,  969,
     9    970,  930,  820,  972,  860,  974,  975,  736,  977,  978/
            data (jb1(i),i= 1001, 1100)/
     +    979,  980,  859,  982,  921,  984,  985,  986,  987,  988,
     1    989,  990,  991,  992,  993,  994,  995,  996,  997,  998,
     2    999, 1000, 1001, 1002, 1003, 1004, 1005, 1006,  983,  921,
     3   1008,  973,  930, 1011, 1012, 1013,  859, 1015, 1016, 1017,
     4   1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025,  981, 1027,
     5   1028, 1029, 1030, 1009, 1032, 1033, 1034, 1035, 1036, 1037,
     6   1038, 1039, 1040, 1041, 1042,  931,  976, 1044, 1045, 1014,
     7   1044, 1047, 1048, 1050, 1051, 1049,  958, 1053, 1054, 1055,
     8   1056, 1057, 1058, 1059,  842,  931, 1061, 1062, 1063, 1064,
     9   1065, 1066, 1067, 1049,  973, 1069,  981, 1071, 1072, 1070/
            data (jb1(i),i= 1101, 1200)/
     +    860, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082,
     1   1083, 1032, 1085, 1086,  958,  983, 1089, 1089, 1090, 1091,
     2   1010, 1010, 1093, 1094, 1095, 1096, 1089, 1098, 1099, 1100,
     3   1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110,
     4   1111, 1112,   16, 1114, 1115, 1009, 1117, 1118, 1119, 1120,
     5   1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130,
     6   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1070,  976,
     7   1142, 1143, 1144, 1145, 1146, 1032,   17, 1148, 1149, 1150,
     8   1151, 1152, 1153, 1154, 1085, 1156, 1157, 1158, 1159, 1160,
     9   1155, 1132, 1162, 1163, 1097, 1142, 1165, 1166, 1167, 1168/
            data (jb1(i),i= 1201, 1300)/
     +   1169, 1141, 1142, 1171, 1172, 1173, 1174, 1175, 1176, 1177,
     1   1178, 1179, 1181, 1182, 1183, 1184, 1085, 1026, 1186, 1187,
     2   1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197,
     3   1198, 1199, 1200, 1201, 1202, 1132, 1131, 1205, 1206, 1207,
     4   1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217,
     5   1204, 1219, 1220, 1221, 1222, 1223, 1224, 1225, 1218, 1203,
     6   1227, 1228, 1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236,
     7   1237, 1088, 1050, 1240, 1241, 1242, 1243, 1244, 1245, 1246,
     8   1180, 1141, 1248, 1249, 1250, 1251, 1252, 1088, 1254, 1255,
     9   1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265/
            data (jb1(i),i= 1301, 1400)/
     +   1266, 1267, 1203, 1239, 1269, 1270, 1271, 1272, 1273, 1274,
     1   1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284,
     2   1131, 1253, 1286, 1287, 1288, 1289, 1290, 1238, 1239, 1292,
     3   1293, 1294, 1295, 1180, 1298, 1299, 1300, 1301, 1302, 1303,
     4   1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313,
     5   1253, 1297, 1113, 1316, 1317, 1318, 1319, 1320, 1321, 1322,
     6   1323, 1324, 1325, 1326, 1097, 1315,   18, 1116, 1155, 1330,
     7   1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1340, 1341,
     8   1342, 1343, 1344, 1345, 1346, 1347, 1348, 1259, 1181, 1350,
     9   1351, 1352, 1353, 1339, 1355, 1356, 1357, 1358, 1359, 1360/
            data (jb1(i),i= 1401, 1500)/
     +   1361, 1362, 1363, 1364, 1365, 1366, 1354, 1181, 1368, 1369,
     1   1370, 1371, 1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379,
     2   1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389,
     3   1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399,
     4   1050, 1339, 1401, 1402, 1298, 1403, 1404, 1405, 1406, 1407,
     5   1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417,
     6   1418, 1340, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426,
     7   1427, 1428, 1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436,
     8   1437, 1438, 1439, 1296, 1204, 1441, 1442, 1443, 1444, 1445,
     9   1446, 1447, 1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455/
            data (jb1(i),i= 1501, 1600)/
     +   1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465,
     1   1466, 1467, 1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475,
     2   1476, 1113, 1478, 1479, 1480, 1481, 1482, 1483, 1484, 1485,
     3   1486, 1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496,
     4   1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1328,
     5   1296, 1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515,
     6   1516, 1517, 1518, 1519, 1520, 1521, 1522, 1524, 1525, 1385,
     7   1523, 1527, 1528, 1218, 1530, 1531, 1532, 1533, 1534, 1529,
     8     21, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544,
     9   1545, 1546, 1547, 1524, 1549, 1550, 1551, 1552, 1553, 1554/
            data (jb1(i),i= 1601, 1700)/
     +   1555, 1556, 1557, 1558, 1559, 1560, 1504, 1488, 1563, 1564,
     1   1565, 1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573, 1574,
     2   1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582, 1523,   22,
     3   1584, 1585, 1562, 1548, 1587, 1588, 1529, 1590, 1591, 1592,
     4   1593, 1594, 1477, 1589,   23, 1597, 1598, 1599, 1600, 1601,
     5   1602, 1603, 1604, 1605, 1596, 1607, 1608, 1609, 1610, 1611,
     6   1612, 1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621,
     7   1622, 1623, 1624, 1625, 1626, 1627, 1238, 1116, 1607, 1630,
     8   1631, 1629, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640,
     9   1641, 1642, 1643, 1644, 1645, 1646, 1647, 1648, 1298, 1650/
            data (jb1(i),i= 1701, 1800)/
     +   1651, 1652, 1653, 1654, 1655, 1656, 1657, 1658, 1607, 1660,
     1   1661, 1659, 1524, 1663, 1664, 1665, 1666, 1667, 1668, 1669,
     2   1670, 1671, 1672, 1673, 1674, 1675, 1676, 1677, 1678, 1679,
     3   1680, 1589, 1682, 1683, 1684, 1685, 1340, 1687, 1688, 1689,
     4   1690, 1691, 1692, 1693, 1694, 1695, 1696, 1697, 1698, 1699,
     5   1700, 1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709,
     6   1710, 1711, 1712, 1714, 1715, 1716, 1717, 1718, 1719, 1720,
     7   1721, 1722, 1723, 1724, 1725, 1726, 1727, 1563, 1729, 1730,
     8   1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740,
     9   1741, 1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749, 1750/
            data (jb1(i),i= 1801, 1900)/
     +   1751, 1752, 1753, 1754, 1755, 1756, 1757, 1758, 1759, 1629,
     1   1562, 1761, 1729, 1477, 1763, 1590, 1488, 1766, 1767, 1768,
     2   1769, 1770, 1771, 1772, 1548, 1774, 1775, 1773, 1659, 1354,
     3   1778, 1779, 1780, 1781, 1782, 1783, 1784, 1785, 1786, 1787,
     4   1788, 1789, 1790, 1791, 1792, 1793, 1794, 1795, 1681, 1504,
     5   1714, 1798, 1799, 1800, 1765, 1713, 1802, 1803, 1804, 1805,
     6   1806, 1807, 1808, 1809, 1810, 1632, 1487, 1812, 1813, 1814,
     7   1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822, 1823, 1824,
     8   1825, 1826, 1827, 1828, 1829, 1830, 1831, 1832, 1833, 1834,
     9   1835, 1836, 1837, 1838, 1839, 1764, 1797, 1841, 1842, 1843/
            data (jb1(i),i= 1901, 2000)/
     +   1844, 1845, 1846, 1847, 1848, 1849, 1850, 1851, 1852, 1853,
     1   1854, 1855, 1777, 1563, 1857, 1858, 1859, 1860, 1861, 1862,
     2   1863, 1864, 1865, 1797, 1867, 1868, 1869, 1870, 1871, 1872,
     3   1873, 1874, 1875, 1876, 1877, 1866, 1879, 1880, 1713, 1632,
     4   1882, 1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890, 1891,
     5   1892, 1893, 1894, 1895, 1596, 1777, 1898, 1899, 1900, 1901,
     6   1902, 1903, 1764, 1905, 1906, 1907, 1908,   24, 1910, 1911,
     7   1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920, 1921,
     8   1897, 1923, 1924, 1925, 1926, 1927, 1928, 1929, 1930, 1931,
     9   1932, 1933, 1934, 1681, 1936, 1937, 1938, 1939, 1940, 1909/
            data (jb1(i),i= 2001, 2100)/
     +   1487, 1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950,
     1   1951, 1952, 1953, 1649, 1955, 1956, 1957, 1958, 1936, 1954,
     2   1909, 1960, 1961, 1962, 1963, 1964, 1965, 1966, 1967, 1968,
     3   1969, 1970, 1971, 1972, 1973, 1974, 1975, 1976, 1977, 1765,
     4   1979, 1978, 1773, 1981, 1982, 1983, 1984, 1985, 1986, 1729,
     5   1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997,
     6   1998, 1999, 2000, 1878, 2002, 2003, 2004, 2005, 2006, 2007,
     7   2008, 2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016, 2017,
     8   1923, 1686, 2019, 2020, 2021, 2022, 2023, 2024, 2025, 2026,
     9   2027, 2028, 2029, 1897, 2031, 2032, 2033, 2034, 2035, 2036/
            data (jb1(i),i= 2101, 2200)/
     +   2037, 2038, 2039, 2040, 2041, 2042, 2043, 1987, 2045, 2046,
     1   2030, 2048, 2049, 2050, 2051, 2052, 2053, 2054, 2055, 2056,
     2   2057, 2058, 2059, 2060, 2061, 2062, 2063, 2064, 2065, 2066,
     3   2067, 2068, 1403, 1794, 2070, 2071, 2072, 2073, 2074, 2075,
     4   2076, 2077, 2078, 2079, 2080, 2081, 2082, 2083, 2084, 2085,
     5   2086, 2087, 2088, 2048, 1866, 1896, 2091, 2092, 2093, 2094,
     6   2095, 2096, 2097, 2098, 2099, 2100, 2101, 1686, 2103, 2104,
     7   2044, 2106, 2107, 2108, 2105, 1896, 2110, 2111, 2112, 2113,
     8   2114, 2115, 2116, 2117, 2118, 2119, 2120, 2121, 2122, 2123,
     9   2124, 2125, 2126, 2127, 2128, 2129, 2130, 2131, 2132, 2133/
            data (jb1(i),i= 2201, 2300)/
     +   2134, 2135, 2136, 2137, 2048, 2139, 2141, 2142, 2143, 2144,
     1   2145, 2146, 2147, 2148, 2149, 2150, 2151, 2152, 2153, 2154,
     2   2155, 2156, 2157, 2158, 2159, 2160, 2161, 2162, 2163, 2164,
     3   2165, 2166, 2167, 2168, 2169, 2170, 2171, 2172, 2173, 2174,
     4   2175, 2176, 2177, 2178, 2179, 2180, 2181, 2182, 2183, 2184,
     5   2185, 2186, 2187, 1649, 2189, 2190, 2191, 2192, 2193, 2194,
     6   2195, 2196, 2197, 2198, 2199, 2200, 2201, 2202, 2203, 2204,
     7   2205, 2206, 2207, 2208, 2209, 2210, 2211, 2212, 2213, 2214,
     8   2215, 1978, 2217, 2218, 2219, 2220, 2221, 2223, 2224, 2225,
     9   2226, 2216, 2001, 2223, 2229, 2230, 2231, 2232, 1878, 1904/
            data (jb1(i),i= 2301, 2400)/
     +   2234, 2235, 2236, 2237, 2238, 2239, 2240, 2241, 2242, 2243,
     1   2244, 2245, 2246, 2247, 2229, 2102, 2249, 2250, 2251, 2252,
     2   2253, 2254, 2255, 2256, 2257, 1904, 2229, 2141, 2140, 2260,
     3   2261, 2262, 2263, 2264, 2265, 2266, 2267, 1923, 2268, 2269,
     4   2270, 2271, 2272, 2273, 2274, 2275, 2276, 2277, 2278, 2279,
     5   2280, 2282, 2090, 1714, 2284, 2285, 2286, 2287, 2288, 2289,
     6   2282, 2216, 2291, 2140, 2293, 2294, 2295, 2296, 2297, 2298,
     7   2299, 2300, 2301, 2281, 2090, 2138, 2304, 2305, 2306, 2307,
     8   2308, 2309, 2310, 2311, 2312, 2313, 2314, 2315, 2001, 1987,
     9   2317, 2318, 2319, 2320, 2321, 2322, 2323, 2324, 2325, 2326/
            data (jb1(i),i= 2401, 2500)/
     +   2327, 2328, 2329, 2330, 2331, 2304, 2222, 2333, 2334, 2335,
     1   2336, 2337, 2338, 2339, 2340, 2341, 2342, 1936, 2344, 2345,
     2   2346, 2347, 2348, 2349, 2343, 2222, 2351, 2352, 1955, 2354,
     3   2355, 2356, 2357, 2358, 2359, 2360, 2044, 2362, 2363, 2364,
     4   2365, 2366, 2367, 2368, 2102, 2370, 2371, 2372, 2373, 2374,
     5   2375, 2376, 2377, 2378, 2379, 2380, 2361, 2223, 2292, 2384,
     6   2382, 2386, 2387, 2388, 2389, 2390, 2391, 2392, 2393, 2394,
     7   2395, 2396, 2397, 2398, 2399, 2400, 2030, 2402, 2403, 2404,
     8   2405, 2406, 2407, 2408, 2409, 2410, 2411, 2412, 2413, 2414,
     9   2415, 2416, 2417, 2418, 2419, 2420, 2421, 2422, 2423, 2424/
            data (jb1(i),i= 2501, 2600)/
     +   2425, 2426, 2427, 2428, 2429, 2430, 2431, 2432, 2433, 2434,
     1   2435, 2436, 2437, 2105, 2439, 2292, 2402, 2441, 2442, 2443,
     2   2444, 2445, 2446, 2447, 2448, 2449, 2450, 2369, 2282, 2353,
     3   2453, 2452, 2343, 2455, 2361, 2457, 2456, 2415, 2459, 2460,
     4   2461, 2462, 2463, 2386, 2386, 2465, 2466, 2467, 2468, 2469,
     5   2470, 2471, 2472, 2304, 2474, 2475, 2476, 2477, 2478, 2479,
     6   2480, 2481, 2482, 2483, 2484, 2485, 2486, 2487, 2488, 2489,
     7   2490, 2491, 2188, 2493, 2439, 2495, 2496, 2497, 2498, 2383,
     8   2492, 2500, 2281, 2502, 2503, 2504, 2505, 2506, 2507, 2508,
     9   2509, 2510, 2511, 2512, 2494,   27, 2514, 2515, 2516, 2517/
            data (jb1(i),i= 2601, 2700)/
     +   2518, 2519, 2520, 2494, 2501, 2522, 2523, 2524, 2525, 2473,
     1     28, 2527, 2528, 2402, 2530, 2531, 2532, 2533, 2534, 2535,
     2   2536, 2529, 2538, 2539, 2540, 2541, 2537, 2452, 2543, 2544,
     3   2546, 2415, 2548, 2549, 2550, 2551, 2552, 2553, 2554, 2555,
     4   2556, 2557, 2558, 2559, 2560, 2561, 2562, 2381, 2383, 2564,
     5   2565, 2566, 2567, 2568, 2569, 2570, 2571, 2572, 2573, 2574,
     6   2575, 2576, 2577, 2578, 2579, 2580, 2581, 2492, 2582, 2545,
     7   2381, 2585, 2586, 2587, 2588, 2589, 2590, 2591, 2592, 2593,
     8   2594, 2595, 2596, 2597, 2598, 2599, 2600, 2601, 2602, 2603,
     9   2604, 2605, 2606, 2607, 2608, 2609, 2610, 2611, 2612, 2613/
            data (jb1(i),i= 2701, 2800)/
     +   2614, 2615, 2616, 2617, 2618, 2619, 2593, 2621, 2622, 2623,
     1   2624, 2625, 2626, 2627, 2628, 2629, 2630, 2631, 2632, 2633,
     2   2634, 2635, 2636, 2637, 2638, 2639, 2640, 2641, 2141, 2643,
     3   2644, 2645, 2646, 2647, 2648, 2649, 2650, 2651, 2652, 2653,
     4   2654, 2138, 2656, 2657, 2658, 2659, 2660, 2661, 2662, 2663,
     5   2664, 2665, 2666, 2667, 2668, 2669, 2670, 2671, 2672, 2673,
     6   2674, 2675, 2676, 2548, 2655, 2545, 2679, 2680, 2681, 2682,
     7   2683, 2684, 2685, 2686, 2687, 2677, 2689, 2620,   29, 2692,
     8   2693, 2584, 2369, 2695, 2696, 2642, 2698, 2699, 2700, 2701,
     9   2702, 2703, 2704, 2705, 2706, 2707, 2708, 2709, 2710, 2711/
            data (jb1(i),i= 2801, 2900)/
     +   2712, 2713, 2714, 2715, 2716, 2717, 2718, 2719, 2720, 2721,
     1   2548, 2691, 2188, 2724, 2725, 2726, 2727, 2728, 2729, 2730,
     2   2731, 2732, 2733, 2734, 2735, 2736, 2655, 2738, 2739, 2740,
     3   2737, 2697, 2742, 2546, 2529, 2723, 2456, 2745, 2746, 2747,
     4   2353, 2749, 2750, 2748, 2439,   30, 2753, 2754, 2755, 2756,
     5   2757, 2758, 2759, 2760, 2761, 2691, 2694, 2763, 2764, 2697,
     6   2766, 2767, 2768, 2688, 2770, 2771, 2677, 2620, 2773, 2774,
     7   2775, 2776, 2777, 2778, 2779, 2780, 2781, 2782, 2783, 2784,
     8   2785, 2786, 2787, 2788, 2789, 2790, 2791, 2792, 2793, 2582,
     9   2537, 2795, 2769, 2751, 2797, 2798, 2799, 2800,   32, 2802/
            data (jb1(i),i= 2901, 3000)/
     +   2803, 2804, 2805, 2806, 2807, 2808, 2809, 2810, 2811, 2812,
     1   2765, 2382, 2814, 2815, 2816, 2817, 2801, 2819, 2820, 2821,
     2   2765, 2823, 2824, 2825, 2826, 2827, 2828, 2829, 2830, 2748,
     3   2818, 2832, 2823, 2723, 2834, 2835, 2836, 2837, 2752, 2838,
     4   2839, 2840, 2841, 2842, 2843, 2844, 2845, 2846, 2847, 2794,
     5   2849, 2848,   34, 2851, 2852, 2853, 2854, 2855, 2856, 2857,
     6   2858, 2859, 2860, 2861, 2862, 2863, 2864, 2865, 2688, 2744,
     7   2867, 2868, 2769, 2870, 2869, 2737, 2872, 2873, 2874, 2875,
     8   2876, 2877, 2878, 2818, 2879, 2880, 2752, 2882, 2883, 2884,
     9   2885, 2886, 2887, 2888, 2889, 2890, 2891, 2892, 2893, 2894/
            data (jb1(i),i= 3001, 3080)/
     +   2895, 2896, 2897, 2898, 2899, 2900, 2901, 2902, 2903, 2904,
     1   2905, 2906, 2907, 2908, 2909, 2910, 2911, 2912, 2913, 2914,
     2   2915, 2881, 2546, 2917, 2918, 2919, 2871, 2920, 2801, 2921,
     3   2848, 2923, 2922, 2794, 2925, 2926, 2927, 2501, 2928, 2929,
     4   2930, 2473, 2924, 2881, 2931, 2932,   44, 2933, 2934, 2935,
     5   2936, 2937, 2938, 2939, 2823,   45, 2941, 2942, 2943, 2944,
     6   2642,   46, 2946, 2947, 2948, 2949, 2950, 2834, 2951, 2867,
     7      1,    2,    3,    4,    5,    6,    7,    8,    9,    1/
            data (jb2(i),i=    1,  100)/
     +     34,   50,   51,   52,   52,   53,   54,   55,   56,   57,
     1     58,   59,   60,   61,   62,   63,   63,   64,   65,   66,
     2     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     3     77,   78,   79,   80,   80,    7,   81,   82,   83,   84,
     4     85,   85,   86,   87,   88,   89,   90,   91,   92,   93,
     5     93,   94,   95,   96,   97,   98,   99,  100,  100,  101,
     6    102,  103,  104,  105,  106,  106,  107,  108,  109,  110,
     7    111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
     8    121,  122,  122,  123,  124,  125,  126,  127,  128,  129,
     9    130,  131,  132,  133,  134,  135,  135,  136,  137,  138/
            data (jb2(i),i=  101,  200)/
     +    139,  140,  141,  142,  143,  144,  144,  145,  146,  147,
     1    148,  149,  150,  150,  151,  152,  153,  154,  155,  156,
     2    157,  158,  158,  159,  160,  161,  162,  163,  164,  165,
     3    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     4    176,  177,  178,  178,  179,  180,  181,  182,  183,  184,
     5    185,  186,  187,  188,  189,  190,  190,   16,  191,  192,
     6    193,  194,  195,  196,  197,  198,  199,  200,  201,  202,
     7    203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
     8    213,  214,  215,  216,  217,  217,  218,  219,  220,  221,
     9    222,  223,  224,  225,  226,  227,  228,  228,  229,  230/
            data (jb2(i),i=  201,  300)/
     +    231,  232,  233,  234,  235,  236,  237,  238,  239,  239,
     1    240,  241,  242,  243,  244,  245,  246,  247,  248,  249,
     2    250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
     3    260,  261,  262,  262,  263,  264,  265,  266,  267,  268,
     4    269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
     5    279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
     6    288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
     7    298,  298,  299,  300,  301,  302,  303,  304,  305,  306,
     8    307,  308,  309,  310,  311,  312,  312,  313,  314,  315,
     9    315,  316,  317,  318,  319,  320,  321,  322,  323,  324/
            data (jb2(i),i=  301,  400)/
     +    325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
     1    335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
     2    345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
     3    355,  356,  357,  358,  359,  360,  360,  361,  362,  363,
     4    364,  364,  365,  366,  367,  368,  369,  370,  371,  372,
     5    373,  374,  375,  376,  377,  378,  379,  379,  380,  381,
     6    382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
     7    391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
     8    401,  402,  402,  403,  404,  405,  406,  407,  408,  409,
     9    410,  410,  411,  412,  413,  414,  415,  416,  417,  418/
            data (jb2(i),i=  401,  500)/
     +    419,  420,  421,  422,  423,  424,  425,  426,  427,  427,
     1    428,  429,  429,  430,  431,  432,  433,  434,  435,  436,
     2    437,  437,   40,   41,   41,   42,   44,  438,  439,  440,
     3    441,  442,  442,   43,  443,  444,  445,  446,  447,  448,
     4    448,   45,   34,  449,  449,  450,  451,  452,  453,  454,
     5    455,  456,  457,  458,  459,  460,  461,  461,   48,   49,
     6    462,  463,  464,  465,  465,  466,  467,  468,  469,  470,
     7    471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
     8    481,  482,  483,  484,  485,  486,  487,  487,  488,  489,
     9    490,  491,  491,  492,  493,  494,  495,  496,  497,  498/
            data (jb2(i),i=  501,  600)/
     +    499,  499,  500,  501,  502,  503,  504,  505,  506,  507,
     1    508,  509,  510,  511,  512,  513,  514,  515,  516,  516,
     2    517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     3    527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     4    537,  538,  539,  540,  541,  542,  543,    8,  544,  545,
     5    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     6    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     7    566,  567,  568,  569,  570,  571,  572,  572,  573,  574,
     8    575,  576,  577,  578,  579,  580,  581,  582,  583,  584,
     9    585,  586,  587,  588,  589,  590,  591,  592,  593,  594/
            data (jb2(i),i=  601,  700)/
     +    595,  596,  597,  597,  599,  600,  601,  601,  603,  604,
     1    605,  605,  606,  607,  608,  609,  610,  611,  612,  612,
     2    613,  614,  614,  615,  616,  617,  618,  619,  620,  621,
     3    622,  623,  624,  624,  625,  626,  627,  628,  629,  630,
     4    631,  632,  633,  634,  635,  636,  637,  638,  640,  640,
     5    641,  642,  643,  644,  645,  646,  647,  648,  648,  650,
     6    651,  652,   12,  653,  654,  655,  656,  656,  657,  658,
     7    659,  660,  661,  662,  663,  664,  665,  666,  667,  668,
     8    669,  670,  671,  672,  673,  675,  676,  677,  678,  679,
     9    679,  680,  681,  682,  683,  684,  685,  686,  687,  688/
            data (jb2(i),i=  701,  800)/
     +    689,  690,  691,  692,  693,  693,  694,  695,  696,  697,
     1    698,  699,  700,  701,  702,  703,  704,  705,  706,  707,
     2    708,  709,  710,  711,  712,  713,  714,  715,  716,  717,
     3    718,  719,  720,  722,  723,  723,  724,  725,  726,  727,
     4    728,  729,  730,  731,  731,  732,  733,  734,  735,  736,
     5    736,  738,  739,  740,  741,  742,  743,  744,  745,  745,
     6    746,  747,  748,  749,  750,  751,  752,  753,  754,  755,
     7    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     8    766,  767,  768,  769,  770,  771,  772,  773,  774,  775,
     9    776,  777,  778,  779,  780,  781,  782,  783,  784,  785/
            data (jb2(i),i=  801,  900)/
     +    786,  787,  788,  789,   13,  790,  791,  792,  793,  794,
     1    795,  796,  797,  798,  799,  800,  801,  802,  803,  804,
     2    805,  806,  807,  808,  809,  809,  810,  811,  812,  813,
     3    814,  815,  816,  817,  818,  819,  820,  821,  822,  823,
     4    824,   14,  826,  827,  828,  829,  830,  831,  832,  833,
     5    834,  835,  836,  837,  838,  839,  840,  841,  841,  843,
     6    844,  845,  846,  847,  848,  848,  849,  850,  851,  852,
     7    853,  854,  854,  855,  856,  857,  858,  859,  860,  861,
     8    862,  863,  864,  865,  866,  867,  868,  869,  870,  871,
     9    872,  873,  874,  875,  876,  877,  878,  879,  880,  881/
            data (jb2(i),i=  901, 1000)/
     +    882,  883,  884,  885,  886,  887,  887,  888,  889,  890,
     1    891,  892,  893,  894,  895,  896,  897,  898,  899,  900,
     2    901,  902,  903,  904,  905,  906,  907,  908,  909,  910,
     3    911,  912,  913,  914,  915,  916,  917,  918,  919,  920,
     4    920,  921,  922,  923,  924,  925,  926,  927,  928,  929,
     5    930,  932,  933,  934,  935,  936,  937,  938,  939,  940,
     6    941,  942,  943,  944,  945,  946,  947,  948,  949,  950,
     7    951,  952,  953,  954,  955,  956,  957,  957,  959,  960,
     8    961,  962,  963,  964,  965,  966,  967,  968,  969,  970,
     9    971,  971,  972,  973,  974,  975,  976,  977,  978,  979/
            data (jb2(i),i= 1001, 1100)/
     +    980,  981,  982,  983,  984,  985,  986,  987,  988,  989,
     1    990,  991,  992,  993,  994,  995,  996,  997,  998,  999,
     2   1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007, 1007, 1008,
     3   1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018,
     4   1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028,
     5   1029, 1030, 1031, 1031, 1033, 1034, 1035, 1036, 1037, 1038,
     6   1039, 1040, 1041, 1042, 1043, 1043, 1026, 1045, 1046, 1046,
     7   1047, 1048, 1049, 1051, 1052, 1052, 1053, 1054, 1055, 1056,
     8   1057, 1058, 1059, 1060, 1060, 1061, 1062, 1063, 1064, 1065,
     9   1066, 1067, 1068, 1068, 1069, 1070, 1071, 1072, 1073, 1073/
            data (jb2(i),i= 1101, 1200)/
     +   1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083,
     1   1084, 1084, 1086, 1087, 1087, 1088,   15, 1090, 1091, 1092,
     2   1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101,
     3   1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111,
     4   1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121,
     5   1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     6   1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1140, 1141,
     7   1143, 1144, 1145, 1146, 1147, 1147, 1148, 1149, 1150, 1151,
     8   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     9   1161, 1162, 1163, 1164, 1164, 1165, 1166, 1167, 1168, 1169/
            data (jb2(i),i= 1201, 1300)/
     +   1170, 1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178,
     1   1179, 1180, 1182, 1183, 1184, 1185, 1185, 1186, 1187, 1188,
     2   1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198,
     3   1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208,
     4   1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218,
     5   1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1226, 1227,
     6   1228, 1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237,
     7   1238, 1239, 1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247,
     8   1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254, 1255, 1256,
     9   1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266/
            data (jb2(i),i= 1301, 1400)/
     +   1267, 1268, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275,
     1   1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285,
     2   1285, 1286, 1287, 1288, 1289, 1290, 1291, 1291, 1292, 1293,
     3   1294, 1295, 1296, 1297, 1299, 1300, 1301, 1302, 1303, 1304,
     4   1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314,
     5   1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323,
     6   1324, 1325, 1326, 1327, 1327, 1328, 1329, 1329, 1330, 1331,
     7   1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1341, 1342,
     8   1343, 1344, 1345, 1346, 1347, 1348, 1349, 1349, 1350, 1351,
     9   1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361/
            data (jb2(i),i= 1401, 1500)/
     +   1362, 1363, 1364, 1365, 1366, 1367, 1367, 1368, 1369, 1370,
     1   1371, 1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380,
     2   1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390,
     3   1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400,
     4   1400, 1401, 1402, 1403, 1328, 1404, 1405, 1406, 1407, 1408,
     5   1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418,
     6     19, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427,
     7   1428, 1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437,
     8   1438, 1439, 1440, 1440, 1441, 1442, 1443, 1444, 1445, 1446,
     9   1447, 1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456/
            data (jb2(i),i= 1501, 1600)/
     +   1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466,
     1   1467, 1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476,
     2   1477, 1478, 1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486,
     3   1487, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497,
     4   1498, 1499, 1500, 1501, 1502, 1503,   20, 1505, 1506, 1506,
     5   1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516,
     6   1517, 1518, 1519, 1520, 1521, 1522, 1523, 1525, 1526, 1526,
     7   1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1535,
     8   1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545,
     9   1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555/
            data (jb2(i),i= 1601, 1700)/
     +   1556, 1557, 1558, 1559, 1560, 1561, 1561, 1562, 1564, 1565,
     1   1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575,
     2   1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583, 1583, 1584,
     3   1585, 1586, 1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593,
     4   1594, 1595, 1595, 1596, 1597, 1598, 1599, 1600, 1601, 1602,
     5   1603, 1604, 1605, 1606, 1606, 1608, 1609, 1610, 1611, 1612,
     6   1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622,
     7   1623, 1624, 1625, 1626, 1627, 1628, 1628, 1629, 1630, 1631,
     8   1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641,
     9   1642, 1643, 1644, 1645, 1646, 1647, 1648, 1649, 1650, 1651/
            data (jb2(i),i= 1701, 1800)/
     +   1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661,
     1   1662, 1662, 1663, 1664, 1665, 1666, 1667, 1668, 1669, 1670,
     2   1671, 1672, 1673, 1674, 1675, 1676, 1677, 1678, 1679, 1680,
     3   1681, 1682, 1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690,
     4   1691, 1692, 1693, 1694, 1695, 1696, 1697, 1698, 1699, 1700,
     5   1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709, 1710,
     6   1711, 1712, 1713, 1715, 1716, 1717, 1718, 1719, 1720, 1721,
     7   1722, 1723, 1724, 1725, 1726, 1727, 1728, 1728, 1730, 1731,
     8   1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740, 1741,
     9   1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749, 1750, 1751/
            data (jb2(i),i= 1801, 1900)/
     +   1752, 1753, 1754, 1755, 1756, 1757, 1758, 1759, 1760, 1760,
     1   1761, 1762, 1762, 1763, 1764, 1765, 1766, 1767, 1768, 1769,
     2   1770, 1771, 1772, 1773, 1774, 1775, 1776, 1776, 1777, 1778,
     3   1779, 1780, 1781, 1782, 1783, 1784, 1785, 1786, 1787, 1788,
     4   1789, 1790, 1791, 1792, 1793, 1794, 1795, 1796, 1796, 1797,
     5   1798, 1799, 1800, 1801, 1801, 1802, 1803, 1804, 1805, 1806,
     6   1807, 1808, 1809, 1810, 1811, 1811, 1812, 1813, 1814, 1815,
     7   1816, 1817, 1818, 1819, 1820, 1821, 1822, 1823, 1824, 1825,
     8   1826, 1827, 1828, 1829, 1830, 1831, 1832, 1833, 1834, 1835,
     9   1836, 1837, 1838, 1839, 1840, 1840, 1841, 1842, 1843, 1844/
            data (jb2(i),i= 1901, 2000)/
     +   1845, 1846, 1847, 1848, 1849, 1850, 1851, 1852, 1853, 1854,
     1   1855, 1856, 1856, 1857, 1858, 1859, 1860, 1861, 1862, 1863,
     2   1864, 1865, 1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873,
     3   1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881, 1881, 1882,
     4   1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890, 1891, 1892,
     5   1893, 1894, 1895, 1896, 1897, 1898, 1899, 1900, 1901, 1902,
     6   1903, 1904, 1905, 1906, 1907, 1908, 1909, 1910, 1911, 1912,
     7   1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920, 1921, 1922,
     8   1922, 1924, 1925, 1926, 1927, 1928, 1929, 1930, 1931, 1932,
     9   1933, 1934, 1935, 1935, 1937, 1938, 1939, 1940, 1941, 1941/
            data (jb2(i),i= 2001, 2100)/
     +   1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950, 1951,
     1   1952, 1953, 1954, 1954, 1956, 1957, 1958, 1959, 1959, 1955,
     2   1960, 1961, 1962, 1963, 1964, 1965, 1966, 1967, 1968, 1969,
     3   1970, 1971, 1972, 1973, 1974, 1975, 1976, 1977, 1978, 1979,
     4   1980, 1980, 1981, 1982, 1983, 1984, 1985, 1986, 1987, 1988,
     5   1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
     6   1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008,
     7   2009, 2010, 2011, 2012, 2013, 2014, 2015, 2016, 2017, 2018,
     8   2018, 2019, 2020, 2021, 2022, 2023, 2024, 2025, 2026, 2027,
     9   2028, 2029, 2030, 2031, 2032, 2033, 2034, 2035, 2036, 2037/
            data (jb2(i),i= 2101, 2200)/
     +   2038, 2039, 2040, 2041, 2042, 2043, 2044, 2045, 2046, 2047,
     1   2047, 2049, 2050, 2051, 2052, 2053, 2054, 2055, 2056, 2057,
     2   2058, 2059, 2060, 2061, 2062, 2063, 2064, 2065, 2066, 2067,
     3   2068, 2069, 2069, 2070, 2071, 2072, 2073, 2074, 2075, 2076,
     4   2077, 2078, 2079, 2080, 2081, 2082, 2083, 2084, 2085, 2086,
     5   2087, 2088, 2089, 2089, 2090, 2091, 2092, 2093, 2094, 2095,
     6   2096, 2097, 2098, 2099, 2100, 2101, 2102, 2103, 2104, 2105,
     7   2106, 2107, 2108, 2109, 2109, 2110, 2111, 2112, 2113, 2114,
     8   2115, 2116, 2117, 2118, 2119, 2120, 2121, 2122, 2123, 2124,
     9   2125, 2126, 2127, 2128, 2129, 2130, 2131, 2132, 2133, 2134/
            data (jb2(i),i= 2201, 2300)/
     +   2135, 2136, 2137, 2138, 2139, 2140, 2142, 2143, 2144, 2145,
     1   2146, 2147, 2148, 2149, 2150, 2151, 2152, 2153, 2154, 2155,
     2   2156, 2157, 2158, 2159, 2160, 2161, 2162, 2163, 2164, 2165,
     3   2166, 2167, 2168, 2169, 2170, 2171, 2172, 2173, 2174, 2175,
     4   2176, 2177, 2178, 2179, 2180, 2181, 2182, 2183, 2184, 2185,
     5   2186, 2187, 2188, 2189, 2190, 2191, 2192, 2193, 2194, 2195,
     6   2196, 2197, 2198, 2199, 2200, 2201, 2202, 2203, 2204, 2205,
     7   2206, 2207, 2208, 2209, 2210, 2211, 2212, 2213, 2214, 2215,
     8   2216, 2217, 2218, 2219, 2220, 2221, 2222, 2224, 2225, 2226,
     9   2227, 2227, 2228, 2228, 2230, 2231, 2232, 2233, 2233, 2234/
            data (jb2(i),i= 2301, 2400)/
     +   2235, 2236, 2237, 2238, 2239, 2240, 2241, 2242, 2243, 2244,
     1   2245, 2246, 2247, 2248, 2248, 2249, 2250, 2251, 2252, 2253,
     2   2254, 2255, 2256, 2257, 2258, 2258, 2259, 2259, 2260, 2261,
     3   2262, 2263, 2264, 2265, 2266, 2267,   25, 2268, 2269, 2270,
     4   2271, 2272, 2273, 2274, 2275, 2276, 2277, 2278, 2279, 2280,
     5   2281, 2283, 2283, 2284, 2285, 2286, 2287, 2288, 2289, 2290,
     6   2290, 2291, 2292, 2293, 2294, 2295, 2296, 2297, 2298, 2299,
     7   2300, 2301, 2302, 2302, 2303, 2303, 2305, 2306, 2307, 2308,
     8   2309, 2310, 2311, 2312, 2313, 2314, 2315, 2316, 2316, 2317,
     9   2318, 2319, 2320, 2321, 2322, 2323, 2324, 2325, 2326, 2327/
            data (jb2(i),i= 2401, 2500)/
     +   2328, 2329, 2330, 2331, 2332, 2332, 2333, 2334, 2335, 2336,
     1   2337, 2338, 2339, 2340, 2341, 2342, 2343, 2344, 2345, 2346,
     2   2347, 2348, 2349, 2350, 2350, 2351, 2352, 2353, 2354, 2355,
     3   2356, 2357, 2358, 2359, 2360, 2361, 2362, 2363, 2364, 2365,
     4   2366, 2367, 2368, 2369, 2370, 2371, 2372, 2373, 2374, 2375,
     5   2376, 2377, 2378, 2379, 2380, 2381, 2382, 2383, 2384, 2385,
     6   2385, 2387, 2388, 2389, 2390, 2391, 2392, 2393, 2394, 2395,
     7   2396, 2397, 2398, 2399, 2400, 2401, 2401, 2403, 2404, 2405,
     8   2406, 2407, 2408, 2409, 2410, 2411, 2412, 2413, 2414,   26,
     9   2416, 2417, 2418, 2419, 2420, 2421, 2422, 2423, 2424, 2425/
            data (jb2(i),i= 2501, 2600)/
     +   2426, 2427, 2428, 2429, 2430, 2431, 2432, 2433, 2434, 2435,
     1   2436, 2437, 2438, 2438, 2440, 2440, 2441, 2442, 2443, 2444,
     2   2445, 2446, 2447, 2448, 2449, 2450, 2451, 2451, 2452, 2453,
     3   2454, 2454, 2455, 2456, 2457, 2458, 2458, 2459, 2460, 2461,
     4   2462, 2463, 2464, 2464, 2465, 2466, 2467, 2468, 2469, 2470,
     5   2471, 2472, 2473, 2474, 2475, 2476, 2477, 2478, 2479, 2480,
     6   2481, 2482, 2483, 2484, 2485, 2486, 2487, 2488, 2489, 2490,
     7   2491, 2492, 2493, 2494, 2495, 2496, 2497, 2498, 2499, 2499,
     8   2500, 2501, 2502, 2503, 2504, 2505, 2506, 2507, 2508, 2509,
     9   2510, 2511, 2512, 2513, 2513, 2514, 2515, 2516, 2517, 2518/
            data (jb2(i),i= 2601, 2700)/
     +   2519, 2520, 2521, 2521, 2522, 2523, 2524, 2525, 2526, 2526,
     1   2527, 2528, 2529, 2530, 2531, 2532, 2533, 2534, 2535, 2536,
     2   2537, 2538, 2539, 2540, 2541, 2542, 2542, 2543, 2544, 2545,
     3   2547, 2547, 2549, 2550, 2551, 2552, 2553, 2554, 2555, 2556,
     4   2557, 2558, 2559, 2560, 2561, 2562, 2563, 2563, 2564, 2565,
     5   2566, 2567, 2568, 2569, 2570, 2571, 2572, 2573, 2574, 2575,
     6   2576, 2577, 2578, 2579, 2580, 2581, 2582, 2583, 2583, 2584,
     7   2585, 2586, 2587, 2588, 2589, 2590, 2591, 2592, 2593, 2594,
     8   2595, 2596, 2597, 2598, 2599, 2600, 2601, 2602, 2603, 2604,
     9   2605, 2606, 2607, 2608, 2609, 2610, 2611, 2612, 2613, 2614/
            data (jb2(i),i= 2701, 2800)/
     +   2615, 2616, 2617, 2618, 2619, 2620, 2621, 2622, 2623, 2624,
     1   2625, 2626, 2627, 2628, 2629, 2630, 2631, 2632, 2633, 2634,
     2   2635, 2636, 2637, 2638, 2639, 2640, 2641, 2642, 2643, 2644,
     3   2645, 2646, 2647, 2648, 2649, 2650, 2651, 2652, 2653, 2654,
     4   2655, 2656, 2657, 2658, 2659, 2660, 2661, 2662, 2663, 2664,
     5   2665, 2666, 2667, 2668, 2669, 2670, 2671, 2672, 2673, 2674,
     6   2675, 2676, 2677, 2678, 2678, 2679, 2680, 2681, 2682, 2683,
     7   2684, 2685, 2686, 2687, 2688, 2689, 2690, 2690, 2691, 2693,
     8   2694, 2692, 2695, 2696, 2697, 2698, 2699, 2700, 2701, 2702,
     9   2703, 2704, 2705, 2706, 2707, 2708, 2709, 2710, 2711, 2712/
            data (jb2(i),i= 2801, 2900)/
     +   2713, 2714, 2715, 2716, 2717, 2718, 2719, 2720, 2721, 2722,
     1   2722, 2723, 2724, 2725, 2726, 2727, 2728, 2729, 2730, 2731,
     2   2732, 2733, 2734, 2735, 2736, 2737, 2738, 2739, 2740, 2741,
     3   2741, 2742, 2743, 2743, 2744, 2744, 2745, 2746, 2747, 2748,
     4   2749, 2750, 2751, 2751, 2752, 2753, 2754, 2755, 2756, 2757,
     5   2758, 2759, 2760, 2761, 2762, 2762, 2763, 2764, 2765, 2766,
     6   2767, 2768, 2769, 2770, 2771, 2772, 2772, 2773, 2774, 2775,
     7   2776, 2777, 2778, 2779, 2780, 2781, 2782, 2783, 2784, 2785,
     8   2786, 2787, 2788, 2789, 2790, 2791, 2792, 2793,   31, 2794,
     9   2795, 2796, 2796, 2797, 2798, 2799, 2800, 2801, 2802, 2803/
            data (jb2(i),i= 2901, 3000)/
     +   2804, 2805, 2806, 2807, 2808, 2809, 2810, 2811, 2812, 2813,
     1   2813, 2814, 2815, 2816, 2817, 2818, 2819, 2820, 2821, 2822,
     2   2822, 2824, 2825, 2826, 2827, 2828, 2829, 2830, 2831, 2831,
     3   2832, 2833, 2833, 2834, 2835, 2836, 2837,   33, 2838, 2839,
     4   2840, 2841, 2842, 2843, 2844, 2845, 2846, 2847, 2848, 2849,
     5   2850, 2850, 2851, 2852, 2853, 2854, 2855, 2856, 2857, 2858,
     6   2859, 2860, 2861, 2862, 2863, 2864, 2865, 2866, 2866, 2867,
     7   2868, 2869, 2870, 2871, 2871, 2872, 2873, 2874, 2875, 2876,
     8   2877, 2878,   35, 2879, 2880, 2881, 2882, 2883, 2884, 2885,
     9   2886, 2887, 2888, 2889, 2890, 2891, 2892, 2893, 2894, 2895/
            data (jb2(i),i= 3001, 3080)/
     +   2896, 2897, 2898, 2899, 2900, 2901, 2902, 2903, 2904, 2905,
     1   2906, 2907, 2908, 2909, 2910, 2911, 2912, 2913, 2914, 2915,
     2   2916, 2916, 2917, 2918, 2919,   36, 2920,   37, 2921, 2922,
     3   2923,   38, 2924, 2925, 2926, 2927,   39, 2928, 2929, 2930,
     4     40,   41,   42, 2931, 2932,   43, 2933, 2934, 2935, 2936,
     5   2937, 2938, 2939, 2940, 2940, 2941, 2942, 2943, 2944, 2945,
     6   2945, 2946, 2947, 2948, 2949, 2950,   47, 2951,   48,   49,
     7      2,    3,    4,    5,    6,    7,    8,    9,   10,   10/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine la(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(4430) :: jx,jy
            integer(kind=iknd), save, dimension(4500) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'louisiana     '/
            data jrot,ipart/1,2/
            data kv/   1,3067,4428,   0,   0/
            data kb/   1,3134,4495,   0,   0/
            data iib/1505,1361,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  16176,16152,16128,16152,16128,16104,20352,16080,23712,23952,
     1  24432,24528,27336,28200,33648,35376,36696,35184,35280,38328,
     2  35232,35328,41136,43104,44496,44640,46632,47544,48168,48696,
     3  49080,49536,49632,49728,49824,51864,52272,52752,16128,16488,
     4  16848,16992,17112,17112,16992,16824,16584,16560,16440,16344,
     5  16296,16464,16896,17352,17496,17640,17856,18144,18312,18456,
     6  18624,18696,18864,18984,19584,19752,20064,20064,19920,19560,
     7  19584,19680,19920,20184,20424,20616,20856,21024,21096,21000,
     8  20568,20496,20760,21072,21312,21504,21552,21408,21504,21696,
     9  21888,22128,22272,22464,22416,22104,22128,22200,22800,22992/
            data (jx(i),i=  101,  200)/
     +  22896,22944,23280,23688,23784,23784,23544,23448,23472,23640,
     1  23568,23736,16056,24384,24384,24504,24528,24384,24240,23856,
     2  23688,24216,24000,24168,24144,24432,25896,25920,26568,26592,
     3  26712,26712,26880,26928,26856,27048,27096,27192,24768,24936,
     4  25272,25224,24960,24960,25032,25128,25248,25416,25680,25824,
     5  25944,26016,26256,26544,26616,26784,27120,27216,27336,27432,
     6  27504,27576,27528,27192,27144,27192,27288,28080,28080,27960,
     7  28032,28176,28224,28152,27624,27792,27936,28008,28248,28488,
     8  28656,28704,29016,28992,29064,29232,29256,29544,29544,29616,
     9  29832,29952,30096,30360,30408,30360,30504,30504,30720,30792/
            data (jx(i),i=  201,  300)/
     +  30840,30936,31080,31080,31200,31248,31464,31632,31920,31872,
     1  32016,32064,32256,32352,32376,32496,32568,32712,32736,32856,
     2  32856,32928,33192,33240,33456,33792,33840,28488,29232,29448,
     3  29496,29352,29184,29376,29544,29736,29760,29640,29784,29952,
     4  30120,30264,30288,30360,30552,31104,31488,31728,31848,31824,
     5  31416,31248,31296,31440,31752,31704,31848,32016,32328,32592,
     6  32760,32832,32808,32832,32928,33072,33360,33552,33792,34008,
     7  34224,34728,34848,35064,33672,33744,33792,33888,33984,34296,
     8  34464,34536,34608,34560,34680,34704,34824,34872,34944,35160,
     9  35352,35400,35328,35448,35544,35712,35856,36048,36168,36168/
            data (jx(i),i=  301,  400)/
     +  36264,36408,36528,36600,38256,37968,37920,37824,37752,37584,
     1  37200,37032,37008,36888,36792,36816,36504,36480,36360,36240,
     2  36216,36072,36048,35904,35832,35784,35616,35400,35400,35304,
     3  35160,35016,35112,35040,38376,38568,38712,38832,38880,39024,
     4  39168,39192,39288,39408,39456,39696,39696,39792,39912,39936,
     5  40224,40608,40728,41184,41352,41616,41664,41856,41880,42096,
     6  42168,42264,42480,42600,42792,42888,42960,36840,36936,37008,
     7  37104,37296,37368,37704,37752,37848,37944,38016,38040,38184,
     8  38496,38688,38976,39024,39144,39312,39408,39312,39384,39384,
     9  39504,39672,39840,39960,40008,40104,40200,40224,40272,40368/
            data (jx(i),i=  401,  500)/
     +  40416,40608,40656,40776,40896,40872,40944,40896,41040,44352,
     1  44232,44280,44448,44424,44088,43944,43608,43248,41280,41568,
     2  41616,41832,41856,42120,42264,42768,42768,43008,43368,43584,
     3  43536,43656,43704,43848,43920,43968,44184,44160,44424,44472,
     4  44376,45120,45240,45312,45288,45048,45168,45312,45552,45888,
     5  45936,45912,45720,45432,44904,44640,44616,44280,44376,44328,
     6  44376,44256,44208,44304,44232,44112,43968,44040,44232,44232,
     7  44352,44304,44472,44640,44592,44664,44712,44712,44904,44952,
     8  45000,44856,44976,44808,44808,45000,45048,44856,44856,45024,
     9  44880,44856,44952,44976,45096,45096,45144,45240,45168,45240/
            data (jx(i),i=  501,  600)/
     +  45240,45336,45360,45456,45720,45672,45552,45552,45720,45864,
     1  45936,45936,45984,46152,46176,46272,46344,46440,46584,46536,
     2  46656,46608,46680,46560,46920,46584,46560,46680,46584,46488,
     3  46368,46200,46200,46032,46200,46224,46344,46368,46296,46464,
     4  46440,46320,46368,46248,46296,46392,46392,46488,46464,46512,
     5  46704,46656,46608,46584,46728,46752,46800,46896,49488,49416,
     6  49176,49008,48984,48912,48888,48816,48672,48672,48528,48648,
     7  48648,48720,48720,48192,47976,47904,47904,47640,47376,47352,
     8  47496,47496,47304,47280,47376,47232,47256,47400,47592,47616,
     9  47712,47712,47472,47160,46968,46872,46728,46560,46656,46608/
            data (jx(i),i=  601,  700)/
     +  46680,46776,46776,46584,46656,46872,47112,47136,47064,46896,
     1  47256,47280,47424,47448,44592,44808,45120,46128,46656,46800,
     2  46992,47208,47400,47544,48024,47712,47520,47424,47256,47352,
     3  47184,47160,47352,47736,48624,48984,46872,46944,47064,47088,
     4  46968,47112,46920,46920,46800,46776,46584,46632,46824,46920,
     5  46944,47016,47040,47136,47352,47352,47448,47376,47448,47448,
     6  47592,47616,47664,47784,47688,47736,47832,47856,48648,48432,
     7  48312,48168,48072,47904,47904,48168,48336,48432,48504,48696,
     8  48744,48840,48912,49008,49152,49344,49296,49248,49080,49032,
     9  49080,49224,49224,49128,49104,49200,49248,49344,49536,49512/
            data (jx(i),i=  701,  800)/
     +  49632,49632,49512,49272,49296,49464,49584,49632,49656,49704,
     1  49752,47760,47832,47424,47400,47496,47424,47448,47400,47256,
     2  47304,47232,47376,47424,47328,47376,47976,48096,48384,48456,
     3  48528,48408,48456,48936,49104,49272,49560,49320,49320,49224,
     4  49368,49464,49560,49608,49584,49704,49776,49800,49824,49728,
     5  49632,49584,50976,50952,50904,50856,50784,50808,50688,50712,
     6  50616,50640,50544,50472,50568,50520,50616,50568,50520,50496,
     7  50400,50472,50352,50568,50400,50352,50568,50496,50400,50400,
     8  50304,50496,50400,50352,50256,50136,50160,50280,50328,50280,
     9  50184,49992,50016,49920,49872,49944,49776,49776,49872,49872/
            data (jx(i),i=  801,  900)/
     +  49800,49704,49776,49608,49728,49704,49560,49440,49512,49488,
     1  49392,49416,49248,49224,49152,49128,49056,48744,48672,48576,
     2  48600,48432,48264,48240,48336,48384,48432,48528,48480,48384,
     3  48336,48264,48192,48168,48072,48192,48312,48456,48456,48384,
     4  48384,48240,48168,48168,48216,48336,48336,48216,48096,48144,
     5  48072,48000,47952,47832,47784,47856,47928,47856,47688,47616,
     6  47520,47472,47496,47616,47568,47688,47856,47856,47760,47832,
     7  47904,47904,48048,48192,52272,52344,52296,52104,52176,51936,
     8  51912,52080,52032,51936,51936,51864,51912,51840,51792,51816,
     9  51720,51768,51528,51624,51600,51528,51456,51360,51240,51384/
            data (jx(i),i=  901, 1000)/
     +  51384,51216,51168,51216,51144,51048,51000,50712,50856,50976,
     1  50928,51024,51000,51072,51168,51120,51192,51336,51432,51432,
     2  51288,51312,51120,50808,50688,50808,50784,50856,50760,52320,
     3  52248,52104,52128,52008,51912,51696,51624,51576,51312,51240,
     4  51360,51288,51216,51048,51000,51096,51192,51168,51264,51312,
     5  51408,51408,51312,51360,51480,51456,51360,51000,50904,51024,
     6  50640,50640,50808,50808,50616,50592,50520,50424,50400,50280,
     7  50112,50112,50040,50160,50304,50232,50160,50112,49872,49992,
     8  49968,49872,49992,49896,49896,49656,49752,49752,49464,49464,
     9  49392,49344,49320,49224,49248,49200,48888,48840,48720,49920/
            data (jx(i),i= 1001, 1100)/
     +  50232,50328,50328,50496,50688,50712,50928,51048,51168,51216,
     1  51480,51648,51672,51528,51456,51384,51192,51048,51192,51336,
     2  51288,51312,51576,51408,51288,51360,51216,51264,51384,51408,
     3  51480,51600,51720,51624,51624,51696,51768,51768,51936,51888,
     4  51960,52032,51936,52008,51936,52080,52032,52080,51984,52104,
     5  51840,51912,52152,52176,52128,52272,52272,52536,52488,52320,
     6  52320,52416,52536,52560,52488,52224,49848,49776,49800,49704,
     7  49680,49368,49416,49584,49512,49704,49584,49632,49680,49728,
     8  49608,49728,49896,49944,49872,49896,50040,50064,50160,50208,
     9  50088,50160,50232,50304,50352,50424,50448,50304,50256,50568/
            data (jx(i),i= 1101, 1200)/
     +  50616,50400,50688,50736,50904,50784,50856,51000,51048,51168,
     1  51216,51288,51312,51264,51240,51192,51216,51288,51312,51408,
     2  51072,51048,51120,51072,50832,50784,50880,50712,50664,50664,
     3  50568,50520,50688,50424,50280,50352,50448,50496,50208,49920,
     4  49824,49896,49800,49848,49704,49728,49680,49728,49968,50088,
     5  50112,50256,50256,50544,50832,50856,51120,51384,51456,51432,
     6  51552,51528,51624,51408,51432,51480,51792,51864,51792,52056,
     7  52056,51936,51936,51864,51768,51816,51888,51768,51768,51888,
     8  51912,51816,51960,52728,52776,52824,52776,52896,53088,53448,
     9  53256,53328,53304,53160,53088,52920,53040,53160,53352,53352/
            data (jx(i),i= 1201, 1300)/
     +  53208,53232,53136,53208,52992,52896,52776,52944,52920,52752,
     1  52584,52512,52536,52752,52848,53088,53112,52968,52512,52512,
     2  52872,52800,52608,52416,52392,52560,52512,52248,52104,52008,
     3  51768,51768,51960,51984,52152,52416,52368,52296,52056,52152,
     4  52392,52416,52296,52392,52320,52080,52056,51984,51936,52104,
     5  51984,51840,51744,51672,51408,51624,51504,51408,51360,51432,
     6  51480,51576,51696,51576,51720,51696,51528,51480,51360,51192,
     7  51168,51000,50952,50976,51072,51096,51384,51456,51624,51672,
     8  51408,51336,51240,51120,51048,50976,51000,51312,51288,51408,
     9  51528,51648,52464,52368,52488,52440,52872,53064,53064,53160/
            data (jx(i),i= 1301, 1400)/
     +  53160,53280,53328,53256,53088,53112,53040,52920,52824,52656,
     1  52848,52944,52896,52944,52992,53088,53016,53040,53280,53208,
     2  53376,52056,51912,51864,51648,51552,51384,51480,51528,51528,
     3  51576,51672,51600,51720,51792,51744,51912,51720,52200,52128,
     4  51888,51768,51888,52152,52032,52056,52152,52200,52320,52320,
     5  52416,52392,52608,52608,52464,52464,52632,52728,52800,52872,
     6  52920,52944,52992,53016,53088,53064,53280,53304,53376,53448,
     7  53472,53520,53400,53328,53208,53160,53232,53328,53304,52992,
     8  52920,53328,53352,53184,53064,53136,53208,53232,53424,53160,
     9  53040,52992,52728,52608,52584,52392,52512,52680,53016,52992/
            data (jx(i),i= 1401, 1500)/
     +  52632,52680,52608,52728,52824,52944,52848,53016,53016,53208,
     1  53520,53568,53496,53616,53616,53808,54912,54912,54576,54144,
     2  54072,54120,54072,53736,53568,53544,53448,53304,53208,53016,
     3  53088,53040,53184,53280,53376,53688,53928,53976,54000,54144,
     4  54216,54288,54144,53664,53736,53616,53664,53592,53472,53496,
     5  53424,53400,53184,53016,53088,52944,52920,52728,52896,53232,
     6  53400,53424,53376,53040,52896,53040,53256,53256,53376,53400,
     7  53040,53064,52944,52968,52896,52848,52704,52656,52824,52800,
     8  52680,52704,52608,52776,52752,52560,52488,52584,52560,52488,
     9  52344,52200,52056,51936,52032,51960,52032,52008,52056,52080/
            data (jx(i),i= 1501, 1600)/
     +  52176,52176,52032,52128,52224,18912,18720,18648,18240,17976,
     1  17952,17856,17832,17448,16992,16608,16560,16440,16392,18048,
     2  18048,18192,18168,18600,19008,19008,19416,19416,19512,19536,
     3  20256,19392,19176,19080,18984,18696,18672,18480,18288,17928,
     4  17664,17400,17400,17232,17088,16944,16728,16392,16272,16320,
     5  16440,16416,16632,16680,16800,16920,17016,17448,17472,17424,
     6  17736,17880,17904,18600,18936,19176,19128,19176,19464,19488,
     7  19608,19680,19872,19920,20040,20208,19272,19392,19392,19512,
     8  20016,20208,20208,20280,20256,20280,20232,19392,19440,19440,
     9  18936,18960,18696,18600,18600,19056,19080,19440,19776,20064/
            data (jx(i),i= 1601, 1700)/
     +  20136,20280,21936,21936,21096,21096,18552,18576,18504,18360,
     1  18000,17784,17712,17568,17544,17304,17112,16992,17040,16896,
     2  16656,16608,16464,16272,20352,20424,20592,20640,20400,20496,
     3  20592,20976,20880,20640,20616,20784,20880,20808,20664,20376,
     4  20448,20448,20496,20448,20280,20016,19920,19968,19920,19920,
     5  19848,18936,19032,19080,19248,19200,19080,19008,19128,19056,
     6  19104,19008,19224,19464,19512,19440,19512,19632,19680,20136,
     7  20256,20640,20712,21120,21528,21528,21120,21528,21888,21840,
     8  21720,21456,21144,20784,20688,20592,20976,21192,21264,21288,
     9  21504,21504,21960,23616,23880,24048,24288,24456,21168,21624/
            data (jx(i),i= 1701, 1800)/
     +  21888,22200,22656,23184,23208,22800,21960,23184,23328,23328,
     1  23208,23592,23544,23136,23136,23040,23040,22968,22872,22824,
     2  22992,22944,22824,22728,22680,22728,22560,22512,22368,22320,
     3  22080,22008,21984,22104,22104,22032,21912,21816,21720,21768,
     4  21672,21576,21432,21264,21168,21000,20904,20736,20664,20688,
     5  20568,20616,20544,20472,20400,20256,20112,20064,19872,19680,
     6  19608,19464,19392,19440,18936,18864,18840,19032,18984,18840,
     7  18456,18312,18240,18336,18264,18120,17832,17616,17640,17736,
     8  17712,17520,17400,17208,17064,16968,16800,16728,16608,16656,
     9  16608,16536,16560,16464,16392,16176,23592,23616,23496,23160/
            data (jx(i),i= 1801, 1900)/
     +  23160,22920,22368,22248,22104,22032,22104,23856,23808,23640,
     1  23664,23544,23688,23760,23520,23400,23352,23472,23832,23688,
     2  23664,23520,23544,23424,23328,23400,23400,22992,22896,22992,
     3  22776,22752,22512,22560,22512,22272,22416,22440,22320,21984,
     4  23256,22872,22800,22824,22752,22824,22704,22728,22608,22536,
     5  22632,22872,23064,23424,23976,21936,22104,22104,22248,22224,
     6  22512,22536,22608,22584,22632,22776,23088,23496,23760,23952,
     7  24120,24168,24360,24240,24240,24168,24240,23880,24024,24000,
     8  23904,23784,23736,23616,23496,23400,23304,23184,24432,24456,
     9  24456,24144,24024,23616,24456,24552,24648,24648,24720,24768/
            data (jx(i),i= 1901, 2000)/
     +  24912,24984,24936,25032,25080,25008,25152,25248,25224,25392,
     1  25416,25512,25632,25704,25872,26088,28656,28608,28416,28200,
     2  28032,27960,27792,27648,27552,27576,27432,27264,27312,27264,
     3  27120,26904,26832,26664,26472,26400,26304,26064,26040,25968,
     4  25872,25632,25272,25128,25008,24672,23736,23904,24000,24024,
     5  24096,24264,24480,24624,24672,24864,25056,25248,25320,25584,
     6  25632,25824,25968,25968,26040,25992,26208,26424,26520,26112,
     7  26520,26544,26544,24288,24360,24408,24768,24792,24864,24888,
     8  25056,25152,25584,25704,25872,25944,26016,26184,26232,26472,
     9  26616,26640,26928,24864,25056,25296,25392,25608,25800,26136/
            data (jx(i),i= 2001, 2100)/
     +  26136,26760,26736,26856,26928,26856,26952,26832,26256,26424,
     1  26424,26592,26616,26544,26592,26664,26760,26760,26808,26880,
     2  26880,27048,26928,26952,26832,26808,26592,26520,26088,26088,
     3  26928,26520,26616,26664,26616,26496,26592,26688,27360,26856,
     4  26976,27192,27264,27336,27624,27720,27816,27816,28656,27048,
     5  27120,27120,27456,27744,28152,28152,28200,32304,28608,28608,
     6  30288,30288,31968,28704,28944,28992,28944,29064,29064,29472,
     7  29520,29640,29736,29904,30120,30192,30504,30864,30816,30720,
     8  30768,30744,30864,30840,30648,30576,30672,30696,30624,30576,
     9  30504,30480,30336,30312,30240,30192,30024,29904,29808,29736/
            data (jx(i),i= 2101, 2200)/
     +  29496,29544,29448,29472,29400,29328,29400,29280,29232,28992,
     1  29016,28920,28896,28824,28680,28656,28536,28512,28416,28368,
     2  28320,28224,28176,28152,28104,27960,31728,31560,31656,31608,
     3  31464,31368,31176,31200,31152,30960,30912,30864,30744,30744,
     4  30696,30672,30792,30888,30960,31080,31104,31224,31224,31296,
     5  31296,31416,31440,31584,31584,31704,31704,31920,31944,32136,
     6  32136,31968,32016,32016,33504,33384,33264,33120,33120,32784,
     7  32784,31944,30936,30864,30936,30912,30960,31056,31128,31272,
     8  31536,31680,31680,31776,31776,31848,31824,31920,31920,32040,
     9  32088,32136,32208,32328,32136,32256,32856,32760,32616,32568/
            data (jx(i),i= 2201, 2300)/
     +  32472,31992,31800,31800,31704,31608,31608,31440,30960,30768,
     1  30648,30576,30624,31200,31176,31272,31272,31128,30936,30912,
     2  30816,30696,30576,30360,30000,29760,29472,29352,29184,29208,
     3  29424,29496,29496,29304,29160,28896,28656,28440,28272,28416,
     4  28416,28080,28104,28320,28464,28320,32376,32472,32568,32616,
     5  32544,32520,32640,32712,32808,32952,33000,33072,33144,33264,
     6  33240,33072,33096,33288,33192,33144,33120,32808,32592,32568,
     7  32640,32880,33000,33144,33240,33264,33432,33480,33384,33600,
     8  33816,33840,34056,34224,34368,34560,34680,34920,32208,32208,
     9  32256,32256,32352,32352,32400,32424,32688,32688,32832,32832/
            data (jx(i),i= 2301, 2400)/
     +  33024,33024,36480,35760,35784,35688,35664,35520,34200,34056,
     1  33984,32352,32256,32256,32544,32544,32472,35208,35448,35184,
     2  35040,34968,35328,35208,35280,35520,35664,36456,36456,36384,
     3  36408,36456,36360,36192,35856,35832,35640,35496,35400,35520,
     4  35592,35616,35712,35712,35784,36480,36432,36624,36624,36624,
     5  36552,36552,36768,36576,36624,35352,35520,35640,36624,36696,
     6  36768,36864,36888,36888,36456,36048,36096,36120,36240,36240,
     7  36480,36672,36840,37032,37416,37920,37968,37920,37848,37728,
     8  37464,37272,37032,36840,36720,36696,36552,36408,36288,35808,
     9  35640,35352,38328,38592,36072,36384,36720,36840,36912,36840/
            data (jx(i),i= 2401, 2500)/
     +  36936,36912,36504,36408,36336,36216,36192,36168,36288,36576,
     1  37200,37488,37584,37776,37944,37848,37896,37680,37656,38016,
     2  38496,38616,38640,38160,38256,38352,38400,35592,35592,35712,
     3  35928,36120,36120,36360,36360,36480,36576,36624,36744,36888,
     4  37008,37104,37200,37296,37512,37632,37656,37752,37896,37968,
     5  38064,38136,38232,38232,38472,38664,38136,38256,38400,38424,
     6  38712,40200,40104,40056,39576,39048,38904,38664,38568,38256,
     7  37872,37680,37440,37176,36888,38664,38712,38832,39312,39480,
     8  39480,39768,39768,40032,40056,40176,40200,40200,40344,40320,
     9  40272,40200,39432,39576,39936,40032,40176,40344,40392,37392/
            data (jx(i),i= 2501, 2600)/
     +  37488,37656,38544,38616,38712,39024,39144,39552,39576,39864,
     1  39840,39888,39984,40272,40416,40944,40944,40824,40824,40344,
     2  39288,39288,41448,41328,41112,41040,41184,40968,41088,41184,
     3  41184,41112,40656,40632,40368,40416,40728,41184,41448,41520,
     4  41808,41976,42312,42504,42648,42648,42744,43008,43152,43584,
     5  43680,43896,43968,43944,44016,44376,41160,41136,40320,40320,
     6  41160,38808,39024,39168,39312,39408,39480,39696,39792,40056,
     7  40104,40152,40392,40416,40728,40848,40872,41016,41016,41112,
     8  41112,41232,41376,41400,41544,39360,39432,39456,39528,39648,
     9  39744,39960,40032,40080,39912,40056,40896,41448,41616,41640/
            data (jx(i),i= 2601, 2700)/
     +  41592,41640,41664,41808,41808,41640,41544,41232,41136,41016,
     1  40800,40392,40440,41592,41568,41616,41832,41832,41904,40152,
     2  40176,40344,40680,40848,41064,41112,41328,41280,41400,41376,
     3  41568,41880,42048,42144,41784,41568,41352,41544,41424,41496,
     4  40416,40824,40800,41640,41640,41928,41928,42072,41928,41952,
     5  42552,38232,38448,38640,42600,42888,42696,42768,42744,42912,
     6  42960,42768,42336,41592,41808,42024,42192,42144,42168,42216,
     7  42288,42384,42432,42576,42600,42720,42816,42864,43032,43056,
     8  43152,43104,42936,42840,42768,42792,42672,42600,43224,43032,
     9  43080,43272,42768,42864,42912,43104,43200,43200,42936,43104/
            data (jx(i),i= 2701, 2800)/
     +  42936,43104,42288,42264,42408,42408,42696,42696,42888,42960,
     1  43176,43392,43584,43608,44448,44640,44784,44784,45600,45816,
     2  44160,43992,43968,43704,43512,43368,43272,43152,43104,43032,
     3  43008,42792,42144,42072,41976,41760,41688,41616,41424,41352,
     4  41328,41016,40992,40632,43776,44040,44232,44280,43896,43512,
     5  43176,43248,43200,43296,43248,42984,42960,42840,42816,42720,
     6  42720,42600,42504,42504,42312,42024,41784,41616,41544,44256,
     7  44112,44208,44112,44160,44304,44304,41880,42840,42864,43344,
     8  43392,43848,43872,44088,43920,44016,44088,44352,44520,44352,
     9  44040,43800,43776,44376,44544,44568,44640,44640,44520,44304/
            data (jx(i),i= 2801, 2900)/
     +  44280,43920,43896,43968,43800,43848,43800,43944,44040,44112,
     1  44256,44544,44328,44424,44280,44640,44304,43920,43776,43848,
     2  43824,43896,43632,43680,43632,43680,43632,43680,44640,44640,
     3  44520,44232,44232,43992,43896,43776,43656,43608,43512,43512,
     4  42528,42528,41400,41376,44136,44328,44256,44352,44424,44520,
     5  44568,44640,44664,44400,44352,44328,44640,44520,44520,44904,
     6  44928,45192,45360,45696,45240,45384,45480,45600,45504,45216,
     7  44976,45768,45480,45480,45072,45072,44520,44544,43896,43920,
     8  44328,44496,44904,44928,45000,45000,45144,45168,45288,45288,
     9  45672,45888,45744,45600,45600,45720,45720,45816,45744,45864/
            data (jx(i),i= 2901, 3000)/
     +  45816,45864,45936,45840,44688,44736,44784,44736,44808,44712,
     1  44664,44880,44880,44760,44832,44808,45240,45408,45456,45792,
     2  45936,45960,45720,45624,45600,45768,45672,45720,47688,46488,
     3  46392,46392,46080,45888,45720,45504,45024,45072,45144,45480,
     4  46584,47592,46488,46032,46032,45456,45552,45696,45888,46248,
     5  46368,46464,46464,46560,46728,47064,47232,47376,47448,47592,
     6  45840,46392,46992,47088,47160,47136,47232,47184,47280,47232,
     7  47520,46104,46080,46152,46272,46584,46752,46920,46944,47088,
     8  47232,47280,47568,47688,46272,46440,46512,46656,46560,46584,
     9  46824,46944,46992,47136,47352,47400,47688,47928,48432,48312/
            data (jx(i),i= 3001, 3100)/
     +  47832,47688,47784,47760,47808,48336,48480,48480,44640,46104,
     1  46344,46560,46728,46896,47088,47208,47832,48312,48360,48648,
     2  49008,49128,49152,48504,48576,48648,48696,48816,48744,48648,
     3  48744,48960,49032,49296,49296,47568,47304,47280,47160,47112,
     4  47016,47016,47256,47304,47424,47880,47976,48024,48624,48696,
     5  48912,49056,49272,49224,49272,49584,49968,50016,50376,50856,
     6  50976,51240,51456,51672,52320,52512,53544,53520,53496,53496,
     7  53688,53736,53736,53712,52488,52392,52320,52344,51528,51480,
     8  51456,47448,47424,47376,47424,47832,47832,47856,53784,53904,
     9  53784,53712,53664,53616,53880,54000,53976,53880,53952,53928/
            data (jx(i),i= 3101, 3200)/
     +  54024,54048,53880,53856,54024,54048,53976,53952,54000,53688,
     1  53736,53856,53856,53808,53856,53952,53928,54048,54024,53928,
     2  53976,53976,53784,54000,53976,54048,54072,54360,54480,54528,
     3  54672,53952,53952,54264,54840,54816,54888,53712,53760,53760,
     4  53832,53808,53664,53616,53808,53760,53784,53832,53736,53736,
     5  53592,53568,53808,53784,53736,53520,53424,53496,53568,53520,
     6  53544,53448,53520,53568,53376,53400,53424,53544,53520,53592,
     7  53592,53544,53544,53592,53616,53520,53376,53328,53448,53640,
     8  53544,53592,53328,53352,53472,53472,53400,53256,53328,53496,
     9  53472,53400,53496,53424,53448,53256,53280,53184,53208,53256/
            data (jx(i),i= 3201, 3300)/
     +  53304,53376,53232,53112,53112,53208,53352,53304,53400,53088,
     1  53088,53040,53040,53136,53016,53088,53160,53088,53064,53160,
     2  53184,53184,53112,52680,52656,52392,52152,52008,51864,51840,
     3  51720,51744,51600,51648,51624,51696,51456,51528,51648,51768,
     4  51888,52056,52104,51960,52104,52128,52248,52056,52008,52080,
     5  52008,51984,51912,51840,51984,52128,52440,52296,52320,52488,
     6  52608,52680,52728,52800,52680,52536,52560,52488,52392,52512,
     7  52368,52392,52296,52320,52584,52584,52272,52128,51936,51864,
     8  51912,52200,52272,52272,52416,52464,52584,52680,52728,52584,
     9  52536,52584,52752,52680,52632,52440,52344,52272,52368,52344/
            data (jx(i),i= 3301, 3400)/
     +  52440,52536,52584,52632,52776,52776,52752,52656,52800,52776,
     1  52728,52512,52560,52536,52536,52560,52488,52416,52608,52632,
     2  52632,52560,52632,52656,52536,52416,52608,52704,52704,52608,
     3  52560,52536,52656,52728,52656,52488,52440,52344,52488,52464,
     4  52512,52488,52536,52392,52296,52416,52464,52416,52272,52248,
     5  52512,52536,52488,52296,52416,52392,52464,52368,52416,52416,
     6  52152,52152,52248,52392,52440,52416,52272,52248,52440,52440,
     7  52272,52320,52272,52152,52008,51456,51336,51312,51408,51528,
     8  51576,51528,51312,51048,50880,51072,51432,51576,51456,51360,
     9  51432,51864,51840,51744,51672,51600,51696,51816,51888,51960/
            data (jx(i),i= 3401, 3500)/
     +  52008,51936,51912,52008,52080,52200,52248,52056,52368,52368,
     1  52176,52128,52248,52320,52344,52224,52344,52296,52224,51984,
     2  52080,52392,51936,51744,51696,51960,52272,52296,52248,52104,
     3  52200,52248,52320,52296,52272,52320,52248,52176,52200,52248,
     4  52200,52032,52200,52248,52176,51960,51360,51360,51528,51576,
     5  51456,51408,51288,51648,51600,51648,51528,51456,51408,51504,
     6  51528,51576,51672,51648,51792,51744,51720,51864,51720,51792,
     7  51864,51912,51888,51840,51816,51888,51912,51768,51744,51936,
     8  51984,51984,51864,51864,52128,52056,52032,51816,52176,51960,
     9  51864,51864,51768,52176,52152,52080,51480,51576,51504,51408/
            data (jx(i),i= 3501, 3600)/
     +  51384,51552,51528,51432,51528,51144,51192,51360,51384,51240,
     1  51336,51408,51240,51336,51408,51432,51360,51312,51192,51288,
     2  51312,51240,51192,51072,51168,51144,51024,51264,51240,51288,
     3  50928,50976,50976,50880,51000,51072,51024,50976,50952,50880,
     4  50880,50712,50976,50952,50688,50760,50832,50976,50856,50976,
     5  51096,51144,51192,51120,51096,51168,51192,51264,50760,50688,
     6  50664,50736,50664,50712,50832,50736,50736,50832,50832,50808,
     7  50832,50832,50760,50760,50856,50616,50664,49536,49752,49896,
     8  49944,49944,50040,49968,49752,49752,49608,49440,49440,49152,
     9  49056,49056,48792,48720,48744,48696,48624,48480,48480,48408/
            data (jx(i),i= 3601, 3700)/
     +  48552,48504,48552,48504,48672,48792,48912,48840,48888,49128,
     1  49032,49032,48936,48984,49152,49056,49296,50064,50088,50040,
     2  49944,49944,50088,50040,50016,50088,49752,49728,49776,49848,
     3  49872,49992,50136,49896,50064,50160,49968,49944,50184,50184,
     4  50136,50064,50256,50088,50064,49944,49872,49776,49752,49848,
     5  49872,50016,50160,50304,50136,49992,50064,50256,50160,50280,
     6  50376,50304,50304,50376,50376,50232,50328,50304,50304,50400,
     7  50376,50352,50400,50352,50304,50400,50448,50496,50448,50448,
     8  50448,50520,50544,50400,50616,50544,50544,50592,50616,50688,
     9  50664,50712,50712,50616,50616,50712,50664,50712,50760,50688/
            data (jx(i),i= 3701, 3800)/
     +  50760,50736,49776,49872,49872,49128,49104,49176,49416,49512,
     1  49656,49800,49896,49896,49824,49680,49296,49704,49656,49896,
     2  49944,49896,49776,49920,49968,49944,49848,49968,49968,49896,
     3  49896,49632,49632,49824,49704,49632,49584,49584,49680,49656,
     4  49464,49464,49392,49440,49368,49464,49632,49560,49560,49704,
     5  49704,49632,49032,48984,48984,48840,48912,48864,49032,49080,
     6  49056,49128,49104,49224,49344,49176,49104,49392,49320,49320,
     7  49392,49440,49536,49584,49416,49080,49080,49176,49104,49056,
     8  49152,49176,49152,49200,49224,49152,49248,49224,49128,49176,
     9  49272,49224,49272,48696,48648,48600,48672,48552,48552,48696/
            data (jx(i),i= 3801, 3900)/
     +  48720,48672,48600,48624,48600,48528,48720,48648,48792,48936,
     1  48840,48912,48888,48960,48888,48960,48912,48912,48984,49032,
     2  48864,48576,48768,49032,49080,48984,48312,48312,48360,48384,
     3  48312,48432,48360,48360,48408,48336,48336,48408,48504,48576,
     4  48528,48504,48576,48576,48432,48456,48504,48552,48624,48600,
     5  48624,48648,48624,48048,48024,48096,48120,48048,48024,48024,
     6  47952,47928,47976,48048,48000,48072,48072,47928,47880,47832,
     7  47880,47952,47904,47928,47928,48000,47928,47808,47808,47856,
     8  47736,47712,47640,47544,47592,47616,47664,47784,47712,47544,
     9  47664,47640,47592,47424,47400,47424,47184,47280,47256,47232/
            data (jx(i),i= 3901, 4000)/
     +  47280,47520,47496,47520,47544,47400,47568,47520,47472,47520,
     1  47544,47520,47400,47280,47256,47376,47400,47448,47232,47256,
     2  47184,47064,46992,47208,47280,47256,47088,47232,47280,47280,
     3  47208,47304,47232,47160,47112,47304,47304,47232,47232,47184,
     4  47304,47304,47328,47352,47256,47256,46896,46776,46824,46896,
     5  47040,47112,47088,46632,46536,46584,46656,46776,46800,47112,
     6  46968,46920,46944,47136,47136,46944,47112,47112,47088,47160,
     7  43776,43776,43920,44184,44544,45048,45504,46488,46824,46920,
     8  46872,46776,46344,45912,45168,44688,44400,44016,43824,46920,
     9  46968,46920,46872,46968,46920,47064,47088,47088,47016,46944/
            data (jx(i),i= 4001, 4100)/
     +  46968,45696,45768,45696,45768,45792,45840,45912,45912,46008,
     1  46008,46128,46200,46176,46248,46152,46080,46008,45912,45792,
     2  45864,45816,45696,45648,46224,46176,46152,46248,46248,46272,
     3  46224,46224,46320,46320,46272,46080,45984,45888,46008,46032,
     4  46200,46320,46392,46320,46272,46200,46296,46176,46248,46392,
     5  46464,46464,46560,46512,46488,46464,46752,46752,46824,46824,
     6  46512,46488,46392,46464,46632,46560,46584,46488,46464,46704,
     7  46704,46872,46848,46776,45576,45528,45480,45576,45600,45528,
     8  45552,45600,45648,45504,45360,45504,45432,45576,45672,45552,
     9  45648,45552,45552,45456,45408,45648,45600,45720,45648,45672/
            data (jx(i),i= 4101, 4200)/
     +  45720,45768,45720,45648,45720,45744,45696,45624,45696,45768,
     1  45816,45792,45744,45744,45720,45600,45576,45648,45696,45840,
     2  45840,45864,45816,45720,45912,45912,45984,46008,45840,45792,
     3  45864,45792,45840,45960,45864,45936,45960,46008,45960,46104,
     4  46056,46104,46104,46128,46008,45312,45312,45360,45360,45288,
     5  45312,45216,45240,45288,45336,45384,45360,45288,45336,45384,
     6  45408,45360,45480,45504,45528,45432,45456,45600,45528,45384,
     7  45480,45528,45192,45144,45216,44880,44832,44688,44592,44616,
     8  44736,44808,45288,45000,45288,45240,45240,45120,45000,45024,
     9  45144,45120,45168,45288,45336,45312,45336,45264,45168,45192/
            data (jx(i),i= 4201, 4300)/
     +  44976,44904,44976,44880,45024,44856,44760,45024,45072,45048,
     1  45000,44880,44736,44760,44928,45000,45120,44952,45120,45096,
     2  45048,44880,44952,44856,44832,44952,44856,44880,44664,44688,
     3  44736,44544,44760,44664,44712,44736,44832,44808,44592,44808,
     4  44880,44856,44760,44472,44424,44496,44448,44544,44520,44448,
     5  44400,44472,44472,44568,44544,44448,44352,44520,44568,44544,
     6  44616,44568,44352,44424,44544,44496,44568,44640,44616,43848,
     7  43992,44064,44040,43776,43896,43728,43656,43584,43608,43872,
     8  43800,43920,43992,44088,44280,44304,44208,44112,44112,44208,
     9  44184,43968,43848,44208,44136,44256,44280,44184,44232,44208/
            data (jx(i),i= 4301, 4400)/
     +  44064,43968,44016,44256,44184,44088,44016,43968,43848,43992,
     1  44256,44256,44088,44040,44136,44160,44232,44256,44136,44088,
     2  44208,44280,44088,44232,44280,44280,43944,43968,43920,43896,
     3  43968,43992,43776,43680,43704,43560,43536,43368,43416,43488,
     4  43512,43560,43584,43704,43752,43896,43824,43680,43896,43944,
     5  44160,44112,43992,44136,44184,44160,43008,43008,42936,43176,
     6  43104,43128,43008,43224,43224,43344,43272,43200,43272,43344,
     7  43344,43272,43104,43176,43152,43344,43368,43272,43272,43344,
     8  43392,43368,43680,43704,43608,43632,43776,43680,43752,43800,
     9  43800,43896,42816,42816,42888,42864,42936,43080,43176,43104/
            data (jx(i),i= 4401, 4430)/
     +  43032,42984,42888,42840,42720,42720,42936,42888,42912,43152,
     1  43128,43080,46104,46128,46224,46224,46464,46464,46536,46536,
     2  46344,46248,46248,45960,45960,45888,45840,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  33936,28608,24456,38976,40416,22176,42000,19800,41664,17880,
     1  42264,42432,19176,39696,21816,37608,21744,48264,44304,52464,
     2  46440,41424,20232,54408,20376,52560,34920,35928,55800,50184,
     3  29592,51672,40920,51720,51720,48192,51024,50856,41208,40920,
     4  40824,40872,41064,41280,41448,41472,41424,41496,41400,41496,
     5  41688,41832,41928,41880,41784,41472,41304,41232,41280,41232,
     6  41376,42000,42120,42072,41352,41352,41520,41784,42144,42336,
     7  42456,42552,42528,42288,41976,42120,42648,42696,42528,42288,
     8  41976,41856,41688,41688,41832,42120,42360,42672,42864,42888,
     9  42696,42576,42600,43320,43392,43560,43632,43632,43320,43056/
            data (jy(i),i=  101,  200)/
     +  42960,42816,42864,42816,42720,42648,42552,42360,42240,42192,
     1  42024,41784,17952,41976,41904,41808,41640,41280,41256,41328,
     2  41592,42288,42192,42456,42672,42648,17880,18024,18432,18528,
     3  18624,18840,18768,18816,19032,19008,19152,19128,42384,42024,
     4  42072,41832,41592,41496,41400,41376,41424,42000,42024,41904,
     5  41376,41280,41184,41208,41064,40968,40512,40536,40704,40728,
     6  40656,40536,40440,40344,40248,40056,39960,39720,40080,40464,
     7  40608,40560,40488,40008,19248,19512,19536,19632,19536,19704,
     8  19704,19872,19704,19632,19608,19728,19656,19656,19584,19512,
     9  19560,19656,19680,19920,20112,20208,20304,20520,20424,20208/
            data (jy(i),i=  201,  300)/
     +  20256,20232,20400,20616,20544,20688,20592,20856,20856,21120,
     1  21024,20880,20808,20832,20760,20712,20880,20952,21072,21096,
     2  21264,21312,21312,21456,21384,21480,21576,39504,39528,39384,
     3  39168,38856,38688,38520,38544,38712,38880,39312,39432,39360,
     4  39144,38880,38568,38496,38568,38592,38928,38904,38736,38568,
     5  38352,38328,38184,38040,38112,38328,38280,38280,38592,38592,
     6  38448,38280,37680,37512,37440,37488,37824,37944,37872,37704,
     7  37704,38184,38232,38112,21984,22008,21912,21960,21864,21936,
     8  21840,21720,21792,21840,21840,21984,22080,22080,22008,22176,
     9  21936,21792,21672,21624,21696,21648,21960,22032,22008,21864/
            data (jy(i),i=  301,  400)/
     +  21768,21816,21648,21648,52512,52560,52488,52488,52584,52656,
     1  52584,52800,52680,52824,52824,52944,52896,53040,53088,52992,
     2  53064,53040,53136,53112,53256,53184,53160,53304,53376,53328,
     3  53376,53328,53160,53112,52608,52728,52632,52752,52704,52800,
     4  52848,52992,52896,52968,53088,53160,53232,53256,53400,53544,
     5  53832,53952,53904,54144,54360,54384,54312,54264,54336,54432,
     6  54384,54528,54528,54696,54816,54528,54552,21744,21672,21768,
     7  21792,21696,21552,21456,21288,21312,21264,21312,21264,21288,
     8  21168,20856,20640,20712,20688,20736,20664,20640,20568,20472,
     9  20352,20376,20256,20328,20472,20520,20448,20496,20448,20496/
            data (jy(i),i=  401,  500)/
     +  20448,20568,20520,20592,20544,20472,20424,20352,20328,52776,
     1  52992,53376,53592,53736,53616,53952,54048,54456,20088,20136,
     2  20064,20040,20112,20208,20496,20520,20448,20400,20544,20496,
     3  20568,20640,20544,20496,20520,20448,20352,20256,20544,20472,
     4  20400,52728,52824,52968,53184,53688,53784,53544,53592,53976,
     5  54264,54408,54816,54816,54960,54888,55008,55512,55584,55632,
     6  55848,55920,55848,55824,55800,55920,55920,56136,56040,56232,
     7  56232,55944,55944,55800,56064,56064,56112,55728,55872,55728,
     8  55896,55944,56016,56088,56184,56136,56184,56256,56376,56376,
     9  56424,56544,56544,56472,56592,56232,56136,56112,56016,55920/
            data (jy(i),i=  501,  600)/
     +  56064,56088,56160,56136,56496,56280,56136,56064,56088,56256,
     1  56256,56136,56112,56232,56328,56208,56232,56688,56760,56856,
     2  56928,56832,56736,56544,56328,56328,56256,56184,56136,56184,
     3  56088,55896,55512,55440,55464,55392,55392,55344,55248,55248,
     4  55608,55656,55488,55608,55776,55824,55968,55872,55728,55584,
     5  55584,55440,55488,55344,55368,55296,55416,55512,32376,32640,
     6  33000,33456,34392,34368,34152,34176,34440,34680,34440,34200,
     7  33888,33936,33864,33600,33888,33888,33336,33048,33000,33072,
     8  33264,33360,33288,33360,33432,33528,33624,33696,33600,33504,
     9  33480,33552,33816,34320,34872,34920,34848,35160,35208,35040/
            data (jy(i),i=  601,  700)/
     +  35016,35280,35400,35592,36096,36192,36168,36096,36024,35952,
     1  35784,35712,35712,35904,20256,20184,19800,19392,18744,18624,
     2  18624,18912,18912,19104,19368,19704,20136,20424,22392,23448,
     3  23904,24456,25416,26520,28344,29208,55248,55368,55392,55128,
     4  54960,54720,54552,54672,54696,54552,54504,54456,54504,54384,
     5  54432,54432,54216,54384,54456,54624,54672,54816,54792,54912,
     6  54600,54624,54888,55176,55248,55344,55272,55488,50376,50424,
     7  50376,50424,50376,50424,50472,50544,50472,50520,50448,50424,
     8  50256,50208,50088,50160,50136,50256,50472,50328,50328,50544,
     9  50520,50640,50784,50688,50808,51000,50856,50904,51240,51360/
            data (jy(i),i=  701,  800)/
     +  51408,51648,51480,51432,51528,51576,51816,51840,51792,51792,
     1  51888,35736,35928,36672,36936,37104,37512,37776,37872,37896,
     2  37992,38136,38280,38184,38064,37944,37872,37896,37800,37656,
     3  37896,38328,38448,38616,38616,38712,38496,39192,39456,39600,
     4  39672,39552,39552,39696,40152,40248,40176,40248,40488,40512,
     5  40656,40848,57024,56952,56952,56832,56808,56712,56544,56736,
     6  56616,56736,56712,56784,56832,56952,57000,57072,57048,57168,
     7  57144,57024,56736,56568,56592,56544,56376,56328,56400,56112,
     8  56016,55608,55224,55248,55128,55128,55320,55344,55512,55512,
     9  55416,55344,55224,55176,55248,55392,55560,55440,55392,55320/
            data (jy(i),i=  801,  900)/
     +  55272,55320,55176,55080,55080,55056,54912,54936,54648,54624,
     1  54672,54576,54432,54168,54072,54168,54192,53952,54024,53808,
     2  53664,53304,53256,53304,53568,53400,53568,53688,53880,53688,
     3  53904,53544,53544,53376,53760,53832,54096,54024,54120,54144,
     4  54240,54096,54144,54312,54432,54528,54648,54576,54600,54432,
     5  54312,54288,54480,54408,54336,54384,54288,54216,54264,53928,
     6  53856,53928,54024,54120,54216,54480,54648,54696,54696,54912,
     7  54984,55248,55584,55728,58920,58728,58704,58896,58944,59064,
     8  58872,58776,58656,58728,58536,58608,58728,58896,58872,58656,
     9  58704,58992,58968,58824,58752,58872,58824,58896,58800,58608/
            data (jy(i),i=  901, 1000)/
     +  58560,58656,58584,58536,58512,58536,58344,58272,58224,58248,
     1  58176,58176,58056,58080,58008,57936,57840,57744,57768,57696,
     2  57696,57600,57792,57696,57408,57360,57312,57216,57144,50856,
     3  50760,50688,50904,50736,50736,50640,50760,50568,50472,50520,
     4  50688,50664,50712,50568,50664,50784,50808,50904,51024,50880,
     5  50880,51000,51000,51168,51192,51264,51288,50976,51000,51192,
     6  51240,51072,51072,51000,51000,51072,51072,50976,51048,51048,
     7  50952,50808,51048,51072,51168,51264,51264,51168,51072,50856,
     8  50784,50904,50472,50424,50328,50184,50136,50016,49896,49680,
     9  49632,49680,50016,49968,49752,49632,49824,50088,50112,40896/
            data (jy(i),i= 1001, 1100)/
     +  40968,41160,41304,41376,41280,41424,41472,41808,41880,42024,
     1  42144,42120,42240,42456,42384,42456,42384,42528,42984,42912,
     2  42768,42696,42744,43200,43224,43272,43488,43704,43728,43800,
     3  43824,43704,43728,43776,44136,44016,44016,43728,43728,43896,
     4  43896,43824,44016,44088,44160,44136,44256,44304,44352,44448,
     5  44616,44664,44520,44712,44760,44760,44880,44640,44568,44688,
     6  44520,44520,44328,51072,51024,51168,52224,52224,52104,52152,
     7  52056,52152,52224,52200,52272,52248,52464,52488,52392,52416,
     8  52656,52968,53088,53064,52944,52896,52872,52968,52848,52896,
     9  53040,53088,53016,53064,52944,52944,53064,53232,53400,53304/
            data (jy(i),i= 1101, 1200)/
     +  53352,53472,53496,53568,53520,53472,53400,53448,53280,53208,
     1  53040,53016,53688,53712,53664,53784,53832,53784,53832,54192,
     2  54480,54552,54648,54768,54720,54648,54648,54480,54504,54336,
     3  54336,54456,54624,54552,54408,54384,54456,54360,54336,54048,
     4  54024,53904,53856,53784,53784,53976,53976,54096,54192,54408,
     5  54312,54432,54528,54888,54792,54840,54816,54480,54576,54768,
     6  54840,54720,54696,54384,54336,54360,54840,55176,55224,55752,
     7  55776,55800,55656,55608,55704,55800,55824,55920,56088,56064,
     8  56016,55968,55896,56376,56496,56472,56688,56592,56544,45120,
     9  45216,45288,45360,45408,45528,45552,45792,45552,45576,45624/
            data (jy(i),i= 1201, 1300)/
     +  45672,45792,45792,45912,45840,45912,45792,45768,45696,45720,
     1  45624,45624,45720,45864,46032,46104,46176,46176,45960,46032,
     2  46200,46224,46176,46032,46056,46176,46224,46032,45984,45864,
     3  45744,45816,45960,46152,46128,46248,46320,46248,46200,46344,
     4  46440,46488,46488,46608,46608,46440,46320,46272,46368,46560,
     5  46632,46632,46704,46392,46392,46512,46560,46536,46656,46776,
     6  46680,46680,46968,47016,47136,47208,47112,47280,47136,47160,
     7  47208,47136,47184,47280,47256,47448,47424,47376,47376,47520,
     8  47664,47760,47784,47664,47664,47808,47928,47880,48024,48192,
     9  48216,48120,44256,44352,44112,43992,43680,43920,44088,44016/
            data (jy(i),i= 1301, 1400)/
     +  44088,44112,44184,44280,44280,44448,44568,44496,44352,44472,
     1  44544,44712,45000,45120,45120,44976,44880,44808,44760,45000,
     2  45048,48384,48336,48264,48432,48408,48576,48768,48768,48624,
     3  48600,48672,48816,48768,48816,48888,48984,48984,49152,49248,
     4  49152,49200,49416,49440,49488,49584,49584,49440,49416,49272,
     5  49320,49392,49416,49320,49272,49224,49224,49416,49176,49488,
     6  49512,49344,49320,49536,49560,49632,49656,49536,49632,49560,
     7  49584,49728,49872,50160,50088,50136,50256,56640,56808,56952,
     8  57024,56856,56976,56976,57096,57120,57072,57096,57048,57192,
     9  57360,57288,57264,57168,57264,57216,57432,57384,57456,57504/
            data (jy(i),i= 1401, 1500)/
     +  57504,57528,57624,57744,57744,57672,57600,57624,57552,57576,
     1  57336,57264,57072,57096,57216,57288,56592,56640,56928,57240,
     2  57288,57144,57168,57384,57696,57888,57936,57888,57768,57864,
     3  57912,57960,58032,58032,58176,58320,58560,58536,58680,58824,
     4  58776,58824,58896,58536,58704,58728,58824,58848,58776,58896,
     5  58776,58968,59112,59064,58896,58992,58872,58704,59064,59208,
     6  59208,59328,59352,59160,59136,59376,59472,59400,59448,59496,
     7  59520,59616,59688,59616,59568,59712,59808,59712,59520,59448,
     8  59472,59424,59376,59280,59112,59088,59160,59280,59328,59280,
     9  59376,59376,59712,59760,59592,59520,59376,59304,59280,59376/
            data (jy(i),i= 1501, 1600)/
     +  59328,59256,59160,59040,59064,33936,34056,33960,34032,33936,
     1  33984,33936,34008,33792,33864,33768,33840,33792,33888,28608,
     2  28536,28536,28608,28608,24456,24864,24864,24960,24888,24960,
     3  24912,37416,37536,37416,37416,37608,37704,37752,37656,37896,
     4  37920,38160,38352,38544,38520,38664,38712,38976,40392,40320,
     5  40344,40272,40296,40104,40032,40080,40008,39984,39936,39864,
     6  39744,39720,39792,39768,39528,39528,39360,39336,39336,39384,
     7  39384,39312,39312,39384,39120,38976,33744,33504,33360,33360,
     8  32688,32640,32352,32256,32208,31128,37752,37752,31104,30288,
     9  30264,30048,29832,29328,27768,27768,27672,27432,27504,27456/
            data (jy(i),i= 1601, 1700)/
     +  27336,27336,23352,22800,22800,22752,22776,22560,22584,22536,
     1  22680,22608,22704,22728,22608,22464,22560,22488,22344,22224,
     2  22152,22104,22080,22200,41712,41712,41520,38904,39096,39024,
     3  39024,35208,35304,35352,35424,35520,35760,35784,35760,36072,
     4  36216,36336,36384,36600,36600,36768,36864,37008,37032,37152,
     5  37272,34008,34056,34032,34104,34200,34128,34152,34320,34416,
     6  34536,34704,34728,34896,34992,35088,35232,35160,35088,35136,
     7  35064,35160,35232,31128,27360,28200,29448,29448,38736,38664,
     8  38664,38760,38640,38808,38784,25008,25032,25128,25104,25176,
     9  25176,24456,24456,28224,28008,28008,27864,27840,35016,34872/
            data (jy(i),i= 1701, 1800)/
     +  34632,34464,34416,34224,31968,31968,31128,33648,33648,33288,
     1  33168,22536,22392,22296,22152,22152,22080,22056,22080,22008,
     2  21936,21912,21864,21960,21792,21648,21648,21312,21360,21264,
     3  21264,21192,20952,21000,20832,20784,20832,20760,20856,20952,
     4  20952,20736,20808,20688,20736,20544,20328,20232,20376,20472,
     5  20448,20232,20160,20184,20352,20424,20376,20184,20304,20160,
     6  20184,20088,20112,19992,20040,19992,19896,19776,19680,19704,
     7  19992,19992,19944,19728,19704,19920,20040,20040,19968,19920,
     8  19872,19920,19752,19704,19800,19776,19848,19560,19728,19848,
     9  19920,19896,19680,19656,19800,19704,21384,22896,23016,23040/
            data (jy(i),i= 1801, 1900)/
     +  22968,22872,23112,22920,22896,22992,23208,38640,40056,40224,
     1  40344,40440,40584,40752,40872,41160,41568,41664,38208,38280,
     2  38424,38472,38280,38112,38184,38328,38376,38328,38376,38544,
     3  38544,38808,38784,38616,38568,38688,38760,38856,38976,38712,
     4  21360,21024,20856,20784,20688,20568,20472,20376,20280,20112,
     5  19896,19752,19464,19344,18624,37488,37296,37128,37104,36936,
     6  36912,36816,36792,36552,36432,36456,36360,36336,36000,35976,
     7  35808,35520,35376,35304,35064,34992,34680,34728,34536,34440,
     8  34464,34680,34704,34512,34560,34512,34584,34560,31992,26880,
     9  24864,24792,24672,24648,35376,35472,35472,35592,35592,35544/
            data (jy(i),i= 1901, 2000)/
     +  35616,35544,35448,35448,35304,35232,35112,35208,35256,35280,
     1  35328,35376,35328,35376,35352,35448,26664,26592,26664,26592,
     2  26640,26760,26808,26856,26784,26880,26784,26784,27120,27192,
     3  27144,27168,27240,27240,27336,27408,27288,27312,27192,27120,
     4  27264,27288,27192,27096,27120,26904,21504,21552,21768,22008,
     5  22056,22128,22128,22224,22128,21960,22200,22272,22464,22464,
     6  22560,22632,22752,22920,22968,23040,23304,23352,23472,35328,
     7  35328,34488,31992,38664,38640,38544,38544,38496,38520,38688,
     8  38688,38592,38544,38640,38640,38496,38520,38400,38520,38544,
     9  38400,38256,38016,25128,25056,25248,25248,25104,25080,25392/
            data (jy(i),i= 2001, 2100)/
     +  24432,24408,24264,24216,24048,23856,23760,23520,35784,35832,
     1  35928,35976,36024,36072,36168,36144,36240,36168,36144,36240,
     2  36336,36336,36576,36768,36840,36960,37104,37248,37416,37824,
     3  37848,23304,23304,23112,23016,22992,22872,22776,22776,31992,
     4  31920,31896,31800,31848,31776,31632,31584,29496,29496,37992,
     5  37992,38064,38088,38016,38280,39480,39504,34536,22752,23592,
     6  23616,24432,24432,26712,26688,26808,26880,26976,27168,27192,
     7  27480,27576,27984,28128,28368,28344,28680,32976,32832,32808,
     8  32760,32616,32688,32568,32640,32520,32496,32304,32256,32328,
     9  32280,32328,32352,32136,32280,32112,32136,31968,32064,31752/
            data (jy(i),i= 2101, 2200)/
     +  31440,31536,31560,31680,31728,31656,31536,31608,31560,31560,
     1  31656,31680,31656,31728,31464,31536,31536,31632,31632,31704,
     2  31632,31800,31800,31728,31728,31608,29184,29088,29016,28872,
     3  29040,28896,28992,28872,28800,28800,28920,28848,28872,28968,
     4  28944,28776,28344,28344,28128,28056,27912,27912,27768,27768,
     5  27624,27600,27408,27408,27288,27288,27072,27096,26808,26808,
     6  26520,26088,26112,26448,21888,21840,21912,21792,21888,21984,
     7  22728,23160,33048,33096,33168,33240,33264,33192,33312,33264,
     8  33360,33480,33552,33576,33648,33696,33744,33840,33912,33984,
     9  33936,34008,33888,33960,34368,34416,35976,36048,36072,35808/
            data (jy(i),i= 2201, 2300)/
     +  35712,35712,35880,36264,36432,36336,36096,35832,35688,35784,
     1  35760,35880,35976,36168,36384,36600,36744,36888,36792,36408,
     2  36192,36216,36360,36384,36048,36000,36072,36168,36408,36480,
     3  36552,36648,36768,36936,36984,36912,37008,37032,37152,37320,
     4  37512,37848,37944,38064,38256,38352,34584,34536,34632,34512,
     5  34512,34464,34488,34416,34608,34584,34704,34560,34680,34680,
     6  34848,34944,35040,35064,35256,35232,35136,35040,35208,35352,
     7  35544,35808,36144,36168,36312,36600,36744,36888,37032,37272,
     8  37224,37056,36936,36936,37056,36936,37008,36912,26520,26664,
     9  26664,26952,26952,27240,27240,27360,27384,27504,27504,27648/
            data (jy(i),i= 2301, 2400)/
     +  27648,27768,27840,32304,32904,32928,32880,32832,32688,32760,
     1  32712,32688,32856,33024,33264,33360,33576,36696,37440,37560,
     2  37512,37392,36984,37152,37344,37464,37416,29688,29976,30120,
     3  30288,30288,30528,30672,30648,30864,31200,31296,31440,31656,
     4  31680,31800,31800,31944,31896,28680,28680,27816,26568,25272,
     5  25272,22824,22416,21912,21792,36504,36432,36240,36264,36240,
     6  36120,36168,32880,32688,32664,32304,48288,48432,48432,48528,
     7  48576,48720,48744,48744,49008,49080,44184,44232,44232,44136,
     8  44232,44208,44280,44160,44208,44112,44064,44136,44136,44016,
     9  44160,44208,51264,46488,37560,37440,37440,37512,37728,38040/
            data (jy(i),i= 2401, 2500)/
     +  38232,38280,38256,38160,37824,37800,37848,38352,38496,38640,
     1  38544,38352,38040,38016,38352,38784,39192,39624,39768,40008,
     2  40104,40200,43680,44184,43968,43944,43824,41376,41304,41280,
     3  41352,41232,41184,41184,41112,41064,41040,41088,41016,41040,
     4  40968,41016,40896,40944,40752,40776,40632,40560,40560,40464,
     5  40512,40344,40344,40272,40416,40416,40872,40704,40680,40536,
     6  40464,36696,36720,36888,36672,36696,36792,36744,36864,36864,
     7  36648,36672,36552,36216,36312,40176,40344,40320,39912,39936,
     8  39648,39576,39528,39528,38952,38928,37152,38112,38136,38352,
     9  38328,38592,29712,29832,29664,29496,29568,29472,29448,32880/
            data (jy(i),i= 2501, 2600)/
     +  32928,33240,33216,33168,33000,32976,32904,32904,32496,32496,
     1  31224,31032,30864,30816,30576,25296,25824,25848,28224,28248,
     2  26544,25296,34776,34824,34848,34920,35184,35760,35928,36240,
     3  37344,37224,37008,36840,37224,37416,37680,37800,37608,37776,
     4  37776,37824,38088,38112,38328,38712,39048,38928,39072,39096,
     5  39192,39120,39168,39792,39888,39960,25272,23184,23184,22344,
     6  22344,43488,43440,43176,43056,43056,43176,43176,43080,43224,
     7  43152,43224,43176,43056,43176,43104,43248,43320,43224,43224,
     8  43440,43440,43512,43752,43848,40320,40392,40752,40872,40944,
     9  40920,40632,40608,40728,41232,41328,41328,40992,41040,41136/
            data (jy(i),i= 2601, 2700)/
     +  41424,41640,41736,41808,40392,40320,40176,39888,39696,39696,
     1  39552,39216,39144,43776,43128,42936,42792,42264,41952,46560,
     2  46632,46704,46752,46968,47040,47112,47112,47208,47232,47304,
     3  47352,47616,47976,33504,33960,33984,34272,34440,34584,34632,
     4  32640,32640,33216,33216,33360,33360,33504,48216,48408,48840,
     5  49008,49152,49128,49200,49296,50448,46056,46224,46344,46488,
     6  46656,46920,47184,44184,44400,44448,44592,44688,44784,44808,
     7  44736,44760,44880,44928,45144,45240,45216,45312,45336,45480,
     8  45528,45648,45720,45696,45768,45816,45840,45936,46008,50736,
     9  51072,51336,52368,52512,52824,52872,52968,53040,53448,53688/
            data (jy(i),i= 2701, 2800)/
     +  53952,54240,33504,33360,33360,33216,33216,32952,32904,32664,
     1  32592,32616,32400,32328,47616,46896,46896,46800,46944,46920,
     2  29568,29568,29520,29472,29640,29568,29784,29760,29808,29760,
     3  29616,29520,29472,29544,29448,29544,29472,29520,29448,29496,
     4  29640,29688,29736,29520,43728,43560,43344,35112,35232,35496,
     5  35352,35232,35064,35016,34872,34872,35040,35088,35160,35160,
     6  35040,34944,34944,34872,35088,35064,34944,35088,35064,43128,
     7  42960,42576,42408,42288,42288,42144,42816,42504,42576,42432,
     8  42264,42288,42144,29832,30048,30264,30312,30648,31200,31584,
     9  31920,32040,32184,38976,38904,38832,38808,38040,37944,37968/
            data (jy(i),i= 2801, 2900)/
     +  37776,37512,37440,37392,37200,37104,36984,36624,36624,36696,
     1  36336,36216,35760,35592,35472,34992,34176,33960,33984,33744,
     2  33696,33624,32952,32808,32664,32616,32472,32400,26424,25296,
     3  25296,26448,27312,27216,27144,27168,27312,27240,27264,26400,
     4  26400,26112,26112,25296,29496,29376,29256,29184,28944,28872,
     5  28680,28584,41184,40008,40080,40800,41016,41112,41184,41088,
     6  40872,40920,39048,51336,50904,50904,50808,50424,50256,50232,
     7  50352,44016,43992,43800,43776,43512,43512,43344,45912,45768,
     8  45864,45624,45792,45720,45744,45840,45840,45768,45768,45840,
     9  45840,45936,44856,44832,44904,45168,45360,45408,45648,45720/
            data (jy(i),i= 2901, 3000)/
     +  46176,46296,46320,46464,52512,52560,52536,52464,52368,52344,
     1  52176,51888,51768,51600,51528,51456,51288,51600,52032,52200,
     2  52152,52104,51960,51744,51504,51504,51384,51384,49584,50040,
     3  49968,49896,49416,49392,49200,49128,49056,34872,34776,37848,
     4  37032,43008,43704,43824,44016,41040,41136,41136,41328,41400,
     5  41520,41808,41952,42144,42288,42240,42336,42288,42192,42216,
     6  39648,39888,39912,40008,40152,40488,40776,40968,41184,41304,
     7  41592,47112,47232,47328,47424,47448,47616,47856,48072,48336,
     8  48360,48432,48432,48528,52296,52440,52440,52560,52896,53016,
     9  53232,53184,53904,54024,54120,54288,54576,55464,42408,42216/
            data (jy(i),i= 3001, 3100)/
     +  42312,49824,49896,50040,50160,50136,50160,50208,29568,51192,
     1  50856,50832,50904,50808,50904,50880,51336,51456,51600,51648,
     2  51576,51624,51672,42360,42120,42096,41832,41760,41664,41616,
     3  41448,41232,41280,41088,40920,44088,44064,44400,44400,44520,
     4  44520,44712,44712,44880,44880,45120,45288,45480,45984,46248,
     5  46440,46656,46728,46824,46872,47040,47448,47592,47784,48312,
     6  48360,48312,48384,48336,51048,50856,47544,47616,47592,47472,
     7  48168,48192,48168,48120,48144,48312,48240,48144,51864,51912,
     8  51816,55152,55200,55152,55128,60240,60144,60192,47520,48144,
     9  48072,47760,47784,47184,43512,43752,43968,43848,45072,44952/
            data (jy(i),i= 3101, 3200)/
     +  44952,44856,44880,44736,44736,44616,44664,44544,44544,46248,
     1  45960,45768,45648,45648,45408,45384,45288,45120,45408,45648,
     2  45648,45696,46200,44304,44088,44040,44232,56688,56688,56616,
     3  56640,57144,57072,56880,56568,56544,56520,48792,48696,48504,
     4  48576,48768,49248,49272,44928,44880,44784,44832,44472,44616,
     5  44736,44568,44664,44736,44736,48024,48048,47880,47976,45384,
     6  45432,45432,44304,44424,44424,44184,44280,46584,46680,46608,
     7  47088,47136,47064,44760,44832,44976,44952,44832,44856,44496,
     8  44496,44448,46272,46224,46248,44544,44688,44664,44520,46560,
     9  46512,46608,45936,45888,45960,44328,44496,44568,44352,48480/
            data (jy(i),i= 3201, 3300)/
     +  48264,48312,48720,48744,48648,48576,48072,48024,47952,45960,
     1  46056,46056,45960,44664,44712,44616,47616,47640,47568,47544,
     2  48096,48144,48096,42480,42360,42096,42072,42168,42168,42072,
     3  42048,42240,42456,42648,42936,43056,43152,43368,43464,43392,
     4  43656,43728,43656,43584,43488,43584,43344,43416,43392,43296,
     5  43296,43464,43488,43320,43200,43176,43320,43488,43584,43536,
     6  43392,43392,43440,43128,43152,43104,43176,43224,43104,42984,
     7  42960,43008,42960,42888,42792,42744,42816,42768,42960,42888,
     8  42816,42576,42600,42696,42600,42672,42672,42720,42648,43032,
     9  43032,42984,43032,43104,43752,43848,43992,43872,43776,43728/
            data (jy(i),i= 3301, 3400)/
     +  43608,43680,43488,43464,43608,49128,49176,49056,46488,46560,
     1  46512,47976,47976,48024,48888,48936,48960,48840,47496,47520,
     2  47616,47592,46416,46464,46464,46392,48648,48624,48696,48696,
     3  48816,48720,42840,42936,42912,49056,49200,49104,47616,47664,
     4  47688,42864,42912,42888,59688,59712,59976,59976,59760,59520,
     5  59448,59616,59664,59568,47760,47808,47832,46680,46728,46944,
     6  46728,46680,46728,47928,47928,48048,48072,47976,48624,48696,
     7  48648,48600,41184,40848,40680,40200,40176,40248,40248,40344,
     8  40536,40680,40824,40896,41208,41184,41376,41544,41568,41712,
     9  41808,41736,41592,41520,41544,41448,41472,41424,41520,41496/
            data (jy(i),i= 3401, 3500)/
     +  41544,41592,41712,41880,41784,41712,41760,42000,42048,41640,
     1  44352,44184,44136,44232,44376,44424,47856,47904,47856,51576,
     2  51408,51240,51888,51984,51936,51696,59904,60000,60000,59856,
     3  59640,47472,47472,47424,47664,47688,47712,47688,46968,47088,
     4  47088,46704,48168,48192,48240,48192,42576,42624,42672,42600,
     5  42432,42528,42432,51888,51888,51792,52320,52368,52344,52248,
     6  52152,52056,52056,52224,51360,51456,51360,47640,47712,47616,
     7  48144,48144,48072,48120,51624,51552,51600,51864,51696,51432,
     8  51408,51480,51456,51408,55920,55848,55896,47784,47784,47928,
     9  47880,48000,47880,51168,51264,51240,51384,51336,51480,51432/
            data (jy(i),i= 3501, 3600)/
     +  51336,50664,50712,50616,50616,51768,51648,51744,51840,51864,
     1  47256,47328,47352,52464,52440,52488,52776,52824,52704,52752,
     2  52680,52632,52680,52632,52608,52512,52464,52320,52536,52608,
     3  52704,52704,52656,51456,51480,51600,51744,51648,51792,51816,
     4  51528,51528,53256,53304,53112,53040,53064,53040,52944,52896,
     5  52968,51192,51240,51264,51216,52920,52872,52944,52656,52728,
     6  52680,53424,53424,53232,53328,58440,58392,58392,58464,58512,
     7  57000,57024,57000,52392,52464,52488,52344,36768,36672,36744,
     8  36552,36408,36264,36024,35928,35736,35544,35160,35016,34536,
     9  34464,34584,34704,34848,35040,35280,35352,35352,35448,35568/
            data (jy(i),i= 3601, 3700)/
     +  35784,35880,35976,36024,36120,36384,36408,36576,36648,36648,
     1  36696,36864,36960,37008,36984,37248,37104,51216,51264,51312,
     2  51288,51240,52272,52272,52368,52344,52680,52656,52584,52560,
     3  52656,52464,52560,52728,52056,52032,52224,52056,51864,51768,
     4  51792,51480,51528,51720,51552,51528,51384,51384,51000,51072,
     5  51312,51384,55488,55560,55584,55464,55416,55968,55944,55872,
     6  52560,52560,52656,52632,51624,51696,51696,57240,57216,57216,
     7  57312,51360,51408,51480,51432,36000,35952,36000,36048,51408,
     8  51336,51336,51576,51528,52992,52920,52968,52848,52752,52800,
     9  52848,51432,51336,51336,51432,53016,52992,52872,52896,51648/
            data (jy(i),i= 3701, 3800)/
     +  51624,51672,52368,52296,52392,58632,58488,58368,58128,57888,
     1  57840,57888,58032,58224,58464,58656,58752,40680,40848,40776,
     2  40680,40488,40560,52368,52344,52440,52488,51576,51672,51672,
     3  51600,50616,50664,50688,50928,50808,50808,50952,51024,51072,
     4  51024,50904,50856,50688,50688,50496,50496,51168,51072,51168,
     5  51360,51360,54960,54984,55200,55104,55008,54936,54672,54720,
     6  54816,54840,55008,54888,54864,55176,55128,55416,55416,55512,
     7  55488,55008,55032,55152,55152,55392,55440,55392,54432,54384,
     8  54264,54408,55512,55464,55584,55632,54744,54816,54720,54672,
     9  54648,54600,54528,55056,55080,55032,55008,54096,53976,54168/
            data (jy(i),i= 3801, 3900)/
     +  54432,54504,54432,54216,54096,54216,54768,54720,54528,54552,
     1  54480,54576,54336,54432,54408,55512,55512,55440,55416,55488,
     2  59280,59496,59256,59088,59112,59256,54816,54696,54696,54864,
     3  54864,54936,54960,55032,54384,54432,54336,54312,54360,54360,
     4  54456,54720,54744,54816,54720,54552,54552,54888,54912,54864,
     5  55344,55416,55440,59664,59616,59640,59784,59784,54720,54888,
     6  54864,54576,54528,54672,55896,55920,55872,56136,56256,56136,
     7  56040,56016,56016,55944,60048,60072,60144,55944,55896,55944,
     8  55392,55584,55560,55296,55176,55320,55392,55992,56112,56040,
     9  56232,56280,56184,56184,56112,56232,56208,56136,56136,55824/
            data (jy(i),i= 3901, 4000)/
     +  55776,55968,60408,60336,60456,60504,56520,56544,56520,56472,
     1  55392,55656,55512,55488,55440,55464,55368,55416,55632,55680,
     2  55728,55656,55512,54912,54936,54984,54984,60648,60672,60624,
     3  55200,55296,55296,55464,55416,54600,54648,54648,54864,54792,
     4  54696,54816,55080,55128,55200,55104,55824,55896,55920,56088,
     5  56160,56256,56304,56016,55680,55704,55632,55608,55680,55728,
     6  55968,55944,55824,57624,57696,57600,57552,60720,60768,60744,
     7  60648,60840,61032,61224,61392,61488,61512,61296,61128,60936,
     8  60816,60768,60744,61032,61056,60984,60864,60576,60576,55512,
     9  55488,55632,55584,60864,60840,60768,56808,56880,56904,56784/
            data (jy(i),i= 4001, 4100)/
     +  56688,56688,56712,56856,56928,56928,56664,56616,56784,56616,
     1  56808,56544,56544,56496,56328,56400,56352,56472,56304,56256,
     2  56448,56544,56520,56688,57792,57768,57672,57600,60048,60072,
     3  60096,57072,57096,57192,57216,57096,57072,56880,56880,56976,
     4  56976,56328,56664,56928,56904,56736,60000,59976,59928,59880,
     5  59928,60000,56040,56112,56064,55944,55464,55512,55536,57432,
     6  57336,57456,57480,57264,57312,57216,57072,56976,56784,57120,
     7  57264,57264,57336,57144,58104,58152,57984,57888,60648,60648,
     8  60576,56424,56448,56712,56568,56448,56352,56352,56952,57072,
     9  57048,56856,56928,56976,56808,56760,56904,57144,57144,57312/
            data (jy(i),i= 4101, 4200)/
     +  57288,60408,60552,60456,60384,57528,57552,57432,57360,57384,
     1  60792,60864,60840,57648,57768,57768,57576,57576,57648,57576,
     2  57648,60936,61008,60912,57288,57384,57336,57456,57480,57264,
     3  57144,57120,56952,57144,57216,60456,60480,60432,60384,60048,
     4  59976,59976,57192,57264,57192,57600,57480,57576,56472,56496,
     5  56568,56520,56328,56352,56256,56304,57096,57048,57000,57024,
     6  57240,57192,57072,57240,57312,57336,60816,60840,60888,60840,
     7  60696,60720,56280,56208,56160,57360,57432,57432,57504,57408,
     8  57384,57288,57096,57408,57384,57528,57816,57744,57792,57648,
     9  57600,57480,57360,57240,57336,56712,56808,56784,56832,56760/
            data (jy(i),i= 4201, 4300)/
     +  56976,56904,56928,57672,57504,57816,57768,56976,57000,57096,
     1  57024,56736,56688,56616,56664,56616,56712,56784,57936,58008,
     2  57936,57072,57096,57168,57120,58104,58080,57984,57552,57528,
     3  57552,57672,57864,57864,57816,56832,56856,56952,56904,57576,
     4  57552,57624,57672,57480,57456,57408,56544,56496,56784,56736,
     5  56568,57024,56976,57000,57072,58056,57864,57816,57912,56376,
     6  56424,56472,56304,56280,57312,57288,57216,57240,57312,57936,
     7  57936,57840,57792,57768,57648,57696,57768,57744,57624,57600,
     8  57504,57528,57672,57648,57744,57816,57792,57840,57936,57864,
     9  58032,58056,58104,56328,56208,56232,56424,58128,58152,58200/
            data (jy(i),i= 4301, 4400)/
     +  58272,57000,56784,56952,57048,56952,57120,55848,55656,55560,
     1  55584,55728,55848,56472,56280,56472,56472,56592,56568,56616,
     2  57384,57408,57504,57096,57048,57120,58128,58224,58296,58200,
     3  57360,57432,57408,57480,57528,57480,57600,57648,57480,57480,
     4  57360,57384,57264,57384,57264,57288,57192,57168,57024,57240,
     5  57288,57336,57312,57144,57168,57216,58128,58080,58080,57936,
     6  58032,58104,58176,57912,57840,57864,57960,55944,55992,55944,
     7  56112,56184,56112,56040,55920,57744,57768,57816,57768,58344,
     8  58344,58272,57864,57912,57936,57864,55704,55728,55776,57888,
     9  57816,57816,55296,55248,55248,55104,54960,54888,54720,54456/
            data (jy(i),i= 4401, 4430)/
     +  54744,54816,54768,55008,55176,55224,58296,58296,58176,55704,
     1  55776,55728,51576,51216,51216,51096,51096,51216,51216,51408,
     2  51432,51504,51792,51720,51864,51864,51672,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +     34,    6,    3,    4,    2,    1,    1,    5,   39,   40,
     1     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     2     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     3     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     4     71,   72,   73,    7,    7,   75,   76,   77,   78,   79,
     5     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     6     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     7    100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
     8    110,  111,    9,   10,    8,   11,  114,  115,  116,  117,
     9    118,  119,  120,    9,   11,  122,  123,  124,  125,   12/
            data (jb1(i),i=  101,  200)/
     +     10,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     1    136,  137,   13,   12,  139,  140,  141,  142,  143,  144,
     2    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     3    155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
     4    165,  166,  167,  168,  169,  170,  171,  172,  173,   14,
     5     13,  175,  176,  177,  178,  179,  180,  181,  182,  183,
     6    184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
     7    194,  195,  196,  197,  198,  199,  200,  201,  202,  203,
     8    204,  205,  206,  207,  208,  209,  210,  211,  212,  213,
     9    214,  215,  216,  217,  218,  219,  220,  221,  222,  223/
            data (jb1(i),i=  201,  300)/
     +    224,  225,  226,   15,   18,   19,   19,   16,   14,  228,
     1    229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
     2    239,  240,  241,  242,  243,  244,  245,  246,  247,  248,
     3    249,  250,  251,  252,  253,  254,  255,  256,  257,  258,
     4    259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
     5    269,  270,  271,  272,  273,   16,   15,  275,  276,  277,
     6    278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
     7    288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
     8    298,  299,  300,  301,  302,  303,   17,   20,  305,  306,
     9    307,  308,  309,  310,  311,  312,  313,  314,  315,  316/
            data (jb1(i),i=  301,  400)/
     +    317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
     1    327,  328,  329,  330,  331,  332,  333,   18,   20,  335,
     2    336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
     3    346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
     4    356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
     5    366,   24,   17,  368,  369,  370,  371,  372,  373,  374,
     6    375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
     7    385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
     8    395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
     9    405,  406,  407,  408,   23,   26,  410,  411,  412,  413/
            data (jb1(i),i=  401,  500)/
     +    414,  415,  416,  417,   24,   23,  419,  420,  421,  422,
     1    423,  424,  425,  426,  427,  428,  429,  430,  431,  432,
     2    433,  434,  435,  436,  437,  438,  439,  440,   25,   26,
     3    442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
     4    452,  453,  454,  455,  456,  457,  458,  459,  460,  461,
     5    462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
     6    472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
     7    482,  483,  484,  485,  486,  487,  488,  489,  490,  491,
     8    492,  493,  494,  495,  496,  497,  498,  499,  500,  501,
     9    502,  503,  504,  505,  506,  507,  508,  509,  510,  511/
            data (jb1(i),i=  501,  600)/
     +    512,  513,  514,  515,  516,  517,  518,  519,  520,  521,
     1    522,  523,  524,  525,  526,  527,  528,  529,  530,  531,
     2    532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
     3    542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
     4    552,  553,  554,  555,  556,  557,   31,  559,  560,  561,
     5    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     6    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     7    582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
     8    592,  593,  594,  595,  596,   27,   27,  598,  599,  600,
     9    601,  602,  603,  604,  605,  606,  607,  608,  609,  610/
            data (jb1(i),i=  601,  700)/
     +    611,  612,  613,   28,   25,  615,  616,  617,  618,  619,
     1    620,  621,  622,  623,  624,  625,  626,  627,  628,  629,
     2    630,  631,  632,  633,  634,  635,   31,  558,  637,  638,
     3    639,  640,  641,  642,  643,  644,  645,  646,  647,  648,
     4    649,  650,  651,  652,  653,  654,  655,  656,  657,  658,
     5    659,  660,  661,  662,  663,  664,  665,  666,  667,   29,
     6     30,  669,  670,  671,  672,  673,  674,  675,  676,  677,
     7    678,  679,  680,  681,  682,  683,  684,  685,  686,  687,
     8    688,  689,  690,  691,  692,  693,  694,  695,  696,  697,
     9    698,  699,  700,  701,  702,  703,  704,  705,   32,   32/
            data (jb1(i),i=  701,  800)/
     +    707,  708,  709,  710,   34,   28,  712,  713,  714,  715,
     1    716,  717,  718,  719,  720,  721,  722,  723,  724,  725,
     2    726,  727,  728,  729,  730,  731,  732,  733,  734,  735,
     3    736,  737,  738,  739,  740,  741,  742,  743,  744,  745,
     4    746,  747,  748,  749,  750,  751,   33,  753,  754,  755,
     5    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     6    766,  767,  768,  769,  770,  771,  772,  773,  774,  775,
     7    776,  777,  778,  779,  780,  781,  782,  783,  784,  785,
     8    786,  787,  788,  789,  790,  791,  792,  793,  794,  795,
     9    796,  797,  798,  799,  800,  801,  802,  803,  804,  805/
            data (jb1(i),i=  801,  900)/
     +    806,  807,  808,  809,  810,  811,  812,  813,  814,  815,
     1    816,  817,  818,  819,  820,  821,  822,  823,  824,  825,
     2    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     3    836,  837,  838,  839,  840,  841,  842,  843,  844,  845,
     4    846,  847,  848,  849,  850,  851,  852,  853,  854,  855,
     5    856,  857,  858,  859,  860,  861,  862,  863,  864,  865,
     6    866,  867,  868,  869,  870,  871,  872,  873,   29,  875,
     7    876,  877,  878,  879,  880,  881,  882,  883,  884,  885,
     8    886,  887,  888,  889,  890,  891,  892,  893,  894,  895,
     9    896,  897,  898,  899,  900,  901,  902,  903,  904,  905/
            data (jb1(i),i=  901, 1000)/
     +    906,  907,  908,  909,  910,  911,  912,  913,  914,  915,
     1    916,  917,  918,  919,  920,  921,  922,  923,  924,  925,
     2    926,  927,  928,  753,   37,  930,  931,  932,  933,  934,
     3    935,  936,  937,  938,  939,  940,  941,  942,  943,  944,
     4    945,  946,  947,  948,  949,  950,  951,  952,  953,  954,
     5    955,  956,  957,  958,  959,  960,  961,  962,  963,  964,
     6    965,  966,  967,  968,  969,  970,  971,  972,  973,  974,
     7    975,  976,  977,  978,  979,  980,  981,  982,  983,  984,
     8    985,  986,  987,  988,  989,  990,  991,  992,  993,  994,
     9    995,  996,  997,  998,   30,   33, 1000, 1001, 1002, 1003/
            data (jb1(i),i= 1001, 1100)/
     +   1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013,
     1   1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023,
     2   1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033,
     3   1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043,
     4   1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053,
     5   1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062,   38,
     6   1064, 1065,   37,   35, 1067, 1068, 1069, 1070, 1071, 1072,
     7   1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082,
     8   1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092,
     9   1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102/
            data (jb1(i),i= 1101, 1200)/
     +   1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112,
     1   1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122,
     2   1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132,
     3   1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142,
     4   1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151, 1152,
     5   1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162,
     6   1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172,
     7   1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182,
     8   1183, 1184, 1185, 1186, 1187, 1188, 1190, 1191, 1192, 1193,
     9   1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202, 1203/
            data (jb1(i),i= 1201, 1300)/
     +   1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213,
     1   1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223,
     2   1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233,
     3   1234, 1235, 1236, 1237, 1238, 1239, 1240, 1241, 1242, 1243,
     4   1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253,
     5   1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263,
     6   1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273,
     7   1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283,
     8   1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291,   36, 1063,
     9   1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302/
            data (jb1(i),i= 1301, 1400)/
     +   1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312,
     1   1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1190,   36,
     2   1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331,
     3   1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341,
     4   1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351,
     5   1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361,
     6   1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371,
     7   1372, 1373, 1374, 1375, 1376,   38, 1189, 1378, 1379, 1380,
     8   1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390,
     9   1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400/
            data (jb1(i),i= 1401, 1500)/
     +   1401, 1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409, 1410,
     1   1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419, 1420,
     2   1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428, 1429, 1430,
     3   1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439, 1440,
     4   1441, 1442, 1443, 1444, 1445, 1446, 1447, 1448, 1449, 1450,
     5   1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458, 1459, 1460,
     6   1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470,
     7   1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478, 1479, 1480,
     8   1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488, 1489, 1490,
     9   1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500/
            data (jb1(i),i= 1501, 1600)/
     +   1501, 1502, 1503, 1504,  875, 1506, 1507, 1508, 1509, 1510,
     1   1511, 1512, 1513, 1514, 1515, 1516, 1517, 1518, 1519,    2,
     2   1520, 1521, 1522, 1523,    3, 1525, 1526, 1527, 1528, 1529,
     3   1530, 1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540,
     4   1541, 1542, 1543, 1544, 1545, 1546, 1547, 1548,    5, 1549,
     5   1550, 1551, 1552, 1553, 1554, 1555, 1556, 1557, 1558, 1559,
     6   1560, 1561, 1562, 1563, 1564, 1565, 1566, 1567, 1568, 1569,
     7   1570, 1571, 1572, 1573, 1574, 1575, 1506, 1577, 1578, 1579,
     8   1580, 1581, 1582, 1583, 1584, 1585, 1576, 1587, 1532, 1586,
     9   1589, 1590, 1591, 1592, 1593, 1524, 1524, 1595, 1596, 1597/
            data (jb1(i),i= 1601, 1700)/
     +   1598, 1599, 1600, 1601, 1531, 1603, 1604, 1605, 1606, 1607,
     1   1608, 1609, 1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617,
     2   1618, 1619, 1620, 1621, 1622, 1623, 1624,    7, 1625, 1626,
     3   1627, 1576, 1629, 1630, 1628, 1632, 1633, 1634, 1635, 1636,
     4   1637, 1638, 1639, 1640, 1641, 1642, 1643, 1644, 1645, 1646,
     5   1647, 1648, 1649, 1650, 1532, 1506, 1652, 1653, 1654, 1655,
     6   1656, 1657, 1658, 1659, 1660, 1661, 1662, 1663, 1664, 1665,
     7   1666, 1667, 1668, 1669, 1670, 1671, 1672, 1632, 1586, 1602,
     8   1675, 1674, 1677, 1676, 1679, 1680, 1681, 1682, 1683, 1684,
     9   1628, 1531, 1686, 1687, 1688, 1689, 1690, 1691, 1692, 1603/
            data (jb1(i),i= 1701, 1800)/
     +   1676, 1694, 1695, 1696, 1697, 1632, 1699, 1700, 1701, 1702,
     1   1703, 1705, 1706, 1674, 1704, 1708, 1709, 1710, 1705, 1712,
     2   1713, 1714, 1715, 1716, 1717, 1718, 1719, 1720, 1721, 1722,
     3   1723, 1724, 1725, 1726, 1727, 1728, 1729, 1730, 1731, 1732,
     4   1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742,
     5   1743, 1744, 1745, 1746, 1747, 1748, 1749, 1750, 1751, 1752,
     6   1753, 1754, 1755, 1756, 1757, 1758, 1759, 1760, 1761, 1762,
     7   1763, 1764, 1765, 1766, 1767, 1768, 1769, 1770, 1771, 1772,
     8   1773, 1774, 1775, 1776, 1777, 1778, 1779, 1780, 1781, 1782,
     9   1783, 1784, 1785, 1786, 1787, 1788, 1789, 1790, 1791, 1792/
            data (jb1(i),i= 1801, 1900)/
     +   1793, 1794, 1795, 1796, 1712, 1798, 1799, 1800, 1801, 1802,
     1   1803, 1804, 1805, 1806, 1603, 1712, 1808, 1809, 1810, 1811,
     2   1812, 1813, 1814, 1815, 1816, 1817, 1818, 1808, 1819, 1820,
     3   1821, 1822, 1823, 1824, 1825, 1826, 1827, 1828, 1829, 1830,
     4   1831, 1832, 1833, 1834, 1835, 1836, 1837, 1838, 1839, 1679,
     5   1797, 1841, 1842, 1843, 1844, 1845, 1846, 1847, 1848, 1849,
     6   1850, 1851, 1852, 1853, 1854, 1855, 1679, 1856, 1857, 1858,
     7   1859, 1860, 1861, 1862, 1863, 1864, 1865, 1866, 1867, 1868,
     8   1869, 1870, 1871, 1872, 1873, 1874, 1875, 1876, 1877, 1878,
     9   1879, 1880, 1881, 1882, 1883, 1884, 1885, 1886, 1887, 1704/
            data (jb1(i),i= 1901, 2000)/
     +   1705, 1698, 1890, 1891, 1892, 1893, 1798, 1698,   11, 1873,
     1   1895, 1896, 1897, 1898, 1899, 1900, 1901, 1902, 1903, 1904,
     2   1905, 1906, 1907, 1908, 1909, 1910, 1911, 1912, 1913, 1914,
     3   1915, 1917, 1918, 1919, 1920, 1921, 1922, 1923, 1924, 1925,
     4   1926, 1927, 1928, 1929, 1930, 1931, 1932, 1933, 1934, 1935,
     5   1936, 1937, 1938, 1939, 1940, 1941, 1942, 1943, 1944, 1945,
     6   1890, 1797, 1947, 1948, 1949, 1950, 1951, 1952, 1953, 1954,
     7   1955, 1956, 1957, 1958, 1959, 1960, 1961, 1962, 1963, 1964,
     8   1965, 1966, 1967, 1968, 1916, 1970, 1971, 1972, 1889, 1808,
     9   1974, 1975, 1976, 1977, 1978, 1979, 1980, 1981, 1982, 1983/
            data (jb1(i),i= 2001, 2100)/
     +   1984, 1985, 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1891,
     1   1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003,
     2   2004, 2005, 2006, 2007, 1969, 1916, 2009, 2010, 2011, 2012,
     3   2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022,
     4   2023, 2024, 2025, 2026, 2027, 2028, 2029, 2030, 1993, 1969,
     5   2032, 2033, 2034, 2035, 2036, 2037, 2038, 2039, 1973, 2040,
     6   2041, 2042, 2043, 2044, 2045, 2046, 2047, 2048, 1917, 1993,
     7   2050, 2051, 2052, 2053, 2054, 2055, 2056, 2057, 1972, 2039,
     8   2059, 2060, 2061, 2062, 1917, 2064, 2065, 2066, 2067, 2068,
     9   2069, 2070, 2071, 2072, 2073, 2074, 2075, 2076, 2078, 2079/
            data (jb1(i),i= 2101, 2200)/
     +   2080, 2081, 2082, 2083, 2084, 2085, 2086, 2087, 2088, 2089,
     1   2090, 2091, 2092, 2093, 2094, 2095, 2096, 2097, 2098, 2099,
     2   2100, 2101, 2102, 2103, 2104, 2105, 2106, 2107, 2108, 2109,
     3   2110, 2111, 2112, 2113, 2114, 2115, 2116, 2117, 2118, 2119,
     4   2120, 2121, 2122, 2123, 2124, 2125, 2047, 2078, 2127, 2128,
     5   2129, 2130, 2131, 2132, 2133, 2134, 2135, 2136, 2137, 2138,
     6   2139, 2140, 2141, 2077, 2077, 2143, 2144, 2145, 2146, 2147,
     7   2148, 2149, 2150, 2151, 2152, 2153, 2154, 2155, 2156, 2157,
     8   2158, 2159, 2160, 2063, 2162, 2163, 2161,   15, 2165, 2166,
     9   2167, 2168, 2169, 2170, 2171, 2063, 2078, 2173, 2174, 2175/
            data (jb1(i),i= 2201, 2300)/
     +   2176, 2177, 2178, 2179, 2180, 2181, 2182, 2183, 2184, 2185,
     1   2186, 2187, 2188, 2189, 2190, 2191, 2192, 2193, 2194, 2195,
     2   2058, 2197, 2198, 2199, 2200, 2201, 2202, 2203, 2204, 2205,
     3   2206, 2207, 2208, 2209, 2210, 2211, 2212, 2213, 2214, 2215,
     4   2216, 2217, 2218, 2219, 2220, 2221, 2222, 2223, 2224, 2225,
     5   2226, 2227, 2228, 2229, 2230, 2231, 2232, 2233, 2234, 2235,
     6   2236, 2237, 2238, 2239, 2240, 2241, 2242, 2243, 2244, 2245,
     7   2055, 2058, 2247, 2248, 2249, 2250, 2251, 2252, 2253, 2254,
     8   2255, 2256, 2257, 2258, 2259, 2260, 2261, 2262, 2263, 2264,
     9   2265, 2266, 2267, 2268, 2269, 2270, 2271, 2197, 2197, 2273/
            data (jb1(i),i= 2301, 2400)/
     +   2274, 2275, 2276, 2277, 2278, 2279, 2280, 2281, 2282, 2283,
     1   2284, 2285, 2286, 2287, 2161, 2289, 2290, 2291, 2292, 2293,
     2   2294, 2295, 2296, 2297, 2298, 2299, 2300, 2301, 2302, 2304,
     3   2305, 2306, 2307, 2308, 2309, 2310, 2311, 2312, 2313, 2314,
     4   2315, 2316, 2193, 2288, 2319, 2320, 2321, 2288, 2318, 2323,
     5   2324, 2319,   16, 2326, 2319, 2328, 2329, 2330, 2331, 2332,
     6   2333, 2334, 2335, 2336, 2337, 2338, 2339, 2340, 2341, 2342,
     7   2343, 2344, 2304, 2303, 2346, 2328, 2303, 2348, 2349, 2350,
     8   2351, 2352, 2353, 2354, 2355, 2318, 2356, 2357, 2358, 2359,
     9   2360, 2361, 2362, 2363, 2364, 2365, 2304,   18, 2367, 2368/
            data (jb1(i),i= 2401, 2500)/
     +   2369, 2370, 2371, 2372, 2373, 2374, 2375, 2377, 2378, 2379,
     1   2380, 2381, 2382, 2383, 2384, 2385, 2386, 2387, 2388, 2389,
     2   2390, 2391, 2392, 2376, 2393,   21, 2327, 2395, 2396, 2397,
     3   2398, 2399, 2400, 2401, 2402, 2403, 2404, 2405, 2406, 2407,
     4   2408, 2409, 2410, 2411, 2412, 2413, 2414, 2415, 2416, 2417,
     5   2418, 2419, 2420, 2421, 2394, 2377, 2424, 2425, 2426, 2423,
     6     22, 2428, 2429, 2430, 2431, 2432, 2433, 2434, 2435, 2436,
     7   2437, 2438, 2439, 2440, 2441, 2442, 2443, 2444, 2445, 2446,
     8   2447, 2448, 2449, 2450, 2451, 2452, 2453, 2454, 2455, 2422,
     9   2377, 2457, 2458, 2459, 2460, 2456, 2462, 2463, 2464, 2465/
            data (jb1(i),i= 2501, 2600)/
     +   2466, 2467, 2468, 2469, 2470, 2471, 2472, 2473, 2474, 2362,
     1   2422, 2476, 2477, 2478, 2479, 2480, 2481, 2482, 2483, 2484,
     2   2485, 2487, 2488, 2489, 2490, 2491, 2486, 2462, 2328, 2493,
     3   2494, 2495, 2496, 2497, 2498, 2363, 2500, 2501, 2502, 2503,
     4   2504, 2505, 2506, 2507, 2508, 2509, 2510, 2511, 2512, 2513,
     5   2514, 2499, 2516, 2517, 2518, 2519, 2498, 2349, 2521, 2516,
     6   2523, 2524, 2525, 2526, 2527, 2528, 2529, 2530, 2531, 2532,
     7   2533, 2462, 2487, 2535, 2536, 2537, 2538, 2539, 2540, 2541,
     8   2542, 2543, 2544, 2545, 2546, 2547, 2548, 2549, 2550, 2551,
     9   2552, 2553, 2554, 2555, 2516, 2557, 2558, 2559, 2560, 2561/
            data (jb1(i),i= 2601, 2700)/
     +   2423, 2562, 2563, 2564, 2565, 2566, 2567, 2568, 2569, 2570,
     1   2571, 2572, 2573, 2574, 2575, 2576, 2577, 2578, 2579, 2580,
     2   2581, 2582, 2583, 2584, 2461, 2586, 2587, 2588, 2589, 2590,
     3   2591, 2592, 2593, 2594, 2595, 2596, 2597, 2598, 2599, 2600,
     4   2601, 2602, 2603, 2604, 2605, 2606, 2607, 2608, 2609, 2610,
     5   2611, 2612, 2486, 2585, 2614, 2615, 2616, 2617, 2618, 2604,
     6   2394, 2620, 2621, 2622, 2623, 2624, 2625, 2626, 2627, 2628,
     7   2629, 2630, 2631, 2632, 2634, 2635, 2636, 2637, 2638, 2639,
     8   2523, 2515, 2641, 2642, 2643, 2644, 2645, 2646, 2634, 2633,
     9   2648, 2649, 2650, 2376, 2652, 2653, 2654, 2651, 2655, 2657/
            data (jb1(i),i= 2701, 2800)/
     +   2658, 2659, 2660, 2661, 2662, 2633, 2585, 2664, 2665, 2666,
     1   2667, 2668, 2669, 2670, 2671, 2672, 2673, 2674, 2675, 2676,
     2   2677, 2678, 2679, 2680, 2681, 2682, 2683, 2684, 2685, 2686,
     3   2687, 2657, 2657, 2656, 2690, 2691, 2692, 2693, 2694, 2695,
     4   2696, 2697, 2698, 2699, 2700, 2701, 2702, 2634, 2703, 2704,
     5   2705, 2706, 2707, 2708, 2709, 2710, 2711, 2712, 2713, 2651,
     6   2715, 2716, 2717, 2718, 2719, 2721, 2722, 2723, 2724, 2725,
     7   2726, 2727, 2728, 2729, 2730, 2731, 2732, 2733, 2734, 2735,
     8   2736, 2737, 2738, 2739, 2740, 2741, 2742, 2743, 2499, 2689,
     9   2745, 2746, 2748, 2749, 2750, 2751, 2752, 2753, 2754, 2755/
            data (jb1(i),i= 2801, 2900)/
     +   2756, 2757, 2758, 2759, 2760, 2761, 2762, 2763, 2764, 2765,
     1   2766, 2767, 2768, 2523, 2747, 2770, 2771, 2772, 2773, 2774,
     2   2775, 2617, 2777, 2778, 2779, 2780, 2781, 2782, 2776, 2721,
     3   2784, 2785, 2786, 2787, 2788, 2789, 2790, 2791, 2792, 2714,
     4   2556, 2794, 2795, 2796, 2797, 2798, 2799, 2800, 2801, 2802,
     5   2803, 2804, 2805, 2806, 2807, 2808, 2809, 2810, 2811, 2812,
     6   2813, 2814, 2748, 2748, 2816, 2817, 2818, 2819, 2820, 2821,
     7   2822, 2823, 2824, 2825, 2826, 2827, 2714, 2829, 2830, 2831,
     8   2829, 2832, 2833, 2834, 2835, 2836, 2837, 2838, 2839, 2840,
     9   2841, 2842, 2843, 2557, 2721, 2845, 2846, 2847, 2848, 2849/
            data (jb1(i),i= 2901, 3000)/
     +   2850, 2851, 2829, 2776, 2556, 2854, 2855, 2856, 2857, 2858,
     1   2853, 2853, 2860, 2861, 2862, 2864, 2865, 2866, 2867, 2868,
     2   2869, 2870, 2656, 2872, 2873, 2874, 2875, 2876, 2877, 2747,
     3   2689, 2879, 2880, 2881, 2882, 2883, 2884, 2885, 2886, 2887,
     4   2888, 2889, 2890, 2891, 2872, 2893, 2894, 2895, 2896, 2897,
     5   2898, 2899, 2892, 2892, 2901, 2902, 2903, 2720,   26, 2905,
     6   2906, 2907, 2908, 2909, 2910, 2911, 2912, 2913, 2914, 2915,
     7   2916, 2917, 2918, 2919, 2920, 2921, 2922, 2923, 2924, 2925,
     8   2926, 2927, 2864, 2929, 2930, 2931, 2932, 2933, 2934, 2935,
     9   2936, 2651, 2816, 2938, 2939, 2863, 2940, 2941, 2942, 2943/
            data (jb1(i),i= 3001, 3100)/
     +   2944, 2872, 2862, 2946, 2947, 2948, 2949, 2950, 2951, 2952,
     1   2953, 2954, 2955, 2956, 2957, 2958, 2959, 2863, 2961, 2962,
     2   2963, 2964, 2965, 2966, 2967, 2968, 2969, 2970, 2960, 2720,
     3   2972, 2973, 2974, 2975, 2976, 2977, 2978, 2979, 2980, 2981,
     4   2982, 2983, 2929, 2921, 2985, 2986, 2987, 2988, 2989, 2990,
     5   2991, 2992, 2993, 2994, 2995, 2996, 2997, 2998, 2942, 2999,
     6   3000, 2960, 2929, 3002, 3003, 3004, 3005, 3006, 3007, 3008,
     7   2852, 3009, 2864, 3010, 3011, 3012, 3013, 3014, 3015, 3016,
     8   3017, 3018, 3019, 3020, 3021, 3022, 3023, 2999, 3024, 3025,
     9   3026, 3027, 3028, 3029, 3030, 3031, 3032, 3033, 3034, 3035/
            data (jb1(i),i= 3101, 3200)/
     +   2942, 3036, 3037, 3038, 3039, 3040, 3041, 3042, 3043, 3044,
     1   3045, 3046, 3047, 3048, 3049, 3050, 3051, 3052, 3053, 3054,
     2   3055, 3056, 3057, 3058, 3059, 3060, 3061, 3062, 3063, 3064,
     3     37, 3065, 3066,    1,    2,    3,    1,    5,    6,    7,
     4      5,    9,   10,   11,    9,   13,   14,   13,   16,   17,
     5     18,   16,   20,   21,   20,   23,   24,   25,   26,   27,
     6     23,   29,   30,   31,   29,   33,   34,   33,   36,   37,
     7     38,   36,   40,   41,   42,   40,   44,   45,   46,   47,
     8     48,   49,   50,   51,   52,   53,   54,   55,   56,   44,
     9     58,   59,   60,   58,   62,   63,   64,   65,   66,   67/
            data (jb1(i),i= 3201, 3300)/
     +     62,   69,   70,   69,   72,   73,   74,   75,   76,   77,
     1     72,   79,   80,   81,   79,   83,   84,   85,   83,   87,
     2     88,   87,   90,   91,   92,   90,   94,   95,   94,   97,
     3     98,   99,  100,   97,  102,  103,  102,  105,  106,  105,
     4    108,  109,  110,  111,  112,  108,  114,  115,  114,  117,
     5    118,  117,  120,  121,  122,  120,  124,  125,  124,  127,
     6    128,  127,  130,  131,  132,  130,  134,  135,  136,  137,
     7    138,  139,  134,  141,  142,  141,  144,  145,  146,  144,
     8    148,  149,  148,  151,  152,  153,  151,  155,  156,  155,
     9    158,  159,  160,  161,  162,  163,  164,  165,  166,  167/
            data (jb1(i),i= 3301, 3400)/
     +    168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
     1    178,  179,  180,  181,  182,  183,  184,  185,  186,  187,
     2    188,  189,  190,  191,  192,  193,  194,  195,  196,  197,
     3    198,  199,  200,  201,  202,  203,  204,  205,  206,  207,
     4    208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
     5    218,  219,  220,  221,  222,  158,  224,  225,  226,  227,
     6    224,  229,  230,  231,  232,  233,  234,  235,  236,  237,
     7    238,  229,  240,  241,  240,  243,  244,  243,  246,  247,
     8    246,  249,  250,  251,  249,  253,  254,  255,  253,  257,
     9    258,  259,  257,  261,  262,  263,  264,  265,  261,  267/
            data (jb1(i),i= 3401, 3500)/
     +    268,  267,  270,  271,  270,  273,  274,  273,  276,  277,
     1    276,  279,  280,  281,  282,  283,  284,  285,  286,  287,
     2    279,  289,  290,  289,  292,  293,  294,  295,  296,  292,
     3    298,  299,  300,  301,  298,  303,  304,  305,  303,  307,
     4    308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
     5    318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
     6    328,  329,  330,  331,  332,  333,  334,  335,  336,  337,
     7    338,  339,  340,  341,  342,  343,  307,  345,  346,  347,
     8    348,  349,  345,  351,  352,  351,  354,  355,  356,  357,
     9    358,  359,  354,  361,  362,  363,  364,  361,  366,  367/
            data (jb1(i),i= 3501, 3600)/
     +    366,  369,  370,  371,  369,  373,  374,  375,  373,  377,
     1    378,  379,  377,  381,  382,  383,  384,  385,  386,  381,
     2    388,  389,  388,  391,  392,  393,  394,  395,  396,  397,
     3    391,  399,  400,  399,  402,  403,  402,  405,  406,  407,
     4    405,  409,  410,  411,  412,  409,  414,  415,  416,  417,
     5    414,  419,  420,  419,  422,  423,  424,  425,  426,  422,
     6    428,  429,  428,  431,  432,  433,  434,  431,  436,  437,
     7    438,  436,  440,  441,  442,  443,  440,  445,  446,  445,
     8    448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
     9    458,  459,  460,  461,  462,  463,  448,  465,  466,  465/
            data (jb1(i),i= 3601, 3700)/
     +    468,  469,  470,  471,  472,  473,  474,  475,  468,  477,
     1    478,  479,  480,  481,  482,  483,  484,  477,  486,  487,
     2    488,  486,  490,  491,  490,  493,  494,  493,  496,  497,
     3    498,  496,  500,  501,  502,  503,  500,  505,  506,  505,
     4    508,  509,  510,  508,  512,  513,  514,  515,  516,  517,
     5    518,  519,  520,  521,  522,  523,  524,  525,  526,  527,
     6    528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
     7    538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
     8    548,  549,  550,  512,  552,  553,  554,  555,  552,  557,
     9    558,  559,  557,  561,  562,  563,  564,  565,  566,  567/
            data (jb1(i),i= 3701, 3800)/
     +    561,  569,  570,  571,  569,  573,  574,  573,  576,  577,
     1    578,  579,  580,  581,  582,  583,  584,  585,  576,  587,
     2    588,  589,  590,  587,  592,  593,  592,  595,  596,  597,
     3    595,  599,  600,  599,  602,  603,  604,  602,  606,  607,
     4    608,  606,  610,  611,  612,  610,  614,  615,  616,  617,
     5    614,  619,  620,  619,  622,  623,  624,  622,  626,  627,
     6    628,  626,  630,  631,  632,  630,  634,  635,  634,  637,
     7    638,  637,  640,  641,  642,  643,  644,  645,  646,  647,
     8    648,  649,  650,  640,  652,  653,  654,  655,  656,  652,
     9    658,  659,  660,  658,  662,  663,  664,  662,  666,  667/
            data (jb1(i),i= 3801, 3900)/
     +    668,  669,  670,  671,  672,  673,  674,  675,  676,  677,
     1    678,  679,  680,  666,  682,  683,  684,  685,  682,  687,
     2    688,  689,  690,  691,  692,  693,  694,  695,  696,  697,
     3    698,  699,  700,  687,  702,  703,  704,  702,  706,  707,
     4    708,  706,  710,  711,  710,  713,  714,  715,  713,  717,
     5    718,  719,  717,  721,  722,  723,  721,  725,  726,  725,
     6    728,  729,  730,  728,  732,  733,  734,  735,  736,  737,
     7    738,  739,  732,  741,  742,  741,  744,  745,  744,  747,
     8    748,  747,  750,  751,  752,  753,  750,  755,  756,  757,
     9    758,  759,  755,  761,  762,  763,  764,  761,  766,  767/
            data (jb1(i),i= 3901, 4000)/
     +    766,  769,  770,  771,  769,  773,  774,  773,  776,  777,
     1    778,  779,  780,  776,  782,  783,  782,  785,  786,  785,
     2    788,  789,  790,  791,  788,  793,  794,  795,  796,  797,
     3    793,  799,  800,  799,  802,  803,  804,  802,  806,  807,
     4    806,  809,  810,  809,  812,  813,  812,  815,  816,  817,
     5    818,  819,  820,  815,  822,  823,  824,  825,  826,  827,
     6    828,  829,  830,  831,  832,  833,  834,  835,  822,  837,
     7    838,  839,  837,  841,  842,  843,  841,  845,  846,  847,
     8    848,  849,  850,  851,  845,  853,  854,  855,  856,  853,
     9    858,  859,  860,  858,  862,  863,  862,  865,  866,  867/
            data (jb1(i),i= 4001, 4100)/
     +    868,  865,  870,  871,  870,  873,  874,  875,  873,  877,
     1    878,  879,  877,  881,  882,  883,  884,  885,  886,  887,
     2    888,  889,  890,  891,  892,  893,  894,  895,  896,  881,
     3    898,  899,  900,  898,  902,  903,  902,  905,  906,  907,
     4    908,  909,  910,  911,  912,  913,  914,  915,  916,  917,
     5    918,  919,  920,  921,  922,  905,  924,  925,  926,  924,
     6    928,  929,  928,  931,  932,  933,  934,  931,  936,  937,
     7    938,  939,  940,  941,  942,  943,  944,  945,  946,  947,
     8    948,  949,  950,  951,  952,  953,  954,  955,  956,  957,
     9    936,  959,  960,  961,  959,  963,  964,  963,  966,  967/
            data (jb1(i),i= 4101, 4200)/
     +    968,  969,  970,  971,  972,  973,  974,  966,  976,  977,
     1    978,  979,  976,  981,  982,  983,  984,  985,  981,  987,
     2    988,  989,  987,  991,  992,  991,  994,  995,  996,  997,
     3    998,  999, 1000, 1001, 1002, 1003, 1004,  994, 1006, 1007,
     4   1006, 1009, 1010, 1011, 1009, 1013, 1014, 1013, 1016, 1017,
     5   1018, 1019, 1020, 1021, 1016, 1023, 1024, 1023, 1026, 1027,
     6   1028, 1029, 1030, 1026, 1032, 1033, 1034, 1032, 1036, 1037,
     7   1038, 1036, 1040, 1041, 1042, 1043, 1040, 1045, 1046, 1045,
     8   1048, 1049, 1050, 1051, 1052, 1053, 1054, 1048, 1056, 1057,
     9   1056, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067/
            data (jb1(i),i= 4201, 4300)/
     +   1068, 1059, 1070, 1071, 1072, 1070, 1074, 1075, 1074, 1077,
     1   1078, 1077, 1080, 1081, 1080, 1083, 1084, 1085, 1086, 1087,
     2   1088, 1089, 1083, 1091, 1092, 1093, 1091, 1095, 1096, 1095,
     3   1098, 1099, 1098, 1101, 1102, 1103, 1104, 1105, 1101, 1107,
     4   1108, 1107, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117,
     5   1110, 1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127,
     6   1128, 1119, 1130, 1131, 1132, 1133, 1130, 1135, 1136, 1135,
     7   1138, 1139, 1140, 1138, 1142, 1143, 1144, 1142, 1146, 1147,
     8   1148, 1149, 1150, 1151, 1146, 1153, 1154, 1153, 1156, 1157,
     9   1158, 1156, 1160, 1161, 1160, 1163, 1164, 1165, 1163, 1167/
            data (jb1(i),i= 4301, 4400)/
     +   1168, 1167, 1170, 1171, 1172, 1170, 1174, 1175, 1176, 1174,
     1   1178, 1179, 1178, 1181, 1182, 1183, 1184, 1181, 1186, 1187,
     2   1188, 1186, 1190, 1191, 1192, 1190, 1194, 1195, 1196, 1197,
     3   1194, 1199, 1200, 1201, 1202, 1199, 1204, 1205, 1206, 1207,
     4   1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217,
     5   1218, 1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1204,
     6   1228, 1229, 1230, 1228, 1232, 1233, 1234, 1232, 1236, 1237,
     7   1238, 1239, 1240, 1236, 1242, 1243, 1244, 1245, 1246, 1242,
     8   1248, 1249, 1250, 1251, 1252, 1253, 1248, 1255, 1256, 1255,
     9   1258, 1259, 1258, 1261, 1262, 1263, 1261, 1265, 1266, 1267/
            data (jb1(i),i= 4401, 4500)/
     +   1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277,
     1   1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1265,
     2   1288, 1289, 1288, 1291, 1292, 1293, 1294, 1295, 1296, 1291,
     3   1298, 1299, 1300, 1298, 1302, 1303, 1304, 1305, 1306, 1307,
     4   1308, 1302, 1310, 1311, 1312, 1310, 1314, 1315, 1314, 1317,
     5   1318, 1319, 1317, 1321, 1322, 1321, 1324, 1325, 1324, 1327,
     6   1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336, 1337,
     7   1338, 1339, 1327, 1341, 1342, 1341, 1344, 1345, 1344, 1347,
     8   1348, 1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357,
     9   1358, 1359, 1360, 1347,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     35,    8,    6,    5,    3,    4,    2,   39,   40,   41,
     1     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     2     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     3     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     4     72,   73,   74,   74,   75,   76,   77,   78,   79,   80,
     5     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     6     91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
     7    101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
     8    111,  112,  112,  113,  113,  114,  115,  116,  117,  118,
     9    119,  120,  121,  121,  122,  123,  124,  125,  126,  126/
            data (jb2(i),i=  101,  200)/
     +    127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
     1    137,  138,  138,  139,  140,  141,  142,  143,  144,  145,
     2    146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
     3    156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
     4    166,  167,  168,  169,  170,  171,  172,  173,  174,  174,
     5    175,  176,  177,  178,  179,  180,  181,  182,  183,  184,
     6    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     7    195,  196,  197,  198,  199,  200,  201,  202,  203,  204,
     8    205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
     9    215,  216,  217,  218,  219,  220,  221,  222,  223,  224/
            data (jb2(i),i=  201,  300)/
     +    225,  226,  227,  227,   21,   21,   22,   22,  228,  229,
     1    230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
     2    240,  241,  242,  243,  244,  245,  246,  247,  248,  249,
     3    250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
     4    260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
     5    270,  271,  272,  273,  274,  274,  275,  276,  277,  278,
     6    279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
     7    289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
     8    299,  300,  301,  302,  303,  304,  304,  305,  306,  307,
     9    308,  309,  310,  311,  312,  313,  314,  315,  316,  317/
            data (jb2(i),i=  301,  400)/
     +    318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
     1    328,  329,  330,  331,  332,  333,  334,  334,  335,  336,
     2    337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
     3    347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
     4    357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
     5    367,  367,  368,  369,  370,  371,  372,  373,  374,  375,
     6    376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
     7    386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
     8    396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
     9    406,  407,  408,  409,  409,  410,  411,  412,  413,  414/
            data (jb2(i),i=  401,  500)/
     +    415,  416,  417,  418,  418,  419,  420,  421,  422,  423,
     1    424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
     2    434,  435,  436,  437,  438,  439,  440,  441,  441,  442,
     3    443,  444,  445,  446,  447,  448,  449,  450,  451,  452,
     4    453,  454,  455,  456,  457,  458,  459,  460,  461,  462,
     5    463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
     6    473,  474,  475,  476,  477,  478,  479,  480,  481,  482,
     7    483,  484,  485,  486,  487,  488,  489,  490,  491,  492,
     8    493,  494,  495,  496,  497,  498,  499,  500,  501,  502,
     9    503,  504,  505,  506,  507,  508,  509,  510,  511,  512/
            data (jb2(i),i=  501,  600)/
     +    513,  514,  515,  516,  517,  518,  519,  520,  521,  522,
     1    523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
     2    533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
     3    543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
     4    553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
     5    563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
     6    573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
     7    583,  584,  585,  586,  587,  588,  589,  590,  591,  592,
     8    593,  594,  595,  596,  597,  597,  598,  599,  600,  601,
     9    602,  603,  604,  605,  606,  607,  608,  609,  610,  611/
            data (jb2(i),i=  601,  700)/
     +    612,  613,  614,  614,  615,  616,  617,  618,  619,  620,
     1    621,  622,  623,  624,  625,  626,  627,  628,  629,  630,
     2    631,  632,  633,  634,  635,  636,  636,  637,  638,  639,
     3    640,  641,  642,  643,  644,  645,  646,  647,  648,  649,
     4    650,  651,  652,  653,  654,  655,  656,  657,  658,  659,
     5    660,  661,  662,  663,  664,  665,  666,  667,  668,  668,
     6    669,  670,  671,  672,  673,  674,  675,  676,  677,  678,
     7    679,  680,  681,  682,  683,  684,  685,  686,  687,  688,
     8    689,  690,  691,  692,  693,  694,  695,  696,  697,  698,
     9    699,  700,  701,  702,  703,  704,  705,  706,  706,  707/
            data (jb2(i),i=  701,  800)/
     +    708,  709,  710,  711,  711,  712,  713,  714,  715,  716,
     1    717,  718,  719,  720,  721,  722,  723,  724,  725,  726,
     2    727,  728,  729,  730,  731,  732,  733,  734,  735,  736,
     3    737,  738,  739,  740,  741,  742,  743,  744,  745,  746,
     4    747,  748,  749,  750,  751,  752,  752,  754,  755,  756,
     5    757,  758,  759,  760,  761,  762,  763,  764,  765,  766,
     6    767,  768,  769,  770,  771,  772,  773,  774,  775,  776,
     7    777,  778,  779,  780,  781,  782,  783,  784,  785,  786,
     8    787,  788,  789,  790,  791,  792,  793,  794,  795,  796,
     9    797,  798,  799,  800,  801,  802,  803,  804,  805,  806/
            data (jb2(i),i=  801,  900)/
     +    807,  808,  809,  810,  811,  812,  813,  814,  815,  816,
     1    817,  818,  819,  820,  821,  822,  823,  824,  825,  826,
     2    827,  828,  829,  830,  831,  832,  833,  834,  835,  836,
     3    837,  838,  839,  840,  841,  842,  843,  844,  845,  846,
     4    847,  848,  849,  850,  851,  852,  853,  854,  855,  856,
     5    857,  858,  859,  860,  861,  862,  863,  864,  865,  866,
     6    867,  868,  869,  870,  871,  872,  873,  874,  874,  876,
     7    877,  878,  879,  880,  881,  882,  883,  884,  885,  886,
     8    887,  888,  889,  890,  891,  892,  893,  894,  895,  896,
     9    897,  898,  899,  900,  901,  902,  903,  904,  905,  906/
            data (jb2(i),i=  901, 1000)/
     +    907,  908,  909,  910,  911,  912,  913,  914,  915,  916,
     1    917,  918,  919,  920,  921,  922,  923,  924,  925,  926,
     2    927,  928,  929,  929,  930,  931,  932,  933,  934,  935,
     3    936,  937,  938,  939,  940,  941,  942,  943,  944,  945,
     4    946,  947,  948,  949,  950,  951,  952,  953,  954,  955,
     5    956,  957,  958,  959,  960,  961,  962,  963,  964,  965,
     6    966,  967,  968,  969,  970,  971,  972,  973,  974,  975,
     7    976,  977,  978,  979,  980,  981,  982,  983,  984,  985,
     8    986,  987,  988,  989,  990,  991,  992,  993,  994,  995,
     9    996,  997,  998,  999,  999, 1000, 1001, 1002, 1003, 1004/
            data (jb2(i),i= 1001, 1100)/
     +   1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014,
     1   1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024,
     2   1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034,
     3   1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044,
     4   1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054,
     5   1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064,
     6   1065, 1066, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073,
     7   1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083,
     8   1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093,
     9   1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103/
            data (jb2(i),i= 1101, 1200)/
     +   1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113,
     1   1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123,
     2   1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133,
     3   1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142, 1143,
     4   1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151, 1152, 1153,
     5   1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163,
     6   1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172, 1173,
     7   1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183,
     8   1184, 1185, 1186, 1187, 1188, 1189, 1191, 1192, 1193, 1194,
     9   1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202, 1203, 1204/
            data (jb2(i),i= 1201, 1300)/
     +   1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213, 1214,
     1   1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223, 1224,
     2   1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233, 1234,
     3   1235, 1236, 1237, 1238, 1239, 1240, 1241, 1242, 1243, 1244,
     4   1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254,
     5   1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264,
     6   1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274,
     7   1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284,
     8   1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1292, 1293,
     9   1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303/
            data (jb2(i),i= 1301, 1400)/
     +   1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313,
     1   1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1321, 1322,
     2   1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332,
     3   1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342,
     4   1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352,
     5   1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362,
     6   1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372,
     7   1373, 1374, 1375, 1376, 1377, 1377, 1378, 1379, 1380, 1381,
     8   1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391,
     9   1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400, 1401/
            data (jb2(i),i= 1401, 1500)/
     +   1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409, 1410, 1411,
     1   1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419, 1420, 1421,
     2   1422, 1423, 1424, 1425, 1426, 1427, 1428, 1429, 1430, 1431,
     3   1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439, 1440, 1441,
     4   1442, 1443, 1444, 1445, 1446, 1447, 1448, 1449, 1450, 1451,
     5   1452, 1453, 1454, 1455, 1456, 1457, 1458, 1459, 1460, 1461,
     6   1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470, 1471,
     7   1472, 1473, 1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481,
     8   1482, 1483, 1484, 1485, 1486, 1487, 1488, 1489, 1490, 1491,
     9   1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501/
            data (jb2(i),i= 1501, 1600)/
     +   1502, 1503, 1504, 1505, 1505, 1507, 1508, 1509, 1510, 1511,
     1   1512, 1513, 1514, 1515, 1516, 1517, 1518, 1519,    1, 1520,
     2   1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530,
     3   1531, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541,
     4   1542, 1543, 1544, 1545, 1546, 1547, 1548,    4, 1549, 1550,
     5   1551, 1552, 1553, 1554, 1555, 1556, 1557, 1558, 1559, 1560,
     6   1561, 1562, 1563, 1564, 1565, 1566, 1567, 1568, 1569, 1570,
     7   1571, 1572, 1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580,
     8   1581, 1582, 1583, 1584, 1585, 1586, 1587, 1588, 1588, 1589,
     9   1590, 1591, 1592, 1593, 1594, 1594, 1595, 1596, 1597, 1598/
            data (jb2(i),i= 1601, 1700)/
     +   1599, 1600, 1601, 1602, 1602, 1604, 1605, 1606, 1607, 1608,
     1   1609, 1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618,
     2   1619, 1620, 1621, 1622, 1623, 1624,    6, 1625, 1626, 1627,
     3   1628, 1629, 1630, 1631, 1631, 1633, 1634, 1635, 1636, 1637,
     4   1638, 1639, 1640, 1641, 1642, 1643, 1644, 1645, 1646, 1647,
     5   1648, 1649, 1650, 1651, 1651, 1652, 1653, 1654, 1655, 1656,
     6   1657, 1658, 1659, 1660, 1661, 1662, 1663, 1664, 1665, 1666,
     7   1667, 1668, 1669, 1670, 1671, 1672, 1673, 1673, 1674, 1675,
     8   1676, 1677, 1678, 1678, 1680, 1681, 1682, 1683, 1684, 1685,
     9   1685, 1686, 1687, 1688, 1689, 1690, 1691, 1692, 1693, 1693/
            data (jb2(i),i= 1701, 1800)/
     +   1694, 1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702, 1703,
     1   1704, 1706, 1707, 1707, 1708, 1709, 1710, 1711, 1711, 1713,
     2   1714, 1715, 1716, 1717, 1718, 1719, 1720, 1721, 1722, 1723,
     3   1724, 1725, 1726, 1727, 1728, 1729, 1730, 1731, 1732, 1733,
     4   1734, 1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742, 1743,
     5   1744, 1745, 1746, 1747, 1748, 1749, 1750, 1751, 1752, 1753,
     6   1754, 1755, 1756, 1757, 1758, 1759, 1760, 1761, 1762, 1763,
     7   1764, 1765, 1766, 1767, 1768, 1769, 1770, 1771, 1772, 1773,
     8   1774, 1775, 1776, 1777, 1778, 1779, 1780, 1781, 1782, 1783,
     9   1784, 1785, 1786, 1787, 1788, 1789, 1790, 1791, 1792, 1793/
            data (jb2(i),i= 1801, 1900)/
     +   1794, 1795, 1796,    8, 1797, 1799, 1800, 1801, 1802, 1803,
     1   1804, 1805, 1806, 1807, 1807, 1798, 1809, 1810, 1811, 1812,
     2   1813, 1814, 1815, 1816, 1817, 1818,    9, 1819, 1820, 1821,
     3   1822, 1823, 1824, 1825, 1826, 1827, 1828, 1829, 1830, 1831,
     4   1832, 1833, 1834, 1835, 1836, 1837, 1838, 1839, 1840, 1840,
     5   1841, 1842, 1843, 1844, 1845, 1846, 1847, 1848, 1849, 1850,
     6   1851, 1852, 1853, 1854, 1855,   10, 1856, 1857, 1858, 1859,
     7   1860, 1861, 1862, 1863, 1864, 1865, 1866, 1867, 1868, 1869,
     8   1870, 1871, 1872, 1873, 1874, 1875, 1876, 1877, 1878, 1879,
     9   1880, 1881, 1882, 1883, 1884, 1885, 1886, 1887, 1888, 1888/
            data (jb2(i),i= 1901, 2000)/
     +   1889, 1889, 1891, 1892, 1893, 1894, 1894, 1890,   12, 1895,
     1   1896, 1897, 1898, 1899, 1900, 1901, 1902, 1903, 1904, 1905,
     2   1906, 1907, 1908, 1909, 1910, 1911, 1912, 1913, 1914, 1915,
     3   1916, 1918, 1919, 1920, 1921, 1922, 1923, 1924, 1925, 1926,
     4   1927, 1928, 1929, 1930, 1931, 1932, 1933, 1934, 1935, 1936,
     5   1937, 1938, 1939, 1940, 1941, 1942, 1943, 1944, 1945, 1946,
     6   1946, 1947, 1948, 1949, 1950, 1951, 1952, 1953, 1954, 1955,
     7   1956, 1957, 1958, 1959, 1960, 1961, 1962, 1963, 1964, 1965,
     8   1966, 1967, 1968, 1969, 1970, 1971, 1972, 1973, 1973, 1974,
     9   1975, 1976, 1977, 1978, 1979, 1980, 1981, 1982, 1983, 1984/
            data (jb2(i),i= 2001, 2100)/
     +   1985, 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
     1   1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
     2   2005, 2006, 2007, 2008, 2008, 2009, 2010, 2011, 2012, 2013,
     3   2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023,
     4   2024, 2025, 2026, 2027, 2028, 2029, 2030, 2031, 2031, 2032,
     5   2033, 2034, 2035, 2036, 2037, 2038, 2039,   13, 2040, 2041,
     6   2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049, 2049, 2050,
     7   2051, 2052, 2053, 2054, 2055, 2056, 2057,   14, 2058, 2059,
     8   2060, 2061, 2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069,
     9   2070, 2071, 2072, 2073, 2074, 2075, 2076, 2077, 2079, 2080/
            data (jb2(i),i= 2101, 2200)/
     +   2081, 2082, 2083, 2084, 2085, 2086, 2087, 2088, 2089, 2090,
     1   2091, 2092, 2093, 2094, 2095, 2096, 2097, 2098, 2099, 2100,
     2   2101, 2102, 2103, 2104, 2105, 2106, 2107, 2108, 2109, 2110,
     3   2111, 2112, 2113, 2114, 2115, 2116, 2117, 2118, 2119, 2120,
     4   2121, 2122, 2123, 2124, 2125, 2126, 2126, 2127, 2128, 2129,
     5   2130, 2131, 2132, 2133, 2134, 2135, 2136, 2137, 2138, 2139,
     6   2140, 2141, 2142, 2142, 2143, 2144, 2145, 2146, 2147, 2148,
     7   2149, 2150, 2151, 2152, 2153, 2154, 2155, 2156, 2157, 2158,
     8   2159, 2160, 2161, 2162, 2163, 2164, 2164, 2165, 2166, 2167,
     9   2168, 2169, 2170, 2171, 2172, 2172, 2173, 2174, 2175, 2176/
            data (jb2(i),i= 2201, 2300)/
     +   2177, 2178, 2179, 2180, 2181, 2182, 2183, 2184, 2185, 2186,
     1   2187, 2188, 2189, 2190, 2191, 2192, 2193, 2194, 2195, 2196,
     2   2196, 2198, 2199, 2200, 2201, 2202, 2203, 2204, 2205, 2206,
     3   2207, 2208, 2209, 2210, 2211, 2212, 2213, 2214, 2215, 2216,
     4   2217, 2218, 2219, 2220, 2221, 2222, 2223, 2224, 2225, 2226,
     5   2227, 2228, 2229, 2230, 2231, 2232, 2233, 2234, 2235, 2236,
     6   2237, 2238, 2239, 2240, 2241, 2242, 2243, 2244, 2245, 2246,
     7   2246, 2247, 2248, 2249, 2250, 2251, 2252, 2253, 2254, 2255,
     8   2256, 2257, 2258, 2259, 2260, 2261, 2262, 2263, 2264, 2265,
     9   2266, 2267, 2268, 2269, 2270, 2271, 2272, 2272, 2273, 2274/
            data (jb2(i),i= 2301, 2400)/
     +   2275, 2276, 2277, 2278, 2279, 2280, 2281, 2282, 2283, 2284,
     1   2285, 2286, 2287, 2288, 2289, 2290, 2291, 2292, 2293, 2294,
     2   2295, 2296, 2297, 2298, 2299, 2300, 2301, 2302, 2303, 2305,
     3   2306, 2307, 2308, 2309, 2310, 2311, 2312, 2313, 2314, 2315,
     4   2316, 2317, 2317, 2318, 2320, 2321, 2322, 2322, 2323, 2324,
     5   2325, 2325, 2326, 2327, 2327, 2329, 2330, 2331, 2332, 2333,
     6   2334, 2335, 2336, 2337, 2338, 2339, 2340, 2341, 2342, 2343,
     7   2344, 2345, 2345, 2346, 2347, 2347, 2348, 2349, 2350, 2351,
     8   2352, 2353, 2354, 2355,   17, 2356, 2357, 2358, 2359, 2360,
     9   2361, 2362, 2363, 2364, 2365, 2366, 2366, 2367, 2368, 2369/
            data (jb2(i),i= 2401, 2500)/
     +   2370, 2371, 2372, 2373, 2374, 2375, 2376, 2378, 2379, 2380,
     1   2381, 2382, 2383, 2384, 2385, 2386, 2387, 2388, 2389, 2390,
     2   2391, 2392,   19, 2393,   20, 2394, 2395, 2396, 2397, 2398,
     3   2399, 2400, 2401, 2402, 2403, 2404, 2405, 2406, 2407, 2408,
     4   2409, 2410, 2411, 2412, 2413, 2414, 2415, 2416, 2417, 2418,
     5   2419, 2420, 2421, 2422, 2423, 2424, 2425, 2426, 2427, 2427,
     6   2428, 2429, 2430, 2431, 2432, 2433, 2434, 2435, 2436, 2437,
     7   2438, 2439, 2440, 2441, 2442, 2443, 2444, 2445, 2446, 2447,
     8   2448, 2449, 2450, 2451, 2452, 2453, 2454, 2455, 2456, 2456,
     9   2457, 2458, 2459, 2460, 2461, 2461, 2463, 2464, 2465, 2466/
            data (jb2(i),i= 2501, 2600)/
     +   2467, 2468, 2469, 2470, 2471, 2472, 2473, 2474, 2475, 2475,
     1   2476, 2477, 2478, 2479, 2480, 2481, 2482, 2483, 2484, 2485,
     2   2486, 2488, 2489, 2490, 2491, 2492, 2492, 2487, 2493, 2494,
     3   2495, 2496, 2497, 2498, 2499, 2500, 2501, 2502, 2503, 2504,
     4   2505, 2506, 2507, 2508, 2509, 2510, 2511, 2512, 2513, 2514,
     5   2515, 2515, 2517, 2518, 2519, 2520, 2520, 2521, 2522, 2522,
     6   2524, 2525, 2526, 2527, 2528, 2529, 2530, 2531, 2532, 2533,
     7   2534, 2534, 2535, 2536, 2537, 2538, 2539, 2540, 2541, 2542,
     8   2543, 2544, 2545, 2546, 2547, 2548, 2549, 2550, 2551, 2552,
     9   2553, 2554, 2555, 2556, 2557, 2558, 2559, 2560, 2561,   23/
            data (jb2(i),i= 2601, 2700)/
     +   2562, 2563, 2564, 2565, 2566, 2567, 2568, 2569, 2570, 2571,
     1   2572, 2573, 2574, 2575, 2576, 2577, 2578, 2579, 2580, 2581,
     2   2582, 2583, 2584, 2585, 2586, 2587, 2588, 2589, 2590, 2591,
     3   2592, 2593, 2594, 2595, 2596, 2597, 2598, 2599, 2600, 2601,
     4   2602, 2603, 2604, 2605, 2606, 2607, 2608, 2609, 2610, 2611,
     5   2612, 2613, 2613, 2614, 2615, 2616, 2617, 2618, 2619, 2619,
     6   2620, 2621, 2622, 2623, 2624, 2625, 2626, 2627, 2628, 2629,
     7   2630, 2631, 2632, 2633, 2635, 2636, 2637, 2638, 2639, 2640,
     8   2640, 2641, 2642, 2643, 2644, 2645, 2646, 2647, 2647, 2648,
     9   2649, 2650, 2651, 2652, 2653, 2654, 2655, 2655, 2656, 2658/
            data (jb2(i),i= 2701, 2800)/
     +   2659, 2660, 2661, 2662, 2663, 2663, 2664, 2665, 2666, 2667,
     1   2668, 2669, 2670, 2671, 2672, 2673, 2674, 2675, 2676, 2677,
     2   2678, 2679, 2680, 2681, 2682, 2683, 2684, 2685, 2686, 2687,
     3   2688, 2688, 2689, 2690, 2691, 2692, 2693, 2694, 2695, 2696,
     4   2697, 2698, 2699, 2700, 2701, 2702,   24, 2703, 2704, 2705,
     5   2706, 2707, 2708, 2709, 2710, 2711, 2712, 2713, 2714, 2715,
     6   2716, 2717, 2718, 2719, 2720, 2722, 2723, 2724, 2725, 2726,
     7   2727, 2728, 2729, 2730, 2731, 2732, 2733, 2734, 2735, 2736,
     8   2737, 2738, 2739, 2740, 2741, 2742, 2743, 2744, 2744, 2745,
     9   2746, 2747, 2749, 2750, 2751, 2752, 2753, 2754, 2755, 2756/
            data (jb2(i),i= 2801, 2900)/
     +   2757, 2758, 2759, 2760, 2761, 2762, 2763, 2764, 2765, 2766,
     1   2767, 2768, 2769, 2769, 2770, 2771, 2772, 2773, 2774, 2775,
     2   2776, 2777, 2778, 2779, 2780, 2781, 2782, 2783, 2783, 2784,
     3   2785, 2786, 2787, 2788, 2789, 2790, 2791, 2792, 2793, 2793,
     4   2794, 2795, 2796, 2797, 2798, 2799, 2800, 2801, 2802, 2803,
     5   2804, 2805, 2806, 2807, 2808, 2809, 2810, 2811, 2812, 2813,
     6   2814, 2815, 2815, 2816, 2817, 2818, 2819, 2820, 2821, 2822,
     7   2823, 2824, 2825, 2826, 2827, 2828, 2828, 2830, 2831,   25,
     8   2832, 2833, 2834, 2835, 2836, 2837, 2838, 2839, 2840, 2841,
     9   2842, 2843, 2844, 2844, 2845, 2846, 2847, 2848, 2849, 2850/
            data (jb2(i),i= 2901, 3000)/
     +   2851, 2852, 2852, 2853, 2854, 2855, 2856, 2857, 2858, 2859,
     1   2859, 2860, 2861, 2862, 2863, 2865, 2866, 2867, 2868, 2869,
     2   2870, 2871, 2871, 2873, 2874, 2875, 2876, 2877, 2878, 2878,
     3   2879, 2880, 2881, 2882, 2883, 2884, 2885, 2886, 2887, 2888,
     4   2889, 2890, 2891, 2892, 2893, 2894, 2895, 2896, 2897, 2898,
     5   2899, 2900, 2900, 2901, 2902, 2903, 2904, 2904, 2905, 2906,
     6   2907, 2908, 2909, 2910, 2911, 2912, 2913, 2914, 2915, 2916,
     7   2917, 2918, 2919, 2920, 2921, 2922, 2923, 2924, 2925, 2926,
     8   2927, 2928, 2928, 2930, 2931, 2932, 2933, 2934, 2935, 2936,
     9   2937, 2937, 2938, 2939,   27, 2940, 2941,   28, 2943, 2944/
            data (jb2(i),i= 3001, 3100)/
     +   2945, 2945, 2946, 2947, 2948, 2949, 2950, 2951, 2952, 2953,
     1   2954, 2955, 2956, 2957, 2958, 2959, 2960, 2961, 2962, 2963,
     2   2964, 2965, 2966, 2967, 2968, 2969, 2970, 2971, 2971, 2972,
     3   2973, 2974, 2975, 2976, 2977, 2978, 2979, 2980, 2981, 2982,
     4   2983, 2984, 2984, 2985, 2986, 2987, 2988, 2989, 2990, 2991,
     5   2992, 2993, 2994, 2995, 2996, 2997, 2998,   29, 2999, 3000,
     6   3001, 3001, 3002, 3003, 3004, 3005, 3006, 3007, 3008,   30,
     7   3009,   31, 3010, 3011, 3012, 3013, 3014, 3015, 3016, 3017,
     8   3018, 3019, 3020, 3021, 3022, 3023,   32, 3024, 3025, 3026,
     9   3027, 3028, 3029, 3030, 3031, 3032, 3033, 3034, 3035,   33/
            data (jb2(i),i= 3101, 3200)/
     +   3036, 3037, 3038, 3039, 3040, 3041, 3042, 3043, 3044, 3045,
     1   3046, 3047, 3048, 3049, 3050, 3051, 3052, 3053, 3054, 3055,
     2   3056, 3057, 3058, 3059, 3060, 3061, 3062, 3063, 3064,   36,
     3   3065, 3066,   38,    2,    3,    4,    4,    6,    7,    8,
     4      8,   10,   11,   12,   12,   14,   15,   15,   17,   18,
     5     19,   19,   21,   22,   22,   24,   25,   26,   27,   28,
     6     28,   30,   31,   32,   32,   34,   35,   35,   37,   38,
     7     39,   39,   41,   42,   43,   43,   45,   46,   47,   48,
     8     49,   50,   51,   52,   53,   54,   55,   56,   57,   57,
     9     59,   60,   61,   61,   63,   64,   65,   66,   67,   68/
            data (jb2(i),i= 3201, 3300)/
     +     68,   70,   71,   71,   73,   74,   75,   76,   77,   78,
     1     78,   80,   81,   82,   82,   84,   85,   86,   86,   88,
     2     89,   89,   91,   92,   93,   93,   95,   96,   96,   98,
     3     99,  100,  101,  101,  103,  104,  104,  106,  107,  107,
     4    109,  110,  111,  112,  113,  113,  115,  116,  116,  118,
     5    119,  119,  121,  122,  123,  123,  125,  126,  126,  128,
     6    129,  129,  131,  132,  133,  133,  135,  136,  137,  138,
     7    139,  140,  140,  142,  143,  143,  145,  146,  147,  147,
     8    149,  150,  150,  152,  153,  154,  154,  156,  157,  157,
     9    159,  160,  161,  162,  163,  164,  165,  166,  167,  168/
            data (jb2(i),i= 3301, 3400)/
     +    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     1    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     2    189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
     3    199,  200,  201,  202,  203,  204,  205,  206,  207,  208,
     4    209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
     5    219,  220,  221,  222,  223,  223,  225,  226,  227,  228,
     6    228,  230,  231,  232,  233,  234,  235,  236,  237,  238,
     7    239,  239,  241,  242,  242,  244,  245,  245,  247,  248,
     8    248,  250,  251,  252,  252,  254,  255,  256,  256,  258,
     9    259,  260,  260,  262,  263,  264,  265,  266,  266,  268/
            data (jb2(i),i= 3401, 3500)/
     +    269,  269,  271,  272,  272,  274,  275,  275,  277,  278,
     1    278,  280,  281,  282,  283,  284,  285,  286,  287,  288,
     2    288,  290,  291,  291,  293,  294,  295,  296,  297,  297,
     3    299,  300,  301,  302,  302,  304,  305,  306,  306,  308,
     4    309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
     5    319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
     6    329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
     7    339,  340,  341,  342,  343,  344,  344,  346,  347,  348,
     8    349,  350,  350,  352,  353,  353,  355,  356,  357,  358,
     9    359,  360,  360,  362,  363,  364,  365,  365,  367,  368/
            data (jb2(i),i= 3501, 3600)/
     +    368,  370,  371,  372,  372,  374,  375,  376,  376,  378,
     1    379,  380,  380,  382,  383,  384,  385,  386,  387,  387,
     2    389,  390,  390,  392,  393,  394,  395,  396,  397,  398,
     3    398,  400,  401,  401,  403,  404,  404,  406,  407,  408,
     4    408,  410,  411,  412,  413,  413,  415,  416,  417,  418,
     5    418,  420,  421,  421,  423,  424,  425,  426,  427,  427,
     6    429,  430,  430,  432,  433,  434,  435,  435,  437,  438,
     7    439,  439,  441,  442,  443,  444,  444,  446,  447,  447,
     8    449,  450,  451,  452,  453,  454,  455,  456,  457,  458,
     9    459,  460,  461,  462,  463,  464,  464,  466,  467,  467/
            data (jb2(i),i= 3601, 3700)/
     +    469,  470,  471,  472,  473,  474,  475,  476,  476,  478,
     1    479,  480,  481,  482,  483,  484,  485,  485,  487,  488,
     2    489,  489,  491,  492,  492,  494,  495,  495,  497,  498,
     3    499,  499,  501,  502,  503,  504,  504,  506,  507,  507,
     4    509,  510,  511,  511,  513,  514,  515,  516,  517,  518,
     5    519,  520,  521,  522,  523,  524,  525,  526,  527,  528,
     6    529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
     7    539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
     8    549,  550,  551,  551,  553,  554,  555,  556,  556,  558,
     9    559,  560,  560,  562,  563,  564,  565,  566,  567,  568/
            data (jb2(i),i= 3701, 3800)/
     +    568,  570,  571,  572,  572,  574,  575,  575,  577,  578,
     1    579,  580,  581,  582,  583,  584,  585,  586,  586,  588,
     2    589,  590,  591,  591,  593,  594,  594,  596,  597,  598,
     3    598,  600,  601,  601,  603,  604,  605,  605,  607,  608,
     4    609,  609,  611,  612,  613,  613,  615,  616,  617,  618,
     5    618,  620,  621,  621,  623,  624,  625,  625,  627,  628,
     6    629,  629,  631,  632,  633,  633,  635,  636,  636,  638,
     7    639,  639,  641,  642,  643,  644,  645,  646,  647,  648,
     8    649,  650,  651,  651,  653,  654,  655,  656,  657,  657,
     9    659,  660,  661,  661,  663,  664,  665,  665,  667,  668/
            data (jb2(i),i= 3801, 3900)/
     +    669,  670,  671,  672,  673,  674,  675,  676,  677,  678,
     1    679,  680,  681,  681,  683,  684,  685,  686,  686,  688,
     2    689,  690,  691,  692,  693,  694,  695,  696,  697,  698,
     3    699,  700,  701,  701,  703,  704,  705,  705,  707,  708,
     4    709,  709,  711,  712,  712,  714,  715,  716,  716,  718,
     5    719,  720,  720,  722,  723,  724,  724,  726,  727,  727,
     6    729,  730,  731,  731,  733,  734,  735,  736,  737,  738,
     7    739,  740,  740,  742,  743,  743,  745,  746,  746,  748,
     8    749,  749,  751,  752,  753,  754,  754,  756,  757,  758,
     9    759,  760,  760,  762,  763,  764,  765,  765,  767,  768/
            data (jb2(i),i= 3901, 4000)/
     +    768,  770,  771,  772,  772,  774,  775,  775,  777,  778,
     1    779,  780,  781,  781,  783,  784,  784,  786,  787,  787,
     2    789,  790,  791,  792,  792,  794,  795,  796,  797,  798,
     3    798,  800,  801,  801,  803,  804,  805,  805,  807,  808,
     4    808,  810,  811,  811,  813,  814,  814,  816,  817,  818,
     5    819,  820,  821,  821,  823,  824,  825,  826,  827,  828,
     6    829,  830,  831,  832,  833,  834,  835,  836,  836,  838,
     7    839,  840,  840,  842,  843,  844,  844,  846,  847,  848,
     8    849,  850,  851,  852,  852,  854,  855,  856,  857,  857,
     9    859,  860,  861,  861,  863,  864,  864,  866,  867,  868/
            data (jb2(i),i= 4001, 4100)/
     +    869,  869,  871,  872,  872,  874,  875,  876,  876,  878,
     1    879,  880,  880,  882,  883,  884,  885,  886,  887,  888,
     2    889,  890,  891,  892,  893,  894,  895,  896,  897,  897,
     3    899,  900,  901,  901,  903,  904,  904,  906,  907,  908,
     4    909,  910,  911,  912,  913,  914,  915,  916,  917,  918,
     5    919,  920,  921,  922,  923,  923,  925,  926,  927,  927,
     6    929,  930,  930,  932,  933,  934,  935,  935,  937,  938,
     7    939,  940,  941,  942,  943,  944,  945,  946,  947,  948,
     8    949,  950,  951,  952,  953,  954,  955,  956,  957,  958,
     9    958,  960,  961,  962,  962,  964,  965,  965,  967,  968/
            data (jb2(i),i= 4101, 4200)/
     +    969,  970,  971,  972,  973,  974,  975,  975,  977,  978,
     1    979,  980,  980,  982,  983,  984,  985,  986,  986,  988,
     2    989,  990,  990,  992,  993,  993,  995,  996,  997,  998,
     3    999, 1000, 1001, 1002, 1003, 1004, 1005, 1005, 1007, 1008,
     4   1008, 1010, 1011, 1012, 1012, 1014, 1015, 1015, 1017, 1018,
     5   1019, 1020, 1021, 1022, 1022, 1024, 1025, 1025, 1027, 1028,
     6   1029, 1030, 1031, 1031, 1033, 1034, 1035, 1035, 1037, 1038,
     7   1039, 1039, 1041, 1042, 1043, 1044, 1044, 1046, 1047, 1047,
     8   1049, 1050, 1051, 1052, 1053, 1054, 1055, 1055, 1057, 1058,
     9   1058, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068/
            data (jb2(i),i= 4201, 4300)/
     +   1069, 1069, 1071, 1072, 1073, 1073, 1075, 1076, 1076, 1078,
     1   1079, 1079, 1081, 1082, 1082, 1084, 1085, 1086, 1087, 1088,
     2   1089, 1090, 1090, 1092, 1093, 1094, 1094, 1096, 1097, 1097,
     3   1099, 1100, 1100, 1102, 1103, 1104, 1105, 1106, 1106, 1108,
     4   1109, 1109, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118,
     5   1118, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128,
     6   1129, 1129, 1131, 1132, 1133, 1134, 1134, 1136, 1137, 1137,
     7   1139, 1140, 1141, 1141, 1143, 1144, 1145, 1145, 1147, 1148,
     8   1149, 1150, 1151, 1152, 1152, 1154, 1155, 1155, 1157, 1158,
     9   1159, 1159, 1161, 1162, 1162, 1164, 1165, 1166, 1166, 1168/
            data (jb2(i),i= 4301, 4400)/
     +   1169, 1169, 1171, 1172, 1173, 1173, 1175, 1176, 1177, 1177,
     1   1179, 1180, 1180, 1182, 1183, 1184, 1185, 1185, 1187, 1188,
     2   1189, 1189, 1191, 1192, 1193, 1193, 1195, 1196, 1197, 1198,
     3   1198, 1200, 1201, 1202, 1203, 1203, 1205, 1206, 1207, 1208,
     4   1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218,
     5   1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227, 1227,
     6   1229, 1230, 1231, 1231, 1233, 1234, 1235, 1235, 1237, 1238,
     7   1239, 1240, 1241, 1241, 1243, 1244, 1245, 1246, 1247, 1247,
     8   1249, 1250, 1251, 1252, 1253, 1254, 1254, 1256, 1257, 1257,
     9   1259, 1260, 1260, 1262, 1263, 1264, 1264, 1266, 1267, 1268/
            data (jb2(i),i= 4401, 4500)/
     +   1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277, 1278,
     1   1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287, 1287,
     2   1289, 1290, 1290, 1292, 1293, 1294, 1295, 1296, 1297, 1297,
     3   1299, 1300, 1301, 1301, 1303, 1304, 1305, 1306, 1307, 1308,
     4   1309, 1309, 1311, 1312, 1313, 1313, 1315, 1316, 1316, 1318,
     5   1319, 1320, 1320, 1322, 1323, 1323, 1325, 1326, 1326, 1328,
     6   1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338,
     7   1339, 1340, 1340, 1342, 1343, 1343, 1345, 1346, 1346, 1348,
     8   1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357, 1358,
     9   1359, 1360, 1361, 1361,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine me(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(2740) :: jx,jy
            integer(kind=iknd), save, dimension(2760) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'maine         '/
            data jrot,ipart/0,2/
            data kv/   1,1778,2736,   0,   0/
            data kb/   1,1795,2753,   0,   0/
            data iib/1385, 958,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  21648,41232,45888,45720,45768,45864,45960,46128,46416,46248,
     1  46224,46320,46488,46464,46584,46920,46968,46752,47280,47352,
     2  47592,47616,47688,47760,47592,47592,47976,47976,47928,48072,
     3  48048,48192,48240,48456,48552,48672,48768,49032,49080,49032,
     4  48792,48696,48768,48672,48528,48552,48144,48072,48096,48360,
     5  48240,48216,48048,48120,48000,47952,47832,47712,47688,47712,
     6  47832,47808,47664,47640,47712,47808,47832,47736,47616,47520,
     7  47376,47424,47232,47280,47280,47160,46848,46920,46728,46728,
     8  46992,47088,47232,47448,47496,47544,47592,47616,47424,47232,
     9  47136,47232,47232,47592,47592,47376,47352,47400,47568,47688/
            data (jx(i),i=  101,  200)/
     +  47784,47736,47928,47904,48096,48096,48216,48144,48144,47928,
     1  47760,47640,47688,47496,47616,47520,47328,47064,46464,46104,
     2  46032,45912,45816,45720,45480,45240,45144,44880,44832,44616,
     3  44664,32280,16800,39744,14160,30360,27288,22488,12336,18120,
     4  41232,41232,41352,41496,41640,41616,41400,41400,41328,41088,
     5  40824,40296,40200,40032,39864,39648,39360,39072,38592,38016,
     6  37944,37872,37368,37248,36960,36720,36600,36360,36096,35952,
     7  35952,35400,35136,34752,34488,34224,34128,34080,33960,33528,
     8  33360,33024,32640,32232,31488,31296,31104,30936,30216,30168,
     9  30120,30120,30240,30216,30312,30216,30168,30072,29928,29664/
            data (jx(i),i=  201,  300)/
     +  29616,29280,29184,29088,28848,28680,21888,41112,41232,41184,
     1  41424,41352,41208,41232,41424,41544,41592,17040,17592,17856,
     2  18144,18264,18216,18096,18000,18168,18288,18672,19080,19416,
     3  19464,19440,19584,19608,19440,19392,19320,19272,19176,18960,
     4  19008,19152,18984,19152,19128,19296,19272,19032,19104,19272,
     5  19392,19560,19536,19680,19224,19464,19584,19584,19752,19992,
     6  20016,19968,20088,20304,20544,20664,20736,20856,20976,21336,
     7  16152,15936,15576,15600,15264,15336,15288,15456,15600,15840,
     8  15912,16032,15984,16056,15960,15960,15792,15552,15288,15048,
     9  14928,14544,14304,14472,14352,14424,14352,14184,41568,41688/
            data (jx(i),i=  301,  400)/
     +  41760,41952,41976,41832,41904,41976,42096,42360,42648,42720,
     1  42984,43152,43392,43584,43824,43992,44040,44016,44352,44616,
     2  44664,44544,44712,44592,44424,44448,44304,44280,44160,43968,
     3  44136,44208,44376,44736,44616,44688,44640,44424,44448,44400,
     4  44304,44160,44136,44232,44376,44472,39984,39960,39888,39960,
     5  40056,40056,40224,40320,40296,40368,40272,40272,40344,40440,
     6  40536,40488,40584,40464,40488,40440,40608,40608,40680,40656,
     7  40776,40632,40656,40800,40872,40896,40824,40776,40800,40872,
     8  40992,41016,40992,40872,40776,40776,40872,40992,41064,41016,
     9  41064,41184,41328,41328,41112,41016,41160,41256,41376,41424/
            data (jx(i),i=  401,  500)/
     +  41496,41544,41568,41664,41592,41592,41424,41448,41640,41664,
     1  41592,41616,41760,41784,41952,41904,42024,42072,41952,42024,
     2  41904,41952,42048,42024,42096,42000,42000,42096,42120,42216,
     3  42216,42360,42384,42336,42432,42528,42600,42672,42720,42888,
     4  42936,43104,42936,42936,43008,42960,43464,43608,43608,43512,
     5  43680,43608,43368,43440,43752,43752,43680,43728,43656,43680,
     6  43824,43872,43824,43872,44136,44256,44232,44280,44448,44568,
     7  44784,44808,44640,44712,44640,44832,44784,44832,44904,44832,
     8  44904,44832,44928,45000,45120,45168,45240,45288,45336,45408,
     9  45408,45264,45288,45360,45336,45264,45192,45288,45048,45096/
            data (jx(i),i=  501,  600)/
     +  45120,45048,45240,45192,45360,45456,45384,45432,45600,45960,
     1  12216,11952,12096,12480,12600,12648,12600,12648,12888,13128,
     2  13440,13464,13392,13584,13800,14112,14040,14016,39864,39744,
     3  39624,39576,39456,39456,39504,39552,39600,39648,39696,39792,
     4  39864,39840,39936,40056,39936,39864,39768,39696,39600,39504,
     5  39624,39576,39504,39504,39408,39312,39360,39192,39144,39168,
     6  39048,39024,39048,38976,38928,38880,38928,38904,38856,38712,
     7  38736,38688,38640,38688,38808,38544,38496,38448,38400,38496,
     8  38472,38232,38208,38256,38184,37992,37968,38040,37920,37896,
     9  37992,37800,37440,37368,37416,37584,37800,37872,37680,37296/
            data (jx(i),i=  601,  700)/
     +  37200,37056,37176,37440,37752,37728,37632,37656,37560,37344,
     1  37272,37368,37320,37224,37056,36912,36768,36816,36768,36864,
     2  36912,36816,37104,37200,37296,37296,37080,37056,37104,37272,
     3  37056,36744,36744,36648,36552,36504,36432,36504,36312,36144,
     4  36144,35952,35808,35784,35808,35880,35856,35760,35712,35448,
     5  35184,35424,35520,35520,35448,35544,35496,35544,35472,35376,
     6  35328,35400,35352,35424,35328,35256,35184,35160,34944,34968,
     7  34896,34512,34416,34416,34512,34560,34608,34392,34392,34464,
     8  34632,34704,34752,34584,34560,34704,34824,34824,34896,34920,
     9  34992,34848,34704,34656,34704,34896,34968,34896,32112,31944/
            data (jx(i),i=  701,  800)/
     +  31872,31872,32088,32400,32352,32280,32112,32208,32352,31896,
     1  31920,32040,32016,31872,31752,31584,31560,31368,31152,31056,
     2  30696,30816,30744,31032,31080,31080,30984,30792,30768,30600,
     3  30552,31992,32040,32208,32376,32688,32808,32856,32928,32976,
     4  32808,32664,32544,32592,32472,32400,32304,32280,32256,32352,
     5  32328,32232,32256,32352,32472,32520,32448,32664,32712,32880,
     6  33048,33096,33024,33120,33336,33168,33144,33336,33408,33504,
     7  33672,33696,33600,33480,33312,33240,33216,33216,33240,32952,
     8  32952,32880,32664,32808,32760,32808,32736,32520,32424,32520,
     9  32256,32208,32304,32184,32184,32304,32496,32520,32688,32688/
            data (jx(i),i=  801,  900)/
     +  32736,32760,32880,32880,32928,33000,33024,33096,33384,33432,
     1  33480,33504,33624,33984,34032,34152,34032,34056,34536,34536,
     2  34704,34704,30216,30216,30168,30072,30144,30072,30144,30072,
     3  29928,29856,29760,29784,29928,29904,29832,29712,29640,29688,
     4  29640,29664,29760,30144,30192,30120,29976,29976,29880,29952,
     5  29928,29784,29712,29616,29688,29520,29472,29352,29472,29400,
     6  29544,29568,29400,29064,28968,28872,28848,28776,28848,28824,
     7  28752,28632,28656,28776,28824,28680,28608,28488,28464,28200,
     8  28248,28176,28104,28152,28056,28056,28224,28248,28200,28248,
     9  28392,28488,28608,28632,28728,28608,28896,28992,29040,29088/
            data (jx(i),i=  901, 1000)/
     +  29040,28920,28824,28704,28728,28608,28464,28416,28368,28368,
     1  28272,28224,28104,28032,27960,27984,27840,27768,27648,27792,
     2  27792,27720,27816,27744,27912,27888,27792,27648,27624,27456,
     3  27432,27384,27240,27192,18264,18216,18288,18312,18432,18384,
     4  18408,18528,18504,18648,18840,18888,18912,18984,19128,19296,
     5  19392,19560,19464,19512,19368,19488,19320,19344,19224,19104,
     6  19152,19104,19056,19032,18960,18792,18792,18936,19224,19080,
     7  19152,19056,19080,19152,19200,19272,19392,19440,19368,19416,
     8  19656,19632,19800,19800,20016,20016,20136,20112,20256,20400,
     9  20424,20376,20544,20544,20712,20496,20688,20712,20784,20856/
            data (jx(i),i= 1001, 1100)/
     +  20832,20928,20952,21048,21072,21264,21360,21480,21552,21192,
     1  21216,21552,21576,21720,21864,21912,21648,21624,21480,21360,
     2  21096,21072,21264,21216,21432,21360,21600,21600,21648,21720,
     3  21864,21864,22056,22008,22056,22128,22056,21984,21888,21960,
     4  21936,21864,21816,21744,21720,21672,21480,21408,21456,21624,
     5  21888,21960,21960,22008,22224,22344,22224,22416,22464,22416,
     6  22992,23040,22968,22968,23064,23136,23160,23112,23016,23016,
     7  23112,23136,23232,23280,23232,23136,23184,23088,23136,23160,
     8  23184,23256,23352,23280,23208,23376,23328,23280,23232,23256,
     9  23352,23424,23304,23136,23088,23112,22920,22920,22728,22776/
            data (jx(i),i= 1101, 1200)/
     +  22704,22848,22848,22656,22632,22704,22656,22608,22584,22608,
     1  22560,22632,22800,22824,22776,22656,22728,22848,22608,22608,
     2  22656,22656,22704,22680,22776,22728,22656,22608,22584,22488,
     3  12384,12552,12576,12480,12552,12360,12480,12456,12240,12240,
     4  12336,12480,12696,12864,13008,12936,13128,13344,13512,13536,
     5  13728,13800,13704,13608,13656,13584,13776,14136,14304,14496,
     6  14592,14544,14568,14472,14496,14568,14664,14640,14712,14664,
     7  14664,14832,14832,14880,15096,15216,15168,15240,15360,15312,
     8  15408,15408,15264,15288,15504,15504,15576,15672,15816,15816,
     9  15672,15720,15768,15864,15888,15816,15984,15816,15936,16056/
            data (jx(i),i= 1201, 1300)/
     +  16176,16344,16512,16896,17088,17328,17280,17376,17352,17424,
     1  17448,17424,17520,17736,17712,17832,17784,17976,18288,18192,
     2  17976,17904,17952,18072,17928,17832,17832,27408,27384,27336,
     3  27216,27192,27408,27480,27456,27216,27168,27096,27072,27192,
     4  27216,27168,27096,27144,27048,26976,26904,26856,27024,26976,
     5  26736,26688,26736,26640,26472,26376,26376,26448,26376,26256,
     6  26208,26160,26088,26160,25968,25872,25872,25776,25800,25848,
     7  25920,25872,25824,25848,25704,25632,25728,25608,25608,25560,
     8  25464,25464,25560,25488,25584,25536,25536,25488,25392,25440,
     9  25392,25392,25440,25296,25272,25440,25632,25704,25728,25584/
            data (jx(i),i= 1301, 1400)/
     +  25560,25464,25344,25104,25272,25320,25200,25176,25344,25320,
     1  25176,25056,25056,25152,25176,25056,24936,24816,24888,24672,
     2  24504,24504,24360,24408,24504,24576,24720,24840,24960,24720,
     3  24432,24576,24744,24720,24864,24960,24936,24768,24696,24576,
     4  24528,24408,24432,24480,24240,24168,24192,23976,23160,23184,
     5  23256,23280,23352,23376,23256,23376,23424,23520,23424,23568,
     6  23568,23688,23688,24000,24000,24144,23976,23736,23712,23880,
     7  23856,23784,23736,23640,23568,23592,23496,23520,23640,23688,
     8  23808,23736,23808,23880,23904,24288,32184,32160,39096,40272,
     9  40248,40392,40368,40632,33288,33288,35568,35568,35616,35688/
            data (jx(i),i= 1401, 1500)/
     +  35664,35832,37224,37248,39960,39864,40104,39072,32160,30960,
     1  31056,31032,30936,31872,32616,31680,31896,27408,24288,24168,
     2  24144,24552,24888,24672,24576,24456,24384,24408,24144,24048,
     3  24336,24360,24288,24240,24312,24192,24048,24144,24168,24048,
     4  23928,23736,23664,23544,23592,23472,23280,23568,23448,23568,
     5  23640,23760,24024,24000,24048,24192,24456,24432,24264,24240,
     6  24336,24336,24192,24264,24144,24120,23808,23688,23712,23640,
     7  24336,24264,24288,24720,24792,25008,25944,25920,26160,26112,
     8  28056,28008,28176,27648,27504,27120,27000,27048,26856,26832,
     9  26328,36864,37176,36024,36240,35088,35616,34080,33792,33408/
            data (jx(i),i= 1501, 1600)/
     +  33072,32928,32664,32712,32544,32544,32424,32064,32088,31824,
     1  28944,28752,17160,17064,17064,17856,18360,18336,18816,18984,
     2  20184,20616,20232,20280,20208,20232,20304,20400,21288,21336,
     3  21288,21288,21384,21432,21528,21552,21552,21432,21576,21912,
     4  21864,21936,21840,22032,22176,22872,23136,23184,23400,23568,
     5  23856,23928,25104,25248,25224,25368,24912,24864,26232,26352,
     6  39408,39768,38664,39360,39528,39744,39528,20352,21120,21096,
     7  21192,21264,20880,21120,21168,21960,22200,19704,19344,14592,
     8  14184,14328,14400,14592,14592,16008,16920,16560,18984,18744,
     9  18888,18984,19056,19080,19248,26280,26304,26592,26544,26472/
            data (jx(i),i= 1601, 1700)/
     +  26448,27048,26808,27216,27000,26568,25992,26880,26928,27024,
     1  27456,28152,29496,30216,20592,20400,20400,20304,20568,20592,
     2  20808,20784,20976,20928,21528,21480,21384,21336,21288,21216,
     3  21216,21408,25848,25656,24672,24528,24600,23664,23616,22800,
     4  22560,22392,23568,23424,23400,19008,19080,18984,19080,18504,
     5  18432,17016,17064,17040,27936,27840,27528,27192,26904,26928,
     6  26664,26520,26592,26496,26616,26808,21120,20976,21048,21144,
     7  21120,21216,22584,22320,22152,22056,21840,21624,21192,17088,
     8  17760,17832,18120,18576,19584,19584,20376,20592,20688,22368,
     9  22440,22632,22752,14208,14232,14112,14136,14064,14136,14112/
            data (jx(i),i= 1701, 1800)/
     +  14256,14256,14400,14400,14616,14496,14472,14544,14736,14568,
     1  14880,14232,13680,13536,13608,13608,13944,15072,15096,15768,
     2  16056,16080,15912,15912,15840,16128,16200,16272,16464,16800,
     3  16848,14064,13920,13824,13704,13584,13344,13032,12888,12744,
     4  12600,12552,12480,14232,14472,14664,15024,15072,15408,15384,
     5  15432,15360,15504,15384,15336,15408,15600,15744,15744,15912,
     6  16080,16344,17184,16848,22512,22536,22584,22728,22776,22968,
     7  23112,23304,22800,22896,23280,24192,24000,19800,19704,19560,
     8  19560,19704,19464,19512,19656,19512,19176,19128,19176,19296,
     9  19296,19344,19224,19296,20376,20352,20568,20520,20616,20592/
            data (jx(i),i= 1801, 1900)/
     +  20472,20016,19944,19824,19848,20040,20112,20160,20568,20496,
     1  20496,20616,19512,19536,19656,19632,20064,19992,20112,22008,
     2  22032,21960,21936,19656,19608,19608,19704,21144,21072,21144,
     3  21216,19992,19944,20112,20568,20424,20328,20352,20256,20256,
     4  20112,20304,20424,20520,20352,20280,20376,20016,19968,20088,
     5  20088,20280,20232,20352,20352,20208,20136,20160,20904,20856,
     6  20976,21048,20976,20904,20904,21048,21168,21120,21168,21216,
     7  24816,24768,24840,24864,20760,20688,20808,20832,21072,20976,
     8  21048,21096,24432,24360,24264,24336,24360,24480,24600,24600,
     9  24672,24624,24672,24480,20544,20448,20544,20616,27696,27600/
            data (jx(i),i= 1901, 2000)/
     +  27648,27768,27816,28560,28512,28608,28632,26664,26712,26712,
     1  28104,28008,28128,26568,26616,26712,26616,26520,30288,30240,
     2  30240,30312,30552,30480,30456,30552,27648,27624,27696,27744,
     3  32928,32856,32904,33096,33072,24336,24360,24456,24504,24360,
     4  25272,25272,25344,25368,25344,29376,29424,29520,29448,29496,
     5  29376,27984,27864,27864,28008,23856,23976,24096,24240,24360,
     6  24552,24072,23928,27672,27624,27768,27744,31584,31656,31608,
     7  31680,31632,31488,31512,31440,31560,31584,31512,31680,31728,
     8  21360,21312,21312,21408,21432,27504,27408,27216,27384,27456,
     9  27504,27840,27912,27912,27336,27216,27288,27384,27432,27360/
            data (jx(i),i= 2001, 2100)/
     +  27456,27744,27672,27696,27792,31656,31656,31584,31560,31632,
     1  31848,31776,31824,31992,27168,27240,27240,27168,29496,29448,
     2  29472,29592,29232,29160,29208,29352,29256,27000,27120,27120,
     3  27072,27000,26640,26688,26784,26688,26952,27048,27024,31752,
     4  31848,31872,31872,31752,31920,31896,31992,32208,32208,32400,
     5  32352,32448,32472,32544,32688,32592,32640,32568,32544,32544,
     6  32472,32184,31944,31848,31872,31824,31800,31656,31464,31416,
     7  31536,31488,31560,31584,31752,31680,36432,36624,36648,36768,
     8  36672,36672,36600,36600,36552,36312,33816,33744,33792,33960,
     9  35160,35136,35040,35016,35136,35280,35184,32352,32376,32256/
            data (jx(i),i= 2101, 2200)/
     +  32112,32064,31968,32016,32064,32232,34104,34128,34224,32424,
     1  32232,32376,30288,30192,30264,33648,33672,33744,33936,33816,
     2  31512,31464,31560,31584,31800,31680,31776,30144,30144,30216,
     3  30192,31248,31128,31152,31344,31704,31776,31752,31608,31752,
     4  31896,31848,31920,31968,32064,32040,32184,32184,32424,32376,
     5  32352,32328,32352,32304,32208,32280,32232,32064,32040,31656,
     6  31752,31656,31584,31464,31320,31344,31224,35808,35784,35904,
     7  36168,36168,36240,36120,35952,35928,35976,35664,35712,35544,
     8  35472,35376,35208,35352,35568,35616,35784,33552,33552,33696,
     9  33696,33648,33624,33912,33936,34032,35784,35640,35736,35808/
            data (jx(i),i= 2201, 2300)/
     +  34104,34128,34200,34056,33936,34032,37536,37488,37416,37512,
     1  37584,33816,33792,33864,34248,34224,34272,32592,32496,32568,
     2  32640,32256,32232,32400,32376,33888,33816,33936,33912,33576,
     3  33312,33384,33240,33216,33216,33312,33336,33288,33240,33048,
     4  33264,33312,33480,33504,33384,33384,33552,33576,33792,34080,
     5  34176,34224,34008,34032,33672,33648,34248,34248,34032,34080,
     6  33840,33720,33816,33744,34080,34032,37584,37512,37464,37560,
     7  36552,36504,36528,36648,36696,36672,35496,35448,35496,35616,
     8  32640,32592,32544,32688,32736,36816,36912,36792,36672,36696,
     9  34608,34368,34320,34392,34392,34296,34488,36312,36288,36432/
            data (jx(i),i= 2301, 2400)/
     +  36552,36432,34128,34176,34128,33864,33912,32160,32136,32184,
     1  32280,32256,34416,34368,34368,34488,32616,32472,32448,32544,
     2  34248,34200,34104,35376,35328,35472,35448,31200,31176,31128,
     3  31056,31128,35328,35256,35280,35376,35424,31320,31368,31320,
     4  31368,31248,31296,31440,31512,31656,31512,31536,31608,31560,
     5  31608,31704,31752,31800,31728,31872,31728,31680,31512,31416,
     6  31416,31488,31368,31392,31488,31488,31416,31272,31152,31080,
     7  31176,31056,31008,30936,30936,32808,32760,32784,32928,37896,
     8  37872,37968,37968,37248,37464,37392,37344,37224,35592,35592,
     9  35640,35664,35664,32976,32976,33048,33480,33456,33336,33096/
            data (jx(i),i= 2401, 2500)/
     +  33096,37344,37272,37488,37464,35424,35472,35448,35280,35232,
     1  32856,32808,32856,33096,33048,32880,37800,37776,37536,37560,
     2  37632,38088,38064,37896,37776,37464,37512,37464,37272,37056,
     3  36912,36792,36648,36552,36528,36384,36528,36312,36312,36120,
     4  36144,36048,36000,35928,36024,35976,35808,35784,35832,36024,
     5  35952,36048,36168,36144,36192,36264,36288,36408,36384,36456,
     6  36552,36648,36720,36936,37128,37008,36768,36792,36888,36792,
     7  36888,36912,36888,36744,36912,36936,37008,37152,37200,37296,
     8  37512,37536,37584,37680,37752,37872,37944,37968,38016,38064,
     9  38136,38856,38808,38808,35712,35808,35832,35760,35904,35880/
            data (jx(i),i= 2501, 2600)/
     +  35760,35592,35688,35304,35256,35184,35040,35016,34920,34872,
     1  34992,34968,35064,35160,35304,35256,35376,38424,38520,38592,
     2  38496,38376,38352,40992,40824,40800,40848,40896,40920,41016,
     3  41040,38640,38568,38496,38616,36192,36144,36144,36216,41184,
     4  41088,41136,43224,43176,43200,43248,43344,43272,43296,43368,
     5  31680,31776,31824,31776,31656,31608,38424,38496,38544,38592,
     6  38496,38448,43152,43080,43104,43176,42672,42600,42624,42696,
     7  42360,42288,42312,42384,43416,43584,43560,43656,43512,43416,
     8  43416,43248,43848,43776,43800,43920,43968,43944,41280,41256,
     9  41136,41232,42648,42600,42600,42672,43872,43800,43824,43896/
            data (jx(i),i= 2601, 2700)/
     +  41640,41520,41616,43008,43032,42960,42984,43056,42672,42600,
     1  42696,43200,43128,43152,43224,41472,41424,41472,41568,41328,
     2  41328,42432,42384,42408,42456,43248,43176,43080,43152,43728,
     3  43656,43680,43752,32616,32784,32640,32520,32448,32472,44136,
     4  44016,43968,43896,43776,43800,43632,43632,43896,44040,44208,
     5  44304,44160,43968,44040,42840,42816,42768,42720,42744,42816,
     6  43896,43848,43872,43920,41232,41232,41136,41160,42864,42840,
     7  42912,42936,45168,45096,45120,44568,44520,44592,44616,44208,
     8  44040,44016,43920,43800,43776,43896,43968,44040,44016,44064,
     9  44328,44328,46200,46200,46320,46128,45984,45888,45912,45792/
            data (jx(i),i= 2701, 2740)/
     +  45888,45240,45168,45216,45360,45312,45360,33864,33744,33792,
     1  33936,34008,34008,34128,34128,34200,34296,34272,34080,33816,
     2  33744,33792,33864,33960,48696,48768,48696,48504,48480,48288,
     3  48240,48192,48312,48432,48432,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  50784,39480,26712,26712,26592,26640,26592,26160,26280,26376,
     1  26688,26736,26736,26520,26352,26424,26472,26592,26736,26976,
     2  27192,27336,27312,27576,27648,27696,27720,27840,27888,27984,
     3  28080,28128,27960,28104,28272,28320,28512,28584,28680,28752,
     4  28656,28968,29184,29232,29112,29376,29760,29736,29664,29088,
     5  29016,28872,28752,29208,29160,29448,29472,29616,29592,29448,
     6  29232,29208,29328,29256,29136,29160,29088,29088,28992,29352,
     7  29352,28584,28608,28800,29184,29400,29520,29688,29784,29904,
     8  29880,29784,29760,29520,29736,29736,29664,29736,29952,30024,
     9  30144,30120,30216,30000,30144,30240,30336,30360,30264,30384/
            data (jy(i),i=  101,  200)/
     +  30120,30024,29928,30048,30120,30408,30456,30552,30696,31224,
     1  31416,31368,31512,31656,31848,32184,32376,32928,33024,33240,
     2  33240,32760,32712,32568,32472,32616,32784,32880,33096,33312,
     3  33624,26736,39360,24504,34488,21216,18024,16272,15672,12264,
     4  41928,42048,42192,42240,42528,42600,42744,42912,48312,57072,
     5  57288,57552,57816,58080,58224,58704,58872,59208,59520,60000,
     6  60096,60312,60504,60672,60648,60744,60696,60744,60672,60456,
     7  59808,59760,59928,59928,59736,59784,59736,59424,59280,59160,
     8  59232,59208,58992,58872,58392,58632,58776,58776,59304,59448,
     9  60360,60936,61056,61272,61344,61584,61536,61680,61560,61584/
            data (jy(i),i=  201,  300)/
     +  61728,61896,61872,61968,61920,62016,52320,39648,39648,40104,
     1  40128,40344,40488,40968,41208,41256,41328,39408,39840,39840,
     2  40032,40176,40416,40560,40944,41016,41256,41664,41832,42144,
     3  42384,42600,42696,42840,42936,43056,43056,43152,43104,43104,
     4  43296,43440,43824,43944,44064,44208,44352,44352,44592,44808,
     5  44832,44784,45024,45384,45960,46368,46680,46872,47184,47352,
     6  47520,47688,47904,48072,48120,48216,48384,48432,48696,48768,
     7  38688,38568,38136,37944,37440,37296,37104,36960,36672,36552,
     8  36312,36288,36144,36000,35904,35784,35712,35928,35904,36096,
     9  36360,36384,36048,35664,35304,35064,34824,34704,39456,39312/
            data (jy(i),i=  301,  400)/
     +  39360,39264,39336,39552,39600,39504,39504,38904,38664,38808,
     1  38592,38592,38448,38448,38352,38352,38424,38544,38568,38232,
     2  37896,37680,37296,37272,37392,37248,37320,37200,37200,37056,
     3  36744,36312,36240,35688,35568,35448,35256,35040,34920,34752,
     4  34632,34584,34488,34392,34008,33960,24528,24264,24144,24120,
     5  23880,23736,23352,23376,23808,24000,24096,24216,24168,24360,
     6  24384,24216,23928,23952,23688,23640,23160,23280,23352,23424,
     7  23952,24288,24336,24312,24456,24432,24240,24264,24144,24120,
     8  24264,24432,24576,24864,24912,24984,24984,24864,25008,25224,
     9  25296,25272,25056,25272,25368,25560,25440,25680,25320,25320/
            data (jy(i),i=  401,  500)/
     +  25728,25728,25920,25512,25488,25176,25056,24816,24816,25056,
     1  25056,25128,25128,25440,25680,25800,25872,25776,25416,25344,
     2  25080,24984,24960,24840,24816,24768,24504,24480,24696,24768,
     3  24480,24600,24744,24792,25032,25080,25032,25320,25416,25440,
     4  25296,25224,25080,25008,25008,24864,24912,25008,25176,25296,
     5  25824,25968,26064,26136,26112,26232,26376,26424,26520,26568,
     6  26472,26328,26160,26112,26400,26208,25968,25944,25944,25800,
     7  25920,26016,26208,26424,26664,26688,26496,26448,26448,26352,
     8  26304,26160,25872,25752,25920,26184,26208,26112,26112,26256,
     9  26304,26352,26448,26448,26592,26688,26688,26832,26880,26952/
            data (jy(i),i=  501,  600)/
     +  27144,27312,27288,27024,26952,26976,27024,27168,27096,27216,
     1  26640,34920,34992,35016,35088,35136,35328,35400,35232,35304,
     2  34896,34752,34536,34104,33912,33984,34080,34248,24288,24000,
     3  24048,24216,24288,24216,24000,23952,23664,23664,23880,23760,
     4  23808,23712,23376,23208,23208,23016,23112,23352,23232,23280,
     5  23088,22992,22992,22680,22776,22728,22464,22344,22368,22512,
     6  22536,22632,23016,23112,23040,23040,22920,22848,22848,23256,
     7  23448,23520,23928,24048,24096,24264,24168,24192,24264,24288,
     8  24360,24504,24264,24168,24096,24096,24144,24168,24408,24600,
     9  24672,24744,24984,25152,25344,25416,25320,25344,25512,25416/
            data (jy(i),i=  601,  700)/
     +  25248,25248,24984,24864,24648,24408,24384,24024,24048,24360,
     1  24528,24576,24696,24720,24648,24888,24888,24792,24720,24672,
     2  24576,24504,24504,24384,24168,24096,24144,24096,24000,23928,
     3  23832,23976,23832,23832,23952,24384,24096,23784,23544,23616,
     4  23400,23184,23160,23208,23880,24144,24432,24504,24240,24360,
     5  24360,24240,23904,23736,23664,23352,23040,22992,22920,22920,
     6  23064,23256,23568,23760,23880,23616,23592,23352,23352,23256,
     7  23160,23328,23304,23256,23232,23136,22968,22368,22320,22368,
     8  22800,22824,22608,22248,22080,21792,21792,21912,21864,21600,
     9  21408,21432,21600,21552,21360,21288,21000,21000,26400,26208/
            data (jy(i),i=  701,  800)/
     +  25824,25752,25680,25272,24408,24408,24240,24048,24024,23760,
     1  24024,24120,24192,24144,23976,23976,23808,23808,23520,23568,
     2  23520,23160,23064,22848,22728,22296,22008,21840,21864,21816,
     3  21528,25944,25824,25752,25416,25272,25032,25032,25176,25080,
     4  24552,24384,23952,23784,23784,23568,23544,23472,23208,23232,
     5  23136,23112,22968,22944,22992,23136,23184,23232,23496,23616,
     6  23640,23832,23976,24024,23832,23736,23448,23352,23184,23160,
     7  22992,22824,22752,23064,23136,23256,23280,23232,23160,23280,
     8  23352,23400,23016,22896,22848,22704,22656,22896,22872,22752,
     9  22560,22344,22248,22200,22104,22008,22008,22176,22152,22344/
            data (jy(i),i=  801,  900)/
     +  22392,22248,22464,22320,22296,22440,22416,22200,22008,21864,
     1  21840,21912,21816,21720,21888,21960,21720,21624,21408,21264,
     2  21216,21096,20928,20712,20784,20712,20544,20376,20280,20208,
     3  20424,19824,19776,19728,19752,19560,19512,19560,19440,19368,
     4  19344,19056,19128,19248,19224,19008,18888,18816,18816,18648,
     5  18576,18552,18480,18504,18672,18600,18816,18840,18672,18480,
     6  18480,18360,18096,18096,17952,17976,18096,17856,17856,17784,
     7  17640,17568,17544,17592,17520,17208,17208,17328,17208,17016,
     8  17088,17232,17256,17400,17400,17496,17496,17544,17592,17784,
     9  17808,18024,18000,18096,18168,18168,18528,18840,18816,18936/
            data (jy(i),i=  901, 1000)/
     +  18984,18912,18672,18696,18504,18264,18216,18288,18288,18144,
     1  18072,17856,17784,17952,17760,17544,17520,17352,17352,17496,
     2  17616,17592,17832,17832,18024,18072,17952,17976,17832,17688,
     3  17856,17856,17616,17640,12336,12432,12576,12456,12480,12432,
     4  12168,12168,12288,12456,12576,12744,12528,12480,12480,12624,
     5  12528,12624,12768,12888,13056,13344,13632,13704,13776,13680,
     6  13608,13584,13656,13536,13536,13560,13680,13680,13920,14088,
     7  14232,14256,14544,14592,14304,14424,14400,14496,14640,14616,
     8  14952,15240,15336,15120,15288,15360,15504,15576,15576,15672,
     9  15744,15816,15960,16104,16176,15744,15888,15960,15912,15960/
            data (jy(i),i= 1001, 1100)/
     +  15744,15840,16008,16032,16128,16368,16344,16464,16440,15936,
     1  15888,16272,16224,16224,16368,16344,15912,15792,15672,15384,
     2  15000,14832,14976,14712,14928,15120,15384,15576,15648,15624,
     3  15840,16008,16368,16128,16104,16176,15816,15984,15744,15696,
     4  15624,15456,15456,15384,15264,15264,14928,14664,14640,15024,
     5  15312,15360,15216,15264,15984,15792,15480,15456,16056,16056,
     6  17904,17856,17640,17496,17376,17424,16872,16608,16464,16416,
     7  16440,16536,16560,16440,16056,15912,15768,15696,15696,15552,
     8  15672,15648,15408,15408,15504,15120,15048,15072,14880,14832,
     9  14952,14880,14688,14688,14760,14664,14496,14328,14352,14520/
            data (jy(i),i= 1101, 1200)/
     +  14640,14976,15000,14856,14904,15048,15192,15120,15168,15312,
     1  15480,15600,15552,15624,15672,15648,15720,16056,15912,16128,
     2  16200,16296,16296,16392,16536,16560,16584,16440,16560,16464,
     3  12864,12648,12504,12432,12144,11664,11568,11184,10848,10392,
     4  10056, 9864, 9840, 9648, 9384, 9288, 9168, 8832, 8760, 8664,
     5   8568, 8376, 8016, 7920, 7800, 7296, 7080, 6864, 6624, 6528,
     6   6600, 6696, 6744, 6888, 7008, 6816, 6816, 6744, 6696, 6696,
     7   6528, 6600, 6384, 6360, 6480, 6792, 6840, 6816, 6984, 7056,
     8   7056, 7152, 7128, 7248, 7224, 7440, 7608, 7656, 7608, 7680,
     9   7752, 7944, 7920, 7992, 8064, 8112, 8304, 8640, 9000, 9144/
            data (jy(i),i= 1201, 1300)/
     +   9552, 9768, 9840, 9888, 9816,10032,10104,10152,10272,10248,
     1  10272,10440,10536,10536,10632,10680,10752,10992,11160,11208,
     2  11040,11088,11208,11184,11256,11400,11832,18384,18408,18312,
     3  18288,18336,18528,18744,18936,18960,19128,19104,18936,18840,
     4  18576,18456,18456,18696,18696,18552,18528,18384,18240,18168,
     5  17832,17832,18048,17976,17400,17352,17280,17328,16872,16632,
     6  16680,16512,16488,16440,15984,15936,16080,16464,16536,16512,
     7  16680,16824,16800,16632,16512,16536,16992,16896,17064,16800,
     8  16752,16632,16704,16416,16296,16176,16008,15984,16104,16272,
     9  16320,16704,17232,17208,17280,17784,17952,18120,18528,18408/
            data (jy(i),i= 1301, 1400)/
     +  18072,17880,17808,16920,17088,16968,16752,16488,16248,16080,
     1  15720,15696,15840,15888,16320,16272,15888,16032,16176,16128,
     2  16200,16392,16440,16512,16536,17088,17136,16896,17136,17328,
     3  17184,17712,18096,18168,18360,18360,18624,18360,18288,18264,
     4  18096,18048,17976,17976,17448,17448,17328,17304,18024,17592,
     5  17400,16728,16368,16176,15792,15648,15888,15864,15456,14952,
     6  15120,15144,14976,15360,15648,16176,16176,15696,15744,16248,
     7  16464,16536,16392,16344,16464,16608,16752,16800,16728,17112,
     8  17112,16848,16824,16992,17280,50760,48480,50736,38928,39216,
     9  39288,39360,39456,39336,48480,48312,48312,44016,43920,42600/
            data (jy(i),i= 1401, 1500)/
     +  38136,38040,38376,38496,35304,35280,34224,34056,39456,39168,
     1  38832,38136,37272,37440,33816,33624,32568,31704,48480,48480,
     2  43176,43248,41736,41712,41592,41712,41928,42024,41952,42000,
     3  41616,41520,41352,41352,41088,40728,40728,40632,40488,40368,
     4  40464,40488,40608,40440,40296,40296,40224,40056,39912,39816,
     5  39576,39480,39408,39072,39048,39144,38976,38904,39048,39024,
     6  38736,38640,38568,38232,38160,38016,37824,37824,37728,37680,
     7  34488,34488,34416,32040,32064,30912,31080,31200,31248,31464,
     8  28392,28320,27240,27144,27600,27648,27552,27384,27192,26976,
     9  26880,33600,32064,31848,30768,30528,27792,27480,27000,27240/
            data (jy(i),i= 1501, 1600)/
     +  26904,26448,26496,26640,26688,26784,26808,26880,26976,26880,
     1  26256,27336,37392,37392,37224,32712,32784,32856,32928,32256,
     2  32472,30168,30096,29712,29688,29520,29544,28944,29088,28656,
     3  28656,28392,28392,28104,28128,27984,27744,27720,26712,26760,
     4  26688,26544,26496,26328,25872,25992,25776,25488,25440,25824,
     5  25752,25680,25416,25488,25752,26016,26616,26976,27216,27192,
     6  32424,30264,30048,26664,26712,25656,25608,24312,24288,24408,
     7  24576,24576,24840,25344,25608,25416,25776,24216,23976,31176,
     8  31128,30000,30000,28896,27528,28320,26160,25944,25392,24984,
     9  25008,24576,24576,24528,24552,26856,26664,26616,26472,26496/
            data (jy(i),i= 1601, 1700)/
     +  26280,26208,25080,24984,23880,23976,22440,22248,22440,22416,
     1  21984,22704,21312,21360,23016,22968,22872,22848,22392,22200,
     2  21936,20760,20664,20568,20424,20232,20256,20136,20136,19824,
     3  19776,19704,21648,21408,21648,20976,19656,19872,20040,20232,
     4  20016,19488,19488,19224,19032,23760,23448,23424,22776,20808,
     5  20832,18960,18912,18600,18984,19776,20736,20688,20760,20856,
     6  20952,21336,21696,22056,22200,22152,17832,18024,18144,18144,
     7  18456,18552,17544,17184,17112,16992,17136,17040,17592,18480,
     8  18048,18216,18000,18648,17568,17496,16944,17280,17184,16416,
     9  16632,16944,17400,15888,16008,16152,16320,16416,16440,16536/
            data (jy(i),i= 1701, 1800)/
     +  16632,16584,16680,16608,16800,16824,17040,17184,17328,17544,
     1  17760,18744,18888,19272,19392,19464,19224,19992,19944,20376,
     2  19896,19776,19488,19296,19008,18432,18408,18528,18288,18720,
     3  18744,15840,15864,15792,15840,15792,15864,15744,15624,15648,
     4  15552,15600,15552,15744,15552,15576,15768,15624,15528,15432,
     5  15288,15240,15072,14808,14448,14400,14472,14376,14232,14376,
     6  14232,14592,13656,13200,17496,17928,18000,17928,18216,18240,
     7  18672,18648,17760,17736,18408,18192,17736,13824,13728,13776,
     8  13848,14016,13584,13680,13656,13512,12312,12336,12384,12384,
     9  12288,14208,14208,14256,14160,14232,14448,14328,14328,14256/
            data (jy(i),i= 1801, 1900)/
     +  14280,14208,14064,14112,14184,14328,14448,14352,14040,14016,
     1  14064,14184,14016,14160,14208,14040,13752,13752,13872,14664,
     2  14592,14592,14664,14544,14520,14568,14640,14520,14496,14640,
     3  14616,14448,14496,14544,15096,14640,14616,14568,14448,14592,
     4  14616,14952,14952,15096,14376,14376,14472,14928,14976,15144,
     5  15240,15336,15168,15192,15144,15048,15096,15024,14880,14904,
     6  15120,15120,15696,15672,15720,15816,15648,15648,15744,15696,
     7  15576,15648,15720,15600,15576,15576,15648,15600,15480,15408,
     8  15576,15552,16080,16080,15864,15816,15672,15456,15360,15840,
     9  15792,15960,16056,16176,15360,15336,15432,15432,14976,14976/
            data (jy(i),i= 1901, 2000)/
     +  15120,15216,15192,16992,17064,17112,17016,16992,17112,16992,
     1  16968,17040,17184,16920,17136,17184,17472,16920,16920,16944,
     2  17016,16992,16800,16800,16896,16872,16776,16800,16824,16680,
     3  16560,16608,16656,16728,16632,16608,16560,16608,17136,16848,
     4  16608,16656,16704,16656,16368,16560,16704,16776,16488,16392,
     5  16392,16320,16320,16440,16440,16752,16320,16224,17064,17184,
     6  17952,16896,16872,16224,16296,16512,16296,16176,16224,16320,
     7  16392,16488,16392,16296,16176,16128,15768,15816,16032,15960,
     8  15744,15744,15864,15960,15816,17496,17328,17352,17472,17616,
     9  17640,17208,17304,17232,17232,17112,17280,17304,17112,17088/
            data (jy(i),i= 2001, 2100)/
     +  17232,17040,16992,16944,16968,18504,18456,18432,18528,18576,
     1  18432,18624,18648,18456,18120,18216,18144,18000,18024,18024,
     2  18072,18048,17928,17904,18024,18024,17880,18072,18144,17928,
     3  17736,17712,17616,17760,17784,17544,17568,17640,17520,19008,
     4  19056,19032,18888,18792,18744,18672,18576,18792,18480,18552,
     5  18672,18720,18816,18768,18888,19008,19080,19272,19248,19152,
     6  19128,19128,19392,19344,19488,19512,19608,19632,19512,19296,
     7  19296,19200,19176,19224,19200,19104,19392,19464,19416,19440,
     8  19536,19632,19680,19728,19752,19560,19392,19440,19512,19368,
     9  19344,19320,19416,19560,19728,19488,19464,19416,19560,19632/
            data (jy(i),i= 2101, 2200)/
     +  19560,19728,19680,19656,19368,19296,19248,19320,19272,19248,
     1  19176,19320,19008,19008,19128,18984,19104,19056,19104,18960,
     2  19032,19152,19080,18936,18864,18912,18960,18840,18912,18912,
     3  18816,19680,19488,19464,19680,19944,19944,19800,19752,19704,
     4  19752,19848,19968,19848,19896,19944,19992,19920,19992,20064,
     5  20016,20064,20112,20112,20328,20400,20448,20400,20448,20136,
     6  20064,19992,20064,20016,19872,19824,19752,20040,19944,19776,
     7  19824,20016,20064,20328,20544,20424,20328,20232,20376,20424,
     8  20256,20256,20088,19920,20112,19872,20064,19800,19896,19944,
     9  19752,19728,19824,19656,19704,19728,19632,19728,19776,19680/
            data (jy(i),i= 2201, 2300)/
     +  19584,19752,19656,19944,19944,20040,19896,19896,20064,20160,
     1  20112,19848,19944,19920,19800,19920,19872,19848,19824,19920,
     2  19920,19776,19848,19896,19824,20328,20280,20160,20112,19992,
     3  20088,20208,20184,20256,20424,20472,20544,20688,20784,20880,
     4  20952,21048,20904,21000,21096,21216,21480,21624,21432,21336,
     5  21216,21000,21096,20880,20856,20784,20808,20760,20736,20616,
     6  20712,20664,20592,20472,20304,20232,20304,20280,20376,20376,
     7  20256,20328,20424,20472,20328,20280,20616,20616,20712,20640,
     8  20616,20616,20736,20880,20808,20736,20616,20592,20664,20760,
     9  20520,20856,20688,20664,20616,20520,20448,20424,20448,20616/
            data (jy(i),i= 2301, 2400)/
     +  20616,20424,20520,20424,20376,20496,20568,20976,21024,21144,
     1  21168,20976,20952,20976,21024,21000,20952,20904,21096,21096,
     2  20952,20880,20952,20880,21000,21000,20928,21096,21144,21048,
     3  20808,20880,20640,20664,20760,20808,20712,21672,21576,21384,
     4  21336,21072,21024,21264,21624,21888,21984,22080,22104,22224,
     5  22440,22344,22392,22440,22512,22728,23040,22872,22872,22728,
     6  22560,22464,22320,22224,22248,22152,22008,21912,21672,21144,
     7  21336,21528,21360,21360,21240,21120,21120,21264,21168,21120,
     8  21192,21216,21120,21048,21168,21216,21336,21288,21864,22104,
     9  22080,21960,21888,21840,21936,22008,21720,21624,21528,21672/
            data (jy(i),i= 2401, 2500)/
     +  21768,21528,21600,21600,21528,21552,21528,21432,21480,21696,
     1  21456,21504,21528,21408,21360,21384,21408,21336,21288,21480,
     2  21480,22584,22776,23064,23088,23352,23448,23616,23688,23592,
     3  23712,23736,23472,23448,23544,23472,23160,23088,22992,22872,
     4  22824,22632,22632,22464,22440,22224,22080,21840,21744,21720,
     5  21600,21312,21432,21288,21216,21336,21264,21216,21024,20976,
     6  21264,20904,20928,21024,21288,21504,21576,21672,21624,21792,
     7  21864,22104,22344,22728,22704,22632,21912,21744,21792,21744,
     8  21792,21840,21792,21816,21912,21936,22080,22008,22032,22272,
     9  22272,22608,22656,22752,22176,22272,22368,22392,22608,22872/
            data (jy(i),i= 2501, 2600)/
     +  22824,22512,22392,22104,22080,22200,22248,22200,22224,22296,
     1  22680,22824,22992,22944,22512,22320,22176,22944,22944,23040,
     2  23256,23112,23016,23496,23616,23808,23928,23928,23664,23664,
     3  23544,23304,23280,23424,23424,23208,23280,23328,23256,24000,
     4  24048,23856,23832,23856,23904,23856,23760,23784,23856,23808,
     5  23856,23856,23712,23520,23568,23712,23664,23832,23808,23760,
     6  23544,23520,24000,24048,24096,24048,24000,24024,24096,24048,
     7  23976,24000,24048,24000,23904,23976,24144,24192,24408,24456,
     8  24792,24528,24288,24384,24456,24456,24384,24312,24312,24408,
     9  24264,24264,24216,24240,24312,24264,24192,24216,24264,24240/
            data (jy(i),i= 2601, 2700)/
     +  24240,24216,24144,24432,24360,24360,24528,24480,24360,24432,
     1  24408,24336,24360,24408,24384,24432,24336,24288,24384,24648,
     2  24504,24288,24312,24384,24336,24696,24816,24624,24576,24504,
     3  24528,24600,24552,24480,24792,25176,25248,25056,24816,24480,
     4  24456,24576,24600,24504,24576,24648,24720,24744,24648,25272,
     5  25320,25368,25296,25224,25152,25296,25296,25128,25008,25032,
     6  24912,24912,24984,24936,24744,24984,24840,24744,24600,24696,
     7  24720,24648,25632,25632,25728,25416,25488,25536,25464,25680,
     8  25800,25632,25608,25704,25560,25392,25392,25464,25536,25584,
     9  25536,25608,25896,25992,26040,26040,26160,26064,25992,25992/
            data (jy(i),i= 2701, 2740)/
     +  25848,25848,25800,25920,25752,25776,25896,18624,18360,18168,
     1  18312,18288,18360,18360,18216,18240,18672,19176,19176,18864,
     2  18720,18696,18768,18744,29688,29784,29928,30000,30168,30336,
     3  30312,30048,29880,29856,29736,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
     1     13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
     2     23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
     3     33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
     4     43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
     5     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     6     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     7     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     8     83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
     9     93,   94,   95,   96,   97,   98,   99,  100,  101,  102/
            data (jb1(i),i=  101,  200)/
     +    103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
     1    113,  114,  115,  116,  117,  118,  119,  120,  121,  122,
     2    123,  124,  125,  126,  127,  128,  129,  130,  141,  142,
     3    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     4    153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     5    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     6    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     7    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     8    193,  194,  195,  196,  197,  198,  199,  200,  201,  202,
     9    203,  204,  205,  206,    1,    2,  208,  209,  210,  211/
            data (jb1(i),i=  201,  300)/
     +    212,  213,  214,  215,  216,  141,  133,  218,  219,  220,
     1    221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
     2    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     3    241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
     4    251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
     5    261,  262,  263,  264,  265,  266,  267,  268,  269,    1,
     6    133,  271,  272,  273,  274,  275,  276,  277,  278,  279,
     7    280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
     8    290,  291,  292,  293,  294,  295,  296,  297,  135,    2,
     9    299,  300,  301,  302,  303,  304,  305,  306,  307,  308/
            data (jb1(i),i=  301,  400)/
     +    309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
     1    319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
     2    329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
     3    339,  340,  341,  342,  343,  344,  345,  131,  134,  347,
     4    348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
     5    358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
     6    368,  369,  370,  371,  372,  373,  374,  375,  376,  377,
     7    378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
     8    388,  389,  390,  391,  392,  393,  394,  395,  396,  397,
     9    398,  399,  400,  401,  402,  403,  404,  405,  406,  407/
            data (jb1(i),i=  401,  500)/
     +    408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     1    418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
     2    428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
     3    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     4    448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
     5    458,  459,  460,  461,  462,  463,  464,  465,  466,  467,
     6    468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
     7    478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
     8    488,  489,  490,  491,  492,  493,  494,  495,  496,  497,
     9    498,  499,  500,  501,  502,  503,  504,  505,  506,  507/
            data (jb1(i),i=  501,  600)/
     +    508,  509,    3,  139,  511,  512,  513,  514,  515,  516,
     1    517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     2    527,  135,  134,  529,  530,  531,  532,  533,  534,  535,
     3    536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
     4    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     5    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     6    566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
     7    576,  577,  578,  579,  580,  581,  582,  583,  584,  585,
     8    586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
     9    596,  597,  598,  599,  600,  601,  602,  603,  604,  605/
            data (jb1(i),i=  601,  700)/
     +    606,  607,  608,  609,  610,  611,  612,  613,  614,  615,
     1    616,  617,  618,  619,  620,  621,  622,  623,  624,  625,
     2    626,  627,  628,  629,  630,  631,  632,  633,  634,  635,
     3    636,  637,  638,  639,  640,  641,  642,  643,  644,  645,
     4    646,  647,  648,  649,  650,  651,  652,  653,  654,  655,
     5    656,  657,  658,  659,  660,  661,  662,  663,  664,  665,
     6    666,  667,  668,  669,  670,  671,  672,  673,  674,  675,
     7    676,  677,  678,  679,  680,  681,  682,  683,  684,  685,
     8    686,  687,  688,  689,  690,  691,  692,  693,  694,  695,
     9    696,  697,  132,  699,  700,  701,  702,  703,  704,  705/
            data (jb1(i),i=  701,  800)/
     +    706,  707,  708,  709,  710,  711,  712,  713,  714,  715,
     1    716,  717,  718,  719,  720,  721,  722,  723,  724,  725,
     2    726,  727,  728,  729,  730,  136,  132,  732,  733,  734,
     3    735,  736,  737,  738,  739,  740,  741,  742,  743,  744,
     4    745,  746,  747,  748,  749,  750,  751,  752,  753,  754,
     5    755,  756,  757,  758,  759,  760,  761,  762,  763,  764,
     6    765,  766,  767,  768,  769,  770,  771,  772,  773,  774,
     7    775,  776,  777,  778,  779,  780,  781,  782,  783,  784,
     8    785,  786,  787,  788,  789,  790,  791,  792,  793,  794,
     9    795,  796,  797,  798,  799,  800,  801,  802,  803,  804/
            data (jb1(i),i=  801,  900)/
     +    805,  806,  807,  808,  809,  810,  811,  812,  813,  814,
     1    815,  816,  817,  818,  819,  820,  821,  698,  136,  823,
     2    824,  825,  826,  827,  828,  829,  830,  831,  832,  833,
     3    834,  835,  836,  837,  838,  839,  840,  841,  842,  843,
     4    844,  845,  846,  847,  848,  849,  850,  851,  852,  853,
     5    854,  855,  856,  857,  858,  859,  860,  861,  862,  863,
     6    864,  865,  866,  867,  868,  869,  870,  871,  872,  873,
     7    874,  875,  876,  877,  878,  879,  880,  881,  882,  883,
     8    884,  885,  886,  887,  888,  889,  890,  891,  892,  893,
     9    894,  895,  896,  897,  898,  899,  900,  901,  902,  903/
            data (jb1(i),i=  901, 1000)/
     +    904,  905,  906,  907,  908,  909,  910,  911,  912,  913,
     1    914,  915,  916,  917,  918,  919,  920,  921,  922,  923,
     2    924,  925,  926,  927,  928,  929,  930,  931,  932,  933,
     3    137,  140,  935,  936,  937,  938,  939,  940,  941,  942,
     4    943,  944,  945,  946,  947,  948,  949,  950,  951,  952,
     5    953,  954,  955,  956,  957,  958,  959,  960,  961,  962,
     6    963,  964,  965,  966,  967,  968,  969,  970,  971,  972,
     7    973,  974,  975,  976,  977,  978,  979,  980,  981,  982,
     8    983,  984,  985,  986,  987,  988,  989,  990,  991,  992,
     9    993,  994,  995,  996,  997,  998,  999, 1000, 1001, 1002/
            data (jb1(i),i= 1001, 1100)/
     +   1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012,
     1   1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022,
     2   1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032,
     3   1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042,
     4   1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052,
     5   1053, 1054, 1055, 1056, 1057, 1058, 1059,  138, 1061, 1062,
     6   1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072,
     7   1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082,
     8   1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092,
     9   1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102/
            data (jb1(i),i= 1101, 1200)/
     +   1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112,
     1   1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122,
     2   1123, 1124, 1125, 1126, 1127, 1128, 1129,  138,  139, 1131,
     3   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141,
     4   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151,
     5   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     6   1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171,
     7   1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181,
     8   1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191,
     9   1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201/
            data (jb1(i),i= 1201, 1300)/
     +   1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211,
     1   1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221,
     2   1222, 1223, 1224, 1225, 1226,  140,  137, 1228, 1229, 1230,
     3   1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240,
     4   1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250,
     5   1251, 1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260,
     6   1261, 1262, 1263, 1264, 1265, 1266, 1267, 1268, 1269, 1270,
     7   1271, 1272, 1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280,
     8   1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290,
     9   1291, 1292, 1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300/
            data (jb1(i),i= 1301, 1400)/
     +   1301, 1302, 1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310,
     1   1311, 1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320,
     2   1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330,
     3   1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340,
     4   1341, 1342, 1343, 1344, 1345, 1346, 1347, 1349, 1350, 1351,
     5   1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361,
     6   1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371,
     7   1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381,
     8   1382, 1383, 1384, 1348, 1061,    1, 1387, 1386, 1389, 1390,
     9   1391, 1392, 1393, 1394, 1387, 1395, 1396, 1397, 1398, 1399/
            data (jb1(i),i= 1401, 1500)/
     +   1400, 1401, 1402, 1403, 1389, 1389, 1405, 1406, 1407, 1387,
     1   1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 1386,
     2   1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428,
     3   1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438,
     4   1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447, 1448,
     5   1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458,
     6   1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468,
     7   1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478,
     8   1479, 1418, 1418, 1481, 1482, 1483, 1484, 1485, 1486, 1487,
     9   1488, 1489, 1490, 1408, 1492, 1493, 1494, 1495, 1496, 1497/
            data (jb1(i),i= 1501, 1600)/
     +   1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507,
     1    132, 1508, 1509, 1510, 1511, 1483,  133, 1513, 1514, 1515,
     2   1516, 1517, 1518, 1519, 1520, 1521, 1522, 1523, 1524, 1525,
     3   1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535,
     4   1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545,
     5   1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555,
     6   1556, 1557, 1558, 1559, 1491, 1408, 1561, 1562, 1563, 1564,
     7   1565, 1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573, 1574,
     8   1575, 1576, 1545, 1568, 1578,  135, 1580, 1581, 1582, 1583,
     9   1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593/
            data (jb1(i),i= 1601, 1700)/
     +   1594, 1579, 1491, 1596, 1597, 1598, 1599, 1600, 1601, 1602,
     1   1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612,
     2   1613, 1614, 1568, 1615, 1616, 1617, 1618, 1619, 1620, 1621,
     3   1622, 1623, 1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631,
     4   1607, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641,
     5   1632, 1638, 1643, 1644, 1579, 1646, 1647, 1648, 1649, 1650,
     6   1651, 1652, 1653,  137, 1655, 1656, 1657, 1658, 1659, 1660,
     7   1661, 1662, 1663, 1664, 1665, 1608, 1667, 1668, 1669, 1670,
     8   1671, 1632, 1673, 1674, 1675, 1676, 1677, 1678, 1667, 1654,
     9   1680, 1681, 1682, 1683, 1684, 1685, 1686, 1687, 1688, 1667/
            data (jb1(i),i= 1701, 1800)/
     +    138, 1690, 1691, 1692, 1673, 1694, 1695, 1696, 1697, 1698,
     1   1699, 1700, 1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708,
     2   1709, 1710, 1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718,
     3   1719, 1720, 1721, 1722, 1723, 1724, 1725, 1726, 1727, 1728,
     4   1729, 1730, 1654, 1694, 1732, 1733, 1734, 1735, 1736, 1737,
     5   1738, 1739, 1740, 1741, 1742, 1743, 1694, 1744, 1745, 1746,
     6   1747, 1748, 1749, 1750, 1751, 1752, 1753, 1754, 1755, 1756,
     7   1757, 1758, 1759, 1760, 1761, 1762, 1763, 1764, 1673, 1765,
     8   1766, 1767, 1768, 1769, 1770, 1771, 1645, 1673, 1773, 1774,
     9   1775, 1776, 1348, 1775,    1,    2,    3,    4,    1,    6/
            data (jb1(i),i= 1801, 1900)/
     +      7,    8,    6,   10,   11,   12,   13,   10,   15,   16,
     1     15,   18,   19,   20,   21,   22,   23,   18,   25,   26,
     2     27,   28,   29,   30,   25,   32,   33,   34,   32,   36,
     3     37,   38,   36,   40,   41,   40,   43,   44,   45,   43,
     4     47,   48,   49,   47,   51,   52,   53,   51,   55,   56,
     5     55,   58,   59,   60,   61,   62,   63,   64,   65,   66,
     6     58,   68,   69,   68,   71,   72,   73,   74,   75,   76,
     7     77,   78,   79,   80,   71,   82,   83,   84,   82,   86,
     8     87,   88,   86,   90,   91,   92,   90,   94,   95,   96,
     9     94,   98,   99,  100,   98,  102,  103,  104,  102,  106/
            data (jb1(i),i= 1901, 2000)/
     +    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     1    106,  118,  119,  120,  118,  122,  123,  124,  125,  122,
     2    127,  128,  129,  127,  131,  132,  131,  134,  135,  134,
     3    137,  138,  139,  140,  137,  142,  143,  144,  142,  146,
     4    147,  148,  146,  150,  151,  152,  150,  154,  155,  156,
     5    157,  154,  159,  160,  161,  162,  159,  164,  165,  166,
     6    167,  164,  169,  170,  171,  172,  173,  169,  175,  176,
     7    177,  175,  179,  180,  181,  182,  183,  184,  185,  179,
     8    187,  188,  189,  187,  191,  192,  193,  194,  195,  196,
     9    197,  198,  191,  200,  201,  202,  200,  204,  205,  206/
            data (jb1(i),i= 2001, 2100)/
     +    207,  204,  209,  210,  211,  212,  213,  209,  215,  216,
     1    215,  218,  219,  220,  218,  222,  223,  222,  225,  226,
     2    227,  225,  229,  230,  231,  232,  229,  234,  235,  236,
     3    234,  238,  239,  240,  238,  242,  243,  244,  242,  246,
     4    247,  248,  249,  246,  251,  252,  253,  254,  251,  256,
     5    257,  258,  256,  260,  261,  260,  263,  264,  265,  266,
     6    267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
     7    277,  278,  279,  280,  281,  282,  283,  284,  285,  286,
     8    287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
     9    297,  298,  263,  300,  301,  302,  303,  304,  305,  306/
            data (jb1(i),i= 2101, 2200)/
     +    307,  308,  300,  310,  311,  312,  310,  314,  315,  316,
     1    317,  318,  319,  314,  321,  322,  323,  324,  325,  326,
     2    327,  328,  321,  330,  331,  330,  333,  334,  333,  336,
     3    337,  336,  339,  340,  341,  342,  339,  344,  345,  346,
     4    344,  348,  349,  348,  351,  352,  353,  351,  355,  356,
     5    357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
     6    367,  368,  369,  370,  371,  372,  373,  374,  375,  376,
     7    377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
     8    387,  388,  389,  355,  391,  392,  393,  394,  395,  396,
     9    397,  398,  399,  400,  401,  402,  403,  404,  405,  406/
            data (jb1(i),i= 2201, 2300)/
     +    407,  408,  409,  391,  411,  412,  413,  414,  415,  411,
     1    417,  418,  417,  420,  421,  422,  420,  424,  425,  424,
     2    427,  428,  427,  430,  431,  432,  433,  430,  435,  436,
     3    435,  438,  439,  438,  441,  442,  443,  441,  445,  446,
     4    447,  445,  449,  450,  451,  452,  453,  454,  455,  456,
     5    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     6    467,  468,  469,  470,  471,  472,  473,  474,  475,  476,
     7    477,  478,  479,  480,  481,  482,  483,  484,  485,  486,
     8    487,  488,  449,  490,  491,  492,  490,  494,  495,  496,
     9    497,  498,  494,  500,  501,  502,  500,  504,  505,  506/
            data (jb1(i),i= 2301, 2400)/
     +    507,  504,  509,  510,  511,  512,  509,  514,  515,  516,
     1    517,  518,  519,  514,  521,  522,  523,  524,  521,  526,
     2    527,  528,  529,  526,  531,  532,  533,  534,  531,  536,
     3    537,  538,  536,  540,  541,  542,  540,  544,  545,  544,
     4    547,  548,  549,  547,  551,  552,  553,  554,  551,  556,
     5    557,  558,  559,  556,  561,  562,  563,  564,  565,  566,
     6    567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
     7    577,  578,  579,  580,  581,  582,  583,  584,  585,  586,
     8    587,  588,  589,  590,  591,  561,  593,  594,  595,  596,
     9    597,  593,  599,  600,  601,  599,  603,  604,  605,  603/
            data (jb1(i),i= 2401, 2500)/
     +    607,  608,  609,  610,  607,  612,  613,  614,  615,  612,
     1    617,  618,  619,  620,  621,  622,  623,  617,  625,  626,
     2    627,  625,  629,  630,  631,  632,  629,  634,  635,  636,
     3    637,  638,  634,  640,  641,  642,  643,  640,  645,  646,
     4    647,  648,  649,  650,  651,  652,  653,  654,  655,  656,
     5    657,  658,  659,  660,  661,  662,  663,  664,  665,  666,
     6    667,  668,  669,  670,  671,  672,  673,  674,  675,  676,
     7    677,  678,  679,  680,  681,  682,  683,  684,  685,  686,
     8    687,  688,  689,  690,  691,  692,  693,  694,  695,  696,
     9    697,  698,  699,  700,  701,  702,  703,  704,  705,  706/
            data (jb1(i),i= 2501, 2600)/
     +    707,  708,  709,  710,  711,  712,  713,  645,  715,  716,
     1    715,  718,  719,  720,  721,  722,  723,  724,  725,  718,
     2    727,  728,  729,  730,  731,  732,  733,  734,  735,  736,
     3    737,  738,  739,  727,  741,  742,  743,  744,  745,  741,
     4    747,  748,  749,  750,  751,  752,  753,  747,  755,  756,
     5    757,  755,  759,  760,  761,  759,  763,  764,  763,  766,
     6    767,  768,  766,  770,  771,  772,  770,  774,  775,  776,
     7    777,  778,  774,  780,  781,  782,  783,  784,  780,  786,
     8    787,  788,  786,  790,  791,  792,  790,  794,  795,  796,
     9    794,  798,  799,  800,  801,  802,  803,  804,  798,  806/
            data (jb1(i),i= 2601, 2700)/
     +    807,  808,  809,  810,  806,  812,  813,  814,  812,  816,
     1    817,  818,  816,  820,  821,  822,  820,  824,  825,  824,
     2    827,  828,  829,  830,  827,  832,  833,  832,  835,  836,
     3    837,  835,  839,  840,  841,  842,  843,  839,  845,  846,
     4    847,  845,  849,  850,  851,  849,  853,  854,  855,  853,
     5    857,  858,  859,  860,  861,  857,  863,  864,  865,  866,
     6    867,  868,  869,  870,  871,  863,  873,  874,  875,  876,
     7    873,  878,  879,  880,  881,  882,  878,  884,  885,  886,
     8    884,  888,  889,  890,  888,  892,  893,  894,  892,  896,
     9    897,  896,  899,  900,  901,  899,  903,  904,  905,  906/
            data (jb1(i),i= 2701, 2760)/
     +    907,  908,  909,  910,  911,  912,  913,  914,  903,  916,
     1    917,  918,  919,  920,  921,  922,  923,  916,  925,  926,
     2    925,  928,  929,  928,  931,  932,  933,  934,  935,  936,
     3    937,  938,  939,  940,  941,  942,  943,  944,  945,  946,
     4    931,  948,  949,  950,  951,  952,  953,  954,  955,  956,
     5    957,  948,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
     1     14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
     2     24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
     3     34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
     4     44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
     5     54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
     6     64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
     7     74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
     8     84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
     9     94,   95,   96,   97,   98,   99,  100,  101,  102,  103/
            data (jb2(i),i=  101,  200)/
     +    104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
     1    114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
     2    124,  125,  126,  127,  128,  129,  130,  131,  142,  143,
     3    144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
     4    154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
     5    164,  165,  166,  167,  168,  169,  170,  171,  172,  173,
     6    174,  175,  176,  177,  178,  179,  180,  181,  182,  183,
     7    184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
     8    194,  195,  196,  197,  198,  199,  200,  201,  202,  203,
     9    204,  205,  206,  207,  207,  208,  209,  210,  211,  212/
            data (jb2(i),i=  201,  300)/
     +    213,  214,  215,  216,  217,  217,  218,  219,  220,  221,
     1    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     2    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     3    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     4    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     5    262,  263,  264,  265,  266,  267,  268,  269,  270,  270,
     6    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     7    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     8    291,  292,  293,  294,  295,  296,  297,  298,  298,  299,
     9    300,  301,  302,  303,  304,  305,  306,  307,  308,  309/
            data (jb2(i),i=  301,  400)/
     +    310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
     1    320,  321,  322,  323,  324,  325,  326,  327,  328,  329,
     2    330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
     3    340,  341,  342,  343,  344,  345,  346,  346,  347,  348,
     4    349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
     5    359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
     6    369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
     7    379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
     8    389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
     9    399,  400,  401,  402,  403,  404,  405,  406,  407,  408/
            data (jb2(i),i=  401,  500)/
     +    409,  410,  411,  412,  413,  414,  415,  416,  417,  418,
     1    419,  420,  421,  422,  423,  424,  425,  426,  427,  428,
     2    429,  430,  431,  432,  433,  434,  435,  436,  437,  438,
     3    439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
     4    449,  450,  451,  452,  453,  454,  455,  456,  457,  458,
     5    459,  460,  461,  462,  463,  464,  465,  466,  467,  468,
     6    469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
     7    479,  480,  481,  482,  483,  484,  485,  486,  487,  488,
     8    489,  490,  491,  492,  493,  494,  495,  496,  497,  498,
     9    499,  500,  501,  502,  503,  504,  505,  506,  507,  508/
            data (jb2(i),i=  501,  600)/
     +    509,  510,  510,  511,  512,  513,  514,  515,  516,  517,
     1    518,  519,  520,  521,  522,  523,  524,  525,  526,  527,
     2    528,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     3    537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
     4    547,  548,  549,  550,  551,  552,  553,  554,  555,  556,
     5    557,  558,  559,  560,  561,  562,  563,  564,  565,  566,
     6    567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
     7    577,  578,  579,  580,  581,  582,  583,  584,  585,  586,
     8    587,  588,  589,  590,  591,  592,  593,  594,  595,  596,
     9    597,  598,  599,  600,  601,  602,  603,  604,  605,  606/
            data (jb2(i),i=  601,  700)/
     +    607,  608,  609,  610,  611,  612,  613,  614,  615,  616,
     1    617,  618,  619,  620,  621,  622,  623,  624,  625,  626,
     2    627,  628,  629,  630,  631,  632,  633,  634,  635,  636,
     3    637,  638,  639,  640,  641,  642,  643,  644,  645,  646,
     4    647,  648,  649,  650,  651,  652,  653,  654,  655,  656,
     5    657,  658,  659,  660,  661,  662,  663,  664,  665,  666,
     6    667,  668,  669,  670,  671,  672,  673,  674,  675,  676,
     7    677,  678,  679,  680,  681,  682,  683,  684,  685,  686,
     8    687,  688,  689,  690,  691,  692,  693,  694,  695,  696,
     9    697,  698,  699,  700,  701,  702,  703,  704,  705,  706/
            data (jb2(i),i=  701,  800)/
     +    707,  708,  709,  710,  711,  712,  713,  714,  715,  716,
     1    717,  718,  719,  720,  721,  722,  723,  724,  725,  726,
     2    727,  728,  729,  730,  731,  731,  732,  733,  734,  735,
     3    736,  737,  738,  739,  740,  741,  742,  743,  744,  745,
     4    746,  747,  748,  749,  750,  751,  752,  753,  754,  755,
     5    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     6    766,  767,  768,  769,  770,  771,  772,  773,  774,  775,
     7    776,  777,  778,  779,  780,  781,  782,  783,  784,  785,
     8    786,  787,  788,  789,  790,  791,  792,  793,  794,  795,
     9    796,  797,  798,  799,  800,  801,  802,  803,  804,  805/
            data (jb2(i),i=  801,  900)/
     +    806,  807,  808,  809,  810,  811,  812,  813,  814,  815,
     1    816,  817,  818,  819,  820,  821,  822,  822,  823,  824,
     2    825,  826,  827,  828,  829,  830,  831,  832,  833,  834,
     3    835,  836,  837,  838,  839,  840,  841,  842,  843,  844,
     4    845,  846,  847,  848,  849,  850,  851,  852,  853,  854,
     5    855,  856,  857,  858,  859,  860,  861,  862,  863,  864,
     6    865,  866,  867,  868,  869,  870,  871,  872,  873,  874,
     7    875,  876,  877,  878,  879,  880,  881,  882,  883,  884,
     8    885,  886,  887,  888,  889,  890,  891,  892,  893,  894,
     9    895,  896,  897,  898,  899,  900,  901,  902,  903,  904/
            data (jb2(i),i=  901, 1000)/
     +    905,  906,  907,  908,  909,  910,  911,  912,  913,  914,
     1    915,  916,  917,  918,  919,  920,  921,  922,  923,  924,
     2    925,  926,  927,  928,  929,  930,  931,  932,  933,  934,
     3    934,  935,  936,  937,  938,  939,  940,  941,  942,  943,
     4    944,  945,  946,  947,  948,  949,  950,  951,  952,  953,
     5    954,  955,  956,  957,  958,  959,  960,  961,  962,  963,
     6    964,  965,  966,  967,  968,  969,  970,  971,  972,  973,
     7    974,  975,  976,  977,  978,  979,  980,  981,  982,  983,
     8    984,  985,  986,  987,  988,  989,  990,  991,  992,  993,
     9    994,  995,  996,  997,  998,  999, 1000, 1001, 1002, 1003/
            data (jb2(i),i= 1001, 1100)/
     +   1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013,
     1   1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023,
     2   1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033,
     3   1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043,
     4   1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053,
     5   1054, 1055, 1056, 1057, 1058, 1059, 1060, 1060, 1062, 1063,
     6   1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073,
     7   1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083,
     8   1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093,
     9   1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103/
            data (jb2(i),i= 1101, 1200)/
     +   1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113,
     1   1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123,
     2   1124, 1125, 1126, 1127, 1128, 1129, 1130, 1130, 1131, 1132,
     3   1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142,
     4   1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151, 1152,
     5   1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162,
     6   1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172,
     7   1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182,
     8   1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191, 1192,
     9   1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202/
            data (jb2(i),i= 1201, 1300)/
     +   1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212,
     1   1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222,
     2   1223, 1224, 1225, 1226, 1227, 1227, 1228, 1229, 1230, 1231,
     3   1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240, 1241,
     4   1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251,
     5   1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261,
     6   1262, 1263, 1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271,
     7   1272, 1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281,
     8   1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291,
     9   1292, 1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301/
            data (jb2(i),i= 1301, 1400)/
     +   1302, 1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311,
     1   1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321,
     2   1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331,
     3   1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341,
     4   1342, 1343, 1344, 1345, 1346, 1347, 1348, 1350, 1351, 1352,
     5   1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362,
     6   1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372,
     7   1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382,
     8   1383, 1384, 1385, 1385, 1349, 1386, 1388, 1388, 1390, 1391,
     9   1392, 1393, 1394,    2, 1395, 1396, 1397, 1398, 1399, 1400/
            data (jb2(i),i= 1401, 1500)/
     +   1401, 1402, 1403, 1404, 1404, 1405, 1406, 1407, 1408, 1409,
     1   1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419,
     2   1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428, 1429,
     3   1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439,
     4   1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447, 1448, 1449,
     5   1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458, 1459,
     6   1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469,
     7   1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478, 1479,
     8   1480, 1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488,
     9   1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498/
            data (jb2(i),i= 1501, 1600)/
     +   1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507,  132,
     1   1508, 1509, 1510, 1511, 1512, 1512, 1513, 1514, 1515, 1516,
     2   1517, 1518, 1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526,
     3   1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536,
     4   1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546,
     5   1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556,
     6   1557, 1558, 1559, 1560, 1560, 1561, 1562, 1563, 1564, 1565,
     7   1566, 1567,  134, 1569, 1570, 1571, 1572, 1573, 1574, 1575,
     8   1576, 1577, 1577, 1578, 1579, 1580, 1581, 1582, 1583, 1584,
     9   1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594/
            data (jb2(i),i= 1601, 1700)/
     +   1595, 1595, 1596, 1597, 1598, 1599, 1600, 1601, 1602, 1603,
     1   1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612, 1613,
     2   1614,  136, 1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622,
     3   1623, 1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631, 1632,
     4   1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641, 1642,
     5   1642, 1643, 1644, 1645, 1646, 1647, 1648, 1649, 1650, 1651,
     6   1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661,
     7   1662, 1663, 1664, 1665, 1666, 1666, 1668, 1669, 1670, 1671,
     8   1672, 1672, 1674, 1675, 1676, 1677, 1678, 1679, 1679, 1680,
     9   1681, 1682, 1683, 1684, 1685, 1686, 1687, 1688, 1689, 1689/
            data (jb2(i),i= 1701, 1800)/
     +   1690, 1691, 1692, 1693, 1693, 1695, 1696, 1697, 1698, 1699,
     1   1700, 1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709,
     2   1710, 1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719,
     3   1720, 1721, 1722, 1723, 1724, 1725, 1726, 1727, 1728, 1729,
     4   1730, 1731, 1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738,
     5   1739, 1740, 1741, 1742, 1743,  139, 1744, 1745, 1746, 1747,
     6   1748, 1749, 1750, 1751, 1752, 1753, 1754, 1755, 1756, 1757,
     7   1758, 1759, 1760, 1761, 1762, 1763, 1764,  140, 1765, 1766,
     8   1767, 1768, 1769, 1770, 1771, 1772, 1772, 1773, 1774, 1061,
     9   1776, 1777, 1777, 1349,    2,    3,    4,    5,    5,    7/
            data (jb2(i),i= 1801, 1900)/
     +      8,    9,    9,   11,   12,   13,   14,   14,   16,   17,
     1     17,   19,   20,   21,   22,   23,   24,   24,   26,   27,
     2     28,   29,   30,   31,   31,   33,   34,   35,   35,   37,
     3     38,   39,   39,   41,   42,   42,   44,   45,   46,   46,
     4     48,   49,   50,   50,   52,   53,   54,   54,   56,   57,
     5     57,   59,   60,   61,   62,   63,   64,   65,   66,   67,
     6     67,   69,   70,   70,   72,   73,   74,   75,   76,   77,
     7     78,   79,   80,   81,   81,   83,   84,   85,   85,   87,
     8     88,   89,   89,   91,   92,   93,   93,   95,   96,   97,
     9     97,   99,  100,  101,  101,  103,  104,  105,  105,  107/
            data (jb2(i),i= 1901, 2000)/
     +    108,  109,  110,  111,  112,  113,  114,  115,  116,  117,
     1    117,  119,  120,  121,  121,  123,  124,  125,  126,  126,
     2    128,  129,  130,  130,  132,  133,  133,  135,  136,  136,
     3    138,  139,  140,  141,  141,  143,  144,  145,  145,  147,
     4    148,  149,  149,  151,  152,  153,  153,  155,  156,  157,
     5    158,  158,  160,  161,  162,  163,  163,  165,  166,  167,
     6    168,  168,  170,  171,  172,  173,  174,  174,  176,  177,
     7    178,  178,  180,  181,  182,  183,  184,  185,  186,  186,
     8    188,  189,  190,  190,  192,  193,  194,  195,  196,  197,
     9    198,  199,  199,  201,  202,  203,  203,  205,  206,  207/
            data (jb2(i),i= 2001, 2100)/
     +    208,  208,  210,  211,  212,  213,  214,  214,  216,  217,
     1    217,  219,  220,  221,  221,  223,  224,  224,  226,  227,
     2    228,  228,  230,  231,  232,  233,  233,  235,  236,  237,
     3    237,  239,  240,  241,  241,  243,  244,  245,  245,  247,
     4    248,  249,  250,  250,  252,  253,  254,  255,  255,  257,
     5    258,  259,  259,  261,  262,  262,  264,  265,  266,  267,
     6    268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
     7    278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
     8    288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
     9    298,  299,  299,  301,  302,  303,  304,  305,  306,  307/
            data (jb2(i),i= 2101, 2200)/
     +    308,  309,  309,  311,  312,  313,  313,  315,  316,  317,
     1    318,  319,  320,  320,  322,  323,  324,  325,  326,  327,
     2    328,  329,  329,  331,  332,  332,  334,  335,  335,  337,
     3    338,  338,  340,  341,  342,  343,  343,  345,  346,  347,
     4    347,  349,  350,  350,  352,  353,  354,  354,  356,  357,
     5    358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
     6    368,  369,  370,  371,  372,  373,  374,  375,  376,  377,
     7    378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
     8    388,  389,  390,  390,  392,  393,  394,  395,  396,  397,
     9    398,  399,  400,  401,  402,  403,  404,  405,  406,  407/
            data (jb2(i),i= 2201, 2300)/
     +    408,  409,  410,  410,  412,  413,  414,  415,  416,  416,
     1    418,  419,  419,  421,  422,  423,  423,  425,  426,  426,
     2    428,  429,  429,  431,  432,  433,  434,  434,  436,  437,
     3    437,  439,  440,  440,  442,  443,  444,  444,  446,  447,
     4    448,  448,  450,  451,  452,  453,  454,  455,  456,  457,
     5    458,  459,  460,  461,  462,  463,  464,  465,  466,  467,
     6    468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
     7    478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
     8    488,  489,  489,  491,  492,  493,  493,  495,  496,  497,
     9    498,  499,  499,  501,  502,  503,  503,  505,  506,  507/
            data (jb2(i),i= 2301, 2400)/
     +    508,  508,  510,  511,  512,  513,  513,  515,  516,  517,
     1    518,  519,  520,  520,  522,  523,  524,  525,  525,  527,
     2    528,  529,  530,  530,  532,  533,  534,  535,  535,  537,
     3    538,  539,  539,  541,  542,  543,  543,  545,  546,  546,
     4    548,  549,  550,  550,  552,  553,  554,  555,  555,  557,
     5    558,  559,  560,  560,  562,  563,  564,  565,  566,  567,
     6    568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
     7    578,  579,  580,  581,  582,  583,  584,  585,  586,  587,
     8    588,  589,  590,  591,  592,  592,  594,  595,  596,  597,
     9    598,  598,  600,  601,  602,  602,  604,  605,  606,  606/
            data (jb2(i),i= 2401, 2500)/
     +    608,  609,  610,  611,  611,  613,  614,  615,  616,  616,
     1    618,  619,  620,  621,  622,  623,  624,  624,  626,  627,
     2    628,  628,  630,  631,  632,  633,  633,  635,  636,  637,
     3    638,  639,  639,  641,  642,  643,  644,  644,  646,  647,
     4    648,  649,  650,  651,  652,  653,  654,  655,  656,  657,
     5    658,  659,  660,  661,  662,  663,  664,  665,  666,  667,
     6    668,  669,  670,  671,  672,  673,  674,  675,  676,  677,
     7    678,  679,  680,  681,  682,  683,  684,  685,  686,  687,
     8    688,  689,  690,  691,  692,  693,  694,  695,  696,  697,
     9    698,  699,  700,  701,  702,  703,  704,  705,  706,  707/
            data (jb2(i),i= 2501, 2600)/
     +    708,  709,  710,  711,  712,  713,  714,  714,  716,  717,
     1    717,  719,  720,  721,  722,  723,  724,  725,  726,  726,
     2    728,  729,  730,  731,  732,  733,  734,  735,  736,  737,
     3    738,  739,  740,  740,  742,  743,  744,  745,  746,  746,
     4    748,  749,  750,  751,  752,  753,  754,  754,  756,  757,
     5    758,  758,  760,  761,  762,  762,  764,  765,  765,  767,
     6    768,  769,  769,  771,  772,  773,  773,  775,  776,  777,
     7    778,  779,  779,  781,  782,  783,  784,  785,  785,  787,
     8    788,  789,  789,  791,  792,  793,  793,  795,  796,  797,
     9    797,  799,  800,  801,  802,  803,  804,  805,  805,  807/
            data (jb2(i),i= 2601, 2700)/
     +    808,  809,  810,  811,  811,  813,  814,  815,  815,  817,
     1    818,  819,  819,  821,  822,  823,  823,  825,  826,  826,
     2    828,  829,  830,  831,  831,  833,  834,  834,  836,  837,
     3    838,  838,  840,  841,  842,  843,  844,  844,  846,  847,
     4    848,  848,  850,  851,  852,  852,  854,  855,  856,  856,
     5    858,  859,  860,  861,  862,  862,  864,  865,  866,  867,
     6    868,  869,  870,  871,  872,  872,  874,  875,  876,  877,
     7    877,  879,  880,  881,  882,  883,  883,  885,  886,  887,
     8    887,  889,  890,  891,  891,  893,  894,  895,  895,  897,
     9    898,  898,  900,  901,  902,  902,  904,  905,  906,  907/
            data (jb2(i),i= 2701, 2760)/
     +    908,  909,  910,  911,  912,  913,  914,  915,  915,  917,
     1    918,  919,  920,  921,  922,  923,  924,  924,  926,  927,
     2    927,  929,  930,  930,  932,  933,  934,  935,  936,  937,
     3    938,  939,  940,  941,  942,  943,  944,  945,  946,  947,
     4    947,  949,  950,  951,  952,  953,  954,  955,  956,  957,
     5    958,  958,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ml(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(3470) :: jx,jy
            integer(kind=iknd), save, dimension(3490) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'maryland      '/
            data jrot,ipart/1,3/
            data kv/   1,1498,3060,3463,   0/
            data kb/   1,1517,3087,3490,   0/
            data iib/1212,1432, 403,   0,   0/
            data (jx(i),i=    1,  100)/
     +  18720,26088,18264,19896,17904,22440,19008,19056,19536,19848,
     1  20208,20400,20976,21000,21672,21744,21960,22104,22536,22584,
     2  23232,23280,23160,23112,23184,23400,23616,23472,23832,23976,
     3  24480,24600,24696,25008,25032,25512,25272,25320,25200,25320,
     4  25272,24984,25128,25464,25488,25416,25464,25464,25848,25968,
     5  26136,25920,25824,25632,25536,25488,25200,24576,24312,24192,
     6  23832,23904,24168,24144,24360,24456,24480,24360,24312,24600,
     7  24816,24912,25104,25176,25176,25296,25752,25800,25896,25920,
     8  26040,26112,26328,26352,26568,26688,26976,26880,26640,26184,
     9  25992,25992,25920,25848,25464,25296,25248,25296,25152,25128/
            data (jx(i),i=  101,  200)/
     +  18816,28080,28056,28344,28296,28320,28176,28152,27936,27840,
     1  27864,28104,28536,28680,28728,28656,28488,28512,28728,28920,
     2  28872,28656,28728,28512,28440,28296,28152,28128,28320,28296,
     3  28200,28128,27744,27528,27408,27336,27288,27216,27216,26904,
     4  27000,26976,27024,27192,27312,27288,27504,27864,27912,28008,
     5  28032,27816,27648,27456,27480,27216,27336,27312,27120,27048,
     6  27000,27048,26928,26976,26904,26832,26784,26784,26688,26688,
     7  26616,26592,26760,26664,26832,26904,26832,26856,27024,26952,
     8  26760,26664,26544,26616,26544,26592,26808,26784,26952,26928,
     9  26832,26832,26760,26712,26592,26544,26424,26448,26424,26256/
            data (jx(i),i=  201,  300)/
     +  26280,26160,26088,26136,26256,26376,26376,25920,25536,25608,
     1  25536,25536,25680,25512,25440,25320,25416,25416,25272,18936,
     2  27696,27600,27504,27408,28056,27912,27888,27504,27456,27504,
     3  27768,28080,27768,27744,27672,27672,27360,27336,27192,27216,
     4  27360,28200,27936,28032,28152,28344,28344,28440,28656,28752,
     5  28752,28608,28560,28632,28536,28632,28560,28584,28824,28944,
     6  29208,29328,29640,29544,29232,29304,29232,29040,33768,28944,
     7  29088,29280,29472,29760,29832,29760,29688,29424,29592,29856,
     8  29952,29976,29856,29880,29736,29640,29496,29448,29640,29832,
     9  30000,30096,30144,30024,30072,30192,30288,30240,30288,30384/
            data (jx(i),i=  301,  400)/
     +  30360,30432,30384,30600,30528,30168,30168,30600,30816,31104,
     1  31536,31320,31128,31032,30888,30864,30912,31152,31104,31200,
     2  31104,31200,31080,31104,30840,30720,30840,31104,31176,31344,
     3  31344,31512,31488,31656,31464,31584,31824,31848,31752,31776,
     4  31992,32496,32640,32760,32352,32328,32592,32376,32352,32544,
     5  32712,32664,32472,32544,32640,32784,33024,32928,32880,34320,
     6  34392,34368,34656,34776,35064,35064,34944,34776,34800,34920,
     7  35040,35208,35808,36072,36168,36288,38328,38232,38208,38064,
     8  38232,38304,38280,38112,38040,37824,37776,37728,37680,37344,
     9  37272,37152,36936,36648,36384,32736,32280,32112,31920,31872/
            data (jx(i),i=  401,  500)/
     +  31608,31440,31440,31248,31248,31176,31248,31176,31080,31104,
     1  31272,31368,31536,31536,31752,31776,31944,32064,32088,31992,
     2  32160,32424,32424,32544,33264,33312,33264,33696,33552,33648,
     3  33888,34176,34152,34392,34464,34464,34296,34008,33936,33888,
     4  34032,34056,33816,33816,33648,33696,33432,33408,33528,33312,
     5  33504,33432,33240,33312,33216,33264,33408,33480,33768,33816,
     6  33624,33600,33840,33792,34032,33984,34032,33912,33960,34128,
     7  34056,34176,34344,34320,34800,35112,34800,34728,34608,34728,
     8  34536,34536,34728,34824,34920,35016,34872,34848,35064,35280,
     9  35232,35280,35832,35976,35832,35880,35856,35736,35688,35472/
            data (jx(i),i=  501,  600)/
     +  35472,35640,35664,35424,35616,35688,36072,36312,36528,36480,
     1  36816,36864,36816,36960,36960,36768,36936,37320,37752,37800,
     2  37800,38016,38160,38568,44136,44088,44208,44448,44640,45096,
     3  45120,45168,45312,45504,45600,45624,45816,46056,46032,46224,
     4  46296,46272,46344,46272,46272,46008,45936,45648,45624,45864,
     5  45840,45456,45504,45264,45000,45048,45216,45048,45000,44760,
     6  44544,44304,44160,43536,43104,42888,42504,42432,42216,42048,
     7  42048,42384,42552,42768,42912,42960,43080,43200,43368,43464,
     8  43728,43704,43752,43272,43104,43032,42936,42840,42936,42864,
     9  42888,42720,42792,42936,43056,43056,43104,43248,43392,43464/
            data (jx(i),i=  601,  700)/
     +  43944,44112,44352,44568,44520,44280,44040,43752,43536,43224,
     1  43080,42480,42336,42192,41688,41592,41352,41280,41064,40968,
     2  40944,41184,41088,40848,40800,40848,40728,40512,40224,40032,
     3  40056,40416,40488,40680,40656,40536,40320,39912,39864,39864,
     4  39720,39384,38880,38544,38376,41232,41208,41304,41256,40752,
     5  40608,40416,40008,39672,39096,39096,38976,38880,38760,38640,
     6  42192,41880,41880,41784,41616,41520,41328,44976,44832,44688,
     7  44760,44736,44592,44424,44328,44232,43824,43728,43632,43560,
     8  43368,43368,43656,43776,43968,44136,44280,44232,43944,43872,
     9  43752,43968,43680,43464,43344,43392,43368,43224,42984,42648/
            data (jx(i),i=  701,  800)/
     +  42672,42960,43128,42912,42816,42840,42312,41904,41616,41328,
     1  40896,40824,40872,40800,40368,39840,39528,38976,38856,38736,
     2  38616,38472,45432,45264,39216,39840,41424,41736,42168,42504,
     3  42816,42984,43200,43968,44208,44328,44568,44784,45600,45456,
     4  45288,45264,45144,45264,45288,45576,45648,42240,42336,42456,
     5  42528,42504,42672,42744,42720,43056,43104,43224,43440,43680,
     6  43920,44136,44232,44328,44448,44376,44472,44736,44952,45000,
     7  44928,44976,45120,45120,45288,45408,45264,45528,45552,45456,
     8  45648,45888,45960,46032,46152,46128,45912,45840,45936,45696,
     9  46008,46056,46200,46416,46872,47640,48288,48864,49152,49344/
            data (jx(i),i=  801,  900)/
     +  49272,48912,48888,49368,49416,49656,49704,49488,49536,49776,
     1  50184,50544,50880,50952,50904,50640,50592,50616,50304,50040,
     2  49848,49824,49584,49560,49392,49176,49104,49296,49344,49152,
     3  49632,49680,49272,49032,48912,48816,48744,48720,48768,48600,
     4  48576,48480,48432,48504,48336,48192,48096,47664,47448,47496,
     5  47640,47808,48096,48048,48216,48312,48408,48648,48672,48528,
     6  48672,48888,49128,49152,49032,49008,48960,48768,48648,48672,
     7  48456,48456,48360,48456,48888,49104,49080,48984,49032,48600,
     8  48168,47736,47280,47280,47088,47112,46920,46800,46800,46752,
     9  46560,46512,46392,46296,46176,46200,46056,46056,46224,46248/
            data (jx(i),i=  901, 1000)/
     +  46320,46608,46608,46440,46584,46368,46632,46680,46944,47136,
     1  47160,46968,46896,46656,46368,46032,45888,45552,45624,45792,
     2  46008,46128,46272,46368,46488,46560,46656,46464,46632,46704,
     3  46920,46920,46992,46920,47112,47160,47304,47184,47040,46896,
     4  46776,46680,46512,46344,45888,45816,45744,45768,45720,45504,
     5  45168,45144,45000,45000,44808,44832,44784,44712,44712,44808,
     6  44472,17568,21144,21144,27312,27384,27240,27216,27000,26832,
     7  26328,26136,25992,25872,25704,25608,25536,25656,25656,25224,
     8  25008,25032,24984,24648,24528,24528,24048,24072,23904,24096,
     9  23832,23544,23568,23736,23784,23544,23520,23280,23304,23088/
            data (jx(i),i= 1001, 1100)/
     +  22920,22728,22752,22680,22512,22464,22560,20184,20280,19920,
     1  19488,19296,19224,19152,18864,18840,19176,19464,20040,20616,
     2  20736,20760,20616,20616,20736,20952,21024,20928,20688,20568,
     3  20448,20376,20448,20688,20808,20760,20520,20472,20712,20808,
     4  20952,21192,21360,21480,21528,21624,21768,21984,22344,22416,
     5  22416,22344,22128,22128,22200,22344,22656,22752,22944,22752,
     6  22800,22896,23112,23184,23472,23496,23784,23880,24024,24144,
     7  24600,24888,24984,25416,25800,25944,26184,20616,21000,21240,
     8  21456,21576,21600,21552,21672,21624,21768,21816,21960,21888,
     9  22032,21984,22056,21912,21720,21672,21480,21432,21432,21672/
            data (jx(i),i= 1101, 1200)/
     +  21600,21408,21408,21528,21528,21360,21264,21048,20784,20712,
     1  20712,20952,20856,20688,20376,20184,20088,20064,20136,20352,
     2  20400,20304,20136,19992,20040,19824,19800,22584,22416,22416,
     3  22656,22752,23088,23256,23208,23064,22968,22824,22704,22512,
     4  22392,22344,22392,22344,22128,21888,21840,21696,21720,21432,
     5  21216,20952,20928,21024,21000,20856,20640,20544,20352,20160,
     6  20160,19800,19632,19584,19416,19416,19728,19872,19944,19824,
     7  19896,20040,20136,20184,20160,20232,20352,20592,20688,20712,
     8  20616,26328,26496,26592,26496,26520,26640,26856,27360,27648,
     9  28056,28464,28752,28944,29112,29640,29808,30000,30264,30984/
            data (jx(i),i= 1201, 1300)/
     +  31200,31248,31488,31800,31896,32016,32520,32712,32856,33072,
     1  33120,33216,18960,19224,19344,19416,19440,19560,20112,20376,
     2  20328,20472,20592,20712,21384,22056,22272,22824,22968,23160,
     3  23424,23904,24168,24600,25152,25800,18360,18360,18504,18672,
     4  18792,18816,18888,18960,19104,19056,19080,19368,19416,19584,
     5  19656,25032,24816,24648,24264,24120,24000,23640,23640,23400,
     6  23184,23136,23136,23064,22992,22752,22752,22320,22056,21552,
     7  21360,20976,25776,25560,25368,24888,24576,23760,23496,23160,
     8  22872,22848,22608,22560,22368,22320,22104,21960,21792,21504,
     9  21528,21336,21312,21048,21192,21048,20856,20832,20688,20616/
            data (jx(i),i= 1301, 1400)/
     +  20496,20328,20280,20496,20472,20400,20280,20184,19920,19800,
     1  19656,19320,19272,19056,25872,23208,23400,23544,23928,24024,
     2  24144,24360,24504,24648,24864,25176,25368,25608,25800,25920,
     3  25848,25944,25776,25776,25704,25704,25872,25848,25680,25728,
     4  25512,25608,25848,28152,27384,25584,25632,28416,28416,28320,
     5  28272,28416,28440,28560,26112,26256,26304,26544,26544,26664,
     6  26616,26640,26832,26976,27528,27648,27672,28224,28272,28392,
     7  28728,28944,25992,26160,26568,26928,27336,27384,27456,27456,
     8  27720,27984,28008,28392,28584,28848,28944,29088,29184,29208,
     9  29304,29376,29472,29664,29808,29928,29952,30072,29952,30144/
            data (jx(i),i= 1401, 1500)/
     +  30168,30072,28944,29016,29112,29208,29184,29472,30192,30240,
     1  30240,30336,30528,30600,30384,30096,30720,30840,30984,31272,
     2  31416,31728,31728,31848,31992,32184,32256,32520,32688,32736,
     3  32952,33192,33504,33888,34008,34104,34440,34536,34704,34800,
     4  35328,35400,35688,36048,36144,36168,36504,36672,36768,36912,
     5  37056,37344,37440,33120,32616,34608,37968,37944,37776,37104,
     6  37056,37104,37296,37296,37632,37680,37872,38136,38280,39768,
     7  39528,39480,39192,39048,38976,39120,39144,39024,39048,39864,
     8  40320,40560,40584,40992,43944,43824,43752,43560,43440,42504,
     9  41904,41856,41832,41928,42144,42192,45048,36072,36288,36504/
            data (jx(i),i= 1501, 1600)/
     +  36816,36768,36792,36984,37104,37344,37656,37728,37920,38160,
     1  38496,38568,38592,39072,39408,39552,39600,39744,40176,40296,
     2  40488,40536,40704,40632,40464,40464,40344,40248,40176,39936,
     3  39984,40272,40512,40152,40080,40008,39936,39936,40008,39984,
     4  39936,39768,40080,39792,39600,39504,39264,39240,39168,39192,
     5  39432,39576,39672,39600,39648,39336,39216,39216,39144,39048,
     6  38856,38760,38640,38616,38808,38904,39120,39120,39048,38928,
     7  38640,38592,38424,38424,38592,38520,38592,38448,38328,38280,
     8  38352,38280,38376,38376,38136,38160,38088,37968,37776,37824,
     9  37992,37872,37800,37752,37704,37656,37608,37608,37392,37296/
            data (jx(i),i= 1601, 1700)/
     +  37272,37176,37296,37248,37584,37680,37632,37680,37824,37944,
     1  38040,38160,38304,38304,38232,37800,37752,38112,38160,38160,
     2  38424,38616,38688,38880,38976,39000,38904,38496,38400,38472,
     3  38424,38280,38184,38208,38520,38016,37968,37968,37920,37776,
     4  37704,37776,38064,37800,37944,37560,37488,37512,37416,37152,
     5  37008,36888,36984,37176,37104,36768,36504,36456,36504,36768,
     6  37056,37368,37536,37416,37440,37320,37368,37464,37608,37728,
     7  37752,37632,37632,37728,37920,38208,38232,38016,37992,38136,
     8  38088,37800,37536,37392,37128,36936,36480,36360,36432,36360,
     9  36408,36576,36768,36864,36840,36672,36696,37032,37080,36984/
            data (jx(i),i= 1701, 1800)/
     +  37128,37536,37656,37752,37704,37800,37896,38016,38112,38688,
     1  38760,38760,38544,39000,36144,36264,36264,36456,36720,37008,
     2  36984,37224,37392,37776,37848,37992,38232,38352,38400,38472,
     3  38808,38976,38952,38688,38280,38088,37968,37800,37800,37392,
     4  37152,36960,36912,36912,36792,36048,35976,35928,35712,35304,
     5  35496,35688,35760,35976,35880,36144,36072,36288,36432,36504,
     6  36624,36720,36936,37032,37296,37296,37008,36816,36864,36744,
     7  36696,36576,36552,36456,36288,36216,36192,36408,36336,36336,
     8  36600,36624,36936,36936,36600,36600,36960,36744,36600,36600,
     9  36480,36312,36240,36216,36360,36264,36216,35928,35832,35712/
            data (jx(i),i= 1801, 1900)/
     +  35784,35544,35520,35448,35544,35376,35448,35328,35256,35232,
     1  35112,35016,35208,35280,35184,34944,34896,34992,34896,34872,
     2  34704,34656,34776,34704,34176,33816,33744,33768,33984,34656,
     3  34392,34416,34272,34056,33936,33576,33456,33240,33288,33432,
     4  33648,33792,33936,34080,34584,34752,34920,35352,35448,35448,
     5  34800,34728,34680,34104,34152,34536,34512,34728,34008,33960,
     6  33984,33936,33864,33768,33720,33840,33576,33528,33552,33480,
     7  33408,33144,33192,33144,33240,33192,33336,32760,32760,32880,
     8  32856,32616,32448,32400,32664,32280,32112,32016,32016,32112,
     9  31824,31728,31704,31536,31536,31776,31944,31560,31584,31392/
            data (jx(i),i= 1901, 2000)/
     +  31272,31272,31176,31128,31272,31224,31368,31224,31248,31512,
     1  31464,31272,31080,31008,30936,31056,31056,31008,30888,30888,
     2  30624,30120,29880,29832,29736,30000,29808,29664,29592,29640,
     3  29592,29448,29232,28944,28728,28512,28248,28152,28248,28128,
     4  28104,27984,28032,28104,28152,28320,28344,28584,28896,29040,
     5  29376,29592,29688,29784,29880,30000,30120,30144,30432,30552,
     6  30528,30360,30336,30624,30672,30840,30840,30768,30480,30336,
     7  30192,29952,29856,29712,29664,29712,29448,29400,29496,29520,
     8  29688,29904,30000,30144,30192,29832,29304,29496,29544,29520,
     9  29688,29688,29952,29952,30240,30360,30312,30360,30480,30480/
            data (jx(i),i= 2001, 2100)/
     +  30552,30672,30912,30960,30744,30552,30576,30456,30480,30576,
     1  30672,30864,30984,31320,31608,31584,31176,31104,31800,31752,
     2  31848,32112,32472,32472,32328,32328,32472,32376,32088,31872,
     3  31800,30816,30504,30480,30264,29952,29736,29712,29808,29976,
     4  29904,29376,28008,27600,27672,27888,28008,28248,27984,28008,
     5  27912,27864,27600,27456,27384,27432,27216,27144,27144,27336,
     6  27600,27648,27504,27288,27096,27048,27144,27048,26928,26928,
     7  26640,26424,26400,26448,26688,26664,26496,26472,26640,26568,
     8  26712,26664,26544,26424,26328,26304,26112,26040,25920,25656,
     9  25680,25800,25824,25872,25944,26112,26160,26064,25752,25776/
            data (jx(i),i= 2101, 2200)/
     +  25824,26016,26040,26136,26064,25848,25776,25728,25872,26064,
     1  25800,25848,26064,26232,26160,25824,25848,25944,25992,25848,
     2  25848,25944,25968,25752,25704,25704,25656,28152,25680,25608,
     3  25608,25656,25608,25656,25584,25368,25296,25248,25440,25416,
     4  25512,25440,25464,25560,25608,25584,25416,25416,25272,25200,
     5  24888,24888,25008,25008,24888,24864,24816,24528,24408,23952,
     6  23952,24048,24168,24000,23904,23736,23808,23784,23904,23712,
     7  23808,23856,24144,24168,24288,24264,24216,24144,24024,23928,
     8  23928,23688,23712,23472,23544,23520,23280,23160,22992,23040,
     9  22992,22848,22704,22680,22608,22392,22200,22200,21984,22032/
            data (jx(i),i= 2201, 2300)/
     +  21720,21624,21576,21672,21696,21768,21936,22080,22248,22968,
     1  22992,22896,22944,22944,23040,23064,23184,23496,23688,23712,
     2  24048,24120,24072,23976,23784,23448,23016,22752,22704,22656,
     3  22512,22488,22272,22128,22080,22128,21720,21504,21624,21936,
     4  21960,22056,22272,22488,22536,22368,22344,21984,22128,22104,
     5  22152,22248,22344,22344,22272,21840,21600,21456,20976,20376,
     6  20088,19752,19344,19200,19056,19104,20496,46584,46464,46176,
     7  45984,45792,45888,45768,45624,45672,45624,45312,45264,44976,
     8  44856,44880,44784,44736,44568,44520,44712,44664,44616,44400,
     9  44304,44184,44592,44760,44952,45072,45072,44928,44832,44664/
            data (jx(i),i= 2301, 2400)/
     +  44520,44496,44832,44808,43872,43608,43200,42408,42360,42432,
     1  42288,42264,42336,42288,42096,42072,42144,42312,42696,43008,
     2  43176,43080,42864,42768,42240,42408,42408,42264,42048,41952,
     3  41760,41784,42024,42024,41712,41712,41880,41880,41832,41496,
     4  41520,41808,41808,42048,42144,42096,42048,41976,41928,41688,
     5  41760,41496,41400,41376,41544,41568,41520,41616,41352,41256,
     6  41184,41256,41208,40968,40800,40728,40704,40608,40680,40968,
     7  41016,40968,40656,40632,40896,40800,40728,40656,41088,41376,
     8  41136,41112,40872,40560,40920,40968,41376,41400,41208,40776,
     9  40944,41352,41616,41496,41208,41040,40968,41016,40944,40800/
            data (jx(i),i= 2401, 2500)/
     +  40728,40632,40704,40848,40656,40560,40392,40272,40272,40104,
     1  39792,39696,39648,39696,39960,40104,40128,40032,39816,39792,
     2  39864,39888,40104,40056,40080,40200,39744,39792,39864,39888,
     3  40032,40152,40248,40344,40296,40416,40416,40296,40272,40608,
     4  40872,40656,40584,40464,40464,40656,40656,40824,40920,41088,
     5  40968,40992,40800,40776,40680,40680,40608,40440,40344,40320,
     6  40200,40080,40008,39768,39816,39792,39744,39624,39552,39360,
     7  30096,39696,41112,43032,42984,43032,43320,43392,43464,43536,
     8  43560,43872,44112,44256,44328,44400,44664,44784,44928,44928,
     9  44640,44832,44952,45216,45480,45768,46032,46056,46176,46176/
            data (jx(i),i= 2501, 2600)/
     +  46344,46512,46608,46584,46320,46248,46896,46968,47208,47304,
     1  47256,47112,47088,46992,46920,46776,46680,46536,46368,46392,
     2  46224,46128,45984,45888,45792,45696,45552,45528,45432,45144,
     3  45072,45024,44760,44736,44544,44592,44784,44928,45048,45648,
     4  45864,45888,45960,46056,46368,46488,46536,46704,47064,47184,
     5  47664,47640,47496,47448,47496,46920,46944,46824,46800,46632,
     6  46512,46416,46464,46296,46344,46296,46176,46056,46104,46272,
     7  46488,46488,43248,43224,43344,43632,43704,43728,43824,44016,
     8  44280,44496,44496,44592,44664,44808,45096,45432,45552,45984,
     9  46104,46200,46512,46632,46752,46848,47088,47160,47376,47352/
            data (jx(i),i= 2601, 2700)/
     +  47256,47112,46896,46680,46680,46944,47016,47016,46824,46824,
     1  46752,46776,51864,43248,43320,43632,43680,43536,43368,43320,
     2  43464,43512,43584,43632,43584,43728,43752,43848,43992,44040,
     3  44304,44328,44304,44160,44136,44160,43992,44016,43920,43992,
     4  43656,43752,43968,43968,44016,44160,44064,44064,44328,44544,
     5  44712,44592,44616,44808,44784,44928,45024,45096,45216,45120,
     6  45264,45168,45048,45048,45192,45600,46200,46272,46584,46848,
     7  47040,47424,47424,47808,47856,47688,47400,47304,46920,46728,
     8  46680,46824,46920,46728,46656,46728,47016,47184,47280,47280,
     9  47352,47568,47568,47808,47832,48048,48168,48192,48264,48288/
            data (jx(i),i= 2701, 2800)/
     +  48480,48624,48864,49344,49440,49728,49800,49896,49824,49656,
     1  49728,49824,49824,49704,49680,50088,50064,50328,50304,50400,
     2  50448,50640,51000,51168,51192,51048,51408,51480,43080,52056,
     3  52200,52200,52320,52488,52488,52248,52248,52128,52008,51888,
     4  51888,51912,52152,52440,52392,52104,52056,51984,52248,52224,
     5  52416,52512,52272,52248,52560,52608,52584,52824,52752,52968,
     6  53040,52848,52872,52968,52968,53136,53160,53088,52848,52416,
     7  52416,52560,52728,52608,52608,52512,52392,52296,52296,52440,
     8  52440,51960,51840,51720,51744,51936,52104,52128,52056,52200,
     9  52200,52152,51456,51504,51456,51288,51288,51192,51216,51096/
            data (jx(i),i= 2801, 2900)/
     +  51048,50976,50952,51216,51168,51264,51024,51048,50880,50928,
     1  50808,50880,50832,50928,50856,50664,50328,50304,50232,50184,
     2  50112,50040,50136,50064,49968,49944,49824,49800,50016,50040,
     3  50304,50352,50496,50496,50376,50328,50424,50376,50592,50280,
     4  50280,50184,50256,50232,49992,49968,49872,49584,49704,49800,
     5  49872,49608,49584,49320,49296,49176,49248,49248,49152,49248,
     6  49152,49320,49152,49152,49056,48984,48984,49080,49056,48984,
     7  48792,48840,48744,48648,48576,48984,48960,48744,48672,48816,
     8  48768,48960,48960,48744,49008,48984,49128,49080,48960,48840,
     9  49032,49056,48888,48864,48936,49080,49152,49272,49272,49176/
            data (jx(i),i= 2901, 3000)/
     +  49176,49272,49200,48984,48552,48240,48120,48144,48000,47904,
     1  47928,48072,47856,47952,47544,47568,47736,47688,47496,47400,
     2  47328,47376,47328,47448,47304,47208,47136,46968,46848,35880,
     3  35736,35664,35496,35280,35184,35064,35064,34920,34824,34632,
     4  34560,34512,34344,33816,33888,33936,28152,28128,27984,28056,
     5  28056,27840,27912,28152,28224,28128,25560,25680,25680,25584,
     6  30240,30288,30768,31104,31392,31728,32256,32712,33216,33312,
     7  33384,33552,33864,34104,42936,42696,42504,42432,42240,42048,
     8  41760,41592,41520,41328,41160,39192,39120,38760,38832,38952,
     9  38928,38592,38424,38472,38640,38592,38496,38712,38712,38928/
            data (jx(i),i= 3001, 3100)/
     +  38832,46512,47184,47520,47640,47832,47904,48384,48624,48864,
     1  49104,49248,49464,49920,50088,50160,50112,50376,50496,50448,
     2  50328,50400,50688,50784,50904,50784,51048,51168,51384,51336,
     3  51576,51600,43752,43968,44160,44592,44712,44760,45120,45504,
     4  45552,45720,45792,46248,46632,46368,46320,46464,46416,46464,
     5  46752,46752,46704,46584,46224,46104,46272,46296,46464,27984,
     6  28032,28272,28248,27960,51312,51264,51144,50880,50640,49464,
     7  48048,47088,46680,46512,45936,45720,45744,45888,46344,46416,
     8  46656,47064,47256,47424,47928,48336,48384,48696,48720,48840,
     9  49056,49296,49416,49800,50040,50040,50088,50208,50352,50568/
            data (jx(i),i= 3101, 3200)/
     +  50424,50472,50640,50784,51120,51192,43296,44088,44832,45432,
     1  45624,45696,45408,44688,44520,44328,44232,44064,43824,43440,
     2  43296,50328,50352,50304,50184,50280,50328,50208,50208,50328,
     3  50328,51000,51072,50952,51000,50760,50664,50904,53160,53232,
     4  53304,53328,53208,53136,53064,53352,53328,53376,53424,52608,
     5  52632,52440,52344,52200,52128,52008,51936,52296,52464,52488,
     6  51888,51936,52008,52104,52128,52248,52248,52104,52104,51840,
     7  51624,51744,52584,52584,52200,52248,52584,52536,52440,52464,
     8  51984,51648,51576,51600,51504,51192,50952,50904,50952,51192,
     9  51648,51840,51936,51960,52104,49896,49680,49680,49752,49800/
            data (jx(i),i= 3201, 3300)/
     +  49920,49944,50208,50160,50304,50280,49992,49536,49584,49560,
     1  49464,49368,49368,49488,49536,49488,49416,49344,49368,49560,
     2  49584,49536,49680,49704,49656,49440,49368,49272,49320,49200,
     3  49296,49224,49152,49488,49440,49272,49176,49368,49488,49560,
     4  49464,49296,49152,49176,49464,49560,48072,48120,48216,48408,
     5  48432,48600,48768,48696,48528,48456,48552,48600,48864,48936,
     6  48624,48504,48528,48336,48264,48144,47976,47832,47760,47736,
     7  47952,48024,48168,48168,48024,46416,46704,47088,47064,47184,
     8  47136,47280,47304,47184,47064,46968,46800,46560,46440,46368,
     9  46224,46224,46152,46080,46176,46128,46272,46608,46512,46488/
            data (jx(i),i= 3301, 3400)/
     +  46560,46656,46680,45672,45600,45528,45696,45552,45816,45840,
     1  45624,45192,45216,45384,45384,45192,45144,45240,45360,45480,
     2  45744,45912,45960,45744,45480,45384,45360,45432,45504,45480,
     3  41712,41856,41592,41592,41784,41976,42120,42024,37320,37152,
     4  36984,36912,37152,37296,37440,37320,37512,37536,37464,34656,
     5  34848,34992,34992,35232,35280,35136,35040,34992,34944,34848,
     6  34920,34848,34920,34824,34728,34608,34656,34608,34512,34392,
     7  34296,34464,34512,27312,27264,27120,27192,27384,23784,23952,
     8  24144,24432,24360,24288,23664,23640,23736,23688,22512,22416,
     9  22464,22536,22656,22704,32736,32400,32088,31992,31968,32208/
            data (jx(i),i= 3401, 3470)/
     +  32832,32952,33024,33504,33816,34344,34896,35472,35712,35328,
     1  35304,35088,35160,35064,34680,34704,34656,34512,34152,34128,
     2  34224,34152,34368,34392,34320,33816,33720,33528,33504,33600,
     3  33360,33360,33480,33336,33456,34080,34272,34464,34464,33984,
     4  33840,33816,33696,33672,33816,34200,34176,34128,33984,33864,
     5  33648,33672,33576,33504,33528,33408,33408,33144,33048,33144,
     6  33000,32904,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  36888,33600,24072,24240,15720,13296,50040,54840,55008,55392,
     1  55512,55848,56016,56112,56568,56568,56880,56976,57144,56976,
     2  56664,56568,56472,56400,56376,56400,56592,56712,56904,56832,
     3  56856,56808,56568,56136,55968,55704,55608,55464,55272,55104,
     4  55032,54936,54888,54936,55056,55200,55224,55584,55392,55152,
     5  54984,54816,54648,54576,54600,54720,54720,55056,54864,54888,
     6  55056,54864,54528,54360,54120,54144,54216,54312,54576,54624,
     7  54576,54408,54432,54384,54240,54312,54144,54240,54240,54336,
     8  54312,54432,54480,54360,54384,54216,54072,53904,54000,53856,
     9  53904,53688,53568,53832,53832,53664,53472,53424,53232,53016/
            data (jy(i),i=  101,  200)/
     +  40584,50472,50736,50712,50808,50952,50976,51120,51168,51336,
     1  51360,51336,50952,50976,51072,51360,51384,51696,51648,51720,
     2  51816,51864,52008,52200,52368,52368,52416,52368,52224,52032,
     3  51960,51792,51576,51600,51552,51480,51288,51240,51144,51024,
     4  51360,51528,51576,51504,51720,51912,51816,51888,52056,52152,
     5  52320,52320,52440,52416,52536,52680,52200,52176,52392,52368,
     6  52320,52200,52104,51984,51936,51984,51960,51816,51840,51984,
     7  51984,52056,52224,52416,52392,52488,52584,52680,52704,52872,
     8  52872,52584,52608,52896,52992,53088,53136,53280,53304,53376,
     9  53376,53568,53616,53496,53400,53208,53184,53112,52872,52800/
            data (jy(i),i=  201,  300)/
     +  53016,52968,53064,53160,53160,53376,53448,53256,53304,53136,
     1  53040,52896,52752,52632,52296,52320,52584,52800,52968,46824,
     2  49320,49608,49584,49368,49224,49152,49056,49056,49104,49128,
     3  49200,50376,50304,50136,50088,49872,49824,49584,49416,49344,
     4  49296,36792,49440,49728,49872,49944,49776,49800,49656,49752,
     5  50376,50448,50424,50280,50232,50016,49920,49872,49848,49968,
     6  49848,49680,49488,49440,49608,49416,49320,49752,41616,50352,
     7  50424,50640,50616,50184,50160,50592,50664,50760,50856,50664,
     8  50664,50736,50832,50928,50904,51096,51168,51336,51312,51480,
     9  51768,51768,51648,51432,51336,51552,51552,51192,51120,51144/
            data (jy(i),i=  301,  400)/
     +  51312,51480,51648,51672,51768,51840,51936,51864,52008,52104,
     1  51936,51768,51744,51816,51744,51528,51384,51384,51264,51096,
     2  51000,50928,50760,50664,50688,50472,50424,50448,50616,50616,
     3  50760,50832,50976,50976,51144,51504,51408,51480,51672,51912,
     4  52176,52488,52152,52008,52152,52104,51912,51840,51696,51792,
     5  51744,51624,51456,51360,51408,51600,51576,51432,51168,42072,
     6  42264,42480,42840,42912,43008,43056,43080,43704,43776,43704,
     7  43248,43080,42984,43056,42960,42960,42168,42336,42576,42648,
     8  42792,43176,43296,43152,42816,43032,43032,42936,42912,43008,
     9  43296,43104,42936,42912,43080,51096,50664,50640,50448,50328/
            data (jy(i),i=  401,  500)/
     +  50304,50208,50040,49992,49824,49752,49680,49536,49488,49248,
     1  49464,49728,49728,49920,49968,49776,49800,49752,49848,49920,
     2  50400,50472,50616,50736,51024,51168,51264,51336,51504,51648,
     3  51432,51432,51336,51480,51480,51384,51216,51168,51096,51024,
     4  50880,50808,50712,50592,50592,50424,50544,50496,50328,50256,
     5  50136,49824,49752,49680,49488,49368,49416,49680,49680,49800,
     6  49896,50112,50088,50256,50160,50232,50328,50400,50448,50448,
     7  50544,50736,50760,50952,50952,50640,50592,50664,50496,50424,
     8  50328,50280,50256,50136,50112,50160,50328,50472,50520,50448,
     9  50304,50256,50064,50088,50184,50376,50496,50496,50424,50472/
            data (jy(i),i=  501,  600)/
     +  50616,50616,50736,50856,50880,50952,50880,50712,50640,50400,
     1  50328,50256,50136,50064,49896,49896,49824,49992,50040,50112,
     2  50400,50448,50376,47808,45240,44760,44640,44832,45240,45216,
     3  45024,45024,45264,45432,45408,45336,45480,45408,45600,45720,
     4  45720,45480,45384,45072,44904,44640,44280,44376,44424,44640,
     5  44736,44496,44280,44064,44088,43992,43896,43728,43488,43560,
     6  43464,43488,43464,43176,43056,42840,42840,42912,43008,42960,
     7  42912,42792,42600,42576,42408,42600,42600,42408,42288,42024,
     8  41904,41712,41568,41688,41616,41640,41832,41808,41592,41328,
     9  41136,41112,41040,41016,41280,41448,41472,41376,41376,41280/
            data (jy(i),i=  601,  700)/
     +  41256,41064,40680,40032,39936,39768,39408,39384,39264,39408,
     1  39288,39240,39120,39216,39312,39432,39480,39720,40008,40032,
     2  39960,39672,39648,39744,39936,40296,40584,40848,41400,41400,
     3  41208,40728,40512,40344,40224,40248,40464,40584,40656,41208,
     4  41448,41664,41664,41736,41904,47616,47760,47928,48024,48048,
     5  47976,48072,48072,47832,47880,47760,47712,47736,47856,47760,
     6  47952,47976,47904,47904,48000,47976,47712,51120,51072,51168,
     7  51000,50976,50952,50832,50856,50952,50952,51000,50880,50928,
     8  50904,50856,50784,50832,50760,50784,50616,50568,50520,50448,
     9  50184,49896,49944,49392,49296,49224,49176,49200,49368,49296/
            data (jy(i),i=  701,  800)/
     +  49200,49200,49104,48960,48720,48600,48552,48240,48432,48264,
     1  48456,48456,48264,48192,48264,48216,47976,48048,47904,48000,
     2  47976,47880,51144,51048,50352,50592,50496,50544,50736,50808,
     3  51072,51336,51384,52104,52248,52440,52344,52392,51816,51504,
     4  51648,51528,51504,51408,51264,51360,51288,48072,48072,47928,
     5  48000,48120,48264,48240,48120,48264,48456,48456,48744,48744,
     6  49176,49416,49440,49776,49800,49968,50208,50520,50664,50520,
     7  50328,50256,50280,50520,50424,50496,50712,50688,50784,50952,
     8  50952,51168,51072,51072,51528,51672,51792,51936,52152,52128,
     9  52560,52584,52392,52272,52248,52512,52848,53280,53304,53160/
            data (jy(i),i=  801,  900)/
     +  52992,52872,52800,52752,52848,52776,52800,53016,53088,53136,
     1  53064,53280,53352,53304,53232,53112,53040,52776,52728,52464,
     2  52464,52248,52128,52008,52224,52224,52152,52104,52032,51936,
     3  51864,51816,51696,51552,51624,51528,51552,51672,51768,51888,
     4  52056,52032,51696,51528,51480,51624,51624,51360,51024,50976,
     5  51024,51288,51312,51480,51408,51240,51192,51336,51144,50976,
     6  50976,51144,51168,51120,51048,50856,50784,50760,50640,50544,
     7  50592,50400,50256,50256,50616,50664,50568,50472,50184,50040,
     8  49968,49536,48744,48528,48192,47904,47952,48168,48456,48528,
     9  48576,48720,48696,48744,48672,48576,48456,48408,48408,48504/
            data (jy(i),i=  901, 1000)/
     +  48480,48192,48024,47976,47832,47784,47712,47640,47688,47496,
     1  47376,47424,47352,47568,47616,47592,47400,47328,47280,47328,
     2  47256,47376,47352,47256,47352,47352,47280,47040,47064,47208,
     3  47208,47016,46896,46752,46800,46968,46824,46536,46560,46512,
     4  46392,46152,46128,46176,46008,46056,45984,45840,45792,45840,
     5  45744,45672,45768,45960,45984,46128,46176,46104,45864,45648,
     6  45648, 7464, 7296, 7224, 6840, 7080, 7176, 7392, 7776, 7848,
     7   8328, 8544, 8904, 9048, 9048, 9240, 9528, 9648, 9816,10008,
     8  10224,10320,10392,10440,10824,11016,11304,11544,11568,11808,
     9  11760,11904,12024,12024,12072,12168,12336,12408,12624,12552/
            data (jy(i),i= 1001, 1100)/
     +  12720,12672,12792,12864,12744,12768,13008,24816,25104,25296,
     1  25776,25680,25704,26112,26376,26616,27576,27984,28488,28824,
     2  28968,29328,29520,29688,29736,29736,29880,29952,29976,29952,
     3  29856,29928,30048,30216,30624,30768,30696,30768,31392,31488,
     4  31512,31512,31416,31296,30720,30672,30744,30960,30936,31032,
     5  31152,31272,31368,31512,31560,31512,31224,31296,31872,32184,
     6  32400,32376,31920,31920,32208,31920,32112,31848,31968,32496,
     7  32736,32784,32568,32640,32424,32568,33264,18240,18360,18792,
     8  19008,19320,19488,19824,20112,20304,20328,20520,20712,21336,
     9  21648,21864,22056,22200,22224,22344,22224,22248,22392,22584/
            data (jy(i),i= 1101, 1200)/
     +  22632,22584,22680,22776,22872,22824,22728,22392,22296,22392,
     1  22560,23064,23232,23208,22800,22704,22728,22824,23064,23352,
     2  23496,23568,23472,23496,23832,23808,23856,13416,13512,13608,
     3  13752,14064,14472,14832,14904,14832,14928,14880,15096,15144,
     4  15264,15336,15480,15528,15672,15720,15888,15888,16152,16224,
     5  16488,16584,16704,16920,17040,17088,16896,16896,17088,17160,
     6  17328,17328,17400,17592,17760,17856,17640,17664,17832,18120,
     7  18216,18312,18216,18072,17832,17712,17688,17808,17904,18096,
     8  18144,33936,34368,34752,35184,35256,35328,35352,35664,36384,
     9  36816,36576,36504,36072,35904,35760,35760,35856,36336,36768/
            data (jy(i),i= 1201, 1300)/
     +  37824,38496,39120,39456,39720,39840,39744,39816,39960,40584,
     1  41136,41280,36648,36480,36312,36312,36456,36480,36144,35904,
     2  35712,35568,35304,35256,35088,34848,34680,34512,34608,34512,
     3  34584,34320,34248,34224,34032,33672,24120,24240,24216,24456,
     4  24432,24480,24408,24456,24384,24168,24096,24192,23784,24072,
     5  24024,52872,52872,52728,52728,52632,52608,52296,52176,51960,
     6  52032,52008,51888,51792,51504,51168,50928,50520,50496,50304,
     7  50136,50040,41112,41136,41280,41424,41448,41928,41880,42072,
     8  41784,41688,41616,41448,41400,41184,41136,41160,40920,40728,
     9  40464,40320,40200,39960,39840,39744,39720,39264,39216,39288/
            data (jy(i),i= 1301, 1400)/
     +  39144,39168,39216,39408,39648,39624,39720,39696,39840,40128,
     1  40248,40152,40560,40464,40896,45552,45576,45408,45240,45456,
     2  45264,45144,45168,45408,45336,45336,45192,45264,45432,45336,
     3  45000,44880,44544,44184,44040,43800,43368,43176,42864,42720,
     4  42216,41760,41352,49176,47808,47832,50496,48984,48864,48768,
     5  48480,48264,48024,47928,45408,45384,45600,45720,46176,46296,
     6  46392,46584,46608,46824,46632,46728,46848,47328,47640,47808,
     7  49656,50160,40848,40896,41112,41496,41592,41784,41880,42024,
     8  42552,42648,42816,43104,43320,43344,43440,43392,43416,43536,
     9  43512,43560,43896,43872,44232,44184,44112,44256,44568,44784/
            data (jy(i),i= 1401, 1500)/
     +  44928,45144,47760,47640,47616,47400,47232,46920,46560,46440,
     1  46200,46056,46008,45864,45384,45216,45888,46032,45912,45888,
     2  46272,46536,46704,46848,47160,47232,47232,47496,47544,47712,
     3  47856,47784,47904,47952,48072,47976,48264,48264,48168,48240,
     4  47928,47952,47808,47856,47784,47640,47640,47736,47592,47592,
     5  47760,47784,47976,43296,42816,44736,50208,49008,48912,48912,
     6  48816,48384,48216,48000,47976,47856,47856,47736,47832,42552,
     7  42720,42864,43008,43416,43824,44328,44712,45072,45336,46992,
     8  47088,47064,47112,47112,45456,45480,45576,45672,45840,46272,
     9  46608,46680,47064,47520,47640,47736,51336,59664,59616,59208/
            data (jy(i),i= 1501, 1600)/
     +  58920,58848,58728,58584,58392,58200,58176,57960,57912,58176,
     1  58200,58248,58488,58776,58704,58512,58320,58224,58344,58176,
     2  58152,57888,57696,57648,57744,57816,57864,57816,57888,57744,
     3  57672,57696,57456,57024,57000,57096,57048,56928,56784,56760,
     4  56832,56712,56568,56496,56640,56832,56880,56784,56808,56688,
     5  56424,56448,56400,56160,55968,55920,56064,56232,56304,56712,
     6  56712,56856,56880,56784,56424,56376,55776,55704,55584,55536,
     7  55584,55728,55752,55872,55992,56280,56376,56424,56232,56304,
     8  56472,56520,56592,56664,56688,56184,56208,56232,56568,56616,
     9  56616,56976,56976,56904,56712,56736,56712,56544,56640,56712/
            data (jy(i),i= 1601, 1700)/
     +  56832,56856,56496,56304,56352,56256,56136,56112,56160,55968,
     1  55920,55992,55872,55752,55680,55848,55800,55608,55536,55368,
     2  55464,55344,55176,55152,55224,55152,55032,54936,55104,55176,
     3  55224,55200,55152,54864,54792,54624,54648,54744,54768,54648,
     4  54696,54912,54960,55104,55272,55392,55224,54984,54840,54936,
     5  54792,54744,54672,54672,54504,54480,54624,54552,54480,54336,
     6  54336,54528,54240,54120,54024,53928,53904,53880,53976,53976,
     7  54192,54312,54384,54360,54144,54192,54120,54000,53880,53784,
     8  53736,53784,53688,53688,54024,54168,54288,54312,54072,53904,
     9  53880,54048,54096,54072,53880,53784,53736,53784,53688,53592/
            data (jy(i),i= 1701, 1800)/
     +  53424,53544,53376,53400,53520,53544,53472,53304,53280,53400,
     1  53376,53280,53208,53088,59712,59712,59832,59760,59208,58992,
     2  58776,58464,58320,58320,58104,58152,58392,58320,58368,58608,
     3  58776,58968,53016,52968,53112,53088,53160,53136,53064,53064,
     4  53280,53208,53256,53376,53448,53664,53736,54048,54048,54504,
     5  54480,54264,54312,54312,54456,54672,54768,54984,55032,54936,
     6  55056,54984,55080,55200,55704,55800,55968,56232,56376,56448,
     7  56640,56616,56496,56496,56664,56640,56544,56376,56328,56256,
     8  56256,55992,55848,55728,55800,55680,55560,55416,55416,55344,
     9  55368,55632,55632,55536,55272,55248,55344,55392,55560,55536/
            data (jy(i),i= 1801, 1900)/
     +  55296,55344,55584,55776,55920,55944,56040,56088,56040,55872,
     1  55896,56376,56424,56544,56640,56520,56568,56736,56904,57072,
     2  57096,57048,56928,56688,56640,56808,56808,56664,56544,56496,
     3  56232,55920,55992,55944,56040,56064,55920,55896,55800,55752,
     4  55872,55824,55680,55776,55656,55584,55320,55272,55200,55152,
     5  55296,55320,55512,55512,55440,55368,55248,55176,55224,55176,
     6  55080,55056,55200,55200,55032,54912,54768,54792,54936,54912,
     7  54696,54696,54840,54912,55008,55152,55224,55680,55776,55824,
     8  55920,56112,56136,56040,55872,55848,55992,56016,55944,55728,
     9  55704,55584,55704,55752,55800,55800,56256,55944,56208,55992/
            data (jy(i),i= 1901, 2000)/
     +  56088,56160,56088,56160,56304,56400,56568,56640,56832,57048,
     1  57096,57072,56856,56880,56760,56568,56424,56328,56256,56544,
     2  56664,57264,57240,57288,57672,57600,57816,58176,58152,57864,
     3  57744,57792,57768,57432,57744,57888,58224,58584,59184,59304,
     4  58896,58680,58512,58464,58152,57936,57792,57648,57288,57240,
     5  57600,57552,57384,57000,56976,57048,57000,56640,56616,56520,
     6  56472,56424,56376,56160,55944,55872,55800,55776,55848,56088,
     7  56184,56256,56160,56184,56256,56400,56520,56496,56376,56184,
     8  56040,56016,56088,56016,55800,55680,55800,55608,55488,55416,
     9  55392,55488,55464,55560,55680,55584,55488,55464,55584,55680/
            data (jy(i),i= 2001, 2100)/
     +  55680,55584,55512,55440,55200,55248,55104,55032,54960,54960,
     1  55056,55056,55272,55200,55224,55152,55080,55008,55008,55152,
     2  55224,55152,55416,55344,55200,55104,55056,54912,54672,54768,
     3  54864,54768,54576,54648,54672,54408,54456,54384,54336,54288,
     4  54192,54360,55080,55200,55272,55200,55368,55512,55680,55512,
     5  55464,55368,55416,55344,55368,55536,55560,55608,55704,55800,
     6  55800,55848,56016,55920,55992,55944,55848,55752,55728,55632,
     7  55632,55848,56112,56184,56160,56400,56376,56424,56544,56736,
     8  57120,57120,56952,56544,56568,56376,56328,56472,56568,56640,
     9  56880,57168,57936,57960,57840,57792,57816,58056,58248,58416/
            data (jy(i),i= 2101, 2200)/
     +  58488,58464,58608,58680,58704,58560,58656,58872,59064,59064,
     1  59136,59352,59352,59568,59592,59496,59856,59856,59904,60024,
     2  60264,60384,60504,60408,60456,60672,60696,61872,61752,60672,
     3  60216,59976,59352,59208,59184,59496,59520,59472,59280,59064,
     4  58992,58848,58800,58824,58728,58488,58440,57912,57744,57720,
     5  58128,58200,58272,58416,58416,58272,58248,58344,58512,58752,
     6  58848,58848,59064,59064,58944,59136,59304,59400,59424,59712,
     7  59784,60024,60216,60432,60456,60792,60792,60552,60408,60456,
     8  60312,60216,59976,59784,59616,59376,59472,59904,60024,60048,
     9  60360,60144,60264,60120,60120,60528,60504,60624,60600,60840/
            data (jy(i),i= 2201, 2300)/
     +  60672,60720,60672,60624,60504,60504,60360,60384,60168,59760,
     1  59688,59640,59400,59184,59208,59328,59304,58872,58752,58608,
     2  58368,58200,58152,58152,58344,58296,58608,58632,58800,58848,
     3  58800,58752,58800,58728,58800,58872,59064,59016,58800,58728,
     4  58560,58344,58248,58320,58296,58128,57936,57888,57696,57528,
     5  57528,57696,57696,57408,57216,57072,56808,56736,56304,56112,
     6  55728,55440,55272,55128,55104,61488,61464,55968,55920,56064,
     7  56208,56064,55920,55680,55704,55776,55848,55800,55584,55512,
     8  55440,55320,55272,55104,55128,55056,54984,54816,54792,54888,
     9  54864,54624,54648,54528,54672,54672,54600,54552,54432,54408/
            data (jy(i),i= 2301, 2400)/
     +  54168,54096,54048,54000,53856,53736,53424,53088,53160,53280,
     1  53280,53328,53448,53664,53736,53856,53928,53880,53664,53760,
     2  54096,54120,53904,53904,54144,54240,54336,54360,54192,54360,
     3  54480,54552,54528,54600,54672,54744,54768,54888,54960,54840,
     4  54888,55320,55488,55416,55656,55752,55752,55560,55560,55704,
     5  56112,56064,56232,55944,55968,55896,55536,55368,55008,55056,
     6  55368,55464,55608,55560,55848,55752,55560,55536,55464,55440,
     7  55152,55104,55200,55176,55032,54864,54840,54720,54792,54624,
     8  54648,54528,54600,54528,54432,54384,54456,54384,54264,54264,
     9  54144,54144,54024,53976,54024,53928,53856,53544,53520,53568/
            data (jy(i),i= 2401, 2500)/
     +  53760,53856,53952,54000,54192,54192,54312,54288,54048,54048,
     1  53856,53856,53928,54000,54168,54144,54192,54456,54408,54600,
     2  54768,54648,54672,54816,54984,55056,55560,55728,55752,55632,
     3  55680,55632,55392,55440,55704,55776,55848,55968,56112,56400,
     4  56496,56568,56736,56832,56952,56856,57048,57072,57384,57624,
     5  57768,57936,57960,58152,58176,58584,58608,58512,58584,58704,
     6  58608,58728,58560,58608,58896,59136,59184,58800,58776,58920,
     7  61992,62472,62568,60720,60672,60624,60552,60552,60744,60648,
     8  60480,60432,60312,60480,60216,60144,60024,60048,59928,59880,
     9  59784,59760,59808,59448,59352,59064,59040,58992,58992,59112/
            data (jy(i),i= 2501, 2600)/
     +  58992,58992,58920,58872,58824,58728,58776,58944,58848,58536,
     1  58512,58632,58752,58800,58608,58536,58368,58440,58392,58224,
     2  58176,58032,58032,57840,57816,58200,58488,58680,58704,58704,
     3  58752,58584,58440,58200,58080,58032,58080,57960,58032,57528,
     4  57480,57288,57240,57576,57744,57648,57456,57600,57528,57624,
     5  57696,57624,57528,57432,57264,56976,56688,56640,56760,56976,
     6  56880,56904,56688,56664,56496,56448,56592,56592,56304,56184,
     7  56280,56064,60648,60936,60984,60936,60840,60576,60528,60504,
     8  60744,60480,60264,60264,60360,60336,60072,59952,59784,59616,
     9  59496,59568,59496,59328,59328,59496,59424,59592,59664,59904/
            data (jy(i),i= 2601, 2700)/
     +  59784,59760,59880,59904,60048,60000,60144,60288,60408,60576,
     1  60792,61176,63647,67943,71735,71783,71711,71615,71399,71087,
     2  71231,71231,71111,71135,71351,71399,71471,71471,71639,71543,
     3  71543,71495,71351,71351,71279,71135,71063,70991,70847,70655,
     4  70199,70151,70319,70079,70055,70127,70439,70583,71087,71111,
     5  71063,70847,70799,70847,71087,71063,70559,70535,70703,71015,
     6  71087,71135,71111,71351,71567,71543,71111,71015,70991,70751,
     7  70799,70439,70223,70151,70103,69983,70079,69983,70319,70343,
     8  70247,70223,70079,70055,69983,69935,69983,69647,69623,69359,
     9  69335,69503,69311,69311,69191,69167,69287,69119,69119,69191/
            data (jy(i),i= 2701, 2800)/
     +  69023,69119,68855,68735,68615,68615,68663,68615,68471,68519,
     1  68303,68255,68183,68159,67991,67919,67775,67559,67415,67391,
     2  67631,67679,67559,67655,67511,67391,67319,67367,62663,63503,
     3  63551,63407,63239,63191,63095,62879,62639,62424,62352,62448,
     4  62328,62232,62184,61992,61896,61872,61944,61776,61704,61200,
     5  61032,60816,60816,60744,60576,60600,60720,60672,60552,60504,
     6  60240,60288,59952,59976,60048,60048,59976,59808,59616,59616,
     7  59688,59784,59808,59952,60120,60168,60312,60288,60216,60072,
     8  60000,60048,60168,60144,59928,59880,59760,59712,59712,59616,
     9  59544,59520,59904,60072,60096,60024,59952,60000,60120,60120/
            data (jy(i),i= 2801, 2900)/
     +  59952,60000,60288,60240,60600,60672,60744,60552,60480,60600,
     1  60744,60816,60936,61104,61152,61080,61440,61608,61584,61392,
     2  61416,61488,61632,61824,61728,61584,61632,61464,61224,61080,
     3  61200,60960,60912,60816,60792,60696,60552,60264,59928,59952,
     4  59760,59928,60024,60072,59904,60120,60072,60288,60264,60312,
     5  60552,60552,60480,60432,60600,60744,60744,60840,60936,61032,
     6  61128,61272,61344,61512,61656,61632,61560,61320,61248,61272,
     7  61584,61752,61776,61632,61392,60888,60840,60936,60912,60696,
     8  60552,60480,60408,60264,60264,60024,59904,59856,59880,59784,
     9  59592,59496,59448,59304,59136,59136,59256,59232,59088,59016/
            data (jy(i),i= 2901, 3000)/
     +  58944,58776,58728,58704,58824,58800,59064,59328,59376,59760,
     1  59856,59856,60048,60120,60528,60576,60648,60720,60696,60720,
     2  60672,60576,60384,60240,60120,60144,60312,60504,61104,59328,
     3  59424,59280,59376,59088,59064,59136,58968,59088,59016,59016,
     4  59064,59016,59040,56880,56904,57336,59496,59808,59904,60000,
     5  60120,60288,60600,60912,61224,61656,61488,61272,61128,60960,
     6  61632,61344,60672,60528,60480,60144,59976,59472,59136,59208,
     7  59112,59160,58992,58944,60864,60720,60864,61152,61344,61752,
     8  61800,61920,62232,62448,62472,62040,61896,61680,61560,61512,
     9  61200,61176,60624,60288,60048,59856,59712,59592,59496,59232/
            data (jy(i),i= 3001, 3100)/
     +  59136,63815,63935,64175,64319,64415,64535,64823,64775,64487,
     1  64391,64415,64703,64895,64847,64775,64511,64415,64271,64007,
     2  63863,63767,63719,63503,63455,63167,63095,63167,63383,63479,
     3  63551,63695,68087,68255,68279,68111,68159,68255,68399,68183,
     4  68063,67943,67703,67559,61440,61536,61656,61896,62016,62136,
     5  62256,62544,62615,62592,62807,63143,63383,63551,63671,52680,
     6  52584,52536,52584,52824,68927,69407,69527,69599,69791,70415,
     7  70703,71159,71303,71423,71615,71615,71543,71567,71351,71183,
     8  71207,71039,70871,70847,70559,70487,70295,70223,70127,70223,
     9  70127,70151,70103,69887,69839,69623,69599,69791,69791,69623/
            data (jy(i),i= 3101, 3200)/
     +  69575,69479,69479,69383,69335,69239,72335,72239,71999,71903,
     1  71831,71711,71687,71879,71975,71903,72023,72023,72119,72119,
     2  71999,68591,68471,68447,68591,68687,68639,67919,67991,68063,
     3  67895,67703,67799,67943,68063,68063,67895,67847,59664,59760,
     4  59760,59640,59592,59472,59592,59328,59424,59448,59328,58008,
     5  58104,58176,58056,58056,57984,57960,57888,57840,57936,58032,
     6  57264,57264,57384,57384,57480,57528,57576,57576,57720,57744,
     7  57528,57504,57432,57312,57312,57384,57768,57600,57600,57696,
     8  58008,57888,57600,57432,57240,57288,57408,57768,57984,58032,
     9  58320,58344,58344,58224,58152,57984,57768,57480,57480,57600/
            data (jy(i),i= 3201, 3300)/
     +  57576,57672,57648,57792,57888,58008,58032,57528,57600,57648,
     1  57600,57648,57552,57432,57408,58968,59064,58968,58848,58824,
     2  58920,50952,51024,51072,51120,51024,51096,50736,50712,57144,
     3  57168,57288,57168,56880,56928,56904,56784,56832,56760,56832,
     4  57840,57960,57936,57792,57792,57864,56712,56664,56760,56856,
     5  56688,56760,56712,57000,57072,57264,57336,57168,57288,57648,
     6  57552,57600,57720,57816,57768,57480,57528,57432,57360,57168,
     7  57024,57216,57192,56952,56784,55248,55272,55632,55728,55848,
     8  55968,55944,55968,56232,56232,55800,55512,55512,55440,55536,
     9  55512,55656,55656,55488,55416,55224,55056,45576,45528,45312/
            data (jy(i),i= 3301, 3400)/
     +  45336,45456,45552,55296,55320,55248,55176,54192,54360,54528,
     1  54336,54264,54192,54816,54960,54888,54768,54624,54600,54672,
     2  54672,54792,55032,54840,54864,55536,55320,55320,55440,55536,
     3  53112,53208,53232,53016,53016,53088,53016,52968,52488,52464,
     4  52560,52536,52344,52392,52800,52680,52608,52728,52824,55752,
     5  55752,55560,55488,55488,55560,55800,55728,55776,55944,56016,
     6  56112,56184,56376,56520,56352,56256,56016,55752,54600,54672,
     7  54600,54504,54504,54432,54480,54432,54264,54288,57312,57264,
     8  57432,57120,57096,56976,57000,57048,57168,57264,33024,32904,
     9  32760,32712,32736,33000,53976,53832,53808,53880,53760,53496/
            data (jy(i),i= 3401, 3470)/
     +  53400,53352,53208,52944,52872,52752,52896,52632,52680,52944,
     1  53064,53160,53232,53328,53280,53184,53112,53232,53136,53184,
     2  53280,53376,53376,53424,53496,53568,53280,53208,53304,53568,
     3  53616,53688,53712,53856,53880,53664,53736,53880,53904,53880,
     4  53976,54192,54168,54216,54288,54336,54552,54576,54432,54528,
     5  54528,54360,54288,54288,54408,54432,54504,54552,54504,54408,
     6  54384,54096,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
     1     17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
     2     27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
     3     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     4     47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
     5     57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
     6     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     7     77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
     8     87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     9     97,   98,   99,  102,  103,  104,  105,  106,  107,  108/
            data (jb1(i),i=  101,  200)/
     +    109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
     1    119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
     2    129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
     3    139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
     4    149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
     5    159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
     6    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     7    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     8    189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
     9    199,  200,  201,  202,  203,  204,  205,  206,  207,  208/
            data (jb1(i),i=  201,  300)/
     +    209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
     1    100,  221,  222,  223,  225,  226,  227,  228,  229,  230,
     2    221,  102,  232,  233,  234,  235,  236,  237,  238,  239,
     3    240,  224,  225,  243,  244,  245,  246,  247,  248,  249,
     4    251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
     5    261,  262,  263,  264,  265,  266,  267,  250,  251,  270,
     6    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     7    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     8    291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
     9    301,  302,  303,  304,  305,  306,  307,  308,  309,  310/
            data (jb1(i),i=  301,  400)/
     +    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     1    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     2    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     3    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     4    351,  352,  353,  354,  355,  356,  357,  358,  269,  360,
     5    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     6    371,  372,  373,  374,  375,  377,  378,  379,  380,  381,
     7    382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
     8    392,  393,  394,  376,  359,  396,  397,  398,  399,  400,
     9    401,  402,  403,  404,  405,  406,  407,  408,  409,  410/
            data (jb1(i),i=  401,  500)/
     +    411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
     1    421,  422,  423,  424,  425,  426,  427,  428,  429,  430,
     2    431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
     3    441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
     4    451,  452,  453,  454,  455,  456,  457,  458,  459,  460,
     5    461,  462,  463,  464,  465,  466,  467,  468,  469,  470,
     6    471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
     7    481,  482,  483,  484,  485,  486,  487,  488,  489,  490,
     8    491,  492,  493,  494,  495,  496,  497,  498,  499,  500,
     9    501,  502,  503,  504,  505,  506,  507,  508,  509,  510/
            data (jb1(i),i=  501,  600)/
     +    511,  512,  513,  514,  515,  516,  517,  518,  519,  520,
     1    521,  522,  525,  526,  527,  528,  529,  530,  531,  532,
     2    533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
     3    543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
     4    553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
     5    563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
     6    573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
     7    583,  584,  585,  586,  587,  588,  589,  590,  591,  592,
     8    593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
     9    603,  604,  605,  606,  607,  608,  609,  610,  611,  612/
            data (jb1(i),i=  601,  700)/
     +    613,  614,  615,  616,  617,  618,  619,  620,  621,  622,
     1    623,  624,  625,  626,  627,  628,  629,  630,  631,  632,
     2    633,  634,  635,  636,  637,  638,  639,  640,  641,  642,
     3    643,  644,  377,  646,  647,  648,  649,  650,  651,  652,
     4    653,  654,  655,  656,  657,  658,  659,  524,  661,  662,
     5    663,  664,  665,  666,  646,  668,  669,  670,  671,  672,
     6    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     7    683,  684,  685,  686,  687,  688,  689,  690,  691,  692,
     8    693,  694,  695,  696,  697,  698,  699,  700,  701,  702,
     9    703,  704,  705,  706,  707,  708,  709,  710,  711,  712/
            data (jb1(i),i=  701,  800)/
     +    713,  714,  715,  716,  717,  718,  719,  720,  721,  524,
     1    668,  723,  523,  725,  726,  727,  728,  729,  730,  731,
     2    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     3    742,  743,  744,  745,  746,  723,  661,  748,  749,  750,
     4    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     5    761,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     6    771,  772,  773,  774,  775,  776,  777,  778,  779,  780,
     7    781,  782,  783,  784,  785,  786,  787,  788,  789,  790,
     8    791,  792,  793,  794,  795,  796,  797,  798,  799,  800,
     9    801,  802,  803,  804,  805,  806,  807,  808,  809,  810/
            data (jb1(i),i=  801,  900)/
     +    811,  812,  813,  814,  815,  816,  817,  818,  819,  820,
     1    821,  822,  823,  824,  825,  826,  827,  828,  829,  830,
     2    831,  832,  833,  834,  835,  836,  837,  838,  839,  840,
     3    841,  842,  843,  844,  845,  846,  847,  848,  849,  850,
     4    851,  852,  853,  854,  855,  856,  857,  858,  859,  860,
     5    861,  862,  863,  864,  865,  866,  867,  868,  869,  870,
     6    871,  872,  873,  874,  875,  876,  877,  878,  879,  880,
     7    881,  882,  883,  884,  885,  886,  887,  888,  889,  890,
     8    891,  892,  893,  894,  895,  896,  897,  898,  899,  900,
     9    901,  902,  903,  904,  905,  906,  907,  908,  909,  910/
            data (jb1(i),i=  901, 1000)/
     +    911,  912,  913,  914,  915,  916,  917,  918,  919,  920,
     1    921,  922,  923,  924,  925,  926,  927,  928,  929,  930,
     2    931,  932,  933,  934,  935,  936,  937,  938,  939,  940,
     3    941,  942,  943,  944,  945,  946,  947,  948,  949,  950,
     4    951,  952,  953,  954,  955,  956,  957,  958,  959,  960,
     5    525,    5,  962,  963,  964,  965,  966,  967,  968,  969,
     6    970,  971,  972,  973,  974,  975,  976,  977,  978,  979,
     7    980,  981,  982,  983,  984,  985,  986,  987,  988,  989,
     8    990,  991,  992,  993,  994,  995,  996,  997,  998,  999,
     9   1000, 1001, 1002, 1003, 1004, 1005, 1006,    6,    3,    1/
            data (jb1(i),i= 1001, 1100)/
     +      1,  101,    7,    4, 1008, 1009, 1010, 1011, 1012, 1013,
     1   1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023,
     2   1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033,
     3   1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043,
     4   1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053,
     5   1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063,
     6   1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073,
     7   1074, 1075, 1076,    2, 1078, 1079, 1080, 1081, 1082, 1083,
     8   1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093,
     9   1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103/
            data (jb1(i),i= 1101, 1200)/
     +   1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113,
     1   1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123,
     2   1124, 1125, 1126,    4,    6, 1128, 1129, 1130, 1131, 1132,
     3   1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142,
     4   1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151, 1152,
     5   1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162,
     6   1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172,
     7   1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1078,    2,
     8   1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190,  242,
     9    242, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200/
            data (jb1(i),i= 1201, 1300)/
     +   1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210,
     1   1211,  269,    1, 1213, 1214, 1215, 1216, 1217, 1218, 1219,
     2   1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229,
     3   1230, 1231, 1232, 1233, 1234, 1235, 1236,    3, 1237, 1238,
     4   1239, 1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248,
     5   1249, 1250, 1251,    5,  100, 1252, 1253, 1254, 1255, 1256,
     6   1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266,
     7   1267, 1268, 1269, 1270, 1271,    7, 1273, 1274, 1275, 1276,
     8   1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286,
     9   1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296/
            data (jb1(i),i= 1301, 1400)/
     +   1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306,
     1   1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1273,  220,
     2   1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325,
     3   1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335,
     4   1336, 1337, 1338, 1339, 1340, 1341, 1342, 1273,  221, 1315,
     5    225, 1344, 1345, 1346,  102, 1344, 1348, 1349, 1350, 1351,
     6   1352, 1353, 1330, 1355, 1356, 1357, 1358, 1359, 1360, 1361,
     7   1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1354,  250,
     8   1344,  251,  259, 1315, 1373, 1374, 1375, 1376, 1377, 1378,
     9   1379, 1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388/
            data (jb1(i),i= 1401, 1500)/
     +   1389, 1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398,
     1   1399, 1400, 1401, 1354, 1403, 1404, 1405, 1406, 1407, 1408,
     2   1409, 1410, 1411, 1412, 1413, 1414, 1415, 1402, 1414, 1417,
     3   1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427,
     4   1428, 1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437,
     5   1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447,
     6   1448, 1449, 1450, 1451, 1452, 1402,  269, 1454,  376, 1454,
     7    523, 1457, 1458, 1459, 1460, 1461, 1462, 1463, 1453, 1453,
     8   1465, 1466, 1467, 1468, 1469,  377, 1470, 1471, 1472, 1473,
     9   1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482, 1483/
            data (jb1(i),i= 1501, 1600)/
     +   1484,  525, 1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492,
     1   1493, 1494, 1495,  661,  668, 1497,    1,    2,    3,    4,
     2      5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
     3     15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
     4     25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
     5     35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
     6     45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
     7     55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
     8     65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
     9     75,   76,   77,   78,   79,   80,   81,   82,   83,   84/
            data (jb1(i),i= 1601, 1700)/
     +     85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
     1     95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
     2    105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
     3    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     4    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     5    135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
     6    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     7    155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
     8    165,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     9    175,  176,  177,  178,  179,  180,  181,  182,  183,  184/
            data (jb1(i),i= 1701, 1800)/
     +    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     1    195,  196,  197,  198,  199,  200,  201,  202,  203,  204,
     2    205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
     3    215,  216,    1,  218,  219,  220,  221,  222,  223,  224,
     4    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     5    217,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     6    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     7    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     8    265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
     9    275,  276,  277,  278,  279,  280,  281,  282,  283,  284/
            data (jb1(i),i= 1801, 1900)/
     +    285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
     1    295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
     2    305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
     3    315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
     4    325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
     5    335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
     6    345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
     7    355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
     8    365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
     9    375,  376,  377,  378,  379,  380,  381,  382,  383,  384/
            data (jb1(i),i= 1901, 2000)/
     +    385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
     1    395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
     2    405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
     3    415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
     4    425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
     5    435,  436,  437,  438,  439,  440,  441,  442,  443,  444,
     6    445,  446,  447,  448,  449,  450,  451,  452,  453,  454,
     7    455,  456,  457,  458,  459,  460,  461,  462,  463,  464,
     8    465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
     9    475,  476,  477,  478,  479,  480,  481,  482,  483,  484/
            data (jb1(i),i= 2001, 2100)/
     +    485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
     1    495,  496,  497,  498,  499,  500,  501,  502,  503,  504,
     2    505,  506,  507,  508,  509,  510,  511,  512,  513,  514,
     3    515,  516,  517,  518,  519,  520,  521,  522,  523,  524,
     4    525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
     5    535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     6    545,  546,  547,  548,  549,  550,  551,  552,  553,  554,
     7    555,  556,  557,  558,  559,  560,  561,  562,  563,  564,
     8    565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
     9    575,  576,  577,  578,  579,  580,  581,  582,  583,  584/
            data (jb1(i),i= 2101, 2200)/
     +    585,  586,  587,  588,  589,  590,  591,  592,  593,  594,
     1    595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
     2    605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
     3    615,  616,  617,  618,  619,  620,  621,  622,  623,  624,
     4    625,  626,  627,  628,  629,  631,  630,  633,  634,  635,
     5    636,  637,  638,  639,  640,  641,  642,  643,  644,  645,
     6    646,  647,  648,  649,  650,  651,  652,  653,  654,  655,
     7    656,  657,  658,  659,  660,  661,  662,  663,  664,  665,
     8    666,  667,  668,  669,  670,  671,  672,  673,  674,  675,
     9    676,  677,  678,  679,  680,  681,  682,  683,  684,  685/
            data (jb1(i),i= 2201, 2300)/
     +    686,  687,  688,  689,  690,  691,  692,  693,  694,  695,
     1    696,  697,  698,  699,  700,  701,  702,  703,  704,  705,
     2    706,  707,  708,  709,  710,  711,  712,  713,  714,  715,
     3    716,  717,  718,  719,  720,  721,  722,  723,  724,  725,
     4    726,  727,  728,  729,  730,  731,  732,  733,  734,  735,
     5    736,  737,  738,  739,  740,  741,  742,  743,  744,  745,
     6    746,  747,  748,  749,  750,  751,  752,  753,  754,  755,
     7    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     8    766,  767,  768,  769,  632,  771,  772,  773,  774,  775,
     9    776,  777,  778,  779,  780,  781,  782,  783,  784,  785/
            data (jb1(i),i= 2301, 2400)/
     +    786,  787,  788,  789,  790,  791,  792,  793,  794,  795,
     1    796,  797,  798,  799,  800,  801,  802,  803,  804,  805,
     2    806,  807,  808,  809,  810,  811,  812,  813,  814,  815,
     3    816,  817,  818,  819,  820,  821,  822,  823,  824,  825,
     4    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     5    836,  837,  838,  839,  840,  841,  842,  843,  844,  845,
     6    846,  847,  848,  849,  850,  851,  852,  853,  854,  855,
     7    856,  857,  858,  859,  860,  861,  862,  863,  864,  865,
     8    866,  867,  868,  869,  870,  871,  872,  873,  874,  875,
     9    876,  877,  878,  879,  880,  881,  882,  883,  884,  885/
            data (jb1(i),i= 2401, 2500)/
     +    886,  887,  888,  889,  890,  891,  892,  893,  894,  895,
     1    896,  897,  898,  899,  900,  901,  902,  903,  904,  905,
     2    906,  907,  908,  909,  910,  911,  912,  913,  914,  915,
     3    916,  917,  918,  919,  920,  921,  922,  923,  924,  925,
     4    926,  927,  928,  929,  930,  931,  932,  933,  934,  935,
     5    936,  937,  938,  939,  940,  941,  942,  943,  944,  945,
     6    946,  947,  948,  949,  950,  951,  952,  953,  954,  955,
     7    956,  957,  958,  959,  960,  961,  962,  963,  964,  965,
     8    966,  967,  968,  969,  970,  971,  972,  235,  631,  974,
     9    975,  977,  978,  979,  980,  981,  982,  983,  984,  985/
            data (jb1(i),i= 2501, 2600)/
     +    986,  987,  988,  989,  990,  991,  992,  993,  994,  995,
     1    996,  997,  998,  999, 1000, 1001, 1002, 1003, 1004, 1005,
     2   1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015,
     3   1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025,
     4   1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035,
     5   1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045,
     6   1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055,
     7   1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065,
     8   1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074,  771,
     9    977, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084/
            data (jb1(i),i= 2601, 2700)/
     +   1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094,
     1   1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104,
     2   1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114,
     3   1117, 1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126,
     4   1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136,
     5   1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146,
     6   1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156,
     7   1157, 1158, 1159, 1160, 1161, 1162, 1163, 1164, 1165, 1166,
     8   1167, 1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175, 1176,
     9   1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185, 1186/
            data (jb1(i),i= 2701, 2800)/
     +   1187, 1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196,
     1   1197, 1198, 1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206,
     2   1207, 1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216,
     3   1217, 1218, 1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226,
     4   1227, 1228, 1229, 1230, 1116,  976, 1117, 1116, 1233, 1234,
     5   1235, 1236, 1237, 1238, 1239, 1240, 1241, 1242, 1243, 1244,
     6   1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254,
     7   1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264,
     8   1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274,
     9   1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284/
            data (jb1(i),i= 2801, 2900)/
     +   1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294,
     1   1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304,
     2   1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314,
     3   1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324,
     4   1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334,
     5   1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343, 1344,
     6   1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353, 1354,
     7   1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1364,
     8   1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374,
     9   1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384/
            data (jb1(i),i= 2901, 3000)/
     +   1385, 1386, 1387, 1388, 1389, 1390, 1391, 1392, 1393, 1394,
     1   1395, 1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404,
     2   1405, 1406, 1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414,
     3   1415, 1416, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424,
     4   1425, 1426, 1427, 1428, 1429, 1430, 1431, 1115,    1, 1433,
     5   1434, 1435, 1436, 1437, 1438, 1439, 1440, 1441, 1442, 1443,
     6   1444, 1445,  329, 1447, 1448, 1446,  443, 1450, 1451, 1452,
     7   1453, 1454, 1455, 1456, 1457, 1458, 1459,  632, 1460, 1461,
     8   1462,  630,  974, 1464, 1465, 1466, 1467, 1468, 1469, 1470,
     9   1471, 1472, 1473, 1474, 1475, 1476, 1446,  977, 1478, 1479/
            data (jb1(i),i= 3001, 3100)/
     +   1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487,  976,  975,
     1   1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498,
     2   1499, 1500, 1501, 1502, 1503,  235, 1505, 1506, 1507, 1508,
     3   1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517, 1518,
     4   1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528,
     5   1529, 1530, 1531, 1532, 1533, 1534, 1535, 1117, 1536, 1537,
     6   1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546, 1505,
     7   1115, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556,
     8   1557, 1558, 1559, 1560, 1561, 1505,    1,    2,    3,    4,
     9      1,    6,    7,    8,    9,   10,   11,   12,   13,   14/
            data (jb1(i),i= 3101, 3200)/
     +     15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
     1     25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
     2     35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
     3     45,   46,    6,   48,   49,   50,   51,   52,   53,   54,
     4     55,   56,   57,   58,   59,   60,   61,   48,   63,   64,
     5     65,   66,   67,   63,   69,   70,   71,   69,   73,   74,
     6     75,   76,   77,   78,   73,   80,   81,   82,   83,   84,
     7     85,   80,   87,   88,   89,   87,   91,   92,   93,   94,
     8     95,   96,   97,   98,   99,  100,   91,  102,  103,  104,
     9    105,  106,  107,  108,  109,  110,  111,  112,  102,  114/
            data (jb1(i),i= 3201, 3300)/
     +    115,  116,  114,  118,  119,  120,  118,  122,  123,  124,
     1    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     2    135,  122,  137,  138,  139,  140,  141,  142,  143,  144,
     3    145,  146,  147,  137,  149,  150,  151,  152,  153,  154,
     4    155,  149,  157,  158,  159,  160,  161,  157,  163,  164,
     5    165,  166,  167,  168,  169,  163,  171,  172,  173,  171,
     6    175,  176,  177,  178,  179,  180,  175,  182,  183,  184,
     7    185,  186,  182,  188,  189,  190,  191,  192,  193,  194,
     8    195,  196,  197,  198,  199,  200,  201,  202,  203,  204,
     9    205,  206,  207,  208,  209,  210,  211,  212,  213,  214/
            data (jb1(i),i= 3301, 3400)/
     +    215,  188,  217,  218,  219,  220,  221,  222,  223,  224,
     1    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     2    235,  236,  237,  217,  239,  240,  241,  242,  243,  239,
     3    245,  246,  247,  245,  249,  250,  251,  252,  253,  249,
     4    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     5    265,  255,  267,  268,  269,  270,  267,  272,  273,  274,
     6    272,  276,  277,  278,  276,  280,  281,  282,  283,  284,
     7    280,  286,  287,  288,  289,  286,  291,  292,  293,  294,
     8    295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
     9    305,  306,  307,  308,  291,  310,  311,  312,  313,  310/
            data (jb1(i),i= 3401, 3490)/
     +    315,  316,  317,  318,  315,  320,  321,  322,  323,  324,
     1    325,  326,  327,  328,  320,  330,  331,  332,  333,  334,
     2    330,  336,  337,  338,  339,  340,  341,  342,  343,  344,
     3    345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
     4    355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
     5    365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
     6    375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
     7    385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
     8    395,  396,  397,  398,  399,  400,  401,  402,  336,    0/
            data (jb2(i),i=    1,  100)/
     +      8,    9,   10,   11,   12,   13,   14,   15,   16,   17,
     1     18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
     2     28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
     3     38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
     4     48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
     5     58,   59,   60,   61,   62,   63,   64,   65,   66,   67,
     6     68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
     7     78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
     8     88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
     9     98,   99,  100,  103,  104,  105,  106,  107,  108,  109/
            data (jb2(i),i=  101,  200)/
     +    110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
     1    120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
     2    130,  131,  132,  133,  134,  135,  136,  137,  138,  139,
     3    140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
     4    150,  151,  152,  153,  154,  155,  156,  157,  158,  159,
     5    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     6    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     7    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     8    190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
     9    200,  201,  202,  203,  204,  205,  206,  207,  208,  209/
            data (jb2(i),i=  201,  300)/
     +    210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
     1    219,  222,  223,  224,  226,  227,  228,  229,  230,  231,
     2    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     3    241,  241,  243,  244,  245,  246,  247,  248,  249,  250,
     4    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     5    262,  263,  264,  265,  266,  267,  268,  268,  270,  271,
     6    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     7    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     8    292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
     9    302,  303,  304,  305,  306,  307,  308,  309,  310,  311/
            data (jb2(i),i=  301,  400)/
     +    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     1    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     2    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     3    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     4    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     5    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     6    372,  373,  374,  375,  376,  378,  379,  380,  381,  382,
     7    383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
     8    393,  394,  395,  395,  396,  397,  398,  399,  400,  401,
     9    402,  403,  404,  405,  406,  407,  408,  409,  410,  411/
            data (jb2(i),i=  401,  500)/
     +    412,  413,  414,  415,  416,  417,  418,  419,  420,  421,
     1    422,  423,  424,  425,  426,  427,  428,  429,  430,  431,
     2    432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
     3    442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
     4    452,  453,  454,  455,  456,  457,  458,  459,  460,  461,
     5    462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
     6    472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
     7    482,  483,  484,  485,  486,  487,  488,  489,  490,  491,
     8    492,  493,  494,  495,  496,  497,  498,  499,  500,  501,
     9    502,  503,  504,  505,  506,  507,  508,  509,  510,  511/
            data (jb2(i),i=  501,  600)/
     +    512,  513,  514,  515,  516,  517,  518,  519,  520,  521,
     1    522,  523,  526,  527,  528,  529,  530,  531,  532,  533,
     2    534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
     3    544,  545,  546,  547,  548,  549,  550,  551,  552,  553,
     4    554,  555,  556,  557,  558,  559,  560,  561,  562,  563,
     5    564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
     6    574,  575,  576,  577,  578,  579,  580,  581,  582,  583,
     7    584,  585,  586,  587,  588,  589,  590,  591,  592,  593,
     8    594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
     9    604,  605,  606,  607,  608,  609,  610,  611,  612,  613/
            data (jb2(i),i=  601,  700)/
     +    614,  615,  616,  617,  618,  619,  620,  621,  622,  623,
     1    624,  625,  626,  627,  628,  629,  630,  631,  632,  633,
     2    634,  635,  636,  637,  638,  639,  640,  641,  642,  643,
     3    644,  645,  645,  647,  648,  649,  650,  651,  652,  653,
     4    654,  655,  656,  657,  658,  659,  660,  660,  662,  663,
     5    664,  665,  666,  667,  667,  669,  670,  671,  672,  673,
     6    674,  675,  676,  677,  678,  679,  680,  681,  682,  683,
     7    684,  685,  686,  687,  688,  689,  690,  691,  692,  693,
     8    694,  695,  696,  697,  698,  699,  700,  701,  702,  703,
     9    704,  705,  706,  707,  708,  709,  710,  711,  712,  713/
            data (jb2(i),i=  701,  800)/
     +    714,  715,  716,  717,  718,  719,  720,  721,  722,  722,
     1    724,  724,  725,  726,  727,  728,  729,  730,  731,  732,
     2    733,  734,  735,  736,  737,  738,  739,  740,  741,  742,
     3    743,  744,  745,  746,  747,  747,  748,  749,  750,  751,
     4    752,  753,  754,  755,  756,  757,  758,  759,  760,  761,
     5    762,  763,  764,  765,  766,  767,  768,  769,  770,  771,
     6    772,  773,  774,  775,  776,  777,  778,  779,  780,  781,
     7    782,  783,  784,  785,  786,  787,  788,  789,  790,  791,
     8    792,  793,  794,  795,  796,  797,  798,  799,  800,  801,
     9    802,  803,  804,  805,  806,  807,  808,  809,  810,  811/
            data (jb2(i),i=  801,  900)/
     +    812,  813,  814,  815,  816,  817,  818,  819,  820,  821,
     1    822,  823,  824,  825,  826,  827,  828,  829,  830,  831,
     2    832,  833,  834,  835,  836,  837,  838,  839,  840,  841,
     3    842,  843,  844,  845,  846,  847,  848,  849,  850,  851,
     4    852,  853,  854,  855,  856,  857,  858,  859,  860,  861,
     5    862,  863,  864,  865,  866,  867,  868,  869,  870,  871,
     6    872,  873,  874,  875,  876,  877,  878,  879,  880,  881,
     7    882,  883,  884,  885,  886,  887,  888,  889,  890,  891,
     8    892,  893,  894,  895,  896,  897,  898,  899,  900,  901,
     9    902,  903,  904,  905,  906,  907,  908,  909,  910,  911/
            data (jb2(i),i=  901, 1000)/
     +    912,  913,  914,  915,  916,  917,  918,  919,  920,  921,
     1    922,  923,  924,  925,  926,  927,  928,  929,  930,  931,
     2    932,  933,  934,  935,  936,  937,  938,  939,  940,  941,
     3    942,  943,  944,  945,  946,  947,  948,  949,  950,  951,
     4    952,  953,  954,  955,  956,  957,  958,  959,  960,  961,
     5    961,  962,  963,  964,  965,  966,  967,  968,  969,  970,
     6    971,  972,  973,  974,  975,  976,  977,  978,  979,  980,
     7    981,  982,  983,  984,  985,  986,  987,  988,  989,  990,
     8    991,  992,  993,  994,  995,  996,  997,  998,  999, 1000,
     9   1001, 1002, 1003, 1004, 1005, 1006, 1007, 1007,    5,    3/
            data (jb2(i),i= 1001, 1100)/
     +    101,  220,  220, 1008, 1009, 1010, 1011, 1012, 1013, 1014,
     1   1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024,
     2   1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034,
     3   1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044,
     4   1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054,
     5   1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064,
     6   1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074,
     7   1075, 1076, 1077, 1077, 1079, 1080, 1081, 1082, 1083, 1084,
     8   1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094,
     9   1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104/
            data (jb2(i),i= 1101, 1200)/
     +   1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114,
     1   1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123, 1124,
     2   1125, 1126, 1127, 1127, 1128, 1129, 1130, 1131, 1132, 1133,
     3   1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142, 1143,
     4   1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151, 1152, 1153,
     5   1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163,
     6   1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172, 1173,
     7   1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1181, 1182,
     8   1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191, 1191,
     9   1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201/
            data (jb2(i),i= 1201, 1300)/
     +   1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211,
     1   1212, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220,
     2   1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230,
     3   1231, 1232, 1233, 1234, 1235, 1236,    2, 1237, 1238, 1239,
     4   1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249,
     5   1250, 1251,    4,    6, 1252, 1253, 1254, 1255, 1256, 1257,
     6   1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266, 1267,
     7   1268, 1269, 1270, 1271, 1272, 1272, 1274, 1275, 1276, 1277,
     8   1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287,
     9   1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296, 1297/
            data (jb2(i),i= 1301, 1400)/
     +   1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306, 1307,
     1   1308, 1309, 1310, 1311, 1312, 1313, 1314,  101, 1315, 1316,
     2   1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326,
     3   1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336,
     4   1337, 1338, 1339, 1340, 1341, 1342, 1343, 1343,  224,  242,
     5   1344, 1345, 1346, 1347, 1347, 1348, 1349, 1350, 1351, 1352,
     6   1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362,
     7   1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1370, 1371,
     8   1371, 1372, 1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379,
     9   1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389/
            data (jb2(i),i= 1401, 1500)/
     +   1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399,
     1   1400, 1401, 1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409,
     2   1410, 1411, 1412, 1413, 1414, 1415, 1416, 1416, 1417, 1418,
     3   1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428,
     4   1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438,
     5   1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447, 1448,
     6   1449, 1450, 1451, 1452, 1453, 1454, 1455, 1455, 1456, 1456,
     7   1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1464, 1465,
     8   1466, 1467, 1468, 1469,  524, 1470, 1471, 1472, 1473, 1474,
     9   1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482, 1483, 1484/
            data (jb2(i),i= 1501, 1600)/
     +    646, 1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492, 1493,
     1   1494, 1495, 1496, 1496, 1497,  723,    2,    3,    4,    5,
     2      6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
     3     16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
     4     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     5     36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     6     46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
     7     56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
     8     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     9     76,   77,   78,   79,   80,   81,   82,   83,   84,   85/
            data (jb2(i),i= 1601, 1700)/
     +     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     1     96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
     2    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     3    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     4    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     5    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     6    146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
     7    156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
     8    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     9    176,  177,  178,  179,  180,  181,  182,  183,  184,  185/
            data (jb2(i),i= 1701, 1800)/
     +    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     1    196,  197,  198,  199,  200,  201,  202,  203,  204,  205,
     2    206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
     3    216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
     4    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     5    236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
     6    246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
     7    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     8    266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
     9    276,  277,  278,  279,  280,  281,  282,  283,  284,  285/
            data (jb2(i),i= 1801, 1900)/
     +    286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
     1    296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
     2    306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
     3    316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
     4    326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
     5    336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
     6    346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
     7    356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
     8    366,  367,  368,  369,  370,  371,  372,  373,  374,  375,
     9    376,  377,  378,  379,  380,  381,  382,  383,  384,  385/
            data (jb2(i),i= 1901, 2000)/
     +    386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
     1    396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
     2    406,  407,  408,  409,  410,  411,  412,  413,  414,  415,
     3    416,  417,  418,  419,  420,  421,  422,  423,  424,  425,
     4    426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
     5    436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
     6    446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
     7    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     8    466,  467,  468,  469,  470,  471,  472,  473,  474,  475,
     9    476,  477,  478,  479,  480,  481,  482,  483,  484,  485/
            data (jb2(i),i= 2001, 2100)/
     +    486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
     1    496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
     2    506,  507,  508,  509,  510,  511,  512,  513,  514,  515,
     3    516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
     4    526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
     5    536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
     6    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     7    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     8    566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
     9    576,  577,  578,  579,  580,  581,  582,  583,  584,  585/
            data (jb2(i),i= 2101, 2200)/
     +    586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
     1    596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
     2    606,  607,  608,  609,  610,  611,  612,  613,  614,  615,
     3    616,  617,  618,  619,  620,  621,  622,  623,  624,  625,
     4    626,  627,  628,  629,  630,  632,  633,  634,  635,  636,
     5    637,  638,  639,  640,  641,  642,  643,  644,  645,  646,
     6    647,  648,  649,  650,  651,  652,  653,  654,  655,  656,
     7    657,  658,  659,  660,  661,  662,  663,  664,  665,  666,
     8    667,  668,  669,  670,  671,  672,  673,  674,  675,  676,
     9    677,  678,  679,  680,  681,  682,  683,  684,  685,  686/
            data (jb2(i),i= 2201, 2300)/
     +    687,  688,  689,  690,  691,  692,  693,  694,  695,  696,
     1    697,  698,  699,  700,  701,  702,  703,  704,  705,  706,
     2    707,  708,  709,  710,  711,  712,  713,  714,  715,  716,
     3    717,  718,  719,  720,  721,  722,  723,  724,  725,  726,
     4    727,  728,  729,  730,  731,  732,  733,  734,  735,  736,
     5    737,  738,  739,  740,  741,  742,  743,  744,  745,  746,
     6    747,  748,  749,  750,  751,  752,  753,  754,  755,  756,
     7    757,  758,  759,  760,  761,  762,  763,  764,  765,  766,
     8    767,  768,  769,  770,  770,  772,  773,  774,  775,  776,
     9    777,  778,  779,  780,  781,  782,  783,  784,  785,  786/
            data (jb2(i),i= 2301, 2400)/
     +    787,  788,  789,  790,  791,  792,  793,  794,  795,  796,
     1    797,  798,  799,  800,  801,  802,  803,  804,  805,  806,
     2    807,  808,  809,  810,  811,  812,  813,  814,  815,  816,
     3    817,  818,  819,  820,  821,  822,  823,  824,  825,  826,
     4    827,  828,  829,  830,  831,  832,  833,  834,  835,  836,
     5    837,  838,  839,  840,  841,  842,  843,  844,  845,  846,
     6    847,  848,  849,  850,  851,  852,  853,  854,  855,  856,
     7    857,  858,  859,  860,  861,  862,  863,  864,  865,  866,
     8    867,  868,  869,  870,  871,  872,  873,  874,  875,  876,
     9    877,  878,  879,  880,  881,  882,  883,  884,  885,  886/
            data (jb2(i),i= 2401, 2500)/
     +    887,  888,  889,  890,  891,  892,  893,  894,  895,  896,
     1    897,  898,  899,  900,  901,  902,  903,  904,  905,  906,
     2    907,  908,  909,  910,  911,  912,  913,  914,  915,  916,
     3    917,  918,  919,  920,  921,  922,  923,  924,  925,  926,
     4    927,  928,  929,  930,  931,  932,  933,  934,  935,  936,
     5    937,  938,  939,  940,  941,  942,  943,  944,  945,  946,
     6    947,  948,  949,  950,  951,  952,  953,  954,  955,  956,
     7    957,  958,  959,  960,  961,  962,  963,  964,  965,  966,
     8    967,  968,  969,  970,  971,  972,  973,  973,  974,  975,
     9    976,  978,  979,  980,  981,  982,  983,  984,  985,  986/
            data (jb2(i),i= 2501, 2600)/
     +    987,  988,  989,  990,  991,  992,  993,  994,  995,  996,
     1    997,  998,  999, 1000, 1001, 1002, 1003, 1004, 1005, 1006,
     2   1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016,
     3   1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026,
     4   1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036,
     5   1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046,
     6   1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056,
     7   1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066,
     8   1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1075,
     9   1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085/
            data (jb2(i),i= 2601, 2700)/
     +   1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095,
     1   1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105,
     2   1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115,
     3   1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127,
     4   1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136, 1137,
     5   1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146, 1147,
     6   1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156, 1157,
     7   1158, 1159, 1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167,
     8   1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177,
     9   1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185, 1186, 1187/
            data (jb2(i),i= 2701, 2800)/
     +   1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197,
     1   1198, 1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207,
     2   1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217,
     3   1218, 1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227,
     4   1228, 1229, 1230, 1231, 1231, 1232, 1232, 1233, 1234, 1235,
     5   1236, 1237, 1238, 1239, 1240, 1241, 1242, 1243, 1244, 1245,
     6   1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254, 1255,
     7   1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265,
     8   1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275,
     9   1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285/
            data (jb2(i),i= 2801, 2900)/
     +   1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295,
     1   1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305,
     2   1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315,
     3   1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325,
     4   1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335,
     5   1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343, 1344, 1345,
     6   1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353, 1354, 1355,
     7   1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1364, 1365,
     8   1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375,
     9   1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384, 1385/
            data (jb2(i),i= 2901, 3000)/
     +   1386, 1387, 1388, 1389, 1390, 1391, 1392, 1393, 1394, 1395,
     1   1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404, 1405,
     2   1406, 1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415,
     3   1416, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425,
     4   1426, 1427, 1428, 1429, 1430, 1431, 1432, 1432, 1433, 1434,
     5   1435, 1436, 1437, 1438, 1439, 1440, 1441, 1442, 1443, 1444,
     6   1445, 1446, 1447, 1448, 1449, 1449, 1450, 1451, 1452, 1453,
     7   1454, 1455, 1456, 1457, 1458, 1459,  631, 1460, 1461, 1462,
     8   1463, 1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470, 1471,
     9   1472, 1473, 1474, 1475, 1476, 1477, 1477, 1478, 1479, 1480/
            data (jb2(i),i= 3001, 3100)/
     +   1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488, 1488, 1489,
     1   1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499,
     2   1500, 1501, 1502, 1503, 1504, 1504, 1506, 1507, 1508, 1509,
     3   1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517, 1518, 1519,
     4   1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529,
     5   1530, 1531, 1532, 1533, 1534, 1535, 1116, 1536, 1537, 1538,
     6   1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546, 1547, 1547,
     7   1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556, 1557,
     8   1558, 1559, 1560, 1561, 1562, 1562,    2,    3,    4,    5,
     9      5,    7,    8,    9,   10,   11,   12,   13,   14,   15/
            data (jb2(i),i= 3101, 3200)/
     +     16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
     1     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     2     36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     3     46,   47,   47,   49,   50,   51,   52,   53,   54,   55,
     4     56,   57,   58,   59,   60,   61,   62,   62,   64,   65,
     5     66,   67,   68,   68,   70,   71,   72,   72,   74,   75,
     6     76,   77,   78,   79,   79,   81,   82,   83,   84,   85,
     7     86,   86,   88,   89,   90,   90,   92,   93,   94,   95,
     8     96,   97,   98,   99,  100,  101,  101,  103,  104,  105,
     9    106,  107,  108,  109,  110,  111,  112,  113,  113,  115/
            data (jb2(i),i= 3201, 3300)/
     +    116,  117,  117,  119,  120,  121,  121,  123,  124,  125,
     1    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     2    136,  136,  138,  139,  140,  141,  142,  143,  144,  145,
     3    146,  147,  148,  148,  150,  151,  152,  153,  154,  155,
     4    156,  156,  158,  159,  160,  161,  162,  162,  164,  165,
     5    166,  167,  168,  169,  170,  170,  172,  173,  174,  174,
     6    176,  177,  178,  179,  180,  181,  181,  183,  184,  185,
     7    186,  187,  187,  189,  190,  191,  192,  193,  194,  195,
     8    196,  197,  198,  199,  200,  201,  202,  203,  204,  205,
     9    206,  207,  208,  209,  210,  211,  212,  213,  214,  215/
            data (jb2(i),i= 3301, 3400)/
     +    216,  216,  218,  219,  220,  221,  222,  223,  224,  225,
     1    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     2    236,  237,  238,  238,  240,  241,  242,  243,  244,  244,
     3    246,  247,  248,  248,  250,  251,  252,  253,  254,  254,
     4    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     5    266,  266,  268,  269,  270,  271,  271,  273,  274,  275,
     6    275,  277,  278,  279,  279,  281,  282,  283,  284,  285,
     7    285,  287,  288,  289,  290,  290,  292,  293,  294,  295,
     8    296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
     9    306,  307,  308,  309,  309,  311,  312,  313,  314,  314/
            data (jb2(i),i= 3401, 3490)/
     +    316,  317,  318,  319,  319,  321,  322,  323,  324,  325,
     1    326,  327,  328,  329,  329,  331,  332,  333,  334,  335,
     2    335,  337,  338,  339,  340,  341,  342,  343,  344,  345,
     3    346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
     4    356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
     5    366,  367,  368,  369,  370,  371,  372,  373,  374,  375,
     6    376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
     7    386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
     8    396,  397,  398,  399,  400,  401,  402,  403,  403,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ma(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1410) :: jx,jy
            integer(kind=iknd), save, dimension(1420) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'massachusetts '/
            data jrot,ipart/1,2/
            data kv/   1,1171,1402,   0,   0/
            data kb/   1,1184,1415,   0,   0/
            data iib/ 751, 231,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  20592,21624,21552,27024,21576,31656,31584,31536,31392,31248,
     1  31224,31344,31608,31848,32184,32400,32352,32424,32640,33072,
     2  33144,33120,33240,33264,33576,33600,33240,33216,34248,34824,
     3  35088,35208,35544,36096,36672,36720,36744,36672,36816,36936,
     4  36984,36816,36576,36408,35400,35472,35592,35664,35760,35832,
     5  35880,36384,36480,36648,36744,36504,36744,36840,37008,37176,
     6  37392,37680,37920,37920,37728,37368,37296,38136,38160,38016,
     7  37968,38136,38328,38376,38592,38640,38760,39024,39240,39768,
     8  39984,40632,40872,41088,30960,30696,31776,37104,37200,37416,
     9  37752,42792,45480,45384,45456,45576,45672,45984,46296,46536/
            data (jx(i),i=  101,  200)/
     +  45816,45624,45504,45552,44952,44544,44784,45192,45648,45960,
     1  46272,46296,45864,45816,45984,46272,46584,46632,46536,46200,
     2  46368,46512,46584,46992,47088,47520,47568,47808,48048,48144,
     3  48120,47880,47736,47568,47520,47592,47472,47664,47712,47880,
     4  48240,48264,48408,48528,48888,48936,48816,48600,48480,48384,
     5  48240,48264,48192,48192,47352,47232,47088,46440,46272,46968,
     6  47496,47904,48024,48000,47760,47784,47520,47520,47640,48144,
     7  48456,48552,48528,48672,46416,46224,46056,45816,45624,44952,
     8  44784,44736,44664,44568,43704,43272,42792,42264,41856,41952,
     9  41760,41328,41832,42240,42408,42648,43176,43416,43752,43968/
            data (jx(i),i=  201,  300)/
     +  43728,43800,43920,43920,43656,43680,43752,42960,42384,42144,
     1  42000,41520,41376,41184,40992,40608,39936,39792,39696,39888,
     2  27024,27624,27552,27624,27552,27384,27312,27168,26712,26568,
     3  26544,26640,26496,26232,25968,25944,25848,25560,25560,25800,
     4  25800,25296,25272,25704,25728,25464,25320,25032,24936,24888,
     5  25056,24864,24744,24576,24648,24600,24720,24768,24648,24648,
     6  24552,24480,24288,24168,24288,24000,23880,24024,23880,23808,
     7  23544,23232,23064,23112,23280,23376,23616,23712,23688,23424,
     8  23352,23064,22848,22680,22536,22416,22104,21888,21816,21672,
     9  21264,21144,21288,21240,21432,21576,21840,22056,22056,22320/
            data (jx(i),i=  301,  400)/
     +  22608,22536,22392,22320,22152,21912,21912,22224,22296,22488,
     1  22464,22272,22272,22440,22224,22200,22032,21840,21672,21576,
     2  21864,21816,21624,21432,21288,21360,21144,21072,21048,21144,
     3  21120,21024,20952,20544,20352,20496,20856,21024,21072,21000,
     4  20808,20376,19272,18504,18504,18912,18936,18528,18360,18288,
     5  18480,18480,18336,18360,18312,17208,17472,17064,16944,16992,
     6  17424,17688,17952,18888,18600,18912,19344,20544,20376,20448,
     7  21528,21624,27576,27768,27936,28152,28344,28416,28536,29232,
     8  29280,28968,28776,28728,28752,28656,28512,28464,28464,28560,
     9  28896,28992,29160,29232,28992,28848,29088,29304,29328,29184/
            data (jx(i),i=  401,  500)/
     +  29448,29616,29784,29856,29976,30024,30288,30624,31680,31152,
     1  30936,30816,30336,30024,30168,30240,30312,30240,30264,30576,
     2  30792,30816,30984,31128,31200,31272,31200,31248,31368,31440,
     3  31368,31128,31128,31368,31512,31656,31824,31656,31536,31392,
     4  31320,31536,31632,31848,31896,31752,31728,31464,31392,31128,
     5  30912,30888,31104,31104,30720,30576,30528,30288,30216,30216,
     6  30384,30336,42720,42720,43008,43224,43272,43176,43584,43776,
     7  43992,44112,44088,43920,43872,43920,44208,44352,44328,44424,
     8  44568,44544,44616,44688,44880,45000,45312,45720,45840,46152,
     9  46488,46680,47256,47520,47616,47784,47664,47664,47856,47328/
            data (jx(i),i=  501,  600)/
     +  47160,47184,47136,46752,46632,46728,47064,46944,46968,46368,
     1  46296,46344,46680,46800,46920,46968,46920,46728,46488,46248,
     2  46056,46008,45456,45264,44832,44832,44904,45312,45504,45456,
     3  45336,44928,44856,44880,45048,45000,44832,44784,44832,44664,
     4  44544,44544,44664,44808,44904,44952,44952,45120,45336,45216,
     5  45072,44832,44544,44424,44304,44352,43992,43968,43704,43968,
     6  43872,43776,43824,43656,43728,44112,44040,46464,46608,46584,
     7  46440,44016,43464,43200,42888,42840,42936,42864,42624,42768,
     8  42720,42600,42264,42144,41832,41736,41448,41400,41424,41544,
     9  41496,42144,42576,42792,43368,43584,44088,44256,43944,42768/
            data (jx(i),i=  601,  700)/
     +  37824,34728,34128,35088,36216,36192,35592,35664,35232,35112,
     1  35184,35496,35640,35784,36216,36840,37056,39720,39672,38112,
     2  37968,37896,37944,38352,38328,38256,38304,38400,38568,38592,
     3  38544,38616,38712,38736,38808,39000,39264,39816,40656,41088,
     4  41352,41784,41880,41832,41856,42048,41928,42096,42072,42312,
     5  42480,42624,42696,42792,42984,43080,43080,43008,43104,43104,
     6  43056,43008,42864,42744,42864,42864,42768,42816,42792,42720,
     7  42624,42552,42552,42360,42048,41352,21528,34752,36552,37368,
     8  37320,37488,37152,36984,37392,38280,38112,37680,37560,37392,
     9  37344,37440,37560,37560,37440,37320,42888,43344,43872,43824/
            data (jx(i),i=  701,  800)/
     +  43368,43296,43272,43056,43128,42984,42696,42672,42888,43080,
     1  43128,42984,43032,43176,43512,43560,43632,43608,43776,43920,
     2  44208,43992,43872,43824,43848,43800,43464,43512,44016,44328,
     3  44352,44256,44280,44808,44952,45048,45072,44880,44880,44784,
     4  44760,44928,45096,45120,45264,45360,45480,45336,45360,45432,
     5  45504,22128,22296,22440,23280,23472,23688,23352,23304,23352,
     6  23544,23640,23496,23352,23472,23880,24144,24216,24168,24216,
     7  24144,24576,25152,25296,25224,25272,25368,25680,25800,25920,
     8  26088,26160,26376,27048,21792,22248,22224,22320,22416,23352,
     9  23256,23256,23064,23736,25608,25704,25536,25344,25056,25200/
            data (jx(i),i=  801,  900)/
     +  25248,25080,25200,25752,26760,26952,28200,28320,28560,28776,
     1  29160,29232,29376,29664,29832,29928,30048,30288,30504,30288,
     2  30120,30024,30072,30000,30456,31320,31512,31440,31488,31560,
     3  31464,31464,31680,32640,33144,33192,33408,33216,33216,33168,
     4  33720,33720,33936,22392,22416,22320,22464,22512,22632,22704,
     5  22680,22800,22896,22944,23016,23040,23328,23160,23184,23736,
     6  25704,27024,27312,27336,27240,27336,27384,27312,27312,27168,
     7  27120,26928,27216,28080,28176,28248,28392,28416,28368,28224,
     8  28560,28560,28728,28824,28824,29064,29208,29232,29160,28872,
     9  28752,28848,29040,29112,29088,29304,29544,29592,29712,29712/
            data (jx(i),i=  901, 1000)/
     +  29760,30216,29880,28872,28392,27984,27096,26304,25896,24888,
     1  24912,24360,24336,24264,24240,24096,24000,23856,23784,23688,
     2  23472,23472,22920,22944,22776,22824,22656,22680,30360,30144,
     3  29400,29256,29280,29424,29496,29880,29952,30384,30576,30864,
     4  25992,26304,26376,26736,27288,27624,27696,27792,27768,27864,
     5  27888,27960,27960,28104,27912,28992,28728,28584,28248,28848,
     6  28512,28920,29400,29688,30096,30384,30960,31008,31080,31152,
     7  30744,30408,31248,31416,31416,31272,31344,31200,31056,31104,
     8  30864,29712,29520,29712,26064,26040,31008,31104,31392,31488,
     9  31584,31800,31752,31944,32208,32160,32448,31920,31848,31824/
            data (jx(i),i= 1001, 1100)/
     +  31752,31776,31032,31008,31200,31464,31392,31464,31896,32064,
     1  31896,31800,31584,31440,31344,31296,31296,31152,31152,31080,
     2  31104,31032,31128,31008,30912,30888,30888,30192,30000,30000,
     3  30360,30336,30504,30528,31128,30888,31272,31344,31536,31824,
     4  31824,32136,32136,32328,32304,32376,30504,30552,30744,30720,
     5  32256,32856,33360,32808,32688,32904,32856,33312,33312,33696,
     6  34032,33360,33264,33048,33000,31944,31656,31776,32064,32520,
     7  32856,33048,33240,33336,33288,32784,33816,33696,33432,33336,
     8  33240,33120,33048,32664,32712,32616,32784,32760,32472,35016,
     9  33504,31968,31944,30744,30792,30720,30360,30312,30168,30024/
            data (jx(i),i= 1101, 1200)/
     +  30048,29928,29976,29880,30264,30312,31224,31728,31752,31824,
     1  32112,32352,32472,32544,32496,32616,32712,32832,32976,33168,
     2  33384,33384,33528,33888,35352,35184,34968,34824,34488,33312,
     3  33528,33816,34272,34440,34224,32616,32640,35064,34992,35088,
     4  35448,35664,35808,36192,36744,36816,36984,37056,37248,37752,
     5  41616,41904,42192,42552,37968,38496,38784,39024,39048,39168,
     6  39240,39240,40248,41328,41688,42168,41808,42552,42480,45072,
     7  51504,51384,51384,51264,51000,50664,50304,50232,50016,50160,
     8  50208,50160,49968,49920,49680,49680,49872,49920,49632,49272,
     9  48816,48792,48984,49104,49296,49728,49752,48720,48600,48648/
            data (jx(i),i= 1201, 1300)/
     +  48840,49152,49200,49008,49104,49224,49416,49584,49704,49896,
     1  50472,50592,50880,51528,51960,52152,52200,52128,52152,52032,
     2  51840,51816,51696,51624,51672,51792,52536,52800,52824,52344,
     3  52008,51768,51600,51552,51600,51696,51768,51864,51864,51720,
     4  51720,51576,51528,51600,52200,52512,52584,52464,52272,52176,
     5  52104,52128,50184,50064,49872,49560,49536,49920,49920,49992,
     6  50400,50472,50400,50160,50112,50016,49968,50088,50280,51408,
     7  51264,50640,50496,50016,49800,49800,49896,50184,50400,50616,
     8  50664,50808,51048,51144,51480,50088,50088,50448,50448,50616,
     9  51024,51240,51768,52056,52272,52368,52320,51624,51384,51264/
            data (jx(i),i= 1301, 1400)/
     +  51312,51552,51672,51864,52152,52080,52272,52392,52704,52632,
     1  52296,52416,52416,52464,52536,52680,52800,52920,52992,53400,
     2  53592,53496,53472,53568,53184,52872,52704,52368,51600,50472,
     3  50208,50088,50088,49992,49392,49560,49656,49656,49560,49488,
     4  49392,49344,48648,48768,48840,48936,49080,49368,49488,49512,
     5  49296,49176,49056,48840,48744,48624,48480,48480,48096,47952,
     6  47832,48120,48240,48456,45168,45240,45528,45528,45432,45168,
     7  45912,46344,46416,46416,46368,46080,45936,21792,21888,21984,
     8  22032,21984,21888,30192,30264,30240,30120,29784,29832,29928,
     9  30264,30336,30528,30600,30648,30336,30216,54120,53616,53592/
            data (jx(i),i= 1401, 1410)/
     +  54072,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  46464,35712,16920,51840,29304,54888,54960,54912,55128,55128,
     1  55200,55296,55344,55536,56016,55968,56112,56136,56112,56184,
     2  56136,55920,55824,56112,56232,56352,56256,56352,56976,57528,
     3  57528,57408,57504,57864,58344,58320,58248,58104,57888,57840,
     4  57672,57672,57936,57912,57264,57048,57000,57024,57312,57336,
     5  57192,56976,57120,57120,56952,56760,56424,56448,56640,56664,
     6  57024,57216,57456,57552,57624,57408,57456,57984,58176,58344,
     7  58584,58920,59160,59424,59424,59280,59280,59400,59616,59616,
     8  59712,59448,59448,59520,54168,50592,52536,43080,32280,16752,
     9  45096,58032,54576,54288,54168,54192,54408,54480,54504,54408/
            data (jy(i),i=  101,  200)/
     +  54096,54096,53976,53640,53400,53352,53208,53184,53352,53592,
     1  53640,53472,53304,53184,53112,53160,53088,53040,52920,52680,
     2  52560,52584,52776,53040,53040,53232,52944,52848,52872,52824,
     3  52776,52752,52584,52560,52488,52416,52248,52224,52296,52368,
     4  52320,51768,51696,51480,51456,51408,51312,51288,51144,50640,
     5  50808,51048,51096,51264,51072,50880,50808,50856,50784,50640,
     6  50880,50904,50832,50544,50448,50376,50136,50040,49992,50352,
     7  50448,50400,50256,49992,49704,49536,49512,49536,49632,49632,
     8  48864,48888,48552,48480,49248,49488,49536,49968,49944,49848,
     9  49752,49728,49536,49656,49608,49440,49344,49056,48912,48504/
            data (jy(i),i=  201,  300)/
     +  48408,48336,48312,48168,48048,47976,47952,47352,46224,46128,
     1  45984,45888,45888,45984,45936,46032,45888,45912,45888,45168,
     2  51984,52128,52344,52680,52728,52608,52296,52200,52224,52344,
     3  52488,52800,52944,53064,53400,53712,53808,53832,53712,53544,
     4  53472,53592,53304,53064,52944,52944,52872,53160,53184,53112,
     5  52920,52728,52272,52344,52632,52776,52848,52968,53136,53352,
     6  53472,53952,54264,54600,54744,55056,55320,55536,55704,55944,
     7  56184,56232,56376,56640,56616,56664,56520,56592,56688,56784,
     8  56904,57096,57072,57264,57288,57672,57672,57576,57312,57144,
     9  57144,57000,56808,56712,56496,56424,56184,56160,56280,56376/
            data (jy(i),i=  301,  400)/
     +  56280,55872,55896,56088,56112,55560,55512,55488,55272,55248,
     1  55128,55104,55008,54816,54744,54672,54672,54576,54624,54768,
     2  55368,55392,55248,55008,54528,54216,54288,54192,53976,53832,
     3  53712,53712,53832,53784,53856,53856,54288,54384,54552,54624,
     4  54600,54360,53952,53832,53688,53688,53400,52560,52440,52560,
     5  52896,53040,53328,53640,53784,53664,53088,52488,52104,51816,
     6  51072,50088,49824,49560,48432,47856,47520,47664,46872,46608,
     7  45816,40248,51384,51264,51288,51336,51648,51576,51600,51960,
     8  51912,51576,51600,51576,51312,51192,51192,51096,51024,51000,
     9  51168,51336,51240,51072,50736,50376,50352,50232,50304,50520/
            data (jy(i),i=  401,  500)/
     +  50904,50928,50664,50424,50424,50592,50424,50472,54792,54672,
     1  53904,53664,53304,53208,52560,52560,52752,52896,53064,53208,
     2  53208,53376,53544,53592,53568,53448,53280,53232,53280,53040,
     3  52992,53016,52800,52584,52536,52608,52416,52296,52272,52344,
     4  52296,51960,51936,52032,51960,51840,51744,51768,51912,52080,
     5  52104,52008,51720,51408,50928,50904,51072,51288,51288,51120,
     6  50832,50688,58200,58272,58128,57960,58128,58248,58296,57888,
     7  57672,57672,57888,58008,58104,58224,58368,58176,57936,57768,
     8  57936,58056,58248,58224,57864,57864,58008,57888,57984,57960,
     9  58080,57912,57792,57408,57312,57408,57480,57600,57888,58296/
            data (jy(i),i=  501,  600)/
     +  58608,58752,59040,59040,59112,59184,59208,59760,59952,60000,
     1  60072,60144,60240,60240,60144,60168,60552,60840,61080,61224,
     2  61128,61296,61584,61584,62016,62136,62208,62304,62232,62400,
     3  62639,62855,63071,63287,63527,63695,63911,64127,64271,64223,
     4  64319,64511,64775,64799,64559,64535,64367,64343,64439,64607,
     5  64631,64919,65471,65567,66143,66479,67391,67799,68735,69167,
     6  69215,69143,69239,69527,69551,69407,69023,68471,68927,69047,
     7  69239,69551,69767,69671,69647,69551,69287,69167,69215,68951,
     8  68903,68879,68975,69311,69287,69407,69215,69263,69383,69479,
     9  69527,69383,69455,69719,69815,69839,69623,69791,70439,70847/
            data (jy(i),i=  601,  700)/
     +  70031,67511,65015,63263,64703,65591,65591,65015,65327,65591,
     1  66023,66575,66719,66863,67031,67151,66335,66767,67823,67487,
     2  67607,67727,67895,68183,68399,68495,68615,68495,68519,68423,
     3  68351,68159,68255,68447,68543,68423,68423,68591,68639,68303,
     4  67895,66719,66671,66503,66335,66215,66047,65663,65543,65063,
     5  64799,64727,64775,64583,64439,64415,64343,64247,63983,63695,
     6  62951,62831,62783,63383,63599,63791,63911,64007,64103,64079,
     7  63935,63479,62328,61512,60672,59784,12840, 9480, 9072, 9240,
     8  11496,38016,37992,45096,20784,20784,21600,21672,21792,21768,
     9  22608,24288,24336,24696,24888,25680,57672,57792,57432,57336/
            data (jy(i),i=  701,  800)/
     +  57648,57648,57504,57336,57072,56808,56832,56784,56448,56592,
     1  56544,56304,56280,56376,56688,56712,56616,56496,56520,56688,
     2  56688,56328,56256,56256,56376,56352,55920,55872,56040,56208,
     3  56160,55992,55920,55992,55896,55920,55776,55632,55344,55200,
     4  54984,54816,55032,55200,55320,55344,55152,55032,54936,54912,
     5  54768,46824,46776,46536,48000,47832,48120,48216,48264,48384,
     6  48480,48624,49608,49896,49944,50328,50448,50352,50232,50088,
     7  49968,49752,49704,49872,50280,50304,50280,50400,50256,50328,
     8  50232,50112,50112,50616,35784,36240,36312,36360,36456,36480,
     9  36696,37872,37872,39744,39576,40296,40248,40296,40536,40752/
            data (jy(i),i=  801,  900)/
     +  40968,41208,41904,42096,41616,41904,41688,41256,40944,41352,
     1  40896,40992,40944,40632,40776,40992,41016,41136,41352,41568,
     2  41928,42480,42624,42984,43008,42720,42720,42576,42264,42144,
     3  41928,41784,41352,41136,41496,41928,41952,42240,42768,42840,
     4  42960,43296,43296,16944,17352,18168,18096,18144,18120,17952,
     5  17760,17712,17736,17520,17520,17424,17736,18000,18072,18192,
     6  17808,51576,51408,51336,51240,51144,51000,51000,50904,50856,
     7  50904,50736,50736,50400,50208,50280,50184,50016,49920,49968,
     8  49752,49848,49896,50064,49968,49848,49488,49320,49176,49152,
     9  48936,48912,48648,48384,48312,48216,48360,48312,48360,48480/
            data (jy(i),i=  901, 1000)/
     +  48528,29040,29088,29016,29184,29496,29328,30096,29688,29496,
     1  29760,29664,29784,29808,29880,29856,30312,30312,30240,30312,
     2  30264,30336,30240,30024,30024,29784,29736,29520,48432,48168,
     3  48864,49080,49368,49368,49296,49224,49080,48864,48648,48000,
     4  19464,19488,19584,19536,19608,21264,21408,21408,21504,21504,
     5  21408,21384,21528,21528,22488,22464,23832,24240,26040,26160,
     6  27960,28080,28128,28272,28296,28416,28368,28296,28320,28368,
     7  28824,28920,17520,17424,17376,17256,17064,16872,16848,16752,
     8  16464,16344,16392,17304,17952,17760,53952,53856,53808,53952,
     9  53736,53832,53712,53544,53688,53976,54240,54816,54864,54912/
            data (jy(i),i= 1001, 1100)/
     +  54912,54864,48144,48312,48312,48576,48696,48792,48864,49080,
     1  49224,49152,49416,49416,49320,49368,49560,49656,49728,49728,
     2  49848,50064,50208,50352,50304,50352,50520,29184,29448,29544,
     3  29616,29664,29688,29640,29736,30792,30744,30960,30816,30816,
     4  30720,30768,30840,30864,30744,30696,18288,19272,19296,19464,
     5  19560,19056,19728,19968,20712,20736,21048,21096,21264,21264,
     6  22872,22800,23160,23184,23376,23712,24048,24264,24312,24000,
     7  23928,24096,24192,24408,24864,27624,27792,28368,28296,28320,
     8  28608,28608,28680,29688,29736,29856,29904,30096,30264,50064,
     9  52632,52728,52584,47952,47928,47760,47616,47376,47400,47304/
            data (jy(i),i= 1101, 1200)/
     +  47040,46920,46872,46632,45672,45648,46056,46176,45672,45720,
     1  45720,45504,45600,45552,45456,45360,45384,45504,45192,44496,
     2  44544,44088,43824,43536,43008,43056,42912,42936,43320,30048,
     3  29976,30000,31104,31128,32208,17520,17472,17040,16416,16416,
     4  16488,16608,16416,16416,16608,16680,16656,16776,16704,45384,
     5  59136,58512,58032,58224,50712,51408,51672,51648,51744,51768,
     6  51720,51840,52128,51096,51480,51312,53064,53400,53712,54528,
     7  61056,61008,60696,60528,60504,60384,60456,60216,59880,59880,
     8  59736,59592,59568,59472,59472,59568,59664,59832,59712,59712,
     9  59496,59400,59160,59088,59184,58872,58800,58944,58872,58656/
            data (jy(i),i= 1201, 1300)/
     +  58416,58512,58440,58224,57912,57768,57720,57384,57264,57144,
     1  56952,56712,56616,56232,56256,56232,56136,56064,55920,55848,
     2  55968,56088,56088,55368,55032,54936,55560,56016,56184,56328,
     3  56688,57912,59232,60360,60528,63911,63935,64127,64223,64223,
     4  64343,64439,64151,63911,64559,64895,65279,65327,65303,65183,
     5  64919,64655,53736,54480,54600,54528,54504,54024,53688,53664,
     6  52920,52992,53256,53520,53328,53376,53328,53232,52920,61584,
     7  61656,61584,61632,61584,61488,61416,61200,61080,61104,60912,
     8  60648,60720,60672,61080,61296,68351,68303,68327,68663,68735,
     9  68711,68639,68303,68087,67823,67967,68087,68735,68783,68951/
            data (jy(i),i= 1301, 1400)/
     +  69071,69215,69215,68807,68903,68639,68471,68183,67895,67751,
     1  67535,66839,65927,65783,65783,65975,66023,65711,65735,66767,
     2  67631,67847,68279,69215,69983,70103,70103,69959,69503,68951,
     3  68687,68687,68567,68351,54696,54744,54840,55152,55224,55248,
     4  55200,54936,55944,55824,55680,55632,55440,55368,55416,55608,
     5  55848,56136,56208,56136,56376,56496,56760,56880,57312,57240,
     6  56976,56736,56400,56208,61968,61824,61848,62016,62064,62016,
     7  54744,54720,54816,55104,55128,54912,54888,54816,54792,54840,
     8  54984,55056,55032,51576,51672,51744,51840,51888,51720,51648,
     9  52320,52296,52080,52128,52296,52464,52392,55056,55032,55872/
            data (jy(i),i= 1401, 1410)/
     +  55896,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
     1     16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
     2     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     3     36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     4     46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
     5     56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
     6     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     7     76,   77,   78,   79,   80,   81,   82,   83,   93,   94,
     8     95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
     9    105,  106,  107,  108,  109,  110,  111,  112,  113,  114/
            data (jb1(i),i=  101,  200)/
     +    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     1    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     2    135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
     3    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     4    155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
     5    165,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     6    175,  176,  177,  178,  179,  180,  181,  182,  183,  184,
     7    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     8    195,  196,  197,  198,  199,  200,  201,  202,  203,  204,
     9    205,  206,  207,  208,  209,  210,  211,  212,  213,  214/
            data (jb1(i),i=  201,  300)/
     +    215,  216,  217,  218,  219,   91,    4,  221,  222,  223,
     1    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     2    234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
     3    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     4    254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
     5    264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
     6    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     7    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     8    294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
     9    304,  305,  306,  307,  308,  309,  310,  311,  312,  313/
            data (jb1(i),i=  301,  400)/
     +    314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
     1    324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
     2    334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
     3    344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
     4    354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
     5    364,  365,  366,  367,  368,  369,    1,    3,    1,  371,
     6      2,    2,    4,  373,  374,  375,  376,  377,  378,  379,
     7    380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     8    390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
     9    400,  401,  402,  403,  404,  405,  406,  407,   86,    6/
            data (jb1(i),i=  401,  500)/
     +    409,   85,   85,  411,  412,  413,  414,  415,  416,  417,
     1    418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
     2    428,  429,  430,  431,  432,  433,  434,  435,   87,   87,
     3    437,  438,  439,  440,  441,  442,  443,  444,  445,  446,
     4    447,  448,  449,  450,  451,  452,  453,  454,  455,  456,
     5    457,  458,  459,  460,  461,   86,   92,  463,  464,  465,
     6    466,  467,  468,  469,  470,  471,  472,  473,  474,  475,
     7    476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
     8    486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
     9    496,  497,  498,  499,  500,  501,  502,  503,  504,  505/
            data (jb1(i),i=  501,  600)/
     +    506,  507,  508,  509,  510,  511,  512,  513,  514,  515,
     1    516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
     2    526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
     3    536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
     4    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     5    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     6    566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
     7    576,  577,  578,  579,  580,  581,  582,  583,  584,  585,
     8    586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
     9    596,  597,  598,  599,  600,  601,  602,  603,  604,  605/
            data (jb1(i),i=  601,  700)/
     +    606,  607,  608,  609,  610,  611,  612,  613,  614,  615,
     1    616,  617,  618,  619,  620,  621,  622,  623,  624,  625,
     2    626,  627,  628,  629,  630,  631,  632,  633,  634,  635,
     3    636,  637,  638,  639,  640,  641,  642,  643,  644,  645,
     4    646,  647,  648,  649,  650,  651,  652,  653,  654,  655,
     5    656,  657,  658,  659,  660,  661,  662,  663,  664,  665,
     6    666,  667,  668,  669,  670,  671,  672,  673,  674,  675,
     7     84,    3,  677,  678,  679,  680,   90,   88,  682,   89,
     8     88,   91,   90,  685,  686,  687,  688,  689,  690,  691,
     9    692,  693,  694,  695,   89,   92,  697,  698,  699,  700/
            data (jb1(i),i=  701,  800)/
     +    701,  702,  703,  704,  705,  706,  707,  708,  709,  710,
     1    711,  712,  713,  714,  715,  716,  717,  718,  719,  720,
     2    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     3    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     4    741,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     5     93,    1,  752,  753,  754,  755,  756,  757,  758,  759,
     6    760,  761,  762,  763,  764,  765,  766,  767,  768,  769,
     7    770,  771,  772,  773,  774,  775,  776,  777,  778,  779,
     8    780,  781,  782,  783,    2,  785,  786,  787,  788,  789,
     9    790,  791,  792,  793,  794,  795,  796,  797,  798,  799/
            data (jb1(i),i=  801,  900)/
     +    800,  801,  802,  803,  804,  805,  806,  807,  808,  809,
     1    810,  811,  812,  813,  814,  815,  816,  817,  818,  819,
     2    820,  821,  822,  823,  824,  825,  826,  827,  828,  829,
     3    830,  831,  832,  833,  834,  835,  836,  837,  838,  839,
     4    840,  841,  842,    3,  844,  845,  846,  847,  848,  849,
     5    850,  851,  852,  853,  854,  855,  856,  857,  858,  859,
     6    860,    4,  862,  863,  864,  865,  866,  867,  868,  869,
     7    870,  871,  784,  784,  873,  874,  875,  876,  877,  878,
     8    879,  880,  881,  882,  883,  884,  885,  886,  887,  888,
     9    889,  890,  891,  892,  893,  894,  895,  896,  897,  898/
            data (jb1(i),i=  901, 1000)/
     +    899,  900,  902,  903,  904,  905,  906,  907,  908,  909,
     1    910,  911,  912,  913,  914,  915,  916,  917,  918,  919,
     2    920,  921,  922,  923,  924,  925,  926,  927,  928,  929,
     3    901,  901,  931,  932,  933,  934,  935,  936,  937,  938,
     4    929,  929,  861,  941,  942,  943,  944,  945,  946,  947,
     5    948,  949,  950,  951,  952,  953,  954,  955,  956,  957,
     6    958,  959,  960,  961,  962,  963,  964,  965,  966,  967,
     7    968,  969,  970,  971,  902,  973,  974,  975,  976,  977,
     8    978,  979,  980,  981,  982,  983,  984,  985,  861,   85,
     9    987,  988,  989,  990,  991,  992,  993,  994,  995,  996/
            data (jb1(i),i= 1001, 1100)/
     +    997,  998,  999, 1000, 1001,    6,  940, 1003, 1004, 1005,
     1   1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015,
     2   1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025,
     3   1026, 1027,  902, 1028, 1029, 1030, 1031, 1032, 1033, 1034,
     4   1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044,
     5   1045,  973, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054,
     6   1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064,
     7   1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074,
     8   1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084,
     9   1085, 1086, 1087, 1088, 1046, 1090, 1091, 1092, 1093,  940/
            data (jb1(i),i= 1101, 1200)/
     +   1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103,
     1   1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113,
     2   1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123,
     3    843,   88, 1125, 1126, 1127, 1128,  843, 1046, 1130, 1131,
     4   1132, 1133, 1134, 1135,  973, 1136, 1137, 1138, 1139, 1140,
     5   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149,   91,
     6   1090,   84, 1151, 1152, 1153, 1154, 1090, 1155, 1156, 1157,
     7   1158, 1159, 1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167,
     8   1168, 1169,   93,    1,    2,    3,    4,    5,    6,    7,
     9      8,    9,   10,   11,   12,   13,   14,   15,   16,   17/
            data (jb1(i),i= 1201, 1300)/
     +     18,   19,   20,   21,   22,   23,   24,   25,   26,   27,
     1     28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
     2     38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
     3     48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
     4     58,   59,   60,   61,   62,   63,   64,    1,   66,   67,
     5     68,   69,   70,   71,   72,   73,   66,   75,   76,   77,
     6     78,   79,   80,   81,   75,   83,   84,   85,   86,   87,
     7     88,   89,   83,   91,   92,   93,   94,   95,   96,   97,
     8     98,   91,  100,  101,  102,  103,  104,  105,  106,  107,
     9    108,  109,  110,  111,  112,  113,  114,  100,  116,  117/
            data (jb1(i),i= 1301, 1400)/
     +    118,  119,  120,  121,  122,  123,  124,  125,  126,  127,
     1    128,  129,  130,  131,  132,  133,  134,  135,  136,  137,
     2    138,  139,  140,  141,  142,  143,  144,  145,  146,  147,
     3    148,  149,  150,  151,  152,  153,  154,  155,  156,  157,
     4    158,  159,  160,  161,  162,  163,  116,  165,  166,  167,
     5    168,  169,  170,  171,  165,  173,  174,  175,  176,  177,
     6    178,  179,  180,  181,  182,  183,  184,  185,  186,  187,
     7    188,  189,  190,  191,  192,  193,  173,  195,  196,  197,
     8    198,  199,  195,  201,  202,  203,  204,  205,  206,  201,
     9    208,  209,  210,  211,  212,  208,  214,  215,  216,  217/
            data (jb1(i),i= 1401, 1420)/
     +    218,  219,  214,  221,  222,  223,  224,  225,  226,  221,
     1    228,  229,  230,  228,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
     1     17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
     2     27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
     3     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     4     47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
     5     57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
     6     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     7     77,   78,   79,   80,   81,   82,   83,   84,   94,   95,
     8     96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
     9    106,  107,  108,  109,  110,  111,  112,  113,  114,  115/
            data (jb2(i),i=  101,  200)/
     +    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     1    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     2    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     3    146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
     4    156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
     5    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     6    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     7    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     8    196,  197,  198,  199,  200,  201,  202,  203,  204,  205,
     9    206,  207,  208,  209,  210,  211,  212,  213,  214,  215/
            data (jb2(i),i=  201,  300)/
     +    216,  217,  218,  219,  220,  220,  221,  222,  223,  224,
     1    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     2    235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     3    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     4    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     5    265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
     6    275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
     7    285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
     8    295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
     9    305,  306,  307,  308,  309,  310,  311,  312,  313,  314/
            data (jb2(i),i=  301,  400)/
     +    315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
     1    325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
     2    335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
     3    345,  346,  347,  348,  349,  350,  351,  352,  353,  354,
     4    355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
     5    365,  366,  367,  368,  369,  370,  370,    5,  371,  372,
     6    372,    5,  373,  374,  375,  376,  377,  378,  379,  380,
     7    381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
     8    391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
     9    401,  402,  403,  404,  405,  406,  407,  408,  408,  409/
            data (jb2(i),i=  401,  500)/
     +    410,  410,  411,  412,  413,  414,  415,  416,  417,  418,
     1    419,  420,  421,  422,  423,  424,  425,  426,  427,  428,
     2    429,  430,  431,  432,  433,  434,  435,  436,  436,  437,
     3    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     4    448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
     5    458,  459,  460,  461,  462,  462,  463,  464,  465,  466,
     6    467,  468,  469,  470,  471,  472,  473,  474,  475,  476,
     7    477,  478,  479,  480,  481,  482,  483,  484,  485,  486,
     8    487,  488,  489,  490,  491,  492,  493,  494,  495,  496,
     9    497,  498,  499,  500,  501,  502,  503,  504,  505,  506/
            data (jb2(i),i=  501,  600)/
     +    507,  508,  509,  510,  511,  512,  513,  514,  515,  516,
     1    517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     2    527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     3    537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
     4    547,  548,  549,  550,  551,  552,  553,  554,  555,  556,
     5    557,  558,  559,  560,  561,  562,  563,  564,  565,  566,
     6    567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
     7    577,  578,  579,  580,  581,  582,  583,  584,  585,  586,
     8    587,  588,  589,  590,  591,  592,  593,  594,  595,  596,
     9    597,  598,  599,  600,  601,  602,  603,  604,  605,  606/
            data (jb2(i),i=  601,  700)/
     +    607,  608,  609,  610,  611,  612,  613,  614,  615,  616,
     1    617,  618,  619,  620,  621,  622,  623,  624,  625,  626,
     2    627,  628,  629,  630,  631,  632,  633,  634,  635,  636,
     3    637,  638,  639,  640,  641,  642,  643,  644,  645,  646,
     4    647,  648,  649,  650,  651,  652,  653,  654,  655,  656,
     5    657,  658,  659,  660,  661,  662,  663,  664,  665,  666,
     6    667,  668,  669,  670,  671,  672,  673,  674,  675,  676,
     7    676,  677,  678,  679,  680,  681,  681,  682,  683,  683,
     8    684,  684,  685,  686,  687,  688,  689,  690,  691,  692,
     9    693,  694,  695,  696,  696,  697,  698,  699,  700,  701/
            data (jb2(i),i=  701,  800)/
     +    702,  703,  704,  705,  706,  707,  708,  709,  710,  711,
     1    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     2    722,  723,  724,  725,  726,  727,  728,  729,  730,  731,
     3    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     4    742,  743,  744,  745,  746,  747,  748,  749,  750,  751,
     5    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     6    761,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     7    771,  772,  773,  774,  775,  776,  777,  778,  779,  780,
     8    781,  782,  783,  784,  785,  786,  787,  788,  789,  790,
     9    791,  792,  793,  794,  795,  796,  797,  798,  799,  800/
            data (jb2(i),i=  801,  900)/
     +    801,  802,  803,  804,  805,  806,  807,  808,  809,  810,
     1    811,  812,  813,  814,  815,  816,  817,  818,  819,  820,
     2    821,  822,  823,  824,  825,  826,  827,  828,  829,  830,
     3    831,  832,  833,  834,  835,  836,  837,  838,  839,  840,
     4    841,  842,  843,  844,  845,  846,  847,  848,  849,  850,
     5    851,  852,  853,  854,  855,  856,  857,  858,  859,  860,
     6    861,  862,  863,  864,  865,  866,  867,  868,  869,  870,
     7    871,  872,  872,  873,  874,  875,  876,  877,  878,  879,
     8    880,  881,  882,  883,  884,  885,  886,  887,  888,  889,
     9    890,  891,  892,  893,  894,  895,  896,  897,  898,  899/
            data (jb2(i),i=  901, 1000)/
     +    900,  901,  903,  904,  905,  906,  907,  908,  909,  910,
     1    911,  912,  913,  914,  915,  916,  917,  918,  919,  920,
     2    921,  922,  923,  924,  925,  926,  927,  928,    5,  930,
     3    930,  931,  932,  933,  934,  935,  936,  937,  938,  939,
     4    939,  940,  941,  942,  943,  944,  945,  946,  947,  948,
     5    949,  950,  951,  952,  953,  954,  955,  956,  957,  958,
     6    959,  960,  961,  962,  963,  964,  965,  966,  967,  968,
     7    969,  970,  971,  972,  972,  974,  975,  976,  977,  978,
     8    979,  980,  981,  982,  983,  984,  985,  986,  986,  987,
     9    988,  989,  990,  991,  992,  993,  994,  995,  996,  997/
            data (jb2(i),i= 1001, 1100)/
     +    998,  999, 1000, 1001, 1002, 1002, 1003, 1004, 1005, 1006,
     1   1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016,
     2   1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026,
     3   1027,   86, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035,
     4   1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045,
     5   1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055,
     6   1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065,
     7   1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075,
     8   1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085,
     9   1086, 1087, 1088, 1089, 1089, 1091, 1092, 1093,   87, 1094/
            data (jb2(i),i= 1101, 1200)/
     +   1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104,
     1   1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114,
     2   1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123, 1124,
     3   1124, 1125, 1126, 1127, 1128, 1129, 1129, 1130, 1131, 1132,
     4   1133, 1134, 1135,   89, 1136, 1137, 1138, 1139, 1140, 1141,
     5   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149,   90, 1150,
     6   1150, 1151, 1152, 1153, 1154,   92, 1155, 1156, 1157, 1158,
     7   1159, 1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168,
     8   1169, 1170, 1170,    2,    3,    4,    5,    6,    7,    8,
     9      9,   10,   11,   12,   13,   14,   15,   16,   17,   18/
            data (jb2(i),i= 1201, 1300)/
     +     19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
     1     29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
     2     39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     3     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     4     59,   60,   61,   62,   63,   64,   65,   65,   67,   68,
     5     69,   70,   71,   72,   73,   74,   74,   76,   77,   78,
     6     79,   80,   81,   82,   82,   84,   85,   86,   87,   88,
     7     89,   90,   90,   92,   93,   94,   95,   96,   97,   98,
     8     99,   99,  101,  102,  103,  104,  105,  106,  107,  108,
     9    109,  110,  111,  112,  113,  114,  115,  115,  117,  118/
            data (jb2(i),i= 1301, 1400)/
     +    119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
     1    129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
     2    139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
     3    149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
     4    159,  160,  161,  162,  163,  164,  164,  166,  167,  168,
     5    169,  170,  171,  172,  172,  174,  175,  176,  177,  178,
     6    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     7    189,  190,  191,  192,  193,  194,  194,  196,  197,  198,
     8    199,  200,  200,  202,  203,  204,  205,  206,  207,  207,
     9    209,  210,  211,  212,  213,  213,  215,  216,  217,  218/
            data (jb2(i),i= 1401, 1420)/
     +    219,  220,  220,  222,  223,  224,  225,  226,  227,  227,
     1    229,  230,  231,  231,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine mi(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1820) :: jx,jy
            integer(kind=iknd), save, dimension(1900) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'michigan      '/
            data jrot,ipart/0,4/
            data kv/   1, 592,1193,1257,1817/
            data kb/   1, 659,1273,1338,1898/
            data iib/ 458, 551,  62, 560,   0/
            data (jx(i),i=    1,  100)/
     +  39792,37704,47976,42696,35976,48528,35712,31896,34560,48672,
     1  30984,47280,30048,45264,29832,48048,46680,29664,30864,31272,
     2  52272,30888,50424,30336,40128,37176,46872,34032,31248,43080,
     3  42264,41928,41664,41592,41712,41664,41520,41424,40968,40848,
     4  39864,39480,39432,39504,39480,39360,39264,39168,38904,38784,
     5  38616,38112,38160,38328,38376,38448,38568,38568,38376,38256,
     6  38184,37776,37536,37560,37680,37968,38376,38328,38352,38664,
     7  38784,38736,38328,38208,38040,47760,47928,47976,47736,47568,
     8  47496,47472,47376,47328,47400,47304,47280,47016,46944,46680,
     9  46608,46488,46104,45960,45816,45792,45720,45504,45600,45408/
            data (jx(i),i=  101,  200)/
     +  44712,44016,43824,43656,43512,43464,43368,42888,37464,37080,
     1  36792,36672,36480,36048,35976,34584,34488,34488,34608,34728,
     2  34752,34704,34536,34464,34584,34728,34800,34944,34944,34728,
     3  34752,34632,34728,34800,34872,34968,34968,35160,35040,34800,
     4  34704,34608,34440,34272,34248,34056,33840,33768,33648,33648,
     5  33528,33144,32952,32712,32496,32496,32544,32496,32400,32208,
     6  32136,31920,31824,31896,31944,48528,48288,48048,47976,47880,
     7  47760,47712,47616,47640,47736,47808,47640,47736,48024,48144,
     8  48168,48288,48624,48792,48720,48480,48456,48384,48552,48408,
     9  48432,48312,48168,48048,48720,48648,48672,48792,48864,48720/
            data (jx(i),i=  201,  300)/
     +  48696,36048,36144,36120,36048,36096,36000,35616,35376,35352,
     1  35232,34944,35040,35208,35328,35400,35448,35568,35520,35424,
     2  35256,35184,34992,35016,35064,35208,35208,34896,34824,34704,
     3  31824,31848,31776,31656,31416,30840,30816,31056,48624,48408,
     4  48144,47976,47904,48000,47880,47688,47544,47424,30912,31032,
     5  30888,30888,30792,30360,30240,29640,29760,29880,29760,29760,
     6  29640,29280,29472,29736,30000,45312,45384,45456,45552,45600,
     7  45696,45864,45912,45888,45960,46128,46200,46248,46248,46296,
     8  46656,46608,46680,46656,46728,47064,47256,47160,47304,53352,
     9  53280,53112,53040,52992,52776,52728,52416,52224,52128,52032/
            data (jx(i),i=  301,  400)/
     +  51552,51240,51096,50976,50808,50616,50544,50400,50088,49728,
     1  49200,49152,48912,48552,48384,48384,48816,48840,48672,48480,
     2  48504,48432,48360,48192,45240,45336,45216,45216,45144,45144,
     3  45120,45072,45120,45048,45216,45480,45768,45888,46344,47904,
     4  47760,47760,47712,47544,47448,46992,46800,29736,29232,29184,
     5  29208,29472,54240,54096,53880,53544,53424,30432,30528,30552,
     6  30696,31008,31032,31272,30912,30768,30504,30504,30408,29856,
     7  54384,54792,54840,54624,54528,54576,54504,54624,54528,54384,
     8  54240,54144,53592,53712,53712,53496,53304,53040,31152,52152,
     9  52200,52344,52488,52656,52752,52728,52800,52512,52512,52608/
            data (jx(i),i=  401,  500)/
     +  52872,52920,31272,31128,31176,31056,30576,52128,51912,51552,
     1  51360,51072,50760,50808,50712,50592,50640,50496,50448,50400,
     2  50424,50400,50328,50424,50304,50304,50088,49944,50064,50040,
     3  49992,49776,49656,49584,49536,49512,49368,49416,49248,49080,
     4  48912,48912,49032,48984,48864,48792,48888,48720,48720,48768,
     5  48696,48648,29568,28800,28200,27432,40248,40272,39912,38448,
     6  38448,38280,37992,37704,45024,42816,42096,39912,39912,39168,
     7  36984,36984,45096,42168,39288,39192,39264,36072,36168,36408,
     8  36480,36480,36600,31896,33480,45216,39360,42264,36432,33480,
     9  45336,33528,43608,42384,40920,39408,38016,36504,32184,35088/
            data (jx(i),i=  501,  600)/
     +  35136,43656,44424,44400,32232,43704,42504,42504,41016,38064,
     1  35208,48072,50208,41088,32256,43776,46704,44496,44520,45960,
     2  45960,42552,42552,43800,39624,38160,35232,33816,32280,50328,
     3  48888,48936,48264,48264,46824,33840,45384,45360,42672,42672,
     4  39744,36816,36768,33120,33096,50616,51360,48432,47016,46968,
     5  45552,44064,42792,42792,41280,39816,38352,36888,35400,33936,
     6  50904,47976,47256,44328,44280,41376,40656,38424,37032,35496,
     7  34080,37104,48168,46680,44424,42960,49728,49848,49968,40776,
     8  40032,34128,31224,31200,34200,34032,50424,51192,50352,51096,
     9  52896,33048,33240,33360,33792,34056,34104,34272,34584,34992/
            data (jx(i),i=  601,  700)/
     +  35208,35496,35592,35712,35808,35928,36000,36168,36624,36960,
     1  37008,37080,37152,37272,37608,38112,38520,38664,38856,38928,
     2  39120,39120,39216,39336,39624,39696,39960,39768,39840,39744,
     3  39864,39720,39864,40008,39960,40008,39960,40128,40392,40464,
     4  40608,40632,40704,40848,40920,40920,40944,41040,41064,41208,
     5  41232,41328,41304,41400,41496,41616,41640,42000,41952,42096,
     6  42192,42360,42408,42312,42456,42504,42792,42720,32880,32712,
     7  32688,32784,32232,31800,31536,31368,31080,30888,30648,30576,
     8  30360,30288,30336,30192,30168,30216,30120,29808,29712,29736,
     9  29664,29520,24744,25320,25728,25752,25968,25920,25728,25872/
            data (jx(i),i=  701,  800)/
     +  25824,26088,26016,25944,25992,25920,25992,25992,26136,26328,
     1  26208,26424,26496,26544,26592,26592,26640,26688,26640,26544,
     2  26640,26640,26400,26280,26448,26472,26424,26496,26544,26664,
     3  26784,26832,26928,27120,27288,27264,27384,27384,27504,27456,
     4  27600,27672,27576,27624,27864,28008,28080,28416,28416,28512,
     5  28536,28704,28824,28944,29088,29136,29040,28968,28944,28800,
     6  28944,28896,28752,28680,28584,28512,28560,28512,28488,28584,
     7  28560,28488,28416,28320,28272,28320,28272,28032,28032,28152,
     8  28248,28344,28536,28656,28680,28608,28536,28632,28776,28752,
     9  28824,29064,29160,29088,29184,29088,29112,29256,29376,29400/
            data (jx(i),i=  801,  900)/
     +  21288,21504,21528,21672,21432,21408,21672,21600,21552,21384,
     1  21360,21504,21528,21648,21192,21168,21240,21000,21072,21096,
     2  21240,21336,21792,22176,22392,22440,22176,22080,22056,21984,
     3  21960,21864,21912,22224,22368,22728,22656,22704,22824,23088,
     4  23688,23736,23880,23952,24360,24336,24600,19728,19848,19800,
     5  19824,19968,19608,19656,19992,20424,20496,20472,20640,21120,
     6  32952,33504,35112,36576,32400,32448,32352,32280,32328,31608,
     7  31512,31344,31248,29976,29568,29448,29064,28896,28896,28680,
     8  28608,28440,28320,28344,28056,27912,27888,27768,27576,27384,
     9  27096,26904,26736,26640,26640,26496,26304,26208,26184,26016/
            data (jx(i),i=  901, 1000)/
     +  25848,25632,25440,25368,25200,24768,24264,24024,24024,24120,
     1  24144,24096,24024,24096,24048,23928,23808,23640,23616,23376,
     2  23280,23280,23184,22920,22872,22608,22464,22512,22416,22392,
     3  22320,22248,22128,22056,22008,21864,21792,21600,21336,21072,
     4  20544,20256,14616,15504,15672,15696,15792,15792,16080,16152,
     5  16152,16296,16416,16488,16752,16848,16968,17040,17376,17544,
     6  17688,17952,18192,18408,18480,18576,18720,18912,19152,19248,
     7  17904,17976,17688,17616,17640,17568,17496,16968,16872,16800,
     8  16920,16848,16608,16080,15864,15648,15408,15120,20088,19440,
     9  19296,19056,18816,19176,19488,19776,19704,19440,19104,18432/
            data (jx(i),i= 1001, 1100)/
     +  18336,18336,18240,18168,18264,18264,17976,17832,17712,17616,
     1  17712,17808,17712,17760, 9504, 8712, 7800, 7008, 6816, 6336,
     2   6504, 6720, 6840, 6960, 6936, 7152, 7200, 7488, 7800, 7824,
     3   8016, 7992,14040, 9912,10368,10800,11112,11496,12120,12312,
     4  13440,13968,14256,14616,14616,14760,14976,37032,37656,38016,
     5  38280,38016,37872,37800,37872,37704,37752,37920,38256,38424,
     6  38520,38880,38976,39072,39408,39936,40200,40560,40416,40392,
     7  40560,40968,40992,41088,41184,41256,41256,41520,41688,41712,
     8  41904,42120,42408,42480,42648,42696,42840,42936,42912,42816,
     9  42744,42744,42624,42552,42456,42432,42528,42432,42408,42552/
            data (jx(i),i= 1101, 1200)/
     +  42576,42552,42744,42864,42888,42960,42960,43056,43152,43224,
     1  43224,43320,43344,43464,43680,43872,43848,43752,43680,43632,
     2  43944,44040,44160,44232,44304,44400,44376,44472,44496,44616,
     3  44688,44592,44592,44520,44496,44424,44400,44160,44088,43944,
     4  43536,43392,24144,24144,24384,24360,16464,16536,17304,17328,
     5  15072,15480,15456,14712,14640,14640,12432,12480,10296,10320,
     6   9576, 9648,19776,19800,20544,20544,20232,32976,30048,30072,
     7  28584,28584,25632,36696,37416,37440,41856,41904,42624,42648,
     8  19752,33000,22656,22704,24888,24888,29328,29328,29520,22176,
     9  22200,22656,17592,19248,19152,19176,19104,19032,18912,18792/
            data (jx(i),i= 1201, 1300)/
     +  18504,18384,18144,18024,18072,18024,17952,17808,17808,17856,
     1  18216,18288,17880,18048,18168,18192,18120,17784,17712,17616,
     2  16992,16848,16968,16944,17208,18120,18432,18744,18960,19224,
     3  19320,20400,20328,20736,21432,21384,21672,21864,22200,22224,
     4  21984,21888,21744,21624,21432,20856,20760,20928,20904,20760,
     5  20496,20208,19656,19296,18816,18816,48864,48840,48792,50664,
     6  50688,50664,50616,50520,50472,50544,50592,50592,50544,50568,
     7  50520,50472,50472,50472,50424,50424,53712,53592,53496,53592,
     8  53832,53832,53904,53952,53808,53808,53664,53520,53448,53664,
     9  53856,53928,54120,54216,54360,53952,53472,53448,53424,53688/
            data (jx(i),i= 1301, 1400)/
     +  53856,53904,53616,53616,53640,53832,53712,53424,53376,53352,
     1  53472,53472,53616,47904,47856,47880,48216,48312,48240,48096,
     2  48168,48120,31632,31824,31896,31752,31776,31536,31368,31368,
     3  31464,48504,48504,48384,48384,32472,32496,32352,32088,31968,
     4  31896,31944,32304,32592,49056,49032,49008,49224,49104,49152,
     5  48624,48576,48528,48600,48312,48240,48312,28536,28584,28560,
     6  28368,28344,28416,33552,33528,33648,33672,33600,33312,33336,
     7  33264,33192,33000,33264,35328,35328,35232,35280,35232,35112,
     8  35256,35184,34992,34848,34872,34800,34800,34608,34632,34512,
     9  34512,34560,34920,35064,35112,35304,28248,28128,28104,28176/
            data (jx(i),i= 1401, 1500)/
     +  34320,34320,34392,34080,34032,34128,34080,34224,33264,33264,
     1  33192,33216,37224,37176,37224,41712,41208,40896,40656,40632,
     2  40680,40968,41136,41568,41640,41616,41760,42024,41952,41832,
     3  41832,35496,35496,35592,35592,38064,38040,38088,35280,35064,
     4  35112,35016,35208,35256,35184,35256,35328,35376,35400,35496,
     5  35448,35496,35472,35424,34152,34104,34152,36120,36072,35976,
     6  35856,36000,35952,36000,35952,36048,36480,36360,36360,36480,
     7  40464,40632,40512,38976,38928,39000,40272,40416,40560,40536,
     8  40440,40248,41568,41520,41496,41544,41832,41904,41784,41832,
     9  41904,41976,41952,42048,41928,41808,41760,41856,41496,41568/
            data (jx(i),i= 1501, 1600)/
     +  41616,41520,41664,41784,41784,45408,45240,45096,45144,45024,
     1  45072,44976,44832,44760,44832,44928,44928,45024,45000,45072,
     2  45000,45048,45168,45240,45216,45288,45264,45360,45456,45528,
     3  45552,45624,45672,45696,45768,45864,45912,46152,46248,46320,
     4  46248,46344,46344,46440,46392,46560,46656,46752,46776,46872,
     5  46968,47184,47112,46992,46872,46800,46728,46680,46536,46488,
     6  46392,46200,45672,45624,45984,45960,46008,45960,45864,46008,
     7  45720,45600,45432,40968,40944,40968,42528,42432,42552,42576,
     8  42288,42240,42360,45120,45072,45120,40488,40320,40344,40488,
     9  40728,40680,40608,40632,40704,42168,42096,42024,42072,42048/
            data (jx(i),i= 1601, 1700)/
     +  42192,42384,42336,42360,42528,42456,42504,42216,42168,42288,
     1  45456,45504,45552,45456,45504,45480,45408,45360,44976,44880,
     2  44928,45240,45216,45264,44736,44736,44784,44088,44016,44040,
     3  44160,45792,45744,45816,45216,45144,45096,45360,45288,45288,
     4  45336,45432,45432,45480,42624,42600,42648,43056,43008,43032,
     5  43344,43176,42984,42744,42744,42840,42744,42912,42984,43080,
     6  43056,43128,43152,43200,43008,42960,42984,42912,42936,42864,
     7  42600,42456,42384,42432,42384,42240,42264,42504,42600,42696,
     8  42864,43080,43200,43104,43032,42888,42816,43008,43080,43104,
     9  43128,43296,43200,43008,42936,28560,28608,28632,28536,28440/
            data (jx(i),i= 1701, 1800)/
     +  28416,28440,28320,28272,28152,28152,28080,28008,28176,28344,
     1  28512,28392,28512,27024,26952,27000,27048,28032,27960,28008,
     2  39936,39912,39960,27888,27816,27936,23928,23856,23928,20856,
     3  20496,20448,20448,20784,20856,22944,22728,22584,22848,17088,
     4  16992,16992,18048,17712,18264,17736,18024,17736,17640,17664,
     5  17496,17400,17448,16944,17112,16920,16920,16824,16848,16752,
     6  16632,16704,16656,16320,16248,15960,15960,15792,15744,15792,
     7  15504,15024,13920,13680,13680,13992,14040,13944,13704,13800,
     8  13584,13752,13824,14040,15408,15480,15216,15048,14952,14928,
     9  15360,15216,15600,15912,16320,16752,16872,17040,17376,17376/
            data (jx(i),i= 1801, 1820)/
     +  17280,17376,17352,17112,17424,17400,17472,16032,16128,16128,
     1  16176,16176,16056,13440,13656,13488,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  41400,37776,36792,40248,36384,33840,33432,32856,32688,30912,
     1  30480,27888,27600,25656,24528,24312,23040,21600,18600,15648,
     2  13584,12696, 9912,11208, 7248, 7176, 7152, 7128, 7104, 6888,
     3  40416,40368,40440,40392,40320,40248,40320,40272,40632,40776,
     4  41232,41376,41328,41232,41184,41040,41088,41016,41112,41016,
     5  41112,41112,41064,41064,40992,40992,40800,40728,40488,40440,
     6  40248,39984,39576,39168,38760,38400,38232,38280,38304,38280,
     7  38160,37992,37800,37824,37752,37224,37176,37320,37464,37704,
     8  37704,37800,37776,37872,37920,38040,37872,38016,37944,37944,
     9  38040,38040,38256,38424,38424,38352,38424,38400,38472,38448/
            data (jy(i),i=  101,  200)/
     +  39024,39072,39000,39048,39216,39552,39720,40224,37848,37728,
     1  37512,37344,37368,36912,36600,32904,33168,33552,33912,33960,
     2  34488,34488,34320,34392,34656,34800,35064,34968,35112,35376,
     3  35472,35688,35856,35904,35928,35760,35952,36168,36408,36144,
     4  36120,36192,35952,35616,35400,35160,35040,34800,34704,34392,
     5  34176,34128,34344,34368,33984,33912,33912,33768,33720,33816,
     6  33912,33864,33600,33096,33096,34032,34080,34200,34344,34392,
     7  34560,34872,34944,35088,35040,35088,35184,35472,35664,35664,
     8  35544,35400,35280,35280,35424,35496,35760,35760,35832,36048,
     9  36240,36264,36408,36720,31200,31512,31848,32160,32616,32856/
            data (jy(i),i=  201,  300)/
     +  33384,35904,35568,35208,35064,34656,34080,33144,32928,32664,
     1  32496,32544,33024,33240,33312,33480,34248,34272,34512,34536,
     2  34392,34008,33744,33672,33744,33744,33720,33048,32640,32616,
     3  32856,32568,32424,32304,32328,31944,31632,31032,29328,29352,
     4  29016,28680,28632,28776,28896,28872,28776,28584,30216,30216,
     5  30144,29616,29016,28200,27864,25680,25488,25512,25560,25632,
     6  25704,26520,26760,26976,27408,25776,25776,26088,26136,26328,
     7  26424,26448,26400,26328,26400,26328,26376,26352,26472,26520,
     8  26376,26664,26712,26808,26880,26976,26928,27192,27408,24144,
     9  24888,25368,25440,25632,25896,26112,26640,26808,26808,26952/
            data (jy(i),i=  301,  400)/
     +  27072,27264,27216,27240,27072,27048,26832,26664,26664,26472,
     1  26400,26112,25896,25824,25824,25776,25728,25584,25344,25272,
     2  25152,24984,24936,24504,25224,25152,25176,24552,24480,24576,
     3  24408,24456,24336,24336,23880,23544,23448,23352,23280,23976,
     4  23952,24144,24168,23832,23784,23136,22968,24072,23352,23088,
     5  22704,22152,19776,20280,22032,22896,23400,19512,19560,19464,
     6  19440,19656,19824,19920,19800,19656,19704,19584,19584,20856,
     7  19224,18480,18168,17808,17424,17064,16776,16296,16152,15192,
     8  15000,15072,15144,15384,15480,15480,15648,15552,17520,13824,
     9  14184,14448,14592,14592,14544,14760,14784,14976,15144,15312/
            data (jy(i),i=  401,  500)/
     +  15360,15480,15000,14400,14160,13320,11688,13032,12744,12720,
     1  12528,12408,12000,11928,11760,11688,11520,11112,10656,10656,
     2  10392,10344,10368,10080, 9936, 9624, 9432, 9456, 9360, 9144,
     3   9072, 9144, 9072, 8928, 8616, 8688, 8712, 8568, 8472, 8088,
     4   7992, 7800, 7368, 7368, 7824, 7752, 7560, 7536, 7464, 7416,
     5   7392, 7296,10080, 8280, 7632, 7080, 7248, 6696,37176,37128,
     6  36984,36984,37512,37512,36600,36504,36480,36432,35688,35688,
     7  35640,36384,33672,33576,33504,34944,34944,33432,33240,33072,
     8  33096,33384,33432,32688,32664,30720,30552,30624,30504,30456,
     9  27792,27504,27720,27672,27624,27576,27576,27576,27504,27528/
            data (jy(i),i=  501,  600)/
     +  24552,26328,25632,26352,24504,24888,24840,24744,24696,24600,
     1  21600,23688,23856,21744,21576,22704,22032,22704,22344,22368,
     2  22008,21792,21912,21960,21696,21672,20160,20112,20112,20904,
     3  20808,20064,20016,19944,19872,19368,19056,19800,18912,18840,
     4  18768,18696,20160,18624,19368,17208,17280,17016,16152,16896,
     5  16080,16008,15936,15888,15840,15816,15768,15720,15696,15672,
     6  13464,13224,13176,13008,13008,12888,12864,12816,12768,12744,
     7  12720, 9816,10272,10176,10032, 9984,10416,10248,10248, 9888,
     8   9888, 9744, 9744,11208, 7488, 7272,20904,19488,20544,20592,
     9  17376,42792,42792,42888,42768,42744,42792,42792,43368,43824/
            data (jy(i),i=  601,  700)/
     +  43920,43848,43944,43968,43920,43752,43872,43896,43656,43608,
     1  43536,43656,43536,43560,43368,43248,42792,42552,42504,42408,
     2  42312,42192,42072,42072,41832,41904,41928,42120,42144,42480,
     3  42528,42744,42984,42984,43104,43272,43440,43656,43560,43464,
     4  43440,43488,43512,43440,43296,43032,42960,43008,43200,43200,
     5  43080,42984,43320,43272,43320,43248,43296,43032,43272,43224,
     6  43272,43056,43080,43248,43152,43200,43056,43200,42768,42624,
     7  42504,42384,42648,42744,42744,42648,42720,42576,42576,42408,
     8  42264,41928,41808,41592,41376,41328,41256,41280,41208,41136,
     9  41016,40992,39192,40176,40344,40464,40536,40560,40488,40560/
            data (jy(i),i=  701,  800)/
     +  40584,40848,40872,40968,41112,41160,41208,41424,41616,41712,
     1  41832,42096,42312,42264,42312,42240,42360,42312,42192,42216,
     2  42120,41976,41616,41568,41208,40872,40512,40392,40200,40488,
     3  40488,40440,40560,40560,40656,40848,40968,41064,41112,41232,
     4  41280,41424,41616,41832,41880,41616,41688,41616,41664,41688,
     5  41904,41976,42168,42144,42024,41808,41640,41616,41400,41256,
     6  41088,41064,41136,41088,41184,41160,41064,41088,40992,41016,
     7  40848,40920,40704,40728,40632,40512,40416,40344,40128,40056,
     8  39864,39768,39744,39624,39672,39768,40128,40200,40176,40272,
     9  40584,40560,40656,40728,40776,40824,40896,40944,40896,41016/
            data (jy(i),i=  801,  900)/
     +  40680,40584,40488,40320,40176,40104,39720,39360,39336,39384,
     1  39336,39168,38952,38736,38280,38184,38016,37584,37560,37656,
     2  37464,37536,37512,37848,37680,37464,37056,36792,36600,36552,
     3  36360,36216,36024,35784,35472,35376,35520,35832,35976,36192,
     4  37032,37200,37344,37632,38136,38328,38784,42408,42336,42240,
     5  42072,41976,41568,41448,41208,41328,41208,41112,40992,40944,
     6  48936,48840,48840,49536,48816,48768,48768,48768,48840,48600,
     7  48624,48768,48744,47832,47664,47712,47280,47232,47160,46872,
     8  46872,46512,46560,46776,46776,46944,47040,47088,47064,46728,
     9  46728,46968,46944,47040,47136,47448,47544,47544,47472,47400/
            data (jy(i),i=  901, 1000)/
     +  47400,47208,47232,47304,47184,47160,47280,47520,47616,47592,
     1  47640,47664,47856,48048,47976,48048,48024,48192,48432,48504,
     2  48744,48888,48912,49224,49656,49944,49872,49920,49968,50184,
     3  50184,50040,50040,50136,50376,50352,50496,50592,50568,50760,
     4  50736,50784,43992,43392,43344,43416,43416,43272,43368,43320,
     5  43248,43272,43224,43032,43008,43272,43176,43224,43272,43032,
     6  43104,42912,43008,42864,42744,42768,42672,42768,42600,42672,
     7  51048,51480,51864,51864,52296,52464,52512,52608,52728,53040,
     8  53352,53496,53424,52920,52824,52608,52512,51888,50856,50736,
     9  50664,50208,50016,50688,50904,51216,51264,51168,50952,50352/
            data (jy(i),i= 1001, 1100)/
     +  50400,50496,50424,50280,50280,50184,49824,49536,49488,49584,
     1  49752,49752,50160,50616,49824,49104,48840,48552,48576,48264,
     2  48000,48024,48144,48024,47832,47856,47712,47688,47064,46872,
     3  46416,46248,44328,50184,50304,50352,50232,50376,50352,50400,
     4  50976,51600,51528,51672,51600,51624,51720,49632,49608,49728,
     5  49704,49440,49176,48264,47832,47568,47448,47256,47208,47328,
     6  47160,47160,47016,46968,47064,47352,47328,46872,46968,46800,
     7  46728,46944,47040,46920,46944,47088,47256,47424,47472,47520,
     8  47544,47424,46944,46608,46296,45768,45600,45360,45312,45384,
     9  45384,45288,45144,45192,45144,45096,45048,45048,44976,44880/
            data (jy(i),i= 1101, 1200)/
     +  44928,44784,44688,44712,44808,44784,44880,44784,44856,44736,
     1  44832,44856,44664,44592,44568,44472,44400,44376,44280,44136,
     2  43752,43728,43536,43512,43608,43560,43632,43488,43536,43488,
     3  43296,43008,43080,43080,43152,43104,43056,43056,42912,43008,
     4  43056,43200,42888,42144,42144,39192,46680,50328,50328,51072,
     5  49656,49632,48912,48936,46704,45960,46056,47496,47592,48312,
     6  48360,49824,46608,48816,48816,49536,49536,47328,47304,45840,
     7  45840,44376,44352,45216,45216,44472,44616,43872,43920,43176,
     8  45144,45144,42912,45120,42888,44352,44376,42144,42144,40680,
     9  42168,42168,54000,53256,53088,52752,52704,52776,52704,52392/
            data (jy(i),i= 1201, 1300)/
     +  52224,51696,51408,51384,51576,51528,51672,51792,52056,52176,
     1  52488,53232,52704,52824,52848,52656,52488,52296,52344,52584,
     2  52680,53016,53208,53592,53664,54696,54888,54984,55152,55224,
     3  55368,55536,55560,55608,55488,55560,55560,55464,55272,54912,
     4  54960,54840,54864,54768,54888,54816,54696,54456,54384,54336,
     5  54144,54048,53424,53304,53976,53256, 7320, 7368, 7320,11328,
     6  10848,10512,10416,10416,10728,11112,10344,10392,10368,10320,
     7  10320,10344,10296,10224,10248,10176,14544,14496,14376,14544,
     8  14568,14640,14568,14640,14688,14640,14808,14640,14640,14832,
     9  14880,15048,15048,14976,15048,14496,14952,14976,14952,14880/
            data (jy(i),i= 1301, 1400)/
     +  14904,15072,15220,15048,15120,15048,14976,14880,14904,14856,
     1  14736,14688,14832,24576,24576,24528,25584,25488,25488,26856,
     2  26808,26736,34992,34920,34824,34800,34608,34488,34560,34656,
     3  34896,34224,34344,34344,34224,35280,35760,35904,35952,35904,
     4  35712,35376,34992,35088,35448,35496,35424,35448,35520,35400,
     5  35688,35712,35592,35592,36720,36672,36648,39168,39288,39384,
     6  39504,39408,39144,38736,38664,38496,38688,38760,37872,38016,
     7  38184,38280,38328,37776,39960,40128,40344,40512,40776,40872,
     8  40968,41016,40992,41064,40872,40776,40632,40392,40032,39888,
     9  39600,39528,39432,39504,39624,39768,39744,39744,39672,39600/
            data (jy(i),i= 1401, 1500)/
     +  40680,40872,40896,40920,40848,40704,40512,40512,40608,40488,
     1  40464,40608,40392,40416,40416,40896,40992,41424,41592,41640,
     2  41712,41616,41640,41472,41496,41664,41424,41352,41136,41064,
     3  40968,41160,41064,41064,41184,41232,41160,41136,41568,41640,
     4  41424,41376,41400,41304,41208,41160,41232,41184,41232,41208,
     5  41280,41328,41400,41376,41232,41184,41160,41424,41232,41160,
     6  41184,41376,41424,41496,41544,41544,41496,41496,41376,41376,
     7  41856,41736,41736,42048,42024,41976,42240,42216,42024,41952,
     8  41904,42000,42624,42672,42624,42552,43104,43032,42984,42960,
     9  42984,42888,42888,42816,42768,42840,42792,42696,42912,42912/
            data (jy(i),i= 1501, 1600)/
     +  43032,43200,43104,43104,43152,43512,43248,43320,43416,43440,
     1  43536,43608,43440,43104,43104,43320,43152,43176,43080,43080,
     2  42984,42984,43080,43008,42936,42912,42864,42840,43008,43008,
     3  42912,42888,42888,42984,42840,42936,42864,42960,43080,43008,
     4  42840,42864,42936,42912,42816,42744,42792,42744,42840,42768,
     5  42840,43368,43464,43416,43536,43536,43848,43944,43992,44208,
     6  44160,44304,44256,44136,44016,44016,43920,43848,43776,43752,
     7  43752,43608,43608,42936,42936,42912,42960,42936,42888,42936,
     8  42984,42912,42888,42888,42912,42936,42984,43032,42864,42936,
     9  42888,42984,42960,42888,42864,42984,43176,43152,43008,42936/
            data (jy(i),i= 1601, 1700)/
     +  42936,43008,43032,42984,43080,43080,43032,43176,43176,43104,
     1  43968,43944,43848,43776,43848,43896,43776,43848,43872,43872,
     2  43824,43872,43920,43920,43968,43920,43944,44112,44136,44064,
     3  44016,43992,44016,44040,44304,44304,44208,44232,44256,44208,
     4  44184,44160,44232,44184,44760,44808,44808,45096,45096,45024,
     5  45408,45960,46056,46008,45936,45960,45792,45624,45384,45264,
     6  45144,45120,45264,45264,45120,45096,45144,46296,46416,46416,
     7  46632,47232,47280,47160,47136,47328,47424,47592,47760,47832,
     8  47760,47808,47712,47616,47280,47184,46848,46608,46392,46368,
     9  46440,46080,46056,46104,46152,47184,47184,47016,46896,46848/
            data (jy(i),i= 1701, 1800)/
     +  46896,47040,47016,46848,46872,47256,47304,47640,47784,47784,
     1  47568,47136,47064,47160,47136,47064,47088,47112,47112,47040,
     2  47376,47424,47448,47424,47376,47280,48192,48192,48120,51096,
     3  51312,51264,51216,51024,51024,55032,55128,55032,54960,60600,
     4  60600,60672,61392,61248,61656,61344,61632,61416,61392,61488,
     5  61296,61272,61344,61176,61320,61200,61152,61104,61080,61080,
     6  60816,60984,61008,60840,60672,60576,60528,60456,60480,60552,
     7  60336,60168,59592,59376,59232,59448,59424,59304,59208,59160,
     8  58920,58872,58728,58656,59184,59280,59184,59232,59208,59352,
     9  59568,59568,59712,59928,59976,60144,60336,60336,60600,60744/
            data (jy(i),i= 1801, 1820)/
     +  60720,60768,60816,60696,61488,61512,61488,59520,59592,59520,
     1  59184,59208,59112,59040,59088,59112,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      4,   31,   32,   33,   34,   35,   36,   37,   38,   39,
     1     40,    1,    1,   42,   43,   44,   45,   46,   47,   48,
     2     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     3     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     4     69,   70,   71,   72,   73,   74,    2,    3,   76,   77,
     5     78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
     6     88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
     7     98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
     8      4,    2,  109,  110,  111,  112,  113,  114,    5,    9,
     9    116,  117,  118,  119,  120,  121,  122,  123,  124,  125/
            data (jb1(i),i=  101,  200)/
     +    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     1    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     2    146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
     3    156,  157,  158,  159,  160,  161,  162,  163,  164,    8,
     4      6,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     5    175,  176,  177,  178,  179,  180,  181,  182,  183,  184,
     6    185,  186,  187,  188,  189,  190,  191,  192,  193,    3,
     7     10,  195,  196,  197,  198,  199,  200,    6,    5,  202,
     8    203,  204,  205,  206,    7,    7,  208,  209,  210,  211,
     9    212,  213,  214,  215,  216,  217,  218,  219,  220,  221/
            data (jb1(i),i=  201,  300)/
     +    222,  223,  224,  225,  226,  227,  228,  229,    9,    8,
     1    231,  232,  233,  234,  235,  236,  237,   11,   10,  239,
     2    240,  241,  242,  243,  244,  245,  246,  247,   12,   11,
     3    249,  250,  251,  252,  253,  254,   13,   15,  256,  257,
     4    258,  259,  260,  261,  262,  263,  264,   13,   14,  266,
     5    267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
     6    277,  278,  279,  280,  281,  282,  283,  284,  285,  286,
     7    287,  288,   12,  290,  291,  292,  293,  294,  295,  296,
     8    297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
     9    307,  308,  309,  310,  311,  312,  313,  314,  315,  316/
            data (jb1(i),i=  301,  400)/
     +    317,  318,  319,  320,  321,  322,  323,   16,   14,  325,
     1    326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
     2    336,  337,  338,   17,   16,  340,  341,  342,  343,  344,
     3    345,  346,   17,   15,  348,  349,  350,  351,   18,  353,
     4    354,  355,  356,  290,   19,  358,  359,  360,  361,  362,
     5    363,  364,  365,  366,  367,  368,  369,   18,  353,  371,
     6    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     7    382,  383,  384,  385,  386,  387,   19,   20,   21,  390,
     8    391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
     9    401,  388,   20,  403,  404,  405,   22,   24,   22,   21/
            data (jb1(i),i=  401,  500)/
     +    408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     1    418,  419,  420,  421,  422,  423,   23,   23,  425,  426,
     2    427,  428,  429,  430,  431,  432,  433,  434,  435,  436,
     3    437,  438,  439,  440,  441,  442,  443,  444,  445,  446,
     4    447,  448,  449,  450,  451,   27,   25,   26,   28,   24,
     5    453,  454,  455,   29,   27,   25,  457,   30,  459,  459,
     6    460,  461,  462,  463,  464,  465,  465,  466,  466,  467,
     7    459,  468,  469,  470,  471,  472,  473,  465,  473,  467,
     8    474,  470,  476,  475,    7,  478,  479,  480,  481,  482,
     9    475,    8,  484,  485,  473,  475,  474,  486,  486,  487/
            data (jb1(i),i=  501,  600)/
     +    487,  480,  489,  485,  490,  486,  490,  491,  491,  493,
     1    488,  494,  487,  495,  496,  489,  497,   13,  498,  492,
     2    492,  500,  493,   14,  503,  502,  499,  502,  506,  507,
     3    508,  495,  509,  497,  501,  501,  505,  501,   16,  512,
     4    509,  505,  506,  517,  516,  518,  519,  520,  517,  522,
     5    523,  516,  514,  514,  525,  510,  511,  515,  511,  527,
     6    528,  515,  530,  531,  532,  533,  534,  517,  528,  537,
     7    535,  537,  522,  539,  540,  525,  541,  527,  542,   19,
     8    544,  536,  546,  546,  534,  549,  548,  549,  537,  551,
     9    552,  540,  553,  554,  555,  541,  556,  557,  542,  558/
            data (jb1(i),i=  601,  700)/
     +    559,  536,  560,  561,  546,  561,  562,  549,  563,  564,
     1    552,  565,  555,  566,  567,  557,  568,  569,  559,  570,
     2    571,  569,  562,  573,  574,  564,  575,  573,  577,  578,
     3    579,  576,  567,  580,  572,  572,  571,  583,  584,  582,
     4    581,  572,  574,  582,  585,  586,  583,  576,  513,  530,
     5    513,  353,  530,  589,  588,  547,  388,  547,    1,    2,
     6      3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
     7     13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
     8     23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
     9     33,   34,   35,   36,   37,   38,   39,   40,   41,   42/
            data (jb1(i),i=  701,  800)/
     +     43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
     1     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     2     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     3     73,   74,   75,   76,    1,   78,   79,   80,   81,   82,
     4     83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
     5     93,   94,   95,   96,   97,   98,   99,  100,  102,  103,
     6    104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
     7    114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
     8    124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
     9    134,  135,  136,  137,  138,  139,  140,  141,  142,  143/
            data (jb1(i),i=  801,  900)/
     +    144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
     1    154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
     2    164,  165,  166,  167,  168,  169,  170,  171,  172,  173,
     3    174,  175,  176,  177,  178,  179,  180,  181,  182,  183,
     4    184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
     5    194,  195,  196,  197,  198,  199,  200,  201,  202,  203,
     6    204,  205,  206,  207,  208,  101,  210,  211,  212,  213,
     7    214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
     8    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     9    234,  235,  236,  237,  238,  239,  240,  241,  242,  243/
            data (jb1(i),i=  901, 1000)/
     +    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     1    254,  255,  102,  257,  258,  259,  260,  261,  262,  263,
     2    264,  265,  266,  267,  268,  210,  270,  271,  272,  270,
     3    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     4    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     5    294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
     6    304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
     7    314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
     8    324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
     9    334,  335,  336,  337,  338,  339,  340,  341,  342,  343/
            data (jb1(i),i= 1001, 1100)/
     +    344,  345,  346,  347,  348,  349,  350,  352,  353,  354,
     1    355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
     2    365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
     3    375,  376,  377,  378,  257,  380,  381,  382,  383,  384,
     4    385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
     5    395,  396,  351,  398,  399,  400,  401,  402,  403,  404,
     6    405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
     7    415,  416,  417,  418,  419,  420,  421,  422,  380,  424,
     8    425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
     9    435,  436,  437,  438,  439,  440,  441,  352,  424,  443/
            data (jb1(i),i= 1101, 1200)/
     +    444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
     1    454,  455,  397,  273,  457,  458,  459,  460,  461,  462,
     2    463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
     3    473,  474,  475,  476,  477,  478,  479,  480,  481,  482,
     4    483,  484,  485,  486,  487,  488,  489,  490,  491,  492,
     5    493,  494,  495,  496,  497,  498,  499,  500,  501,  502,
     6    503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
     7    513,  514,  515,  516,  517,  518,  519,  520,  521,  522,
     8    523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
     9    533,  534,  535,  536,  537,  538,  539,  540,  541,  542/
            data (jb1(i),i= 1201, 1300)/
     +    543,  544,  545,  546,  547,  548,  549,  550,   77,  552,
     1    553,  554,  102,  556,  557,  558,  380,  397,  560,  561,
     2    562,  563,  565,  566,  567,  568,  569,  570,  424,  572,
     3    573,  574,  575,  351,  270,  577,  578,  579,  580,  556,
     4    556,  311,  564,  583,  584,  585,  586,  587,  588,   77,
     5    273,  572,  583,  577,  352,  581,  592,  590,  552,  552,
     6    594,  582,    1,  257,  581,  596,  597,  101,  210,  599,
     7    600,  592,    2,    3,    4,    5,    6,    7,    8,    9,
     8     10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
     9     20,   21,   22,   23,   24,   25,   26,   27,   28,   29/
            data (jb1(i),i= 1301, 1400)/
     +     30,   31,   32,    1,    1,   34,   35,   36,   37,   38,
     1     39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     2     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     3     59,   60,   61,    2,    1,   63,   64,    1,    2,    1,
     4      4,    5,    6,    7,    8,    9,    4,   11,   12,   13,
     5     11,   15,   16,   15,   18,   19,   18,   21,   22,   23,
     6     24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
     7     34,   35,   36,   37,   38,   39,   21,   41,   42,   41,
     8     44,   45,   46,   47,   48,   49,   50,   44,   52,   53,
     9     52,   55,   56,   55,   58,   59,   58,   61,   62,   61/
            data (jb1(i),i= 1401, 1500)/
     +     64,   65,   64,   67,   68,   69,   70,   71,   72,   73,
     1     74,   67,   76,   77,   78,   76,   80,   81,   82,   83,
     2     84,   85,   86,   87,   80,   89,   90,   89,   92,   93,
     3     92,   95,   96,   97,   95,   99,  100,   99,  102,  103,
     4    104,  105,  106,  102,  108,  109,  110,  111,  108,  113,
     5    114,  115,  116,  117,  113,  119,  120,  121,  122,  123,
     6    124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
     7    134,  135,  136,  137,  138,  139,  119,  141,  142,  143,
     8    141,  145,  146,  147,  148,  149,  150,  151,  145,  153,
     9    154,  155,  153,  157,  158,  157,  160,  161,  162,  163/
            data (jb1(i),i= 1501, 1600)/
     +    164,  165,  166,  167,  168,  169,  170,  171,  172,  173,
     1    174,  160,  176,  177,  178,  176,  180,  181,  180,  183,
     2    184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
     3    194,  195,  196,  197,  183,  199,  200,  199,  202,  203,
     4    204,  205,  206,  207,  208,  209,  202,  211,  212,  213,
     5    211,  215,  216,  215,  218,  219,  218,  221,  222,  223,
     6    224,  225,  221,  227,  228,  229,  227,  231,  232,  233,
     7    234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
     8    244,  245,  246,  247,  248,  231,  250,  251,  252,  253,
     9    254,  255,  256,  257,  258,  259,  260,  261,  262,  263/
            data (jb1(i),i= 1601, 1700)/
     +    264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
     1    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     2    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     3    294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
     4    304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
     5    314,  315,  316,  250,  318,  319,  318,  321,  322,  323,
     6    321,  325,  326,  325,  328,  329,  328,  331,  332,  333,
     7    331,  335,  336,  337,  338,  335,  340,  341,  342,  343,
     8    344,  340,  346,  347,  346,  349,  350,  349,  352,  353,
     9    352,  355,  356,  357,  358,  359,  360,  361,  355,  363/
            data (jb1(i),i= 1701, 1800)/
     +    364,  363,  366,  367,  366,  369,  370,  369,  372,  373,
     1    374,  372,  376,  377,  376,  379,  380,  379,  382,  383,
     2    384,  382,  386,  387,  386,  389,  390,  389,  392,  393,
     3    392,  395,  396,  397,  398,  399,  400,  401,  402,  403,
     4    404,  405,  406,  407,  395,  409,  410,  409,  412,  413,
     5    414,  415,  416,  417,  418,  419,  420,  421,  422,  423,
     6    424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
     7    434,  435,  436,  437,  438,  412,  440,  441,  442,  443,
     8    444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
     9    454,  455,  456,  440,  458,  459,  460,  458,  462,  463/
            data (jb1(i),i= 1801, 1900)/
     +    462,  465,  466,  465,  468,  469,  468,  471,  472,  471,
     1    474,  475,  476,  477,  478,  474,  480,  481,  482,  480,
     2    484,  485,  486,  487,  488,  489,  490,  491,  492,  493,
     3    494,  495,  496,  497,  498,  499,  500,  501,  502,  503,
     4    504,  505,  506,  507,  508,  509,  510,  511,  512,  513,
     5    514,  515,  516,  517,  518,  519,  520,  521,  522,  523,
     6    524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
     7    534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
     8    544,  545,  546,  547,  484,  549,  550,  549,  552,  553,
     9    552,  555,  556,  555,  558,  559,  558,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     1     41,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     2     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     3     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     4     70,   71,   72,   73,   74,   75,   75,   76,   77,   78,
     5     79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
     6     89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
     7     99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
     8    108,  109,  110,  111,  112,  113,  114,  115,  115,  116,
     9    117,  118,  119,  120,  121,  122,  123,  124,  125,  126/
            data (jb2(i),i=  101,  200)/
     +    127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
     1    137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
     2    147,  148,  149,  150,  151,  152,  153,  154,  155,  156,
     3    157,  158,  159,  160,  161,  162,  163,  164,  165,  165,
     4    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     5    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     6    186,  187,  188,  189,  190,  191,  192,  193,  194,  194,
     7    195,  196,  197,  198,  199,  200,  201,  201,  202,  203,
     8    204,  205,  206,  207,  207,  208,  209,  210,  211,  212,
     9    213,  214,  215,  216,  217,  218,  219,  220,  221,  222/
            data (jb2(i),i=  201,  300)/
     +    223,  224,  225,  226,  227,  228,  229,  230,  230,  231,
     1    232,  233,  234,  235,  236,  237,  238,  238,  239,  240,
     2    241,  242,  243,  244,  245,  246,  247,  248,  248,  249,
     3    250,  251,  252,  253,  254,  255,  255,  256,  257,  258,
     4    259,  260,  261,  262,  263,  264,  265,  265,  266,  267,
     5    268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
     6    278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
     7    288,  289,  289,  291,  292,  293,  294,  295,  296,  297,
     8    298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
     9    308,  309,  310,  311,  312,  313,  314,  315,  316,  317/
            data (jb2(i),i=  301,  400)/
     +    318,  319,  320,  321,  322,  323,  324,  324,  325,  326,
     1    327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
     2    337,  338,  339,  339,  340,  341,  342,  343,  344,  345,
     3    346,  347,  347,  348,  349,  350,  351,  352,  352,  354,
     4    355,  356,  357,  357,  358,  359,  360,  361,  362,  363,
     5    364,  365,  366,  367,  368,  369,  370,  370,  371,  372,
     6    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     7    383,  384,  385,  386,  387,  388,  389,  389,  390,  391,
     8    392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
     9    402,  402,  403,  404,  405,  406,  406,  407,  407,  408/
            data (jb2(i),i=  401,  500)/
     +    409,  410,  411,  412,  413,  414,  415,  416,  417,  418,
     1    419,  420,  421,  422,  423,  424,  424,  425,  426,  427,
     2    428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
     3    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     4    448,  449,  450,  451,  452,  452,   26,   28,   29,  453,
     5    454,  455,  456,  456,   30,  457,  458,  458,    1,  460,
     6    461,  462,  463,  464,    2,    3,  466,    4,  467,  468,
     7    468,  469,  470,  471,  472,    5,    6,  473,  474,  474,
     8    475,  476,  477,  477,  478,  479,  480,  481,  482,  483,
     9    483,  484,  485,    9,  486,  487,  488,   10,  488,  488/
            data (jb2(i),i=  501,  600)/
     +    489,  489,  490,  490,   11,  491,  492,   12,  493,  494,
     1    494,  495,  496,  496,  497,  498,  498,  499,  500,  500,
     2    499,  501,  502,  503,  504,  504,  505,  506,  507,  508,
     3    509,  509,  510,  510,  510,  505,   15,  511,  512,  513,
     4    514,  515,  516,   17,  518,  519,  520,  521,  521,  523,
     5    524,  524,  522,  525,  526,  526,  526,   18,  527,  528,
     6    529,  529,  531,  532,  533,  534,  535,  535,  536,  538,
     7    538,  539,  539,  540,  541,  541,  542,  543,  543,  544,
     8    545,  545,  547,  548,  548,  550,  550,  551,  551,  552,
     9    553,  553,  554,  555,  556,  556,  557,  558,  558,  559/
            data (jb2(i),i=  601,  700)/
     +    560,  560,   20,   21,  561,  562,  563,  563,  564,  565,
     1    565,  566,  566,  567,  568,  568,  569,  570,  570,  571,
     2     22,  572,  573,  574,  575,  575,  576,  577,  578,  579,
     3     23,  580,  580,  581,  581,  582,  582,  584,   24,  583,
     4     25,   26,   27,  585,  586,   28,   29,   30,  290,  587,
     5    587,  588,  589,  590,  590,  588,  591,  591,    2,    3,
     6      4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
     7     14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
     8     24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
     9     34,   35,   36,   37,   38,   39,   40,   41,   42,   43/
            data (jb2(i),i=  701,  800)/
     +     44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
     1     54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
     2     64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
     3     74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
     4     84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
     5     94,   95,   96,   97,   98,   99,  100,  101,  103,  104,
     6    105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
     7    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     8    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     9    135,  136,  137,  138,  139,  140,  141,  142,  143,  144/
            data (jb2(i),i=  801,  900)/
     +    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     1    155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
     2    165,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     3    175,  176,  177,  178,  179,  180,  181,  182,  183,  184,
     4    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     5    195,  196,  197,  198,  199,  200,  201,  202,  203,  204,
     6    205,  206,  207,  208,  209,  209,  211,  212,  213,  214,
     7    215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
     8    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     9    235,  236,  237,  238,  239,  240,  241,  242,  243,  244/
            data (jb2(i),i=  901, 1000)/
     +    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     1    255,  256,  256,  258,  259,  260,  261,  262,  263,  264,
     2    265,  266,  267,  268,  269,  269,  271,  272,  273,  274,
     3    275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
     4    285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
     5    295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
     6    305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
     7    315,  316,  317,  318,  319,  320,  321,  322,  323,  324,
     8    325,  326,  327,  328,  329,  330,  331,  332,  333,  334,
     9    335,  336,  337,  338,  339,  340,  341,  342,  343,  344/
            data (jb2(i),i= 1001, 1100)/
     +    345,  346,  347,  348,  349,  350,  351,  353,  354,  355,
     1    356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
     2    366,  367,  368,  369,  370,  371,  372,  373,  374,  375,
     3    376,  377,  378,  379,  379,  381,  382,  383,  384,  385,
     4    386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
     5    396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
     6    406,  407,  408,  409,  410,  411,  412,  413,  414,  415,
     7    416,  417,  418,  419,  420,  421,  422,  423,  423,  425,
     8    426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
     9    436,  437,  438,  439,  440,  441,  442,  442,  443,  444/
            data (jb2(i),i= 1101, 1200)/
     +    445,  446,  447,  448,  449,  450,  451,  452,  453,  454,
     1    455,  456,  456,  457,  458,  459,  460,  461,  462,  463,
     2    464,  465,  466,  467,  468,  469,  470,  471,  472,  473,
     3    474,  475,  476,  477,  478,  479,  480,  481,  482,  483,
     4    484,  485,  486,  487,  488,  489,  490,  491,  492,  493,
     5    494,  495,  496,  497,  498,  499,  500,  501,  502,  503,
     6    504,  505,  506,  507,  508,  509,  510,  511,  512,  513,
     7    514,  515,  516,  517,  518,  519,  520,  521,  522,  523,
     8    524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
     9    534,  535,  536,  537,  538,  539,  540,  541,  542,  543/
            data (jb2(i),i= 1201, 1300)/
     +    544,  545,  546,  547,  548,  549,  550,  551,  551,  553,
     1    554,  555,  555,  557,  558,  559,  559,  560,  561,  562,
     2    563,  564,  566,  567,  568,  569,  570,  571,  571,  573,
     3    574,  575,  576,  576,  577,  578,  579,  580,  581,  564,
     4    572,  582,  565,  584,  585,  586,  587,  588,  589,  589,
     5    583,  590,  591,  591,  565,  582,  593,  593,  592,  594,
     6    595,  595,  591,  590,  596,  597,  598,  598,  599,  600,
     7    601,  601,    3,    4,    5,    6,    7,    8,    9,   10,
     8     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     9     21,   22,   23,   24,   25,   26,   27,   28,   29,   30/
            data (jb2(i),i= 1301, 1400)/
     +     31,   32,   33,   33,   34,   35,   36,   37,   38,   39,
     1     40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     2     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     3     60,   61,   62,   62,   63,   64,    2,    2,    3,    3,
     4      5,    6,    7,    8,    9,   10,   10,   12,   13,   14,
     5     14,   16,   17,   17,   19,   20,   20,   22,   23,   24,
     6     25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
     7     35,   36,   37,   38,   39,   40,   40,   42,   43,   43,
     8     45,   46,   47,   48,   49,   50,   51,   51,   53,   54,
     9     54,   56,   57,   57,   59,   60,   60,   62,   63,   63/
            data (jb2(i),i= 1401, 1500)/
     +     65,   66,   66,   68,   69,   70,   71,   72,   73,   74,
     1     75,   75,   77,   78,   79,   79,   81,   82,   83,   84,
     2     85,   86,   87,   88,   88,   90,   91,   91,   93,   94,
     3     94,   96,   97,   98,   98,  100,  101,  101,  103,  104,
     4    105,  106,  107,  107,  109,  110,  111,  112,  112,  114,
     5    115,  116,  117,  118,  118,  120,  121,  122,  123,  124,
     6    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     7    135,  136,  137,  138,  139,  140,  140,  142,  143,  144,
     8    144,  146,  147,  148,  149,  150,  151,  152,  152,  154,
     9    155,  156,  156,  158,  159,  159,  161,  162,  163,  164/
            data (jb2(i),i= 1501, 1600)/
     +    165,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     1    175,  175,  177,  178,  179,  179,  181,  182,  182,  184,
     2    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     3    195,  196,  197,  198,  198,  200,  201,  201,  203,  204,
     4    205,  206,  207,  208,  209,  210,  210,  212,  213,  214,
     5    214,  216,  217,  217,  219,  220,  220,  222,  223,  224,
     6    225,  226,  226,  228,  229,  230,  230,  232,  233,  234,
     7    235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     8    245,  246,  247,  248,  249,  249,  251,  252,  253,  254,
     9    255,  256,  257,  258,  259,  260,  261,  262,  263,  264/
            data (jb2(i),i= 1601, 1700)/
     +    265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
     1    275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
     2    285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
     3    295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
     4    305,  306,  307,  308,  309,  310,  311,  312,  313,  314,
     5    315,  316,  317,  317,  319,  320,  320,  322,  323,  324,
     6    324,  326,  327,  327,  329,  330,  330,  332,  333,  334,
     7    334,  336,  337,  338,  339,  339,  341,  342,  343,  344,
     8    345,  345,  347,  348,  348,  350,  351,  351,  353,  354,
     9    354,  356,  357,  358,  359,  360,  361,  362,  362,  364/
            data (jb2(i),i= 1701, 1800)/
     +    365,  365,  367,  368,  368,  370,  371,  371,  373,  374,
     1    375,  375,  377,  378,  378,  380,  381,  381,  383,  384,
     2    385,  385,  387,  388,  388,  390,  391,  391,  393,  394,
     3    394,  396,  397,  398,  399,  400,  401,  402,  403,  404,
     4    405,  406,  407,  408,  408,  410,  411,  411,  413,  414,
     5    415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
     6    425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
     7    435,  436,  437,  438,  439,  439,  441,  442,  443,  444,
     8    445,  446,  447,  448,  449,  450,  451,  452,  453,  454,
     9    455,  456,  457,  457,  459,  460,  461,  461,  463,  464/
            data (jb2(i),i= 1801, 1900)/
     +    464,  466,  467,  467,  469,  470,  470,  472,  473,  473,
     1    475,  476,  477,  478,  479,  479,  481,  482,  483,  483,
     2    485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
     3    495,  496,  497,  498,  499,  500,  501,  502,  503,  504,
     4    505,  506,  507,  508,  509,  510,  511,  512,  513,  514,
     5    515,  516,  517,  518,  519,  520,  521,  522,  523,  524,
     6    525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
     7    535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     8    545,  546,  547,  548,  548,  550,  551,  551,  553,  554,
     9    554,  556,  557,  557,  559,  560,  560,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine mn(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1220) :: jx,jy
            integer(kind=iknd), save, dimension(1310) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'minnesota     '/
            data jrot,ipart/0,1/
            data kv/   1,1219,   0,   0,   0/
            data kb/   1,1305,   0,   0,   0/
            data iib/ 657,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  18504,11544, 6600,23736,32088, 6576,40248,40464,45072,45456,
     1  45816,45984,46080,46248,46272,46320,46344,46416,46512,46536,
     2  46680,46680,46536,46680,46872,47544,47976,48096,48024,48096,
     3  48480,48672,48840,49104,49224,49440,49656,49776,50160,50760,
     4  51456,51648,51672,51888,52032,52128,52296,52488,52728,52824,
     5  52896,53160,53400,53496,53784,53856,54096,54288,54792,54144,
     6  54024,53880,53928,53808,53640,53664,53016,52224,52032,51888,
     7  51720,50904,45288,50592,49800,49608,49056,48936,48504,48048,
     8  47760,47520,47328,46968, 8064, 8016,41064,41496,41496,41784,
     9  41880,42528,42864,43152,43296,43656,43872,44064,44304,44400/
            data (jx(i),i=  101,  200)/
     +  44712,37296,40344,40224,39360,39096,38568,38472,38496,38232,
     1  38184,37992,37848,37872,37944,37992,37848,37800,37392, 8112,
     2  37296, 9192,33816, 7296,34368, 9720, 9504,34080, 9456,34464,
     3   9264,37776,40392, 9144,44328,11736,15840,19944,24120,41376,
     4  28224,36432,32328,23616,23112,22992,22800,22464,22128,22080,
     5  22200,22176,22272,21840,21720,21600,21432,21504,21144,20616,
     6  20424,20232,20016,19632,19440,19320,31560,31368,30912,30480,
     7  30336,30144,29760,29784,29688,29280,28944,28824,28728,28536,
     8  27720,27552,27648,27432,25104,24888,24840,24864,24816,24576,
     9  24264,23976,23808, 6624, 6768, 6552, 6720, 6648, 6768, 6720/
            data (jx(i),i=  201,  300)/
     +   6816, 6720, 6864, 6840, 6912, 6864, 6888, 6984, 6960, 7080,
     1   7032, 7128, 7008, 6984, 7032, 6888, 6912, 6864, 6888, 6792,
     2   6840, 6792, 6840, 6696, 6744, 6672, 6792, 6600, 6696, 6696,
     3   6624, 6696, 6576, 6624, 6504, 6480, 6432, 6384, 6408, 6360,
     4   6456,40104,39840,39600,39264,39240,39168,39120,39024,38928,
     5  38880,38928,38712,38592,38424,38016,38016,37944,37824,37296,
     6  37176,37032,37128,37272,37032,36648,36288,36216,35976,35952,
     7  36048,35952,35760,34824,34608,34440,34584,34992,34944,34752,
     8  34320,32976,32976,32760, 6528, 6648, 6624, 6720, 6672, 6528,
     9   6720, 6576, 6648, 6576, 6720, 6720, 6600, 6720, 6768, 6744/
            data (jx(i),i=  301,  400)/
     +   6648, 6792, 6744, 6672, 6792, 6648, 6744, 6576, 6672, 6720,
     1   6576, 6552, 6744, 6720, 6624, 6816, 6696, 6768, 6816, 6672,
     2   6792, 6696, 6816, 6600, 6720, 6720, 6792, 6672, 6840, 6696,
     3   6672, 6744,44712,44448,43632,42984,42816,42600,42456,42240,
     4  41712,41688,41760,41256,41160,41088,40992,40968,40800,40896,
     5  40824,40824,40728,40800,40680,40584,40368,40320, 8064, 8112,
     6   8064, 8136, 8016, 7968, 8064, 8040, 8112, 8064, 8088, 8040,
     7   8112, 7992, 8088, 8112, 7920, 7944, 7752, 7728, 7680, 7752,
     8   7680, 7704, 7632, 7704, 7656, 7536, 7536, 7344, 7440, 7272,
     9   7176, 7200, 7080, 7008, 6984, 7032, 6960, 6936, 6744, 6768/
            data (jx(i),i=  401,  500)/
     +   6720, 6648, 6600, 6672, 6528, 6672, 6528, 8112, 8064, 8112,
     1   8040, 8088, 7992, 8088, 8064, 7992, 8064, 8016, 8088, 8016,
     2   8064, 7992, 8064, 7992, 8088, 8040, 8136, 8040, 8136, 8040,
     3   8112, 8016, 8088, 8016, 8112, 8064, 8112, 8064, 7992, 7920,
     4   8040, 7992, 8064, 7968, 8064, 7992, 8016, 8088, 7992, 8064,
     5   8040, 8112, 8088, 8184, 8184, 8136, 8160, 8112, 8160, 8088,
     6   8088, 8208, 8136, 8256, 8232, 8256, 8328, 8280, 8424, 8376,
     7   8424, 8376, 8400, 8256, 8208, 8208, 8136, 8184, 8040, 8040,
     8   7944, 8088, 8016, 8136, 8064, 8088, 8016, 8064, 8040, 8112,
     9   8040, 8112, 7992, 8088, 9360, 9240, 9264, 9192, 9216, 9144/
            data (jx(i),i=  501,  600)/
     +   9144, 9240, 9168, 9120, 9168, 9192, 9120, 9168, 9168, 9048,
     1   8880, 8904, 8760, 8688, 8592, 8616, 8520, 8544, 8448, 8496,
     2   8496, 8424, 8472, 8352, 8376, 8328, 8400, 8304, 8352, 8304,
     3   8328, 8256, 8304, 8232, 8256, 8160, 8184, 8112, 8160, 8088,
     4   8136, 8088,34080,34176,34296,34248,34368,34464,34584,35064,
     5  35640,35640,35736,35856,36024,36168,36360,36456,36912,37008,
     6  37032,37320, 7200, 7248, 7368, 7704, 8016, 8520, 8736, 9096,
     7   9288, 9720, 9624, 9552, 9432, 9072, 8736, 8304, 8184, 7944,
     8   7752,34656,34656,34992,35016,34704,34488,34488,34320,34176,
     9  33888,33528,33456,33432,33552,33600,34272,34320,34296,34320/
            data (jx(i),i=  601,  700)/
     +  34248,34344,34392,34032,33984,34032,34248,34224,34344,34296,
     1  34176,34272,34248,33984,33984,35184,35256,35616,35736,35904,
     2  36000,36408,37128,37368,37488,40200,40224,40128,39936,40008,
     3  39960,39720,39192,39072,37992,44112,43872,43752,43320,42792,
     4  42240,41688,41448,41328,40800,44880,44880,44712,44760,44544,
     5  44544,44472,44520,44592,44640,44520, 9000,18288,18264,18360,
     6  18288,18360,18192,18192,18408,18792,19416,19656,19608,18072,
     7  18000,11424,11544,11448,16392,18816,18792,23688,32064,32112,
     8  32112,32160,32136,10584,16320,16296,16344,18600,18408,18312,
     9  18480,18744,18696,18768,18720,40272,40392,10512,10632,10632/
            data (jx(i),i=  701,  800)/
     +  15504,15480,16320,16272,16416,16392,23664,27744,27744,10560,
     1  11400,11376,14616,14664,15480,23616,13080,16272,23688,23640,
     2  23616,23784,23832,24216,25560,25680,26064,26040,26088,26160,
     3  26472,26616,26784,27024,27312,27720,27672,27672,27624,27624,
     4  27576,27480,27552,27696,27672,21984,23616,12144,12960,18720,
     5  18696,18768,21960,22008,21936,22008,21936,21120,32136,32232,
     6  32256,32304,32304,27648,18672,32280,37200,37248,12072,12216,
     7  12096,18648,11376,12072,23904,23976,24024,24048,23952,23976,
     8  32328,18624,18696,18648,21048,21096,21048,21192,21360,21360,
     9  21408,21672,21768,21912,23880,23640,23376,23160,22992,22848/
            data (jx(i),i=  801,  900)/
     +  22608,22248,22128,22032,27624,27408,27384,32328,27360,23688,
     1  23736,23544,23568,23928,11232,11352,11256,31152,29880,29880,
     2  14520,18576,18648,18624,11232,27360,27648,27648,11208,11280,
     3  11208,18576,14472,21840,24240,24096,24024,23904,23784,25752,
     4  18576,29832,29256,29280,31752,31752,32328,11160,25080,24744,
     5  24744,24864,24744,24624,24672,24384,27648,29304,11232,11160,
     6  11976,14448,17712,18528,25152,25368,25416,25728,29304,32544,
     7  32520,31752,20976,20976,32544,12000,11760,11712,11352,11232,
     8  10848,10776,10320, 9984, 9816,24288,24384,24240,24288,24504,
     9  24672,24792,24912,25104,25416,25488,23496,23472,24288,25896/
            data (jx(i),i=  901, 1000)/
     +  26088,26304,26400,26568,26808,27144,27312,27600,27816,27936,
     1  28104,28224,28848,28920,29016,29232,29256,29472,29568,29664,
     2  29832,29928,30288,30432,30624,30816,30792,31152,11928,12024,
     3  12432,17712,17664,17712,32544,12936,13800,13800,13920,14136,
     4  14280,14376,31176,24288,24312,24288,25920,29088,28944,28656,
     5  28368,28296,28296,27984,27912,27768,27576,27528,27528,31536,
     6  31368,31296,31296,31632,31824,32064,32328,32472,17616,20904,
     7  22632,22656,32784,32760,30480,30936,31176,13584,13608,14352,
     8  27528,29160,29160,29328,29352,29640,29760,29952,30144,14496,
     9  14496,14448,14808,15048,15144,15168,15432,15504,15696,15648/
            data (jx(i),i= 1001, 1100)/
     +  15768,15936,15768,15720,15816,15840,15888,16032,32544,32496,
     1  32568,32880,33024,33120,16056,27504,27576,27600,27840,27840,
     2  27984,28176,28272,28440,28488,28416,28440,28488,28536,28584,
     3  28512,28656,28656,28752,28800,33360,33504,33600,33840,22632,
     4  16104,16200,16320,16536,16584,16584,16824,25896,11880,26688,
     5  26712,27504,22608,24240,24264,15168,15144,15192,17136,17160,
     6  17328,17592,18000,18168,18360,18528,18600,18576,18720,18912,
     7  19104,19128,19272,19752,20016,20112,16800,26544,26568,26664,
     8  26616,26664,26616,26760,26760,26856,26904,27000,27264,27336,
     9  27456,27504,29136,30528,30792,30792,32400,32400,32736,33024/
            data (jx(i),i= 1101, 1200)/
     +  33192,33240,34080,34056,34440,30768,20424,20592,21744,21744,
     1  26400,26496,26424,26520,26640,26688,26520,20784,20904,21240,
     2  21216,21312,21288,21384,21432,21624,21720,21912,22056,22200,
     3  22272,22416,22488,22608,22872,22944,22944,22992,22968,23064,
     4  23160,23352,23400,25824,25776,25776,26376,26232,26184,26256,
     5  26184,26256,26232,26376,11832,11952,11808,11928,15120,15984,
     6  18408,18432,20064,27456,27480,29112,29928,32352,32400,36528,
     7  36504,35712,35712,34848,23472,23664,23760,23832,24048,24096,
     8  24288,24432,24432,24936,25392,25560,25896,25824,25752,25824,
     9  18456,18384,20064,23376,38904,38904,37296,37296,11784,11856/
            data (jx(i),i= 1201, 1220)/
     +  15888,15960,19992,20040,41328,23328,24168,38928,27432,28248,
     1  34872,34800,32352,32328,29904,36408,36432,34800,    0,    0/
            data (jy(i),i=    1,  100)/
     +  58392,58656,54600,55440,54648,51096,50736,38736,50712,51000,
     1  51120,51240,51192,51240,51216,50616,50592,50664,50616,50472,
     2  50472,50352,50232,50136,49824,49944,50136,50112,49968,49896,
     3  49944,50016,49968,50016,49896,49920,50040,49968,50064,50136,
     4  49920,49632,49392,49248,49272,49152,49056,49056,49176,49344,
     5  49296,49392,49368,49272,49320,49248,49368,49176,49296,49056,
     6  49128,49008,48792,48888,48816,48720,48168,47880,47640,47592,
     7  47472,47136,43824,46992,46776,46608,46512,46392,46272,45912,
     8  45816,45600,45552,45288,44640,41352,39408,39672,39792,40008,
     9  40200,40584,41088,41280,41544,41856,42168,42336,42672,42888/
            data (jy(i),i=  101,  200)/
     +  43272,36216,38664,38664,37944,37824,37392,37224,37008,36888,
     1  36696,36696,36576,36480,36480,36408,36240,36072,36072,36432,
     2  33864,30648,27360,26616,23280,23616,19128,18024,17496,17808,
     3  13416,15384,12936,10152, 9768, 6768, 6648, 6528, 6456, 6432,
     4   6408, 6384, 6384,55368,55440,55560,55608,55848,56256,56640,
     5  56808,57048,57144,59184,59400,59976,61128,61344,61440,61824,
     6  61800,61680,61656,61824,61992,58368,54624,54768,54768,54648,
     7  54456,54480,54312,53976,53880,53736,53736,53688,53760,53616,
     8  53616,53736,54096,54672,54912,54984,55056,55248,55368,55488,
     9  55440,55536,55512,54648,54648,54744,54816,54912,54936,55056/
            data (jy(i),i=  201,  300)/
     +  55152,55200,55224,55296,55272,55368,55392,55368,55488,55608,
     1  55680,55872,55968,56040,56112,56280,56304,56376,56472,56544,
     2  56664,56736,56784,56928,57000,56976,57048,57144,57336,57576,
     3  57600,57696,57744,57864,58008,58248,58248,58416,58536,58584,
     4  58920,50808,50784,51048,50976,51168,51168,51096,51288,51288,
     5  51576,51840,51888,52176,52128,52152,52224,52224,52080,52104,
     6  52032,51792,51336,51072,51048,50832,51624,51648,52128,52272,
     7  52656,52680,52968,52848,52944,53136,53424,53496,53856,53904,
     8  53856,54480,54672,54624,51168,51408,51480,51408,51504,51528,
     9  51576,51624,51696,51744,51792,51912,51960,52008,52104,52152/
            data (jy(i),i=  301,  400)/
     +  52200,52224,52368,52368,52488,52536,52632,52896,52944,53040,
     1  53064,53160,53232,53352,53376,53376,53496,53496,53568,53592,
     2  53712,53880,53904,53952,54000,54072,54048,54240,54312,54336,
     3  54432,54456,50568,50376,49608,49488,49368,49296,49488,49464,
     4  49248,49440,49824,49752,49896,49824,49848,49944,49872,50136,
     5  50232,50448,50400,50664,50712,50664,50712,50664,44688,44712,
     6  44760,44784,44784,44880,44952,45024,45000,45072,45144,45192,
     7  45240,45264,45288,45576,45936,46272,46560,46704,46704,46776,
     8  46872,47016,47064,47064,47184,47256,47424,47592,47736,48168,
     9  48216,48648,48864,48912,49152,49320,49464,49896,50136,50352/
            data (jy(i),i=  401,  500)/
     +  50424,50424,50712,50760,50808,50952,50952,41472,41568,41664,
     1  41664,41736,41760,41832,42000,42000,42072,42120,42144,42192,
     2  42264,42408,42432,42480,42768,42912,43008,43032,43104,43224,
     3  43248,43392,43416,43464,43584,43656,43680,43800,43824,43896,
     4  43992,44232,44448,44448,44520,44568,36456,36528,36672,36816,
     5  36864,36960,37128,37440,37728,37776,37824,37824,37896,37968,
     6  38160,38280,38352,38400,38664,38760,38784,38952,39096,39168,
     7  39192,39240,39312,39216,39264,39408,39432,39624,39624,39936,
     8  40008,40200,40248,40296,40296,40344,40368,40536,40632,40752,
     9  40776,40944,41088,41112,31152,31824,32064,32112,32400,32592/
            data (jy(i),i=  501,  600)/
     +  32712,32760,32808,32976,33048,33168,33216,33240,33528,33720,
     1  33768,33864,34032,34272,34344,34416,34416,34584,34584,34776,
     2  34872,34872,34920,34992,35112,35184,35232,35592,35640,35736,
     3  35808,35976,36024,36024,36120,36120,36192,36288,36336,36336,
     4  36360,36360,27648,27936,28104,28320,28416,28704,28896,29256,
     5  29448,29592,29712,29736,29664,29664,30024,30120,30024,30168,
     6  30456,30576,26832,27072,27264,27456,27744,27984,28392,28800,
     7  29880,23880,23976,24240,24456,24624,24864,24912,25032,25368,
     8  25944,23592,23856,24240,24672,24984,25344,25584,25752,25824,
     9  25752,25824,25896,26496,27192,27288,23160,22992,22848,22560/
            data (jy(i),i=  601,  700)/
     +  22272,22080,21552,21216,21072,20952,20736,20256,19992,19632,
     1  19512,19296,18888,18240,18120,17088,16848,16704,16416,16464,
     2  16416,16416,16272,16056,15624,13224,13464,13704,13848,14040,
     3  14184,14496,14736,14880,15192,10152,10416,10656,11136,11352,
     4  11472,11952,12096,12360,12600, 6504, 6648, 6888, 7320, 7584,
     5   7872, 7992, 8520, 8688, 9072, 9264, 6864,58296,58008,57888,
     6  57792,57552,57456,57408,57432,57240,57384,57576,55680,55704,
     7  54072,55968,55968,54336,54120,54048,52416,52320,49416,49392,
     8  48576,48576,47760,50880,50640,49224,49224,49152,48864,48120,
     9  47856,47784,45864,45888,43392,46944,44712,49440,49440,48912/
            data (jy(i),i=  701,  800)/
     +  48720,48432,48384,45936,45936,44304,47376,47352,47856,47808,
     1  47784,46968,46824,47640,47616,43608,44424,41016,43536,43536,
     2  43440,43440,43464,43320,43896,43872,43272,42984,42744,42648,
     3  42504,42264,42144,42408,42216,42216,42072,41952,41952,41784,
     4  41784,41664,41400,41328,39624,43296,43272,41184,41160,40920,
     5  42576,42576,42480,42480,39216,39216,37584,37632,46128,46128,
     6  40344,40344,39576,37488,37704,37128,37128,36192,39528,39528,
     7  37080,36864,36288,36264,32592,32592,32760,35904,35928,37560,
     8  33840,33576,36024,36024,33936,33936,33792,33648,33624,33504,
     9  33384,33312,33360,33264,32736,32808,33096,33072,32952,32952/
            data (jy(i),i=  801,  900)/
     +  32832,33072,33048,33264,35520,35424,32208,31392,31392,31464,
     1  31680,31944,32112,32520,33024,33024,31368,31416,31368,32208,
     2  31224,32760,32760,31104,30552,29760,29736,28224,29736,29736,
     3  28080,27960,27960,27888,27864,27936,28080,28104,28296,28296,
     4  27840,29736,29712,27408,27360,29736,29736,26448,25800,26352,
     5  26640,26904,26928,27240,27360,27552,25776,25752,26448,24816,
     6  24768,24672,24576,24552,25152,24960,24768,24552,24408,24360,
     7  25728,25752,24504,23688,23280,22560,22728,22680,22824,22992,
     8  23040,23256,23376,23376,23592,23160,23232,23400,23448,23472,
     9  23568,23544,23400,23496,23808,24144,23640,23232,23232,24336/
            data (jy(i),i=  901, 1000)/
     +  24312,24072,24144,24120,23784,23688,23472,23304,23352,23280,
     1  23376,23280,23256,23304,22992,22800,22800,22608,22608,22512,
     2  22512,22344,22128,21960,21816,21456,20832,20832,23160,23136,
     3  22296,22128,22920,22920,21672,21576,20688,20520,20352,20256,
     4  20256,20184,21672,22680,22680,20376,20328,22656,22656,22488,
     5  22464,22392,22008,21792,21696,21360,21288,21192,20304,19512,
     6  19584,19704,20832,19536,19752,19776,19728,19512,19680,19608,
     7  19584,20376,21648,19464,18504,18696,18888,18984,19800,19776,
     8  19488,19488,18648,18720,18648,18648,18744,18672,18480,20040,
     9  19944,19896,19872,19536,19464,19344,19248,19104,19008,18912/
            data (jy(i),i= 1001, 1100)/
     +  18864,18720,18696,18600,18600,18528,18600,18408,18960,18576,
     1  18360,18336,18288,18408,19704,17136,17064,17136,17256,17352,
     2  17376,17640,17592,17664,17760,17928,18048,18168,18144,18192,
     3  18288,18360,18456,18432,18576,18360,18288,18144,18120,17928,
     4  18408,18288,18312,18192,18120,18048,17880,17880,17400,17856,
     5  17448,17448,17088,17064,17904,17280,16464,16464,17808,17664,
     6  17496,17544,17112,17064,16872,16776,16680,16632,16632,16464,
     7  16416,16320,16344,16080,16032,15888,16416,16224,16296,16296,
     8  16368,16560,16656,16752,16824,16800,16944,16920,17088,17040,
     9  17088,17040,16224,17016,17016,16200,15504,15936,15960,15864/
            data (jy(i),i= 1101, 1200)/
     +  15936,16200,16200,16992,17016,15528,15744,15504,17952,15480,
     1  15408,15456,15528,15552,15768,15984,16176,15360,15384,15192,
     2  15072,15072,15000,15000,14880,14880,14760,14784,14664,14664,
     3  14592,14616,14496,14520,14184,14160,14064,14064,13968,13920,
     4  13704,13608,13632,13368,13416,13536,14376,14496,14736,14760,
     5  14808,14832,14976,15144,16584,16584,13320,13320,13176,13176,
     6  13104,13920,13872,13368,12936,12936,12936,12936,12936,15360,
     7  14544,14544,12936,12912,13560,13512,13416,13440,13248,13296,
     8  13128,13152,13056,12936,12624,12576,12744,13032,13128,13200,
     9  13104,12264,12240,12168,12936,12120,12912,12120,10056,10056/
            data (jy(i),i= 1201, 1220)/
     +   9912, 9888, 9792, 9792, 9720, 9720, 9720, 9696, 9672, 9672,
     1   9672, 9672, 9672, 9672, 9648, 9528, 9672, 9528,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
     1     19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
     2     29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
     3     39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     4     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     5     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     6     69,   70,   71,   72,   74,   75,   76,   77,   78,   79,
     7     80,   81,   82,   83,   73,    8,   87,   88,   89,   90,
     8     91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
     9     73,    8,  103,  104,  105,  106,  107,  108,  109,  110/
            data (jb1(i),i=  101,  200)/
     +    111,  112,  113,  114,  115,  116,  117,  118,  102,    4,
     1    144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
     2    154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
     3    164,  165,    1,    1,    5,  167,  168,  169,  170,  171,
     4    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     5    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     6    192,    4,    3,  194,  195,  196,  197,  198,  199,  200,
     7    201,  202,  203,  204,  205,  206,  207,  208,  209,  210,
     8    211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
     9    221,  222,  223,  224,  225,  226,  227,  228,  229,  230/
            data (jb1(i),i=  201,  300)/
     +    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     1      2,    7,  242,  243,  244,  245,  246,  247,  248,  249,
     2    250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
     3    260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
     4    270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
     5    280,  281,  282,  283,    5,    6,  285,  286,  287,  288,
     6    289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
     7    299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
     8    309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
     9    319,  320,  321,  322,  323,  324,  325,  326,  327,  328/
            data (jb1(i),i=  301,  400)/
     +    329,  330,  331,    3,    9,  333,  334,  335,  336,  337,
     1    338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
     2    348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
     3      7,   85,  359,  360,  361,  362,  363,  364,  365,  366,
     4    367,  368,  369,  370,  371,  372,  373,  374,  375,  376,
     5    377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
     6    387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
     7    397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
     8      6,   86,  408,  409,  410,  411,  412,  413,  414,  415,
     9    416,  417,  418,  419,  420,  421,  422,  423,  424,  425/
            data (jb1(i),i=  401,  500)/
     +    426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
     1    436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
     2     85,  120,  447,  448,  449,  450,  451,  452,  453,  454,
     3    455,  456,  457,  458,  459,  460,  461,  462,  463,  464,
     4    465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
     5    475,  476,  477,  478,  479,  480,  481,  482,  483,  484,
     6    485,  486,  487,  488,  489,  490,  491,  492,  493,   86,
     7    102,  122,  495,  496,  497,  498,  499,  500,  501,  502,
     8    503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
     9    513,  514,  515,  516,  517,  518,  519,  520,  521,  522/
            data (jb1(i),i=  501,  600)/
     +    523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
     1    533,  534,  535,  536,  537,  538,  539,  540,  541,  120,
     2    123,  543,  544,  545,  546,  547,  548,  549,  550,  551,
     3    552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
     4    121,  124,  563,  564,  565,  566,  567,  568,  569,  570,
     5    122,  126,  572,  573,  574,  575,  576,  577,  578,  579,
     6    580,  124,  126,  125,  582,  583,  584,  585,  586,  587,
     7    588,  589,  590,  591,  592,  593,  594,  595,  123,  125,
     8    597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
     9    607,  608,  609,  610,  611,  612,  613,  614,  128,  128/
            data (jb1(i),i=  601,  700)/
     +    127,  130,  616,  617,  618,  619,  620,  621,  622,  623,
     1    624,  132,  133,  626,  627,  628,  629,  630,  631,  632,
     2    633,  634,  132,  129,  135,  636,  637,  638,  639,  640,
     3    641,  642,  643,  644,  133,  131,  140,  646,  647,  648,
     4    649,  650,  651,  652,  653,  654,  655,  135,  136,  134,
     5    136,  137,  138,  139,  140,  141,  142,    1,  658,  659,
     6    660,  661,  662,  663,  664,  665,  666,  667,  668,  669,
     7    670,    2,  672,  673,  674,  674,  671,  671,  676,  677,
     8    678,    5,  679,  680,  681,  682,    6,  675,  684,  685,
     9    686,  687,  688,  689,  690,  691,  692,  693,  694,    7/
            data (jb1(i),i=  701,  800)/
     +    696,  697,  684,  698,  699,  700,  701,  687,  702,  703,
     1    704,  705,  707,  708,  683,  678,    9,  700,  710,  711,
     2    712,  713,  714,  702,  707,   85,  706,  706,  716,  719,
     3    720,  719,  722,  723,  724,  725,  726,  727,  728,  729,
     4    730,  731,  732,  733,  734,  735,  736,  737,  738,  739,
     5    740,  741,  742,  743,  744,  695,  746,  721,   86,  717,
     6    748,  718,  718,  695,  751,  750,  746,  753,  754,  755,
     7    756,  757,  683,  759,  760,  761,  762,  745,  745,  750,
     8    758,  766,  767,  768,  763,  748,  769,  770,  765,  771,
     9    120,  773,  771,  775,  776,  777,  778,  779,  764,  781/
            data (jb1(i),i=  801,  900)/
     +    766,  782,  783,  772,  758,  785,  786,  787,  788,  789,
     1    782,  790,  791,  792,  793,  775,  795,  796,  797,  798,
     2    799,  800,  801,  802,  803,  794,  764,  805,  806,  781,
     3    807,  809,  810,  811,  812,  813,  775,  773,  815,  816,
     4    808,  818,  807,  819,  817,  782,  822,  823,  821,  817,
     5    825,  809,  826,  827,  825,  829,  830,  824,  821,  831,
     6    794,  832,  835,  836,  837,  838,  839,  828,  834,  832,
     7    833,  819,  842,  843,  845,  845,  846,  808,  844,  831,
     8    848,  849,  850,  851,  852,  853,  854,  855,  835,  828,
     9    849,  844,  857,  848,  859,  860,  833,  861,  862,  841/
            data (jb1(i),i=  901, 1000)/
     +    863,  849,  865,  866,  867,  858,  870,  871,  845,  869,
     1    864,  873,  870,  875,  876,  877,  878,  879,  880,  881,
     2    882,  883,  884,  885,  886,  887,  888,  889,  890,  891,
     3    892,  893,  894,  895,  868,  874,  897,  898,  886,  868,
     4    900,  901,  902,  903,  904,  905,  906,  907,  908,  909,
     5    910,  911,  912,  913,  914,  915,  869,  916,  917,  918,
     6    919,  920,  921,  922,  923,  924,  925,  926,  927,  861,
     7    929,  876,  876,  931,  863,  933,  932,  875,  931,  936,
     8    937,  938,  939,  940,  941,  928,  935,  886,  944,  945,
     9    946,  916,  948,  949,  950,  951,  952,  953,  954,  955/
            data (jb1(i),i= 1001, 1100)/
     +    956,  957,  958,  947,  960,  961,  962,  928,  960,  964,
     1    965,  966,  967,  932,  874,  969,  971,  946,  970,  935,
     2    973,  968,  975,  976,  960,  127,  978,  979,  942,  959,
     3    981,  982,  983,  984,  985,  986,  987,  988,  975,  942,
     4    990,  991,  992,  993,  994,  995,  996,  997,  998,  999,
     5   1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007,  968, 1009,
     6   1010, 1011, 1012, 1013, 1008,  969, 1016, 1017, 1018, 1019,
     7   1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029,
     8   1030, 1031, 1032, 1033, 1034,  983, 1014, 1036, 1037, 1038,
     9   1039,  971, 1008, 1041, 1042, 1043, 1044, 1045, 1046,  947/
            data (jb1(i),i= 1101, 1200)/
     +    129, 1048, 1050, 1051, 1016, 1040, 1053, 1054, 1048, 1049,
     1   1056, 1057, 1047, 1059, 1060, 1061, 1062, 1063, 1064, 1065,
     2   1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075,
     3   1058, 1047, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085,
     4   1086, 1087, 1088, 1089, 1090, 1091, 1016, 1078,  975, 1094,
     5   1095, 1093, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104,
     6   1105, 1096, 1097, 1076, 1107, 1040, 1109, 1108, 1111, 1112,
     7   1113, 1114, 1115, 1116, 1078, 1110, 1108, 1118, 1119, 1120,
     8   1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130,
     9   1131, 1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140/
            data (jb1(i),i= 1201, 1300)/
     +   1141, 1142, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151,
     1   1152, 1153, 1111, 1049, 1155, 1156, 1157, 1157, 1058, 1158,
     2   1159, 1161, 1162, 1076, 1160, 1144, 1164, 1093, 1165, 1166,
     3   1167, 1097, 1168,  132, 1170, 1171, 1172, 1173, 1169, 1143,
     4   1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184,
     5   1185, 1186, 1187, 1188, 1189, 1144, 1161, 1191, 1192, 1143,
     6   1193,  133, 1195, 1173, 1197, 1196, 1158, 1199, 1199, 1160,
     7   1200, 1201, 1193, 1202, 1203, 1205, 1194, 1204, 1206, 1205,
     8   1196, 1165, 1207, 1209, 1174, 1211, 1212, 1168, 1213, 1214,
     9   1167, 1210, 1216, 1208, 1212, 1216, 1200, 1202, 1204, 1207/
            data (jb1(i),i= 1301, 1310)/
     +   1205, 1210, 1216, 1214,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
     1     20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
     2     30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
     3     40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     4     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     5     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     6     70,   71,   72,   74,   75,   76,   77,   78,   79,   80,
     7     81,   82,   83,   84,   84,   87,   88,   89,   90,   91,
     8     92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
     9    101,  103,  104,  105,  106,  107,  108,  109,  110,  111/
            data (jb2(i),i=  101,  200)/
     +    112,  113,  114,  115,  116,  117,  118,  119,  119,  144,
     1    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     2    155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
     3    165,  166,  166,    2,  167,  168,  169,  170,  171,  172,
     4    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     5    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     6    193,  193,  194,  195,  196,  197,  198,  199,  200,  201,
     7    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     8    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     9    222,  223,  224,  225,  226,  227,  228,  229,  230,  231/
            data (jb2(i),i=  201,  300)/
     +    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     1    241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
     2    251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
     3    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     4    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     5    281,  282,  283,  284,  284,  285,  286,  287,  288,  289,
     6    290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
     7    300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
     8    310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
     9    320,  321,  322,  323,  324,  325,  326,  327,  328,  329/
            data (jb2(i),i=  301,  400)/
     +    330,  331,  332,  332,  333,  334,  335,  336,  337,  338,
     1    339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
     2    349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
     3    358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
     4    368,  369,  370,  371,  372,  373,  374,  375,  376,  377,
     5    378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
     6    388,  389,  390,  391,  392,  393,  394,  395,  396,  397,
     7    398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
     8    407,  408,  409,  410,  411,  412,  413,  414,  415,  416,
     9    417,  418,  419,  420,  421,  422,  423,  424,  425,  426/
            data (jb2(i),i=  401,  500)/
     +    427,  428,  429,  430,  431,  432,  433,  434,  435,  436,
     1    437,  438,  439,  440,  441,  442,  443,  444,  445,  446,
     2    446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
     3    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     4    466,  467,  468,  469,  470,  471,  472,  473,  474,  475,
     5    476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
     6    486,  487,  488,  489,  490,  491,  492,  493,  494,  494,
     7    121,  495,  496,  497,  498,  499,  500,  501,  502,  503,
     8    504,  505,  506,  507,  508,  509,  510,  511,  512,  513,
     9    514,  515,  516,  517,  518,  519,  520,  521,  522,  523/
            data (jb2(i),i=  501,  600)/
     +    524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
     1    534,  535,  536,  537,  538,  539,  540,  541,  542,  542,
     2    543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
     3    553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
     4    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     5    571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
     6    581,  581,  127,  582,  583,  584,  585,  586,  587,  588,
     7    589,  590,  591,  592,  593,  594,  595,  596,  596,  597,
     8    598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
     9    608,  609,  610,  611,  612,  613,  614,  615,  615,  130/
            data (jb2(i),i=  601,  700)/
     +    129,  616,  617,  618,  619,  620,  621,  622,  623,  624,
     1    625,  625,  626,  627,  628,  629,  630,  631,  632,  633,
     2    634,  635,  635,  131,  636,  637,  638,  639,  640,  641,
     3    642,  643,  644,  645,  645,  134,  646,  647,  648,  649,
     4    650,  651,  652,  653,  654,  655,  656,  656,  657,  657,
     5    137,  138,  139,  141,  142,  143,  143,  658,  659,  660,
     6    661,  662,  663,  664,  665,  666,  667,  668,  669,  670,
     7    671,  672,  673,  674,    3,  675,  675,  676,  677,  678,
     8      4,  679,  680,  681,  682,  683,  684,  685,  685,  686,
     9    687,  688,  689,  690,  691,  692,  693,  694,  695,  696/
            data (jb2(i),i=  701,  800)/
     +    697,    8,  698,  699,  700,  701,  702,  703,  703,  704,
     1    705,  706,  708,  709,  709,  707,   73,  710,  711,  712,
     2    713,  714,  715,  715,  716,  717,  717,  718,  719,  720,
     3    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     4    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     5    741,  742,  743,  744,  745,  746,  747,  747,  748,  749,
     6    749,  749,  750,  751,  752,  752,  753,  754,  755,  756,
     7    757,  758,  759,  760,  761,  762,  763,  763,  764,  765,
     8    765,  767,  768,  102,  766,  769,  770,  771,  772,  772,
     9    773,  774,  774,  776,  777,  778,  779,  780,  780,  121/
            data (jb2(i),i=  801,  900)/
     +    781,  783,  784,  784,  785,  786,  787,  788,  789,  790,
     1    790,  791,  792,  793,  794,  795,  796,  797,  798,  799,
     2    800,  801,  802,  803,  804,  804,  805,  806,  807,  808,
     3    809,  810,  811,  812,  813,  814,  814,  815,  816,  817,
     4    818,  819,  820,  820,  821,  822,  823,  824,  824,  825,
     5    122,  826,  827,  828,  829,  830,  831,  832,  833,  833,
     6    834,  834,  836,  837,  838,  839,  840,  840,  835,  841,
     7    841,  842,  843,  844,  123,  846,  847,  847,  845,  848,
     8    124,  850,  851,  852,  853,  854,  855,  856,  856,  857,
     9    857,  858,  858,  859,  860,  861,  862,  862,  863,  864/
            data (jb2(i),i=  901, 1000)/
     +    864,  865,  866,  867,  868,  869,  871,  872,  872,  870,
     1    873,  874,  875,  125,  877,  878,  879,  880,  881,  882,
     2    883,  884,  885,  126,  887,  888,  889,  890,  891,  892,
     3    893,  894,  895,  896,  896,  897,  898,  899,  899,  900,
     4    901,  902,  903,  904,  905,  906,  907,  908,  909,  910,
     5    911,  912,  913,  914,  915,  916,  917,  917,  918,  919,
     6    920,  921,  922,  923,  924,  925,  926,  927,  928,  929,
     7    930,  930,  931,  932,  933,  934,  934,  935,  936,  937,
     8    938,  939,  940,  941,  942,  943,  943,  944,  945,  946,
     9    947,  948,  949,  950,  951,  952,  953,  954,  955,  956/
            data (jb2(i),i= 1001, 1100)/
     +    957,  958,  959,  959,  961,  962,  963,  963,  964,  965,
     1    966,  967,  968,  969,  970,  970,  972,  972,  971,  973,
     2    974,  974,  976,  977,  977,  978,  979,  980,  980,  981,
     3    982,  983,  984,  985,  986,  987,  988,  989,  989,  990,
     4    991,  992,  993,  994,  995,  996,  997,  998,  999, 1000,
     5   1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010,
     6   1011, 1012, 1013, 1014, 1015, 1015, 1017, 1018, 1019, 1020,
     7   1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030,
     8   1031, 1032, 1033, 1034, 1035, 1035, 1036, 1037, 1038, 1039,
     9    128, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048/
            data (jb2(i),i= 1101, 1200)/
     +   1049, 1050, 1051, 1052, 1052, 1053, 1054, 1055, 1055, 1056,
     1   1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066,
     2   1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,
     3   1077, 1077, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086,
     4   1087, 1088, 1089, 1090, 1091, 1092, 1092, 1093, 1094, 1095,
     5   1096, 1096, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105,
     6    130, 1106, 1106, 1107, 1108, 1109, 1110, 1110, 1112, 1113,
     7   1114, 1115, 1116, 1117, 1117, 1111, 1118, 1119, 1120, 1121,
     8   1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     9   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141/
            data (jb2(i),i= 1201, 1300)/
     +   1142, 1143, 1145, 1146, 1147, 1148, 1149, 1150, 1151, 1152,
     1   1153, 1154, 1154, 1155, 1156, 1157,  131, 1158, 1159, 1159,
     2   1160, 1162, 1163, 1163, 1161, 1164, 1165, 1166, 1166, 1167,
     3   1168, 1169, 1169, 1170, 1171, 1172, 1173, 1174, 1174, 1175,
     4   1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185,
     5   1186, 1187, 1188, 1189, 1190, 1190, 1191, 1192, 1193, 1194,
     6   1194, 1195, 1196, 1197, 1198, 1198, 1199,  134, 1200, 1201,
     7   1201, 1202, 1203, 1203, 1204,  135, 1206, 1206, 1207, 1208,
     8   1208, 1209, 1209, 1210, 1211, 1212, 1213, 1213, 1214, 1215,
     9   1215, 1215, 1217, 1217, 1218, 1218,  136,  137,  138,  139/
            data (jb2(i),i= 1301, 1310)/
     +    140,  141,  142,  143,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ms(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1400) :: jx,jy
            integer(kind=iknd), save, dimension(1480) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'mississippi   '/
            data jrot,ipart/0,2/
            data kv/   1,1351,1392,   0,   0/
            data kb/   1,1432,1473,   0,   0/
            data iib/ 614,  41,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  38352,35184,44496,40200,31704,26280,46776,23904,46536,20328,
     1  46272,18048,45984,18576,45768,45528,19848,45288,20040,45048,
     2  17928,17280,45480,14664,19968,45936,33048,32040,27816,25008,
     3  46176,41616,33648,46464,46392,46368,46512,46464,46416,46392,
     4  46320,46176,46056,45936,45744,45528,45384,45408,45360,45312,
     5  45312,45168,44736,44640,44712,44544,44520,44472,44424,44472,
     6  44424,44328,44088,43824,43464,43272,43032,42744,42360,42456,
     7  42672,42744,42408,42048,41928,42096,42192,41976,41784,41712,
     8  37104,37416,37464,37416,37512,37824,37872,37680,37704,37800,
     9  38040,38040,37848,37824,37632,37632,37776,38904,39528,39600/
            data (jx(i),i=  101,  200)/
     +  39624,39624,39672,39648,39720,40032,41160,41904,41880,41664,
     1  41448,41352,41184,40560,40536,40632,40704,40752,40968,41136,
     2  41160,33792,33744,33984,34008,34272,34296,34224,34152,34248,
     3  34296,34344,34320,34464,34488,34680,34920,35040,35232,35304,
     4  35400,35688,35784,35976,36048,35952,36000,36216,36168,36432,
     5  36360,36408,36816,37320,37296,37152,36960,36792,36792,46056,
     6  46536,46800,47088,26208,26304,26784,26856,26832,26760,26352,
     7  26208,25872,25488,25344,25248,24984,24768,24576,24576,24840,
     8  24720,24720,24984,24984,24888,24672,24312,24264,24456,24360,
     9  24312,24168,24024,24096,23976,23880,23832,23856,24120,24720/
            data (jx(i),i=  201,  300)/
     +  24840,24840,24768,24360,24144,24000,23952,24096,24072,24000,
     1  23880,23856,23712,23760,23904,24192,24264,24192,23760,23688,
     2  23832,23808,23592,23064,22992,23064,23040,22896,22776,22776,
     3  22896,22872,22512,22152,22056,22032,22272,22200,22056,21744,
     4  21576,21456,21456,21360,21240,21072,20688,20520,20472,20520,
     5  20784,21000,21456,21672,21720,21600,21336,21144,20832,20568,
     6  20352,20256,20256,20664,20856,21072,21120,20928,20616,20400,
     7  20232,20136,20304,20280,20160,19992,19800,19560,19224,19080,
     8  19056,19176,19704,19704,19368,19344,19704,20040,20064,19992,
     9  19824,19560,19392,19248,18984,18792,18624,18624,18672,18648/
            data (jx(i),i=  301,  400)/
     +  18744,19056,19392,19656,19656,19272,19128,18792,18384,18072,
     1  17976,17880,17928,18504,18624,18600,18480,18240,17904,17808,
     2  17784,18240,18264,18168,17736,17784,18072,18312,18384,18360,
     3  18480,18840,18936,18888,18768,18096,18096,18216,18552,18840,
     4  19080,19176,19392,19512,19488,19152,18936,18744,18696,18720,
     5  18888,19152,19248,19344,19560,19656,19584,19224,19248,19152,
     6  18912,18432,18264,18168,18216,18840,18960,18888,18648,18504,
     7  18240,18120,18144,18336,18504,18672,18840,18912,18840,18912,
     8  18816,18912,19104,19200,19344,19440,19344,19248,18912,18672,
     9  18624,18672,18600,18720,18792,19512,19632,19680,18816,18720/
            data (jx(i),i=  401,  500)/
     +  18960,19152,19704,19896,20064,20184,20184,19512,19488,19680,
     1  20304,20376,20184,19872,19488,19344,19200,19128,19152,19248,
     2  19536,19776,19944,20256,20424,20544,20592,20400,20208,20208,
     3  20280,21144,21384,21480,21216,21096,20784,20688,20568,20496,
     4  20544,20496,20496,20400,20280,20184,19872,19752,19488,19272,
     5  19056,18720,18624,18696,18744,19104,19296,19392,19512,19824,
     6  19872,19752,20088,20328,20304,20040,20016,19920,19560,19608,
     7  19320,19032,18912,18816,18768,18840,19368,19536,19536,19416,
     8  18720,18552,18600,18408,18288,17736,17760,18000,17976,17832,
     9  17736,17640,17568,17472,17232,17088,16800,16800,17064,17712/
            data (jx(i),i=  501,  600)/
     +  17832,17880,17760,16776,16608,16536,16560,16392,16152,15768,
     1  15576,15360,15432,15600,15792,16128,16320,16416,16488,16368,
     2  16104,15744,15432,15336,15432,15408,15456,15864,15864,15792,
     3  15576,15408,15168,15144,15024,14808,14808,14904,15144,15072,
     4  15120,15456,15504,15432,15288,15096,14376,14112,14136,14616,
     5  32784,32832,32976,14592,14400,14376,14712,14976,15024,14880,
     6  14280,33096,33048,33120,33000,32832,32904,32880,32952,32784,
     7  32832,32688,32736,32640,32760,32712,32616,32520,32592,32400,
     8  32448,32280,32400,32376,32280,32160,32160,32256,32160,32064,
     9  32040,32112,32064,32088,31992,32184,32328,32232,32352,32304/
            data (jx(i),i=  601,  700)/
     +  32352,32352,32424,32448,32640,32520,32592,32592,32736,32832,
     1  32928,32976,33120,33264,37872,37776,38280,38256,38424,36384,
     2  35904,35760,35256,44616,41280,40968,40920,40248,31800,27288,
     3  27408,27600,27864,28008,28176,28512,28584,28776,29208,29328,
     4  29376,29568,29640,29640,29976,30048,27240,41208,41376,36384,
     5  32400,34224,34416,34560,34680,34896,35256,35640,35832,35928,
     6  36024,36096,36432,32328,31848,44784,44808,44952,45120,31920,
     7  27360,27144,27024,27120,27096,27192,27096,26976,26952,27024,
     8  27168,27144,27240,27192,41256,43104,43080,27360,32040,43272,
     9  26376,26424,25512,36480,39480,39480,40464,40464,40776,40752/
            data (jx(i),i=  701,  800)/
     +  41256,36576,34056,34056,30072,32064,40584,29736,29832,28104,
     1  28080,27480,28128,25128,41592,41592,37632,36624,25560,25080,
     2  25152,23208,23136,23136,34200,30192,31680,31704,30072,30120,
     3  34272,41712,28224,28200,29736,29736,30216,25200,39720,39720,
     4  38736,38736,37272,37248,37752,37272,38784,38952,39000,45504,
     5  45480,45168,45048,44832,44784,44280,44088,43848,43752,41784,
     6  43896,43944,43872,43752,34248,27768,27864,27840,27720,27552,
     7  27120,26688,26568,26520,26568,26664,26856,26952,27144,27240,
     8  27408,31584,28320,28248,38328,38328,37488,36648,36144,35976,
     9  35568,42312,42936,43368,43416,43536,43752,44136,44208,44040/
            data (jx(i),i=  801,  900)/
     +  43968,44040,43992,44160,43992,43872,43896,41496,41616,41952,
     1  42072,42288,23256,22272,22296,34392,27984,26568,26568,26856,
     2  26976,26832,26688,26640,26568,26496,38448,27960,28296,28296,
     3  28656,28584,28536,28512,28560,28392,42456,41088,25320,36288,
     4  36216,34968,34896,34944,35184,35280,35304,33120,31728,32376,
     5  32400,33048,24360,24360,22800,22344,22296,22344,41256,26400,
     6  26256,26208,26064,26136,26136,25776,25728,25344,38256,38256,
     7  37272,37320,32568,32496,32400,32136,22680,22656,22896,23112,
     8  23184,23112,23136,23016,23112,23208,23184,23040,22992,26568,
     9  26448,26352,26304,26376,26328,26208,26184,26016,26040,26232/
            data (jx(i),i=  901, 1000)/
     +  26160,25992,25920,25752,25680,25608,25656,25584,25680,25728,
     1  26064,26136,26280,26424,26496,30144,20952,21000,40248,36384,
     2  40080,40104,39744,39744,39240,39240,32400,32400,23496,23400,
     3  25440,25464,31368,31392,32088,31896,31824,31704,31728,31680,
     4  31488,31464,31440,31512,31488,31344,31368,31008,30888,30792,
     5  30648,30600,30456,30384,30192,40440,22512,22536,22632,22704,
     6  22848,23112,22992,22944,23136,23160,22992,22776,22704,22728,
     7  22992,23208,23376,23496,23400,23304,23208,23136,23040,22920,
     8  32520,20976,20808,20760,20544,20592,22968,23208,23184,22968,
     9  22944,36504,36456,31992,32040,32136,32520,25560,25680,25968/
            data (jx(i),i= 1001, 1100)/
     +  26232,26472,26544,26664,26904,26880,27000,27120,27216,27528,
     1  27720,27840,28104,28344,28392,28560,28608,28920,29136,29400,
     2  29544,29520,29664,29640,29664,29808,29880,30000,20592,20640,
     3  20736,20808,20904,21072,21288,21384,21528,21624,21600,22560,
     4  22632,22872,22896,22824,22920,22968,23232,23256,23592,23592,
     5  24240,24240,24552,24576,24624,24720,24792,24840,24864,24960,
     6  25176,25176,25344,29280,29352,29544,29544,29736,29880,30000,
     7  30168,30312,30480,30504,30624,30696,30768,30792,30936,31008,
     8  31176,31296,31512,31872,31944,27576,27576,25560,36600,40608,
     9  32640,32592,22968,22944,23088,23040,23208,23232,23160,23232/
            data (jx(i),i= 1101, 1200)/
     +  23352,23880,23832,24048,24120,24168,24264,24168,24096,24384,
     1  23088,36744,36792,36840,20784,20856,21000,21120,21168,21096,
     2  21120,21216,21480,21552,21624,21816,21840,21720,21816,22032,
     3  21984,22104,22176,22536,22560,22344,22464,22680,22752,22728,
     4  22872,22896,22872,32736,33336,33480,33552,27816,27744,27816,
     5  27648,27672,27624,27624,27672,27960,28104,28200,28224,28176,
     6  28008,28080,28032,28056,28200,28248,28416,28512,28440,28464,
     7  28632,28800,29040,29256,43032,42072,40800,40464,20208,21912,
     8  21936,21864,21912,22968,36000,32568,23136,22992,22968,30432,
     9  22992,28968,27672,27696,27768,27792,27960,28104,28224,28488/
            data (jx(i),i= 1201, 1300)/
     +  28488,28776,28848,28848,28656,28824,28728,28872,29064,29112,
     1  29088,29016,28776,28248,28008,27768,27408,26472,26472,26136,
     2  26136,22992,40632,18936,18912,18168,18000,17808,17832,17568,
     3  17544,17568,24096,24000,18936,41664,38640,36192,35664,34344,
     4  32640,32832,33000,33240,33576,33816,34200,34200,34296,33672,
     5  30720,32040,32016,30504,30696,27888,27720,24912,18288,17976,
     6  17928,17832,17736,17544,17472,17328,17232,16968,16776,16296,
     7  16200,15936,15936,15888,15672,15648,15840,15744,15384,15240,
     8  15024,14856,14760,29880,29880,20640,20616,20520,20376,20232,
     9  20016,19920,29208,29208,29376,29376,29472,29496,29760,29808/
            data (jx(i),i= 1301, 1400)/
     +  19872,19632,19488,19440,19176,19056,38952,38904,38832,41880,
     1  35712,36696,36816,36912,36912,36096,36096,35592,35568,35352,
     2  35352,34824,34824,33840,29928,30000,30024,30264,30288,31008,
     3  31008,31104,31128,31224,31224,32016,41424,41904,36936,41496,
     4  41520,37056,38016,38016,35016,35088,34584,34560,34080,34104,
     5  45912,46344,46584,45840,45552,45576,41064,40824,40728,41208,
     6  41256,39624,39096,39000,39792,39840,39960,39816,39552,39648,
     7  39456,39480,43872,44664,45048,45216,45240,45024,44136,43392,
     8  43008,42888,42888,43152,43392,43536,41664,41712,41880,41616,
     9  41592,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  61656,61536,61944,61752,61416,59736,55944,55824,51624,51144,
     1  47664,44280,42432,38376,38256,34248,33456,30216,28176,26352,
     2  25320,23928,21144,17424,15408,16152,15744,15720,15600,15504,
     3  13152, 9408, 9528, 9168, 9168, 9096, 8808, 8688, 8664, 8760,
     4   8832, 8784, 8808, 8496, 8376, 8376, 8472, 8544, 8616, 8616,
     5   8544, 8616, 8640, 8784, 8880, 8832, 8928, 8880, 9048, 9168,
     6   9192, 8928, 8784, 8760, 8544, 8544, 8592, 8808, 8976, 9024,
     7   8928, 9000, 9096, 9264, 9408, 9384, 9408, 9528, 9480, 9384,
     8   8664, 8712, 8664, 8544, 8616, 8616, 8568, 8496, 8448, 8376,
     9   8400, 8352, 8352, 8256, 8208, 7896, 7896, 8328, 8640, 8544/
            data (jy(i),i=  101,  200)/
     +   8520, 8592, 8544, 8640, 8712, 8832, 9024, 9024, 9216, 9288,
     1   9288, 9360, 9264, 9216, 9384, 9432, 9336, 9384, 9360, 9408,
     2   9480, 9120, 8952, 8568, 8424, 8208, 7920, 7872, 7632, 7632,
     3   7392, 7344, 7224, 7128, 6840, 6720, 6408, 6432, 6576, 6576,
     4   6456, 6432, 6552, 6576, 6504, 6384, 6360, 6504, 6744, 7008,
     5   7128, 7272, 7512, 7968, 8136, 8328, 8256, 8304, 8400,62016,
     6  61224,61008,60912,61248,61056,60744,60504,60264,60144,59904,
     7  59520,59688,59496,59328,59304,59976,60024,59904,59712,59256,
     8  59064,58920,58464,58368,58248,58152,58200,58296,58584,58920,
     9  58992,58992,58848,58392,58368,58272,58128,57984,57864,57816/
            data (jy(i),i=  201,  300)/
     +  57768,57672,57480,57072,57000,57096,57192,57504,57648,57744,
     1  57768,57552,57264,56760,56472,56304,56160,56016,55656,55416,
     2  54816,54600,54360,54144,53832,53544,53424,53400,53496,53688,
     3  53952,54048,53928,54024,53952,53808,53544,53088,52920,53112,
     4  53016,52824,52488,52224,52152,52152,52536,52512,52392,52224,
     5  51936,51864,51936,51816,51696,51456,51336,51408,51648,51648,
     6  51528,51432,51264,50856,50808,50832,50712,50160,50088,49944,
     7  49896,49800,49512,49320,49248,49296,49608,49560,49776,49752,
     8  49656,49440,49032,48768,48336,48072,47544,47352,47184,47064,
     9  46992,47064,47256,47304,47040,47208,47112,46848,46752,46584/
            data (jy(i),i=  301,  400)/
     +  46416,46344,46512,46248,45984,45792,45768,45960,46368,46392,
     1  46344,46128,45960,45504,45168,45000,44808,44784,44952,44904,
     2  44592,44160,43944,43752,43392,43272,43200,43296,43512,43896,
     3  44016,43824,43536,43344,43224,42960,42792,42696,42600,42672,
     4  42888,43464,43464,43296,43104,42768,42408,42264,42096,41736,
     5  41304,41040,41400,41520,41544,41448,41088,40728,39816,39744,
     6  39696,39888,39840,39696,39456,39048,38904,38664,38544,38136,
     7  37872,37512,37320,37152,37128,37128,37224,37416,37752,37800,
     8  37920,38040,38112,38088,37896,37344,36744,36648,36528,36192,
     9  35904,35712,35520,35352,35304,35232,35160,34992,34248,34032/
            data (jy(i),i=  401,  500)/
     +  33600,33576,33792,34176,34176,34056,33840,33264,33192,32952,
     1  32688,32448,32376,32496,33024,33096,32904,32688,32400,32208,
     2  31968,31848,31824,31992,31992,31896,31656,31488,31152,31032,
     3  30936,30768,31176,31128,30480,30336,30096,30240,30264,30192,
     4  29760,29568,29280,29160,29184,29472,29592,29352,29424,29232,
     5  29280,29088,28632,28440,28392,28296,28296,28416,28464,28392,
     6  28632,28920,28728,28728,28416,28272,28032,27960,27792,27384,
     7  27456,27768,27768,27672,27552,27432,27312,27216,26904,26736,
     8  26568,26304,25872,25800,25584,25176,25104,24864,24768,24648,
     9  24648,24720,25056,25152,25128,24984,24168,24048,24024,24192/
            data (jy(i),i=  501,  600)/
     +  24144,24048,23880,23904,23688,23424,22656,22392,22368,22536,
     1  22728,22512,22248,22080,22032,22152,22176,22128,21984,21816,
     2  21600,21432,21408,21312,21096,20760,20448,19968,19752,19656,
     3  19536,19608,20064,20256,20256,20016,19896,19656,19728,19560,
     4  19296,18984,18744,18600,18456,18384,18408,18312,18096,17664,
     5  15744,15672,15768,17232,16968,16776,16344,16104,15936,15696,
     6  15336,15576,15432,15336,15288,15048,14952,14832,14784,14688,
     7  14544,14520,14352,14304,14160,14040,14040,13992,13632,13632,
     8  13536,13392,13368,13296,13296,13200,13032,12720,12504,12432,
     9  12312,12264,12120,11904,11808,11760,11544,11352,11208,11184/
            data (jy(i),i=  601,  700)/
     +  11136,11040,10992,10824,10776,10656,10608,10536,10488,10200,
     1  10176,10056, 9960, 9912,57096,59592,59640,60120,60120,56880,
     2  56880,59856,59832,59208,59064,59040,60192,60192,58872,58200,
     3  58272,58608,58632,58584,58344,58248,58272,58056,58224,58200,
     4  58272,58272,58320,58416,58656,58824,59760,57216,57240,57048,
     5  56424,56472,56232,56208,56088,56160,56112,56208,56064,56136,
     6  55992,56040,55848,57912,57888,59208,59040,59016,55896,56400,
     7  56256,58152,57912,57792,57624,57480,57168,57048,56784,56784,
     8  56568,56472,56424,56328,56208,55800,56304,55776,52272,51504,
     9  55728,54744,54720,54576,54672,54528,54552,54888,54912,56040/
            data (jy(i),i=  701,  800)/
     +  56064,52080,52296,51984,51864,51936,51216,51864,51792,51768,
     1  52968,53376,50784,50712,51432,51264,51096,51048,52872,52872,
     2  49656,49632,49632,51168,48576,48792,48840,48504,51648,51600,
     3  46920,48216,46728,47736,47760,47952,47952,47688,48144,47472,
     4  47424,47256,47208,48024,48048,47016,46104,46176,45264,47592,
     5  47352,46992,46944,47016,46800,46656,46656,46560,46440,46728,
     6  46824,46752,46728,46536,46416,47712,47520,47352,47232,47136,
     7  47184,46992,46872,46728,46560,46440,46392,46416,46848,46872,
     8  46704,46320,46224,46224,45240,44880,44856,44664,44400,44160,
     9  43992,44760,44784,45024,45000,45048,45312,45024,45048,45216/
            data (jy(i),i=  801,  900)/
     +  45480,45480,45648,45936,46056,46032,46368,45384,45432,45360,
     1  45432,45432,45384,45360,44376,43944,42288,42720,42576,42552,
     2  42312,42000,42096,41976,42000,41904,42072,43224,43248,43728,
     3  43752,45384,45432,45720,45960,46104,42288,42216,42168,39984,
     4  42000,41952,43632,43680,43632,43656,43824,41904,43344,43368,
     5  43200,43224,42144,41472,41424,43416,43416,41400,38040,41952,
     6  41808,41616,41592,41472,41232,41232,41088,41448,42072,41088,
     7  41016,40032,41880,41616,41568,41040,41352,41016,40824,40728,
     8  40608,40488,40272,39768,39768,39600,39480,39504,39432,39984,
     9  39984,39888,39768,39600,39528,39648,39864,39792,39648,39480/
            data (jy(i),i=  901, 1000)/
     +  39408,39456,39648,39576,39744,39696,39576,39504,39072,39000,
     1  38952,38616,38544,38688,38544,37104,39408,38376,37968,37896,
     2  37968,37896,37872,37944,37944,38016,37752,37224,37440,39456,
     3  38496,37488,37200,37128,40848,40752,40464,40440,40032,39936,
     4  39864,39792,39528,39432,39312,39240,39000,38592,38400,37752,
     5  37680,37488,37440,37272,37224,34008,36456,36216,36240,36168,
     6  36288,36216,36120,35904,35736,35568,35424,35568,35256,35184,
     7  34992,34992,34896,34728,34536,34512,34512,34776,34800,34464,
     8  34416,37512,37128,36696,36432,34440,34272,34248,34104,34056,
     9  33984,33864,33864,33816,33960,34008,33744,33528,33648,33552/
            data (jy(i),i= 1001, 1100)/
     +  33792,33888,33960,33936,34248,34320,34392,34344,34560,34536,
     1  34632,34584,34800,34824,34896,34944,35064,35064,35400,35472,
     2  35736,35856,36240,36504,36552,36576,36624,36960,33432,31560,
     3  31944,32016,32040,31968,32016,31968,32016,31968,33456,33504,
     4  33432,33384,33504,33624,33672,33912,33960,33648,33648,33168,
     5  33168,33024,33000,32760,32784,32712,32784,32760,32880,32928,
     6  32952,33120,33168,31608,32064,32112,32208,32520,32616,32616,
     7  32736,32736,32880,32952,32976,33144,33144,33216,33288,33552,
     8  33528,33768,33840,33816,33912,31608,32592,32544,29832,30000,
     9  29688,31248,29496,29664,29832,30048,30192,30312,30864,30960/
            data (jy(i),i= 1101, 1200)/
     +  30984,30840,31200,31656,31728,31920,32016,32064,32424,32712,
     1  27480,25824,25824,24984,27864,27888,27816,27816,27960,28128,
     2  28248,28392,28224,28344,28248,28344,28488,28560,28728,28680,
     3  28560,28464,28656,28680,28800,28944,29112,29112,29160,29256,
     4  29256,29328,29400,27696,27720,27216,24672,27600,27816,27960,
     5  28296,28416,28560,28968,29064,29088,29304,29280,29328,29544,
     6  29712,29808,29856,29928,30000,30312,30288,30384,30576,30672,
     7  30720,30936,31488,31536,25752,25560,25416,25368,25248,24864,
     8  24600,24480,24408,24456,24912,24552,25080,24912,24768,24360,
     9  23448,24192,27432,27312,27288,27144,26904,26880,26568,26232/
            data (jy(i),i= 1201, 1300)/
     +  25968,25776,25464,25320,25248,25032,24744,24624,24624,24528,
     1  24432,24384,24168,23904,23904,23736,23544,23544,23376,23376,
     2  23520,22464,20928,22344,22560,22584,22704,22800,22944,23016,
     3  23088,23280,19488,22464,19368,20976,20880,20784,20760,20736,
     4  22680,22680,22440,22320,22152,22104,21912,21696,21624,20688,
     5  20112,20136,20640,21624,21624,19560,19560,19512,19632,19488,
     6  19608,19608,19512,19536,19464,19416,19296,19320,19152,18936,
     7  19032,19032,18744,18624,18600,18552,18288,17976,17808,18048,
     8  18048,17832,17496,19464,20136,19416,19320,19320,19392,19296,
     9  19224,19272,19584,19536,19536,19440,19440,19368,19368,19464/
            data (jy(i),i= 1301, 1400)/
     +  19224,19104,19152,19128,19224,19344,14880,15912,15912,16008,
     1  19752,19800,15960,15960,15864,15840,15624,15600,15816,15816,
     2  15984,15960,15792,15768,18264,18264,17688,17688,17136,17160,
     3  16944,16968,16680,16680,16512,16536,14952,14976,14832,12960,
     4  12312,11808,11832,12192,11784,10248,10248,10080,10056, 9552,
     5   7080, 7176, 7104, 7008, 7104, 7176, 6912, 6864, 6936, 7032,
     6   7008, 7032, 7080, 7128, 7152, 7296, 7368, 6960, 6624, 6888,
     7   6888, 6960, 7368, 7248, 7248, 7320, 7248, 7152, 7224, 7416,
     8   7344, 7392, 7440, 7464, 7536, 7440, 7296, 7368, 7296, 7176,
     9   7200,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +     31,   34,   35,   36,   37,   38,   39,   40,   41,   42,
     1     43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
     2     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     3     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     4     73,   74,   75,   76,   77,   78,   79,   32,   81,   82,
     5     83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
     6     93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
     7    103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
     8    113,  114,  115,  116,  117,  118,  119,  120,   32,   33,
     9    122,  123,  124,  125,  126,  127,  128,  129,  130,  131/
            data (jb1(i),i=  101,  200)/
     +    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     1    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     2    152,  153,  154,  155,  156,  157,  158,   81,    3,  160,
     3    161,  162,    7,    3,    1,    1,    2,    5,  164,  165,
     4    166,  167,  168,  169,    6,    6,  171,  172,  173,  174,
     5    175,  176,  177,  178,  179,  180,  181,  182,  183,  184,
     6    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     7    195,  196,  197,  198,  199,  200,  201,  202,  203,  204,
     8    205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
     9    215,  216,  217,    8,    7,    8,  219,  220,  221,  222/
            data (jb1(i),i=  201,  300)/
     +    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     1    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     2    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     3    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     4     10,    9,   10,  264,  265,  266,  267,  268,  269,  270,
     5    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     6    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     7    291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
     8    301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
     9    311,  312,  313,  314,  315,  316,  317,  318,  319,  320/
            data (jb1(i),i=  301,  400)/
     +     12,   11,   12,  322,  323,  324,  325,  326,  327,  328,
     1    329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
     2    339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
     3    349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
     4    359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
     5     14,   13,   15,   14,  370,  371,  372,  373,  374,  375,
     6    376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
     7    386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
     8    396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
     9    406,   17,   17,  408,  409,  410,  411,  412,  413,  414/
            data (jb1(i),i=  401,  500)/
     +    415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
     1    425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
     2    435,  436,  437,  438,  439,  440,  441,  442,  443,  444,
     3    445,  446,  447,  448,  449,  450,  451,  452,  453,  454,
     4    455,  456,  457,  458,  459,  460,  461,  462,  463,  464,
     5    465,   19,   16,   18,   19,  467,  468,  469,  470,  471,
     6    472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
     7    482,  483,  484,   21,   21,  486,  487,  488,  489,  490,
     8    491,  492,  493,  494,  495,  496,  497,  498,  499,  500,
     9    501,  502,   22,   22,  504,  505,  506,  507,  508,  509/
            data (jb1(i),i=  501,  600)/
     +    510,  511,  512,  513,  514,  515,  516,  517,  518,  519,
     1    520,  521,  522,  523,  524,  525,  526,  527,  528,  529,
     2    530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
     3    540,  541,  542,  543,  544,  545,  546,  547,  548,  549,
     4     24,   20,   23,   28,  551,  552,   27,   28,   29,   25,
     5     24,  554,  555,  556,  557,  558,  559,  560,   25,   26,
     6     27,  562,  563,  564,  565,  566,  567,  568,  569,  570,
     7    571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
     8    581,  582,  583,  584,  585,  586,  587,  588,  589,  590,
     9    591,  592,  593,  594,  595,  596,  597,  598,  599,  600/
            data (jb1(i),i=  601,  700)/
     +    601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
     1    611,  612,  613,   33,  615,  616,  617,  618,  619,  620,
     2    621,  622,  623,  624,  624,  625,  626,  627,  628,  629,
     3    630,  631,  632,  633,  634,  635,  636,  637,  638,  639,
     4    640,  641,  642,  643,  644,  645,  629,    6,  630,  648,
     5    625,  615,  620,  615,  651,  652,  653,  654,  655,  656,
     6    657,  658,  659,  660,  661,  662,  651,  664,  629,  624,
     7    666,  667,  668,  651,  670,  630,  672,  673,  674,  675,
     8    676,  677,  678,  679,  680,  681,  682,  683,  671,  648,
     9    669,  620,  669,  685,  686,  671,  670,  686,  688,  691/
            data (jb1(i),i=  701,  800)/
     +    692,  693,  694,  695,  696,  663,  697,  698,  699,  700,
     1    685,  694,  689,  703,  705,  689,  702,  697,  705,  708,
     2    709,  710,  711,  688,  690,  710,  713,  690,  715,  707,
     3    707,  717,  702,  693,  719,  714,  714,  721,  722,  723,
     4    724,  704,  726,  727,  725,  705,  729,  726,  725,  716,
     5    733,  734,  735,  736,  726,  721,  732,  739,  740,  741,
     6    742,  743,  744,  717,  743,  731,  742,  747,  748,   11,
     7    750,  751,  752,  753,  754,  755,  756,  757,  758,  732,
     8    760,  761,  762,  763,  759,  731,  738,  766,  767,  768,
     9    769,  770,  771,  772,  773,  774,  775,  776,  777,  778/
            data (jb1(i),i=  801,  900)/
     +    779,  780,  733,  765,  782,  783,  733,  749,  785,  786,
     1    787,  788,  789,  790,  792,  793,  794,  795,  796,  797,
     2    798,  799,  800,  801,  802,  803,  804,  805,  806,  759,
     3    749,  808,  809,  810,  811,  792,  722,  813,  814,  815,
     4    791,  765,  817,  818,  819,  820,  821,  822,  823,  824,
     5    825,  786,  817,  828,  829,  830,  831,  832,  833,  834,
     6    835,  783,  837,  792,  837,  827,  738,  840,  841,  842,
     7    843,  844,  845,  846,  791,  842,  782,  849,  850,  851,
     8    848,  839,  853,  854,  815,  856,  857,  855,  838,  826,
     9    860,  861,  862,  863,  864,  865,  866,  867,  839,  827/
            data (jb1(i),i=  901, 1000)/
     +    869,  870,  871,  840,  848,  873,  874,  875,  817,  855,
     1    877,  878,  879,  880,  881,  882,  883,  884,  885,  886,
     2    887,  888,  826,  890,  891,  892,  893,  894,  895,  896,
     3    897,  898,  899,  900,  901,  902,  903,  904,  905,  906,
     4    907,  908,  909,  910,  911,  912,  913,  914,  915,  889,
     5    917,  918,  859,  859,  840,  919,  921,  922,  923,  924,
     6    925,  920,  920,  927,  929,  889,  913,  931,  929,  928,
     7    933,  916,  876,  935,  936,  937,  938,  939,  940,  941,
     8    942,  943,  944,  945,  946,  947,  948,  949,  950,  951,
     9    952,  953,  954,  916,  919,  929,  957,  958,  959,  960/
            data (jb1(i),i= 1001, 1100)/
     +    961,  962,  963,  964,  965,  966,  967,  968,  969,  970,
     1    971,  972,  973,  974,  975,  976,  977,  978,  979,  928,
     2    918,  982,  983,  984,  985,  980,  956,  980,  987,  988,
     3    989,  990,  956,  920,  992,  994,  995,  981,  993,  981,
     4    998,  999, 1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007,
     5   1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017,
     6   1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027,
     7    916,   17, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036,
     8   1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045,  991,
     9    991, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055/
            data (jb1(i),i= 1101, 1200)/
     +   1056, 1057, 1058, 1059, 1060, 1061, 1062,  998, 1064, 1065,
     1   1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075,
     2   1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084,  994,
     3   1064, 1086, 1087,  998,  993,   18,  956, 1089, 1089,  994,
     4   1091, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101,
     5   1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1054, 1093,
     6   1089, 1112, 1113,   19, 1115, 1116, 1117, 1118, 1119, 1120,
     7   1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130,
     8   1131, 1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140,
     9   1141, 1142, 1093, 1144, 1145, 1146, 1091, 1144, 1148, 1149/
            data (jb1(i),i= 1201, 1300)/
     +   1150, 1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159,
     1   1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169,
     2   1170, 1171, 1172, 1173, 1064, 1111,   20, 1175, 1176, 1090,
     3   1177,   21, 1179, 1180, 1181, 1182, 1183, 1114, 1114, 1147,
     4   1147, 1111, 1187, 1188, 1184, 1186, 1184, 1190, 1148, 1193,
     5   1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202, 1203,
     6   1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1192, 1192,
     7   1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1191, 1191,
     8   1178, 1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232,
     9   1233, 1222, 1222, 1224, 1236, 1223, 1223, 1237, 1185, 1238/
            data (jb1(i),i= 1301, 1400)/
     +   1239, 1186, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248,
     1   1240, 1240, 1251, 1252, 1250, 1190, 1254, 1251, 1216, 1256,
     2   1257, 1233, 1235, 1259, 1260, 1261, 1262, 1263, 1264, 1265,
     3   1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275,
     4   1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1251,
     5   1233, 1286, 1287, 1288, 1289, 1290, 1291, 1256, 1293, 1294,
     6   1295, 1296, 1297, 1298, 1299, 1284, 1292, 1301, 1302, 1303,
     7   1304, 1305, 1235, 1307, 1308, 1237, 1292, 1236, 1239, 1311,
     8   1312, 1313, 1314, 1310, 1315, 1316, 1317, 1318, 1319, 1320,
     9   1321, 1322, 1323, 1250, 1324, 1284, 1325, 1326, 1327, 1328/
            data (jb1(i),i= 1401, 1480)/
     +   1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336, 1257, 1258,
     1   1337, 1310, 1307, 1307, 1315, 1337, 1340, 1340, 1342, 1343,
     2   1341, 1339, 1341, 1342, 1345, 1346, 1347, 1348, 1349, 1350,
     3   1342,    1,    2,    3,    4,    5,    1,    7,    8,    9,
     4     10,    7,   12,   13,   14,   15,   16,   17,   18,   19,
     5     20,   21,   12,   23,   24,   25,   26,   27,   28,   29,
     6     30,   31,   32,   33,   34,   35,   23,   37,   38,   39,
     7     40,   37,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
     1     44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
     2     54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
     3     64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
     4     74,   75,   76,   77,   78,   79,   80,   80,   82,   83,
     5     84,   85,   86,   87,   88,   89,   90,   91,   92,   93,
     6     94,   95,   96,   97,   98,   99,  100,  101,  102,  103,
     7    104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
     8    114,  115,  116,  117,  118,  119,  120,  121,  121,  122,
     9    123,  124,  125,  126,  127,  128,  129,  130,  131,  132/
            data (jb2(i),i=  101,  200)/
     +    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     1    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     2    153,  154,  155,  156,  157,  158,  159,  159,  160,  161,
     3    162,  163,  163,    4,    4,    2,    5,  164,  165,  166,
     4    167,  168,  169,  170,  170,  171,  172,  173,  174,  175,
     5    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     6    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     7    196,  197,  198,  199,  200,  201,  202,  203,  204,  205,
     8    206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
     9    216,  217,  218,  218,    9,  219,  220,  221,  222,  223/
            data (jb2(i),i=  201,  300)/
     +    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     1    234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
     2    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     3    254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
     4    263,   11,  264,  265,  266,  267,  268,  269,  270,  271,
     5    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     6    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     7    292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
     8    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     9    312,  313,  314,  315,  316,  317,  318,  319,  320,  321/
            data (jb2(i),i=  301,  400)/
     +    321,   13,  322,  323,  324,  325,  326,  327,  328,  329,
     1    330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
     2    340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
     3    350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
     4    360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
     5    369,   15,   16,  370,  371,  372,  373,  374,  375,  376,
     6    377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
     7    387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
     8    397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
     9    407,  407,  408,  409,  410,  411,  412,  413,  414,  415/
            data (jb2(i),i=  401,  500)/
     +    416,  417,  418,  419,  420,  421,  422,  423,  424,  425,
     1    426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
     2    436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
     3    446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
     4    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     5    466,  466,   18,   20,  467,  468,  469,  470,  471,  472,
     6    473,  474,  475,  476,  477,  478,  479,  480,  481,  482,
     7    483,  484,  485,  485,  486,  487,  488,  489,  490,  491,
     8    492,  493,  494,  495,  496,  497,  498,  499,  500,  501,
     9    502,  503,  503,  504,  505,  506,  507,  508,  509,  510/
            data (jb2(i),i=  501,  600)/
     +    511,  512,  513,  514,  515,  516,  517,  518,  519,  520,
     1    521,  522,  523,  524,  525,  526,  527,  528,  529,  530,
     2    531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
     3    541,  542,  543,  544,  545,  546,  547,  548,  549,  550,
     4    550,   23,   26,  551,  552,  553,  553,   29,   30,   30,
     5    554,  555,  556,  557,  558,  559,  560,  561,  561,   31,
     6    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     7    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     8    582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
     9    592,  593,  594,  595,  596,  597,  598,  599,  600,  601/
            data (jb2(i),i=  601,  700)/
     +    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     1    612,  613,  614,  614,  616,  617,  618,  619,    1,  621,
     2    622,  623,    2,    3,  625,  626,  627,  628,    4,    5,
     3    631,  632,  633,  634,  635,  636,  637,  638,  639,  640,
     4    641,  642,  643,  644,  645,  646,  646,  647,  647,  649,
     5    649,  648,  650,  650,  652,  653,  654,  655,  656,  657,
     6    658,  659,  660,  661,  662,  663,  664,  665,  665,  666,
     7    667,  668,  669,  670,  671,  672,  673,  674,  675,  676,
     8    677,  678,  679,  680,  681,  682,  683,  684,  684,  685,
     9      7,  663,  686,  687,  687,  688,  689,  690,  691,  692/
            data (jb2(i),i=  701,  800)/
     +    693,    8,  695,  696,  697,  694,  698,  699,  700,  701,
     1    701,  702,  703,  704,  706,  706,  704,  707,  708,  709,
     2    710,  711,  712,  712,    9,  713,  714,  715,  716,  716,
     3    717,  718,  718,  719,  720,  720,  721,  722,  723,  724,
     4     10,  725,  727,  728,  728,  729,  730,  730,  731,  732,
     5    734,  735,  736,  737,  737,  738,  739,  740,  741,  742,
     6    743,  744,  745,  745,  746,  746,  747,  748,  749,  750,
     7    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     8    761,  762,  763,  764,  764,  765,  766,  767,  768,  769,
     9    770,  771,  772,  773,  774,  775,  776,  777,  778,  779/
            data (jb2(i),i=  801,  900)/
     +    780,  781,  781,  782,  783,  784,  784,  785,  786,  787,
     1    788,  789,  790,  791,  793,  794,  795,  796,  797,  798,
     2    799,  800,  801,  802,  803,  804,  805,  806,  807,  807,
     3    808,  809,  810,  811,  812,  812,  813,  814,  815,   12,
     4    816,  816,  818,  819,  820,  821,  822,  823,  824,  825,
     5    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     6    836,  836,   13,  837,  838,  838,  839,  841,  842,  843,
     7    844,  845,  846,  847,  847,  848,  849,  850,  851,  852,
     8    852,  853,  854,  855,  856,  857,  858,  858,  859,  860,
     9    861,  862,  863,  864,  865,  866,  867,  868,  868,  869/
            data (jb2(i),i=  901, 1000)/
     +    870,  871,  872,  872,  873,  874,  875,  876,  876,  877,
     1    878,  879,  880,  881,  882,  883,  884,  885,  886,  887,
     2    888,  889,  890,  891,  892,  893,  894,  895,  896,  897,
     3    898,  899,  900,  901,  902,  903,  904,  905,  906,  907,
     4    908,  909,  910,  911,  912,  913,  914,  915,  916,  917,
     5    918,   14,   15,  919,  920,  921,  922,  923,  924,  925,
     6    926,  926,  927,  928,  930,  930,  931,  932,  932,  933,
     7    934,  934,  935,  936,  937,  938,  939,  940,  941,  942,
     8    943,  944,  945,  946,  947,  948,  949,  950,  951,  952,
     9    953,  954,  955,  955,  956,  957,  958,  959,  960,  961/
            data (jb2(i),i= 1001, 1100)/
     +    962,  963,  964,  965,  966,  967,  968,  969,  970,  971,
     1    972,  973,  974,  975,  976,  977,  978,  979,  980,  981,
     2    982,  983,  984,  985,  986,  986,   16,  987,  988,  989,
     3    990,  991,  992,  992,  993,  995,  996,  996,  997,  997,
     4    999, 1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008,
     5   1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018,
     6   1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028,
     7   1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037,
     8   1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1046,
     9   1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056/
            data (jb2(i),i= 1101, 1200)/
     +   1057, 1058, 1059, 1060, 1061, 1062, 1063, 1063, 1065, 1066,
     1   1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,
     2   1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1085,
     3   1086, 1087, 1088, 1088, 1089, 1090, 1090, 1090, 1091, 1092,
     4   1092, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102,
     5   1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1110, 1111,
     6   1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121,
     7   1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     8   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141,
     9   1142, 1143, 1143, 1145, 1146, 1147, 1144, 1148, 1149, 1150/
            data (jb2(i),i= 1201, 1300)/
     +   1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160,
     1   1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170,
     2   1171, 1172, 1173, 1174, 1174, 1148, 1175, 1176, 1177, 1177,
     3   1178, 1179, 1180, 1181, 1182, 1183, 1184, 1178, 1185, 1185,
     4   1186, 1187, 1188, 1189, 1189, 1190, 1191, 1192, 1193, 1194,
     5   1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202, 1203, 1204,
     6   1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1212, 1213,
     7   1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1221, 1222,
     8   1223, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232,   22,
     9   1234, 1234, 1224, 1235,   23, 1236, 1237, 1238, 1238, 1239/
            data (jb2(i),i= 1301, 1400)/
     +   1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249,
     1   1249, 1250, 1252, 1253, 1253, 1254, 1255, 1255, 1256, 1257,
     2   1258, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266,
     3   1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276,
     4   1277, 1278, 1279, 1280, 1281, 1282, 1283,   24, 1285, 1285,
     5   1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295,
     6   1296, 1297, 1298, 1299, 1300, 1300, 1301, 1302, 1303, 1304,
     7   1305, 1306, 1306, 1308, 1309, 1309,   25, 1310, 1311, 1312,
     8   1313, 1314, 1315,   26, 1316, 1317, 1318, 1319, 1320, 1321,
     9   1322, 1323, 1324, 1324,   27, 1325, 1326, 1327, 1328, 1329/
            data (jb2(i),i= 1401, 1480)/
     +   1330, 1331, 1332, 1333, 1334, 1335, 1336,   28,   29,   30,
     1   1338, 1338, 1337, 1339, 1339, 1340,   31, 1341, 1343, 1344,
     2   1344, 1342,   32, 1345, 1346, 1347, 1348, 1349, 1350,   33,
     3     81,    2,    3,    4,    5,    6,    6,    8,    9,   10,
     4     11,   11,   13,   14,   15,   16,   17,   18,   19,   20,
     5     21,   22,   22,   24,   25,   26,   27,   28,   29,   30,
     6     31,   32,   33,   34,   35,   36,   36,   38,   39,   40,
     7     41,   41,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine mo(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1390) :: jx,jy
            integer(kind=iknd), save, dimension(1500) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'missouri      '/
            data jrot,ipart/0,1/
            data kv/   1,1385,   0,   0,   0/
            data kb/   1,1499,   0,   0,   0/
            data iib/ 367,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  14184,17016,23112,30432,27864,33384,10104, 7536,20280,36624,
     1  11448,37104,12264,38064,10608,39024,14136,42432,14112,42912,
     2  14064,46944,45984,46608,13968,45408,46176,13872,48528,13800,
     3  51768,13752,52224,13704,35880,44160,27552,13632,39984,32472,
     4  46848,23448,17712,21432,51960,48960, 6144, 6048, 6096, 6192,
     5   6528, 6600, 6600, 6744, 6840, 6888, 6840, 6648, 6672, 6528,
     6   6792, 6792, 6912, 6960, 7056, 7032, 6816, 6792, 6864, 7104,
     7   7464, 7560,36648,36840,37152,37008,36864,36816,36672,36624,
     8  36408,36432,36336,36384,36048,35904,35712,35712,35232,35184,
     9  34920,36576,36528,36528,36696,36696, 7680, 8040, 8112, 8016/
            data (jx(i),i=  101,  200)/
     +   8160, 8352, 8424, 8616, 8640, 8520, 8424, 8544, 8856, 8976,
     1   9264, 9456, 9648, 9936, 9984, 9936,10104,10320,10416,10704,
     2  11088,11184,11280,11664,11856,11928,11832,11856,11976,12192,
     3  37248,37056,37080,37176,37632,37680,37632,37656,38328,38640,
     4  12216,11904,11856,11976,12312,12360,12312,12240,12072,11712,
     5  11640,11568,11184,10992,10944,11016,10968,10896,10608,10536,
     6  10512,39144,39264,39528,39648,39936,40056,40344,40776,40872,
     7  41424,41856,42168,42336,10920,11016,11400,11496,11688,11712,
     8  11808,12048,12096,12144,12000,11952,12000,12096,12504,12528,
     9  12456,12600,12816,13080,13320,13632,13728,13728,13800,14232/
            data (jx(i),i=  201,  300)/
     +  42576,42768,42528,42816,42840,42984,43248,43608,43800,44088,
     1  44376,44496,44976,45528,46008,46944,47016,46320,46296,46512,
     2  46560,46416,46176,45792,45216,45216,45336,45576,45960,46608,
     3  47112,47256,47664,48048,48480,48504,48288,48840,49272,49656,
     4  49992,50256,50520,50640,50592,50616,51000,51192,51720,51792,
     5  51792,52032,52104,52032,51792,52320,52296,52440,52656,53016,
     6  52968,53544,51792,52008,52416,52560,52512,52128,51936,51912,
     7  52032,53520,53976,54096,54312,54480,54528,54768,54696,54480,
     8  54480,54648,54984,55080,54984,54744,54624,54600,54840,54936,
     9  55128,55080,54936,54600,54480,54360,54072,53976,53520,53544/
            data (jx(i),i=  301,  400)/
     +  53856,53928,53904,53784,53688,13608,52152,52224,52176,51912,
     1  52152,52104,51816,51720,51768,51960,52368,52512,52344,52416,
     2  52584,52728,52896,53208,53328,50808,51048,51120,51240,51600,
     3  51744,51648,50928,50856,51000,51504,51984,52056,51576,51432,
     4  51456,51552,47352,47304,47424,47496,47448,47568,47928,48024,
     5  48048,47952,48072,47928,47688,47592,47616,47184,46920,46800,
     6  46536,46392,46224,46200,46104,46080,45792,14160,14304,14304,
     7  14376,17136,17160,17040,23184,30480,28104,27840,27912,27960,
     8  28008,27864,28056,28056,28008,27936,28152,28032,28152,28080,
     9  28008,28008,27960,27960,28008,27912,27984,27912,28032,27984/
            data (jx(i),i=  401,  500)/
     +  28248,28128,28224,28176,28080,26856,26856,33360,30480,10200,
     1  10272,10080,23184,20352,20352,20304,33360,10944,10944,11016,
     2  10968,10992,10944,11040,10992,11040,11016,11064,11088,11160,
     3  17088,14256,11448,11352,11472,11376,11400,11352,11400,11328,
     4  11376,11280,11184,11136,11016,11016,11064,11064,11112,11160,
     5  11136,11184,11136,11208,11136,11184,11136,20352,14280,30552,
     6  17040,26928,26880,23208,23160,23208,20352,34200,30960,30552,
     7  33360,14232,17160,17112,20328,14232,17088,23952,23160,26856,
     8  25224,35112,35112,34176,23784,23760,23832,23712,23904,23784,
     9  20328,28032,28056,30912,31728,31728,30888,35136,14208,17040/
            data (jx(i),i=  501,  600)/
     +  20304,14184,17040,25032,24888,24600,24480,24360,24264,24216,
     1  24120,24144,24048,24000,23976,23808,23880,23784,23904,23688,
     2  23736,23808,23928,23856,23856,30840,32520,37200,37008,38832,
     3  35136,27960,29976,30840,27360,26904,22344,22416,22536,22872,
     4  22800,22872,23184,23376,23448,23328,23376,23808,24000,24168,
     5  24216,24456,24384,24432,24624,24816,26808,26592,26448,26400,
     6  26448,26160,26160,26088,25584,25392,25296,25200,25080,16992,
     7  20280,20688,20832,21048,21096,21528,21744,22080,22224,22176,
     8  22224,37440,38496,39072,39048,17256,17256,17160,17184,17520,
     9  17736,17952,18216,18336,18264,18624,18744,18792,18624,18600/
            data (jx(i),i=  601,  700)/
     +  18768,18936,18936,19272,19560,19776,20088,16848,16752,16440,
     1  16320,16080,15840,15672,15552,15576,15432,15192,14832,14664,
     2  14424,35808,35832,32328,32352,26304,26496,26520,26256,26232,
     3  26496,26520,26856,38520,28992,29040,28968,29016,26520,27000,
     4  27480,27912,28080,28368,28752,22176,32160,32112,32184,32064,
     5  32088,31992,31920,31968,32088,32016,31968,32064,32040,32088,
     6  32064,32136,32064,32088,32040,32112,32112,32184,32136,32088,
     7  31992,32016,31944,31968,31920,31824,31848,31752,31752,31584,
     8  31536,31536,25464,25440,22176,29496,17664,19704,19704,40800,
     9  40776,40968,41136,41880,41880,41952,41952,42408,42480,42432/
            data (jx(i),i=  701,  800)/
     +  42480,42504,42624,42672,42576,42576,42768,42672,42720,39096,
     1  39096,39648,39672,17616,29664,29712,29952,30072,30360,30360,
     2  30192,30168,30216,30288,38544,37440,37440,37800,35808,35760,
     3  25368,27024,37056,36456,36096,28632,42504,42840,42888,42984,
     4  43176,43344,43728,43944,43968,44280,44520,44640,44976,45168,
     5  45288,45336,45408,45648,45912,46344,46776,46896,30480,30600,
     6  30624,30480,30504,31008,31248,33576,33888,34056,34224,34872,
     7  35160,18024,17592,17616,17544,31680,31680,31728,32016,32352,
     8  32760,33072,33336,40800,40416,40272,40128,39888,39600,38856,
     9  38832,38208,37992,45672,45528,45648,46080,46368,46488,22080/
            data (jx(i),i=  801,  900)/
     +  42120,41952,41664,41568,41208,40896,25320,22056,23664,23712,
     1  42504,18000,17784,17664,17352,17328,17208,17184,17064,16992,
     2  16944,16824,16776,16800,16704,16704,16536,16344,16296,16176,
     3  18072,17904,28608,27000,29568,45384,45456,45384,45072,45024,
     4  44904,44808,44928,44904,43560,43440,43368,43200,43080,43104,
     5  42912,42792,42648,42648,21960,31776,31776,32136,32352,32352,
     6  32280,32040,31968,32088,32400,33024,33120,33000,33000,33288,
     7  30216,30216,31104,31344,31464,31536,31776,35832,34128,34224,
     8  25272,42504,42240,28080,28128,28536,28560,37896,39912,37896,
     9  21744,21624,21696,21840,22104,22176,22056,25368,25464,25752/
            data (jx(i),i=  901, 1000)/
     +  25800,25968,25944,25800,25704,25752,25848,25920,26160,26280,
     1  26328,26136,27576,27576,27696,27912,28032,36672,36648,35952,
     2  35856,43008,42984,43128,43200,43176,43296,46080,45960,45840,
     3  45576,45000,25368,25368,25224,18000,43512,43464,43512,43416,
     4  43752,17952,17904,17784,17760,17688,17640,17592,17544,17592,
     5  17448,17016,16992,16944,16992,16872,16824,16776,16752,16656,
     6  16584,16680,16656,16728,16656,16656,30240,29424,29424,29280,
     7  29280,29160,29136,28992,29016,28896,28896,28824,28824,28752,
     8  28752,28488,28488,28224,31872,31896,31752,39960,39960,33096,
     9  35976,34008,33768,33600,33480,33048,17928,25296,26904,30216/
            data (jx(i),i= 1001, 1100)/
     +  19824,19800,21168,21552,21624,22032,21552,24432,24480,36744,
     1  36768,34728,34704,38424,38400,39576,28656,28704,28800,28800,
     2  29016,29088,29208,29304,29448,29544,29928,30120,43344,31416,
     3  31416,30192,41640,41640,47328,47016,46656,44712,45648,48096,
     4  39624,39624,47064,44184,43344,17832,49200,47088,49560,49680,
     5  49656,49776,49824,49968,50160,50280,50328,50448,50496,50568,
     6  50592,50640,50688,50688,50808,50880,50880,51048,51144,51240,
     7  51288,51312,51528,51600,51624,51696,44208,44112,44160,39600,
     8  40008,40872,42456,42480,42624,42624,42768,17808,20376,20544,
     9  21240,21144,21312,21240,46632,47160,47160,21240,26880,26976/
            data (jx(i),i= 1101, 1200)/
     +  26928,28176,31416,31440,31488,31464,35136,35160,35952,39216,
     1  21192,39192,38424,38424,40704,40704,40536,40536,40296,40296,
     2  40152,40152,39864,39864,39600,39624,39480,39456,24480,24552,
     3  24408,25296,25296,17736,44160,17952,17712,21144,50088,50112,
     4  50376,50376,50520,50520,50640,50640,50784,50784,50904,50904,
     5  51120,51120,51408,51408,51648,51648,51960,49296,42792,42648,
     6  42648,42480,42504,40032,40032,39216,39216,37560,37560,37152,
     7  37152,21264,21312,25344,47520,47496,46680,25392,25272,48360,
     8  48360,48624,48624,26568,26568,35928,43296,43152,43152,43032,
     9  43008,42864,42864,41112,41112,28224,28248,28152,32664,17880/
            data (jx(i),i= 1201, 1300)/
     +  35928,46680,46704,46824,46824,46968,46968,47088,47088,47208,
     1  47232,21264,26544,46560,46680,50016,49944,50088,50184,50208,
     2  50256,50448,50520,50688,50760,50712,50760,50688,50736,50736,
     3  46440,46560,17856,21240,52008,46464,46512,46440,46560,46512,
     4  46536,46464,46512,46584,39192,39192,40008,43440,43440,43296,
     5  35928,35832,35808,35856,40824,40824,41280,23520,23256,23304,
     6  27600,32496,32616,43704,43728,43992,44016,44136,17784,21432,
     7  21504,21240,46776,46728,46776,46752,46824,46800,46944,46896,
     8  46944,46896,46872,47016,46992,47064,47016,47136,47112,47184,
     9  47208,47328,47304,47352,47400,47352,47400,47328,47400,47328/
            data (jx(i),i= 1301, 1390)/
     +  47448,47352,47424,47400,48768,50712,50616,47376,47352,47400,
     1  46872,46944,46920,47088,47136,47064,47136,47088,47112,47112,
     2  47160,47256,47208,47304,47280,47352,47304,48840,48792,48840,
     3  48744,48840,51960,51888,51888,51792,51624,51480,51264,51024,
     4  50832,50592,50496,50448,50376,52008,52128,52152,52392,52392,
     5  52656,52656,52776,52776,53040,53040,53256,53256,52008,52128,
     6  52128,52296,52296,52368,52368,52440,52464,52584,52608,52656,
     7  52656,52752,52728,52944,52944,53016,53016,53160,53256,53376,
     8  53376,53448,53448,53520,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  55344,55296,55320,55512,55416,55632,55512,52608,55320,52296,
     1  49104,49512,48360,47088,45696,46272,42120,42864,41712,40152,
     2  39192,39048,36456,38712,35712,35064,32616,31824,30384,28032,
     3  27576,25320,24648,22464,17184,17328,17088,19728,17232,17112,
     4  17400,17088,17160,17112,16080,12792,55704,55632,55248,55152,
     5  55104,55152,55392,55464,55368,55200,55032,54960,54792,54648,
     6  54312,54048,53808,53544,53400,53280,53184,53112,53040,53112,
     7  52944,52824,52584,53160,53544,53592,53496,53592,53592,53736,
     8  53832,54024,54096,54264,54336,54600,54744,55008,55176,55440,
     9  55704,52200,51624,51192,50544,50280,52512,52416,52224,51936/
            data (jy(i),i=  101,  200)/
     +  51744,51600,51360,51288,51144,51000,50616,50400,50424,50376,
     1  49944,49824,49608,49536,49416,49200,49152,49224,48960,48816,
     2  48816,48888,49104,49128,49056,48960,48744,48624,48528,48480,
     3  49248,48960,48672,48480,48144,48024,47616,47448,46896,46488,
     4  48168,48072,47976,47832,47904,47760,47592,47496,47472,47688,
     5  47640,47136,46968,46680,46512,46320,46224,46152,46152,46080,
     6  45912,45888,45768,45768,45672,45072,44928,44688,44520,44352,
     7  44016,43632,43272,43152,45408,45048,44856,44640,44496,44352,
     8  44280,44352,44304,44160,44016,43896,43608,43392,43056,42912,
     9  42720,42624,42600,42264,42240,42360,42312,42168,42096,42000/
            data (jy(i),i=  201,  300)/
     +  42072,41712,41208,40656,40368,40008,39720,39528,39624,39888,
     1  40440,40488,40416,40128,40056,39480,39336,38352,38184,37728,
     2  37344,37056,36792,35568,34464,34032,33648,33240,33000,32232,
     3  32064,31776,31584,31224,31152,31080,30792,30336,30672,30312,
     4  30192,29928,29784,29592,29328,29280,29160,28944,28776,28680,
     5  28272,27984,27816,27744,27720,24624,24336,23928,23544,23184,
     6  22752,22392,27384,26904,26424,25992,25560,25416,25224,24840,
     7  24648,18864,18336,18264,18312,18504,18936,19224,19440,19728,
     8  19920,20112,20064,20184,20400,20424,20544,20880,20952,21072,
     9  21960,22176,22248,22104,22128,22536,22752,22944,22920,22800/
            data (jy(i),i=  301,  400)/
     +  22632,22488,22344,22224,22248,17208,16152,16344,16560,17040,
     1  17328,17448,17808,18024,18216,18360,18288,18000,17328,17232,
     2  17208,17328,17616,18792,18888,12888,13224,13728,13824,13992,
     3  14232,14376,14976,15144,15240,15144,15264,15480,15744,15960,
     4  16056,16128,17400,17256,17184,16896,16728,16608,16536,16440,
     5  16248,15792,15600,15336,15216,15024,14928,14688,14448,14040,
     6  13824,13776,13560,13416,13320,13176,12672,54432,54432,53616,
     7  53616,53544,54360,54360,53496,53160,53112,55344,55344,55248,
     8  55200,55128,55128,55032,55032,54864,54768,54720,54528,54432,
     9  54456,54384,54432,54288,54288,54216,54096,54048,53976,53904/
            data (jy(i),i=  401,  500)/
     +  53736,53712,53616,53568,53592,53112,53520,52800,52776,52536,
     1  54576,54576,52392,52392,54336,54336,52368,52512,52368,52272,
     2  52176,52008,51840,51576,51480,51480,51360,51384,51312,51288,
     3  51216,51168,49248,49320,49512,49872,50016,50064,50304,50448,
     4  50496,50544,50496,50640,50712,50760,50736,50784,50760,50928,
     5  51000,51000,51024,51072,51096,51144,51168,51168,50352,50304,
     6  50256,50256,50256,50208,50208,49608,49536,49488,49488,49488,
     7  49488,48312,50256,47976,47928,47640,47544,47112,47136,47088,
     8  47160,47016,46776,46776,46920,46728,46656,46608,46368,46296,
     9  46296,46248,47088,46224,46224,46776,46224,43776,45600,45528/
            data (jy(i),i=  501,  600)/
     +  45480,44904,44832,44112,44424,44472,44592,44592,44520,44640,
     1  44592,44928,44928,44688,44880,44856,44976,45120,45216,45576,
     2  45624,45552,45600,45648,46128,43824,43752,43632,44856,46272,
     3  43632,43536,42864,42864,43752,42672,43272,43272,43080,43008,
     4  42768,42672,42696,42840,42984,43248,43416,43440,43704,43608,
     5  43632,43992,44256,44352,44352,44064,42720,42600,42624,42816,
     6  42936,43104,43344,43440,43488,43584,43680,44016,44112,42528,
     7  42480,42480,42696,42792,42864,42816,42600,42552,42648,43056,
     8  43200,42000,42000,42000,42816,42576,42480,42336,42288,42192,
     9  41928,41832,41904,42048,42288,42504,42432,42336,42144,42000/
            data (jy(i),i=  601,  700)/
     +  41904,42000,42216,42288,42528,42552,42432,42624,42768,42816,
     1  42744,42336,42120,42432,42456,42168,41952,41760,42024,42000,
     2  41784,41184,42000,41160,42816,41136,41280,41400,41496,41664,
     3  41856,42072,42432,40608,40512,40440,40392,40296,40656,40344,
     4  40296,40416,40320,40344,40248,40032,41160,40848,40728,40392,
     5  40296,39768,39624,39624,39480,39456,39336,39336,39216,39240,
     6  39168,39144,39096,39024,38976,38928,38880,38856,38856,38688,
     7  38736,38592,38496,38400,38400,38232,38136,38136,38016,37920,
     8  37752,37248,40296,39888,39864,39840,39792,39696,39984,39528,
     9  39744,39648,39720,39624,39840,39840,39960,40104,40056,39960/
            data (jy(i),i=  701,  800)/
     +  39984,39912,39864,39912,39960,40008,40008,40104,40176,40608,
     1  40032,40056,39504,39000,39600,39312,39000,38904,38808,38568,
     2  38424,38328,38160,38112,39192,39216,37944,37848,37824,37824,
     3  37704,37608,37872,37608,37680,37584,37416,37608,37752,37824,
     4  37872,37800,37824,37896,38280,38568,39096,39192,39144,39216,
     5  39408,39744,39816,39792,39456,39192,39264,39168,38064,37944,
     6  37824,37656,37584,37464,37272,36840,37080,37392,37512,37656,
     7  37848,36504,36552,37344,37368,37128,36912,36840,36624,36504,
     8  36456,36552,36768,36456,36624,36912,37008,37008,36912,37128,
     9  37368,37896,37800,36768,37008,37584,38280,38520,38736,36408/
            data (jy(i),i=  801,  900)/
     +  36744,36840,36768,36624,36384,36408,36168,36000,35928,36192,
     1  35904,35400,35496,35448,35472,35424,35424,35376,35448,35400,
     2  35448,35424,35472,35520,35496,35544,35448,35592,35520,35640,
     3  33216,33216,35232,36768,35208,35520,35712,35760,35688,35760,
     4  35712,35952,36000,36144,36144,35880,35880,36000,35952,35688,
     5  35592,35808,35808,35880,33144,34392,34728,34776,34896,34968,
     6  35160,35352,35640,35688,35520,35664,35904,36120,36432,36552,
     7  35208,34392,34392,34248,34272,34392,33984,33960,33960,34032,
     8  33600,35280,33312,33312,34488,34464,35232,33264,33240,33216,
     9  33072,33192,33240,33144,31872,33048,33048,33744,33720,33456/
            data (jy(i),i=  901, 1000)/
     +  33312,33240,33168,33168,33096,32976,32928,32976,33360,33336,
     1  33192,33048,33000,33096,33240,33288,33360,32712,33288,32712,
     2  32712,32328,32232,32256,32304,32184,32136,32496,32472,32304,
     3  32376,31848,31776,32952,32952,31560,32064,31968,31560,31488,
     4  31488,31488,31560,31512,31608,31584,31680,31584,31608,31656,
     5  31752,31656,31536,31656,31728,31704,31536,31608,31488,31464,
     6  31536,31536,31608,31632,31632,31704,31416,31416,31560,31560,
     7  31680,31704,31800,31824,32136,32136,32232,32232,32352,32352,
     8  32784,32784,33192,33216,31392,32736,32736,31368,28896,31344,
     9  31752,31752,31560,31656,31344,27504,30288,30288,30216,29856/
            data (jy(i),i= 1001, 1100)/
     +  30192,29640,29592,29568,30384,30360,29448,29352,30312,32712,
     1  29304,29304,27504,29304,28464,28488,30168,29880,29784,29688,
     2  29520,29352,29280,29400,29400,29568,29592,29856,28920,27480,
     3  27912,28512,28872,28920,28416,28680,28392,30312,31320,29808,
     4  28896,28464,28128,28080,28056,27840,27816,27720,27816,27888,
     5  27744,27816,27744,27720,27864,27768,27840,27792,27816,27720,
     6  27768,27696,27768,27840,27840,27888,27768,27816,27912,27648,
     7  27720,27600,27672,27576,27648,27552,27648,27648,25008,27456,
     8  27456,27648,27648,25512,25512,24576,24576,27288,27216,27216,
     9  27192,28776,28752,26976,25056,25032,27240,26832,28584,28584/
            data (jy(i),i= 1101, 1200)/
     +  26352,26328,26280,24240,24240,22416,27480,25872,25848,25848,
     1  25848,26664,26640,27456,22872,23304,23280,23544,23496,23640,
     2  23616,23880,23856,24336,24360,24888,24888,25824,25752,28632,
     3  28632,26376,25704,25104,24600,24552,24576,24456,23400,23544,
     4  23544,23688,23688,23952,23952,24096,24096,24192,24192,24288,
     5  24288,24432,24432,24504,24528,24600,24576,23376,23592,23592,
     6  23304,23328,22464,22800,22752,22752,22344,22368,21504,21504,
     7  20832,22752,24456,22656,22512,22944,22944,24360,24360,22536,
     8  22704,22704,23352,22488,22632,22320,21336,21336,21744,21744,
     9  22008,22008,22488,22464,22920,22464,24288,24288,22392,22296/
            data (jy(i),i= 1201, 1300)/
     +  20808,21552,21768,21768,21912,21912,22056,22056,22200,22200,
     1  22512,21768,20016,21504,21504,23112,23016,22704,22632,22512,
     2  22464,22128,21792,21672,21528,21288,21168,21048,21000,20904,
     3  21360,21360,21216,21096,21048,21288,21264,21240,21096,21048,
     4  20952,20976,20856,20832,20856,20304,20304,20256,20928,20928,
     5  19896,19872,18192,18192,20304,20256,20232,20088,20088,21744,
     6  19992,19872,19872,20256,19032,19032,18216,18216,19488,17208,
     7  20112,20136,20640,20544,20496,20424,20424,20376,20280,20256,
     8  20160,20184,19992,19968,19896,19848,19824,19752,19704,19704,
     9  19536,19416,19320,19272,19296,19248,19200,19176,19128,19104/
            data (jy(i),i= 1301, 1390)/
     +  18960,18912,18816,18768,18672,18720,20904,18648,18768,18720,
     1  17688,17712,17808,17880,18096,18168,18216,18264,18264,18336,
     2  18384,18432,18504,18528,18624,18600,18648,17952,17736,17064,
     3  16416,16416,16224,16224,16320,16320,16680,16752,16632,16608,
     4  16776,16872,16824,16512,16464,21120,21144,21408,21408,21672,
     5  21696,21816,21840,21960,21984,22248,22344,22392,20832,20832,
     6  20712,20712,20592,20592,20448,20448,20304,20328,20112,20112,
     7  20040,20040,19920,19776,19656,19656,19512,19512,19248,19200,
     8  19056,19056,19008,19008,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      4,    4,    1,    3,    3,    2,    1,    7,   47,   48,
     1     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     2     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     3     69,   70,   71,    8,   10,   73,   74,   75,   76,   77,
     4     78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
     5     88,   89,   90,    6,   10,   92,   93,   94,   95,   12,
     6      8,   97,   98,   99,  100,  101,  102,  103,  104,  105,
     7    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     8    116,  117,  118,  119,  120,  121,  122,   11,   11,  124,
     9    125,  126,  127,  128,  129,   13,   12,  131,  132,  133/
            data (jb1(i),i=  101,  200)/
     +    134,  135,  136,  137,   14,   14,  139,   16,   13,  141,
     1    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     2    152,  153,  154,  155,  156,  157,  158,  159,  160,   15,
     3     16,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     4    171,  172,  173,   18,   15,  175,  176,  177,  178,  179,
     5    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     6    190,  191,  192,  193,  194,  195,  196,  197,  198,   17,
     7     17,   19,   18,  201,  202,  203,  204,   20,   19,   20,
     8    206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
     9    216,   22,   22,   24,  218,  219,  220,  221,  222,   23/
            data (jb1(i),i=  201,  300)/
     +     21,   23,   26,   26,  225,  226,  227,  228,   27,   25,
     1     27,  230,  231,  232,  233,  234,  235,  236,   29,   28,
     2     29,  238,  239,  240,  241,  242,  243,  244,  245,  246,
     3    247,  248,  249,  250,  251,  252,  253,  254,   31,   30,
     4     33,  256,  257,  258,  259,  260,  261,   31,  263,  264,
     5    265,  266,  267,  268,  269,  270,   33,   32,   34,  272,
     6    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     7    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     8    293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
     9    303,  304,  262,   36,   36,   35,   43,   38,   43,   35/
            data (jb1(i),i=  301,  400)/
     +     37,   42,   37,   45,  307,  308,  309,  310,  311,  312,
     1    313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
     2    323,  324,  272,   46,  326,  327,  328,  329,  330,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4     45,   41,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,  362,  363,  364,  365,  366,   46,    1,  368,  369,
     7    370,  372,  373,  374,  371,  375,  376,  376,    5,  378,
     8    379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
     9    389,  390,  391,  392,  393,  394,  395,  396,  397,  398/
            data (jb1(i),i=  401,  500)/
     +    399,  400,  401,  402,  403,  404,  377,  377,  375,  406,
     1    408,  408,  376,  410,  411,  412,  410,  375,  413,  414,
     2    415,  416,  408,  417,  410,  418,  419,  420,  421,  422,
     3    423,  424,  425,  426,  427,  428,  429,  372,  371,  430,
     4     11,  433,  434,  435,  436,  437,  438,  439,  440,  441,
     5    442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
     6    452,  453,  454,  455,  456,  430,  414,  431,  432,  409,
     7    431,  459,  460,  462,  406,  463,  464,  413,  464,  466,
     8    458,  468,  469,  460,  468,  417,  469,  459,  472,  461,
     9    473,  467,  474,  472,  474,  476,  478,  466,  462,  478/
            data (jb1(i),i=  501,  600)/
     +    480,   14,  482,  483,  468,  478,  485,  486,  487,  488,
     1    489,  475,  490,  492,  480,  494,  495,  484,  469,  494,
     2    492,  483,  476,  499,  477,  491,  500,  499,  500,  502,
     3    504,  505,  506,  507,  508,  509,  510,  511,  512,  513,
     4    514,  515,  516,  517,  518,  519,  520,  521,  522,  523,
     5    524,  490,  497,  526,  498,  528,  529,  530,  498,  528,
     6    492,  532,  526,  533,  532,  535,  537,  538,  539,  540,
     7    541,  542,  543,  544,  545,  546,  547,  548,  549,  550,
     8    551,  552,  553,  554,  555,  504,  536,  557,  558,  559,
     9    560,  561,  562,  563,  564,  565,  566,  567,  568,  504/
            data (jb1(i),i=  601,  700)/
     +    503,  501,  571,  572,  573,  574,  575,  576,  577,  578,
     1    579,  580,  537,  502,  528,  582,  583,  584,  585,  570,
     2    586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
     3    596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
     4    606,  571,  570,  608,  609,  610,  611,  612,  613,  614,
     5    615,  616,  617,  618,  619,  620,  621,  622,  582,  622,
     6    624,  534,  626,  627,  628,  629,  630,  631,  632,  536,
     7    583,  533,  635,  636,  637,  626,  639,  640,  641,  642,
     8    643,  644,  638,  537,  624,  647,  648,  649,  650,  651,
     9    652,  653,  654,  655,  656,  657,  658,  659,  660,  661/
            data (jb1(i),i=  701,  800)/
     +    662,  663,  664,  665,  666,  667,  668,  669,  670,  671,
     1    672,  673,  674,  675,  676,  677,  678,  679,  680,  681,
     2    626,  683,  646,  646,  638,  591,  687,  688,  685,  690,
     3    691,  692,  693,  694,  695,  696,  697,  698,  699,  700,
     4    701,  702,  703,  704,  705,  706,  707,  708,  709,  634,
     5    710,  711,  712,  690,   21,  687,  686,  715,  716,  717,
     6    718,  719,  720,  721,  722,  723,  634,  725,  726,  727,
     7    729,  622,  684,  731,  727,  733,  734,  729,  732,  686,
     8    737,  738,  739,  740,  741,  742,  743,  744,  745,  746,
     9    747,  748,  749,  750,  751,  752,  753,  754,  755,  756/
            data (jb1(i),i=  801,  900)/
     +    757,  758,  724,  759,  760,  761,  762,  763,  764,  682,
     1    766,  767,  768,  769,  770,  730,  772,  773,  774,  714,
     2    682,  776,  777,  778,  779,  780,  781,  782,  766,  690,
     3    784,  785,  786,  787,  788,  789,  790,  791,  792,  728,
     4     23,  794,  795,  796,  797,  798,  799,  685,  772,  737,
     5    801,  802,  803,  804,  805,  784,  731,  800,  808,  809,
     6    807,  737,  772,  812,  813,  814,  815,  816,  817,  818,
     7    819,  820,  821,  822,  823,  824,  825,  826,  827,  828,
     8    829,  830,  831,  812,  833,  732,  724,  833,   26,  836,
     9    837,  838,  839,  840,  841,  842,  843,  844,  845,  846/
            data (jb1(i),i=  901, 1000)/
     +    847,  848,  849,  850,  851,  852,  853,  811,  808,  856,
     1    857,  858,  859,  860,  861,  862,  863,  864,  865,  866,
     2    867,  868,  869,  766,  835,  871,  872,  873,  874,  875,
     3    856,  856,  729,  877,  879,  878,  807,  811,  882,  884,
     4    885,  886,  833,  728,  883,  888,  889,  831,  891,  892,
     5    893,  855,  895,  896,  855,  881,  898,  899,  900,  901,
     6    902,  903,  904,  905,  906,  907,  908,  909,  910,  911,
     7    912,  913,  914,  915,  916,  884,  918,  888,  918,  920,
     8    878,  883,  922,  923,  924,  925,  926,   27,  928,  929,
     9    930,  931,  895,  933,  934,  881,  831,  927,  937,  938/
            data (jb1(i),i= 1001, 1100)/
     +    939,  940,  932,  936,  942,  943,  944,  945,  946,  947,
     1    948,  949,  950,  951,  952,  953,  954,  955,  956,  957,
     2    958,  959,  960,  961,  962,  963,  964,  965,  966,  967,
     3    968,  969,  970,  971,  972,  973,  974,  975,  976,  977,
     4    978,  979,  980,  981,  982,  983,  884,  985,  986,  877,
     5    967,  889,  988,  985,  920,  991,  992,  993,  994,  990,
     6    990,  936,  933,  998,  967,  997, 1001, 1002, 1003, 1004,
     7   1005,  895, 1004, 1007, 1008,  998,  918, 1010, 1011, 1012,
     8   1011, 1014, 1015,  999, 1017, 1018, 1019, 1020, 1021, 1022,
     9   1023, 1024, 1025, 1026, 1027, 1000,  927, 1030, 1031, 1000/
            data (jb1(i),i= 1101, 1200)/
     +   1029, 1033,  989, 1035, 1036, 1037, 1038,  932,   29, 1035,
     1    989, 1041, 1016, 1035, 1043, 1029, 1044,  997, 1046, 1047,
     2   1043, 1047, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056,
     3   1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066,
     4   1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,
     5   1044, 1077, 1078, 1080, 1081, 1082, 1083, 1084, 1085, 1086,
     6    996,  996, 1016, 1046, 1088, 1089, 1090, 1003, 1092, 1091,
     7   1091, 1095, 1096, 1048, 1094,  999, 1099, 1100, 1101, 1102,
     8   1030, 1103, 1104, 1105, 1013, 1107, 1108, 1109, 1098, 1110,
     9   1112, 1113, 1080, 1115, 1116, 1117, 1118, 1119, 1120, 1121/
            data (jb1(i),i= 1201, 1300)/
     +   1122, 1123, 1124, 1125, 1126, 1127, 1110, 1129, 1130, 1008,
     1   1111, 1101, 1132, 1129, 1088, 1134, 1079, 1079, 1087, 1136,
     2   1134, 1111, 1136, 1139, 1140, 1141, 1142, 1143, 1144, 1145,
     3   1146, 1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155,
     4   1156, 1157, 1139, 1047, 1087, 1159, 1160, 1161, 1162, 1115,
     5   1164, 1165, 1166, 1167, 1168, 1169, 1170, 1172, 1138, 1172,
     6   1175, 1176, 1095, 1174, 1178, 1133, 1175, 1180, 1181, 1182,
     7   1158, 1184, 1174, 1109, 1187, 1188, 1189, 1190, 1191, 1192,
     8   1163, 1163, 1194, 1115, 1196, 1197, 1102, 1184, 1106, 1106,
     9   1186, 1136, 1200, 1186, 1202, 1203, 1204, 1205, 1206, 1207/
            data (jb1(i),i= 1301, 1400)/
     +   1208, 1209, 1210, 1175, 1172, 1184, 1214, 1202, 1139, 1216,
     1   1217, 1218, 1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226,
     2   1227, 1228, 1229, 1187, 1231, 1214, 1200, 1212, 1233, 1230,
     3   1231, 1236, 1237, 1238, 1239, 1240, 1241, 1242, 1243, 1171,
     4   1245, 1246, 1171, 1248, 1249, 1187, 1201, 1251, 1252, 1253,
     5   1254, 1247, 1255, 1256, 1248, 1258, 1259, 1212, 1213, 1213,
     6   1261, 1262, 1199, 1248, 1264, 1265, 1266, 1267, 1268, 1261,
     7   1233, 1269, 1270, 1271, 1234, 1247, 1262, 1244, 1273, 1274,
     8   1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284,
     9   1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294/
            data (jb1(i),i= 1401, 1500)/
     +   1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1305,
     1   1306, 1230, 1305, 1304, 1309, 1308,   41, 1311, 1312, 1313,
     2   1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323,
     3   1324, 1325, 1326, 1308, 1258, 1269, 1270, 1305, 1328, 1329,
     4   1330, 1331,   45, 1333, 1334, 1335, 1336, 1337, 1338, 1339,
     5   1340, 1341, 1342, 1343, 1344, 1332, 1332, 1235, 1346, 1347,
     6   1348, 1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357,
     7    262, 1235, 1359, 1360, 1361, 1362, 1363, 1364, 1365, 1366,
     8   1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375, 1376,
     9   1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      6,    5,    7,    5,    9,    9,    2,   47,   48,   49,
     1     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     2     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     3     70,   71,   72,   72,   73,   74,   75,   76,   77,   78,
     4     79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
     5     89,   90,   91,   91,   92,   93,   94,   95,   96,   96,
     6     97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
     7    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     8    117,  118,  119,  120,  121,  122,  123,  123,  124,  125,
     9    126,  127,  128,  129,  130,  130,  131,  132,  133,  134/
            data (jb2(i),i=  101,  200)/
     +    135,  136,  137,  138,  138,  139,  140,  140,  141,  142,
     1    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     2    153,  154,  155,  156,  157,  158,  159,  160,  161,  161,
     3    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     4    172,  173,  174,  174,  175,  176,  177,  178,  179,  180,
     5    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     6    191,  192,  193,  194,  195,  196,  197,  198,  199,  199,
     7    200,  200,  201,  202,  203,  204,  205,  205,   21,  206,
     8    207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
     9    217,  217,   24,  218,  219,  220,  221,  222,  223,  223/
            data (jb2(i),i=  201,  300)/
     +     25,  224,  224,  225,  226,  227,  228,  229,  229,   28,
     1    230,  231,  232,  233,  234,  235,  236,  237,  237,   30,
     2    238,  239,  240,  241,  242,  243,  244,  245,  246,  247,
     3    248,  249,  250,  251,  252,  253,  254,  255,  255,   32,
     4    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     5    266,  267,  268,  269,  270,  271,  271,   34,   38,  273,
     6    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     7    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     8    294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
     9    304,  305,  305,   41,   39,   39,  306,  306,   44,   40/
            data (jb2(i),i=  301,  400)/
     +     40,   44,   42,  307,  308,  309,  310,  311,  312,  313,
     1    314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
     2    324,  325,  325,  326,  327,  328,  329,  330,  331,  332,
     3    333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
     4    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     5    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     6    362,  363,  364,  365,  366,  367,  367,  368,  369,  370,
     7    371,  373,  374,    2,  372,    3,    4,  377,  378,  379,
     8    380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     9    390,  391,  392,  393,  394,  395,  396,  397,  398,  399/
            data (jb2(i),i=  401,  500)/
     +    400,  401,  402,  403,  404,  405,  405,  406,  407,  407,
     1      6,  409,  409,  411,  412,    7,    8,  413,  414,  415,
     2    416,    9,  417,   10,  418,  419,  420,  421,  422,  423,
     3    424,  425,  426,  427,  428,  429,  430,  431,  432,  432,
     4    433,  434,  435,  436,  437,  438,  439,  440,  441,  442,
     5    443,  444,  445,  446,  447,  448,  449,  450,  451,  452,
     6    453,  454,  455,  456,  457,  457,  458,  458,  459,  460,
     7    461,  461,  462,  463,  463,  464,  465,  465,  466,  467,
     8    467,   12,  470,  470,  471,  471,  471,  472,   13,  473,
     9    474,  475,  475,  476,  477,  477,  479,  479,  480,  481/
            data (jb2(i),i=  501,  600)/
     +    481,  482,  483,  484,  484,  485,  486,  487,  488,  489,
     1    490,  491,  491,  493,  493,  495,  496,  496,  494,  497,
     2    497,  498,  499,   15,  500,  501,  501,  502,  503,  503,
     3    505,  506,  507,  508,  509,  510,  511,  512,  513,  514,
     4    515,  516,  517,  518,  519,  520,  521,  522,  523,  524,
     5    525,  525,  526,  527,  527,  529,  530,   16,  531,  531,
     6    532,  533,  534,  534,  535,  536,  538,  539,  540,  541,
     7    542,  543,  544,  545,  546,  547,  548,  549,  550,  551,
     8    552,  553,  554,  555,  556,  556,  557,  558,  559,  560,
     9    561,  562,  563,  564,  565,  566,  567,  568,  569,  569/
            data (jb2(i),i=  601,  700)/
     +    570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
     1    580,  581,  581,   17,  582,  583,  584,  585,   18,  586,
     2    587,  588,  589,  590,  591,  592,  593,  594,  595,  596,
     3    597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
     4    607,  607,  608,  609,  610,  611,  612,  613,  614,  615,
     5    616,  617,  618,  619,  620,  621,   19,  623,  623,  624,
     6    625,  625,  627,  628,  629,  630,  631,  632,  633,  633,
     7    634,  635,  636,  637,  638,  639,  640,  641,  642,  643,
     8    644,  645,  645,  646,  647,  648,  649,  650,  651,  652,
     9    653,  654,  655,  656,  657,  658,  659,  660,  661,  662/
            data (jb2(i),i=  701,  800)/
     +    663,  664,  665,  666,  667,  668,  669,  670,  671,  672,
     1    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     2    683,  684,  684,  685,  686,  687,  688,  689,  689,  691,
     3    692,  693,  694,  695,  696,  697,  698,  699,  700,  701,
     4    702,  703,  704,  705,  706,  707,  708,  709,   20,  710,
     5    711,  712,  713,  713,  714,  714,  715,  716,  717,  718,
     6    719,  720,  721,  722,  723,  724,  725,  726,  727,  728,
     7    730,  730,  731,  732,  733,  734,  735,  735,  736,  736,
     8    738,  739,  740,  741,  742,  743,  744,  745,  746,  747,
     9    748,  749,  750,  751,  752,  753,  754,  755,  756,  757/
            data (jb2(i),i=  801,  900)/
     +    758,   22,  759,  760,  761,  762,  763,  764,  765,  765,
     1    767,  768,  769,  770,  771,  771,  773,  774,  775,  775,
     2    776,  777,  778,  779,  780,  781,  782,  783,  783,  784,
     3    785,  786,  787,  788,  789,  790,  791,  792,  793,  793,
     4    794,  795,  796,  797,  798,  799,   24,  800,  800,  801,
     5    802,  803,  804,  805,  806,  806,  807,  808,  809,  810,
     6    810,  811,  812,  813,  814,  815,  816,  817,  818,  819,
     7    820,  821,  822,  823,  824,  825,  826,  827,  828,  829,
     8    830,   25,  832,  832,  834,  834,  835,  835,  836,  837,
     9    838,  839,  840,  841,  842,  843,  844,  845,  846,  847/
            data (jb2(i),i=  901, 1000)/
     +    848,  849,  850,  851,  852,  853,  854,  854,  855,  857,
     1    858,  859,  860,  861,  862,  863,  864,  865,  866,  867,
     2    868,  869,  870,  870,  871,  872,  873,  874,  875,  876,
     3    876,  877,  878,  879,  880,  880,  881,  882,  883,  885,
     4    886,  887,  887,  888,  889,  890,  890,  891,  892,  893,
     5    894,  894,  896,  897,  897,  898,  899,  900,  901,  902,
     6    903,  904,  905,  906,  907,  908,  909,  910,  911,  912,
     7    913,  914,  915,  916,  917,  917,  919,  919,  920,  921,
     8    921,  922,  923,  924,  925,  926,  927,  928,  929,  930,
     9    931,  932,  933,  934,  935,  935,  936,  937,  938,  939/
            data (jb2(i),i= 1001, 1100)/
     +    940,  941,  941,  942,  943,  944,  945,  946,  947,  948,
     1    949,  950,  951,  952,  953,  954,  955,  956,  957,  958,
     2    959,  960,  961,  962,  963,  964,  965,  966,   28,  968,
     3    969,  970,  971,  972,  973,  974,  975,  976,  977,  978,
     4    979,  980,  981,  982,  983,  984,  984,  986,  987,  987,
     5    985,  988,  989,  990,  991,  992,  993,  994,  995,  995,
     6    996,  997,  998,  999, 1000, 1001, 1002, 1003, 1004, 1005,
     7   1006, 1006, 1007, 1008, 1009, 1009, 1010, 1011, 1012, 1013,
     8   1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023,
     9   1024, 1025, 1026, 1027, 1028, 1028, 1029, 1031, 1032, 1032/
            data (jb2(i),i= 1101, 1200)/
     +   1033, 1034, 1034, 1036, 1037, 1038, 1039, 1039, 1040, 1040,
     1   1041, 1042, 1042, 1043, 1044, 1045, 1045, 1046,   30, 1048,
     2   1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057,
     3   1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067,
     4   1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,   31,
     5   1077, 1078, 1079, 1081, 1082, 1083, 1084, 1085, 1086, 1087,
     6   1030, 1013, 1080, 1088, 1089, 1090, 1091, 1092, 1093, 1093,
     7   1094, 1096, 1097, 1097, 1098, 1099, 1100, 1101, 1102, 1103,
     8   1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112,
     9   1113, 1114, 1114, 1116, 1117, 1118, 1119, 1120, 1121, 1122/
            data (jb2(i),i= 1201, 1300)/
     +   1123, 1124, 1125, 1126, 1127, 1128, 1128, 1130, 1131, 1131,
     1   1129, 1132, 1133, 1133, 1134,   32, 1095, 1135, 1135, 1137,
     2   1137, 1138, 1138, 1140, 1141, 1142, 1143, 1144, 1145, 1146,
     3   1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156,
     4   1157,   33, 1158, 1158, 1159, 1160, 1161, 1162, 1163, 1164,
     5   1165, 1166, 1167, 1168, 1169, 1170, 1171, 1173, 1173, 1174,
     6   1176, 1177, 1177, 1178, 1179, 1179, 1180, 1181, 1182, 1183,
     7   1183, 1185, 1185, 1186, 1188, 1189, 1190, 1191, 1192, 1193,
     8   1193, 1194, 1195, 1195, 1197, 1198, 1198, 1196, 1196, 1199,
     9   1199, 1200,   34, 1201, 1203, 1204, 1205, 1206, 1207, 1208/
            data (jb2(i),i= 1301, 1400)/
     +   1209, 1210, 1211, 1211, 1212, 1213, 1215, 1215, 1216, 1217,
     1   1218, 1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227,
     2   1228, 1229, 1230, 1231, 1232, 1232, 1233, 1234, 1234, 1235,
     3   1236, 1237, 1238, 1239, 1240, 1241, 1242, 1243, 1244, 1245,
     4   1246, 1247, 1201, 1249, 1250, 1250, 1251, 1252, 1253, 1254,
     5     35, 1255, 1256, 1257, 1257, 1259, 1260, 1260, 1258, 1261,
     6   1262, 1263, 1263, 1264, 1265, 1266, 1267, 1268,   36,   37,
     7   1269,   38, 1271, 1272, 1272,   39,   40, 1273, 1274, 1275,
     8   1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285,
     9   1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295/
            data (jb2(i),i= 1401, 1500)/
     +   1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1306,
     1   1307, 1307, 1308, 1309, 1310, 1310, 1311, 1312, 1313, 1314,
     2   1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324,
     3   1325, 1326, 1327, 1327,   42,   43,   44, 1328, 1329, 1330,
     4   1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340,
     5   1341, 1342, 1343, 1344, 1345, 1345,   46, 1346, 1347, 1348,
     6   1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357, 1358,
     7   1358, 1359, 1360, 1361, 1362, 1363, 1364, 1365, 1366, 1367,
     8   1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375, 1376, 1377,
     9   1378, 1379, 1380, 1381, 1382, 1383, 1384,  272,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine mt(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1910) :: jx,jy
            integer(kind=iknd), save, dimension(1970) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'montana       '/
            data jrot,ipart/1,1/
            data kv/   1,1907,   0,   0,   0/
            data kb/   1,1963,   0,   0,   0/
            data iib/ 329,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  18168,18408,18576,18192,17856,17496,21720,18624,18648,18360,
     1  23808,18648,29544,35448,36120,47952,43560,51360,51024,48888,
     2  48408,49080,49080,53064,17808,18528,17064,24672,25632,25728,
     3  26040,26616,26688,26664,26832,27408,27408,27672,27696,27840,
     4  28200,28368,28656,28848,28992,29112,29208,29472,29472,29544,
     5  29256,35040,29688,29736,29832,29928,29928,30144,30264,30264,
     6  30360,30552,30912,31032,31152,31128,31248,31320,31464,31656,
     7  31848,31920,32088,32280,32520,32544,32784,32976,33024,33576,
     8  33576,33912,34032,34176,34344,34440,34512,34656,34776,34896,
     9  34848,35064,35136,35232,35400,35640,35736,35616,35592,35448/
            data (jx(i),i=  101,  200)/
     +  40824,36048,36096,36312,36216,36216,36144,36240,36240,36000,
     1  35904,35832,35664,35472,36336,36504,36648,36744,36936,37224,
     2  37344,37800,37992,38160,38448,38784,38952,39120,39312,39816,
     3  39864,39840,39984,40152,40248,40416,40632,40728,40872,40944,
     4  41088,41160,41160,41328,41448,41616,42000,42264,42168,42288,
     5  42816,42936,43080,43224,43392,43488,43584,43728,43848,44064,
     6  44304,47544,44424,44472,44376,44496,44472,44568,44664,44832,
     7  45000,45168,45288,45096,44784,44640,44712,44616,44568,44376,
     8  44352,44040,43872,43680,43536,43488,43608,48624,43728,43944,
     9  44136,44160,44136,44232,44232,44400,44544,44928,44928,45216/
            data (jx(i),i=  201,  300)/
     +  45432,45576,45648,45768,45912,46368,46776,46848,46944,47040,
     1  47280,47520,47712,47832,47976,48072,48072,48264,48336,48456,
     2  48504,48624,48888,49248,49320,49320,49368,49944,50064,50160,
     3  50184,50328,50568,50568,50352,50328,50376,51264,51336,51216,
     4  51048,53280,53280,53112,52608,52608,52368,52416,52584,52608,
     5  52728,52632,52704,52584,52632,52488,52416,52704,52848,52752,
     6  52728,52488,52560,52464,52536,52680,52632,52512,52464,52392,
     7  52200,52080,51960,51864,51840,51672,51456,51192,51192,51408,
     8  51648,51816,51792,52032,52104,52344,52416,52560,52704,52944,
     9  53136,49152,49200,49152,49176,49104,50712,50832,51072,51288/
            data (jx(i),i=  301,  400)/
     +  51456,51672,51792,52032,52320,52464,52608,52824,53184,53496,
     1  53592,53568,53760,53928,53856,53712,53424,53256,52944,52920,
     2  52824,52944,52944,53016,52992,53136,53040,53232,53208,28200,
     3  24168,24168,23520,23496,22824,22824,22176,22152,21864,21912,
     4  21480,21480,18840,18840,28152,26712,26664,26712,26376,26136,
     5  26208,26232,24384,24384,22656,22776,21720,21720,20400,20376,
     6  19080,19056,25200,24552,24552,24000,23976,23232,23208,22800,
     7  22800,22224,22224,21912,19272,19272,18312,18456,18720,18792,
     8  19080,19200,19392,19512,19680,19752,20064,20112,20208,20208,
     9  20280,20448,20520,20688,20808,20784,21408,21432,24048,24024/
            data (jx(i),i=  401,  500)/
     +  25608,21096,21168,19200,19224,18576,18552,18168,18168,20160,
     1  20112,20784,21960,21312,21360,20712,22608,22512,23856,23736,
     2  24624,24624,23472,23304,23160,22872,22920,22656,22536,22464,
     3  21888,21840,21624,21696,21504,21624,21528,21528,21384,21072,
     4  20928,20784,20712,20568,20448,20352,20064,19800,19608,19632,
     5  19512,19656,19536,19752,19776,19704,19752,19656,19536,19224,
     6  19032,18888,18888,18816,18696,18648,23880,24240,24336,24072,
     7  24096,23904,23904,23544,23544,23664,24000,24216,24552,25008,
     8  25080,25392,25536,25680,25800,25848,26064,26280,26304,26232,
     9  26328,26184,26088,26256,26376,26280,26496,26352,26304,26016/
            data (jx(i),i=  501,  600)/
     +  25992,26064,25992,25872,25776,25560,25248,24576,24576,23904,
     1  23952,24600,24600,25320,25200,25200,25008,25176,25176,25080,
     2  24960,24888,25008,24984,24888,24816,24744,24768,24672,24792,
     3  24552,24600,24528,24624,24480,24528,24672,24672,24600,25248,
     4  25272,22728,22920,22824,22848,22920,23256,23280,23592,23616,
     5  24600,25176,25176,25248,25128,25008,25104,25104,24984,24960,
     6  24864,24840,24528,24336,24192,24072,23976,23904,23784,26376,
     7  26376,25920,25920,25584,25560,25248,25920,25368,25080,25080,
     8  25176,25176,25296,25248,25320,25392,25488,25368,25200,25176,
     9  25272,25416,25440,25368,25248,25200,25344,25320,25368,25344/
            data (jx(i),i=  601,  700)/
     +  25200,25128,25320,23760,23736,27456,27480,26184,26280,26040,
     1  25944,26040,25800,25800,25704,25704,25584,25632,25776,25896,
     2  26208,26136,26256,26328,26448,26376,26664,26688,26904,27024,
     3  27120,27432,27600,27816,28008,28152,28152,28392,28608,28656,
     4  29088,31728,31752,30408,30456,29136,29112,26544,26568,25896,
     5  26808,26712,25704,25704,28200,26544,26544,26424,26304,25944,
     6  25920,25800,25728,25584,25608,25344,25248,28152,28248,28320,
     7  28080,28056,27744,27816,27672,27720,27624,27744,27840,27984,
     8  28176,28152,28248,28272,28488,28464,29040,29400,29664,29736,
     9  29856,29856,30120,30264,30696,30696,28392,28584,28704,28776/
            data (jx(i),i=  701,  800)/
     +  28800,28920,28992,28944,29064,28968,29040,29112,29088,28992,
     1  29064,29112,29232,29160,29184,29256,29256,29352,29232,29232,
     2  28152,28248,28224,28392,28320,28344,28176,28056,27840,27768,
     3  27696,27744,27696,27480,27384,27456,27408,27240,27216,27408,
     4  27360,27192,27144,27024,26880,26784,26664,26568,26496,26304,
     5  26256,26112,25992,25824,25704,25776,25920,28584,30720,30504,
     6  30480,29904,29904,29760,29784,29712,29784,29760,29544,29544,
     7  29400,29160,28584,29928,30000,29976,30024,29976,30000,29712,
     8  29760,29664,29688,29616,29448,29352,29256,29112,28968,28872,
     9  28992,29016,29112,29088,29256,29136,28968,28488,28368,28224/
            data (jx(i),i=  801,  900)/
     +  28008,27504,26880,26832,29040,29448,29520,29616,29664,29712,
     1  29832,29856,30000,30312,30720,30888,31080,31248,31320,31440,
     2  31608,32256,32232,32544,32496,29136,29184,26592,26712,26784,
     3  26880,27024,27336,27456,27600,27864,27888,28056,28080,28248,
     4  28824,28920,29040,30144,29688,29616,29328,29136,29184,29088,
     5  29112,29208,29184,35640,34968,34944,32952,32976,32328,32328,
     6  31680,31656,31392,31320,31272,31272,30024,30000,30048,30072,
     7  29232,29256,28584,38280,38160,37944,37416,37104,36864,36456,
     8  36456,36120,36144,35088,35088,32472,32400,30048,30096,30024,
     9  29664,29424,30072,29664,29472,29400,29376,29280,29208,28728/
            data (jx(i),i=  901, 1000)/
     +  28824,28776,28560,28704,28584,28608,28584,28752,28728,28680,
     1  28584,28488,28368,35256,35136,35136,33168,33168,32112,32112,
     2  32016,32016,31560,31560,31656,31176,31176,32208,32184,30888,
     3  30864,30768,30792,30528,30216,30000,30024,29928,29760,29760,
     4  29856,29424,29280,29088,29064,29016,28920,27816,27792,34728,
     5  34704,34632,34584,34560,34536,34224,34224,34128,34104,34080,
     6  33816,33768,33576,33408,33480,33384,33360,33216,33072,32760,
     7  32688,32664,32520,32496,32400,32352,32304,32208,32064,32016,
     8  31872,31872,31728,31656,31680,31608,31608,31512,31488,31392,
     9  31392,31296,31296,31200,31080,30984,30936,30696,34992,32352/
            data (jx(i),i= 1001, 1100)/
     +  32304,31392,31368,31152,31152,31032,31032,30528,30384,30240,
     1  30096,30144,29928,29784,29664,29592,29688,29664,29592,29568,
     2  29664,29424,29616,29592,29496,31488,31368,31536,31848,31920,
     3  32112,32112,32184,32304,32640,32544,32568,31464,31632,32304,
     4  32352,31680,34176,34560,34536,32904,32904,32952,32952,32856,
     5  32808,32568,32592,32472,32520,32424,32400,34536,33888,33888,
     6  33816,33816,33240,33240,33576,33696,33864,33912,34032,34368,
     7  34512,34584,34632,34584,34680,34704,35088,35112,35256,35376,
     8  35400,34752,34728,33744,33768,33528,33552,33432,33432,33576,
     9  33432,33432,33360,33336,33000,32976,32760,32736,32544,32520/
            data (jx(i),i= 1101, 1200)/
     +  32424,32400,32184,32184,32064,32064,31728,31704,31608,31608,
     1  33600,33576,33480,33408,33336,33336,33216,33192,32976,32832,
     2  32520,32496,32088,32088,31368,31368,30936,30912,30576,30528,
     3  30336,30096,30048,29760,33792,33576,33576,33480,33480,33360,
     4  33408,32952,33000,31440,34944,34872,34896,34224,34296,34080,
     5  34272,34488,34368,42336,39720,39696,37056,37056,34416,34392,
     6  35712,35544,35352,35304,35280,35400,35376,35112,34920,34728,
     7  34992,35232,35208,35640,35616,35856,35832,36264,36240,35112,
     8  35544,35232,35160,35616,35952,35976,36192,36312,36072,36168,
     9  35928,35952,35496,35544,39384,35760,35952,35832,35808,35616/
            data (jx(i),i= 1201, 1300)/
     +  35496,35376,35136,35064,35232,35016,35424,35256,35280,35112,
     1  35088,34968,35664,35712,36144,40344,39264,39264,39024,39024,
     2  38928,38904,38568,38592,37944,37920,37632,37632,36984,36984,
     3  36648,36672,36096,36360,36240,36264,36360,36312,35976,35640,
     4  35664,35616,35472,39240,37896,37896,36600,36552,36192,36192,
     5  36072,36096,35760,35856,35784,35856,36024,36048,35976,36096,
     6  35544,35544,35376,35376,35328,35328,35160,35160,34752,34752,
     7  34656,34656,32424,32424,32136,32112,31800,31800,31152,31128,
     8  36528,36768,36864,37344,37392,37464,37848,38064,38184,38520,
     9  38688,38856,39120,39216,39360,39456,39528,39672,39792,39888/
            data (jx(i),i= 1301, 1400)/
     +  40128,40440,40704,40968,41040,40896,40992,40992,41304,41400,
     1  41520,41568,41688,41688,41760,41712,41760,37152,37152,35856,
     2  35544,35592,35664,39816,37152,37152,38304,38280,38208,38232,
     3  38040,38016,37920,37848,37848,37680,37488,37560,37512,37344,
     4  37128,37416,37416,36648,36648,36504,36456,36432,36312,36024,
     5  35760,35712,35664,35616,42744,41136,41112,37512,37512,37416,
     6  35856,36000,36048,36144,36216,36312,36360,36624,36624,36696,
     7  36720,37128,37224,37392,37536,37752,38184,38256,38256,38112,
     8  38088,38376,38448,38664,38856,38928,39120,39432,39624,39648,
     9  39744,39744,40056,40296,39504,39504,39384,39384,39288,39240/
            data (jx(i),i= 1401, 1500)/
     +  38904,38904,38664,38664,38568,38568,38448,38448,38352,38328,
     1  38208,38184,38544,38496,38664,38712,38760,38928,38832,38928,
     2  38904,39144,39384,41952,41928,39264,37704,37704,39768,39792,
     3  40056,40104,40104,39816,39648,42288,42312,42144,42048,42048,
     4  41880,41784,41592,41544,41592,41568,41376,41040,40680,40608,
     5  40080,47784,47784,46464,46464,43152,43152,40488,40488,40368,
     6  42408,42384,42144,41976,41952,41832,41784,41472,41352,41400,
     7  41016,41040,40368,40368,40080,40152,41688,41784,41640,41544,
     8  41448,41472,41304,41232,41208,41328,41256,41328,41064,40872,
     9  40320,40296,39648,39696,43392,43224,43200,43080,42672,42600/
            data (jx(i),i= 1501, 1600)/
     +  42384,42216,42168,42072,41928,41832,41784,41712,41184,41160,
     1  41064,40872,40728,40608,40512,40512,40392,40056,40800,40632,
     2  40608,40512,40320,40176,40176,40080,40056,39960,39768,39768,
     3  39648,39672,39456,39456,39240,39240,39144,39144,38928,38928,
     4  38808,38832,38496,38496,38376,38376,38160,38160,38064,38064,
     5  37848,37824,37608,37608,41112,40440,40464,40464,41112,41784,
     6  48552,46488,46488,45144,45144,44664,44640,41952,39936,39960,
     7  38640,38640,37992,38016,37488,37488,37368,40776,41424,41352,
     8  41688,41664,41976,45264,45288,42312,42240,42312,42528,42744,
     9  42816,42768,42840,43248,42816,42480,41808,41760,43488,43512/
            data (jx(i),i= 1601, 1700)/
     +  43368,43176,42960,42936,43152,43152,43080,42840,42864,42552,
     1  42504,42552,42528,42432,42432,42336,42288,42240,42072,42504,
     2  42864,43128,43344,43440,43464,43608,43824,43896,44184,44280,
     3  43080,42984,43056,43056,42240,42216,42552,42576,43368,43344,
     4  43416,43368,45864,45864,47160,47016,43248,42984,42744,42648,
     5  42648,42600,42576,42672,42600,42792,42768,42864,42888,44064,
     6  43776,43296,43296,43416,45432,45384,45168,45144,44928,44904,
     7  42888,42864,42000,41952,41736,41736,41520,41520,41280,41256,
     8  40824,44328,44112,44112,44016,44016,43800,43800,41664,41688,
     9  42360,45696,45720,51336,50784,50760,50424,50424,49776,49752/
            data (jx(i),i= 1701, 1800)/
     +  49080,49080,48408,48408,46104,45696,45672,45792,45792,45624,
     1  45384,45168,45024,44784,46464,46464,45120,45120,44808,44784,
     2  44448,44448,43104,43104,42432,42432,41760,41760,45432,44976,
     3  45000,44784,44784,44520,44208,44112,46464,46464,44256,44256,
     4  44136,44136,44016,44016,43920,43920,43800,43800,43680,43680,
     5  43584,43584,43464,43464,43248,43248,43128,43128,48816,48648,
     6  48528,48504,48360,48120,48120,48024,48024,47880,47832,47664,
     7  47640,47592,47496,47304,47184,47328,46320,45648,47832,47808,
     8  47232,47088,47088,46776,46752,46560,46560,46344,46320,46200,
     9  46200,46104,46104,46008,46008,45888,45864,45744,45744,45648/
            data (jx(i),i= 1801, 1900)/
     +  45624,45528,45504,45048,45048,44544,44592,44304,44400,44304,
     1  47016,47784,48504,48432,48408,48552,48576,48744,48816,48912,
     2  48912,48696,48624,48864,48912,48864,48840,48672,48744,49032,
     3  48888,48744,48648,48360,48312,48336,48624,24672,24456,24480,
     4  24312,24456,24408,24216,24264,24456,24528,24408,24456,24264,
     5  24264,24120,23928,24048,23976,23952,24096,24096,23976,23856,
     6  24096,24168,24048,24144,24000,24096,23904,24024,24312,24336,
     7  24288,24504,24552,24432,24696,24528,24672,24672,24528,24576,
     8  24384,26784,26184,26184,29640,29280,29808,28488,28512,27840,
     9  28008,27336,27432,28848,28824,26832,35184,34944,34968,34872/
            data (jx(i),i= 1901, 1910)/
     +  39072,39720,39648,40296,40200,40872,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  52872,47544,41256,15000,58224,63503,68975,27720,32352,18288,
     1   7992,34992, 9744,14448,16200,65903,18024,31080,31632,48576,
     2  59280,40200,39096,33168, 8376,23664,68543,69263, 7872, 7992,
     3   8136, 8496, 8544, 8640, 8784, 8856, 9048, 9144, 9240, 9384,
     4   9312, 9480, 9528, 9264, 9168, 9432, 9384, 9480, 9576, 9624,
     5  69671,70175, 9672, 9312, 9120, 9096, 9264, 9576, 9624, 9768,
     6   9912,10104,10224,10344,10608,10728,10824,11280,11280,11400,
     7  11376,11544,11592,11880,12024,12144,12168,12336,12432,12576,
     8  12768,13032,13200,13152,13152,13080,13176,13152,13296,13296,
     9  13464,13632,13872,13968,13968,13848,14016,14112,14256,14328/
            data (jy(i),i=  101,  200)/
     +  70703,16008,15696,15480,15312,15192,15120,14856,14736,14592,
     1  14592,14688,14688,14544,16248,16224,16128,16176,16104,16104,
     2  15792,15912,15840,15648,15672,15576,15576,15360,15456,15456,
     3  15312,15120,15024,15048,15264,15360,15288,15144,15096,15264,
     4  15168,15216,15336,15576,15600,15456,15672,15528,15384,15000,
     5  14664,14784,14808,14976,15048,14952,15000,14952,14664,14784,
     6  14688,71303,14616,14664,14832,14928,15192,15168,15264,15336,
     7  15624,15696,15816,16152,16296,16296,16584,16656,16920,16992,
     8  17136,17304,17568,17544,17592,17784,17856,55296,18048,18216,
     9  18168,18240,18432,18504,18624,18720,18624,18504,18864,18912/
            data (jy(i),i=  201,  300)/
     +  18792,18816,18888,18792,19008,18984,19272,19200,19224,19368,
     1  19488,19728,19728,19848,19824,19944,20160,20088,20256,20280,
     2  20448,20424,20520,20472,20400,20208,20184,20400,20544,20568,
     3  20760,20904,20976,21048,21384,21504,21552,31320,31464,31536,
     4  31560,26088,26136,26232,26328,26520,26856,26976,27072,27504,
     5  27672,27912,28080,28056,28344,28536,28968,29088,29232,29304,
     6  29544,29880,30360,30528,30768,30888,31176,31152,30936,30936,
     7  30840,30864,30936,30888,31032,31128,31056,31752,31896,32088,
     8  32232,32208,32304,32520,32376,32448,32688,32760,32976,33000,
     9  33432,33408,36912,37080,38016,38376,22128,22104,22272,22272/
            data (jy(i),i=  301,  400)/
     +  22440,22464,22536,22344,22584,22560,22752,22656,22752,23088,
     1  23280,23376,23448,23568,23736,23784,23664,23736,24000,24168,
     2  24288,24624,24960,25128,25296,25488,25704,25896,26040,52152,
     3  52008,52200,52152,52704,52680,52464,52416,52656,52632,52968,
     4  52944,52896,52752,52896,44544,44520,45600,45840,45864,45936,
     5  46104,46800,46776,46896,46824,47136,47112,47232,47184,47496,
     6  47448,47544,41160,41160,41064,41040,41208,41208,41328,41304,
     7  41520,41520,41304,41256,41184,41256,15000,15216,15000,15072,
     8  15048,15120,15120,14928,14904,15192,15360,15504,15384,15288,
     9  15168,15048,15096,15048,15264,14064,14016,14232,14088,13224/
            data (jy(i),i=  401,  500)/
     +  13200,59976,58872,58752,58104,58032,58248,63551,63623,63791,
     1  64127,64175,66047,65999,65327,65279,27696,25704,25680,21720,
     2  31608,32304,21552,21792,21840,21720,21480,21120,21120,21192,
     3  21168,21000,20808,20496,20352,20208,20136,19968,19824,19824,
     4  19920,19872,20016,20064,20040,19920,19728,19800,19656,19536,
     5  19392,19224,19056,18984,18792,18744,18720,18552,18672,18384,
     6  18552,18504,18384,18384,18504,18384, 8112, 8112, 8400, 8520,
     7   8712, 9000, 9216, 9408, 9552, 9720, 9888, 9744, 9984,10008,
     8  10104,10224,10416,10464,10464,10368,10344,10488,10656,10824,
     9  10992,11040,11160,11136,11208,11568,11760,11952,12216,12288/
            data (jy(i),i=  501,  600)/
     +  12336,12384,12528,12552,12456,12480,40200,40176,39576,39552,
     1  35616,35616,34944,60048,60240,60336,60384,60480,60528,60720,
     2  60744,60864,60984,61032,61056,60984,61008,61152,61392,61608,
     3  61704,62208,62568,62687,63095,63191,63167,63335,34584,34584,
     4  31608,27984,28152,28416,28560,28656,28656,29640,29640,30288,
     5  30288,23496,23304,23208,23208,23136,23088,22800,22776,22680,
     6  22608,22296,22296,22344,22224,22032,22008,21840,21840,31584,
     7  28656,28656,28344,28344,27672,27672,57120,57072,57216,57312,
     8  57360,57816,58008,58584,58608,58512,58704,58824,58800,58872,
     9  58992,59040,59136,59184,59136,59160,59400,59568,59688,59784/
            data (jy(i),i=  601,  700)/
     +  59760,59808,59976,59976,60168,15168,15816,15816,18120,18120,
     1  18048,18024,17952,18072,18096,18192,18216,18936,19056,19032,
     2  19152,19368,19368,19464,19488,19632,19728,19872,20016,20040,
     3  19968,20016,19920,20088,20040,20160,20304,20328,20304,20208,
     4  20160,59208,58800,58704,58032,57936,58128,57984,57480,57432,
     5  15216,13224,13296,13176,41208,23520,23880,23928,24048,23928,
     6  23712,23712,23784,23640,23568,23496,23544,41304,41472,41808,
     7  42168,42336,42600,43248,43608,43824,43968,44280,44232,44352,
     8  44232,40968,40824,40488,40272,39696,39696,39624,39672,39624,
     9  39504,39312,39072,38640,38040,37776,45000,45096,45048,45120/
            data (jy(i),i=  701,  800)/
     +  45384,45504,45672,46008,46272,46440,46536,46512,46752,46872,
     1  46872,46968,46968,47112,47184,47208,47352,47448,47496,47544,
     2  52200,52488,52680,53040,53640,53904,54768,54888,54864,54936,
     3  55176,55392,55560,55608,55824,55896,55968,55992,56088,56184,
     4  56256,56208,56352,56424,56424,56592,56616,56544,56688,56616,
     5  56784,56784,56688,56928,56928,57024,57000,31584,35568,35568,
     6  34896,34896,34392,34296,34272,34272,34176,34032,33816,33672,
     7  33456,33480,33816,28296,28056,27600,27456,27240,27096,26856,
     8  26760,26736,26568,26448,26424,26352,26352,25896,25872,25704,
     9  25608,25320,25104,24888,24552,24264,24120,23832,23904,23904/
            data (jy(i),i=  801,  900)/
     +  23784,23856,23664,23568,18576,18648,18576,18624,18576,18720,
     1  18648,18528,18456,18768,18840,18720,18768,18696,18792,18816,
     2  19080,19032,18456,18432,17112,20952,22608,23400,23328,23016,
     3  22968,23112,23136,23064,23112,23040,22992,22968,22704,22536,
     4  22728,22632,22680,49680,49704,49608,49560,49272,49056,48744,
     5  48480,48312,47784,46128,46080,46200,46152,45480,45480,45576,
     6  45552,46200,46176,47496,47496,47592,28560,28656,28704,28920,
     7  28944,30264,30264,26760,26712,26808,26856,26784,26904,26760,
     8  26280,26280,25656,25656,24336,24384,22992,23064,22872,22776,
     9  22704,22776,49896,49896,50040,50160,50400,50400,50520,50784/
            data (jy(i),i=  901, 1000)/
     +  50904,50928,50952,51120,51168,51336,51456,51768,51984,52080,
     1  52032,52128,52056,35520,35520,35568,35520,34896,34896,34824,
     2  34824,34776,34776,34848,34896,34920,35568,17112,17040,17088,
     3  16704,16584,16464,16344,16416,16488,16680,16728,16632,16416,
     4  16224,16344,16512,16464,16560,16560,15216,15264,15168,49920,
     5  49848,49872,49776,49800,49656,49704,49776,49800,49728,49824,
     6  49800,49896,49944,49824,49776,49752,49824,49728,49752,49584,
     7  49656,49536,49512,49608,49536,49584,49560,49608,49536,49584,
     8  49560,49464,49512,49440,49512,49536,49464,49488,49440,49512,
     9  49416,49512,49488,49512,49416,49488,49416,49584,21648,21720/
            data (jy(i),i= 1001, 1100)/
     +  20880,13992,13752,13776,13440,13464,13128,13152,13056,12864,
     1  12504,12360,12168,11880,11784,11592,11400,11256,11184,10944,
     2  10584,10392,10224, 9840, 9840,14400,14544,15168,15576,15864,
     3  16152,16272,16320,16200,16656,16872,16992,62783,60528,60600,
     4  59928,59880,59376,30240,29568,29592,29160,29136,29064,29040,
     5  28800,28656,28608,28608,28464,28440,28272,30888,30888,32208,
     6  32208,32880,32880,33288,33288,33168,33288,33840,34104,34464,
     7  34464,34656,34680,34800,34848,34944,34992,35304,35376,14448,
     8  15096,15144,15048,15096,15192,15192,15288,15288,15408,15696,
     9  15720,15864,15888,15552,15528,15120,15120,15024,15024,14784/
            data (jy(i),i= 1101, 1200)/
     +  14784,14712,14712,14520,14520,14424,14424,14088,14088,13992,
     1  67127,67679,67727,67871,67871,67991,67991,68087,68135,68279,
     2  68351,68423,68447,68567,68495,68423,68375,68303,68231,68111,
     3  68039,67775,67607,67823,64895,64871,64775,64775,64679,64655,
     4  64007,63959,63287,63191,67223,62088,61872,61824,60744,60720,
     5  59376,56088,56088,59304,59160,59376,59184,59400,59208,59376,
     6  31080,31080,31008,31056,30936,30912,30576,30312,30360,30552,
     7  21072,21048,20712,20712,20376,20304,19680,19680,18864,62112,
     8  66599,66575,67247,65927,65951,65303,65327,63983,63959,62855,
     9  62831,62615,62592,62136,22944,23016,22656,22464,22272,22296/
            data (jy(i),i= 1201, 1300)/
     +  22224,22032,21936,21888,21720,21720,50304,50208,50160,50160,
     1  50208,50160,44112,42144,42144,45456,45432,45312,45312,45192,
     2  45192,45144,45072,44952,44928,44832,44808,44712,44688,44256,
     3  44232,44136,37512,37152,37008,36816,36744,36528,36048,35976,
     4  35712,35664,35544,66095,65999,65855,65759,66695,40272,39864,
     5  39816,39648,39096,38856,38616,38352,38280,38088,37920,37824,
     6  40224,40032,39984,39816,39816,39768,39792,39984,40008,40104,
     7  40104,40200,40176,39576,39576,38880,38880,38256,38232,37800,
     8  18984,18912,18816,18720,18552,18552,18672,18624,18816,19008,
     9  18984,19056,18984,19152,19104,19008,19008,18744,18768,18936/
            data (jy(i),i= 1301, 1400)/
     +  18888,19104,18888,18816,18984,19104,19200,19392,19560,19512,
     1  19584,19800,19824,20016,20016,20208,20280,30216,30360,30360,
     2  30600,30720,30744,37488,29544,30072,26952,27024,27048,27144,
     3  27288,27480,27480,27456,27384,27360,27720,27936,28056,28272,
     4  28296,50640,50544,50520,50304,50400,50328,50400,50376,50496,
     5  50304,50352,50304,50400,30168,30192,29544,50856,50784,50784,
     6  31296,31272,31320,31272,31344,31344,31488,31536,31728,31776,
     7  31968,31944,32016,31896,32184,32352,32376,32472,32664,32784,
     8  33048,33288,33408,33312,33288,33168,33072,33024,33192,33288,
     9  33264,33312,33408,47448,47424,47640,47640,47856,47856,49392/
            data (jy(i),i= 1401, 1500)/
     +  49392,49464,49464,49584,49560,49680,49680,49800,49800,49872,
     1  49872,50640,26544,26280,26160,26160,26040,26016,25776,25752,
     2  25608,25392,25464,65783,66023,65759,42192,42120,42144,40824,
     3  34848,37488,25344,25368,25272,30528,30696,30792,30936,31032,
     4  31176,31248,31224,31272,31368,31464,31416,31440,31704,31848,
     5  31872,38760,37848,37824,37896,37848,37464,37440,37488,44688,
     6  22608,22920,23232,23280,23472,23472,23400,23400,23544,23712,
     7  23880,24264,24264,24768,25008,25128,20400,20496,20616,20568,
     8  20592,20736,20976,20976,21072,21144,21240,21264,21552,21624,
     9  21672,21576,21600,22944,27432,27096,26976,26928,26112,26088/
            data (jy(i),i= 1501, 1600)/
     +  26208,26184,26136,26136,26040,26064,26016,26064,26040,25896,
     1  25872,25920,25920,25776,25728,25656,25632,25704,52200,52152,
     2  52248,52248,52368,52320,52392,52368,52440,52368,52392,52272,
     3  52272,52152,52152,52056,52032,51912,51912,51816,51792,51696,
     4  51672,51576,51552,51456,51432,51336,51336,51216,51216,51096,
     5  51072,50976,50952,50856,42072,42072,40848,41088,41088,20304,
     6  33456,33504,34152,34128,34440,34464,34800,55320,55224,54840,
     7  54768,54672,54624,53976,53952,53832,53808,52656,52680,54000,
     8  54024,54696,54696,65975,65711,22536,22176,21912,21696,21576,
     9  21360,21264,21192,21024,20712,20712,20424,20376,18096,18168/
            data (jy(i),i= 1601, 1700)/
     +  18192,18168,18360,18432,18504,18600,18768,18816,18912,19248,
     1  19344,19512,19704,19776,19896,19896,19968,20208,20184,22656,
     2  23112,23976,24312,24312,24384,24336,24432,24624,24624,24696,
     3  29496,29664,29760,29952,55320,55656,55680,55488,55536,55872,
     4  55872,56520,56664,56448,56520,59160,27600,27744,27768,27888,
     5  28128,28104,28272,28536,28728,28872,28944,29064,29256,25104,
     6  25488,25704,25752,25896,46320,48096,48096,48768,48744,49416,
     7  49320,49464,49416,50280,50280,50496,50472,50712,50688,51360,
     8  51360,45216,45216,45096,45096,45000,44976,44880,44856,44736,
     9  59088,59304,59064,29448,29448,27912,27912,27360,27384,27240/
            data (jy(i),i= 1701, 1800)/
     +  27264,26496,26496,25824,25824,25608,25440,25248,25080,24840,
     1  24648,24648,24576,24672,38760,39432,39408,40080,40080,40728,
     2  40728,41400,41352,41448,41424,41640,41616,42072,46056,46032,
     3  45672,45672,45456,45456,45576,45552,31680,31800,31800,30840,
     4  30840,30720,30720,30600,30600,30480,30504,30384,30384,30264,
     5  30264,30168,30168,29832,29832,29616,29616,29496,48528,48552,
     6  48600,48672,48624,48768,48912,48816,48888,48888,49008,48936,
     7  48984,48960,49176,49176,49368,46080,46056,46152,40176,40752,
     8  40752,40920,41184,41184,41280,41280,41400,41424,41520,41520,
     9  41640,41640,41736,41736,41856,41856,42096,42096,42192,42192/
            data (jy(i),i= 1801, 1900)/
     +  42504,42504,43392,43392,43704,43704,43992,44520,44904,45120,
     1  59208,40176,33600,33600,33720,33912,34008,34056,34176,34152,
     2  34536,34656,34920,35208,35424,38688,38784,38976,39096,33168,
     3  33072,32856,32952,32952,33096,33216,33384,68975,68999,68879,
     4  68759,68567,68519,68495,68399,68447,68255,67967,67679,67607,
     5  67415,67127,67031,66815,66743,66599,66431,66383,66407,66263,
     6  66191,65951,65903,65615,65471,65087,64799,64679,64655,64607,
     7  64415,64439,64367,64295,64103,64007,63839,63719,63743,63503,
     8  63407,63311,63263,63455,69263,69239,67295,67175,66767,66695,
     9  64727,64679,63359,62568,62783,62639,68567,68543,68207,68207/
            data (jy(i),i= 1901, 1910)/
     +  68015,68063,68735,68807,70151,70223,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      5,    1,    4,   11,    1,    4,    2,    8,   10,    3,
     1      8,    9,    7,    6,    7,   11,   29,   30,   31,   32,
     2     33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
     3     43,   44,   45,   46,   47,   48,   49,   13,   28,   51,
     4     13,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     5     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     6     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     7     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     8     92,   93,   94,   95,   96,   97,   98,   99,   14,   52,
     9     15,  102,  103,  104,  105,  106,  107,  108,  109,  110/
            data (jb1(i),i=  101,  200)/
     +    111,  112,  113,   14,   15,  115,  116,  117,  118,  119,
     1    120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
     2    130,  131,  132,  133,  134,  135,  136,  137,  138,  139,
     3    140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
     4    150,  151,  152,  153,  154,  155,  156,  157,  158,  159,
     5    160,   16,  101,  161,  163,  164,  165,  166,  167,  168,
     6    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     7    179,  180,  181,  182,  183,  184,  185,  186,   17,   16,
     8     20,   21,   20,   22,   17,  189,  190,  191,  192,  193,
     9    194,  195,  196,  197,  198,  199,  200,  201,  202,  203/
            data (jb1(i),i=  201,  300)/
     +    204,  205,  206,  207,  208,  209,  210,  211,  212,  213,
     1    214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
     2    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     3    234,  235,  236,   18,  238,  239,  240,   19,  242,  243,
     4    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     5    254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
     6    264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
     7    274,  275,  276,   18,   19,  278,  279,  280,  281,  282,
     8    283,  284,  285,  286,  287,  288,  289,   24,   24,  291,
     9    292,  293,  294,  295,   23,  237,  297,  298,  299,  300/
            data (jb1(i),i=  301,  400)/
     +    301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
     1    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     2    321,  322,  323,  324,  325,  326,  327,  328,  242,  330,
     3    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     7    371,  372,  373,  374,  375,  376,    4,  377,  378,  379,
     8    380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     9    390,  391,  392,  393,  394,  395,  396,  397,  398,  399/
            data (jb1(i),i=  401,  500)/
     +    400,  402,  403,  404,  405,  406,  407,    6,  408,  409,
     1    410,  411,  402,    7,  413,  414,  415,  412,  417,  417,
     2    418,  419,  421,  422,  420,  423,  424,  425,  426,  427,
     3    428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
     4    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     5    448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
     6    458,  459,  460,  461,  462,  463,  464,  465,  466,   11,
     7    467,  468,  469,  470,  471,  472,  473,  474,  475,  476,
     8    477,  478,  479,  480,  481,  482,  483,  484,  485,  486,
     9    487,  488,  489,  490,  491,  492,  493,  494,  495,  496/
            data (jb1(i),i=  501,  600)/
     +    497,  498,  499,  500,  501,  502,  503,  504,  505,  401,
     1    363,  507,  508,  509,  510,  511,  512,  513,  514,  515,
     2    516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
     3    526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
     4    536,  537,  513,  539,  540,  417,  542,  543,  544,  545,
     5    546,  547,  548,  549,  550,  421,  552,  553,  554,  555,
     6    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     7    566,  567,  568,  420,  570,  571,  572,  573,  574,  575,
     8    552,  577,  578,  579,  580,  581,  582,  583,  584,  585,
     9    586,  587,  588,  589,  590,  591,  592,  593,  594,  595/
            data (jb1(i),i=  601,  700)/
     +    596,  597,  598,  599,  600,  601,  602,  514,  421,  514,
     1    604,  402,  606,  607,  608,  609,  610,  611,  612,  613,
     2    614,  615,  616,  617,  618,  619,  620,  621,  622,  623,
     3    624,  625,  626,  627,  628,  629,  630,  631,  632,  633,
     4    634,  635,  636,  637,  638,  639,  640,  642,  643,  644,
     5    645,  646,  647,  648,  649,  577,  541,  606,  651,  652,
     6    653,  401,  363,  656,  657,  658,  659,  660,  661,  662,
     7    663,  664,  665,  666,  552,  655,  668,  669,  670,  671,
     8    672,  673,  674,  675,  676,  677,  678,  679,  680,  345,
     9    655,  682,  683,  684,  685,  686,  687,  688,  689,  690/
            data (jb1(i),i=  701,  800)/
     +    691,  692,  693,  694,  695,  345,  697,  698,  699,  700,
     1    701,  702,  703,  704,  705,  706,  707,  708,  709,  710,
     2    711,  712,  713,  714,  715,  716,  717,  718,  719,  330,
     3    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     4    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     5    741,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     6    751,  752,  753,  754,  755,  756,  577,  570,  759,  760,
     7    761,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     8    771,  772,  758,  774,  775,  776,  777,  778,  779,  780,
     9    781,  782,  783,  784,  785,  786,  787,  788,  789,  790/
            data (jb1(i),i=  801,  900)/
     +    791,  792,  793,  794,  795,  796,  797,  798,  799,  800,
     1    801,  802,  803,  656,  641,  805,  806,  807,  808,  809,
     2    810,  811,  812,  813,  814,  815,  816,  817,  818,  819,
     3    820,  821,  822,  823,  824,  641,  826,  656,  828,  829,
     4    830,  831,  832,  833,  834,  835,  836,  837,  838,  839,
     5    840,  841,  842,  827,  844,  845,  846,  847,  848,  849,
     6    850,  851,  852,  720,  854,  855,  856,  857,  858,  859,
     7    860,  861,  862,  863,  864,  865,  720,  774,  867,  868,
     8    869,  870,  871,  872,  758,  874,  875,  876,  877,  878,
     9    879,  880,  881,  882,  883,  884,  885,  886,  887,  888/
            data (jb1(i),i=  901, 1000)/
     +    889,  890,  891,  827,  844,  893,  894,  895,  896,  897,
     1    898,  899,  900,  901,  902,  903,  904,  905,  906,  907,
     2    908,  909,  910,  911,  912,  330,  696,  914,  915,  916,
     3    917,  918,  919,  920,  921,  922,  923,  924,  925,  926,
     4    759,  825,  928,  929,  930,  931,  932,  933,  934,  935,
     5    936,  937,  938,  939,  940,  941,  942,  943,  944,  945,
     6    946,  947,  948,  606,  950,  951,  952,  953,  954,  955,
     7    956,  957,  958,  959,  960,  961,  962,  963,  964,  965,
     8    966,  967,  968,  969,  970,  971,  972,  973,  974,  975,
     9    976,  977,  978,  979,  980,  981,  982,  983,  984,  985/
            data (jb1(i),i= 1001, 1100)/
     +    986,  987,  988,  989,  990,  991,  992,  993,  994,  995,
     1    996,  997,  844,  999, 1000,  826, 1002, 1003, 1004, 1005,
     2   1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015,
     3   1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025,
     4   1002, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034,
     5   1035, 1036,  825, 1038, 1039, 1040, 1041,  642,  642, 1044,
     6   1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054,
     7   1055, 1056,  774, 1044, 1058, 1059, 1060, 1061, 1062, 1063,
     8   1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073,
     9   1074, 1075, 1076, 1077, 1078,  914,   14, 1080, 1081, 1082/
            data (jb1(i),i= 1101, 1200)/
     +   1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092,
     1   1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102,
     2   1103, 1104, 1105, 1106, 1107, 1108, 1109, 1002, 1111, 1112,
     3   1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122,
     4   1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132,
     5   1133, 1111, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142,
     6   1143, 1038, 1111, 1146, 1147, 1148, 1149, 1043, 1043, 1151,
     7   1152,  950, 1154, 1155, 1156, 1157, 1158, 1159, 1151, 1161,
     8   1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1044,  999,
     9   1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1146, 1181/
            data (jb1(i),i= 1201, 1300)/
     +   1182, 1145, 1181, 1184, 1185, 1186, 1187, 1188, 1189, 1190,
     1   1191, 1192, 1193, 1180, 1195, 1196, 1197, 1198, 1199, 1200,
     2   1201, 1202, 1203, 1204, 1205,  999, 1207, 1208, 1209, 1210,
     3   1211,  950,  854,  854, 1213, 1214, 1216, 1217, 1218, 1219,
     4   1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229,
     5   1230, 1231, 1213, 1233, 1234, 1235, 1236, 1237, 1238, 1239,
     6   1240, 1241, 1242,  914, 1244, 1245, 1246, 1247, 1181, 1249,
     7   1250, 1251, 1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259,
     8   1233, 1179, 1215, 1249, 1261, 1262, 1263, 1264, 1265, 1266,
     9   1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276/
            data (jb1(i),i= 1301, 1400)/
     +   1277, 1278, 1279,  696, 1179, 1281, 1282, 1283, 1284, 1285,
     1   1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295,
     2   1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305,
     3   1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315,
     4   1316, 1318, 1319, 1320, 1321, 1322, 1161, 1233, 1325, 1318,
     5    874, 1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335,
     6   1336, 1337, 1338, 1339, 1340, 1325, 1342, 1343, 1344, 1345,
     7   1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353, 1207, 1355,
     8   1356, 1325, 1358, 1359, 1342, 1161, 1361, 1362, 1363, 1364,
     9   1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374/
            data (jb1(i),i= 1401, 1500)/
     +   1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384,
     1   1385, 1386, 1387, 1388, 1389, 1390, 1391, 1392, 1216, 1394,
     2   1395, 1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404,
     3   1405, 1406, 1407, 1408, 1409, 1410, 1411, 1342,  874, 1413,
     4   1414, 1415, 1416, 1417, 1418, 1419, 1420, 1421, 1422, 1195,
     5   1424, 1425, 1244, 1215, 1427, 1428, 1429, 1324, 1393, 1431,
     6   1433, 1434, 1423, 1355, 1436, 1437, 1438, 1439, 1440, 1441,
     7   1442, 1443, 1444, 1445, 1446, 1447, 1448, 1449, 1450, 1393,
     8   1324, 1452, 1453, 1454, 1455, 1456, 1457, 1458, 1432, 1216,
     9   1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470/
            data (jb1(i),i= 1501, 1600)/
     +   1471, 1472, 1473, 1474, 1475, 1433, 1317, 1477, 1478, 1479,
     1   1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488, 1489,
     2   1490, 1491, 1492, 1493, 1195, 1495, 1496, 1497, 1498, 1499,
     3   1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509,
     4   1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517, 1433, 1519,
     5   1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529,
     6   1530, 1531, 1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539,
     7   1540, 1541, 1542, 1543, 1544, 1545, 1546, 1547, 1548, 1549,
     8   1550, 1551, 1552, 1553, 1358, 1555, 1460, 1430, 1557, 1558,
     9   1555, 1317, 1561, 1562, 1563, 1564, 1565, 1566, 1431, 1154/
            data (jb1(i),i= 1601, 1700)/
     +   1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1358,
     1   1519, 1578, 1579, 1580, 1581, 1582, 1568, 1424, 1584, 1585,
     2   1461, 1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594,
     3   1595, 1596, 1597, 1560,   17, 1599, 1600, 1601, 1602, 1603,
     4   1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612, 1613,
     5   1614, 1615, 1616, 1617, 1618, 1560, 1461, 1620, 1621, 1622,
     6   1623, 1624, 1625, 1626, 1627, 1628, 1629, 1631, 1632, 1633,
     7   1355, 1568, 1635, 1636, 1637, 1638, 1639, 1640, 1641, 1642,
     8   1643, 1644, 1645, 1495, 1647, 1648, 1649, 1650, 1651, 1652,
     9   1653, 1654, 1655, 1656, 1657, 1658, 1631, 1630, 1660, 1661/
            data (jb1(i),i= 1701, 1800)/
     +   1662, 1663, 1495, 1665, 1666, 1667, 1668, 1669, 1670, 1671,
     1   1672, 1673, 1674, 1675, 1676, 1677, 1678, 1679, 1680, 1519,
     2   1682, 1683, 1684, 1685, 1686, 1687, 1688, 1689, 1460, 1154,
     3   1691, 1692, 1646,   18, 1694, 1695, 1696, 1697, 1698, 1699,
     4   1700, 1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709,
     5   1710, 1711, 1712, 1713, 1630, 1452, 1715, 1716, 1717, 1718,
     6   1719, 1720, 1721, 1722, 1723, 1724, 1725, 1726, 1727, 1555,
     7   1665, 1729, 1730, 1731, 1732, 1733, 1734, 1735, 1682,   19,
     8   1737, 1738, 1739, 1740, 1741, 1742, 1743, 1744, 1745, 1746,
     9   1747, 1748, 1749, 1750, 1751, 1752, 1753, 1754, 1755, 1756/
            data (jb1(i),i= 1801, 1900)/
     +   1757, 1631,   20, 1759, 1760, 1761, 1762, 1763, 1764, 1765,
     1   1766, 1767, 1768, 1769, 1770, 1771, 1772, 1773, 1774, 1775,
     2   1776, 1777, 1665, 1779, 1780, 1781, 1782, 1783, 1784, 1785,
     3   1786, 1787, 1788, 1789, 1790, 1791, 1792, 1793, 1794, 1795,
     4   1796, 1797, 1798, 1799, 1800, 1801, 1802, 1803, 1804, 1805,
     5   1806, 1807, 1808, 1809, 1682, 1646, 1811, 1452, 1779, 1779,
     6   1561, 1813, 1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821,
     7   1822, 1823, 1824, 1825, 1826, 1827, 1828, 1829,   24, 1830,
     8   1831, 1832, 1833, 1834, 1835, 1836, 1561,   28, 1838, 1839,
     9   1840, 1841, 1842, 1843, 1844, 1845, 1846, 1847, 1848, 1849/
            data (jb1(i),i= 1901, 1970)/
     +   1850, 1851, 1852, 1853, 1854, 1855, 1856, 1857, 1858, 1859,
     1   1860, 1861, 1862, 1863, 1864, 1865, 1866, 1867, 1868, 1869,
     2   1870, 1871, 1872, 1873, 1874, 1875, 1876, 1877, 1878, 1879,
     3   1880,  538, 1882, 1883,  538, 1134, 1885,   51, 1134, 1887,
     4   1888, 1889, 1890, 1891, 1892, 1882, 1038, 1894, 1895, 1882,
     5     52, 1897, 1898, 1899, 1145, 1244, 1901, 1902, 1903, 1904,
     6   1905,  101,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      6,    5,   25,   25,    2,   10,    3,   26,   26,   12,
     1      9,   12,   27,   27,   28,   29,   30,   31,   32,   33,
     2     34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
     3     44,   45,   46,   47,   48,   49,   50,   50,   51,   52,
     4     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     5     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     6     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     7     83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
     8     93,   94,   95,   96,   97,   98,   99,  100,  100,  101,
     9    102,  103,  104,  105,  106,  107,  108,  109,  110,  111/
            data (jb2(i),i=  101,  200)/
     +    112,  113,  114,  114,  115,  116,  117,  118,  119,  120,
     1    121,  122,  123,  124,  125,  126,  127,  128,  129,  130,
     2    131,  132,  133,  134,  135,  136,  137,  138,  139,  140,
     3    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     4    151,  152,  153,  154,  155,  156,  157,  158,  159,  160,
     5    161,  162,  162,  163,  164,  165,  166,  167,  168,  169,
     6    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     7    180,  181,  182,  183,  184,  185,  186,  187,  187,   21,
     8    188,  188,   22,   23,  189,  190,  191,  192,  193,  194,
     9    195,  196,  197,  198,  199,  200,  201,  202,  203,  204/
            data (jb2(i),i=  201,  300)/
     +    205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
     1    215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
     2    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     3    235,  236,  237,  238,  239,  240,  241,  241,  243,  244,
     4    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     5    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     6    265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
     7    275,  276,  277,  277,  278,  279,  280,  281,  282,  283,
     8    284,  285,  286,  287,  288,  289,  290,  290,  291,  292,
     9    293,  294,  295,  296,  296,  297,  298,  299,  300,  301/
            data (jb2(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     1    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  329,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4    342,  343,  344,    1,  346,  347,  348,  349,  350,  351,
     5    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     6    362,    2,  364,  365,  366,  367,  368,  369,  370,  371,
     7    372,  373,  374,  375,  376,    3,  377,  378,  379,  380,
     8    381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
     9    391,  392,  393,  394,  395,  396,  397,  398,  399,  400/
            data (jb2(i),i=  401,  500)/
     +    401,  403,  404,  405,  406,  407,    5,  408,  409,  410,
     1    411,  412,  412,  413,  414,  415,  416,  416,    8,  418,
     2    419,  420,  422,    9,  423,  424,  425,  426,  427,  428,
     3    429,  430,  431,  432,  433,  434,  435,  436,  437,  438,
     4    439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
     5    449,  450,  451,  452,  453,  454,  455,  456,  457,  458,
     6    459,  460,  461,  462,  463,  464,  465,  466,   10,  467,
     7    468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
     8    478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
     9    488,  489,  490,  491,  492,  493,  494,  495,  496,  497/
            data (jb2(i),i=  501,  600)/
     +    498,  499,  500,  501,  502,  503,  504,  505,  506,  506,
     1    507,  508,  509,  510,  511,  512,  513,   12,  515,  516,
     2    517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     3    527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     4    537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
     5    547,  548,  549,  550,  551,  551,  553,  554,  555,  556,
     6    557,  558,  559,  560,  561,  562,  563,  564,  565,  566,
     7    567,  568,  569,  569,  571,  572,  573,  574,  575,  576,
     8    576,  578,  579,  580,  581,  582,  583,  584,  585,  586,
     9    587,  588,  589,  590,  591,  592,  593,  594,  595,  596/
            data (jb2(i),i=  601,  700)/
     +    597,  598,  599,  600,  601,  602,  603,  603,  541,  604,
     1    605,  605,  607,  608,  609,  610,  611,  612,  613,  614,
     2    615,  616,  617,  618,  619,  620,  621,  622,  623,  624,
     3    625,  626,  627,  628,  629,  630,  631,  632,  633,  634,
     4    635,  636,  637,  638,  639,  640,  641,  643,  644,  645,
     5    646,  647,  648,  649,  650,  650,  570,  651,  652,  653,
     6    654,  654,  655,  657,  658,  659,  660,  661,  662,  663,
     7    664,  665,  666,  667,  667,  668,  669,  670,  671,  672,
     8    673,  674,  675,  676,  677,  678,  679,  680,  681,  681,
     9    682,  683,  684,  685,  686,  687,  688,  689,  690,  691/
            data (jb2(i),i=  701,  800)/
     +    692,  693,  694,  695,  696,  697,  698,  699,  700,  701,
     1    702,  703,  704,  705,  706,  707,  708,  709,  710,  711,
     2    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     3    722,  723,  724,  725,  726,  727,  728,  729,  730,  731,
     4    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     5    742,  743,  744,  745,  746,  747,  748,  749,  750,  751,
     6    752,  753,  754,  755,  756,  757,  757,  758,  760,  761,
     7    762,  763,  764,  765,  766,  767,  768,  769,  770,  771,
     8    772,  773,  773,  775,  776,  777,  778,  779,  780,  781,
     9    782,  783,  784,  785,  786,  787,  788,  789,  790,  791/
            data (jb2(i),i=  801,  900)/
     +    792,  793,  794,  795,  796,  797,  798,  799,  800,  801,
     1    802,  803,  804,  804,  805,  806,  807,  808,  809,  810,
     2    811,  812,  813,  814,  815,  816,  817,  818,  819,  820,
     3    821,  822,  823,  824,  825,  826,  827,  828,  829,  830,
     4    831,  832,  833,  834,  835,  836,  837,  838,  839,  840,
     5    841,  842,  843,  843,  845,  846,  847,  848,  849,  850,
     6    851,  852,  853,  853,  855,  856,  857,  858,  859,  860,
     7    861,  862,  863,  864,  865,  866,  866,  867,  868,  869,
     8    870,  871,  872,  873,  873,  875,  876,  877,  878,  879,
     9    880,  881,  882,  883,  884,  885,  886,  887,  888,  889/
            data (jb2(i),i=  901, 1000)/
     +    890,  891,  892,  892,  893,  894,  895,  896,  897,  898,
     1    899,  900,  901,  902,  903,  904,  905,  906,  907,  908,
     2    909,  910,  911,  912,  913,  913,  759,  915,  916,  917,
     3    918,  919,  920,  921,  922,  923,  924,  925,  926,  927,
     4    927,  928,  929,  930,  931,  932,  933,  934,  935,  936,
     5    937,  938,  939,  940,  941,  942,  943,  944,  945,  946,
     6    947,  948,  949,  949,  951,  952,  953,  954,  955,  956,
     7    957,  958,  959,  960,  961,  962,  963,  964,  965,  966,
     8    967,  968,  969,  970,  971,  972,  973,  974,  975,  976,
     9    977,  978,  979,  980,  981,  982,  983,  984,  985,  986/
            data (jb2(i),i= 1001, 1100)/
     +    987,  988,  989,  990,  991,  992,  993,  994,  995,  996,
     1    997,  998,  998, 1000, 1001, 1001, 1003, 1004, 1005, 1006,
     2   1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016,
     3   1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025,   13,
     4   1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035,
     5   1036, 1037, 1037, 1039, 1040, 1041, 1042, 1042, 1043, 1045,
     6   1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055,
     7   1056, 1057, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064,
     8   1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074,
     9   1075, 1076, 1077, 1078, 1079, 1079, 1080, 1081, 1082, 1083/
            data (jb2(i),i= 1101, 1200)/
     +   1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093,
     1   1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103,
     2   1104, 1105, 1106, 1107, 1108, 1109, 1110, 1110, 1112, 1113,
     3   1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123,
     4   1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133,
     5   1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142, 1143,
     6   1144, 1144, 1145, 1147, 1148, 1149, 1150, 1150, 1151, 1152,
     7   1153, 1153, 1155, 1156, 1157, 1158, 1159, 1160, 1160, 1162,
     8   1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1170, 1171,
     9   1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1182/
            data (jb2(i),i= 1201, 1300)/
     +   1183, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191,
     1   1192, 1193, 1194, 1194, 1196, 1197, 1198, 1199, 1200, 1201,
     2   1202, 1203, 1204, 1205, 1206, 1206, 1208, 1209, 1210, 1211,
     3   1212, 1212, 1207, 1213, 1214, 1215, 1217, 1218, 1219, 1220,
     4   1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230,
     5   1231, 1232, 1232, 1234, 1235, 1236, 1237, 1238, 1239, 1240,
     6   1241, 1242, 1243, 1243, 1245, 1246, 1247, 1248, 1248, 1250,
     7   1251, 1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260,
     8   1260,   15, 1249, 1261, 1262, 1263, 1264, 1265, 1266, 1267,
     9   1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277/
            data (jb2(i),i= 1301, 1400)/
     +   1278, 1279, 1280, 1280, 1281, 1282, 1283, 1284, 1285, 1286,
     1   1287, 1288, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296,
     2   1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306,
     3   1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314, 1315, 1316,
     4   1317, 1319, 1320, 1321, 1322, 1323, 1323, 1324, 1326, 1326,
     5   1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336,
     6   1337, 1338, 1339, 1340, 1341, 1341, 1343, 1344, 1345, 1346,
     7   1347, 1348, 1349, 1350, 1351, 1352, 1353, 1354, 1354, 1356,
     8   1357, 1357, 1359, 1360, 1360, 1361, 1362, 1363, 1364, 1365,
     9   1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375/
            data (jb2(i),i= 1401, 1500)/
     +   1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384, 1385,
     1   1386, 1387, 1388, 1389, 1390, 1391, 1392, 1393, 1394, 1395,
     2   1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404, 1405,
     3   1406, 1407, 1408, 1409, 1410, 1411, 1412, 1412, 1413, 1414,
     4   1415, 1416, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1423,
     5   1425, 1426, 1426, 1427, 1428, 1429, 1430, 1430, 1431, 1432,
     6   1434, 1435, 1435, 1436, 1437, 1438, 1439, 1440, 1441, 1442,
     7   1443, 1444, 1445, 1446, 1447, 1448, 1449, 1450, 1451, 1451,
     8   1432, 1453, 1454, 1455, 1456, 1457, 1458, 1459, 1459, 1460,
     9   1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470, 1471/
            data (jb2(i),i= 1501, 1600)/
     +   1472, 1473, 1474, 1475, 1476, 1476, 1477, 1478, 1479, 1480,
     1   1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488, 1489, 1490,
     2   1491, 1492, 1493, 1494, 1494, 1496, 1497, 1498, 1499, 1500,
     3   1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510,
     4   1511, 1512, 1513, 1514, 1515, 1516, 1517, 1518, 1518, 1520,
     5   1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530,
     6   1531, 1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540,
     7   1541, 1542, 1543, 1544, 1545, 1546, 1547, 1548, 1549, 1550,
     8   1551, 1552, 1553, 1554, 1554, 1556, 1556, 1557, 1558, 1559,
     9   1559, 1560, 1562, 1563, 1564, 1565, 1566, 1567, 1567, 1424/
            data (jb2(i),i= 1601, 1700)/
     +   1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577, 1577,
     1   1578, 1579, 1580, 1581, 1582, 1583, 1583, 1584, 1585,   16,
     2   1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, 1595,
     3   1596, 1597, 1598, 1598, 1599, 1600, 1601, 1602, 1603, 1604,
     4   1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612, 1613, 1614,
     5   1615, 1616, 1617, 1618, 1619, 1619, 1620, 1621, 1622, 1623,
     6   1624, 1625, 1626, 1627, 1628, 1629, 1630, 1632, 1633, 1634,
     7   1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641, 1642, 1643,
     8   1644, 1645, 1646, 1647, 1648, 1649, 1650, 1651, 1652, 1653,
     9   1654, 1655, 1656, 1657, 1658, 1659, 1659, 1660, 1661, 1662/
            data (jb2(i),i= 1701, 1800)/
     +   1663, 1664, 1664, 1666, 1667, 1668, 1669, 1670, 1671, 1672,
     1   1673, 1674, 1675, 1676, 1677, 1678, 1679, 1680, 1681, 1681,
     2   1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1690, 1691,
     3   1692, 1693, 1693, 1694, 1695, 1696, 1697, 1698, 1699, 1700,
     4   1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709, 1710,
     5   1711, 1712, 1713, 1714, 1714, 1715, 1716, 1717, 1718, 1719,
     6   1720, 1721, 1722, 1723, 1724, 1725, 1726, 1727, 1728, 1728,
     7   1729, 1730, 1731, 1732, 1733, 1734, 1735, 1736, 1736, 1737,
     8   1738, 1739, 1740, 1741, 1742, 1743, 1744, 1745, 1746, 1747,
     9   1748, 1749, 1750, 1751, 1752, 1753, 1754, 1755, 1756, 1757/
            data (jb2(i),i= 1801, 1900)/
     +   1758, 1758, 1759, 1760, 1761, 1762, 1763, 1764, 1765, 1766,
     1   1767, 1768, 1769, 1770, 1771, 1772, 1773, 1774, 1775, 1776,
     2   1777, 1778, 1778, 1780, 1781, 1782, 1783, 1784, 1785, 1786,
     3   1787, 1788, 1789, 1790, 1791, 1792, 1793, 1794, 1795, 1796,
     4   1797, 1798, 1799, 1800, 1801, 1802, 1803, 1804, 1805, 1806,
     5   1807, 1808, 1809, 1810, 1810, 1811,   21, 1812, 1812,   22,
     6   1813, 1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822,
     7   1823, 1824, 1825, 1826, 1827, 1828, 1829,   23, 1830, 1831,
     8   1832, 1833, 1834, 1835, 1836, 1837, 1837, 1838, 1839, 1840,
     9   1841, 1842, 1843, 1844, 1845, 1846, 1847, 1848, 1849, 1850/
            data (jb2(i),i= 1901, 1970)/
     +   1851, 1852, 1853, 1854, 1855, 1856, 1857, 1858, 1859, 1860,
     1   1861, 1862, 1863, 1864, 1865, 1866, 1867, 1868, 1869, 1870,
     2   1871, 1872, 1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880,
     3   1881, 1881, 1883, 1884, 1884, 1885, 1886, 1886, 1887, 1888,
     4   1889, 1890, 1891, 1892, 1893, 1893, 1894, 1895, 1896, 1896,
     5   1897, 1898, 1899, 1900, 1900, 1901, 1902, 1903, 1904, 1905,
     6   1906, 1906,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine nb(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(600) :: jx,jy
            integer(kind=iknd), save, dimension(690) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'nebraska      '/
            data jrot,ipart/1,1/
            data kv/   1, 597,   0,   0,   0/
            data kb/   1, 689,   0,   0,   0/
            data iib/ 254,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  19416,17400,19608,18264,18312,20472,19608,19848,19872,20520,
     1  20616,20592,20496,19872,19680,19560,19536,19752,19848,19824,
     2  19584,19608,19896,19848,19584,19512,19536,19728,19752,19728,
     3  19536,22704,17664,25056,17904,27000,27312,30000,30888,32976,
     4  33672,35688,37104,37344,37536,36984,39624,40512,42144,43944,
     5  44712,47376,47472,47496,47568,47616,47616,47664,47688,47712,
     6  47736,47736,47736,17160,18072,19296,19056,18912,18312,19680,
     7  19704,19488,19464,19512,19632,19584,19704,19920,20040,20136,
     8  20208,20376,20472,20496,20664,20856,20880,20856,20736,20736,
     9  21000,21288,21360,21360,21408,21528,21792,21912,22488,22824/
            data (jx(i),i=  101,  200)/
     +  22920,22752,22752,23112,23016,23064,23256,23448,23760,24144,
     1  24312,24384,24504,24912,25176,25344,25536,25704,26064,26184,
     2  26280,26472,26592,26784,27072,27384,27432,27552,27696,27816,
     3  27816,27696,27672,27960,28008,28056,28296,28560,28656,28728,
     4  29064,29232,29520,29664,29760,29904,30312,30432,30552,30672,
     5  30720,31248,31632,31752,31848,31944,32112,32328,32448,32496,
     6  32424,32232,32184,32232,32496,32712,32856,33000,33000,33120,
     7  33312,33528,33912,34104,34224,34368,34392,34536,34728,34848,
     8  34776,34584,34584,34656,35208,35520,35688,35808,35904,35880,
     9  36000,36312,36672,36912,36840,37176,37512,37656,37776,38184/
            data (jx(i),i=  201,  300)/
     +  38520,38664,38808,38904,39072,39360,39792,39984,40272,40464,
     1  40680,40848,41208,41472,41664,42024,42120,42096,41928,41784,
     2  41832,41976,42216,42312,42456,42648,42960,43224,43488,43704,
     3  43896,44016,44184,44280,44208,44328,44352,44472,44640,44784,
     4  44856,45072,45384,45696,45936,46008,46152,46248,46680,46872,
     5  46944,46896,47184,47328,20592,22968,22944,19536,19536,23688,
     6  19752,20208,20136,20160,20040,19992,19872,19656,19392,19320,
     7  19344,19824,19848,19800,20040,19968,20016,20232,20208,20448,
     8  20544,20568,20472,20496,24480,20928,20784,20688,20688,20496,
     9  20568,20472,20376,20328,20304,20136,19896,19920,20856,21000/
            data (jx(i),i=  301,  400)/
     +  20976,21024,20928,20736,20688,20400,20424,20304,22728,25152,
     1  23184,19776,19776,23736,23808,23808,24528,23688,25320,25296,
     2  25344,27000,26784,26784,23352,23352,19992,19992,26952,26952,
     3  27696,27048,27096,27096,27168,20376,20376,23808,23784,27192,
     4  27192,27216,26376,26400,27264,27264,23856,23856,27264,27264,
     5  23880,23880,20424,20424,27264,27264,27264,23208,26616,26616,
     6  27480,27480,27312,27624,27624,27648,28872,28920,30600,29808,
     7  29808,30264,30240,30264,30384,30384,30408,30432,30456,30480,
     8  30504,30528,30528,30576,30600,30624,30648,30672,30672,30672,
     9  30672,30936,30360,32712,32856,33072,30096,30096,29760,32712/
            data (jx(i),i=  401,  500)/
     +  32880,32880,33048,33048,33192,33216,30648,33264,33264,33288,
     1  33672,33768,32520,32520,32808,32832,32928,32904,33096,33096,
     2  33216,33216,33360,33360,33792,33384,33312,33312,33504,33504,
     3  33408,33360,33600,33816,33840,33960,33984,32688,34008,34032,
     4  33888,33888,34032,33960,34056,34056,34080,34080,34080,34080,
     5  33288,33432,33672,33768,33960,33984,34056,34104,34008,34080,
     6  33960,34080,34272,34344,34512,34584,33984,37464,33504,33504,
     7  35208,34056,35328,35328,35184,35160,35016,35040,34872,34824,
     8  33672,35376,35760,35592,35352,34992,34848,34632,34176,34752,
     9  34992,35976,36120,36216,37080,36672,36672,36216,36360,36456/
            data (jx(i),i=  501,  600)/
     +  36768,37200,37248,37296,37296,36912,36912,37368,34032,37416,
     1  37416,37440,37464,37464,37488,37488,37512,37512,37200,37224,
     2  36936,36960,37056,36984,36960,37128,37536,37656,37632,37464,
     3  37368,36600,36840,36936,37152,37728,37992,37992,38304,38616,
     4  39168,39792,40680,37272,40704,40728,40752,40800,40824,40848,
     5  40848,40872,40896,40896,40992,40872,41016,40896,40896,41184,
     6  41064,41112,41304,41280,41184,41232,41136,41280,41352,41280,
     7  41352,44304,42264,42360,42456,44088,44088,44136,44208,44208,
     8  44208,44280,44256,44256,43416,43416,44280,44304,44304,44304,
     9  44304,44328,44328,44808,44832,44928,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  49440,11952,55416,35808,42624,58824,49968,50400,50664,51336,
     1  51576,52104,52200,52584,52584,52728,53040,53136,53304,53472,
     2  53640,53808,54048,54120,54336,54456,54552,54576,54672,54888,
     3  55248,61752,17112,63911,22224, 7416,64439, 7248,65687, 7080,
     4  67127,67319,11808,17520,21744,67655,68111,21648,69119,21552,
     5  70439,67055,63623,26904,60192,31176,56760,53352,35448,49920,
     6  39720,46512,43104, 8016,26280,49104,48864,48408,48072,55488,
     7  55728,55944,56472,56712,56928,57168,57360,57360,57432,57840,
     8  57936,57984,58392,59112,59208,59184,59256,59352,59520,59664,
     9  60288,60384,60480,60936,61200,61272,61080,61056,61704,61728/
            data (jy(i),i=  101,  200)/
     +  61896,62208,62376,62711,63215,63431,63503,63503,63335,63359,
     1  63215,63239,63431,63695,63935,63887,63959,63767,63815,63863,
     2  64055,64127,64391,64367,64463,64511,64775,64823,64751,64751,
     3  64847,64919,65039,65135,65399,65471,65423,65471,65327,65303,
     4  65471,65687,65735,65951,66023,65999,65783,65807,65999,66023,
     5  65711,65879,65735,65807,65999,66047,65903,65927,66047,66215,
     6  66359,66407,66503,66599,66695,66503,66527,66911,67151,67271,
     7  67151,67175,67223,67007,67031,67223,67511,67631,67583,67391,
     8  67367,67391,67295,67199,67367,67271,67775,67919,67847,67679,
     9  67631,67751,67799,67655, 6840,67847,67799,68015,68087,68015/
            data (jy(i),i=  201,  300)/
     +  68255,68231,67991,67967,68039,68015,68015,67775,67751,68015,
     1  68111,68471,68759,68807,68639,68735,68831,69263,69239,69335,
     2  69479,69551,69527,69335,69383,69239,69527,69527,69671,69719,
     3  69863,69839,69623,69623,69935,70151,70319,70415,70391,70583,
     4  70967,71063,70967,71351,71447,71663,71663,71591,71495,71567,
     5  71759,71999,72311,21432,49488,12096,11856,12024,11904,55464,
     6  35784,42624,42720,42816,42960,43152,43296,44040,44400,44640,
     7  44784,45264,45504,45624,45936,46128,46272,46536,47040,47448,
     8  48264,48408,48624,49152,58896,39552,38544,38400,38256,38160,
     9  37992,37416,37320,37104,36672,36240,36144,36024,39648,40032/
            data (jy(i),i=  301,  400)/
     +  40368,40608,40968,41136,41304,41736,42072,42192,61008,61056,
     1  16992,17136,16992,52944,49560,49512,56352,56328,60336,61056,
     2  58920,60384,22464,22224,22320,22128,22272,22128,26712,62352,
     3  62376,58968,30960,56400,52992,35784,35880,35832,35952,35928,
     4  35184,49584,11928,12240,12216,39600,39624,39552,39456,42744,
     5  42768,42696,42696,42624,46200,42840,12504,17160,17064,17352,
     6  17352,17520,64151,64175,21984,22416,53016,49632,35136,12360,
     7  12312,12288,21888,22488,62448,26616,26760,59880,59016,57336,
     8  56472,30888,31872,53064,35256,49632,39432,46224,42840,46272,
     9  42888,63287,63263,53112,12144,17544,17688,17496,17424,52704/
            data (jy(i),i=  401,  500)/
     +  52704,51528,51528,51264,51264,49704,49680,12072,12120,59952,
     1  22368,64223,63335,63407,63407,63527,63527,63623,63647,63767,
     2  63767,63935,63935,64199,63143,60816,60888,61152,61320,61416,
     3  61920,62400,62687,26664,27672,31776,54048,54024,35208,57384,
     4  57168,57024,56736,56520,49704,49728,42960,42912,46320,46344,
     5  59808,59520,59232,58776,58584,58296,58224,57936,57792,57552,
     6  56448,56304,55800,55344,55128,54840,54816,49776,17520,17760,
     7  17664,49824,49824,51120,51120,51480,51480,52632,52632,54048,
     8  21864,21792,64295,64103,64007,64079,64007,63767,63599,54840,
     9  54288,53280,53256,53160,21768,11904,11856,64415,64367,64391/
            data (jy(i),i=  501,  600)/
     +  64223,64415,27576,60024,60000,17616,17544,56592,35304,35232,
     1  35376,53160,46320,42912,46512,41304,63335,64175,64175,63335,
     2  67511,67055,66887,66647,66359,65999,65543,65159,65015,64895,
     3  64511,52896,52584,52152,51864,51360,50976,50880,50664,50280,
     4  49800,63383,26928,27744,27672,60048,31152,56664,35328,53256,
     5  37128,49824,49848,46536,46512,39216,39648,41256,41352,41352,
     6  40392,39984,43128,42336,41952,41640,45720,45456,45192,44568,
     7  43944,49896,66431,63479,60120,26856,27000,60120,56712,31104,
     8  31248,35472,53328,53304,37080,36240,36240,49920,46536,39624,
     9  46512,39720,43104,66959,66551,63551,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    7,    8,    9,   10,   11,   12,   13,   14,   15,
     1     16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
     2     26,   27,   28,   29,   30,    3,    2,   36,    2,   33,
     3     35,    4,    1,   66,   67,   68,    5,    4,    3,   70,
     4     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     5     81,   82,    6,    6,   84,   85,   86,   87,   88,   89,
     6     90,   91,   92,   93,   94,   95,   96,   97,   98,   32,
     7     32,  100,  101,  102,  103,  104,  105,  106,  107,  108,
     8    109,  110,  111,  112,  113,   34,   34,  115,  116,  117,
     9    118,  119,  120,  121,  122,  123,  124,   37,   37,  126/
            data (jb1(i),i=  101,  200)/
     +    127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
     1    137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
     2    147,  148,  149,  150,   39,   36,   39,  152,  153,  154,
     3    155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
     4    165,  166,  167,  168,  169,  170,  171,   41,   38,   41,
     5    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     6    183,  184,  185,   42,   42,  187,  188,  189,  190,  191,
     7    192,  193,   46,   43,   40,   43,   44,   46,  196,  197,
     8    198,  199,  200,  201,  202,  203,  204,  205,   47,   45,
     9     47,  207,  208,  209,  210,  211,  212,  213,  214,  215/
            data (jb1(i),i=  201,  300)/
     +    216,   49,   48,   49,  218,  219,  220,  221,  222,  223,
     1    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     2    234,  235,  236,  237,  238,   51,   51,  240,  241,  242,
     3    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     4     52,   52,   54,   50,   53,   54,   55,   57,   56,   58,
     5     59,   60,   61,   62,    1,  256,  257,  258,  259,  260,
     6      4,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     7    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     8    281,  282,  283,  255,  262,  285,  286,  287,  288,  289,
     9    290,  291,  292,  293,  294,  295,  296,  297,  261,  286/
            data (jb1(i),i=  301,  400)/
     +    299,  300,  301,  302,  303,  304,  305,  306,  307,  262,
     1     32,  309,  311,  312,  313,  256,  260,  314,  315,  255,
     2    285,  260,  317,  310,  319,  310,  285,  319,  319,  323,
     3    324,  325,  326,  327,  328,  323,  322,  330,  322,  329,
     4    332,  317,  334,  314,  261,  336,  337,  338,  339,  340,
     5    333,  315,  256,  343,  344,  345,  346,  347,  286,  346,
     6    350,  351,  352,  353,  262,  346,  342,  350,  340,  355,
     7    345,  311,  358,  359,  360,  357,  361,   37,  363,  331,
     8    362,  365,  323,  335,  367,  342,  341,  357,  370,  371,
     9    372,  365,  373,  331,  329,  374,  376,  375,  378,  332/
            data (jb1(i),i=  401,  500)/
     +    379,  380,  334,  333,  377,  382,  381,  367,  369,  369,
     1    368,  349,  385,  355,  356,  387,  386,  388,  389,  388,
     2    392,  375,  392,  384,  372,  396,  397,  398,  362,  395,
     3    394,  400,  401,  402,  403,  404,  405,  406,  386,  408,
     4    395,  408,  378,  374,   41,  392,  413,  414,  415,  416,
     5    417,  418,  419,  420,  421,  422,  423,  412,  412,  410,
     6    426,  427,  428,  429,  430,  431,  432,  425,  377,  411,
     7    434,  383,  435,  437,  394,  385,  436,  380,  440,  441,
     8    442,  443,  406,  445,  447,  391,  390,  445,  449,  447,
     9    410,  451,  452,  453,  454,  455,  456,  457,  458,  459/
            data (jb1(i),i=  501,  600)/
     +    440,  444,  461,  462,  463,  464,  465,  437,  466,  446,
     1    396,  469,  470,  446,  472,  473,  474,  475,  476,  477,
     2    478,  479,  437,  411,  481,  471,  483,  483,  484,  485,
     3    486,  487,  488,  425,  466,  490,  491,  492,  493,  482,
     4    408,  496,  497,  483,  498,  499,  500,  501,  435,  495,
     5    410,  504,  471,  506,  507,  505,  444,  439,  509,  510,
     6    508,  494,  450,  447,  468,  513,  514,  511,  513,  517,
     7    518,  502,  504,  517,  495,   46,  521,  522,  523,  524,
     8    525,  526,  527,  528,  529,  530,  502,  494,  532,  533,
     9    534,  535,  536,  537,  538,  539,  540,  468,  542,  517/
            data (jb1(i),i=  601,  690)/
     +    543,  503,  544,  543,  505,  545,  546,  508,  511,  547,
     1    548,  512,  549,  541,  550,  552,  515,  552,  554,  551,
     2    556,  516,  558,  559,  560,  561,  557,  563,  564,  565,
     3    560,  555,  567,  568,  569,  570,  563,  553,   49,  573,
     4    542,  574,  546,  543,  576,  576,  575,  578,  548,  547,
     5    577,  580,  581,  579,  583,  550,  551,  585,  586,  582,
     6    584,  572,  572,  555,  557,  587,  589,  590,  591,  563,
     7    592,   51,  594,  573,  595,  574,  594,  596,  577,  578,
     8    581,  579,  583,  582,  588,  592,  591,  593,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
     1     17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
     2     27,   28,   29,   30,   31,   31,   33,   64,   64,   35,
     3     65,   65,   66,   67,   68,   69,   69,    5,   70,   71,
     4     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     5     82,   83,   83,   84,   85,   86,   87,   88,   89,   90,
     6     91,   92,   93,   94,   95,   96,   97,   98,   99,   99,
     7    100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
     8    110,  111,  112,  113,  114,  114,  115,  116,  117,  118,
     9    119,  120,  121,  122,  123,  124,  125,  125,  126,  127/
            data (jb2(i),i=  101,  200)/
     +    128,  129,  130,  131,  132,  133,  134,  135,  136,  137,
     1    138,  139,  140,  141,  142,  143,  144,  145,  146,  147,
     2    148,  149,  150,  151,  151,   38,  152,  153,  154,  155,
     3    156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
     4    166,  167,  168,  169,  170,  171,  172,  172,   40,  173,
     5    174,  175,  176,  177,  178,  179,  180,  181,  182,  183,
     6    184,  185,  186,  186,  187,  188,  189,  190,  191,  192,
     7    193,  194,  194,  195,  195,   44,   45,  196,  197,  198,
     8    199,  200,  201,  202,  203,  204,  205,  206,  206,   48,
     9    207,  208,  209,  210,  211,  212,  213,  214,  215,  216/
            data (jb2(i),i=  201,  300)/
     +    217,  217,   50,  218,  219,  220,  221,  222,  223,  224,
     1    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     2    235,  236,  237,  238,  239,  239,  240,  241,  242,  243,
     3    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     4    253,   53,  254,  254,   55,   56,   57,   58,   59,   60,
     5     61,   62,   63,   63,  255,  257,  258,  259,    2,    3,
     6    261,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  284,    5,    6,  287,  288,  289,  290,
     9    291,  292,  293,  294,  295,  296,  297,  298,  298,  299/
            data (jb2(i),i=  301,  400)/
     +    300,  301,  302,  303,  304,  305,  306,  307,  308,  308,
     1    309,  310,  312,  313,   33,  311,  314,  315,  316,  316,
     2    317,  318,  318,   34,  320,  320,  321,  321,  322,  324,
     3    325,  326,  327,  328,   35,  329,  330,  331,  332,  333,
     4    334,  334,  335,  335,  336,  337,  338,  339,  340,  341,
     5    341,  342,  343,  344,  345,   36,  347,  348,  348,  349,
     6    351,  352,  353,  354,  354,  350,  355,  356,  349,  356,
     7    357,  358,  359,  360,  361,  361,  362,  363,  364,  364,
     8    365,  366,  366,  367,  368,  368,  369,  370,  371,  372,
     9     38,  373,  374,  375,  376,  376,  377,  378,  379,  379/
            data (jb2(i),i=  401,  500)/
     +    380,  381,  381,  382,  382,  383,  384,  384,  383,  385,
     1    386,  387,  387,  388,  389,  389,  390,  390,  391,  391,
     2     39,  393,  393,  394,  395,  397,  398,  399,  399,  396,
     3    400,  401,  402,  403,  404,  405,  406,  407,  407,   40,
     4    409,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     5    418,  419,  420,  421,  422,  423,  424,  424,  425,  426,
     6    427,  428,  429,  430,  431,  432,  433,  433,  434,  434,
     7    435,  436,  436,  438,  438,  439,  439,  440,  441,  442,
     8    443,  444,  445,  446,  448,  448,  449,  450,  450,  449,
     9    451,  452,  453,  454,  455,  456,  457,  458,  459,  460/
            data (jb2(i),i=  501,  600)/
     +    460,  461,  462,  463,  464,  465,  466,  467,  467,  468,
     1    469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
     2    479,  480,  480,  481,  482,  482,   42,  484,  485,  486,
     3    487,  488,  489,  489,  490,  491,  492,  493,  494,  495,
     4    496,  497,   43,  498,  499,  500,  501,  502,  503,  503,
     5    504,  505,  506,  507,   44,  508,  508,  509,  510,  511,
     6    512,  512,  513,  514,  515,  515,  516,  516,  514,  518,
     7    519,  519,  520,  520,   45,  521,  522,  523,  524,  525,
     8    526,  527,  528,  529,  530,  531,  531,  532,  533,  534,
     9    535,  536,  537,  538,  539,  540,  541,  541,   47,  542/
            data (jb2(i),i=  601,  690)/
     +     48,  544,  545,  545,  546,  547,  548,  548,  549,  549,
     1    550,  550,  551,  552,  553,  553,  554,  554,  555,  556,
     2    557,  558,  559,  560,  561,  562,  562,  564,  565,  566,
     3    566,  567,  568,  569,  570,  571,  571,  572,  573,  574,
     4    574,  575,  575,  576,   50,  577,  578,  579,  579,  580,
     5    580,  581,  582,  583,  584,  584,  585,  586,  587,  587,
     6    588,  588,  589,  589,  590,  590,  591,  592,  593,  593,
     7    593,  594,  595,  595,  596,  596,   52,   53,   54,   55,
     8     56,   57,   58,   59,   60,   61,   62,   63,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine nv(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(330) :: jx,jy
            integer(kind=iknd), save, dimension(350) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'nevada        '/
            data jrot,ipart/0,1/
            data kv/   1, 326,   0,   0,   0/
            data kb/   1, 342,   0,   0,   0/
            data iib/  77,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  30288,16608,48384,11832,11808,15864,16920,48744,29352,21408,
     1  49200,37512,12624,40848,43104,47928,20952,11808,49368,49248,
     2  49032,48912,48960,48768,48288,48072,47976,47688,47736,47640,
     3  47328,47136,47064,46872,46704,46464,46440,46008,45768,45648,
     4  45408,45000,44856,44856,44976,44952,45072,44952,44928,45024,
     5  45024,45144,45216,45480,45216,45264,45168,45288,45240,45384,
     6  45360,45576,45576,45456,45576,45456,45432,45984,46128,46224,
     7  46176,45840,45720,45960,46008,45816,45840,30288,16488,16368,
     8  16368,16416,16584,16632,16632,16512,37464,36480,35472,35448,
     9  32880,32856,32880,32904,32880,32832,28560,28896,30288,28560/
            data (jx(i),i=  101,  200)/
     +  26496,26520,19608,19632,16800,16104,16224,16368,27096,21384,
     1  16944,16944,17064,17088,16968,16992,16872,16872,16776,25608,
     2  25584,25488,25488,25416,25536,25512,25752,25920,25992,25752,
     3  25704,25752,25800,25896,26088,26256,26424,26472,26352,26688,
     4  26784,26760,26904,27192,27312,27456,27432,27552,27408,27552,
     5  27408,27480,27360,27360,27408,27408,27504,27576,27552,27480,
     6  27336,19536,19536,19296,19320,19200,19200,19080,19080,18960,
     7  18984,18864,18864,18720,18720,18600,18600,18480,18480,18360,
     8  18384,18264,18264,18144,18144,18000,18000,17904,17904,17784,
     9  17784,17664,17664,17568,17568,17448,17448,17328,17376,17544/
            data (jx(i),i=  201,  300)/
     +  17568,17616,17640,17688,17760,17760,16416,16848,15312,15792,
     1  15888,16104,16368,13656,14040,15120,16368,15312,15192,14832,
     2  14712,14712,14496,14328,14136,14016,13824,13800,14040,14016,
     3  13896,13896,13824,13896,13944,13944,13992,13992,13872,13872,
     4  13752,13752,13632,37128,37128,37200,37344,37344,37584,37536,
     5  37680,37584,37608,37560,37680,37632,37752,37752,37704,37704,
     6  37632,37632,37512,37536,37464,37536,12696,12696,12816,12816,
     7  13104,13104,13272,13272,13392,13392,13680,28344,14640,13368,
     8  13320,13824,14016,14568,14568,14472,14568,15888,15768,15768,
     9  15432,15456,15336,15336,15456,15456,15576,15576,15936,15912/
            data (jx(i),i=  301,  330)/
     +  16032,16056,18480,18576,17880,17880,18528,25104,42840,37440,
     1  37344,42936,26088,22968,22968,29352,29016,28896,28872,21888,
     2  38448,38448,44688,44688,45288,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  61728,61872,47088,39528,39096,34416,33408,35640,21792,29208,
     1  21072,14160,62016,61800,61896,61992,61776,38232,15936,15840,
     2  15360,15288,15144,14616,14472,14544,14712,14832,14976,15144,
     3  15456,15504,15480,15336,15456,15336,15504,15504,15360,15408,
     4  15216,15120,15000,14904,14712,14616,14520,14376,14160,13992,
     5  13824,13728,13512,13272,13104,12936,12768,12384,11928,11760,
     6  11496,11184,11064,10968,10608,10440,10320, 9096, 8040, 7800,
     7   7392, 7320, 7200, 7008, 6888, 6624, 6360,53784,53640,53640,
     8  53976,55848,55848,57048,57264,57264,46920,46896,51096,53832,
     9  53808,39192,40872,40872,46440,46440,50016,50928,50952,51264/
            data (jy(i),i=  101,  200)/
     +  51288,52680,52752,53592,46008,46032,50160,50160,45888,45912,
     1  43104,43488,43488,44304,44304,44496,44496,45216,45216,38664,
     2  38736,38808,39024,39072,39144,39288,39408,39624,39864,40416,
     3  40752,40920,40968,40920,40992,41280,41304,41520,41592,41808,
     4  41928,42048,42048,42192,42144,42336,42696,42888,43056,43320,
     5  43512,43776,43872,43968,44160,44472,44568,44808,45072,45384,
     6  45480,38616,38904,38928,39144,39144,39264,39264,39384,39384,
     7  39480,39504,39600,39600,39840,39840,39960,39960,40080,40080,
     8  40176,40200,40296,40320,40440,40440,40560,40560,40680,40680,
     9  40776,40800,40896,40920,41016,41016,41136,41136,42192,42192/
            data (jy(i),i=  201,  300)/
     +  43128,43128,43680,43776,43800,43896,43032,43008,42816,42768,
     1  42840,42888,43104,40152,40272,40800,43032,42840,42624,42624,
     2  42576,42504,42456,42240,42168,42192,42312,41712,41688,41376,
     3  41376,41232,41232,41016,41016,40896,40896,40776,40800,40392,
     4  40392,40224,40224,39240,41640,41616,41664,41808,42192,42432,
     5  42672,43104,43344,43800,43944,44448,44616,44784,44856,45192,
     6  45336,45552,45816,46368,46560,46752,39552,39648,39720,39792,
     7  39840,39888,39888,40008,40008,40104,40104,39216,38808,38856,
     8  39072,39792,39696,39672,39552,39360,39192,35304,35304,36000,
     9  36000,36600,36600,37080,37080,37776,37776,37944,37944,38016/
            data (jy(i),i=  301,  330)/
     +  38016,38760,33384,36864,36864,37656,38640,38520,35496,20832,
     1  30408,30504,33744,37296,37944,30000,30360,30360,30528,29184,
     2  20856,20928,21048,20976,20976,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      4,    2,    1,   14,   15,    3,    2,    1,    3,    4,
     1      5,    6,    6,    7,    9,    8,   11,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   74,   75,   76,   12,    9,    1,   79,   80,
     8     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     9     78,   92,   93,   94,   95,   91,   97,   98,   78,   97/
            data (jb1(i),i=  101,  200)/
     +    100,  101,  102,  103,   79,  105,  106,  107,   79,   97,
     1     87,  109,  105,  111,  112,  113,  114,  115,  116,  117,
     2    118,  105,  120,  121,  122,  123,  124,  125,  126,  127,
     3    128,  129,  130,  131,  132,  133,  134,  135,  136,  137,
     4    138,  139,  140,  141,  142,  143,  144,  145,  146,  147,
     5    148,  149,  150,  151,  152,  153,  154,  155,  156,  157,
     6    158,  159,  160,  109,  162,  163,  164,  165,  166,  167,
     7    168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
     8    178,  179,  180,  181,  182,  183,  184,  185,  186,  187,
     9    188,  189,  190,  191,  192,  193,  194,  195,  196,  197/
            data (jb1(i),i=  201,  300)/
     +    198,  199,  200,  201,  202,  203,  204,  205,  111,  207,
     1    111,  209,  210,  211,  212,  207,  214,  215,  216,  207,
     2    209,  218,  219,  220,  221,  222,  223,  224,  225,  226,
     3    227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
     4    237,  238,  239,  240,  241,  242,  214,  244,  245,  246,
     5    247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
     6    257,  258,  259,  260,  261,  262,  263,  264,  265,   87,
     7      4,  267,  268,  269,  270,  271,  272,  273,  274,  275,
     8    276,  214,   92,  120,   92,  279,  280,  281,  277,  282,
     9    283,  284,  285,  286,  279,    6,  288,  289,  290,  291/
            data (jb1(i),i=  301,  350)/
     +    292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
     1    279,    7,  303,  304,  305,  306,  162,  162,  120,  244,
     2    309,  310,  311,  309,  313,  314,  308,    9,  316,  317,
     3    318,  313,   10,  313,  310,  321,  322,  323,  324,  325,
     4    310,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     13,   13,   14,   15,   16,   16,   17,   17,    8,    5,
     1     18,   18,    7,   10,   10,   11,   19,   20,   21,   22,
     2     23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
     3     33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
     4     43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
     5     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     6     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     7     73,   74,   75,   76,   77,   77,   12,   78,   80,   81,
     8     82,   83,   84,   85,   86,    2,   88,   89,   90,   91,
     9     91,   93,   94,   95,   96,   96,   98,   99,   99,  100/
            data (jb2(i),i=  101,  200)/
     +    101,  102,  103,  104,  104,  106,  107,  108,  108,  109,
     1      3,  110,  110,  112,  113,  114,  115,  116,  117,  118,
     2    119,  119,  121,  122,  123,  124,  125,  126,  127,  128,
     3    129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
     4    139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
     5    149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
     6    159,  160,  161,  161,  163,  164,  165,  166,  167,  168,
     7    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     8    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     9    189,  190,  191,  192,  193,  194,  195,  196,  197,  198/
            data (jb2(i),i=  201,  300)/
     +    199,  200,  201,  202,  203,  204,  205,  206,  206,  208,
     1    208,  210,  211,  212,  213,  213,  215,  216,  217,  217,
     2    218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
     3    228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
     4    238,  239,  240,  241,  242,  243,  243,  245,  246,  247,
     5    248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
     6    258,  259,  260,  261,  262,  263,  264,  265,  266,  266,
     7    267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
     8    277,  277,  278,  278,  244,  280,  281,    5,  282,  283,
     9    284,  285,  286,  287,  287,  288,  289,  290,  291,  292/
            data (jb2(i),i=  301,  350)/
     +    293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
     1    302,  303,  304,  305,  306,  307,  307,  308,  308,  309,
     2      8,  311,  312,  312,  314,  315,  315,  316,  317,  318,
     3    319,  319,  320,  320,  321,  322,  323,  324,  325,   11,
     4     12,    0,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine nh(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(590) :: jx,jy
            integer(kind=iknd), save, dimension(600) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'new hampshire '/
            data jrot,ipart/0,1/
            data kv/   1, 587,   0,   0,   0/
            data kb/   1, 596,   0,   0,   0/
            data iib/ 396,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  27408,38976,19344,40488,17736,42072,36864,26208,30288,30408,
     1  30384,30504,30360,30480,30240,30288,30240,30000,29976,30072,
     2  29904,29880,29712,29664,29184,29064,29280,29592,29880,29952,
     3  29880,30144,30192,30144,30240,30480,31008,30720,30624,30600,
     4  30648,30624,30240,30312,30336,30432,30792,31104,31344,30792,
     5  30960,30744,30888,31032,31344,31584,31824,31824,31704,31704,
     6  31824,32016,32208,32136,31632,31584,32208,32376,32472,32568,
     7  32760,32712,33072,33792,33864,34080,34224,34392,34680,35136,
     8  35352,35760,36072,36264,36408,36528,36456,36576,36840,38184,
     9  38808,27648,27816,28080,28296,28632,28680,28896,29016,29208/
            data (jx(i),i=  101,  200)/
     +  29136,29208,29280,29304,29424,29544,29808,29904,30000,29976,
     1  30096,30024,29856,30048,30144,29856,29808,29904,30312,30384,
     2  30480,30408,30456,30528,30672,30672,30624,30528,30504,30408,
     3  30432,40272,40536,40632,40608,19368,19272,19368,19344,19512,
     4  19536,19728,19680,19728,20112,20736,20904,21144,21144,21456,
     5  21384,21456,21384,21624,21576,21744,21960,22344,22368,22560,
     6  22632,22656,22752,22632,22416,22416,22344,22464,22536,22704,
     7  22608,22656,22776,22896,22872,23064,22992,23184,23256,23496,
     8  23328,23496,23520,23400,23280,23184,23208,23424,23328,23328,
     9  23136,22896,22992,23136,23016,22992,22896,22968,23328,23424/
            data (jx(i),i=  201,  300)/
     +  24168,24432,24888,25080,25248,25632,25872,26592,26688,26712,
     1  26928,40632,40560,40368,40560,40512,40584,40488,40296,40272,
     2  40320,40248,40488,40512,40608,40800,41160,41184,41448,41568,
     3  41688,41712,41640,41592,41736,41760,41928,42360,42624,42696,
     4  43008,43176,43056,43056,42912,42984,42912,42984,42984,42912,
     5  42768,42648,42552,42312,42096,42072,42336,42408,42336,42264,
     6  42168,42216,19152,18624,18576,18576,18336,18336,18600,18624,
     7  18504,18504,18312,18192,18192,18240,18504,18576,18336,18360,
     8  18528,18264,18192,17976,17904,17976,17880,17928,17760,17832,
     9  17760,37224,37848,37704,38016,38568,39624,39864,40104,41040/
            data (jx(i),i=  301,  400)/
     +  41880,42144,42360,42936,43464,43488,43392,43320,43176,43128,
     1  43272,43104,43248,43488,43512,43704,43680,43728,44040,44208,
     2  44352,44304,44400,44424,44544,44592,44736,44880,44880,44736,
     3  44616,44544,44352,44112,44088,44424,44448,44256,44328,44064,
     4  43704,43176,42816,42600,42600,42504,42576,42840,42936,42936,
     5  42768,42432,42144,41808,41688,41640,41688,41592,41784,41976,
     6  17928,17688,17544,17328,17064,17040,16704,16536,16440,16440,
     7  16296,16296,16368,16632,16752,16704,16608,16656,16848,17592,
     8  17664,17640,17928,17904,17664,17664,17568,17592,17928,18000,
     9  17928,18024,17736,30912,36120,36672,33408,33360,32952,32712/
            data (jx(i),i=  401,  500)/
     +  32880,32424,31992,31464,31440,30384,30168,28632,28464,33912,
     1  34056,34008,34200,34392,34560,34656,34656,34608,35328,37704,
     2  38544,38472,31512,31392,31296,30888,33960,33552,34056,33768,
     3  33504,33576,33576,31704,29784,29736,29784,29688,29760,29688,
     4  29784,29616,29592,29280,29016,28920,28848,28752,28608,28584,
     5  28824,28656,34680,35856,36360,36672,36744,36792,37392,28536,
     6  28392,28152,27888,27768,27648,27576,27480,27288,27288,26736,
     7  26112,25488,23424,23376,23064,22608,22800,21480,21192,37896,
     8  38208,38304,38376,38448,38496,38568,38640,38880,38952,39072,
     9  39120,39216,39240,39336,39600,36504,37608,36984,28752,28872/
            data (jx(i),i=  501,  590)/
     +  28992,29304,29256,29472,29736,29856,30096,30312,30264,30336,
     1  30288,30432,30528,30528,30648,30744,30816,31008,31176,31344,
     2  31320,31536,35496,36336,24528,24360,23712,23664,23856,23808,
     3  23232,23664,23976,24048,24600,24192,24384,24168,22008,22296,
     4  19584,19632,18912,18984,18072,18048,39912,39240,40680,41400,
     5  35472,35352,35184,34800,34296,34128,34344,33432,33336,33048,
     6  32856,32784,32424,32328,30432,29928,27024,26064,34680,33480,
     7  33960,34608,35016,34944,35016,35088,35136,35184,36600,24240,
     8  24144,23952,23952,24816,25440,25896,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  42360,40320,24984,24528,15600,14880, 7440, 6360,46656,46776,
     1  47112,47112,47232,47256,47400,47520,47712,47688,47736,47784,
     2  47832,48168,48288,48648,49392,49776,49944,50424,50664,50952,
     3  51216,51552,51744,51912,52224,52416,53208,53544,53784,53880,
     4  53928,54336,54816,54912,55128,55224,55344,55272,55536,55512,
     5  56136,56256,56688,56904,57120,57624,57888,58056,58224,58320,
     6  58536,59232,59616,59784,60144,60240,60288,60216,60264,60552,
     7  60672,60984,61128,61752,61656,61608,61200,61080,60744,60720,
     8  60624,60744,60648,60936,61320,61416,61608,61872,62016,49392,
     9  42384,42288,42456,42504,42600,42888,43008,43152,43536,43680/
            data (jy(i),i=  101,  200)/
     +  43848,43968,43992,43896,43920,44112,44160,44448,44448,44616,
     1  44520,44712,44904,45000,45264,45576,45744,45864,45888,46008,
     2  46032,46248,46272,46200,46296,46368,46488,46488,46584,46536,
     3  46656,25248,24984,24768,24624,25080,25344,25560,25680,25848,
     4  26112,26544,26784,27216,27720,28128,28440,28656,28896,29424,
     5  29760,30072,30576,30744,31080,31176,31560,31896,32376,32496,
     6  32640,32784,32856,32928,32928,33216,33408,33840,33864,33792,
     7  34008,34080,34056,34320,34512,34680,34824,34992,35256,35304,
     8  35448,35568,35736,35808,35712,35880,36096,36336,36672,36960,
     9  37200,37680,37920,38736,38976,39288,39408,39672,39984,40368/
            data (jy(i),i=  201,  300)/
     +  40704,40800,40824,40992,41040,40896,40872,41232,41376,41904,
     1  42144,24072,23712,23232,23064,22704,22488,22200,21960,21744,
     2  21480,21288,20784,20568,20496,20232,20232,20136,19944,19656,
     3  19584,19488,19464,19344,19320,19224,19176,18624,18552,18360,
     4  18216,17904,17544,17328,17160,16920,16320,16008,15816,15744,
     5  15816,16032,15888,15840,15912,15816,15672,15120,15096,15216,
     6  15192,15048,24792,24408,24144,23712,23160,23016,22752,22560,
     7  22104,21744,20520,20280,20136,19872,19824,19728,19344,19080,
     8  18864,18048,17880,17664,17472,17112,16776,16512,16272,15984,
     9  15816, 7512, 7368, 8472, 8880, 9168, 8904, 9768,10032,10272/
            data (jy(i),i=  301,  400)/
     +  10728,10704,10608,10224,10488,10896,10896,10776,10800,10896,
     1  11112,11304,11352,11040,11256,11424,11712,11856,12336,12984,
     2  13128,13272,13296,13416,13488,13800,13896,14136,14232,14352,
     3  14328,14400,14304,14280,14328,14472,14544,14592,14832,14952,
     4  15288,15624,15552,15600,15144,14904,14688,14640,14448,14304,
     5  14280,14448,14424,14304,14064,14208,14448,14568,14568,14856,
     6   6408, 6768, 7176, 7344, 7200, 7608, 7872, 8184, 8568, 8856,
     7   9192, 9432, 9648, 9984,10392,10776,11040,11184,11328,11640,
     8  11832,12048,12312,12480,12720,13056,13320,13416,13776,13968,
     9  14376,14712,15216, 6360, 6432, 7248,37104,37320,37536,38472/
            data (jy(i),i=  401,  500)/
     +  38496,39288,39480,39360,39528,39288,40344,40968,40872,37224,
     1  36624,36072,35856,36000,36000,36720,36984,36984,39288,39216,
     2  39288,40272,28848,29568,29592,31632,32232,34488,35520,35496,
     3  36096,36216,36552,27504,27192,27072,26880,26640,26160,25968,
     4  25800,25704,25440,25224,25200,25344,25344,25224,25200,25080,
     5  24888,24528,25968,25008,24888,24600,24648,24792,24384,24648,
     6  24576,24600,24264,24456,24384,24408,24240,24192,24072,25488,
     7  24672,23664,23928,24120,23592,23760,24096,24624,24720,25128,
     8  23736,23856,23760,23856,23760,23880,23760,24192,24144,24216,
     9  24168,24264,24168,24288,23280,18936,20496,23760,24336,24288/
            data (jy(i),i=  501,  590)/
     +  24024,23832,23568,23256,23136,22992,23088,22608,22584,22392,
     1  22392,22056,22008,21960,21984,21888,22056,22056,22272,22248,
     2  22344,22296,19656,18696,22128,21672,21744,21360,21120,20352,
     3  19200,17784,17784,17112,16392,15120,15792,16272,15120,16176,
     4  15672,15528,15552,15024,15072,15576,15960,14736,14808,15024,
     5  16464,16272,15768,14952,13584,13632,12960,13176,13680,13464,
     6  13608,13800,13728,14160,13776,15840,14952,16848,11496,11280,
     7   9048, 9024, 8544, 8376, 8208, 8256, 8208, 7968, 7704,15120,
     8  13992,12768,11208,11208, 7944, 7944,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
     1     19,   20,   21,   22,   23,   24,   25,   26,   27,   28,
     2     29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
     3     39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     4     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     5     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     6     69,   70,   71,   72,   73,   74,   75,   76,   77,   78,
     7     79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
     8     89,   90,    1,   92,   93,   94,   95,   96,   97,   98,
     9     99,  100,  101,  102,  103,  104,  105,  106,  107,  108/
            data (jb1(i),i=  101,  200)/
     +    109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
     1    119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
     2    129,  130,    9,    2,    2,  132,  133,  134,    4,    3,
     3    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     4    146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
     5    156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
     6    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     7    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     8    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     9    196,  197,  198,  199,  200,  201,  202,  203,  204,  205/
            data (jb1(i),i=  201,  300)/
     +    206,  207,  208,  209,  210,    1,    4,  212,  213,  214,
     1    215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
     2    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     3    235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     4    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     5    255,  256,  257,  258,  259,  260,  261,    6,    3,  263,
     6    264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
     7    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     8    284,  285,  286,  287,  288,  289,  290,    5,    7,  292,
     9    293,  294,  295,  296,  297,  298,  299,  300,  301,  302/
            data (jb1(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
     1    313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
     2    323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
     3    333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
     4    343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
     5    353,  354,  355,  356,  357,  358,  359,    6,    8,  361,
     6    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     7    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     8    382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
     9    392,    5,    8,  394,  395,    7,  397,  398,  399,  400/
            data (jb1(i),i=  401,  500)/
     +    401,  402,  403,  404,  405,  406,  407,  408,  409,  397,
     1    410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
     2    420,  421,  422,  423,  424,  425,  426,  427,  428,  429,
     3    430,  431,  432,  397,  423,  434,  435,  436,  437,  438,
     4    439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
     5    449,  450,  451,  423,  453,  454,  455,  456,  457,  458,
     6    452,  460,  461,  462,  463,  464,  465,  466,  467,  468,
     7    469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
     8    479,  459,  480,  481,  482,  483,  484,  485,  486,  487,
     9    488,  489,  490,  491,  492,  493,  494,  495,  496,  497/
            data (jb1(i),i=  501,  600)/
     +    459,  452,  499,  500,  501,  502,  503,  504,  505,  506,
     1    507,  508,  509,  510,  511,  512,  513,  514,  515,  516,
     2    517,  518,  519,  520,  521,  522,  496,  496,  472,  525,
     3    526,  527,  528,  529,  530,  531,  532,  533,  534,  536,
     4    537,  535,  536,  539,  540,  541,  542,  543,  544,  545,
     5    546,  524,  547,  548,  549,  550,  524,  551,  552,  553,
     6    554,  555,  556,  557,  558,  559,  560,  561,  562,  563,
     7    564,  565,  566,  567,  535,  557,  569,  570,  571,  572,
     8    573,  574,  575,  576,  577,  578,  579,  536,  580,  581,
     9    582,  583,  584,  585,  586,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
     1     20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
     2     30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
     3     40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     4     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     5     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     6     70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
     7     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     8     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     9    100,  101,  102,  103,  104,  105,  106,  107,  108,  109/
            data (jb2(i),i=  101,  200)/
     +    110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
     1    120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
     2    130,  131,  131,   91,  132,  133,  134,  135,  135,  136,
     3    137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
     4    147,  148,  149,  150,  151,  152,  153,  154,  155,  156,
     5    157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
     6    167,  168,  169,  170,  171,  172,  173,  174,  175,  176,
     7    177,  178,  179,  180,  181,  182,  183,  184,  185,  186,
     8    187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
     9    197,  198,  199,  200,  201,  202,  203,  204,  205,  206/
            data (jb2(i),i=  201,  300)/
     +    207,  208,  209,  210,  211,  211,  212,  213,  214,  215,
     1    216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
     2    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     3    236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
     4    246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
     5    256,  257,  258,  259,  260,  261,  262,  262,  263,  264,
     6    265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
     7    275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
     8    285,  286,  287,  288,  289,  290,  291,  291,  292,  293,
     9    294,  295,  296,  297,  298,  299,  300,  301,  302,  303/
            data (jb2(i),i=  301,  400)/
     +    304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
     1    314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
     2    324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
     3    334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
     4    344,  345,  346,  347,  348,  349,  350,  351,  352,  353,
     5    354,  355,  356,  357,  358,  359,  360,  360,  361,  362,
     6    363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
     7    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     8    383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
     9    393,  393,  394,  395,  396,  396,  398,  399,  400,  401/
            data (jb2(i),i=  401,  500)/
     +    402,  403,  404,  405,  406,  407,  408,  409,    1,  410,
     1    411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
     2    421,  422,    2,  424,  425,  426,  427,  428,  429,  430,
     3    431,  432,  433,  433,  434,  435,  436,  437,  438,  439,
     4    440,  441,  442,  443,  444,  445,  446,  447,  448,  449,
     5    450,  451,  452,  453,  454,  455,  456,  457,  458,  459,
     6    460,  461,  462,  463,  464,  465,  466,  467,  468,  469,
     7    470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
     8      3,  480,  481,  482,  483,  484,  485,  486,  487,  488,
     9    489,  490,  491,  492,  493,  494,  495,    4,  497,  498/
            data (jb2(i),i=  501,  600)/
     +    498,  499,  500,  501,  502,  503,  504,  505,  506,  507,
     1    508,  509,  510,  511,  512,  513,  514,  515,  516,  517,
     2    518,  519,  520,  521,  522,  523,  523,  524,  525,  526,
     3    527,  528,  529,  530,  531,  532,  533,  534,  535,  537,
     4    538,  538,  539,  540,  541,  542,  543,  544,  545,  546,
     5      5,  547,  548,  549,  550,    6,  551,  552,  553,  554,
     6    555,  556,  557,  558,  559,  560,  561,  562,  563,  564,
     7    565,  566,  567,  568,  568,  569,  570,  571,  572,  573,
     8    574,  575,  576,  577,  578,  579,    7,  580,  581,  582,
     9    583,  584,  585,  586,    8,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine nj(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1370) :: jx,jy
            integer(kind=iknd), save, dimension(1390) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'new jersey    '/
            data jrot,ipart/0,2/
            data kv/   1,1256,1362,   0,   0/
            data kb/   1,1276,1382,   0,   0/
            data iib/ 745, 106,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  36912,26592,39624,43608,41400,40896,41088,41232,41664,41688,
     1  41448,41280,41136,41832,41688,41736,42168,42240,42168,41976,
     2  41904,42216,42264,42504,42816,42936,43176,39792,39768,39912,
     3  40200,40464,40584,40800,22656,39480,39024,38784,38688,38400,
     4  38208,38016,37776,37512,37272,37656,37896,37992,38232,38520,
     5  38712,38808,38880,39048,39024,39144,39264,39576,39648,42000,
     6  42096,42312,42720,42984,43104,43128,43320,43224,42984,42840,
     7  42672,42504,42528,42768,42864,42936,43008,43104,43320,43392,
     8  43560,43560,43896,43920,44112,44064,44136,44064,43968,43752,
     9  43584,43392,43248,43368,43392,43656,43728,43680,43944,44040/
            data (jx(i),i=  101,  200)/
     +  43872,43656,43680,43584,43416,43296,43224,43200,43248,43152,
     1  43320,43440,43488,43440,43752,43800,43368,43080,43032,42792,
     2  42456,42384,42360,42672,42864,42960,43368,43584,43752,43824,
     3  43800,43704,43416,43128,42768,42456,42216,41904,41136,41064,
     4  40944,40848,40608,40344,40224,40152,27096,30816,24936,23520,
     5  18360,36336,18432,18192,18168,17952,17760,17352,17136,16872,
     6  16536,16248,16056,16008,16080,16656,16584,16680,16536,16848,
     7  16968,16920,16608,16512,16176,16104,16128,16368,16560,16920,
     8  17016,17208,17328,17496,17568,17808,32112,27528,27360,26616,
     9  26088,25872,25488,25392,25416,25512,25368,25272,25128,25056/
            data (jx(i),i=  201,  300)/
     +  24672,24192,24072,23880,23760,23472,23160,22896,22896,23064,
     1  23064,22944,23040,23016,22872,22656,22464,22416,21960,21672,
     2  21576,21744,21744,21480,21456,21048,20856,20760,20328,20352,
     3  20160,20064,19728,19680,19608,19488,19200,19032,18984,18912,
     4  18816,18552,27888,27936,27696,27528,27360,26976,26832,26592,
     5  26592,26544,26424,26424,26520,26448,26688,26976,27744,28176,
     6  28248,28224,27720,27648,27720,27984,28200,28176,28008,27960,
     7  28008,28176,28272,28272,28200,28272,28464,28680,28824,28704,
     8  28536,28416,28344,28392,28368,28440,29568,29808,29784,29664,
     9  29544,29784,29904,30120,30144,30072,30000,29832,29712,29736/
            data (jx(i),i=  301,  400)/
     +  30168,30264,30312,30240,30408,30336,30120,30000,30024,30144,
     1  30504,30936,31224,31176,30768,30792,30504,30600,30864,30912,
     2  31080,31032,31080,31224,31344,31512,31824,32184,32184,31968,
     3  32112,32160,32520,32712,32928,33192,33384,33888,33960,33840,
     4  33624,33240,33048,32976,32928,33000,33000,32640,32568,32736,
     5  32712,32400,32208,32040,36192,31248,30744,30456,30240,30024,
     6  29568,29520,29544,28968,28776,28656,28464,28296,28416,28056,
     7  27768,27648,27384,26976,26856,26640,26376,26280,26136,26160,
     8  26280,26520,26568,37656,26376,25824,25560,25536,25392,24840,
     9  24144,23688,23616,23904,23952,24336,24600,24720,24984,25056/
            data (jx(i),i=  401,  500)/
     +  24840,24552,24360,24336,24504,24528,24096,23880,23664,23064,
     1  22872,22560,22560,22824,22536,22440,22488,22848,22896,22872,
     2  22608,22512,22656,22704,22680,22512,44256,44712,45144,45168,
     3  44952,22632,22848,23184,23568,23928,24264,24792,24864,24888,
     4  24744,24936,25464,26040,26520,26808,26952,27480,27792,28032,
     5  28440,28680,28848,29880,30264,30552,30768,30840,36408,36672,
     6  36696,37272,37248,37320,37416,37440,37608,37752,38016,37968,
     7  38040,37944,37920,37968,38064,38328,38328,38496,38448,38472,
     8  37968,37944,37800,37824,37992,38064,38256,38328,38496,38664,
     9  38664,38808,38904,39120,39048,39168,39168,39336,39264,39288/
            data (jx(i),i=  501,  600)/
     +  39432,39600,39768,39864,39960,39960,40080,40200,40464,40296,
     1  40392,40560,40608,40824,40944,40944,40632,40584,40584,40848,
     2  40776,40800,40368,40368,40512,40392,40608,40704,40968,40944,
     3  40728,40728,41016,41184,41448,41304,40944,40944,41256,41304,
     4  41280,41352,41520,41856,41856,41760,41088,40776,40440,40392,
     5  40776,41040,41352,41496,41640,41736,41712,41808,41664,41736,
     6  41640,41448,41256,41232,41328,41616,41712,41856,41904,41784,
     7  41400,41376,41496,41304,41448,41664,41808,41904,42024,42216,
     8  42240,42384,42456,42456,42336,41952,41904,41712,41424,41424,
     9  41544,41640,42096,42600,42768,42648,42648,42456,42336,42216/
            data (jx(i),i=  601,  700)/
     +  42384,42216,42120,42048,41904,41952,41904,41760,41712,41832,
     1  41928,42024,42072,42360,42336,42408,42768,42744,43080,43128,
     2  43104,42984,42648,42384,42096,41976,41928,41904,41976,30528,
     3  30048,29784,29640,29232,29040,28920,28848,28560,28344,27720,
     4  27168,26448,25824,25200,25080,24624,24048,23640,23544,23688,
     5  23664,23352,23208,22656,22272,21696,21000,20424,20016,19752,
     6  18672,18840,32184,32016,32136,32424,32544,32760,32904,33072,
     7  33672,33888,33768,33912,33984,34176,34296,34296,34464,34512,
     8  34704,34968,35088,35112,34872,34968,34968,34560,34536,34368,
     9  34344,34536,35232,35784,36528,36456,36216,36216,36000,36024/
            data (jx(i),i=  701,  800)/
     +  35928,35712,35544,35280,35208,35280,35544,35616,35616,35688,
     1  35832,35904,36000,36024,36240,36288,36504,37200,36984,36840,
     2  37032,36768,36648,36504,36360,36288,36288,36480,36528,37488,
     3  37752,37944,37872,38160,38304,38376,38136,38016,36912,36648,
     4  36552,36552,36384,36384,36480,34608,30024,30240,30528,30864,
     5  31008,31104,31248,31656,32016,32040,32232,32328,32304,32184,
     6  38616,38736,38688,38424,38328,38496,38400,38376,38160,38280,
     7  38208,37944,37848,37584,37464,37200,37152,36576,36504,36360,
     8  36120,35976,35832,35760,35856,35832,35592,35424,34968,34728,
     9  34632,34608,34704,34944,34896,34776,38592,38736,39000,39240/
            data (jx(i),i=  801,  900)/
     +  39432,40320,40488,40920,40728,40848,40920,40872,40896,41064,
     1  41040,41112,41376,41472,41400,41304,41232,41208,41256,41184,
     2  41064,38760,38760,38904,39072,39096,39168,39336,27984,28320,
     3  28368,28536,28632,29016,29160,29112,29304,29304,29400,29352,
     4  29640,29688,40824,40992,40968,40968,41160,41256,41424,41616,
     5  41616,41736,41832,41856,41808,41856,42024,42216,42624,43080,
     6  43344,30744,33696,33840,33840,34152,34128,34416,34392,34200,
     7  34248,34128,34248,34344,34536,34656,35376,38400,38400,38232,
     8  38064,37848,37704,37536,37440,37536,37728,37608,37656,37632,
     9  37512,37320,37272,37152,36984,36984,36912,36960,36864,37152/
            data (jx(i),i=  901, 1000)/
     +  37032,37008,36912,29064,29472,30456,30624,40536,40512,40656,
     1  40824,40944,41064,41352,41280,37128,37680,37776,38088,38328,
     2  38448,39624,39816,40440,40656,36072,35904,35544,35496,35400,
     3  35256,35568,36192,36360,36336,36120,35952,35520,27744,27648,
     4  27072,26544,26352,25944,25560,25416,25008,24840,24096,23472,
     5  23400,23160,23088,35328,38112,38136,38328,38904,38952,39168,
     6  39696,30960,30816,30936,30912,30864,30744,30888,30816,30864,
     7  30744,30768,30984,31176,30864,30888,30816,31056,30744,30480,
     8  29928,29520,30384,34488,34320,34248,34416,34848,34968,35376,
     9  35448,35016,34824,34128,33672,33264,33144,32904,32640,30888/
            data (jx(i),i= 1001, 1100)/
     +  32112,32568,29328,29448,28272,28488,32472,32568,32784,32976,
     1  33192,33288,33792,34056,34224,34584,34848,35064,35016,39312,
     2  39144,39144,36624,36552,35472,33144,32760,33000,33024,33120,
     3  33240,33576,34008,35088,34968,30912,31008,31152,31056,31008,
     4  31080,31200,31368,31656,31632,31800,32328,32544,32616,32976,
     5  33840,34320,36384,38904,38976,39144,39264,39240,39312,39624,
     6  40008,40464,40704,40776,40848,41616,41688,42024,36864,36768,
     7  36600,36312,36360,36312,25104,25176,25320,25608,25704,25824,
     8  25656,25752,25680,26040,26424,26280,26328,26616,26688,26856,
     9  27240,27744,27936,28056,28728,29208,29472,29616,29736,29832/
            data (jx(i),i= 1101, 1200)/
     +  29976,30024,30672,28152,27912,27888,27744,27576,27264,27144,
     1  26352,26112,26064,25824,25608,25608,25560,25248,25200,24720,
     2  24696,24456,24528,24360,23952,23832,23688,23640,24912,22440,
     3  21888,21648,21480,21240,21000,20712,20496,20400,20256,20040,
     4  19584,19488,19392,19392,19272,19200,19152,18840,18936,18912,
     5  18840,31728,31920,32064,31992,32016,32112,32352,32448,32520,
     6  32664,32952,33480,33960,34032,34344,34416,34536,34800,35016,
     7  35160,35280,35520,35616,35664,35688,35784,35832,35784,35808,
     8  35928,36024,36048,35928,36048,36144,26256,24792,24816,24696,
     9  24744,24576,24672,24672,24552,24528,21768,20400,20088,19944/
            data (jx(i),i= 1201, 1300)/
     +  19896,19752,19560,19464,18816,18696,18672,18552,18696,18600,
     1  18720,18720,18600,18600,28512,28584,28488,28608,28440,28416,
     2  28464,28896,28968,29088,29424,29496,29664,29760,29928,29952,
     3  30192,30288,30384,30744,30936,31008,31224,31344,31728,31800,
     4  31896,32040,28296,28032,27864,27672,27384,27288,27312,27288,
     5  27312,27408,27360,27504,27552,34128,34032,34032,34248,34296,
     6  34272,38688,38616,38688,38760,36408,36384,36312,36264,36384,
     7  35832,35784,36024,36072,36048,36144,36144,36144,35760,35688,
     8  39312,39096,38952,38904,39024,39048,39240,39336,39480,39648,
     9  39840,39912,40344,40488,41088,41088,41328,41280,41568,41664/
            data (jx(i),i= 1301, 1370)/
     +  41832,41880,41856,41520,41088,40248,39816,39144,39096,39120,
     1  39264,39264,38784,38880,38928,38904,38808,38280,38424,38376,
     2  38208,38208,41232,41184,41184,41424,41400,41016,41064,41112,
     3  41112,41016,40224,40344,40344,40224,40104,40080,39912,39840,
     4  39792,39888,39960,39792,39648,39624,39744,41496,41472,41688,
     5  41736,41568,42096,42168,42216,42168,42120,42120,42192,42144,
     6  42072,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  58512,55968,56952,49200,47160,46536,46728,47016,47208,46944,
     1  46536,46320,45864,45912,46104,46200,46056,46104,46200,46296,
     2  46368,46512,46704,46728,47136,47112,48408,44592,44928,45528,
     3  45792,45816,45888,46224,44496,41184,41520,41592,42024,42264,
     4  42312,42264,41784,41760,41832,42096,42336,42528,42552,42432,
     5  42216,42216,42672,42984,43416,43656,43752,43848,43896,33624,
     6  33360,33192,33384,33312,33432,34128,35016,35088,34968,34992,
     7  35064,35280,35376,35232,35256,35376,35376,35256,35208,35256,
     8  35784,36168,37128,37920,38592,39072,39840,40032,40848,41376,
     9  41616,41760,41688,41472,41160,41160,41088,40848,40224,39312/
            data (jy(i),i=  101,  200)/
     +  38688,38640,38544,38376,38472,38304,38304,38424,38496,38736,
     1  38712,38760,38832,38880,39120,39432,39576,39432,39312,39288,
     2  39000,39048,39144,39408,39480,39600,39864,39816,39624,39624,
     3  40056,40152,40296,40344,40560,40608,40776,40824,41376,41376,
     4  41088,41088,41136,41328,41040,40944,38688,34440,30792,28416,
     5  26064,20784,16872,16944,17136,17376,17760,18192,18288,18528,
     6  18504,18312,18528,19128,19464,19512,19800,20352,20472,20856,
     7  21216,21336,21504,21696,21936,22296,22560,22824,22944,23424,
     8  24024,24216,24480,24504,24912,25464,14736,11976,11976,12336,
     9  12264,12312,12288,12360,12432,12528,12888,12912,12888,12768/
            data (jy(i),i=  201,  300)/
     +  12720,12768,12672,12624,12216,12096,12480,12576,12696,12744,
     1  12816,12912,13176,13320,13560,13632,13560,13848,14040,14232,
     2  14352,14472,14592,14664,14856,14856,14568,14616,14976,15192,
     3  15528,15888,15960,15936,15768,15768,16080,16200,16464,16560,
     4  16656,16680,11472,10680,10080, 9840, 9192, 8736, 8208, 7632,
     5   7032, 6936, 6864, 6768, 6600, 6432, 6360, 6384, 6576, 6744,
     6   6840, 6912, 6840, 6888, 7008, 7008, 7080, 7248, 7320, 7440,
     7   7488, 7392, 7440, 7560, 7728, 7776, 7680, 7776, 7680, 7440,
     8   7392, 7440, 7392, 7152, 6912, 6840, 7824, 8136, 8280, 8424,
     9   8712, 8808, 9216, 9456, 9600, 9720,10056, 9936,10152,10392/
            data (jy(i),i=  301,  400)/
     +  10488,10416,10104, 9864, 9552, 9432, 9336, 9072, 8688, 8784,
     1   9144, 9960,10344,10584,10464,10728,10776,10848,10896,11208,
     2  11304,10872,10824,10896,11208,11328,11976,12432,12552,12672,
     3  12720,12936,12984,13152,13656,13992,14160,14352,14616,14808,
     4  14736,14472,14568,14568,14448,14328,14208,13920,13992,14424,
     5  14520,14616,14616,14664,59016,62016,61776,61776,61704,61344,
     6  61224,61176,60936,60456,60120,59688,59520,59184,58848,58032,
     7  57696,57408,57072,56808,56640,56472,56376,56232,55920,55848,
     8  55872,56040,56040,58032,55704,55392,54960,54768,54648,54264,
     9  53976,53592,53232,53064,52800,52128,51864,51408,51024,50736/
            data (jy(i),i=  401,  500)/
     +  50376,50400,50328,50208,49968,49776,49104,48984,48672,48768,
     1  48384,48168,48072,47712,47160,46800,46656,46536,46440,46320,
     2  46056,45840,45624,45312,45192,45072,50592,51840,53496,53880,
     3  53928,44184,43944,43896,44136,44088,43944,43368,43152,42048,
     4  41328,40560,40224,40368,40128,39600,38904,38256,38160,38016,
     5  37488,36840,36624,35976,35256,35088,34848,34656,20808,20664,
     6  20400,20376,20520,20592,20544,20424,20400,20496,20304,20184,
     7  20040,19992,19752,19704,19800,19752,19896,20112,20280,20352,
     8  20712,20856,20976,21264,21168,21360,21432,21792,21888,21744,
     9  21984,22032,21912,22008,22200,22368,22488,22488,22752,22800/
            data (jy(i),i=  501,  600)/
     +  22776,22872,22848,23040,23112,23256,23424,23424,23592,23688,
     1  23904,24000,24216,24192,24384,24432,24480,24576,24600,24600,
     2  24768,24984,25080,25488,25776,26064,26280,26736,26832,26928,
     3  26952,27024,27168,27600,27744,27840,27864,27960,28008,28080,
     4  28296,28584,28896,29160,29232,29304,29280,29520,29544,29712,
     5  29784,29568,29520,29616,29616,29904,30024,30264,30456,30648,
     6  30720,30600,30672,30768,30960,30912,31008,30984,31080,31176,
     7  31224,31296,31440,31632,31704,31464,31416,31464,31248,31272,
     8  31536,31656,31896,31992,32016,31872,31944,31920,32112,32208,
     9  32256,32136,32064,32352,32304,31968,31224,30648,30024,29928/
            data (jy(i),i=  601,  700)/
     +  29544,29064,28416,26832,26472,26016,25944,25968,25848,25824,
     1  25728,25752,25872,27960,28368,28992,31032,31344,32424,32760,
     2  33024,33120,33120,32976,33048,33168,33312,33600,33696,34128,
     3  33984,33768,33744,33888,33840,33672,33360,33144,32904,32640,
     4  32568,32136,31536,31224,31128,30480,30264,29928,29664,28848,
     5  28656,28296,28248,28224,27888,27648,27480,27528,27480,27312,
     6  26472,26304,14832,15048,15168,15024,15168,15024,15024,15120,
     7  15048,15264,15552,15864,15888,15768,15768,15984,16152,16560,
     8  16656,16656,16584,16320,16128,16056,15984,15696,15456,15168,
     9  15000,15024,15624,15840,16320,16632,16728,16896,16944,17112/
            data (jy(i),i=  701,  800)/
     +  17160,17232,17208,17064,17568,17640,17712,17856,18216,18336,
     1  18336,18624,18624,18528,18504,18240,17976,18072,17928,17688,
     2  17568,17424,17232,17160,17304,17280,17016,16872,16728,17352,
     3  17640,18048,18408,18408,18504,18912,18840,19128,19176,19440,
     4  19584,19752,19968,20280,20304,55800,51792,51840,51984,51816,
     5  51528,51528,51648,51816,52032,52224,52392,52584,52728,52968,
     6  51480,51816,51888,52008,52152,52824,53304,53352,53424,53640,
     7  53832,53832,53904,53928,54048,54048,54216,54144,54192,54408,
     8  54504,54480,54312,54360,54648,54720,55008,55104,54888,54648,
     9  54648,54792,55176,55440,55608,55752,54288,54168,53688,53472/
            data (jy(i),i=  801,  900)/
     +  53400,53280,53424,53088,52608,52536,52392,52248,52176,52080,
     1  51576,51288,50976,50616,50544,50688,50640,50208,49944,49800,
     2  49752,51432,51288,51144,51240,51384,51408,51048,48984,49152,
     3  49272,49320,49392,49992,50088,50352,50448,50640,50664,51192,
     4  51336,51480,48984,49296,49512,48936,48624,48624,48744,48792,
     5  48504,48432,48480,48624,48768,48960,49176,49344,49464,49776,
     6  49560,47472,48336,47928,47736,47616,47424,46968,46728,46632,
     7  46392,46224,45864,45816,45840,46056,46320,51504,51576,51696,
     8  51720,51648,51768,51696,51144,50856,50736,50352,50256,49992,
     9  49608,49560,49392,49344,49176,48840,48648,48480,48360,48264/
            data (jy(i),i=  901, 1000)/
     +  48144,47976,47856,47928,47904,47616,47472,48312,48048,47808,
     1  47808,47952,48000,47928,47328,47784,47400,47424,47304,47472,
     2  47496,47088,46752,46704,46752,47064,46848,46656,46392,46416,
     3  44640,44808,45432,45960,46200,46056,46080,45888,48864,48576,
     4  48024,47232,47208,46872,46776,46656,46440,46248,45648,45336,
     5  45240,45072,44880,44568,44880,44712,44472,44592,44712,44688,
     6  44736,47088,46728,46656,46584,46344,46176,45840,45744,45648,
     7  45552,45480,45408,45120,44712,44640,44424,44280,43752,43608,
     8  42480,42744,40656,44232,44088,43848,43416,43008,42696,42600,
     9  42216,41976,41688,41016,40680,40536,40032,39648,39504,39504/
            data (jy(i),i= 1001, 1100)/
     +  39912,39816,40464,39792,39552,38832,38736,38400,38400,38184,
     1  38136,37992,37632,37608,37656,37416,37368,37248,36792,41136,
     2  40944,40296,37560,37344,36696,34152,35112,35232,35088,35064,
     3  35160,35232,35928,36528,36720,34416,34488,34728,34824,35064,
     4  35136,35160,35040,35016,34800,34776,34440,34392,34200,34128,
     5  32760,33048,34896,34848,34464,34296,33960,33720,33576,33504,
     6  33600,33552,33480,33264,33192,34128,33984,33768,25584,21744,
     7  21168,21120,20904,20880,30744,30816,30840,30768,30648,30480,
     8  30192,29952,29760,29568,29520,29304,29208,29136,29064,28704,
     9  28248,26136,25992,25968,26112,26088,25944,25752,25704,25464/
            data (jy(i),i= 1101, 1200)/
     +  25368,25272,24816,22008,22224,22440,22512,23352,23832,23952,
     1  24192,24336,24480,24672,24792,25152,25248,25632,25800,26256,
     2  26496,26688,27360,27528,27816,28056,28152,28344,21096,23328,
     3  23232,23304,23664,23736,23664,23856,23832,23928,23904,24240,
     4  24432,24624,24720,24960,25200,25200,25344,25584,25776,25944,
     5  26112,23952,23736,23352,22728,22584,22440,22344,22416,22248,
     6  22392,22248,21768,21648,21528,21288,21120,21192,21072,20808,
     7  20832,20736,20808,20616,20640,20832,20856,20808,20664,20544,
     8  20448,20472,20568,20784,20808,20736,19872,20832,20760,20712,
     9  20160,19488,19368,19104,18816,18576,20880,19344,19272,19296/
            data (jy(i),i= 1201, 1300)/
     +  19248,18936,18792,18552,18648,18432,18240,17976,17904,17592,
     1  17304,17136,17112,16944,17808,17448,17136,16704,16104,15552,
     2  15384,15264,15144,15072,15048,15120,15048,15096,15048,14928,
     3  14880,14952,14808,14904,14856,14760,14808,14736,14880,14736,
     4  14856,14904,15312,15048,13512,13320,13248,13176,12816,12672,
     5  12576,12528,12408,12384,12264,15048,15120,15216,15480,15432,
     6  15288,19680,19704,19800,19752,17616,17472,17496,17760,17736,
     7  17760,17856,18024,17952,17688,17616,17544,17472,17304,17424,
     8  20424,20016,19896,20040,20208,20472,20568,20928,21072,21408,
     9  21552,21744,22512,22968,23808,23976,24408,24720,24864,25248/
            data (jy(i),i= 1301, 1370)/
     +  25560,25488,25248,24600,23448,22056,21192,21384,21456,21528,
     1  21552,21408,20832,20904,20856,20688,20736,20784,20664,20568,
     2  20616,20760,25560,25584,25680,25680,25608,24312,24360,24336,
     3  24192,24216,23184,23184,23088,22920,22896,23064,22536,22488,
     4  22560,22680,22680,21912,21936,21840,21816,26328,26448,26328,
     5  26088,26160,30768,30888,30768,30648,30696,29808,29712,29544,
     6  29640,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      6,    7,    5,    5,    9,   10,   11,   12,   13,   14,
     1     15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
     2     25,   26,    4,   28,   29,   30,   31,   32,   33,    6,
     3     36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     4     46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
     5     56,   57,   58,   28,   60,   61,   62,   63,   64,   65,
     6     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     7     76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
     8     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     9     96,   97,   98,   99,  100,  101,  102,  103,  104,  105/
            data (jb1(i),i=  101,  200)/
     +    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     1    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     2    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     3    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     4     36,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     5    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     6    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     7    182,  183,  184,  185,  151,  188,  189,  190,  191,  192,
     8    193,  194,  195,  196,  197,  198,  199,  200,  201,  202,
     9    203,  204,  205,  206,  207,  208,  209,  210,  211,  212/
            data (jb1(i),i=  201,  300)/
     +    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     1    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     2    233,  234,  235,  236,  237,  238,  239,  240,  241,  153,
     3    188,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     4    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     5    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     6    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     7    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     8    292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
     9    302,  303,  304,  305,  306,  307,  308,  309,  310,  311/
            data (jb1(i),i=  301,  400)/
     +    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     1    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     2    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     3    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     4    352,  353,  187,    1,  355,  356,  357,  358,  359,  360,
     5    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     6    371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
     7    381,  382,    2,    3,    1,    2,  385,  386,  387,  388,
     8    389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
     9    399,  400,  401,  402,  403,  404,  405,  406,  407,  408/
            data (jb1(i),i=  401,  500)/
     +    409,  410,  411,  412,  413,  414,  415,  416,  417,  418,
     1    419,  420,  421,  422,  423,  424,  425,   35,    4,  427,
     2    428,  429,  430,    3,   35,  432,  433,  434,  435,  436,
     3    437,  438,  439,  440,  441,  442,  443,  444,  445,  446,
     4    147,  147,  448,  449,  450,  451,  452,  453,  454,  455,
     5    456,  457,  148,  152,  459,  460,  461,  462,  463,  464,
     6    465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
     7    475,  476,  477,  478,  479,  480,  481,  482,  483,  484,
     8    485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
     9    495,  496,  497,  498,  499,  500,  501,  502,  503,  504/
            data (jb1(i),i=  501,  600)/
     +    505,  506,  507,  508,  509,  510,  511,  512,  513,  514,
     1    515,  516,  517,  518,  519,  520,  521,  522,  523,  524,
     2    525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
     3    535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     4    545,  546,  547,  548,  549,  550,  551,  552,  553,  554,
     5    555,  556,  557,  558,  559,  560,  561,  562,  563,  564,
     6    565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
     7    575,  576,  577,  578,  579,  580,  581,  582,  583,  584,
     8    585,  586,  587,  588,  589,  590,  591,  592,  593,  594,
     9    595,  596,  597,  598,  599,  600,  601,  602,  603,  604/
            data (jb1(i),i=  601,  700)/
     +    605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
     1    615,  616,  617,  618,  619,  620,  621,  622,  623,  624,
     2    625,  626,  627,  628,   60,  148,  630,  631,  632,  633,
     3    634,  635,  636,  637,  638,  639,  640,  641,  642,  643,
     4    644,  149,  149,  646,  647,  648,  649,  650,  150,  150,
     5    652,  653,  654,  655,  656,  657,  658,  659,  660,  661,
     6    151,  187,  663,  664,  665,  666,  667,  668,  669,  670,
     7    671,  672,  673,  674,  675,  676,  677,  678,  679,  680,
     8    681,  682,  683,  684,  685,  686,  687,  688,  689,  690,
     9    691,  692,  693,  694,  695,  696,  697,  698,  699,  700/
            data (jb1(i),i=  701,  800)/
     +    701,  702,  703,  704,  705,  706,  707,  708,  709,  710,
     1    711,  712,  713,  714,  715,  716,  717,  718,  719,  720,
     2    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     3    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     4    741,  742,  743,  744,  152,    1,    2,  747,  748,  749,
     5    750,  751,  752,  753,  754,  755,  756,  757,  758,  759,
     6    746,  761,  762,  763,  764,  765,  766,  767,  768,  769,
     7    770,  771,  772,  773,  774,  775,  776,  777,  778,  779,
     8    780,  781,  782,  783,  784,  785,  786,  787,  788,  789,
     9    790,  791,  792,  793,  794,  795,  746,    3,  797,  798/
            data (jb1(i),i=  801,  900)/
     +    799,  800,  801,  802,  803,  804,  805,  806,  807,  808,
     1    809,  810,  811,  812,  813,  814,  815,  816,  817,  818,
     2    819,  820,  761,  822,  823,  824,  825,  826,  827,  821,
     3    829,  830,  831,  832,  833,  834,  835,  836,  837,  838,
     4    839,  840,  841,  747,  843,  844,  821,  843,  846,  847,
     5    848,  849,  850,  851,  852,  853,  854,  855,  856,  857,
     6    858,  859,  860,  861,  862,  863,  864,  865,  866,  867,
     7    868,  869,  870,  871,  872,  873,  874,  875,  876,  761,
     8    878,  879,  880,  881,  882,  883,  884,  885,  886,  887,
     9    888,  889,  890,  891,  892,  893,  894,  895,  896,  897/
            data (jb1(i),i=  901, 1000)/
     +    898,  899,  900,  901,  902,  829,  904,  905,  906,  862,
     1    843,  908,  909,  910,  911,  912,  913,  914,  915,  903,
     2    916,  917,  918,  919,  920,  921,  922,  923,  924,    6,
     3    903,  926,  927,  928,  929,  877,  931,  932,  933,  934,
     4    935,  936,  937,  877,  829,  939,  940,  941,  942,  943,
     5    944,  945,  946,  947,  948,  949,  950,  951,  952,  953,
     6    931,  954,  955,  956,  957,  958,  959,  960,   28,  862,
     7    962,  963,  964,  965,  966,  967,  968,  969,  970,  971,
     8    972,  973,  974,  975,  976,  977,  978,  979,  980,  981,
     9    982,  931,  984,  985,  986,  987,  988,  989,  990,  991/
            data (jb1(i),i= 1001, 1100)/
     +    992,  993,  994,  995,  996,  997,  998,  983, 1000, 1001,
     1    999,  983, 1003, 1004, 1005, 1006,  999, 1007, 1008, 1009,
     2   1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018,   36,
     3   1020, 1021, 1022, 1023, 1024, 1019, 1026, 1027, 1028, 1029,
     4   1030, 1031, 1032, 1033, 1034, 1019,  148, 1036, 1037, 1038,
     5   1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048,
     6   1049, 1026, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058,
     7   1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067,   60,
     8   1026, 1051, 1069, 1070, 1071, 1072, 1073,  149, 1075, 1076,
     9   1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086/
            data (jb1(i),i= 1101, 1200)/
     +   1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096,
     1   1097, 1098, 1099, 1100, 1101, 1102, 1104, 1105, 1106, 1107,
     2   1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117,
     3   1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127,
     4   1128, 1103, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136,
     5   1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146,
     6   1147, 1148, 1149, 1150, 1151, 1074, 1103, 1152, 1153, 1154,
     7   1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163, 1164,
     8   1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172, 1173, 1174,
     9   1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184/
            data (jb1(i),i= 1201, 1300)/
     +   1185, 1074, 1104, 1129, 1129, 1188, 1189, 1190, 1191, 1192,
     1   1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202,
     2   1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212,
     3   1213, 1214, 1187, 1215, 1216, 1217, 1218, 1219, 1220, 1221,
     4   1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231,
     5   1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240, 1241,
     6   1242, 1220, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250,
     7   1251, 1252, 1253, 1254, 1255,    1,    2,    3,    4,    5,
     8      1,    7,    8,    9,    7,   11,   12,   13,   14,   11,
     9     16,   17,   18,   19,   20,   21,   22,   23,   24,   16/
            data (jb1(i),i= 1301, 1390)/
     +     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     1     36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     2     46,   47,   48,   49,   50,   51,   26,   53,   54,   55,
     3     56,   53,   58,   59,   60,   61,   58,   63,   64,   65,
     4     66,   63,   68,   69,   70,   71,   68,   73,   74,   75,
     5     76,   73,   78,   79,   80,   81,   82,   78,   84,   85,
     6     86,   87,   84,   89,   90,   91,   89,   93,   94,   95,
     7     96,   93,   98,   99,  100,  101,   98,  103,  104,  105,
     8    103,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      7,    8,    8,    9,   10,   11,   12,   13,   14,   15,
     1     16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
     2     26,   27,   27,   29,   30,   31,   32,   33,   34,   34,
     3     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     4     47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
     5     57,   58,   59,   59,   61,   62,   63,   64,   65,   66,
     6     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     7     77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
     8     87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     9     97,   98,   99,  100,  101,  102,  103,  104,  105,  106/
            data (jb2(i),i=  101,  200)/
     +    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     1    117,  118,  119,  120,  121,  122,  123,  124,  125,  126,
     2    127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
     3    137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
     4    146,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     5    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     6    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     7    183,  184,  185,  186,  186,  189,  190,  191,  192,  193,
     8    194,  195,  196,  197,  198,  199,  200,  201,  202,  203,
     9    204,  205,  206,  207,  208,  209,  210,  211,  212,  213/
            data (jb2(i),i=  201,  300)/
     +    214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
     1    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     2    234,  235,  236,  237,  238,  239,  240,  241,  242,  242,
     3    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     4    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     5    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     6    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     7    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     8    293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
     9    303,  304,  305,  306,  307,  308,  309,  310,  311,  312/
            data (jb2(i),i=  301,  400)/
     +    313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
     1    323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
     2    333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
     3    343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
     4    353,  354,  354,  355,  356,  357,  358,  359,  360,  361,
     5    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     6    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     7    382,  383,  383,  384,  384,  385,  386,  387,  388,  389,
     8    390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
     9    400,  401,  402,  403,  404,  405,  406,  407,  408,  409/
            data (jb2(i),i=  401,  500)/
     +    410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
     1    420,  421,  422,  423,  424,  425,  426,  426,  427,  428,
     2    429,  430,  431,  431,  432,  433,  434,  435,  436,  437,
     3    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     4    447,  448,  449,  450,  451,  452,  453,  454,  455,  456,
     5    457,  458,  458,  459,  460,  461,  462,  463,  464,  465,
     6    466,  467,  468,  469,  470,  471,  472,  473,  474,  475,
     7    476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
     8    486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
     9    496,  497,  498,  499,  500,  501,  502,  503,  504,  505/
            data (jb2(i),i=  501,  600)/
     +    506,  507,  508,  509,  510,  511,  512,  513,  514,  515,
     1    516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
     2    526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
     3    536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
     4    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     5    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     6    566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
     7    576,  577,  578,  579,  580,  581,  582,  583,  584,  585,
     8    586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
     9    596,  597,  598,  599,  600,  601,  602,  603,  604,  605/
            data (jb2(i),i=  601,  700)/
     +    606,  607,  608,  609,  610,  611,  612,  613,  614,  615,
     1    616,  617,  618,  619,  620,  621,  622,  623,  624,  625,
     2    626,  627,  628,  629,  629,  630,  631,  632,  633,  634,
     3    635,  636,  637,  638,  639,  640,  641,  642,  643,  644,
     4    645,  645,  646,  647,  648,  649,  650,  651,  651,  652,
     5    653,  654,  655,  656,  657,  658,  659,  660,  661,  662,
     6    662,  663,  664,  665,  666,  667,  668,  669,  670,  671,
     7    672,  673,  674,  675,  676,  677,  678,  679,  680,  681,
     8    682,  683,  684,  685,  686,  687,  688,  689,  690,  691,
     9    692,  693,  694,  695,  696,  697,  698,  699,  700,  701/
            data (jb2(i),i=  701,  800)/
     +    702,  703,  704,  705,  706,  707,  708,  709,  710,  711,
     1    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     2    722,  723,  724,  725,  726,  727,  728,  729,  730,  731,
     3    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     4    742,  743,  744,  745,  745,  746,  747,  748,  749,  750,
     5    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     6    760,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     7    771,  772,  773,  774,  775,  776,  777,  778,  779,  780,
     8    781,  782,  783,  784,  785,  786,  787,  788,  789,  790,
     9    791,  792,  793,  794,  795,  796,  796,  797,  798,  799/
            data (jb2(i),i=  801,  900)/
     +    800,  801,  802,  803,  804,  805,  806,  807,  808,  809,
     1    810,  811,  812,  813,  814,  815,  816,  817,  818,  819,
     2    820,  821,  822,  823,  824,  825,  826,  827,  828,  828,
     3    830,  831,  832,  833,  834,  835,  836,  837,  838,  839,
     4    840,  841,  842,  842,  844,  845,  845,  846,  847,  848,
     5    849,  850,  851,  852,  853,  854,  855,  856,  857,  858,
     6    859,  860,  861,    4,  863,  864,  865,  866,  867,  868,
     7    869,  870,  871,  872,  873,  874,  875,  876,  877,  878,
     8    879,  880,  881,  882,  883,  884,  885,  886,  887,  888,
     9    889,  890,  891,  892,  893,  894,  895,  896,  897,  898/
            data (jb2(i),i=  901, 1000)/
     +    899,  900,  901,  902,  903,  904,  905,  906,  907,  907,
     1    908,  909,  910,  911,  912,  913,  914,  915,    5,  916,
     2    917,  918,  919,  920,  921,  922,  923,  924,  925,  925,
     3    926,  927,  928,  929,  930,  930,  932,  933,  934,  935,
     4    936,  937,  938,  938,  939,  940,  941,  942,  943,  944,
     5    945,  946,  947,  948,  949,  950,  951,  952,  953,   35,
     6    954,  955,  956,  957,  958,  959,  960,  961,  961,  962,
     7    963,  964,  965,  966,  967,  968,  969,  970,  971,  972,
     8    973,  974,  975,  976,  977,  978,  979,  980,  981,  982,
     9    983,  984,  985,  986,  987,  988,  989,  990,  991,  992/
            data (jb2(i),i= 1001, 1100)/
     +    993,  994,  995,  996,  997,  998,  999, 1000, 1001, 1002,
     1   1002, 1003, 1004, 1005, 1006,  147, 1007, 1008, 1009, 1010,
     2   1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020,
     3   1021, 1022, 1023, 1024, 1025, 1025, 1027, 1028, 1029, 1030,
     4   1031, 1032, 1033, 1034, 1035, 1035, 1036, 1037, 1038, 1039,
     5   1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049,
     6   1050, 1050, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059,
     7   1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1068,
     8   1051, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077,
     9   1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087/
            data (jb2(i),i= 1101, 1200)/
     +   1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097,
     1   1098, 1099, 1100, 1101, 1102, 1103, 1105, 1106, 1107, 1108,
     2   1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118,
     3   1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128,
     4    150, 1104, 1130, 1131, 1132, 1133, 1134, 1135, 1136, 1137,
     5   1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146, 1147,
     6   1148, 1149, 1150, 1151,  151,  152, 1152, 1153, 1154, 1155,
     7   1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163, 1164, 1165,
     8   1166, 1167, 1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175,
     9   1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185/
            data (jb2(i),i= 1201, 1300)/
     +   1186, 1186, 1187, 1187, 1188, 1189, 1190, 1191, 1192, 1193,
     1   1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202, 1203,
     2   1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213,
     3   1214,  153, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222,
     4   1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232,
     5   1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240, 1241, 1242,
     6    187, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251,
     7   1252, 1253, 1254, 1255,  188,    2,    3,    4,    5,    6,
     8      6,    8,    9,   10,   10,   12,   13,   14,   15,   15,
     9     17,   18,   19,   20,   21,   22,   23,   24,   25,   25/
            data (jb2(i),i= 1301, 1390)/
     +     27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
     1     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     2     47,   48,   49,   50,   51,   52,   52,   54,   55,   56,
     3     57,   57,   59,   60,   61,   62,   62,   64,   65,   66,
     4     67,   67,   69,   70,   71,   72,   72,   74,   75,   76,
     5     77,   77,   79,   80,   81,   82,   83,   83,   85,   86,
     6     87,   88,   88,   90,   91,   92,   92,   94,   95,   96,
     7     97,   97,   99,  100,  101,  102,  102,  104,  105,  106,
     8    106,    0,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine nm(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(450) :: jx,jy
            integer(kind=iknd), save, dimension(490) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'new mexico    '/
            data jrot,ipart/0,1/
            data kv/   1, 449,   0,   0,   0/
            data kb/   1, 482,   0,   0,   0/
            data iib/  49,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  31704,37584,20880,46800, 8064,54408, 7656, 7512,54528,54672,
     1  54720, 6984,49632,28152, 6816,20712,40488,13296, 8472,16416,
     2  24960,25008,44328,54456,54576,54264, 6288,13128,54720,54888,
     3  26160,26040,26016,26184,26112,26208,26064,26184,25992,25944,
     4  26040,26016,26208,26304,26304,26472,26712,26880,26880,35184,
     5  33576,32664,31152,31320,31608,31920,31992,31968,32088,32088,
     6  32040,31872,31776,31800,31896,31776,31776,31872,31872,31728,
     7  31824,31776,31848,31728,36432,36552,36672,36720,36672,36720,
     8  36672,36744,36624,36648,36600,36648,36792,36600,36576,36360,
     9  36576,36552,36408,36432,36576,36456,36432,36552,36696,36792/
            data (jx(i),i=  101,  200)/
     +  36864,37056,37344,37536,37464,37560,37488,37680,37560,37536,
     1  37416,19104,19248,19296,19320,19368,19416,19416,19488,19776,
     2  19872,20040,20256,20568,20640,20592,20616,20808,40296,40296,
     3  43584,24816,24744,29664,29664,46896,19008,35328,35952,36024,
     4  36264,36312,36240,36240,36024,36024,44256,44352,44328,44232,
     5  44256,44352,44256,44328,44328,44448,44208,44328,44352,44256,
     6  44136,44160,44016,44112,43944,43992,43872,43848,43752,43800,
     7  43704,43752,43800,43848,43704,43752,43704,43656,43656,43584,
     8  43608,43560,43656,43608,43632,21360,21480,29664,31152,31128,
     9  31032,31080,33696,33672,33816,34008,34224,34248,34416,34944/
            data (jx(i),i=  201,  300)/
     +  35136,29616,29352,28800,28800,28440,28320,28464,28488,28584,
     1  28584,29112,29112,29232,29232,29520,29520,29640,33648,36576,
     2  37536,37560,37992,38088,38400,38640,38976,39048,39120,39216,
     3  39240,44160,29640,29424,29808,30216,30024,33720,33696,44232,
     4  44328,44232,44256,44136,44208,44088,44136,44112,44040,44040,
     5  43944,44064,44016,44088,44160,44040,44136,44064,44160,44112,
     6  51840,51768,51888,51864,48576,48552,46896,29592,49896,51696,
     7  51864,46824,47136,49176,49896,12168,12288,18024,18048,18864,
     8  18864,22152,21864,37008,37032,46080,46080,23136,48168,48192,
     9  49920,29592,22080,21984,28224,28224,28128,26160,26040,25848/
            data (jx(i),i=  301,  400)/
     +  25872,23472,30312,30312,29592,28152,28176,27744,27744,27792,
     1  27840,46080,40104,40128,43608,43632,44448,44424,36816,36816,
     2  36984,13920,17880,49152,49416,49416,51072,51072,51888,51864,
     3  52680,52656,47520,46104,17688,17856,17880,17784,24480,25344,
     4  27456,27816,31992,28128,36816,40104,49200,28368,28392,30120,
     5  30936,30960,31968,40896,40920,43032,45936,45912,47568,36744,
     6  40008,40008,40176,40176,40128,51120,51120,49440,49416,48456,
     7  48408,48744,49128,49104,49464,49464,15336,15432,23352,28584,
     8  28368,33504,33504,36768,17856,17496,17376,17400,17496,17496,
     9  17448,17280,17304,17232,17088,17040,17136,17088,17088,16968/
            data (jx(i),i=  401,  450)/
     +  16872,16752,16488,16512,16464,16632,16560,16560,16488,16608,
     1  16608,16464,16416,28584,40464,36432,36480,36312,36312,36192,
     2  36216,36744,40536,40560,49560,48816,20808,20856,24168,24168,
     3  28272,28560, 8400, 8352,10008, 9984,10872,10728,10824,10752,
     4  13248,13320,13200,13344,15792,15816,13296,13224,    0,    0/
            data (jy(i),i=    1,  100)/
     +  60552,60504,60768,60552,51768,48744,41856,38328,41280,35112,
     1  28200,25224,13200,13200,21144,11280,13152,11472,61176,60888,
     2  60672,60624,60504,60696,55968,55968, 7392, 7200,22776,13272,
     3  13224,13104,13008,12960,12792,12768,12528,12456,12360,12264,
     4  12120,11976,11760,11736,11568,11424,11424,11232,11160,51192,
     5  52032,53280,53904,54216,54288,54456,54768,55128,55320,55488,
     6  55872,56280,56832,57120,57264,57240,57408,57408,57576,57912,
     7  58272,58872,59256,60000,53568,53664,53592,53760,54120,54456,
     8  54576,54840,55008,55224,55416,55608,55728,55920,56088,56328,
     9  56400,56616,56832,56952,57120,57312,57528,57672,57720,57696/
            data (jy(i),i=  101,  200)/
     +  57936,57960,57816,58008,58584,58920,59112,59664,59832,60120,
     1  60312,53424,57744,57744,58920,58896,58944,59136,59232,59424,
     2  59376,59592,59664,59856,59976,60120,60384,60576,53544,53136,
     3  53160,53232,51192,51120,50784,53184,51360,51216,51792,52056,
     4  52368,52488,52704,52896,53136,53256,50328,50352,50424,50400,
     5  50496,50544,50640,50664,50592,50688,50928,51000,51072,51168,
     6  51192,51432,51552,51696,51840,51912,51936,52176,52224,52320,
     7  52416,52464,52416,52536,52656,52752,52800,52824,52752,52752,
     8  52848,52920,52944,52968,53112,44640,51264,50448,50448,50976,
     9  51048,51144,51120,50880,50784,50784,50688,50808,50856,50880/
            data (jy(i),i=  201,  300)/
     +  50976,48792,49152,49392,49344,49344,49512,49512,50760,50760,
     1  50688,50688,50736,50736,50880,50856,50808,49752,49872,49848,
     2  49488,49440,49344,49248,49224,49032,48864,48744,48888,48912,
     3  48960,49008,49632,49752,49488,49488,49128,42000,47760,50280,
     4  50232,50208,50112,50088,50016,49968,49848,49848,49920,49776,
     5  49728,49656,49584,49632,49584,49512,49464,49392,49296,49224,
     6  48720,51168,51168,52008,51960,52800,52752,43680,45360,45384,
     7  45504,49032,49200,45672,45648,41664,44976,44760,45168,45144,
     8  44736,43848,44640,42000,43608,43656,42960,41376,44160,43920,
     9  43944,42024,41400,37800,40416,40632,40728,40800,40752,40512/
            data (jy(i),i=  301,  400)/
     +  40464,40536,40416,41184,41232,36384,37128,37128,37968,37968,
     1  40416,39528,35400,37824,37848,38664,38688,39528,35400,37872,
     2  37872,38016,37920,37896,37896,38736,38760,39576,39576,40392,
     3  40416,41256,37872,37872,27408,33936,34800,34824,37728,37272,
     4  36528,36312,34584,34656,34584,32952,35016,27240,28968,28848,
     5  28848,30504,30480,32952,32088,32088,32088,32904,32928,23856,
     6  23880,25560,25560,26376,26424,28104,28944,28944,30432,30456,
     7  32928,22344,22344,26424,26424,28080,24888,27504,27264,26376,
     8  26376,26352,25536,25512,19152,19320,19632,19944,20232,20616,
     9  20784,21048,21192,21408,21528,21888,22104,22248,22416,22392/
            data (jy(i),i=  401,  450)/
     +  22512,22512,22872,23040,23280,23640,23736,24168,24480,24576,
     1  24672,24744,24840,23184,18048,18072,21912,21936,22248,22248,
     2  22656,22656,18048,22272,18144,18144,19080,20736,20664,21072,
     3  22296,22296,21048,19392,19344,18528,18504,14352,14352,12288,
     4  12192,14280,14280,18432,18384,19176,11784,11784,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      5,   19,    3,    3,   21,    1,    1,    2,    4,    4,
     1     24,   25,    6,    5,    6,    7,    8,    9,   10,   12,
     2     15,   27,   18,   11,   29,   13,   14,   31,   32,   33,
     3     34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
     4     44,   45,   46,   47,   48,   16,   14,   13,   16,   50,
     5     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     7     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     8     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     9     91,   92,   93,   94,   95,   96,   97,   98,   99,  100/
            data (jb1(i),i=  101,  200)/
     +    101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
     1    111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
     2    121,  122,  123,  124,  125,  126,  127,  128,   75,  129,
     3    130,  112,  132,  133,  134,  136,  131,  112,   50,  138,
     4    139,  140,  141,  142,  143,  144,  145,   75,  147,  148,
     5    149,  150,  151,  152,  153,  154,  155,  156,  157,  158,
     6    159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
     7    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     8    179,  180,  181,  182,  183,  184,  131,  137,  186,  137,
     9    188,  189,  190,  191,  192,  193,  194,  195,  196,  197/
            data (jb1(i),i=  201,  300)/
     +    198,  199,  200,   50,  202,  203,  204,  205,  206,  207,
     1    208,  209,  210,  211,  212,  213,  214,  215,  216,  135,
     2    135,  188,  194,  219,  220,  221,  222,  223,  224,  225,
     3    226,  227,  228,  229,  230,  231,  233,  218,  218,  233,
     4    235,  236,  202,  238,  219,  147,  240,  241,  242,  243,
     5    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     6    254,  255,  256,  257,  258,  259,  232,  261,  261,  262,
     7    263,  264,  265,  266,  136,  202,  269,  270,  261,  232,
     8    272,  273,  274,  269,    7,  276,  277,  278,  279,  280,
     9    186,  282,  186,  268,  284,  285,  286,  282,  287,  289/
            data (jb1(i),i=  301,  400)/
     +    290,  269,  268,  238,  238,  288,  293,  295,  296,  297,
     1    298,  299,  300,  301,  288,  295,  303,  304,  292,  306,
     2    307,  308,  309,  310,  295,  287,  313,  314,  315,  316,
     3    317,  312,  319,  320,  284,    8,  322,  294,  324,  325,
     4    326,  327,  328,  329,  330,  331,  332,  324,  312,  333,
     5    335,  336,  337,  323,  294,  339,  340,  341,  306,  343,
     6    306,  313,  343,  319,  313,   10,  324,  348,  349,  350,
     7    351,  352,  343,  346,  354,  355,  356,  357,  358,  333,
     8    360,  361,  362,  363,  364,  346,  366,  367,  368,  369,
     9    370,  359,  366,  372,  373,  374,  375,  366,  377,  335/
            data (jb1(i),i=  401,  490)/
     +    335,  348,  380,  348,  380,  382,  383,  360,  377,  385,
     1    386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
     2    396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
     3    406,  407,  408,  409,  410,  411,  412,  377,  380,  415,
     4    416,  417,  418,  419,  420,  421,  360,  415,  423,  372,
     5     13,  425,  372,  427,  428,  429,  414,   14,  431,  414,
     6     15,  433,  434,  435,  436,  437,  438,  439,  440,  385,
     7    427,  441,  442,  443,  444,  445,  385,  415,   18,  447,
     8    441,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     19,   20,   20,   21,   22,   22,    2,   23,   23,   24,
     1     25,   26,   26,    7,    9,    8,   12,   10,   11,   15,
     2     27,   28,   28,   29,   30,   30,   31,   32,   33,   34,
     3     35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
     4     45,   46,   47,   48,   49,   49,   17,   17,   18,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   74,    1,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   97,   98,   99,  100,  101/
            data (jb2(i),i=  101,  200)/
     +    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     1      2,  113,  114,  115,  116,  117,  118,  119,  120,  121,
     2    122,  123,  124,  125,  126,  127,  128,    3,  129,  130,
     3    131,  132,  133,  134,  135,    4,  136,  137,  138,  139,
     4    140,  141,  142,  143,  144,  145,  146,  146,  148,  149,
     5    150,  151,  152,  153,  154,  155,  156,  157,  158,  159,
     6    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     7    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     8    180,  181,  182,  183,  184,  185,  185,    5,  187,  187,
     9    189,  190,  191,  192,  193,  194,  195,  196,  197,  198/
            data (jb2(i),i=  201,  300)/
     +    199,  200,  201,  201,  203,  204,  205,  206,  207,  208,
     1    209,  210,  211,  212,  213,  214,  215,  216,  217,  217,
     2    188,  218,  219,  220,  221,  222,  223,  224,  225,  226,
     3    227,  228,  229,  230,  231,  232,  234,  234,  233,  235,
     4    236,  237,  237,  239,  239,  240,  241,  242,  243,  244,
     5    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     6    255,  256,  257,  258,  259,  260,  260,    6,  262,  263,
     7    264,  265,  266,  267,  267,  268,  270,  271,  271,  272,
     8    273,  274,  275,  275,  276,  277,  278,  279,  280,  281,
     9    281,  283,  283,  282,  285,  286,  287,  288,  289,  290/
            data (jb2(i),i=  301,  400)/
     +    291,  291,  292,  292,  284,  293,  294,  296,  297,  298,
     1    299,  300,  301,  302,  302,  303,  304,  305,  305,  307,
     2    308,  309,  310,  311,  311,  312,  314,  315,  316,  317,
     3    318,  318,  320,  321,  321,  322,  323,  323,  325,  326,
     4    327,  328,  329,  330,  331,  332,    9,  333,  334,  334,
     5    336,  337,  338,  338,  339,  340,  341,  342,  342,  344,
     6    344,  319,  345,  345,  346,  347,  347,  349,  350,  351,
     7    352,  353,  353,  354,  355,  356,  357,  358,  359,  359,
     8    361,  362,  363,  364,  365,  365,  367,  368,  369,  370,
     9    371,  371,   11,  373,  374,  375,  376,  376,  378,  378/
            data (jb2(i),i=  401,  490)/
     +    379,  379,  381,  381,  382,  383,  384,  384,   12,  386,
     1    387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
     2    397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
     3    407,  408,  409,  410,  411,  412,  413,  413,  414,  416,
     4    417,  418,  419,  420,  421,  422,  422,  423,  424,  424,
     5    425,  426,  426,  428,  429,  430,  430,  431,  432,  432,
     6    433,  434,  435,  436,  437,  438,  439,  440,  441,  427,
     7     16,  442,  443,  444,  445,  446,  446,   17,  447,  448,
     8    448,    0,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ny(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1420) :: jx,jy
            integer(kind=iknd), save, dimension(1480) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'new york      '/
            data jrot,ipart/1,4/
            data kv/   1, 975,1276,1286,1414/
            data kb/   1,1031,1336,1347,1475/
            data iib/ 377, 284,  10, 128,   0/
            data (jx(i),i=    1,  100)/
     +  16632,20304,16584,21696,21552,21648,21240,21120,21072,20616,
     1  19080,18672,18504,18096,17904,17592,17448,17256,17160,16704,
     2  16704,16560,16440,16440,16536,16512,16656,26544,27696,27024,
     3  26568,26496,26520,26448,26448,26352,26328,26184,25992,25920,
     4  26136,26136,26208,26088,25848,25704,25464,25416,25200,25200,
     5  25272,25200,24984,24960,24936,25008,24984,24888,24960,25080,
     6  25224,25320,25200,25248,25128,24960,24840,24600,24720,24696,
     7  24456,24456,24384,24504,24456,24312,24432,24528,24552,24840,
     8  24864,24744,24456,24408,24288,24360,24336,24192,24216,24096,
     9  24072,23616,23520,23328,23256,23088,22992,22992,22944,22944/
            data (jx(i),i=  101,  200)/
     +  22728,22776,22656,22440,22056,21888,22008,21912,21792,21816,
     1  21768,29880,29592,29400,29208,29064,28992,28992,29064,29088,
     2  28944,28824,28608,28632,28560,28200,28248,28200,28104,28032,
     3  28056,27960,27912,27720,27720,28056,29880,29880,29976,29952,
     4  30072,32304,32184,32016,31848,31680,31416,31200,30648,29976,
     5  29880,30456,30456,30600,30696,30576,30480,30384,29976,30072,
     6  30216,30312,30480,30552,30528,30600,30600,30864,31248,30984,
     7  30960,30912,30864,30864,31032,31032,31080,31152,31320,31296,
     8  31392,31512,31416,31272,31128,31032,31032,30864,30864,30792,
     9  30864,31056,30912,30768,30720,30480,30576,33864,36504,41328/
            data (jx(i),i=  201,  300)/
     +  37536,41520,41664,41760,41832,41904,41928,41424,43176,45888,
     1  46776,47232,49152,50352,51336,51144,51024,51048,50928,50952,
     2  50736,50760,50520,50208,49464,48480,47832,51000,52008,51888,
     3  51912,51840,51864,51792,51960,51744,51456,51480,51360,16560,
     4  16536,16584,16656,16392,16632,16824,17160,17328,17832,18072,
     5  18264,18672,19056,19728,20088,20808,21192,21864,22728,22872,
     6  23328,23664,23808,24024,24480,24576,24792,25488,25992,26256,
     7  26424,32400,32736,32904,33048,33240,33312,33456,33720,34296,
     8  34416,34368,34440,34704,34800,35136,35208,35400,35496,35712,
     9  35880,36072,36312,26760,26928,27984,28152,28440,28584,28488/
            data (jx(i),i=  301,  400)/
     +  28128,28080,28248,28488,28632,28872,35520,35520,35040,34776,
     1  34776,41112,38832,38592,37632,37392,37392,37296,37080,37104,
     2  36768,36600,41136,43176,43008,43080,43032,43104,43056,42432,
     3  42312,42336,42144,42000,41952,41424,46800,46632,46704,46608,
     4  46680,46536,46368,46296,46344,46296,46104,46080,45960,45840,
     5  45672,45264,45144,45144,44712,44568,44376,44328,44064,43896,
     6  43848,43800,43680,43608,43512,43416,43248,46752,46968,47064,
     7  47280,47352,52440,52704,52872,52848,52368,16968,16968,23592,
     8  23616,24192,20400,20544,20832,20856,21024,21120,21264,21216,
     9  21360,19008,19008,20136,20136,23184,24240,21576,23832,24000/
            data (jx(i),i=  401,  500)/
     +  24144,24408,24600,24624,24720,24936,24936,25296,25296,25248,
     1  26040,25992,26760,26808,27624,24456,24624,26592,27168,25272,
     2  25680,26616,26496,26448,26616,26712,27480,27792,28296,29496,
     3  29904,30360,27336,30816,29112,29016,29016,28776,28680,28560,
     4  28080,27912,27672,27192,26928,26856,29376,30624,31056,31344,
     5  31488,31224,31248,30072,30264,30384,30552,30648,30864,31296,
     6  31320,31536,31296,31128,31008,31176,31176,30960,30960,30816,
     7  31032,31536,31440,31656,31584,31392,31872,31896,31728,31728,
     8  31632,31608,31320,31128,31176,31368,31584,31680,31584,31392,
     9  31416,31584,31704,31512,31464,31944,32040,32136,30744,30696/
            data (jx(i),i=  501,  600)/
     +  29376,31920,31920,31992,31968,32088,32328,32304,32376,32472,
     1  32736,32760,32688,32520,32496,32400,32376,32256,32280,32232,
     2  32304,32256,32304,32184,32280,32352,32400,32256,32328,32256,
     3  32208,32256,32280,32208,32328,34152,33000,31992,32088,32208,
     4  32280,32424,32520,32784,33072,33168,32832,32736,33240,33000,
     5  33216,33264,32856,32832,32064,36552,36120,35808,35304,35088,
     6  34752,34128,33696,31128,31200,31368,31584,32280,32520,32904,
     7  33408,33528,33648,33912,33600,33624,33312,33360,33432,33600,
     8  33600,33648,33696,33720,32976,33744,33816,33864,33744,33768,
     9  33840,34320,33960,33960,33624,33624,34224,34272,30672,30744/
            data (jx(i),i=  601,  700)/
     +  30840,30912,31248,31392,31344,31464,31536,31512,31560,32424,
     1  33024,34464,34488,34512,34560,32208,32112,32112,31992,32112,
     2  32064,32088,32280,32568,32808,32928,33168,33144,34056,34056,
     3  34656,34656,33528,33336,34944,34704,34680,34272,34968,34920,
     4  34368,34344,35064,35160,35232,32712,32664,32520,32424,32448,
     5  32328,32280,32064,31968,33840,34008,34296,34176,34704,34704,
     6  35280,35304,34416,34512,35328,35352,35040,34680,34704,33408,
     7  33360,33360,32760,32520,32496,32232,32136,35352,35016,34200,
     8  33936,35208,35232,34920,35112,35304,35400,35088,35664,35280,
     9  35736,35784,35640,35712,35976,36408,36504,36552,36624,36648/
            data (jx(i),i=  701,  800)/
     +  36720,36792,36768,37056,37056,37176,35280,35472,35544,35592,
     1  35832,35880,35856,35880,36624,36624,36552,36768,36480,33792,
     2  34368,34488,34464,35232,35232,36000,36048,36816,35304,35568,
     3  36096,36096,36864,36984,34896,34872,34152,37104,37128,36840,
     4  37200,37200,37224,36264,35712,35328,36792,36864,37080,37200,
     5  37320,37536,37608,37584,37656,37632,37488,37536,37488,37512,
     6  37440,37320,37344,37440,37320,37152,37176,37104,36984,35592,
     7  36648,37560,37680,37152,37152,36768,37272,37632,37680,37488,
     8  37584,37536,36912,37680,37872,37896,37848,37608,37944,37680,
     9  37056,36768,36312,36024,38400,38424,38424,38400,38448,38472/
            data (jx(i),i=  801,  900)/
     +  35856,36264,36696,37080,37272,37656,38376,38472,38688,38856,
     1  38880,38784,38784,38928,38352,39264,38928,38664,38424,37992,
     2  37632,37584,37296,37104,36288,35832,39216,39264,39216,38880,
     3  38832,38760,38736,38880,38688,38712,38400,38328,38328,38136,
     4  38208,37896,37848,37968,37608,37680,37584,38664,39432,39456,
     5  39456,39432,39456,38424,38616,38808,39360,39360,39264,39264,
     6  39168,39168,39624,39624,39480,39720,39840,39816,39720,39720,
     7  39336,39360,40272,39720,39792,39840,40272,40488,40224,38976,
     8  40824,40464,40272,39888,39696,39336,38736,38232,40944,41088,
     9  40488,40512,40368,41208,41784,40896,40680,40704,40512,40536/
            data (jx(i),i=  901, 1000)/
     +  41400,41736,38808,38808,39024,39024,39120,39336,39456,39504,
     1  39528,39696,39696,39768,39816,39912,39912,40056,40104,40272,
     2  40320,40320,41424,41832,41424,42024,41808,41208,41256,45360,
     3  44040,43608,42984,42624,41712,42984,44088,44904,45360,45312,
     4  45336,45000,45048,45240,45360,45432,45144,45216,45288,45240,
     5  45432,46632,46224,45864,46536,45888,45576,46128,46200,46272,
     6  46440,46584,47616,47400,46992,49128,48216,48120,47904,51168,
     7  51120,51240,51432,51840,53136,53208,53184,53328,53304,53376,
     8  53352,53424,53424,53496,53592,53616,53448,53448,53544,53496,
     9  53544,53616,53640,53688,53760,53712,53736,53808,53856,53784/
            data (jx(i),i= 1001, 1100)/
     +  53592,53448,53976,54024,54144,54192,53832,53112,53016,52920,
     1  52848,52608,52680,52752,52584,52440,52608,52488,52344,52296,
     2  52368,52224,52248,52152,52392,52224,52176,51936,52032,52008,
     3  51936,51984,51864,51864,51744,51888,51888,51816,51864,51816,
     4  51816,51864,52056,52152,52032,51528,51456,51360,51168,51168,
     5  51264,51168,51240,51408,51456,51384,50352,49728,49704,49536,
     6  49440,49368,49368,49320,49368,49584,49536,49416,49440,49488,
     7  49656,49656,49872,49872,49992,50016,50064,49944,50136,49920,
     8  49896,49752,49656,49752,50088,49872,49824,49728,49968,50160,
     9  50064,49992,49800,49848,50016,50136,50160,50016,50232,50544/
            data (jx(i),i= 1101, 1200)/
     +  50640,50568,50736,50736,50784,50880,51024,50880,50952,50904,
     1  50952,50784,50688,50352,50208,50208,50016,50184,50208,49944,
     2  49824,49872,49752,49680,49608,49488,49464,49392,49008,48936,
     3  49152,49032,48768,48792,48744,48912,48912,49296,49416,49632,
     4  49800,50208,50328,50352,50472,50448,50544,50520,50616,50472,
     5  50496,50664,50616,50712,50592,50592,50544,50520,50472,50520,
     6  50520,50688,50832,51144,51072,50976,50928,50856,51048,51216,
     7  51264,51144,51072,50856,50928,50664,50952,50928,50856,50928,
     8  51168,51216,51096,51120,51048,51120,51168,51240,51360,51072,
     9  51024,50928,50856,50760,50952,51192,51312,51192,51264,51384/
            data (jx(i),i= 1201, 1300)/
     +  51336,51120,51096,51216,51240,51120,51048,51000,51144,51456,
     1  51528,51912,51528,51432,51456,51600,51720,51960,51960,51816,
     2  51720,51912,52128,52512,52176,52056,52104,52080,52224,52200,
     3  52080,52032,52080,52032,52248,53304,52776,53064,53160,53424,
     4  53640,53832,53880,53904,53952,53928,53856,53856,53712,53712,
     5  53880,53856,53688,53640,53568,53448,53256,53400,53760,53688,
     6  53592,51408,51576,53208,53136,52920,52992,52992,52680,52416,
     7  52536,52656,53256,53304,53400,53592,53856,53784,53592,53616,
     8  53496,53400,53328,53160,53136,53472,53424,53040,52176,52176,
     9  52368,52536,53064,53352,53400,53640,53472,53328,53424,54024/
            data (jx(i),i= 1301, 1400)/
     +  54216,54576,54480,54312,54192,54240,54312,53760,53688,53592,
     1  53376,53472,53568,50448,50400,50328,50304,49320,49248,49056,
     2  49176,49272,49320,49392,49632,49584,49896,49632,49560,49584,
     3  49464,49440,49512,49464,49344,49224,49416,49512,49512,49728,
     4  49752,49680,49752,49656,49776,47904,47856,47904,47760,47592,
     5  47664,47760,47712,48744,48576,48504,48504,48576,25896,25824,
     6  25704,25632,25656,25944,25992,25944,25656,25776,25296,25224,
     7  25032,24912,24744,24720,24888,24936,25008,25080,25152,24600,
     8  24528,24528,24624,24672,23472,23568,23424,23376,22224,22296,
     9  22320,22488,22584,22272,21912,22248,22248,22176,22080,22776/
            data (jx(i),i= 1401, 1420)/
     +  22848,22776,22872,22800,22728,22704,22512,22416,22560,22488,
     1  22536,22656,22632,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  54624,62999,58800,47880,48048,48072,48384,48288,48072,48336,
     1  49896,50400,50520,51144,51192,51720,52128,52248,52608,53136,
     2  53496,53640,54000,54168,54240,54384,54480,62879,45624,45528,
     3  45408,45432,45336,45336,45216,45216,45048,45048,45216,45504,
     4  45432,45552,45624,45672,46080,46104,46032,46152,46344,46416,
     5  46416,46512,46560,46776,46608,46464,46416,46416,46344,46344,
     6  46152,45840,45792,45672,45624,45744,46056,46224,45960,45888,
     7  46056,45984,46032,45672,45600,45672,45408,45240,45288,45168,
     8  45072,45024,45096,44856,44976,44856,44712,44784,44712,44712,
     9  44640,45144,45408,45648,45648,46128,46248,46368,46368,46440/
            data (jy(i),i=  101,  200)/
     +  46752,46824,46848,47016,47448,47712,47712,47856,47856,47784,
     1  47784,43032,43392,43800,43944,44232,44256,44520,44712,45000,
     2  45408,45504,45576,45744,45576,45624,45648,45768,45672,45744,
     3  45840,45816,45888,45720,45648,45648,31632,32112,33408,33816,
     4  34512,28104,27744,27840,27792,27960,27912,27936,27912,30600,
     5  31200,42384,42456,42408,42456,42504,42504,42648,42888,34752,
     6  35256,35976,36240,36264,36144,36216,36288,36600,37272,38016,
     7  38304,39576,39744,40008,40464,40800,40728,40728,40896,40968,
     8  41064,41088,41112,41016,41016,40872,40968,41304,41472,41616,
     9  41712,41712,41736,41640,41952,42288,42312,63695,27144,27384/
            data (jy(i),i=  201,  300)/
     +  63263,32160,35640,40608,43152,46008,50760,62448,52080,62304,
     1  54576,62232,57888,60072,60792,60960,60960,61032,61128,61200,
     2  61224,61488,61584,61584,61104,62663,62208,59928,59904,60120,
     3  60240,60264,60408,60456,60720,60624,60624,60744,59808,54744,
     4  54960,55056,56904,62903,62855,62951,62951,62831,62711,62927,
     5  62999,62831,62855,62711,62807,63239,63311,63071,63215,63167,
     6  62759,62735,62639,62639,62472,62496,62687,62687,62903,62927,
     7  62807,28200,28056,28056,28152,28416,28608,28704,28728,28992,
     8  29016,28968,28944,29016,28968,28584,28368,28104,27744,27648,
     9  27624,27360,27192,63023,63047,62592,62663,62615,62831,62903/
            data (jy(i),i=  301,  400)/
     +  62951,63383,63455,63431,63695,63767,63767,63719,63599,63647,
     1  63695,22968,23112,23640,25224,25344,25440,25560,25752,25896,
     2  26448,27096,62376,51960,51912,51816,51696,51552,51360,51216,
     3  51120,51000,50832,50832,62496,62496,54288,54192,54048,53832,
     4  53664,53664,53520,53376,53208,53064,53088,52968,52968,52848,
     5  52848,52512,52632,52704,52608,52656,52560,52680,52656,52584,
     6  52368,52344,52392,52512,52536,52296,52248,54648,54648,54792,
     7  54960,54912,59640,59568,59352,59232,59328,54672,55128,55872,
     8  55776,55824,62280,62280,62064,61800,61632,61248,60984,60840,
     9  59568,59064,59208,59352,59424,50280,51960,58176,58488,57336/
            data (jy(i),i=  401,  500)/
     +  49656,50040,49920,49968,49920,49920,49608,49632,49344,49272,
     1  48360,47856,47760,48144,48216,53856,52584,62520,58728,57504,
     2  57024,57768,57888,58176,58368,58776,46680,46704,52320,48312,
     3  49680,58152,57768,61608,61344,61392,61440,61512,61464,61656,
     4  61944,62160,62184,62376,62376,62280,54360,53784,54720,58272,
     5  43848,43824,43080,59808,59928,59904,60024,60000,60216,60144,
     6  60384,60576,60744,60768,61056,61104,61176,61152,61296,61344,
     7  54744,55872,57144,57168,57768,57768,46872,46776,46512,46320,
     8  46296,46368,45768,45552,45504,45504,45600,45480,45288,45168,
     9  45120,45168,45096,44976,44880,31536,34440,47520,47664,47520/
            data (jy(i),i=  501,  600)/
     +  47952,46920,47040,47064,47232,47280,31536,28296,28656,28800,
     1  28896,29184,29280,29280,29400,29424,29808,29856,30000,30144,
     2  30192,30264,30408,30456,30600,30600,30744,30816,30864,30864,
     3  31032,31056,31200,31272,31368,31464,38280,54864,54720,54768,
     4  54624,54624,54408,54384,54480,42360,42360,42456,40824,39744,
     5  39744,34944,34968,34680,34992,42576,42456,42216,42168,42192,
     6  42312,42192,42216,61584,61680,61608,61704,61680,61776,61752,
     7  61584,61584,61488,61464,58584,55800,36048,36024,36120,36048,
     8  36024,36048,35856,36960,37584,37584,58608,62568,62687,62927,
     9  63023,34632,34656,34752,34776,34920,33912,33912,52512,52368/
            data (jy(i),i=  601,  700)/
     +  52320,52104,51984,52056,52104,52248,52416,52536,52560,52032,
     1  51624,51720,51672,51456,51456,47640,47712,48072,48168,48336,
     2  48408,48528,48624,48960,49032,49224,49272,49560,49608,50232,
     3  50280,54456,54600,54576,55152,51672,52128,52368,53568,53640,
     4  53736,58656,57600,57552,47424,47304,46968,46968,47016,47088,
     5  47088,46944,46944,46872,58848,59160,59448,59808,59856,59928,
     6  60312,60408,40776,40704,40704,45048,44928,44568,43968,43896,
     7  43896,43728,43704,43728,43872,43800,43872,61176,61320,61152,
     8  61344,60552,60648,60912,60984,57408,56376,55704,51168,51432,
     9  58104,47448,50328,50328,34560,34344,34104,34248,34224,34032/
            data (jy(i),i=  701,  800)/
     +  33960,33984,34080,33888,33984,33984,57648,57600,57336,57312,
     1  57480,57552,57720,58080,45096,43896,43896,27624,27288,37032,
     2  37152,37080,36912,36864,36696,36792,37488,37440,38592,38424,
     3  38304,38232,38208,31344,31440,31296,31320,31344,32328,42744,
     4  43080,42384,41136,41184,40944,40872,27816,27984,28080,28200,
     5  28224,28464,28464,28560,28704,28968,29232,29376,29400,29472,
     6  29472,29760,29856,29880,30024,30480,30720,31008,31224,55056,
     7  55272,54768,35952,36000,36360,36384,35232,35232,39816,39816,
     8  39648,39552,39600,40560,40536,40704,41160,41112,60648,60624,
     9  60792,60720,60816,61032,47568,45120,45936,46608,46608,57672/
            data (jy(i),i=  801,  900)/
     +  58200,58152,58008,57768,57744,57816,57576,57600,57696,57456,
     1  57096,56976,56808,56472,55392,50400,50520,50472,50640,50520,
     2  50496,50568,50712,50928,50952,51144,50712,50856,51096,51360,
     3  51600,51696,51792,51768,52080,52104,52392,52608,52848,52872,
     4  53088,53232,53376,53400,53976,54408,54528,42432,42384,42816,
     5  39816,40656,43344,44880,44880,45216,45144,44904,44904,44520,
     6  44520,44112,44088,43752,43752,42816,42696,42408,42408,42120,
     7  42096,40656,50376,47688,47736,48984,48984,56424,55896,56568,
     8  59832,59928,60144,60264,60480,60648,60552,60672,57336,58800,
     9  58992,59232,59232,59712,54360,55800,55944,56112,43344,43176/
            data (jy(i),i=  901, 1000)/
     +  43272,43104,45936,45984,46056,45960,45960,46104,46032,46080,
     1  46152,46224,46104,46104,46176,46128,46176,46200,46128,46176,
     2  46152,45984,50328,50472,62304,62280,61104,59856,59808,59616,
     3  59712,59616,59688,59520,59712,56400,55680,56832,57000,57096,
     4  57168,57672,57744,57744,58128,58512,58488,58704,58752,58896,
     5  58992,59448,59760,61992,59352,59352,56664,56304,54552,54504,
     6  54576,54504,59472,59592,59664,60048,59544,59544,59712,60288,
     7  60336,60480,59976,59832,63119,62975,62831,62424,62256,62208,
     8  62112,62064,61968,61800,61728,61680,61656,61536,61488,61416,
     9  61344,61344,61488,61200,61272,62136,62184,62136,61392,61008/
            data (jy(i),i= 1001, 1100)/
     +  60960,60984,60240,59928,59832,59856,60744,63479,63695,63791,
     1  64151,64391,64463,64919,64991,64895,65255,65663,65783,66023,
     2  66287,66359,66503,66527,66671,67031,67055,66911,67103,67319,
     3  67367,67463,67439,67535,67631,67727,67823,67823,67895,67967,
     4  68159,68183,67583,67487,67919,69095,69167,69071,69047,69407,
     5  69431,69551,69575,69263,69263,69431,71423,72623,72815,73031,
     6  73079,73055,72863,72791,72647,72695,72575,72551,72455,72407,
     7  72431,72191,71999,71855,71927,71903,71807,71783,71543,71327,
     8  71231,71303,71159,71015,70991,70871,70943,70583,70607,70199,
     9  70175,70271,70151,70031,70151,70079,69863,69791,69791,69647/
            data (jy(i),i= 1101, 1200)/
     +  69527,69407,69335,69431,69431,69383,68999,68615,68567,68327,
     1  68255,68231,68567,68807,69023,69167,69191,69287,69383,69287,
     2  69455,69671,69695,69479,69479,69599,69743,69719,70055,70463,
     3  70271,70463,70607,70439,70391,70055,69959,69647,69311,69167,
     4  68855,68399,68183,67727,67295,66863,66335,65567,65615,65303,
     5  65231,65351,65183,65159,65135,64991,65015,65135,65063,64943,
     6  64799,64871,64871,64727,64655,64655,64775,64799,64391,64583,
     7  64559,64343,64319,63719,63599,63263,63191,63311,63359,63503,
     8  63551,63503,63479,63383,63263,63095,63167,63095,62759,62999,
     9  62903,63047,63023,62687,62615,62783,62687,62615,62544,62544/
            data (jy(i),i= 1201, 1300)/
     +  62328,62304,62424,62424,62472,62544,62520,62424,61752,61608,
     1  61656,61680,61488,61224,61152,61104,61320,61272,61224,61200,
     2  60984,60960,60984,59712,59880,60048,60144,60264,60336,60384,
     3  60360,60552,60768,60840,60960,60360,59616,59304,59424,59184,
     4  59184,59472,59496,59376,59376,59856,59760,59952,59904,59976,
     5  60120,60216,60192,60096,60144,59976,60624,60960,61104,61104,
     6  61056,62855,62903,60312,60360,60264,60144,60072,59904,61296,
     7  61320,61152,61176,61080,61056,63167,62256,62280,62639,62807,
     8  63143,63623,64247,64343,64151,63911,64415,65639,67415,67223,
     9  66911,66407,65351,64391,63959,59064,58944,58968,58200,58104/
            data (jy(i),i= 1301, 1400)/
     +  57864,57840,58176,58464,58560,58608,58560,59064,60504,60648,
     1  60528,60456,60528,69239,69311,69287,69143,71615,71639,71351,
     2  71351,71231,71447,71519,71519,71615,70415,70415,70343,70175,
     3  70151,70199,70367,70415,70151,70103,69863,69839,69743,69863,
     4  69935,69959,70127,70175,70367,71879,72071,72143,72263,72575,
     5  72143,72023,71975,70895,70967,71087,70943,70799,44136,44424,
     6  44448,44544,44304,44712,44808,44880,45000,44784,45120,45360,
     7  45528,45504,45648,45528,45144,45120,45192,45144,45216,44760,
     8  44760,44616,44520,44568,44976,44976,45264,45120,46656,46584,
     9  46728,46632,46776,47208,47424,46896,46848,46872,46968,45912/
            data (jy(i),i= 1401, 1420)/
     +  45960,46104,46104,46224,46200,46344,46464,46440,46320,46296,
     1  46128,46104,45984,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
     1     14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
     2     24,   25,   26,    1,   29,   30,   31,   32,   33,   34,
     3     35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
     4     45,   46,   47,   48,   49,   50,   51,   52,   53,   54,
     5     55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
     6     65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
     7     75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
     8     85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
     9     95,   96,   97,   98,   99,  100,  101,  102,  103,  104/
            data (jb1(i),i=  101,  200)/
     +    105,  106,  107,  108,  109,  110,    4,  112,  113,  114,
     1    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     2    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     3    135,   29,  137,  138,  139,  140,  142,  143,  144,  145,
     4    146,  147,  148,  149,  150,  137,  152,  153,  154,  155,
     5    156,  157,  158,  112,  141,  160,  161,  162,  163,  164,
     6    165,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     7    175,  176,  177,  178,  179,  180,  181,  182,  183,  184,
     8    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     9    195,  196,  152,  215,  216,  217,  218,  219,  220,  221/
            data (jb1(i),i=  201,  300)/
     +    222,  223,  224,  225,  226,  212,  229,  230,  231,  232,
     1    233,  234,  235,  236,  237,  215,    1,  240,  241,  242,
     2      3,    3,  244,  245,  246,  247,  248,  249,  250,  251,
     3    252,  253,  254,    2,    2,  256,  257,  258,  259,  260,
     4    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     5     28,  142,  272,  273,  274,  275,  276,  277,  278,  279,
     6    280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
     7    290,  291,  292,  199,   28,  294,  295,  296,  297,  298,
     8    299,  300,  301,  302,  303,  304,  305,  198,  201,  307,
     9    308,  309,  310,  198,  200,  312,  313,  314,  315,  316/
            data (jb1(i),i=  301,  400)/
     +    317,  318,  319,  320,  321,  199,  200,  208,  201,  202,
     1    203,  204,  205,  206,  209,  324,  325,  326,  327,  328,
     2    329,  330,  331,  332,  333,  207,  210,  335,  208,  211,
     3    337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
     4    347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
     5    357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
     6    209,  210,  211,  368,  369,  370,  371,  213,  213,  214,
     7    228,  229,  373,  374,  375,  376,  239,    1,  378,  379,
     8    380,  381,    2,  383,  384,  385,  386,  387,  388,  389,
     9    390,    3,  392,  393,  394,  391,    4,  396,  391,  398/
            data (jb1(i),i=  401,  500)/
     +    399,  382,  396,  401,  402,  403,  404,  405,  406,  407,
     1    408,  409,  410,  411,  412,  413,  414,  382,  397,  416,
     2    418,  418,  400,  420,  421,  422,  423,  424,  425,  419,
     3    415,  427,   29,  397,  415,  429,  430,  432,  419,  434,
     4    435,  436,  437,  438,  439,  440,  441,  442,  443,  444,
     5    445,  418,  416,  447,  448,  432,  451,  452,  112,  432,
     6    454,  455,  456,  457,  458,  459,  460,  461,  462,  463,
     7    464,  465,  466,  467,  468,  469,  434,  449,  471,  472,
     8    473,  474,  475,  450,  477,  478,  479,  480,  481,  482,
     9    483,  484,  485,  486,  487,  488,  489,  490,  491,  492/
            data (jb1(i),i=  501,  600)/
     +    493,  494,  451,  137,  496,  141,  498,  499,  500,  430,
     1    477,  502,  503,  504,  505,  498,  496,  142,  508,  509,
     2    510,  511,  512,  513,  514,  515,  516,  517,  518,  519,
     3    520,  521,  522,  523,  524,  525,  526,  527,  528,  529,
     4    530,  531,  532,  533,  534,  507,  507,  171,  449,  538,
     5    539,  540,  541,  542,  543,  544,  546,  547,  152,  546,
     6    537,  550,  549,  552,  553,  554,  497,  556,  557,  558,
     7    559,  560,  561,  562,  546,  434,  564,  565,  566,  567,
     8    568,  569,  570,  571,  572,  573,  450,  545,  575,  552,
     9    577,  578,  579,  580,  581,  582,  583,  537,  585,  584/
            data (jb1(i),i=  601,  700)/
     +    575,  574,  588,  589,  590,  591,  592,  593,  594,  595,
     1    552,  536,  597,  592,  429,  599,  600,  601,  602,  603,
     2    604,  605,  606,  607,  608,  609,  610,  611,  612,  613,
     3    614,  498,  616,  617,  618,  619,  620,  621,  622,  623,
     4    624,  625,  626,  627,  628,  629,  630,  615,  632,  633,
     5    545,  632,  613,  636,  637,  638,  639,  640,  632,  587,
     6    642,  643,  645,  646,  647,  648,  649,  650,  651,  652,
     7    653,  477,  587,  655,  656,  657,  658,  659,  660,  661,
     8    549,  663,  664,  645,  666,  667,  668,  669,  670,  671,
     9    672,  673,  674,  675,  676,  451,  678,  679,  680,  574/
            data (jb1(i),i=  701,  800)/
     +    662,  682,  683,  684,  678,  644,  686,  687,  635,  689,
     1    615,  662,  692,  693,  689,  645,  592,  695,  696,  697,
     2    698,  699,  700,  701,  702,  703,  704,  705,  644,  707,
     3    708,  709,  710,  711,  712,  713,  691,  666,  715,  716,
     4    556,  718,  719,  584,  720,  721,  722,  723,  724,  725,
     5    726,  727,  665,  729,  730,  731,  732,  728,  718,  734,
     6    735,  736,  536,  734,  738,  706,  556,  740,  741,  742,
     7    743,  744,  745,  665,  718,  747,  748,  749,  750,  751,
     8    752,  753,  754,  755,  756,  757,  758,  759,  760,  761,
     9    762,  763,  764,  765,  766,  767,  768,  734,  635,  770/
            data (jb1(i),i=  801,  900)/
     +    771,  773,  774,  775,  728,  706,  777,  773,  779,  780,
     1    781,  782,  733,  779,  784,  785,  786,  787,  743,  201,
     2    789,  790,  791,  792,  793,  678,  692,  796,  715,  797,
     3    798,  795,  789,  691,  801,  802,  803,  804,  805,  806,
     4    807,  800,  800,  809,  810,  811,  812,  813,  814,  772,
     5    816,  817,  818,  819,  820,  821,  822,  823,  824,  825,
     6    689,  816,  827,  828,  829,  830,  831,  832,  833,  834,
     7    835,  836,  837,  838,  839,  840,  841,  842,  843,  844,
     8    845,  846,  772,  742,  848,  849,  779,  851,  850,  739,
     9    796,  854,  855,  856,  857,  858,  859,  860,  861,  862/
            data (jb1(i),i=  901, 1000)/
     +    863,  864,  853,  850,  866,  867,  868,  869,  870,  871,
     1    852,  816,  795,  874,  875,  876,  873,  878,  879,  814,
     2    881,  882,  883,  884,  885,  886,  887,  789,  878,  889,
     3    890,  891,  892,  881,  881,  773,  852,  895,  896,  897,
     4    878,  853,  899,  900,  901,  902,  797,  903,  904,  905,
     5    906,  907,  908,  909,  910,  911,  912,  913,  914,  915,
     6    916,  917,  918,  919,  920,  921,  922,  873,  923,  924,
     7    208,  925,  926,  927,  928,  894,  895,  930,  931,  932,
     8    933,  934,  894,  895,  936,  937,  938,  939,  940,  941,
     9    942,  943,  944,  945,  946,  947,  948,  949,  950,  930/
            data (jb1(i),i= 1001, 1100)/
     +    952,  953,  954,  952,  955,  930,  939,  957,  958,  959,
     1    960,  961,  962,  963,  964,  952,  963,  963,  214,  966,
     2    967,  968,  963,  228,  970,  971,  215,  239,  973,  229,
     3      1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     4     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     5     21,   22,   23,   24,   25,   27,   27,   29,   30,   31,
     6     32,   26,    1,   34,   35,   36,   37,   38,   39,   40,
     7     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     8     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     9     61,   62,   63,   64,   65,   66,   67,   68,   69,   70/
            data (jb1(i),i= 1101, 1200)/
     +     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     1     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     2     91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
     3    101,  102,  103,  104,  105,  106,  107,  108,  109,  110,
     4    111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
     5    121,  122,  123,  124,  125,  126,  127,  128,  129,  130,
     6    131,  132,  133,  134,  135,  136,  137,  138,  139,  140,
     7    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     8    151,  152,  153,  154,  155,  156,  157,  158,  159,  160,
     9    161,  162,  163,  164,  165,  166,  167,  168,  169,  170/
            data (jb1(i),i= 1201, 1300)/
     +    171,  172,  173,  174,  175,  176,  177,  178,  179,  180,
     1    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     2    191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
     3    201,  202,  203,  204,  205,  206,  207,  208,  209,  210,
     4    211,  212,  213,  214,  216,  217,  218,  219,  220,  221,
     5    215,  215,  223,  224,  225,  226,  227,  228,  229,  230,
     6    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     7    241,  242,  243,  244,  245,  246,  247,  248,  250,  251,
     8    252,  253,  254,  255,  256,  257,  258,  259,  260,  249,
     9    250,  263,  264,  265,  266,  267,  268,  269,  270,  271/
            data (jb1(i),i= 1301, 1400)/
     +    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     1    262,  262,  283,   28,   26,  285,  286,  287,  215,  288,
     2      1,  262,  290,  291,  292,  293,  294,  250,  249,  296,
     3    297,  298,  299,  300,   28,    1,    2,    3,    4,    5,
     4      1,    7,    8,    9,    6,    1,    1,    2,    3,    4,
     5      5,    6,    7,    8,    9,    1,   11,   12,   13,   14,
     6     15,   16,   17,   18,   19,   20,   21,   22,   11,   24,
     7     25,   26,   27,   24,   29,   30,   31,   29,   33,   34,
     8     35,   36,   37,   38,   39,   40,   33,   42,   43,   44,
     9     45,   46,   47,   48,   49,   50,   51,   52,   53,   54/
            data (jb1(i),i= 1401, 1480)/
     +     55,   56,   57,   58,   59,   42,   61,   62,   63,   64,
     1     65,   66,   67,   61,   69,   70,   71,   72,   69,   74,
     2     75,   76,   77,   74,   79,   80,   81,   82,   79,   84,
     3     85,   86,   87,   88,   89,   90,   91,   92,   93,   84,
     4     95,   96,   97,   98,   95,  100,  101,  102,  100,  104,
     5    105,  106,  107,  108,  109,  110,  111,  112,  113,  104,
     6    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     7    125,  126,  127,  115,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
     1     15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
     2     25,   26,   27,   27,   30,   31,   32,   33,   34,   35,
     3     36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     4     46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
     5     56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
     6     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     7     76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
     8     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     9     96,   97,   98,   99,  100,  101,  102,  103,  104,  105/
            data (jb2(i),i=  101,  200)/
     +    106,  107,  108,  109,  110,  111,  111,  113,  114,  115,
     1    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     2    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     3    136,  136,  138,  139,  140,  141,  143,  144,  145,  146,
     4    147,  148,  149,  150,  151,  151,  153,  154,  155,  156,
     5    157,  158,  159,  159,  160,  161,  162,  163,  164,  165,
     6    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     7    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     8    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     9    196,  197,  197,  216,  217,  218,  219,  220,  221,  222/
            data (jb2(i),i=  201,  300)/
     +    223,  224,  225,  226,  227,  227,  230,  231,  232,  233,
     1    234,  235,  236,  237,  238,  238,  240,  241,  242,  243,
     2    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     3    253,  254,  255,  255,  256,  257,  258,  259,  260,  261,
     4    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     5    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     6    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     7    291,  292,  293,  293,  294,  295,  296,  297,  298,  299,
     8    300,  301,  302,  303,  304,  305,  306,  306,  307,  308,
     9    309,  310,  311,  311,  312,  313,  314,  315,  316,  317/
            data (jb2(i),i=  301,  400)/
     +    318,  319,  320,  321,  322,  322,  202,  323,  323,  203,
     1    204,  205,  206,  207,  324,  325,  326,  327,  328,  329,
     2    330,  331,  332,  333,  334,  334,  335,  336,  336,  337,
     3    338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
     4    348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
     5    358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
     6    367,  212,  368,  369,  370,  371,  372,  372,  214,  228,
     7    239,  373,  374,  375,  376,  377,  377,  378,  379,  380,
     8    381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
     9    391,  392,  393,  394,  395,  395,  396,  397,  398,  399/
            data (jb2(i),i=  401,  500)/
     +    400,  400,  401,  402,  403,  404,  405,  406,  407,  408,
     1    409,  410,  411,  412,  413,  414,  415,  416,  417,  417,
     2     28,  419,  420,  421,  422,  423,  424,  425,  426,  426,
     3    427,  428,  428,  429,  430,  431,  431,  433,  433,  435,
     4    436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
     5    446,  446,  447,  448,  449,  450,  452,  453,  453,  454,
     6    455,  456,  457,  458,  459,  460,  461,  462,  463,  464,
     7    465,  466,  467,  468,  469,  470,  470,  471,  472,  473,
     8    474,  475,  476,  476,  478,  479,  480,  481,  482,  483,
     9    484,  485,  486,  487,  488,  489,  490,  491,  492,  493/
            data (jb2(i),i=  501,  600)/
     +    494,  495,  495,  496,  497,  497,  499,  500,  501,  501,
     1    502,  503,  504,  505,  506,  506,  507,  508,  509,  510,
     2    511,  512,  513,  514,  515,  516,  517,  518,  519,  520,
     3    521,  522,  523,  524,  525,  526,  527,  528,  529,  530,
     4    531,  532,  533,  534,  535,  535,  536,  537,  538,  539,
     5    540,  541,  542,  543,  544,  545,  547,  548,  548,  549,
     6    550,  551,  551,  553,  554,  555,  555,  557,  558,  559,
     7    560,  561,  562,  563,  563,  564,  565,  566,  567,  568,
     8    569,  570,  571,  572,  573,  574,  575,  576,  576,  577,
     9    578,  579,  580,  581,  582,  583,  584,  585,  586,  586/
            data (jb2(i),i=  601,  700)/
     +    587,  588,  589,  590,  591,  198,  593,  594,  595,  596,
     1    596,  597,  598,  598,  599,  600,  601,  602,  603,  604,
     2    605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
     3    615,  616,  617,  618,  619,  620,  621,  622,  623,  624,
     4    625,  626,  627,  628,  629,  630,  631,  631,  633,  634,
     5    634,  635,  636,  637,  638,  639,  640,  641,  641,  642,
     6    643,  644,  646,  647,  648,  649,  650,  651,  652,  653,
     7    654,  654,  655,  656,  657,  658,  659,  660,  661,  662,
     8    663,  664,  665,  666,  667,  668,  669,  670,  671,  672,
     9    673,  674,  675,  676,  677,  677,  679,  680,  681,  681/
            data (jb2(i),i=  701,  800)/
     +    682,  683,  684,  685,  685,  686,  687,  688,  688,  690,
     1    690,  691,  693,  694,  694,  692,  695,  696,  697,  698,
     2    699,  700,  701,  702,  703,  704,  705,  706,  707,  708,
     3    709,  710,  711,  712,  713,  714,  714,  715,  716,  717,
     4    717,  719,  199,  720,  721,  722,  723,  724,  725,  726,
     5    727,  728,  729,  730,  731,  732,  733,  733,  200,  735,
     6    736,  737,  737,  738,  739,  739,  740,  741,  742,  743,
     7    744,  745,  746,  746,  747,  748,  749,  750,  751,  752,
     8    753,  754,  755,  756,  757,  758,  759,  760,  761,  762,
     9    763,  764,  765,  766,  767,  768,  769,  769,  770,  771/
            data (jb2(i),i=  801,  900)/
     +    772,  774,  775,  776,  776,  777,  778,  778,  780,  781,
     1    782,  783,  783,  784,  785,  786,  787,  788,  788,  789,
     2    790,  791,  792,  793,  794,  794,  795,  797,  796,  798,
     3    799,  799,  800,  801,  802,  803,  804,  805,  806,  807,
     4    808,  808,  809,  810,  811,  812,  813,  814,  815,  815,
     5    817,  818,  819,  820,  821,  822,  823,  824,  825,  826,
     6    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     7    836,  837,  838,  839,  840,  841,  842,  843,  844,  845,
     8    846,  847,  847,  848,  849,  850,  851,  852,  853,  202,
     9    854,  855,  856,  857,  858,  859,  860,  861,  862,  863/
            data (jb2(i),i=  901, 1000)/
     +    864,  865,  865,  866,  867,  868,  869,  870,  871,  872,
     1    872,  873,  874,  875,  876,  877,  877,  879,  880,  880,
     2    882,  883,  884,  885,  886,  887,  888,  888,  889,  890,
     3    891,  892,  893,  893,  894,  203,  204,  896,  897,  898,
     4    898,  899,  900,  901,  902,  205,  903,  904,  905,  906,
     5    907,  908,  909,  910,  911,  912,  913,  914,  915,  916,
     6    917,  918,  919,  920,  921,  922,  206,  923,  924,  207,
     7    925,  926,  927,  928,  929,  929,  209,  931,  932,  933,
     8    934,  935,  935,  936,  937,  938,  939,  940,  941,  942,
     9    943,  944,  945,  946,  947,  948,  949,  950,  951,  951/
            data (jb2(i),i= 1001, 1100)/
     +    953,  954,  210,  955,  956,  956,  957,  958,  959,  960,
     1    961,  962,  211,  964,  965,  965,  212,  213,  966,  967,
     2    968,  969,  969,  970,  971,  972,  972,  973,  974,  974,
     3      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     4     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     5     22,   23,   24,   25,   26,   28,   29,   30,   31,   32,
     6     33,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     7     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     8     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     9     62,   63,   64,   65,   66,   67,   68,   69,   70,   71/
            data (jb2(i),i= 1101, 1200)/
     +     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     1     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     2     92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
     3    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     4    112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
     5    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     6    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     7    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     8    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     9    162,  163,  164,  165,  166,  167,  168,  169,  170,  171/
            data (jb2(i),i= 1201, 1300)/
     +    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     1    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     2    192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
     3    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     4    212,  213,  214,  216,  217,  218,  219,  220,  221,  222,
     5    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     6    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     7    242,  243,  244,  245,  246,  247,  248,  249,  251,  252,
     8    253,  254,  255,  256,  257,  258,  259,  260,  261,  261,
     9    263,  264,  265,  266,  267,  268,  269,  270,  271,  272/
            data (jb2(i),i= 1301, 1400)/
     +    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     1    282,  283,  284,  284,  285,  286,  287,   27,  288,  289,
     2    289,  290,  291,  292,  293,  294,  295,  295,  296,  297,
     3    298,  299,  300,  301,  301,    2,    3,    4,    5,    6,
     4      7,    8,    9,   10,   10,    6,    2,    3,    4,    5,
     5      6,    7,    8,    9,   10,   10,   12,   13,   14,   15,
     6     16,   17,   18,   19,   20,   21,   22,   23,   23,   25,
     7     26,   27,   28,   28,   30,   31,   32,   32,   34,   35,
     8     36,   37,   38,   39,   40,   41,   41,   43,   44,   45,
     9     46,   47,   48,   49,   50,   51,   52,   53,   54,   55/
            data (jb2(i),i= 1401, 1480)/
     +     56,   57,   58,   59,   60,   60,   62,   63,   64,   65,
     1     66,   67,   68,   68,   70,   71,   72,   73,   73,   75,
     2     76,   77,   78,   78,   80,   81,   82,   83,   83,   85,
     3     86,   87,   88,   89,   90,   91,   92,   93,   94,   94,
     4     96,   97,   98,   99,   99,  101,  102,  103,  103,  105,
     5    106,  107,  108,  109,  110,  111,  112,  113,  114,  114,
     6    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     7    126,  127,  128,  128,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine nc(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(3220) :: jx,jy
            integer(kind=iknd), save, dimension(3330) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'north carolina'/
            data jrot,ipart/1,2/
            data kv/   1,2719,3221,   0,   0/
            data kb/   1,2820,3322,   0,   0/
            data iib/1331, 502,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  23208,25176,23736,23736,23640,23784,24720,23376,25104,23112,
     1  23856,25536,26136,23448,26016,23952,23976,23976,23880,23832,
     2  25368,27384,26304,28176,27936,28704,28752,29016,30768,30960,
     3  31200,30648,31944,32352,31440,33432,31968,31992,32160,32088,
     4  32184,32352,32520,32688,32592,32616,32760,32664,32616,32664,
     5  32784,33048,32928,32928,32832,32880,32856,32928,33096,33096,
     6  32976,33024,33168,33168,33336,33288,33192,33384,33432,33384,
     7  33432,33528,33672,33576,33600,33720,33840,33792,33864,33600,
     8  33504,33432,33408,33288,33360,33624,33648,33528,33408,33384,
     9  33336,33312,33216,33192,33048,33072,33024,33192,33408,33528/
            data (jx(i),i=  101,  200)/
     +  33480,33504,33648,33672,33816,33864,33816,33864,33888,33960,
     1  33912,33984,33960,33864,33528,33480,33384,33456,33624,33624,
     2  33744,33720,33792,33792,33912,34008,33528,33600,33768,33840,
     3  33960,33936,34032,33936,32376,36528,34728,34944,36120,36192,
     4  37536,36288,36456,36576,36648,39624,36744,37704,37752,37752,
     5  39624,37920,38088,36768,39480,39600,42360,42192,42144,42072,
     6  41976,42000,41928,41832,41760,41616,41640,41568,41544,41448,
     7  41304,41256,41352,40968,41016,40896,40848,40944,40800,40680,
     8  40320,40152,40296,40128,39720,39720,39960,39864,39864,40032,
     9  40104,40296,40248,40320,40320,40368,40368,40656,40704,40728/
            data (jx(i),i=  201,  300)/
     +  41040,41040,41208,41136,41232,41112,41208,41280,41256,41424,
     1  41472,41280,40896,40824,40704,40536,40584,40656,40440,40344,
     2  40296,40248,40080,40080,40344,40296,40224,40152,39912,39792,
     3  39600,41184,43776,44088,44904,47208,23016,23304,23232,23304,
     4  23304,23376,23448,23472,24048,24048,24000,24024,24216,24144,
     5  24192,24648,24624,24456,24480,24240,24168,24072,24120,24552,
     6  24768,25464,25896,26112,26400,26448,26592,26688,26784,26808,
     7  27000,27168,27240,27024,26832,26424,26040,25800,25728,25704,
     8  25728,25632,25608,25440,25392,25296,25368,25320,25104,25200,
     9  23304,24000,25200,25032,24744,24648,24072,23736,23592,25368/
            data (jx(i),i=  301,  400)/
     +  25464,25008,24984,26424,26544,26448,26712,27000,26904,26736,
     1  26664,26712,26784,26808,26664,26424,26472,26400,26352,26304,
     2  26136,26088,26184,26136,26184,26088,26088,25992,25800,25632,
     3  25368,25512,25848,25824,25752,25656,25800,26088,26184,24744,
     4  24792,25032,25128,25392,25728,25848,25224,25296,25392,25368,
     5  25440,25440,25584,25752,25776,25968,26136,26016,26208,26160,
     6  26280,26304,26424,26448,26544,26376,26136,25944,25872,25632,
     7  25440,25416,25440,25344,25248,27480,27120,27408,27336,27264,
     8  27216,27216,27048,27048,26736,26520,26376,26640,26520,26784,
     9  26880,26880,27048,27000,27072,27240,27120,26976,26760,26544/
            data (jx(i),i=  401,  500)/
     +  26568,26424,26160,27768,27768,27528,27552,27600,27960,28104,
     1  28080,27720,27600,27792,27864,27912,27768,27456,27288,27240,
     2  26808,26328,25776,25632,27912,27552,27552,27432,27648,27720,
     3  27648,27792,27792,28032,28800,28704,28320,28464,28656,28704,
     4  28704,28776,28800,28584,28272,28224,28224,27936,27600,27456,
     5  26928,26424,26136,26136,28776,30696,30672,30768,30744,30840,
     6  30888,30864,30912,30840,30696,30672,30360,30168,30192,30120,
     7  30048,29952,29904,29928,30096,30000,30072,30096,29784,29592,
     8  29424,29232,29064,29064,29232,29208,28584,28632,28848,28704,
     9  28464,28560,28680,28632,28584,28440,28488,28392,28344,28128/
            data (jx(i),i=  501,  600)/
     +  28104,28152,28080,28344,28464,28560,28752,28800,28800,28752,
     1  28776,28704,28656,30456,30216,29976,29880,29832,29688,29424,
     2  29424,29304,29208,29328,29472,29448,29328,29088,28848,28344,
     3  28248,28416,28512,28800,29112,29232,30792,30696,30648,30840,
     4  30864,31176,31176,31248,31080,31104,31008,31056,30960,30744,
     5  33960,34104,33984,33936,33864,33792,33840,33648,33648,33552,
     6  33576,33504,33288,33240,33120,33120,33288,33192,33024,32856,
     7  32736,32712,32496,32400,32280,32352,32232,32112,32040,32040,
     8  31992,31944,31848,31776,31536,30096,29688,29424,29232,28944,
     9  28680,28824,28776,28824,29064,29016,29064,28992,29136,28992/
            data (jx(i),i=  601,  700)/
     +  28944,28968,28920,28824,28632,28584,28680,28608,28680,28608,
     1  28488,28536,28416,28296,28176,28152,28320,28464,28512,28680,
     2  28968,29304,29424,29688,29808,30024,30384,30624,30720,30768,
     3  30624,30624,30792,30864,31056,31080,31296,31488,31464,31560,
     4  31752,31776,31848,31800,31680,31608,31656,31440,31320,32208,
     5  33432,33240,33096,32928,32880,32544,32520,32544,32448,32592,
     6  32616,32208,32088,31920,31752,31728,31824,32160,32280,32400,
     7  32448,32232,32424,32448,32352,32256,32280,32376,32448,32352,
     8  32232,32112,32304,32304,32424,32352,32376,32496,32568,32568,
     9  32784,32616,32784,32880,32760,32688,32736,32952,33072,33072/
            data (jx(i),i=  701,  800)/
     +  33120,33360,33408,33336,33432,33456,33576,33528,33720,33552,
     1  33432,33432,33336,33192,33360,33264,33384,33480,33432,33336,
     2  33408,33528,33408,33336,33240,33120,33048,33024,32712,32880,
     3  33240,33216,33120,33216,33144,33120,33048,33024,33024,32928,
     4  32760,32976,32976,32472,33864,34176,34296,34440,34728,34872,
     5  32640,32832,32880,32712,32760,32832,33024,33144,33408,33504,
     6  33648,33792,33672,33432,33312,33312,33432,33624,33552,33408,
     7  33480,33600,33792,33912,33936,33936,33744,33840,33816,33912,
     8  33888,34008,34104,34464,34440,34320,34176,34176,34248,34440,
     9  34272,34272,34128,34224,34176,34272,34368,34368,34440,34536/
            data (jx(i),i=  801,  900)/
     +  34584,34608,34656,34680,34632,34704,34752,34776,34656,34608,
     1  34560,34560,34272,34272,34320,34344,34392,34512,34488,34704,
     2  34512,34536,34392,34344,34368,34440,34440,34752,34728,34632,
     3  34632,34704,34752,34872,34824,34896,34992,34968,35088,35136,
     4  35256,35136,35136,35040,35088,35112,35136,35280,35256,35352,
     5  35544,35544,35448,35472,35400,35448,35256,35280,35400,35448,
     6  35544,35664,35616,35520,35448,35520,35664,35760,35928,35832,
     7  35952,35928,35976,36096,36168,36168,36072,36216,36192,36120,
     8  35976,35904,36072,36336,36360,36240,36264,36384,36360,36432,
     9  36360,36816,36672,36816,36648,36480,36456,36312,36168,36024/
            data (jx(i),i=  901, 1000)/
     +  36000,35880,35952,35976,35856,36000,36168,36480,36696,36744,
     1  36672,37032,37200,37200,37104,37104,36984,36888,36744,36672,
     2  36768,36648,36696,36600,40128,40200,40176,40104,40056,40056,
     3  39912,39960,39888,39768,39864,39720,39792,39696,39696,39552,
     4  39624,39528,39384,39384,39528,39456,39240,39240,38976,39216,
     5  39456,39576,39600,39816,39840,39744,39696,39696,39264,38904,
     6  38976,39240,39264,39120,39288,39312,39432,39504,39528,39624,
     7  39696,39672,39600,39696,39672,39624,39672,39672,39600,39360,
     8  39336,39216,39216,39072,39096,38904,38952,39000,39144,39264,
     9  39264,38856,38688,38784,38616,38688,38568,38112,38232,38400/
            data (jx(i),i= 1001, 1100)/
     +  38424,38400,38280,38304,38256,38256,37944,37944,37800,37824,
     1  37752,37680,37776,37656,37632,37560,37536,37512,37440,37344,
     2  37008,37008,37128,37008,36864,37008,35304,35280,35376,35328,
     3  35352,35304,35136,35136,35496,37608,38016,37920,37872,37632,
     4  37512,37392,37368,37464,37704,37728,37824,37944,38016,37992,
     5  38208,37824,37824,37752,37584,37344,37320,37224,37296,37200,
     6  37152,37272,37368,37392,37344,37512,37584,37464,37344,37248,
     7  37272,37152,37080,37032,36864,36840,36912,36936,36816,36768,
     8  36672,36672,36504,36504,36672,36864,36936,36960,37152,37200,
     9  37176,37368,37344,37464,37464,37656,37728,37776,37968,37872/
            data (jx(i),i= 1101, 1200)/
     +  37704,37608,37488,37464,37608,37632,37704,37704,37536,37488,
     1  37536,37320,37392,37320,37416,37368,37464,37392,36912,36888,
     2  36024,36024,35952,35904,35808,35760,35784,35880,35784,35880,
     3  35904,36024,36120,35904,36000,35976,35928,35832,35832,35664,
     4  35664,35736,35856,35856,36168,36288,36192,36192,36264,36384,
     5  36288,36336,36288,36360,36408,36288,36456,36504,36576,36480,
     6  36456,36624,36744,36696,36792,36912,36816,36936,37008,36984,
     7  37032,36864,36888,37032,36936,37056,37104,37104,37152,37344,
     8  37152,37200,37104,37248,37344,37464,37560,37560,37344,37128,
     9  37320,37104,37080,36960,36840,36792,36936,38112,38304,37800/
            data (jx(i),i= 1201, 1300)/
     +  37608,37632,37968,37896,37944,38160,38472,38520,38160,38232,
     1  38184,37968,37800,37824,38088,38016,38184,38088,37968,37872,
     2  37872,37776,37728,37848,38280,38016,37896,37824,37800,37704,
     3  37680,37608,37296,36984,36600,36528,36768,36816,37800,37752,
     4  36720,36816,36936,37056,37320,37536,36984,38520,39576,39504,
     5  39600,39552,39672,39768,39888,39936,39960,40104,40176,40224,
     6  40296,40296,40224,40152,39624,43776,43416,43344,43152,43224,
     7  42792,42720,42600,42720,42672,42552,42600,42576,43776,43848,
     8  43848,44064,44592,44568,44712,44856,44856,45024,45144,45192,
     9  45960,46032,45456,44928,45096,45552,46032,46416,46752,46872/
            data (jx(i),i= 1301, 1400)/
     +  47256,47424,47472,47520,47592,47424,47400,47448,47400,47352,
     1  47328,47208,47064,47064,47256,47400,47544,47472,47352,47280,
     2  47280,47112,47424,47424,47520,47856,47976,47832,47736,47712,
     3  47784,23544,23976,24072,24216,24264,24576,24600,24768,24816,
     4  24696,24912,24960,25056,25104,25896,26232,25584,25248,24864,
     5  24504,24096,23952,23952,23880,27072,27000,24576,24024,23976,
     6  24744,23928,26856,26904,26832,26784,26664,26688,26520,26208,
     7  26016,25800,25512,25584,25656,25704,25680,25416,25272,25104,
     8  24888,24720,24624,24624,24552,24432,24168,24120,24192,24120,
     9  24192,24000,23952,23976,24528,24168,24024,24024,23928,23880/
            data (jx(i),i= 1401, 1500)/
     +  23736,23712,23568,23472,24984,25296,25008,25128,24936,25176,
     1  25296,25512,25536,25392,25248,24984,24888,24912,24840,24768,
     2  24744,24888,24792,24624,24432,24192,25104,24864,24408,25488,
     3  25368,25392,25224,25296,25152,25152,26736,26616,26640,26544,
     4  26496,26376,26376,26256,26376,26304,25704,25488,25704,25944,
     5  25776,23592,23664,23736,23832,23832,23976,24072,24024,24072,
     6  24264,24408,26160,26160,26544,26568,26568,26592,26592,26592,
     7  26592,26664,26688,26736,25920,25056,24072,26616,26616,26712,
     8  26352,26400,26304,26376,26328,25728,26400,26424,26568,26568,
     9  26352,26376,26472,26304,26328,26424,26448,26640,26640,26472/
            data (jx(i),i= 1501, 1600)/
     +  26496,26376,26544,26448,26592,26664,26616,26784,25584,25656,
     1  25920,26352,26424,26400,26520,26736,27024,27168,27120,27192,
     2  27120,26544,26520,27120,27216,27096,27240,27216,27072,27048,
     3  26856,26904,26808,26952,26976,25320,25512,25848,26040,27216,
     4  27288,27240,27288,27264,27720,27600,27480,27504,27408,27336,
     5  27168,27096,26952,27120,27648,27840,27888,27792,27384,27144,
     6  27168,27000,26808,26688,26616,26496,26328,27936,27960,28104,
     7  28080,29472,29280,29280,29640,29928,29952,29856,29688,29496,
     8  29184,29184,29520,29592,29472,29376,29304,29256,28968,28848,
     9  28920,29016,28944,28968,28872,28968,28896,28440,28248,27888/
            data (jx(i),i= 1601, 1700)/
     +  28224,28368,28464,28584,28392,28512,28632,28608,28968,29256,
     1  29472,29376,29928,29952,28416,27120,27264,27240,27480,27600,
     2  27552,27648,27840,27888,28104,28104,28200,28368,28416,28440,
     3  28464,26928,27048,27384,27504,27648,27816,27936,28152,28416,
     4  28488,28488,27960,28032,30432,30432,30264,30264,29808,29664,
     5  29472,29424,29280,28944,28848,28752,28704,28824,28776,28944,
     6  28800,28728,28560,28440,28512,28608,28560,28392,28080,28200,
     7  28104,28200,28776,28944,28824,28680,28632,28560,28680,28536,
     8  28560,28656,28632,28488,28008,28008,28080,28224,28200,28248,
     9  28488,28536,28704,29136,28920,28920,28656,28656,28992,28872/
            data (jx(i),i= 1701, 1800)/
     +  28728,28608,28344,28512,29208,28296,28224,28008,29256,28896,
     1  28896,28968,29088,29160,29688,29376,29016,28872,28800,28272,
     2  30840,30024,29328,28896,28896,28920,29016,29328,32664,31392,
     3  30600,30504,30504,30312,29952,29712,30456,30432,30144,29760,
     4  29640,29424,29256,29184,29592,29496,29400,29712,28440,27456,
     5  29736,30000,28512,29616,29664,29904,31104,31080,30936,30912,
     6  30816,30888,30480,30528,30456,30432,30240,30000,29688,29568,
     7  29520,29352,30432,30192,30216,30096,29904,29976,29880,30024,
     8  30048,29256,30216,30240,30192,30048,30264,28584,28824,29232,
     9  29280,29472,29496,29568,29568,29832,32280,32496,30720,30432/
            data (jx(i),i= 1801, 1900)/
     +  30024,29616,30312,30432,30504,30552,30768,30864,30864,31608,
     1  31656,31224,31152,31056,30912,30696,30600,30216,29352,28968,
     2  30648,30576,30624,30504,30456,30816,30960,30600,30432,30360,
     3  30120,29976,29832,29664,30912,31056,29976,29808,30000,30984,
     4  30840,30840,30720,30672,30984,30984,30744,31488,31296,31200,
     5  31080,30744,30624,30504,30408,31152,30984,30792,30672,30576,
     6  30456,30408,30312,30456,30360,30432,30216,30336,30312,30096,
     7  29952,29904,29856,29952,29856,29688,29568,29304,30936,30840,
     8  30864,30528,30480,30288,30288,30216,30168,31440,30696,29928,
     9  30000,30000,30192,30168,30240,30240,30504,31440,30912,30216/
            data (jx(i),i= 1901, 2000)/
     +  30072,31536,31368,31200,31080,30864,30744,30648,31680,31632,
     1  31104,31128,31032,30768,31608,31464,31536,31608,31512,31464,
     2  31392,31368,31320,31368,31224,31176,31296,31200,30600,30624,
     3  30552,30552,31176,31368,31608,31752,31776,31200,32184,32328,
     4  32232,32208,32088,32088,31992,31944,31824,31656,31344,31296,
     5  31056,30888,30936,32376,32208,32304,32280,33096,32856,32784,
     6  32520,32352,32304,32064,31896,31800,31680,32712,32664,32496,
     7  32424,32472,32424,32616,32568,32640,32760,32448,31512,32808,
     8  32880,32784,32856,32808,34008,33840,33600,33072,32952,32808,
     9  32664,32472,32448,32136,32208,32088,32064,33000,32664,32592/
            data (jx(i),i= 2001, 2100)/
     +  32472,32328,31584,31512,31536,31488,31320,31080,31008,33048,
     1  31320,30888,33072,32760,32568,32376,32208,31992,31944,31680,
     2  31488,33072,33000,33120,33360,33408,33504,33432,33480,33864,
     3  34272,34560,34728,33144,33048,33048,32904,33144,33048,32784,
     4  33288,33336,33552,33600,33720,33864,33936,34224,34344,34416,
     5  34752,34896,35160,32928,32856,32640,32400,32232,32136,32208,
     6  32376,32616,32760,32808,32688,32664,32832,33000,33000,32928,
     7  32832,32808,32928,33048,33168,33192,33336,33168,33120,33264,
     8  33264,33312,33336,31848,33336,32976,32928,32688,32352,32136,
     9  31872,31800,31680,31560,31416,31464,31368,31392,31200,33336/
            data (jx(i),i= 2101, 2200)/
     +  35136,34944,34776,34656,34560,34296,33984,33768,33816,33672,
     1  33816,33672,33648,33552,33528,33552,33408,33384,33552,32400,
     2  32712,32880,33096,33600,33624,33120,32976,32832,32784,32712,
     3  32664,32376,32328,31920,31824,36576,36360,36288,35904,35664,
     4  35592,34968,34848,34632,34536,34368,34248,34104,33768,33504,
     5  33144,33240,33360,33648,33696,33648,33768,33696,33888,33840,
     6  33984,34104,34032,33888,33816,33840,33576,33696,33480,33432,
     7  33336,34128,33264,32976,33624,33744,33888,34200,34320,34152,
     8  33816,33336,33480,33696,33816,34008,34320,34152,34080,34200,
     9  34392,34296,34080,34104,34056,33864,33696,33672,33744,33744/
            data (jx(i),i= 2201, 2300)/
     +  34392,34320,34248,34272,34152,34104,33888,33816,34464,34008,
     1  34080,34200,34224,34200,34152,33912,33792,33768,34128,34320,
     2  34896,34968,34920,33096,33168,33240,33456,33576,33792,34080,
     3  34224,34392,34632,34848,36216,35496,35472,35256,35184,35064,
     4  35016,35040,34656,34200,33984,33864,33552,33312,35088,34848,
     5  34728,34752,34584,34440,34248,34128,34104,33840,34776,34848,
     6  34776,35016,34944,35328,35016,35376,35328,35400,35304,35184,
     7  35016,34944,34752,34488,34464,34344,35424,35016,35232,35496,
     8  35352,35472,35328,35328,35520,35496,35640,35448,35304,35664,
     9  35640,35808,35928,35352,35400,35352,35472,35688,36072,34440/
            data (jx(i),i= 2301, 2400)/
     +  35952,35400,35664,35904,36000,36048,35520,34800,34296,34200,
     1  34176,33480,35064,35088,35304,35664,35640,35808,35808,34248,
     2  34296,34248,34272,34200,34296,34560,34800,34872,35160,35640,
     3  36120,36240,36000,36096,35928,35856,35856,36024,36240,34536,
     4  36240,36072,35976,35904,35808,35640,35496,35712,35832,35928,
     5  36096,36264,36360,36528,37080,37272,35904,34680,36384,36072,
     6  35688,35568,33600,36408,36432,36384,36240,36168,36144,35568,
     7  35400,35280,35088,34944,34752,36000,36288,36456,36480,36384,
     8  36504,36552,36408,36312,36360,36288,36168,36144,36360,36600,
     9  36528,36264,35928,35664,35520,35184,34968,34848,34752,34776/
            data (jx(i),i= 2401, 2500)/
     +  34704,34536,34656,34608,34512,34392,36624,36456,36480,36432,
     1  36240,36288,36312,36264,36432,36576,36288,36096,35952,35880,
     2  35496,35400,35256,35160,37440,36288,36288,36120,35928,35856,
     3  35904,36072,36048,36216,36000,36048,39528,39168,38976,38736,
     4  38304,38064,37824,37512,37296,37032,36840,36816,36864,36984,
     5  37080,37128,37080,36864,36840,36792,36864,36816,36624,37416,
     6  37344,37200,37104,37104,36912,36528,36456,36384,36384,36192,
     7  36336,36264,36240,36528,36576,36768,36888,36960,37056,37224,
     8  37320,37344,37536,37680,37656,37248,37248,37200,37032,36744,
     9  36672,36960,37416,37872,38184,35280,35976,36864,37464,37344/
            data (jx(i),i= 2501, 2600)/
     +  36552,36216,37632,37656,37272,37200,37152,37032,36888,36768,
     1  36480,36288,35712,35592,35568,35640,35664,35640,35304,34896,
     2  39264,39096,38280,37848,37776,39552,39456,39528,39456,39312,
     3  39168,38616,38352,37944,37608,37776,37680,37584,39360,39096,
     4  39024,39000,38904,38904,38856,38472,38304,38280,38208,38208,
     5  38064,37968,38112,38208,37776,37632,38184,38640,38832,37032,
     6  37128,37272,38880,38904,38832,38760,38592,38496,38112,37776,
     7  37032,36984,36864,36696,36648,36648,36480,36168,35904,35880,
     8  35832,35760,35688,38976,38976,39072,39192,39144,39240,39240,
     9  39024,39072,39240,38664,38808,39024,39288,39336,39456,40032/
            data (jx(i),i= 2601, 2700)/
     +  39864,38184,40128,40008,40152,40152,40080,40152,40248,39960,
     1  38496,36912,36792,36384,39840,39480,41664,40536,40272,41424,
     2  41232,40656,40536,40440,40416,40080,39936,39600,39216,39120,
     3  39000,42264,42264,42192,39672,40128,40512,40680,41592,42096,
     4  42168,42408,41808,42096,42216,42456,43056,42624,42504,42648,
     5  42576,43296,43320,43368,43464,43416,43272,43440,43440,43488,
     6  43584,43632,43584,43464,43368,43248,43128,43296,43344,43176,
     7  43296,43056,43128,43344,42672,42696,42768,42912,43176,43248,
     8  43344,43488,43584,43608,44016,43992,44712,44472,44160,44160,
     9  44064,43992,43992,43704,43728,47136,47016,46944,46632,46464/
            data (jx(i),i= 2701, 2800)/
     +  46368,46296,46224,46032,46008,45864,45840,45744,45576,45576,
     1  45384,45216,45192,45432,45048,45000,44832,44712,47208,47328,
     2  47304,47160,46968,46944,46800,46704,46176,46032,46152,46104,
     3  46440,46752,27648,27888,27912,27840,27840,27624,27672,27816,
     4  48024,47976,47976,47424,47424,47472,47760,47808,47808,47736,
     5  47856,47664,47592,47616,47856,47928,47904,47832,47808,47520,
     6  47472,47592,47616,47448,47352,48000,47904,47304,47328,47352,
     7  46896,47040,46944,45864,45432,45384,45336,45312,44976,45864,
     8  44880,44760,44616,44280,44328,44352,44688,44424,44400,44544,
     9  44208,44136,44064,43944,43896,43632,43608,43680,43584,43800/
            data (jx(i),i= 2801, 2900)/
     +  43896,43800,43800,43344,43416,43368,43416,43488,43464,43440,
     1  43416,43464,43560,43728,43704,43752,43056,43104,43032,42888,
     2  43152,43176,43224,43248,43320,43344,41592,41616,41640,40680,
     3  40752,40560,40584,40632,40104,40080,40008,39960,39912,39864,
     4  39744,39600,39480,39408,39384,39312,39312,39264,39120,39000,
     5  39072,38808,38184,38280,38952,39696,40512,40944,40632,40704,
     6  40656,40152,40440,40464,40464,40176,40368,40416,40512,40272,
     7  40104,40032,40056,40104,40296,40584,40416,40056,40032,39912,
     8  39960,39864,39864,39936,39912,39984,39984,40632,40608,40512,
     9  40632,40680,39936,39936,39840,39792,39888,39960,39984,39864/
            data (jx(i),i= 2901, 3000)/
     +  39816,39816,39192,39120,39144,39240,39336,39384,39408,38112,
     1  37920,37824,37728,38016,37536,37656,37512,37248,37416,37464,
     2  37440,37296,37248,37296,37080,37128,37272,37008,37056,37080,
     3  37032,36984,37008,37176,37104,37152,37200,37152,37152,37056,
     4  37200,37200,36840,36792,36792,36360,36384,36432,36936,36720,
     5  36600,36384,36600,36528,36552,36120,36360,36360,36096,35904,
     6  35304,35136,35448,35856,35928,35904,35352,35304,35304,35256,
     7  35184,35256,34176,34176,34224,34248,34320,34320,34248,34272,
     8  34320,34272,34440,34464,34440,33984,34032,33984,31320,31776,
     9  33240,34728,34728,35160,35088,35040,34752,34872,34728,34512/
            data (jx(i),i= 3001, 3100)/
     +  34416,34440,34368,34032,33624,33288,31320,31344,29808,29688,
     1  30408,29472,29520,29520,29616,29568,29592,29352,29400,29328,
     2  28872,28920,28896,28848,28248,28176,28248,28176,28224,28344,
     3  28416,28536,28368,28728,28776,28728,27504,27528,27528,26184,
     4  25968,26112,26184,25752,25608,25728,25344,25392,25392,25464,
     5  25416,25368,25440,24336,24384,24384,24408,24456,24456,24960,
     6  25032,25128,25152,24984,25272,25200,25200,24168,24192,24192,
     7  23160,23136,23256,23208,23280,23232,23328,23376,23352,23160,
     8  23112,23112,23184,23064,23088,23136,22968,23064,22992,23496,
     9  23568,23616,23544,23520,23424,23592,23472,23232,23184,23016/
            data (jx(i),i= 3101, 3200)/
     +  22992,23112,22992,41568,41520,41568,41160,41520,41664,41112,
     1  41016,40800,40872,34320,34272,34104,34224,34080,34008,34080,
     2  34032,34056,34128,34080,28464,29040,29376,29472,29208,29016,
     3  28992,29160,29064,28656,28752,28704,28560,28416,28416,47112,
     4  47040,47040,47040,47112,25800,26952,28704,29640,29688,29664,
     5  29568,29640,29496,29496,29376,29256,29232,28776,28752,28584,
     6  28176,28080,27840,27672,27336,27456,27384,26736,26904,25824,
     7  25776,25728,25704,25560,25320,25272,24816,24504,24360,24288,
     8  24264,24096,24120,24048,24072,23928,23856,23856,24000,24048,
     9  23808,23664,23544,23592,23352,23280,23136,23040,23064,22968/
            data (jx(i),i= 3201, 3220)/
     +  22992,24912,25416,42504,43368,43320,42432,42456,42360,42384,
     1  42288,42216,42192,42096,42120,41856,41688,41664,41856,42096/
            data (jy(i),i=    1,  100)/
     +  63935,66671,50976,28944,54048,49992,61296,61200,67919,65615,
     1  32184,62927,65903,59448,62711,35568,38568,42288,45000,47520,
     2  26184,64559,24768,21120,23568,65471,63071,20472,67031,68135,
     3  69143,17040,64367,60288,14904, 9672,64655,64751,64871,64967,
     4  65063,64871,64895,65111,64847,64775,64751,64703,64439,64079,
     5  64199,64271,64367,64439,64439,64487,64559,64535,64751,64559,
     6  64487,64415,64391,64223,64367,64511,64487,64703,64703,64511,
     7  64439,64439,64607,64607,64727,64703,64775,64847,64967,64847,
     8  64991,64919,64991,64991,65087,65039,65183,65159,65303,65183,
     9  65207,65351,65255,65159,65231,65327,65447,65351,65567,65591/
            data (jy(i),i=  101,  200)/
     +  65495,65471,65543,65639,65687,65639,65303,65303,65423,65447,
     1  65543,65735,65927,65783,65807,65687,65759,65879,65927,66095,
     2  66047,66191,66215,66263,66167,66455,66479,66575,66551,66743,
     3  66743,66887,66911,67079,60168,19824,63911, 9096,21480,24312,
     4  16608,25824,29064,31176,61560,39504,60168, 9192,13056,15888,
     5  41256,32688,63839,60336,60168,36552,57360,57648,57624,57816,
     6  57840,57984,58176,58200,58536,58560,58416,58416,58632,58632,
     7  58368,58368,58200,58008,57936,57984,58128,58320,58512,58536,
     8  58248,58200,58032,58104,58032,58080,58152,58248,58536,58320,
     9  58488,58560,58680,58608,58488,58488,58584,58776,58968,58728/
            data (jy(i),i=  201,  300)/
     +  58512,58344,58296,58416,58512,58560,58560,58632,58776,58824,
     1  58944,59232,59592,59592,59760,59688,59808,59808,60120,60096,
     2  60000,60048,59856,59976,60192,60288,60288,60408,60432,60264,
     3  60264,42960,55752,45960,54288,49128,67631,67703,67559,67583,
     4  67415,67319,67367,67655,67919,68015,68063,68111,68183,68015,
     5  67943,68327,68399,68327,68447,68327,68399,68327,68471,68567,
     6  68543,68903,69047,69215,69263,69359,69335,69455,69479,69551,
     7  69527,69671,69575,69215,69071,69047,68711,68615,68663,68591,
     8  68495,68447,68327,68375,68447,68423,68303,68255,68207,68135,
     9  61224,36744,26112,26256,26304,26424,26352,26568,26592,62783/
            data (jy(i),i=  301,  400)/
     +  62735,62304,62016,66095,66287,66359,66407,66743,67175,66911,
     1  66887,67079,67103,67295,67607,67535,67439,67319,67487,67487,
     2  67223,67175,67127,66983,66839,66911,67127,67055,67007,66671,
     3  66407,26160,26328,25920,25752,25680,25368,25056,24864,61224,
     4  61248,61872,62304,62592,62855,62831,67967,68135,68015,68135,
     5  68183,68327,68207,68279,68231,68375,68327,68087,68039,68231,
     6  68351,68471,68495,68663,68663,67943,67703,67583,67367,67223,
     7  66983,66719,66575,66527,66671,64991,64919,65159,65759,65855,
     8  65807,65639,65471,65279,65015,64679,64655,65063,65207,65255,
     9  65327,65495,65903,66023,66047,66383,66671,66359,66287,66071/
            data (jy(i),i=  401,  500)/
     +  65831,65975,65855,23952,23784,64799,65039,65039,64655,64319,
     1  63791,63599,63359,63479,63479,63239,63071,62975,63047,62879,
     2  62759,62807,63071,63047,23232,23088,22848,22608,22392,22224,
     3  22056,21744,21576,21216,63335,64079,65159,65399,65375,65303,
     4  62999,62951,62735,62831,63071,63023,62927,62903,62711,62711,
     5  62520,62520,62592,62687,20760,67079,67175,67319,67391,67391,
     6  67583,67775,67895,67967,67967,67775,67871,67823,67655,67583,
     7  67343,67295,67343,67439,67631,67751,67751,67847,67847,67751,
     8  67775,67487,67391,67439,67583,67823,68039,67895,67631,67535,
     9  67223,67535,67679,67751,67679,67679,67919,67991,67967,67655/
            data (jy(i),i=  501,  600)/
     +  67367,67175,66911,66119,65903,65855,66239,66215,66071,66023,
     1  65855,65855,65663,17160,17424,17424,17592,17520,17544,17448,
     2  17568,17592,17832,18048,18144,18288,18288,18480,18480,19296,
     3  19560,19680,19824,19704,19728,20064,16848,16560,16248,15912,
     4  15648,15432,15048,14952,68087,67991,67823,67535,67343,67223,
     5  67223,67247,67319,67415,67343,67367,67487,67775,67871,67919,
     6  67823,67775,67823,67919,67895,68135,68135,68255,68231,68399,
     7  68303,68399,68663,68471,68519,68615,68663,68975,68999,68903,
     8  68903,69023,69047,69143,69071,68303,68231,68327,68255,68279,
     9  68735,68735,68831,68879,68903,68951,68999,69047,69215,69215/
            data (jy(i),i=  601,  700)/
     +  69287,69119,68999,68999,68831,68975,69191,69239,69527,69527,
     1  69335,69143,69263,69287,69215,69263,69551,69551,69743,69815,
     2  70055,70031,70199,70295,70199,70151,70319,70367,70319,70199,
     3  70175,70079,69935,70031,70055,70199,70271,70151,70031,69935,
     4  69935,69887,69551,69551,69695,69671,69359,69239,69263,59808,
     5   9768,10104,10128,10272,10680,11136,11784,12024,12312,12480,
     6  13080,13488,13848,14112,14256,14400,14568,64727,64775,64727,
     7  64487,64415,64391,64223,64031,64103,63959,63935,63767,63719,
     8  63479,63455,63431,63191,63479,63527,63599,63743,63719,63599,
     9  63311,62951,63071,63311,63407,63599,63743,63911,63887,63743/
            data (jy(i),i=  701,  800)/
     +  63863,64031,64031,63959,63863,64055,63935,64103,64127,63527,
     1  63551,63767,63623,63599,63551,63359,63455,63359,63167,63095,
     2  63023,62711,62711,62376,62328,62376,62544,62328,62424,62256,
     3  62184,61944,62016,61824,61752,61512,61608,61536,61296,61320,
     4  61224,61224,61104,60528, 9216, 9288, 9240, 9096, 9048, 9168,
     5  60648,60840,60792,60480,60456,60648,60840,61104,61200,61128,
     6  61248,61200,61296,61272,61464,61536,61608,61560,61680,61728,
     7  62160,62280,62304,62088,62112,62352,62400,62544,62639,62855,
     8  63095,63287,63023,62592,62807,62831,63119,63263,63191,63167,
     9  63263,63335,63335,63575,63719,63767,63647,63815,63839,63767/
            data (jy(i),i=  801,  900)/
     +  63647,63839,63839,63575,63479,63479,63575,64007,63959,64127,
     1  64079,63887,63983,64295,64319,64223,64415,64343,64463,64439,
     2  64535,64631,64511,64535,64823,64871,64727,64727,64871,64871,
     3  64919,64991,64943,65015,64775,64871,64871,64535,64631,64847,
     4  64799,64631,64439,64343,64319,64079,64223,64271,64391,64631,
     5  64607,64559,64487,64391,64367,64247,64055,64007,64127,63863,
     6  64031,63839,63647,63719,63527,63623,63503,63503,63311,63239,
     7  63191,63047,63119,63095,63119,21720,21984,21360,21312,21264,
     8  21264,21192,20976,20856,20736,20736,20544,20400,20280,20136,
     9  20016,61392,61248,61272,61104,61032,60960,60936,60840,60696/
            data (jy(i),i=  901, 1000)/
     +  60576,60528,60528,60480,60432,60456,60744,60840,60624,60456,
     1  60192,18312,18312,18480,18528,18600,18696,18984,18960,19056,
     2  19152,19320,19392,19512,60984,61008,61080,61152,61152,61296,
     3  61488,61536,61704,61680,61776,62016,63527,63551,63335,63311,
     4  63455,63455,63359,63239,63119,62951,63239,63551,63575,63647,
     5  63815,63791,63719,63695,64103,64103,63983,64055,64103,64055,
     6  64175,64295,64343,64439,64487,64415,64319,64319,64415,64391,
     7  64439,64583,64607,64679,64799,64823,64847,64919,64967,64847,
     8  64967,64871,64967,64895,64967,65111,65159,65159,65015,65063,
     9  65159,65327,65231,65375,65471,65591,65567,65663,65735,65711/
            data (jy(i),i= 1001, 1100)/
     +  65783,65831,65831,65855,65903,66047,66311,66071,66143,65975,
     1  65903,66167,66407,66407,66527,66527,66431,66551,66551,66431,
     2  66239,66311,66359,66383,66095,66143, 8616, 8448, 8376, 8208,
     3   7920, 7824, 7776, 7632, 7152, 6864,63767,63743,63839,63623,
     4  63599,63719,64031,64199,64199,64343,64487,64511,64415,64583,
     5  64751,64583,64727,64535,64367,64295,64247,64391,64463,64487,
     6  64703,64751,64703,64823,64919,64895,64967,64967,65039,64967,
     7  64919,64847,64991,64919,64943,64967,64991,65159,65063,65135,
     8  65039,64991,65039,65111,65303,65327,65399,65303,65303,65327,
     9  65423,65447,65351,65351,65135,65183,65087,65279,65303,65375/
            data (jy(i),i= 1101, 1200)/
     +  65303,65519,65567,65615,65615,65663,65567,65783,65735,65759,
     1  65879,65759,65879,65927,66119,66167,66239,66263,65927,65975,
     2  63143,63407,63431,63575,63551,63599,63767,63767,64007,63959,
     3  64079,63959,63959,64175,64223,64295,64247,64295,64127,64151,
     4  64271,64271,64415,64487,64319,64343,64271,64175,64271,64223,
     5  64151,64055,64031,63983,63839,63743,63767,63719,63911,63911,
     6  64103,64079,63839,63743,63767,63671,63527,63575,63479,63431,
     7  63359,63359,63263,63287,63167,63215,63119,63311,63311,63047,
     8  62951,62855,62711,62783,62927,62855,62687,62544,62160,62112,
     9  62088,61848,61608,61608,61728,61704,61512,63671,63479,63695/
            data (jy(i),i= 1201, 1300)/
     +  63503,63383,63239,63191,63047,62999,63023,62951,62927,62879,
     1  62831,62951,62544,62328,62400,62328,62232,62232,62280,62256,
     2  62208,62256,61968,61896,61872,61800,61824,61680,61776,61800,
     3  61920,61704,61320,61248,61008,60840,60648,60456,12048,12048,
     4  31104,31224,31248,31104,31056,31176,32016,33096,33024,60312,
     5  60384,60432,60384,60432,60528,60720,60600,60576,60600,60456,
     6  60528,60648,60840,60864,41352,55896,56160,56280,56304,56400,
     7  56880,56808,56832,56952,57048,57096,57144,57216,55704,55776,
     8  55824,55728,55296,55176,55248,55152,54984,55104,54984,55008,
     9  54792,54552,54528,54216,54192,54360,54432,54336,54360,54240/
            data (jy(i),i= 1301, 1400)/
     +  54048,53808,53784,53928,53880,53112,52704,52344,52320,52584,
     1  52464,52488,52392,52320,52392,52224,51240,51336,51336,51432,
     2  51336,51288,51240,51096,51120,49944,49896,49752,49944,49776,
     3  49704,64319,64919,65255,65279,65591,65831,66071,66095,66143,
     4  66287,66335,66407,66407,66647,51336,51168,29760,29568,29496,
     5  29208,28992,28992,28920,54072,49776,49704,49608,49704,49872,
     6  64655,64319,58608,58536,58440,58464,58320,58200,57912,57984,
     7  57696,57672,57480,57144,57048,56712,56592,56400,56448,56664,
     8  56688,56616,56472,56352,56304,56064,55944,55872,55656,55440,
     9  55080,54720,54384,54264,61056,61008,61008,61128,61104,61176/
            data (jy(i),i= 1401, 1500)/
     +  61224,61296,61320,61176,63911,30096,30288,30528,30864,31176,
     1  31176,31344,31584,31632,31752,67847,67871,67775,67775,67703,
     2  67583,67439,67127,67055,66815,66791,31848,31680,31992,63071,
     3  63095,63215,63335,63599,63743,63839,27984,28032,28152,28200,
     4  28344,28368,28464,28440,28704,28824,28872,29160,29496,65711,
     5  65303,59520,59976,60024,60024,60144,60144,59976,59904,59760,
     6  59640,59688,59184,60936,35448,38544,42216,44208,44976,46464,
     7  47544,42216,35448,53352,53784,53976,54000,53136,52920,52656,
     8  52392,52224,52152,51984,51864,26832,27336,27504,35400,34896,
     9  34848,34608,34464,34224,34176,34224,34104,34032,33912,33816/
            data (jy(i),i= 1501, 1600)/
     +  33456,33408,33312,33144,33120,32976,32880,32400,32016,32184,
     1  32400,59136,59040,58872,58536,58560,49824,50088,50208,50328,
     2  50400,50640,50928,55632,55488,55272,55032,54240,54120,54000,
     3  53976,53784,53640,53640,53592,63839,63863,63839,63719,63887,
     4  64007,64103,64175,64295,58392,58464,58776,58992,59064,58920,
     5  58896,58800,58800,28176,27840,27480,25560,26544,25416,25224,
     6  25032,24864,24840,24936,24888,24960,24912,47544,47664,47712,
     7  47976,62520,62280,62088,62016,61776,61680,61608,61560,61632,
     8  61368,61248,60840,60600,60528,60600,60552,60648,60600,60456,
     9  60240,60144,60048,59928,59880,59472,59376,59376,59208,58464/
            data (jy(i),i= 1601, 1700)/
     +  47928,48000,47928,48072,48144,48312,48288,48360,48264,48096,
     1  47928,47592,47424,46872,57840,55752,55872,56016,56184,56664,
     2  56736,56856,56904,56808,56928,57240,57528,57648,32352,33744,
     3  31296,35640,35544,35616,35568,35592,35424,35112,35040,35112,
     4  35184,49464,49464,48408,23184,23088,23064,23136,23088,23136,
     5  23064,22872,22752,22776,22704,22728,22584,22416,22296,22368,
     6  22152,22200,22008,21984,21888,21888,21696,21720,21624,21408,
     7  21264,21240,38520,29088,29352,29496,29880,30072,30264,30432,
     8  30648,30720,31056,31104,27720,27984,28152,28248,28392,28488,
     9  28656,28776,28920,35928,36288,37248,37248,37800,35736,35808/
            data (jy(i),i= 1701, 1800)/
     +  35760,35568,35424,35256,25584,26088,25968,25824,24576,24864,
     1  24912,25056,25104,25512,24288,23928,23760,23784,23880,23640,
     2  65303,65255,65615,65399,63023,62951,62855,62783,25416,25104,
     3  24216,24312,24480,24672,24816,24792,21192,21120,21072,20904,
     4  20568,20520,20640,20544,38496,24480,24432,54792,55128,55584,
     5  42192,46056,44208,44136,44256,44352,28728,28536,28368,28248,
     6  28176,27384,27072,26976,26856,26880,26784,26280,26016,25992,
     7  25824,25776,23280,23424,23640,23904,24024,24240,24312,45576,
     8  58296,58320,33648,42192,44448,44352,51648,52392,50304,50616,
     9  50904,50928,51048,51072,51264,51480,46248,46824,29064,28968/
            data (jy(i),i= 1801, 1900)/
     +  29064,28968,59016,58944,59016,59352,59640,63575,66311,66143,
     1  66767,66863,66983,66959,30672,30912,30912,31200,31440,31464,
     2  29544,29664,29856,30000,30432,30576,62112,62232,62208,62304,
     3  62400,62304,62472,62424,69023,52152,54264,54456,54672,51960,
     4  51936,51816,51768,51696,28800,28896,28968,22104,22032,21792,
     5  21672,21624,21648,21552,21336,35472,35520,35328,35424,35400,
     6  35352,35256,35328,35448,35568,35664,35760,35904,35976,35976,
     7  35784,35808,35952,36096,36168,36072,36120,36072,35352,35184,
     8  34968,34584,34392,34200,33936,33936,33792,61104,59712,58008,
     9  57960,57840,57768,57600,57552,57408,57192,56016,55608,55368/
            data (jy(i),i= 1901, 2000)/
     +  55368,22224,22560,22728,22776,22992,22944,22992,17616,17544,
     1  17400,17184,17112,17184,55800,17904,17976,18240,18408,18600,
     2  18648,18744,18768,18864,18912,19032,19224,19200,20376,20616,
     3  20736,20928,63863,63815,63935,64151,64343,52344,52656,53112,
     4  60312,60144,60168,60048,60048,59880,59904,59664,59616,59688,
     5  59472,59544,59688,54888,53160,53592,54888,22872,22512,22272,
     6  21984,22056,22176,22056,22008,22056,21984,26376,26304,26328,
     7  26256,26064,25920,25800,25728,25632,27600,27768,28536,27576,
     8  27288,27072,26736,26520,18624,18360,18216,18384,18480,18408,
     9  18480,18360,18264,18144,17880,17856,17760,31824,31848,32016/
            data (jy(i),i= 2001, 2100)/
     +  31920,32064,31536,31440,31224,31032,31008,30840,30840,48384,
     1  50088,50808,15432,15600,15552,15408,15456,15432,15288,15432,
     2  15144,46464,15048,14832,14616,14472,14448,14280,14160,14040,
     3  14232,14256,14232,22968,23400,23880,24096,24288,25248,25296,
     4  15624,15720,15744,16008,16152,16176,16344,16416,16560,16752,
     5  16968,16992,17304,46344,46104,45888,45816,45672,45336,45120,
     6  45024,44760,44784,44568,44592,44448,44400,44256,44184,44088,
     7  44136,44040,43848,43920,43656,42144,38376,31920,31824,31824,
     8  40608,33096,33432,33168,37536,37392,37320,37344,37056,36720,
     9  36576,36432,36384,36480,36384,36144,35952,35784,35472,36744/
            data (jy(i),i= 2101, 2200)/
     +  11664,11592,11640,11832,12144,12336,12432,12408,12264,12000,
     1  11952,11568,11088,10848,10440,10392,10224,10008, 9816,59976,
     2  59688,59736,59664,59616,57504,57312,57216,57240,57096,57096,
     3  56856,56568,56424,56088,55944,38352,38520,38496,38352,38160,
     4  38160,38304,38400,38424,38496,38376,38208,38184,38040,37584,
     5  22440,22392,22464,22344,22248,22152,18864,19200,19536,19608,
     6  20112,20136,20184,20160,20184,20616,21072,21408,21384,21600,
     7  21648,28152,27720,27744,54912,54936,55080,55104,22176,22104,
     8  22056,31752,31872,31848,31920,31800,31824,55632,55872,55896,
     9  56064,56328,56520,56664,56832,57072,57120,57288,57336,57432/
            data (jy(i),i= 2201, 2300)/
     +  58152,58152,58008,57888,57840,57744,57672,57576,58440,58848,
     1  59040,59064,59112,59232,59280,59256,59400,59568,18600,18336,
     2  17976,17760,17664,48552,48576,48744,48840,48984,49152,49248,
     3  49416,49464,49704,49680,19680,19632,19560,19584,19512,19512,
     4  61848,44928,44256,44088,43800,43824,43584,43752,51432,51504,
     5  51672,51888,52104,52464,52464,52536,52488,52512,13752,13656,
     6  13560,13272,13104,62184,63815,50640,50040,57576,57648,57912,
     7  57912,57840,57744,57864,57984,58080,11544,49368,49344,49128,
     8  11472,11136,10848,10464,10128,10056, 9528, 9288, 9288,51864,
     9  51984,52488,52488,48312,47976,47808,47448,47160,45576,54960/
            data (jy(i),i= 2301, 2400)/
     +  54936,44640,45072,45168,45528,34824,33960,33768,33216,33240,
     1  33312,33072,21744,21672,21552,21528,21456,21432,21504,22344,
     2  22512,22584,22728,22896,23160,23400,23520,23664,23880,24360,
     3  54552,54480,54216,53928,53808,53544,53376,53136,35160,36024,
     4  11208,11280,11424,11448,11328,11544,11592,17208,17016,16992,
     5  16800,16824,16728,16848,16344,16272,25872,26304,41736,41424,
     6  41304,41088,40608,35424,35664,36240,36624,36696,36840,29136,
     7  28872,28872,28776,28872,28560,37056,37128,37248,37368,37416,
     8  37512,37704,37680,37800,37896,37968,37968,38064,38136,31320,
     9  31440,31488,31392,31440,31392,31488,31632,31608,31704,31920/
            data (jy(i),i= 2401, 2500)/
     +  32040,31800,31680,31608,31584,31824,38784,39024,39264,39648,
     1  40008,40128,40704,41136,41544,61608,61584,61296,61200,61320,
     2  61368,61512,61512,61776,42912,43872,43992,44136,44424,44472,
     3  44592,44784,45000,45192,45288,45384,39576,39672,39912,40056,
     4  39864,39912,39672,39840,39600,39552,39480,39336,39240,39072,
     5  39024,38904,38736,38400,60072,59952,59832,59784,59760, 9528,
     6   9576, 9528, 9576, 9672, 9936,10272,10272,10344,10632,11136,
     7  11304,11400,11832,11952,12096,12144,12336,12336,12480,12480,
     8  12528,12648,12792,12792,12888,42624,42144,42048,42000,42048,
     9  45480,45624,45648,45984,46056,57192,57360,56688,55752,55608/
            data (jy(i),i= 2501, 2600)/
     +  55560,55416,15816,15744,15552,15408,15408,15600,15576,15384,
     1  15240,15024,15096,15024,14952,14856,14688,14592,14376,14328,
     2  43752,43848,43704,43368,43224,41280,41640,41808,41736,41784,
     3  41712,42168,42000,42072,42528,56160,32952,33216,60000,59784,
     4  59784,59880,59904,59760,59712,59592,59424,59328,59328,59280,
     5  59208,58728,58488,58488,57480,56400,64007,63047,60864,60360,
     6  60432,60360,60408,50064,49968,49968,49728,49752,49248,48960,
     7  48816,48744,48768,48960,48984,48888,49008,49008,48936,49032,
     8  49056,48960,49080,60840,60744,60600,60552,60432,60336,60048,
     9  49968,47664,47088,46800,46920,46944,45000,60072,60096,56208/
            data (jy(i),i= 2601, 2700)/
     +  56160,56376,52992,53712,53856,53976,54264,54408,52824,52344,
     1  52680,52560,52464,52512,43920,43728,51984,52680,52992,51864,
     2  51600,51408,51264,51240,51072,50904,50904,50568,50328,50160,
     3  50136,57240,57120,57072,47328,47472,47808,47832,47496,47496,
     4  47544,47424,51840,51984,52128,52608,52008,47712,48888,48960,
     5  49080,50616,51264,51432,52440,52728,52896,53160,53328,53376,
     6  53352,53712,53952,53952,54048,54000,54144,54264,54384,54576,
     7  54720,55248,55344,55320,47112,46848,46776,46656,46680,46464,
     8  46368,46416,46368,46272,46128,45984,54240,54264,54024,53928,
     9  54000,53952,53808,53880,53736,49200,49176,49296,49224,49584/
            data (jy(i),i= 2701, 2800)/
     +  49656,49632,49776,49848,49776,49800,49896,49848,49872,49944,
     1  49896,50112,50256,50832,51144,51216,51168,52008,54504,54456,
     2  54432,54504,54576,54480,54624,54648,54576,54768,54768,54864,
     3  54744,54720,70415,70415,70343,70271,70127,70151,70271,70319,
     4  49992,49992,50088,54264,54216,54240,50520,50472,50352,50832,
     5  50472,50688,51120,51120,50328,50136,49992,50232,54000,54168,
     6  54264,54312,54384,54384,54456,54360,54072,54336,54312,54360,
     7  54312,54240,54240,54936,55056,55008,55104,55032,55320,54984,
     8  55392,55416,55560,55656,55584,55656,55368,55536,55656,55584,
     9  55800,55752,55800,55872,56016,56088,56136,56184,56328,56112/
            data (jy(i),i= 2801, 2900)/
     +  55968,55968,56040,56376,56376,56328,56448,56424,56472,56232,
     1  56280,56352,56232,56040,55992,55992,56784,56712,56664,56880,
     2  56592,56640,56568,56472,56496,56424,58680,58728,58656,60216,
     3  60048,60312,60360,60312,64991,65063,65087,65159,65135,65231,
     4  65279,65423,65447,65543,65471,65471,65567,65639,65711,65687,
     5  65735,65903,66503,66503,65903,65399,64919,64775,64631,64751,
     6  64799,65015,60432,60408,60456,64367,64775,64823,64775,64463,
     7  63911,63887,64031,62208,61272,60528,60624,62040,62400,62639,
     8  62999,63143,63263,63311,63575,63671,63071,60000,59976,60096,
     9  60072,60000,64487,64391,64367,64511,64559,64799,64751,64799/
            data (jy(i),i= 2901, 3000)/
     +  64679,64775,65591,65663,65663,65591,65063,65039,65111,66551,
     1  66767,66791,66983,66743,67175,67055,67127,67415,67103,67103,
     2  67151,66599,66599,66671,66695,66791,66695,67511,67463,67511,
     3  66479,66479,66599,66575,66479,67103,67103,67055,67487,67607,
     4  67535,67463,65951,65879,65999,68087,68351,68351,67727,67751,
     5  67919,68015,65351,65327,65423,68615,68423,68543,68759,68999,
     6  70127,70271,69599,68951,68759,68639,65303,65231,65303,69887,
     7  69911,69935,70847,70799,70799,64463,64487,64415,64415,71903,
     8  71927,71951,71399,71375,71423,63551,63575,63647,72287,72311,
     9  72215,71999,71567,70415,70391,70631,70823,70919,71207,71447/
            data (jy(i),i= 3001, 3100)/
     +  71495,71591,71927,72023,71999,72119,72215,71783,70847,71735,
     1  72071,70967,70943,71015,71231,71207,71159,70679,70631,70655,
     2  71111,71087,71039,71039,68663,68759,68999,69023,69119,69095,
     3  68879,68759,68543,70991,70967,70967,70055,70031,70103,69263,
     4  69215,69287,69311,62999,62927,62951,69143,69143,69167,69071,
     5  69071,68999,68999,68231,68207,68279,68951,68951,68999,69167,
     6  69143,69215,69143,69071,69047,69071,69023,68999,68975,69023,
     7  68615,68663,68663,68711,68711,68759,67487,67487,67583,68711,
     8  68711,68759,68783,67799,67751,67775,68447,68495,68567,68567,
     9  68639,68471,68399,68279,68231,68111,68015,68111,67943,67799/
            data (jy(i),i= 3101, 3200)/
     +  67991,68183,68159,58800,58800,58848,59520,59136,58848,59472,
     1  59664,59952,59688,66359,66311,66383,66479,65327,65375,65375,
     2  65663,65855,65639,65615,70175,70703,70775,71063,70991,70823,
     3  70895,71015,71039,70775,70655,70607,70679,70391,70223,54480,
     4  54504,54480,54432,54432,69719,70223,71231,71663,71615,71543,
     5  71519,71447,71375,71303,71351,71303,71207,71111,71063,71063,
     6  70799,70583,70439,70463,70343,70151,70031,69911,70007,69647,
     7  69527,69527,69599,69431,69407,69287,69263,69119,69095,68999,
     8  69095,69047,68975,68975,68927,68925,68951,68855,68855,68759,
     9  68591,68567,68711,68783,68759,68831,68831,68783,68663,68663/
            data (jy(i),i= 3201, 3220)/
     +  68855,69359,69527,57504,56568,56544,57456,57480,57528,57576,
     1  57744,57744,57864,57912,58008,58488,58656,58800,58560,58104/
            data (jb1(i),i=    1,  100)/
     +     33,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     1     46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
     2     56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
     3     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     4     76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
     5     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     6     96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
     7    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     8    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     9    126,  127,  128,  129,  130,  131,  132,  133,  157,  158/
            data (jb1(i),i=  101,  200)/
     +    159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
     1    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     2    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     3    189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
     4    199,  200,  201,  202,  203,  204,  205,  206,  207,  208,
     5    209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
     6    219,  220,  221,  222,  223,  224,  225,  226,  227,  228,
     7    229,  230,  155,   10,  237,  238,  239,  240,  241,  242,
     8    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     9    253,  254,  255,  256,  257,  258,  259,  260,  261,  262/
            data (jb1(i),i=  201,  300)/
     +    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     1    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     2    283,  284,  285,  286,  287,  288,  289,    9,    1,    8,
     3      1,    8,    5,    3,    3,    4,    6,   19,   11,   18,
     4     17,   16,   17,   21,  293,  294,  295,  296,  297,  298,
     5      4,   12,  300,  301,  302,    7,   13,  304,  305,  306,
     6    307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
     7    317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
     8    327,  328,  329,  330,    2,   21,  332,  333,  334,  335,
     9    336,  337,  338,   23,    7,  340,  341,  342,  343,  344/
            data (jb1(i),i=  301,  400)/
     +    345,   15,    9,  347,  348,  349,  350,  351,  352,  353,
     1    354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
     2    364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
     3    374,    2,   22,  376,  377,  378,  379,  380,  381,  382,
     4    383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
     5    393,  394,  395,  396,  397,  398,  399,  400,  401,  402,
     6     13,   23,  404,   25,   22,  406,  407,  408,  409,  410,
     7    411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
     8    421,  422,  423,   12,   25,  425,  426,  427,  428,  429,
     9    430,  431,  432,  433,   24,   27,  435,  436,  437,  438/
            data (jb1(i),i=  401,  500)/
     +    439,   26,   27,  441,  442,  443,  444,  445,  446,  447,
     1    448,  449,  450,  451,  452,  453,   15,   24,   28,   29,
     2    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     3    466,  467,  468,  469,  470,  471,  472,  473,  474,  475,
     4    476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
     5    486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
     6    496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
     7    506,  507,  508,  509,  510,  511,  512,   26,   32,  514,
     8    515,  516,  517,  518,  519,  520,  521,  522,  523,  524,
     9    525,  526,  527,  528,  529,  530,  531,  532,  533,  534/
            data (jb1(i),i=  501,  600)/
     +    535,   28,   32,  537,  538,  539,  540,  541,  542,  543,
     1     35,   30,  545,  546,  547,  548,  549,   29,  134,  551,
     2    552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
     3    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     4    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     5    582,  583,  584,   31,   30,  586,  587,  588,  589,  590,
     6    591,  592,  593,  594,  595,  596,  597,  598,  599,  600,
     7    601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
     8    611,  612,  613,  614,  615,  616,  617,  618,  619,  620,
     9    621,  622,  623,  624,  625,  626,  627,  628,  629,  630/
            data (jb1(i),i=  601,  700)/
     +    631,  632,  633,  634,  635,  636,  637,  638,  639,  640,
     1    641,  642,  643,  644,  645,  646,  647,  648,   31,  135,
     2     34,   36,  651,  652,  653,  654,  655,  656,  657,  658,
     3    659,  660,  661,  662,  663,  664,  665,  666,   35,   33,
     4    668,  669,  670,  671,  672,  673,  674,  675,  676,  677,
     5    678,  679,  680,  681,  682,  683,  684,  685,  686,  687,
     6    688,  689,  690,  691,  692,  693,  694,  695,  696,  697,
     7    698,  699,  700,  701,  702,  703,  704,  705,  706,  707,
     8    708,  709,  710,  711,  712,  713,  714,  715,  716,  717,
     9    718,  719,  720,  721,  722,  723,  724,  725,  726,  727/
            data (jb1(i),i=  701,  800)/
     +    728,  729,  730,  731,  732,  733,  734,  735,  736,  737,
     1    738,  739,  740,  741,  742,  743,   34,   36,  745,  746,
     2    747,  748,  749,  138,  135,  751,  752,  753,  754,  755,
     3    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     4    766,  767,  768,  769,  770,  771,  772,  773,  774,  775,
     5    776,  777,  778,  779,  780,  781,  782,  783,  784,  785,
     6    786,  787,  788,  789,  790,  791,  792,  793,  794,  795,
     7    796,  797,  798,  799,  800,  801,  802,  803,  804,  805,
     8    806,  137,  137,  808,  809,  810,  811,  812,  813,  814,
     9    815,  816,  817,  818,  819,  820,  821,  822,  823,  824/
            data (jb1(i),i=  801,  900)/
     +    825,  826,  827,  828,  829,  830,  831,  832,  833,  834,
     1    835,  836,  837,  838,  839,  840,  841,  842,  843,  844,
     2    845,  846,  847,  848,  849,  850,  851,  852,  853,  854,
     3    855,  856,  857,  858,  859,  860,  861,  862,  863,  864,
     4    865,  866,  867,  868,  869,  870,  871,  872,  873,  874,
     5    139,  876,  140,  140,  142,  139,  878,  879,  880,  881,
     6    882,  883,  884,  885,  886,  887,  888,  889,  890,  136,
     7    143,  147,  145,  892,  893,  894,  895,  896,  897,  898,
     8    899,  900,  901,  902,  903,  904,  905,  906,  907,  908,
     9    909,  910,  147,  141,  912,  913,  914,  915,  916,  917/
            data (jb1(i),i=  901, 1000)/
     +    918,  919,  920,  921,  922,  923,  136,  925,  926,  927,
     1    928,  929,  930,  931,  932,  933,  934,  935,  936,  937,
     2    938,  939,  940,  941,  942,  943,  944,  945,  946,  947,
     3    948,  949,  950,  951,  952,  953,  954,  955,  956,  957,
     4    958,  959,  960,  961,  962,  963,  964,  965,  966,  967,
     5    968,  969,  970,  971,  972,  973,  974,  975,  976,  977,
     6    978,  979,  980,  981,  982,  983,  984,  985,  986,  987,
     7    988,  989,  990,  991,  992,  993,  994,  995,  996,  997,
     8    998,  999, 1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007,
     9   1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017/
            data (jb1(i),i= 1001, 1100)/
     +   1018, 1019, 1020, 1021, 1022, 1023, 1024, 1025,  138, 1027,
     1   1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035,  148,  153,
     2   1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046,
     3   1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056,
     4   1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066,
     5   1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,
     6   1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086,
     7   1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096,
     8   1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106,
     9   1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116/
            data (jb1(i),i= 1101, 1200)/
     +   1117, 1118, 1119, 1026,  875, 1121, 1122, 1123, 1124, 1125,
     1   1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135,
     2   1136, 1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145,
     3   1146, 1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155,
     4   1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163, 1164, 1165,
     5   1166, 1167, 1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175,
     6   1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185,
     7   1186, 1187, 1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195,
     8   1196,  145,  153, 1198, 1199, 1200, 1201, 1202, 1203, 1204,
     9   1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213, 1214/
            data (jb1(i),i= 1201, 1300)/
     +   1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223, 1224,
     1   1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233, 1234,
     2   1235, 1236, 1237,  154,  141,  148, 1239,  149,  149,  144,
     3   1241, 1242, 1243, 1244, 1245, 1246,  152,  152, 1248,  156,
     4    146,  146,  155, 1250, 1251, 1252, 1253, 1254, 1255, 1256,
     5   1257, 1258, 1259, 1260, 1261, 1262, 1263,  925,  151,  232,
     6    233, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274,
     7   1275, 1276, 1277,  157,  232,  233, 1279, 1280, 1281, 1282,
     8   1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292,
     9    235,  235, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301/
            data (jb1(i),i= 1301, 1400)/
     +   1302, 1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311,
     1   1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321,
     2   1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330,  236,
     3    234, 1332, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339,
     4   1340, 1341, 1342, 1343, 1344, 1345,    3, 1346, 1348, 1349,
     5   1350, 1351, 1352, 1353, 1354,    5, 1356, 1357, 1358, 1359,
     6   1360, 1361, 1332, 1363, 1364, 1365, 1366, 1367, 1368, 1369,
     7   1370, 1371, 1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379,
     8   1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389,
     9   1390, 1391, 1392, 1393, 1355,    7, 1395, 1396, 1397, 1398/
            data (jb1(i),i= 1401, 1500)/
     +   1399, 1400, 1401, 1402, 1403, 1404, 1361, 1348, 1406, 1407,
     1   1408, 1409, 1410, 1411, 1412, 1413, 1414,    9, 1416, 1417,
     2   1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1415,
     3   1427, 1428, 1429,   12, 1430, 1431, 1432, 1433, 1434, 1435,
     4   1405, 1437, 1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445,
     5   1446, 1447, 1448, 1348,   13, 1450, 1361,   14, 1452, 1453,
     6   1454, 1455, 1456, 1457, 1458, 1459, 1460, 1461, 1462,   15,
     7   1463,   16, 1466, 1465,   18, 1467, 1469, 1469, 1468, 1471,
     8   1470, 1467, 1466, 1465, 1474, 1475, 1476, 1355, 1474, 1478,
     9   1479, 1480, 1481, 1482, 1483, 1484, 1347,   21, 1486, 1487/
            data (jb1(i),i= 1501, 1600)/
     +   1437, 1473, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496,
     1   1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506,
     2   1507, 1415, 1509, 1510, 1508, 1463, 1512, 1513, 1514, 1515,
     3   1363, 1356, 1517, 1518, 1519, 1520, 1521, 1522, 1347, 1524,
     4   1525, 1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534,
     5   1474, 1405, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543,
     6   1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552, 1363,
     7   1437, 1554, 1555, 1557, 1556, 1557, 1559, 1560, 1561, 1562,
     8   1563, 1564, 1565, 1566, 1567, 1471, 1568, 1569, 1570, 1572,
     9   1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582/
            data (jb1(i),i= 1601, 1700)/
     +   1583, 1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592,
     1   1593, 1594, 1595, 1596, 1597, 1598, 1599, 1545, 1571, 1601,
     2   1602, 1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611,
     3   1612, 1613, 1545, 1524, 1616, 1617, 1618, 1619, 1620, 1621,
     4   1622, 1623, 1624, 1625, 1626, 1627, 1615, 1508, 1629, 1629,
     5   1473, 1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640,
     6   1630, 1642, 1356, 1642, 1571, 1645, 1646, 1647, 1648, 1649,
     7   1650, 1651, 1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659,
     8   1660, 1661, 1662, 1663, 1664, 1665, 1666, 1667, 1668, 1669,
     9   1670, 1671, 1672, 1466, 1674, 1675, 1676, 1677, 1678, 1679/
            data (jb1(i),i= 1701, 1800)/
     +   1680, 1681, 1682, 1683, 1631, 1556, 1685, 1686, 1687, 1688,
     1   1689, 1690, 1691, 1692, 1674, 1694, 1695, 1696, 1697, 1673,
     2   1694, 1699, 1700, 1701, 1702, 1703, 1641, 1705, 1706, 1707,
     3   1557, 1709, 1710, 1711, 1712, 1713, 1705, 1715, 1716, 1717,
     4   1718, 1719, 1720, 1721, 1722, 1723, 1724,   27, 1725, 1726,
     5   1727, 1572, 1729, 1730, 1731, 1732, 1733, 1734, 1735, 1709,
     6   1737, 1738, 1739, 1740, 1741, 1742, 1743, 1744, 1673, 1715,
     7   1746, 1709, 1748, 1749, 1524, 1472, 1745, 1470, 1468, 1753,
     8   1754, 1755, 1757, 1758, 1759, 1760, 1761, 1762, 1763, 1764,
     9   1765, 1766, 1767, 1768, 1769, 1770, 1771, 1705, 1645, 1773/
            data (jb1(i),i= 1801, 1900)/
     +   1774, 1775, 1776, 1777, 1778, 1715, 1614, 1756, 1752, 1781,
     1   1615, 1630, 1784, 1785, 1756, 1751, 1787, 1474, 1642, 1789,
     2   1790, 1791, 1792, 1793, 1794, 1795, 1787, 1614, 1797, 1799,
     3   1800, 1801, 1674, 1781, 1803, 1804, 1805, 1806, 1721, 1721,
     4   1809, 1810, 1811, 1812, 1813, 1814, 1815, 1816, 1817, 1818,
     5   1819, 1631, 1799, 1821, 1822, 1823, 1824, 1825, 1815, 1808,
     6   1827, 1828, 1829, 1830, 1831, 1832, 1833, 1572,   30, 1835,
     7   1836, 1837, 1838, 1748, 1836, 1840, 1841, 1842, 1843, 1787,
     8   1757, 1845, 1846, 1799, 1848, 1849, 1850, 1851, 1852, 1853,
     9   1854, 1737, 1856, 1857, 1858, 1859, 1860, 1861, 1862, 1863/
            data (jb1(i),i= 1901, 2000)/
     +   1864, 1865, 1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873,
     1   1874, 1875, 1876, 1877, 1694, 1856, 1879, 1880, 1881, 1882,
     2   1883, 1884, 1885, 1886, 1783, 1827, 1888, 1807, 1781, 1890,
     3   1891, 1892, 1893, 1894, 1895, 1896, 1897, 1898, 1899, 1900,
     4   1748, 1848, 1902, 1903, 1904, 1905, 1906, 1907, 1645, 1909,
     5   1910, 1911, 1912, 1913, 1914, 1898, 1909, 1916, 1917, 1918,
     6   1919, 1920, 1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928,
     7   1929, 1930, 1931, 1737, 1808, 1933, 1934, 1935, 1936, 1937,
     8   1836, 1938, 1939,   34, 1941, 1942, 1943, 1944, 1945, 1946,
     9   1947, 1948, 1949, 1950, 1951, 1952, 1807, 1915, 1940, 1955/
            data (jb1(i),i= 2001, 2100)/
     +   1956, 1954, 1958, 1959, 1960, 1961, 1962, 1963, 1964, 1965,
     1   1966, 1848, 1968, 1969, 1970, 1971, 1972, 1973, 1974, 1975,
     2   1729, 1977, 1978, 1757, 1977, 1980, 1981, 1982, 1983, 1968,
     3   1985, 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994,
     4   1995, 1996, 1909, 1998, 1999, 2000, 2001, 2002, 2003, 2004,
     5   2005, 2006, 2007, 2008, 1815, 1977, 2010, 2011, 1787, 1798,
     6   2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 1798,
     7   2013, 2023, 2024, 2025, 2026, 2027, 2028, 2029, 2030, 2031,
     8   2032, 1958, 2034, 2035, 2036, 2037, 2038, 2039, 1729, 2013,
     9   2041, 2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049, 2050/
            data (jb1(i),i= 2101, 2200)/
     +   2051, 2052, 2022, 2054, 2055, 2056, 2057, 2058, 2059, 2060,
     1   2061, 2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069, 2070,
     2   2071, 2072, 2073, 2074, 2075, 1784, 1745, 1998, 2078, 2079,
     3   2076, 2077, 2080, 2083, 1783, 2082, 2077, 2085, 2086, 2087,
     4   2088, 2089, 2090, 2091, 2092, 2093, 2094, 2095, 2096, 2097,
     5   2098, 1856, 2085, 2083, 2101, 2102, 2103, 2104, 2105, 2106,
     6   2107, 2108, 2109, 2110, 2111, 2112, 2113, 2114, 2115, 2116,
     7   2117, 2118, 2119,  135, 2120, 2121, 2122, 2123, 2125, 2126,
     8   2127, 2128, 2129, 2130, 2131, 2132, 2133, 2134, 1915, 2136,
     9   2137, 2138, 2139, 2140, 2141, 2142, 2143, 2144, 2145, 2146/
            data (jb1(i),i= 2201, 2300)/
     +   2147, 2148, 2149, 2085, 1958, 2151, 2152, 2153, 2154, 2155,
     1   1985, 2157, 2158, 2159, 2160, 2161, 2162, 2163, 2164, 2165,
     2   2166, 2167, 2168, 2169, 2170, 2156, 2172, 2173, 1980, 1954,
     3   2175, 2176, 2177, 2179, 2180, 2156, 2080, 2182, 2183, 2184,
     4   2185, 2186, 2172, 2178, 2188, 2189, 2190, 2191, 2192, 2193,
     5   2194, 2195, 2196, 2197, 2198, 2199, 2125, 2201, 2202, 2203,
     6   2204, 2205, 2206, 2207, 2125, 2201, 2209, 2210, 2211, 2212,
     7   2213, 2214, 2215, 2216, 2217, 2124, 1985, 2219, 2220, 2221,
     8   2222, 2053, 2010, 2224, 2225, 2226, 2227, 2228, 2229, 2230,
     9   2231, 2232, 2233,  136, 2235, 2236, 2237, 2238, 2239, 1985/
            data (jb1(i),i= 2301, 2400)/
     +   2124, 2022, 2242, 2243, 2244, 2245, 2246, 2247, 2075, 2249,
     1   2250, 2251, 2252, 2253, 2254, 2255, 2256, 2257, 1940, 2033,
     2   2259, 2260, 2261, 2262, 2101, 2241, 2264, 2265, 2249, 2266,
     3   2234, 2268, 2269, 2270, 2271, 2272, 2273, 2274, 2275, 2201,
     4   2101, 2234, 2278, 2279, 2277, 2281, 2282, 2283, 2284, 2285,
     5   2286, 2287, 2288, 2289, 2249, 2290, 2291, 2292, 2280, 2294,
     6   2295, 2296, 2297, 2298, 2178, 2300, 2242, 2302, 2303, 2304,
     7   2306, 2307, 2308, 2309, 2310, 2311, 2082, 2299, 2179, 2313,
     8   2314, 2315, 2316, 2317, 2318, 2319, 2179, 2320, 2321, 2322,
     9   2323, 2324, 2325, 2326, 2327, 2328, 2329, 2330, 2301, 2331/
            data (jb1(i),i= 2401, 2500)/
     +   2332, 2333, 2334, 2335, 2336, 2337, 2293, 2339, 2100, 2306,
     1   2341, 2342, 2343, 2344, 2345, 2346, 2277, 2053, 2348, 2349,
     2   2350, 2351, 2352, 2353, 2354, 2355, 2356,  142, 2357, 1968,
     3   2359, 2360, 2361, 2362, 2081, 2339, 2364, 2365, 2366, 2367,
     4   2368,  143, 2370, 2371, 2372, 2373, 2374, 2172, 2369, 2376,
     5   2377, 2378, 2379, 2380, 2381, 2382, 2383, 2384, 2385, 2386,
     6   2387, 2388, 2136,  144, 2390, 2391, 2392, 2393, 2394, 2395,
     7   2396, 2397, 2398, 2399, 2400, 2401, 2402, 2403, 2404, 2405,
     8   2187, 2136, 2407, 2408, 2409, 2410, 2411, 2412, 2413, 2414,
     9   2359,  145, 2416, 2417, 2418, 2419, 2420, 2421, 2422, 2423/
            data (jb1(i),i= 2501, 2600)/
     +   2241, 2425, 2426, 2427, 2428, 2429, 2430, 2431, 2432, 2433,
     1   2434, 2435, 2305,  146, 2437, 2438, 2439, 2440, 2441, 2442,
     2   2443, 2444, 2445, 2446, 2447, 2448, 2449, 2450, 2451, 2452,
     3   2453, 2136,  147, 2455, 2456, 2457, 2458, 2268,  148, 2460,
     4   2461, 2462, 2463, 2464, 2465, 2466, 2467, 2468, 2469, 2341,
     5   2341, 2471, 2472, 2473, 2474, 2475, 2476, 2477, 2478, 2479,
     6   2480, 2481, 2482, 2483, 2484, 2485, 2425, 2486, 2487, 2488,
     7   2489, 2359, 2299, 2491, 2492, 2493, 2494, 2268, 2496, 2497,
     8   2498, 2499, 2500, 2501, 2301,  150, 2503, 2504, 2505, 2506,
     9   2507, 2508, 2509, 2510, 2511, 2512, 2513, 2514, 2515, 2516/
            data (jb1(i),i= 2601, 2700)/
     +   2517, 2518, 2519, 2033, 2521, 2522, 2523, 2524, 2425,  151,
     1   2526, 2527, 2528, 2529, 2530, 2531, 2532, 2533, 2534, 2425,
     2   2499,  152, 2537, 2306, 2539, 2540, 2541, 2542, 2543, 2544,
     3   2545, 2546, 2547, 2548, 2549, 2550, 2551, 2552, 2553, 2554,
     4   2555, 2536,  153, 2557, 2558,  154, 2560, 2561, 2562, 2559,
     5   2564, 2565, 2566, 2567, 2568, 2569, 2570, 2571, 2572, 2573,
     6   2574, 2575, 2576, 2577, 2578, 2579, 2580, 2581, 2582, 2280,
     7   2559, 2584, 2585, 2586, 2587, 2588, 2589, 2539, 2564, 2591,
     8   2592, 2495, 2594, 2595, 2593, 2521, 2495, 2539, 2598, 2599,
     9   2369, 2600, 2601, 2536, 2603, 2604, 2605, 2606, 2607, 2600/
            data (jb1(i),i= 2701, 2800)/
     +   2603, 2609, 2610, 2611, 2612, 2613, 2293,  232, 2615, 2521,
     1   2617, 2618, 2603, 2617, 2620, 2621, 2622, 2623, 2624, 2625,
     2   2626, 2627, 2628, 2629, 2630, 2564,  157, 2632, 2633, 2600,
     3   2593, 2635, 2636, 2637, 2638, 2639, 2640, 2641, 2617, 2643,
     4   2644, 2645, 2646, 2642, 2648, 2649, 2650, 2651, 2652, 2653,
     5   2647, 2647, 2655, 2656, 2657, 2658, 2659, 2660, 2661, 2662,
     6   2663, 2664, 2665, 2666, 2667, 2668, 2669, 2670, 2671, 2672,
     7   2673, 2674, 2642, 2675, 2676, 2677, 2678, 2679, 2680, 2681,
     8   2682, 2683, 2684, 2685, 2686,  235, 2687, 2688, 2689, 2690,
     9   2691, 2692, 2693, 2694, 2662,  236, 2696, 2697, 2698, 2699/
            data (jb1(i),i= 2801, 2900)/
     +   2700, 2701, 2702, 2703, 2704, 2705, 2706, 2707, 2708, 2709,
     1   2710, 2711, 2712, 2713, 2714, 2715, 2716, 2717, 2656,    1,
     2      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     3     12,   13,    1,   15,   16,   17,   18,   19,   20,   21,
     4     15,   23,   24,   23,   26,   27,   26,   29,   30,   29,
     5     32,   33,   34,   35,   32,   37,   38,   39,   37,   41,
     6     42,   43,   44,   45,   46,   47,   48,   41,   50,   51,
     7     50,   53,   54,   53,   56,   57,   58,   59,   60,   61,
     8     56,   63,   64,   63,   66,   67,   66,   69,   70,   71,
     9     69,   73,   74,   75,   76,   73,   78,   79,   80,   81/
            data (jb1(i),i= 2901, 3000)/
     +     78,   83,   84,   83,   86,   87,   86,   89,   90,   89,
     1     92,   93,   94,   92,   96,   97,   96,   99,  100,  101,
     2     99,  103,  104,  103,  106,  107,  106,  109,  110,  109,
     3    112,  113,  114,  115,  112,  117,  118,  119,  120,  121,
     4    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     5    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     6    142,  143,  117,  145,  146,  145,  148,  149,  150,  151,
     7    152,  153,  154,  148,  156,  157,  158,  159,  160,  161,
     8    162,  163,  164,  165,  166,  167,  168,  156,  170,  171,
     9    172,  173,  170,  175,  176,  177,  178,  179,  180,  175/
            data (jb1(i),i= 3001, 3100)/
     +    182,  183,  182,  185,  186,  187,  185,  189,  190,  189,
     1    192,  193,  194,  195,  192,  197,  198,  199,  197,  201,
     2    202,  201,  204,  205,  204,  207,  208,  207,  210,  211,
     3    210,  213,  214,  215,  216,  213,  218,  219,  218,  221,
     4    222,  223,  221,  225,  226,  225,  228,  229,  230,  231,
     5    232,  233,  228,  235,  236,  235,  238,  239,  240,  241,
     6    242,  243,  244,  245,  246,  247,  238,  249,  250,  249,
     7    252,  253,  252,  255,  256,  255,  258,  259,  260,  258,
     8    262,  263,  262,  265,  266,  265,  268,  269,  268,  271,
     9    272,  273,  274,  275,  276,  277,  278,  279,  280,  281/
            data (jb1(i),i= 3101, 3200)/
     +    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     1    292,  271,  294,  295,  294,  297,  298,  297,  300,  301,
     2    300,  303,  304,  305,  303,  307,  308,  309,  310,  311,
     3    312,  313,  314,  307,  316,  317,  316,  319,  320,  319,
     4    322,  323,  324,  322,  326,  327,  326,  329,  330,  329,
     5    332,  333,  334,  332,  336,  337,  336,  339,  340,  339,
     6    342,  343,  344,  345,  342,  347,  348,  347,  350,  351,
     7    350,  353,  354,  353,  356,  357,  356,  359,  360,  359,
     8    362,  363,  364,  362,  366,  367,  366,  369,  370,  371,
     9    372,  373,  374,  375,  376,  377,  378,  379,  380,  381/
            data (jb1(i),i= 3201, 3300)/
     +    382,  383,  384,  369,  386,  387,  386,  389,  390,  391,
     1    389,  393,  394,  393,  396,  397,  398,  396,  400,  401,
     2    400,  403,  404,  405,  403,  407,  408,  409,  410,  411,
     3    412,  413,  414,  415,  416,  417,  418,  419,  420,  407,
     4    422,  423,  424,  425,  422,  427,  428,  429,  430,  431,
     5    432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
     6    442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
     7    452,  453,  454,  455,  456,  457,  458,  459,  460,  461,
     8    462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
     9    472,  473,  474,  475,  476,  477,  478,  479,  480,  481/
            data (jb1(i),i= 3301, 3330)/
     +    482,  483,  484,  427,  486,  487,  488,  489,  490,  491,
     1    492,  493,  494,  495,  496,  497,  498,  499,  500,  501,
     2    486,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     1     47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
     2     57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
     3     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     4     77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
     5     87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     6     97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
     7    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     8    117,  118,  119,  120,  121,  122,  123,  124,  125,  126,
     9    127,  128,  129,  130,  131,  132,  133,  134,  158,  159/
            data (jb2(i),i=  101,  200)/
     +    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     1    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     2    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     3    190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
     4    200,  201,  202,  203,  204,  205,  206,  207,  208,  209,
     5    210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
     6    220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
     7    230,  231,  231,  237,  238,  239,  240,  241,  242,  243,
     8    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     9    254,  255,  256,  257,  258,  259,  260,  261,  262,  263/
            data (jb2(i),i=  201,  300)/
     +    264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
     1    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     2    284,  285,  286,  287,  288,  289,  290,  290,   10,  291,
     3    291,   14,   14,    5,    6,   11,   20,   20,   16,   19,
     4     18,  292,  292,  293,  294,  295,  296,  297,  298,  299,
     5    299,  300,  301,  302,  303,  303,  304,  305,  306,  307,
     6    308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
     7    318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
     8    328,  329,  330,  331,  331,  332,  333,  334,  335,  336,
     9    337,  338,  339,  339,  340,  341,  342,  343,  344,  345/
            data (jb2(i),i=  301,  400)/
     +    346,  346,  347,  348,  349,  350,  351,  352,  353,  354,
     1    355,  356,  357,  358,  359,  360,  361,  362,  363,  364,
     2    365,  366,  367,  368,  369,  370,  371,  372,  373,  374,
     3    375,  375,  376,  377,  378,  379,  380,  381,  382,  383,
     4    384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
     5    394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
     6    403,  404,  405,  405,  406,  407,  408,  409,  410,  411,
     7    412,  413,  414,  415,  416,  417,  418,  419,  420,  421,
     8    422,  423,  424,  424,  425,  426,  427,  428,  429,  430,
     9    431,  432,  433,  434,  434,  435,  436,  437,  438,  439/
            data (jb2(i),i=  401,  500)/
     +    440,  440,  441,  442,  443,  444,  445,  446,  447,  448,
     1    449,  450,  451,  452,  453,  454,  454,  455,  455,  456,
     2    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     3    467,  468,  469,  470,  471,  472,  473,  474,  475,  476,
     4    477,  478,  479,  480,  481,  482,  483,  484,  485,  486,
     5    487,  488,  489,  490,  491,  492,  493,  494,  495,  496,
     6    497,  498,  499,  500,  501,  502,  503,  504,  505,  506,
     7    507,  508,  509,  510,  511,  512,  513,  513,  514,  515,
     8    516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
     9    526,  527,  528,  529,  530,  531,  532,  533,  534,  535/
            data (jb2(i),i=  501,  600)/
     +    536,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     1    544,  545,  546,  547,  548,  549,  550,  550,  551,  552,
     2    553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
     3    563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
     4    573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
     5    583,  584,  585,  585,  586,  587,  588,  589,  590,  591,
     6    592,  593,  594,  595,  596,  597,  598,  599,  600,  601,
     7    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     8    612,  613,  614,  615,  616,  617,  618,  619,  620,  621,
     9    622,  623,  624,  625,  626,  627,  628,  629,  630,  631/
            data (jb2(i),i=  601,  700)/
     +    632,  633,  634,  635,  636,  637,  638,  639,  640,  641,
     1    642,  643,  644,  645,  646,  647,  648,  649,  649,  650,
     2    650,  651,  652,  653,  654,  655,  656,  657,  658,  659,
     3    660,  661,  662,  663,  664,  665,  666,  667,  667,  668,
     4    669,  670,  671,  672,  673,  674,  675,  676,  677,  678,
     5    679,  680,  681,  682,  683,  684,  685,  686,  687,  688,
     6    689,  690,  691,  692,  693,  694,  695,  696,  697,  698,
     7    699,  700,  701,  702,  703,  704,  705,  706,  707,  708,
     8    709,  710,  711,  712,  713,  714,  715,  716,  717,  718,
     9    719,  720,  721,  722,  723,  724,  725,  726,  727,  728/
            data (jb2(i),i=  701,  800)/
     +    729,  730,  731,  732,  733,  734,  735,  736,  737,  738,
     1    739,  740,  741,  742,  743,  744,  744,  745,  746,  747,
     2    748,  749,  750,  750,  751,  752,  753,  754,  755,  756,
     3    757,  758,  759,  760,  761,  762,  763,  764,  765,  766,
     4    767,  768,  769,  770,  771,  772,  773,  774,  775,  776,
     5    777,  778,  779,  780,  781,  782,  783,  784,  785,  786,
     6    787,  788,  789,  790,  791,  792,  793,  794,  795,  796,
     7    797,  798,  799,  800,  801,  802,  803,  804,  805,  806,
     8    807,  807,  808,  809,  810,  811,  812,  813,  814,  815,
     9    816,  817,  818,  819,  820,  821,  822,  823,  824,  825/
            data (jb2(i),i=  801,  900)/
     +    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     1    836,  837,  838,  839,  840,  841,  842,  843,  844,  845,
     2    846,  847,  848,  849,  850,  851,  852,  853,  854,  855,
     3    856,  857,  858,  859,  860,  861,  862,  863,  864,  865,
     4    866,  867,  868,  869,  870,  871,  872,  873,  874,  875,
     5    876,  877,  877,  142,  143,  878,  879,  880,  881,  882,
     6    883,  884,  885,  886,  887,  888,  889,  890,  891,  891,
     7    144,  154,  892,  893,  894,  895,  896,  897,  898,  899,
     8    900,  901,  902,  903,  904,  905,  906,  907,  908,  909,
     9    910,  911,  911,  912,  913,  914,  915,  916,  917,  918/
            data (jb2(i),i=  901, 1000)/
     +    919,  920,  921,  922,  923,  924,  924,  926,  927,  928,
     1    929,  930,  931,  932,  933,  934,  935,  936,  937,  938,
     2    939,  940,  941,  942,  943,  944,  945,  946,  947,  948,
     3    949,  950,  951,  952,  953,  954,  955,  956,  957,  958,
     4    959,  960,  961,  962,  963,  964,  965,  966,  967,  968,
     5    969,  970,  971,  972,  973,  974,  975,  976,  977,  978,
     6    979,  980,  981,  982,  983,  984,  985,  986,  987,  988,
     7    989,  990,  991,  992,  993,  994,  995,  996,  997,  998,
     8    999, 1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008,
     9   1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018/
            data (jb2(i),i= 1001, 1100)/
     +   1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028,
     1   1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1036, 1037,
     2   1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047,
     3   1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057,
     4   1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067,
     5   1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077,
     6   1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087,
     7   1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097,
     8   1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106, 1107,
     9   1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117/
            data (jb2(i),i= 1101, 1200)/
     +   1118, 1119, 1120, 1120, 1121, 1122, 1123, 1124, 1125, 1126,
     1   1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136,
     2   1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146,
     3   1147, 1148, 1149, 1150, 1151, 1152, 1153, 1154, 1155, 1156,
     4   1157, 1158, 1159, 1160, 1161, 1162, 1163, 1164, 1165, 1166,
     5   1167, 1168, 1169, 1170, 1171, 1172, 1173, 1174, 1175, 1176,
     6   1177, 1178, 1179, 1180, 1181, 1182, 1183, 1184, 1185, 1186,
     7   1187, 1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195, 1196,
     8   1197, 1197, 1198, 1199, 1200, 1201, 1202, 1203, 1204, 1205,
     9   1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213, 1214, 1215/
            data (jb2(i),i= 1201, 1300)/
     +   1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223, 1224, 1225,
     1   1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233, 1234, 1235,
     2   1236, 1237, 1238, 1238,  150, 1239, 1240, 1240,  150, 1241,
     3   1242, 1243, 1244, 1245, 1246, 1247, 1247, 1248, 1249, 1249,
     4    156,  151, 1250, 1251, 1252, 1253, 1254, 1255, 1256, 1257,
     5   1258, 1259, 1260, 1261, 1262, 1263, 1264, 1264, 1265, 1265,
     6   1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275,
     7   1276, 1277, 1278, 1278,  234, 1279, 1280, 1281, 1282, 1283,
     8   1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293,
     9   1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302/
            data (jb2(i),i= 1301, 1400)/
     +   1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312,
     1   1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322,
     2   1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1331,
     3    236,    1, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340,
     4   1341, 1342, 1343, 1344, 1345,    2, 1346, 1347, 1349, 1350,
     5   1351, 1352, 1353, 1354,    4, 1355, 1357, 1358, 1359, 1360,
     6      6, 1362, 1362, 1364, 1365, 1366, 1367, 1368, 1369, 1370,
     7   1371, 1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380,
     8   1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390,
     9   1391, 1392, 1393, 1394, 1394, 1395, 1396, 1397, 1398, 1399/
            data (jb2(i),i= 1401, 1500)/
     +   1400, 1401, 1402, 1403, 1404,    8, 1405, 1406, 1407, 1408,
     1   1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418,
     2   1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426,   10, 1427,
     3   1428, 1429,   11, 1430, 1431, 1432, 1433, 1434, 1435, 1436,
     4   1436, 1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446,
     5   1447, 1448, 1449, 1449, 1450, 1451, 1451, 1452, 1453, 1454,
     6   1455, 1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464,
     7   1464, 1465,   17, 1466, 1467, 1468, 1470,   19, 1469,   20,
     8   1471, 1472, 1472, 1473, 1475, 1476, 1477, 1477, 1478, 1479,
     9   1480, 1481, 1482, 1483, 1484, 1485, 1485, 1486, 1487, 1488/
            data (jb2(i),i= 1501, 1600)/
     +   1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497,
     1   1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507,
     2   1508, 1509, 1510, 1511, 1511, 1512, 1513, 1514, 1515, 1516,
     3   1516, 1517, 1518, 1519, 1520, 1521, 1522, 1523, 1523, 1525,
     4   1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535,
     5   1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544,
     6     22, 1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553, 1553,
     7   1554, 1555, 1556, 1558, 1558, 1559, 1560, 1561, 1562, 1563,
     8   1564, 1565, 1566, 1567,   23, 1568, 1569, 1570, 1571, 1573,
     9   1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583/
            data (jb2(i),i= 1601, 1700)/
     +   1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593,
     1   1594, 1595, 1596, 1597, 1598, 1599, 1600, 1600, 1601, 1602,
     2   1603, 1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612,
     3   1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622,
     4   1623, 1624, 1625, 1626, 1627, 1628, 1628, 1629, 1630, 1631,
     5   1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641,
     6   1641, 1643, 1643, 1644, 1644, 1646, 1647, 1648, 1649, 1650,
     7   1651, 1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659, 1660,
     8   1661, 1662, 1663, 1664, 1665, 1666, 1667, 1668, 1669, 1670,
     9   1671, 1672,   24, 1673, 1675, 1676, 1677, 1678, 1679, 1680/
            data (jb2(i),i= 1701, 1800)/
     +   1681, 1682, 1683, 1684, 1684, 1685, 1686, 1687, 1688, 1689,
     1   1690, 1691, 1692, 1693, 1693, 1695, 1696, 1697, 1698, 1698,
     2   1699, 1700, 1701, 1702, 1703, 1704, 1704, 1706, 1707, 1708,
     3   1708, 1710, 1711, 1712, 1713, 1714, 1714, 1716, 1717, 1718,
     4   1719, 1720,   25, 1722, 1723, 1724,   26, 1725, 1726, 1727,
     5   1728, 1728, 1730, 1731, 1732, 1733, 1734, 1735, 1736, 1736,
     6   1738, 1739, 1740, 1741, 1742, 1743, 1744,   28, 1745, 1746,
     7   1747, 1747, 1749, 1750, 1750, 1751, 1751, 1752, 1753, 1754,
     8   1755, 1756, 1758, 1759, 1760, 1761, 1762, 1763, 1764, 1765,
     9   1766, 1767, 1768, 1769, 1770, 1771, 1772, 1772, 1773, 1774/
            data (jb2(i),i= 1801, 1900)/
     +   1775, 1776, 1777, 1778, 1779, 1779, 1752, 1780, 1780, 1782,
     1   1782, 1783, 1785, 1786, 1786, 1784, 1788, 1788, 1789, 1790,
     2   1791, 1792, 1793, 1794, 1795, 1796, 1796, 1797, 1798, 1800,
     3   1801, 1802, 1802, 1803, 1804, 1805, 1806, 1807, 1808, 1809,
     4   1810, 1811, 1812, 1813, 1814,   29, 1816, 1817, 1818, 1819,
     5   1820, 1820, 1821, 1822, 1823, 1824, 1825, 1826, 1826, 1827,
     6   1828, 1829, 1830, 1831, 1832, 1833, 1834, 1834, 1835,   31,
     7   1837, 1838, 1839, 1839, 1840, 1841, 1842, 1843, 1844, 1844,
     8   1845, 1846, 1847, 1847, 1849, 1850, 1851, 1852, 1853, 1854,
     9   1855, 1855, 1857, 1858, 1859, 1860, 1861, 1862, 1863, 1864/
            data (jb2(i),i= 1901, 2000)/
     +   1865, 1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873, 1874,
     1   1875, 1876, 1877, 1878, 1878, 1879, 1880, 1881, 1882, 1883,
     2   1884, 1885, 1886, 1887, 1887, 1888, 1889, 1889, 1890, 1891,
     3   1892, 1893, 1894, 1895, 1896, 1897, 1898, 1899, 1900, 1901,
     4   1901, 1902, 1903, 1904, 1905, 1906, 1907, 1908, 1908, 1910,
     5   1911, 1912, 1913, 1914,   32, 1915, 1916, 1917, 1918, 1919,
     6   1920, 1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929,
     7   1930, 1931, 1932, 1932, 1933, 1934, 1935, 1936, 1937,   33,
     8   1938, 1939, 1940, 1941, 1942, 1943, 1944, 1945, 1946, 1947,
     9   1948, 1949, 1950, 1951, 1952, 1953, 1953, 1954, 1955, 1956/
            data (jb2(i),i= 2001, 2100)/
     +   1957, 1957, 1959, 1960, 1961, 1962, 1963, 1964, 1965, 1966,
     1   1967, 1967, 1969, 1970, 1971, 1972, 1973, 1974, 1975, 1976,
     2   1976, 1978, 1979, 1979, 1980, 1981, 1982, 1983, 1984, 1984,
     3   1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
     4   1996, 1997, 1997, 1999, 2000, 2001, 2002, 2003, 2004, 2005,
     5   2006, 2007, 2008, 2009, 2009, 1998, 2011, 2012, 2012, 2010,
     6   2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021,   35, 2022,
     7   2023, 2024, 2025, 2026, 2027, 2028, 2029, 2030, 2031, 2032,
     8   2033, 2034, 2035, 2036, 2037, 2038, 2039, 2040, 2040, 2041,
     9   2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049, 2050, 2051/
            data (jb2(i),i= 2101, 2200)/
     +   2052, 2053, 2054, 2055, 2056, 2057, 2058, 2059, 2060, 2061,
     1   2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069, 2070, 2071,
     2   2072, 2073, 2074, 2075, 2076, 2076, 2077, 2078, 2079, 2080,
     3   2081, 2081, 2082, 2084, 2084, 2083, 2085, 2086, 2087, 2088,
     4   2089, 2090, 2091, 2092, 2093, 2094, 2095, 2096, 2097, 2098,
     5   2099, 2099, 2100, 2100, 2102, 2103, 2104, 2105, 2106, 2107,
     6   2108, 2109, 2110, 2111, 2112, 2113, 2114, 2115, 2116, 2117,
     7   2118, 2119,   36, 2120, 2121, 2122, 2123, 2124, 2126, 2127,
     8   2128, 2129, 2130, 2131, 2132, 2133, 2134, 2135, 2135, 2137,
     9   2138, 2139, 2140, 2141, 2142, 2143, 2144, 2145, 2146, 2147/
            data (jb2(i),i= 2201, 2300)/
     +   2148, 2149, 2150, 2150, 2151, 2152, 2153, 2154, 2155, 2156,
     1   2157, 2158, 2159, 2160, 2161, 2162, 2163, 2164, 2165, 2166,
     2   2167, 2168, 2169, 2170, 2171, 2171, 2173, 2174, 2174, 2175,
     3   2176, 2177, 2178, 2180, 2181, 2181, 2182, 2183, 2184, 2185,
     4   2186, 2187, 2187, 2188, 2189, 2190, 2191, 2192, 2193, 2194,
     5   2195, 2196, 2197, 2198, 2199, 2200, 2200, 2202, 2203, 2204,
     6   2205, 2206, 2207, 2208, 2208, 2209, 2210, 2211, 2212, 2213,
     7   2214, 2215, 2216, 2217, 2218, 2218, 2219, 2220, 2221, 2222,
     8   2223, 2223, 2224, 2225, 2226, 2227, 2228, 2229, 2230, 2231,
     9   2232, 2233, 2234, 2235, 2236, 2237, 2238, 2239, 2240, 2240/
            data (jb2(i),i= 2301, 2400)/
     +   2241, 2242, 2243, 2244, 2245, 2246, 2247, 2248, 2248, 2250,
     1   2251, 2252, 2253, 2254, 2255, 2256, 2257, 2258, 2258, 2259,
     2   2260, 2261, 2262, 2263, 2263, 2264, 2265,  137, 2266, 2267,
     3   2267, 2269, 2270, 2271, 2272, 2273, 2274, 2275, 2276, 2276,
     4   2277, 2278, 2279, 2280, 2281, 2282, 2283, 2284, 2285, 2286,
     5   2287, 2288, 2289,  138, 2290, 2291, 2292, 2293, 2294, 2295,
     6   2296, 2297, 2298, 2299, 2300, 2301, 2302, 2303, 2304, 2305,
     7   2307, 2308, 2309, 2310, 2311, 2312, 2312, 2305, 2313, 2314,
     8   2315, 2316, 2317, 2318, 2319,  139, 2320, 2321, 2322, 2323,
     9   2324, 2325, 2326, 2327, 2328, 2329, 2330,  140, 2331, 2332/
            data (jb2(i),i= 2401, 2500)/
     +   2333, 2334, 2335, 2336, 2337, 2338, 2338, 2340, 2340, 2339,
     1   2342, 2343, 2344, 2345, 2346, 2347, 2347, 2348, 2349, 2350,
     2   2351, 2352, 2353, 2354, 2355, 2356,  141, 2357, 2358, 2358,
     3   2360, 2361, 2362, 2363, 2363, 2364, 2365, 2366, 2367, 2368,
     4   2369, 2370, 2371, 2372, 2373, 2374, 2375, 2375, 2376, 2377,
     5   2378, 2379, 2380, 2381, 2382, 2383, 2384, 2385, 2386, 2387,
     6   2388, 2389, 2389, 2390, 2391, 2392, 2393, 2394, 2395, 2396,
     7   2397, 2398, 2399, 2400, 2401, 2402, 2403, 2404, 2405, 2406,
     8   2406, 2407, 2408, 2409, 2410, 2411, 2412, 2413, 2414, 2415,
     9   2415, 2416, 2417, 2418, 2419, 2420, 2421, 2422, 2423, 2424/
            data (jb2(i),i= 2501, 2600)/
     +   2424, 2426, 2427, 2428, 2429, 2430, 2431, 2432, 2433, 2434,
     1   2435, 2436, 2436, 2437, 2438, 2439, 2440, 2441, 2442, 2443,
     2   2444, 2445, 2446, 2447, 2448, 2449, 2450, 2451, 2452, 2453,
     3   2454, 2454, 2455, 2456, 2457, 2458, 2459, 2459, 2460, 2461,
     4   2462, 2463, 2464, 2465, 2466, 2467, 2468, 2469, 2470, 2470,
     5   2471, 2472, 2473, 2474, 2475, 2476, 2477, 2478, 2479, 2480,
     6   2481, 2482, 2483, 2484, 2485,  149, 2486, 2487, 2488, 2489,
     7   2490, 2490, 2491, 2492, 2493, 2494, 2495, 2496, 2497, 2498,
     8   2499, 2500, 2501, 2502, 2502, 2503, 2504, 2505, 2506, 2507,
     9   2508, 2509, 2510, 2511, 2512, 2513, 2514, 2515, 2516, 2517/
            data (jb2(i),i= 2601, 2700)/
     +   2518, 2519, 2520, 2520, 2522, 2523, 2524, 2525, 2525, 2526,
     1   2527, 2528, 2529, 2530, 2531, 2532, 2533, 2534, 2535, 2535,
     2   2536, 2537, 2538, 2538, 2540, 2541, 2542, 2543, 2544, 2545,
     3   2546, 2547, 2548, 2549, 2550, 2551, 2552, 2553, 2554, 2555,
     4   2556, 2556, 2557, 2558, 2559, 2560, 2561, 2562, 2563, 2563,
     5   2565, 2566, 2567, 2568, 2569, 2570, 2571, 2572, 2573, 2574,
     6   2575, 2576, 2577, 2578, 2579, 2580, 2581, 2582, 2583, 2583,
     7   2584, 2585, 2586, 2587, 2588, 2589, 2590, 2590, 2591, 2592,
     8   2593, 2594, 2595, 2596, 2596, 2597, 2597, 2598, 2599,  155,
     9    156, 2601, 2602, 2602, 2604, 2605, 2606, 2607, 2608, 2608/
            data (jb2(i),i= 2701, 2800)/
     +   2609, 2610, 2611, 2612, 2613, 2614, 2614, 2615, 2616, 2616,
     1   2618, 2619, 2619, 2620, 2621, 2622, 2623, 2624, 2625, 2626,
     2   2627, 2628, 2629, 2630, 2631, 2631, 2632, 2633, 2634, 2634,
     3   2635, 2636, 2637, 2638, 2639, 2640, 2641, 2642, 2643, 2644,
     4   2645, 2646, 2647, 2648, 2649, 2650, 2651, 2652, 2653, 2654,
     5   2654, 2655, 2656, 2657, 2658, 2659, 2660, 2661, 2662, 2663,
     6   2664, 2665, 2666, 2667, 2668, 2669, 2670, 2671, 2672, 2673,
     7   2674,  233, 2675, 2676, 2677, 2678, 2679, 2680, 2681, 2682,
     8   2683, 2684, 2685, 2686,  234, 2687, 2688, 2689, 2690, 2691,
     9   2692, 2693, 2694, 2695, 2695, 2696, 2697, 2698, 2699, 2700/
            data (jb2(i),i= 2801, 2900)/
     +   2701, 2702, 2703, 2704, 2705, 2706, 2707, 2708, 2709, 2710,
     1   2711, 2712, 2713, 2714, 2715, 2716, 2717, 2718, 2718,    2,
     2      3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
     3     13,   14,   14,   16,   17,   18,   19,   20,   21,   22,
     4     22,   24,   25,   25,   27,   28,   28,   30,   31,   31,
     5     33,   34,   35,   36,   36,   38,   39,   40,   40,   42,
     6     43,   44,   45,   46,   47,   48,   49,   49,   51,   52,
     7     52,   54,   55,   55,   57,   58,   59,   60,   61,   62,
     8     62,   64,   65,   65,   67,   68,   68,   70,   71,   72,
     9     72,   74,   75,   76,   77,   77,   79,   80,   81,   82/
            data (jb2(i),i= 2901, 3000)/
     +     82,   84,   85,   85,   87,   88,   88,   90,   91,   91,
     1     93,   94,   95,   95,   97,   98,   98,  100,  101,  102,
     2    102,  104,  105,  105,  107,  108,  108,  110,  111,  111,
     3    113,  114,  115,  116,  116,  118,  119,  120,  121,  122,
     4    123,  124,  125,  126,  127,  128,  129,  130,  131,  132,
     5    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     6    143,  144,  144,  146,  147,  147,  149,  150,  151,  152,
     7    153,  154,  155,  155,  157,  158,  159,  160,  161,  162,
     8    163,  164,  165,  166,  167,  168,  169,  169,  171,  172,
     9    173,  174,  174,  176,  177,  178,  179,  180,  181,  181/
            data (jb2(i),i= 3001, 3100)/
     +    183,  184,  184,  186,  187,  188,  188,  190,  191,  191,
     1    193,  194,  195,  196,  196,  198,  199,  200,  200,  202,
     2    203,  203,  205,  206,  206,  208,  209,  209,  211,  212,
     3    212,  214,  215,  216,  217,  217,  219,  220,  220,  222,
     4    223,  224,  224,  226,  227,  227,  229,  230,  231,  232,
     5    233,  234,  234,  236,  237,  237,  239,  240,  241,  242,
     6    243,  244,  245,  246,  247,  248,  248,  250,  251,  251,
     7    253,  254,  254,  256,  257,  257,  259,  260,  261,  261,
     8    263,  264,  264,  266,  267,  267,  269,  270,  270,  272,
     9    273,  274,  275,  276,  277,  278,  279,  280,  281,  282/
            data (jb2(i),i= 3101, 3200)/
     +    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     1    293,  293,  295,  296,  296,  298,  299,  299,  301,  302,
     2    302,  304,  305,  306,  306,  308,  309,  310,  311,  312,
     3    313,  314,  315,  315,  317,  318,  318,  320,  321,  321,
     4    323,  324,  325,  325,  327,  328,  328,  330,  331,  331,
     5    333,  334,  335,  335,  337,  338,  338,  340,  341,  341,
     6    343,  344,  345,  346,  346,  348,  349,  349,  351,  352,
     7    352,  354,  355,  355,  357,  358,  358,  360,  361,  361,
     8    363,  364,  365,  365,  367,  368,  368,  370,  371,  372,
     9    373,  374,  375,  376,  377,  378,  379,  380,  381,  382/
            data (jb2(i),i= 3201, 3300)/
     +    383,  384,  385,  385,  387,  388,  388,  390,  391,  392,
     1    392,  394,  395,  395,  397,  398,  399,  399,  401,  402,
     2    402,  404,  405,  406,  406,  408,  409,  410,  411,  412,
     3    413,  414,  415,  416,  417,  418,  419,  420,  421,  421,
     4    423,  424,  425,  426,  426,  428,  429,  430,  431,  432,
     5    433,  434,  435,  436,  437,  438,  439,  440,  441,  442,
     6    443,  444,  445,  446,  447,  448,  449,  450,  451,  452,
     7    453,  454,  455,  456,  457,  458,  459,  460,  461,  462,
     8    463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
     9    473,  474,  475,  476,  477,  478,  479,  480,  481,  482/
            data (jb2(i),i= 3301, 3330)/
     +    483,  484,  485,  485,  487,  488,  489,  490,  491,  492,
     1    493,  494,  495,  496,  497,  498,  499,  500,  501,  502,
     2    502,    0,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine nd(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(840) :: jx,jy
            integer(kind=iknd), save, dimension(890) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'north dakota  '/
            data jrot,ipart/0,1/
            data kv/   1, 839,   0,   0,   0/
            data kb/   1, 891,   0,   0,   0/
            data iib/ 316,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  20400,14736,23640,31800,35856,45600,39096, 7872, 7656,50592,
     1  50568,50736,50520,50688,50592,50688,50640,50736,50640,50784,
     2  50760,50808,50760,50784,50904,50856,50952,50904,51000,50856,
     3  50832,50880,50712,50760,50688,50712,50616,50640,50592,50640,
     4  50496,50544,50448,50568,50376,50448,50424,50376,50424,50304,
     5  50328,50208,50184,50064,50088,50016,50088,50808,50832,50880,
     6  50928,50880,50760,50928,50784,50832,50760,50904,50904,50784,
     7  50880,50928,50808,50952,50880,50808,50928,50784,50856,50664,
     8  50784,50808,50664,50640,50808,50784,50688,50688,50880,50736,
     9  50832,50880,50856,50712,50832,50712,50832,50640,50736,50736/
            data (jx(i),i=  101,  200)/
     +  50808,50664,50832,50664,50664,50736, 7272, 6864,52536,52344,
     1  52296,52248,52320,52248,52248,52176,52248,52200,52080,52032,
     2  51864,51936,51888,51744,51648,51624,51504,51408,51360,51408,
     3  51336,51288,51072,51072,50952,50880,50928,50784,50928,50784,
     4  50784,50856,50760,52968,52920,52992,52896,52968,52896,52968,
     5  52896,52992,52920,52968,52872,52944,52848,52824,52920,52848,
     6  52848,52920,52872,52920,52872,52728,52824,52752,52824,52704,
     7  52800,52728,52824,52776,52848,52800,52848,52680,52680,52776,
     8  52728,52824,52728,52800,52680,52752,52800,52728,52632,52536,
     9  52584,53424,53448,53400,53424,53376,53424,53328,53304,53424/
            data (jx(i),i=  201,  300)/
     +  53352,53400,53472,53400,53448,53520,53448,53592,53544,53592,
     1  53520,53544,53424,53352,53328,53256,53304,53160,53136,53016,
     2  53160,53088,53184,53136,53088,53112,53064,53136,53064,53136,
     3  52992,53088,52992,53064,53040,53088,53016,52944,53040,52992,
     4  52920,52992,52944,53016, 6384,53472,53376,53424,53352,53400,
     5  53376,53448, 6240, 6048,12912,50712,19440,55104,55128,54984,
     6  55104,55104,54936,54960,54864,54888,54792,54792,54864,54792,
     7  54744,54792,54792,54720,54744,54624,54456,54456,54288,54216,
     8  54120,54120,54048,54024,53952,53976,53928,53976,53976,53904,
     9  53952,53808,53832,53784,53832,53760,53784,53712,53760,53712/
            data (jx(i),i=  301,  400)/
     +  53736,53640,53688,53640,53640,53544,53568,53496,53520,53448,
     1  53496,53424,29208,33336,45624,39096,20328,19512,19488,18984,
     2  18936,31968,31992,31776,14880,14928,14616,26280,26304,30360,
     3  30360,31152,14856,23808,23856,23568,45816,45792,45648,36024,
     4  43368,36048,35832,39288,39096,39288,26232,21336,21408,20304,
     5  20952,21000,20688,20808,20496,20544,37848,39288,36024,42120,
     6  41496,41424,41472,41280,41208,41112,40824,40752,40416,40392,
     7  40464,40656,40656,40584,40560,40584,40464,40464,40368,40416,
     8  40296,40248,40104,39912,39816,39864,39816,39744,39648,39624,
     9  39384,39168,39216,39144,39120,39120,39000,38832,38784,38664/
            data (jx(i),i=  401,  500)/
     +  38664,38376,38280,38160,37848,15024,15120,14784,45984,43560,
     1  43560,43392, 7416, 7488, 7584, 7656, 7800, 7992, 8304, 8448,
     2   8448, 8544, 8592, 8688, 8856, 8880, 8832, 8880, 8952, 9168,
     3   9312, 9432, 9264, 9288, 9648, 9864, 9960,10152,10224,10224,
     4  10104,10224,10440,10224,10224,10536,10776,11208,11448,12072,
     5  12216,12384,12456,12456,12336,12408,12648,12864,13296,13392,
     6  13416,14136,14448,14568,14736,16440,16368,16104,16008,15984,
     7  16032,15984,15456,15576,15576,15480,15168,16728,16704,33960,
     8  33984,33768,33816,42120,42744,42744,17688,17664,16056,15984,
     9  16104,16248,16584,26664,16056,26688,26400,26496,26208,16032/
            data (jx(i),i=  501,  600)/
     +  29088,31536,31560,31296,31368,31104,32352,42120,37248,42288,
     1  42144,17496,17088,16920,16536,16152,12864,13080,15984,28416,
     2  28488,29064,48816,46200,46152,46032,45552,18744,18528,18360,
     3  18432,18264,18264,18456,18480,17904,17784,18888,19008,18624,
     4  42288,37416,37416,37224,24672,24528,24408,24120,24024,24024,
     5  23832,23688,23544,23592,24000,23664,23472,22488,22344,22008,
     6  21816,21624,21168,20712,20448,20208,19872,19824,19872,19680,
     7  19008, 9264,32496,32568,32328,45768,45768,45600, 9264, 9456,
     8   9072,32016,42312,36048,37416,49056,49008,48888,47400,42528,
     9  42528,26544,26448,26352,26472,26424,26064,25824,25320,25104/
            data (jx(i),i=  601,  700)/
     +  25080,25032,24816,27888,27936,13176,13344,11712,11904,36216,
     1  36240,36024,16440,16440,19200,18888,21336,21432,24672,26664,
     2  26736,26952,27048,26712,26640,19104,32136,32184,31944, 7968,
     3   8016,28368,28464,28320,27960,27864,27648,27552,27480,27600,
     4  27600,27336,27264,27240,27384,27360,27096,26856,26856,26712,
     5  13680,19080,50256,47640,47592,47448,33216,45384,42744,42720,
     6  42552,38880,50304,28776,28728,28824,29064,28872,28872,28992,
     7  28992,28872,28656,28392,28200,28128,28008,28008,27936,27912,
     8  27840,27840,27576,27552,27312,27072,27048,26928,26880,26832,
     9  26544,26472,26496,26352,26376,26256,26184,26136,26040,25968/
            data (jx(i),i=  701,  800)/
     +  25992,26088,26040,25968,25896,25920,25752,13056,13536,25776,
     1  24168,24216,21528,21552,45576,45408,33384,33144,39096,38856,
     2  19536,19560,19248,19344,16296,16344,19464,19512,19632,19704,
     3  19728,19896,19968,20040,20088,20160,20208,20328,20472,20472,
     4  20520,20472,20520,20616,20760,20808,20952,21024,21072,21120,
     5  21096,21216,21312,21432,21456,21528,21528,21576,21648,21768,
     6  21792,21936,22128,22248,22392,22416,22536,22536,22632,22680,
     7  22728,22800,22848,22776,22920,22992,23112,23208,23208,23328,
     8  23424,23616,23664,23832,23784,23808,23928,24000,23952,24072,
     9  24120,24024,24072,24120,24192,24240,24288,24312,24432,24480/
            data (jx(i),i=  801,  840)/
     +  24504,24576,24600,24576,24648,24792,24768,24816,24768,24768,
     1  24936,24960,25032,25200,25224,25296,25392,25368,25296,25296,
     2  25488,25464,25704,50712,50520,50448,29256,29160,28896,28584,
     3  28584,28488,28632,28872,28944,28824,28992,29040,    0,    0/
            data (jy(i),i=    1,  100)/
     +  48456,48696,48312,48144,48072,48120,48072,49104,45648,43896,
     1  43968,43992,44064,44136,44256,44280,44400,44496,44544,44568,
     2  44640,44616,44712,44760,44736,44832,44976,45048,45240,45336,
     3  45384,45456,45624,45672,45720,45816,45888,45984,46080,46128,
     4  46248,46320,46296,46392,46464,46656,46896,46920,47016,47064,
     5  47184,47304,47544,47712,47808,47880,48216,40608,40848,40752,
     6  40800,40872,40872,40920,40968,41064,41088,41160,41256,41328,
     7  41352,41448,41544,41568,41712,41712,41856,41880,42000,42240,
     8  42288,42384,42384,42480,42576,42696,42672,42720,42720,42840,
     9  42840,42912,42960,42936,43080,43224,43248,43272,43344,43416/
            data (jy(i),i=  101,  200)/
     +  43392,43584,43680,43680,43776,43824,39672,33384,35736,36024,
     1  36168,36168,36240,36336,36480,36528,36552,36648,36720,36912,
     2  37008,37176,37200,37584,37632,38064,38256,38304,38544,38736,
     3  38832,39240,39504,39720,39792,40080,40104,40152,40320,40320,
     4  40416,40488,40536,31680,31704,31800,31920,31968,31992,32304,
     5  32448,32520,32568,32640,32736,32784,32808,32904,32928,32952,
     6  33024,33048,33168,33216,33312,33384,33504,33744,33936,33960,
     7  34008,34080,34104,34200,34224,34248,34296,34368,34416,34464,
     8  34536,34512,34704,34752,34752,34800,34968,35184,35256,35424,
     9  35496,27120,27264,27312,27360,27360,27432,27528,27720,27816/
            data (jy(i),i=  201,  300)/
     +  27888,27960,27960,28224,28320,28320,28512,28680,28728,28752,
     1  28800,28848,28776,28800,28944,28968,29160,29160,29496,29520,
     2  29712,29760,29832,29832,29904,30072,30168,30288,30312,30480,
     3  30600,30648,30888,30912,30960,31008,31272,31272,31344,31512,
     4  31512,31584,31632,31656,25992,25968,25992,26088,26232,26376,
     5  26448,26496,23544,20376,19992,19392,19704,19488,19536,20352,
     6  20688,20880,21480,21696,21792,22056,22248,22368,22416,22464,
     7  22632,22680,22824,22848,23136,23352,23400,23472,23640,23856,
     8  23952,24024,24024,24168,24192,24240,24288,24384,24456,24456,
     9  24504,24576,24720,24792,24816,24960,25128,25176,25224,25320/
            data (jy(i),i=  301,  400)/
     +  25416,25536,25584,25608,25680,25680,25752,25848,25896,25872,
     1  25920,25944,19416,19344,19296,19296,46608,46656,45840,45864,
     2  44232,43824,45456,45456,45240,46056,46080,43968,44760,44664,
     3  43848,43824,44424,44040,45672,45672,43824,45456,45456,43776,
     4  43800,45408,45408,43776,45408,45384,43152,43296,45768,45792,
     5  37584,39216,39240,42504,42528,44136,42144,42144,42144,37872,
     6  37872,38040,38112,38328,38640,38712,38592,38424,38208,38280,
     7  38376,38520,38736,38784,38880,38688,38712,38928,39144,39192,
     8  39240,39264,39048,38976,39024,38904,38760,38904,38880,38664,
     9  38688,38592,38808,38808,38880,39144,39168,39024,38880,38880/
            data (jy(i),i=  401,  500)/
     +  39672,39672,39960,39960,40128,40440,42768,42792,40536,40512,
     1  42144,42144,39576,39384,39408,39528,39528,39240,39312,39528,
     2  39744,39696,39432,39408,39672,39816,40008,40152,40152,40008,
     3  40056,40176,40416,40488,40704,40584,40584,40800,40752,40680,
     4  40560,40392,40296,40032,39912,39816,39552,39792,39672,39816,
     5  39984,39984,40032,40176,40272,40416,40608,40656,40728,40704,
     6  40560,40608,40464,40464,40560,39336,39624,39552,39600,39696,
     7  39792,39960,40104,40248,40320,40440,40368,39120,39192,37248,
     8  38880,38904,42168,38880,38880,40512,37704,36864,37584,37872,
     9  38376,38568,38856,37392,37368,39024,39048,42312,42336,37344/
            data (jy(i),i=  501,  600)/
     +  37320,37296,38928,38928,42192,42216,37272,37248,37224,35592,
     1  35592,36816,36960,37104,37128,37392,33024,36288,36144,32448,
     2  35688,35688,35688,35640,38904,38904,35640,35064,35352,35712,
     3  36480,36744,36816,36864,37032,37248,37128,29784,32736,32784,
     4  34800,34776,35592,35592,31992,32040,32184,32232,32568,32928,
     5  33144,33648,33864,34032,34368,34776,34800,34512,34488,34608,
     6  34584,34536,34248,34344,34560,34656,34656,34704,34872,35064,
     7  34968,33240,32376,35616,35640,31560,32376,32376,26664,29928,
     8  29976,32376,32352,32328,32328,31608,32400,32424,31584,31536,
     9  32328,30888,30984,31248,31608,31824,32136,32208,32136,32040/
            data (jy(i),i=  601,  700)/
     +  31848,31776,31872,30864,32448,29760,33000,26520,29832,25800,
     1  29064,29064,29592,29856,29472,29496,29400,31848,31752,29256,
     2  29352,29472,29736,30240,30672,27000,25848,29112,29112,25896,
     3  26736,25920,26208,26232,26088,26472,26400,26472,26736,26784,
     4  26904,26928,27000,27240,27456,27600,27888,28464,28920,29088,
     5  26424,26184,25896,25848,29136,29136,25824,25800,25776,29064,
     6  29064,25776,22632,23976,24264,24600,24912,25272,25320,25368,
     7  25440,25536,25608,23832,23856,23712,23712,23592,23544,23616,
     8  23616,23736,23712,23640,23616,23688,23784,23712,23832,23832,
     9  23592,23424,23304,23280,23208,23064,23088,22992,23064,23040/
            data (jy(i),i=  701,  800)/
     +  22896,22872,22800,22824,22728,22632,22656,23160,23112,23520,
     1  23568,25992,26088,26904,22536,22536,22536,22536,22512,22512,
     2  22176,22896,22896,26160,22296,23016,20736,20760,20688,20760,
     3  20712,20856,20760,20736,20808,20760,20880,20808,20880,20784,
     4  20760,20640,20472,20544,20400,20520,20544,20496,20568,20568,
     5  20448,20544,20400,20400,20352,20352,20280,20304,20280,20304,
     6  20400,20448,20232,20376,20208,20304,20256,20424,20376,20400,
     7  20328,20376,20472,20544,20688,20592,20664,20592,20664,20664,
     8  20832,20808,20760,20856,20904,20952,21000,20952,21024,21072,
     9  21168,21240,21312,21288,21336,21312,21360,21288,21408,21360/
            data (jy(i),i=  801,  840)/
     +  21408,21360,21432,21480,21504,21432,21552,21624,21648,21792,
     1  21864,21936,21912,22056,22008,22056,22200,22320,22296,22344,
     2  22488,22584,22584,19944,19968,22632,19560,19848,20064,20592,
     3  21000,21168,21744,21960,22200,22560,22968,23328,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    1,    3,    4,    6,    5,    2,    8,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,    6,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   97,   98,   99,  100,  101/
            data (jb1(i),i=  101,  200)/
     +    102,  103,  104,  105,   10,    9,  107,  109,  110,  111,
     1    112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
     2    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     3    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     4    142,   58,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  109,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb1(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     4    242,  243,  144,  108,  246,  247,  248,  249,  250,  251,
     5    192,  245,  253,  254,  255,  256,  258,  259,  260,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     9    292,  293,  294,  295,  296,  297,  298,  299,  300,  301/
            data (jb1(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     1    246,  257,  313,  256,  314,  315,  317,  318,  319,  320,
     2      1,  322,  323,    4,    9,  325,  326,    2,  328,  329,
     3    330,  331,  325,  321,  328,  334,  335,    3,  322,   10,
     4    337,  338,    6,  322,  337,  340,  342,    5,  341,    7,
     5    345,  344,  347,  348,  349,  317,  328,  351,  352,  353,
     6    354,  355,  321,  357,  344,  340,  357,  360,  361,  362,
     7    363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
     8    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     9    383,  384,  385,  386,  387,  388,  389,  390,  391,  392/
            data (jb1(i),i=  401,  500)/
     +    393,  394,  395,  396,  397,  398,  399,  400,  401,  402,
     1    403,  404,  357,  406,  407,  333,   58,  409,  410,  411,
     2    341,  107,  413,  414,  415,  416,  417,  418,  419,  420,
     3    421,  422,  423,  424,  425,  426,  427,  428,  429,  430,
     4    431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
     5    441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
     6    451,  452,  453,  454,  455,  456,  457,  458,  459,  460,
     7    461,  462,  463,  464,  406,  466,  467,  468,  469,  470,
     8    471,  472,  473,  474,  475,  476,  406,  478,  466,  480,
     9    481,  482,  359,  360,  484,  485,  410,  351,  487,  489/
            data (jb1(i),i=  501,  600)/
     +    490,  491,  492,  478,  351,  489,  494,  496,  497,  498,
     1    347,  495,  494,  502,  503,  504,  505,  332,  501,  502,
     2    480,  360,  508,  480,  510,  508,  488,  512,  513,  514,
     3    515,  489,  517,  518,  500,  520,  521,  501,  109,  523,
     4    524,  525,  409,  524,  510,  528,  529,  530,  531,  532,
     5    533,  534,  535,  536,  488,  538,  539,  528,  510,  541,
     6    542,  543,  509,  545,  546,  547,  548,  549,  550,  551,
     7    552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
     8    562,  563,  564,  565,  566,  567,  568,  569,  570,  528,
     9    108,  573,  574,  507,  517,  576,  577,  527,  579,  580/
            data (jb1(i),i=  601,  700)/
     +    572,  520,  573,  541,  573,  583,  542,  584,  144,  586,
     1    587,  523,  586,  576,  576,  590,  583,  592,  593,  594,
     2    595,  596,  597,  598,  599,  600,  601,  602,  545,  592,
     3    604,  520,  606,  517,  608,  606,  610,  611,  584,  606,
     4    613,  538,  615,  538,  617,  618,  545,  615,  620,  621,
     5    622,  623,  624,  592,  617,  615,  627,  628,  582,  245,
     6    630,  579,  632,  633,  634,  635,  636,  637,  638,  639,
     7    640,  641,  642,  643,  644,  645,  646,  647,  648,  649,
     8    620,  579,  608,  626,  651,  627,  246,  653,  654,  655,
     9    589,  627,  654,  610,  658,  659,  660,  590,  610,  659/
            data (jb1(i),i=  701,  800)/
     +    653,  664,  665,  666,  667,  668,  669,  670,  671,  672,
     1    632,  664,  674,  675,  676,  677,  678,  679,  680,  681,
     2    682,  683,  684,  685,  686,  687,  688,  689,  690,  691,
     3    692,  693,  694,  695,  696,  697,  698,  699,  700,  701,
     4    702,  703,  704,  705,  706,  253,  651,  708,  707,  710,
     5    711,  712,  713,  626,  663,  715,  658,  717,  657,  719,
     6    662,  717,  716,  721,  722,  723,  652,  721,  725,  709,
     7    721,  727,  728,  729,  730,  731,  732,  733,  734,  735,
     8    736,  737,  738,  739,  740,  741,  742,  743,  744,  745,
     9    746,  747,  748,  749,  750,  751,  752,  753,  754,  755/
            data (jb1(i),i=  801,  890)/
     +    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     1    766,  767,  768,  769,  770,  771,  772,  773,  774,  775,
     2    776,  777,  778,  779,  780,  781,  782,  783,  784,  785,
     3    786,  787,  788,  789,  790,  791,  792,  793,  794,  795,
     4    796,  797,  798,  799,  800,  801,  802,  803,  804,  805,
     5    806,  807,  808,  809,  810,  811,  812,  813,  814,  815,
     6    816,  817,  818,  819,  820,  821,  822,  707,  708,  256,
     7    824,  825,  663,  727,  313,  827,  828,  829,  830,  831,
     8    832,  833,  834,  835,  836,  837,  664,  717,  719,  715/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    7,    7,    8,    9,   11,   12,
     1     13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
     2     23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
     3     33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
     4     43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
     5     53,   54,   55,   56,   57,   57,   59,   60,   61,   62,
     6     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     7     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     8     83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
     9     93,   94,   95,   96,   97,   98,   99,  100,  101,  102/
            data (jb2(i),i=  101,  200)/
     +    103,  104,  105,  106,  106,  107,  108,  110,  111,  112,
     1    113,  114,  115,  116,  117,  118,  119,  120,  121,  122,
     2    123,  124,  125,  126,  127,  128,  129,  130,  131,  132,
     3    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     4    143,  143,  145,  146,  147,  148,  149,  150,  151,  152,
     5    153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     6    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     7    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     8    183,  184,  185,  186,  187,  188,  189,  190,  191,  191,
     9    193,  194,  195,  196,  197,  198,  199,  200,  201,  202/
            data (jb2(i),i=  201,  300)/
     +    203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
     1    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     2    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     3    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     4    243,  244,  244,  245,  247,  248,  249,  250,  251,  252,
     5    252,  253,  254,  255,  257,  258,  259,  260,  261,  262,
     6    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     7    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     8    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     9    293,  294,  295,  296,  297,  298,  299,  300,  301,  302/
            data (jb2(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
     1    312,  313,  314,  315,  316,  316,  318,  319,  320,  321,
     2    317,  323,  324,  324,  325,  326,  327,  327,  329,  330,
     3    331,  332,  333,  333,  334,  335,  336,  336,  332,  337,
     4    338,  339,  339,  340,  341,  342,  343,  343,  344,  345,
     5    346,  346,  348,  349,  350,  350,  347,  352,  353,  354,
     6    355,  356,  356,  358,  358,  359,  359,  361,  362,  363,
     7    364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
     8    374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
     9    384,  385,  386,  387,  388,  389,  390,  391,  392,  393/
            data (jb2(i),i=  401,  500)/
     +    394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
     1    404,  405,  405,  407,  408,  408,  409,  410,  411,  412,
     2    412,  413,  414,  415,  416,  417,  418,  419,  420,  421,
     3    422,  423,  424,  425,  426,  427,  428,  429,  430,  431,
     4    432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
     5    442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
     6    452,  453,  454,  455,  456,  457,  458,  459,  460,  461,
     7    462,  463,  464,  465,  465,  467,  468,  469,  470,  471,
     8    472,  473,  474,  475,  476,  477,  477,  479,  479,  481,
     9    482,  483,  483,  484,  485,  486,  486,  487,  488,  490/
            data (jb2(i),i=  501,  600)/
     +    491,  492,  493,  493,  494,  495,  496,  497,  498,  499,
     1    499,  500,  501,  503,  504,  505,  506,  506,  502,  507,
     2    507,  508,  509,  509,  511,  511,  512,  513,  514,  515,
     3    516,  516,  518,  519,  519,  521,  522,  522,  523,  524,
     4    525,  526,  526,  527,  527,  529,  530,  531,  532,  533,
     5    534,  535,  536,  537,  537,  539,  540,  540,  541,  542,
     6    543,  544,  544,  546,  547,  548,  549,  550,  551,  552,
     7    553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
     8    563,  564,  565,  566,  567,  568,  569,  570,  571,  571,
     9    572,  574,  575,  575,  572,  577,  578,  578,  580,  581/
            data (jb2(i),i=  601,  700)/
     +    581,  582,  582,  583,  584,  585,  585,  585,  586,  587,
     1    588,  588,  589,  589,  590,  591,  591,  593,  594,  595,
     2    596,  597,  598,  599,  600,  601,  602,  603,  603,  604,
     3    605,  605,  607,  607,  609,  609,  611,  612,  612,  613,
     4    614,  614,  616,  616,  618,  619,  619,  617,  621,  622,
     5    623,  624,  625,  625,  620,  626,  628,  629,  629,  630,
     6    631,  631,  633,  634,  635,  636,  637,  638,  639,  640,
     7    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     8    650,  608,  651,  652,  652,  632,  653,  654,  655,  656,
     9    656,  657,  658,  657,  659,  660,  661,  661,  662,  662/
            data (jb2(i),i=  701,  800)/
     +    663,  665,  666,  667,  668,  669,  670,  671,  672,  673,
     1    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     2    683,  684,  685,  686,  687,  688,  689,  690,  691,  692,
     3    693,  694,  695,  696,  697,  698,  699,  700,  701,  702,
     4    703,  704,  705,  706,  707,  708,  709,  709,  710,  711,
     5    712,  713,  714,  714,  715,  716,  716,  718,  718,  720,
     6    720,  720,  719,  722,  723,  724,  724,  725,  726,  726,
     7    727,  728,  729,  730,  731,  732,  733,  734,  735,  736,
     8    737,  738,  739,  740,  741,  742,  743,  744,  745,  746,
     9    747,  748,  749,  750,  751,  752,  753,  754,  755,  756/
            data (jb2(i),i=  801,  890)/
     +    757,  758,  759,  760,  761,  762,  763,  764,  765,  766,
     1    767,  768,  769,  770,  771,  772,  773,  774,  775,  776,
     2    777,  778,  779,  780,  781,  782,  783,  784,  785,  786,
     3    787,  788,  789,  790,  791,  792,  793,  794,  795,  796,
     4    797,  798,  799,  800,  801,  802,  803,  804,  805,  806,
     5    807,  808,  809,  810,  811,  812,  813,  814,  815,  816,
     6    817,  818,  819,  820,  821,  822,  823,  823,  255,  824,
     7    825,  826,  826,  257,  827,  828,  829,  830,  831,  832,
     8    833,  834,  835,  836,  837,  838,  838,  314,  316,  315/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine oh(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(950) :: jx,jy
            integer(kind=iknd), save, dimension(1040) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'ohio          '/
            data jrot,ipart/0,2/
            data kv/   1, 914, 951,   0,   0/
            data kb/   1,1001,1038,   0,   0/
            data iib/ 404,  37,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  49608,50688,51624,51816,52008,52296,52704,54888,54936,25944,
     1  25392,25200,25224,24576,24216,24264,24360,24432,24120,24072,
     2  24024,23832,23040,22608,22632,22800,22824,22704,22536,22464,
     3  22464,18048,44280,44808,45432,46512,46776,47136,48312,26952,
     4  27384,27456,27576,27744,27864,27936,28128,28368,28872,29400,
     5  29592,29736,29976,30216,30456,30744,30864,30888,30792,30888,
     6  30888,30792,30408,29688,29688,29976,29808,29640,29544,29328,
     7  29064,29064,29280,29448,29640,29712,29568,29448,29280,29328,
     8  29208,29088,28824,28392,28008,27528,27288,26904,26448,12432,
     9  43824,43392,42480,41520,41424,40872,40296,39960,39408,39000/
            data (jx(i),i=  101,  200)/
     +   7776,26952,27048,27192,27456,27600,27696,27624,27648,27720,
     1  27840,27912,27936,27864,27816,27936,28032,28176,28320,28464,
     2  28728,34824,35760,36648,37320,38520,34608,33480,33144,32136,
     3  31080,31056,31152,31656,31992,32016,31656,31560,31488,31512,
     4  31392,31200,31344,31368,31080,30912,30672,30696,30648,30600,
     5  30288,29928,29784,29688,29616,29496,29208,28968, 7680,54960,
     6   7536,54984, 7392,53376,52968,51672,49224,41448,41088,11832,
     7  37104,34920,14736,28824,18648,23664, 7944,54984,54648,54360,
     8  54048,53832,53424, 7104,53400,53616,53808,53904,54144,53976,
     9  53952,53784,54024,54000,54120,53928,53928,53520,53328, 6744/
            data (jx(i),i=  201,  300)/
     +  52896,52920,52656,52584,52656,52560,52584,52296,52416,52296,
     1  52032,51840,51840,52008,52032,51888, 6504,51600,51648,51600,
     2  51168,51120,51192,51408,51576,51480,51192,51144,51048,50880,
     3  50424, 6288,48624,48192,47736,47592,47328,47184,46800,46536,
     4  45696,45432,45288,45168,45048,44856,44664,44448,44040,43488,
     5  43368,43200,42720,42264,42048,41856,41784,41784, 6192, 6600,
     6   6888, 7032, 7272, 7728, 8040, 8376, 8568, 9072, 9288, 9600,
     7   9768,10080,10248,10416,10536,10536,10632,10824,11448,35184,
     8  35736,35928,36120,36192,36240,36216,36024,36120,36000,35976,
     9  35736,35712,35928,36384,36576,36648,36624,36816,37272,37728/
            data (jx(i),i=  301,  400)/
     +  37848,38016,38208,38328,38520,38880,39024,39384,39048,39120,
     1  39312,39504,39888,40008,40032,40248,40440,40728,40944,40992,
     2  40968,40752,40800,40944,40968,40848,40512,40416,40464,40704,
     3  40944,41160,41232,41232,14352,13608,13008,12864,12696,12744,
     4  12672,12120,12000,15816,16296,16896,17040,17184,17736,17952,
     5  18504,23448,23256,23064,22944,22704,22272,21480,21000,20808,
     6  20592,19632,19488,19368,19200,19008,28584,28392,28344,28152,
     7  28248,28152,27984,27504,27024,26688,26472,26088,25464,25248,
     8  24984,24384,24048,23904,34824,34800,34632,34512,34416,34248,
     9  33888,33456,32064,31824,31656,31368,31272,31200,31080,30672/
            data (jx(i),i=  401,  500)/
     +  30432,30192,29880,29232,49608,23160,44280,45360,46392,46416,
     1  48528,48528,12912,12936,12504,12576,12384,23112,18096,18048,
     2  17976,49608,12888,23952,23952,17928,18096,18888,19128,19368,
     3  19800,20016,21024,21456,45336,43176,43176,43248,43488,43440,
     4  42096,45336,45528,45528,45504,45336,49608,29328,29352,34848,
     5  22968,39960,39984,38952,29352,49608,11520,11496,12768,12744,
     6  13992,14136,17832,22920,34872,38928,38904,37800,37776,36720,
     7  36696,48696,49608,12000,12648,22848,26256,29400,30552,29040,
     8  29136,33792,33768,36648,37152,42024,45288,48672,17712,42456,
     9  42480,12576,12600,11976,44976,45024,16440,16440,15168,15144/
            data (jx(i),i=  501,  600)/
     +  50784,50784,51624,51600,17664,22464,22416,22200,22176,21768,
     1  21720,34344,34344,34200,34224,34008,34008,33912,33936,34320,
     2  11208,11232,12576,11928,11880,48672,30432,26184,28992,28992,
     3  22728,22512,22512,21888,21936,24000,24024,17592,15072,15072,
     4  13800,13800,37128,42432,34752,34752,34320,46104,46968,47016,
     5  47424,47424,42408,44448,44544,44760,44784,51168,51192,50544,
     6  50544,52464,52464,17544,36048,36048,31560,31560,31344,31344,
     7  31560,31560,34320,46632,46704,46056,21528,21552,17592,17544,
     8  22680,22728,17184,16272,16248,16152,24576,24552,36504,36432,
     9  27072,27144,27792,27864,28944,41736,42264,42168,50280,50304/
            data (jx(i),i=  601,  700)/
     +  50472,50520,51168,12384,12336,11280,11256,11016,27072,28152,
     1  28080,30144,31248,31440,31320,31320,15912,15984,16056,30048,
     2  21072,18456,18480,36240,34656,33120,33120,15768,11184,13584,
     3  13584,42672,42744,41688,45864,45912,46560,36336,36408,47112,
     4  47112,48384,48432,50952,45840,25320,25320,24480,51072,51120,
     5  51144,41616,52248,52272,42168,42120,29880,21552,21720,24888,
     6  25296,15552,21408,29592,29640,29712,47016,33072,33192,45720,
     7  45720,45312,45288,44448,44424,43128,43104,41832,15312,14016,
     8  14064,11112,35760,35784,36168,33696,33696,15264,16536,16512,
     9  17808,17760,18768,18768,19824,19800,14448,14808,15240,46968/
            data (jx(i),i=  701,  800)/
     +  41880,41448,24816,24264,24240,24312,24192,24288,24360,24480,
     1  24504,24312,24360,29280,29232,29448,29400,29328,29136,29088,
     2  20472,21456,21456,46128,46032,46488,46440,37512,37560,36456,
     3  36576,41784,19704,24216,37800,37872,38088,37464,34128,34248,
     4  33816,33912,33048,34056,35376,35352,36528,12432,11592,15984,
     5  46440,45600,45624,45168,45168,44976,44976,44544,44544,44304,
     6  44280,42984,43032,42384,42432,19440,30072,30072,31320,31368,
     7  32736,32808,28800,46656,46632,46920,49248,37680,40080,24000,
     8  29928,27192,27264,27264,27072,27024,41856,41568,41544,41472,
     9  41472,41664,41640,41040,41040,40776,40776,40344,40296,41472/
            data (jx(i),i=  801,  900)/
     +  40344,40368,40176,40176,39960,20280,20520,35016,35136,36432,
     1  22752,32472,32448,31104,31080,29808,15504,12624,22896,23016,
     2  22968,23016,22632,22464,22608,22608,22680,22584,22560,22704,
     3  22656,15648,17088,18000,17904,17712,17424,17448,29616,34896,
     4  35352,35232,29328,29544,22464,12120,12240,12384,12312,12000,
     5  11904,12144,12264,12504,19176,16944,19896,30888,30864,32184,
     6  32136,33432,33288,23760,23280,34584,34800,29040,24048,24144,
     7  24192,24408,24432,26736,37152,34560,29640,29544,30792,31656,
     8  33024,31656,34032,34128,32784,32856,32640,32688,31560,15528,
     9  29688,29424,29448,30096,30168,30264,30624,10440,10320,10320/
            data (jx(i),i=  901,  950)/
     +  11592,11664,11952,11592, 8328, 8448, 9648, 9864,10104,10320,
     1  12624,12576,12672,30024,29760,29664,29784,29808,29904,30168,
     2  30144,29736,29808,29856,29856,29808,29664,29592,31008,30912,
     3  30768,30720,30624,30696,30816,31008,31272,31224,31320,31104,
     4  31008,29832,30024,29928,29520,29448,29472,29592,29688,29784/
            data (jy(i),i=    1,  100)/
     +  58392,58632,59040,59184,59160,59328,59376,60240,53232,55368,
     1  55584,55584,55704,56184,56256,56328,56304,56328,56592,56616,
     2  56448,56352,56424,56760,56832,56928,57024,57024,56928,56928,
     3  57024,56976,55176,55800,56352,57048,57000,57144,57816,52872,
     4  52944,52920,52992,52920,53040,52992,53328,53280,53280,53472,
     5  53304,53496,53520,53472,53592,53568,53328,53400,53688,53808,
     6  53976,54048,54096,53904,54024,54120,54408,54264,54024,53856,
     7  53784,53832,53928,54096,54432,54480,54768,54744,54624,54312,
     8  54072,53928,53760,53736,53880,54216,54456,55008,55248,57000,
     9  54912,54480,53736,53136,53112,53232,53088,53088,53184,53352/
            data (jy(i),i=  101,  200)/
     +  53064,52800,52752,52728,52800,52704,52680,52536,52440,52584,
     1  52512,52536,52608,52656,52776,52824,52752,52440,52344,52320,
     2  52440,52320,52344,52920,53184,53520,52272,51672,51648,52224,
     3  53280,53160,53112,52536,52248,52176,52416,52416,52536,52656,
     4  52584,52632,52680,52728,52752,52848,52728,52872,52872,52680,
     5  52632,52968,53040,53016,53088,52776,52608,52632,50544,47880,
     6  46680,44472,42864,39840,33624,29136,24600,19896,19392,17736,
     7  16104,10728,13968,10656,11904,11424,57024,40656,40536,40320,
     8  40488,40392,40008,37392,39720,39480,39168,38760,38280,37680,
     9  37272,37104,36816,36432,36048,35592,35256,34920,34224,31032/
            data (jy(i),i=  201,  300)/
     +  33288,32856,32592,32424,32112,31536,30984,30576,30072,30000,
     1  30120,30096,29928,29568,29424,29256,25920,29016,28632,28440,
     2  28008,27888,27696,27456,27120,26976,26784,26208,25872,25704,
     3  25680,22080,23952,23256,23136,23040,22728,22368,22392,22320,
     4  21768,21696,21744,21864,22296,22584,22704,22680,22200,21912,
     5  21768,20640,20784,20808,20760,20616,20496,20016,19200,19320,
     6  19680,19752,19608,19032,18912,18624,18600,18768,18936,18816,
     7  18864,19176,19248,19152,18960,18480,18216,18120,18000,10944,
     8  10824,10848,10968,11088,11280,11544,12168,12576,12984,13224,
     9  13488,13728,13992,14232,14472,14760,15264,15504,16440,16752/
            data (jy(i),i=  301,  400)/
     +  17136,17208,17160,17064,16680,16704,16584,15768,15264,15144,
     1  14976,14928,15216,15408,15744,15960,15912,15648,15648,15744,
     2  15840,16224,16416,16728,16992,17184,17496,17880,17976,17904,
     3  17952,18144,18360,18720,14016,14328,14472,14592,15024,15600,
     4  15840,16776,17400,14160,13896,13728,13584,13104,12816,12144,
     5  12000,11208,11160,11328,11784,11952,12144,12288,12696,12768,
     6  12768,12480,12312,11832,11712,11712,10848,11184,12048,12432,
     7  13056,13272,13344,13224,12936,13008,12960,12480,12168,11712,
     8  11472,11400,11568,11592,10584,10176, 9312, 8856, 8760, 8664,
     9   8592, 8640, 8160, 8136, 8160, 8352, 8592, 9072, 9216, 9456/
            data (jy(i),i=  401,  500)/
     +   9792,10224,10440,10464,56376,55344,54264,54264,54264,55296,
     1  55296,56376,53736,54144,54168,55680,55680,53616,55464,55488,
     2  53568,53256,52896,53592,52968,52560,52536,52896,53184,53280,
     3  53592,54192,54768,55368,51024,51072,50808,50544,50040,50016,
     4  50016,52152,52152,52272,52440,52440,51000,52440,50376,50184,
     5  50016,49992,51096,51120,49872,47880,50400,49752,49704,49056,
     6  49008,52848,48912,48744,47016,49992,48912,48936,48000,48024,
     7  46944,45744,45744,46512,46512,46176,46104,46104,46056,46056,
     8  46104,45960,47016,45912,45888,45792,45768,44496,45288,44712,
     9  45792,44568,45216,45240,44568,45768,45336,45120,45144,44520/
            data (jy(i),i=  501,  600)/
     +  44496,44904,44904,44472,43824,46200,45552,45576,44928,44952,
     1  43680,42408,42936,43080,43248,43248,43344,43344,45960,42264,
     2  42072,42720,43944,43968,42048,41952,41904,41880,41832,41952,
     3  41736,41736,41952,41976,43656,41688,41904,41256,41328,41544,
     4  41568,42000,41160,41112,39552,42048,42072,40848,40824,41904,
     5  41880,41976,40608,40920,41064,41016,40872,40080,40704,40728,
     6  41952,40056,39840,39720,39720,41160,39528,40800,40800,41232,
     7  41232,41856,39480,37656,39576,39600,39096,39168,39600,39624,
     8  39072,39216,39672,39696,38928,38952,39048,38112,39768,38088,
     9  37920,38664,38736,40992,40992,37848,40608,37848,37536,38160/
            data (jy(i),i=  601,  700)/
     +  38160,39456,39432,39048,37560,37584,37248,37320,37704,37608,
     1  36792,36624,36528,39120,39120,39528,35904,36528,36480,35568,
     2  35088,35400,35616,34896,34944,35040,35328,34584,34944,34896,
     3  34824,34584,36720,36768,34464,35784,35760,33840,34896,33816,
     4  33840,33816,33768,33648,33840,33696,35184,35208,36816,36864,
     5  37488,33576,33576,33648,34608,33576,33360,33336,35016,33192,
     6  33168,32496,31872,30648,31176,31176,30624,30360,30432,30648,
     7  30600,30600,30192,30216,29784,29832,28992,29040,30168,30288,
     8  30816,30888,30144,30696,30672,30384,30312,29712,29592,29376,
     9  29232,28872,28704,28608,28488,28440,25776,29544,29520,29400/
            data (jy(i),i=  701,  800)/
     +  30336,30360,32328,32376,32256,31968,31752,31536,30984,30792,
     1  30552,30432,28920,30672,30240,30216,29544,28944,28968,28536,
     2  28368,31776,31872,29424,27048,27048,25584,28056,28704,28776,
     3  30072,27792,27624,27192,24816,24816,27360,27408,26400,27672,
     4  27720,29016,29088,25560,25440,25008,24912,26016,26040,25584,
     5  25368,25392,25488,25512,25704,25728,25944,25944,26160,26160,
     6  25248,25296,26424,26472,27744,25200,25008,25200,25104,25776,
     7  25656,26520,25128,25584,25152,25176,25080,23496,23328,24576,
     8  23736,24384,24264,24168,24096,23976,25368,25272,24984,24792,
     9  24504,24504,23784,23832,23880,23904,23952,23976,23328,20712/
            data (jy(i),i=  801,  900)/
     +  20736,21168,21192,21384,21408,22656,25080,22440,23736,23616,
     1  22584,22632,22248,22368,22152,22272,21024,21336,19944,20448,
     2  20448,20736,20640,21048,21144,21216,21336,21408,21792,22152,
     3  22296,21000,20832,21024,20736,20472,20472,20808,19944,21120,
     4  21096,19800,19368,19344,17880,19944,20040,20304,20496,20448,
     5  20664,20832,21048,21192,17448,17544,17424,19848,19656,19512,
     6  18984,18864,17352,17280,17808,17232,19824,16176,17256,17208,
     7  17016,16896,16440,16344,16824,17016,16104,14784,14688,14592,
     8  14568,14736,10776,12096,12216,13080,13104,13536,13656,19776,
     9  11016,11712,12240,12192,12384,13248,13200,30888,26088,25776/
            data (jy(i),i=  901,  950)/
     +  25416,25368,25416,21672,22008,22104,21912,21960,21864,21888,
     1  21600,21528,21432,56352,56280,56136,56064,55992,56208,56304,
     2  56376,56592,56520,56544,56712,56760,56784,56592,55200,55248,
     3  55200,55056,54960,54864,54864,54696,54912,54984,55224,55080,
     4  55128,55848,55896,55680,55344,55368,55680,55872,55752,55776/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    5,    6,    7,    8,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     33,   34,   35,   36,   37,   38,    1,   40,   41,   42,
     4     43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
     5     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     6     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     7     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     8     83,   84,   85,   86,   87,   88,   10,   33,   91,   92,
     9     93,   94,   95,   96,   97,   98,   99,   40,  102,  103/
            data (jb1(i),i=  101,  200)/
     +    104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
     1    114,  115,  116,  117,  118,  119,  120,  122,  123,  124,
     2    125,  100,  122,  127,  128,  129,  130,  131,  132,  133,
     3    134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
     4    144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
     5    154,  155,  156,  157,  121,   32,   90,  101,  101,    9,
     6    159,  160,  161,  162,  178,  179,  180,  181,  182,  164,
     7    163,  164,  185,  186,  187,  188,  189,  190,  191,  192,
     8    193,  194,  195,  196,  197,  198,  165,  184,  165,  201,
     9    202,  203,  204,  205,  206,  207,  208,  209,  210,  211/
            data (jb1(i),i=  201,  300)/
     +    212,  213,  214,  215,  166,  200,  166,  218,  219,  220,
     1    221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
     2    167,  217,  167,  233,  234,  235,  236,  237,  238,  239,
     3    240,  241,  242,  243,  244,  245,  246,  247,  248,  249,
     4    250,  251,  252,  253,  254,  255,  256,  257,  168,  168,
     5    232,  259,  260,  261,  262,  263,  264,  265,  266,  267,
     6    268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
     7    278,  170,  172,  280,  281,  282,  283,  284,  285,  286,
     8    287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
     9    297,  171,  171,  299,  300,  301,  302,  303,  304,  305/
            data (jb1(i),i=  301,  400)/
     +    306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
     1    316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
     2    326,  327,  328,  329,  330,  331,  332,  333,  169,  173,
     3    335,  336,  337,  338,  339,  340,  341,  342,  170,  173,
     4    344,  345,  346,  347,  348,  349,  350,  175,  176,  352,
     5    353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
     6    363,  364,  365,  175,  174,  367,  368,  369,  370,  371,
     7    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     8    382,  383,  176,  172,  385,  386,  387,  388,  389,  390,
     9    391,  392,  393,  394,  395,  396,  397,  398,  399,  400/
            data (jb1(i),i=  401,  500)/
     +    401,  402,  403,  174,    1,   10,   33,  407,  408,  409,
     1    410,  411,  405,  413,  414,  415,  416,  417,  406,   32,
     2    419,  420,  413,  405,    9,  413,  423,  418,  424,   40,
     3    421,  426,  427,  428,  429,  430,  431,  432,  433,  406,
     4    435,  436,  437,  438,  439,  440,  435,  442,  443,  444,
     5    445,  408,  422,  435,  121,  448,  122,  449,  418,  441,
     6    452,  453,  100,  449,  451,  447,  159,  457,  458,  459,
     7    461,  423,  460,  426,  461,  451,  463,  456,  450,  452,
     8    466,  467,  468,  469,  470,  465,  472,  456,  474,  474,
     9    460,  464,  476,  455,  478,  477,  480,  478,  482,  465/
            data (jb1(i),i=  501,  600)/
     +    479,  471,  484,  441,  485,  435,  472,  472,  463,  490,
     1    486,  492,  493,  474,  490,  495,  487,  489,  497,  498,
     2    499,  492,  488,  501,  502,  503,  504,  489,  476,  506,
     3    507,  508,  509,  510,  505,  512,  513,  514,  515,  516,
     4    517,  518,  482,  512,  521,  522,  492,  523,  524,  521,
     5    488,  479,  477,  529,  527,  528,  531,  532,  533,  534,
     6    511,  531,  536,  528,  505,  538,  539,  540,  541,  525,
     7    485,  490,  543,  545,  546,  520,  548,  549,  550,  551,
     8    526,  553,  554,  555,  556,  548,  544,  558,  559,  560,
     9    526,  558,  562,  563,  538,  565,  543,  545,  567,  568/
            data (jb1(i),i=  601,  700)/
     +    569,  570,  571,  527,  567,  545,  574,  575,  548,  577,
     1    578,  579,  564,  581,  531,  577,  564,  583,  584,  585,
     2    581,  587,  565,  589,  591,  592,  593,  594,  529,  588,
     3    590,  553,  597,  596,  599,  600,  601,  602,  558,  574,
     4    586,  604,  605,  606,  607,  521,  591,  609,  610,  611,
     5    612,  613,  614,  615,  567,  617,  618,  586,  612,  577,
     6    621,  622,  617,  590,  624,  625,  626,  620,  617,  629,
     7    630,  628,  632,  633,  596,  635,  636,  574,  632,  638,
     8    624,  640,  641,  642,  643,  635,  640,  646,  647,  588,
     9    644,  649,  650,  599,  638,  644,  653,  654,  632,  655/
            data (jb1(i),i=  701,  800)/
     +    652,  620,  646,  658,  621,  658,  646,  660,  628,  658,
     1    662,  664,  665,  657,  640,  664,  668,  667,  670,  671,
     2    672,  673,  674,  675,  676,  677,  662,  679,  680,  681,
     3    683,  684,  638,  669,  686,  683,  679,  688,  689,  690,
     4    691,  692,  693,  694,  695,  697,  698,  688,  667,  700,
     5    678,  701,  652,  660,  703,  704,  705,  706,  707,  708,
     6    709,  710,  711,  712,  664,  714,  715,  716,  717,  718,
     7    719,  713,  696,  721,  722,  663,  700,  724,  725,  726,
     8    728,  729,  730,  683,  678,  728,  696,  713,  733,  735,
     9    736,  737,  728,  739,  740,  741,  742,  669,  739,  744/
            data (jb1(i),i=  801,  900)/
     +    745,  746,  697,  748,  697,  727,  751,  752,  753,  754,
     1    755,  756,  757,  758,  759,  760,  761,  762,  763,  764,
     2    732,  733,  750,  767,  768,  769,  770,  771,  739,  767,
     3    720,  735,  727,  774,  775,  776,  777,  735,  778,  734,
     4    767,  780,  782,  783,  784,  785,  781,  762,  787,  788,
     5    789,  790,  791,  792,  793,  794,  795,  796,  797,  798,
     6    779,  168,  800,  801,  802,  803,  804,  779,  806,  766,
     7    808,  809,  747,  780,  806,  808,  812,  813,  814,  815,
     8    781,  750,  817,  819,  820,  821,  822,  823,  824,  825,
     9    826,  827,  828,  829,  830,  811,  817,  832,  806,  834/
            data (jb1(i),i=  901, 1000)/
     +    835,  836,  837,  833,  816,  808,  840,  841,  842,  819,
     1    843,  839,  819,  170,  846,  847,  848,  849,  850,  851,
     2    852,  853,  818,  855,  833,  855,  845,  839,  858,  859,
     3    860,  861,  862,  864,  845,  866,  842,  863,  843,  864,
     4    869,  870,  871,  872,  873,  868,  171,  875,  866,  868,
     5    877,  878,  879,  863,  881,  880,  172,  883,  884,  885,
     6    886,  887,  888,  880,  173,  832,  174,  891,  892,  893,
     7    894,  895,  896,  879,  855,  864,  607,  607,  200,  629,
     8    682,  898,  749,  217,  899,  749,  901,  902,  903,  232,
     9    905,  906,  907,  908,  909,  904,  904,  911,  912,  818/
            data (jb1(i),i= 1001, 1040)/
     +      1,    2,    3,    4,    5,    6,    7,    1,    9,   10,
     1     11,   12,   13,   14,    9,   16,   17,   18,   19,   20,
     2     21,   22,   23,   24,   25,   26,   27,   16,   29,   30,
     3     31,   32,   33,   34,   35,   36,   29,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   11,   12,
     1     13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
     2     23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
     3     34,   35,   36,   37,   38,   39,   39,   41,   42,   43,
     4     44,   45,   46,   47,   48,   49,   50,   51,   52,   53,
     5     54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
     6     64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
     7     74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
     8     84,   85,   86,   87,   88,   89,   89,   91,   92,   93,
     9     94,   95,   96,   97,   98,   99,  100,  102,  103,  104/
            data (jb2(i),i=  101,  200)/
     +    105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
     1    115,  116,  117,  118,  119,  120,  121,  123,  124,  125,
     2    126,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     3    135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
     4    145,  146,  147,  148,  149,  150,  151,  152,  153,  154,
     5    155,  156,  157,  158,  158,   90,  177,  177,  159,  160,
     6    161,  162,  163,  178,  179,  180,  181,  182,  183,  183,
     7    184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
     8    194,  195,  196,  197,  198,  199,  199,  200,  201,  202,
     9    203,  204,  205,  206,  207,  208,  209,  210,  211,  212/
            data (jb2(i),i=  201,  300)/
     +    213,  214,  215,  216,  216,  217,  218,  219,  220,  221,
     1    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     2    231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     3    241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
     4    251,  252,  253,  254,  255,  256,  257,  258,  258,  169,
     5    259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
     6    269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
     7    279,  279,  280,  281,  282,  283,  284,  285,  286,  287,
     8    288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
     9    298,  298,  299,  300,  301,  302,  303,  304,  305,  306/
            data (jb2(i),i=  301,  400)/
     +    307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
     1    317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
     2    327,  328,  329,  330,  331,  332,  333,  334,  334,  335,
     3    336,  337,  338,  339,  340,  341,  342,  343,  343,  344,
     4    345,  346,  347,  348,  349,  350,  351,  351,  352,  353,
     5    354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
     6    364,  365,  366,  366,  367,  368,  369,  370,  371,  372,
     7    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     8    383,  384,  384,  385,  386,  387,  388,  389,  390,  391,
     9    392,  393,  394,  395,  396,  397,  398,  399,  400,  401/
            data (jb2(i),i=  401,  500)/
     +    402,  403,  404,  404,  405,  406,  407,  408,  409,  410,
     1    411,  412,  412,  414,  415,  416,  417,   90,  418,  419,
     2    420,  421,  421,  422,  422,  423,  101,  424,  425,  425,
     3    426,  427,  428,  429,  430,  431,  432,  433,  434,  434,
     4    436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
     5    446,  446,  447,  447,  448,  449,  450,  450,  451,  452,
     6    453,  454,  454,  455,  455,  456,  457,  458,  459,  460,
     7    462,  462,  461,  463,  463,  464,  464,  160,  465,  466,
     8    467,  468,  469,  470,  471,  471,  473,  473,  161,  475,
     9    475,  476,  477,  478,  479,  480,  481,  481,  483,  483/
            data (jb2(i),i=  501,  600)/
     +    482,  484,  485,  486,  486,  487,  487,  488,  489,  491,
     1    491,  493,  494,  494,  495,  496,  496,  497,  498,  499,
     2    500,  500,  501,  502,  503,  504,  162,  505,  506,  507,
     3    508,  509,  510,  511,  511,  513,  514,  515,  516,  517,
     4    518,  519,  519,  520,  522,  163,  523,  524,  525,  525,
     5    526,  527,  528,  530,  530,  529,  532,  533,  534,  535,
     6    535,  536,  537,  537,  538,  539,  540,  541,  542,  542,
     7    543,  544,  544,  546,  547,  547,  549,  550,  551,  552,
     8    552,  554,  555,  556,  557,  557,  553,  559,  560,  561,
     9    561,  562,  563,  164,  564,  566,  566,  565,  568,  569/
            data (jb2(i),i=  601,  700)/
     +    570,  571,  572,  572,  573,  573,  575,  576,  576,  578,
     1    579,  580,  580,  582,  582,  581,  583,  584,  585,  586,
     2    587,  588,  589,  590,  592,  593,  594,  595,  595,  591,
     3    596,  597,  598,  598,  600,  601,  602,  603,  603,  599,
     4    604,  605,  606,  607,  608,  608,  609,  610,  611,  612,
     5    613,  614,  615,  616,  616,  618,  619,  619,  620,  621,
     6    622,  623,  623,  624,  625,  626,  627,  627,  628,  630,
     7    631,  631,  633,  634,  634,  636,  637,  637,  635,  639,
     8    639,  641,  642,  643,  644,  645,  645,  647,  648,  648,
     9    649,  650,  651,  651,  652,  653,  654,  165,  655,  656/
            data (jb2(i),i=  701,  800)/
     +    656,  657,  657,  659,  659,  660,  661,  661,  662,  663,
     1    663,  665,  666,  666,  667,  668,  669,  670,  671,  672,
     2    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     3    684,  685,  685,  686,  687,  687,  688,  689,  690,  691,
     4    692,  693,  694,  695,  696,  698,  699,  699,  700,  166,
     5    701,  702,  702,  703,  704,  705,  706,  707,  708,  709,
     6    710,  711,  712,  713,  714,  715,  716,  717,  718,  719,
     7    720,  720,  721,  722,  723,  723,  724,  725,  726,  727,
     8    729,  730,  731,  731,  732,  732,  733,  734,  734,  736,
     9    737,  738,  738,  740,  741,  742,  743,  743,  744,  745/
            data (jb2(i),i=  801,  900)/
     +    746,  747,  748,  749,  750,  751,  752,  753,  754,  755,
     1    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     2    765,  766,  766,  768,  769,  770,  771,  772,  772,  773,
     3    773,  747,  774,  775,  776,  777,  167,  778,  779,  780,
     4    781,  782,  783,  784,  785,  786,  786,  787,  788,  789,
     5    790,  791,  792,  793,  794,  795,  796,  797,  798,  799,
     6    799,  800,  801,  802,  803,  804,  805,  805,  807,  807,
     7    809,  810,  810,  811,  811,  812,  813,  814,  815,  816,
     8    816,  817,  818,  820,  821,  822,  823,  824,  825,  826,
     9    827,  828,  829,  830,  831,  831,  832,  833,  834,  835/
            data (jb2(i),i=  901, 1000)/
     +    836,  837,  838,  838,  839,  840,  841,  842,  169,  843,
     1    844,  844,  845,  846,  847,  848,  849,  850,  851,  852,
     2    853,  854,  854,  856,  856,  857,  857,  858,  859,  860,
     3    861,  862,  863,  865,  865,  867,  867,  866,  868,  869,
     4    870,  871,  872,  873,  874,  874,  875,  876,  876,  877,
     5    878,  879,  880,  881,  882,  882,  883,  884,  885,  886,
     6    887,  888,  889,  889,  890,  890,  891,  892,  893,  894,
     7    895,  896,  897,  897,  175,  176,  184,  629,  898,  682,
     8    898,  899,  899,  900,  900,  901,  902,  903,  904,  905,
     9    906,  907,  908,  909,  910,  910,  911,  912,  913,  913/
            data (jb2(i),i= 1001, 1040)/
     +      2,    3,    4,    5,    6,    7,    8,    8,   10,   11,
     1     12,   13,   14,   15,   15,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   28,   30,   31,
     3     32,   33,   34,   35,   36,   37,   37,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ok(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1070) :: jx,jy
            integer(kind=iknd), save, dimension(1140) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'oklahoma      '/
            data jrot,ipart/1,1/
            data kv/   1,1065,   0,   0,   0/
            data kb/   1,1141,   0,   0,   0/
            data iib/ 330,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  20232,20424,22776,19824,19920,20040,20352,20400,20424,24720,
     1  20136,20304,24960,25080,20088,20424,27504,30888,32352,35136,
     2  34752,38808,42936,43680,45312,48504,47040,47136,48696,49224,
     3  49272,49320,19680,19824,24480,24384,43224,43008,43032,43368,
     4  43416,43776,44160,44520,44664,44856,44904,44976,44856,44568,
     5  44568,44616,44784,44928,44952,44904,44952,44640,44424,44280,
     6  44184,44592,44568,44688,44688,44928,44976,45072,45192,45192,
     7  46992,47256,47376,47040,47064,46968,46728,46584,46512,46488,
     8  46584,46608,46560,46632,46608,46344,45960,47064,47928,47808,
     9  47544,47208,47064,47040,47232,47184,47352,47304,48528,48696/
            data (jx(i),i=  101,  200)/
     +  48768,48624,48720,48864,48984,48960,48744,48672,48744,48816,
     1  48912,49152,49104,49248,49128,49320,49440,49632,49608,49848,
     2  50208,50232,50208,50280,50016,50016,50088,50208,50304,50304,
     3  50256,50448,50472,50328,50328,50664,50688,50616,50640,50784,
     4  50832,50928,50880,50664,50856,50880,50688,50832,51048,50880,
     5  50904,51024,51120,51192,51192,51024,51096,51192,51288,51288,
     6  51168,51240,51168,49176,49056,49032,49128,49128,48936,48888,
     7  48768,48648,48600,48696,49128,49128,48960,49176,49032,49200,
     8  49224,49176,49008,49032,49128,49080,48792,48792,48912,48984,
     9  48936,48744,48576,48312,48360,46968,46944,47136,47208,47496/
            data (jx(i),i=  201,  300)/
     +  47664,47808,47928,48024,48168,48360,48480,48456,48336,48504,
     1  48720,48936,49128,49320,49416,49512,49584,49800,49728,49464,
     2  49440,49224,49200,49008,48936,48576,48504,48552,48744,48696,
     3  49152,49296,48864,48744,48840,49296,49440,49776,49800,49632,
     4  49704,49800,49872,49968,50040,50160,50736,50928,50976,50856,
     5  50520,50376,50184,50040,49824,49728,49320,49200,49152,49200,
     6  49608,49584,49416,49656,49656,49536,49560,49848,50040,50088,
     7  49992,49920,49368,49200,49152,49200,49056,49056,49752,49824,
     8  49896,49872,49560,49488,49464,49656,49632,49152,48792,48696,
     9  49440,49512,49368,49608,49248,49176,49200,49344,49440,49488/
            data (jx(i),i=  301,  400)/
     +  49344,49368,49512,49608,49584,49464,49656,49584,49704,49680,
     1  49848,49896,50232,50424,50544,50352,50376,51024,51120,51096,
     2  50856,50640,50304,50256,50328,49920,49920,49728,49560,49320,
     3  22272,22272,22416,22440,22608,22656,22584,22896,23160,23208,
     4  23184,23088,23160,23520,23688,23928,24000,24096,20544,20904,
     5  21528,21744,21744,21888,22224,22872,20256,20208,20040,20016,
     6  19896,20448,20448,23688,23784,20544,20568,24144,24216,20952,
     7  24216,24240,24240,24384,24480,23664,24168,24168,24000,24192,
     8  24408,24432,24600,24696,24768,24888,21720,21720,22416,22392,
     9  22440,22752,22944,23256,23760,24168,25056,25416,25440,25464/
            data (jx(i),i=  401,  500)/
     +  25464,24216,24216,26064,25944,26136,26040,25920,25896,25656,
     1  25560,25608,25512,25512,25104,25032,25248,25320,25344,25272,
     2  25176,24576,24408,24288,24384,24624,24840,24960,25392,25440,
     3  25608,25584,25752,25920,26064,26040,25920,25800,25800,25872,
     4  25992,26184,26304,26400,26688,26736,26736,26472,26424,26832,
     5  27000,27336,27336,27408,27600,27840,27960,27312,26520,26520,
     6  24912,27576,27648,26832,26808,25416,25680,25704,27864,27840,
     7  27936,27984,28056,28776,28728,30360,27312,28104,28152,28152,
     8  28200,28152,27360,28128,28200,28200,28248,28296,28296,27480,
     9  27480,28296,27480,27552,27552,31536,28512,28488,27672,28560/
            data (jx(i),i=  501,  600)/
     +  24504,27816,28080,28104,28248,28416,28512,28536,28584,28824,
     1  28824,29184,29496,29712,29808,30096,30312,30504,30624,30984,
     2  29616,30096,30168,29832,29592,29568,29664,29880,29952,30144,
     3  30192,30120,29976,30288,30264,30696,30720,32568,30960,30960,
     4  31200,31128,31344,31488,31512,31320,31056,30864,30672,30624,
     5  30336,30024,29712,29664,29928,30432,30768,30864,31056,31128,
     6  31272,31128,31056,30864,30432,30048,29616,31536,32232,32280,
     7  32328,32472,30024,30024,32880,30792,30744,32952,33552,31920,
     8  31944,33648,34008,34224,33960,33960,33960,33960,32328,33576,
     9  34416,34416,35256,35256,33984,33984,34368,34368,34488,34560/
            data (jx(i),i=  601,  700)/
     +  34608,34656,34656,34488,34536,34656,34656,34536,34344,34248,
     1  34776,34776,34680,34848,34992,34944,34968,35328,36144,36096,
     2  35808,35856,35160,34368,35184,35280,33624,33648,33456,35400,
     3  35280,35064,34968,34944,35184,35232,35160,34896,34752,34728,
     4  34848,34752,34800,34944,35208,35424,35496,35352,35688,35712,
     5  35400,35328,35136,35112,35376,37944,36600,36552,35496,35544,
     6  35568,35616,34032,34032,35880,35640,35640,35928,38064,36720,
     7  36768,35568,35784,35784,35592,35568,35664,35784,35784,35688,
     8  35880,35928,35856,36000,36072,36168,34488,34584,34560,34704,
     9  34800,34872,34824,34608,34656,34776,34824,34944,34992,35040/
            data (jx(i),i=  701,  800)/
     +  35136,35232,35136,35136,35040,35160,35232,37368,37440,37656,
     1  37680,37920,38280,38352,40968,37416,37296,37080,37032,36912,
     2  36888,37080,37032,36888,36912,36792,36792,36648,36480,36624,
     3  36624,36168,36168,35904,35856,35928,38040,38040,38184,37968,
     4  38088,37944,38016,38112,38088,38136,38064,38064,38160,38040,
     5  38832,38088,38040,38016,38832,38256,38304,38592,38640,38616,
     6  38736,38736,38856,38976,39096,39456,39576,39936,40224,40176,
     7  40368,40488,40632,40824,41640,38400,38352,39648,39648,39504,
     8  39576,39360,39408,39336,38832,38424,38256,38256,38136,37728,
     9  37656,37176,37128,36888,36792,36480,36312,36168,36216,35928/
            data (jx(i),i=  801,  900)/
     +  37800,37800,39744,39600,39600,39720,39816,39576,39312,39264,
     1  39864,35112,35136,34992,34944,35064,35016,35088,35136,35184,
     2  35136,35256,35184,35256,39312,39552,39648,39552,39576,39480,
     3  39480,39792,39888,40032,40128,40128,39816,39648,39696,39816,
     4  39840,39792,39600,39528,39672,39888,40056,40248,40272,39888,
     5  39816,40320,40416,40416,40464,41040,39648,39648,39744,39744,
     6  39552,41520,39912,39888,39048,39024,41688,41688,41640,41640,
     7  41472,41280,41280,40872,40848,39624,39624,40440,40440,41256,
     8  41256,41400,41400,42456,42504,41784,42024,42048,42336,40848,
     9  40728,40752,40608,40632,40464,40440,40536,40488,40752,41064/
            data (jx(i),i=  901, 1000)/
     +  41040,41112,41376,41448,41688,41856,41976,41880,42000,42120,
     1  42144,42168,42120,42192,42480,41712,42552,42912,40464,42480,
     2  42912,43104,41472,43488,41880,41856,43536,42768,42744,42360,
     3  42504,42528,42744,42744,42888,42936,43032,43032,43104,43320,
     4  43368,43440,43488,43584,43608,43656,42024,43704,42048,43704,
     5  44328,44256,43416,43392,44304,44640,44640,44544,44520,44232,
     6  44232,44088,44088,43704,43680,43704,45192,45168,43536,44832,
     7  44784,45024,45120,45192,45696,42624,42912,42960,42912,42960,
     8  42912,42960,43176,43392,43368,43824,43824,43944,43968,44160,
     9  44160,44304,44472,44496,44664,44808,44904,44856,45000,45120/
            data (jx(i),i= 1001, 1070)/
     +  45192,46440,46440,45624,45576,43128,45672,46656,46584,43296,
     1  43320,46632,46632,46680,46680,46752,46800,46848,46896,47040,
     2  47040,47160,46728,45336,45336,46728,47136,46656,47640,47712,
     3  48144,48168,49032,48888,48696,48624,48552,48480,48456,48120,
     4  48024,48096,48048,47952,47736,47784,47568,47496,47424,47280,
     5  46704,46680,46752,46920,46968,48552,48720,48840,48864,49128,
     6  49248,48528,48528,48360,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  53880,33648,70031,66791,63983,61128,48576,43656,29520,14160,
     1  14352,22464,22320,29472,59520,40440,70703,29424,71567,29400,
     2  71999,29352,72143,30504,35400,66983,40056,43704,53112,55824,
     3  62280,48264,69887, 7056, 6864,70103,29304,29712,29808,30288,
     4  30384,30672,30840,31224,31464,31584,31656,32376,32472,32544,
     5  32664,33120,33264,33576,33696,33768,33912,34080,34008,34032,
     6  34176,34560,34704,34824,34944,35016,35136,35232,35208,35376,
     7  39648,39384,39000,38112,37848,37632,37440,37392,37272,37008,
     8  36864,36648,36288,36120,35976,35472,35400,40152,41136,41520,
     9  41688,41784,41928,42048,42624,42984,43320,43512,67247,67175/
            data (jy(i),i=  101,  200)/
     +  67223,67535,67559,67439,67511,67583,67583,67679,67631,67751,
     1  67751,67895,68207,68327,68471,68519,68687,68639,68951,68927,
     2  69335,69503,69647,69815,70031,70103,70151,69983,69959,70127,
     3  70247,70127,70223,70295,70367,70463,70727,70871,70991,71039,
     4  70871,70895,71111,71231,71351,71447,71543,71591,71519,71759,
     5  71879,71831,71687,71687,71807,71999,72047,71927,71999,72047,
     6  72071,72167,72287,62256,62328,62448,62592,62759,62927,63215,
     7  63455,63407,63455,63839,63959,64031,64199,64295,64583,64631,
     8  65015,65543,65567,65711,65879,66047,66023,66119,66071,66095,
     9  66215,66263,66239,66407,66695,43824,43896,43992,44088,44064/
            data (jy(i),i=  201,  300)/
     +  43896,43896,44136,43968,44088,44136,44448,44712,44904,45216,
     1  45216,45072,45192,44976,44976,45120,45408,45840,46104,46368,
     2  46512,46512,46656,46728,47016,47232,47352,47688,47856,48000,
     3  48000,48120,52824,52680,52656,52776,52704,52440,52272,52080,
     4  51960,51960,52224,52272,52248,51912,51960,51840,51696,51360,
     5  51144,51168,51048,51072,51312,51336,51192,51096,50904,50808,
     6  50616,50472,50184,50136,50064,50016,49968,49920,49752,49368,
     7  49128,49080,49104,48960,48696,55464,55272,55176,54960,54840,
     8  54528,54456,54312,54216,54000,53784,53640,53400,53328,53232,
     9  62280,62232,61920,61704,61104,60888,60840,60888,60816,60576/
            data (jy(i),i=  301,  400)/
     +  60480,60432,60432,60312,60264,60240,60048,59640,59640,59424,
     1  59376,59184,59136,59016,58656,58344,58176,57984,57744,57672,
     2  57600,57360,57144,56856,56520,56328,55920,55632,55584,55824,
     3  53928,53712,53736,53424,53400,53280,52896,52680,52656,52584,
     4  51960,51912,51648,51600,51720,51696,51768,51696,33768,33864,
     5  34272,34608,34680,34632,34824,67151,67055,66911,66743,66815,
     6  66743,64007,63815,63935,61080,61128,60984,48624,43776,43728,
     7  29472,34824,32496,67175,64727,64703,51792,52224,52752,52968,
     8  52896,52680,52536,52152,52056,52056,22440,22368,35112,35520,
     9  35856,36264,36336,36672,36888,37296,37296,61104,43776,59712/
            data (jy(i),i=  401,  500)/
     +  40584,40512,40560,40584,40440,40032,39600,39504,39336,39192,
     1  39024,38904,38568,38424,38280,52104,52272,52464,52656,52728,
     2  53112,53472,53616,53904,54048,54168,54192,54288,54240,54264,
     3  54504,54912,55080,55104,55320,55392,55440,55560,55632,55728,
     4  55776,55728,55464,55392,55416,55584,55848,56064,56256,56424,
     5  56856,57144,57504,57840,57888,57696,57696,52728,52704,51912,
     6  51888,68903,67271,67223,67295,61248,61248,61104,61152,61560,
     7  59784,57504,55056,57528,59592,59616,53544,53544,48696,47064,
     8  49488,51120,51120,49488,43824,43008,39816,34152,32544,32544,
     9  32472,37368,37296,37296,37368,39864,65807,66479,66455,64055/
            data (jy(i),i=  501,  600)/
     +  63935,62639,62759,63023,63023,63167,63167,62999,62999,65807,
     1  65687,65687,65279,65327,65399,65303,65447,65735,65711,65447,
     2  34152,55104,51144,49536,49704,49896,50016,50064,50520,50712,
     3  50808,51048,51144,61224,61632,61632,61224,66575,66527,64679,
     4  64175,63863,63287,63095,62951,62639,62639,62544,62496,30000,
     5  30168,30216,30576,30744,30960,30888,31080,31320,31584,31608,
     6  32376,32544,32760,32808,33120,33216,33768,34200,51192,47136,
     7  43080,69023,68999,68927,58440,58392,59616,55176,62136,62088,
     8  61680,66575,66815,67055,39864,39936,42240,42288,42288,61320,
     9  61368,60960,60960,60144,34176,34272,34272,66983,67103,67079/
            data (jy(i),i=  601,  700)/
     +  55200,51240,67823,67823,67727,67655,67583,67415,67343,67199,
     1  34272,39936,66911,66863,66719,66599,66575,66431,65807,65615,
     2  65351,65039,55200,32640,32640,59328,59256,58464,64943,69095,
     3  68975,68927,68831,68735,68567,68375,68279,68375,68327,68279,
     4  68015,67823,71735,71567,71519,71399,71183,70823,70511,70247,
     5  70079,69887,69647,69455,69239,68327,68255,69143,51240,47208,
     6  43944,42360,42360,42240,64223,64559,64655,47208,65087,65039,
     7  64247,44544,44904,45024,45072,45144,45192,45408,45504,45696,
     8  45792,45936,46416,46728,60192,56640,56592,56544,56304,56232,
     9  56280,56184,55968,55800,55728,55608,55704,55680,55824,55752/
            data (jy(i),i=  701,  800)/
     +  55896,55872,55704,55560,55464,55392,55296,60216,59952,60000,
     1  59784,59592,59520,59400,59448,60792,60936,61080,61368,61608,
     2  61704,61920,61992,62088,62256,62376,62592,62520,62855,63023,
     3  63191,63671,63791,63791,63935,64079,34296,33912,39984,39840,
     4  39768,39720,39552,39528,39360,39240,39192,39096,39048,38976,
     5  30216,33720,33624,31032,31008,33984,34200,34176,34248,34344,
     6  34416,34536,34464,34512,34464,34464,34488,34776,34824,34632,
     7  34632,34728,35040,35160,63959,63911,65087,51336,50952,50736,
     8  50592,50280,49920,49776,49704,49728,49632,49416,49272,49248,
     9  49080,48576,48360,48072,48048,48120,48024,47808,47616,47352/
            data (jy(i),i=  801,  900)/
     +  56712,56280,56304,51528,51768,51960,52392,52656,52824,52944,
     1  54144,54024,54312,54312,54432,54456,54576,54624,54744,54768,
     2  54792,55032,55104,55128,53088,53160,53376,53616,53664,53784,
     3  53952,53976,54048,56184,56112,56040,55824,55824,55608,55488,
     4  55248,55080,55032,54792,54624,54816,54816,54648,54504,54336,
     5  54216,52944,47280,44040,39960,57024,56448,56592,56760,56880,
     6  57000,67439,67391,67847,67823,68375,31896,33792,33792,33600,
     7  33672,33672,33912,33936,35136,30192,31440,31416,31488,31488,
     8  31776,31776,31896,63983,62759,59472,47304,44064,52992,35256,
     9  35304,35376,35400,35472,35568,35688,35712,35904,35856,35880/
            data (jy(i),i=  901, 1000)/
     +  35784,35760,35832,35712,35856,35832,36312,36624,36720,36720,
     1  36672,36480,36384,36312,36240,61104,61152,38400,38376,37032,
     2  37032,68471,68375,56232,56232,57048,53808,52992,53808,51384,
     3  51384,50928,51000,51168,51144,51216,51144,51288,51240,51264,
     4  51216,51360,51336,51384,49800,48192,48120,31920,43680,43680,
     5  57096,59112,59112,59544,56280,39672,40080,40080,40872,40896,
     6  42480,42480,42888,42888,39672,38400,53040,53472,53424,49800,
     7  52224,52272,52200,52320,43704,36408,36408,36360,36216,36120,
     8  35976,35784,35640,35688,35544,35424,35352,35304,35352,35400,
     9  35328,35256,35328,35208,35208,35376,35400,35472,35448,35568/
            data (jy(i),i= 1001, 1070)/
     +  35568,66887,66935,66887,67703,67583,48192,53064,62064,62783,
     1  61968,60408,55104,55176,55512,55584,55488,55512,55608,55704,
     2  55800,55800,57168,39672,40080,56808,56808,52824,52824,48240,
     3  53088,52824,55872,55776,55752,55872,55872,55824,55704,55464,
     4  55704,55848,55920,55848,55848,55968,56088,55944,55968,55824,
     5  60480,60552,60720,60744,60840,60888,60960,61104,61320,61488,
     6  61632,48264,48456,48264,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      4,    5,    6,    1,    1,   11,    7,    9,    8,    2,
     1      2,    4,    3,   11,   34,   10,   10,   13,    3,   17,
     2     14,   18,   17,   19,   20,   21,   22,   37,   38,   39,
     3     40,   24,   24,   42,   43,   44,   45,   46,   47,   48,
     4     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     5     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     6     69,   25,   27,   71,   72,   73,   74,   75,   76,   77,
     7     78,   79,   80,   81,   82,   83,   84,   85,   86,   25,
     8     27,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     9     97,   28,   26,   99,  100,  101,  102,  103,  104,  105/
            data (jb1(i),i=  101,  200)/
     +    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     1    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     2    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     3    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     4    146,  147,  148,  149,  150,  151,  152,  153,  154,  155,
     5    156,  157,  158,  159,  160,  161,  162,   23,   31,  164,
     6    165,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     7    175,  176,  177,  178,  179,  180,  181,  182,  183,  184,
     8    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     9     26,   28,  196,  197,  198,  199,  200,  201,  202,  203/
            data (jb1(i),i=  201,  300)/
     +    204,  205,  206,  207,  208,  209,  210,  211,  212,  213,
     1    214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
     2    224,  225,  226,  227,  228,  229,  230,  231,   32,   29,
     3    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     4    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     5    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     6    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     7    273,  274,   32,   30,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,   29,   31,
     9    291,  292,  293,  294,  295,  296,  297,  298,  299,  300/
            data (jb1(i),i=  301,  400)/
     +    301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
     1    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     2    321,  322,  323,  324,  325,  326,  327,  328,  329,   30,
     3      1,  331,  332,  333,  334,  335,  336,  337,  338,  339,
     4    340,  341,  342,  343,  344,  345,  346,  347,    2,  349,
     5    350,  351,  352,  353,  354,    3,  356,  357,  358,  359,
     6    360,  361,    5,  362,  363,  364,    6,  366,  365,  348,
     7    368,  368,  369,  370,    9,  355,  372,  371,  356,  374,
     8    364,  375,   10,  348,  377,  378,  379,  380,  381,  382,
     9    383,  384,  385,   12,  387,  388,  355,  389,  390,  391/
            data (jb1(i),i=  401,  500)/
     +    392,  393,  394,  395,  396,  371,  365,  369,  398,  400,
     1    399,   16,  402,  401,  401,  404,  405,  406,  407,  408,
     2    409,  410,  411,  412,  413,  414,  397,  386,  416,  417,
     3    418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
     4    428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
     5    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     6    448,  449,  450,  451,  452,  453,  454,  455,  456,  458,
     7    459,  460,  386,  462,  462,  463,  464,  374,  398,  466,
     8    467,  468,  469,  400,  457,  457,  472,  472,  474,  475,
     9    458,  477,  473,  368,  479,  481,  482,  458,  479,  481/
            data (jb1(i),i=  501,  600)/
     +    480,  399,  485,  486,  488,  489,  490,  373,  487,  397,
     1    493,  494,  492,  488,  487,  497,  498,  463,  497,  375,
     2    500,  470,  502,  503,  504,  505,  506,  507,  508,  500,
     3    497,  510,  511,  512,  513,  514,  515,  516,  517,  518,
     4    519,  488,  473,  522,  481,  524,  525,  526,  527,  528,
     5    529,  530,  531,  532,  523,  534,  470,  476,  536,  534,
     6    538,  520,  520,  540,  541,  542,  543,  544,  545,  546,
     7    547,  548,  536,   18,  550,  551,  552,  553,  554,  555,
     8    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     9    566,  521,  521,  496,  523,  569,  480,  570,  486,  572/
            data (jb1(i),i=  601,  700)/
     +    462,  573,  572,  538,  575,  576,  476,  575,  522,  579,
     1    580,  536,  538,  582,  583,  496,  585,  587,  588,  571,
     2    586,  579,  590,  591,  592,  593,  568,  595,  596,  584,
     3    598,  599,  578,  601,  569,  603,  604,  605,  606,  607,
     4    608,  609,  584,  597,  586,  611,  600,  613,  614,  615,
     5    616,  617,  618,  619,  620,  621,  601,  597,  624,  625,
     6    594,  626,  627,  575,  579,  622,  630,  631,  632,  633,
     7    634,  635,  636,  637,  638,  639,  640,  641,  603,   21,
     8    643,  644,  645,  646,  647,  648,  649,  650,  651,  652,
     9    653,  654,  630,  656,  657,  630,  602,  659,  570,  661/
            data (jb1(i),i=  701,  800)/
     +    662,  663,  587,  665,  666,  622,  660,  669,  670,  665,
     1    661,  672,  673,  674,  675,  676,  677,  678,  679,  680,
     2    681,  682,  683,  668,  594,  685,  686,  687,  688,  689,
     3    690,  691,  692,  693,  694,  695,  696,  697,  698,  699,
     4    700,  701,  702,  703,  704,  705,  706,  623,  685,  708,
     5    709,  710,  711,  712,  713,  714,  708,  716,  717,  718,
     6    719,  720,  721,  722,  723,  724,  725,  726,  727,  728,
     7    729,  730,  731,  732,  733,  734,  735,  665,  611,  737,
     8    656,  612,  739,  740,  741,  742,  743,  744,  745,  746,
     9    747,  748,  749,  737,  751,  738,  752,  753,  754,  751/
            data (jb1(i),i=  801,  900)/
     +    738,  756,  757,  758,  759,  760,  761,  762,  763,  764,
     1    765,  766,  767,  768,  769,  770,  771,  772,  773,  775,
     2    776,  669,  659,  778,  779,  780,  781,  782,  783,  784,
     3    785,  786,  787,  788,  789,  790,  791,  792,  793,  794,
     4    795,  796,  797,  798,  799,  668,  686,  801,  802,  778,
     5    804,  805,  806,  807,  808,  809,  811,  812,  813,  814,
     6    815,  816,  817,  818,  819,  820,  821,  822,  823,  623,
     7    810,  825,  826,  827,  828,  829,  830,  831,  832,  811,
     8    803,  834,  835,  836,  837,  838,  839,  840,  841,  842,
     9    843,  844,  845,  846,  847,  848,  849,  850,  811,  810/
            data (jb1(i),i=  901, 1000)/
     +    852,  668,  661,  739,  854,  715,  803,  857,  858,  859,
     1    860,  856,  862,  863,  864,  865,  656,  775,  867,  868,
     2    869,  870,  871,  872,  873,  874,  774,  751,  876,  877,
     3    878,  879,  880,  881,  882,  867,  775,  884,  715,  853,
     4    854,  887,  852,  774,  890,  891,  892,  893,  894,  895,
     5    896,  897,  898,  899,  900,  901,  902,  903,  904,  905,
     6    906,  907,  908,  909,  910,  911,  912,  913,  914,  886,
     7    916,  885,  918,  855,  915,  920,  918,  922,  862,  922,
     8    924,  925,  856,  924,  889,  928,  927,  889,  930,  931,
     9    932,  933,  934,  935,  936,  937,  938,  939,  940,  941/
            data (jb1(i),i= 1001, 1100)/
     +    942,  943,  944,  945,  946,  887,   24,  867,  888,  949,
     1    951,  952,  953,  886,  951,  924,  956,  957,  958,  959,
     2    960,  961,  962,  963,  950,  956,  965,  918,  967,  968,
     3    927,  945,  970,  971,  972,  973,  967,  950,  915,  976,
     4    977,  978,  979,  980,  981,  982,  983,  984,  985,  986,
     5    987,  988,  989,  990,  991,  992,  993,  994,  995,  996,
     6    997,  998,  999, 1000, 1001, 1002, 1003, 1004, 1005,  922,
     7    946,  975,  967, 1002,  885, 1010, 1009, 1009, 1008, 1013,
     8   1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1012,  951,
     9   1002,  956, 1024, 1025, 1023, 1026, 1022,  975, 1008, 1028/
            data (jb1(i),i= 1101, 1140)/
     +   1029, 1007,   29, 1031, 1029,   30, 1033, 1034, 1035, 1036,
     1   1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046,
     2   1047, 1048, 1049, 1022, 1012, 1051, 1052, 1053, 1054, 1055,
     3   1056, 1057, 1058, 1059, 1060, 1061,   32, 1062, 1063, 1030/
            data (jb2(i),i=    1,  100)/
     +      5,    6,   15,   15,    7,   12,    8,   12,   16,   16,
     1      9,   33,   33,   34,   35,   35,   13,   14,   36,   36,
     2     18,   20,   19,   21,   22,   23,   37,   38,   39,   40,
     3     41,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     4     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     5     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     6     70,   70,   71,   72,   73,   74,   75,   76,   77,   78,
     7     79,   80,   81,   82,   83,   84,   85,   86,   87,   87,
     8     88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
     9     98,   98,   99,  100,  101,  102,  103,  104,  105,  106/
            data (jb2(i),i=  101,  200)/
     +    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     1    117,  118,  119,  120,  121,  122,  123,  124,  125,  126,
     2    127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
     3    137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
     4    147,  148,  149,  150,  151,  152,  153,  154,  155,  156,
     5    157,  158,  159,  160,  161,  162,  163,  163,  164,  165,
     6    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     7    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     8    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     9    195,  196,  197,  198,  199,  200,  201,  202,  203,  204/
            data (jb2(i),i=  201,  300)/
     +    205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
     1    215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
     2    225,  226,  227,  228,  229,  230,  231,  232,  232,  233,
     3    234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
     4    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     5    254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
     6    264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
     7    274,  275,  275,  276,  277,  278,  279,  280,  281,  282,
     8    283,  284,  285,  286,  287,  288,  289,  290,  290,  291,
     9    292,  293,  294,  295,  296,  297,  298,  299,  300,  301/
            data (jb2(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     1    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  330,  330,
     3    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     6    361,    4,  362,  363,  364,  365,  366,  367,  367,  368,
     7      7,  369,  370,    8,  371,  372,  373,  373,  374,  375,
     8    376,  376,   11,  377,  378,  379,  380,  381,  382,  383,
     9    384,  385,  386,  387,  388,   13,  389,  390,  391,  392/
            data (jb2(i),i=  401,  500)/
     +    393,  394,  395,  396,  397,   14,  398,  399,  400,   15,
     1    401,  402,  403,  403,  404,  405,  406,  407,  408,  409,
     2    410,  411,  412,  413,  414,  415,  415,  416,  417,  418,
     3    419,  420,  421,  422,  423,  424,  425,  426,  427,  428,
     4    429,  430,  431,  432,  433,  434,  435,  436,  437,  438,
     5    439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
     6    449,  450,  451,  452,  453,  454,  455,  456,  457,  459,
     7    460,  461,  461,   17,  463,  464,  465,  465,  466,  467,
     8    468,  469,  470,  471,  471,  472,  473,  474,  475,  476,
     9    477,  478,  478,  479,  480,  482,  483,  483,  484,  484/
            data (jb2(i),i=  501,  600)/
     +    485,  485,  486,  487,  489,  490,  491,  491,  492,  493,
     1    494,  495,  495,  492,  496,  498,  499,  499,  500,  501,
     2    501,  502,  503,  504,  505,  506,  507,  508,  509,  509,
     3    510,  511,  512,  513,  514,  515,  516,  517,  518,  519,
     4    520,  521,  522,  523,  524,  525,  526,  527,  528,  529,
     5    530,  531,  532,  533,  533,  535,  535,  534,  537,  537,
     6    539,  539,  540,  541,  542,  543,  544,  545,  546,  547,
     7    548,  549,  549,  550,  551,  552,  553,  554,  555,  556,
     8    557,  558,  559,  560,  561,  562,  563,  564,  565,  566,
     9    567,  567,  568,  568,  569,  570,  570,  571,  571,   19/
            data (jb2(i),i=  601,  700)/
     +    573,  574,  574,  572,  576,  577,  577,  578,  578,  580,
     1    581,  581,  582,  583,  584,  585,  586,  588,  589,  589,
     2    587,  590,  591,  592,  593,  594,  595,  596,  597,  598,
     3    599,  600,  601,  602,  602,  604,  605,  606,  607,  608,
     4    609,  610,  610,  611,  612,  612,  613,  614,  615,  616,
     5    617,  618,  619,  620,  621,  622,  623,  624,  625,   20,
     6    626,  627,  628,  628,  629,  629,  631,  632,  633,  634,
     7    635,  636,  637,  638,  639,  640,  641,  642,  642,  643,
     8    644,  645,  646,  647,  648,  649,  650,  651,  652,  653,
     9    654,  655,  655,  657,  658,  658,  659,  660,  660,  662/
            data (jb2(i),i=  701,  800)/
     +    663,  664,  664,  666,  667,  667,  668,  670,  671,  671,
     1    672,  673,  674,  675,  676,  677,  678,  679,  680,  681,
     2    682,  683,  684,  684,  685,  686,  687,  688,  689,  690,
     3    691,  692,  693,  694,  695,  696,  697,  698,  699,  700,
     4    701,  702,  703,  704,  705,  706,  707,  707,  708,  709,
     5    710,  711,  712,  713,  714,  715,  716,  717,  718,  719,
     6    720,  721,  722,  723,  724,  725,  726,  727,  728,  729,
     7    730,  731,  732,  733,  734,  735,  736,  736,  737,  738,
     8    669,  739,  740,  741,  742,  743,  744,  745,  746,  747,
     9    748,  749,  750,  750,   22,  752,  753,  754,  755,  755/
            data (jb2(i),i=  801,  900)/
     +    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     1    766,  767,  768,  769,  770,  771,  772,  773,  774,  776,
     2    777,  777,  778,  779,  780,  781,  782,  783,  784,  785,
     3    786,  787,  788,  789,  790,  791,  792,  793,  794,  795,
     4    796,  797,  798,  799,  800,  800,  801,  802,  803,  804,
     5    805,  806,  807,  808,  809,  810,  812,  813,  814,  815,
     6    816,  817,  818,  819,  820,  821,  822,  823,  824,  824,
     7    825,  826,  827,  828,  829,  830,  831,  832,  833,  833,
     8    834,  835,  836,  837,  838,  839,  840,  841,  842,  843,
     9    844,  845,  846,  847,  848,  849,  850,  851,  851,  852/
            data (jb2(i),i=  901, 1000)/
     +    853,  853,  854,  855,  855,  856,  857,  858,  859,  860,
     1    861,  861,  863,  864,  865,  866,  866,  862,  868,  869,
     2    870,  871,  872,  873,  874,  875,  875,  876,  877,  878,
     3    879,  880,  881,  882,  883,  883,  884,  885,  886,  887,
     4    888,  888,  889,  890,  891,  892,  893,  894,  895,  896,
     5    897,  898,  899,  900,  901,  902,  903,  904,  905,  906,
     6    907,  908,  909,  910,  911,  912,  913,  914,  915,  916,
     7    917,  917,  919,  919,  920,  921,  921,   23,  923,  923,
     8    925,  926,  926,  927,  928,  929,  929,  930,  931,  932,
     9    933,  934,  935,  936,  937,  938,  939,  940,  941,  942/
            data (jb2(i),i= 1001, 1100)/
     +    943,  944,  945,  946,  947,  947,  948,  948,  949,  950,
     1    952,  953,  954,  954,  955,  955,  957,  958,  959,  960,
     2    961,  962,  963,  964,  964,  965,  966,  966,  968,  969,
     3    969,  970,  971,  972,  973,  974,  974,  975,  976,  977,
     4    978,  979,  980,  981,  982,  983,  984,  985,  986,  987,
     5    988,  989,  990,  991,  992,  993,  994,  995,  996,  997,
     6    998,  999, 1000, 1001,   25, 1003, 1004, 1005, 1006, 1006,
     7   1007, 1007, 1008, 1009, 1010, 1011, 1011, 1012, 1013, 1014,
     8   1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023, 1023,
     9     26, 1024, 1025,   27, 1026, 1027, 1027,   28, 1028, 1029/
            data (jb2(i),i= 1101, 1140)/
     +   1030, 1030, 1031, 1032, 1032, 1033, 1034, 1035, 1036, 1037,
     1   1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047,
     2   1048, 1049, 1050, 1050, 1051, 1052, 1053, 1054, 1055, 1056,
     3   1057, 1058, 1059, 1060, 1061,   31, 1062, 1063, 1064, 1064/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine og(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1580) :: jx,jy
            integer(kind=iknd), save, dimension(1620) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'oregon        '/
            data jrot,ipart/0,2/
            data kv/   1,1469,1579,   0,   0/
            data kb/   1,1504,1614,   0,   0/
            data iib/ 530, 110,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  45888,37320,13992,10392,30096,17496,33984,28584,25440,22536,
     1  53592,10128,51432, 9312,46584, 9024, 9096, 9048, 9048, 9168,
     2   9240, 9240, 9360, 9480, 9600, 9624, 9744, 9744, 9864, 9552,
     3   9552, 9648, 9600, 9504, 9312, 9264, 9240, 9216, 9168, 9264,
     4   9240, 9312, 9360, 8616,39240,29568,20664, 6912,10944,14688,
     5  13800,13584,13512,13200,12912,12936,12696,12648,12552,12288,
     6  12168,11880,11736,11616,11664,11520,11136,11040,11160,11328,
     7  11352,11400,11520,11520,11400,11352,11400,11544,11448,11352,
     8  11280,11232,11184,11016,11040,10944,10824,10800,10680,10776,
     9  10656,10680,10512,10320,10200,10320,10296,10176,10560,10656/
            data (jx(i),i=  101,  200)/
     +  10752,10656,10680,10584,10416,10272,10416,10464,10416,52200,
     1  52368,52368,52464,52584,53016,53136,53256,53376,53544,53856,
     2  54216,54552,54696,54936,55152,55056,54840,54792,54672,54696,
     3  54528,54480,54384,54096,54120,54000,53880,53736,53592,38256,
     4  38736,39144,39744,39912,36864,36480,36384,36168,35880,35064,
     5  34536,34176,17520,17328,17376,17304,17256,17280,17232,17016,
     6  16944,17112,17184,17160,17304,17376,17232,17184,17184,16944,
     7  16704,16152,15912,15744,15576,15264,15120,15000,14808,14712,
     8  14520,33528,33000,32736,32304,31416,31152,31008,30696,30528,
     9  30264,24912,23808,23208,22848,22680,22680,29856,29040,28704/
            data (jx(i),i=  201,  300)/
     +  22464,22488,21936,21768,21192,21000,20856,20976,21048,20544,
     1  20160,19872,19344,19128,18864,18504,18024,17544,17400,17448,
     2  17352,17376,17520,17448,28416,28176,27984,27552,27288,27096,
     3  26904,26880,26712,26064,25608,10128,10176,10272,10416,10488,
     4  10512,10392,10368,10344,10368,10296,10320,10296,10248,10368,
     5  10392,10440,10536,10536,10416,10368,10320,10272,10104,10296,
     6  10392,10464,10416,10368,10560,10512,10320,10344,10272,10368,
     7  10392,10416,10512,10800,10872,11016,10848,10800,10824,10704,
     8  10800,10632,10416,10608,10848,10896,10848,10848,10800,10680,
     9  10584,10560,10512,10416,10392,10320,53256,53232,53256,53352/
            data (jx(i),i=  301,  400)/
     +  53376,53256,53376,53280,52896,52848,52656,52512,52296,52152,
     1  52128,51840,51816,51720,51720,51672,51504,51432,51288,51384,
     2  51240,51600,10008, 9528, 9672, 9672, 9744, 9840, 9888,10056,
     3   9864, 9888, 9840, 9768, 9576, 9576, 9552, 9552, 9672, 9792,
     4   9840, 9912, 9816, 9936, 9912,10152,10272,10368,10248, 9960,
     5  10032,10008, 9792, 9672, 9744, 9600, 9744, 9624, 9648, 9696,
     6   9696, 9792, 9960,10056,10248,51600,51744,51888,52056,52224,
     7  52296,52464,52608,52920,52992,53040,53280,53496,53376,53064,
     8  53112,53328,53304,53352,53112,53232,53184,53232,53160,53136,
     9  52992,52896,53976, 8712, 8808, 8856, 8880, 9048, 9024, 9144/
            data (jx(i),i=  401,  500)/
     +   9312, 9384, 9600,10080,10392,10512,10464,10200, 9648, 9456,
     1   9504, 9456, 9288, 9240, 9144, 8976, 8952, 8736, 9000, 8544,
     2   8640, 8664, 8568, 8520, 8208, 7872, 7944, 8016, 8184, 8280,
     3   8400, 8424, 8496, 8544, 8592, 7128, 7248, 7224, 7440, 7560,
     4   7464, 7608, 7824, 7920, 7944, 7872, 7944, 7944, 7968, 8040,
     5   7968, 8064, 8160, 8184, 8064, 7968, 7992, 8112, 8232, 8472,
     6   8616, 8592, 8640, 8832, 8832, 8904, 8856, 8736, 8784, 8568,
     7   8784, 6648, 6552, 6528, 6360, 6528, 6576, 6672, 6792, 6912,
     8   7080, 7056, 7272, 7344, 7320, 7416, 7200, 7200, 7128, 7152,
     9   7296, 7464, 7488, 7152, 7176, 7104, 7200, 7272, 7272, 7248/
            data (jx(i),i=  501,  600)/
     +   7128, 7128, 7248, 7248, 7440, 7464, 7536, 7512, 7536, 7464,
     1   7464, 7584, 7584, 7584, 7512, 7488, 7632, 7632, 7752, 7776,
     2   7680, 7680, 7800, 7824, 7968, 8112, 8472,25824,15816,15264,
     3  46008,47328,47376,47136,47184,47304,47328,47448,47472,47568,
     4  47640,47928,47976,48072,48096,48240,48240,48600,48624,48744,
     5  48768,48888,48912,49032,49056,49296,49320,50616,50664,37416,
     6  38520,38544,39168,39312,39216,39288,43152,43128,42960,42888,
     7  42264,42240,42000,41928,42432,42432,43512,43488,43632,43632,
     8  43776,43872,44856,44856,45336,45192,45504,45456,45600,45576,
     9  46032,13992,15936,15936,16200,16200,16560,16560,11856,11856/
            data (jx(i),i=  601,  700)/
     +  31392,31488,31320,31344,31272,31320,31248,31272,31104,30912,
     1  31008,30888,30816,30936,30864,30888,30816,30888,30864,30888,
     2  30936,31008,30888,30984,30888,30912,31032,30912,31008,30936,
     3  31032,31104,31200,31080,31200,31128,31200,31152,31368,31512,
     4  31608,31656,31560,31536,31872,31920,31800,31920,31776,31656,
     5  31608,31392,31392,31248,31152,31176,31104,31104,30936,30744,
     6  30624,30432,30288,30216,17424,17424,35496,35472,35664,35616,
     7  34872,34848,34104,31176,29808,29856,29592,29544,29352,28968,
     8  28248,28032,28008,28056,27960,28104,28200,28272,28320,28392,
     9  28464,28440,28536,28512,28608,28632,28728,28824,28920,28944/
            data (jx(i),i=  701,  800)/
     +  29016,28944,29088,29112,28896,28824,28656,28704,28608,28656,
     1  23976,25272,25224,25464,23208,22944,22872,22752,22632,22608,
     2  22680,22608,22632,22560,17664,18240,18168,18336,13344,13224,
     3  13224,13344,13368,13488,13488,13608,13608,13728,13728,13968,
     4  13992,14232,14232,14328,14328,14112,14112,13872,13872,13608,
     5  13608,13488,13488,13368,13368,13248,13248,13992,16944,16680,
     6  16680,16320,16320,16200,16200,16056,16056,15936,15936,15456,
     7  15456,15336,15336,16560,16680,16680,16800,16824,16920,16920,
     8  17064,17064,17184,17184,17304,17304,17424,17424,17568,17544,
     9  17688,23424,23784,23928,23928,24048,11784,11400,11400,13344/
            data (jx(i),i=  801,  900)/
     +  17688,17328,17328,17064,17064,17040,16944,48864,48912,47640,
     1  47568,47616,47496,47448,47352,47184,47088,47040,46800,46416,
     2  46224,45864,45696,45600,45480,45312,45192,45024,45000,44856,
     3  24072,24072,23976,23856,23712,23664,24000,24168,24168,24264,
     4  24216,24048,23856,23832,23544,23496,23376,23352,23448,23400,
     5  23640,23760,23952,23808,31416,31344,31152,31128,31248,44592,
     6  44520,44448,44328,44112,44088,43968,43944,43680,43656,43488,
     7  31320,31272,31344,31296,31368,31320,31392,31440,31488,31536,
     8  31632,31512,31536,31800,31848,32016,31992,40776,15720,15912,
     9  16056,16152,16080,16080,15936,15960,16080,16128,16080,16008/
            data (jx(i),i=  901, 1000)/
     +  15888,15840,15912,16128,16152,16344,16464,16584,16944,11784,
     1  40632,36240,35544,44856,44952,44904,44976,44592,44448,44616,
     2  44688,44472,44208,44016,43704,43632,43440,43320,43416,43896,
     3  44040,44256,44400,44448,44616,44592,44448,44232,44376,44352,
     4  44280,44016,44040,43968,44112,44016,43968,43872,43776,43608,
     5  43632,45264,19800,19824,19752,19512,19272,19128,18936,18744,
     6  18600,18600,18072,17424,17496,17640,17592,17640,17592,17640,
     7  17664,17448,17424,17136,11736,11856,11856,12480,36552,36408,
     8  36288,23712,31992,31968,31896,31872,31920,31896,31992,32016,
     9  23712,23376,23304,23304,23472,23592,23640,23568,23424,23496/
            data (jx(i),i= 1001, 1100)/
     +  23424,15312,15336,15264,15264,15408,15576,15576,15432,15120,
     1  15048,15048,15096,15216,15384,15480,15456,15672,15888,15912,
     2  15744,15696,15672,15792,22464,22320,21984,21552,21336,20976,
     3  20880,20568,20520,20280,19368,19152,19008,18576,18504,18024,
     4  17856,17784,17688,17544,17328,17256,17136,17088,17040,16680,
     5  16632,16584,16536,16392,16296,16128,16032,16056,15912,15864,
     6  15552,15480,15360,15240,23376,23472,23352,23376,23160,23184,
     7  23088,23208,23208,27696,28440,28392,29352,29352,32064,34272,
     8  34296,35040,35040,49800,49752,49608,49608,49488,49464,49224,
     9  49224,49080,49080,46752,46776,46536,46536,46392,46416,46296/
            data (jx(i),i= 1101, 1200)/
     +  46296,46176,46176,46128,46128,46056,46056,45960,45960,45840,
     1  45840,45720,45744,45504,45504,11424,11424,11160,11160,11664,
     2  11664,11760,11760,12480,12504,12456,35256,33024,33000,32280,
     3  32232,29976,29952,28512,28464,27768,23208,23304,23472,45384,
     4  14904,15024,15072,15144,15168,15216,15144,16704,16728,16968,
     5  16992,17256,17616,17808,18288,18336,18624,18744,18936,19032,
     6  19104,19224,19536,19728,20016,20232,20280,14880,14952,14808,
     7  14808,14664,14736,14808,14664,14688,14808,14736,14808,14784,
     8  14880,14856,14784,14808,14784,14736,14712,14664,14568,14616,
     9  14736,15024,14952,15096,15120,15480,15672,15624,15432,36648/
            data (jx(i),i= 1201, 1300)/
     +  10392,10392,41784,41808,45696,45744,45936,46008,46344,46488,
     1  35928,36000, 9600, 9600,10320,10320,10440,10440,10488,10440,
     2  10584,10632,10704,10752,10968,11016,11808,11808,12096,12096,
     3  12336,12312,12576,12576,12888,12888,13248,13248,13992,13992,
     4  15264,15288,22320,22320,22536,22368,22392,22512,22464,22440,
     5  22536,22440,22464,22728,22680,22752,23016,23088,23160,23328,
     6  23352,23304,23376,23472,23664,23592,23640,23544,23544,35280,
     7  26448,10704,10704,11064,11064,11400,11376,11760,11736,11376,
     8  11376,11016,11016,11016,11064,11064,15288,15480,22008,21912,
     9  21744,21504,21408,21528,21552,21384,21504,35424,35184,35280/
            data (jx(i),i= 1301, 1400)/
     +  35232,35304,38904,15480,17712,17736,29400,26472,26400,26520,
     1  21792,21984,21960,22128,22224,22296,22272,22344,22320,22440,
     2  22464,22344,22152,21960,21840,21792,21936,20616,20616,14712,
     3  14832,14832,14952,15024,15192,15192,16056,16056,16320,16320,
     4  16440,16440,17424,17424,17496,17496,17544,17544,17784,17784,
     5  17904,17904,18024,18024,18144,18168,18408,18408,18624,18624,
     6  18768,18768,18888,18888,19512,19512,19632,19632,19752,19752,
     7  19872,19872, 8328, 8328, 8520, 8520, 8592, 8544, 8736, 8736,
     8   8880, 8880, 9000, 9000, 8856, 8856, 8880, 9000, 9024, 9120,
     9   9120, 9312, 9312, 9936, 9936,10128,10128,10272,10272,10344/
            data (jx(i),i= 1401, 1500)/
     +  10344,10704,10704,10800,10824,11232,11520,11544,11640,11664,
     1  11784,11784,11904,11904,12504,12504,12600,12624,12744,12744,
     2  13344,13344,13632,13632,13800,13800,13848,13848,14088,14424,
     3  14424,14568,14568,11352,10944,10992,10728,10776,10704,10632,
     4  10560,10344,10248,10008, 9888, 9792, 9840, 9768, 9768, 9624,
     5   9576, 9696,10248,10416,10560,10656,10848,10824,11040,11136,
     6  11136,11040,10968,10992,10728,10848,10944,10776, 7416, 7416,
     7   7320, 7320, 7200, 7080, 7056, 7176, 6432, 6480, 6528, 6408,
     8   6360, 6072, 6072, 6240, 6192, 6048, 6840, 6840, 6960, 6960,
     9   6840, 6720, 6768, 6984, 6960, 7200, 7176, 7104, 7176, 9120/
            data (jx(i),i= 1501, 1580)/
     +   9240, 9216, 9096,10032, 9912, 9912,10032,10176,10176,10296,
     1  10296,10176,10296,10296,10176,18096,17688,17880,18048,19344,
     2  19008,19008,18768,18984,10440,10464,10536,10104,10224,10224,
     3  10104,10248,10368,10368,10248,16944,16920,17016,14640,14472,
     4  14640,14784,13320,13344,13536,13536,12288,12192,12264,12408,
     5  15168,15288,15408,10272,10392,10440,12504,12648,12624,12552,
     6  13272,13344,13464,13224,13128,13200,12888,12912,12864,12816,
     7  12696,12624,12720,12792,13296,13416,13368,13272,    0,    0/
            data (jy(i),i=    1,  100)/
     +  60984,59808,61248,58224,58008,57720,58776,57144,57528,57072,
     1  53664,51960,46848,45432,26856,41928,42000,42024,42120,43200,
     2  42984,42816,42744,42792,42768,42696,42696,42912,42960,42864,
     3  42912,42984,43032,42864,42792,42864,43248,43200,43272,43968,
     4  44256,44568,45312,39768,26472,26136,26136,34224,26040,26064,
     5  61296,61512,61776,62040,62040,61944,61800,61632,61632,61512,
     6  61536,61488,61560,61776,61872,61728,61704,61632,61512,61512,
     7  61320,61344,61272,61224,61320,61296,61080,60840,60984,61008,
     8  61488,61440,61464,61224,61368,61464,61488,61632,61464,61608,
     9  61584,61680,61824,61800,61968,61944,61968,62016,61032,60192/
            data (jy(i),i=  101,  200)/
     +  60168,60000,60168,59856,59808,59592,59232,59208,59088,61392,
     1  61224,61128,61056,60672,60312,60000,59952,60048,60048,59688,
     2  59712,59472,58920,58656,58296,58008,57816,57576,57384,57048,
     3  56832,56544,56448,55800,55416,55224,54288,53952,53832,60024,
     4  59952,60048,60384,60648,59688,59832,59832,59664,59232,59112,
     5  58944,58896,58008,58464,58776,58608,58584,58656,58632,58296,
     6  58272,58584,58608,58656,58680,58824,59400,59376,59688,59976,
     7  60696,61032,61128,61344,61440,61464,61560,61512,61224,61176,
     8  61152,58536,58344,58008,57936,57696,57672,57720,58008,58080,
     9  58080,57768,57480,57576,57432,57288,57168,57792,57456,57168/
            data (jy(i),i=  201,  300)/
     +  57048,57000,56736,56592,56424,56256,56256,56280,56376,56136,
     1  56112,56376,56280,56304,56376,56616,56664,57072,56928,56640,
     2  56808,56928,57072,57288,57264,57192,57240,57192,56856,56784,
     3  56904,57192,57360,57624,57504,52320,52416,52872,53088,52920,
     4  53016,53136,53352,53280,53088,52944,53280,53400,53400,53832,
     5  53808,53856,54000,54072,54000,53904,54384,54432,54432,54600,
     6  55224,55104,55104,54768,54984,55176,55464,55608,55680,55776,
     7  55992,55848,55848,55560,55728,55824,55824,55896,55944,56232,
     8  56328,56280,56424,57408,57408,57456,57696,57504,57600,57576,
     9  57432,57168,57792,57888,58032,58056,53136,52752,52728,52824/
            data (jy(i),i=  301,  400)/
     +  52800,52608,52368,51936,51264,51048,50952,50808,50736,50544,
     1  50352,49560,49248,49128,48864,48768,48696,48456,48360,47904,
     2  47568,47136,52008,46632,46752,46608,46752,46536,46608,46584,
     3  46680,46848,46824,46896,46752,46680,46704,47352,48288,48360,
     4  48264,48288,48120,48240,48000,47928,47904,48048,47928,48048,
     5  48336,48408,48432,48360,48696,48816,49296,49632,49848,49920,
     6  50136,50232,50928,51936,51816,46584,46512,46488,46704,46632,
     7  46464,46320,46488,46464,46368,46056,46008,45816,45312,45096,
     8  44808,44616,44424,44328,44064,43992,43848,43680,43488,43224,
     9  43080,42720,27360,40200,40320,40320,40416,40536,40584,40824/
            data (jy(i),i=  401,  500)/
     +  40560,40584,40464,40464,40320,40200,40320,40488,40512,40584,
     1  40704,40656,40680,40896,40944,40848,40536,40320,41520,39384,
     2  39480,39456,39336,39336,38328,37632,37632,37824,37968,38184,
     3  38232,38280,38256,38448,38424,34800,35424,35568,36192,36888,
     4  37224,37464,37584,37584,37512,37296,37320,37008,37200,36984,
     5  37416,37464,37392,37440,37512,37440,37560,37680,37968,38208,
     6  38184,37848,37704,37776,37680,37656,37848,37992,38160,38280,
     7  38544,33672,33552,33336,33240,33096,32952,32328,32424,32304,
     8  31944,31848,31728,31416,31176,30912,30312,30072,29808,29712,
     9  29760,29904,29808,29664,29184,28848,28824,28632,28320,28272/
            data (jy(i),i=  501,  600)/
     +  28272,28152,28152,28224,27960,27792,27600,27456,27336,27336,
     1  27216,27192,27024,26976,26976,26856,26856,26952,26808,26736,
     2  26736,26616,26616,26688,26472,26448,26088,26112,26064,26112,
     3  59784,59856,59136,59112,58392,58416,58176,58176,57816,57816,
     4  56928,56952,56208,56208,55704,55704,55464,55488,55248,55248,
     5  55152,55152,54912,54912,54432,54432,54072,54168,53448,57120,
     6  57168,56448,56472,52776,52776,52032,52224,52968,52944,53928,
     7  53904,54408,54384,55104,55128,55272,55320,55968,55968,56064,
     8  56064,55992,56016,56376,56424,58272,58296,59016,59016,59376,
     9  59400,58152,58152,57912,57912,57792,57792,57648,58128,58176/
            data (jy(i),i=  601,  700)/
     +  52848,52968,53064,53160,53208,53280,53304,53400,53424,53544,
     1  53616,53640,53880,53928,53976,54096,54096,54168,54288,54312,
     2  54240,54288,54384,54504,54552,54888,54960,55008,55104,55152,
     3  55176,55296,55320,55392,55488,55560,55632,55728,55872,55752,
     4  55752,55824,55872,56016,55968,56112,56256,56304,56352,56496,
     5  56808,56928,57072,57024,57144,57240,57240,57336,57432,57456,
     6  57624,57720,57864,57864,57648,57720,52464,52608,52608,53352,
     7  53328,54048,54024,52464,52416,52776,52968,53088,53112,53376,
     8  53376,53496,53880,54072,54120,54288,54288,54408,54264,54264,
     9  54432,54528,54480,54624,54624,54720,54768,55008,54984,55296/
            data (jy(i),i=  701,  800)/
     +  55344,55512,55728,56112,56208,56184,56448,56712,56856,56952,
     1  53784,53808,56016,56040,55512,55752,55968,55920,56040,56208,
     2  56328,56424,56664,56760,55200,55200,55416,55440,55224,55224,
     3  55344,55368,55728,55728,55944,55944,56088,56088,56208,56208,
     4  56448,56448,56568,56568,56688,56688,56808,56808,56952,56952,
     5  57072,57072,57192,57192,57288,57312,57552,57552,54216,54216,
     6  54456,54456,54576,54600,54720,54720,54816,54840,54960,54960,
     7  55104,55104,55224,56928,56928,56808,56808,56688,56688,56568,
     8  56568,56448,56448,56328,56304,56184,56184,56064,56064,55944,
     9  55944,55056,54912,54768,54408,54096,52176,52176,53400,53352/
            data (jy(i),i=  801,  900)/
     +  54360,54360,54456,54456,54216,53736,53736,53304,52560,52488,
     1  52536,52632,52680,52800,52776,53016,52968,53064,52680,52440,
     2  52440,52560,52776,52824,52776,52536,52560,52464,52296,51984,
     3  53688,53496,53496,53376,53352,53208,52656,52608,52488,52368,
     4  52176,52152,52008,51888,51912,51744,51720,51648,51192,51048,
     5  51048,50808,50784,50616,52632,52680,52632,52560,52344,52056,
     6  52032,52104,52104,52248,52176,52200,52080,51984,52176,52248,
     7  52224,52128,51888,51792,51480,51336,51240,51000,50952,50976,
     8  50856,50736,50640,50496,50352,50280,50232,52128,52152,52392,
     9  52392,52512,52536,52680,52800,52896,52848,52944,52992,53232/
            data (jy(i),i=  901, 1000)/
     +  53208,53304,53400,53424,53760,53952,53808,53808,53664,51936,
     1  52104,51888,51864,51888,51840,51552,51216,51192,50952,50736,
     2  50208,50136,50160,49992,49920,49776,49848,49752,49416,49344,
     3  49272,49272,49200,49032,48888,48648,48600,48168,47928,47832,
     4  47736,47664,47496,47232,46992,46944,46800,46776,46632,46224,
     5  45960,46056,50568,50640,50736,50712,50856,50856,51024,51384,
     6  51456,51672,51936,52608,52896,53040,53160,53184,53232,53352,
     7  53736,53736,53856,53856,49320,49320,49176,49152,46056,50424,
     8  50424,50112,50112,50040,50088,50016,49968,49872,49800,48072,
     9  50424,50016,49896,49752,49632,49704,49560,49560,49344,48984/
            data (jy(i),i= 1001, 1100)/
     +  48888,49296,49344,49416,49560,49776,49848,49920,50040,50088,
     1  50160,50328,50376,50352,50760,50832,50928,50928,51072,51408,
     2  51456,51648,51744,51984,48864,48936,48888,49056,49224,48960,
     3  48960,49272,49392,49464,49464,49416,49536,49656,49728,49632,
     4  49704,49800,49776,49824,49752,49632,49584,49632,49512,49296,
     5  49200,49224,49104,49128,48984,48864,48960,49152,49152,49296,
     6  49368,49440,49296,49152,48336,48072,47640,47472,47256,46872,
     7  46776,46656,46416,46488,46512,47232,47256,47976,46992,47088,
     8  46680,46704,46008,46704,47448,47448,47568,47568,47688,47664,
     9  47808,47784,47904,47736,47592,47592,47472,47472,47280,47280/
            data (jy(i),i= 1101, 1200)/
     +  47088,47088,46968,46968,46848,46824,46728,46704,46584,46584,
     1  46464,46440,46200,46176,46056,45456,45744,45744,45984,45984,
     2  46368,46368,46728,46704,48576,48576,40800,40728,41472,41448,
     3  42192,42120,42840,42816,44328,44352,45528,45504,45288,44208,
     4  45456,45432,45168,45120,45024,44976,44736,44736,45240,45240,
     5  45480,45384,45504,45480,45312,45168,45096,44976,45024,44976,
     6  45000,44928,44880,44904,44832,44976,45192,45552,45648,45696,
     7  45840,45864,46056,46128,46248,46320,46320,46512,46560,46704,
     8  46728,47280,47400,47544,47616,47616,47784,47808,47760,47880,
     9  47976,48024,48120,48312,48408,48456,48576,48744,48792,43080/
            data (jy(i),i= 1201, 1300)/
     +  45408,45456,44088,43344,38328,37968,34632,34632,29232,29232,
     1  43056,40848,41904,41832,41832,41880,41880,42048,42048,42168,
     2  42168,42264,42240,42360,42432,42600,42576,42504,42504,42384,
     3  42384,42120,42120,41928,41904,41592,41592,41424,41400,41160,
     4  41160,39912,39816,39888,39912,40296,40392,40536,40608,40872,
     5  41040,41376,41880,42192,42216,42384,42312,42336,42720,42864,
     6  43248,43416,43536,43536,43968,44280,44688,45000,45216,40056,
     7  39864,39720,38928,38928,38208,38208,36744,36744,35232,35256,
     8  34512,34512,33168,33048,33048,32736,39648,39648,39624,39528,
     9  39480,39264,38952,38856,38784,38352,38280,36384,36360,34128/
            data (jy(i),i= 1301, 1400)/
     +  34128,32688,32880,39096,39144,38280,32520,32472,37656,37680,
     1  38160,37968,37920,37608,37608,37488,37320,37176,36984,36912,
     2  36816,36552,36408,35760,35472,35232,35136,35112,34512,32064,
     3  32064,32112,32160,32280,32280,32448,32424,32472,32472,32544,
     4  32544,32616,32664,32760,32760,32904,32904,33072,33024,33144,
     5  33144,33264,33264,33384,33384,33504,33504,33648,33648,33768,
     6  33768,33888,33888,34008,34008,34128,34128,34248,34248,34392,
     7  34392,34488,34200,34080,34008,33888,33888,33768,33696,33576,
     8  33576,33408,33384,33120,33120,32784,32376,32376,31752,31776,
     9  31848,31848,31896,31896,31992,31992,32184,32184,32328,32328/
            data (jy(i),i= 1401, 1500)/
     +  32640,32640,32688,32688,32736,32856,32736,32664,32712,32328,
     1  32328,32448,32424,32328,32328,32256,32256,32136,32136,32088,
     2  31992,32064,32088,32184,32184,32304,32304,32256,32208,32256,
     3  32184,32184,32064,32064,31416,31248,30864,30720,30624,30384,
     4  30312,30264,30312,30264,30312,30288,29880,29784,29592,29472,
     5  29352,29136,29112,28992,29040,28824,28704,28608,28104,28056,
     6  27912,27888,27720,27480,27216,27120,26832,26424,27888,27768,
     7  27768,27888,28824,28824,28704,28704,33456,33504,33456,33288,
     8  33384,32856,32952,32928,32712,32688,31752,31872,31872,31728,
     9  29904,29928,29784,29760,29832,35544,35424,35544,35664,44208/
            data (jy(i),i= 1501, 1580)/
     +  44208,44064,44088,52176,52176,52296,52296,55488,55608,55608,
     1  55488,55848,55824,55704,55704,56736,56976,56808,56712,56376,
     2  56472,56400,56568,56376,56088,56208,56304,59640,59640,59520,
     3  59520,59352,59352,59232,59232,60144,60096,60024,61248,61224,
     4  61200,61272,61968,62040,62040,61824,61584,61560,61512,61608,
     5  61584,61488,61488,62304,62256,62280,61800,61776,61632,61680,
     6  62136,62064,62112,62040,62112,62136,62088,62064,62016,62064,
     7  61896,61824,61848,61920,62184,62160,62232,62232,    0,    0/
            data (jb1(i),i=    1,  100)/
     +     16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
     1     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     2     36,   37,   38,   39,   40,   41,   42,   14,    3,   51,
     3     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     4     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     5     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     6     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     7     92,   93,   94,   95,   96,   97,   98,   99,  100,  101,
     8    102,  103,  104,  105,  106,  107,  108,    4,    1,  110,
     9    111,  112,  113,  114,  115,  116,  117,  118,  119,  120/
            data (jb1(i),i=  101,  200)/
     +    121,  122,  123,  124,  125,  126,  127,  128,  129,  130,
     1    131,  132,  133,  134,  135,  136,  137,  138,   11,    2,
     2    140,  141,  142,  143,    1,    2,  145,  146,  147,  148,
     3    149,  150,  151,    7,    6,  153,  154,  155,  156,  157,
     4    158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
     5    168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
     6    178,  179,  180,    3,    7,  182,  183,  184,  185,  186,
     7    187,  188,  189,  190,    5,    9,  192,  193,  194,  195,
     8    196,   10,    5,  198,  199,    8,   10,  201,  202,  203,
     9    204,  205,  206,  207,  208,  209,  210,  211,  212,  213/
            data (jb1(i),i=  201,  300)/
     +    214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
     1      6,    8,  225,  226,  227,  228,  229,  230,  231,  232,
     2    233,  234,    9,  236,  237,  238,  239,  240,  241,  242,
     3    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     4    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     5    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     6    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     7    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     8    293,  294,  295,    4,   11,  297,  298,  299,  300,  301,
     9    302,  303,  304,  305,  306,  307,  308,  309,  310,  311/
            data (jb1(i),i=  301,  400)/
     +    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     1     13,   12,  236,   14,  324,  325,  326,  327,  328,  329,
     2    330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
     3    340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
     4    350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
     5    360,  361,  362,  363,  364,   12,   13,  366,  367,  368,
     6    369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
     7    379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
     8    389,  390,  391,  392,   15,   44,  394,  395,  396,  397,
     9    398,  399,  400,  401,  402,  403,  404,  405,  406,  407/
            data (jb1(i),i=  401,  500)/
     +    408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     1    418,   16,   44,  420,  421,  422,  423,  424,  425,  426,
     2    427,  428,  429,  430,  431,  432,  433,  434,   48,  436,
     3    437,  438,  439,  440,  441,  442,  443,  444,  445,  446,
     4    447,  448,  449,  450,  451,  452,  453,  454,  455,  456,
     5    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     6    467,  468,  469,  470,  435,   48,  472,  473,  474,  475,
     7    476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
     8    486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
     9    496,  497,  498,  499,  500,  501,  502,  503,  504,  505/
            data (jb1(i),i=  501,  600)/
     +    506,  507,  508,  509,  510,  511,  512,  513,  514,  515,
     1    516,  517,  518,  519,  520,  521,  522,  523,  524,  525,
     2    526,   49,   15,   45,   46,   47,   47,  529,   50,   49,
     3    531,  531,  532,  533,  534,  535,  536,  537,  538,  539,
     4    540,  541,  542,  543,  544,  545,  546,  547,  548,  549,
     5    550,  551,  552,  553,  554,  555,  556,  557,  558,    2,
     6    560,  561,  562,  563,  564,  565,  567,  568,  569,  570,
     7    571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
     8    581,  582,  583,  584,  585,  586,  587,  588,  589,  590,
     9    531,    3,  592,  593,  594,  595,  596,  597,  592,  599/
            data (jb1(i),i=  601,  700)/
     +    600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
     1    610,  611,  612,  613,  614,  615,  616,  617,  618,  619,
     2    620,  621,  622,  623,  624,  625,  626,  627,  628,  629,
     3    630,  631,  632,  633,  634,  635,  636,  637,  638,  639,
     4    640,  641,  642,  643,  644,  645,  646,  647,  648,  649,
     5    650,  651,  652,  653,  654,  655,  656,  657,  658,  659,
     6    660,  661,  662,  663,  664,  598,  665,  666,  667,  668,
     7    669,  670,  671,  672,  673,  674,  675,  676,  677,  678,
     8    679,  680,  681,  682,  683,  684,  685,  686,  687,  688,
     9    689,  690,  691,  692,  693,  694,  695,  696,  697,  698/
            data (jb1(i),i=  701,  800)/
     +    699,  700,  701,  702,  703,  704,  705,  706,  707,  708,
     1    709,  710,  711,  712,  713,  714,  715,  716,  717,  718,
     2    719,  720,  721,  722,  723,  724,  725,  726,  727,  715,
     3    729,  730,  731,  732,  733,  734,  735,  736,  737,  738,
     4    739,  740,  741,  742,  743,  744,  745,  746,  747,  748,
     5    749,  750,  751,  752,  753,  754,  755,  756,  757,  592,
     6    759,  760,  761,  762,  763,  764,  765,  766,  767,  768,
     7    769,  770,  771,  772,  729,  598,  774,  775,  776,  777,
     8    778,  779,  780,  781,  782,  783,  784,  785,  786,  787,
     9    788,  789,  790,  725,  715,  792,  793,  794,  795,  711/
            data (jb1(i),i=  801,  900)/
     +    797,  798,  799,  729,  725,  801,  802,  803,  804,  759,
     1    806,  759,  559,  559,  808,  809,  810,  811,  812,  813,
     2    814,  815,  816,  817,  818,  819,  820,  821,  822,  823,
     3    824,  825,  826,  827,  828,  829,  711,  831,  832,  833,
     4    834,  835,  836,  837,  838,  839,  840,  841,  842,  843,
     5    844,  845,  846,  847,  848,  849,  850,  851,  852,  853,
     6    601,  855,  856,  857,  674,  667,  674,  830,  860,  861,
     7    862,  863,  864,  865,  866,  867,  868,  869,  567,  859,
     8    871,  872,  873,  874,  875,  876,  877,  878,  879,  880,
     9    881,  882,  883,  884,  885,  886,  567,  889,  890,  891/
            data (jb1(i),i=  901, 1000)/
     +    892,  893,  894,  895,  896,  897,  898,  899,  900,  901,
     1    902,  903,  904,  905,  906,  907,  908,  806,  797,  797,
     2    888,  566,  566,  667,  912,  910,  830,  914,  915,  916,
     3    917,  918,  919,  920,  921,  922,  923,  924,  925,  926,
     4    927,  928,  929,  930,  931,  932,  933,  934,  935,  936,
     5    937,  938,  939,  940,  941,  942,  943,  944,  945,  946,
     6    947,  948,  949,  950,  951,  854,  953,  954,  955,  956,
     7    957,  958,  959,  960,  961,  962,  963,  964,  965,  966,
     8    967,  968,  969,  970,  971,  972,  973,  806,  910,  975,
     9    976,  977,  979,  980,  912,  887,  887,  983,  984,  985/
            data (jb1(i),i= 1001, 1100)/
     +    986,  987,  988,  989,  854,  982,  982,  992,  993,  994,
     1    995,  996,  997,  998,  999, 1000, 1002, 1003, 1004, 1005,
     2   1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015,
     3   1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023,  889, 1001,
     4   1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034,
     5   1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044,
     6   1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054,
     7   1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1002,  978,
     8   1002, 1001, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072,
     9   1074, 1075, 1076, 1077,  990,  990, 1079, 1080, 1081, 1082/
            data (jb1(i),i= 1101, 1200)/
     +    979,   13, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091,
     1   1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101,
     2   1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111,
     3   1112, 1113, 1114,  952, 1116, 1117, 1118, 1119, 1120, 1121,
     4   1122, 1123, 1124, 1125,  978, 1073, 1127, 1128, 1129, 1130,
     5   1131, 1132, 1133, 1134, 1135, 1074, 1073, 1137, 1138,  952,
     6   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150,
     7   1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160,
     8   1161, 1162, 1163, 1164, 1165, 1166, 1139, 1141, 1168, 1169,
     9   1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179/
            data (jb1(i),i= 1201, 1300)/
     +   1180, 1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189,
     1   1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1064,
     2   1116,  979,   14, 1201, 1116, 1140, 1203, 1200, 1140, 1205,
     3   1206, 1207, 1208, 1209, 1210, 1200, 1211, 1127,   16, 1213,
     4   1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223,
     5   1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233,
     6   1234, 1235, 1236, 1237, 1238, 1239, 1240, 1241, 1243, 1244,
     7   1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254,
     8   1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264,
     9   1265, 1266, 1267, 1268, 1139, 1127, 1270, 1243,   44, 1272/
            data (jb1(i),i= 1301, 1400)/
     +   1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282,
     1   1283, 1284, 1285, 1242, 1287, 1243, 1289, 1290, 1291, 1292,
     2   1293, 1294, 1295, 1296, 1270, 1298, 1299, 1300, 1301, 1302,
     3   1303, 1288, 1304, 1305, 1297,   46, 1307, 1308, 1309, 1271,
     4   1297, 1311, 1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319,
     5   1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328, 1330,
     6   1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340,
     7   1341, 1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350,
     8   1351, 1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360,
     9   1361, 1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370/
            data (jb1(i),i= 1401, 1500)/
     +   1371, 1329, 1329,   48, 1373, 1374, 1375, 1376, 1377, 1378,
     1   1379, 1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388,
     2   1389, 1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398,
     3   1399, 1400, 1401, 1402, 1403, 1404, 1286, 1286, 1406, 1407,
     4   1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417,
     5   1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427,
     6   1428, 1429, 1430, 1431, 1432, 1330, 1409, 1434, 1435, 1436,
     7   1437, 1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446,
     8   1447, 1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456,
     9   1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466/
            data (jb1(i),i= 1501, 1600)/
     +   1467, 1468, 1330,    1,    2,    3,    1,    5,    6,    7,
     1      5,    9,   10,   11,   12,    9,   14,   15,   16,   17,
     2     14,   19,   20,   21,   19,   23,   24,   25,   26,   23,
     3     28,   29,   30,   28,   32,   33,   34,   32,   36,   37,
     4     38,   36,   40,   41,   42,   40,   44,   45,   46,   44,
     5     48,   49,   50,   48,   52,   53,   54,   55,   52,   57,
     6     58,   57,   60,   61,   62,   60,   64,   65,   66,   64,
     7     68,   69,   68,   71,   72,   73,   71,   75,   76,   77,
     8     75,   79,   80,   81,   79,   83,   84,   83,   86,   87,
     9     86,   89,   90,   91,   89,   93,   94,   93,   96,   97/
            data (jb1(i),i= 1601, 1620)/
     +     96,   99,  100,  101,   99,  103,  104,  105,  103,  107,
     1    108,  109,  107,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
     1     27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
     2     37,   38,   39,   40,   41,   42,   43,   43,   51,   52,
     3     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     4     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     5     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     6     83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
     7     93,   94,   95,   96,   97,   98,   99,  100,  101,  102,
     8    103,  104,  105,  106,  107,  108,  109,  109,  110,  111,
     9    112,  113,  114,  115,  116,  117,  118,  119,  120,  121/
            data (jb2(i),i=  101,  200)/
     +    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     1    132,  133,  134,  135,  136,  137,  138,  139,  139,  140,
     2    141,  142,  143,  144,  144,  145,  146,  147,  148,  149,
     3    150,  151,  152,  152,  153,  154,  155,  156,  157,  158,
     4    159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
     5    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     6    179,  180,  181,  181,  182,  183,  184,  185,  186,  187,
     7    188,  189,  190,  191,  191,  192,  193,  194,  195,  196,
     8    197,  197,  198,  199,  200,  200,  201,  202,  203,  204,
     9    205,  206,  207,  208,  209,  210,  211,  212,  213,  214/
            data (jb2(i),i=  201,  300)/
     +    215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
     1    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     2    234,  235,  235,  237,  238,  239,  240,  241,  242,  243,
     3    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     4    254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
     5    264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
     6    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     7    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     8    294,  295,  296,  296,  297,  298,  299,  300,  301,  302,
     9    303,  304,  305,  306,  307,  308,  309,  310,  311,  312/
            data (jb2(i),i=  301,  400)/
     +    313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
     1    322,  323,  323,  324,  325,  326,  327,  328,  329,  330,
     2    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     3    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     4    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     5    361,  362,  363,  364,  365,  365,  366,  367,  368,  369,
     6    370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
     7    380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     8    390,  391,  392,  393,  393,  394,  395,  396,  397,  398,
     9    399,  400,  401,  402,  403,  404,  405,  406,  407,  408/
            data (jb2(i),i=  401,  500)/
     +    409,  410,  411,  412,  413,  414,  415,  416,  417,  418,
     1    419,  419,  420,  421,  422,  423,  424,  425,  426,  427,
     2    428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
     3    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     4    448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
     5    458,  459,  460,  461,  462,  463,  464,  465,  466,  467,
     6    468,  469,  470,  471,  471,  472,  473,  474,  475,  476,
     7    477,  478,  479,  480,  481,  482,  483,  484,  485,  486,
     8    487,  488,  489,  490,  491,  492,  493,  494,  495,  496,
     9    497,  498,  499,  500,  501,  502,  503,  504,  505,  506/
            data (jb2(i),i=  501,  600)/
     +    507,  508,  509,  510,  511,  512,  513,  514,  515,  516,
     1    517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     2    527,  527,   45,   46,  528,  528,  529,  530,  530,   50,
     3      1,  532,  533,  534,  535,  536,  537,  538,  539,  540,
     4    541,  542,  543,  544,  545,  546,  547,  548,  549,  550,
     5    551,  552,  553,  554,  555,  556,  557,  558,  559,  560,
     6    561,  562,  563,  564,  565,  566,  568,  569,  570,  571,
     7    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     8    582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
     9    591,  592,  593,  594,  595,  596,  597,  598,  599,  600/
            data (jb2(i),i=  601,  700)/
     +      4,  602,  603,  604,  605,  606,  607,  608,  609,  610,
     1    611,  612,  613,  614,  615,  616,  617,  618,  619,  620,
     2    621,  622,  623,  624,  625,  626,  627,  628,  629,  630,
     3    631,  632,  633,  634,  635,  636,  637,  638,  639,  640,
     4    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     5    651,  652,  653,  654,  655,  656,  657,  658,  659,  660,
     6    661,  662,  663,  664,    5,  665,  666,    6,  668,  669,
     7    670,  671,  672,  673,    7,  675,  676,  677,  678,  679,
     8    680,  681,  682,  683,  684,  685,  686,  687,  688,  689,
     9    690,  691,  692,  693,  694,  695,  696,  697,  698,  699/
            data (jb2(i),i=  701,  800)/
     +    700,  701,  702,  703,  704,  705,  706,  707,  708,  709,
     1    710,    8,  712,  713,  714,    9,  716,  717,  718,  719,
     2    720,  721,  722,  723,  724,   10,  726,  727,  728,  728,
     3    730,  731,  732,  733,  734,  735,  736,  737,  738,  739,
     4    740,  741,  742,  743,  744,  745,  746,  747,  748,  749,
     5    750,  751,  752,  753,  754,  755,  756,  757,  758,  758,
     6    760,  761,  762,  763,  764,  765,  766,  767,  768,  769,
     7    770,  771,  772,  773,  773,  774,  775,  776,  777,  778,
     8    779,  780,  781,  782,  783,  784,  785,  786,  787,  788,
     9    789,  790,  791,  791,  792,  793,  794,  795,  796,  796/
            data (jb2(i),i=  801,  900)/
     +    798,  799,  800,  800,  801,  802,  803,  804,  805,  805,
     1    807,  807,   11,  808,  809,  810,  811,  812,  813,  814,
     2    815,  816,  817,  818,  819,  820,  821,  822,  823,  824,
     3    825,  826,  827,  828,  829,  830,  831,  832,  833,  834,
     4    835,  836,  837,  838,  839,  840,  841,  842,  843,  844,
     5    845,  846,  847,  848,  849,  850,  851,  852,  853,  854,
     6    855,  856,  857,  858,  858,  859,  859,  860,  861,  862,
     7    863,  864,  865,  866,  867,  868,  869,  870,  870,  871,
     8    872,  873,  874,  875,  876,  877,  878,  879,  880,  881,
     9    882,  883,  884,  885,  886,  887,  888,  890,  891,  892/
            data (jb2(i),i=  901, 1000)/
     +    893,  894,  895,  896,  897,  898,  899,  900,  901,  902,
     1    903,  904,  905,  906,  907,  908,  909,  909,  889,  910,
     2    911,  911,  912,  913,  913,   12,  914,  915,  916,  917,
     3    918,  919,  920,  921,  922,  923,  924,  925,  926,  927,
     4    928,  929,  930,  931,  932,  933,  934,  935,  936,  937,
     5    938,  939,  940,  941,  942,  943,  944,  945,  946,  947,
     6    948,  949,  950,  951,  952,  953,  954,  955,  956,  957,
     7    958,  959,  960,  961,  962,  963,  964,  965,  966,  967,
     8    968,  969,  970,  971,  972,  973,  974,  974,  975,  976,
     9    977,  978,  980,  981,  981,  982,  983,  984,  985,  986/
            data (jb2(i),i= 1001, 1100)/
     +    987,  988,  989,  990,  991,  991,  992,  993,  994,  995,
     1    996,  997,  998,  999, 1000, 1001, 1003, 1004, 1005, 1006,
     2   1007, 1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016,
     3   1017, 1018, 1019, 1020, 1021, 1022, 1023, 1024, 1024, 1025,
     4   1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035,
     5   1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043, 1044, 1045,
     6   1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055,
     7   1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1063, 1064,
     8   1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073,
     9   1075, 1076, 1077, 1078, 1078, 1079, 1080, 1081, 1082, 1083/
            data (jb2(i),i= 1101, 1200)/
     +   1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092,
     1   1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102,
     2   1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112,
     3   1113, 1114, 1115, 1115, 1117, 1118, 1119, 1120, 1121, 1122,
     4   1123, 1124, 1125, 1126, 1126, 1074, 1128, 1129, 1130, 1131,
     5   1132, 1133, 1134, 1135, 1136, 1136, 1137, 1138, 1139, 1140,
     6   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151,
     7   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     8   1162, 1163, 1164, 1165, 1166, 1167, 1167, 1168, 1169, 1170,
     9   1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180/
            data (jb2(i),i= 1201, 1300)/
     +   1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190,
     1   1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1199,
     2   1141, 1200, 1201, 1202, 1202, 1203, 1204, 1204, 1205, 1206,
     3   1207, 1208, 1209, 1210,   15, 1211, 1212, 1212, 1213, 1214,
     4   1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223, 1224,
     5   1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233, 1234,
     6   1235, 1236, 1237, 1238, 1239, 1240, 1241, 1242, 1244, 1245,
     7   1246, 1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254, 1255,
     8   1256, 1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265,
     9   1266, 1267, 1268, 1269, 1269, 1270, 1271, 1271, 1272, 1273/
            data (jb2(i),i= 1301, 1400)/
     +   1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283,
     1   1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292, 1293,
     2   1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303,
     3     45, 1304, 1305, 1306, 1306, 1307, 1308, 1309, 1310, 1310,
     4   1311, 1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320,
     5   1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1331,
     6   1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341,
     7   1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351,
     8   1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361,
     9   1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371/
            data (jb2(i),i= 1401, 1500)/
     +   1372, 1372,   47, 1373, 1374, 1375, 1376, 1377, 1378, 1379,
     1   1380, 1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389,
     2   1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399,
     3   1400, 1401, 1402, 1403, 1404, 1405, 1405, 1406, 1407, 1408,
     4   1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418,
     5   1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428,
     6   1429, 1430, 1431, 1432, 1433, 1433, 1434, 1435, 1436, 1437,
     7   1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447,
     8   1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457,
     9   1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467/
            data (jb2(i),i= 1501, 1600)/
     +   1468,   49,   50,    2,    3,    4,    4,    6,    7,    8,
     1      8,   10,   11,   12,   13,   13,   15,   16,   17,   18,
     2     18,   20,   21,   22,   22,   24,   25,   26,   27,   27,
     3     29,   30,   31,   31,   33,   34,   35,   35,   37,   38,
     4     39,   39,   41,   42,   43,   43,   45,   46,   47,   47,
     5     49,   50,   51,   51,   53,   54,   55,   56,   56,   58,
     6     59,   59,   61,   62,   63,   63,   65,   66,   67,   67,
     7     69,   70,   70,   72,   73,   74,   74,   76,   77,   78,
     8     78,   80,   81,   82,   82,   84,   85,   85,   87,   88,
     9     88,   90,   91,   92,   92,   94,   95,   95,   97,   98/
            data (jb2(i),i= 1601, 1620)/
     +     98,  100,  101,  102,  102,  104,  105,  106,  106,  108,
     1    109,  110,  110,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine pa(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1450) :: jx,jy
            integer(kind=iknd), save, dimension(1510) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'pennsylvania  '/
            data jrot,ipart/1,1/
            data kv/   1,1444,   0,   0,   0/
            data kb/   1,1510,   0,   0,   0/
            data iib/ 227,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  24936,23280,22848,22728,22512,22152,21984,21840,21240,21216,
     1  21072,21120,21288,21240,21336,21360,21648,21744,21720,21504,
     2  21408,21432,21264,20664,20568,20424,20472,20400,19944,23448,
     3  23520,23856,24120,24648,24696,24480,29592,24312,29856,34296,
     4  36456,37848,38136,42696,42696,49392,49968,52872,52368,52704,
     5  53112,53160,53400,53568,53664,53904,54048,54144,54144,53784,
     6  53472,53280,53088,53064,54144,54072,53376,53304,24744,24816,
     7  25056,25152,25344,25296,25488,25872,26088,26184,26448,26424,
     8  26520,26400,26472,26376,26616,26616,26736,27000,27144,27288,
     9  27384,27600,27672,27720,27984,28392,28464,28752,28968,29112/
            data (jx(i),i=  101,  200)/
     +  29640,29664,29760,29784,30504,30576,30696,30888,31080,31104,
     1  31416,31464,31488,31392,31416,31776,31896,31968,31896,32040,
     2  31920,32184,32136,32160,32088,32472,32592,32952,33024,33168,
     3  33192,33408,33504,33624,33864,34344,34488,34656,34824,35352,
     4  35832,36192,36216,36528,36408,36480,36624,36768,37128,37368,
     5  37584,37800,37968,38640,38808,39408,39624,39600,39648,39960,
     6  40344,40584,40536,40752,40872,41112,41664,41760,41784,41856,
     7  42144,42504,42600,42936,43128,43248,43296,43152,43176,43272,
     8  43584,44328,44784,45168,45360,45288,45432,45720,46200,46488,
     9  46608,46848,47400,47808,48168,48360,48528,48696,48864,48888/
            data (jx(i),i=  201,  300)/
     +  49032,48960,48984,49296,49512,49656,49704,50328,50448,50856,
     1  51000,51192,51336,51816,52056,52128,52152,52536,52560,52560,
     2  53160,52920,52704,52920,53304,53640,54192,24432,25800,25944,
     3  25944,28680,25440,25128,28344,28416,28776,28728,28800,29160,
     4  29208,29064,29136,29016,29256,29280,29328,29736,29832,28440,
     5  28416,28320,28536,28584,28704,28800,28848,28848,29016,29016,
     6  29184,29160,29328,29328,29496,29472,29616,29616,29784,29784,
     7  29904,29856,29952,30264,30312,30288,30192,30048,29904,29880,
     8  30504,30480,30792,30816,31536,30528,29208,30960,31008,31080,
     9  32088,31056,30816,30264,30168,29376,29400,32304,31200,31224/
            data (jx(i),i=  301,  400)/
     +  30864,30912,31104,31104,34248,33864,33864,33432,32064,31896,
     1  31992,31992,32112,32208,32112,32184,32136,32280,31560,30912,
     2  30936,30984,31080,32304,32472,32400,32280,32304,32448,32376,
     3  32232,32424,32280,32496,32448,32304,32616,32688,33552,33552,
     4  33960,32208,33552,34056,34104,32880,32880,31824,31752,34200,
     5  32184,32160,32328,32304,32880,32904,33216,33216,33648,33912,
     6  33960,34080,34032,34104,34056,33624,32376,34296,31584,31728,
     7  31920,32136,32160,32208,32184,32304,32616,32712,32808,32856,
     8  32784,32856,32904,32784,32904,33144,33288,33288,33408,33528,
     9  33624,33816,33912,34152,34200,34296,34440,34584,34320,34488/
            data (jx(i),i=  401,  500)/
     +  34440,34512,34512,34632,34632,35184,35304,34680,34512,34440,
     1  35472,35496,35496,35256,34800,34704,34728,35088,35328,35424,
     2  35544,35496,35400,35424,35280,34296,34200,33888,33888,33504,
     3  33504,33216,33096,32592,32544,35208,35424,35640,35592,35592,
     4  35976,35688,35688,35736,35856,35928,36024,35976,36048,34368,
     5  35712,35832,36600,36480,31584,31608,31848,32184,32568,32664,
     6  32736,32928,33264,34104,34488,34512,34632,34824,34968,35088,
     7  36504,36504,35520,36288,36312,36504,36840,34344,34488,34728,
     8  35232,35520,35760,35976,35952,36096,36360,36408,36504,36600,
     9  36552,36600,36696,36792,36864,36696,36672,36720,36720,36840/
            data (jx(i),i=  501,  600)/
     +  36696,36840,36792,36648,36576,36672,36792,36792,36744,36720,
     1  36432,36480,36576,36576,36672,36672,36768,36792,36984,36888,
     2  36720,36552,36600,36552,36600,36432,36480,36240,37512,37800,
     3  36648,36528,36432,36336,36048,35952,35856,35832,35760,35856,
     4  35784,35832,34896,34896,33912,34032,34224,34248,34464,34344,
     5  34512,34920,34968,35040,35040,35256,35280,35160,37824,38064,
     6  42600,39600,38040,36144,35136,34224,38232,36984,35784,35832,
     7  34896,40080,39864,39552,39456,39312,39120,38976,38856,38688,
     8  38568,38472,38352,38328,36096,35904,35952,36120,36096,36288,
     9  36288,36384,36408,36696,36936,37152,37176,37488,38736,38880/
            data (jx(i),i=  601,  700)/
     +  36144,36576,36840,37512,37848,38112,38544,38904,36480,36672,
     1  36840,37104,37512,37848,38232,38304,38496,39072,36312,37008,
     2  37152,37344,37704,38184,37944,37944,38016,37968,38256,38328,
     3  38664,38928,39072,37488,38544,39312,38952,38904,38952,38880,
     4  38976,39096,39240,39120,39840,36144,36240,36504,36768,36960,
     5  37800,38088,38184,38352,39744,40368,40320,40344,40392,40416,
     6  40272,39096,40128,40464,39072,39216,39432,39576,39816,39696,
     7  40152,40488,40272,40176,40008,39672,39552,39336,39192,39024,
     8  39048,38928,38760,38712,38664,38616,38496,38352,38256,38112,
     9  38136,37920,37848,37704,37704,37608,37680,37776,37560,37800/
            data (jx(i),i=  701,  800)/
     +  37848,37704,37488,37344,37224,37152,37200,37080,37056,36960,
     1  36936,36792,36696,36648,36456,36456,36360,36360,36216,36168,
     2  36096,35616,35544,35616,35496,35520,35424,35400,35256,40512,
     3  40440,40632,40704,39360,40776,41064,40584,39792,41184,40632,
     4  40536,40848,40800,40920,41208,41328,41400,41832,41688,41856,
     5  41928,38976,39360,39840,40296,41184,41472,41832,42168,42024,
     6  42000,42096,42072,42144,42072,41832,41880,41832,41592,41592,
     7  41424,41568,42288,41928,42000,41976,42120,42072,42216,42312,
     8  42312,42432,42432,42528,42504,42600,42456,40680,40584,40776,
     9  40992,41136,41328,41208,41448,41616,41664,41568,41640,41856/
            data (jx(i),i=  801,  900)/
     +  42168,42432,42456,42672,42528,42624,41160,41232,41232,42792,
     1  43296,43152,43656,40848,41088,41088,41232,41256,41208,41064,
     2  41088,41400,41736,41856,42144,41928,42456,42936,43080,41616,
     3  41568,41616,41880,42216,42792,43008,43392,43776,44160,44448,
     4  45144,45384,45672,44064,42312,43128,43032,43128,43056,43200,
     5  43416,43584,43776,43848,44088,40488,40464,42216,44016,44664,
     6  44304,47952,44832,42672,42792,43272,43200,43416,43392,43632,
     7  43656,43632,43392,43344,43632,43704,43680,43464,43704,43632,
     8  43608,43944,43872,43896,44184,44208,44016,44112,44304,44256,
     9  44328,44496,44568,44640,44664,44856,44880,44640,44784,44640/
            data (jx(i),i=  901, 1000)/
     +  44568,44448,44400,44280,44280,44400,45168,44304,45288,44952,
     1  43824,43536,42672,42384,41736,45408,45384,45480,45384,45408,
     2  45168,45072,45024,44712,43872,43728,43080,42840,42096,41976,
     3  41376,41328,41400,41232,41208,41064,40920,45000,45360,46008,
     4  46152,45768,45768,45648,45360,45264,45096,44664,44472,44328,
     5  44064,43968,43728,43296,43104,42960,42720,40824,40992,41208,
     6  41520,41544,41880,42024,42360,42480,42792,43056,43176,43032,
     7  42696,42696,43272,43704,43728,43584,43656,43896,44304,46176,
     8  46464,45912,45768,46464,45984,45744,45432,45384,45048,43632,
     9  43056,42792,42552,42264,45912,46248,46272,46488,46728,46608/
            data (jx(i),i= 1001, 1100)/
     +  46560,46608,46368,46248,46152,46056,47496,46968,46680,46200,
     1  46728,46392,46320,46248,45936,45720,45648,45480,44400,44280,
     2  44328,44232,44040,43872,42552,42264,42216,41880,41664,41496,
     3  41208,41040,40800,44784,45984,46080,46152,46200,46392,46704,
     4  46776,46224,46776,46056,46848,47472,49440,48528,48384,48264,
     5  48288,48240,48024,47976,48000,47952,47856,47832,47760,47712,
     6  47736,47616,47640,47520,47640,47616,46824,47136,47208,47136,
     7  47256,47592,47640,47592,47832,47856,48168,48696,48888,47976,
     8  48816,47928,47112,47928,47448,47376,46440,46224,46248,46320,
     9  46536,46848,46944,46968,46824,46512,46560,46728,46824,46632/
            data (jx(i),i= 1101, 1200)/
     +  46464,46440,46320,46704,46872,46944,46848,46896,47280,47376,
     1  47256,47256,47568,47760,47424,47208,48816,48456,48528,48336,
     2  48312,48120,48024,46872,47088,47304,47352,47568,47592,48072,
     3  48240,48120,48144,48360,48456,49080,48984,48624,48384,48216,
     4  48192,48000,47808,47712,47640,47832,48024,48000,48096,48336,
     5  48192,48288,48264,48168,48144,48024,47928,47952,47880,47784,
     6  47808,47712,47520,47400,47568,47688,47664,47568,47520,48048,
     7  48048,47904,47880,48288,48432,48624,48648,48528,48552,48720,
     8  48888,48984,48960,49008,49152,49272,49224,49224,49440,49800,
     9  49656,49752,46920,47592,49344,48408,48792,49440,49416,49152/
            data (jx(i),i= 1201, 1300)/
     +  49056,49056,49272,49320,49248,49080,49008,48984,48912,48816,
     1  48672,48456,48360,48264,48312,48240,48120,47832,49416,49464,
     2  49416,49488,49464,49320,49200,49080,49200,49176,49296,49176,
     3  49056,49008,49056,49032,48936,49032,48816,48768,48960,48936,
     4  49056,49272,49320,49272,49368,49296,49440,49512,49560,49536,
     5  49440,49488,49056,49104,49440,49896,52608,52512,52416,52128,
     6  52056,52008,51912,51696,51360,51288,51144,50952,50832,50496,
     7  50304,49872,49824,49872,49824,49752,49560,49320,49728,49800,
     8  49848,50016,49536,49680,49416,49896,50448,50928,50400,50352,
     9  51000,50400,50136,49944,48192,48408,48480,48504,48672,49008/
            data (jx(i),i= 1301, 1400)/
     +  49104,49320,49608,50088,50640,51000,51096,51312,51456,51624,
     1  51768,51768,51936,52080,52176,52272,52224,52224,50808,51432,
     2  51672,51768,51840,52032,52176,52272,52320,52200,50064,50232,
     3  50688,50712,50880,50856,51336,51432,51480,51600,51624,51504,
     4  51552,51672,51696,51792,51816,51840,51984,52056,52104,52152,
     5  52224,52320,52440,52536,52896,52608,52416,52200,51648,51384,
     6  51096,50832,50424,50088,49800,49872,49680,49608,49128,52368,
     7  52536,52656,52848,52896,52992,53040,47952,48648,48912,48864,
     8  49056,49584,52080,52608,48432,48720,48912,49128,49272,49440,
     9  49488,49872,50376,51888,52728,49512,50136,50232,50544,50808/
            data (jx(i),i= 1401, 1450)/
     +  51000,51696,52344,52584,52536,52392,52272,52032,52008,51696,
     1  51504,51288,51216,50184,50064,49584,49152,50064,51000,51192,
     2  51456,51504,52224,52248,52224,52464,52464,52752,52896,52992,
     3  53352,53424,53640,53688,53832,53856,53976,54072,54096,54000,
     4  53976,54096,54072,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  12192,12312,13416,13608,14352,15000,15456,15696,16032,16224,
     1  16368,16632,16632,16512,16440,16152,15888,15912,16032,16512,
     2  16584,16752,17160,18096,18432,18648,18840,19008,19824,19632,
     3  21096,27744,34656,54600,61008,47040,11880,40440,65015,11592,
     4  65759,11376,64511,11064,63719,10632,65927,16488,63551,59712,
     5  52632,21744,27552,31848,34656,41064,45672,54288,53424,53352,
     6  53208,53040,52776,52680,53256,53280,52872,52728,62328,62400,
     7  62400,62544,62663,62831,62975,63095,63047,63143,63167,63383,
     8  63503,63719,63887,64031,64127,64319,64559,64631,64967,64943,
     9  64751,64703,64775,65063,65159,65207,65015,65159,65111,65183/
            data (jy(i),i=  101,  200)/
     +  65255,65135,65063,64967,65495,65519,65471,65639,65663,65831,
     1  65807,65879,66071,66239,66359,66719,66671,66719,67007,67295,
     2  67535,67703,67895,68063,68207,68255,68471,68711,68663,68375,
     3  68111,67967,67703,67703,67391,67175,67055,66983,67055,66815,
     4  66479,66023,65927,65831,65999,65999,65879,65567,65423,65111,
     5  64631,64367,64319,64751,64895,65159,65039,64871,64751,64847,
     6  64607,64367,64031,63911,63743,63887,63671,63719,63887,63935,
     7  63719,63815,63719,63791,63767,63863,64031,64295,64511,64703,
     8  65015,65063,64967,65087,65399,65711,65999,66143,66263,66527,
     9  66839,67031,67271,67919,68087,68351,68423,68399,68207,68015/
            data (jy(i),i=  201,  300)/
     +  67775,67511,67415,67271,67007,66647,66335,65543,65231,64967,
     1  64583,64343,64295,64391,64271,64151,63791,10464,62975,62352,
     2  61536,61152,60528,59040,58512,58200,57960,27768,27672,27624,
     3  27384,27192,20976,15024,20808,21792,28560,28704,31800,31776,
     4  32400,34512,54816,32424,54840,58680,61200,47448,48048,20808,
     5  19968,18696,18696,18480,18480,18264,18288,18072,18048,17904,
     6  17880,17736,17736,17568,17544,17376,17376,17136,17136,16968,
     7  16968,15672,15672,40368,43320,46584,46632,46944,47016,47256,
     8  21696,21600,21576,22008,21984,53784,54024,35928,36552,40368,
     9  57528,58176,57864,58200,58152,58584,58656,25656,25728,25992/
            data (jy(i),i=  301,  400)/
     +  26016,26904,26904,27048,29376,29376,29112,29088,26976,26904,
     1  26832,26688,26496,26448,26280,26016,25872,25728,22728,22752,
     2  23184,23160,24624,24552,24720,24792,24792,24864,24864,24960,
     3  24960,25080,25272,25488,25584,25584,55776,53160,52896,51936,
     4  51528,48600,50088,16728,34008,34080,33888,33912,32304,19752,
     5  21936,21312,21312,20688,20664,20424,20376,20208,20184,19968,
     6  20040,19992,19680,19656,29976,30000,36504,35424,63983,63839,
     7  63863,63575,63407,63407,63287,63215,63215,63119,63095,62759,
     8  62639,62639,62568,62376,62256,62400,62328,62544,62639,62592,
     9  62615,62472,62496,62424,62328,62280,62448,62472,61344,61104/
            data (jy(i),i=  401,  500)/
     +  60960,60936,60840,60744,61968,35904,15696,15216,14136,14136,
     1  50088,49608,49272,48720,60624,60504,60384,60120,60048,59832,
     2  59832,59712,59688,59568,59376,59352,59064,59040,58944,58896,
     3  58992,58968,58464,57792,57624,48144,47256,47064,24384,24360,
     4  24336,59760,59688,59688,59544,59568,59472,59376,59328,64439,
     5  64151,64943,65423,65663,40344,40512,40560,40800,40920,41040,
     6  41280,41496,41544,42264,42696,42984,43128,43272,43272,43440,
     7  44448,44688,46488,46296,45408,44976,44664,19872,19800,19848,
     8  19824,20040,19920,20376,20544,20568,20472,20640,20712,20664,
     9  20472,20328,20280,20376,20544,20712,20832,20976,21096,21288/
            data (jy(i),i=  501,  600)/
     +  21360,21480,21552,21552,21624,21912,21888,21960,22032,22200,
     1  22368,22416,22368,22440,22464,22704,22608,22680,22680,22776,
     2  22776,22848,23016,23088,23184,23472,23640,23880,42792,41040,
     3  40368,40536,40488,40224,39864,39624,39576,39264,39168,39048,
     4  38928,38760,38208,37344,37344,37200,37104,36960,36936,36720,
     5  36600,36576,36456,36408,36312,36264,36192,36120,24240,28272,
     6  21648,24144,14928,14952,28368,28848,53808,53616,53640,53184,
     7  52776,61008,61896,62496,62807,62999,63119,63359,63287,63503,
     8  63551,63863,63983,64175,59256,59160,58896,58728,58632,58512,
     9  58320,58296,58176,58128,58152,58248,58368,58464,55872,55560/
            data (jy(i),i=  601,  700)/
     +  47160,47472,47472,47352,47208,47256,47448,47784,49824,49800,
     1  50280,50352,50304,50592,50832,50664,50712,50616,48648,48384,
     2  48384,48264,48216,48024,49224,49368,49440,49608,49944,50328,
     3  50256,50352,50448,44040,43272,42456,47256,47088,46872,46560,
     4  46440,45864,45816,45408,42480,59352,59616,59760,60048,60096,
     5  60816,60384,60432,60120,60888,14856,28152,28248,28248,59664,
     6  59928,53040,52800,52080,50880,50832,50904,50856,50904,51840,
     7  51936,32544,32400,32424,32640,32808,33024,33192,33168,33312,
     8  33528,33720,33720,33840,33720,33936,34008,33936,34008,34272,
     9  34344,34512,34656,34632,34536,34560,34752,34776,34896,34896/
            data (jy(i),i=  701,  800)/
     +  35016,35424,35328,35400,35376,35544,35616,35616,35688,35640,
     1  35544,35544,35472,35688,35664,35544,35520,35400,35424,35328,
     2  35352,35184,35280,35400,35448,35616,35616,35760,35760,34944,
     3  34776,32640,19368,42264,39240,58248,58920,56736,36600,37560,
     4  37848,38400,38904,38976,42456,43080,57768,56904,49416,48912,
     5  48888,47976,47928,47544,47400,47376,47232,46800,46560,46512,
     6  46440,46224,46056,45960,45864,45840,45648,45600,45552,45000,
     7  44880,44376,46440,48720,48648,48480,48024,47880,47784,47520,
     8  47280,47184,47064,46944,46752,46728,46536,19512,19608,19896,
     9  19944,20160,20184,20424,20352,20424,20448,20592,20736,20520/
            data (jy(i),i=  801,  900)/
     +  20592,20928,21096,21264,21384,21408,14856,14664,14496,12648,
     1  50496,62975,62376,59736,59880,60000,60096,60216,60288,60360,
     2  60480,60552,60720,60864,60960,61416,61824,61776,61680,32040,
     3  31800,31728,31656,31680,31344,30960,30648,30624,30432,30480,
     4  30408,29952,29760,51432,55848,55608,55368,55272,55152,54984,
     5  54312,54072,53424,52440,51600,28248,28128,27432,26640,26328,
     6  49056,50088,60456,21672,21576,21624,21840,21912,22080,22176,
     7  22248,22416,22464,22536,22512,22560,22656,22704,22824,22920,
     8  23112,23088,23304,23376,23376,23472,23640,23928,24072,24168,
     9  24528,24552,24888,24888,24768,24816,25080,25224,25416,25536/
            data (jy(i),i=  901, 1000)/
     +  25704,25776,25704,25776,25896,26160,60888,61608,38424,38688,
     1  39840,39840,41088,41016,42144,38304,37824,37704,37488,37368,
     2  37224,37248,37056,36984,37632,37824,37632,37704,38280,38544,
     3  39216,39192,39024,39000,39072,39072,39312,26160,25824,25416,
     4  46680,46488,45768,45648,45576,45624,45912,46032,46320,46392,
     5  46368,46200,46056,46080,45984,46056,46344,34560,34104,33912,
     6  33912,34032,34200,34392,34248,34272,34080,34200,34368,34536,
     7  34704,34752,34536,34464,34536,34656,34728,34680,34464,33336,
     8  54264,53736,53424,39168,39600,39912,40344,40560,40536,42960,
     9  44256,44160,45720,46368,29568,29520,29448,29568,29376,27384/
            data (jy(i),i= 1001, 1100)/
     +  27216,27096,27000,27000,26736,26712,47184,46752,46608,46728,
     1  17280,18144,17952,17928,18144,18072,18288,18168,18408,18480,
     2  18576,18720,18816,19080,19152,18864,18576,18504,18624,19032,
     3  19296,19392,19344,14280,16872,16752,16392,16320,16368,16896,
     4  38856,30888,31416,31608,33000,58776,44400,45456,46056,46008,
     5  46560,46704,46512,46560,46632,46680,46632,46512,46536,46632,
     6  46680,46728,46800,46776,46920,47112,17424,17424,17328,17040,
     7  16896,17064,17136,47424,47568,47784,48240,48312,48528,58008,
     8  56976,34512,33504,39648,40224,40512,41760,42192,42312,42288,
     9  41976,41640,41664,41736,42096,42576,42624,42552,42744,43488/
            data (jy(i),i= 1101, 1200)/
     +  44952,45696,46296,39312,39168,39216,39384,39432,39384,39432,
     1  39672,39816,39792,39576,51408,52632,65519,48816,48984,49128,
     2  49320,49608,49704,24912,24696,24624,24456,24480,24312,24144,
     3  23952,23904,23736,23592,23328,22920,22416,22320,21960,21840,
     4  21720,21504,21408,21288,21048,20520,20448,20328,20064,19896,
     5  19656,19536,19368,19296,19200,19200,19008,18792,18672,18672,
     6  18600,18504,58848,59088,59424,59568,59688,59640,59712,59952,
     7  60048,60072,60120,60288,60408,60456,60504,60600,60648,60600,
     8  60648,60816,61056,61104,60984,61080,61200,61488,61512,61752,
     9  62016,62088,38664,38160,37176,35160,36600,15840,15936,15888/
            data (jy(i),i= 1201, 1300)/
     +  15984,16152,16272,16392,16512,16584,16728,16992,17088,17088,
     1  16944,17088,16920,16896,17304,17472,17520,17424,15744,15624,
     2  15504,15408,15336,15336,15432,15264,15096,14976,14712,14304,
     3  14208,14064,14016,13680,13464,13176,13008,12840,12744,12576,
     4  12120,11880,11592,11448,11352,11328,11160,11160,11064,10944,
     5  10944,10848,65879,66023,66095,65831,16632,16560,16368,16344,
     6  16368,16584,16608,16488,16488,16344,16488,16464,16608,16488,
     7  16560,16248,16080,15888,15768,15720,15720,65039,64751,64799,
     8  64775,64607,63935,63815,63455,63047,63599,62903,62472,62568,
     9  41040,41736,42744,43944,39720,39912,39912,40008,40176,40224/
            data (jy(i),i= 1301, 1400)/
     +  40344,40368,40560,40752,41232,62927,63167,63167,63311,63191,
     1  63215,63167,63143,63023,63047,63263,63335,63503,21792,21576,
     2  21912,21912,22032,22056,22008,21936,22032,21984,61584,61632,
     3  61176,61296,61296,61248,60456,60504,60384,60432,60384,60336,
     4  60264,60264,60192,60216,60096,60120,59976,59976,59808,59856,
     5  59712,59760,59688,59760,52392,52200,52152,51936,51840,51264,
     6  50904,50760,50712,50472,50400,50088,49272,49128,48840,21744,
     7  21888,21720,21720,21600,21600,21744,28800,28584,28464,28368,
     8  28224,28176,28128,27984,34248,34032,33744,33768,33984,33912,
     9  33744,33768,33456,32856,32424,36984,36576,36600,36432,36384/
            data (jy(i),i= 1401, 1450)/
     +  36240,36024,35688,45696,45816,45888,46128,46056,45936,45864,
     1  46008,46008,46056,45528,45144,44784,56328,56376,55848,55800,
     2  55896,55728,55824,55776,55656,55608,55488,55512,55368,55392,
     3  55176,55080,55008,54840,54816,54672,54720,54672,54576,54576,
     4  54480,54480,54336,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     1     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     2     21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
     3     58,   59,   60,   61,   62,   63,   51,   57,   65,   66,
     4     67,   51,   31,   32,   33,   36,   34,   34,   35,   69,
     5     70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
     6     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     7     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     8    100,  101,  102,  103,   39,    1,   39,  105,  106,  107,
     9    108,  109,  110,  111,  112,  113,  114,  115,  116,  117/
            data (jb1(i),i=  101,  200)/
     +    118,  119,  120,  121,  122,  123,  124,  125,  126,  127,
     1    128,  129,  130,  131,  132,  133,  134,  135,  136,  137,
     2    138,  139,  140,  141,  142,   41,   37,   41,  144,  145,
     3    146,  147,  148,  149,  150,  151,  152,   43,   40,   42,
     4     43,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     5    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     6     45,   44,   45,  174,  175,  176,  177,  178,  179,  180,
     7    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     8    191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
     9    201,  202,  203,  204,  205,  206,   47,   47,  208,  209/
            data (jb1(i),i=  201,  300)/
     +    210,  211,  212,  213,  214,  215,  216,   49,   48,   46,
     1     48,   52,   49,  219,  220,  221,  222,   50,   53,   54,
     2     55,   56,   50,  224,  225,  226,   58,   32,  228,  229,
     3    230,  231,   31,    1,  233,  233,  235,  232,  232,  237,
     4    238,  239,  240,   33,   34,  241,  242,  243,  245,   35,
     5    246,   36,  248,  235,  250,  251,  252,  253,  254,  255,
     6    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     7    266,  267,  268,  269,  270,  271,  272,  273,   38,  274,
     8    275,  276,  277,  278,  279,  248,  236,  281,  282,  283,
     9    284,  286,  243,  249,  242,  288,  274,  289,  291,  292/
            data (jb1(i),i=  301,  400)/
     +    293,  294,  295,  296,  246,  298,  299,  300,  301,  302,
     1    303,  232,  305,  306,  307,  308,  309,  310,  311,  312,
     2    313,  314,  315,  316,  317,  298,  285,  319,  320,  321,
     3    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     4    332,  333,  334,  335,  298,  291,  337,  286,  338,  339,
     5    340,  249,  342,  341,  271,  345,  346,  347,  348,  241,
     6    344,  285,  351,  352,  353,  354,  355,  356,  357,  358,
     7    359,  360,  361,  362,  363,  350,  305,  365,  345,  289,
     8    367,  345,   39,  369,  370,  371,  372,  373,  374,  375,
     9    376,  377,  378,  379,  380,  381,  382,  383,  384,  385/
            data (jb1(i),i=  401,  500)/
     +    386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
     1    396,  397,  247,  399,  400,  401,  402,  403,  398,  404,
     2    368,  344,  407,  408,  409,  410,  341,  411,  412,  413,
     3    404,  415,  416,  417,  418,  419,  420,  421,  422,  423,
     4    424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
     5    434,  291,  414,  436,  437,  324,  439,  440,  421,  442,
     6    443,  444,  445,  446,  447,  448,  398,  450,  451,  452,
     7    453,  454,  290,  455,  456,  457,  458,  459,  460,  461,
     8    462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
     9    438,  473,  474,  475,  472,  472,  350,  478,  479,  480/
            data (jb1(i),i=  501,  600)/
     +    481,  482,  483,  484,  485,  486,  487,  488,  489,  490,
     1    491,  492,  493,  494,  495,  496,  497,  498,  499,  500,
     2    501,  502,  503,  504,  505,  506,  507,  508,  509,  510,
     3    511,  512,  513,  514,  515,  516,  517,  518,  519,  520,
     4    521,  522,  523,  524,  525,  526,  527,  441,  477,  529,
     5    530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
     6    540,  541,  542,  543,  544,  545,  546,  547,  548,  549,
     7    550,  551,  552,  553,  554,  555,  556,  557,  406,  441,
     8    559,  561,  559,  563,  407,  563,  560,  565,  305,  567,
     9    568,  569,  570,  339,  572,  573,  574,  575,  576,  577/
            data (jb1(i),i=  601,  700)/
     +    578,  579,  580,  581,  582,  583,  584,  449,  585,  586,
     1    587,  588,  589,  590,  591,  592,  593,  594,  595,  596,
     2    597,  598,  599,  567,  438,  601,  602,  603,  604,  605,
     3    606,  607,  412,  609,  610,  611,  612,  613,  614,  615,
     4    616,  617,  414,  619,  620,  621,  622,  623,  624,  625,
     5    626,  627,  628,  629,  630,  631,  632,  618,  477,  634,
     6    635,  608,  637,  638,  639,  640,  641,  642,  643,  644,
     7    636,  449,  646,  647,  648,  649,  650,  651,  652,  653,
     8    654,  572,  563,  560,  657,  658,  660,  572,  567,  662,
     9    663,  618,  665,  666,  667,  668,  669,  670,  664,  672/
            data (jb1(i),i=  701,  800)/
     +    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     1    683,  684,  685,  686,  687,  688,  689,  690,  691,  692,
     2    693,  694,  695,  696,  697,  698,  699,  700,  701,  702,
     3    703,  704,  705,  706,  707,  708,  709,  710,  711,  712,
     4    713,  714,  715,  716,  717,  718,  719,  720,  721,  722,
     5    723,  724,  725,  726,  727,  728,  406,  730,  672,  672,
     6    659,  350,  656,  636,  734,  736,  660,  599,  736,  730,
     7    739,  740,  741,  742,  743,  735,  645,  745,  736,  747,
     8    664,  749,  750,  608,  752,  753,  754,  755,  756,  757,
     9    758,  759,  760,  761,  762,  763,  764,  765,  766,  767/
            data (jb1(i),i=  801,  900)/
     +    768,  769,  770,  771,  746,  759,  751,  774,  775,  776,
     1    777,  778,  779,  780,  781,  782,  783,  784,  785,  786,
     2    773,  733,  788,  789,  790,  791,  792,  793,  794,  795,
     3    796,  797,  798,  799,  800,  801,  802,  803,  804,  805,
     4    561,  656,  807,  808,  809,  810,  751,   45,  812,  660,
     5    814,  815,  816,  817,  818,  819,  820,  821,  822,  823,
     6    824,  825,  826,  827,  828,  813,  732,  830,  831,  832,
     7    833,  834,  835,  836,  837,  838,  839,  840,  841,  842,
     8    811,  748,  845,  846,  847,  848,  849,  850,  851,  852,
     9    853,  854,  844,  659,  856,  857,  858,  859,  811,  861/
            data (jb1(i),i=  901, 1000)/
     +    748,  561,  864,  865,  866,  867,  868,  869,  870,  871,
     1    872,  873,  874,  875,  876,  877,  878,  879,  880,  881,
     2    882,  883,  884,  885,  886,  887,  888,  889,  890,  891,
     3    892,  893,  894,  895,  896,  897,  898,  899,  900,  901,
     4    902,  903,  904,  905,  860,  907,  813,  863,  909,  910,
     5    911,  912,  913,  914,  746,  909,  916,  917,  918,  919,
     6    920,  921,  922,  923,  924,  925,  926,  927,  928,  929,
     7    930,  931,  932,  933,  934,  935,  936,  735,  860,  938,
     8    939,  941,  942,  943,  944,  945,  946,  947,  948,  949,
     9    950,  951,  952,  953,  954,  955,  956,  773,  730,  958/
            data (jb1(i),i= 1001, 1100)/
     +    959,  960,  961,  962,  963,  964,  965,  966,  967,  968,
     1    969,  970,  971,  972,  973,  974,  975,  976,  977,  978,
     2    979,  981,  982,  844,  984,  985,  986,  987,  988,  989,
     3    990,  991,  992,  993,  773,  843,  995,  996,  997,  998,
     4    999, 1000, 1001, 1002, 1003, 1004, 1005,  940, 1007, 1008,
     5   1009,  941, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018,
     6   1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028,
     7   1029, 1030, 1031, 1032,  733,  810, 1034, 1035, 1036, 1037,
     8   1038, 1039, 1011,  984,  909,  843, 1042, 1043, 1044,  980,
     9    863, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055/
            data (jb1(i),i= 1101, 1200)/
     +   1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065,
     1   1007, 1011, 1067, 1068, 1069, 1070, 1071, 1072, 1007, 1074,
     2   1075, 1076, 1077, 1078, 1046, 1080, 1082,  980, 1084, 1085,
     3   1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095,
     4   1096, 1097, 1098, 1099, 1100, 1101, 1102,  941,  984, 1104,
     5   1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1084,
     6    862, 1115,  981,  981,  907, 1079, 1118, 1119, 1120, 1121,
     7   1122,  862,  940, 1124, 1125, 1126, 1127, 1128, 1129, 1130,
     8   1131, 1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140,
     9   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150/
            data (jb1(i),i= 1201, 1300)/
     +   1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160,
     1   1161, 1073, 1046, 1163, 1164, 1165, 1166, 1167, 1168, 1169,
     2   1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179,
     3   1180, 1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189,
     4   1190, 1191, 1041, 1193, 1194, 1082, 1196, 1195, 1198, 1199,
     5   1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209,
     6   1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1073, 1198,
     7   1219, 1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228,
     8   1229, 1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238,
     9   1239, 1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248/
            data (jb1(i),i= 1301, 1400)/
     +   1249, 1250, 1251, 1252, 1117, 1253, 1254, 1255, 1256,   48,
     1   1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266,
     2   1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276,
     3   1198, 1117, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285,
     4   1286, 1287, 1192, 1289, 1288, 1291, 1292, 1293, 1047, 1084,
     5   1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304,
     6   1291, 1288, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313,
     7   1314, 1315, 1316, 1317, 1318, 1136, 1319, 1320, 1321, 1322,
     8   1323, 1324, 1326, 1327, 1325, 1192, 1329, 1330, 1331, 1332,
     9   1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342/
            data (jb1(i),i= 1401, 1500)/
     +   1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352,
     1   1353, 1354,   51, 1355, 1356, 1357, 1358, 1359, 1360, 1361,
     2   1362, 1363, 1364, 1365, 1366, 1367, 1368, 1079, 1326, 1370,
     3   1371, 1372, 1373, 1374, 1375, 1376,  999, 1377, 1378, 1379,
     4   1380, 1381, 1382, 1383, 1384, 1082, 1385, 1386, 1387, 1388,
     5   1389, 1390, 1391, 1392, 1393, 1394, 1395, 1195, 1396, 1397,
     6   1398, 1399, 1400, 1401, 1402, 1403, 1291,   57, 1404, 1405,
     7   1406, 1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415,
     8   1047, 1081, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424,
     9   1425, 1426, 1427, 1428, 1429, 1430, 1431, 1432, 1433, 1434/
            data (jb1(i),i= 1501, 1510)/
     +   1435, 1436, 1437, 1438, 1439, 1440, 1441, 1442,   58,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     59,   60,   61,   62,   63,   64,   64,   65,   66,   67,
     4     68,   68,   32,   33,   38,   38,   36,   35,   69,   70,
     5     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     6     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     7     91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
     8    101,  102,  103,  104,  104,   37,  105,  106,  107,  108,
     9    109,  110,  111,  112,  113,  114,  115,  116,  117,  118/
            data (jb2(i),i=  101,  200)/
     +    119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
     1    129,  130,  131,  132,  133,  134,  135,  136,  137,  138,
     2    139,  140,  141,  142,  143,  143,   40,  144,  145,  146,
     3    147,  148,  149,  150,  151,  152,  153,  153,   42,   44,
     4    154,  155,  156,  157,  158,  159,  160,  161,  162,  163,
     5    164,  165,  166,  167,  168,  169,  170,  171,  172,  173,
     6    173,   46,  174,  175,  176,  177,  178,  179,  180,  181,
     7    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     8    192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
     9    202,  203,  204,  205,  206,  207,  207,  208,  209,  210/
            data (jb2(i),i=  201,  300)/
     +    211,  212,  213,  214,  215,  216,  217,  217,  218,  218,
     1     52,   53,  219,  220,  221,  222,  223,  223,   54,   55,
     2     56,   57,  224,  225,  226,  227,  227,  228,  229,  230,
     3    231,  232,  233,  234,  234,  235,  236,  236,  237,  238,
     4    239,  240,  241,  242,  243,  244,  244,  245,  246,  247,
     5    247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
     6    257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
     7    267,  268,  269,  270,  271,  272,  273,   37,  274,  275,
     8    276,  277,  278,  279,  280,  280,  281,  282,  283,  284,
     9    285,  287,  287,  286,  288,  289,  290,  290,  292,  293/
            data (jb2(i),i=  301,  400)/
     +    294,  295,  296,  297,  297,  299,  300,  301,  302,  303,
     1    304,  304,  306,  307,  308,  309,  310,  311,  312,  313,
     2    314,  315,  316,  317,  318,  318,  319,  320,  321,  322,
     3    323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
     4    333,  334,  335,  336,  336,  337,  338,  338,  339,  340,
     5    341,  342,  343,  343,  344,  346,  347,  348,  349,  349,
     6    350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
     7    360,  361,  362,  363,  364,  364,  365,  366,  366,  367,
     8    368,  368,  369,  370,  371,  372,  373,  374,  375,  376,
     9    377,  378,  379,  380,  381,  382,  383,  384,  385,  386/
            data (jb2(i),i=  401,  500)/
     +    387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
     1    397,  398,  399,  400,  401,  402,  403,  404,  405,  405,
     2    406,  407,  408,  409,  410,   40,  411,  412,  413,  414,
     3    415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
     4    425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
     5    435,  435,  436,  437,  438,  439,  440,  441,  442,  443,
     6    444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
     7    454,   41,  455,  456,  457,  458,  459,  460,  461,  462,
     8    463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
     9    473,  474,  475,  476,  476,  477,  478,  479,  480,  481/
            data (jb2(i),i=  501,  600)/
     +    482,  483,  484,  485,  486,  487,  488,  489,  490,  491,
     1    492,  493,  494,  495,  496,  497,  498,  499,  500,  501,
     2    502,  503,  504,  505,  506,  507,  508,  509,  510,  511,
     3    512,  513,  514,  515,  516,  517,  518,  519,  520,  521,
     4    522,  523,  524,  525,  526,  527,  528,  528,  529,  530,
     5    531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
     6    541,  542,  543,  544,  545,  546,  547,  548,  549,  550,
     7    551,  552,  553,  554,  555,  556,  557,  558,  558,  559,
     8    560,  562,  562,  564,  564,   42,  565,  566,  566,  568,
     9    569,  570,  571,  571,  573,  574,  575,  576,  577,  578/
            data (jb2(i),i=  601,  700)/
     +    579,  580,  581,  582,  583,  584,   43,  585,  586,  587,
     1    588,  589,  590,  591,  592,  593,  594,  595,  596,  597,
     2    598,  599,  600,  600,  601,  602,  603,  604,  605,  606,
     3    607,  608,  609,  610,  611,  612,  613,  614,  615,  616,
     4    617,  618,  619,  620,  621,  622,  623,  624,  625,  626,
     5    627,  628,  629,  630,  631,  632,  633,  633,  634,  635,
     6    636,  637,  638,  639,  640,  641,  642,  643,  644,  645,
     7    645,  646,  647,  648,  649,  650,  651,  652,  653,  654,
     8    655,  655,  656,  657,  658,  659,  661,  661,  662,  663,
     9    664,  665,  666,  667,  668,  669,  670,  671,  671,  673/
            data (jb2(i),i=  701,  800)/
     +    674,  675,  676,  677,  678,  679,  680,  681,  682,  683,
     1    684,  685,  686,  687,  688,  689,  690,  691,  692,  693,
     2    694,  695,  696,  697,  698,  699,  700,  701,  702,  703,
     3    704,  705,  706,  707,  708,  709,  710,  711,  712,  713,
     4    714,  715,  716,  717,  718,  719,  720,  721,  722,  723,
     5    724,  725,  726,  727,  728,  729,  729,  731,  731,  732,
     6    732,  733,  733,  734,  735,  737,  737,  738,  738,  739,
     7    740,  741,  742,  743,  744,  744,  745,  746,  747,  748,
     8    749,  750,  751,  752,  753,  754,  755,  756,  757,  758,
     9    759,  760,  761,  762,  763,  764,  765,  766,  767,  768/
            data (jb2(i),i=  801,  900)/
     +    769,  770,  771,  772,  772,  773,  774,  775,  776,  777,
     1    778,  779,  780,  781,  782,  783,  784,  785,  786,  787,
     2    787,  788,  789,  790,  791,  792,  793,  794,  795,  796,
     3    797,  798,  799,  800,  801,  802,  803,  804,  805,  806,
     4    806,  807,  808,  809,  810,   44,  811,  812,  813,  814,
     5    815,  816,  817,  818,  819,  820,  821,  822,  823,  824,
     6    825,  826,  827,  828,  829,  829,  830,  831,  832,  833,
     7    834,  835,  836,  837,  838,  839,  840,  841,  842,  843,
     8    844,  845,  846,  847,  848,  849,  850,  851,  852,  853,
     9    854,  855,  855,  856,  857,  858,  859,  860,  861,  862/
            data (jb2(i),i=  901, 1000)/
     +    863,  864,  865,  866,  867,  868,  869,  870,  871,  872,
     1    873,  874,  875,  876,  877,  878,  879,  880,  881,  882,
     2    883,  884,  885,  886,  887,  888,  889,  890,  891,  892,
     3    893,  894,  895,  896,  897,  898,  899,  900,  901,  902,
     4    903,  904,  905,  906,  906,  908,  908,  907,  910,  911,
     5    912,  913,  914,  915,  915,  916,  917,  918,  919,  920,
     6    921,  922,  923,  924,  925,  926,  927,  928,  929,  930,
     7    931,  932,  933,  934,  935,  936,  937,  937,  938,  939,
     8    940,  942,  943,  944,  945,  946,  947,  948,  949,  950,
     9    951,  952,  953,  954,  955,  956,  957,  957,  958,  959/
            data (jb2(i),i= 1001, 1100)/
     +    960,  961,  962,  963,  964,  965,  966,  967,  968,  969,
     1    970,  971,  972,  973,  974,  975,  976,  977,  978,  979,
     2    980,  982,  983,  983,  985,  986,  987,  988,  989,  990,
     3    991,  992,  993,  994,  994,  995,  996,  997,  998,  999,
     4   1000, 1001, 1002, 1003, 1004, 1005, 1006, 1006, 1008, 1009,
     5   1010, 1010, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019,
     6   1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029,
     7   1030, 1031, 1032, 1033, 1033, 1034, 1035, 1036, 1037, 1038,
     8   1039, 1040, 1040, 1041, 1041, 1042, 1043, 1044, 1045, 1045,
     9   1046, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056/
            data (jb2(i),i= 1101, 1200)/
     +   1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066,
     1   1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075,
     2   1076, 1077, 1078, 1079, 1080, 1081, 1083, 1083, 1085, 1086,
     3   1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096,
     4   1097, 1098, 1099, 1100, 1101, 1102, 1103, 1103, 1104, 1105,
     5   1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1114,
     6   1115, 1116, 1116, 1081, 1117, 1118, 1119, 1120, 1121, 1122,
     7   1123, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     8   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141,
     9   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151/
            data (jb2(i),i= 1201, 1300)/
     +   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     1   1162, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170,
     2   1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180,
     3   1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190,
     4   1191, 1192, 1193, 1194, 1195, 1196, 1197, 1197, 1199, 1200,
     5   1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210,
     6   1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1218, 1219,
     7   1220, 1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229,
     8   1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239,
     9   1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249/
            data (jb2(i),i= 1301, 1400)/
     +   1250, 1251, 1252,   46, 1253, 1254, 1255, 1256,   47, 1257,
     1   1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266, 1267,
     2   1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1277,
     3   1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286,
     4   1287, 1288, 1289, 1290, 1290, 1292, 1293, 1294, 1294, 1295,
     5   1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305,
     6   1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1314,
     7   1315, 1316, 1317, 1318,   49, 1319, 1320, 1321, 1322, 1323,
     8   1324, 1325, 1327, 1328, 1328, 1329, 1330, 1331, 1332, 1333,
     9   1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343/
            data (jb2(i),i= 1401, 1500)/
     +   1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353,
     1   1354,   50, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362,
     2   1363, 1364, 1365, 1366, 1367, 1368, 1369, 1369, 1370, 1371,
     3   1372, 1373, 1374, 1375, 1376,   52, 1377, 1378, 1379, 1380,
     4   1381, 1382, 1383, 1384,   53, 1385, 1386, 1387, 1388, 1389,
     5   1390, 1391, 1392, 1393, 1394, 1395,   54, 1396, 1397, 1398,
     6   1399, 1400, 1401, 1402, 1403,   55,   56, 1404, 1405, 1406,
     7   1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415, 1416,
     8   1416, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425,
     9   1426, 1427, 1428, 1429, 1430, 1431, 1432, 1433, 1434, 1435/
            data (jb2(i),i= 1501, 1510)/
     +   1436, 1437, 1438, 1439, 1440, 1441, 1442, 1443, 1443,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine ri(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(570) :: jx,jy,jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'rhode island  '/
            data jrot,ipart/0,2/
            data kv/   1, 340, 562,   0,   0/
            data kb/   1, 343, 565,   0,   0/
            data iib/ 283, 222,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  38472,36864,36528,36528,36360,36120,35976,36144,35856,35616,
     1  35064,35136,35832,35856,35568,35304,35256,35016,34824,34656,
     2  34344,34272,34680,34872,35064,35328,35304,35112,35088,35328,
     3  35304,36984,37440,37560,37680,37896,38376,38640,38928,39072,
     4  39192,39312,39408,39432,39504,39720,39600,39192,38616,38376,
     5  38448,38736,39000,38808,38928,39168,39552,39672,39720,39864,
     6  40080,40296,40368,40296,40296,39744,39840,39816,39384,39264,
     7  39336,39504,39768,40200,40560,40752,41064,41136,41352,41640,
     8  41688,41808,41784,41952,42504,42552,42264,41808,41544,41544,
     9  41736,41976,42264,42384,42792,42936,42912,41232,16248,15864/
            data (jx(i),i=  101,  200)/
     +  15216,32688,34920,35112,37176,37248,37152,37176,37536,37296,
     1  37440,37128,37128,37320,37344,37416,37800,38088,35280,35472,
     2  35496,35592,35856,35904,35664,35736,35664,35856,36072,36360,
     3  37152,37176,36384,36456,36480,36120,36072,36144,36024,35784,
     4  35424,35256,35376,35184,35040,34728,34608,34512,34560,33168,
     5  32592,32688,32880,33072,33336,33648,33768,34464,34416,34464,
     6  16608,16632,16608,16512,15648,14592,14544,14472,14520,14736,
     7  14928,14880,14760,14880,15168,15120,15024,14256,14256,14160,
     8  14064,13824,12768,12600,12552,12768,13176,13584,13776,13848,
     9  14016,14640,15480,17208,17832,18192,18360,18888,19584,20424/
            data (jx(i),i=  201,  300)/
     +  20856,21456,23544,24984,25584,26160,26376,27120,27576,28272,
     1  28848,29496,29784,29808,29736,29784,29952,29952,30312,30312,
     2  30744,30768,30984,30936,31008,30984,30816,30240,30192,30216,
     3  31032,31368,31680,31752,31632,31824,32904,33000,32856,32832,
     4  32904,33000,33480,33816,33912,34104,33864,33912,34032,34368,
     5  34416,34224,34176,34464,34368,34008,34104,33888,33816,33888,
     6  33768,33384,33264,32976,32832,32976,33336,33696,34752,34992,
     7  34872,34416,34296,34536,34872,34680,34248,34392,34752,34728,
     8  34512,34536,16560,38424,36936,31992,32232,32184,32280,32592,
     9  32472,32496,32640,32736,32712,32784,32712,32808,33024,33096/
            data (jx(i),i=  301,  400)/
     +  33192,33384,33648,33768,33672,33744,33984,34176,34488,34536,
     1  34632,34824,34872,35184,19128,23064,23496,30984,31056,31056,
     2  30864,30936,31104,31248,31296,31200,31680,31800,32040,32328,
     3  32424,32544,32688,32640,32712,33096,33384,33552,33912,29088,
     4  29232,28368,28320,28488,28392,27456,27264,27456,27432,27168,
     5  27600,27720,27360,26928,26712,26400,26016,25920,25944,25896,
     6  26160,26544,27216,28632,35448,35736,35856,35880,36120,36312,
     7  36600,37152,37320,36960,36984,37320,37296,37008,36936,37032,
     8  36936,37176,37032,36792,36504,36240,35928,35832,35568,35904,
     9  36216,36096,36264,35952,35400,35280,35520,35496,35280,38928/
            data (jx(i),i=  401,  500)/
     +  38952,39216,38784,38568,38400,38280,38208,37848,37152,37104,
     1  37296,37368,37560,37992,38280,38520,39072,39576,39792,39960,
     2  40248,40224,40272,40848,41040,41376,41496,41496,41784,42288,
     3  42552,42624,42528,42720,42984,42624,42840,43152,43272,43368,
     4  43032,42984,42888,42888,42960,42456,42624,42624,43368,43488,
     5  43560,43536,43392,43368,43224,42840,41952,41640,41424,41136,
     6  40944,40872,40536,40176,39768,39528,39408,39360,39408,39312,
     7  38784,38712,38928,38880,38952,44376,44280,44088,44040,43848,
     8  43896,43848,43944,44328,44328,44160,43920,44040,44088,44208,
     9  44136,43800,43632,43800,43824,44304,44424,44256,44400,44352/
            data (jx(i),i=  501,  570)/
     +  44424,44736,44616,44424,44496,45120,45288,45216,44952,45168,
     1  45576,45768,46080,46296,46272,46584,46728,46872,47184,47424,
     2  47640,47688,48144,48624,47784,47352,47232,47304,47592,47592,
     3  47472,47616,47544,45456,45480,44544,38232,38568,38952,39480,
     4  39864,39744,39600,39264,38304,38160,38136,38184,37992,37872,
     5  37584,37464,37704,37248,37200,37656,38136,38304,38400,38304,
     6  38112,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  46824,45120,45048,45504,45864,45936,46152,46728,47664,48168,
     1  48720,49128,50760,51600,51912,51408,50688,50136,49320,49272,
     2  49416,49296,48336,48168,48096,47760,47592,47376,47064,45912,
     3  45720,44832,44280,43704,43536,43488,43512,43416,43224,42960,
     4  42480,42432,42576,42912,43152,43416,43944,44352,44760,45216,
     5  46032,46056,45768,45384,45048,44784,44640,44688,45144,45360,
     6  45528,45024,44712,44472,43584,42168,41424,41136,40584,40320,
     7  39168,39024,39024,40200,40152,39792,39504,39000,38736,38832,
     8  39264,39456,39720,39936,40344,40776,41424,42048,42528,42960,
     9  43032,42456,42048,42000,42192,42912,43152,45384,42648,48408/
            data (jy(i),i=  101,  200)/
     +  60624,61944,62064,53976,54504,54216,53808,53496,51936,50880,
     1  50376,49800,49368,48864,48264,48096,47664,47016,45624,45336,
     2  45096,44880,44832,44736,44496,43968,43608,43344,43176,43080,
     3  43104,42960,42648,42312,41448,40896,40608,40296,39816,39792,
     4  40080,40296,40800,40968,40824,40944,41304,41232,40920,40944,
     5  41112,39768,39624,39672,39864,39960,39768,39504,39120,38904,
     6  34584,32832,23328,23136,23352,22656,22536,22272,21648,21384,
     7  20928,20232,19632,19176,18576,18192,18048,17448,17280,16896,
     8  16872,16512,16416,16296,15984,15840,16056,16176,16200,15840,
     9  15912,16440,16800,17232,17448,17424,17520,17472,17640,17712/
            data (jy(i),i=  201,  300)/
     +  17856,18408,19248,19968,20112,20136,20256,20472,20688,20832,
     1  20784,21024,21048,21384,21624,21816,21984,22152,23520,23832,
     2  23904,23232,22920,22608,22368,22176,21960,21432,21240,21048,
     3  20688,20256,20184,20400,20880,21504,23256,23688,24288,24744,
     4  24912,25080,25368,25464,25968,26256,26832,27192,27312,27336,
     5  27912,28296,29352,30024,30984,32160,32304,32280,32592,32760,
     6  32904,33168,33576,33696,34056,34344,34200,34416,34776,35088,
     7  35568,35592,35832,36120,36360,36744,36912,37080,37104,37464,
     8  37968,38400,37248,46680,45264,43728,43824,44064,44232,44256,
     9  44784,44904,44904,45072,45192,45264,45408,45408,45624,45504/
            data (jy(i),i=  301,  400)/
     +  45600,45600,45864,45816,45696,45672,45744,46008,46080,46008,
     1  46104,46032,45864,45888,34800,34920,35088,35472,35496,35760,
     2  36360,36384,36792,36888,37080,37176,37536,37512,37800,37608,
     3  37296,37272,37416,37728,37728,38424,38688,38616,38904, 7224,
     4   7416, 8832, 9360,10272,11304,11832,11784,10704,10344, 9912,
     5   9360, 9000, 8760, 9048, 9360, 8880, 8592, 7728, 6912, 6672,
     6   6312, 6432, 6744, 6960,25968,26232,26472,26928,26952,27816,
     7  27768,27840,28152,28824,29136,29688,29832,30024,30168,30312,
     8  31800,32448,33456,33840,33888,33744,32928,31848,30744,29832,
     9  29448,28920,28680,28608,28728,28464,27336,26928,26232,29400/
            data (jy(i),i=  401,  500)/
     +  28776,27984,27744,27528,27504,27552,28008,27504,26904,26616,
     1  26424,26112,25944,26280,26136,26280,26712,26376,26304,27000,
     2  27312,27912,28416,28560,28296,28248,28464,28656,28752,28584,
     3  28320,28200,27744,27744,28464,29016,29904,30336,30840,31560,
     4  31824,32736,33192,33864,34344,35136,36240,36936,37176,37296,
     5  37632,38136,38472,39120,39168,38640,38232,37920,37416,37320,
     6  37080,35976,35328,33960,33312,32784,32208,31416,30984,30696,
     7  30840,30480,30312,30024,29736,40872,40368,40008,39312,38304,
     8  37992,37392,36408,35856,35640,35400,34824,34704,34608,33576,
     9  33360,33480,33408,33096,32496,32256,32064,31416,31080,30816/
            data (jy(i),i=  501,  570)/
     +  30648,30312,30048,29784,29472,28704,28080,27552,26712,26616,
     1  26928,27024,27072,27216,27480,27888,27888,28080,28176,28368,
     2  28584,29184,29424,29496,35736,36288,36744,37416,37992,38280,
     3  38616,39384,39840,40296,40464,40656,34584,34440,34680,35400,
     4  36672,37128,37320,37584,38112,38376,38904,39168,39648,39768,
     5  39744,39456,38712,38256,37848,37416,37416,37296,36864,36264,
     6  35760,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,    2,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   97,    1,   99,  100,  101/
            data (jb1(i),i=  101,  200)/
     +    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     1    112,  113,  114,  115,  116,  117,    1,   31,  119,  120,
     2    121,  122,  123,  124,  125,  126,  127,  128,  129,  130,
     3    131,  132,  133,  134,  135,  136,  137,  138,  139,  140,
     4    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     5    151,  152,  153,  154,  155,  156,  157,  158,  159,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb1(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     4    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     5    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    160,  161,   99,    1,  284,  285,   99,  286,  287,  288,
     9    289,  290,  291,  292,  293,  294,  295,  296,  297,  298/
            data (jb1(i),i=  301,  400)/
     +    299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
     1    309,  310,  311,  312,  313,   31,  161,  315,  316,  317,
     2    318,  319,  320,  321,  322,  323,  324,  325,  326,  327,
     3    328,  329,  330,  331,  332,  333,  334,  335,  336,  337,
     4    338,  160,    1,    2,    3,    4,    5,    6,    7,    8,
     5      9,   10,   11,   12,   13,   14,   15,   16,   17,   18,
     6     19,   20,   21,   22,   23,   24,    1,   26,   27,   28,
     7     29,   30,   31,   32,   33,   34,   35,   36,   37,   38,
     8     39,   40,   41,   42,   43,   44,   45,   46,   47,   48,
     9     49,   50,   51,   52,   53,   54,   55,   56,   57,   58/
            data (jb1(i),i=  401,  500)/
     +     59,   26,   61,   62,   63,   64,   65,   66,   67,   68,
     1     69,   70,   71,   72,   73,   74,   75,   76,   77,   78,
     2     79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
     3     89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
     4     99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
     5    109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
     6    119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
     7    129,  130,  131,  132,  133,  134,  135,   61,  137,  138,
     8    139,  140,  141,  142,  143,  144,  145,  146,  147,  148,
     9    149,  150,  151,  152,  153,  154,  155,  156,  157,  158/
            data (jb1(i),i=  501,  570)/
     +    159,  160,  161,  162,  163,  164,  165,  166,  167,  168,
     1    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     2    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     3    189,  190,  191,  192,  193,  194,  195,  196,  137,  198,
     4    199,  200,  201,  202,  203,  204,  205,  206,  207,  208,
     5    209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
     6    219,  220,  221,  198,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      3,    4,    5,    6,    7,    8,    9,   10,   11,   12,
     1     13,   14,   15,   16,   17,   18,   19,   20,   21,   22,
     2     23,   24,   25,   26,   27,   28,   29,   30,   31,   32,
     3     33,   34,   35,   36,   37,   38,   39,   40,   41,   42,
     4     43,   44,   45,   46,   47,   48,   49,   50,   51,   52,
     5     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     6     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     7     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     8     83,   84,   85,   86,   87,   88,   89,   90,   91,   92,
     9     93,   94,   95,   96,   97,   98,   98,  100,  101,  102/
            data (jb2(i),i=  101,  200)/
     +    103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
     1    113,  114,  115,  116,  117,  118,  118,  119,  120,  121,
     2    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     3    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     4    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  162,
     6    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     7    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     8    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     9    193,  194,  195,  196,  197,  198,  199,  200,  201,  202/
            data (jb2(i),i=  201,  300)/
     +    203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
     1    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     2    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     3    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     4    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     5    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     6    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     7    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     8    282,  283,  283,  284,  285,    2,  286,  287,  288,  289,
     9    290,  291,  292,  293,  294,  295,  296,  297,  298,  299/
            data (jb2(i),i=  301,  400)/
     +    300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
     1    310,  311,  312,  313,  314,  314,  315,  316,  317,  318,
     2    319,  320,  321,  322,  323,  324,  325,  326,  327,  328,
     3    329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
     4    339,  339,    2,    3,    4,    5,    6,    7,    8,    9,
     5     10,   11,   12,   13,   14,   15,   16,   17,   18,   19,
     6     20,   21,   22,   23,   24,   25,   25,   27,   28,   29,
     7     30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
     8     40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     9     50,   51,   52,   53,   54,   55,   56,   57,   58,   59/
            data (jb2(i),i=  401,  500)/
     +     60,   60,   62,   63,   64,   65,   66,   67,   68,   69,
     1     70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
     2     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     3     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     4    100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
     5    110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
     6    120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
     7    130,  131,  132,  133,  134,  135,  136,  136,  138,  139,
     8    140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
     9    150,  151,  152,  153,  154,  155,  156,  157,  158,  159/
            data (jb2(i),i=  501,  570)/
     +    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     1    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     2    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     3    190,  191,  192,  193,  194,  195,  196,  197,  197,  199,
     4    200,  201,  202,  203,  204,  205,  206,  207,  208,  209,
     5    210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
     6    220,  221,  222,  222,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine sc(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(2180) :: jx,jy
            integer(kind=iknd), save, dimension(2230) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'south carolina'/
            data jrot,ipart/0,2/
            data kv/   1,2081,2176,   0,   0/
            data kb/   1,2128,2223,   0,   0/
            data iib/ 867,  95,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  26280,10776,21144,12120,30984,17688,34440, 9672,40920,45768,
     1  49752,12168,13632,18504,50592,19536,22152,42456,47088,23616,
     2  42648,42648,42264,42168,42000,41568,41592,41400,41376,41544,
     3  41664,41808,41976,41832,41832,42000,42768,43248,43344,43272,
     4  43368,43536,43464,43632,44016,43920,44088,44352,44832,44880,
     5  44856,44544,44376,44328,44472,44424,44280,44280,44400,44376,
     6  44472,44688,44712,45192,45144,45456,45480,45696,45768,45816,
     7  45792,45648,45600,45984,46560,46896,46920,46824,46584,46488,
     8  46344,46296,46320,46200,46176,46488,46632,46776,46896,46944,
     9  46896,46584,46704,46824,46800,47088,47256,47424,47616,47832/
            data (jx(i),i=  101,  200)/
     +  47808,47640,47280,40848,25776,34680,36072,27072,31584,31728,
     1  31224,12216,12264,12360,12504,12840,12888,12864,13008,13032,
     2  13176,13344,13464,13656,14088,14280,14520,14640,14856,15000,
     3  15264,15264,15408,15552,15624,15936,16032,16008,16128,16296,
     4  16584,16944,11952,12000,11976,29544,29472,29616,29640,29472,
     5  29400,29568,30696, 9528, 9168, 9024, 8856, 8736, 8736, 8568,
     6   8328, 8208, 8016, 7992, 7872, 7968, 7920, 7632, 7200, 7056,
     7   6624, 6552, 6168, 6168, 6048, 6096, 6048, 6408, 6384, 6624,
     8   6576, 6696, 6768, 6936, 6960, 7008, 7128, 7176, 7128, 7248,
     9   7224, 7416, 7512, 7608, 7632, 7944, 7992, 8088, 8112, 8256/
            data (jx(i),i=  201,  300)/
     +   8400, 8472, 8544, 8424, 8472, 8544, 8496, 8712, 8640,32184,
     1  32064,43464, 9936,10080,10200,10368,10584,10776,10944,11256,
     2  11592,11784,12072,12168,13608,13296,13128,13128,12984,12816,
     3  12408,13944,14064,14448,14688,15288,15672,15984,16152,16560,
     4  16656,16776,17064,17232,17280,17616,17640,17760,18048,18264,
     5  19176,54888,54720,54432,54576,54840,54936,55128,53928,53256,
     6  52728,51432,19728,19800,20376,20544,20544,20376,20424,20232,
     7  20328,20424,20376,20208,20208,20304,20280,20592,20472,20592,
     8  20568,20688,20784,20880,20880,21024,21096,21216,21216,21096,
     9  21072,21240,21408,21360,21240,21288,21168,21192,21408,21600/
            data (jx(i),i=  301,  400)/
     +  21672,21888,21912,21984,47784,47928,47952,47904,48000,48144,
     1  48168,47976,47736,47520,47496,47664,47904,48048,48240,48288,
     2  48720,48840,48792,48648,48576,48672,48552,48576,48408,47952,
     3  47664,47640,47736,47688,47712,47784,47952,47952,48000,48096,
     4  48432,48432,48744,48768,48696,48504,48456,48216,48000,47952,
     5  47880,47832,47808,47904,47832,47856,48048,48192,48576,48624,
     6  48768,48792,48840,48816,48864,48912,48888,48936,48984,49056,
     7  49008,49128,49104,49176,49800,50304,50328,22008,22056,22512,
     8  23064,23280,23688,23640,23760,23760,23928,24096,24120,24168,
     9  24192,24144,24240,24360,24672,24648,24696,24792,24888,24792/
            data (jx(i),i=  401,  500)/
     +  24888,24816,24768,24696,24696,24792,24792,24960,25008,25056,
     1  25104,25176,25008,25080,25152,25296,25224,25368,25416,25512,
     2  25608,25608,25536,25632,25560,25608,25536,25656,25536,25752,
     3  25632,41040,41040,41160,41088,41160,41160,40872,40800,40896,
     4  41136,41184,41256,41424,41448,41904,42024,42024,42096,36120,
     5  36168,36384,36384,36240,36048,36024,36096,36240,36432,36360,
     6  36432,36216,36480,36624,36840,36816,36912,37584,38040,38400,
     7  38352,38256,38232,38088,37920,37896,37800,37632,37560,37368,
     8  37296,37080,37128,37464,37608,37824,37872,37848,37776,37752,
     9  37800,38088,38088,38184,38232,38328,38376,38520,38520,38160/
            data (jx(i),i=  501,  600)/
     +  38232,38184,37944,37944,37824,37776,37680,37752,38040,38136,
     1  38208,38280,38352,38304,38568,38688,38928,39336,39960,40440,
     2  40512,40392,39912,40152,40368,40368,40416,40464,40320,40296,
     3  40512,40848,40704,40776,41616,41520,41640,41784,41736,41640,
     4  41544,41544,41496,41136,40920,40680,40656,40728,40632,40248,
     5  40128,40296,40488,40680,40800,40824,41016,41136,41184,41184,
     6  41064,41040,40872,40728,40752,25656,25680,25560,25752,25848,
     7  25752,25872,25656,25656,25992,26136,26208,26304,26280,26352,
     8  26688,26904,26928,26952,27000,34776,34872,35112,35352,35832,
     9  36024,36096,36120,36216,36168,36048,36072,36144,36384,36408/
            data (jx(i),i=  601,  700)/
     +  36528,36672,36432,36144,36072,36048,36168,36288,36264,36312,
     1  36264,36144,36072,36000,35952,35952,36168,36168,36264,36120,
     2  31656,31704,31824,31824,31896,32136,32184,32232,32184,31992,
     3  32040,32040,32448,32664,32832,32808,33240,33432,33504,33504,
     4  33264,33360,33360,33264,33432,33384,33384,33264,33360,33504,
     5  33552,33408,33456,33408,33480,33408,33600,33720,33816,33720,
     6  33696,33720,33792,33744,33792,33720,33696,33840,34008,34248,
     7  34512,34608,34656,34392,34392,34560,35208,35736,35736,35592,
     8  35376,35376,35712,35904,35952,35904,35832,35592,35424,35352,
     9  35232,35232,34920,34776,34680,34608,34632,34872,35136,35112/
            data (jx(i),i=  701,  800)/
     +  35184,35424,35496,35544,35640,35688,35496,35376,35040,34872,
     1  34608,34128,34176,34560,34704,34608,34224,34104,34008,33528,
     2  33312,33408,33384,32976,32976,33096,33648,33936,34344,34488,
     3  34536,34416,34272,34344,34344,34488,34680,34920,34992,34776,
     4  31680,31800,31680,31368,31392,27168,27384,27552,27552,28032,
     5  28008,27888,27912,27840,27864,28128,28128,28368,28344,28488,
     6  28656,28584,28728,28680,28464,28464,28368,28488,28416,28800,
     7  28728,28848,28704,28632,28776,28704,28752,28992,29160,29376,
     8  29736,29976,30168,30432,30744,30840,30792,30864,30984,31200,
     9  31248,31296,31368,31608,31752,31728,31656,31392,31320,31512/
            data (jx(i),i=  801,  900)/
     +  31776,31944,32112,32160,31560,31368,31248,31224,31344,31248,
     1  31368,31488,31512,31392,31416,31704,31896,32184,32184,32280,
     2  32304,32352,32256,32040,32184,32160,31968,31800,31896,32784,
     3  33480,33408,32904,32808,32664,32568,32448,32496,32256,32160,
     4  32112,32088,31872,31776,31536,31296,31152,31152,31224,31248,
     5  31368,31584,31800,31944,32016,32088,31920,31728,31896,32088,
     6  32232,32112,31992,31944,31800,31920,31848,25920,25848,25368,
     7  25056,25104,25080,25152,24984,25008,25176,25152,25224,25128,
     8  25200,25224,25296,25392,25344,10968,10896,10992,11160,11040,
     9  11136,11112,10992,11088,11064,10920,10704,10680,10800,10944/
            data (jx(i),i=  901, 1000)/
     +  10800,10704,10728,10632,10680,10656,10536,10560,10368,10296,
     1  10440,10608,10560,21816,21816,21960,22392,22512,22776,22944,
     2  23040,23136,23280,23424,23520,23616,23784,24048,24432,24576,
     3  24624,24768,24912,25080,25104,12192,12312,12696,13176,13344,
     4  13704,14016,14064,14064,13824,13776,13896,13872,13800,14256,
     5  14376,14352,14448,14328,14304,14400,14496,14616,14736,14808,
     6  14928,14904,15000,14904,25296,25128,31032,31032,31248,31344,
     7  31224,31200,31224,31320,31368,31272,31128,31152,31032,31008,
     8  30960,31032,30936,17520,17640,17856,18072,18216,18144,18360,
     9  25680,25632,25728,25752,25488,25368,25368,25296,25128,25032/
            data (jx(i),i= 1001, 1100)/
     +  25224,25368,25320,25200,25104,25032,11784,35928,35976,35760,
     1  35784,35592,35568,35496,35208,35184,34920,34920,34632,22032,
     2  21600,21288,18480,18672,18720,18816,18960,19032,19104,19152,
     3  19104,19200,19800,20328,20616,20736,20880,20952,21072,21192,
     4  23424,23088,22680,21720,21408,31248,31248,31224,31416,31248,
     5  31032,31128,31080,31224,41928,42048,42144,42168,42360,42432,
     6  42312,42312,42192,42264,42120,42024,41904,41784,41664,41472,
     7  41400,41232,40896,40824,25704,25632,25680,17376,17376,16584,
     8  16440,15888,15816,15600,15528,15432,15168,15216,15072,15144,
     9  15120,15216,15096,15216,15144,34560,34848,34824,34632,34584/
            data (jx(i),i= 1101, 1200)/
     +  34488,34272,34248,34128,33768,33792,33648,33480,33288,33168,
     1  33072,32952,32928,32640,32592,32640,32592,32664,32592,31224,
     2  31056,31056,31200,23664,23736,23856,24336,24360,24504,25200,
     3  25440,25512,16656,16872,16968,17088,17280,25680,25752,25776,
     4  25680,25848,26208,26256,26352,26520,26448,26496,26616,26736,
     5  20304,20520,20664,20856,21120,21312,21288,21480,21720,22008,
     6  22032,22344,22560,22728,22824,37272,39768,39936,40320,40416,
     7  40584,41016,41280,41592,41616,41808,36312,36288,36360,36408,
     8  36552,36576,36840,36864,36816,37152,37272,41880,42072,42144,
     9  42192,42264,42360,42408,42552,42528,42624,42720,42696,42984/
            data (jx(i),i= 1201, 1300)/
     +  43032,42936,42936,42720,42768,42960,43080,43056,43248,43440,
     1  43368,43512,43536,43440,43368,43536,43680,43680,43992,31776,
     2  32352,32208,32208,32088,31704,49152,49344,49464,49584,48648,
     3  48264,47880,47448,47280,46704,46224,45528,45240,45096,44760,
     4  44304,44520,44592,44688,17616,17976,18048,18216,18384,18504,
     5  18840,19272,19440,19584,19872,26520,26448,16344,16464,16584,
     6  16608,17040,17208,17304,17280,17184,17016,16392,30384,29280,
     7  29016,28128,28272,28152,28152,27888,27744,27672,27384,27072,
     8  35304,35520,35592,35784,35784,36312,36600,36600,36456,36504,
     9  36840,36768,20400,20568,20616,20736,20688,20832,21072,33936/
            data (jx(i),i= 1301, 1400)/
     +  33888,34056,34296,31320,31560,32880,33024,33480,33720,43440,
     1  43080,42984,42720,42240,39504,37248,37392,37656,37752,38112,
     2  38256,38328,38448,38712,39096,39096,38640,38736,21000,21072,
     3  21240,21384,21768,22032,22152,22368,22536,22656,22896,23112,
     4  23472,23616,23856,23952,24120,24360,24432,24648,24816,25224,
     5  25440,25632,25848,25992,26016,25848,25512,25848,26160,26376,
     6  15864,15168,14784,14616,14304,40248,39936,19560,20592,20616,
     7  20784,20856,21072,20424,20808,21048,21168,21432,21552,22032,
     8  23280,19248,16584,17208,17544,17904,18000,18168,18936,19272,
     9  39960,39528,38400,38328,37752,37656,37488,37224,37128,36984/
            data (jx(i),i= 1401, 1500)/
     +  36360,36192,36072,35304,40512,41352,41232,40944,40704,41544,
     1  41280,40848,26616,26808,26928,26760,27144,27648,28128,28464,
     2  28680,28992,29352,29472,29520,29808,29784,29688,29904,29760,
     3  29856,24720,24072,44904,44832,44712,44616,44640,44904,45024,
     4  45168,45120,45216,45192,45096,45024,45024,45240,45216,45384,
     5  45576,45576,45480,45576,45936,45912,46272,46440,46392,46800,
     6  46944,47064,47280,47352,47280,47304,47232,30024,29976,30120,
     7  30120,30456,30648,30744,30816,30888,30840,31032,31272,31728,
     8  31800,31800,31896,32184,32208,32352,32400,32472,32520,32616,
     9  32568,32592,32712,32688,32784,32808,32904,32952,33024,33024/
            data (jx(i),i= 1501, 1600)/
     +  33216,33528,33576,33528,33696,33888,47304,46896,46608,45936,
     1  45720,45456,44040,43992,43584,43464,43104,42912,42336,41952,
     2  41736,41640,33864,33768,33720,33792,33888,33840,34032,33984,
     3  34080,34032,34080,33936,33816,33744,33672,33696,33936,33888,
     4  33816,33936,33816,33792,33840,33936,33864,33864,33792,33912,
     5  33936,34080,34104,34104,34032,33936,48624,48576,48528,48504,
     6  48384,48336,48144,48048,47904,47928,48000,47880,47880,47832,
     7  47760,47496,47328,47304,47088,47088,47136,47208,47304,47424,
     8  47592,47832,47976,48024,47952,48216,48288,48336,48360,48528,
     9  48672,48696,48744,48768,48912,49080,29544,29784,30216,30768/
            data (jx(i),i= 1601, 1700)/
     +  30408,29856,29640,29616,29400,29376,29496,29592,47568,47544,
     1  47616,47664,47784,47760,47856,47832,48096,48048,48168,48216,
     2  48576,48576,28056,29112,27192,26928,26496,26208,26112,25752,
     3  25608,25560,25248,24792,24504,24360,39840,39024,38832,38256,
     4  37632,37488,36192,36240,35808,35832,35904,35856,35664,35616,
     5  35352,35160,34800,33816,33960,34152,34176,34320,34488,34464,
     6  34656,18696,18552,18384,18288,18168,18168,18000,17808,18000,
     7  17928,18264,18264,18528,18120,18072,18192,18120,49584,49584,
     8  49536,49488,49344,49320,49224,49320,49224,49176,49128,49032,
     9  48960,48744,48744,34848,34800,34920,35016,35184,41136,40848/
            data (jx(i),i= 1701, 1800)/
     +  40320,40536,40392,39240,26136,35088,35112,34728,34608,34608,
     1  34080,34008,34248,33864,34008,33960,33768,33720,33504,33312,
     2  33120,33144,31968,31224,30816,30600,30624,30576,30336,43680,
     3  43344,43008,42960,42816,42552,42456,42336,42216,42000,41952,
     4  41760,41760,41568,41664,41664,41592,41400,41136,40680,40440,
     5  40344,40344,40272,40248,40176,40128,40080,40008,39960,39864,
     6  39792,39504,39480,39336,39336,38016,38208,38448,38640,38784,
     7  38712,38760,38880,38832,38952,38784,38760,38976,39000,26856,
     8  27456,27720,37896,37224,36960,36528,36264,35832,35808,35568,
     9  35472,35688,35664,35280,47088,46992,46752,46536,46368,46272/
            data (jx(i),i= 1801, 1900)/
     +  46272,46056,46128,45624,45504,45048,44544,44496,44184,44112,
     1  43896,43680,43632,43728,38016,37872,37848,37728,37728,37080,
     2  36840,36696,36624,36600,46080,45984,46008,45960,45792,45840,
     3  45696,45744,45720,45600,45240,45048,45000,44880,44904,44760,
     4  44400,44160,43776,42744,42816,43176,43296,43440,43488,43872,
     5  44064,44376,44400,44472,44544,44928,45192,45312,45696,45816,
     6  46032,36264,35904,35304,35208,35232,35136,32088,31728,31584,
     7  31152,30576,29688,29568,29160,28848,28320,28056,27864,46488,
     8  46272,46152,27984,27456,27048,26208,24384,27768,27696,27744,
     9  27672,38736,37032,37224,37248,36792,36720,36696,31128,31152/
            data (jx(i),i= 1901, 2000)/
     +  31248,31104,31032,30984,30648,29184,28248,28992,39360,39600,
     1  39720,39960,39936,40248,36216,36264,36384,36216,36192,36240,
     2  36024,36144,36144,36336,36360,36216,35808,35568,35040,34848,
     3  34296,33888,33360,33144,32880,32568,38544,38856,38976,39216,
     4  38976,39552,39360,39336,39024,38472,38352,38568,38712,38736,
     5  38856,37248,27552,27528,27288,27120,27264,26592,26472,26160,
     6  25896,29376,29424,29544,29832,30144,30336,30408,30576,30936,
     7  31056,31104,31296,31560,31560,31800,31680,31344,34608,34584,
     8  34512,34536,34320,34416,34368,34128,34056,33936,33840,33672,
     9  33528,33600,33360,33360,33552,33504,33336,33288,33288,33432/
            data (jx(i),i= 2001, 2100)/
     +  33432,33264,33216,33072,33048,32952,32904,32808,32712,32640,
     1  32568,32520,31992,31968,31848,36264,36120,35880,35880,35712,
     2  35688,35760,35952,36072,36024,31008,30384,30408,30528,30552,
     3  30384,29832,28344,27672,31416,31560,31560,31704,31752,31704,
     4  31560,31584,31728,31776,31632,31632,31464,31248,31128,31128,
     5  30792,30672,30648,30048,30024,30096,29808,29856,30024,30096,
     6  30144,30360,30528,30504,30384,30312,30336,30432,30384,30552,
     7  30600,30720,30792,30936,30960,30744,31080,30912,30912,31032,
     8  32544,32376,32328,32256,32472,32712,32760,31992,32112,31992,
     9  35160,34944,34776,34800,35160,35400,35448,38568,38640,38520/
            data (jx(i),i= 2101, 2180)/
     +  38496,32136,32040,31992,32088,41256,41184,41136,41208,41256,
     1  41280,41304,41376,36192,36192,36288,36240,48816,48912,48792,
     2  49008,48960,48816,48816,48624,47808,47688,47712,47976,47904,
     3  48120,48144,48096,48336,48264,48264,48408,48360,48216,48408,
     4  48504,48576,48480,47976,47928,48000,48120,48120,55128,54936,
     5  55032,46896,47040,47160,47232,47184,47136,47040,47088,46968,
     6  46992,45096,45048,45120,44808,44736,44760,44880,44952,45360,
     7  45360,45408,45456,45504,45552,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  53016,51864,53304,51960,51864,53472,48720,44784,48672,46440,
     1  42576,41400,38976,33792,33576,32952,28800,25560,28392,27528,
     2  25584,25512,25416,25440,24888,24696,24408,24048,23808,23784,
     3  23832,23640,23568,23520,23448,23400,23856,24000,24144,24288,
     4  24264,24480,24624,24624,24864,25032,24960,25128,25296,25512,
     5  25632,25536,25368,25440,25536,25656,25656,25704,25728,25848,
     6  26136,26352,26520,26808,26880,26928,26808,26568,26616,26808,
     7  26568,26472,26376,26544,26664,26616,26664,26760,26784,26856,
     8  26712,26712,26784,26784,26832,26952,26832,26880,26784,26928,
     9  26952,27120,27144,27120,27288,27456,27624,27624,27696,28008/
            data (jy(i),i=  101,  200)/
     +  28056,28200,28248,25272,23208,20976,22296,20904,20544,19656,
     1  15024,51984,52128,52104,52272,52368,52440,52584,52704,52584,
     2  52584,52728,52680,52824,52896,53112,53040,53112,53112,53280,
     3  53304,53136,53136,53328,53520,53736,53544,53424,53304,53448,
     4  53376,53496,52200,52152,52008,52824,52632,52512,52344,52152,
     5  51816,51504,52272,44712,44880,45072,45120,45288,45432,45480,
     6  45792,45840,46080,46152,46224,46344,46368,46368,46512,46728,
     7  47016,47184,47328,47472,47568,47640,47880,48288,48696,48864,
     8  49008,49008,49080,49056,49368,49392,49344,49536,49608,49632,
     9  49752,49776,49872,49800,49920,50232,50256,50208,50400,50328/
            data (jy(i),i=  201,  300)/
     +  50472,50424,50448,50640,50664,50640,50832,51120,51240,50184,
     1  48744,48672,44832,44760,44832,44784,44832,44736,44520,43344,
     2  43056,42528,42168,41760,39168,39576,39672,39960,40056,40392,
     3  40680,38232,38136,38040,37680,37176,37032,36768,36720,36336,
     4  36072,36024,35736,35424,35088,34680,34296,34104,33960,33696,
     5  33360,37512,37368,37296,37248,37368,37176,37152,36696,36312,
     6  35928,34680,32640,32400,32136,31848,31752,31680,31464,31392,
     7  31248,30984,30936,30960,30888,30792,30648,30648,30528,30432,
     8  30336,30504,30264,30264,30144,30240,30144,30168,30048,30072,
     9  29928,29856,29592,29568,29664,29520,29496,29424,29232,29136/
            data (jy(i),i=  301,  400)/
     +  28992,28968,29088,29088,28320,28248,28080,27984,27984,28032,
     1  28200,28440,28488,28584,28656,28680,28824,28680,28560,28224,
     2  28632,28848,28896,28656,28656,28848,29016,29400,29520,29664,
     3  30048,30480,30768,30864,30912,30840,31320,30960,30888,31200,
     4  31584,31680,31968,31896,31776,31608,31464,31200,30552,30528,
     5  30624,30600,30528,30456,30312,30216,30144,30216,30240,30456,
     6  30456,30648,30672,30912,30960,30816,30696,30672,30792,30792,
     7  30624,30408,31104,31368,32520,33168,33144,28584,28392,27912,
     8  27696,27528,27504,27360,27408,27264,27240,27024,27096,27096,
     9  27024,26928,26904,26952,26712,26640,26496,26544,26496,26376/
            data (jy(i),i=  401,  500)/
     +  26304,25944,25896,25968,25776,25680,25560,25416,25104,25080,
     1  25152,25104,24912,24864,24888,24768,24456,24528,24408,24432,
     2  24336,24264,24216,24072,23880,23808,23688,23592,23520,23352,
     3  23256,25344,25584,25656,25464,25416,25344,25176,25008,24720,
     4  24552,24312,24288,24408,24720,25008,25200,25392,25488,22296,
     5  22200,22080,22032,21816,21792,21648,21552,21696,21624,21336,
     6  21048,20808,20688,20544,20256,20136,19920,20424,20664,20976,
     7  21072,21072,21120,21192,21456,21432,21528,21576,21744,21720,
     8  21624,21720,21912,21816,22080,22176,22272,22368,22296,22344,
     9  22488,22584,22704,22704,22848,22800,22896,22872,22776,22560/
            data (jy(i),i=  501,  600)/
     +  22440,22368,22392,22176,22056,21768,21744,21648,21576,21336,
     1  21264,21360,21384,21288,20952,20976,21240,21408,21576,21552,
     2  21672,21816,21984,22032,22344,22560,22584,22344,22152,21960,
     3  21960,22176,21960,21960,22512,22656,22752,23160,23184,23040,
     4  23088,23256,23376,23376,23448,23832,23928,24144,24288,24264,
     5  24384,24360,24456,24384,24192,23832,23616,23592,23640,23808,
     6  24048,24456,24576,24816,25152,23064,22848,22704,22560,22200,
     7  22176,22080,21888,21792,21336,21336,21168,21216,21144,21072,
     8  20952,21000,20904,20976,20880,20976,20592,20472,20184,20232,
     9  20160,20232,20496,20280,20112,19992,19872,19848,19920,20016/
            data (jy(i),i=  601,  700)/
     +  20064,20232,20568,20640,20760,20880,21048,21120,21456,21576,
     1  21648,21480,21480,21528,21696,21864,21888,21960,22032,22128,
     2  20520,20400,20352,20208,20112,20088,20256,20256,19920,19800,
     3  19704,19440,18600,18408,18408,18312,17760,17688,17712,18264,
     4  18504,18696,18984,19272,19392,19488,19560,19608,19656,19560,
     5  19392,19200,19056,18912,18768,18504,18408,18600,18624,18456,
     6  18240,17544,17496,17424,17376,17328,17280,17184,17232,17448,
     7  17784,18000,17880,17544,17352,17400,17808,17976,18024,18192,
     8  18336,18432,18216,18648,19056,19128,19128,18768,18768,18672,
     9  18600,18504,18360,18360,18264,18408,18480,18624,18696,18816/
            data (jy(i),i=  701,  800)/
     +  18888,18888,18984,18936,19008,19080,19464,19536,19608,19560,
     1  19656,19488,19608,19728,19848,20040,20016,20184,20232,20208,
     2  20136,20304,20376,20544,20616,20592,20328,20400,20256,20256,
     3  20352,20544,20640,20712,20856,20760,20304,20304,20376,20640,
     4  19728,19848,20256,20592,20640,20592,20448,20424,20232,19776,
     5  19656,19584,19512,19440,19272,18888,18720,18312,18240,18360,
     6  18216,18072,17568,17424,17280,17136,17016,16848,16776,16416,
     7  16344,16152,16152,16080,15864,15744,15480,15408,15216,15096,
     8  15264,15240,15000,14880,14640,14640,14712,14736,14664,14928,
     9  15120,15024,15048,15360,15696,15816,15816,15648,15672,15888/
            data (jy(i),i=  801,  900)/
     +  15936,16152,16248,16368,16584,16440,16440,16536,16776,16800,
     1  16920,16872,16800,16632,16608,16680,16560,16536,16728,17064,
     2  17136,17040,16296,15888,16008,15912,15720,15456,15312,15840,
     3  16752,16920,17352,17352,17208,17376,17352,17448,17928,17928,
     4  17856,17568,17472,17496,17712,17712,17880,17976,17952,18096,
     5  17904,17832,17664,17640,17736,18048,18360,18480,18504,18240,
     6  18408,18744,18768,18888,19008,19104,19392,52680,51576,51528,
     7  51384,51096,50928,50808,50352,50256,50208,50040,49944,49752,
     8  49656,49368,49176,49104,49008,46224,46440,46512,46896,47040,
     9  47328,47424,47520,47736,47856,47928,47928,48000,48432,48600/
            data (jy(i),i=  901, 1000)/
     +  48672,48912,49200,49896,49920,50400,50736,50856,50928,51096,
     1  51264,51312,51480,51696,51456,51432,50160,50160,49944,49872,
     2  49920,49824,49752,49776,49560,49464,49464,49608,49440,49488,
     3  49416,49512,49392,49344,49248,51816,51744,51888,51936,51888,
     4  52008,52032,52008,51912,51864,51624,51672,51408,51216,51312,
     5  51288,51144,50952,50904,50832,50808,50688,50136,50040,49848,
     6  49344,49248,49032,48888,48912,48792,48768,48864,48984,49104,
     7  49296,49440,49800,49896,50016,50496,50520,50736,50928,51120,
     8  51144,51432,51600,49224,49248,49032,48720,48672,48600,48384,
     9  45720,45792,46104,46512,46728,46992,47568,47616,47592,47736/
            data (jy(i),i= 1001, 1100)/
     +  47952,48024,48504,48648,48624,48696,47112,46272,46416,46560,
     1  46776,46920,47016,47040,47376,47592,48024,48120,48360,49008,
     2  47088,46032,48312,47976,48048,47928,47928,47616,47592,47496,
     3  47400,47376,46896,46704,46272,46128,46104,46008,46032,45864,
     4  45216,45552,45528,45864,46080,45360,48336,47832,47280,47088,
     5  46488,46272,46032,45816,45312,45792,45960,46224,46200,46296,
     6  46416,46512,46632,46728,46752,46848,46824,46992,47016,47280,
     7  47544,47880,48192,48600,45600,45240,44760,45984,45336,44712,
     8  44952,45336,45480,45552,45672,46176,46512,46704,47040,47160,
     9  47328,47472,47688,48312,48576,45576,44952,44904,44880,44760/
            data (jy(i),i= 1101, 1200)/
     +  44760,44640,44760,44856,44808,44616,44640,44568,44736,45024,
     1  45024,44880,44688,44592,44736,44904,44976,45312,45312,44304,
     2  44616,44736,44832,45120,45000,44976,44568,44256,44160,44736,
     3  44688,44784,44520,44328,44136,44112,43800,44616,44592,44448,
     4  44256,43776,42960,42648,42408,42264,42096,41952,41856,41616,
     5  41208,41424,41712,42432,42528,42696,42792,42936,42984,43200,
     6  43344,43728,44208,44208,44304,43248,44760,44688,44880,44856,
     7  44712,44856,44784,45024,45144,45312,45912,45768,45672,45456,
     8  45264,45096,44952,44256,44112,43584,43536,45024,44856,44736,
     9  44712,44808,44712,44880,44856,45000,45144,45048,44952,44856/
            data (jy(i),i= 1201, 1300)/
     +  44712,44640,44496,44496,44112,43872,43896,43584,43752,43680,
     1  43464,43416,43320,43200,43200,42840,42744,42576,42456,41976,
     2  43320,43464,43680,43752,43776,41952,42216,42264,42456,42384,
     3  41976,42000,42264,42144,42456,42504,42336,41976,41880,41784,
     4  42336,42192,42024,41952,43416,43176,42792,42816,42720,42528,
     5  42456,42024,41976,41736,41712,41088,41184,42984,42744,42696,
     6  42168,41760,41496,41088,40752,40416,40080,39528,41760,41472,
     7  41304,41376,41088,40968,40824,41040,41088,41208,41184,41544,
     8  40752,40872,41256,41496,42168,42432,42432,42528,42696,42864,
     9  42864,42960,41112,41064,40896,40872,40704,40536,40368,39888/
            data (jy(i),i= 1301, 1400)/
     +  40008,39912,39912,40920,40776,39504,39672,39720,39864,42288,
     1  42360,42312,41760,41880,39768,43152,43008,42840,42624,42888,
     2  43296,43248,42624,42264,41448,41136,40656,40488,40656,40800,
     3  40896,40824,40824,40752,40872,40896,40992,40872,40824,40608,
     4  40488,40248,40104,40128,39912,39816,39672,39696,39600,39696,
     5  39624,39696,39552,39600,39648,39768,40272,40848,40896,41088,
     6  39456,39504,39768,39648,39672,39288,39624,38208,39720,39840,
     7  39960,40152,40296,38424,38400,37368,37248,37032,37032,36792,
     8  36384,38136,38400,38976,38568,38400,38400,38568,38472,38520,
     9  38808,38808,38112,38760,38592,38712,39120,39168,39456,39648/
            data (jy(i),i= 1401, 1500)/
     +  39672,39792,39672,40056,38064,38592,38760,38928,38976,37320,
     1  37344,37296,40992,40944,40680,40464,39912,39912,39792,39576,
     2  39384,38880,38712,38616,38376,37800,37680,37608,37488,37272,
     3  37176,38688,37128,41472,41256,41208,41040,40920,40656,40368,
     4  40320,40200,40080,39984,40008,39912,39696,39312,38688,38424,
     5  38400,38328,38160,38040,37824,37752,37488,37464,37368,36888,
     6  36816,36840,36696,36504,36408,36360,36336,37128,36960,36912,
     7  36816,36720,36528,36528,36624,36600,36360,36312,36384,36048,
     8  36072,35928,35976,35832,35712,35856,35832,35880,35784,35784,
     9  35856,35904,35784,35664,35712,35808,35712,35856,35784,35712/
            data (jy(i),i= 1501, 1600)/
     +  35664,35880,35832,35736,35568,35496,36096,36528,36480,36120,
     1  36120,36024,36384,36504,36456,36336,36456,36720,36720,37272,
     2  37392,37320,39768,39768,39696,39648,39696,39480,39384,39312,
     3  39144,39072,38976,38976,38760,38784,38664,38520,38208,38088,
     4  38040,37896,37848,37608,37416,37344,37296,36960,36792,36696,
     5  36384,36312,36192,35928,35616,35592,35208,35328,35328,35496,
     6  35520,35808,35904,36120,36600,36696,36720,36888,37296,37488,
     7  37560,37608,37824,38112,38328,38472,38760,38832,38808,39216,
     8  39336,39408,39528,39744,39912,40272,40440,40392,40680,41016,
     9  41136,41064,41088,41256,41448,41520,35040,35208,35352,35640/
            data (jy(i),i= 1601, 1700)/
     +  35928,35976,35760,35520,35544,35832,36048,37056,35784,35664,
     1  35568,35328,35400,35208,35232,35160,35184,35088,35040,35112,
     2  35160,35208,34392,34920,34920,34968,35232,35328,35280,35376,
     3  35520,35904,36192,36312,36648,36936,37656,37104,37056,36720,
     4  36288,36048,35808,35184,35136,35232,35280,35448,35448,35136,
     5  35160,34656,34296,35424,35136,34992,34872,34728,34728,34536,
     6  34344,34200,34464,34536,34704,34800,34896,34968,35376,35568,
     7  35880,36240,36504,36624,37272,37488,37536,37848,33576,34032,
     8  34032,33912,33960,34176,34368,34560,34560,34704,34632,34608,
     9  34944,35112,35184,34200,34008,33792,33408,33240,36480,36384/
            data (jy(i),i= 1701, 1800)/
     +  35856,35280,35088,32520,32400,33144,32952,33264,33240,33312,
     1  33192,33144,32976,32376,32136,32088,32136,32208,32160,32352,
     2  32712,32784,33792,33984,33792,33840,34200,34272,34032,30168,
     3  30384,30384,30456,30528,31056,31080,30984,31152,31224,31344,
     4  31440,31560,31656,31680,31752,31776,31992,32136,32544,32544,
     5  32616,32448,32496,32664,32664,32544,32640,32616,32664,32592,
     6  32640,32616,32544,32592,32496,31848,31824,31968,31896,31920,
     7  32016,32040,31992,32088,32112,32208,32352,32472,32568,32256,
     8  31824,31752,31776,31800,31680,31704,31848,32208,32400,32544,
     9  32736,32808,33072,33264,36024,35760,35424,35256,34968,34680/
            data (jy(i),i= 1801, 1900)/
     +  34464,33792,33528,33072,32832,32544,31896,31632,31248,31032,
     1  30864,30600,30360,30264,31200,31200,30672,30336,30144,29616,
     2  29760,29784,29736,29544,29088,29160,29256,29304,29280,29400,
     3  29376,29472,29496,29376,29472,29592,29712,29664,29760,29856,
     4  29880,30048,30096,25728,26256,26568,26880,27000,27120,27528,
     5  27960,28152,28080,28104,28200,28392,28248,28272,28968,29040,
     6  29040,29616,29544,29808,30048,30312,30480,28536,28848,29280,
     7  29544,30120,30600,30600,31008,31032,31392,31416,31728,28776,
     8  29040,29112,27864,27816,27672,27672,28296,31152,29184,29064,
     9  28296,26712,28248,28464,28632,28896,29112,29448,27912,27624/
            data (jy(i),i= 1901, 2000)/
     +  27480,27288,27048,27048,27600,26712,27504,26952,26232,26352,
     1  26232,26160,25848,25152,24624,24912,25008,25200,25296,25464,
     2  26064,26328,26568,26760,26856,27024,27000,27168,27072,27216,
     3  27048,27192,27696,28104,28368,28488,26496,26160,26352,26208,
     4  26088,25488,24984,25080,25152,24864,24720,24480,24408,24288,
     5  24144,24552,25680,25200,25152,25008,24360,23784,23496,23400,
     6  23208,26568,26232,26208,25824,25152,24984,24816,24792,24408,
     7  24216,23976,23736,23184,22992,22704,22656,22176,21000,20856,
     8  20832,21000,21024,21144,21240,21192,21288,21192,21312,21360,
     9  21576,21768,21720,21792,21888,21984,21960,22080,22176,22176/
            data (jy(i),i= 2001, 2100)/
     +  22272,22320,22248,22224,22320,22320,22392,22368,22440,22320,
     1  22320,22392,22512,22584,22608,24456,23976,23808,23616,23400,
     2  23136,22992,22896,22584,22512,21672,21984,22080,22176,22512,
     3  22608,23304,21984,21456,21984,21816,21624,21528,21336,20736,
     4  19200,19104,19128,19104,18888,18768,18696,18288,18312,18384,
     5  18360,17952,17616,17688,17472,17304,16992,16728,16440,16368,
     6  16392,16320,16080,15792,15888,15864,15744,15720,15576,15624,
     7  15720,15720,15624,15696,15624,15504,15336,15072,15000,14976,
     8  18096,18264,18288,18216,17856,17736,17808,19032,18936,18936,
     9  19992,20136,20088,19728,19680,19728,19872,20712,20784,20832/
            data (jy(i),i= 2101, 2180)/
     +  20736,20016,19944,19992,20064,24072,24072,24024,23928,24000,
     1  23592,23640,23616,20952,21000,21024,20928,29088,29064,29472,
     2  30264,30480,30264,29976,29784,28656,28584,28536,28584,28680,
     3  28368,28464,28512,29832,29832,29760,29688,30096,30024,29928,
     4  29952,29928,29880,29856,29832,29760,29712,29808,37272,37440,
     5  37248,26544,26544,26808,27096,27360,27144,27120,26832,26760,
     6  26640,26232,26256,26304,25992,25968,25872,25944,26112,26664,
     7  26712,26688,26640,26712,26640,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +     18,   21,   22,   23,   24,   25,   26,   27,   28,   29,
     1     30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
     2     40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     3     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     4     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     5     70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
     6     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     7     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     8    100,  101,  102,   19,    3,    1,    4,  112,  113,  114,
     9    115,  116,  117,  118,  119,  120,  121,  122,  123,  124/
            data (jb1(i),i=  101,  200)/
     +    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     1    135,  136,  137,  138,  139,  140,  141,    6,    2,  143,
     2    144,    4,    1,  146,  147,  148,  149,  150,  151,  152,
     3      5,    8,  154,  155,  156,  157,  158,  159,  160,  161,
     4    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     5    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     6    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     7    192,  193,  194,  195,  196,  197,  198,  199,  200,  201,
     8    202,  203,  204,  205,  206,  207,  208,    2,    5,  210,
     9      7,    7,   10,    9,    8,  213,  214,  215,  216,  217/
            data (jb1(i),i=  201,  300)/
     +    218,  219,  220,  221,  222,  223,   12,   10,   13,  225,
     1    226,  227,  228,  229,  230,   12,   13,  232,  233,  234,
     2    235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     3    245,  246,  247,  248,  249,   14,   14,   16,   11,  252,
     4    253,  254,  255,  256,  257,  258,  259,  260,  261,   15,
     5     16,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     6    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     7    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     8    292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
     9    302,  303,   17,   19,  305,  306,  307,  308,  309,  310/
            data (jb1(i),i=  301,  400)/
     +    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     1    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     2    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     3    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     4    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     5    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     6    371,  372,  373,  374,  375,  376,   15,   17,  378,  379,
     7    380,  381,   20,   20,  383,  384,  385,  386,  387,  388,
     8    389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
     9    399,  400,  401,  402,  403,  404,  405,  406,  407,  408/
            data (jb1(i),i=  401,  500)/
     +    409,  410,  411,  412,  413,  414,  415,  416,  417,  418,
     1    419,  420,  421,  422,  423,  424,  425,  426,  427,  428,
     2    429,  430,  105,  104,  432,  433,  434,  435,  436,  437,
     3    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     4    448,   18,  107,  450,  451,  452,  453,  454,  455,  456,
     5    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     6    467,  468,  469,  470,  471,  472,  473,  474,  475,  476,
     7    477,  478,  479,  480,  481,  482,  483,  484,  485,  486,
     8    487,  488,  489,  490,  491,  492,  493,  494,  495,  496,
     9    497,  498,  499,  500,  501,  502,  503,  504,  505,  506/
            data (jb1(i),i=  501,  600)/
     +    507,  508,  509,  510,  511,  512,  513,  514,  515,  516,
     1    517,  518,  519,  520,  521,  522,  523,  524,  525,  526,
     2    527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
     3    537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
     4    547,  548,  549,  550,  551,  552,  553,  554,  555,  556,
     5    557,  558,  559,  560,  561,  562,  563,  564,  104,  105,
     6    566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
     7    576,  577,  578,  579,  580,  581,  582,  583,  584,  108,
     8    106,  586,  587,  588,  589,  590,  591,  592,  593,  594,
     9    595,  596,  597,  598,  599,  600,  601,  602,  603,  604/
            data (jb1(i),i=  601,  700)/
     +    605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
     1    615,  616,  617,  618,  619,  107,  109,  621,  622,  623,
     2    624,  625,  626,  627,  628,  629,  630,  631,  632,  633,
     3    634,  635,  636,  637,  638,  639,  640,  641,  642,  643,
     4    644,  645,  646,  647,  648,  649,  650,  651,  652,  653,
     5    654,  655,  656,  657,  658,  659,  660,  661,  662,  663,
     6    664,  665,  666,  667,  668,  669,  670,  671,  672,  673,
     7    674,  675,  676,  677,  678,  679,  680,  681,  682,  683,
     8    684,  685,  686,  687,  688,  689,  690,  691,  692,  693,
     9    694,  695,  696,  697,  698,  699,  700,  701,  702,  703/
            data (jb1(i),i=  701,  800)/
     +    704,  705,  706,  707,  708,  709,  710,  711,  712,  713,
     1    714,  715,  716,  717,  718,  719,  720,  721,  722,  723,
     2    724,  725,  726,  727,  728,  729,  730,  731,  732,  733,
     3    734,  735,  736,  737,  738,  739,  106,  110,  741,  742,
     4    743,  744,  109,  108,  746,  747,  748,  749,  750,  751,
     5    752,  753,  754,  755,  756,  757,  758,  759,  760,  761,
     6    762,  763,  764,  765,  766,  767,  768,  769,  770,  771,
     7    772,  773,  774,  775,  776,  777,  778,  779,  780,  781,
     8    782,  783,  784,  785,  786,  787,  788,  789,  111,  111,
     9    791,  792,  793,  794,  795,  796,  797,  798,  799,  800/
            data (jb1(i),i=  801,  900)/
     +    801,  802,  803,  804,  805,  806,  807,  808,  809,  810,
     1    811,  812,  813,  814,  815,  816,  817,  818,  819,  820,
     2    821,  822,  823,  824,  825,  826,  827,  828,  829,  830,
     3    831,  832,  833,  834,  835,  836,  837,  838,  839,  840,
     4    841,  842,  843,  844,  845,  846,  847,  848,  849,  850,
     5    851,  852,  853,  854,  855,  856,  857,  858,  859,  860,
     6    861,  862,  863,  864,  865,  866,  110,    1,  868,  869,
     7    870,  871,  872,  873,  874,  875,  876,  877,  878,  879,
     8    880,  881,  882,  883,  884,  886,  887,  888,  889,  890,
     9    891,  892,  893,  894,  895,  896,  897,  898,  899,  900/
            data (jb1(i),i=  901, 1000)/
     +    901,  902,  903,  904,  905,  906,  907,  908,  909,  910,
     1    911,  912,  913,    3,  914,  915,  916,  917,  918,  919,
     2    920,  921,  922,  923,  924,  925,  926,  927,  928,  929,
     3    930,  931,  932,  933,  934,  885,    4,  936,  937,  938,
     4    939,  940,  941,  942,  943,  944,  945,  946,  947,  948,
     5    949,  950,  951,  952,  953,  954,  955,  956,  957,  958,
     6    959,  960,  961,  962,  963,  885,  965,  967,  968,  969,
     7    970,  971,  972,  973,  974,  975,  976,  977,  978,  979,
     8    980,  981,  982,  983,  966,    6,  984,  985,  986,  987,
     9    988,  989,  991,  992,  993,  994,  995,  996,  997,  998/
            data (jb1(i),i= 1001, 1100)/
     +    999, 1000, 1001, 1002, 1003, 1004, 1005,  966,  964,  886,
     1   1008, 1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017,
     2   1018, 1019,  919, 1020, 1021,  886,  990, 1023, 1024, 1025,
     3   1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035,
     4   1036, 1037, 1038, 1039, 1022, 1041, 1042, 1043, 1044, 1022,
     5    991,  967, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1046,
     6   1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064,
     7   1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074,
     8    991, 1075, 1076,  990, 1078, 1079, 1080, 1081, 1082, 1083,
     9   1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093/
            data (jb1(i),i= 1101, 1200)/
     +   1094,  964, 1008, 1096, 1097, 1098, 1099, 1100, 1101, 1102,
     1   1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112,
     2   1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122,
     3   1046, 1041, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     4   1077, 1080, 1133, 1134, 1135, 1136, 1077, 1138, 1139, 1140,
     5   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1151,
     6   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     7   1162, 1163, 1164, 1041, 1166, 1167, 1168, 1169, 1170, 1171,
     8   1172, 1173, 1174, 1175, 1055, 1008, 1177, 1178, 1179, 1180,
     9   1181, 1182, 1183, 1184, 1185, 1186, 1166, 1055, 1188, 1189/
            data (jb1(i),i= 1201, 1300)/
     +   1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199,
     1   1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209,
     2   1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217,   10, 1218,
     3   1220, 1221, 1222, 1223, 1224, 1120, 1226, 1227, 1228, 1229,
     4   1226, 1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238,
     5   1239, 1219, 1241, 1242, 1243, 1240, 1080, 1137, 1245, 1246,
     6   1247, 1248, 1249, 1250, 1251, 1252, 1253, 1254, 1151, 1256,
     7   1150, 1137, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265,
     8   1266, 1267, 1220, 1269, 1270, 1271, 1272, 1273, 1274, 1275,
     9   1276, 1277, 1278, 1279, 1150, 1281, 1282, 1283, 1284, 1285/
            data (jb1(i),i= 1301, 1400)/
     +   1286, 1287, 1288, 1289, 1290, 1291, 1166, 1151, 1293, 1294,
     1   1295, 1296, 1297, 1298, 1300, 1301, 1302, 1281, 1220, 1304,
     2   1305, 1306, 1307, 1308, 1300, 1218, 1310, 1311, 1312, 1313,
     3   1314, 1166, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323,
     4   1324, 1325, 1326, 1327, 1315, 1299, 1329, 1330, 1331, 1332,
     5   1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342,
     6   1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352,
     7   1353, 1354, 1355, 1356, 1357, 1358, 1359, 1256, 1268, 1361,
     8   1362, 1363, 1364, 1365, 1366, 1315, 1368, 1369, 1370, 1371,
     9   1372, 1299, 1368, 1374, 1375, 1376, 1377, 1378, 1379, 1380/
            data (jb1(i),i= 1401, 1500)/
     +   1368, 1268, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1382,
     1   1366, 1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399,
     2   1400, 1401, 1402, 1403, 1281, 1405, 1406, 1407, 1408, 1366,
     3   1410, 1411, 1405, 1256, 1413, 1414, 1415, 1416, 1417, 1418,
     4   1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428,
     5   1429, 1430, 1350, 1432, 1381, 1240, 1434, 1435, 1436, 1437,
     6   1438, 1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447,
     7   1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457,
     8   1458, 1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466, 1431,
     9   1468, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477/
            data (jb1(i),i= 1501, 1600)/
     +   1478, 1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487,
     1   1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497,
     2   1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1467, 1467,
     3   1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517,
     4   1518, 1519, 1520, 1521, 1410, 1300, 1523, 1524, 1525, 1526,
     5   1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536,
     6   1537, 1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546,
     7   1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1506,
     8   1557, 1558, 1559, 1560, 1561, 1562, 1563, 1564, 1565, 1566,
     9   1567, 1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576/
            data (jb1(i),i= 1601, 1700)/
     +   1577, 1578, 1579, 1580, 1581, 1582, 1583, 1584, 1585, 1586,
     1   1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, 1595, 1226,
     2   1597, 1598, 1599, 1600, 1601, 1602, 1603, 1604, 1605, 1606,
     3   1607, 1431, 1507, 1609, 1610, 1611, 1612, 1613, 1614, 1615,
     4   1616, 1617, 1618, 1619, 1620, 1621, 1557, 1623, 1597, 1623,
     5   1625, 1626, 1627, 1628, 1629, 1630, 1631, 1632, 1633, 1634,
     6   1635, 1433, 1405, 1637, 1638, 1639, 1640, 1641, 1642, 1643,
     7   1644, 1645, 1646, 1647, 1648, 1649, 1650, 1651, 1652, 1506,
     8   1654, 1655, 1656, 1657, 1658, 1659, 1660, 1653,   14, 1662,
     9   1663, 1664, 1665, 1666, 1667, 1668, 1669, 1670, 1671, 1672/
            data (jb1(i),i= 1701, 1800)/
     +   1673, 1674, 1675, 1676, 1677, 1382,   15, 1679, 1680, 1681,
     1   1682, 1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691,
     2   1692, 1557, 1653, 1694, 1695, 1696, 1697, 1381, 1410, 1699,
     3   1700, 1701, 1702, 1703, 1623, 1698, 1706, 1707, 1708, 1709,
     4   1710, 1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719,
     5   1720, 1721, 1722, 1723, 1724, 1725, 1726, 1727, 1728, 1597,
     6   1730, 1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739,
     7   1740, 1741, 1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749,
     8   1750, 1751, 1752, 1753, 1754, 1755, 1756, 1757, 1758, 1759,
     9   1760, 1761, 1762, 1763, 1764, 1704, 1766, 1767, 1768, 1769/
            data (jb1(i),i= 1801, 1900)/
     +   1770, 1771, 1772, 1773, 1774, 1775, 1776, 1777, 1778, 1704,
     1   1705, 1780, 1781, 1766, 1783, 1784, 1785, 1786, 1787, 1788,
     2   1789, 1790, 1791, 1792, 1793, 1698, 1705, 1507, 1795, 1796,
     3   1797, 1798, 1799, 1800, 1801, 1802, 1803, 1804, 1805, 1806,
     4   1807, 1808, 1809, 1810, 1811, 1812, 1813, 1730, 1766, 1815,
     5   1816, 1817, 1818, 1819, 1820, 1821, 1822, 1823, 1825, 1826,
     6   1827, 1828, 1829, 1830, 1831, 1832, 1833, 1834, 1835, 1836,
     7   1837, 1838, 1839, 1840, 1841, 1842, 1730,   18, 1844, 1845,
     8   1846, 1847, 1848, 1849, 1850, 1851, 1852, 1853, 1854, 1855,
     9   1856, 1857, 1858, 1859, 1860, 1825, 1824, 1862, 1863, 1864/
            data (jb1(i),i= 1901, 2000)/
     +   1865, 1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873, 1874,
     1   1875, 1876, 1877, 1878, 1782,   19, 1880, 1881, 1825, 1883,
     2   1884, 1885, 1886, 1887, 1782, 1888, 1889, 1890, 1883, 1892,
     3   1893, 1894, 1895, 1896, 1897, 1824, 1868, 1899, 1900, 1901,
     4   1902, 1903, 1904, 1905, 1883, 1907, 1906, 1892, 1909, 1910,
     5   1911, 1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920,
     6   1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929, 1930,
     7   1931, 1932, 1933, 1934, 1935, 1868, 1892, 1937, 1938, 1939,
     8   1940, 1941, 1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949,
     9   1950, 1951, 1915, 1906, 1953, 1954, 1955, 1956, 1957, 1958/
            data (jb1(i),i= 2001, 2100)/
     +   1959, 1960, 1961, 1906, 1962, 1963, 1964, 1965, 1966, 1967,
     1   1968, 1969, 1970, 1971, 1972, 1973, 1974, 1975, 1976, 1977,
     2    106, 1979, 1980, 1981, 1982, 1983, 1984, 1985, 1986, 1987,
     3   1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997,
     4   1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007,
     5   2008, 2009, 2010, 2011, 2012, 2013, 2014, 1976, 1915, 2016,
     6   2017, 2018, 2019, 2020, 2021, 2022, 2023, 2024, 2025, 1978,
     7   2026, 2027, 2028, 2029, 2030, 2031, 2032, 2033, 2034, 1978,
     8   2035, 2036, 2037, 2038, 2039, 2040,  110, 2041, 2042, 2043,
     9   2044, 2045, 2046, 2047, 2048, 2049, 2050, 2051, 2052, 2053/
            data (jb1(i),i= 2101, 2200)/
     +   2054, 2055, 2056, 2057, 2058, 2059, 2060, 2061, 2062, 2063,
     1   2064, 2065, 2066, 2067, 2068, 2069, 2070, 2071, 2072, 2073,
     2   2074, 2075, 2076, 2077, 2078, 2079, 2080,    1,    2,    3,
     3      4,    5,    6,    1,    8,    9,    8,   11,   12,   13,
     4     14,   15,   16,   11,   18,   19,   20,   18,   22,   23,
     5     24,   22,   26,   27,   28,   29,   26,   31,   32,   31,
     6     34,   35,   36,   34,   38,   39,   40,   41,   42,   43,
     7     44,   38,   46,   47,   48,   49,   46,   51,   52,   51,
     8     54,   55,   56,   54,   58,   59,   58,   61,   62,   61,
     9     64,   65,   66,   67,   64,   69,   70,   69,   72,   73/
            data (jb1(i),i= 2201, 2230)/
     +     74,   75,   76,   77,   78,   79,   80,   72,   82,   83,
     1     82,   85,   86,   87,   88,   85,   90,   91,   90,   93,
     2     94,   93,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
     1     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     2     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     3     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     4     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     5     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     6     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     7     91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
     8    101,  102,  103,  103,    6,    3,  112,  113,  114,  115,
     9    116,  117,  118,  119,  120,  121,  122,  123,  124,  125/
            data (jb2(i),i=  101,  200)/
     +    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     1    136,  137,  138,  139,  140,  141,  142,  142,  143,  144,
     2    145,  145,  146,  147,  148,  149,  150,  151,  152,  153,
     3    153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     4    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     5    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     6    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     7    193,  194,  195,  196,  197,  198,  199,  200,  201,  202,
     8    203,  204,  205,  206,  207,  208,  209,  209,  210,  211,
     9    211,    9,  212,  212,  213,  214,  215,  216,  217,  218/
            data (jb2(i),i=  201,  300)/
     +    219,  220,  221,  222,  223,  224,  224,   11,  225,  226,
     1    227,  228,  229,  230,  231,  231,  232,  233,  234,  235,
     2    236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
     3    246,  247,  248,  249,  250,  250,  251,  251,  252,  253,
     4    254,  255,  256,  257,  258,  259,  260,  261,  262,  262,
     5    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     6    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     7    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     8    293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
     9    303,  304,  304,  305,  306,  307,  308,  309,  310,  311/
            data (jb2(i),i=  301,  400)/
     +    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     1    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     2    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     3    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     4    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     5    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     6    372,  373,  374,  375,  376,  377,  377,  378,  379,  380,
     7    381,  382,  382,  383,  384,  385,  386,  387,  388,  389,
     8    390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
     9    400,  401,  402,  403,  404,  405,  406,  407,  408,  409/
            data (jb2(i),i=  401,  500)/
     +    410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
     1    420,  421,  422,  423,  424,  425,  426,  427,  428,  429,
     2    430,  431,  431,  432,  433,  434,  435,  436,  437,  438,
     3    439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
     4    449,  449,  450,  451,  452,  453,  454,  455,  456,  457,
     5    458,  459,  460,  461,  462,  463,  464,  465,  466,  467,
     6    468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
     7    478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
     8    488,  489,  490,  491,  492,  493,  494,  495,  496,  497,
     9    498,  499,  500,  501,  502,  503,  504,  505,  506,  507/
            data (jb2(i),i=  501,  600)/
     +    508,  509,  510,  511,  512,  513,  514,  515,  516,  517,
     1    518,  519,  520,  521,  522,  523,  524,  525,  526,  527,
     2    528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
     3    538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
     4    548,  549,  550,  551,  552,  553,  554,  555,  556,  557,
     5    558,  559,  560,  561,  562,  563,  564,  565,  565,  566,
     6    567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
     7    577,  578,  579,  580,  581,  582,  583,  584,  585,  585,
     8    586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
     9    596,  597,  598,  599,  600,  601,  602,  603,  604,  605/
            data (jb2(i),i=  601,  700)/
     +    606,  607,  608,  609,  610,  611,  612,  613,  614,  615,
     1    616,  617,  618,  619,  620,  620,  621,  622,  623,  624,
     2    625,  626,  627,  628,  629,  630,  631,  632,  633,  634,
     3    635,  636,  637,  638,  639,  640,  641,  642,  643,  644,
     4    645,  646,  647,  648,  649,  650,  651,  652,  653,  654,
     5    655,  656,  657,  658,  659,  660,  661,  662,  663,  664,
     6    665,  666,  667,  668,  669,  670,  671,  672,  673,  674,
     7    675,  676,  677,  678,  679,  680,  681,  682,  683,  684,
     8    685,  686,  687,  688,  689,  690,  691,  692,  693,  694,
     9    695,  696,  697,  698,  699,  700,  701,  702,  703,  704/
            data (jb2(i),i=  701,  800)/
     +    705,  706,  707,  708,  709,  710,  711,  712,  713,  714,
     1    715,  716,  717,  718,  719,  720,  721,  722,  723,  724,
     2    725,  726,  727,  728,  729,  730,  731,  732,  733,  734,
     3    735,  736,  737,  738,  739,  740,  740,  741,  742,  743,
     4    744,  745,  745,  746,  747,  748,  749,  750,  751,  752,
     5    753,  754,  755,  756,  757,  758,  759,  760,  761,  762,
     6    763,  764,  765,  766,  767,  768,  769,  770,  771,  772,
     7    773,  774,  775,  776,  777,  778,  779,  780,  781,  782,
     8    783,  784,  785,  786,  787,  788,  789,  790,  790,  791,
     9    792,  793,  794,  795,  796,  797,  798,  799,  800,  801/
            data (jb2(i),i=  801,  900)/
     +    802,  803,  804,  805,  806,  807,  808,  809,  810,  811,
     1    812,  813,  814,  815,  816,  817,  818,  819,  820,  821,
     2    822,  823,  824,  825,  826,  827,  828,  829,  830,  831,
     3    832,  833,  834,  835,  836,  837,  838,  839,  840,  841,
     4    842,  843,  844,  845,  846,  847,  848,  849,  850,  851,
     5    852,  853,  854,  855,  856,  857,  858,  859,  860,  861,
     6    862,  863,  864,  865,  866,  867,  867,  868,  869,  870,
     7    871,  872,  873,  874,  875,  876,  877,  878,  879,  880,
     8    881,  882,  883,  884,  885,  887,  888,  889,  890,  891,
     9    892,  893,  894,  895,  896,  897,  898,  899,  900,  901/
            data (jb2(i),i=  901, 1000)/
     +    902,  903,  904,  905,  906,  907,  908,  909,  910,  911,
     1    912,  913,    2,  914,  915,  916,  917,  918,  919,  920,
     2    921,  922,  923,  924,  925,  926,  927,  928,  929,  930,
     3    931,  932,  933,  934,  935,  935,  936,  937,  938,  939,
     4    940,  941,  942,  943,  944,  945,  946,  947,  948,  949,
     5    950,  951,  952,  953,  954,  955,  956,  957,  958,  959,
     6    960,  961,  962,  963,  964,  965,  966,  968,  969,  970,
     7    971,  972,  973,  974,  975,  976,  977,  978,  979,  980,
     8    981,  982,  983,    5,  967,  984,  985,  986,  987,  988,
     9    989,  990,  992,  993,  994,  995,  996,  997,  998,  999/
            data (jb2(i),i= 1001, 1100)/
     +   1000, 1001, 1002, 1003, 1004, 1005, 1006, 1006, 1007, 1007,
     1   1009, 1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018,
     2   1019,    7, 1020, 1021, 1022,    8, 1023, 1024, 1025, 1026,
     3   1027, 1028, 1029, 1030, 1031, 1032, 1033, 1034, 1035, 1036,
     4   1037, 1038, 1039, 1040, 1040, 1042, 1043, 1044, 1045, 1045,
     5   1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1054,
     6   1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065,
     7   1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074,    9,
     8   1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084,
     9   1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094/
            data (jb2(i),i= 1101, 1200)/
     +   1095, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103,
     1   1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113,
     2   1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121, 1122, 1123,
     3   1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132,
     4   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141,
     5   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1152,
     6   1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162,
     7   1163, 1164, 1165, 1165, 1167, 1168, 1169, 1170, 1171, 1172,
     8   1173, 1174, 1175, 1176, 1176, 1177, 1178, 1179, 1180, 1181,
     9   1182, 1183, 1184, 1185, 1186, 1187, 1187, 1188, 1189, 1190/
            data (jb2(i),i= 1201, 1300)/
     +   1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200,
     1   1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210,
     2   1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219, 1219,
     3   1221, 1222, 1223, 1224, 1225, 1225, 1227, 1228, 1229,   11,
     4   1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239,
     5   1240, 1241, 1242, 1243, 1244, 1244,   12, 1245, 1246, 1247,
     6   1248, 1249, 1250, 1251, 1252, 1253, 1254, 1255, 1255, 1257,
     7   1257, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266,
     8   1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276,
     9   1277, 1278, 1279, 1280, 1280, 1282, 1283, 1284, 1285, 1286/
            data (jb2(i),i= 1301, 1400)/
     +   1287, 1288, 1289, 1290, 1291, 1292, 1292, 1293, 1294, 1295,
     1   1296, 1297, 1298, 1299, 1301, 1302, 1303, 1303, 1304, 1305,
     2   1306, 1307, 1308, 1309, 1309, 1310, 1311, 1312, 1313, 1314,
     3   1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324,
     4   1325, 1326, 1327, 1328, 1328, 1329, 1330, 1331, 1332, 1333,
     5   1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343,
     6   1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353,
     7   1354, 1355, 1356, 1357, 1358, 1359, 1360, 1360, 1361, 1362,
     8   1363, 1364, 1365,   13, 1367, 1367, 1369, 1370, 1371, 1372,
     9   1373, 1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381/
            data (jb2(i),i= 1401, 1500)/
     +   1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1390,
     1   1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400,
     2   1401, 1402, 1403, 1404, 1404, 1406, 1407, 1408, 1409, 1409,
     3   1411, 1412, 1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419,
     4   1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428, 1429,
     5   1430, 1431, 1432, 1433, 1433, 1434, 1435, 1436, 1437, 1438,
     6   1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447, 1448,
     7   1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458,
     8   1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468,
     9   1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478/
            data (jb2(i),i= 1501, 1600)/
     +   1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488,
     1   1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1498,
     2   1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508,
     3   1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517, 1518,
     4   1519, 1520, 1521, 1522, 1522, 1523, 1524, 1525, 1526, 1527,
     5   1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536, 1537,
     6   1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546, 1547,
     7   1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556, 1556,
     8   1558, 1559, 1560, 1561, 1562, 1563, 1564, 1565, 1566, 1567,
     9   1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577/
            data (jb2(i),i= 1601, 1700)/
     +   1578, 1579, 1580, 1581, 1582, 1583, 1584, 1585, 1586, 1587,
     1   1588, 1589, 1590, 1591, 1592, 1593, 1594, 1595, 1596, 1596,
     2   1598, 1599, 1600, 1601, 1602, 1603, 1604, 1605, 1606, 1607,
     3   1608, 1608, 1609, 1610, 1611, 1612, 1613, 1614, 1615, 1616,
     4   1617, 1618, 1619, 1620, 1621, 1622, 1622, 1624, 1624, 1625,
     5   1626, 1627, 1628, 1629, 1630, 1631, 1632, 1633, 1634, 1635,
     6   1636, 1636, 1637, 1638, 1639, 1640, 1641, 1642, 1643, 1644,
     7   1645, 1646, 1647, 1648, 1649, 1650, 1651, 1652, 1653, 1654,
     8   1655, 1656, 1657, 1658, 1659, 1660, 1661, 1661, 1662, 1663,
     9   1664, 1665, 1666, 1667, 1668, 1669, 1670, 1671, 1672, 1673/
            data (jb2(i),i= 1701, 1800)/
     +   1674, 1675, 1676, 1677, 1678, 1678, 1679, 1680, 1681, 1682,
     1   1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691, 1692,
     2   1693, 1693, 1694, 1695, 1696, 1697, 1698,   16, 1699, 1700,
     3   1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709, 1710,
     4   1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719, 1720,
     5   1721, 1722, 1723, 1724, 1725, 1726, 1727, 1728, 1729, 1729,
     6   1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740,
     7   1741, 1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749, 1750,
     8   1751, 1752, 1753, 1754, 1755, 1756, 1757, 1758, 1759, 1760,
     9   1761, 1762, 1763, 1764, 1765, 1765, 1767, 1768, 1769, 1770/
            data (jb2(i),i= 1801, 1900)/
     +   1771, 1772, 1773, 1774, 1775, 1776, 1777, 1778, 1779, 1779,
     1   1780, 1781, 1782, 1783, 1784, 1785, 1786, 1787, 1788, 1789,
     2   1790, 1791, 1792, 1793, 1794, 1794,   17, 1795, 1796, 1797,
     3   1798, 1799, 1800, 1801, 1802, 1803, 1804, 1805, 1806, 1807,
     4   1808, 1809, 1810, 1811, 1812, 1813, 1814, 1814, 1815, 1816,
     5   1817, 1818, 1819, 1820, 1821, 1822, 1823, 1824, 1826, 1827,
     6   1828, 1829, 1830, 1831, 1832, 1833, 1834, 1835, 1836, 1837,
     7   1838, 1839, 1840, 1841, 1842, 1843, 1843, 1844, 1845, 1846,
     8   1847, 1848, 1849, 1850, 1851, 1852, 1853, 1854, 1855, 1856,
     9   1857, 1858, 1859, 1860, 1861, 1861, 1862, 1863, 1864, 1865/
            data (jb2(i),i= 1901, 2000)/
     +   1866, 1867, 1868, 1869, 1870, 1871, 1872, 1873, 1874, 1875,
     1   1876, 1877, 1878, 1879, 1879, 1880, 1881, 1882, 1882, 1884,
     2   1885, 1886, 1887,   20, 1888, 1889, 1890, 1891, 1891, 1893,
     3   1894, 1895, 1896, 1897, 1898, 1898, 1899, 1900, 1901, 1902,
     4   1903, 1904, 1905, 1906, 1907, 1908, 1908, 1909, 1910, 1911,
     5   1912, 1913, 1914,  104, 1916, 1917, 1918, 1919, 1920, 1921,
     6   1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929, 1930, 1931,
     7   1932, 1933, 1934, 1935, 1936, 1936, 1937, 1938, 1939, 1940,
     8   1941, 1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950,
     9   1951, 1952, 1952, 1953, 1954, 1955, 1956, 1957, 1958, 1959/
            data (jb2(i),i= 2001, 2100)/
     +   1960, 1961,  105, 1962, 1963, 1964, 1965, 1966, 1967, 1968,
     1   1969, 1970, 1971, 1972, 1973, 1974, 1975, 1976, 1977, 1978,
     2   1979, 1980, 1981, 1982, 1983, 1984, 1985, 1986, 1987, 1988,
     3   1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
     4   1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008,
     5   2009, 2010, 2011, 2012, 2013, 2014, 2015, 2015, 2016, 2017,
     6   2018, 2019, 2020, 2021, 2022, 2023, 2024, 2025,  107, 2026,
     7   2027, 2028, 2029, 2030, 2031, 2032, 2033, 2034,  108, 2035,
     8   2036, 2037, 2038, 2039, 2040,  109, 2041, 2042, 2043, 2044,
     9   2045, 2046, 2047, 2048, 2049, 2050, 2051, 2052, 2053, 2054/
            data (jb2(i),i= 2101, 2200)/
     +   2055, 2056, 2057, 2058, 2059, 2060, 2061, 2062, 2063, 2064,
     1   2065, 2066, 2067, 2068, 2069, 2070, 2071, 2072, 2073, 2074,
     2   2075, 2076, 2077, 2078, 2079, 2080,  111,    2,    3,    4,
     3      5,    6,    7,    7,    9,   10,   10,   12,   13,   14,
     4     15,   16,   17,   17,   19,   20,   21,   21,   23,   24,
     5     25,   25,   27,   28,   29,   30,   30,   32,   33,   33,
     6     35,   36,   37,   37,   39,   40,   41,   42,   43,   44,
     7     45,   45,   47,   48,   49,   50,   50,   52,   53,   53,
     8     55,   56,   57,   57,   59,   60,   60,   62,   63,   63,
     9     65,   66,   67,   68,   68,   70,   71,   71,   73,   74/
            data (jb2(i),i= 2201, 2230)/
     +     75,   76,   77,   78,   79,   80,   81,   81,   83,   84,
     1     84,   86,   87,   88,   89,   89,   91,   92,   92,   94,
     2     95,   95,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine sd(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(710) :: jx,jy
            integer(kind=iknd), save, dimension(780) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'south dakota  '/
            data jrot,ipart/0,1/
            data kv/   1, 710,   0,   0,   0/
            data kb/   1, 775,   0,   0,   0/
            data iib/ 179,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  20208,29328,34152,44832,40248,49416,54240, 7320,54456, 6864,
     1  54552, 6648,54648, 6480,54744, 6288,53928,54960,41808,12816,
     2  18720,24240,30864,35160,47400,44112,50472,52776,14448,54000,
     3  53712,53352,52896,52584,52368,51792,51840,51936,52248,52536,
     4  52920,53136,53376,53472,53520, 7680,54360, 7080, 7200,54840,
     5   6048,54936,55056,54864,54792,54720,54528,54432,54240,54192,
     6  54288,54288,54072,54096,54048,54096,54408,54456,54240,54120,
     7  53952,54024,54000,47568,47640,47688,47880,48216,48552,48672,
     8  48840,49464,49704,49992,50112,50088,50160,43776,43440,42720,
     9  42600,42408,42168,42024,44688,44976,45216,45552,45816,45840/
            data (jx(i),i=  101,  200)/
     +  45984,46248,46368,46488,46608,46776,46872,46968,47136,47208,
     1  50592,50640,50832,51600,51768,51720,51768,51864,52032,52176,
     2  52440,52800,52896,53304,53520,53568,53400,53976,54048,54168,
     3  54456,54576,54864,55128,54984,54960,54864,54840,54960,54936,
     4  54792,54888,54816,54720,54576,54672,54528,54504,54384,54384,
     5  54264,54288,54144,54000,53928,53952,53880,53904,53976,53880,
     6  54144,54120,54216,54336,54384,54456,54408,54528,54456,54456,
     7  54528,54576,54696,54576,54720,54600,54600,54528,54912,20064,
     8  29736,29832,30000,30336,30480,30600,30360,30216,30072,30240,
     9  29856,29856,29736,29616,29352,34152,34200,49512,48672,48600/
            data (jx(i),i=  201,  300)/
     +  44856,40248,23304,30264,30000,29640,29472,29400,29472,29688,
     1  51000,50904,49560,14016,30744,30528,30432,30480,30672,30672,
     2  30360,34176,35016,40296,44904,40320,51744,51720,49608,47928,
     3  44904,30624,30312,30360,30600,30504,30048,29736,29688,29712,
     4  29832,34368,35016,36624,40344,51792,48000,25224,25272,23016,
     5  23016,23112,23208,23304,27840,27768,27792,27888,28008,28104,
     6  28560,28848,28992,29328,29856,25656,24888,24912,24984,25080,
     7  25200,25272,25512,25800,25872,26160,26232,26328,26352,26448,
     8  26592,26640,26808,27168,27312,27504,27504,27624,27672,27720,
     9  27720,25176,24936,24840,24648,24480,24072,24000,23928,23808/
            data (jx(i),i=  301,  400)/
     +  23832,23736,23760,23568,23424,23280,23136,23184,22920,22944,
     1  22848,22752,22440,22152,22104,21864,21768,21576,21528,21408,
     2  21144,21072,21000,20952,20880,20664,20592,20112,19824,19728,
     3   7080, 7560, 7968, 8064, 8136, 8232, 8400, 9960,13704,13944,
     4  45000,40416,40416,51840,50328,29328,29232,29040,28104,28320,
     5  28416,28488,28248,28320,28536,28968,48048,34344,45768,45744,
     6  19920,10440,10488, 9744,19440,19392,19248,19176,19032,19008,
     7  18768,18720,18504,18288,17952,17808,17808,17760,17640,17520,
     8  17496,17352,17376,17256,17136,17088,17160,17184,17064,17136,
     9  29088,28656,28656,28728,28896,29280,29592,29832,29952,30048/
            data (jx(i),i=  401,  500)/
     +  30912,31296,31728,32400,32784,32904,32952,32688,32688,19512,
     1  34392,34416,36696,36696,36624,51912,50400,48864,45840,42792,
     2  33000,33240,33768,34392,34608,34800,34776,34608,34248,34128,
     3  34176,29928,29928,40464,39048,34680,34968,35160,35064,35136,
     4  35304,35688,36168,36336,36384,36360,25488,25608,18576,18720,
     5  18768,18864,19104,19128,19200,19296,19344,19440,29904,30072,
     6  30072,15168,15072,15024,14832,14808,14568,14592,14424,14304,
     7  42816,39048,39792,36720,36768,36456,36456,36360,36096,35784,
     8  35664,35712,36024,35952,36384,36648,36576,36336,51984,50472,
     9  25440,48936,47424,45888,45144,42864,24312,24408,24600,24648/
            data (jx(i),i=  501,  600)/
     +  24744,24792,24792,24840,24864,24936,25008,24960,25008,25080,
     1  25176,25176,25200,25344,25344,18336,18480,25440,25512,25536,
     2  25632,25704,25704,25920,25992,26136,26040,26160,26280,26424,
     3  26472,26496,26448,26520,26520,26640,26664,26760,26880,26976,
     4  27072,27168,27096,27240,27168,27264,27384,27360,27408,27456,
     5  27480,27432,27528,27552,27624,27768,27888,28056,27984,28080,
     6  28176,28080,28128,28320,28368,28512,28584,28704,28680,28776,
     7  28896,28968,29088,29160,29232,29208,29328,29376,29544,29592,
     8  29568,29760,29904,30240,30432,30528,30600,30720,13008,13056,
     9  13488,13704,13968,14016,14064,14184,14280,51840,50520,48792/
            data (jx(i),i=  601,  700)/
     +  47496,45216,44232,42912,30768,30864,31032,31368,31464,31584,
     1  31680,31752,31896,31992,32040,32136,32160,32304,32376,32592,
     2  32712,32880,32976,33072,33120,33096,33192,33144,33240,33624,
     3  33840,33744,33840,33912,34080,34200,34272,34248,34368,34368,
     4  34464,34512,34608,34608,35184,39888,39864,39792,40440,18648,
     5  18672,18504,30792,30816,30696,40464,40656,44304,38136,38064,
     6  37872,37848,37776,37704,37512,36840,36696,48888,47328,44496,
     7  44568,52704,51936,50424,50400,38232,38640,38760,39240,39336,
     8  39432,39480,40152,40512,40968,41136,41400,41712,18744,18576,
     9  30888,30792,44424,44328,44304,44376,44304,44304,44424,44328/
            data (jx(i),i=  701,  710)/
     +  44304,44256,44328,44280,44160,44112,44016,14280,14328,    0/
            data (jy(i),i=    1,  100)/
     +  49128,48864,48768,48744,48720,48816,43632,43344,40560,37704,
     1  36744,33936,33696,31416,30648,28104,27552,23928,22920,23544,
     2  23280,23088,22968,22944,21792,21528,21312,20448,49368,43968,
     3  44088,44304,44328,44712,45264,46008,46248,46440,46608,46920,
     4  47160,47568,47880,48192,48936,49752,43392,41448,41448,27600,
     5  23952,24024,24312,24504,25104,25152,25104,25176,25152,25248,
     6  25344,25416,25584,25728,25752,25776,25824,26616,26736,26952,
     7  27048,27360,27480,21840,21648,21624,21672,21840,21672,21696,
     8  21864,21864,21744,21768,21672,21480,21384,21600,21792,22032,
     9  22200,22296,22368,22464,20976,20904,20928,21096,21528,21720/
            data (jy(i),i=  101,  200)/
     +  21816,21816,21576,21552,21576,21792,21768,21744,21504,21552,
     1  21264,21096,21024,21000,20856,20664,20640,20640,20760,20760,
     2  20664,20256,20184,20208,20160,20064,19704,19200,18864,18816,
     3  18984,18960,18624,18696,18744,18888,18912,18984,19056,19296,
     4  19344,19464,19512,19776,19776,19944,20088,20184,20184,20256,
     5  20304,20376,20496,20496,20592,20688,20832,20976,21024,21120,
     6  21384,21456,21720,21648,21840,21864,22056,22224,22296,22464,
     7  22584,22560,22824,23040,23280,23400,23520,23520,23760,44976,
     8  45768,46296,46368,46296,46440,46752,46968,47520,47736,48096,
     9  48240,48552,48576,48480,48672,45744,45744,45528,45504,45768/
            data (jy(i),i=  201,  300)/
     +  45696,45672,44856,44688,45072,45048,45120,45384,45480,45648,
     1  43512,43272,43248,42960,42720,43056,43296,43464,43776,43920,
     2  44400,42672,42648,42648,42648,42648,40464,42000,41952,41928,
     3  41880,41952,41400,41088,40752,40680,40776,40584,40416,39936,
     4  39672,39624,39600,39600,39576,38952,38856,38472,40680,40728,
     5  41064,41064,44112,44112,38568,38736,38928,39096,39120,39096,
     6  38544,38472,38520,38904,39336,33360,33360,34896,34896,37944,
     7  37944,38496,38328,38376,38232,38328,38448,38448,38568,38544,
     8  38616,38712,38616,38688,38568,38592,38496,38520,38640,38640,
     9  38520,38328,38208,38040,37968,38016,37896,37968,37920,37944/
            data (jy(i),i=  301,  400)/
     +  37872,37800,37680,37704,37560,37584,37416,37272,37176,37080,
     1  37056,36960,37032,36984,37080,37128,37008,37056,36984,36984,
     2  36720,36768,36744,36600,36672,36624,36696,36720,36648,36504,
     3  37776,37728,37872,37752,37800,37752,37920,37824,37608,41424,
     4  37296,37296,39576,36672,36624,36600,36600,36600,38376,38328,
     5  38160,37824,37128,36888,36696,36648,36576,36552,36552,37296,
     6  41184,33696,34728,34776,36432,36288,36240,36048,36000,35904,
     7  36000,35856,35832,36072,36048,35928,35448,35328,35328,35184,
     8  34920,34608,34200,33960,33912,33696,33720,33576,33528,33384,
     9  36432,36144,35856,35784,35712,35832,35832,35688,34944,34824/
            data (jy(i),i=  401,  500)/
     +  34608,34608,34464,34080,34080,34008,33792,33576,33456,32016,
     1  33648,36552,33432,36552,36552,33600,33576,33528,33480,33456,
     2  32880,32808,32928,32616,32592,32760,32952,33144,33216,33360,
     3  33552,33480,33240,33456,33456,33600,33408,33096,32664,32448,
     4  32256,32136,31848,31680,31296,31128,31824,31824,29472,29544,
     5  29304,29400,29328,29400,29376,29520,29520,32016,30432,30432,
     6  29304,30960,30432,30456,30240,30144,29952,29880,29760,29496,
     7  31200,31152,31152,27336,27552,27960,28368,28584,28704,28656,
     8  28776,28968,29160,29736,30024,30456,30624,30792,30576,30528,
     9  30504,30504,30480,30456,30456,30432,26544,30096,30240,30168/
            data (jy(i),i=  501,  600)/
     +  30264,30216,30312,30384,30288,30288,30408,30432,30480,30504,
     1  30456,30384,30528,30552,30480,29352,29520,30456,30528,30648,
     2  30552,30576,30480,30552,30384,30384,30288,30192,30384,30216,
     3  30216,30144,30144,30096,30000,30096,29928,29952,29736,29808,
     4  29784,29616,29592,29472,29424,29424,29472,29544,29496,29520,
     5  29496,29400,29280,29376,29304,29400,29280,29448,29496,29616,
     6  29568,29520,29496,29592,29712,29760,29640,29640,29520,29496,
     7  29544,29424,29496,29400,29472,29352,29352,29424,29304,29352,
     8  29472,29400,29472,29328,29088,29208,29184,29232,27744,28872,
     9  28944,29424,29352,29256,29352,29280,29352,27504,27456,27432/
            data (jy(i),i=  601,  700)/
     +  27384,27360,27360,27336,29256,28992,29184,29136,29016,29064,
     1  28968,29040,29040,29160,29112,29160,29064,29064,28968,29064,
     2  28968,29064,28896,28848,28896,29016,28992,29088,28992,29208,
     3  29160,29376,29496,29256,29352,29592,29544,29328,29352,29616,
     4  29640,29424,29448,27336,27336,27336,30384,30384,27312,26712,
     5  27480,27480,26400,27168,27168,26208,26208,24696,25968,26136,
     6  26328,26424,26424,26640,26856,26976,27120,24528,24504,24432,
     7  24576,23856,23832,23808,24552,25656,25272,25176,25080,24960,
     8  24792,24336,24144,23688,23520,23592,23520,23160,24432,24432,
     9  24120,24120,24192,24048,23808,23256,23160,22992,22752,22392/
            data (jy(i),i=  701,  710)/
     +  22200,22152,22008,21840,21768,21648,21648,47520,47496,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    1,    2,    7,   30,   31,   32,   33,   34,   35,
     1     36,   37,   38,   39,   40,   41,   42,   43,   44,    6,
     2      4,    3,    4,    8,   29,    9,    7,   10,   48,    8,
     3     10,    9,   11,   12,   14,   13,   15,   17,   20,   16,
     4     18,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     5     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     6     71,   72,   17,   20,   21,   22,   23,   19,   25,   74,
     7     75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
     8     85,   86,   27,   26,   88,   89,   90,   91,   92,   93,
     9     19,   26,   95,   96,   97,   98,   99,  100,  101,  102/
            data (jb1(i),i=  101,  200)/
     +    103,  104,  105,  106,  107,  108,  109,   25,   27,  111,
     1    112,  113,  114,  115,  116,  117,  118,  119,  120,   28,
     2     28,  122,  123,  124,  125,  126,  127,  128,  129,  130,
     3    131,  132,  133,  134,  135,  136,  137,  138,  139,  140,
     4    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     5    151,  152,  153,  154,  155,  156,  157,  158,  159,  160,
     6    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     7    171,  172,  173,  174,  175,  176,  177,  178,   18,  180,
     8    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     9    191,  192,  193,  194,  195,  181,  196,  196,  198,  199/
            data (jb1(i),i=  201,  300)/
     +    200,  201,  202,  197,  198,  180,  204,  205,  206,  207,
     1    208,  209,  181,  203,    7,  211,  212,  198,    8,  215,
     2    216,  217,  218,  219,  220,  204,  215,  197,  222,  202,
     3    223,  201,  224,  225,  227,  228,  213,  229,  230,  225,
     4    227,  215,  232,  233,  234,  235,  236,  237,  238,  239,
     5    240,  241,  223,  242,  243,  226,  244,  227,  246,  230,
     6    248,  249,  250,  251,  252,  253,  203,  255,  256,  257,
     7    258,  259,  260,  261,  262,  263,  264,  241,  266,  267,
     8    268,  269,  270,  248,  248,  272,  273,  274,  275,  276,
     9    277,  278,  279,  280,  281,  282,  283,  284,  285,  286/
            data (jb1(i),i=  301,  400)/
     +    287,  288,  289,  290,  255,  248,  292,  293,  294,  295,
     1    296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
     2    306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
     3    316,  317,  318,  319,  320,  321,  322,  323,  324,  325,
     4    326,  327,  328,  329,   10,  331,  332,  333,  334,  335,
     5    336,  337,  338,  339,  231,  342,  245,  341,   11,  246,
     6    344,  346,  347,  255,  349,  350,  351,  352,  353,  354,
     7    355,  348,  345,  247,  242,  346,  357,  341,  359,  330,
     8    362,  363,  338,  330,  365,  366,  367,  368,  369,  370,
     9    371,  372,  373,  374,  375,  376,  377,  378,  379,  380/
            data (jb1(i),i=  401,  500)/
     +    381,  382,  383,  384,  385,  386,  387,  388,  389,  362,
     1    348,  391,  392,  393,  394,  395,  396,  397,  398,  399,
     2    400,  401,  402,  403,  404,  405,  406,  407,  408,  330,
     3    411,  358,  413,  414,  244,  362,   13,  416,  345,  417,
     4    418,  359,  419,  409,  421,  422,  423,  424,  425,  426,
     5    427,  428,  429,  430,  411,  409,  432,  420,  342,  434,
     6    413,  411,  436,  413,  266,  437,  438,  439,  440,  441,
     7    442,  443,  444,  445,  447,  266,  410,  449,  450,  451,
     8    452,  453,  454,  455,  456,  457,  410,  433,  459,  460,
     9     14,  462,  463,  464,  465,  466,  467,  468,  469,  420/
            data (jb1(i),i=  501,  600)/
     +    435,  471,  472,  446,  474,  475,  476,  477,  478,  479,
     1    480,  481,  482,  483,  484,  485,  486,  487,  446,   15,
     2    416,  489,  447,  490,  418,  492,  493,  419,  494,  495,
     3    471,  497,  498,  499,  500,  501,  502,  503,  504,  505,
     4    506,  507,  508,  509,  510,  511,  512,  513,  514,  491,
     5    470,  516,  449,  491,  518,  519,  520,  521,  522,  523,
     6    524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
     7    534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
     8    544,  545,  546,  547,  548,  549,  550,  551,  552,  553,
     9    554,  555,  556,  557,  558,  559,  560,  561,  562,  563/
            data (jb1(i),i=  601,  700)/
     +    564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
     1    574,  575,  576,  577,  578,  579,  580,  581,  582,  461,
     2    461,  584,  585,  586,  587,  589,  589,  590,  591,  592,
     3    593,  594,  595,  596,  470,  598,  598,  490,  599,  600,
     4    493,  601,  495,  602,  496,  603,  588,  605,  606,  607,
     5    608,  609,  610,  611,  612,  613,  614,  615,  616,  617,
     6    618,  619,  620,  621,  622,  623,  624,  625,  626,  627,
     7    628,  629,  630,  631,  632,  633,  634,  635,  636,  637,
     8    638,  639,  640,  641,  642,  643,  644,  646,  647,  473,
     9    474,  474,  604,  646,  650,  651,  449,  497,  653,  654/
            data (jb1(i),i=  701,  780)/
     +    588,  497,  649,  656,  657,  659,  660,  661,  662,  663,
     1    664,  665,  666,  474,  603,  600,  668,  669,  670,  658,
     2    672,  672,  598,  673,  674,  668,  659,  676,  677,  678,
     3    679,  680,  681,  682,  683,  684,  685,  686,  687,  688,
     4    589,   21,  689,  650,  497,   23,  691,  653,  645,  669,
     5    670,  693,  694,  695,  696,  697,  698,  699,  700,  701,
     6    702,  703,  704,  705,  706,  707,  674,  672,  214,  708,
     7     29,  214,  180,  340,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     29,    2,    3,   30,   31,   32,   33,   34,   35,   36,
     1     37,   38,   39,   40,   41,   42,   43,   44,   45,   45,
     2      6,    5,    5,   46,   46,   47,   47,   48,   49,   49,
     3     12,   11,   13,   14,   16,   15,   50,   50,   51,   51,
     4     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     5     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     6     72,   73,   73,   21,   22,   23,   24,   24,   74,   75,
     7     76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
     8     86,   87,   87,   88,   89,   90,   91,   92,   93,   94,
     9     94,   95,   96,   97,   98,   99,  100,  101,  102,  103/
            data (jb2(i),i=  101,  200)/
     +    104,  105,  106,  107,  108,  109,  110,  110,  111,  112,
     1    113,  114,  115,  116,  117,  118,  119,  120,  121,  121,
     2    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     3    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     4    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  179,    1,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,    2,  196,    3,  197,  199,  200/
            data (jb2(i),i=  201,  300)/
     +    201,    4,    5,  202,    6,  203,  205,  206,  207,  208,
     1    209,  210,  210,  204,  211,  212,  213,  213,  214,  216,
     2    217,  218,  219,  220,  221,  221,  222,  222,  223,  224,
     3    224,  225,  226,  226,  228,  229,  229,  230,  231,  231,
     4      9,  232,  233,  234,  235,  236,  237,  238,  239,  240,
     5    241,  242,  243,  243,  244,  245,  245,  246,  247,  247,
     6    249,  250,  251,  252,  253,  254,  254,  256,  257,  258,
     7    259,  260,  261,  262,  263,  264,  265,  265,  267,  268,
     8    269,  270,  271,  271,  272,  273,  274,  275,  276,  277,
     9    278,  279,  280,  281,  282,  283,  284,  285,  286,  287/
            data (jb2(i),i=  301,  400)/
     +    288,  289,  290,  291,  291,  292,  293,  294,  295,  296,
     1    297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
     2    307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
     3    317,  318,  319,  320,  321,  322,  323,  324,  325,  326,
     4    327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
     5    337,  338,  339,  340,  341,  343,  343,  342,  344,  344,
     6    345,  347,  348,  349,  350,  351,  352,  353,  354,  355,
     7    356,  356,  357,  357,  358,  358,  359,  360,  360,  361,
     8    363,  364,  364,  365,  366,  367,  368,  369,  370,  371,
     9    372,  373,  374,  375,  376,  377,  378,  379,  380,  381/
            data (jb2(i),i=  401,  500)/
     +    382,  383,  384,  385,  386,  387,  388,  389,  390,  390,
     1    391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
     2    401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
     3    412,  412,  414,  415,  415,   12,  416,  417,  417,  418,
     4    419,  419,  420,  421,  422,  423,  424,  425,  426,  427,
     5    428,  429,  430,  431,  431,  432,  433,  434,  434,  435,
     6    435,  436,  437,  437,  433,  438,  439,  440,  441,  442,
     7    443,  444,  445,  446,  448,  448,  447,  450,  451,  452,
     8    453,  454,  455,  456,  457,  458,  458,  459,  460,  461,
     9    462,  463,  464,  465,  466,  467,  468,  469,  470,  471/
            data (jb2(i),i=  501,  600)/
     +    472,  473,  473,  472,  475,  476,  477,  478,  479,  480,
     1    481,  482,  483,  484,  485,  486,  487,  488,  488,  489,
     2    489,  490,  491,  492,  492,  493,  494,  494,  495,  496,
     3    496,  498,  499,  500,  501,  502,  503,  504,  505,  506,
     4    507,  508,  509,  510,  511,  512,  513,  514,  515,  515,
     5    516,  517,  517,  518,  519,  520,  521,  522,  523,  524,
     6    525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
     7    535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     8    545,  546,  547,  548,  549,  550,  551,  552,  553,  554,
     9    555,  556,  557,  558,  559,  560,  561,  562,  563,  564/
            data (jb2(i),i=  601,  700)/
     +    565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
     1    575,  576,  577,  578,  579,  580,  581,  582,  583,  583,
     2    584,  585,  586,  587,  588,   16,  590,  591,  592,  593,
     3    594,  595,  596,  597,  597,   17,  599,  599,  600,  601,
     4    601,  602,  602,  603,  604,  604,  605,  606,  607,  608,
     5    609,  610,  611,  612,  613,  614,  615,  616,  617,  618,
     6    619,  620,  621,  622,  623,  624,  625,  626,  627,  628,
     7    629,  630,  631,  632,  633,  634,  635,  636,  637,  638,
     8    639,  640,  641,  642,  643,  644,  645,  647,  648,  648,
     9    645,  646,  649,  649,  651,  652,  652,  650,  654,  655/
            data (jb2(i),i=  701,  780)/
     +    655,  653,  656,  657,  658,  660,  661,  662,  663,  664,
     1    665,  666,  667,  667,  658,  668,  669,  670,  671,  671,
     2     18,  673,  673,  674,  675,  675,  676,  677,  678,  679,
     3    680,  681,  682,  683,  684,  685,  686,  687,  688,   19,
     4     20,  689,  690,  690,   22,  691,  692,  692,   24,   25,
     5    693,  694,  695,  696,  697,  698,  699,  700,  701,  702,
     6    703,  704,  705,  706,  707,   26,   27,   28,  708,  709,
     7    709,  340,  361,  361,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine tn(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(2160) :: jx,jy
            integer(kind=iknd), save, dimension(2250) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'tennessee     '/
            data jrot,ipart/1,1/
            data kv/   1,2157,   0,   0,   0/
            data kb/   1,2251,   0,   0,   0/
            data iib/ 262,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  28272,27456,28392,28272,27936,28368,29304,28224,28152,28224,
     1  28368,28008,30744,29544,28296,31872,28392,29400,32232,29448,
     2  33120,34104,34800,36312,37776,38136,38856,39336,41304,43272,
     3  43368,43392,43416,43416,43464,43464,43464,43512,43560,43560,
     4  43560,43584,27480,27672,28272,28008,27864,29184,29472,28152,
     5  28104,28176,28368,28416,28128,28224,28200,28128,30408,30288,
     6  29976,29808,29928,30024,30000,29952,29856,29352,29112,28848,
     7  28752,28152,27792,27648,27408,29352,29616,29736,29616,29328,
     8  29304,29592,29736,29856,30360,30624,30816,30744,30816,30888,
     9  31128,31368,31560,31608,31704,31608,31704,32136,32136,32304/
            data (jx(i),i=  101,  200)/
     +  32328,31944,31968,31848,32112,32112,32184,32112,32400,32592,
     1  33384,33648,33864,33744,33408,33192,33048,32928,32904,33528,
     2  33624,33816,34104,34200,34224,34008,34632,34272,34032,33768,
     3  33576,33096,33000,32856,32736,32592,34944,35016,34824,34824,
     4  34968,35184,35352,35544,35616,35736,35688,35760,36048,36096,
     5  36192,36216,36168,36432,36768,37032,37104,36960,37128,37320,
     6  37584,37680,37944,38088,36192,36168,35856,35784,35568,35592,
     7  35688,35664,35520,35088,35040,34800,34728,34248,34248,36528,
     8  36720,36888,36888,36816,36840,37008,37224,37368,37800,37800,
     9  37680,37800,37872,38232,38304,38496,38640,38856,41136,40728/
            data (jx(i),i=  201,  300)/
     +  40728,40896,40944,40896,40944,40848,40848,40608,40392,40224,
     1  39912,39696,39336,39120,38832,38640,38448,38040,37968,38088,
     2  38304,38376,38328,43344,43128,42840,42744,42792,42744,42672,
     3  42480,42168,41904,41856,42024,41880,41640,40848,40752,40728,
     4  40440,40320,40248,39960,39576,39264,39336,39624,39624,39528,
     5  39240,39000,38760,38688,38688,38808,39144,39288,39336,39432,
     6  43488,43368,28656,28776,29112,27576,27552,27792,27792,27936,
     7  28056,28272,28512,29136,30264,30264,29424,29160,29184,29040,
     8  28944,28848,28728,28776,28656,28680,28920,29136,30792,29472,
     9  29280,29328,29280,30264,29808,29448,29112,28104,28152,28080/
            data (jx(i),i=  301,  400)/
     +  28104,28632,28752,28800,28872,29280,29496,29520,28464,28440,
     1  29400,29472,29520,29568,29832,30000,30192,30720,31056,31560,
     2  31800,31872,31920,32016,29664,29688,29400,29592,29016,29016,
     3  28800,28656,28560,29280,29400,29664,29424,29496,29712,29640,
     4  29688,29544,28416,28728,28968,29616,29880,28344,28368,28416,
     5  28440,28512,29016,29112,29112,29232,29928,29928,29880,29856,
     6  29616,29568,29544,28824,30000,29856,29712,29568,29496,29352,
     7  29256,28968,28872,28464,28488,28344,28368,28512,28416,28536,
     8  30552,30528,30408,30336,29952,29400,31344,31344,31248,31200,
     9  30984,30672,30624,30552,30456,30336,30144,30240,30072,30000/
            data (jx(i),i=  401,  500)/
     +  29904,29808,29904,29928,30072,28584,28824,29856,29880,30000,
     1  30168,30432,30552,30696,30792,29712,30072,30192,29832,30024,
     2  30816,30360,29232,29208,29352,29544,29520,29448,29496,29904,
     3  30384,29376,29520,29520,29328,29280,29496,29760,29712,29856,
     4  29232,29736,30240,30408,30312,30432,30456,30552,30624,30672,
     5  30744,30984,31080,31200,31368,29808,29880,29832,29928,29880,
     6  30048,30000,30072,30144,30072,30120,30240,30288,30216,30216,
     7  30360,30360,30264,30360,30432,30336,30480,30336,30384,30288,
     8  30384,30336,30432,30648,30624,30696,30576,29904,30792,31008,
     9  30384,30600,30552,30504,30360,30096,29952,29880,29928,29784/
            data (jx(i),i=  501,  600)/
     +  29760,29880,29808,29904,29856,29928,32280,32184,32064,31872,
     1  31584,31416,31464,31248,31200,30744,30696,31464,31416,31512,
     2  31512,31728,31848,31872,31800,32064,32448,30096,30168,30240,
     3  30408,30624,30720,30984,32592,32400,32112,31800,31344,31320,
     4  31368,31248,31296,31248,30984,30912,30936,30888,30768,30720,
     5  30744,30648,30576,30504,30600,30408,30528,30792,30792,30672,
     6  30672,30600,30648,30816,31272,30888,30888,31056,31128,31056,
     7  30768,30000,29976,30840,30840,30936,30552,30600,30768,30864,
     8  30936,30600,30576,30936,30960,31176,31200,31104,31344,30480,
     9  30528,30672,31320,31560,31416,31416,31176,31008,31032,30960/
            data (jx(i),i=  601,  700)/
     +  30936,30528,30720,30672,30768,30816,30912,30936,31032,31320,
     1  31104,31080,31032,31080,31224,31104,31200,31176,30960,30984,
     2  31008,31128,31104,31176,31248,31248,30888,30888,30720,30528,
     3  30216,30384,30288,30072,31272,33744,32784,32688,32544,32400,
     4  32304,32232,32088,32064,31944,31920,31824,31680,31512,31488,
     5  31392,31296,31176,31248,31008,31176,31272,30936,30720,30720,
     6  30576,30696,30912,30864,30936,31080,31344,31392,31320,31128,
     7  31008,30960,31296,31224,31320,31296,31032,31056,30888,30648,
     8  30624,30456,30504,30168,30192,30096,30168,29928,29952,29736,
     9  29760,32112,31920,31416,31056,31272,31512,31824,31920,31944/
            data (jx(i),i=  701,  800)/
     +  31920,31824,31776,31488,30960,30960,30864,30840,31440,31536,
     1  31584,31560,31608,31104,31080,31224,31248,31416,31536,31656,
     2  31776,31824,31872,31992,31896,31992,32088,32112,32160,31728,
     3  31800,31920,31536,31776,31536,31368,31224,31224,31488,31584,
     4  31416,31344,31032,31152,31296,31344,31032,31944,31536,31296,
     5  30360,30336,30072,29832,29640,29616,29352,29304,29256,29208,
     6  29232,29136,28680,28656,32544,32472,32376,32328,32112,31992,
     7  31920,32016,31728,31848,31944,32160,32832,33048,32928,32880,
     8  33192,33264,29712,30264,30240,30384,30384,30264,30240,31968,
     9  31920,31968,32136,32184,32112,31512,31512,31656,31752,31896/
            data (jx(i),i=  801,  900)/
     +  31896,32088,31992,31992,32160,31992,31800,31824,32208,32880,
     1  32592,32400,32280,32280,32352,32376,32256,32280,32232,31728,
     2  31632,31896,31992,32208,32280,32160,32184,31896,31968,32280,
     3  29568,31512,31536,31632,31608,32064,32568,32064,32136,32232,
     4  32304,32400,32016,32472,32448,32256,32304,32496,32520,32496,
     5  32832,32904,31872,31968,31968,31104,31488,31656,31872,31896,
     6  31968,31944,32064,32736,32736,32256,31248,32664,32232,32088,
     7  32064,31896,31824,31800,31704,31704,31272,34872,34056,33504,
     8  33192,33216,33144,33240,32760,32784,32832,32760,32664,32664,
     9  32472,32640,32568,32568,32640,32640,32688,32088,32184,32208/
            data (jx(i),i=  901, 1000)/
     +  32400,32424,32544,32472,32520,32616,32928,32904,33120,32088,
     1  32232,32064,32088,31992,32208,32208,32328,32208,32256,32448,
     2  32448,32544,32448,32472,32448,32568,32640,32832,32856,32664,
     3  32616,32856,32952,33024,32736,32784,32640,32664,32520,32400,
     4  32808,32736,33336,31992,32016,31944,31920,31728,31656,31608,
     5  33240,33264,33360,33408,33336,33384,33120,33192,33144,33216,
     6  33072,33096,33264,33264,33072,33048,32976,33000,33432,33288,
     7  33240,32952,32904,33672,33480,33432,33576,33600,33768,33864,
     8  34104,34392,34488,33096,33264,33408,33528,33360,33504,33888,
     9  34008,33672,33672,33600,34512,34608,32904,33048,33240,33480/
            data (jx(i),i= 1001, 1100)/
     +  32640,32736,32952,33072,33480,33048,33024,33504,32184,32232,
     1  32496,32496,32592,32520,32760,32712,32760,32856,34584,34488,
     2  34416,34392,34008,33888,33864,33912,33624,33624,33504,33504,
     3  33792,33768,33336,33024,32136,31680,31512,31128,30840,33936,
     4  33744,33696,33600,33648,33432,33360,33624,33816,34176,34296,
     5  34056,33912,33840,34296,34152,34080,33960,34008,33696,33552,
     6  33240,32832,32592,32568,32304,33456,33384,34080,34200,35544,
     7  35472,35232,35160,35232,35064,34920,34464,34128,34008,34752,
     8  34272,34056,33336,34296,34296,33408,33168,33096,33144,32856,
     9  32856,34320,34344,34344,33720,33888,34128,34128,34440,34368/
            data (jx(i),i= 1101, 1200)/
     +  34320,34344,35664,35424,34800,34728,34752,34680,34488,34344,
     1  34224,33912,33720,33048,32640,32136,34440,34416,34512,34176,
     2  34152,33504,33480,34296,34416,34464,34584,34512,34296,34392,
     3  34368,34320,34488,34536,34536,34392,34416,34344,34488,34440,
     4  36048,34656,34512,34440,34560,34800,34848,34848,34680,34608,
     5  34440,34440,34320,34224,34104,34080,33552,33864,33888,33912,
     6  34032,34248,34368,34296,34560,34608,34872,34872,34896,35064,
     7  35040,35304,35280,35016,35088,34944,35040,34992,35088,35040,
     8  34320,34800,34896,35064,35136,34632,34680,34608,34632,34560,
     9  34656,34584,34464,34488,34920,35232,35352,35544,35448,35304/
            data (jx(i),i= 1201, 1300)/
     +  35280,35448,35256,35328,35448,35496,35448,35280,35232,35256,
     1  35352,35280,35280,35352,35352,35592,35592,35592,34752,34752,
     2  35640,35664,35328,34944,35688,35808,35880,36024,35856,35784,
     3  35688,35688,35664,35688,35592,35592,35520,35448,35520,34560,
     4  35688,35496,35304,34464,34656,34680,34632,34656,34872,35064,
     5  35712,35712,35568,35520,35520,35616,35544,35976,36072,35808,
     6  35880,35712,36336,36144,35832,35736,35736,35592,35328,35400,
     7  35304,35160,34920,34896,34728,34704,36936,36864,36792,36744,
     8  36672,36480,36432,36288,36264,36336,36240,36240,36336,35856,
     9  35664,35568,35616,35928,35928,35880,35928,35880,34224,34320/
            data (jx(i),i= 1301, 1400)/
     +  34368,34632,34968,35040,35304,35376,35448,35400,35544,35544,
     1  35616,35640,35976,36312,36288,35976,35736,35976,35928,36048,
     2  36072,35976,35760,34992,34944,35520,35592,35760,35880,35976,
     3  36024,36120,36024,36072,36264,36288,36192,36600,36648,36816,
     4  36888,36912,36984,37080,37152,37152,37296,35664,36096,36144,
     5  34416,34896,34920,35040,35016,35088,35184,35880,35856,35952,
     6  35952,36096,36120,36264,36144,36144,36000,35904,35760,36000,
     7  35784,35784,35856,35784,35904,35856,35928,36072,35928,35976,
     8  35928,36048,37296,37176,37176,36816,36600,36552,36624,36624,
     9  36696,36768,36624,36624,36408,36408,36216,36288,36192,36432/
            data (jx(i),i= 1401, 1500)/
     +  36792,36816,37032,37056,37224,37368,37392,36696,36696,36504,
     1  36480,36408,36312,36144,35760,35592,39528,39432,39216,39072,
     2  39024,38928,38640,37728,37200,36792,36336,36912,36816,36816,
     3  36456,36480,36408,36408,36144,36144,36000,36024,35280,35160,
     4  35064,34704,34656,34824,35040,35040,35304,35280,35352,35808,
     5  36048,36432,36936,35976,36168,36288,36360,36816,36960,36072,
     6  37104,37128,37032,36960,35808,36648,37152,37368,37824,37752,
     7  37608,37416,37440,37632,37656,37776,37680,37392,37296,37392,
     8  37416,37416,37368,37368,37440,37392,37488,37488,37320,37320,
     9  37056,36936,38040,37824,37752,37752,37608,37584,37488,37416/
            data (jx(i),i= 1501, 1600)/
     +  37272,37296,37176,37272,37200,37296,37272,37368,37320,37224,
     1  37200,37368,37728,37848,37536,37464,37488,37440,37488,37272,
     2  37344,37248,37128,37080,36984,36984,37056,37056,37152,37296,
     3  37296,37200,37056,37080,37008,37080,37128,37176,37176,37104,
     4  37128,37416,37416,37512,36168,36384,36576,36696,36936,37008,
     5  37128,37392,37584,37080,37032,36528,36744,36888,37008,36864,
     6  36792,36960,37464,37752,36984,37008,37128,37248,37248,37392,
     7  37392,37488,37464,37656,37728,37656,37632,37488,37464,37368,
     8  37320,37368,37368,37488,37512,37464,37632,36744,36888,36936,
     9  36960,37320,37584,35664,36024,36336,36336,36408,36936,36936/
            data (jx(i),i= 1601, 1700)/
     +  37752,37968,37584,37536,37392,37392,37680,37704,37776,37800,
     1  37752,37920,37968,38040,38160,38112,38136,38088,38016,38232,
     2  38376,38448,38520,38640,38496,38592,38616,38760,38808,36456,
     3  36696,38136,38472,38352,38376,38328,38232,37704,36864,36720,
     4  36408,36384,36312,36240,36144,36144,38496,38592,38448,38424,
     5  38328,38328,38160,38136,38040,38016,37800,37800,37728,37632,
     6  37584,37416,37416,38520,38688,38976,38784,38808,38352,38328,
     7  38112,37920,38112,38208,38256,38184,38232,38424,38544,38688,
     8  38784,38856,38976,39648,39648,39312,39312,39264,39096,38760,
     9  39120,38952,38928,38808,38808,38496,38544,38424,38328,38304/
            data (jx(i),i= 1701, 1800)/
     +  38256,38064,37632,39336,39384,39240,39240,39024,38856,38856,
     1  38784,38808,38400,38400,38232,38184,38064,38064,37752,37656,
     2  37416,39408,39408,38856,38208,39528,39312,39384,39336,39384,
     3  39312,39144,39504,39432,39480,39528,38232,38208,37944,39456,
     4  39216,39168,39072,39144,39072,38976,38952,38904,39168,39288,
     5  39216,39000,38976,39072,39264,37584,37584,37656,37656,37800,
     6  38304,38304,38352,38376,38544,39552,39552,38856,38952,38904,
     7  38808,38664,38496,37944,39576,37032,37920,38016,38088,38088,
     8  38160,38160,38232,38232,38400,38616,39048,39192,39264,39264,
     9  39312,39600,39624,39312,39456,39288,39288,39480,39504,39648/
            data (jx(i),i= 1801, 1900)/
     +  39696,39696,39600,39648,39504,39720,39768,39720,39672,39600,
     1  39456,39384,39096,39072,39480,39576,39480,39504,39456,39480,
     2  39432,39432,39600,39648,39768,39792,39648,39648,39576,39600,
     3  39240,39264,39336,39864,39672,39672,40680,40464,39960,39792,
     4  39888,39840,39816,39864,39744,39600,39648,39864,39816,39888,
     5  39576,37512,37512,37584,37632,37776,37776,37872,38808,38952,
     6  39000,39000,39312,39360,39528,39552,40056,40056,40176,40296,
     7  40608,37344,37752,37848,38328,38568,39000,39096,39192,39264,
     8  39264,39408,39456,39672,40080,40008,40080,40104,40296,40656,
     9  40584,40104,39144,39216,38376,38496,38592,38688,38832,38040/
            data (jx(i),i= 1901, 2000)/
     +  38040,38112,38088,38136,38160,39264,39264,39456,39888,39912,
     1  39984,40080,40128,40200,40056,40392,40296,40320,40248,40272,
     2  40392,40344,40296,40152,40248,40248,40104,40296,40536,40488,
     3  40560,40536,40656,40584,40608,40680,40680,40776,41088,41064,
     4  41016,40992,40920,40944,40824,40752,40752,40632,40632,40464,
     5  40392,40296,40248,40368,40392,39888,39912,40008,39984,40080,
     6  40080,40152,40176,40248,40320,38904,39144,39408,39504,39624,
     7  39648,39768,39864,40080,40224,40248,40464,39672,39840,40128,
     8  40128,40296,40320,40488,40512,40440,40344,40152,40128,41064,
     9  41136,41184,41328,41304,41208,39360,39912,39936,40224,40392/
            data (jx(i),i= 2001, 2100)/
     +  40512,41016,40800,40800,40488,40560,40560,40728,40728,40824,
     1  40824,40944,40944,41064,41064,41112,41136,41256,41280,41328,
     2  41664,41664,41832,41976,42120,42144,42240,42312,41064,40776,
     3  40632,40632,40536,40584,40656,40656,40584,40584,40344,40344,
     4  40248,40224,40032,39696,41088,40320,39816,39864,39912,39840,
     5  39864,39984,40248,40488,40824,40992,40992,41088,40464,40536,
     6  40632,40584,40608,41088,41160,41376,41208,41376,41448,41208,
     7  40728,40752,40584,40632,42048,40560,40872,40920,41328,41544,
     8  41592,41736,41856,42360,42288,42120,42360,42336,41976,41304,
     9  41304,41376,41304,41088,41088,40896,40776,40560,40752,40680/
            data (jx(i),i= 2101, 2160)/
     +  40656,40392,40224,40032,41160,41208,41712,42504,42552,40512,
     1  40512,40728,40728,43152,43176,42168,42168,41952,40728,40920,
     2  40992,41280,41472,41736,41760,41856,41976,41976,42144,42432,
     3  42600,42648,42936,43032,43200,42456,42360,42384,42264,42264,
     4  41976,41952,41376,41376,40848,40848,40752,40752,39936,43296,
     5  43032,43032,42960,42744,42600,42408,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  45096,70967,48792,27360,65111,41280,14568,38136,58656,31320,
     1  54600,63455,70343,24264,35448,68231,52728,18432,12312,20808,
     2  65423,63215,12168,60576,57528,10080,55320, 8976,52848,11952,
     3  15384,24648,18528,49200,21624,27528,47664,30480,40800,43848,
     4  37392,33432,70247,70175,25800,25824,24168,24432,24360,60264,
     5  60120,57120,57000,43368,35856,35616,35568,35256,70535,70703,
     6  71015,71327,71423,71663,71975,71999,71879,71735,71879,71903,
     7  72023,71903,72095,72095,72311,14016,13824,13584,13464,13512,
     8  13104,13248,13176,13008,13248,13248,13104,12600,12504,12480,
     9  12600,13032,13032,12984,12528,11928,11832,69671,69503,69311/
            data (jy(i),i=  101,  200)/
     +  68975,68759,68519,68327,68039,67943,67871,67679,67055,66863,
     1  66431,66143,65759,65375,65351,65471,65303,65207,65111,64127,
     2  64079,64103,63911,63935,63791,63503,12072,11664,11616,11736,
     3  11928,12024,12144,12528,12624,12648,12168,12024,11640,11376,
     4  11232,11256,11688,11760,11712,11472,11184,11064,10944,10872,
     5  10608,10272,10104, 9744, 9792, 9960,10200,10440,10536,10464,
     6   9840, 9744, 9816,10056,60720,61128,61272,61584,61920,62256,
     7  62520,62615,62759,62999,63095,63071,63239,63047,63191,60576,
     8  60336,60264,60192,60072,59928,59808,59544,59136,58776,58152,
     9  57960,57696,56736,56328,55920,55776,55728,55392,52872,53328/
            data (jy(i),i=  201,  300)/
     +  53472,53544,53640,53928,54096,54168,54336,54720,54888,54768,
     1  54768,54960,54864, 9336, 9312, 9096, 9024, 9120, 9480, 9624,
     2   9744, 9912, 9984,52680, 6864, 6912, 7008, 7512, 7704, 7800,
     3   7872, 7848, 8040, 8184, 8520, 8736, 8760, 8544, 8400, 8160,
     4   8040, 8136, 8520, 8496, 8736, 8400, 8256, 8280, 8040, 7968,
     5   8064, 8352, 8472, 8616, 8736, 8832, 8808, 8856, 8808, 8856,
     6  23016,22992,45096,45192,45048,70823,70679,70559,70415,70223,
     7  70223,69983,69839,49200,46320,46440,46536,46704,46824,46848,
     8  46800,47040,47112,47208,47448,47976,48552,48816,27720,66719,
     9  66575,66479,66431,46200,46104,45720,45168,65183,65111,65087/
            data (jy(i),i=  301,  400)/
     +  65039,65135,64967,65015,64991,64487,64631,41088,41208,41280,
     1  64775,65183,65231,14616,14424,14376,14424,14088,14112,13896,
     2  13776,13680,13464,13464,67511,67607,67895,68351,68975,69167,
     3  69335,69743,69743,37992,38064,37944,66791,66935,66887,67007,
     4  64487,64679,58968,59208,59304,59472,59328,31296,31224,31272,
     5  31200,31272,31128,31200,31248,31296,31224,55440,55464,55320,
     6  55224,55248,55176,54864,60144,60576,60792,60696,60720,61008,
     7  60960,61272,61272,61896,61992,62160,62256,62328,62496,62568,
     8  49464,49536,49584,49776,49512,49344,54696,54768,54792,54912,
     9  54960,54960,55032,54984,55104,55056,55080,55320,55464,55392/
            data (jy(i),i=  401,  500)/
     +  59328,59592,59688,59856,59976,69815,70103,69359,69479,69503,
     1  69791,69959,69983,70175,70199,38256,38448,39864,24288,24216,
     2  24744,41016,44928,44664,44280,44328,44184,44088,43872,43584,
     3  43488,41400,41544,41832,41664,41904,41952,42864,42960,42984,
     4  34920,34848,34512,34512,34080,61008,61104,61080,61176,61128,
     5  61176,61392,61536,61536,61680,59112,59136,59040,59040,58944,
     6  58872,58800,58872,58848,58824,58800,58872,58752,58656,58536,
     7  58560,58488,58440,58320,58368,58272,58248,58128,58056,58032,
     8  57984,57816,57792,57504,57360,57312,57240,67535,67295,67271,
     9  57048,56904,56664,56592,56664,56496,56256,56280,56184,56232/
            data (jy(i),i=  501,  600)/
     +  56184,55968,55776,55584,55536,55536,56808,56952,56856,57048,
     1  57096,57072,57000,57000,57120,57192,57144,50160,50304,50352,
     2  50448,50496,50448,50544,50616,51240,51480,60192,60096,60216,
     3  60288,60288,60216,60384,47976,48000,47904,48120,48192,48264,
     4  48432,48576,48648,48792,48840,48936,49008,49200,49152,49152,
     5  49272,49224,49296,49296,49416,31824,32112,32280,32376,32448,
     6  32616,32640,32808,23928,23904,24816,25080,25392,25992,26400,
     7  26928,37896,37680,37656,37584,37560,33936,33816,33744,33792,
     8  33456,32976,32856,37992,38136,38256,38328,38352,38640,39840,
     9  39552,39288,38712,68159,68015,67871,67919,67703,67559,67535/
            data (jy(i),i=  601,  700)/
     +  67439,60912,60960,60768,60816,60720,60696,60480,60552,54600,
     1  54576,54504,27768,28272,60168,60096,60000,59976,59880,59784,
     2  60288,60288,60192,54504,54456,30000,30048,30192,30264,30480,
     3  30936,30936,31032,31008,54456,30792,30936,30888,31032,30888,
     4  30864,30768,30840,30936,30912,30720,30768,30984,30960,31080,
     5  30984,30576,30408,30312,37464,37440,37080,37200,37128,37224,
     6  37080,37032,37104,36984,37944,37848,37848,37728,37656,37752,
     7  37728,37680,29760,29760,43512,61848,62088,62232,62424,62544,
     8  62615,62735,62951,63311,63383,63455,63671,63935,64103,64295,
     9  64391,55224,55032,23952,34296,34632,34848,34920,35088,35232/
            data (jy(i),i=  701,  800)/
     +  41328,41256,41016,40872,40920,40992,40992,40944,54336,54336,
     1  54312,54216,54216,59736,59592,59568,59400,59208,59136,59184,
     2  59112,59160,59088,59160,59040,58944,58992,58848,58848,54264,
     3  54096,25032,25056,35424,35496,35472,35568,35616,35688,35784,
     4  35856,35952,36456,36552,36576,36744,36816,51984,51936,52296,
     5  52248,52368,52128,52152,52056,52152,52200,52152,52224,52224,
     6  52560,52752,52824,52728,27912,27720,27720,27192,26904,26640,
     7  26184,25848,24000,23880,23904,23616,23232,23040,35544,35784,
     8  35712,35856,18576,18552,18288,18072,17952,17712,17544,17400,
     9  61200,61080,15936,58584,58824,43512,43440,43392,43272,43272/
            data (jy(i),i=  801,  900)/
     +  43176,42960,42888,42816,42576,41616,41376,41304,17376,60600,
     1  60432,60144,59544,59424,59496,59448,59376,58896,13440,53976,
     2  53064,53088,53016,53064,52992,52848,52800,52560,52344,55392,
     3  65039,65015,64967,64967,65015,65015,65447,51840,51840,51768,
     4  51768,51672,60936,61032,60864,60696,60648,60696,60672,60504,
     5  60672,60672,28200,28128,28176,67175,67007,66791,66719,66623,
     6  66623,66215,65903,20640,46368,46632,46320,45720,44784,44784,
     7  44520,44088,44088,43968,43992,43872,43776,49728,49416,48864,
     8  48744,48696,48648,48552,48240,46488,46656,46752,46776,46920,
     9  47040,47280,47352,47496,47568,47736,47784,41352,41208,41280/
            data (jy(i),i=  901, 1000)/
     +  41304,41232,41232,41304,41352,41208,41184,60480,60552,58440,
     1  58368,58272,58128,58056,58080,57960,57936,57888,57840,57840,
     2  57744,57768,57696,57600,57528,57528,57624,57624,57456,57432,
     3  57264,57312,57408,57336,57168,57096,57120,57048,56904,56904,
     4  23040,65567,39336,38856,38808,38784,38832,38784,38808,38736,
     5  60552,60456,60432,39624,39768,39840,40008,40176,40296,40416,
     6  40368,40512,40632,40776,40824,40920,40968,41112,57312,57312,
     7  57144,57000,57120,35760,35736,35592,35616,35496,35472,35496,
     8  35136,35160,35040,41256,41472,41424,41520,41808,42072,42240,
     9  42432,60456,60360,60312,60216,60120,18336,18864,19056,19416/
            data (jy(i),i= 1001, 1100)/
     +  51408,51576,51648,51960,52248,20640,19704,19704,61032,61080,
     1  61392,61488,61464,61608,61824,61872,61968,61968,38592,37560,
     2  37584,37392,36888,36912,36816,36792,36312,36240,36192,36144,
     3  31776,31872,31896,32208,32304,32448,32616,32784,32856,42672,
     4  42720,42864,42864,43008,43080,43440,44472,44952,44952,45288,
     5  15648,15576,15864,53184,53256,53376,53400,53736,54264,54384,
     6  54120,54552,54696,54816,54984,57432,57432,58464,58536,42264,
     7  42216,42504,42432,42240,42432,42336,42288,42504,52440,52824,
     8  28128,28032,28080,58584,45360,45456,45408,45480,46128,46296,
     9  46392,58656,31872,31944,32712,33792,34200,34368,34848,53136/
            data (jy(i),i= 1101, 1200)/
     +  53088,53016,24888,25080,25176,25080,24672,24528,24432,24456,
     1  24624,24624,24744,25224,25272,25008,58896,58920,39624,39552,
     2  39480,39336,39288,30696,30720,30600,30624,29904,28608,28608,
     3  28488,28488,39072,39024,38592,59112,59112,59448,59496,59736,
     4  19224,52968,52848,52872,53064,52824,52824,52728,49944,50184,
     5  50280,50664,50664,50856,51120,51480,57288,57408,57480,57432,
     6  57480,57240,57264,57192,56880,56664,56448,52896,52728,52728,
     7  52776,56016,55752,55272,55080,54912,54816,52608,54744,54696,
     8  15576,15168,15000,14928,14448,12264,12456,12600,12744,12840,
     9  13200,13320,13344,13968,14376,54840,54792,53808,53856,53784/
            data (jy(i),i= 1201, 1300)/
     +  53904,54000,54288,54360,54384,54456,54504,54504,54552,54672,
     1  54720,22968,22920,22920,22968,22944,23280,30552,30648,30624,
     2  53832,48984,49368,49608,25248,25344,25560,25728,25800,25992,
     3  25992,26760,53616,40656,40608,40536,40608,40584,40560,39720,
     4  14328,14352,14472,28152,27936,27864,27720,27552,27336,26832,
     5  42144,42360,42480,42432,41256,41616,41616,53592,53664,42240,
     6  42504,53784,60456,60360,60408,60408,60336,60312,60360,60456,
     7  60504,60336,60264,60144,60120,60048,33816,33600,33600,33336,
     8  33288,32712,32664,32736,32616,32592,32568,32472,32448,23256,
     9  24000,24192,24336,24408,24480,24504,24624,24840,15744,15984/
            data (jy(i),i= 1301, 1400)/
     +  16008,16080,16056,16152,16224,16560,16584,16872,16896,16968,
     1  16968,17352,17664,49440,49224,49320,48936,42624,42720,42768,
     2  20016,20064,20280,52440,52392,52296,52080,52008,52056,51960,
     3  52032,51960,51816,51720,51672,51600,51528,51168,51024,50976,
     4  50904,50976,50976,50784,50784,50592,50520,48864,48240,48048,
     5  45288,45480,45720,45720,45624,45576,45600,45504,45456,45456,
     6  45360,45288,45480,45408,45360,45264,45264,45216,45288,44592,
     7  43920,43800,43800,43728,43536,43392,43344,43392,42960,42864,
     8  42792,42816,50256,50232,50160,50208,50160,50040,50040,49968,
     9  49968,49824,49800,49632,49632,49512,46536,46728,47016,47136/
            data (jy(i),i= 1401, 1500)/
     +  30408,30288,30216,29928,29760,29736,29616,57504,57384,57336,
     1  57168,57192,57072,57048,56856,56856,24456,24312,24264,24384,
     2  24600,24720,24768,24336,24480,24336,24720,34560,34584,34464,
     3  34488,34584,34584,34728,34752,35088,35112,35040,35112,35088,
     4  34992,35088,35016,38568,38640,38592,38544,38472,38448,38424,
     5  38328,38376,38112,14520,14880,14976,15456,16104,16488,17808,
     6  16872,34920,34656,34656,40416,39888,39840,39912,27168,27504,
     7  27456,27744,27864,28008,28344,28680,29016,29448,50568,50592,
     8  50640,50712,50712,50904,50952,39504,39384,39144,38904,38688,
     9  38376,38280,10176,10296,10272,10464,10584,10752,10728,10872/
            data (jy(i),i= 1501, 1600)/
     +  10968,11088,11280,11376,11448,11472,11688,11976,12048,12048,
     1  12264,12384,13032,13128,53520,53496,53280,53232,53040,53040,
     2  52992,52704,52752,52536,52536,52464,52464,52224,52272,52056,
     3  51936,51864,51864,51744,51744,51480,51480,51240,51192,51192,
     4  51096,51072,51168,51120,53736,53616,53616,53712,53784,53928,
     5  53928,53784,37920,37920,38064,49536,49440,49464,49296,49248,
     6  49176,49056,49008,49056,34944,35640,35928,35928,36000,36048,
     7  36216,36192,36624,36624,36744,36792,36936,36936,37104,37080,
     8  37176,37248,37464,37488,37584,37632,37848,26640,26784,26784,
     9  26592,26544,26952,13992,13776,13704,13800,13776,13584,13488/
            data (jy(i),i= 1601, 1700)/
     +  13440,19920,19944,19992,19992,19944,53664,53832,53832,53976,
     1  54120,54168,54312,54264,54336,54456,54672,54864,54984,55032,
     2  54912,54960,55056,55104,55176,55320,55464,55272,55272,45288,
     3  45336,44160,43152,43320,43392,43896,43920,42864,42768,42816,
     4  42840,42696,42768,42744,42768,42720,42816,40728,40680,40512,
     5  40512,40416,40248,40176,40200,40104,40152,40104,40104,39984,
     6  40008,39936,39864,42096,41184,26712,26784,26928,26952,27120,
     7  27240,48816,48936,48912,48864,48456,48336,48288,48432,48480,
     8  48408,48168,48120,37824,37896,37920,37992,37992,37944,37968,
     9  46368,46512,46416,46368,46272,46416,46488,46584,46584,46656/
            data (jy(i),i= 1701, 1800)/
     +  46536,46560,46992,16368,29952,29952,30024,30096,30024,30120,
     1  30120,30048,30000,29760,29784,29616,29616,29520,29496,29616,
     2  29664,18168,18360,19416,19896,47256,46896,46848,46728,46632,
     3  46560,46560,30432,30456,30624,13344,13440,13368,13296,24480,
     4  24744,25344,25608,25656,25968,25992,26064,26544,48120,47976,
     5  47736,47616,47568,47496,47544,23160,23088,23088,23160,23136,
     6  22872,22944,22944,22824,22728,22704,21816,21816,21408,21408,
     7  21000,20736,20568,20280,22704,33624,33528,33408,33384,33504,
     8  33480,33432,33456,33408,33408,33336,32976,32760,32808,32640,
     9  32520,32496,15576,15576,30960,31128,31272,31704,31944,32040/
            data (jy(i),i= 1801, 1900)/
     +  32184,32280,32280,32472,12768,12144,27816,27816,27648,27576,
     1  27576,27264,27264,26976, 9120,11040,11040,11400,11376,11544,
     2  11568,11616,11616,12072,12024,28248,28296,28536,28536,28752,
     3  28776,29712,29688,21792,21864,21816,47832,47688,47544,47352,
     4  47280,47184,24384,24576,24768,24744,22944,23064,23328,23664,
     5  24072,51000,50880,50880,51000,50976,51120,51120,51576,51600,
     6  51552,51624,51672,51768,51768,51912,51912,51984,51984,51576,
     7  51288,50184,49968,49824,49584,49296,49080,48912,48864,48912,
     8  48816,48744,48792,48624,48480,48360,48336,48384,48288,48000,
     9  47880,45696,46128,46272,44088,44136,44304,44256,44328,34824/
            data (jy(i),i= 1901, 2000)/
     +  34752,34728,34872,34968,34824,34728,34800,34776,34968,35040,
     1  35016,35112,35256,35760,35400,37800,37896,38064,38064,38184,
     2  38304,38352,38304,38496,38496,38592,38616,39552,39792,39960,
     3  39984,40104,40128,40152,40224,40200,40296,40464,49680,49608,
     4  49632,49752,49680,49440,49344,49368,49536,49512,49320,49128,
     5  48936,48912,48696,27792,27792,37656,37848,37848,37680,37680,
     6  37800,37824,37944,37944,37776,43320,43272,43320,43512,43512,
     7  43704,43632,43680,43560,43392,43272,43176,37680,37560,37152,
     8  37056,37008,36696,36648,36552,36288,36192,36096,35928,52344,
     9  52320,52440,52392,52536,52584,40632,40656,40800,40704,40536/
            data (jy(i),i= 2001, 2100)/
     +  40560,49824,49968,51120,37944,37944,37896,37848,37776,37776,
     1  37728,37752,37680,37656,37608,37608,37680,37608,37464,37512,
     2  37488,37440,37512,37368,37392,37296,37440,37416,33504,33504,
     3  33408,33360,33360,33288,33264,33024,33024,32880,32904,32832,
     4  32856,32784,32736,32760,18576,18528,18168,21744,21744,20568,
     5  20184,19848,19464,19296,19152,19176,19104,19080,35232,34920,
     6  34872,34824,34632,34152,34152,40776,41160,41448,41808,42144,
     7  42048,42192,42432,42504,44496,43176,43704,43968,44352,44472,
     8  44424,44496,44448,37296,37200,37152,37056,37032,37008,36840,
     9  36720,36672,36600,36624,36528,36456,36288,35808,24672,24576/
            data (jy(i),i= 2101, 2160)/
     +  24432,24432,24528,24384,49608,49752,49728,49392,49488,21792,
     1  21696,21696,21744,27552,27720,27672,27720,27792,47856,47688,
     2  47736,47592,47448,47376,47424,47400,47328,47280,47256,47400,
     3  47400,47496,47472,47520,47784,30528,30552,30648,30648,30576,
     4  30672,30480,30600,30528,30552,30408,30408,30552,30552,44256,
     5  44352,44472,44544,44664,44712,44448,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      2,   43,    5,    4,   45,   46,   47,   48,   14,    5,
     1     12,   50,    9,    9,   52,   11,    4,    1,    1,    6,
     2      8,   55,   56,   15,   15,   10,    6,   11,    3,    7,
     3     18,   14,   13,   59,   60,   61,   62,   63,   64,   65,
     4     66,   67,   68,   69,   70,   71,   72,   73,   74,    2,
     5      7,   76,   77,   78,   79,   80,   81,   82,   83,   84,
     6     85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
     7     95,   96,   19,   13,   98,   99,  100,  101,  102,  103,
     8     16,   16,  105,  106,  107,  108,  109,  110,  111,  112,
     9    113,  114,  115,   21,   21,  117,  118,  119,  120,  121/
            data (jb1(i),i=  101,  200)/
     +    122,  123,  124,  125,   22,   23,  127,  128,  129,  130,
     1    131,  132,  133,  134,  135,   19,   23,  137,  138,  139,
     2    140,  141,  142,  143,  144,  145,  146,  147,  148,  149,
     3    150,  151,  152,  153,  154,  155,  156,  157,  158,  159,
     4    160,  161,  162,  163,   26,   24,  165,  166,  167,  168,
     5    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     6     22,   24,  180,  181,  182,  183,  184,  185,  186,  187,
     7    188,  189,  190,  191,   25,   25,  193,  194,  195,  196,
     8    197,   27,   29,  199,  200,  201,  202,  203,  204,  205,
     9    206,  207,  208,  209,  210,  211,  212,   27,   28,  214/
            data (jb1(i),i=  201,  300)/
     +    215,  216,  217,  218,  219,  220,  221,  222,   26,   29,
     1     34,   30,  225,  226,  227,  228,  229,  230,  231,  232,
     2    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     3    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     4    253,  254,  255,  256,  257,  258,  259,   28,   30,   35,
     5    261,   32,   31,   32,   33,   34,   36,   37,   39,   39,
     6     38,   41,    1,  263,  264,    2,  266,  267,  268,  269,
     7    270,  271,  272,  274,  275,  276,  277,  278,  279,  280,
     8    281,  282,  283,  284,  285,  286,  287,  274,    4,  290,
     9    291,  292,  275,  294,  295,  296,  265,    5,  298,  299/
            data (jb1(i),i=  301,  400)/
     +    300,  301,  302,  303,  304,  305,  306,  308,  309,  310,
     1    307,  311,  312,  293,    7,  314,  315,  316,  317,  318,
     2    319,  320,  321,  322,  323,  325,  326,  327,  328,  329,
     3    330,  331,  332,  273,    8,  334,  335,  290,  337,  338,
     4    339,  325,  341,  307,    9,  343,  344,  345,  346,   10,
     5    348,  349,  350,  351,  352,  353,  354,  355,  356,  358,
     6    359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
     7    369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
     8    379,  380,  381,  382,  383,  384,  385,  274,  387,  388,
     9    389,  390,  391,  392,  393,  394,  395,  396,  397,  398/
            data (jb1(i),i=  401,  500)/
     +    399,  358,  347,  401,  402,  403,  404,  365,  273,  406,
     1    407,  408,  409,  410,  411,  412,  413,  414,  415,  336,
     2    416,  417,   14,  419,  420,  308,  418,  265,  423,  424,
     3    425,  426,  427,  428,  429,  430,  308,  432,  433,  434,
     4    435,  436,  437,  438,  439,  431,   15,  441,  442,  443,
     5    444,  446,  447,  448,  449,  450,  451,  452,  453,  454,
     6    347,  456,  457,  458,  459,  460,  461,  462,  463,  464,
     7    465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
     8    475,  476,  477,  478,  479,  480,  481,  482,  483,  484,
     9    485,  486,  325,  488,  489,  487,  491,  492,  493,  494/
            data (jb1(i),i=  501,  600)/
     +    495,  496,  497,  498,  499,  500,  501,  502,  503,  504,
     1    505,  358,  507,  508,  509,  510,  511,  512,  513,  514,
     2    515,  516,  487,  381,  518,  519,  520,  521,  522,  523,
     3    524,  525,  526,  365,  528,  529,  530,  531,  532,  533,
     4    535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     5    545,  546,  547,  548,  549,  550,  551,  552,  553,  554,
     6    381,  357,  556,  557,  558,  559,  560,  561,  562,  421,
     7    564,  421,  566,  567,  568,  569,  570,  289,  336,  572,
     8    573,  574,  575,  445,  577,  578,  579,  580,  581,  582,
     9    563,  584,  585,  586,  587,  588,  418,  590,  591,  592/
            data (jb1(i),i=  601,  700)/
     +    589,   16,  594,  595,  596,  597,  598,  599,  600,  490,
     1    446,  602,  603,  604,  605,  606,  607,  608,  534,  387,
     2    610,  611,  289,  613,  615,  616,  617,  618,  619,  534,
     3    621,  622,  615,  612,  624,  626,  627,  628,  629,  630,
     4    631,  632,  633,  357,  625,  636,  637,  638,  639,  640,
     5    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     6    651,  652,  653,  626,  576,  655,  656,  657,  658,  659,
     7    660,  661,  662,  663,  584,  665,  666,  667,  668,  669,
     8    670,  671,  576,  614,  673,  626,  431,  455,  676,  677,
     9    678,  679,  680,  681,  682,  683,  684,  685,  686,  687/
            data (jb1(i),i=  701,  800)/
     +    688,  689,  690,  341,  692,  387,  565,  445,  695,  696,
     1    697,  698,  699,  701,  702,  703,  704,  705,  706,  707,
     2    422,  635,  709,  710,  711,  712,  620,  714,  715,  716,
     3    717,  718,  719,  720,  721,  722,  723,  724,  725,  726,
     4    727,  728,  713,  730,  732,  566,  700,  734,  735,  736,
     5    737,  738,  739,  740,  741,  742,  743,  744,  745,  746,
     6    664,  748,  749,  750,  751,  752,  753,  754,  755,  756,
     7    757,  758,  759,  760,  761,  762,  763,  764,  765,  766,
     8    767,  768,  769,  770,  771,  732,  694,  773,  774,  775,
     9    776,  777,  700,  779,  780,  781,   18,  783,  784,  785/
            data (jb1(i),i=  801,  900)/
     +    786,  787,  788,  789,  455,  791,  324,  794,  729,  675,
     1    796,  797,  798,  799,  800,  801,  802,  803,  804,  805,
     2    806,  807,  701,  793,  790,  810,  811,  812,  813,  814,
     3    815,  816,  817,  729,  324,  819,  731,  820,  821,  822,
     4    823,  824,  825,  826,  827,  828,  748,  507,  692,  341,
     5    831,  832,  833,  834,  835,  836,  748,  838,  839,  840,
     6    841,  527,  792,  843,  844,  845,  846,  847,  848,  849,
     7    850,  851,  810,  614,  853,  854,  765,  490,  856,  857,
     8    858,  859,  860,  861,  862,  837,   20,  865,  866,  275,
     9    865,  868,  869,  870,  871,  872,  873,  874,  875,  876/
            data (jb1(i),i=  901, 1000)/
     +    675,  878,  879,  880,  881,  882,  883,  884,  535,  865,
     1    886,  887,  888,  889,  890,  891,  892,  893,  894,  895,
     2    896,  535,  701,  898,  899,  900,  901,  902,  903,  904,
     3    905,  906,  810,  908,  794,  910,  911,  912,  913,  914,
     4    915,  916,  917,  918,  919,  920,  921,  922,  923,  924,
     5    925,  926,  927,  928,  929,  930,  931,  932,  933,  934,
     6    935,  936,  937,  938,  939,  507,  864,  778,  837,  942,
     7    943,  944,  945,  946,  947,  948,  949,  589,  909,  951,
     8    952,  943,  954,  955,  956,  957,  958,  959,  960,  961,
     9    962,  963,  964,  965,  966,  967,  907,  969,  970,  971/
            data (jb1(i),i= 1001, 1100)/
     +    972,  934,  782,  974,  975,  976,  977,  978,  979,  980,
     1    981,  982,  907,  984,  985,  986,  987,  988,  989,  990,
     2    953,  992,  993,  994,  995,  790,  997,  998,  999,  527,
     3   1001, 1002, 1003, 1004,  864, 1006, 1007, 1000,  792, 1009,
     4   1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019,
     5   1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029,
     6    782, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038,  563,
     7    636,  991, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047,
     8   1048, 1049, 1051, 1052,  793, 1054, 1055, 1056, 1057, 1058,
     9   1059, 1060, 1061, 1062, 1063, 1064,  692,  969, 1066, 1067/
            data (jb1(i),i= 1101, 1200)/
     +   1068, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077,  991,
     1   1005, 1079, 1081, 1082,  765, 1069, 1050, 1085, 1086, 1087,
     2   1088, 1089, 1090,  886, 1084, 1031, 1093, 1094, 1095, 1096,
     3   1097, 1098,  983, 1054, 1100, 1101, 1103, 1104, 1105, 1106,
     4   1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115,  732,
     5   1092, 1117, 1119, 1120, 1121, 1122,  943,  636, 1124, 1125,
     6   1126, 1127, 1128, 1129, 1130, 1131, 1081, 1119, 1133, 1134,
     7   1019, 1118, 1136, 1137, 1138, 1139,  996, 1000, 1080, 1142,
     8   1143, 1144, 1102, 1080, 1146, 1147,  878, 1149, 1150, 1151,
     9   1152, 1153, 1154, 1155, 1005,  969, 1157, 1158, 1159, 1160/
            data (jb1(i),i= 1201, 1300)/
     +   1161, 1162, 1163, 1164, 1165, 1166, 1146, 1148, 1170, 1169,
     1   1167, 1172, 1173, 1174, 1175, 1176, 1170, 1179, 1177, 1051,
     2   1181, 1182, 1183, 1184,   23, 1186, 1187, 1188, 1189, 1190,
     3   1191, 1192, 1193, 1194, 1185, 1179, 1196, 1198, 1199, 1200,
     4   1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210,
     5   1197,  778, 1212, 1213, 1214, 1215, 1216, 1218, 1219, 1127,
     6   1198, 1222, 1223,  878, 1103, 1225, 1226, 1227, 1228, 1229,
     7   1230, 1231, 1168, 1234, 1235, 1236, 1237, 1238, 1239, 1119,
     8   1241, 1242, 1185, 1081, 1244, 1245, 1246, 1247, 1248, 1249,
     9   1232, 1251, 1252, 1253, 1070, 1234, 1255, 1256, 1251, 1233/
            data (jb1(i),i= 1301, 1400)/
     +   1258, 1251, 1260, 1221, 1233,   24, 1263, 1264, 1265, 1266,
     1   1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275,  996,
     2   1277, 1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286,
     3   1287, 1288, 1218, 1217, 1217, 1291, 1292, 1293, 1294, 1295,
     4   1296, 1297, 1103, 1051, 1299, 1300, 1301, 1302, 1303, 1304,
     5   1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312, 1314, 1315,
     6   1316, 1222, 1141, 1261, 1318, 1319, 1141, 1321, 1322, 1290,
     7   1178, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332,
     8   1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342,
     9   1343, 1344, 1345, 1346, 1222, 1348, 1349, 1050, 1351, 1352/
            data (jb1(i),i= 1401, 1500)/
     +   1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362,
     1   1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372,
     2   1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381, 1320,
     3   1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391, 1392,
     4   1393, 1394, 1395, 1314, 1364, 1397, 1398, 1399, 1350, 1218,
     5   1401, 1402, 1403, 1404, 1405, 1406,   25, 1408, 1409, 1410,
     6   1411, 1412, 1413, 1414, 1415, 1167, 1417, 1418, 1419, 1420,
     7   1421, 1422, 1423, 1424, 1425, 1426, 1298, 1428, 1429, 1430,
     8   1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439, 1440,
     9   1441, 1442,  983, 1019, 1444, 1445, 1446, 1447, 1448, 1449/
            data (jb1(i),i= 1501, 1600)/
     +   1450, 1451, 1452, 1277, 1241, 1454, 1455, 1456, 1457, 1458,
     1   1313, 1460, 1459, 1462, 1463, 1428, 1347, 1234, 1465, 1466,
     2   1467, 1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477,
     3   1407, 1347, 1479, 1480, 1481, 1482, 1483, 1484, 1468, 1486,
     4   1487, 1488, 1489, 1490, 1491, 1453,   26, 1493, 1494, 1495,
     5   1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505,
     6   1506, 1507, 1508, 1509, 1510, 1511, 1512, 1513, 1515, 1516,
     7   1517, 1518, 1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526,
     8   1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536,
     9   1537, 1538, 1539, 1540, 1541, 1542, 1543, 1485, 1259, 1545/
            data (jb1(i),i= 1601, 1700)/
     +   1546, 1547, 1548, 1549, 1550, 1551, 1515, 1553, 1554, 1453,
     1   1314, 1556, 1557, 1558, 1559, 1560, 1561, 1562, 1563, 1462,
     2   1565, 1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573, 1574,
     3   1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583, 1584,
     4   1585, 1586, 1553, 1232, 1588, 1589, 1590, 1591, 1592, 1469,
     5   1241, 1594, 1595, 1596, 1597, 1598, 1599, 1600, 1514, 1602,
     6   1603, 1604, 1605, 1321, 1515, 1607, 1608, 1609, 1610, 1611,
     7   1612, 1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621,
     8   1622, 1623, 1624, 1625, 1626, 1627, 1628, 1629, 1364, 1630,
     9   1631, 1633, 1634, 1635, 1636, 1632, 1633, 1638, 1639, 1640/
            data (jb1(i),i= 1701, 1800)/
     +   1641, 1642, 1643, 1644, 1645, 1320, 1633, 1648, 1649, 1650,
     1   1651, 1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659, 1660,
     2   1661, 1662, 1468, 1647, 1664, 1648, 1666, 1667, 1668, 1669,
     3   1670, 1469, 1564, 1672, 1673, 1674, 1675, 1676, 1677, 1678,
     4   1679, 1680, 1681, 1682, 1684, 1685, 1686, 1687, 1688, 1689,
     5   1553, 1691, 1692, 1693, 1694, 1695, 1696, 1697, 1698, 1699,
     6   1700, 1701, 1702, 1350, 1459, 1705, 1706, 1707, 1708, 1709,
     7   1710, 1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719,
     8   1720, 1407, 1704, 1722, 1723, 1724, 1602, 1726, 1727, 1728,
     9   1729, 1730, 1731, 1691, 1705, 1733, 1734, 1736, 1737, 1738/
            data (jb1(i),i= 1801, 1900)/
     +   1514, 1417, 1740, 1741, 1742, 1743, 1744, 1745, 1746, 1747,
     1   1666, 1683, 1749, 1750, 1751, 1752, 1753, 1754, 1726, 1290,
     2   1756, 1757, 1758, 1759, 1760, 1761, 1762, 1763, 1764, 1765,
     3   1767, 1768, 1769, 1770, 1771, 1772, 1773, 1602, 1766, 1767,
     4   1277, 1776, 1777, 1778, 1779, 1780, 1781, 1782, 1783, 1784,
     5   1785, 1786, 1787, 1788, 1789, 1790, 1791, 1793, 1704, 1736,
     6   1735, 1795, 1796, 1797, 1798, 1799, 1800, 1801, 1802, 1803,
     7   1792, 1736, 1805, 1807, 1808, 1809, 1810, 1811, 1812, 1813,
     8   1666,   28, 1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822,
     9   1823, 1824, 1806, 1807, 1826, 1827, 1828, 1829, 1830, 1831/
            data (jb1(i),i= 1901, 2000)/
     +   1832, 1705, 1834, 1835, 1767, 1837, 1838, 1839, 1840, 1841,
     1   1726, 1843, 1844, 1845, 1417, 1766, 1847, 1848, 1849, 1850,
     2   1843, 1485, 1852, 1853, 1854, 1855, 1856, 1857, 1858, 1859,
     3   1860, 1861, 1862, 1863, 1864, 1865, 1866, 1867, 1868, 1869,
     4   1870, 1383, 1872, 1873, 1874, 1875, 1876, 1877, 1878, 1879,
     5   1880, 1881, 1882, 1883, 1884, 1885, 1886, 1887, 1888, 1889,
     6   1890, 1837, 1892, 1893, 1691, 1632, 1895, 1896, 1897, 1898,
     7   1892, 1462, 1900, 1901, 1902, 1903, 1904, 1905, 1906, 1907,
     8   1908, 1909, 1910, 1911, 1912, 1914, 1913, 1916, 1917, 1918,
     9   1919, 1920, 1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928/
            data (jb1(i),i= 2001, 2100)/
     +   1929, 1930, 1931, 1932, 1933, 1934, 1935, 1936, 1937, 1939,
     1   1940, 1941, 1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949,
     2   1950, 1951, 1952, 1885, 1807, 1954, 1684, 1956, 1957, 1958,
     3   1959, 1960, 1961, 1962, 1963, 1964, 1916, 1647, 1966, 1967,
     4   1968, 1969, 1970, 1971, 1972, 1973, 1974, 1975, 1976, 1684,
     5   1978, 1979, 1980, 1981, 1982, 1983, 1984, 1985, 1986, 1987,
     6   1988, 1914, 1871, 1990, 1991, 1992, 1993, 1994, 1995, 1648,
     7   1996, 1997, 1998, 1999, 2000, 1938, 1939, 2002, 2003, 1871,
     8   1916, 2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013,
     9   2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023/
            data (jb1(i),i= 2101, 2200)/
     +   2024, 2025, 2026, 2027, 2029, 2030, 2031, 2032, 2033, 2034,
     1   2035, 2036, 2037, 2038, 2039, 2040, 2041, 2042, 2043, 1792,
     2   2045, 2046, 1722, 1834, 2048, 2049, 2050, 2051, 2052, 2053,
     3   2054, 2055, 2056, 2057, 2045, 1913, 2059, 2060, 2061, 2062,
     4   2063, 2064, 2029, 1938, 2066, 2067, 2068, 2069, 2070, 2071,
     5   2072, 2073, 1977, 1892, 1977, 2076, 2077, 2078, 2079, 2080,
     6   2081, 2082, 2075, 2028, 2084, 2085, 2086, 2087, 2088, 2089,
     7   2090, 2091, 2092, 2093, 2094, 2095, 2096, 2097, 1914, 1806,
     8   1793,   32, 2099, 2100, 2101, 2102, 2103, 1843, 2045, 1939,
     9   2105, 2106, 2107, 2108, 2109, 1834, 2110, 2111, 2112, 2113/
            data (jb1(i),i= 2201, 2250)/
     +     36, 2114, 2115, 2116, 2117, 1955, 1837, 2119, 2120, 2121,
     1   2122, 2123, 2124, 2125, 2126, 2127, 2128, 2129, 2130, 2131,
     2   2132, 2133, 2134, 2135,   38, 2136, 2137, 2138, 2139, 2140,
     3   2141, 2142, 2143, 2144, 2145, 2146, 2147, 2148, 1735, 2066,
     4     40, 2150, 2151, 2152, 2153, 2154, 2155, 2075, 2028, 2029/
            data (jb2(i),i=    1,  100)/
     +     43,   44,   44,   45,   46,   47,   48,   49,   49,   12,
     1     50,   51,   51,   52,   53,   53,   10,    3,   54,   54,
     2     55,   56,   57,   57,   58,   58,    8,   17,   17,   18,
     3     20,   20,   59,   60,   61,   62,   63,   64,   65,   66,
     4     67,   68,   69,   70,   71,   72,   73,   74,   75,   75,
     5     76,   77,   78,   79,   80,   81,   82,   83,   84,   85,
     6     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     7     96,   97,   97,   98,   99,  100,  101,  102,  103,  104,
     8    104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
     9    114,  115,  116,  116,  117,  118,  119,  120,  121,  122/
            data (jb2(i),i=  101,  200)/
     +    123,  124,  125,  126,  126,  127,  128,  129,  130,  131,
     1    132,  133,  134,  135,  136,  136,  137,  138,  139,  140,
     2    141,  142,  143,  144,  145,  146,  147,  148,  149,  150,
     3    151,  152,  153,  154,  155,  156,  157,  158,  159,  160,
     4    161,  162,  163,  164,  164,  165,  166,  167,  168,  169,
     5    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     6    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     7    189,  190,  191,  192,  192,  193,  194,  195,  196,  197,
     8    198,  198,  199,  200,  201,  202,  203,  204,  205,  206,
     9    207,  208,  209,  210,  211,  212,  213,  213,  214,  215/
            data (jb2(i),i=  201,  300)/
     +    216,  217,  218,  219,  220,  221,  222,  223,  223,  224,
     1    224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
     2    234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
     3    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     4    254,  255,  256,  257,  258,  259,  260,  260,   31,  261,
     5    262,  262,   33,   36,   35,   37,   38,   40,   41,   40,
     6     42,   42,  263,  264,  265,  266,  267,  268,  269,  270,
     7    271,  272,  273,    3,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  288,  289,  291,
     9    292,  293,  294,  295,  296,  297,  297,  298,  299,  300/
            data (jb2(i),i=  301,  400)/
     +    301,  302,  303,  304,  305,  306,  307,  309,  310,    6,
     1    311,  312,  313,  313,  314,  315,  316,  317,  318,  319,
     2    320,  321,  322,  323,  324,  326,  327,  328,  329,  330,
     3    331,  332,  333,  333,  334,  335,  336,  337,  338,  339,
     4    340,  340,  342,  342,  343,  344,  345,  346,  347,  348,
     5    349,  350,  351,  352,  353,  354,  355,  356,  357,  359,
     6    360,  361,  362,  363,  364,   11,  366,  367,  368,  369,
     7    370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
     8    380,   12,  382,  383,  384,  385,  386,  386,  388,  389,
     9    390,  391,  392,  393,  394,  395,  396,  397,  398,  399/
            data (jb2(i),i=  401,  500)/
     +    400,  400,  401,  402,  403,  404,  405,  405,  406,  407,
     1    408,  409,  410,  411,  412,  413,  414,  415,   13,  416,
     2    417,  418,  419,  420,  421,  422,  422,  423,  424,  425,
     3    426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
     4    436,  437,  438,  439,  440,  440,  441,  442,  443,  444,
     5    445,  447,  448,  449,  450,  451,  452,  453,  454,  455,
     6    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     7    466,  467,  468,  469,  470,  471,  472,  473,  474,  475,
     8    476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
     9    486,  487,  488,  489,  490,  491,  492,  493,  494,  495/
            data (jb2(i),i=  501,  600)/
     +    496,  497,  498,  499,  500,  501,  502,  503,  504,  505,
     1    506,  506,  508,  509,  510,  511,  512,  513,  514,  515,
     2    516,  517,  517,  518,  519,  520,  521,  522,  523,  524,
     3    525,  526,  527,  528,  529,  530,  531,  532,  533,  534,
     4    536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
     5    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     6    555,  556,  557,  558,  559,  560,  561,  562,  563,  564,
     7    565,  566,  567,  568,  569,  570,  571,  571,  572,  573,
     8    574,  575,  576,  577,  578,  579,  580,  581,  582,  583,
     9    583,  585,  586,  587,  588,  589,  590,  591,  592,  593/
            data (jb2(i),i=  601,  700)/
     +    593,  594,  595,  596,  597,  598,  599,  600,  601,  601,
     1    602,  603,  604,  605,  606,  607,  608,  609,  609,  610,
     2    611,  612,  613,  614,  616,  617,  618,  619,  620,  621,
     3    622,  623,  623,  624,  625,  627,  628,  629,  630,  631,
     4    632,  633,  634,  634,  635,  637,  638,  639,  640,  641,
     5    642,  643,  644,  645,  646,  647,  648,  649,  650,  651,
     6    652,  653,  654,  654,  655,  656,  657,  658,  659,  660,
     7    661,  662,  663,  664,  665,  666,  667,  668,  669,  670,
     8    671,  672,  672,  673,  674,  674,  675,  676,  677,  678,
     9    679,  680,  681,  682,  683,  684,  685,  686,  687,  688/
            data (jb2(i),i=  701,  800)/
     +    689,  690,  691,  691,  693,  693,  694,  695,  696,  697,
     1    698,  699,  700,  702,  703,  704,  705,  706,  707,  708,
     2    708,  709,  710,  711,  712,  713,  714,  715,  716,  717,
     3    718,  719,  720,  721,  722,  723,  724,  725,  726,  727,
     4    728,  729,  730,  731,  733,  733,  734,  735,  736,  737,
     5    738,  739,  740,  741,  742,  743,  744,  745,  746,  747,
     6    747,  749,  750,  751,  752,  753,  754,  755,  756,  757,
     7    758,  759,  760,  761,  762,  763,  764,   17,  766,  767,
     8    768,  769,  770,  771,  772,  772,  773,  774,  775,  776,
     9    777,  778,  779,  780,  781,  782,  783,  784,  785,  786/
            data (jb2(i),i=  801,  900)/
     +    787,  788,  789,  790,  791,  792,  793,  795,  795,  796,
     1    797,  798,  799,  800,  801,  802,  803,  804,  805,  806,
     2    807,  808,  808,  809,  809,  811,  812,  813,  814,  815,
     3    816,  817,  818,  818,  819,   19,  820,  821,  822,  823,
     4    824,  825,  826,  827,  828,  829,  829,  830,  830,  831,
     5    832,  833,  834,  835,  836,  837,  838,  839,  840,  841,
     6    842,  842,  843,  844,  845,  846,  847,  848,  849,  850,
     7    851,  852,  852,  853,  854,  855,  855,  856,  857,  858,
     8    859,  860,  861,  862,  863,  863,  864,  866,  867,  867,
     9    868,  869,  870,  871,  872,  873,  874,  875,  876,  877/
            data (jb2(i),i=  901, 1000)/
     +    877,  879,  880,  881,  882,  883,  884,  885,  885,  886,
     1    887,  888,  889,  890,  891,  892,  893,  894,  895,  896,
     2    897,  897,  898,  899,  900,  901,  902,  903,  904,  905,
     3    906,  907,  908,  909,  910,  911,  912,  913,  914,  915,
     4    916,  917,  918,  919,  920,  921,  922,  923,  924,  925,
     5    926,  927,  928,  929,  930,  931,  932,  933,  934,  935,
     6    936,  937,  938,  939,  940,  940,  941,  941,  942,   21,
     7    944,  945,  946,  947,  948,  949,  950,  950,  951,  952,
     8    953,  954,  955,  956,  957,  958,  959,  960,  961,  962,
     9    963,  964,  965,  966,  967,  968,  968,  970,  971,  972/
            data (jb2(i),i= 1001, 1100)/
     +    973,  973,  974,  975,  976,  977,  978,  979,  980,  981,
     1    982,  983,  984,  985,  986,  987,  988,  989,  990,  991,
     2    992,  993,  994,  995,  996,  997,  998,  999, 1000, 1001,
     3   1002, 1003, 1004, 1005, 1006, 1007, 1008, 1008, 1009, 1010,
     4   1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018,   22, 1020,
     5   1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030,
     6   1030, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1039,
     7   1031, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048,
     8   1049, 1050, 1052, 1053, 1053, 1055, 1056, 1057, 1058, 1059,
     9   1060, 1061, 1062, 1063, 1064, 1065, 1065, 1066, 1067, 1068/
            data (jb2(i),i= 1101, 1200)/
     +   1069, 1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1078,
     1   1079, 1080, 1082, 1083, 1083, 1084, 1085, 1086, 1087, 1088,
     2   1089, 1090, 1091, 1091, 1092, 1093, 1094, 1095, 1096, 1097,
     3   1098, 1099, 1099, 1100, 1101, 1102, 1104, 1105, 1106, 1107,
     4   1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1116,
     5   1117, 1118, 1120, 1121, 1122, 1123, 1123, 1124, 1125, 1126,
     6   1127, 1128, 1129, 1130, 1131, 1132, 1132, 1133, 1134, 1135,
     7   1135, 1136, 1137, 1138, 1139, 1140, 1140, 1141, 1142, 1143,
     8   1144, 1145, 1145, 1146, 1147, 1148, 1149, 1150, 1151, 1152,
     9   1153, 1154, 1155, 1156, 1156, 1157, 1158, 1159, 1160, 1161/
            data (jb2(i),i= 1201, 1300)/
     +   1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1171, 1171,
     1   1172, 1173, 1174, 1175, 1176, 1177, 1178, 1180, 1180, 1181,
     2   1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191,
     3   1192, 1193, 1194, 1195, 1195, 1196, 1197, 1199, 1200, 1201,
     4   1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211,
     5   1211, 1212, 1213, 1214, 1215, 1216, 1217, 1219, 1220, 1220,
     6   1221, 1223, 1224, 1224, 1225, 1226, 1227, 1228, 1229, 1230,
     7   1231, 1232, 1233, 1235, 1236, 1237, 1238, 1239, 1240, 1240,
     8   1242, 1243, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250,
     9   1250, 1252, 1253, 1254, 1254, 1255, 1256, 1257, 1257, 1258/
            data (jb2(i),i= 1301, 1400)/
     +   1259, 1260, 1261, 1262, 1262, 1263, 1264, 1265, 1266, 1267,
     1   1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276, 1276,
     2   1278, 1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287,
     3   1288, 1289, 1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296,
     4   1297, 1298, 1298, 1299, 1300, 1301, 1302, 1303, 1304, 1305,
     5   1306, 1307, 1308, 1309, 1310, 1311, 1312, 1313, 1315, 1316,
     6   1317, 1317, 1313, 1318, 1319, 1320, 1321, 1322, 1323, 1323,
     7   1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333,
     8   1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343,
     9   1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352, 1353/
            data (jb2(i),i= 1401, 1500)/
     +   1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363,
     1   1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373,
     2   1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382, 1382,
     3   1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391, 1392, 1393,
     4   1394, 1395, 1396, 1396, 1397, 1398, 1399, 1400, 1400, 1401,
     5   1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409, 1410, 1411,
     6   1412, 1413, 1414, 1415, 1416, 1416, 1418, 1419, 1420, 1421,
     7   1422, 1423, 1424, 1425, 1426, 1427, 1427, 1429, 1430, 1431,
     8   1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439, 1440, 1441,
     9   1442, 1443, 1443, 1444, 1445, 1446, 1447, 1448, 1449, 1450/
            data (jb2(i),i= 1501, 1600)/
     +   1451, 1452, 1453, 1428, 1454, 1455, 1456, 1457, 1458, 1459,
     1   1460, 1461, 1461, 1463, 1464, 1464, 1383, 1465, 1466, 1467,
     2   1468, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478,
     3   1478, 1479, 1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487,
     4   1488, 1489, 1490, 1491, 1492, 1492, 1493, 1494, 1495, 1496,
     5   1497, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506,
     6   1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514, 1516, 1517,
     7   1518, 1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527,
     8   1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536, 1537,
     9   1538, 1539, 1540, 1541, 1542, 1543, 1544, 1544, 1545, 1546/
            data (jb2(i),i= 1601, 1700)/
     +   1547, 1548, 1549, 1550, 1551, 1552, 1552, 1554, 1555, 1555,
     1   1556, 1557, 1558, 1559, 1560, 1561, 1562, 1563, 1564, 1565,
     2   1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575,
     3   1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583, 1584, 1585,
     4   1586, 1587, 1587, 1588, 1589, 1590, 1591, 1592, 1593, 1593,
     5   1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601, 1601, 1603,
     6   1604, 1605, 1606, 1606, 1607, 1608, 1609, 1610, 1611, 1612,
     7   1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622,
     8   1623, 1624, 1625, 1626, 1627, 1628, 1629,   27, 1630, 1631,
     9   1632, 1634, 1635, 1636, 1637, 1637, 1638, 1639, 1640, 1641/
            data (jb2(i),i= 1701, 1800)/
     +   1642, 1643, 1644, 1645, 1646, 1646, 1647, 1649, 1650, 1651,
     1   1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661,
     2   1662, 1663, 1663, 1664, 1665, 1665, 1667, 1668, 1669, 1670,
     3   1671, 1671, 1672, 1673, 1674, 1675, 1676, 1677, 1678, 1679,
     4   1680, 1681, 1682, 1683, 1685, 1686, 1687, 1688, 1689, 1690,
     5   1690, 1692, 1693, 1694, 1695, 1696, 1697, 1698, 1699, 1700,
     6   1701, 1702, 1703, 1703, 1704, 1706, 1707, 1708, 1709, 1710,
     7   1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719, 1720,
     8   1721, 1721, 1722, 1723, 1724, 1725, 1725, 1727, 1728, 1729,
     9   1730, 1731, 1732, 1732, 1733, 1734, 1735, 1737, 1738, 1739/
            data (jb2(i),i= 1801, 1900)/
     +   1739, 1740, 1741, 1742, 1743, 1744, 1745, 1746, 1747, 1748,
     1   1748, 1749, 1750, 1751, 1752, 1753, 1754, 1755, 1755, 1756,
     2   1757, 1758, 1759, 1760, 1761, 1762, 1763, 1764, 1765, 1766,
     3   1768, 1769, 1770, 1771, 1772, 1773, 1774, 1774, 1775, 1775,
     4   1776, 1777, 1778, 1779, 1780, 1781, 1782, 1783, 1784, 1785,
     5   1786, 1787, 1788, 1789, 1790, 1791, 1792, 1794, 1794, 1793,
     6   1795, 1796, 1797, 1798, 1799, 1800, 1801, 1802, 1803, 1804,
     7   1804, 1805, 1806, 1808, 1809, 1810, 1811, 1812, 1813, 1814,
     8   1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822, 1823,
     9   1824, 1825, 1825, 1826, 1827, 1828, 1829, 1830, 1831, 1832/
            data (jb2(i),i= 1901, 2000)/
     +   1833, 1833, 1835, 1836, 1836, 1838, 1839, 1840, 1841, 1842,
     1   1842, 1844, 1845, 1846, 1846, 1847, 1848, 1849, 1850, 1851,
     2   1851, 1852, 1853, 1854, 1855, 1856, 1857, 1858, 1859, 1860,
     3   1861, 1862, 1863, 1864, 1865, 1866, 1867, 1868, 1869, 1870,
     4   1871, 1872, 1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880,
     5   1881, 1882, 1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890,
     6   1891, 1891, 1893, 1894, 1894, 1895, 1896, 1897, 1898, 1899,
     7   1899, 1900, 1901, 1902, 1903, 1904, 1905, 1906, 1907, 1908,
     8   1909, 1910, 1911, 1912, 1913, 1915, 1915, 1917, 1918, 1919,
     9   1920, 1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929/
            data (jb2(i),i= 2001, 2100)/
     +   1930, 1931, 1932, 1933, 1934, 1935, 1936, 1937, 1938, 1940,
     1   1941, 1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950,
     2   1951, 1952, 1953, 1953, 1954, 1955, 1956, 1957, 1958, 1959,
     3   1960, 1961, 1962, 1963, 1964, 1965, 1965, 1966, 1967, 1968,
     4   1969, 1970, 1971, 1972, 1973, 1974, 1975, 1976, 1977, 1978,
     5   1979, 1980, 1981, 1982, 1983, 1984, 1985, 1986, 1987, 1988,
     6   1989, 1989, 1990, 1991, 1992, 1993, 1994, 1995,   29, 1996,
     7   1997, 1998, 1999, 2000, 2001, 2001, 2002, 2003, 2004, 2004,
     8   2005, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013, 2014,
     9   2015, 2016, 2017, 2018, 2019, 2020, 2021, 2022, 2023, 2024/
            data (jb2(i),i= 2101, 2200)/
     +   2025, 2026, 2027, 2028, 2030, 2031, 2032, 2033, 2034, 2035,
     1   2036, 2037, 2038, 2039, 2040, 2041, 2042, 2043, 2044, 2044,
     2   2046, 2047, 2047, 2048, 2049, 2050, 2051, 2052, 2053, 2054,
     3   2055, 2056, 2057, 2058, 2058, 2059, 2060, 2061, 2062, 2063,
     4   2064, 2065, 2065, 2066, 2067, 2068, 2069, 2070, 2071, 2072,
     5   2073, 2074, 2074, 2075, 2076, 2077, 2078, 2079, 2080, 2081,
     6   2082, 2083, 2083, 2084, 2085, 2086, 2087, 2088, 2089, 2090,
     7   2091, 2092, 2093, 2094, 2095, 2096, 2097, 2098, 2098,   30,
     8     31, 2099, 2100, 2101, 2102, 2103, 2104, 2104,   33, 2105,
     9   2106, 2107, 2108, 2109,   34, 2110, 2111, 2112, 2113,   35/
            data (jb2(i),i= 2201, 2250)/
     +   2114, 2115, 2116, 2117, 2118, 2118, 2119, 2120, 2121, 2122,
     1   2123, 2124, 2125, 2126, 2127, 2128, 2129, 2130, 2131, 2132,
     2   2133, 2134, 2135,   37, 2136, 2137, 2138, 2139, 2140, 2141,
     3   2142, 2143, 2144, 2145, 2146, 2147, 2148, 2149, 2149,   39,
     4   2150, 2151, 2152, 2153, 2154, 2155, 2156, 2156,   41,   42/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine tx(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(2270) :: jx,jy
            integer(kind=iknd), save, dimension(2520) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'texas         '/
            data jrot,ipart/0,1/
            data kv/   1,2264,   0,   0,   0/
            data kb/   1,2517,   0,   0,   0/
            data iib/ 763,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  23352,25272,27144,29064,20280,20184,30984,30960,20112,30936,
     1  20040,30936,19968,30912,30888,19872,31104,31176,31392,31680,
     2  31992,32304,32472,32664,32784,34680,34512,34032,33816,33744,
     3  33744,33552,33552,33336,33168,33096,33120,33048,32928,34824,
     4  35400,35568,35736,35928,36384,36600,41976,40032,40152,40128,
     5  40272,40440,40536,40608,40656,40848,40944,41064,41184,41064,
     6  41088,41184,41352,41472,41448,41616,41472,41544,41616,41688,
     7  41856,41808,41880,36720,36816,37488,37704,37800,37776,37704,
     8  37824,37752,37824,38040,38184,38328,38256,38304,38208,38232,
     9  19776,45984,46032,46128,46272,46320,46512,46608,46848,46848/
            data (jx(i),i=  101,  200)/
     +  47016,47088,47184,47232,47376,47400,47544,47808,47832,47928,
     1  38568,38736,38928,38928,39168,39312,39480,39552,39624,39624,
     2  39696,42096,42288,42432,42528,42648,42864,42984,43128,43272,
     3  43152,43176,43344,43512,43608,43896,44064,48048,48048,48072,
     4  48144,48144,48216,48576,48600,48744,48720,48768,48816,48912,
     5  49056,49128,49176,49296,49272,49416,49392,49560,49800,49944,
     6  49968,49872,50016,49968,50016,44136,44232,44376,44616,44760,
     7  44856,44928,44952,45048,45072,45240,45336,45384,45432,45480,
     8  45624,45624,19680,52680,52608,52488,52560,52440,52320,52272,
     9  52224,52248,52104,51960,52056,52080,52008,51912,51840,51888/
            data (jx(i),i=  201,  300)/
     +  51744,51696,51744,51696,51624,51504,51480,51360,51288,51384,
     1  51264,51168,51048,51096,50976,50904,50856,50832,50832,50664,
     2  50760,50592,50616,50568,50472,50328,50304,50376,50352,50112,
     3  50064,19584,52752,52776,52848,19488, 8304, 8016, 7560, 7416,
     4   7296, 7224, 6960, 6816, 6624, 6504, 6384, 6192, 6048, 6168,
     5   6096, 6168, 6096, 6168, 8496,19416,12504,15840,16008,52944,
     6  53040,18384,19416,53208,53400,53400,53496,53616,53784,53760,
     7  53856,53928,53808,53856,53784,54000,54120,54168,54264,54216,
     8  54120,54144,54312,54288,54360,54312,54432,54456,54576,54480,
     9  54408,54672,54672,54768,54744,11928, 8472, 8520, 8640, 8664/
            data (jx(i),i=  301,  400)/
     +   8760, 9072, 9096, 9240, 9720, 9864,10080,10104,10416,10416,
     1  10632,10776,10824,10944,11088,11088,11184,11232,11304,11304,
     2  11472,11640,11856,54816,54912,55008,54960,55008,54912,55080,
     3  55032,55128,54888,54912,55056,55080,54984,55008,54912,55008,
     4  54864,54792,54768,54528,54576,54408,54360,54480,54456,54528,
     5  54432,54336,54312,54408,54528,54552,54096,54504,54576,54576,
     6  54600,54648,54528,54480,54624,54528,54456,54288,21888,22104,
     7  22128,22176,22176,22248,22416,22416,22656,22896,22968,23160,
     8  23208,23256,23352,23376,23664,23784,23784,23856,23808,23832,
     9  23928,24024,53784,54072,54168,53376,52224,24216,24288,24336/
            data (jx(i),i=  401,  500)/
     +  24384,24720,24720,24840,24912,24912,25152,25224,25392,25320,
     1  25392,25392,25464,25512,25608,25728,25728,25800,25848,25944,
     2  25968,25896,26208,26304,26640,26856,27072,27312,27336,27552,
     3  27648,11976,12168,12240,12336,12336,12408,12360,12504,12528,
     4  12696,12744,12816,12888,12960,12912,12936,12864,12912,12888,
     5  12960,12888,12936,13008,13176,13152,13320,13392,13440,13392,
     6  13512,13560,13704,13944,52152,19824,19944,19896,20016,19992,
     7  20112,20160,20256,20256,20448,20448,20544,20712,20928,20952,
     8  21024,21144,21144,21624,21720,21816,21864,16200,14160,14256,
     9  14496,14544,14616,14616,14784,15000,15216,15504,16248,16224/
            data (jx(i),i=  501,  600)/
     +  16320,16440,16680,16728,17088,17400,17376,17472,17544,17784,
     1  17856,17928,17880,18000,17976,18072,18072,18144,18216,18312,
     2  18600,18744,18816,18816,18864,18912,19056,19224,19320,19392,
     3  19536,19536,19608,19728,19704,19584,19680,19848,50976,50832,
     4  50808,49632,49368,28128,28080,27720,27744,47904,48912,48720,
     5  48384,48408,48360,46800,45192,44616,44472,43632,42792,28176,
     6  28272,28200,28368,28464,28560,28608,28632,28704,28728,28944,
     7  28944,29136,29064,29160,29352,29232,29352,29328,29544,29520,
     8  29664,29784,29832,42120,41400,41136,40944,32712,30024,30312,
     9  30456,30576,30696,30888,30864,31032,30984,31104,31104,31200/
            data (jx(i),i=  601,  700)/
     +  31224,31368,31416,31536,31728,31824,31920,31944,32016,32064,
     1  32184,32256,32232,32400,32520,32448,32592,32640,32544,32400,
     2  32592,32568,32616,40848,40848,40944,41208,41472,33864,33696,
     3  33552,33552,33432,33240,33240,33000,33024,32904,32784,32736,
     4  32832,32784,32832,36120,33840,34032,34128,34152,34056,34200,
     5  34392,34464,34656,34752,34800,34920,34992,35280,35352,35544,
     6  35568,35472,35664,35688,35616,35856,35808,35952,35904,36000,
     7  36024,38976,36144,36216,36240,36288,36336,36384,36384,36456,
     8  36456,36552,36576,36696,36696,36912,37008,37056,37104,37128,
     9  37224,37248,37344,37392,37320,37656,37728,37848,37896,37944/
            data (jx(i),i=  701,  800)/
     +  38064,38112,38136,38304,38328,38400,38496,38568,38832,38832,
     1  38904,39072,39144,39168,39216,39264,39240,39312,39336,39360,
     2  39504,39504,39552,39576,39648,39744,39792,39840,39840,39936,
     3  39888,39984,39984,40080,40080,40152,40080,40248,40320,40416,
     4  40416,40536,40512,40584,40608,40728,40752,40800,40920,40968,
     5  40920,40968,40920,41040,41088,41112,41280,41232,41376,41760,
     6  41736,41784,41784,23280,25224,27144,29040,25176,23232,25176,
     7  27072,27072,29016,23160,23184,25104,27048,28992,21816,23088,
     8  23736,25056,25608,27000,27528,28968,29424,21432,21744,23328,
     9  23664,25224,25560,27120,27456,29040,29376,30888,30888,32784/
            data (jx(i),i=  801,  900)/
     +  31656,32208,32496,42024,21360,23280,25176,27072,28968,30672,
     1  30864,30720,30840,36624,34680,32760,45984,32760,31464,31464,
     2  31536,31728,31752,31800,31872,31872,31896,31968,32088,32184,
     3  32328,32376,32400,32424,32520,32520,32592,32592,32712,38232,
     4  36624,45984,40056,38448,21360,49800,49656,49560,49392,49128,
     5  49008,48768,48696,40416,44400,38232,48024,46368,46656,46872,
     6  47712,47832,23256,44088,42432,48264,25152,27048,28944,50088,
     7  30864,30888,32784,34680,36624,49920,49944,52608,52392,52368,
     8  52224,52032,51960,51528,51432,51288,51312,51096,50736,50712,
     9  50664,50568,50496,50400,44088,50160,50280,46008,46200,46392/
            data (jx(i),i=  901, 1000)/
     +  46800,47016,47280,47496,47904,48720,48648,49872,49416,49104,
     1  46032,48072,48576,44448,21288,43632,46776,46776,42432,36624,
     2  37968,38472,39864,40416,22728,41736,23184,24624,25128,50088,
     3  50232,26520,27024,28416,28920,48672,30312,30864,32256,50496,
     4  32784,34680,34152,50304,36072,36624,50352,50448,50352,50328,
     5  45792,45648,45768,45264,44448,43632,44448,51072,51552,51984,
     6  52128,52296,52416,52560,46920,46080,46392,46440,46704,46776,
     7  50376,47064,47088,47496,48048,48432,48528,48576,48648,48696,
     8  48720,50160,49944,49320,48840,48960,49008,49104,49128,49224,
     9  49248,43632,41760,41568,22656,22680,39864,39624,37944,24576/
            data (jx(i),i= 1001, 1100)/
     +  26472,28368,30264,36072,36432,32184,32232,37944,34080,34152,
     1  50880,50616,50496,50400,50976,51096,51144,51240,49368,50568,
     2  50784,51720,51600,51600,51408,47664,47112,45336,43944,43728,
     3  43752,43992,44184,44040,39648,41592,36168,36456,38424,39024,
     4  39648,49416,47640,47568,47640,47544,47664,40200,40200,40920,
     5  40752,40896,40920,40728,40560,40584,40344,40536,40440,40344,
     6  40200,40152,40104,40176,40104,40224,20400,39720,39696,39816,
     7  39816,40008,40032,47784,22296,22584,24216,24504,26112,26448,
     8  27768,28320,38736,42312,29928,30240,31848,32160,33768,34080,
     9  34800,42144,51192,51072,50904,50832,50880,44544,44568,44736/
            data (jx(i),i= 1101, 1200)/
     +  44904,45072,45000,45048,45240,45192,45264,45408,45456,45456,
     1  38208,12288,12336,12312,12216,43008,51216,51432,37464,37296,
     2  37008,49440,43824,51528,51672,16008,16128,16128,16224,16248,
     3  16344,16344,16536,16632,16824,17016,17112,17280,17232,17328,
     4  42216,41808,18288,53232,52824,27696,20352,20448,35736,29904,
     5  22248,22176,37632,36504,36384,24144,39120,26064,53496,46488,
     6  46488,46416,46320,46200,46152,46200,46128,46056,46056,45744,
     7  45768,45696,45792,45696,45696,45648,45576,45648,45576,45528,
     8  45432,45504,45432,46704,46608,46632,46776,46728,46776,46656,
     9  46608,46632,46584,48408,48456,48360,48360,48144,48168,48048/
            data (jx(i),i= 1201, 1300)/
     +  48072,47928,47904,47736,47808,47712,47688,47784,47736,47808,
     1  47736,49440,49416,49296,49224,49080,49032,49080,48912,48912,
     2  48816,48480,39720,39384,49944,49824,49848,49728,49584,49536,
     3  49680,49488,30360,29904, 8496, 8472, 8472, 8352,53112,53088,
     4  53112,53040,53136,53040,53256,26064,27552,27576,52008,52056,
     5  51984,52056,51984,51960,52032,51960,52008,31800,46992,46992,
     6  26040,46680,46752,46680,46800,46848,46992,46944,47016,47040,
     7  46968,46944,46872,46776,46776,46704,46776,46608,46632,42720,
     8  50136,50880,50976,51024,51144,51192,51336,51456,51552,51768,
     9  32256,32496,32592,32664,32736,32880,32832,32856,33024,33000/
            data (jx(i),i= 1301, 1400)/
     +  33168,33216,33216,33336,33576,33744,34560,35352,35376,34536,
     1  34632,34632,34728,34776,34992,35064,35352,35352,35448,35424,
     2  35544,35544,35640,35592,35616,35808,35880,35832,35928,35904,
     3  35976,36048,36000,35904,36024,36072,36144,31824,31848,31920,
     4  31992,31920,32064,31968,32064,32160,32232,32184,33792,33816,
     5  33888,34056,34080,34152,37584,34368,34440,49632,44856,17496,
     6  17616,17688,17664,17712,17664,17760,17736,17832,18264,18312,
     7  18576,18624,18816,19296,19344,19488,37248,44520,20376,40416,
     8  20016,19992,20184,40968,47880,53568,40728,38592,43512,50112,
     9  50040,49992,49872,49944,49872,49848,49632,15360,53064,52776/
            data (jx(i),i= 1401, 1500)/
     +  52224,52272,52416,52560,51624,51144,51024,50952,50880,50832,
     1  50760,22104,21840,20472,20568,20784,21072,21120,21360,21624,
     2  21648,21768,42648,24096,51600,51840,51960,52080,52152,52224,
     3  52368,52416,52368,52392,52536,52488,52632,52848,52848,51504,
     4  25992,27144,28176,28200,30336,32232,38592,36600,36456,36552,
     5  36504,36552,36408,36312,36216,36288,36360,36216,36216,36144,
     6  44520,44544,44496,44712,44832,44784,44880,44856,45120,45576,
     7  45864,41760,45000,44976,45144,47232,47064,47160,47040,47064,
     8  46968,47136,34152,32688,32232,36600,36696,36552,36600,36528,
     9  34656,34152,38904,47904,47976,47976,48120,48024,48048,48216/
            data (jx(i),i= 1501, 1600)/
     +  48264,48312,47184,46824,46512,46296,48816,48384,48600,48672,
     1  48672,17232,52824,48240,41040,40848,39672,42720,42696,42792,
     2  42816,42864,42864,42960,42888,42936,43032,43032,43200,43152,
     3  43224,43176,43392,43368,43440,43488,43416,43464,17760,43680,
     4  44064,44424,43560,27144,30312,32664,30312,22200,22488,22536,
     5  22560,22728,22944,23040,23304,23688,23664,23784,23832,23904,
     6  23928,24048,24072,46464,47352,38400,38088,52872,52992,53040,
     7  53088,53136,53016,53136,51288,50832,50832,42192,50592,51336,
     8  49056,49032,49080,49152,49152,49368,49440,49440,49536,49488,
     9  49560,49464,50232,50232,50112,50208,37800,37896,37896,37800/
            data (jx(i),i= 1601, 1700)/
     +  51792,51192,32664,33360,36072,34656,36552,36672,36672,36840,
     1  36648,36624,36864,36696,36744,36600,36744,36744,36864,36936,
     2  36936,16392,16008,41448,41016,49008,38184,38424,38544,38544,
     3  38664,38760,38856,39120,39432,39480,39600,39816,39936,39984,
     4  40152,40656,40800,43536,43872,43920,43968,43992,44160,44232,
     5  44256,44352,44448,44424,44592,44592,44544,44592,44712,44736,
     6  44736,44784,44712,44688,49320,48456,48720,48864,48792,45096,
     7  45192,45192,45144,45168,45120,45216,45360,45528,45408,45384,
     8  45288,45264,45264,45168,45144,44832,37608,43392,53808,53808,
     9  43224,42984,42840,42432,42432,42360,53016,52944,53088,52992/
            data (jx(i),i= 1701, 1800)/
     +  53016,53064,24360,24504,24480,24528,24408,24360,24312,24192,
     1  24240,24168,24456,24456,24216,24072,27144,28104,43248,43104,
     2  43056,42864,30288,31656,33360,46584,45504,45384,45480,45480,
     3  45528,45480,45552,45504,52992,53088,53016,52680,52560,52416,
     4  52344,51936,53064,53160,53112,53352,53376,53496,53544,53568,
     5  53616,53736,53784,54024,54096,43008,43152,43272,43296,43416,
     6  43416,43488,43464,43536,33360,34800,36072,46632,20976,21000,
     7  21744,21792,22656,22656,45480,45456,45240,45288,45192,45216,
     8  45144,45144,45288,45264,45360,45312,48696,48600,48504,48504,
     9  48336,48096,48072,47808,47784,47592,47448,47304,47136,31632/
            data (jx(i),i= 1801, 1900)/
     +  40224,39624,43632,43680,44784,45240,41304,41784,42000,42000,
     1  42696,37176,39384,43728,51816,49776,49512,49488,49560,49680,
     2  49752,49704,36744,32160,31896,31896,38688,38688,38760,46584,
     3  46008,46368,46464,40896,34800,33816,33264,43848,44328,44544,
     4  44592,44736,44880,44928,45168,45264,46032,45792,45456,45456,
     5  45528,45552,45480,45552,45432,45504,45432,45408,45456,45432,
     6  45552,45480,45528,45432,45552,45744,38304,38160,35856,36096,
     7  36216,36408,36624,36648,36768,36888,36984,37008,36864,36864,
     8  36984,37008,37128,35328,35256,38904,38952,39000,39048,39120,
     9  39192,39192,39336,39288,39456,39720,42600,52152,41592,41640/
            data (jx(i),i= 1901, 2000)/
     +  39840,52128,51984,51936,51672,51576,51432,50664,50544,50424,
     1  50088,49824,49680,45528,45576,45888,45840,45864,45720,45744,
     2  45864,45792,45864,45840,28056,47424,48144,30288,30816,30720,
     3  30576,30648,30576,30624,30552,30648,32160,32928,49800,49944,
     4  50064,50064,50016,50040,49944,50016,49872,49704,49704,49824,
     5  48672,48744,48792,48936,37968,49536,49392,49368,49152,49032,
     6  49008,34536,34584,34584,34632,34800,37800,37872,37848,37680,
     7  37632,37608,37560,37464,37464,37320,37344,37176,41256,41376,
     8  38952,37968,37896,46560,46728,46752,46872,47376,47424,47520,
     9  47568,47592,47688,47664,48000,45696,45768,45744,45864,45720/
            data (jx(i),i= 2001, 2100)/
     +  45720,45816,46056,46080,46200,46128,46176,46344,46440,42720,
     1  42768,42936,43800,43440,46464,43488,44640,44784,35256,28056,
     2  27984,27840,27864,27792,38880,39360,48888,49584,49320,42240,
     3  39816,36768,30264,35256,32928,42432,44832,46104,46584,46608,
     4  46560,46608,46848,46800,46896,46896,47328,47376,47616,47640,
     5  47904,37632,41016,40008,40560,40872,39288,37968,42816,42984,
     6  43200,43320,43248,43320,43344,43440,43488,44784,44424,44448,
     7  44376,43896,43824,43800,43560,38328,39216,38880,38664,35256,
     8  30240,32976,33000,37056,37056,41040,41184,41208,41280,41256,
     9  41352,41568,41520,41520,41592,41568,41616,43512,43272,42744/
            data (jx(i),i= 2101, 2200)/
     +  42480,42576,42624,42504,42360,42120,42096,42000,42000,41880,
     1  41904,41808,37080,40776,39408,39528,39744,40056,40080,40200,
     2  40224,40344,40488,40584,40680,40680,42792,42936,43032,43128,
     3  43032,42840,42768,42888,43008,43032,42888,41232,41640,42144,
     4  42144,42000,41832,41736,41736,30216,33000,39120,38016,40176,
     5  40080,41112,41088,41016,41016,40992,40776,40776,40680,40680,
     6  40656,40584,40608,40512,40536,40416,40416,40272,38784,38760,
     7  37464,35280,33000,38928,39120,39168,41736,41904,41976,42096,
     8  42048,39072,39144,39192,39288,39288,39720,39960,40128,40296,
     9  40344,40224,40320,40392,40464,40488,40512,40944,40872,41208/
            data (jx(i),i= 2201, 2270)/
     +  41400,41376,41304,41496,38616,38640,38832,39000,41016,41328,
     1  35280,38472,38544,38592,39096,39096,39240,39480,39744,40320,
     2  36360,36360,36264,36240,36096,36096,35976,35976,34680,33216,
     3  33072,37488,35280,38184,38160,38472,38472,37152,34680,36768,
     4  36288,36336,36456,36456,36552,36576,36744,38592,38472,38952,
     5  34464,38976,40272,40296,40368,40392,40608,40656,40824,38568,
     6  38472,38424,38952,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  57456,57384,57336,57288,57552,55608,57264,55320,53712,53424,
     1  51816,51528,49896,49632,48792,48000,48888,48864,48696,48288,
     2  48024,47976,48168,48144,48048,47232,47256,47208,47304,47520,
     3  47808,48000,48072,48168,48336,48288,48120,48000,47976,47040,
     4  46872,46896,47040,47016,46632,46656,46224,46032,45936,45648,
     5  45600,45624,45840,45792,45912,45816,46008,46008,45768,45624,
     6  45408,45240,45168,45288,45552,45648,45744,45792,45720,45744,
     7  45960,46224,46152,46944,47016,46896,47064,46944,46800,46704,
     8  46608,46560,46416,46344,46392,46320,46128,46056,45960,45888,
     9  45864,45816,45816,45936,45864,46080,46032,46128,46200,46272/
            data (jy(i),i=  101,  200)/
     +  46248,46032,46104,46032,46080,46008,46008,46032,46104,46056,
     1  45744,45768,45888,46008,46128,46344,46296,46224,46248,46032,
     2  45960,46224,45792,45888,45864,45696,45744,46080,46008,46008,
     3  45816,45768,45672,45672,45480,45504,45288,46056,46224,46104,
     4  46128,46320,46416,46344,46200,46272,46128,46128,46248,46032,
     5  46056,45984,46056,45888,45816,45816,45696,45552,45504,45624,
     6  45600,45504,45528,45432,45456,45120,45120,45456,45384,45432,
     7  45696,45696,45792,45768,45840,45792,45888,45816,45936,45888,
     8  45888,46008,43992,43608,44832,44856,44880,44928,44808,44880,
     9  44880,44928,44976,44928,44880,44832,44856,44808,44832,44952/
            data (jy(i),i=  201,  300)/
     +  44808,44832,44904,44928,44784,44856,44760,44736,44808,44904,
     1  44832,44952,44976,45168,45144,45048,45096,45024,45144,45072,
     2  45216,45144,45312,45216,45312,45192,45240,45264,45336,45312,
     3  45480,42096,41904,41088,39768,40200,35808,35856,36192,36552,
     4  36624,36936,37416,37488,37488,37560,37776,37872,38208,38280,
     5  38328,38520,38544,38640,38472,38280,38256,38064,38064,38016,
     6  37968,37968,37920,37728,37680,37584,37608,37272,37128,37008,
     7  36816,36792,36648,36552,36288,36048,36048,35976,35976,35880,
     8  35856,35784,35736,35688,35664,35568,35496,35352,35376,35304,
     9  35088,34920,34776,34776,34560,32304,35688,35472,35448,35352/
            data (jy(i),i=  301,  400)/
     +  35328,34920,34776,34752,34368,33960,33840,33744,33480,33312,
     1  33264,33120,33192,33048,33072,33000,33024,32904,32904,32832,
     2  32808,32544,32520,34488,34584,34584,34440,34296,34176,34056,
     3  34008,33912,33768,33648,33600,33480,33408,33336,33264,33024,
     4  32736,32712,32424,32136,31992,31872,31728,31656,31536,31272,
     5  31248,31080,30816,30696,30624,30432,28824,30288,30144,30024,
     6  30048,30000,29760,29760,29640,29664,29472,29304,28560,28512,
     7  28440,28488,28416,28392,28416,28320,28176,28128,28200,28176,
     8  28272,28176,28176,28128,28200,28128,28224,28200,28128,28080,
     9  28128,28080,28488,28152,27936,27888,27360,28008,28032,27984/
            data (jy(i),i=  401,  500)/
     +  28032,28032,28128,28200,28176,28032,28104,27912,28008,27912,
     1  27840,27744,27696,27480,27528,27480,27168,27144,27360,27360,
     2  27120,26928,26880,26712,26640,26232,26136,25944,25848,25752,
     3  25656,32184,32136,31968,31632,31416,31320,31176,31104,30936,
     4  30792,30624,30600,30480,30168,30024,29808,29568,29520,29352,
     5  29256,29184,29040,29016,28752,28704,28464,28104,28080,28032,
     6  27816,27840,27648,27480,27312,26424,26544,26712,26904,27072,
     7  27168,27384,27384,27552,27720,27816,28032,27984,28056,28128,
     8  28008,28104,28176,28056,28440,28512,28488,26088,27288,27336,
     9  27216,27096,27120,26976,26712,26616,26400,26256,26040,25920/
            data (jy(i),i=  501,  600)/
     +  25944,25728,25656,25608,25584,25248,25176,25200,25080,24960,
     1  25056,25032,24984,24960,24888,24864,24768,24840,24768,24792,
     2  24720,24768,24912,25080,25080,25224,25248,25608,25632,25584,
     3  25656,25752,25704,25776,25848,25944,26328,26352,26712,26520,
     4  26304,25416,25128,24960,25080,25368,25464,23976,24744,24456,
     5  24288,24192,24264,23280,22464,22056,21720,21240,20520,24360,
     6  24264,24216,24168,23856,23832,23736,23544,23448,23112,23016,
     7  22896,22776,22608,22464,22416,22296,22176,21936,21600,21432,
     8  21264,21240,21096,19680,18408,17784,17112,17016,20952,20856,
     9  20592,20496,20184,20136,19968,19800,19656,19512,19344,19320/
            data (jy(i),i=  601,  700)/
     +  19200,19224,19032,19008,18720,18768,18720,18600,18576,18648,
     1  18648,18552,18480,18480,18288,18024,18024,17952,17328,17232,
     2  17160,17016,16968,16584,15768,15120,14160,13344,13992,14616,
     3  14784,14904,15192,15312,15480,15600,15744,15912,15936,16104,
     4  16224,16320,16608,12624,13848,13752,13608,13512,13344,13224,
     5  13272,13200,13224,13104,13200,13032,13080,13080,12912,12888,
     6  12840,12792,12744,12696,12672,12576,12528,12552,12624,12624,
     7  12576,11784,12528,12528,12456,12552,12480,12504,12456,12480,
     8  12408,12384,12456,12456,12360,12168,12240,12144,12216,12072,
     9  11952,12024,12048,12000,11928,11736,11808,11712,11808,11760/
            data (jy(i),i=  701,  800)/
     +  11760,11808,11640,11688,11784,11760,11784,11736,11784,11712,
     1  11784,11712,11760,11712,11784,11736,11664,11640,11712,11616,
     2  11616,11664,11616,11664,11616,11664,11592,11640,11544,11544,
     3  11472,11424,11352,11352,11280,11304,11232,11232,11040,11064,
     4  11016,11040,10992,11016,10896,10824,10920,10824,10848,10968,
     5  10992,11040,11160,11232,11184,11232,11256,11352,11304,11376,
     6  11328,11352,11832,55512,55440,55392,55368,53568,53616,53544,
     7  53520,53496,53472,51696,51696,51624,51576,51552,49824,49800,
     8  49776,49728,49728,49680,49680,49656,49656,47928,47928,47880,
     9  47856,47832,47832,47784,47784,47760,47760,47736,47352,46704/
            data (jy(i),i=  801,  900)/
     +  46776,46776,46632,43872,45816,45744,45720,45696,45672,45672,
     1  45672,47376,47424,45624,45624,45624,44184,45192,45648,45552,
     2  45600,45576,45504,45528,45480,45552,45480,45600,45528,45552,
     3  45432,45408,45480,45432,45456,45408,45408,45360,45336,44040,
     4  44016,43944,43920,43896,43920,43944,43944,44016,43968,43992,
     5  43920,43992,43944,43920,43656,43896,43872,44304,44256,44280,
     6  44040,43920,43848,43848,43848,43848,43824,43800,43752,43728,
     7  43728,43728,43728,43728,43728,43848,43704,43728,43752,43680,
     8  43752,43680,43440,43512,43488,43560,43608,43632,43488,43416,
     9  43464,43392,43440,43536,43584,43656,43656,43104,43224,43464/
            data (jy(i),i=  901, 1000)/
     +  43536,43752,43728,43800,43800,42408,42312,42216,42600,42600,
     1  42096,42072,42096,42048,42048,42024,42024,42096,42024,42024,
     2  42024,42024,42000,42000,42000,42000,41976,41952,41928,41976,
     3  41904,41880,41880,41856,41856,41832,41832,41832,41808,41808,
     4  41808,41808,41808,41808,41808,41784,41640,41616,41544,41424,
     5  41472,41664,42072,41448,41424,41304,41304,40992,41040,41304,
     6  41088,41064,41256,41088,40944,41184,41184,41112,41040,40944,
     7  40824,40872,40800,40512,40488,40320,40368,40248,40296,40272,
     8  40368,40824,40512,40248,40248,40320,40248,40272,40224,40296,
     9  40176,40104,40104,40104,40104,40104,40080,40080,40080,40056/
            data (jy(i),i= 1001, 1100)/
     +  40008,39960,39936,39888,39888,39888,39888,39888,39888,39888,
     1  39696,39696,39816,39792,39744,39672,39720,39696,39528,39576,
     2  39552,39432,39504,39600,39576,39408,39912,39336,39312,40032,
     3  39720,39528,39192,39216,39048,38856,38760,38928,38664,39048,
     4  38568,38520,38448,38496,38640,38880,39120,38424,38472,36576,
     5  36744,36912,37008,36984,37104,37224,37368,37608,37632,37776,
     6  37728,37776,37920,38088,38232,38376,38256,38544,38448,38448,
     7  38328,38256,38376,38232,38208,38184,38160,38136,38112,38112,
     8  38064,38040,38040,38040,38016,38016,38016,38016,37992,37992,
     9  37992,37944,37872,39144,38880,38328,37848,39048,38856,38832/
            data (jy(i),i= 1101, 1200)/
     +  38664,38688,38496,38448,38424,38208,38112,38160,37824,37800,
     1  37728,33768,33768,33528,32448,36936,37656,37320,37272,37536,
     2  37392,37248,36864,37176,36480,37992,37992,37848,37800,37608,
     3  37584,37440,37536,37032,36888,36912,36768,36696,36600,36480,
     4  36456,37104,36432,36168,36384,36360,36360,36360,36336,36312,
     5  36312,36312,36936,36264,36432,36240,36240,36192,36360,36144,
     6  36456,36384,36480,36456,36504,36576,36744,36720,36792,36864,
     7  37032,37128,37248,37248,37200,37272,37248,37416,37608,37560,
     8  37608,37632,37704,35664,35784,35856,35880,36000,36144,36312,
     9  36264,36144,36072,36096,36192,36264,36456,36624,36696,36672/
            data (jy(i),i= 1201, 1300)/
     +  36768,36840,37080,37176,37536,37632,37752,37920,37992,38040,
     1  38136,35424,35496,35496,35592,35592,35664,35760,35904,35976,
     2  36072,36024,35856,36408,35856,35976,36072,36072,36480,36816,
     3  36888,36984,35832,35832,35880,35880,36192,36192,34272,34344,
     4  34800,35016,35304,35472,35736,35808,35784,36384,36216,35856,
     5  35568,35400,35376,35232,34968,34800,34632,35784,35760,35808,
     6  35640,35592,35520,35448,35448,35184,35040,34968,34968,34848,
     7  34848,34728,34752,34632,34464,34344,34152,34032,33864,35616,
     8  35688,35520,35568,35496,35496,35352,35400,35304,35016,34944,
     9  35424,35376,35136,35208,35112,35232,35280,35352,35280,35208/
            data (jy(i),i= 1301, 1400)/
     +  35160,35208,35112,35088,35376,35304,35376,35952,36264,35304,
     1  35256,35184,35280,35160,35208,35064,35088,34920,34968,35016,
     2  35136,35064,35040,34800,34752,34896,34800,34656,34704,34632,
     3  34632,34704,34536,34464,34392,34440,34296,35736,35784,35688,
     4  35688,35592,35616,35448,35448,35328,35376,35472,35328,35256,
     5  35304,35256,35304,35232,35304,35400,35328,35232,35208,36384,
     6  36408,36360,36096,35976,35832,35688,35616,35472,35448,35400,
     7  35448,35304,35184,35160,35232,35184,35112,34968,34800,34728,
     8  34920,34872,34704,34536,33720,34392,34368,33576,34344,34200,
     9  34248,34632,34680,34800,34848,35016,35064,34200,34176,34128/
            data (jy(i),i= 1401, 1500)/
     +  34512,34440,34416,34224,33768,33888,33912,33984,33984,34032,
     1  33984,33840,33840,34728,34848,34944,34632,34680,34608,34392,
     2  34032,33840,33816,33792,33648,33792,33816,33744,33840,33744,
     3  33720,33600,33624,33504,33360,33240,32832,32664,32544,33744,
     4  33744,33720,33696,35616,33672,33648,33456,33384,33528,33624,
     5  33696,33768,33792,33672,33768,33960,34008,34032,34128,34128,
     6  34632,34608,34488,33768,33624,33456,33384,33288,33384,33720,
     7  33840,33288,33144,33024,32640,33168,33792,33624,33600,33504,
     8  33408,33144,33024,33024,33000,32952,33000,33120,33216,33312,
     9  32928,32928,32904,33216,33216,33072,33000,32976,32880,32880/
            data (jy(i),i= 1501, 1600)/
     +  32952,32880,33048,33048,32880,32856,32760,33048,33096,33024,
     1  32832,32592,32520,31368,32832,32256,32736,33696,33600,33624,
     2  33576,33576,33384,33360,33192,33048,33000,32904,32952,32904,
     3  32856,32760,32544,32424,32400,32304,32256,32184,32136,32064,
     4  32256,32952,32184,32040,32040,32016,32016,33600,33576,33456,
     5  33528,33432,33384,33432,33360,33072,32928,32808,32352,32328,
     6  32112,32040,31920,31824,31344,32328,31656,32328,32328,32184,
     7  32232,32160,31848,31632,31536,33576,33648,31416,31368,31392,
     8  32592,32280,32208,32184,32040,32136,32136,32064,32040,32016,
     9  31848,31728,31584,31512,31416,31344,31080,31080,30984,30792/
            data (jy(i),i= 1601, 1700)/
     +  29760,29736,31104,31104,31080,31080,32760,32688,32592,32520,
     1  32400,32232,32136,31992,31872,31848,31536,31392,31416,31368,
     2  31056,31032,31056,30984,32184,30672,31584,31656,31584,31416,
     3  31392,31320,30984,30816,30984,31032,31032,31128,31104,31032,
     4  31080,30792,30720,31800,31752,31704,31728,31656,31536,31584,
     5  31392,31344,31392,31272,31104,31080,31104,31008,30960,30984,
     6  30888,30840,30816,30696,29904,30912,30816,30696,30552,32520,
     7  32400,32232,32136,31968,31680,31512,31008,30936,30864,30720,
     8  30720,30504,30672,30696,30768,30600,30456,30288,30408,33504,
     9  30408,30408,30696,31008,31128,31344,30384,31176,30840,30648/
            data (jy(i),i= 1701, 1800)/
     +  30456,30456,31872,31752,31608,31464,31320,31080,31032,31080,
     1  30984,30888,30600,30528,30504,30288,30240,30216,30072,30048,
     2  29856,29688,30192,30168,30168,30144,30048,30384,30408,30336,
     3  30312,30192,30120,30096,30264,30192,30024,30120,30024,30024,
     4  29808,29712,29904,29880,29664,29616,29448,29376,29424,29352,
     5  29400,29304,29328,29232,29016,29592,29616,29712,29640,29640,
     6  29568,29472,29328,29232,29520,29520,29520,29472,29376,30336,
     7  30336,31728,31704,31968,30000,30048,29928,29688,29712,29664,
     8  29640,29544,29520,29400,29352,29352,29280,29256,29280,29352,
     9  29472,29544,29640,29616,29736,29856,29712,29688,29544,29256/
            data (jy(i),i= 1801, 1900)/
     +  29856,29256,29304,29280,29448,29280,30456,30096,29208,29136,
     1  29520,29088,29040,28824,28776,28680,29400,29208,29136,29136,
     2  29016,28824,28680,28560,28560,29256,28416,28296,28320,28152,
     3  29760,29592,29448,28032,27984,28512,28560,28632,28272,28248,
     4  28296,27984,27792,27600,27528,27456,27888,27888,29280,29184,
     5  29160,29064,29040,28896,28896,28800,28824,28800,28680,28584,
     6  28536,28464,28416,28344,28224,28176,27864,28272,27816,27792,
     7  27864,27768,27768,27696,27816,27696,27744,27672,27624,27504,
     8  27408,27264,27168,27672,27600,28224,27984,28008,27864,27888,
     9  27816,27696,27672,27624,27504,27432,27384,28776,27360,27432/
            data (jy(i),i= 1901, 2000)/
     +  27336,27528,27504,27384,27264,27240,27384,27120,27240,27096,
     1  27000,27072,27216,27408,27312,27792,27792,27672,27672,27600,
     2  27600,27576,27504,27312,27312,27648,27312,27288,29280,28560,
     3  28248,28032,27960,27816,27696,27288,27288,27288,28584,28464,
     4  28440,28392,28296,28152,27960,27816,27792,27648,27552,27432,
     5  27384,27360,27216,27216,27552,27264,27144,27048,26976,27096,
     6  27240,27264,27216,27000,26976,27000,26472,26568,26664,26664,
     7  26736,26688,26832,26856,26952,26976,26928,27000,26280,27144,
     8  26232,26232,26184,25848,26040,26016,26136,26040,26184,26184,
     9  26232,26424,26472,26664,26664,27264,27120,26928,26904,26856/
            data (jy(i),i= 2001, 2100)/
     +  26760,26640,26496,26376,26256,26208,26160,26112,25896,27336,
     1  27144,27144,26136,25752,25704,25680,26448,26928,25656,26544,
     2  26112,26040,25848,25656,26112,25560,26832,25680,25176,25080,
     3  25056,25032,24936,24936,24936,24864,24504,25320,25608,25488,
     4  25392,25296,25008,24840,24720,24648,24504,24336,24144,24024,
     5  24048,24048,24000,23784,24264,24144,24600,23640,24696,24288,
     6  24144,24000,23856,23832,23664,23616,23424,23256,23232,23424,
     7  23376,23376,23280,23448,23376,23232,23136,23208,23352,23016,
     8  22992,22992,22992,22872,23016,23904,23928,23976,23976,24024,
     9  23976,23664,23472,22848,22800,22752,22632,23352,23208,23040/
            data (jy(i),i= 2101, 2200)/
     +  22824,22704,22488,22392,22464,22488,22608,22584,22656,22632,
     1  22584,22656,20472,21936,22944,22608,22512,22488,22200,22176,
     2  22104,22128,22008,22032,22008,21936,22344,22152,22224,22128,
     3  22032,22176,22104,21936,21864,21672,20784,20568,20664,21072,
     4  21144,21144,21240,21360,21456,21096,21072,21000,23088,20928,
     5  20784,20760,20712,20736,20832,20760,20832,20784,20808,20712,
     6  20760,20736,20856,20808,20880,20928,21024,20904,20472,20736,
     7  20472,20448,20328,20376,20400,20208,19824,20136,20160,19776,
     8  19680,20112,19896,19968,19944,19896,19896,19608,19632,19536,
     9  19560,19656,19728,19632,19632,19704,19656,19728,19608,19728/
            data (jy(i),i= 2201, 2270)/
     +  19584,19536,19536,19464,18648,19728,18576,18312,18336,18432,
     1  17400,16776,16800,16872,16968,17040,17112,17040,17112,17040,
     2  17016,17328,17328,17424,17424,17328,17328,17400,17016,17016,
     3  17160,17016,16992,16992,18624,16992,14928,14904,14904,14904,
     4  17016,16968,16896,16488,16488,16104,16104,14184,14184,14112,
     5  14424,13032,12840,12936,12888,12984,12960,13104,13344,13848,
     6  13848,13512,13440,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    1,    5,    4,    7,    6,    8,    9,
     1     10,   11,   12,   14,   13,   15,   17,   18,   19,   20,
     2     21,   22,   23,   24,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   25,   26,   40,
     4     41,   42,   43,   44,   45,   48,   49,   50,   51,   52,
     5     53,   54,   55,   56,   57,   58,   59,   60,   61,   62,
     6     63,   64,   65,   66,   67,   68,   69,   70,   71,   72,
     7     47,   46,   74,   75,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   16,   92,
     9     93,   94,   95,   96,   97,   98,   99,  100,  101,  102/
            data (jb1(i),i=  101,  200)/
     +    103,  104,  105,  106,  107,  108,  109,   90,  111,  112,
     1    113,  114,  115,  116,  117,  118,  119,  120,   48,   47,
     2    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     3    132,  133,  134,  135,  136,  110,  138,  139,  140,  141,
     4    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     6    162,  163,  164,  137,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8     92,   91,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb1(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  165,
     3    183,  184,  233,  234,  232,  237,  238,  239,  240,  241,
     4    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     5    252,  253,  254,  236,  255,  257,  258,  235,  260,  259,
     6    262,  256,  261,  264,  265,  266,  267,  268,  269,  270,
     7    271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
     8    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     9    291,  292,  293,  294,  237,  297,  298,  299,  300,  301/
            data (jb1(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     1    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     2    322,  296,  295,  324,  325,  326,  327,  328,  329,  330,
     3    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,  353,  354,  355,  356,  358,  359,  360,  361,
     6    362,  363,  364,  365,  366,  367,  357,  369,  370,  371,
     7    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     8    382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
     9    357,  393,  394,  395,  396,  392,  398,  399,  400,  401/
            data (jb1(i),i=  401,  500)/
     +    402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
     1    412,  413,  414,  415,  416,  417,  418,  419,  420,  421,
     2    422,  423,  424,  425,  426,  427,  428,  429,  430,  296,
     3    432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
     4    442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
     5    452,  453,  454,  455,  456,  457,  458,  459,  460,  461,
     6    462,  463,  397,  466,  467,  468,  469,  470,  471,  472,
     7    473,  474,  475,  476,  477,  478,  479,  480,  481,  482,
     8    483,  484,  485,  486,  369,  464,  489,  490,  491,  492,
     9    493,  494,  495,  496,  497,  488,  488,  499,  500,  501/
            data (jb1(i),i=  501,  600)/
     +    502,  503,  504,  505,  506,  507,  508,  509,  510,  511,
     1    512,  513,  514,  515,  516,  517,  518,  519,  520,  521,
     2    522,  523,  524,  525,  526,  527,  528,  529,  530,  531,
     3    532,  533,  534,  535,  536,  537,  466,  465,  539,  540,
     4    541,  542,  544,  545,  546,  431,  543,  549,  550,  551,
     5    552,  548,  548,  554,  555,  556,  557,  558,  544,  560,
     6    561,  562,  563,  564,  565,  566,  567,  568,  569,  570,
     7    571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
     8    581,  582,  559,  584,  585,  586,  583,  589,  590,  591,
     9    592,  593,  594,  595,  596,  597,  598,  599,  600,  601/
            data (jb1(i),i=  601,  700)/
     +    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     1    612,  613,  614,  615,  616,  617,  618,  619,  620,  621,
     2    622,  588,  587,  624,  625,  626,  627,  629,  630,  631,
     3    632,  633,  634,  635,  636,  637,  638,  639,  640,  641,
     4    642,  588,  629,  645,  646,  647,  648,  649,  650,  651,
     5    652,  653,  654,  655,  656,  657,  658,  659,  660,  661,
     6    662,  663,  664,  665,  666,  667,  668,  669,  670,  644,
     7    644,  673,  674,  675,  676,  677,  678,  679,  680,  681,
     8    682,  683,  684,  685,  686,  687,  688,  689,  690,  691,
     9    692,  693,  694,  695,  696,  697,  698,  699,  700,  701/
            data (jb1(i),i=  701,  800)/
     +    702,  703,  704,  705,  706,  707,  708,  709,  710,  672,
     1    672,  712,  713,  714,  715,  716,  717,  718,  719,  720,
     2    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     3    731,  732,  733,  734,  735,  736,  737,  738,  739,  740,
     4    741,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     5    751,  752,  753,  754,  755,  756,  757,  758,  759,  760,
     6    761,  762,  628,    1,    6,    2,  764,    3,  765,    4,
     7    766,  767,  765,  764,    9,  769,  768,  766,  768,  771,
     8    767,  772,  773,   11,  769,  774,  770,  775,  772,  776,
     9    773,  777,  778,   13,  774,  779,  780,  776,  781,  782/
            data (jb1(i),i=  801,  900)/
     +    777,  783,  784,  778,  785,  786,  787,   16,  779,  788,
     1    789,  781,  790,  791,  783,  792,  793,  785,  794,  795,
     2    787,  796,   15,  797,  798,   25,  799,  801,  802,  800,
     3     47,  788,   91,  790,  805,  792,  806,  794,  807,  796,
     4    808,  810,  810,  812,  799,  809,   46,  814,   26,  815,
     5    800,   92,  816,  811,  819,  820,  821,  822,  823,  824,
     6    825,  826,  827,  828,  829,  830,  831,  832,  833,  834,
     7    835,  836,  837,  838,  818,   90,  840,  814,  817,   48,
     8    843,  805,  183,  846,  847,  848,  849,  850,  851,  852,
     9    843,  804,  842,  840,  844,  110,  817,  858,  859,  860/
            data (jb1(i),i=  901, 1000)/
     +    861,  857,  806,  845,  137,  864,  804,  857,  853,  807,
     1    863,  808,  867,  809,  868,  165,  811,  869,  871,  818,
     2    872,  815,  873,  841,  874,  846,  876,  870,  184,  878,
     3    879,  880,  881,  882,  883,  884,  885,  886,  887,  888,
     4    889,  890,  891,  892,  893,  864,  855,  870,  896,  894,
     5    898,  899,  900,  901,  902,  903,  904,  857,  842,  853,
     6    906,  846,  908,  909,  906,  898,  912,  907,  857,  855,
     7    845,  232,  914,  912,  917,  911,  916,  865,  875,  920,
     8    844,  921,  922,  854,  923,  915,  924,  919,  863,  925,
     9    927,  867,  928,  908,  930,  929,  868,  932,  933,  869/
            data (jb1(i),i= 1001, 1100)/
     +    934,  931,  907,  935,  872,  937,  938,  233,  894,  873,
     1    939,  874,  942,  941,  940,  931,  942,  945,  920,  944,
     2    947,  948,  949,  951,  952,  911,  951,  954,  914,  956,
     3    955,  916,  950,  958,  959,  960,  961,  962,  963,  234,
     4    917,  951,  966,  967,  968,  969,  965,  950,  965,  972,
     5    973,  974,  975,  976,  977,  978,  979,  980,  936,  971,
     6    982,  983,  981,  985,  986,  987,  988,  989,  990,  984,
     7    956,  992,  926,  993,  236,  925,  995,  994,  923,  997,
     8    998,  921,  928,  996,  932, 1000,  934, 1001,  937, 1002,
     9    945, 1004, 1003,  939, 1006,  999, 1005, 1007, 1004,  943/
            data (jb1(i),i= 1101, 1200)/
     +   1009, 1011, 1012, 1013,  971, 1011, 1015, 1016, 1017, 1019,
     1   1020, 1011,  984,  235, 1022, 1023, 1024, 1018, 1026,  973,
     2   1026,  954, 1028,  992, 1030, 1031, 1029, 1033, 1029,  998,
     3    994, 1037, 1005, 1039, 1035, 1008, 1035, 1019, 1042, 1043,
     4   1044, 1045, 1046, 1026, 1048, 1036, 1050, 1051, 1052, 1053,
     5   1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063,
     6   1064, 1065, 1048,  256, 1041, 1068, 1069, 1070, 1071, 1072,
     7   1048, 1043, 1067,  995, 1075, 1076, 1000, 1077, 1078, 1001,
     8   1079, 1080, 1002, 1081, 1041, 1039, 1033, 1082, 1003, 1085,
     9   1086, 1006, 1087, 1088, 1009, 1089, 1037, 1090, 1084, 1036/
            data (jb1(i),i= 1201, 1300)/
     +    261, 1018, 1094, 1095, 1096, 1093, 1033, 1098, 1099, 1100,
     1   1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1074, 1109,
     2   1083,  257, 1112, 1113, 1114, 1084, 1093, 1117, 1111, 1119,
     3   1120, 1037, 1118, 1042, 1109, 1116, 1118, 1124,  259, 1126,
     4   1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136,
     5   1137, 1138, 1139, 1116, 1141, 1050,  262, 1140, 1144, 1125,
     6   1081, 1067, 1143, 1147, 1091, 1085, 1146, 1075, 1151, 1148,
     7   1119, 1153, 1154, 1149, 1077, 1151, 1111, 1079, 1156, 1144,
     8    275, 1160, 1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168,
     9   1169, 1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178/
            data (jb1(i),i= 1301, 1400)/
     +   1179, 1180, 1181, 1182, 1110, 1184, 1185, 1186, 1187, 1188,
     1   1189, 1190, 1191, 1192, 1160, 1194, 1195, 1196, 1197, 1198,
     2   1199, 1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208,
     3   1209, 1210, 1074, 1212, 1213, 1214, 1215, 1216, 1217, 1218,
     4   1219, 1220, 1221, 1194, 1050, 1223, 1157, 1225, 1226, 1227,
     5   1228, 1229, 1230, 1231, 1122, 1233, 1150,  237, 1235, 1236,
     6   1237,  255, 1239, 1240, 1241, 1242, 1243, 1244, 1144, 1158,
     7   1246, 1247, 1146, 1125, 1249, 1250, 1251, 1252, 1253, 1254,
     8   1255, 1256, 1087, 1233, 1184, 1259, 1194, 1246, 1184, 1262,
     9   1263, 1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272/
            data (jb1(i),i= 1401, 1500)/
     +   1273, 1274, 1275, 1276, 1277, 1278, 1141, 1225, 1281, 1282,
     1   1283, 1284, 1285, 1286, 1287, 1288, 1289, 1257, 1291, 1292,
     2   1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302,
     3   1303, 1304, 1305, 1212, 1307, 1308, 1149, 1307, 1310, 1311,
     4   1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321,
     5   1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331,
     6   1332, 1333, 1334, 1335, 1336, 1258, 1338, 1339, 1340, 1341,
     7   1342, 1343, 1344, 1345, 1346, 1347, 1291, 1306, 1349, 1350,
     8   1351, 1352, 1353, 1089, 1157, 1354, 1356, 1307, 1212, 1160,
     9   1123, 1140, 1360, 1361, 1362, 1363, 1364, 1365, 1366, 1367/
            data (jb1(i),i= 1501, 1600)/
     +   1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375, 1355, 1154,
     1   1359, 1148, 1223, 1376, 1381, 1382, 1379, 1280, 1358,  295,
     2   1380, 1384, 1380, 1378, 1280, 1239, 1337, 1390, 1391, 1392,
     3   1393, 1394, 1395, 1396, 1358,  258, 1239, 1399, 1257, 1401,
     4   1402, 1403, 1400, 1400, 1406, 1407, 1408, 1409, 1410, 1390,
     5   1152, 1412, 1379, 1414, 1415, 1416, 1417, 1418, 1419, 1420,
     6   1421, 1413, 1389, 1156, 1412, 1405, 1425, 1426, 1427, 1428,
     7   1429, 1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438,
     8   1405, 1406, 1261, 1424, 1441, 1443, 1261, 1442, 1233, 1443,
     9   1291, 1445, 1355, 1388, 1447, 1448, 1449, 1450, 1451, 1452/
            data (jb1(i),i= 1601, 1700)/
     +   1453, 1454, 1455, 1456, 1457, 1458, 1459, 1337, 1378, 1461,
     1   1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470, 1279,
     2   1423, 1384, 1468, 1473, 1474, 1385, 1279, 1477, 1478, 1479,
     3   1480, 1481, 1476, 1354, 1483, 1446, 1484, 1486, 1487, 1488,
     4   1489, 1448, 1486, 1483, 1491, 1447, 1385, 1494, 1495, 1496,
     5   1497, 1498, 1499, 1500, 1501, 1476, 1503, 1504, 1505, 1390,
     6   1502, 1508, 1509, 1510, 1507, 1475, 1376, 1398, 1439, 1115,
     7   1502, 1115, 1472, 1515, 1493, 1516, 1423, 1518, 1519, 1520,
     8   1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530,
     9   1531, 1532, 1533, 1534, 1535, 1536, 1537, 1512, 1540, 1541/
            data (jb1(i),i= 1701, 1800)/
     +   1468, 1538, 1540, 1442, 1445, 1484, 1545, 1545, 1544, 1413,
     1   1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556, 1557,
     2   1558, 1559, 1560, 1561, 1562, 1506, 1514, 1564, 1493, 1566,
     3   1513, 1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576,
     4   1406, 1538, 1579, 1575, 1507, 1581, 1582, 1583, 1584, 1585,
     5   1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, 1595,
     6   1579, 1567, 1597, 1598, 1599, 1601, 1579, 1546, 1603, 1605,
     7   1491, 1604, 1486, 1607, 1608, 1609, 1610, 1611, 1612, 1613,
     8   1614, 1615, 1616, 1617, 1618, 1619, 1620, 1605, 1539, 1622,
     9    296, 1578, 1516, 1624, 1596, 1600, 1567, 1627, 1628, 1629/
            data (jb1(i),i= 1801, 1900)/
     +   1630, 1631, 1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639,
     1   1640, 1641, 1624, 1642, 1540, 1644, 1645, 1646, 1647, 1648,
     2   1649, 1650, 1651, 1652, 1653, 1654, 1655, 1656, 1657, 1658,
     3   1659, 1660, 1661, 1662, 1663, 1626, 1514, 1666, 1667, 1668,
     4   1626, 1475, 1670, 1671, 1672, 1673, 1674, 1675, 1676, 1677,
     5   1678, 1679, 1680, 1681, 1682, 1683, 1684, 1685, 1664, 1600,
     6   1664,  356, 1386, 1689, 1688, 1691, 1692, 1693, 1694, 1695,
     7   1578, 1689, 1574, 1698, 1699, 1700, 1701, 1697, 1563, 1703,
     8   1704, 1705, 1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713,
     9   1714, 1715, 1544, 1716, 1717, 1688, 1719, 1720, 1721, 1547/
            data (jb1(i),i= 1901, 2000)/
     +   1718, 1723, 1604, 1724, 1564, 1726, 1682, 1728, 1729, 1730,
     1   1731, 1732, 1733, 1727, 1697, 1735, 1736, 1737, 1738, 1739,
     2   1740, 1741, 1601, 1737, 1743, 1744, 1745, 1746, 1747, 1748,
     3   1749, 1750, 1751, 1752, 1753, 1754, 1755, 1722, 1756, 1757,
     4   1758, 1759, 1760, 1761, 1762, 1763, 1725, 1765, 1605, 1766,
     5   1726, 1769, 1770, 1771, 1772, 1773, 1563, 1539, 1727, 1775,
     6   1776, 1777, 1778, 1779, 1780, 1781, 1782, 1783, 1784, 1785,
     7   1665, 1787, 1788, 1789, 1790, 1791, 1792, 1793, 1794, 1795,
     8   1796, 1797, 1798, 1768, 1724, 1642, 1801, 1764, 1803, 1804,
     9   1805, 1786, 1643, 1807, 1808, 1809, 1810, 1722, 1687, 1802/
            data (jb1(i),i= 2001, 2100)/
     +   1687, 1764, 1601, 1815, 1665, 1817, 1818, 1819, 1820, 1821,
     1   1816, 1812, 1767, 1769, 1824, 1825, 1800, 1813, 1827, 1828,
     2   1830, 1831, 1832, 1768, 1716, 1809, 1802, 1766, 1835, 1836,
     3   1824, 1814, 1838, 1839, 1840, 1841, 1842, 1843, 1844, 1845,
     4   1830, 1847, 1786, 1849, 1850, 1851, 1852, 1853, 1854, 1855,
     5   1856, 1857, 1858, 1859, 1860, 1861, 1862, 1863, 1864, 1865,
     6   1848, 1829, 1812, 1867, 1823, 1869, 1870, 1871, 1872, 1873,
     7   1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881, 1882, 1869,
     8   1835, 1884, 1829, 1886, 1887, 1888, 1889, 1890, 1891, 1892,
     9   1893, 1894, 1895, 1814,  397, 1815, 1897, 1899, 1834, 1834/
            data (jb1(i),i= 2101, 2200)/
     +   1896,  465, 1902, 1903, 1904, 1905, 1906, 1907, 1908, 1909,
     1   1910, 1911, 1912, 1846, 1914, 1848, 1916, 1917, 1918, 1919,
     2   1920, 1921, 1922, 1923, 1915, 1718, 1830, 1926, 1925, 1800,
     3   1929, 1930, 1931, 1932, 1933, 1934, 1935, 1928, 1824, 1936,
     4   1937, 1816, 1939, 1940, 1941, 1942, 1943, 1944, 1945, 1946,
     5   1947, 1948, 1949, 1913, 1927, 1951, 1952, 1953, 1883, 1867,
     6   1913, 1956, 1957, 1958, 1959, 1960, 1954, 1938, 1962, 1963,
     7   1964, 1965, 1885, 1967, 1968, 1969, 1970, 1971, 1972, 1973,
     8   1974, 1975, 1976, 1977, 1883, 1979, 1899, 1896, 1981, 1982,
     9   1967, 1622, 1984, 1985, 1986, 1987, 1988, 1989, 1990, 1991/
            data (jb1(i),i= 2201, 2300)/
     +   1992, 1993, 1994, 1927, 1915, 1996, 1997, 1998, 1999, 2000,
     1   2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 1984, 1897,
     2   2010, 2011, 2012, 2013, 1984, 2016, 2017, 1846, 2014, 1885,
     3   1925, 2020, 2021, 2022, 2023,  431, 1981, 2025, 1954, 2027,
     4   2028,  543, 1979, 1979, 2026, 1967, 2019, 1928,  544, 2019,
     5   2034, 1938, 2033, 2014, 2030, 2037, 2015, 2016, 2015, 2039,
     6   2040, 2041, 2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049,
     7   2050, 2051, 2026, 2032, 2030, 2054, 2055, 2053, 2031, 2054,
     8   2052, 2036, 2059, 2060, 2061, 2062, 2063, 2064, 2065, 2066,
     9   2037, 2068, 2069, 2070, 2071, 2072, 2073, 2074, 2067, 2058/
            data (jb1(i),i= 2301, 2400)/
     +   2054, 2077, 2078, 2076, 2034, 2033, 2035, 2081, 2080, 2082,
     1   2058, 2084, 2080, 2053, 2086, 2087, 2088, 2089, 2090, 2091,
     2   2092, 2093, 2094, 2095, 2096, 2067, 2098, 2099, 2100, 2101,
     3   2102, 2103, 2104, 2105, 2106, 2107, 2108, 2109, 2110, 2111,
     4   2097, 2084, 2068, 2097, 2077, 2115, 2116, 2117, 2118, 2119,
     5   2120, 2121, 2122, 2123, 2124, 2125, 2114, 2103, 2127, 2128,
     6   2129, 2130, 2131, 2132, 2133, 2134, 2135, 2136,  559, 2138,
     7   2139, 2140, 2141, 2142, 2143, 2144, 2136, 2081,  583, 2083,
     8   2146, 2148, 2076, 2114, 2148, 2150, 2138, 2152, 2153, 2154,
     9   2155, 2156, 2157, 2158, 2159, 2160, 2161, 2162, 2163, 2164/
            data (jb1(i),i= 2401, 2500)/
     +   2165, 2166, 2167, 2150, 2169, 2148, 2169, 2113, 2113, 2080,
     1   2147, 2172, 2169, 2174, 2175, 2138, 2177, 2178, 2179, 2180,
     2    584, 2176, 2182, 2183, 2184, 2185, 2186, 2187, 2188, 2189,
     3   2190, 2191, 2192, 2193, 2194, 2195, 2196, 2197, 2198, 2199,
     4   2200, 2201, 2202, 2203, 2177, 2205, 2176, 2205, 2207, 2208,
     5   2209,  585, 2172, 2212, 2213, 2214, 2215, 2216, 2217, 2218,
     6   2219,  587, 2221, 2222, 2223, 2224, 2225, 2226, 2227, 2211,
     7   2229, 2230, 2231, 2171, 2221, 2211, 2229, 2234, 2205, 2232,
     8   2212, 2234, 2212, 2237, 2229, 2238, 2221, 2241, 2242, 2243,
     9   2244, 2245, 2246, 2240, 2239, 2248, 2237, 2248,  627,  629/
            data (jb1(i),i= 2501, 2520)/
     +   2239, 2252, 2253, 2254, 2255, 2256, 2257, 2258,  628, 2248,
     1   2260, 2261, 2262, 2252, 2238, 2252,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   27,   28,   29,   30,   31,   32,
     3     33,   34,   35,   36,   37,   38,   39,   39,   40,   41,
     4     42,   43,   44,   45,   46,   49,   50,   51,   52,   53,
     5     54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
     6     64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
     7     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     8     83,   84,   85,   86,   87,   88,   89,   90,   91,   93,
     9     94,   95,   96,   97,   98,   99,  100,  101,  102,  103/
            data (jb2(i),i=  101,  200)/
     +    104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
     1    114,  115,  116,  117,  118,  119,  120,  121,  121,  122,
     2    123,  124,  125,  126,  127,  128,  129,  130,  131,  132,
     3    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     4    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     5    153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     6    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     7    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     8    182,  183,  185,  186,  187,  188,  189,  190,  191,  192,
     9    193,  194,  195,  196,  197,  198,  199,  200,  201,  202/
            data (jb2(i),i=  201,  300)/
     +    203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
     1    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     2    223,  224,  225,  226,  227,  228,  229,  230,  231,  231,
     3    232,  233,  234,  235,  236,  238,  239,  240,  241,  242,
     4    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     5    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     6    263,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     9    292,  293,  294,  295,  297,  298,  299,  300,  301,  302/
            data (jb2(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
     1    313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
     2    323,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     5    352,  353,  354,  355,  356,  358,  359,  360,  361,  362,
     6    363,  364,  365,  366,  367,  368,  368,  370,  371,  372,
     7    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     8    383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
     9    393,  394,  395,  396,  397,  398,  399,  400,  401,  402/
            data (jb2(i),i=  401,  500)/
     +    403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
     1    413,  414,  415,  416,  417,  418,  419,  420,  421,  422,
     2    423,  424,  425,  426,  427,  428,  429,  430,  431,  432,
     3    433,  434,  435,  436,  437,  438,  439,  440,  441,  442,
     4    443,  444,  445,  446,  447,  448,  449,  450,  451,  452,
     5    453,  454,  455,  456,  457,  458,  459,  460,  461,  462,
     6    463,  464,  465,  467,  468,  469,  470,  471,  472,  473,
     7    474,  475,  476,  477,  478,  479,  480,  481,  482,  483,
     8    484,  485,  486,  487,  487,  489,  490,  491,  492,  493,
     9    494,  495,  496,  497,  498,  498,  499,  500,  501,  502/
            data (jb2(i),i=  501,  600)/
     +    503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
     1    513,  514,  515,  516,  517,  518,  519,  520,  521,  522,
     2    523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
     3    533,  534,  535,  536,  537,  538,  538,  539,  540,  541,
     4    542,  543,  545,  546,  547,  547,  549,  550,  551,  552,
     5    553,  553,  554,  555,  556,  557,  558,  559,  560,  561,
     6    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     7    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     8    582,  583,  584,  585,  586,  587,  589,  590,  591,  592,
     9    593,  594,  595,  596,  597,  598,  599,  600,  601,  602/
            data (jb2(i),i=  601,  700)/
     +    603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
     1    613,  614,  615,  616,  617,  618,  619,  620,  621,  622,
     2    623,  623,  624,  625,  626,  627,  628,  630,  631,  632,
     3    633,  634,  635,  636,  637,  638,  639,  640,  641,  642,
     4    643,  643,  645,  646,  647,  648,  649,  650,  651,  652,
     5    653,  654,  655,  656,  657,  658,  659,  660,  661,  662,
     6    663,  664,  665,  666,  667,  668,  669,  670,  671,  671,
     7    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     8    683,  684,  685,  686,  687,  688,  689,  690,  691,  692,
     9    693,  694,  695,  696,  697,  698,  699,  700,  701,  702/
            data (jb2(i),i=  701,  800)/
     +    703,  704,  705,  706,  707,  708,  709,  710,  711,  711,
     1    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     2    722,  723,  724,  725,  726,  727,  728,  729,  730,  731,
     3    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     4    742,  743,  744,  745,  746,  747,  748,  749,  750,  751,
     5    752,  753,  754,  755,  756,  757,  758,  759,  760,  761,
     6    762,  763,  763,  764,  764,  765,  765,  766,  766,  767,
     7    767,    8,  768,  769,  769,  770,  770,  771,  771,  772,
     8    773,  773,   10,  774,  775,  775,  776,  776,  777,  777,
     9    778,  778,   12,  779,  780,  780,  781,  782,  782,  783/
            data (jb2(i),i=  801,  900)/
     +    784,  784,  785,  786,  786,  787,   14,  788,  789,  789,
     1    790,  791,  791,  792,  793,  793,  794,  795,  795,  796,
     2    797,  797,  798,  798,  799,  800,  801,  802,  803,  803,
     3    804,  805,  805,  806,  806,  807,  807,  808,  808,  809,
     4    809,  811,  812,  813,  813,  810,  814,  815,  815,  816,
     5    816,  817,  818,  819,  820,  821,  822,  823,  824,  825,
     6    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     7    836,  837,  838,  839,  839,  840,  841,  841,  842,  843,
     8    844,  845,  845,  847,  848,  849,  850,  851,  852,  853,
     9    854,  854,  855,  856,  856,  857,  858,  859,  860,  861/
            data (jb2(i),i=  901, 1000)/
     +    862,  862,  863,  863,  864,  865,  865,  866,  866,  867,
     1    867,  868,  868,  869,  869,  870,  871,  871,  872,  873,
     2    873,  874,  874,  875,  875,  876,  877,  877,  878,  879,
     3    880,  881,  882,  883,  884,  885,  886,  887,  888,  889,
     4    890,  891,  892,  893,  894,  895,  895,  896,  897,  897,
     5    899,  900,  901,  902,  903,  904,  905,  905,  898,  906,
     6    907,  908,  909,  910,  910,  911,  913,  913,  912,  914,
     7    915,  915,  916,  917,  918,  918,  919,  919,  920,  921,
     8    922,  922,  923,  924,  924,  925,  926,  926,  927,  927,
     9    928,  929,  929,  930,  931,  932,  933,  933,  934,  935/
            data (jb2(i),i= 1001, 1100)/
     +    935,  936,  936,  937,  938,  938,  939,  940,  940,  941,
     1    941,  942,  943,  943,  944,  944,  945,  946,  946,  947,
     2    948,  949,  950,  952,  953,  953,  954,  955,  955,  957,
     3    957,  956,  958,  959,  960,  961,  962,  963,  964,  964,
     4    965,  966,  967,  968,  969,  970,  970,  971,  972,  973,
     5    974,  975,  976,  977,  978,  979,  980,  981,  981,  982,
     6    983,  984,  985,  986,  987,  988,  989,  990,  991,  991,
     7    992,  993,  993,  994,  995,  996,  996,  997,  997,  998,
     8    999,  999, 1000, 1000, 1001, 1001, 1002, 1002, 1003, 1003,
     9   1004, 1005, 1006, 1007, 1007, 1008, 1008, 1009, 1010, 1010/
            data (jb2(i),i= 1101, 1200)/
     +   1010, 1012, 1013, 1014, 1014, 1015, 1016, 1017, 1018, 1020,
     1   1021, 1021, 1019, 1022, 1023, 1024, 1025, 1025, 1027, 1027,
     2   1028, 1028, 1029, 1030, 1031, 1032, 1032, 1034, 1034, 1035,
     3   1036, 1038, 1038, 1040, 1040, 1039, 1041, 1042, 1043, 1044,
     4   1045, 1046, 1047, 1047, 1049, 1049, 1051, 1052, 1053, 1054,
     5   1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062, 1063, 1064,
     6   1065, 1066, 1066, 1067, 1068, 1069, 1070, 1071, 1072, 1073,
     7   1073, 1074, 1075, 1076, 1076, 1077, 1078, 1078, 1079, 1080,
     8   1080, 1081, 1082, 1082, 1083, 1083, 1084, 1085, 1086, 1086,
     9   1087, 1088, 1088, 1089, 1090, 1090, 1091, 1091, 1092, 1092/
            data (jb2(i),i= 1201, 1300)/
     +   1093, 1094, 1095, 1096, 1097, 1097, 1098, 1099, 1100, 1101,
     1   1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1110,
     2   1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120,
     3   1121, 1121, 1122, 1122, 1123, 1123, 1124, 1125, 1126, 1127,
     4   1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136, 1137,
     5   1138, 1139, 1140, 1141, 1142, 1142, 1143, 1143, 1145, 1145,
     6   1146, 1147, 1147, 1148, 1149, 1150, 1150, 1151, 1152, 1152,
     7   1153, 1154, 1155, 1155, 1156, 1156, 1157, 1158, 1158, 1159,
     8   1159, 1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169,
     9   1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179/
            data (jb2(i),i= 1301, 1400)/
     +   1180, 1181, 1182, 1183, 1183, 1185, 1186, 1187, 1188, 1189,
     1   1190, 1191, 1192, 1193, 1193, 1195, 1196, 1197, 1198, 1199,
     2   1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209,
     3   1210, 1211, 1211, 1213, 1214, 1215, 1216, 1217, 1218, 1219,
     4   1220, 1221, 1222, 1222, 1223, 1224, 1224, 1226, 1227, 1228,
     5   1229, 1230, 1231, 1232, 1232, 1234, 1234, 1235, 1236, 1237,
     6   1238, 1238, 1240, 1241, 1242, 1243, 1244, 1245, 1245, 1246,
     7   1247, 1248, 1248, 1249, 1250, 1251, 1252, 1253, 1254, 1255,
     8   1256, 1257, 1258, 1258, 1259, 1260, 1260, 1261, 1262, 1263,
     9   1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273/
            data (jb2(i),i= 1401, 1500)/
     +   1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282, 1283,
     1   1284, 1285, 1286, 1287, 1288, 1289, 1290, 1290, 1292, 1293,
     2   1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302, 1303,
     3   1304, 1305, 1306, 1225, 1308, 1309, 1309, 1310, 1311, 1312,
     4   1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322,
     5   1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332,
     6   1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342,
     7   1343, 1344, 1345, 1346, 1347, 1348, 1348, 1349, 1350, 1351,
     8   1352, 1353, 1354, 1306, 1355, 1356, 1357, 1357, 1358, 1359,
     9   1359, 1360, 1361, 1362, 1363, 1364, 1365, 1366, 1367, 1368/
            data (jb2(i),i= 1501, 1600)/
     +   1369, 1370, 1371, 1372, 1373, 1374, 1375, 1376, 1377, 1377,
     1   1378, 1379, 1380, 1381, 1382, 1383, 1383, 1384, 1385, 1386,
     2   1387, 1387, 1388, 1389, 1389, 1386, 1377, 1391, 1392, 1393,
     3   1394, 1395, 1396, 1397, 1397, 1398, 1399, 1400, 1401, 1402,
     4   1403, 1404, 1404, 1405, 1407, 1408, 1409, 1410, 1411, 1411,
     5   1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419, 1420, 1421,
     6   1422, 1422, 1423, 1424, 1424, 1425, 1426, 1427, 1428, 1429,
     7   1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439,
     8   1440, 1440, 1441, 1441, 1442, 1444, 1444, 1443, 1445, 1445,
     9   1446, 1446, 1388, 1447, 1448, 1449, 1450, 1451, 1452, 1453/
            data (jb2(i),i= 1601, 1700)/
     +   1454, 1455, 1456, 1457, 1458, 1459, 1460, 1460, 1461, 1462,
     1   1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470, 1471, 1471,
     2   1472, 1472, 1473, 1474, 1475, 1476, 1477, 1478, 1479, 1480,
     3   1481, 1482, 1482, 1483, 1484, 1485, 1485, 1487, 1488, 1489,
     4   1490, 1490, 1491, 1492, 1492, 1493, 1494, 1495, 1496, 1497,
     5   1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507,
     6   1508, 1509, 1510, 1511, 1511, 1506, 1512, 1512, 1513, 1398,
     7   1514,  296, 1515, 1516, 1517, 1517, 1518, 1519, 1520, 1521,
     8   1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530, 1531,
     9   1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 1541, 1542/
            data (jb2(i),i= 1701, 1800)/
     +   1542, 1543, 1543, 1544, 1545, 1546, 1546, 1547, 1547, 1548,
     1   1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556, 1557, 1558,
     2   1559, 1560, 1561, 1562, 1563, 1564, 1565, 1565, 1566, 1567,
     3   1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577,
     4   1577, 1578, 1580, 1580, 1581, 1582, 1583, 1584, 1585, 1586,
     5   1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, 1595, 1596,
     6   1596, 1597, 1598, 1599, 1600, 1602, 1602, 1603, 1604, 1606,
     7   1606, 1606, 1607, 1608, 1609, 1610, 1611, 1612, 1613, 1614,
     8   1615, 1616, 1617, 1618, 1619, 1620, 1621, 1621, 1622, 1623,
     9   1623, 1624, 1625, 1625, 1626, 1621, 1627, 1628, 1629, 1630/
            data (jb2(i),i= 1801, 1900)/
     +   1631, 1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640,
     1   1641, 1642, 1643, 1643, 1644, 1645, 1646, 1647, 1648, 1649,
     2   1650, 1651, 1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659,
     3   1660, 1661, 1662, 1663, 1664, 1665, 1666, 1667, 1668, 1669,
     4   1669, 1670, 1671, 1672, 1673, 1674, 1675, 1676, 1677, 1678,
     5   1679, 1680, 1681, 1682, 1683, 1684, 1685, 1686, 1686, 1687,
     6   1688, 1689, 1690, 1690, 1691, 1692, 1693, 1694, 1695, 1696,
     7   1696, 1697, 1698, 1699, 1700, 1701, 1702, 1702, 1703, 1704,
     8   1705, 1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713, 1714,
     9   1715, 1716, 1717, 1717, 1718, 1719, 1720, 1721, 1722, 1723/
            data (jb2(i),i= 1901, 2000)/
     +   1723, 1724, 1725, 1725, 1726, 1727, 1728, 1729, 1730, 1731,
     1   1732, 1733, 1734, 1734, 1735, 1736, 1737, 1738, 1739, 1740,
     2   1741, 1742, 1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749,
     3   1750, 1751, 1752, 1753, 1754, 1755,  357, 1756, 1757, 1758,
     4   1759, 1760, 1761, 1762, 1763, 1764, 1765, 1766, 1767, 1767,
     5   1768, 1770, 1771, 1772, 1773, 1774, 1774, 1769, 1775, 1776,
     6   1777, 1778, 1779, 1780, 1781, 1782, 1783, 1784, 1785, 1786,
     7   1787, 1788, 1789, 1790, 1791, 1792, 1793, 1794, 1795, 1796,
     8   1797, 1798, 1799, 1799, 1800, 1801, 1802, 1803, 1804, 1805,
     9   1806, 1806, 1807, 1808, 1809, 1810, 1811, 1811, 1812, 1813/
            data (jb2(i),i= 2001, 2100)/
     +   1813, 1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822,
     1   1822, 1823, 1823,  369, 1825, 1826, 1826, 1827, 1828, 1829,
     2   1831, 1832, 1833, 1833,  392, 1834, 1834, 1835, 1836, 1837,
     3   1837, 1838, 1839, 1840, 1841, 1842, 1843, 1844, 1845, 1846,
     4   1847, 1848, 1849, 1850, 1851, 1852, 1853, 1854, 1855, 1856,
     5   1857, 1858, 1859, 1860, 1861, 1862, 1863, 1864, 1865, 1866,
     6   1866, 1867, 1868, 1868, 1869, 1870, 1871, 1872, 1873, 1874,
     7   1875, 1876, 1877, 1878, 1879, 1880, 1881, 1882, 1883, 1884,
     8   1884, 1885, 1886, 1887, 1888, 1889, 1890, 1891, 1892, 1893,
     9   1894, 1895, 1896, 1897, 1898, 1898, 1899, 1900, 1900, 1901/
            data (jb2(i),i= 2101, 2200)/
     +   1901, 1902, 1903, 1904, 1905, 1906, 1907, 1908, 1909, 1910,
     1   1911, 1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920,
     2   1921, 1922, 1923, 1924, 1924, 1925, 1926, 1927, 1928, 1929,
     3   1930, 1931, 1932, 1933, 1934, 1935, 1936, 1936, 1937, 1937,
     4   1938, 1939, 1940, 1941, 1942, 1943, 1944, 1945, 1946, 1947,
     5   1948, 1949, 1950, 1950, 1951, 1952, 1953, 1954, 1955, 1955,
     6   1956, 1957, 1958, 1959, 1960, 1961, 1961, 1962, 1963, 1964,
     7   1965, 1966, 1966, 1968, 1969, 1970, 1971, 1972, 1973, 1974,
     8   1975, 1976, 1977, 1978, 1978, 1980, 1980, 1981, 1982, 1983,
     9   1983,  488, 1985, 1986, 1987, 1988, 1989, 1990, 1991, 1992/
            data (jb2(i),i= 2201, 2300)/
     +   1993, 1994, 1995, 1995, 1996, 1997, 1998, 1999, 2000, 2001,
     1   2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2009, 2010,
     2   2011, 2012, 2013, 2014, 2015, 2017, 2018, 2018, 2016, 2019,
     3   2020, 2021, 2022, 2023, 2024, 2024, 2025, 2026, 2027, 2028,
     4   2029, 2029, 2030, 2031, 2031, 2032, 2032, 2033, 2033, 2034,
     5   2035, 2035, 2035, 2036, 2036, 2038, 2038, 2037, 2039, 2040,
     6   2041, 2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049, 2050,
     7   2051,  548, 2052, 2052, 2053, 2055, 2056, 2056, 2057, 2057,
     8   2058, 2059, 2060, 2061, 2062, 2063, 2064, 2065, 2066, 2067,
     9   2068, 2069, 2070, 2071, 2072, 2073, 2074, 2075, 2075, 2076/
            data (jb2(i),i= 2301, 2400)/
     +   2077, 2078, 2079, 2079, 2080, 2081, 2082, 2082, 2083, 2083,
     1   2084, 2085, 2085, 2086, 2087, 2088, 2089, 2090, 2091, 2092,
     2   2093, 2094, 2095, 2096, 2097, 2098, 2099, 2100, 2101, 2102,
     3   2103, 2104, 2105, 2106, 2107, 2108, 2109, 2110, 2111, 2112,
     4   2112, 2113,  556, 2114, 2115, 2116, 2117, 2118, 2119, 2120,
     5   2121, 2122, 2123, 2124, 2125, 2126, 2126, 2127, 2128, 2129,
     6   2130, 2131, 2132, 2133, 2134, 2135, 2136, 2137, 2137, 2139,
     7   2140, 2141, 2142, 2143, 2144, 2145, 2145, 2146, 2146, 2147,
     8   2147, 2149, 2149, 2150, 2151, 2151, 2152, 2153, 2154, 2155,
     9   2156, 2157, 2158, 2159, 2160, 2161, 2162, 2163, 2164, 2165/
            data (jb2(i),i= 2401, 2500)/
     +   2166, 2167, 2168, 2168, 2170, 2170, 2171, 2171, 2172, 2172,
     1   2173, 2173, 2174, 2175, 2176, 2177, 2178, 2179, 2180, 2181,
     2   2181, 2182, 2183, 2184, 2185, 2186, 2187, 2188, 2189, 2190,
     3   2191, 2192, 2193, 2194, 2195, 2196, 2197, 2198, 2199, 2200,
     4   2201, 2202, 2203, 2204, 2204, 2206, 2206, 2207, 2208, 2209,
     5   2210, 2210, 2211, 2213, 2214, 2215, 2216, 2217, 2218, 2219,
     6   2220, 2220, 2222, 2223, 2224, 2225, 2226, 2227, 2228, 2228,
     7   2230, 2231,  588, 2232, 2232, 2233, 2233, 2235, 2235, 2234,
     8   2236, 2236, 2237, 2238, 2239, 2240, 2241, 2242, 2243, 2244,
     9   2245, 2246, 2247, 2247, 2240, 2249, 2249, 2250, 2250, 2251/
            data (jb2(i),i= 2501, 2520)/
     +   2251, 2253, 2254, 2255, 2256, 2257, 2258, 2259, 2259, 2260,
     1   2261, 2262, 2263, 2263,  644,  672,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine uh(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1230) :: jx,jy
            integer(kind=iknd), save, dimension(1260) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'utah          '/
            data jrot,ipart/0,1/
            data kv/   1,1223,   0,   0,   0/
            data kb/   1,1252,   0,   0,   0/
            data iib/  29,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  25776,31272,35064, 9984,43824,51864, 9504, 9360,52104, 8976,
     1  52296, 8832, 8592,18576,31848,10368,11904,25896,27384,35064,
     2  51792,35064,40440,52344,52536,52776,40128,40056, 8400,18984,
     3  19224,19368,19248,19440,19584,19752,20016,21216,21288,21480,
     4  21600,21576,21240,21216,20976,20952,20976,20880,23640,23736,
     5  23856,23976,24288,24576,24864,24816,24816,24744,24624,24336,
     6  21672,21600,21456,21120,20928,20784,20616,20496,20616,20712,
     7  21864,21912,21960,22128,22056,22104,22344,22536,24504,24432,
     8  24456,24672,24744,24960,25056,26256,26376,23736,23520,23448,
     9  23424,23256,23232,23328,25488,25704,25824,26496,19872,19776/
            data (jx(i),i=  101,  200)/
     +  19872,19824,19728,19560,19152,19128,18816,18816,18696,18480,
     1  18768,18768,25547,25608,25368,25416,23784,23712,23616,23736,
     2  23928,23784,23520,23520,23256,22920,22992,22920,22872,22920,
     3  22848,22824,22944,22944,22656,22632,22608,22560,22512,18576,
     4  18408,18288,17808,17856,17736,17952,17904,17808,17736,17904,
     5  18384,18696,18672,18744,18720,18576,18720,20232,20160,25392,
     6  25536,25589,25872,26424,26880,27384,27576,27792,27792,27624,
     7  27504,27336,27159,27024,26616,26616,26496,26328,26160,25848,
     8  25608,25440,24936,25156,25272,20088,20040,20112,19992,20016,
     9  20112,20136,20352,20376,21072,21288,21216,21336,21000,20952/
            data (jx(i),i=  201,  300)/
     +  21000,20928,20520,20448,20520,20328,20424,20328,20376,24600,
     1  24456,24456,24384,24240,24120,23880,23712,23568,23448,23304,
     2  23112,22968,22728,22680,22488,22320,22224,22008,22032,21720,
     3  21048,20976,21072,21168,21000,20616,20400,28128,28128,28056,
     4  27840,27936,28152,28224,28152,27936,27936,27864,27768,27648,
     5  27576,27504,27384,27336,27216,27240,27096,27144,27024,26928,
     6  26784,26712,26616,26880,26976,27072,27072,26928,26760,26664,
     7  26544,26184,26064,25968,25896,31344,31464,31560,31512,31296,
     8  31224,31320,31296,31440,31320,31296,31704,31704,31848,31992,
     9  32016,31920,32136,32016,32040,31896,31920,31848,31776,31776/
            data (jx(i),i=  301,  400)/
     +  31680,31680,31536,31512,31272,31296,31200,31128,31080,31056,
     1  30936,30816,30744,30672,30168,30072,29664,29520,29520,29376,
     2  29112,28848,28488,28248,28152,28200,31944,31488,31488,31296,
     3  26880,27456,27360,27408,27456,27384,27504,27672,27768,28008,
     4  33216,33504,33480,33552,33528,33600,33336,33144,33216,32688,
     5  32544,32400,32232,28272,27672,27336,28320,28128,28200,28152,
     6  28296,28632,28776,28992,29088,29184,29232,29568,29760,30312,
     7  30384,30528,31296,31320,31752,31776,31704,31776,31896,31896,
     8  33528,33720,34128,34272,34632,34848,43824,51264,51216,50952,
     9  50880,50568,50544,48936,48960,48744,48576,48216,47952,47928/
            data (jx(i),i=  401,  500)/
     +  47736,47352,46944,46800,46608,46440,46224,45936,45768,45600,
     1  45288,45264,44952,44736,44592,44472,44352,44064,29280,29064,
     2  29040,28920,28896,28800,28800,28632,28680,28968,28680,28536,
     3  28440,28464,28344,27432,27432,27312,27384,27360,27528,27600,
     4  28272,28920,43512,43368,43152,43008,42888,42456,42240,41688,
     5  41112,40968,40800,40488,40320,40176,40056,39936,39792,39504,
     6  39336,39144,38808,38592,38352,38112,37896,37536,36936,36720,
     7  36672,36480,36360,36408,36288,36360,36288,33000,32856,32664,
     8  32568,32376,32304,32352,32256,32040,31704,31488,31200,30936,
     9  30840,30816,30480,30576,31032,31056,31008,31176,31224,31368/
            data (jx(i),i=  501,  600)/
     +  31368,31248,31248,31128,31104,31008,30768,30552,30504,30336,
     1  30024,30072,29856,29928,29568,29496,30048,30000,30168,30240,
     2  30480,30408,30456,30816,25536,25536,25416,25488,25440,25512,
     3  25464,25512,25464,25536,25560,25392,25392,25320,25368,30408,
     4  30696,30720,35928,35928,35688,35376,35184,34920,34800,34416,
     5  34200,33288,32688,32304,32280,32160,32136,31992,31800,31800,
     6  31464,31344,31392,31320,30888,36384,36336,36264,44208,30360,
     7  30096,29904,29856,29712,29496,29376,29256,29232,29016,28800,
     8  28776,28464,28344,28296,28224,28104,28008,27648,27720,27240,
     9  26952,26808,26736,26400,26208,26064,26040,25800,25656,25440/
            data (jx(i),i=  601,  700)/
     +  25488,25416,25488,25488,25608,25680,25488,25536,25488,25728,
     1  25728,25680,25608,25680,25656,25560,25536,25344,25368,25296,
     2  25488,25368,25392,25296,25344,25248,25200,25416,34848,34824,
     3  34368,34344,34440,34416,34200,34032,34032,33864,33720,33600,
     4  33480,33432,33336,33456,33384,33576,33480,33504,33144,33144,
     5  33216,33144,33024,32832,32808,32688,32160,32088,31992,31872,
     6  31776,31632,31608,31728,31608,31536,31536,31464,31368,30768,
     7  30600,30600,30456,30264,30240,30312,30456,30600,30552,30672,
     8  30624,29952,28920,29040,29040,29184,29160,28944,28800,28752,
     9  28440,28296,28248,28152,28080,27528,27144,27048,26952,26880/
            data (jx(i),i=  701,  800)/
     +  26712,26280,26184,26256,26256,26376,26280,26256,26472,26376,
     1  26112,26160,26088,25992,25824,25632,25104,24912,24936,24768,
     2  24696,24360,24168,24096,24024,10680,10680,10536,10536,36672,
     3  36648,33336,39552,39552,39408,43800,43872,43800,43656,43608,
     4  43704,43776,43680,43848,43752,43920,44040,43920,43896,44016,
     5  44112,44112,43992,43944,44016,44064,44232,44040,44064,44304,
     6  44328,44424,44448,44400,44616,44664,44592,44616,44736,45048,
     7  44928,44928,26712,26712,27192,27192,27576,27576,29016,29040,
     8  29352,29304,29856,29856,29952,29952,30456,30480,30120,30144,
     9  29952,33336,26232,26232,25176,25224,25200,25056,25224,25224/
            data (jx(i),i=  801,  900)/
     +  25128,25248,25272,25152,25080,25008,25176,25224,25200,25128,
     1  25032,18096,11352,11352,51888,51888,51744,51744,51576,51576,
     2  43824,34776,34728,34824,34728,34704,34512,34440,34464,34416,
     3  34272,34176,34032,33936,33840,33720,33552,33552,26688,43920,
     4  43752,43728,43800,43968,44040,44184,44064,44232,44136,43968,
     5  43920,43776,43608,43800,43896,43992,44160,44112,44016,43896,
     6  43584,43512,43560,43728,43680,43776,43704,43656,43584,43608,
     7  43488,43464,43512,43416,43344,43296,43272,43368,43248,43344,
     8  43272,43080,43032,43176,43104,43200,43392,43272,43080,43056,
     9  43176,43152,43008,43056,42840,42888,42696,42696,42528,42528/
            data (jx(i),i=  901, 1000)/
     +  42600,42816,42912,42864,42744,42888,42744,42864,42720,42816,
     1  42768,42840,42792,42816,42960,43056,43080,43200,43200,43056,
     2  43056,43200,43128,43224,43392,43440,43392,43512,43368,43464,
     3  43608,43512,43512,43632,43752,43824,43800,43872,43848,43944,
     4  43824,43872,32832,27936,27936,32856,33336,26640,26256,26232,
     5  25632,25632,25488,25488,25344,25344,25176,25152,24840,24792,
     6  24888,24888,24744,24552,24336,24336,24096,24096,23688,23688,
     7  22896,22896,22728,22728,22632,22632,22560,22536,22416,22392,
     8  22296,32784,32760,32832,19968,22272,22224,22296,28872,28536,
     9  28512,26448,26208,26208,43944,33264,32784,28320,28224,28056/
            data (jx(i),i= 1001, 1100)/
     +  28080,44808,44784,45144,45168,45000,45000,45144,44928,44856,
     1  45120,45048,44928,44880,45000,45000,44904,44784,44736,44784,
     2  44592,44592,44448,44448,44592,44664,44592,44496,44448,44256,
     3  44376,44352,44280,44040,44040,43920,43848,44088,43920,43800,
     4  43752,43800,43944,44040,44088,22512,22896,22896,22992,22992,
     5  23568,23592,23400,23688,23664,23760,23784,23712,23568,23424,
     6  23280,23184,23256,23208,23112,22992,22896,22752,22536,22416,
     7  22224,22320,22248,27144,27144,26688,37776,20592,20592,21576,
     8  21576,21504,21504,22392,22392,22560,22584,22464,38544,38712,
     9  38928,38928,39000,39264,39312,39504,39600,39720,39864,39960/
            data (jx(i),i= 1101, 1200)/
     +  39936,40080,40128,40272,40296,40464,40152,40056,40248,40368,
     1  40416,40464,40704,40656,40992,41544,41688,41784,41760,41856,
     2  42384,42456,42384,42720,42984,43152,43392,43488,43608,43752,
     3  43776,44016,44088,44280,44568,44784,12648,12648,13656,13632,
     4  15552,15528,17472,17472,18672,18672,23424,23424,27384,28008,
     5  28008,32352,32568,32736,32736,32928,32760,32736,32712,32832,
     6  33120,33264,33288,33408,33408,33264,33312,33384,33504,33912,
     7  33984,34128,34224,34344,34800,34992,35088,35520,35616,35856,
     8  35880,35808,36072,36072,36336,36288,36408,36336,36504,36432,
     9  36672,36552,36864,36840,36600,36576,36696,37200,37416,37536/
            data (jx(i),i= 1201, 1230)/
     +  37608,37656,37728,37776,37848,37680,37608,37704,37944,38064,
     1  38064,37824,37704,37680,37824,37920,37992,38400,38592,38592,
     2  38352,38448,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  61728,61680,53352,51024,50616,46944,38928,34920,34368,24192,
     1  23088,19512,13512, 6576, 6408,62016,61920,61680,61656,61632,
     2  50760,50544,50520,20664,19368, 6528, 6384, 6432, 6792,59088,
     3  58920,58728,58536,58344,58296,58344,58584,58920,59016,59040,
     4  58968,58824,58440,58224,57864,57768,57528,57456,56712,56640,
     5  56712,56640,56832,56808,56616,56424,56160,55968,55800,55632,
     6  55512,55536,55728,55944,56376,56448,56832,56904,57168,57192,
     7  55536,55464,55464,55584,55632,55656,55584,55416,55488,55392,
     8  55248,55176,55248,55344,55296,55416,55344,55104,55272,55464,
     9  55800,56040,56352,56712,54624,54624,54696,55296,53256,53376/
            data (jy(i),i=  101,  200)/
     +  53472,53448,53568,53568,53760,53472,53544,53616,53640,54000,
     1  54216,54552,54378,54120,53544,53160,55080,54768,54576,54384,
     2  53688,53280,53040,52944,52968,53088,53232,53424,53424,53520,
     3  53664,53976,54168,54384,54528,54624,55152,55368,55368,55704,
     4  55656,55824,57048,57216,57480,57864,58056,58176,58584,59016,
     5  59496,59232,55728,55608,55536,55416,55056,52704,53016,53040,
     6  52368,52319,52056,51024,50832,50904,50784,50496,50136,50088,
     7  49896,49920,49743,49608,49512,49392,49128,48960,48888,48240,
     8  47952,47880,47520,47646,47712,52512,51528,51336,51072,50928,
     9  50737,50688,50544,50160,49824,49296,49152,48648,48528,48432/
            data (jy(i),i=  201,  300)/
     +  48288,48048,48096,47832,47520,47376,47064,46824,45936,47064,
     1  46992,47112,47136,46848,46776,46776,46680,46776,47064,47112,
     2  46968,46680,46608,46800,46992,47376,47400,47592,47688,47712,
     3  47976,47928,47808,47304,46464,45768,45816,55320,55488,55488,
     4  55728,55824,55848,55968,56064,56112,56304,56544,56544,56712,
     5  56736,56616,56592,56520,56784,56856,57240,57336,57936,58152,
     6  58248,58464,58848,58992,59232,59256,59448,59616,60192,60240,
     7  60552,60888,61296,61368,61608,61440,61272,60816,60648,60672,
     8  60600,60504,60408,60312,60144,59976,59472,59184,58608,58560,
     9  58440,58152,57840,57624,57528,57384,56976,56688,56616,56472/
            data (jy(i),i=  301,  400)/
     +  56424,56328,56160,56016,55632,55536,55272,55104,55080,55152,
     1  55032,55128,55272,55224,55224,55152,55344,55224,55056,54840,
     2  54672,54936,54888,55008,55200,55272,54600,54840,55008,55104,
     3  54360,54648,54792,54960,54960,55224,55416,55200,55176,55248,
     4  52176,52536,52608,52704,52800,52968,53088,53304,53904,54504,
     5  54600,54600,54768,52128,52080,52296,52296,52488,52632,52704,
     6  52800,52872,52992,53040,52920,52992,52872,52608,52608,52896,
     7  53160,53256,53160,53256,53688,53856,54072,54336,54384,54552,
     8  52200,52392,52536,52728,52992,53328,48528,46920,47256,47256,
     9  48384,48384,49152,49128,48360,48288,48072,47832,47928,48600/
            data (jy(i),i=  401,  500)/
     +  48792,48624,48576,48432,48360,48456,48432,48456,48192,48216,
     1  48144,48048,48000,48192,48192,48312,48336,48480,49080,49224,
     2  49368,49464,49632,49680,49920,50112,50160,50160,50664,50832,
     3  50856,51048,51408,49728,49488,49248,49152,48984,48864,48648,
     4  48696,48888,48624,48528,48528,48480,48528,48552,48672,48768,
     5  48600,48648,48288,48216,48288,48168,48216,48096,48144,47952,
     6  48096,47928,47928,48024,47736,47712,47832,47760,47376,47544,
     7  47496,47592,47568,47472,47352,47064,47016,52176,52080,52128,
     8  52008,52008,51792,51672,51552,51432,51504,51312,51288,51096,
     9  50976,50760,50472,50112,50112,49824,49680,49656,49440,49176/
            data (jy(i),i=  501,  600)/
     +  49032,48840,48720,48576,48312,48216,48168,48288,48384,48528,
     1  48336,48600,48792,48912,49080,48984,48168,48120,47976,47640,
     2  47328,47184,46776,46296,44760,44952,45072,45144,45264,45336,
     3  45600,45744,45912,46056,46272,46488,46656,46824,47328,45936,
     4  46008,46248,46944,46752,46056,46080,45912,46008,46104,46056,
     5  45600,45984,46416,46512,46656,46848,47160,47064,47064,46848,
     6  46632,46368,46272,46152,46320,38424,44280,44280,37392,45792,
     7  45840,45648,45552,45432,45456,45360,45408,45360,45384,45168,
     8  45024,44904,44808,44832,44712,44832,44760,44568,44448,44160,
     9  44280,44424,44712,44496,44520,44424,44568,44784,44688,39720/
            data (jy(i),i=  601,  700)/
     +  39984,40344,40344,40536,40560,40776,41040,41208,41328,41520,
     1  41688,41784,41784,41928,42000,42000,42072,42528,42888,43032,
     2  43296,43584,43728,43848,44256,44400,44616,44760,38448,38928,
     3  38952,39024,39120,39216,39408,39456,39672,39768,40080,39984,
     4  39936,39960,40152,40440,40512,41016,41208,41400,41952,42144,
     5  42192,42312,42480,42576,42720,42648,42840,42768,42792,42696,
     6  42768,42792,42864,43104,43320,43320,43392,43392,43536,43536,
     7  43920,44064,44304,44400,44568,44712,44736,44976,45096,45600,
     8  45720,37464,37464,37728,37824,37944,38040,38400,38496,38880,
     9  38880,38808,38688,38616,38400,38088,37416,37488,37440,37296/
            data (jy(i),i=  701,  800)/
     +  37176,37128,37248,37344,37440,37680,37800,38064,38352,38544,
     1  38808,38880,39144,39288,39312,39624,39576,39240,39120,39072,
     2  38952,38904,39048,39024,38544,38880,38568,38568,38880,37488,
     3  38424,37488,37392,37440,37464,33672,33864,34272,34296,34416,
     4  34416,34512,34800,34944,35136,35400,35424,35520,35640,35664,
     5  35808,36048,36072,36120,36144,36288,36288,36624,36672,36720,
     6  36552,36432,36480,36768,36792,37080,37200,37320,37224,37200,
     7  37320,37416,31968,32160,32136,32472,32472,32568,32568,33576,
     8  33576,36192,36216,36336,36336,36672,36696,37152,37152,37320,
     9  37296,36288,31992,32160,32160,32256,32760,32880,32952,33336/
            data (jy(i),i=  801,  900)/
     +  33624,33720,33912,33936,34224,34248,34320,34416,34560,34560,
     1  34656,34752,34944,34848,34368,34224,34200,34056,34056,33720,
     2  33576,33648,33672,33912,34056,34248,34440,34608,34776,34824,
     3  35280,35112,35112,35280,35328,35736,35928,36120,29040,22968,
     4  23064,23160,23208,23136,23256,23256,23472,23712,23736,23664,
     5  23808,23784,23904,24144,24144,23952,24024,24264,24360,24216,
     6  24168,24240,24312,24288,24480,24696,24744,24600,24648,24768,
     7  24696,24744,24864,24888,24792,24816,24864,24936,25128,25296,
     8  25344,25248,25296,25368,25536,25704,25824,26016,26136,26232,
     9  26328,26448,26544,26664,26712,27048,27000,27336,27480,27624/
            data (jy(i),i=  901, 1000)/
     +  27696,27672,27720,27864,27960,28080,28320,28536,28656,28776,
     1  28968,29232,29352,29448,29496,29568,29904,29976,30048,30168,
     2  30240,30336,30504,30600,30624,30744,30768,31416,31536,31752,
     3  31872,31896,32136,32112,32352,32400,32664,32736,32856,33048,
     4  33168,33480,28848,28872,29064,33648,33648,28464,28464,28080,
     5  28056,27816,27816,27504,27504,27216,27192,27048,27048,25920,
     6  25920,25536,25512,25296,25248,25080,25056,24984,24984,25080,
     7  25056,24984,24984,24816,24816,24648,24648,24144,24168,23832,
     8  23856,23064,24840,24840,23856,23160,23256,23376,23064,23064,
     9  22992,22992,23016,23112,22968,22920,22920,22536,22272,22152/
            data (jy(i),i= 1001, 1100)/
     +  19128,19128,19224,19488,19584,19560,19632,19776,19824,19968,
     1  20016,20160,20112,20160,20280,20424,20448,20328,20352,20568,
     2  20688,20928,21048,21120,21216,21384,21408,21240,21240,21408,
     3  21696,21744,21768,21480,21648,21696,21792,22032,22392,22392,
     4  22440,22536,22392,22440,22824,19152,19176,19320,19392,19512,
     5  19968,20040,20256,20712,20832,20952,21216,21360,21384,21672,
     6  21744,21912,21984,22080,22152,21984,21960,22296,22488,22512,
     7  22824,22944,23016,19128,19080,19080,19080,12528,15408,15384,
     8  16248,16248,16320,16320,16488,16488,17280,17280,12336,12552,
     9  12672,13008,13104,13200,13488,13416,13464,13656,13584,13896/
            data (jy(i),i= 1101, 1200)/
     +  14136,14232,14424,14496,14760,14952,14904,15240,15336,15288,
     1  15336,15624,15864,16104,16224,16224,15960,16008,16176,16296,
     2  16296,16488,16800,17064,17496,17544,17376,17424,17952,18000,
     3  18240,18624,18672,18576,18912,19008,13368,13512,13488,12504,
     4  12480,11928,11808,12096,12072,12552,12456,12384,12312,12312,
     5  12360, 6456, 6576, 6480, 6672, 6816, 6864, 6936, 7032, 7104,
     6   6888, 6600, 6624, 6744, 6816, 6912, 7104, 7104, 6960, 7536,
     7   7536, 7344, 7344, 7536, 7512, 7440, 7584, 7584, 7752, 7752,
     8   7800, 7992, 8040, 8304, 8280, 8424, 8592, 8736, 8880, 9144,
     9   9240, 9528, 9648, 9864, 9984,10200,10224, 9912, 9960,10056/
            data (jy(i),i= 1201, 1230)/
     +  10248,10248,10152,10200,10488,10656,10800,10872,10824,10992,
     1  11136,11208,11328,11448,11424,11640,11664,11664,11736,11808,
     2  11832,12192,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      4,   16,    1,    1,   18,    2,    2,    3,    5,    6,
     1      3,   22,    5,    4,    6,    7,    8,    9,   11,   24,
     2     25,   26,   27,   15,   10,   12,   13,   14,   14,   30,
     3     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     4     41,   42,   43,   44,   45,   46,   47,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   61,   62,
     6     63,   64,   65,   66,   67,   68,   69,   48,   61,   71,
     7     72,   73,   74,   75,   76,   77,   60,   79,   80,   81,
     8     82,   83,   84,   85,   86,   88,   89,   90,   91,   92,
     9     93,   49,   95,   96,   97,   87,   99,  100,  101,  102/
            data (jb1(i),i=  101,  200)/
     +    103,  104,  105,  106,  107,  108,  109,  110,  111,   95,
     1    113,  114,  115,   88,  117,  118,  119,  120,  121,  122,
     2    123,  124,  125,  126,  127,  128,  129,  130,  131,  132,
     3    133,  134,  135,  136,  137,  138,   78,  140,  141,  142,
     4    143,  144,  145,  146,  147,  148,  149,  150,  151,   30,
     5    140,  153,  154,  155,  156,  112,  158,   99,  116,  160,
     6    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     7    171,  172,  173,  174,  175,  176,  177,  178,  179,  180,
     8    181,  183,  184,  182,  158,  186,  187,  188,  189,  190,
     9    191,  192,  193,  194,  195,  196,  197,  198,  199,  200/
            data (jb1(i),i=  201,  300)/
     +    201,  202,  203,  204,  205,  206,  207,  208,  183,  210,
     1    211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
     2    221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
     3    231,  232,  233,  234,  235,  236,  209,  238,  239,  240,
     4    241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
     5    251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
     6    261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
     7    271,  272,  273,  274,  275,    2,  276,  277,  278,  279,
     8    280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
     9    290,  291,  292,  293,  294,  295,  296,  297,  298,  299/
            data (jb1(i),i=  301,  400)/
     +    300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
     1    310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
     2    320,  321,  322,  323,  324,  325,  238,  327,  328,  329,
     3    307,  113,  331,  332,  333,  334,  335,  336,  337,  338,
     4    339,  238,  341,  342,  343,  344,  345,  346,  347,  348,
     5    349,  350,  351,  352,  327,  354,  355,  162,  354,  357,
     6    358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
     7    368,  369,  370,  371,  372,  373,  374,  375,  376,  377,
     8    378,  379,  327,  341,  381,  382,  383,  384,  385,  386,
     9    191,  387,    6,  388,  389,  390,  391,  392,  393,  394/
            data (jb1(i),i=  401,  500)/
     +    395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
     1    405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
     2    415,  416,  417,  419,  420,  421,  422,  423,  424,  425,
     3    426,  427,  428,  429,  430,  431,  432,  354,  173,  434,
     4    435,  436,  437,  438,  439,  440,  441,  419,  387,  443,
     5    444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
     6    454,  455,  456,  457,  458,  459,  460,  461,  462,  463,
     7    464,  465,  466,  467,  468,  469,  470,  471,  472,  473,
     8    474,  475,  476,  387,  341,  478,  479,  480,  481,  482,
     9    483,  484,  485,  486,  487,  488,  489,  490,  491,  492/
            data (jb1(i),i=  501,  600)/
     +    493,  494,  495,  496,  497,  498,  499,  500,  501,  502,
     1    503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
     2    513,  514,  515,  419,  511,  517,  518,  519,  520,  521,
     3    522,  523,  525,  526,  527,  528,  529,  530,  531,  532,
     4    533,  534,  535,  536,  537,  538,  184,  540,  541,  524,
     5    477,  543,  544,  545,  546,  547,  548,  549,  550,  551,
     6    552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
     7    562,  563,  564,  524,  566,  567,  477,  418,  540,  570,
     8    571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
     9    581,  582,  583,  584,  585,  586,  587,  588,  589,  590/
            data (jb1(i),i=  601,  700)/
     +    591,  592,  593,  594,  595,  596,  597,  598,  525,  600,
     1    601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
     2    611,  612,  613,  614,  615,  616,  617,  618,  619,  620,
     3    621,  622,  623,  624,  625,  626,  627,  525,  566,  629,
     4    630,  631,  632,  633,  634,  635,  636,  637,  638,  639,
     5    640,  641,  642,  643,  644,  645,  646,  647,  648,  649,
     6    650,  651,  652,  653,  654,  655,  656,  657,  658,  659,
     7    660,  661,  662,  663,  664,  665,  666,  667,  668,  669,
     8    670,  671,  672,  673,  674,  675,  676,  677,  678,  679,
     9    680,  540,  682,  683,  684,  685,  686,  687,  688,  689/
            data (jb1(i),i=  701,  800)/
     +    690,  691,  692,  693,  694,  695,  696,  697,  698,  699,
     1    700,  701,  702,  703,  704,  705,  706,  707,  708,  709,
     2    710,  711,  712,  713,  714,  715,  600,  600,  717,  718,
     3    719,  720,  721,  722,  723,  724,  725,  726,  727,  728,
     4    729,  730,  566,  730,  682,  569,  733,  734,  730,  736,
     5    737,  738,  739,  740,  741,  742,  743,  744,  745,  746,
     6    747,  748,  749,  750,  751,  752,  753,  754,  755,  756,
     7    757,  758,  759,  760,  761,  762,  763,  764,  765,  766,
     8    767,  768,  769,  770,  771,  569,  773,  774,  775,  776,
     9    777,  778,  779,  780,  781,  782,  783,  784,  785,  786/
            data (jb1(i),i=  801,  900)/
     +    787,  788,  789,  790,  682,  732,  773,  793,  794,  795,
     1    796,  797,  798,  799,  800,  801,  802,  803,  804,  805,
     2    806,  807,  808,  809,  810,  811,  812,  813,  814,    9,
     3    815,  816,  817,  818,  819,  820,  736,  822,  823,  824,
     4    825,  826,  827,  828,  829,  830,  831,  832,  833,  834,
     5    835,  836,  837,  792,  736,  773,  840,  841,  842,  843,
     6    844,  845,  846,  847,  848,  849,  850,  851,  852,  853,
     7    854,  855,  856,  857,  858,  859,  860,  861,  862,  863,
     8    864,  865,  866,  867,  868,  869,  870,  871,  872,  873,
     9    874,  875,  876,  877,  878,  879,  880,  881,  882,  883/
            data (jb1(i),i=  901, 1000)/
     +    884,  885,  886,  887,  888,  889,  890,  891,  892,  893,
     1    894,  895,  896,  897,  898,  899,  900,  901,  902,  903,
     2    904,  905,  906,  907,  908,  909,  910,  911,  912,  913,
     3    914,  915,  916,  917,  918,  919,  920,  921,  922,  923,
     4    924,  925,  926,  927,  928,  929,  930,  931,  932,  933,
     5    934,  935,  936,  937,  938,  939,  940,  941,  821,  943,
     6    944,  839,  943,  946,  792,  839,  948,  949,  950,  951,
     7    952,  953,  954,  955,  956,  957,  958,  959,  960,  961,
     8    962,  963,  964,  965,  966,  967,  968,  969,  970,  971,
     9    972,  973,  974,  975,  976,  977,  978,  979,  980,  982/
            data (jb1(i),i= 1001, 1100)/
     +    983,  943,  981,  985,  986,  987,  981,  989,  990,  991,
     1    992,  993,  986,  982,   11,  840,  996,  982,  989,  998,
     2    999, 1000, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009,
     3   1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019,
     4   1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029,
     5   1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039,
     6   1040, 1041, 1042, 1043, 1044,  995, 1046, 1047, 1048, 1049,
     7   1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059,
     8   1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069,
     9   1070, 1071, 1072,  986, 1001, 1074, 1075, 1047, 1046, 1001/
            data (jb1(i),i= 1101, 1200)/
     +   1002, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086,
     1   1087, 1046, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1096,
     2   1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106,
     3   1107, 1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116,
     4   1117, 1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126,
     5   1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1002,
     6     13, 1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145,
     7   1078, 1078, 1147, 1148, 1149, 1150, 1089, 1145,   15, 1152,
     8   1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162,
     9   1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172/
            data (jb1(i),i= 1201, 1260)/
     +   1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182,
     1   1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191, 1192,
     2   1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202,
     3   1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212,
     4   1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1089,
     5    840,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     16,   17,   17,   18,   19,   19,   20,   20,   21,   21,
     1     22,   23,   23,    7,    9,    8,   10,   11,   24,   25,
     2     26,   27,   28,   28,   12,   13,   29,   29,   15,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   50,   51,   52,
     5     53,   54,   55,   56,   57,   58,   59,   60,   62,   63,
     6     64,   65,   66,   67,   68,   69,   70,   70,   71,   72,
     7     73,   74,   75,   76,   77,   78,   79,   80,   81,   82,
     8     83,   84,   85,   86,   87,   89,   90,   91,   92,   93,
     9     94,   94,   96,   97,   98,   98,  100,  101,  102,  103/
            data (jb2(i),i=  101,  200)/
     +    104,  105,  106,  107,  108,  109,  110,  111,  112,  113,
     1    114,  115,  116,  117,  118,  119,  120,  121,  122,  123,
     2    124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
     3    134,  135,  136,  137,  138,  139,  139,  141,  142,  143,
     4    144,  145,  146,  147,  148,  149,  150,  151,  152,  152,
     5    153,  154,  155,  156,  157,  157,  159,  159,  160,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8    182,  184,  185,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb2(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  237,  237,  239,  240,  241,
     4    242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
     5    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,    1,  276,  277,  278,  279,  280,
     8    281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
     9    291,  292,  293,  294,  295,  296,  297,  298,  299,  300/
            data (jb2(i),i=  301,  400)/
     +    301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
     1    311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
     2    321,  322,  323,  324,  325,  326,  326,  328,  329,  330,
     3    330,  331,  332,  333,  334,  335,  336,  337,  338,  339,
     4    340,  340,  342,  343,  344,  345,  346,  347,  348,  349,
     5    350,  351,  352,  353,  353,  355,  356,  356,  357,  358,
     6    359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
     7    369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
     8    379,  380,  380,  381,  382,  383,  384,  385,  386,    3,
     9      4,    5,  388,  389,  390,  391,  392,  393,  394,  395/
            data (jb2(i),i=  401,  500)/
     +    396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
     1    406,  407,  408,  409,  410,  411,  412,  413,  414,  415,
     2    416,  417,  418,  420,  421,  422,  423,  424,  425,  426,
     3    427,  428,  429,  430,  431,  432,  433,  433,  434,  435,
     4    436,  437,  438,  439,  440,  441,  442,  442,  443,  444,
     5    445,  446,  447,  448,  449,  450,  451,  452,  453,  454,
     6    455,  456,  457,  458,  459,  460,  461,  462,  463,  464,
     7    465,  466,  467,  468,  469,  470,  471,  472,  473,  474,
     8    475,  476,  477,  418,  478,  479,  480,  481,  482,  483,
     9    484,  485,  486,  487,  488,  489,  490,  491,  492,  493/
            data (jb2(i),i=  501,  600)/
     +    494,  495,  496,  497,  498,  499,  500,  501,  502,  503,
     1    504,  505,  506,  507,  508,  509,  510,  511,  512,  513,
     2    514,  515,  516,  516,  517,  518,  519,  520,  521,  522,
     3    523,  524,  526,  527,  528,  529,  530,  531,  532,  533,
     4    534,  535,  536,  537,  538,  539,  539,  541,  542,  542,
     5    543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
     6    553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
     7    563,  564,  565,  565,  567,  568,  568,  569,  570,  571,
     8    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     9    582,  583,  584,  585,  586,  587,  588,  589,  590,  591/
            data (jb2(i),i=  601,  700)/
     +    592,  593,  594,  595,  596,  597,  598,  599,  599,  601,
     1    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     2    612,  613,  614,  615,  616,  617,  618,  619,  620,  621,
     3    622,  623,  624,  625,  626,  627,  628,  628,  629,  630,
     4    631,  632,  633,  634,  635,  636,  637,  638,  639,  640,
     5    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     6    651,  652,  653,  654,  655,  656,  657,  658,  659,  660,
     7    661,  662,  663,  664,  665,  666,  667,  668,  669,  670,
     8    671,  672,  673,  674,  675,  676,  677,  678,  679,  680,
     9    681,  681,  683,  684,  685,  686,  687,  688,  689,  690/
            data (jb2(i),i=  701,  800)/
     +    691,  692,  693,  694,  695,  696,  697,  698,  699,  700,
     1    701,  702,  703,  704,  705,  706,  707,  708,  709,  710,
     2    711,  712,  713,  714,  715,  716,  716,  717,  718,  719,
     3    720,  721,  722,  723,  724,  725,  726,  727,  728,  729,
     4      7,  731,  731,  732,  732,  733,  734,  735,  735,  737,
     5    738,  739,  740,  741,  742,  743,  744,  745,  746,  747,
     6    748,  749,  750,  751,  752,  753,  754,  755,  756,  757,
     7    758,  759,  760,  761,  762,  763,  764,  765,  766,  767,
     8    768,  769,  770,  771,  772,  772,  774,  775,  776,  777,
     9    778,  779,  780,  781,  782,  783,  784,  785,  786,  787/
            data (jb2(i),i=  801,  900)/
     +    788,  789,  790,  791,  791,  792,  793,  794,  795,  796,
     1    797,  798,  799,  800,  801,  802,  803,  804,  805,  806,
     2    807,  808,  809,  810,  811,  812,  813,  814,    8,  815,
     3    816,  817,  818,  819,  820,  821,  822,  823,  824,  825,
     4    826,  827,  828,  829,  830,  831,  832,  833,  834,  835,
     5    836,  837,  838,  838,  821,  839,  841,  842,  843,  844,
     6    845,  846,  847,  848,  849,  850,  851,  852,  853,  854,
     7    855,  856,  857,  858,  859,  860,  861,  862,  863,  864,
     8    865,  866,  867,  868,  869,  870,  871,  872,  873,  874,
     9    875,  876,  877,  878,  879,  880,  881,  882,  883,  884/
            data (jb2(i),i=  901, 1000)/
     +    885,  886,  887,  888,  889,  890,  891,  892,  893,  894,
     1    895,  896,  897,  898,  899,  900,  901,  902,  903,  904,
     2    905,  906,  907,  908,  909,  910,  911,  912,  913,  914,
     3    915,  916,  917,  918,  919,  920,  921,  922,  923,  924,
     4    925,  926,  927,  928,  929,  930,  931,  932,  933,  934,
     5    935,  936,  937,  938,  939,  940,  941,  942,  942,  944,
     6    945,  945,  946,  947,  947,  948,  949,  950,  951,  952,
     7    953,  954,  955,  956,  957,  958,  959,  960,  961,  962,
     8    963,  964,  965,  966,  967,  968,  969,  970,  971,  972,
     9    973,  974,  975,  976,  977,  978,  979,  980,  981,  983/
            data (jb2(i),i= 1001, 1100)/
     +    984,  984,  985,   10,  987,  988,  988,  990,  991,  992,
     1    993,  994,  994,  989,  995,  996,  997,  997,  998,  999,
     2   1000, 1001, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010,
     3   1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020,
     4   1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030,
     5   1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040,
     6   1041, 1042, 1043, 1044, 1045, 1045,   12, 1048, 1049, 1050,
     7   1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060,
     8   1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070,
     9   1071, 1072, 1073, 1073, 1074, 1075, 1076, 1076, 1047, 1077/
            data (jb2(i),i= 1101, 1200)/
     +   1077, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087,
     1   1088, 1088, 1090, 1091, 1092, 1093, 1094, 1095, 1096, 1097,
     2   1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106, 1107,
     3   1108, 1109, 1110, 1111, 1112, 1113, 1114, 1115, 1116, 1117,
     4   1118, 1119, 1120, 1121, 1122, 1123, 1124, 1125, 1126, 1127,
     5   1128, 1129, 1130, 1131, 1132, 1133, 1134, 1135, 1136, 1136,
     6   1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144, 1145, 1146,
     7   1146, 1147, 1148, 1149, 1150, 1151, 1151,   14, 1152, 1153,
     8   1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163,
     9   1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172, 1173/
            data (jb2(i),i= 1201, 1260)/
     +   1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182, 1183,
     1   1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191, 1192, 1193,
     2   1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202, 1203,
     3   1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213,
     4   1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1222,
     5    995,    0,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine vt(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(560) :: jx,jy
            integer(kind=iknd), save, dimension(570) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'vermont       '/
            data jrot,ipart/0,1/
            data kv/   1, 555,   0,   0,   0/
            data kb/   1, 568,   0,   0,   0/
            data iib/ 353,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  39888,28680,17808,15096,41520,38136,16128,15480,35664,17544,
     1  23640,32064,38304,36672,33552,27576,24168,21864,20160,14808,
     2  14808,14616,14640,14760,14712,14760,14880,14880,15048,14952,
     3  15000,15456,15480,15384,15216,14808,14640,14640,14808,14976,
     4  15288,15336,15336,15096,15072,15216,41928,41928,42216,42792,
     5  43032,43224,43536,43776,44136,44208,44448,44568,44808,44712,
     6  44760,44880,44904,45048,45168,45480,45600,45720,45672,45792,
     7  45840,45528,45768,45864,45816,45528,45456,45600,46056,46128,
     8  46248,46152,46224,46272,46320,46440,46464,46416,46296,46272,
     9  46152,46176,46008,46176,46128,46272,46104,46224,46248,45960/
            data (jx(i),i=  101,  200)/
     +  46032,45960,45696,45672,45768,45576,45528,45552,45408,45360,
     1  45312,44784,44640,44904,45240,45552,45648,45552,45864,45912,
     2  45864,45960,46248,46824,46512,46392,46368,46440,46392,45960,
     3  46056,46080,46488,46944,47208,15480,15816,15840,16248,16320,
     4  15984,15888,15648,15672,15888,15960,16104,37920,37656,37848,
     5  37920,37776,37776,37656,37800,37992,38160,38256,39288,39912,
     6  40128,40320,40920,41136,38136,38256,37992,37968,38088,38232,
     7  38352,38328,38160,38328,38280,38064,37992,37752,37848,37608,
     8  37632,37536,37392,37344,37440,37248,37176,37176,37032,37128,
     9  37104,37368,37488,37368,37368,37272,37056,37032,36504,36360/
            data (jx(i),i=  201,  300)/
     +  36168,36144,36240,36216,35928,36024,35952,36024,35688,15624,
     1  15528,15264,14952,14952,15216,15216,15120,15168,15072,14808,
     2  14592,14640,14520,14592,14544,14352,14040,13968,14448,14448,
     3  14712,14784,15312,15456,15576,15960,17568,17664,17496,17280,
     4  17064,16920,16728,16776,16752,16584,16560,16416,16296,15792,
     5  15480,15360,15312,15144,15144,15192,14952,14808,14376,14376,
     6  14496,14448,14520,14496,14352,14352,14616,14760,15024,15312,
     7  15312,35400,35208,34488,34104,34008,34080,33840,33816,33624,
     8  33672,33552,33648,33648,33432,32880,32808,32760,32784,32496,
     9  32496,32784,32832,32664,32688,32472,32328,32328,32400,32688/
            data (jx(i),i=  301,  400)/
     +  32760,32472,32520,32688,32424,32328,32040,31992,17424,17304,
     1  17280,17208,17520,32040,31776,31608,31368,31056,31032,30648,
     2  30480,30360,30336,30192,30168,30264,30480,30576,30672,30648,
     3  30528,30576,30792,31656,31728,31704,31992,32040,32016,31728,
     4  31728,31608,31632,32040,32112,32016,32160,31800,31848,31944,
     5  31848,32040,31992,39384,38760,40392,39432,29064,29016,29184,
     6  28440,17256,16992,17256,17616,17808,17880,17808,17688,17640,
     7  17616,17712,17592,17352,17160,16896,16800,16824,17208,17328,
     8  27840,25560,25536,25440,25392,25224,25128,24960,24768,23832,
     9  23136,22968,22704,22584,22560,22608,22560,22608,20640,31224/
            data (jx(i),i=  401,  500)/
     +  30192,32184,32064,38208,36408,36912,35904,34056,16248,16728,
     1  16896,16968,16896,16968,17208,17304,17280,17376,31104,22848,
     2  24288,24624,24288,24768,24192,24792,30192,28344,27408,25464,
     3  41184,40008,41208,40128,41064,40296,39792,34800,34728,34752,
     4  34848,34896,34848,34824,34944,34080,33288,33336,32472,35928,
     5  33600,22728,22392,24216,24816,24480,23952,23256,23040,23304,
     6  22080,21984,21168,21240,20328,20328,19224,17232,16872,26136,
     7  23424,23088,31584,31248,29208,29136,28704,28080,27936,27168,
     8  25344,22512,22248,23880,23952,24096,24912,25008,18216,17952,
     9  19080,19056,21264,21504,23952,23976,24600,24720,25320,25416/
            data (jx(i),i=  501,  560)/
     +  25368,25392,25536,25536,25464,25584,24984,25200,24984,27072,
     1  26136,25872,25632,25992,25992,26760,26760,26832,26616,26088,
     2  25104,25080,24624,24624,24408,24408,25392,25320,25416,25344,
     3  25536,25464,25560,25488,26880,29208,31176,33336,20448,22344,
     4  22248,22512,22512,25248,25272,23688,22152,22248,24504,24576,
     5  24744,24768,27648,30000,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  61560,61128,60960,50088,45672,40968,42912,30624,31560,20112,
     1   6384,18552,61488,61296,61152,61224,61176,61080,61104,50616,
     2  50952,51480,51768,51936,52080,52320,52536,52776,53280,53352,
     3  54360,55392,55560,55968,56184,56496,56760,57000,57336,58200,
     4  58608,58800,59736,60096,60312,60840,45888,46464,46848,47112,
     5  47016,47184,47232,47352,47664,47808,47976,48432,48576,48744,
     6  48864,48912,48816,48840,49056,49128,49464,49464,49632,49536,
     7  49560,49968,50064,50376,50496,50712,50928,51048,51072,51216,
     8  51240,51480,51504,51408,51408,51528,51648,51744,51744,51840,
     9  51792,51936,51960,52056,52440,52464,52584,52584,52608,52776/
            data (jy(i),i=  101,  200)/
     +  52920,53136,53136,53160,53232,53280,53568,53664,53712,53832,
     1  54216,55032,55488,55680,56208,56472,56808,57120,57480,57696,
     2  57912,58248,58464,59376,59736,60024,60120,60168,60648,61176,
     3  61296,61536,61776,61704,62016,49752,49200,49032,48120,46992,
     4  46176,45816,45312,45024,44472,43752,43344,41256,41784,42360,
     5  42984,43272,43608,43728,44136,44232,44448,44832,45288,45336,
     6  45552,45600,45384,45432,40632,40272,40008,39744,39552,39648,
     7  39576,39384,39264,39072,39048,39024,38736,38544,38376,38208,
     8  37968,37680,37704,37632,37368,37464,37416,37248,36936,36744,
     9  36408,36408,36312,36240,36072,35928,35784,35232,34752,34416/
            data (jy(i),i=  201,  300)/
     +  34320,34248,34032,33936,33744,33192,32832,32424,31848,30984,
     1  31368,31728,32232,32400,32736,32904,33072,33552,33936,34224,
     2  34968,35424,36120,36624,36984,37296,37560,37752,39168,39744,
     3  40200,41136,41640,42000,42144,42432,25080,25392,25944,26184,
     4  26304,26448,26472,26928,27096,27312,27600,27552,27624,27552,
     5  27552,27504,27024,26856,26592,26472,26184,26232,26592,26784,
     6  27000,27216,27336,27504,27768,27960,28416,29040,29640,29904,
     7  30264,31320,30960,30504,30000,29448,29160,28680,28392,28200,
     8  28056,27816,27528,27432,27192,26832,26712,26472,25968,25344,
     9  25176,24888,24672,24144,23736,22368,22104,21936,21624,21552/
            data (jy(i),i=  301,  400)/
     +  21456,21024,20712,20496,19536,19368,19032,18864, 8544, 8592,
     1   7992, 7848, 6432, 6360, 6792, 7272, 7440, 7296, 7728, 8064,
     2   8400, 8760, 9168, 9528, 9720,10056,10272,10416,10896,11328,
     3  11640,11808,11952,12312,12504,12768,12960,13104,13248,13512,
     4  13896,14208,14304,14712,14952,15408,15768,16440,17040,17232,
     5  17544,17784,18144,55728,56136,58368,59016,59160,59136,56952,
     6  55680,59736,59424,58704,58512,58512,58392,57672,57432,57096,
     7  56952,56664,56376,56256,56064,55608,55224,54936,54288,53976,
     8  56136,55680,55464,55464,55224,55224,54504,54504,53424,53856,
     9  52488,52272,52248,52320,52224,52128,52104,51936,52320,54360/
            data (jy(i),i=  401,  500)/
     +  52176,51240,51024,54000,55152,53592,54024,50112,50448,50760,
     1  51000,51192,51696,52008,52104,52224,52800,53136,49128,51888,
     2  50040,49944,49176,48936,47784,47616,47160,48408,46416,47448,
     3  54552,52824,52008,50424,49248,48192,47856,47280,47184,47160,
     4  47232,47136,47136,47040,46968,45216,44208,43584,41904,41736,
     5  41424,40632,40584,46440,46152,45384,45528,43968,43488,43368,
     6  42600,43776,43944,43536,43392,43488,43224,42864,42840,37512,
     7  38496,38448,42288,40056,40824,40584,40728,38952,39000,37128,
     8  35856,32520,33528,34368,33480,33408,35256,35232,30984,32688,
     9  32760,32856,33000,31992,33336,32880,32664,32904,32688,32520/
            data (jy(i),i=  501,  560)/
     +  32496,32376,32328,32208,32160,32064,30672,30576,29976,29184,
     1  26880,26976,24648,24576,24240,24048,23880,23880,22920,21360,
     2  21864,21672,21624,21072,21048,19944,35832,35664,35640,35472,
     3  35400,35256,35208,35064,34656,33816,33048,32448,19992,19992,
     4  19656,19680,19968,19920,18864,10920,10968,15504,15432,17640,
     5  17664,19032,18144,18528,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,   13,   14,    2,    2,   16,   17,   18,    3,    4,
     1     20,   21,   22,   23,   24,   25,   26,   27,   28,   29,
     2     30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
     3     40,   41,   42,   43,   44,   45,    3,    5,   47,   48,
     4     49,   50,   51,   52,   53,   54,   55,   56,   57,   58,
     5     59,   60,   61,   62,   63,   64,   65,   66,   67,   68,
     6     69,   70,   71,   72,   73,   74,   75,   76,   77,   78,
     7     79,   80,   81,   82,   83,   84,   85,   86,   87,   88,
     8     89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
     9     99,  100,  101,  102,  103,  104,  105,  106,  107,  108/
            data (jb1(i),i=  101,  200)/
     +    109,  110,  111,  112,  113,  114,  115,  116,  117,  118,
     1    119,  120,  121,  122,  123,  124,  125,  126,  127,  128,
     2    129,  130,  131,  132,  133,  134,    1,    4,  136,  137,
     3    138,  139,  140,  141,  142,  143,  144,  145,  146,    7,
     4      6,  148,  149,  150,  151,  152,  153,  154,  155,  156,
     5    157,  158,  159,  160,  161,  162,  163,    5,    6,  165,
     6    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     7    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     8    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     9    196,  197,  198,  199,  200,  201,  202,  203,  204,  205/
            data (jb1(i),i=  201,  300)/
     +    206,  207,  208,    9,    8,  210,  211,  212,  213,  214,
     1    215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
     2    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     3    235,    7,   10,  237,  238,  239,  240,  241,  242,  243,
     4    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     5    254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
     6    264,  265,  266,  267,  268,  269,  270,    8,    9,  272,
     7    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     8    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     9    293,  294,  295,  296,  297,  298,  299,  300,  301,  302/
            data (jb1(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,   12,   10,  309,  310,  311,
     1    312,   11,   11,  314,  315,  316,  317,  318,  319,  320,
     2    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     3    331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
     4    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     5    351,  352,   12,  354,  355,  356,  357,    2,  358,  359,
     6    360,    3,  362,  363,  364,  365,  366,  367,  368,  369,
     7    370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
     8    361,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     9    390,  391,  392,  393,  394,  395,  396,  397,  380,  398/
            data (jb1(i),i=  401,  500)/
     +    361,  400,  401,  402,  354,  404,  405,  406,  407,  403,
     1      4,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     2    380,  403,  398,  420,  421,  422,  423,  424,  425,  419,
     3    427,  428,  429,  426,  354,  431,  432,  433,  434,  435,
     4    436,  437,  419,  438,  439,  440,  441,  442,  443,  444,
     5    445,  446,  447,  448,    6,  450,  449,  452,  426,  454,
     6    455,  456,  457,  458,  459,  453,  453,  461,  462,  463,
     7    464,  465,  466,  467,  468,  469,  470,  471,  452,  449,
     8    473,  474,  475,  476,  477,  478,  479,  470,  470,  482,
     9    483,  484,  485,  486,  487,  481,    8,  489,  490,  491/
            data (jb1(i),i=  501,  570)/
     +    492,  493,  482,  482,  495,  496,  497,  498,  499,  500,
     1    501,  502,  503,  504,  505,  506,  507,  508,  509,  510,
     2    511,  512,  513,  514,  515,  516,  517,  518,  519,  520,
     3    521,  522,  523,  524,  525,  481,  527,  528,  529,  530,
     4    531,  532,  533,  534,  535,  536,  537,  538,   10,  539,
     5    540,  541,  542,  526,  526,  544,   11,  546,  547,  548,
     6    549,  550,  551,  545,  545,  553,  554,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     13,   14,   15,   15,   16,   17,   18,   19,   19,   20,
     1     21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
     2     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     3     41,   42,   43,   44,   45,   46,   46,   47,   48,   49,
     4     50,   51,   52,   53,   54,   55,   56,   57,   58,   59,
     5     60,   61,   62,   63,   64,   65,   66,   67,   68,   69,
     6     70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
     7     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     8     90,   91,   92,   93,   94,   95,   96,   97,   98,   99,
     9    100,  101,  102,  103,  104,  105,  106,  107,  108,  109/
            data (jb2(i),i=  101,  200)/
     +    110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
     1    120,  121,  122,  123,  124,  125,  126,  127,  128,  129,
     2    130,  131,  132,  133,  134,  135,  135,  136,  137,  138,
     3    139,  140,  141,  142,  143,  144,  145,  146,  147,  147,
     4    148,  149,  150,  151,  152,  153,  154,  155,  156,  157,
     5    158,  159,  160,  161,  162,  163,  164,  164,  165,  166,
     6    167,  168,  169,  170,  171,  172,  173,  174,  175,  176,
     7    177,  178,  179,  180,  181,  182,  183,  184,  185,  186,
     8    187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
     9    197,  198,  199,  200,  201,  202,  203,  204,  205,  206/
            data (jb2(i),i=  201,  300)/
     +    207,  208,  209,  209,  210,  211,  212,  213,  214,  215,
     1    216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
     2    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     3    236,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     4    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     5    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     6    265,  266,  267,  268,  269,  270,  271,  271,  272,  273,
     7    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     8    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     9    294,  295,  296,  297,  298,  299,  300,  301,  302,  303/
            data (jb2(i),i=  301,  400)/
     +    304,  305,  306,  307,  308,  308,  309,  310,  311,  312,
     1    313,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     5    352,  353,  353,  355,  356,  357,    1,  358,  359,  360,
     6    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     7    371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
     8    381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
     9    391,  392,  393,  394,  395,  396,  397,  398,  399,  399/
            data (jb2(i),i=  401,  500)/
     +    400,  401,  402,  403,  404,  405,  406,  407,  408,  408,
     1    409,  410,  411,  412,  413,  414,  415,  416,  417,  418,
     2    418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
     3    428,  429,  430,  430,  431,  432,  433,  434,  435,  436,
     4    437,    5,  438,  439,  440,  441,  442,  443,  444,  445,
     5    446,  447,  448,  449,  450,  451,  451,  453,  454,  455,
     6    456,  457,  458,  459,  460,  460,  461,  462,  463,  464,
     7    465,  466,  467,  468,  469,    7,  471,  472,  472,  473,
     8    474,  475,  476,  477,  478,  479,  480,  480,  481,  483,
     9    484,  485,  486,  487,  488,  488,  489,  490,  491,  492/
            data (jb2(i),i=  501,  570)/
     +    493,  494,  494,  495,  496,  497,  498,  499,  500,  501,
     1    502,  503,  504,  505,  506,  507,  508,  509,  510,  511,
     2    512,  513,  514,  515,  516,  517,  518,  519,  520,  521,
     3    522,  523,  524,  525,  526,  527,  528,  529,  530,  531,
     4    532,  533,  534,  535,  536,  537,  538,    9,  539,  540,
     5    541,  542,  543,  543,  544,  545,  546,  547,  548,  549,
     6    550,  551,  552,  552,  553,  554,   12,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine va(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(3350) :: jx,jy
            integer(kind=iknd), save, dimension(3460) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'virginia      '/
            data jrot,ipart/1,3/
            data kv/   1,2734,3007,3345,   0/
            data kb/   1,2848,3122,3460,   0/
            data iib/1126, 266, 338,   0,   0/
            data (jx(i),i=    1,  100)/
     +  20304,19080,19872,19464,19272,19104,18504,18408,18432,18384,
     1  18552,18552,18936,19056,19272,19656,19824,20160,20304,20448,
     2  20760,20856,17184,17592,17736,17952,18216,18312,18600,19200,
     3  19248,19320,19416,19800,20112,20304,20544,20760,21192,21192,
     4  21480,21624,21720,21720,22032,22296,22392,22584,22824,22944,
     5  23448,21456,21600,22128,21960,22488,22728,22488,22464,22872,
     6  24144,24024,24168,24240,24504,24696,24984,25176,25296,25416,
     7  25704,25872,26304,26952,26808,26520,25944,25368,25224,25248,
     8  25176,24672,24120,23952,23880,23688,23568,23328,27072,27216,
     9  27432,27528,27624,26568,27048,27528,27816,27912,27960,27816/
            data (jx(i),i=  101,  200)/
     +  27576,27504,27240,27216,27432,27888,27984,28128,28416,27216,
     1  26304,25920,26304,26544,26688,26736,26904,27120,27264,27504,
     2  27960,28176,28248,28248,28728,28968,29112,29304,29520,29520,
     3  29472,29592,29592,29448,29496,29472,29856,29832,29568,29520,
     4  29592,29544,29592,29976,30120,29976,30168,30264,28488,28584,
     5  28848,29040,29160,29376,29448,29376,29496,29976,30216,30600,
     6  32184,31776,30888,30696,30576,30456,30240,29928,29856,29376,
     7  32880,30360,31176,31176,31272,31200,31248,31296,31512,31656,
     8  31656,31872,32208,32232,32112,32112,31944,32088,32160,32280,
     9  32304,32424,32496,32592,32616,32736,32736,32664,32640,32544/
            data (jx(i),i=  201,  300)/
     +  32664,32736,32832,32976,32760,32808,32808,29808,29664,29592,
     1  29760,29784,29664,29664,30096,30216,30216,30072,30240,30408,
     2  30792,30936,31032,31200,31320,31320,31512,31584,31824,31848,
     3  31968,32040,32352,32976,33096,33144,33264,33816,30696,30768,
     4  31224,31464,31728,31920,32520,32472,32592,32664,32640,32520,
     5  32352,32232,32256,32352,32568,32424,32424,32376,32352,32256,
     6  32280,32208,32280,32064,32088,32040,32136,32232,32280,32304,
     7  32376,32328,32424,32376,32472,32328,32352,32400,32472,32544,
     8  32616,32616,32784,32736,32808,32832,32880,32856,32928,32856,
     9  32880,32976,32976,33120,33048,33096,33360,33408,33264,33072/
            data (jx(i),i=  301,  400)/
     +  33072,33288,33384,33408,33504,33528,33576,33552,33792,33840,
     1  33792,33912,33768,33840,33840,33648,33000,33048,33048,33096,
     2  33192,33192,33072,33216,33504,33744,33768,34200,34416,34368,
     3  34272,34200,34224,34080,34032,33888,33864,33720,33720,33600,
     4  33456,33360,33384,33576,33696,33672,33792,33648,33624,33480,
     5  33504,33744,33816,34032,34152,34200,34248,34320,34344,34056,
     6  34176,34200,34272,34272,34368,34392,34512,34512,34704,34656,
     7  34536,34512,34608,34608,34440,34392,34464,34416,34368,34272,
     8  34200,34200,34152,34080,33984,34080,34008,33888,35160,35304,
     9  32832,33000,33288,33672,33912,33936,34152,34296,34440,34728/
            data (jx(i),i=  401,  500)/
     +  34848,35376,35592,35232,35328,35400,35376,35592,35520,35592,
     1  35400,35424,35376,35400,35352,35448,35400,35352,35472,35328,
     2  35280,35328,35136,35136,35040,35064,34920,34848,34824,34728,
     3  34656,34728,34704,34440,34320,34272,34152,34032,34128,34152,
     4  34056,33912,33912,33816,33696,33648,33456,33408,33384,35616,
     5  35424,35400,35496,35640,35592,35400,35208,35088,35160,35400,
     6  35400,35256,35232,35352,35544,35472,35376,35112,35160,35280,
     7  35232,35064,35064,35664,35640,35592,35448,35472,35352,36216,
     8  36288,36072,35928,35688,35448,35472,35712,35688,35592,35400,
     9  35184,35208,35400,35496,35496,35352,35688,35568,35472,35328/
            data (jx(i),i=  501,  600)/
     +  35208,35184,35328,35424,35328,36456,36408,36024,35760,35640,
     1  37152,36840,36480,35712,36000,36192,36288,36360,36240,36312,
     2  36576,36768,36888,37080,37296,37368,37536,37680,36288,36528,
     3  36528,36360,36336,36528,36648,36816,36912,36888,36960,37008,
     4  36936,36792,36720,36576,36456,36384,36336,36480,36480,36552,
     5  36504,36624,36744,36792,37080,37248,37176,37344,37512,37656,
     6  37680,37608,37344,37176,37008,37056,37008,37104,36984,36840,
     7  36816,36936,36816,36384,36216,36048,36048,36240,36240,36120,
     8  36048,36264,36240,36144,36192,36264,36072,36096,36048,35952,
     9  35952,35856,35928,35880,35832,35832,35712,35616,35520,35496/
            data (jx(i),i=  601,  700)/
     +  35592,37920,37776,37704,38112,37848,36696,36744,36696,36888,
     1  37344,37416,37656,37584,37656,37656,37728,37800,37872,37848,
     2  37728,37944,38064,38256,38112,38136,38208,38160,38112,38016,
     3  38064,38064,37944,37968,37872,37800,37704,37728,37656,37608,
     4  37536,37632,37632,37728,37848,37704,37656,37632,37536,37608,
     5  37368,37368,37512,37416,37488,37512,37464,37368,37368,37296,
     6  37296,37224,37176,37056,37152,37104,37128,37032,37056,36864,
     7  36792,36624,36768,36720,36768,36936,36912,37032,36792,36792,
     8  36648,36624,36552,36600,36432,37776,37848,37752,37728,37872,
     9  37896,37800,37872,37632,37728,38160,37776,37896,38136,38400/
            data (jx(i),i=  701,  800)/
     +  38520,38544,38448,38448,38304,38064,37896,37800,37224,36888,
     1  36840,36936,37512,37896,37704,37680,37392,37344,37776,38136,
     2  38496,38664,38664,38016,37872,37944,38112,38136,37992,38040,
     3  37968,38016,37872,38232,38280,38352,38304,38040,37968,37920,
     4  37944,38472,38544,38736,39096,37656,37728,37848,37944,38040,
     5  38448,38448,38472,38928,38808,38688,38664,38640,38616,38544,
     6  38592,38664,38472,36264,36240,36312,36480,36432,36480,36600,
     7  36696,36768,36888,37032,37224,37344,37512,37800,37992,38232,
     8  38280,38400,38712,38784,38736,38832,39168,38592,38808,38952,
     9  39240,39192,39168,39312,39264,39192,39216,39000,39072,38928/
            data (jx(i),i=  801,  900)/
     +  38832,38856,38760,38880,38712,38592,38592,38688,38640,38640,
     1  38568,38568,38472,38568,38328,38112,38064,37968,37800,37824,
     2  37752,37344,37176,39384,39024,38832,39336,39360,39312,38928,
     3  38952,38760,38808,38880,38592,38520,38856,39048,39456,38664,
     4  38256,38376,38472,38880,38880,39096,39024,39240,39504,39528,
     5  39192,39552,39504,39480,39528,39624,39528,39504,39432,39432,
     6  39360,39264,39360,39312,39144,39000,38976,39000,39048,39072,
     7  39144,39216,39264,39096,39048,38976,39192,40728,40584,40488,
     8  40488,40344,40392,40608,40608,39720,39600,39624,39720,39888,
     9  39696,39696,39816,39840,39960,40200,40080,39960,39792,39744/
            data (jx(i),i=  901, 1000)/
     +  39624,39672,39600,39648,39216,39504,39624,39648,39984,39936,
     1  39696,39600,39600,39864,39912,39864,40056,40152,40440,40656,
     2  40776,41016,41016,41280,41568,41424,41184,41208,41328,41280,
     3  41088,40992,40680,40800,40680,40656,40536,40416,40416,40296,
     4  40104,39720,41664,42144,42192,42024,42048,42000,41808,41688,
     5  41400,41376,41640,41160,40920,40920,40992,40992,41088,41112,
     6  40944,41472,41520,41448,41520,41520,41616,41592,41760,41592,
     7  41568,41688,41808,41856,41952,42048,42120,42144,42216,42144,
     8  42432,42264,42240,39888,40248,40608,40728,40944,40992,41136,
     9  41160,41304,41328,41496,41592,41736,41856,42432,42120,42144/
            data (jx(i),i= 1001, 1100)/
     +  42048,42048,42120,42240,42264,42456,41616,41784,41832,42000,
     1  41976,42072,42120,42192,42336,42456,42720,42264,42144,41808,
     2  41712,41472,41592,44952,44904,44616,44448,44400,44736,44904,
     3  44880,44640,44520,44280,44208,44208,44040,43944,43824,43896,
     4  43848,43968,44088,44280,44184,44088,44088,44256,44448,44448,
     5  44616,44568,44760,44784,44856,44832,44328,42792,41256,41160,
     6  41184,41352,41400,41496,41520,41616,41712,41808,41928,41976,
     7  41904,41928,41736,41712,41568,41640,41736,41904,41952,41736,
     8  41688,41424,41280,45096,45240,45288,45336,42600,42768,42840,
     9  42768,42792,42912,43008,43200,43440,43728,43848,43872,44208/
            data (jx(i),i= 1101, 1200)/
     +  44520,44520,44736,44736,44928,45120,45216,45288,45408,45312,
     1  45408,45408,45432,45240,45456,45528,45600,45768,45840,45528,
     2  45696,45840,45864,45936,45960,45960,21336,21120,20952,20952,
     3  20640,20520,19920,19632,19344,20472,20784,20856,21096,21408,
     4  21480,21504,21624,21480,21144,20832,20832,20760,20832,20808,
     5  20736,21000,21144,21312,21384,21432,21816,21528,21480,22104,
     6  22464,22608,22608,22536,22440,22920,22992,22944,22632,22584,
     7  22224,22104,23016,22800,22848,22776,22824,22728,22560,22320,
     8  22224,23064,22896,21720,21888,21936,21912,21960,22248,22824,
     9  22824,22896,23400,23328,23376,23088,24048,23832,23760,23280/
            data (jx(i),i= 1201, 1300)/
     +  23808,24072,23328,23424,23592,23616,23760,23808,24000,24072,
     1  24360,24480,24576,24576,23088,23088,23160,23328,23352,23496,
     2  23448,23760,23976,23928,24072,24216,24288,24168,24288,24384,
     3  24336,24600,24864,25104,25368,25320,25128,24888,24792,24672,
     4  24600,24264,24240,24120,24144,25656,24312,24432,24072,25872,
     5  23256,22968,22824,22680,22776,26232,26328,26160,25584,25584,
     6  25512,25536,25536,26352,26208,26832,26664,26328,26256,26088,
     7  25992,25800,27312,26784,26328,27168,27216,27312,27216,27120,
     8  26880,26808,26592,26424,26184,26112,25704,25608,25512,25416,
     9  25320,25200,25032,24888,24912,24816,24720,24576,27408,25752/
            data (jx(i),i= 1301, 1400)/
     +  26472,26664,26736,26688,26904,26976,27072,27144,27336,27312,
     1  27696,27792,27816,27696,27624,27648,27792,28176,28080,28152,
     2  28272,28248,28104,28008,27888,27912,28056,27912,28368,28344,
     3  28176,28128,28032,27888,27720,27624,27504,27264,27120,28320,
     4  28392,28320,28344,28224,28056,27984,28032,27912,27912,27864,
     5  27816,27624,27576,27672,27624,27672,27624,27648,27792,27744,
     6  27696,27504,27600,27672,28464,28176,28608,28512,28632,28608,
     7  28464,28200,28824,28728,28680,28416,28272,28080,27936,27864,
     8  28848,28680,28680,28584,28536,28368,28224,28080,27888,28800,
     9  28848,28728,28776,28680,28584,28536,28392,28392,28296,27960/
            data (jx(i),i= 1401, 1500)/
     +  27720,27648,27528,27096,28848,28800,28848,28728,28752,28920,
     1  29016,29112,29208,29088,29040,28824,28800,28704,28656,28704,
     2  28680,28464,28920,28848,29040,29016,28776,28752,28824,28896,
     3  28944,29136,29328,29376,29232,29328,29376,28608,28608,28488,
     4  29544,29184,29064,29112,29040,28968,28632,28608,29688,27696,
     5  27768,27888,28008,28176,28320,28776,28968,29136,29256,29568,
     6  29496,29568,29880,29544,30192,30240,28176,30216,30072,30072,
     7  29952,29976,30048,30024,30144,30840,30768,30648,30168,31128,
     8  30768,30552,30360,31248,31128,31032,31080,30840,30864,30744,
     9  30624,30576,30336,30384,30288,30312,30240,30720,30888,30984/
            data (jx(i),i= 1501, 1600)/
     +  31128,31296,31272,31152,31176,31008,31080,31008,30720,30480,
     1  30504,30072,29880,29880,30144,31392,31392,31272,31416,30840,
     2  31464,31032,31008,30792,30456,30192,29976,29928,32232,32064,
     3  31752,31512,31440,31704,31896,31920,32352,32496,32376,32256,
     4  32064,31632,31464,31464,31296,32688,32328,32568,32448,32448,
     5  32640,32736,32712,32208,32088,31848,31824,31704,31584,31296,
     6  31296,32808,32688,32568,32544,32928,32352,32088,31344,31272,
     7  33288,32832,32856,32736,32160,32136,32280,33288,33072,32904,
     8  32520,32424,32088,32112,32208,31512,31632,31776,31728,31896,
     9  31992,32040,32088,32064,32400,32304,32616,32640,32880,33024/
            data (jx(i),i= 1601, 1700)/
     +  33096,33168,33144,33408,33408,33216,33552,33552,33336,33168,
     1  33000,33576,33456,33240,33072,33024,33192,33072,33192,32760,
     2  32760,32664,32712,32664,32448,32376,32256,32184,32040,31824,
     3  31824,31656,31536,33360,33552,33672,33432,33096,33024,32928,
     4  32616,32664,32640,32520,33672,33936,33960,32640,32808,32904,
     5  33264,33696,33768,34008,33072,32928,34200,33912,33816,33864,
     6  33768,33600,34200,34032,33912,33912,33768,33696,33264,34200,
     7  34224,34104,34176,34488,34464,34320,34128,33936,33744,33960,
     8  34320,34248,34416,34560,34632,34656,34728,33288,33456,33504,
     9  33624,33624,33672,33720,33720,33816,33768,33888,34008,33912/
            data (jx(i),i= 1701, 1800)/
     +  34032,34032,33888,33840,33864,34008,34152,34272,34224,34320,
     1  34224,34200,34368,34440,34512,34416,34464,34608,34680,34704,
     2  34752,34896,34704,34344,34080,33936,33672,33840,34032,34344,
     3  34632,34680,35160,34896,34872,35016,35064,35064,35016,35184,
     4  35352,35160,35232,34992,35040,33696,33456,33624,33648,33816,
     5  34080,34296,34416,34584,34800,34944,35424,35568,35544,35448,
     6  35400,35328,35208,35040,34848,34872,34896,35064,35040,34896,
     7  34704,34560,34392,34608,34920,35016,35160,35136,35328,35328,
     8  35400,35232,35208,35064,34992,34872,34776,34608,34392,34440,
     9  34272,34056,34128,34080,33936,33960,33816,33816,33576,33552/
            data (jx(i),i= 1801, 1900)/
     +  33408,33264,33264,33120,33096,33024,33024,32976,32808,32736,
     1  32424,32328,32208,35640,35064,35640,35688,35112,35112,35592,
     2  35520,35064,34344,34392,34320,34344,34200,34224,34344,34392,
     3  34152,35904,35784,35568,35424,35328,35184,35064,35112,34824,
     4  34680,34536,34536,34680,34656,34440,36048,35976,34728,34680,
     5  34536,34368,33768,33696,33672,33552,33432,35760,36120,36120,
     6  36024,35928,35376,35400,35520,35784,35808,35880,36216,35784,
     7  35616,34968,34656,34608,34248,36360,36360,36264,36312,36024,
     8  35568,35592,35496,35448,35256,35424,35352,35424,35376,35184,
     9  35160,35304,35352,35568,35784,36072,36000,36168,36648,35736/
            data (jx(i),i= 1901, 2000)/
     +  35856,35856,35760,35880,35856,36096,36456,36552,36480,34944,
     1  36720,36840,36744,36720,36552,36456,36480,36576,36408,36528,
     2  36360,36048,35616,35472,35544,36864,36840,36936,36744,36792,
     3  36576,36528,36576,36432,36312,36312,36432,36504,36720,36744,
     4  36648,37032,36936,36624,37152,37056,36960,36672,36528,36432,
     5  36408,36504,36528,37080,36984,36864,36960,36960,37056,37104,
     6  36984,36912,36840,36888,36768,36768,36840,36792,36840,36696,
     7  36696,36600,36576,36456,36312,36312,36168,36216,36168,36192,
     8  36336,36456,36504,36456,36624,36816,37152,36792,36912,37080,
     9  37224,36984,37104,37152,37224,37104,37248,37416,37128,36504/
            data (jx(i),i= 2001, 2100)/
     +  36168,35304,37440,37440,37128,36960,36840,36888,37248,37176,
     1  37224,37320,37272,37176,37032,37008,37104,37416,37512,37464,
     2  37248,37416,37392,37368,37512,37512,37392,37224,37152,37392,
     3  37584,37272,37296,37128,37656,37488,37272,37080,37008,36864,
     4  36888,36792,37224,37224,37440,37272,37176,37224,37176,37344,
     5  37488,37536,37728,37536,37584,37584,37704,37920,37680,37680,
     6  37944,35040,37968,37920,38016,37848,37824,37680,37584,38016,
     7  37920,38064,38136,38184,38184,37824,37776,37728,37848,37800,
     8  37944,38232,38136,38256,38016,38256,37968,38352,37800,38064,
     9  38064,38280,38352,38352,38304,38232,38400,37992,38448,38352/
            data (jx(i),i= 2101, 2200)/
     +  38088,37824,37752,37656,37512,37344,37080,36696,36720,37008,
     1  37032,36840,36600,36624,36504,36384,38280,38424,38376,38400,
     2  38472,38472,38208,38304,38160,38304,38304,38472,38448,38304,
     3  38136,37872,37800,37608,37560,37272,37080,38616,38400,38640,
     4  38424,38472,38424,38184,38736,38088,38232,38256,38328,38544,
     5  38856,38856,38328,38136,38088,37992,37920,37848,38400,38832,
     6  38832,38928,38808,38880,39120,38904,38688,38808,38904,39000,
     7  39096,39192,39192,39264,39312,39024,38928,38664,38568,38640,
     8  39048,39144,39288,39312,39264,39336,38616,38664,38952,39024,
     9  39096,39264,39360,39192,39240,39408,39384,39168,39192,39168/
            data (jx(i),i= 2201, 2300)/
     +  39024,39600,39312,39744,39648,38568,38664,38592,39744,39864,
     1  39072,38904,38808,40056,40104,39696,39504,39888,39792,39648,
     2  39792,38856,39336,39384,39552,39528,39672,39864,39984,40032,
     3  40128,40200,40008,40008,39792,39648,39648,39552,39504,39552,
     4  39720,39456,39360,39360,39456,39528,39696,40128,40056,39816,
     5  39792,39912,40224,40248,38520,39216,40296,40248,40416,40368,
     6  40488,40368,40272,40296,40152,40080,40512,40368,40224,40248,
     7  40368,40200,39960,39792,39912,39912,39624,39456,39384,39432,
     8  39360,39936,40320,40464,40416,40728,40656,40800,40392,40296,
     9  40824,40752,40608,40584,40752,40680,40800,40656,40320,40224/
            data (jx(i),i= 2301, 2400)/
     +  40248,40416,40416,40248,40104,40344,40368,40080,40200,40248,
     1  40344,40440,40512,40776,40848,40848,40224,39696,39576,41016,
     2  40896,40680,40584,40464,39936,39984,39576,39624,39528,39216,
     3  39360,39288,39360,40992,40968,41064,40920,40944,40824,40752,
     4  40464,40416,41064,39912,40536,38808,39504,39936,39960,40200,
     5  40296,40392,40464,40872,40992,41088,41088,40968,41112,41040,
     6  40824,40632,40344,40272,40320,40224,40248,41184,40920,41040,
     7  41088,41256,39720,39720,39480,39456,41280,40992,40920,41088,
     8  40920,41352,41256,41088,40824,41400,40536,40344,40368,40200,
     9  40272,40248,40080,41424,41184,41112,40968,40944,40656,40416/
            data (jx(i),i= 2401, 2500)/
     +  40296,40176,40104,40008,39840,39432,39408,41328,41400,41376,
     1  41448,41472,41544,41520,41664,41448,41544,41544,41184,41208,
     2  41088,41760,41616,41424,41712,41544,41496,41328,41424,41376,
     3  41496,41472,41328,41424,41328,41328,40752,40560,40728,40776,
     4  40944,41136,41040,41088,41856,41712,41232,41184,40848,40224,
     5  41904,41208,40752,40368,41976,41808,42000,41856,41856,41352,
     6  41088,41088,41280,41280,41160,41328,41064,40992,42096,41976,
     7  41328,41160,41232,41976,41760,42192,42048,41688,41400,41376,
     8  41592,42192,42048,41832,42000,42192,42264,42192,42264,41976,
     9  41904,41688,42336,42360,42288,42360,42192,42600,42480,42456/
            data (jx(i),i= 2501, 2600)/
     +  42360,42696,42096,42144,42000,41256,42696,42552,42408,42408,
     1  42576,42744,42792,42552,42120,41928,42000,41976,41856,41688,
     2  41568,41496,41232,40968,40800,40632,42984,43320,42504,42504,
     3  42672,42600,42600,42768,42672,42960,43056,43104,43248,43224,
     4  43128,43344,43272,42552,42576,42528,42864,43128,43176,43032,
     5  43056,43248,43344,42864,42864,42696,43416,43344,43368,42960,
     6  43536,43224,43104,43080,42984,42984,43560,43128,43512,43608,
     7  43608,42528,43824,43872,42312,42552,42480,42552,42384,42360,
     8  43704,43608,43800,43800,43872,41232,41472,41640,41832,42408,
     9  42888,42960,43368,43440,43728,43776,43944,44040,44160,43848/
            data (jx(i),i= 2601, 2700)/
     +  43872,43968,43992,44184,44256,43848,43608,43344,43128,42960,
     1  42840,42696,42648,42240,42048,41928,41256,41280,41400,41448,
     2  41760,41712,41472,41448,41520,41472,41280,44280,44040,43680,
     3  43464,43176,43080,42888,42672,42744,42792,42576,42648,44328,
     4  43224,41568,41496,41592,44280,44352,43992,43992,43872,43584,
     5  43464,43392,43128,43152,42888,42840,42720,44760,43824,43680,
     6  43536,42936,42840,42240,44952,44856,44640,44592,44592,44904,
     7  45000,43968,44064,44280,44424,44472,44544,44832,44856,45024,
     8  43608,45072,42504,45144,44880,44592,44472,45288,44520,44064,
     9  43944,43824,44232,44256,44400,44376,44496,44568,44808,44880/
            data (jx(i),i= 2701, 2800)/
     +  45168,45336,45360,45288,45168,45024,45000,45096,43872,45672,
     1  45504,45408,44880,44592,44448,45552,45480,45096,45072,44832,
     2  45024,44904,44904,44784,44736,44640,44424,43536,43632,43824,
     3  44160,44832,45336,35016,35088,35040,35184,35112,35496,35808,
     4  35664,35352,35304,35568,35664,35712,35664,35712,35760,35808,
     5  35952,35976,35928,36240,36480,36360,36120,36312,36312,36384,
     6  36384,36504,36648,36696,36624,36720,36816,36912,36912,37248,
     7  37512,37296,37152,37200,37296,37344,37560,37656,37656,37704,
     8  37920,38112,38136,37992,37944,38040,38112,38208,38232,38472,
     9  38808,39264,39288,39096,38952,38664,38376,38448,38400,38016/
            data (jx(i),i= 2801, 2900)/
     +  37632,37584,37296,37176,37032,36984,36888,36912,36768,36624,
     1  36576,36360,36336,36456,36504,36432,36264,36048,36000,35832,
     2  30840,31032,31152,31200,31152,31296,31224,31464,31512,31584,
     3  31632,31584,31464,31560,31464,31488,31560,31632,31680,31632,
     4  31752,31728,31920,31968,31920,32040,32184,32184,32280,32016,
     5  32184,32232,32256,32424,32328,32496,32472,32568,32568,32688,
     6  32712,32568,32760,32784,32712,32712,32856,32592,32688,32616,
     7  32544,32520,32544,32688,32832,32736,32736,32856,32976,33144,
     8  33072,32976,33144,33168,33072,33360,33264,33264,33456,33528,
     9  33456,33360,33504,33360,33456,33456,33600,33576,33792,33792/
            data (jx(i),i= 2901, 3000)/
     +  33864,33888,33792,33960,33912,34056,34032,33912,33912,33984,
     1  34080,34032,34128,34248,34296,34392,34296,34200,34248,34344,
     2  34416,34440,34584,34512,34296,34440,34560,34656,34608,34728,
     3  34800,34848,34752,34800,34752,34992,34920,31800,31776,31704,
     4  31320,31272,31320,31416,31656,31488,31320,31104,31032,30936,
     5  30888,30576,30600,30528,30312,30624,30720,30792,35544,35592,
     6  35736,35616,35640,35568,35496,35544,35472,35400,35424,35280,
     7  34968,34896,35064,35064,34848,34824,34896,34752,34752,34632,
     8  34392,34320,33936,33912,33816,33840,33720,33528,33216,33072,
     9  32688,32712,32832,32784,32328,32184,31968,31968,32088,35016/
            data (jx(i),i= 3001, 3100)/
     +  35256,35400,35496,35496,35616,35760,32112,32232,32232,32136,
     1  44664,44568,44616,44760,44808,44880,44856,44784,44616,44616,
     2  44712,44736,39504,39552,39552,39480,39432,39216,39360,39360,
     3  39144,39144,39000,38976,39048,38760,38952,38760,38808,38592,
     4  38616,37584,37560,37680,37872,37944,38256,38352,38232,38256,
     5  38400,38520,38760,38856,38880,38592,38904,38736,38400,38232,
     6  38232,38064,38016,37680,38592,38712,38688,38496,38520,38448,
     7  38400,38496,38448,38448,38568,38520,38448,38496,38424,38376,
     8  38136,38136,38256,38352,38184,38184,37680,37536,37560,37848,
     9  37968,37872,37824,37632,37608,37776,37560,37656,37800,37704/
            data (jx(i),i= 3101, 3200)/
     +  37368,37296,37416,37536,37488,37272,37200,36936,36768,36960,
     1  37032,37248,37464,37488,36984,36936,36816,36864,36960,37416,
     2  37464,37224,37080,37056,37104,37248,37176,36984,37224,37152,
     3  37056,36768,36672,37080,37056,37176,37152,37008,37056,37128,
     4  36552,36576,36624,36648,36552,36648,36144,36072,36048,35952,
     5  35856,36072,36312,36624,36672,36528,36624,36576,36384,36504,
     6  36504,36576,36648,35688,35976,35832,35808,35568,35592,35784,
     7  35808,35880,35856,35808,35712,35688,35592,35712,35760,35808,
     8  35760,35712,35496,35568,35472,35472,35280,35280,35232,35232,
     9  35376,35376,35280,35280,35184,35208,35160,35136,34992,34944/
            data (jx(i),i= 3201, 3300)/
     +  35112,35112,35160,35088,34968,34824,34800,34656,34680,34800,
     1  35496,35688,34560,34632,34584,34776,34800,34752,34752,34632,
     2  34584,34152,34056,33960,33888,33744,33744,34224,34584,34512,
     3  34560,34536,34272,34296,34464,34368,34272,34224,34632,34584,
     4  34512,34344,34584,33744,33792,33720,33672,33528,33528,33576,
     5  33600,32256,32208,32328,32448,32568,32808,32880,33288,33528,
     6  33648,32280,32904,32952,32880,32808,32880,32568,32472,32736,
     7  32496,32472,32544,32568,32448,32304,32256,32184,32280,32568,
     8  32616,32664,32592,31800,31536,31560,31632,32184,32040,31752,
     9  31824,31800,31680,31656,30120,30096,30864,31608,31824,31872/
            data (jx(i),i= 3301, 3350)/
     +  31824,31752,31608,31464,31416,31296,31248,30600,30408,30360,
     1  30168,30792,30912,31032,31176,31248,31344,31440,30888,30768,
     2  30600,30600,31200,31368,31392,31200,31104,31200,31176,31296,
     3  31344,31152,31200,31296,31200,31200,31272,31296,31200,30984,
     4  30984,31152,31032,30960,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  51960,50400,52152,52248,52368,52368,52632,52728,52920,53064,
     1  53472,53904,54120,54504,54768,54624,54360,54288,54336,54624,
     2  54816,55800,47928,47928,47856,47952,47832,48024,47880,47472,
     3  47448,47568,47568,47352,47592,47400,47256,46920,46560,56448,
     4  56424,56544,56880,57168,57432,57648,57864,58056,58152,58080,
     5  58104,46344,46512,46152,45936,45600,45288,45288,45216,44784,
     6  44160,58128,58080,57840,57504,57432,57456,56952,56760,56616,
     7  56544,56424,56256,41496,41616,41640,41952,42144,42216,42360,
     8  42480,42480,42720,42720,42936,42960,43080,43152,41376,41352,
     9  41064,41088,40848,56136,56112,56256,56424,56496,56664,57264/
            data (jy(i),i=  101,  200)/
     +  57528,57960,58152,58248,58488,58488,58416,58416,58680,39576,
     1  39072,38232,38064,38064,38112,37992,37872,37848,37944,37920,
     2  37632,37632,37560,37392,37032,37176,37200,57144,58152,58056,
     3  57960,57864,57768,57744,57672,57336,57816,57720,57648,57528,
     4  57360,57264,58320,58320,58488,58752,58848,59208,58848,58944,
     5  58944,59040,59352,59664,59928,60336,61656,61896,62304,62472,
     6  35160,35592,35976,36144,36024,36024,36216,36192,36360,36744,
     7  61752,59352,59592,59736,59784,59880,59952,59880,59904,60000,
     8  60144,60480,60624,60720,60744,60888,60960,60984,60840,60744,
     9  60816,60792,60888,60912,61008,61128,61224,61296,61272,61416/
            data (jy(i),i=  201,  300)/
     +  61416,61320,61368,61536,61584,61608,61752,57864,57864,57984,
     1  58008,58080,58152,58224,58248,58464,58656,58704,58776,59208,
     2  59352,59328,59400,59304,59424,59664,59616,59736,59976,60144,
     3  60144,60360,60480,60888,61008,61320,61296,63887,62544,62831,
     4  63335,64007,64511,64703,64607,64535,64511,64439,64367,64463,
     5  64463,64367,64295,64367,64319,64271,64199,64175,64103,64127,
     6  63935,63887,63815,63551,63383,63119,63119,63599,63599,63479,
     7  63503,63695,63767,63815,63863,63911,63959,64007,63983,64079,
     8  64007,64175,64151,63863,63791,63935,63935,64079,64127,64175,
     9  64343,64391,64223,64223,64151,64103,64271,64271,64079,64007/
            data (jy(i),i=  301,  400)/
     +  63935,63983,63911,64103,64007,64151,64151,64199,64319,64295,
     1  64247,64199,64127,64127,63983,63959,61680,61728,61896,61776,
     2  61896,62016,62160,62064,62160,62328,62400,62472,62687,62831,
     3  62759,62783,62855,62855,62927,62831,62927,62831,62735,62615,
     4  62663,62592,62783,62759,62879,62951,62975,63071,63215,63263,
     5  63359,63215,63047,63143,62999,62999,63095,63095,63167,63335,
     6  63335,63455,63479,63383,63287,63287,63503,63695,63887,63959,
     7  63911,64079,64103,64175,64271,64271,64151,63959,64079,64079,
     8  63839,64055,64031,63887,63839,64127,64151,63863,58728,62711,
     9  34536,34296,34200,33864,33912,33792,33624,33576,33648,33384/
            data (jy(i),i=  401,  500)/
     +  33144,33912,60600,62759,62879,62903,63023,63263,63383,63455,
     1  63575,63647,63671,63767,63839,63863,64103,64079,64175,64175,
     2  64127,64319,64415,64151,64031,63695,63359,63383,63311,63359,
     3  63287,63167,62496,62232,61992,62160,61824,61872,61968,62160,
     4  62064,62040,61944,61992,61944,61776,61752,61416,61344,60504,
     5  60408,60336,60120,60048,59952,60096,60072,60000,59808,59832,
     6  59760,59712,59640,59376,59352,59208,59328,59256,58992,58992,
     7  58824,58872,58776,63311,63143,63143,62951,62903,62831,63287,
     8  60888,60768,60456,60480,60360,60264,60096,59904,59856,59976,
     9  59976,59904,59928,59856,59688,59568,59376,59136,59112,59208/
            data (jy(i),i=  501,  600)/
     +  59184,59088,59112,59040,58776,61296,61176,60960,60672,60648,
     1  61560,61368,60984,33600,33096,33216,33048,33240,33360,33456,
     2  33264,32856,32760,32400,32160,31944,56952,60000,63383,63407,
     3  63599,63551,63623,63743,63695,63743,63887,63959,63959,64031,
     4  64127,64127,64055,64079,63911,63935,64007,64007,64079,64103,
     5  64175,64151,64175,64271,64199,64319,64487,64391,64679,64631,
     6  64679,64727,64703,64727,64535,64655,64703,64799,64823,64631,
     7  64775,64871,64895,64823,64871,64823,64775,64799,64703,64703,
     8  64607,64631,64583,64535,64415,64391,64271,64535,64511,64583,
     9  64487,64415,64319,64055,64055,64247,64151,63935,63935,63623/
            data (jy(i),i=  601,  700)/
     +  63623,56760,56760,56880,57072,56904,61440,61560,61632,61680,
     1  62064,62184,62352,62376,62448,62568,62448,62472,62592,62653,
     2  62663,62663,62879,62951,63143,63215,63143,63455,63527,63503,
     3  63575,63815,63695,63791,63887,63839,63863,63719,63695,63767,
     4  63671,63599,63431,63311,63287,63167,63215,63359,63359,63119,
     5  63023,63119,63191,63311,63383,63575,63623,63599,63671,63647,
     6  63527,63503,63359,63335,63287,63167,63023,63023,63119,63191,
     7  62951,62975,63047,63071,63191,63335,63455,63671,63599,63551,
     8  63527,63335,63311,63167,63287,56952,57000,57216,57432,57648,
     9  57912,57936,58056,58440,58416,58488,58968,59112,59184,59376/
            data (jy(i),i=  701,  800)/
     +  59544,59712,59760,59856,60000,59952,60000,59928,31800,31752,
     1  31608,31320,30432,29640,29544,29424,29136,28968,28776,29016,
     2  28560,28176,28032,57240,57288,57432,57480,57576,57768,57816,
     3  57912,58080,58296,58368,58512,58536,58656,58800,58920,58920,
     4  59016,59184,59016,58944,62160,60048,60120,60048,60192,60072,
     5  60096,60408,60624,61008,61152,61032,61392,61440,61368,61464,
     6  61800,61920,17760,20352,20424,20544,20544,20640,20664,20472,
     7  20472,20184,20136,20208,20592,20568,20688,20592,20664,20880,
     8  21024,21120,21240,21432,21648,21936,22080,27960,27048,26616,
     9  26088,63695,63671,63575,63431,63455,63575,63551,63671,63719/
            data (jy(i),i=  801,  900)/
     +  63623,63407,63647,63839,63839,63791,63743,63743,63647,63479,
     1  63479,63647,63575,63215,62759,62568,62280,62304,62064,61968,
     2  62016,61704,61656,61656,61704,61536,61320,61176,61080,60720,
     3  60624,60624,60072,59856,59472,59232,17328,16632,15768,25416,
     4  25056,24984,24792,24600,24408,24096,24000,23904,23496,22560,
     5  22248,63983,63983,64127,64247,64295,64415,64655,64703,64583,
     6  64631,64511,64463,64391,64271,64271,64175,64055,64055,64175,
     7  64055,64079,63959,64007,63815,63815,63743,63959,64247,64319,
     8  64487,64631,64655,64511,64607,64847,64775,64727,64559,64583,
     9  64463,64415,64391,64343,64343,64175,64127,64151,64319,64223/
            data (jy(i),i=  901, 1000)/
     +  64199,64079,64031,63983,62184,62040,62160,62256,62568,62639,
     1  62496,62496,62568,62711,62783,62879,62831,62879,63359,63503,
     2  63503,63671,63767,65711,62999,63119,62999,63119,63191,63239,
     3  63167,62927,62615,62136,62208,62424,62448,62304,61992,61776,
     4  61728,61800,63863,64031,64151,64247,64343,64391,64295,64367,
     5  64295,64103,64031,65207,64823,64631,64679,64895,64871,64751,
     6  64415,64439,64487,64655,64727,64847,64799,64943,64871,64727,
     7  64583,64607,64487,64511,64655,64655,64847,65183,64967,64751,
     8  63935,63935,64007,15120,14424,14472,14400,14424,14280,14232,
     9  14112,13920,13608,13512,13272,13248,13344,13176,64703,64583/
            data (jy(i),i= 1001, 1100)/
     +  64583,64463,64295,64223,64055,63959,63551,63479,63239,63215,
     1  63095,63095,62999,63047,62759,62783,62711,62687,62903,63047,
     2  63239,63239,63095,66263,66935,66863,66671,66719,67103,67127,
     3  67343,67271,67367,67319,67343,67295,67271,67343,67367,67439,
     4  67559,67607,67463,67751,67823,67799,67895,67943,68111,68063,
     5  68111,68015,68039,68111,68063,68255,68159,67487,67079,66863,
     6  66719,66527,66335,66383,66551,66551,66647,66575,66671,66647,
     7  66551,66455,66431,66503,66359,66263,66311,66263,66119,66215,
     8  66119,66287,65903,63359,60000,22776,12264,12888,12264,12120,
     9  11928,11640,11592,11424,11400,11184,11160,11064,10632, 9528/
            data (jy(i),i= 1101, 1200)/
     +   8832, 7992, 7632, 7512, 7056, 6840, 9984,10152,57000,60000,
     1  17688,18120,18864,20616,20520,53328,51096,45720,29136,22560,
     2  24960,30912,41880,37968,35304,33552,49536,49632,49584,49656,
     3  49896,49872,50088,50112,50304,51792,51744,51600,51456,51144,
     4  51000,49464,48312,47280,47352,47640,47712,47712,47832,48072,
     5  48120,48216,48072,48192,48336,48288,50688,49992,50280,53352,
     6  57072,57240,56928,56904,56928,57552,54288,54192,54144,53928,
     7  53640,53496,49752,49848,49920,50088,50160,50304,50184,50232,
     8  50448,57744,57744,48192,48312,48288,48216,48168,48456,48168,
     9  48216,48192,47808,57768,57360,57312,48624,48552,48312,49464/
            data (jy(i),i= 1201, 1300)/
     +  49296,48816,50016,50208,50400,50544,50568,50616,50592,50664,
     1  50760,50880,51096,51312,54360,54528,54528,54576,54672,54672,
     2  55032,55272,55272,55416,55536,55536,55608,55728,55968,55968,
     3  56136,56544,56784,56712,48240,48336,48408,48336,48408,48408,
     4  48264,48336,48456,48480,48552,45912,46608,46896,47280,54480,
     5  52920,52920,53016,53016,53136,49056,56112,55704,55056,54936,
     6  54864,54720,50184,49512,49200,47424,47496,47496,47640,47760,
     7  47928,47880,53712,53736,54048,53352,53088,52944,52896,52752,
     8  52704,52608,52536,52392,52296,52128,51816,51816,51888,51816,
     9  51912,51768,51816,51720,51600,51576,51624,51528,47160,45840/
            data (jy(i),i= 1301, 1400)/
     +  45600,45624,45816,46032,46152,46152,46248,46608,46728,46800,
     1  53832,53184,53376,53448,53592,53688,53664,54936,54744,54552,
     2  54576,54504,54408,54240,54216,54120,53976,53976,50184,50112,
     3  50232,50208,50088,49992,50040,50136,50160,49920,49920,50304,
     4  50376,50448,50616,50640,50856,50976,51096,51120,51240,51312,
     5  51504,51624,51744,51816,52008,52128,52248,52368,52608,52632,
     6  52536,52656,52848,52848,55176,55056,55104,55080,54984,54840,
     7  54864,54768,56136,56088,55992,56016,55920,56112,56088,56160,
     8  45864,45936,46056,46128,46272,46392,46656,46680,46896,48720,
     9  48504,48312,48264,48264,48144,48192,48144,48024,47904,47616/
            data (jy(i),i= 1401, 1500)/
     +  47664,47568,47544,47544,55824,55728,55632,55416,56016,48888,
     1  48888,48960,49200,49296,49464,49560,49728,49728,49776,49824,
     2  49968,50160,56280,56400,56400,56520,56568,56712,56904,56904,
     3  56712,56808,56712,56880,56904,57072,58248,58248,58392,58440,
     4  45168,45456,45720,45792,45912,45840,44088,43896,48120,40800,
     5  40872,40872,40704,40632,40464,40296,40152,40200,40152,39888,
     6  39720,39600,39408,37848,49392,51288,53016,51120,51000,50544,
     7  50256,50112,50064,49872,49680,39576,39528,39552,39888,44544,
     8  44976,45000,44928,53448,53112,53088,52968,52968,52872,52680,
     9  52656,52464,52248,52104,51840,51768,51624,62064,61920,61704/
            data (jy(i),i= 1501, 1600)/
     +  61608,61584,61464,61344,61176,60816,60672,60528,60576,60288,
     1  60144,59784,59664,59544,59376,53784,53664,53568,48672,49032,
     2  58200,58056,57720,57744,57432,57576,57576,57864,57408,57336,
     3  57336,57456,57600,49320,49536,49728,50568,62592,62544,62304,
     4  62328,62208,61896,61704,61632,42120,41784,42552,42744,42912,
     5  42984,43272,43344,43728,44088,44160,44040,44064,44184,44256,
     6  44400,62040,62016,62160,62544,38328,38592,38880,39360,39264,
     7  38016,37512,37056,36456,36072,35568,35376,56136,56280,56520,
     8  56712,56832,56928,57096,57168,53784,53880,54192,54360,54432,
     9  54552,54480,54528,54696,55080,55344,55584,55488,55512,55656/
            data (jy(i),i= 1601, 1700)/
     +  55560,55680,55752,55776,55944,56064,47304,42024,42120,42120,
     1  42240,60768,60720,60456,60408,60048,59784,59496,59256,59232,
     2  59040,58944,58824,58680,58608,58464,58584,58560,58584,58488,
     3  58392,58200,58248,61032,60864,63695,63791,63743,63479,63383,
     4  63263,63023,62951,62855,49896,49848,52656,51024,51144,51480,
     5  51720,51912,52392,38136,38640,38472,46056,46368,46848,47208,
     6  47256,47232,45912,45744,45816,45936,45744,45816,45648,53496,
     7  53736,53832,53976,49200,49272,49320,49488,49704,47424,47688,
     8  48888,50352,50376,50232,50280,50400,50520,56280,56328,56256,
     9  56256,56448,56520,56472,56328,56352,56568,56544,56616,56784/
            data (jy(i),i= 1701, 1800)/
     +  56904,56952,56904,56952,57048,57072,57000,57024,57216,57264,
     1  57336,57408,57456,57408,57480,57624,58056,57984,58008,57912,
     2  57888,61608,61344,61080,60960,60840,37032,36816,36744,36408,
     3  36240,36048,35448,58152,58200,58200,58272,58368,58392,58632,
     4  62639,62424,62256,62064,61920,41808,41568,41376,41256,41256,
     5  41064,41016,40896,40896,40728,40752,40032,53832,53976,54000,
     6  54120,54120,53952,53856,53808,50640,51024,51312,51456,51576,
     7  51456,51528,51768,51936,52440,52536,52536,52992,53232,53424,
     8  60648,60576,60480,60504,60264,60336,59928,60024,59808,59568,
     9  59592,59520,59184,59112,59064,58872,58752,58584,58392,58200/
            data (jy(i),i= 1801, 1900)/
     +  58272,58200,58032,58032,58104,58080,57936,57912,57816,57864,
     1  57600,57672,57528,54312,35352,34536,57048,57576,57840,56904,
     2  56592,55752,55416,55296,55248,55128,55008,54816,54696,54504,
     3  54144,44736,44760,44664,44832,44736,44712,44904,45480,45528,
     4  45720,45672,45816,45960,46080,45960,44376,44112,43632,43536,
     5  43368,42864,42792,42672,42456,42408,42264,57264,57576,44688,
     6  44496,63239,40008,39960,39864,39936,40032,40008,39528,38904,
     7  38952,38088,38184,38136,38064,61296,61416,61512,61560,61728,
     8  61512,54816,54840,54672,54792,55032,55080,55176,55248,55200,
     9  55512,55512,55704,55776,55944,55896,55728,55680,55728,54264/
            data (jy(i),i= 1901, 2000)/
     +  54312,54480,54648,54696,54840,54864,55008,55200,55392,50400,
     1  50136,41976,41952,41784,41664,41688,41544,41400,41376,41184,
     2  40800,40584,40416,40224,40080,50232,50376,50400,50520,50712,
     3  50808,50976,51048,51000,51096,51168,51312,52008,52008,52080,
     4  52200,52320,52680,52776,59760,59856,59808,59808,59928,60072,
     5  60384,60600,60768,59640,59736,59736,59688,59544,59520,59448,
     6  59424,59520,59472,59280,59232,59136,58968,58896,58848,58776,
     7  58536,58440,58248,58080,57984,57888,57720,57648,44280,44160,
     8  44160,44040,43944,43776,43824,43536,43248,41856,41712,41712,
     9  41784,57216,57336,57312,57192,57048,57048,34992,35280,35568/
            data (jy(i),i= 2001, 2100)/
     +  35856,35352,42552,42456,42264,42024,55656,55896,56040,56136,
     1  56232,56208,56496,56568,56592,56664,56688,56616,56808,56928,
     2  56928,57096,46608,46536,46416,46344,46224,46200,45936,42600,
     3  42912,42864,43080,43104,49368,49368,49560,49584,49752,49776,
     4  49872,49968,60000,59904,59712,59736,59832,61272,61032,60936,
     5  60936,61080,61152,41904,41904,41832,41808,42120,42336,42432,
     6  47592,49200,56520,56400,47232,47040,46896,46848,46704,61272,
     7  61536,61560,61512,61560,33600,34056,34416,49176,49224,49056,
     8  49032,48696,48576,48168,47904,56256,56304,49392,61056,61176,
     9  61104,61104,61248,61608,61680,61560,32328,33048,36840,36912/
            data (jy(i),i= 2101, 2200)/
     +  37248,37392,37368,37128,37104,37464,37824,38160,38328,38568,
     1  38856,38904,39048,39192,39240,39480,36720,56664,56640,56544,
     2  56496,53976,53808,53616,53472,53448,53304,53256,53088,53016,
     3  52752,52800,52464,52344,52176,52224,52176,56136,56136,62256,
     4  62184,61992,61800,61680,55824,56160,56088,55728,55680,55824,
     5  55584,45912,46224,46368,46464,46488,46608,46536,54240,54696,
     6  54840,55008,55248,62376,30936,31656,53880,53688,53640,53448,
     7  53376,53232,52920,52824,36840,36864,36768,36816,36888,56232,
     8  56520,56400,56400,56232,56112,55968,43896,44016,44040,44496,
     9  44568,44544,44832,55608,55800,55800,45000,45192,45360,45528/
            data (jy(i),i= 2201, 2300)/
     +  45600,63863,63695,63575,63287,62472,62400,62304,63815,57912,
     1  58560,58896,58968,49416,28992,29592,30168,28776,28944,28872,
     2  28680,27792,22056,21960,21912,21840,21720,21096,21072,20880,
     3  20808,31536,31536,31392,31248,31368,31608,31656,31608,31416,
     4  31080,30888,36792,36696,36576,36504,36480,36000,35736,35568,
     5  35400,34968,34752,34656,33648,34152,34296,34488,34440,34320,
     6  31056,31440,31440,31032,31200,31368,47832,48312,48432,48936,
     7  47472,47352,47256,46896,46752,46656,46296,46272,46032,45888,
     8  45864,63431,63455,63527,63623,63791,63887,28536,28392,28704,
     9  42744,42624,42552,42480,42168,42048,41928,41880,41904,41856/
            data (jy(i),i= 2301, 2400)/
     +  41760,41760,41688,41664,41496,41352,41208,40848,40776,40512,
     1  40608,40560,40368,40344,40056,60336,61488,61656,61608,38856,
     2  38832,38640,38712,38496,38208,37992,37824,37752,37464,37320,
     3  37200,37080,36888,51264,51192,50760,50544,50472,50400,50112,
     4  49920,49704,55992,57744,56040,18120,18264,18504,18600,18720,
     5  18720,18840,18792,18984,18984,18888,19176,19272,19464,19680,
     6  19896,19896,19992,20112,20232,20472,20568,44184,43608,43512,
     7  43248,52176,52080,52224,52536,52728,51600,51336,51336,39096,
     8  39216,39768,39936,39744,39672,59544,59376,59400,59136,58800,
     9  58752,58560,58512,24456,24264,24528,24744,25104,25728,25824/
            data (jy(i),i= 2401, 2500)/
     +  25800,25296,25272,25368,25800,25632,25824,65687,65783,65663,
     1  65639,65375,65447,65567,17568,17880,18000,18096,18480,18600,
     2  18720,31512,31632,31632,31848,31920,32064,32160,32208,32304,
     3  32424,32472,32448,32616,32688,32904,33456,33888,31152,31296,
     4  31416,31440,31320,31272,17232,17184,16392,16224,16200,15816,
     5  21768,21480,21216,20856,63695,63863,24888,24960,25128,25632,
     6  26088,26256,26472,26568,26856,27024,27696,28008,54048,53736,
     7  53112,52584,52440,63935,22320,22512,22824,23280,23976,24192,
     8  24192,30744,31032,31272,21528,21336,54360,65327,65519,65687,
     9  65567,65495,47496,64799,64919,65063,65183,16896,17160,17544/
            data (jy(i),i= 2501, 2600)/
     +  17712,29928,29424,29352,29352,28680,30216,30360,30360,30456,
     1  64799,64151,33912,34152,34224,34344,34464,34560,34608,34584,
     2  34728,34608,34872,34728,34800,34800,38496,51168,47760,47976,
     3  48072,48264,48504,48672,48816,49176,49488,49992,50472,50520,
     4  50544,50976,51048,16896,15192,15120,14928,14664,14592,14352,
     5  14184,14016,13992,13512,13392,13392,27504,27576,27744,29280,
     6  35376,35136,35088,35184,35136,34920,37584,35688,35520,35592,
     7  35472,25296,25800,55920,54528,54816,55008,55296,55512,55608,
     8  55416,27192,27144,26616,26328,60288,60408,60624,60624,60312,
     9  60288,60144,60000,59928,59832,59976,59880,59976,59952,59808/
            data (jy(i),i= 2601, 2700)/
     +  59664,59544,59688,59808,46344,45984,46152,46032,46152,46008,
     1  46176,46104,45984,45696,45456,45648,45480,45408,45408,45288,
     2  45216,45096,44952,44544,44304,44256,44352,17400,17736,18528,
     3  19200,19128,19200,19512,20136,20208,20448,20904,16848,60120,
     4  61224,62807,62879,62927,60024,32064,32184,32592,32568,32688,
     5  32784,32976,33024,33144,33480,33648,33720,28416,66215,66623,
     6  66623,65999,65519,65279,28536,28632,28608,28704,28560,28296,
     7  28320,25440,24840,24384,23592,23592,23712,23640,23400,23112,
     8  22368,23016,63479,59880,60048,60024,60168,23064,12576,13512,
     9  13584,13536,55344,55536,55680,56040,56256,56352,56400,56496/
            data (jy(i),i= 2701, 2800)/
     +  56496,56592,56688,56736,18528,18912,19104,19176,54120,45672,
     1  45720,45816,45840,45960,45936,30864,30816,30816,30936,31080,
     2  31488,31560,31848,31896,32040,32088,32136,35088,34992,35040,
     3  34968,35256,35328,67895,67295,67247,67271,67199,67031,67031,
     4  67271,67463,67559,67511,67391,67415,67463,67583,67247,67247,
     5  67439,67199,67055,66863,66911,66935,67247,67151,67247,67247,
     6  67079,66983,67199,67127,67055,66863,66887,67031,66887,66671,
     7  66647,66815,66863,66983,66911,67031,66743,66815,66911,66719,
     8  66647,66767,66863,66863,66911,66935,67031,66935,66791,66791,
     9  67055,67151,67295,67463,67391,67391,67439,67511,67535,67415/
            data (jy(i),i= 2801, 2900)/
     +  67511,67463,67559,67535,67631,67583,67607,67679,67823,67823,
     1  67919,68063,68159,68159,68303,68423,68183,68231,68135,68207,
     2  69215,69311,69287,69215,68975,68807,68687,68495,68519,68375,
     3  68495,68663,68663,68783,68927,69047,69023,68831,68903,69023,
     4  69167,68999,68951,68975,69239,69071,69215,69023,68975,68903,
     5  68783,68903,68807,68831,68711,68735,68903,68903,68855,68879,
     6  68855,68711,68735,68687,68663,68567,68543,68471,68375,68303,
     7  68423,68351,68159,68015,68039,68087,68255,68423,68375,68519,
     8  68351,68279,68159,68111,68063,67943,67991,68207,68519,68399,
     9  68375,68207,68111,68063,68039,67871,68015,67823,67823,67991/
            data (jy(i),i= 2901, 3000)/
     +  67991,68159,68255,68207,68087,68063,67991,67895,67655,67607,
     1  67655,67511,67487,67607,67559,67583,67703,67943,67991,67727,
     2  67751,67631,67727,67487,67415,67367,67247,67271,67415,67415,
     3  67583,67463,67343,67271,67247,67175,67295,70631,70439,70415,
     4  70607,70703,70751,70679,70583,70799,70847,70799,70967,70967,
     5  70871,70895,71111,71087,71327,69383,69311,69335,68519,68711,
     6  68735,68807,68903,69023,69023,68927,68759,68783,68639,68639,
     7  68807,68903,69119,69215,69191,69311,69431,69455,69071,69023,
     8  69287,69215,69407,69551,69599,69743,69839,69599,69743,69887,
     9  70007,70055,70079,70175,70175,70343,70343,70439,70439,67991/
            data (jy(i),i= 3001, 3100)/
     +  68375,68255,68279,68351,68351,68207,70463,70487,70439,70391,
     1  67511,67559,67391,67415,67463,67535,67847,67823,67871,67823,
     2  67775,67607,67247,67271,67175,67079,67175,67823,67679,67535,
     3  67631,67775,67895,67943,67967,68207,68015,68039,68087,68231,
     4  68255,67871,67943,67919,67991,67799,67727,67799,67847,67895,
     5  67847,67895,67823,67871,67775,67679,67607,67583,67679,67583,
     6  67511,67487,67559,67703,68111,68063,67919,67991,68111,68135,
     7  68255,68231,68303,68351,68327,68279,63863,63815,63647,63863,
     8  68375,68495,68447,68135,68135,68327,68375,68447,68495,68519,
     9  68447,68423,68351,67559,67607,67607,68063,68183,68111,68039/
            data (jy(i),i= 3101, 3200)/
     +  67559,67607,67607,67535,67511,67703,67751,67799,67943,68015,
     1  67895,67991,67895,67631,68855,68927,68903,69047,68999,68615,
     2  68495,68735,68759,68063,68111,68039,67991,68447,68375,68279,
     3  68399,68399,68471,68495,68567,68567,68471,68639,68687,68663,
     4  68447,68519,68495,68327,68303,68951,69119,69047,69191,69143,
     5  69335,69335,69167,69047,68999,68255,68111,67967,68111,68135,
     6  68855,68903,68879,64607,64775,64607,64367,64367,64559,69143,
     7  69191,69167,69023,68999,69119,68999,69215,69215,68927,68903,
     8  68855,68903,69383,69287,69239,69167,69239,69380,69383,69167,
     9  69095,68951,68999,68903,68903,69047,69071,68927,68927,68951/
            data (jy(i),i= 3201, 3300)/
     +  69095,69263,69311,69431,69431,69527,69671,69695,69791,69815,
     1  69527,69359,69311,69479,69575,69623,69575,69455,69263,69311,
     2  69239,69503,69479,69695,69695,69863,69935,69767,69719,69647,
     3  69503,69263,69359,69431,69503,69695,69695,69503,64463,64343,
     4  64391,64343,64535,67727,67703,67631,67727,67727,67775,67775,
     5  67727,70415,70319,70223,70271,70199,70199,70031,69959,69815,
     6  69887,70463,68255,68159,68135,68279,68327,67367,67439,67463,
     7  68567,68639,68663,68591,66599,66599,66527,66575,66671,66647,
     8  66743,66671,66599,70631,70799,70967,70967,70511,70487,67319,
     9  67367,67247,67199,67271,72335,72431,71975,71735,71543,71423/
            data (jy(i),i= 3301, 3350)/
     +  71279,71183,71159,71255,71351,71375,71591,71831,71759,71903,
     1  71999,71687,71567,71591,71519,71303,71303,71039,71423,71591,
     2  71639,71783,66359,66359,66287,66335,70871,70943,71039,71039,
     3  70895,70799,66551,66527,66479,66191,66215,66191,66143,71135,
     4  71279,71135,71039,71063,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    1,    3,    4,    5,    6,    7,    8,    9,   10,
     1     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     2     21,    2,   23,   24,   25,   26,   27,   28,   29,   30,
     3     31,   32,   33,   34,   35,   36,   37,   38,   22,   40,
     4     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     5     39,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     51,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     7     71,   72,   74,   75,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   61,   74,   89,   90,
     9     91,   92,   73,   94,   95,   96,   97,   98,   99,  100/
            data (jb1(i),i=  101,  200)/
     +    101,  102,  103,  104,  105,  106,  107,  108,   93,  110,
     1    111,  112,  113,  114,  115,  116,  117,  118,  119,  120,
     2    121,  122,  123,  124,  125,  126,  129,  130,  131,  132,
     3    133,  134,  135,  128,  137,  138,  139,  140,  141,  128,
     4    129,  143,  144,  145,  146,  147,  109,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  161,  162,
     6    163,  164,  165,  166,  167,  168,  169,  127,  148,  172,
     7    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     8    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     9    193,  194,  195,  196,  197,  198,  199,  200,  201,  202/
            data (jb1(i),i=  201,  300)/
     +    203,  204,  205,  206,  171,  137,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  160,  239,  240,  241,  242,
     4    243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
     5    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     6    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     7    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     8    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     9    293,  294,  295,  296,  297,  298,  299,  300,  301,  302/
            data (jb1(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
     1    313,  314,  315,  238,  171,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     3    332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
     4    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     5    352,  353,  354,  355,  356,  357,  358,  359,  360,  361,
     6    362,  363,  364,  365,  366,  367,  368,  369,  370,  371,
     7    372,  373,  374,  375,  376,  377,  378,  379,  380,  381,
     8    382,  383,  384,  385,  386,  387,  238,  161,  391,  392,
     9    393,  394,  395,  396,  397,  398,  399,  400,  401,  390/
            data (jb1(i),i=  401,  500)/
     +    404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
     1    414,  415,  416,  417,  418,  419,  420,  421,  422,  423,
     2    424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
     3    434,  435,  436,  437,  438,  439,  440,  441,  442,  443,
     4    444,  445,  446,  447,  448,  237,  403,  450,  451,  452,
     5    453,  454,  455,  456,  457,  458,  459,  460,  461,  462,
     6    463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
     7    389,  474,  475,  476,  477,  478,  390,  481,  482,  483,
     8    484,  485,  486,  487,  488,  489,  490,  491,  492,  493,
     9    494,  495,  496,  497,  498,  499,  500,  501,  502,  503/
            data (jb1(i),i=  501,  600)/
     +    504,  389,  506,  507,  508,  509,  403,  511,  512,  481,
     1    402,  514,  515,  516,  517,  518,  519,  520,  521,  522,
     2    523,  524,  525,  480,  529,  530,  531,  532,  533,  534,
     3    535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
     4    545,  546,  547,  548,  549,  550,  551,  552,  553,  554,
     5    555,  556,  557,  558,  559,  560,  561,  562,  563,  564,
     6    565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
     7    575,  576,  577,  578,  579,  580,  581,  582,  583,  584,
     8    585,  586,  587,  588,  589,  590,  591,  592,  593,  594,
     9    595,  596,  597,  598,  599,  600,  474,  602,  603,  527/
            data (jb1(i),i=  601,  700)/
     +    605,  602,  506,  607,  608,  609,  610,  611,  612,  613,
     1    614,  615,  616,  617,  618,  619,  620,  621,  622,  623,
     2    624,  625,  626,  627,  628,  629,  630,  631,  632,  633,
     3    634,  635,  636,  637,  638,  639,  640,  641,  642,  643,
     4    644,  645,  646,  647,  648,  649,  650,  651,  652,  653,
     5    654,  655,  656,  657,  658,  659,  660,  661,  662,  663,
     6    664,  665,  666,  667,  668,  669,  670,  671,  672,  673,
     7    674,  675,  676,  677,  678,  679,  680,  681,  682,  683,
     8    684,  480,  527,  686,  687,  688,  689,  690,  691,  692,
     9    693,  694,  695,  696,  697,  698,  699,  700,  701,  702/
            data (jb1(i),i=  701,  800)/
     +    703,  704,  705,  706,  707,  528,  526,  709,  710,  711,
     1    712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
     2    722,  605,  724,  725,  726,  727,  728,  729,  730,  731,
     3    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     4    742,  743,  528,  746,  747,  748,  749,  750,  751,  752,
     5    753,  754,  755,  756,  757,  758,  759,  760,  761,  745,
     6    763,  764,  765,  766,  767,  768,  769,  770,  771,  772,
     7    773,  774,  775,  776,  777,  778,  779,  780,  781,  782,
     8    783,  784,  785,  786,  723,  788,  789,  790,  792,  793,
     9    794,  795,  796,  797,  798,  799,  800,  801,  802,  803/
            data (jb1(i),i=  801,  900)/
     +    804,  805,  806,  807,  808,  809,  810,  811,  812,  813,
     1    814,  815,  816,  817,  818,  819,  820,  821,  822,  511,
     2    824,  825,  826,  827,  828,  829,  830,  831,  832,  833,
     3    834,  835,  744,  763,  837,  838,  791,  840,  841,  842,
     4    843,  844,  845,  846,  847,  848,  849,  850,  787,  852,
     5    853,  854,  855,  856,  857,  858,  859,  860,  861,  862,
     6    863,  864,  865,  866,  867,  868,  869,  870,  871,  872,
     7    873,  874,  875,  876,  792,  878,  879,  880,  881,  882,
     8    883,  884,  885,  886,  887,  888,  889,  890,  891,  892,
     9    893,  894,  895,  896,  897,  898,  899,  900,  901,  902/
            data (jb1(i),i=  901, 1000)/
     +    903,  852,  745,  905,  906,  907,  908,  909,  910,  911,
     1    912,  913,  914,  915,  916,  917,  918,  919,  920,  921,
     2    922,  878,  925,  926,  927,  928,  929,  930,  931,  932,
     3    933,  934,  935,  936,  937,  938,  939,  940,  941,  824,
     4    944,  945,  946,  947,  948,  949,  950,  951,  952,  943,
     5    924,  954,  955,  956,  957,  958,  959,  960,  961,  962,
     6    963,  964,  965,  966,  967,  968,  969,  970,  971,  972,
     7    973,  974,  975,  976,  977,  978,  979,  981,  982,  944,
     8    839,  984,  985,  986,  987,  988,  989,  990,  991,  992,
     9    993,  994,  995,  996,  997,  980,  999, 1000, 1001, 1002/
            data (jb1(i),i= 1001, 1100)/
     +   1003, 1004, 1005,  981,  943, 1007, 1008, 1009, 1010, 1011,
     1   1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021,
     2   1022,  925, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031,
     3   1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041,
     4   1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051,
     5   1052, 1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061,
     6   1062, 1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071,
     7   1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081,
     8   1082,  924, 1024, 1084,  998, 1088, 1089, 1090, 1091, 1092,
     9   1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102/
            data (jb1(i),i= 1101, 1200)/
     +   1103, 1104, 1105, 1106, 1107, 1087, 1109, 1085, 1087, 1111,
     1   1112, 1086, 1114, 1113, 1109, 1116, 1117, 1086, 1120, 1119,
     2   1119, 1118, 1123, 1124, 1122, 1125, 1127, 1128, 1129, 1130,
     3   1131, 1132, 1133, 1134,    2,    1, 1136, 1137, 1138, 1139,
     4   1140, 1127, 1142,   39, 1144, 1145, 1146, 1147, 1148, 1149,
     5   1150, 1151, 1152, 1153, 1154, 1155, 1143, 1141, 1127, 1158,
     6   1157, 1141,   45, 1161, 1162, 1163, 1164, 1161, 1162,   22,
     7   1167, 1168, 1169, 1170, 1171, 1160, 1173, 1174, 1175, 1176,
     8   1177, 1178, 1179, 1180, 1157, 1166, 1182,   50, 1143, 1184,
     9   1185, 1186, 1187, 1188, 1189, 1190, 1191, 1192,   51, 1194/
            data (jb1(i),i= 1201, 1300)/
     +   1195, 1166, 1197, 1198, 1193, 1173, 1200, 1201, 1197, 1173,
     1   1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212,
     2   1213, 1167, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222,
     3   1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232,
     4   1233,   69, 1235, 1236, 1237, 1238, 1239, 1240, 1241, 1242,
     5   1243, 1244, 1197, 1246, 1247, 1248, 1193,   61, 1250, 1251,
     6   1252, 1253, 1254, 1160, 1235,   73, 1257, 1258, 1259, 1260,
     7   1261, 1250, 1214, 1263, 1264, 1256, 1266, 1267, 1268, 1269,
     8   1270, 1271, 1235, 1273, 1274, 1250, 1273, 1276, 1277, 1278,
     9   1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288/
            data (jb1(i),i= 1301, 1400)/
     +   1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296, 1297, 1214,
     1   1266, 1246, 1300, 1301, 1302, 1303, 1304, 1305, 1306, 1307,
     2   1308, 1309, 1299, 1273, 1312, 1313, 1314, 1315, 1316, 1311,
     3   1318, 1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327,
     4   1311, 1329, 1330, 1331, 1332, 1333, 1334, 1335, 1336, 1337,
     5   1338, 1256, 1329, 1340, 1341, 1342, 1343, 1344, 1345, 1346,
     6   1347, 1348, 1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356,
     7   1357, 1358, 1359, 1360, 1361, 1362, 1363, 1312, 1365, 1318,
     8   1365, 1367, 1368, 1369, 1370, 1371, 1318, 1373, 1374, 1375,
     9   1376, 1377, 1378, 1379,   97, 1381, 1382, 1383, 1384, 1385/
            data (jb1(i),i= 1401, 1500)/
     +   1386, 1387, 1388, 1299, 1390, 1391, 1392, 1393, 1394, 1395,
     1   1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1266, 1405,
     2   1406, 1407, 1365, 1373, 1405, 1390, 1410, 1411, 1412, 1413,
     3   1414, 1415, 1416, 1417, 1418, 1419, 1420, 1421, 1329, 1373,
     4   1423, 1424, 1425, 1426, 1427, 1428, 1429, 1430, 1431, 1432,
     5   1433, 1434, 1435, 1436,  129, 1437, 1438, 1439,  109, 1441,
     6   1442, 1443, 1444, 1445, 1381, 1441, 1447,   74, 1390, 1381,
     7     93, 1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458,
     8   1459, 1460, 1461, 1462, 1463,  127, 1449, 1466, 1312, 1466,
     9   1468, 1469, 1470, 1471, 1472, 1473, 1474, 1465, 1476, 1477/
            data (jb1(i),i= 1501, 1600)/
     +   1478, 1463, 1480, 1481, 1482, 1441, 1484, 1485, 1486, 1487,
     1   1488, 1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1466,
     2    160, 1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506,
     3   1507, 1508, 1509, 1510, 1511, 1512, 1513, 1514,  148, 1405,
     4   1516, 1517, 1484, 1519, 1465, 1521, 1522, 1523, 1524, 1525,
     5   1526, 1527,  137, 1529, 1530, 1531, 1532, 1521, 1519, 1534,
     6   1535, 1536, 1538, 1539, 1540, 1541, 1542, 1543, 1544, 1502,
     7   1546, 1476, 1546, 1548, 1549, 1550, 1551, 1552, 1553, 1554,
     8   1555, 1556, 1557, 1558, 1559, 1560, 1480,  171, 1562, 1563,
     9   1564, 1538, 1566, 1567, 1568, 1569, 1476, 1566, 1571, 1572/
            data (jb1(i),i= 1601, 1700)/
     +   1573, 1574, 1575, 1576,  161, 1578, 1579, 1580, 1581, 1582,
     1   1583, 1584, 1529, 1516, 1586, 1587, 1588, 1589, 1590, 1591,
     2   1592, 1593, 1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601,
     3   1602, 1603, 1604, 1605, 1578, 1519, 1608, 1609, 1610, 1546,
     4   1612, 1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621,
     5   1622, 1623, 1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631,
     6   1632, 1521,  237, 1634, 1612,  238, 1636, 1637, 1638, 1639,
     7   1640, 1641, 1642, 1643, 1538, 1537, 1645, 1484, 1537, 1648,
     8   1649, 1650, 1651, 1652, 1647, 1654, 1655, 1566, 1657, 1658,
     9   1659, 1660, 1661, 1607, 1657, 1663, 1664, 1665, 1666, 1667/
            data (jb1(i),i= 1701, 1800)/
     +   1668, 1480, 1647, 1670, 1671, 1672, 1674, 1675, 1676, 1677,
     1   1646, 1607, 1679, 1680, 1674, 1646, 1682, 1683, 1684, 1685,
     2   1686, 1578, 1688, 1689, 1690, 1691, 1692, 1693, 1694, 1695,
     3   1696, 1697, 1698, 1699, 1700, 1701, 1702, 1703, 1704, 1705,
     4   1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713, 1714, 1715,
     5   1716, 1717, 1718, 1719, 1720, 1722, 1723, 1724, 1725, 1612,
     6   1654, 1727, 1728, 1729, 1730, 1731, 1732, 1721, 1734, 1735,
     7   1736, 1737, 1738, 1739, 1740,  390, 1741, 1742, 1743, 1744,
     8   1722, 1608, 1746, 1747, 1748, 1749, 1750, 1751, 1752, 1753,
     9   1754, 1755, 1756, 1758, 1759, 1760, 1761, 1762, 1763, 1764/
            data (jb1(i),i= 1801, 1900)/
     +   1673, 1687, 1766, 1767, 1768, 1769, 1770, 1771, 1772, 1773,
     1   1774, 1775, 1776, 1777, 1778, 1779, 1758,  403, 1781, 1782,
     2   1783, 1784, 1785, 1786, 1787, 1788, 1789, 1790, 1791, 1792,
     3   1793, 1794, 1795, 1796, 1797, 1798, 1799, 1800, 1801, 1802,
     4   1803, 1804, 1805, 1806, 1807, 1808, 1809, 1810, 1811, 1812,
     5   1529, 1758, 1733, 1815,  402, 1817, 1818, 1721, 1817, 1820,
     6   1821, 1822, 1823, 1824, 1825, 1826, 1827, 1828, 1829, 1830,
     7   1673, 1832, 1833, 1834, 1835, 1836, 1837, 1838, 1839, 1840,
     8   1841, 1842, 1843, 1844, 1845, 1657, 1847, 1848, 1849, 1850,
     9   1851, 1852, 1853, 1854, 1855, 1856, 1608, 1817, 1858, 1832/
            data (jb1(i),i= 1901, 2000)/
     +   1860, 1847,  480,  474, 1757, 1863, 1864, 1865, 1866, 1867,
     1   1868, 1869, 1870, 1871, 1872, 1873, 1874, 1654,  506, 1876,
     2   1877, 1878, 1879, 1880, 1722, 1814, 1882, 1883, 1884, 1885,
     3   1886, 1887, 1888, 1889, 1890, 1891, 1892, 1893, 1894, 1895,
     4   1896, 1897, 1898, 1814, 1900, 1901, 1902, 1903, 1904, 1905,
     5   1906, 1907, 1908, 1899, 1687, 1910, 1912, 1913, 1914, 1915,
     6   1916, 1917, 1918, 1919, 1920, 1921, 1922, 1923, 1924, 1757,
     7   1911, 1926, 1927, 1928, 1929, 1930, 1931, 1932, 1933, 1934,
     8   1935, 1936, 1937, 1938, 1939, 1940, 1941, 1942, 1943, 1758,
     9   1945, 1946, 1947, 1948, 1949, 1950, 1951, 1952,  481, 1945/
            data (jb1(i),i= 2001, 2100)/
     +   1954, 1955, 1956, 1957, 1958, 1959, 1960, 1961, 1962, 1963,
     1   1964, 1965, 1966, 1967, 1968, 1969, 1970, 1971, 1972, 1973,
     2   1974, 1975, 1976, 1977, 1859, 1847, 1979, 1980, 1981, 1982,
     3   1983, 1984, 1985, 1986, 1912, 1988, 1989, 1990, 1859, 1992,
     4   1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001, 1733, 2003,
     5   2004, 2005, 1912, 1899, 2007, 2008, 2009, 2010, 2011, 2012,
     6   2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 1997, 1997,
     7   2022, 2023, 2024, 2025, 2026, 2027, 2028, 1832, 2003, 2030,
     8   2031, 2032, 2033, 1987, 2035, 2036, 2037, 2038, 2039, 2040,
     9   2041, 1911,  528, 2043, 2044, 2045, 2046, 1945,  511, 2048/
            data (jb1(i),i= 2101, 2200)/
     +   2049, 2050, 2051, 2052, 1991, 2054, 2055, 2056, 2057, 2058,
     1   2059, 2003, 2061, 1674,  602, 2063, 2061, 2065, 2066, 2067,
     2   2068, 2023, 2053, 2070, 2071, 2072, 2073, 2075, 2076, 1998,
     3   2035, 2078, 2079, 2080, 2081, 2082, 2083, 2084, 2061, 2086,
     4   2064, 2035, 2053, 2089, 2090, 2091, 2092, 2093, 2094, 2095,
     5   2074, 2097, 2075,  526, 2099, 2100, 2101, 2102, 2103, 2104,
     6   2105, 2106, 2107, 2108, 2109, 2110, 2111, 2112, 2113, 2114,
     7   2115, 1869, 1998, 2099,  605, 2118, 2119, 2120, 2064, 2122,
     8   2123, 2124, 2125, 2126, 2127, 2128, 2129, 2130, 2131, 2132,
     9   2133, 2134, 2135, 2136, 1942, 2138, 2086, 2140, 2141, 2142/
            data (jb1(i),i= 2201, 2300)/
     +   2143, 2074, 2138, 2086, 2146, 2147, 2148, 2149, 2145, 2145,
     1   2152, 2153, 2154, 2155, 2156, 2157, 2023, 2122, 2159, 2160,
     2   2161, 2162, 2151, 2140, 2164, 2165, 2097, 2122, 2167, 2168,
     3   2169, 2170, 2171, 2172, 2173, 2088, 2175, 2176, 2177, 2178,
     4   2099, 2138, 2180, 2181, 2182, 2183, 2184, 2185, 1987, 2187,
     5   2188, 2189, 2190, 2191, 2192, 2151, 2194, 2195, 2186, 2193,
     6   2197, 2198, 2199, 2200, 2152, 2202, 2202,  792, 2204, 2205,
     7   2206, 2207, 2140, 2204, 2202, 2210, 2211, 2212,  744, 2088,
     8   2215, 2216, 2165, 2215, 2218, 2219, 2220, 2221,  723,  787,
     9   2223, 2224, 2225, 2226, 2227, 2228, 2229, 2230, 2232, 2233/
            data (jb1(i),i= 2301, 2400)/
     +   2234, 2235, 2236, 2237, 2238, 2239, 2240, 2241, 2165, 2175,
     1   2243, 2244, 2245, 2246, 2247, 2248, 2249, 2250, 2251, 2252,
     2   2253, 2075, 2255, 2256, 2254, 2258, 2259, 2257, 2261, 2262,
     3   2232, 2261, 2264, 2265, 2232, 2267, 2268, 2269, 2214, 2267,
     4   2271, 2272, 2273, 2274, 2275, 2276, 2277, 2278, 2279, 2280,
     5   2152, 2204, 2282, 2283, 2284, 2285, 2286,  878, 2288, 2289,
     6   2215, 2291, 2292, 2293, 2294, 2295, 2296, 2297, 2298, 2299,
     7   2300, 2301, 2302, 2303, 2304, 2305, 2306, 2307, 2308, 2309,
     8   2310, 2311, 2312, 2313, 2314, 1991, 2316, 2317, 2318,  824,
     9   2320, 2321, 2322, 2323, 2324, 2325, 2326, 2327, 2328, 2329/
            data (jb1(i),i= 2401, 2500)/
     +   2330, 2331, 2332, 2175, 2334, 2335, 2336, 2337, 2338, 2339,
     1   2340, 2341, 2214, 2343, 2210, 2343, 2186,  763, 2346, 2347,
     2   2348, 2349, 2350, 2351, 2352, 2353, 2354, 2355, 2356, 2357,
     3   2358, 2359, 2360, 2361, 2362, 2363, 2364, 2365, 2366, 2231,
     4   2193, 2368, 2369, 2370, 2291, 2372, 2373, 2374, 2375, 2174,
     5   2372, 2377, 2378, 2334, 2320, 2380, 2381, 2382, 2383, 2384,
     6   2315, 2316, 2386, 2387, 2388, 2389, 2390, 2391, 2392, 2210,
     7   2394, 2395, 2396, 2397, 2398, 2399, 2400, 2401, 2402, 2403,
     8   2404, 2405, 2406,  791,  924, 2408, 2409, 2410, 2411, 2412,
     9   2413, 2415, 2416, 2417, 2418, 2419, 2420, 2356, 2422, 2423/
            data (jb1(i),i= 2501, 2600)/
     +   2424, 2425, 2426, 2427, 2428, 2429, 2430, 2431, 2432, 2433,
     1   2434, 2435, 2436, 2437, 2257, 2261, 2439, 2440, 2441, 2442,
     2   2443, 2422, 2415, 2445, 2446, 2447, 2448, 2449,  839, 2451,
     3   2452, 2453, 2231, 2455, 2456, 2457, 2458, 2459, 2460, 2461,
     4   2462, 2463, 2464, 2465, 2466, 2467, 2288, 2394, 2469, 2470,
     5   2471, 2472, 2372, 2455, 2474, 2451, 2475, 2476, 2477, 2478,
     6   2479, 2480, 2394, 2482, 2483, 2422, 2451, 2485, 2343, 2469,
     7   2488, 2489, 2490, 2491, 2414, 2267,  980, 2494, 2495, 2496,
     8   2488, 2498, 2499, 2500, 2415, 2502, 2503, 2504, 2505, 2288,
     9   2502, 2507, 2508, 2509, 2482, 2494, 2511,  981, 2513, 2514/
            data (jb1(i),i= 2601, 2700)/
     +   2515, 2516, 2517, 2518, 2519, 2520, 2521, 2522, 2523, 2524,
     1   2525, 2254, 2320, 2334, 2493, 2529, 2530, 2531, 2532, 2533,
     2   2534, 2535, 2536, 2537, 2538, 2539, 2540, 2541, 2542, 2528,
     3   2498, 2544, 2545, 2546, 2547, 2548, 2549, 2550, 2551, 2552,
     4   2553, 2554, 2555,  998, 2557, 2558, 2559, 2502, 2561, 2562,
     5   2563, 2564, 2565, 2513, 2527, 2567, 2568, 2569, 2570, 2561,
     6   2457, 2572, 2386, 2487, 2575, 2576, 2577, 2578, 2579, 2580,
     7   2574, 2557, 2582, 2583, 2584, 2573, 2316, 2586, 2587, 2588,
     8   2589, 2590, 2591, 2592, 2593, 2594, 2595, 2596, 2597, 2598,
     9   2597, 2600, 2601, 2602, 2603, 2599, 2493, 2605, 2606, 2607/
            data (jb1(i),i= 2701, 2800)/
     +   2608, 2609, 2610, 2611, 2612, 2613, 2614, 2615, 2616, 2617,
     1   2618, 2619, 2620, 2621, 2622, 2623, 2624, 2625, 2626, 2368,
     2   2628, 2629, 2630, 2631, 2632, 2633, 2634, 2635, 2636, 2637,
     3   2486, 2498, 2628, 2640, 2641, 2642, 2643,  925, 2599, 2640,
     4   2646, 2647, 2648, 2649, 2650, 2651, 2652, 2653, 2654, 2655,
     5   2656, 2513, 2482, 2557, 1024, 2659, 2660, 2661, 2662, 2663,
     6   2488, 2665, 2666, 2667, 2668, 2658, 2658, 2670, 2665, 2573,
     7   2672, 2673, 2674, 2675, 2676, 2677, 2678, 2679, 2486, 2681,
     8   2680, 1084, 2455, 1085, 2684, 2685, 2686, 2640, 2680, 2688,
     9   1087, 2689, 2690, 2691, 2553, 2574, 2693, 2694, 2695, 2696/
            data (jb1(i),i= 2801, 2900)/
     +   2697, 2698, 2699, 2700, 2701, 2702, 2703, 1109, 2628, 1112,
     1   2705, 2706, 2707, 2708, 1116, 2469, 2528, 1118, 2710, 2711,
     2   2712, 2713, 2714, 2605, 2665, 1122, 2716, 2717, 2718, 2719,
     3   2720, 2721, 2722, 2723, 2724, 2725, 2726, 2646, 2291, 2527,
     4   2561, 2728, 2729, 2730, 2731, 2732, 1125,    1,    2,    3,
     5      4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
     6     14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
     7     24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
     8     34,   35,   36,   37,   38,   39,   40,   41,   42,   43,
     9     44,   45,   46,   47,   48,   49,   50,   51,   52,   53/
            data (jb1(i),i= 2901, 3000)/
     +     54,   55,   56,   57,   58,   59,   60,   61,   62,   63,
     1     64,   65,   66,   67,   68,   69,   70,   71,   72,   73,
     2     74,   75,   76,   77,   78,   79,   80,   81,   82,   83,
     3     84,   85,   86,   88,   89,   90,   91,   92,   93,   94,
     4     95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
     5    105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
     6    115,  116,  117,  118,  119,  120,  121,  122,  123,  124,
     7    125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
     8    135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
     9    145,  146,  147,  148,  149,  150,  151,  152,  153,  154/
            data (jb1(i),i= 3001, 3100)/
     +    155,  156,  157,  158,  159,  160,  161,  162,  163,  164,
     1    165,  166,  167,  168,  169,  170,  171,  172,  173,  174,
     2    175,  176,  177,  178,  179,  180,  181,  182,  183,  184,
     3    185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
     4    195,  196,  197,  198,  199,  200,  201,  202,  203,    1,
     5    205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
     6    215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
     7     88,   87,  226,  227,  228,  229,  230,  231,  232,  233,
     8    234,  235,  236,  237,  238,  239,  240,  241,  242,  243,
     9    244,  245,  246,  247,  248,  249,  250,  251,  252,  253/
            data (jb1(i),i= 3101, 3200)/
     +    254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
     1    264,  265,  205,    1,  267,  268,  269,  270,  271,  272,
     2     87,    1,    2,    3,    1,    5,    6,    7,    8,    5,
     3     10,   11,   12,   13,   14,   15,   10,   17,   18,   19,
     4     20,   17,   22,   23,   24,   25,   26,   27,   28,   22,
     5     30,   31,   32,   33,   34,   30,   36,   37,   38,   39,
     6     40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
     7     50,   51,   52,   53,   54,   55,   56,   57,   36,   59,
     8     60,   61,   62,   63,   64,   65,   59,   67,   68,   69,
     9     67,   71,   72,   73,   71,   75,   76,   77,   78,   79/
            data (jb1(i),i= 3201, 3300)/
     +     75,   81,   82,   83,   84,   85,   86,   81,   88,   89,
     1     88,   91,   92,   93,   91,   95,   96,   97,   98,   95,
     2    100,  101,  102,  103,  104,  105,  106,  107,  100,  109,
     3    110,  111,  112,  113,  114,  115,  116,  109,  118,  119,
     4    120,  118,  122,  123,  124,  125,  126,  122,  128,  129,
     5    130,  128,  132,  133,  132,  135,  136,  137,  138,  135,
     6    140,  141,  142,  143,  144,  145,  146,  147,  148,  140,
     7    150,  151,  152,  153,  150,  155,  156,  155,  158,  159,
     8    160,  161,  162,  158,  164,  165,  166,  167,  164,  169,
     9    170,  171,  169,  173,  174,  175,  173,  177,  178,  179/
            data (jb1(i),i= 3301, 3400)/
     +    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     1    190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
     2    200,  201,  202,  203,  204,  205,  177,  207,  208,  209,
     3    210,  211,  212,  213,  214,  207,  216,  217,  218,  219,
     4    220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
     5    230,  231,  216,  233,  234,  235,  236,  233,  238,  239,
     6    240,  238,  242,  243,  244,  242,  246,  247,  248,  249,
     7    250,  251,  252,  253,  254,  255,  246,  257,  258,  259,
     8    260,  257,  262,  263,  262,  265,  266,  267,  265,  269,
     9    270,  271,  272,  273,  274,  275,  276,  269,  278,  279/
            data (jb1(i),i= 3401, 3460)/
     +    280,  281,  282,  278,  284,  285,  286,  287,  284,  289,
     1    290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
     2    300,  301,  302,  303,  304,  289,  306,  307,  308,  309,
     3    310,  311,  312,  313,  314,  315,  306,  317,  318,  319,
     4    317,  321,  322,  323,  324,  325,  321,  327,  328,  327,
     5    330,  331,  332,  330,  334,  335,  336,  337,  334,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   75,   76,   77,   78,   79,   80,   81,   82,
     8     83,   84,   85,   86,   87,   88,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   97,   98,   99,  100,  101/
            data (jb2(i),i=  101,  200)/
     +    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     1    112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
     2    122,  123,  124,  125,  126,  127,  130,  131,  132,  133,
     3    134,  135,  136,  136,  138,  139,  140,  141,  142,  142,
     4    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     5    153,  154,  155,  156,  157,  158,  159,  160,  162,  163,
     6    164,  165,  166,  167,  168,  169,  170,  170,  172,  173,
     7    174,  175,  176,  177,  178,  179,  180,  181,  182,  183,
     8    184,  185,  186,  187,  188,  189,  190,  191,  192,  193,
     9    194,  195,  196,  197,  198,  199,  200,  201,  202,  203/
            data (jb2(i),i=  201,  300)/
     +    204,  205,  206,  207,  207,  208,  209,  210,  211,  212,
     1    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     2    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     3    233,  234,  235,  236,  237,  239,  240,  241,  242,  243,
     4    244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
     5    254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
     6    264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
     7    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     8    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     9    294,  295,  296,  297,  298,  299,  300,  301,  302,  303/
            data (jb2(i),i=  301,  400)/
     +    304,  305,  306,  307,  308,  309,  310,  311,  312,  313,
     1    314,  315,  316,  316,  317,  318,  319,  320,  321,  322,
     2    323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
     3    333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
     4    343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
     5    353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
     6    363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
     7    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     8    383,  384,  385,  386,  387,  388,  388,  391,  392,  393,
     9    394,  395,  396,  397,  398,  399,  400,  401,  402,  404/
            data (jb2(i),i=  401,  500)/
     +    405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
     1    415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
     2    425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
     3    435,  436,  437,  438,  439,  440,  441,  442,  443,  444,
     4    445,  446,  447,  448,  449,  449,  450,  451,  452,  453,
     5    454,  455,  456,  457,  458,  459,  460,  461,  462,  463,
     6    464,  465,  466,  467,  468,  469,  470,  471,  472,  473,
     7    473,  475,  476,  477,  478,  479,  479,  482,  483,  484,
     8    485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
     9    495,  496,  497,  498,  499,  500,  501,  502,  503,  504/
            data (jb2(i),i=  501,  600)/
     +    505,  505,  507,  508,  509,  510,  510,  512,  513,  513,
     1    514,  515,  516,  517,  518,  519,  520,  521,  522,  523,
     2    524,  525,  526,  529,  530,  531,  532,  533,  534,  535,
     3    536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
     4    546,  547,  548,  549,  550,  551,  552,  553,  554,  555,
     5    556,  557,  558,  559,  560,  561,  562,  563,  564,  565,
     6    566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
     7    576,  577,  578,  579,  580,  581,  582,  583,  584,  585,
     8    586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
     9    596,  597,  598,  599,  600,  601,  601,  603,  604,  604/
            data (jb2(i),i=  601,  700)/
     +    606,  606,  607,  608,  609,  610,  611,  612,  613,  614,
     1    615,  616,  617,  618,  619,  620,  621,  622,  623,  624,
     2    625,  626,  627,  628,  629,  630,  631,  632,  633,  634,
     3    635,  636,  637,  638,  639,  640,  641,  642,  643,  644,
     4    645,  646,  647,  648,  649,  650,  651,  652,  653,  654,
     5    655,  656,  657,  658,  659,  660,  661,  662,  663,  664,
     6    665,  666,  667,  668,  669,  670,  671,  672,  673,  674,
     7    675,  676,  677,  678,  679,  680,  681,  682,  683,  684,
     8    685,  685,  686,  687,  688,  689,  690,  691,  692,  693,
     9    694,  695,  696,  697,  698,  699,  700,  701,  702,  703/
            data (jb2(i),i=  701,  800)/
     +    704,  705,  706,  707,  708,  708,  709,  710,  711,  712,
     1    713,  714,  715,  716,  717,  718,  719,  720,  721,  722,
     2    723,  724,  725,  726,  727,  728,  729,  730,  731,  732,
     3    733,  734,  735,  736,  737,  738,  739,  740,  741,  742,
     4    743,  744,  746,  747,  748,  749,  750,  751,  752,  753,
     5    754,  755,  756,  757,  758,  759,  760,  761,  762,  762,
     6    764,  765,  766,  767,  768,  769,  770,  771,  772,  773,
     7    774,  775,  776,  777,  778,  779,  780,  781,  782,  783,
     8    784,  785,  786,  787,  788,  789,  790,  791,  793,  794,
     9    795,  796,  797,  798,  799,  800,  801,  802,  803,  804/
            data (jb2(i),i=  801,  900)/
     +    805,  806,  807,  808,  809,  810,  811,  812,  813,  814,
     1    815,  816,  817,  818,  819,  820,  821,  822,  823,  823,
     2    825,  826,  827,  828,  829,  830,  831,  832,  833,  834,
     3    835,  836,  836,  837,  838,  839,  840,  841,  842,  843,
     4    844,  845,  846,  847,  848,  849,  850,  851,  851,  853,
     5    854,  855,  856,  857,  858,  859,  860,  861,  862,  863,
     6    864,  865,  866,  867,  868,  869,  870,  871,  872,  873,
     7    874,  875,  876,  877,  877,  879,  880,  881,  882,  883,
     8    884,  885,  886,  887,  888,  889,  890,  891,  892,  893,
     9    894,  895,  896,  897,  898,  899,  900,  901,  902,  903/
            data (jb2(i),i=  901, 1000)/
     +    904,  904,  905,  906,  907,  908,  909,  910,  911,  912,
     1    913,  914,  915,  916,  917,  918,  919,  920,  921,  922,
     2    923,  923,  926,  927,  928,  929,  930,  931,  932,  933,
     3    934,  935,  936,  937,  938,  939,  940,  941,  942,  942,
     4    945,  946,  947,  948,  949,  950,  951,  952,  953,  953,
     5    954,  955,  956,  957,  958,  959,  960,  961,  962,  963,
     6    964,  965,  966,  967,  968,  969,  970,  971,  972,  973,
     7    974,  975,  976,  977,  978,  979,  980,  982,  983,  983,
     8    984,  985,  986,  987,  988,  989,  990,  991,  992,  993,
     9    994,  995,  996,  997,  998,  999, 1000, 1001, 1002, 1003/
            data (jb2(i),i= 1001, 1100)/
     +   1004, 1005, 1006, 1006, 1007, 1008, 1009, 1010, 1011, 1012,
     1   1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022,
     2   1023, 1023, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032,
     3   1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042,
     4   1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052,
     5   1053, 1054, 1055, 1056, 1057, 1058, 1059, 1060, 1061, 1062,
     6   1063, 1064, 1065, 1066, 1067, 1068, 1069, 1070, 1071, 1072,
     7   1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081, 1082,
     8   1083, 1083, 1084, 1085, 1088, 1089, 1090, 1091, 1092, 1093,
     9   1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103/
            data (jb2(i),i= 1101, 1200)/
     +   1104, 1105, 1106, 1107, 1108, 1108, 1110, 1110, 1111, 1112,
     1   1113, 1114, 1115, 1115, 1116, 1117, 1118, 1120, 1121, 1121,
     2   1122, 1123, 1124, 1125, 1126, 1126, 1128, 1129, 1130, 1131,
     3   1132, 1133, 1134, 1135, 1135, 1136, 1137, 1138, 1139, 1140,
     4   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150,
     5   1151, 1152, 1153, 1154, 1155, 1156, 1156, 1157, 1158, 1159,
     6   1159, 1160, 1161, 1162, 1163, 1164, 1165, 1165, 1166, 1167,
     7   1168, 1169, 1170, 1171, 1172, 1172, 1174, 1175, 1176, 1177,
     8   1178, 1179, 1180, 1181, 1181, 1182, 1183, 1183, 1184, 1185,
     9   1186, 1187, 1188, 1189, 1190, 1191, 1192, 1193, 1194, 1195/
            data (jb2(i),i= 1201, 1300)/
     +   1196, 1196, 1198, 1199, 1199, 1200, 1201, 1202, 1202, 1203,
     1   1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212, 1213,
     2   1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222, 1223,
     3   1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232, 1233,
     4   1234, 1234, 1236, 1237, 1238, 1239, 1240, 1241, 1242, 1243,
     5   1244, 1245, 1245, 1247, 1248, 1249, 1249, 1246, 1251, 1252,
     6   1253, 1254, 1255, 1255, 1256, 1257, 1258, 1259, 1260, 1261,
     7   1262, 1262, 1263, 1264, 1265, 1265, 1267, 1268, 1269, 1270,
     8   1271, 1272, 1272, 1274, 1275, 1275, 1276, 1277, 1278, 1279,
     9   1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289/
            data (jb2(i),i= 1301, 1400)/
     +   1290, 1291, 1292, 1293, 1294, 1295, 1296, 1297, 1298, 1298,
     1   1299, 1300, 1301, 1302, 1303, 1304, 1305, 1306, 1307, 1308,
     2   1309, 1310, 1310, 1311, 1313, 1314, 1315, 1316, 1317, 1317,
     3   1319, 1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328,
     4   1328, 1330, 1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338,
     5   1339, 1339, 1340, 1341, 1342, 1343, 1344, 1345, 1346, 1347,
     6   1348, 1349, 1350, 1351, 1352, 1353, 1354, 1355, 1356, 1357,
     7   1358, 1359, 1360, 1361, 1362, 1363, 1364, 1364, 1366, 1366,
     8   1367, 1368, 1369, 1370, 1371, 1372, 1372, 1374, 1375, 1376,
     9   1377, 1378, 1379, 1380, 1380, 1382, 1383, 1384, 1385, 1386/
            data (jb2(i),i= 1401, 1500)/
     +   1387, 1388, 1389, 1389, 1391, 1392, 1393, 1394, 1395, 1396,
     1   1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404, 1404, 1406,
     2   1407, 1408, 1408, 1409, 1409, 1410, 1411, 1412, 1413, 1414,
     3   1415, 1416, 1417, 1418, 1419, 1420, 1421, 1422, 1422, 1423,
     4   1424, 1425, 1426, 1427, 1428, 1429, 1430, 1431, 1432, 1433,
     5   1434, 1435, 1436,  128, 1437, 1438, 1439, 1440, 1440, 1442,
     6   1443, 1444, 1445, 1446, 1446, 1447, 1448, 1448, 1449, 1449,
     7   1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458, 1459,
     8   1460, 1461, 1462, 1463, 1464, 1464, 1465, 1467, 1467, 1468,
     9   1469, 1470, 1471, 1472, 1473, 1474, 1475, 1475, 1477, 1478/
            data (jb2(i),i= 1501, 1600)/
     +   1479, 1479, 1481, 1482, 1483, 1483, 1485, 1486, 1487, 1488,
     1   1489, 1490, 1491, 1492, 1493, 1494, 1495, 1496, 1497, 1497,
     2   1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507,
     3   1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1515, 1516,
     4   1517, 1518, 1518, 1520, 1520, 1522, 1523, 1524, 1525, 1526,
     5   1527, 1528, 1528, 1530, 1531, 1532, 1533, 1533, 1534, 1535,
     6   1536, 1537, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1545,
     7   1547, 1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555,
     8   1556, 1557, 1558, 1559, 1560, 1561, 1561, 1562, 1563, 1564,
     9   1565, 1565, 1567, 1568, 1569, 1570, 1570, 1571, 1572, 1573/
            data (jb2(i),i= 1601, 1700)/
     +   1574, 1575, 1576, 1577, 1577, 1579, 1580, 1581, 1582, 1583,
     1   1584, 1585, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592,
     2   1593, 1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601, 1602,
     3   1603, 1604, 1605, 1606, 1606, 1607, 1609, 1610, 1611, 1611,
     4   1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622,
     5   1623, 1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631, 1632,
     6   1633, 1633, 1634, 1635, 1635, 1636, 1637, 1638, 1639, 1640,
     7   1641, 1642, 1643, 1644, 1644, 1645, 1646, 1647, 1648, 1649,
     8   1650, 1651, 1652, 1653, 1653, 1655, 1656, 1656, 1658, 1659,
     9   1660, 1661, 1662, 1662, 1663, 1664, 1665, 1666, 1667, 1668/
            data (jb2(i),i= 1701, 1800)/
     +   1669, 1669, 1670, 1671, 1672, 1673, 1675, 1676, 1677, 1678,
     1   1678, 1679, 1680, 1681, 1681, 1682, 1683, 1684, 1685, 1686,
     2   1687, 1688, 1689, 1690, 1691, 1692, 1693, 1694, 1695, 1696,
     3   1697, 1698, 1699, 1700, 1701, 1702, 1703, 1704, 1705, 1706,
     4   1707, 1708, 1709, 1710, 1711, 1712, 1713, 1714, 1715, 1716,
     5   1717, 1718, 1719, 1720, 1721, 1723, 1724, 1725, 1726, 1726,
     6   1727, 1728, 1729, 1730, 1731, 1732, 1733, 1734, 1735, 1736,
     7   1737, 1738, 1739, 1740,  389, 1741, 1742, 1743, 1744, 1745,
     8   1745, 1746, 1747, 1748, 1749, 1750, 1751, 1752, 1753, 1754,
     9   1755, 1756, 1757, 1759, 1760, 1761, 1762, 1763, 1764, 1765/
            data (jb2(i),i= 1801, 1900)/
     +   1765, 1766, 1767, 1768, 1769, 1770, 1771, 1772, 1773, 1774,
     1   1775, 1776, 1777, 1778, 1779, 1780, 1780, 1781, 1782, 1783,
     2   1784, 1785, 1786, 1787, 1788, 1789, 1790, 1791, 1792, 1793,
     3   1794, 1795, 1796, 1797, 1798, 1799, 1800, 1801, 1802, 1803,
     4   1804, 1805, 1806, 1807, 1808, 1809, 1810, 1811, 1812, 1813,
     5   1813, 1814, 1815, 1816, 1816, 1818, 1819, 1819, 1820, 1821,
     6   1822, 1823, 1824, 1825, 1826, 1827, 1828, 1829, 1830, 1831,
     7   1831, 1833, 1834, 1835, 1836, 1837, 1838, 1839, 1840, 1841,
     8   1842, 1843, 1844, 1845, 1846, 1846, 1848, 1849, 1850, 1851,
     9   1852, 1853, 1854, 1855, 1856, 1857, 1857, 1858, 1859, 1860/
            data (jb2(i),i= 1901, 2000)/
     +   1861, 1861, 1862, 1862, 1863, 1864, 1865, 1866, 1867, 1868,
     1   1869, 1870, 1871, 1872, 1873, 1874, 1875, 1875, 1876, 1877,
     2   1878, 1879, 1880, 1881, 1881, 1882, 1883, 1884, 1885, 1886,
     3   1887, 1888, 1889, 1890, 1891, 1892, 1893, 1894, 1895, 1896,
     4   1897, 1898, 1899, 1900, 1901, 1902, 1903, 1904, 1905, 1906,
     5   1907, 1908, 1909, 1909, 1910, 1911, 1913, 1914, 1915, 1916,
     6   1917, 1918, 1919, 1920, 1921, 1922, 1923, 1924, 1925, 1925,
     7   1926, 1927, 1928, 1929, 1930, 1931, 1932, 1933, 1934, 1935,
     8   1936, 1937, 1938, 1939, 1940, 1941, 1942, 1943, 1944, 1944,
     9   1946, 1947, 1948, 1949, 1950, 1951, 1952, 1953, 1953, 1954/
            data (jb2(i),i= 2001, 2100)/
     +   1955, 1956, 1957, 1958, 1959, 1960, 1961, 1962, 1963, 1964,
     1   1965, 1966, 1967, 1968, 1969, 1970, 1971, 1972, 1973, 1974,
     2   1975, 1976, 1977, 1978, 1978, 1979, 1980, 1981, 1982, 1983,
     3   1984, 1985, 1986, 1987, 1988, 1989, 1990, 1991, 1992, 1993,
     4   1994, 1995, 1996, 1997, 1999, 2000, 2001, 2002, 2002, 2004,
     5   2005, 2006, 2006, 2007, 2008, 2009, 2010, 2011, 2012, 2013,
     6   2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021, 2021, 2022,
     7    527, 2024, 2025, 2026, 2027, 2028, 2029, 2029, 2030, 2031,
     8   2032, 2033, 2034, 2034, 2036, 2037, 2038, 2039, 2040, 2041,
     9   2042, 2042, 2043, 2044, 2045, 2046, 2047, 2047, 2048, 2049/
            data (jb2(i),i= 2101, 2200)/
     +   2050, 2051, 2052, 2053, 2054, 2055, 2056, 2057, 2058, 2059,
     1   2060, 2060, 2062, 2062, 2063, 2064, 2065, 2066, 2067, 2068,
     2   2069, 2069, 2070, 2071, 2072, 2073, 2074, 2076, 2077, 2077,
     3   2078, 2079, 2080, 2081, 2082, 2083, 2084, 2085, 2085, 2087,
     4   2087, 2088, 2089, 2090, 2091, 2092, 2093, 2094, 2095, 2096,
     5   2096, 2098, 2098, 2097, 2100, 2101, 2102, 2103, 2104, 2105,
     6   2106, 2107, 2108, 2109, 2110, 2111, 2112, 2113, 2114, 2115,
     7   2116, 2116, 2117, 2117, 2118, 2119, 2120, 2121, 2121, 2123,
     8   2124, 2125, 2126, 2127, 2128, 2129, 2130, 2131, 2132, 2133,
     9   2134, 2135, 2136, 2137, 2137, 2139, 2139, 2141, 2142, 2143/
            data (jb2(i),i= 2201, 2300)/
     +   2144, 2144, 2145, 2146, 2147, 2148, 2149, 2150, 2150, 2151,
     1   2153, 2154, 2155, 2156, 2157, 2158, 2158, 2159, 2160, 2161,
     2   2162, 2163, 2163, 2164,  745, 2166, 2166, 2167, 2168, 2169,
     3   2170, 2171, 2172, 2173, 2174, 2174, 2176, 2177, 2178, 2179,
     4   2179, 2180, 2181, 2182, 2183, 2184, 2185, 2186, 2187, 2188,
     5   2189, 2190, 2191, 2192, 2193, 2194, 2195, 2196, 2196, 2197,
     6   2198, 2199, 2200, 2201, 2201,  852, 2203, 2203, 2205, 2206,
     7   2207, 2208, 2208, 2209, 2209, 2211, 2212, 2213, 2213, 2214,
     8   2216, 2217, 2217, 2218, 2219, 2220, 2221, 2222, 2222, 2223,
     9   2224, 2225, 2226, 2227, 2228, 2229, 2230, 2231, 2233, 2234/
            data (jb2(i),i= 2301, 2400)/
     +   2235, 2236, 2237, 2238, 2239, 2240, 2241, 2242, 2242, 2243,
     1   2244, 2245, 2246, 2247, 2248, 2249, 2250, 2251, 2252, 2253,
     2   2254, 2255, 2256, 2257, 2258, 2259, 2260, 2260, 2262, 2263,
     3   2263, 2264, 2265, 2266, 2266, 2268, 2269, 2270, 2270, 2271,
     4   2272, 2273, 2274, 2275, 2276, 2277, 2278, 2279, 2280, 2281,
     5   2281, 2282, 2283, 2284, 2285, 2286, 2287, 2287, 2289, 2290,
     6   2290, 2292, 2293, 2294, 2295, 2296, 2297, 2298, 2299, 2300,
     7   2301, 2302, 2303, 2304, 2305, 2306, 2307, 2308, 2309, 2310,
     8   2311, 2312, 2313, 2314, 2315, 2315, 2317, 2318, 2319, 2319,
     9   2321, 2322, 2323, 2324, 2325, 2326, 2327, 2328, 2329, 2330/
            data (jb2(i),i= 2401, 2500)/
     +   2331, 2332, 2333, 2333, 2335, 2336, 2337, 2338, 2339, 2340,
     1   2341, 2342, 2342, 2344, 2344, 2345, 2345, 2346, 2347, 2348,
     2   2349, 2350, 2351, 2352, 2353, 2354, 2355, 2356, 2357, 2358,
     3   2359, 2360, 2361, 2362, 2363, 2364, 2365, 2366, 2367, 2367,
     4   2368, 2369, 2370, 2371, 2371, 2373, 2374, 2375, 2376, 2376,
     5   2377, 2378, 2379, 2379, 2380, 2381, 2382, 2383, 2384, 2385,
     6   2385, 2386, 2387, 2388, 2389, 2390, 2391, 2392, 2393, 2393,
     7   2395, 2396, 2397, 2398, 2399, 2400, 2401, 2402, 2403, 2404,
     8   2405, 2406, 2407, 2407, 2408, 2409, 2410, 2411, 2412, 2413,
     9   2414, 2416, 2417, 2418, 2419, 2420, 2421, 2421, 2423, 2424/
            data (jb2(i),i= 2501, 2600)/
     +   2425, 2426, 2427, 2428, 2429, 2430, 2431, 2432, 2433, 2434,
     1   2435, 2436, 2437, 2438, 2438, 2439, 2440, 2441, 2442, 2443,
     2   2444, 2444, 2445, 2446, 2447, 2448, 2449, 2450, 2450, 2452,
     3   2453, 2454, 2454, 2456,  943, 2458, 2459, 2460, 2461, 2462,
     4   2463, 2464, 2465, 2466, 2467, 2468, 2468, 2457, 2470, 2471,
     5   2472, 2473, 2473, 2474,  944, 2475, 2476, 2477, 2478, 2479,
     6   2480, 2481, 2481, 2483, 2484, 2484, 2485, 2486, 2487, 2487,
     7   2489, 2490, 2491, 2492, 2492, 2493, 2494, 2495, 2496, 2497,
     8   2497, 2499, 2500, 2501, 2501, 2503, 2504, 2505, 2506, 2506,
     9   2507, 2508, 2509, 2510, 2510, 2511, 2512, 2512, 2514, 2515/
            data (jb2(i),i= 2601, 2700)/
     +   2516, 2517, 2518, 2519, 2520, 2521, 2522, 2523, 2524, 2525,
     1   2526, 2526, 2527, 2528, 2529, 2530, 2531, 2532, 2533, 2534,
     2   2535, 2536, 2537, 2538, 2539, 2540, 2541, 2542, 2543, 2543,
     3   2544, 2545, 2546, 2547, 2548, 2549, 2550, 2551, 2552, 2553,
     4   2554, 2555, 2556, 2556, 2558, 2559, 2560, 2560, 2562, 2563,
     5   2564, 2565, 2566, 2566, 2567, 2568, 2569, 2570, 2571, 2571,
     6   2572, 2573, 2574, 2575, 2576, 2577, 2578, 2579, 2580, 2581,
     7   2581, 2582, 2583, 2584, 2585, 2585, 2586, 2587, 2588, 2589,
     8   2590, 2591, 2592, 2593, 2594, 2595, 2596, 2597, 2598, 2599,
     9   2600, 2601, 2602, 2603, 2604, 2604, 2605, 2606, 2607, 2608/
            data (jb2(i),i= 2701, 2800)/
     +   2609, 2610, 2611, 2612, 2613, 2614, 2615, 2616, 2617, 2618,
     1   2619, 2620, 2621, 2622, 2623, 2624, 2625, 2626, 2627, 2627,
     2   2629, 2630, 2631, 2632, 2633, 2634, 2635, 2636, 2637, 2638,
     3   2638, 2639, 2639, 2641, 2642, 2643, 2644, 2644, 2645, 2645,
     4   2647, 2648, 2649, 2650, 2651, 2652, 2653, 2654, 2655, 2656,
     5   2657, 2657, 2646, 2658, 2659, 2660, 2661, 2662, 2663, 2664,
     6   2664, 2666, 2667, 2668, 2669, 2669, 2670, 2671, 2671, 2672,
     7   2673, 2674, 2675, 2676, 2677, 2678, 2679, 2680, 2681, 2682,
     8   2682, 2683, 2683, 2684, 2685, 2686, 2687, 2687, 2688, 1086,
     9   2689, 2690, 2691, 2692, 2692, 2693, 2694, 2695, 2696, 2697/
            data (jb2(i),i= 2801, 2900)/
     +   2698, 2699, 2700, 2701, 2702, 2703, 2704, 2704, 1111, 2705,
     1   2706, 2707, 2708, 1113, 2709, 2709, 1117, 2710, 2711, 2712,
     2   2713, 2714, 2715, 2715, 1119, 2716, 2717, 2718, 2719, 2720,
     3   2721, 2722, 2723, 2724, 2725, 2726, 2727, 2727, 1123, 1124,
     4   2728, 2729, 2730, 2731, 2732, 2733, 2733,    2,    3,    4,
     5      5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
     6     15,   16,   17,   18,   19,   20,   21,   22,   23,   24,
     7     25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
     8     35,   36,   37,   38,   39,   40,   41,   42,   43,   44,
     9     45,   46,   47,   48,   49,   50,   51,   52,   53,   54/
            data (jb2(i),i= 2901, 3000)/
     +     55,   56,   57,   58,   59,   60,   61,   62,   63,   64,
     1     65,   66,   67,   68,   69,   70,   71,   72,   73,   74,
     2     75,   76,   77,   78,   79,   80,   81,   82,   83,   84,
     3     85,   86,   87,   89,   90,   91,   92,   93,   94,   95,
     4     96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
     5    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     6    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     7    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     8    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     9    146,  147,  148,  149,  150,  151,  152,  153,  154,  155/
            data (jb2(i),i= 3001, 3100)/
     +    156,  157,  158,  159,  160,  161,  162,  163,  164,  165,
     1    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     2    176,  177,  178,  179,  180,  181,  182,  183,  184,  185,
     3    186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
     4    196,  197,  198,  199,  200,  201,  202,  203,  204,  204,
     5    206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
     6    216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
     7    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     8    235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     9    245,  246,  247,  248,  249,  250,  251,  252,  253,  254/
            data (jb2(i),i= 3101, 3200)/
     +    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     1    265,  266,  266,  267,  268,  269,  270,  271,  272,  273,
     2    273,    2,    3,    4,    4,    6,    7,    8,    9,    9,
     3     11,   12,   13,   14,   15,   16,   16,   18,   19,   20,
     4     21,   21,   23,   24,   25,   26,   27,   28,   29,   29,
     5     31,   32,   33,   34,   35,   35,   37,   38,   39,   40,
     6     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     7     51,   52,   53,   54,   55,   56,   57,   58,   58,   60,
     8     61,   62,   63,   64,   65,   66,   66,   68,   69,   70,
     9     70,   72,   73,   74,   74,   76,   77,   78,   79,   80/
            data (jb2(i),i= 3201, 3300)/
     +     80,   82,   83,   84,   85,   86,   87,   87,   89,   90,
     1     90,   92,   93,   94,   94,   96,   97,   98,   99,   99,
     2    101,  102,  103,  104,  105,  106,  107,  108,  108,  110,
     3    111,  112,  113,  114,  115,  116,  117,  117,  119,  120,
     4    121,  121,  123,  124,  125,  126,  127,  127,  129,  130,
     5    131,  131,  133,  134,  134,  136,  137,  138,  139,  139,
     6    141,  142,  143,  144,  145,  146,  147,  148,  149,  149,
     7    151,  152,  153,  154,  154,  156,  157,  157,  159,  160,
     8    161,  162,  163,  163,  165,  166,  167,  168,  168,  170,
     9    171,  172,  172,  174,  175,  176,  176,  178,  179,  180/
            data (jb2(i),i= 3301, 3400)/
     +    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     1    191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
     2    201,  202,  203,  204,  205,  206,  206,  208,  209,  210,
     3    211,  212,  213,  214,  215,  215,  217,  218,  219,  220,
     4    221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
     5    231,  232,  232,  234,  235,  236,  237,  237,  239,  240,
     6    241,  241,  243,  244,  245,  245,  247,  248,  249,  250,
     7    251,  252,  253,  254,  255,  256,  256,  258,  259,  260,
     8    261,  261,  263,  264,  264,  266,  267,  268,  268,  270,
     9    271,  272,  273,  274,  275,  276,  277,  277,  279,  280/
            data (jb2(i),i= 3401, 3460)/
     +    281,  282,  283,  283,  285,  286,  287,  288,  288,  290,
     1    291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
     2    301,  302,  303,  304,  305,  305,  307,  308,  309,  310,
     3    311,  312,  313,  314,  315,  316,  316,  318,  319,  320,
     4    320,  322,  323,  324,  325,  326,  326,  328,  329,  329,
     5    331,  332,  333,  333,  335,  336,  337,  338,  338,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine wa(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(2650) :: jx,jy
            integer(kind=iknd), save, dimension(2690) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'washington    '/
            data jrot,ipart/1,2/
            data kv/   1,2035,2647,   0,   0/
            data kb/   1,2075,2687,   0,   0/
            data iib/1163, 612,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  17544,17280,16920,18120,22056,25656,25656,25656,26376,26184,
     1  26688,29904,28104,31104,32904,33576,35016,35016,35016,33816,
     2  34920,35520,35880,38256,38232,41328,43584,42000,42168,42072,
     3  42048,42048,42216,42288,42264,42168,42168,42072,42072,41952,
     4  42072,42048,41904,41808,41928,41904,42000,42144,42192,42288,
     5  42288,42312,42480,42672,42552,42576,42696,42408,42312,42552,
     6  42624,42864,42936,43080,43104,43224,43368,43344,43440,43440,
     7  43248,43200,42984,43344,43512,43704,43920,44160,44256,44328,
     8  44376,44256,44304,44448,44544,44664,44760,44832,45120,45240,
     9  45480,45576,45312,45192,45120,44928,44856,45096,45240,45456/
            data (jx(i),i=  101,  200)/
     +  45768,45672,45720,45648,44400,44280,43608,43032,42960,43080,
     1  43032,42912,42984,45840,46416,46512,46560,46728,46848,46704,
     2  46752,46512,46320,46488,46608,47016,47112,46896,46848,46824,
     3  46680,46800,46752,46608,46656,46536,48336,48288,47832,48504,
     4  48696,48936,50952,50808,50664,50136,49944,49920,50112,49968,
     5  49872,49680,49776,49680,49248,48816,52464,54264,51192,16704,
     6  17928,21816,21840,21720,21528,21504,21576,21312,21000,20904,
     7  20856,20664,20616,20712,20712,21312,21144,21120,20592,20520,
     8  20400,20400,20544,20568,19920,19416,19224,19032,18912,19032,
     9  18912,18768,18408,18456,18552,18624,18768,18720,18600,18456/
            data (jx(i),i=  201,  300)/
     +  18288,18288,22296,22512,22728,22920,22968,22920,22752,22752,
     1  22632,22680,22776,22752,22872,23112,23304,23328,23424,23568,
     2  23808,23976,23976,24048,23976,24000,23928,23976,23544,23688,
     3  23928,23928,23760,23472,23304,23496,23448,23640,23664,23616,
     4  23880,24048,24144,24336,24432,24408,24504,24456,24360,24312,
     5  24120,24120,24048,24384,24408,24408,24576,24672,24864,24912,
     6  24768,24816,24912,24936,25008,25032,24936,25248,25416,25536,
     7  25512,25632,25608,25728,27768,27768,27936,27912,28104,28224,
     8  28464,28512,28464,28176,27936,27912,27840,27888,27504,27192,
     9  27240,27192,27240,26952,27144,26952,26880,26832,26928,27336/
            data (jx(i),i=  301,  400)/
     +  27576,27504,27576,27576,27456,27360,27312,27288,27384,27192,
     1  27192,27312,27336,27264,27192,27120,27000,27120,27024,27144,
     2  27120,27072,27144,27072,27024,26904,26856,26784,26640,26520,
     3  26592,26472,26376,25968,25944,26040,26016,25992,25872,25824,
     4  25704,25728,25680,25536,25488,25104,25008,24840,24768,24816,
     5  24600,24552,24552,24600,24576,24672,24792,24816,25056,25128,
     6  25104,25152,25272,25296,25344,25512,25608,25848,25968,26040,
     7  25920,29784,29712,29640,29376,29208,29064,29016,28872,28632,
     8  28224,27888,27648,26976,26880,26712,26544,26376,26136,25992,
     9  30792,30312,29832,29304,29160,28968,28896,28920,28824,28704/
            data (jx(i),i=  401,  500)/
     +  28680,28440,28416,28512,28512,28680,28584,28440,28368,28368,
     1  28272,28440,28224,28152,28200,28128,28104,27792,27768,27336,
     2  27048,26832,26544,26400,26280,26424,26352,25944,26136,26088,
     3  26160,26304,26856,27408,27528,27408,27624,27696,27864,28104,
     4  28176,27840,27480,27432,26952,26808,26712,26592,26376,26304,
     5  26376,33384,33120,33120,33000,32736,32640,32496,32400,32592,
     6  32376,32424,32328,32280,31920,31728,31536,31512,31248,31104,
     7  30864,30480,30264,30288,30624,30720,30624,30288,30120,29784,
     8  29760,29592,29568,29496,29400,29592,29688,29832,30072,30552,
     9  30696,30792,30936,31056,31200,31416,31464,31416,31224,31536/
            data (jx(i),i=  501,  600)/
     +  32016,31920,31800,31824,31728,31680,31440,31608,31896,31968,
     1  32400,32448,32568,32928,32976,33288,33312,33024,32832,32712,
     2  32592,32448,32496,32856,32928,32856,32904,33144,33216,33168,
     3  33264,33288,33048,33024,33168,32928,33168,33096,33192,33280,
     4  33360,33432,32784,32640,32448,32472,32280,32328,32208,32040,
     5  31896,31824,31584,31608,31464,31464,31560,31536,31296,31176,
     6  30768,30600,30600,30768,31056,31080,31032,30864,30648,30384,
     7  30288,30240,30336,30456,30432,30792,30984,31440,31752,31824,
     8  32016,32112,32088,31992,32088,32064,31992,31872,31728,31488,
     9  31440,31128,30888,30744,30744,30528,30144,30168,30024,29976/
            data (jx(i),i=  601,  700)/
     +  29952,30072,29976,29904,29784,29496,29640,29400,29208,29304,
     1  29232,29160,29064,29064,28968,28536,28536,28464,28488,28272,
     2  28176,27888,27744,27552,27408,27264,27360,27672,27816,27984,
     3  27984,28296,28680,28800,28896,28680,28392,28272,28176,32280,
     4  31320,31152,31104,31008,30576,30552,30432,30408,30360,30312,
     5  30048,30072,29928,30024,33624,33720,33744,33672,33600,33504,
     6  33120,33072,33192,33312,33288,33312,33408,33552,33768,33792,
     7  33888,34320,34752,34824,34800,34872,34944,33360,33504,33552,
     8  34056,34488,35112,35352,35376,35568,35736,35496,35520,35592,
     9  35568,35280,35160,34728,34560,34800,34824,34896,35112,35256/
            data (jx(i),i=  701,  800)/
     +  35496,35424,35376,35352,35304,35376,35328,35352,35160,34608,
     1  34128,35592,35016,34872,34608,34512,34416,34320,34200,33816,
     2  33432,33192,33000,33288,33576,33744,33864,33864,33528,33336,
     3  32904,32664,32520,32328,32208,31968,31824,31632,31320,35904,
     4  36072,36120,36312,36240,36288,36432,36336,36408,36384,36480,
     5  36408,36504,36456,36648,36384,36264,36024,36072,35880,35904,
     6  36264,36744,37248,37440,37776,37800,38184,34944,34992,35448,
     7  35568,35616,35544,36000,36000,36096,37872,38976,39912,39888,
     8  39792,39720,39672,39168,38952,38760,38736,38760,38880,39096,
     9  39120,39264,39360,39432,39528,39480,39528,39528,39600,39504/
            data (jx(i),i=  801,  900)/
     +  39648,39696,39792,40008,40008,40175,40185,40296,40224,40176,
     1  40248,40536,40608,40632,40512,40536,40536,40632,40800,40944,
     2  40680,40680,40824,40752,40728,40680,40656,40584,40584,40416,
     3  40392,40272,40176,40176,40080,40080,40176,40152,40968,35184,
     4  35328,35424,35808,35712,36048,36192,36336,36504,36552,36456,
     5  36288,36096,36144,36360,36408,36312,36408,36480,36432,36744,
     6  36744,36960,36888,36816,36384,36288,36360,36288,36216,36336,
     7  36288,36120,36216,36120,36024,35784,35760,35880,35832,35688,
     8  35712,35664,35352,35112,35112,35256,35472,35400,35496,35520,
     9  35640,35688,35640,35760,35760,36288,36384,36432,36384,36552/
            data (jx(i),i=  901, 1000)/
     +  36456,36624,36648,36912,37056,36864,37056,37200,37152,37440,
     1  37488,37344,37248,37296,37032,36960,36936,36816,36672,36432,
     2  36216,35976,36024,35688,35712,35688,35640,35424,35328,35112,
     3  34992,35016,35088,35304,35400,35352,35544,35808,35976,36000,
     4  35904,36072,36264,36240,36672,36648,37080,37056,37128,37032,
     5  37080,37032,36888,36936,36792,36552,36552,36600,37008,37032,
     6  37104,37056,37128,37104,37104,37176,37128,37152,37440,37488,
     7  37656,37608,37656,37824,37896,37680,37680,37944,37968,38112,
     8  38208,38112,38088,38136,38040,37824,37776,37728,37704,37800,
     9  37392,37320,37296,37416,37536,37680,37584,37704,37800,38040/
            data (jx(i),i= 1001, 1100)/
     +  38112,38136,38208,38328,38472,38544,38712,38904,38808,38640,
     1  38592,38496,38208,38088,37968,37704,38064,38376,38424,38760,
     2  38616,38736,38688,38472,38496,38424,37992,37752,37704,37752,
     3  37560,37632,37608,37536,37512,37776,37752,37824,37896,37872,
     4  38232,38232,37872,37392,37368,37536,37512,37584,37656,37632,
     5  37896,38160,38376,38208,48072,48024,47400,46992,46848,46800,
     6  46944,46872,46512,46416,46488,46416,43872,44352,44448,44520,
     7  44760,44952,45144,45456,45936,46224,46944,47016,47112,47208,
     8  47232,47328,48024,51000,50640,50232,50064,49728,49248,49104,
     9  49176,49104,48840,48648,48624,48648,48600,48624,48552,48216/
            data (jx(i),i= 1101, 1200)/
     +  48144,47928,47832,47664,47664,51648,51960,52224,52992,53328,
     1  53688,53688,54072,54000,54048,54048,54240,52824,52704,52728,
     2  52992,53208,53328,53352,53280,53304,53496,53520,53784,53784,
     3  53904,54216,51120,51456,51744,52104,52200,52248,52440,52584,
     4  52536,52152,52080,52080,52152,52464,52920,53232,53112,53160,
     5  53112,53160,53592,53688,53544,53160,53040,52968,52656,52680,
     6  52776,52776,52536,21168,21192,21336,22992,22992,28464,17352,
     7  17328,17424,17448,17592,17688,17952,18192,18408,18600,18936,
     8  18984,19560,19536,19608,19632,19896,20352,20856,21072,21432,
     9  21744,21768,21864,22176,22272,22272,22704,22824,23016,23088/
            data (jx(i),i= 1201, 1300)/
     +  23112,23448,23904,24192,24984,25200,25512,25680,25800,26088,
     1  26208,26352,26376,26448,26616,26760,27168,27144,27360,27312,
     2  27552,27744,27744,27936,28104,28512,28896,17760,17784,18672,
     3  18696,19656,19704,20640,20568,26016,25968,26880,18264,18408,
     4  18480,18624,18744,18768,18600,18528,18768,18888,19368,19632,
     5  19944,20280,20328,20952,21072,21288,21240,21336,21480,21600,
     6  21672,21696,21912,21912,22992,22872,22728,22632,22536,22344,
     7  22464,22488,22224,21984,21840,21840,23088,23088,23256,23256,
     8  23160,23040,22848,22824,22872,23040,22968,23112,23064,23088,
     9  23352,23448,23568,23832,23976,24072,24480,24648,24816,24936/
            data (jx(i),i= 1301, 1400)/
     +  25008,25056,25320,25488,25584,28776,28824,28536,28464,28224,
     1  28104,27936,27744,27600,27624,27288,27288,27168,27072,27144,
     2  26976,26976,26688,26400,26160,26184,26112,25968,25872,25728,
     3  25248,25320,25176,25008,24744,24552,24504,24360,24384,24072,
     4  23976,23856,23592,23544,23472,23352,23232,22944,23016,28560,
     5  28368,28176,27840,27744,27408,27432,27240,27264,27432,27456,
     6  27360,27384,27600,27864,28032,28272,28296,28224,27648,27360,
     7  27408,27672,27648,27576,27288,27024,26952,27072,27048,26544,
     8  26664,26712,26904,27504,27840,28176,28392,28440,28680,28632,
     9  28560,28488,30912,30792,30744,30480,30384,30408,30336,30264/
            data (jx(i),i= 1401, 1500)/
     +  30264,30120,29880,29880,29736,29328,29184,29088,28944,28824,
     1  28800,28584,28416,28200,28176,28032,27888,27768,27816,27624,
     2  27504,27504,27432,27168,27072,26976,26904,26568,26376,26280,
     3  25872,25728,30048,30120,30192,28104,35784,30840,30552,30528,
     4  30216,30216,29328,29304,29160,29136,28992,28968,28680,28656,
     5  28488,29424,29280,29304,29208,29472,29376,29760,29832,29520,
     6  29472,29112,28704,28320,28392,28344,28704,28848,26928,29616,
     7  29520,29568,29280,29208,28872,28728,28680,28704,29016,29352,
     8  29352,29520,29520,29592,29616,29472,29112,29232,29184,28752,
     9  28632,28728,28608,28536,28656,28944,29016,28848,28824,28704/
            data (jx(i),i= 1501, 1600)/
     +  28560,31080,32856,32688,32568,32280,32184,31968,31824,31728,
     1  31656,31560,31512,31368,31248,31152,31080,31416,31032,36480,
     2  35520,35496,35328,35328,35184,35184,35016,35016,34704,34704,
     3  34560,34536,34248,34104,33192,33168,33024,33024,32880,32856,
     4  32736,32712,32592,32568,32424,32400,32256,32232,32088,32064,
     5  31632,31632,33816,32880,33816,33624,32928,32928,33312,33624,
     6  33888,33984,34200,34320,34488,34584,34560,34680,34632,34704,
     7  34608,34584,34728,34848,34872,35064,35376,35424,35712,35736,
     8  35664,35472,35592,35832,36096,36072,36240,36144,36144,35304,
     9  32880,33024,33048,33192,33216,33528,33624,33624,33720,34008/
            data (jx(i),i= 1601, 1700)/
     +  34272,34464,34608,34608,34752,34752,34848,34944,35088,35088,
     1  35232,35208,35304,35448,35568,35712,35904,35928,36144,36096,
     2  36168,36456,36600,36792,36864,37056,37344,37512,37608,37680,
     3  37728,37632,37704,37848,38136,38208,35016,33792,35232,35064,
     4  34968,34920,34800,34080,33720,33312,33048,32736,32208,31872,
     5  31584,31344,31176,30984,30768,30840,30624,30408,29976,29760,
     6  29400,28968,28896,35352,38352,38352,36528,36528,36504,38280,
     7  38160,38232,37944,37848,37896,37560,37536,37584,37584,37368,
     8  37680,37560,37728,37704,37584,37344,37416,37248,37152,36528,
     9  36528,38352,41568,41688,40800,40800,39912,40008,39888,39816/
            data (jx(i),i= 1701, 1800)/
     +  39384,39216,38664,38616,38400,38184,38184,38328,38280,38376,
     1  41376,41016,40752,40296,39408,38832,38496,38112,37824,37440,
     2  37200,41688,41544,41664,41400,41064,41016,41016,40848,40920,
     3  40848,40896,40824,40848,40728,40776,40656,40608,40128,39864,
     4  39648,39576,39576,39456,39504,39456,39552,39432,39264,39144,
     5  38904,38736,38520,38352,41376,41304,41136,41016,40920,40896,
     6  40776,40752,40632,40584,40464,40152,39936,39792,39504,39456,
     7  39312,39168,39000,38904,38760,38472,41400,39552,39432,40920,
     8  40800,40800,40512,40512,40320,40368,40104,39936,39864,39792,
     9  39744,39696,39552,39504,39000,39000,38040,39264,39264,41400/
            data (jx(i),i= 1801, 1900)/
     +  41232,41400,41448,41664,41808,41904,41856,41952,41928,42072,
     1  42192,42336,42360,42576,42768,42864,43008,43272,43440,43632,
     2  43680,43824,44064,44232,44328,44400,44568,44616,44712,44784,
     3  45072,45264,45360,45528,45528,41712,41784,41832,41784,41904,
     4  41880,41808,41760,41880,41808,41928,42024,41568,41400,42048,
     5  42000,41928,41640,41544,42192,42432,42480,42408,42696,42696,
     6  42528,42264,42288,42120,42024,41952,41784,41520,40992,40968,
     7  40992,42456,42408,42456,42360,42504,42648,42624,42504,42600,
     8  42168,41736,41928,42048,42312,42384,42336,42408,42552,42576,
     9  42816,42840,43344,43224,42936,42456,42216,42096,41952,41784/
            data (jx(i),i= 1901, 2000)/
     +  41496,41424,41376,41040,40992,41088,41208,41328,41304,41064,
     1  41160,41256,41616,41904,41952,42096,42192,42288,42720,43680,
     2  43920,44328,44568,45120,45768,46056,46200,46248,46536,46728,
     3  46968,43632,43728,43632,43752,43680,43488,42504,42792,42960,
     4  43176,43320,43584,44304,44496,44640,44784,44880,47088,47112,
     5  44808,44856,44400,44424,44256,44256,43800,43800,43512,43560,
     6  47016,46968,44280,44256,44088,44088,43944,43872,45648,45600,
     7  45696,45696,43800,43824,45048,45096,45552,45792,45912,46296,
     8  46440,46728,49080,49152,45624,48288,46368,46440,45528,45576,
     9  42792,42792,48240,47976,47496,48840,49152,51840,51840,51960/
            data (jx(i),i= 2001, 2100)/
     +  52200,51024,51048,50880,50784,50784,50736,50640,50544,50520,
     1  50376,50376,50304,50304,50424,50304,50352,50136,50160,49848,
     2  49824,49872,49800,49824,49824,49944,49944,50088,50040,49752,
     3  49536,49512,49152,49032,54096,54120,54096,54048,54264,54336,
     4  54312,48792,48768,48912,49104,48864,48912,50160,50328,50208,
     5  47904,47712,47520,47712,48096,48072,47904,48000,47928,39600,
     6  39600,39504,39528,37608,37488,37632,37704,37752,37896,37896,
     7  37704,37776,37752,37680,37752,37608,37560,37416,37344,37272,
     8  37368,37512,37584,37632,36888,36816,36816,37080,37224,37176,
     9  37032,36984,36984,36792,37104,37440,37440,37104,36792,36672/
            data (jx(i),i= 2101, 2200)/
     +  36408,36336,36072,36240,36312,36312,36264,36312,37272,37488,
     1  37416,37296,37248,37056,36888,37200,37200,36432,36384,36528,
     2  36576,33912,33984,34152,34368,34488,34656,34824,34848,34992,
     3  35064,35160,35376,35640,35640,35520,35328,35328,35184,34992,
     4  35040,35136,35088,35160,35232,35760,35784,35736,35616,35256,
     5  35064,34896,34416,34176,33888,33672,33528,33576,33672,33048,
     6  33240,33216,33120,33000,33000,32784,32808,32760,32688,32760,
     7  32616,32424,32328,32256,31872,31848,31920,32016,31896,31704,
     8  31824,32136,32232,32208,32304,32184,32304,32448,32472,32544,
     9  33024,33048,32928,28584,28440,28224,28272,28200,28176,27816/
            data (jx(i),i= 2201, 2300)/
     +  27864,27792,27696,27720,27840,28272,28440,28656,28656,28392,
     1  28008,27912,27864,28560,28656,28704,28536,27480,27456,27384,
     2  27504,27000,26952,27048,24888,24600,24552,24624,24648,24456,
     3  24648,24624,24864,25056,25152,25392,25536,25656,25824,25848,
     4  25944,25776,25680,25704,25992,25872,25848,25776,25776,25848,
     5  26040,26256,26304,26352,26400,26544,26400,26568,26832,27480,
     6  27696,27984,28224,28320,28608,28560,28368,28104,28008,27744,
     7  27768,28200,28392,28416,28704,28944,29184,29400,29568,29760,
     8  29640,29640,29448,29208,28872,28920,29064,29112,29064,28872,
     9  28776,28656,28440,28320,27960,27576,27192,27072,27048,27144/
            data (jx(i),i= 2301, 2400)/
     +  26928,26760,26688,26496,26160,23952,23880,23904,24000,23304,
     1  23304,23400,23448,23760,23736,23592,23424,23424,23736,23736,
     2  23808,23784,23688,23496,23520,23448,23040,22968,22872,22800,
     3  22992,22992,23112,23112,23520,23760,23976,24000,23976,24120,
     4  24072,23952,23952,23856,23784,23856,24024,24120,24264,24264,
     5  24336,24384,24288,24336,24312,24384,24384,24312,24216,24216,
     6  24264,24192,24144,24072,24120,24120,23976,24000,23592,23352,
     7  23328,23400,23016,23088,22992,23016,22896,22944,22848,22704,
     8  22704,22656,22680,22560,22608,22656,22752,22776,22680,22704,
     9  22896,22944,22464,22416,22512,22464,22512,22632,22608,22848/
            data (jx(i),i= 2401, 2500)/
     +  22992,23016,23112,23136,22920,22776,22896,22752,22656,22704,
     1  22992,23016,23064,23232,22992,22920,22656,22656,22872,23040,
     2  23256,23280,23160,23256,23016,22560,22464,22392,22608,22440,
     3  22416,22368,22272,22248,22296,22296,22272,22368,22488,22536,
     4  22584,22824,22944,23064,23088,23160,23280,23184,23280,23256,
     5  23400,23328,23616,23736,23880,23976,23976,23904,23928,24072,
     6  23952,24000,23856,23760,23688,23688,23760,23736,23760,23568,
     7  23208,23112,22872,22800,22824,22776,22800,22752,22632,22608,
     8  22680,22728,22584,22584,22632,22536,22272,22368,22512,22488,
     9  22560,22656,22656,22536,22536,22320,22272,22176,22200,22080/
            data (jx(i),i= 2501, 2600)/
     +  22152,22320,22464,22488,22584,22536,22464,22200,22392,22368,
     1  22200,21912,21600,21552,21432,21336,21312,21336,21888,22080,
     2  22176,22320,22512,22440,22512,22296,22320,22296,22032,22056,
     3  21600,21528,21576,21528,21600,21768,21960,22104,22272,22392,
     4  22512,22632,22560,22536,22608,21360,21408,21336,21528,21456,
     5  21312,21264,21312,21360,21648,21960,22032,21768,21552,21504,
     6  21312,21096,20952,21216,21312,21336,21408,21456,21552,21696,
     7  21576,21432,21408,21216,21624,21576,21576,21792,21864,21816,
     8  21720,21816,21768,21720,21648,21720,21672,21792,21744,21792,
     9  21888,21936,21888,21984,22032,22032,21984,22008,22152,22056/
            data (jx(i),i= 2601, 2650)/
     +  22344,22296,22296,22392,22200,22272,22344,22416,22296,18288,
     1  18624,18552,18600,18552,18288,20568,20616,20592,20784,20808,
     2  20736,20904,20976,20880,20832,20904,20928,20976,20928,20952,
     3  21000,21024,44760,44880,44856,45096,45360,45336,45240,45096,
     4  44760,44616,44568,44592,44400,44544,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  52200,56568,61848,38304,27120,28008,27912,27984,27792,27768,
     1  65303,12240,24072,27816,23688,13968,26208,26760,26160,23376,
     2  65951,24960,27720,23016,25752,15672,66647,15696,16080,16104,
     3  16032,16176,16368,16584,16608,16440,16560,16464,16536,16536,
     4  16800,16992,16992,17136,17160,17208,17256,17544,17496,17544,
     5  17640,17592,17712,17760,17952,18048,17760,17616,17448,16968,
     6  16920,16920,16800,16944,16848,17016,17040,17136,17112,17016,
     7  16992,16824,16656,16704,16872,16920,17112,17088,17160,17064,
     8  17088,16968,16896,16872,16752,16752,16800,16944,17040,17400,
     9  17496,17496,17376,17184,16872,16896,16800,16800,16872,16680/
            data (jy(i),i=  101,  200)/
     +  16680,16536,16344,16224,16104,16176,16176,15984,16008,16032,
     1  16152,16008,15888,15936,15864,15768,15816,15696,15696,15912,
     2  15984,15960,16224,16536,16536,16896,17184,17472,17472,17616,
     3  17736,17976,18096,18120,18288,18312,62855,63767,22008,59976,
     4  53064,52848,46416,46824,47832,48192,48432,48576,49080,49440,
     5  50112,50736,51336,51816,52584,52872,34344,29088,25176,64631,
     6  44208,26928,27024,27096,27048,26976,27000,26880,27120,27096,
     7  26952,26760,26544,26448,26352,25992,25896,25824,26016,25872,
     8  25800,25632,25656,25584,25536,24984,25320,25296,25176,24984,
     9  24792,24840,25128,25152,25032,25080,25320,25416,25416,25296/
            data (jy(i),i=  201,  300)/
     +  25248,32136,27408,27552,27504,27264,27336,27144,27048,26760,
     1  26664,26616,26640,26688,27000,27072,27168,27216,27144,27144,
     2  27264,27240,27168,27192,27096,27000,26952,26880,26640,26496,
     3  26544,26472,26424,26448,26328,25848,25752,25632,25776,25800,
     4  25968,25968,25824,25848,25896,25992,25968,26256,26280,26472,
     5  26520,26664,26712,26640,26544,26664,26688,26808,26808,26976,
     6  27024,27120,27144,27048,27000,27048,27120,27432,27768,27792,
     7  27888,27864,27960,27888,24144,23664,23304,23424,23544,23496,
     8  23592,23568,23472,23256,23256,23208,23256,23280,23112,22728,
     9  22680,22512,22272,22560,22560,22632,22824,22848,22536,22176/
            data (jy(i),i=  301,  400)/
     +  21816,21552,21360,20760,20400,20352,20736,20472,19992,19728,
     1  19632,19536,19296,19080,19104,19008,18672,18528,18480,18120,
     2  17832,17784,17520,17448,16728,16296,16152,16152,15816,15792,
     3  15840,15864,15624,14928,14856,14736,14640,14544,14448,14232,
     4  14112,13944,13824,13704,13536,13080,12840,12648,12480,12240,
     5  12168,12000,11760,11688,11616,11496,11496,11592,11736,11808,
     6  11880,11952,11952,11904,11952,11928,11784,11808,27792,27840,
     7  27840,12096,12120,12048,12024,11904,11904,11808,11856,11760,
     8  11760,11688,11736,11448,11448,11640,11712,11736,11640,11784,
     9  27840,28248,28272,28440,28848,29040,29064,28992,29064,29016/
            data (jy(i),i=  401,  500)/
     +  29064,29136,29280,29352,29472,29472,29520,29472,29304,29160,
     1  29088,28968,28560,28560,28656,28632,28512,28272,28176,27984,
     2  27984,28080,28008,27888,27936,27840,27816,27312,27192,27048,
     3  26856,26808,26808,27000,27144,27312,27432,27600,27744,27864,
     4  28056,27912,27600,27504,27216,27216,27384,27480,27408,27504,
     5  27576,23760,23832,23976,24120,24168,24504,24600,24768,24744,
     6  25032,25128,25152,25296,25392,25344,25416,25488,25560,25752,
     7  25800,26232,26328,26520,26496,26544,26640,26568,26568,26448,
     8  26520,26400,26256,26232,26304,26448,26904,26880,27000,27048,
     9  27216,27216,27048,27216,27288,27288,27000,26760,26664,26760/
            data (jy(i),i=  501,  600)/
     +  26472,26352,26304,26208,26232,26112,26040,25968,26136,26280,
     1  26304,26256,26448,26400,26448,26352,26304,26016,25968,25848,
     2  25896,25800,25728,25632,25680,25752,25800,25776,25824,25848,
     3  25848,25920,25848,25872,25896,25920,25944,26016,26064,26232,
     4  26232,26016,23736,24000,24048,24240,24264,24144,24288,24360,
     5  24336,24384,24408,24480,24456,24552,24576,24624,24624,24528,
     6  24480,24528,24600,24648,24624,24744,24816,24864,24792,24912,
     7  24864,24888,24936,24960,24912,25080,25056,24912,24888,24792,
     8  24768,24888,24984,24960,25008,25104,25176,25104,25104,25200,
     9  25272,25344,25344,25392,25512,25776,25704,26112,26184,26136/
            data (jy(i),i=  601,  700)/
     +  26184,26232,26304,26064,25992,25968,25824,25776,25824,25752,
     1  25728,25824,25824,25656,25584,25464,25440,25440,25296,25176,
     2  25200,24984,25032,25320,25224,25272,24696,24360,24408,24336,
     3  24408,24768,24720,24648,24408,24552,24504,24456,24168,13728,
     4  13464,13320,13128,13176,13056,12912,12840,12720,12744,12648,
     5  12576,12528,12360,12264,25872,25704,25752,25920,25944,26352,
     6  26616,26736,26784,26760,26808,26880,26808,26832,26784,27096,
     7  27144,26904,26880,26832,26760,26832,26208,23448,23280,23304,
     8  23136,22776,22536,22512,22464,22440,22728,22848,23040,23064,
     9  23352,23736,24168,24672,24672,24408,24264,24240,23736,23496/
            data (jy(i),i=  701,  800)/
     +  23352,23208,23208,23280,23256,23184,22968,22776,22704,22968,
     1  23328,28368,28344,28176,28152,27960,28032,28032,28104,27816,
     2  27816,27672,27936,28152,28224,28440,28488,28560,28272,28200,
     3  28224,27960,27696,27552,27744,27768,27936,27984,27936,27624,
     4  27504,27696,27888,27768,27720,27888,27696,27768,27648,27696,
     5  27600,27648,27576,27600,27504,27264,27048,27024,26832,26760,
     6  26904,26664,26520,26328,26184,26088,25824,14064,14136,14184,
     7  14520,14520,14352,14496,14616,14736,15144,15216,15168,15312,
     8  15240,15264,15480,15432,15336,15456,15648,15984,16224,16296,
     9  16344,16272,16344,17040,16800,17088,17208,17472,17568,17784/
            data (jy(i),i=  801,  900)/
     +  17688,17424,17328,16704,16488,16426,16495,16512,16488,16344,
     1  16104,16008,15912,16008,16152,16296,16176,16104,16296,16224,
     2  16080,16008,15888,15864,15936,15960,15864,15840,15744,15672,
     3  15720,15744,15720,15624,15624,15552,15504,15408,15624,26760,
     4  26856,26760,26616,26544,26640,26760,26760,26640,26496,26424,
     5  26472,26328,26280,26424,26304,26088,26064,26136,26232,26400,
     6  26496,26400,26256,26256,25920,25920,26016,26016,25848,25800,
     7  25728,25752,25776,25848,25776,25872,25968,25920,26040,26016,
     8  25992,25896,26232,26184,26136,26184,25776,25728,25704,25752,
     9  25608,25512,25440,25464,25512,25320,25224,25248,25344,25320/
            data (jy(i),i=  901, 1000)/
     +  25440,25416,25560,25536,25392,25344,25296,25368,25416,25320,
     1  25224,25152,25200,25104,24936,24936,25008,24816,24768,24840,
     2  25032,25104,25032,25056,25080,25224,25080,25080,24864,24888,
     3  24840,24792,24816,24744,24768,24816,24816,24744,24648,24552,
     4  24480,24528,24144,24120,24072,24000,24024,23832,23616,23544,
     5  23136,23064,23256,23352,23232,23472,23424,23304,22968,22728,
     6  22752,23016,23136,23352,23496,23592,23784,23976,23856,23592,
     7  23496,23400,23136,22944,22992,23184,23424,23424,23160,22968,
     8  22944,23112,23232,23256,23448,23592,23520,23544,23688,23712,
     9  24000,23952,24000,24120,24144,24048,24000,23976,23880,23808/
            data (jy(i),i= 1001, 1100)/
     +  23856,23640,23688,23640,23448,23448,23616,23616,23664,23640,
     1  23544,23520,23928,24024,23952,24096,24120,24024,24096,24216,
     2  24240,24312,24336,24336,24264,24240,24336,24216,24312,24336,
     3  24528,24552,24600,24552,24696,24696,24600,24648,24600,24672,
     4  24792,24840,24792,24840,24888,24912,24960,25008,24984,25032,
     5  25080,25488,25464,25560,21576,21240,20544,20376,20208,20040,
     6  19248,18696,18576,18624,18480,18408,66671,66527,66575,66791,
     7  66887,67103,67103,67343,67367,67679,67487,67367,67319,67367,
     8  67511,67607,67895,25176,24984,25128,24936,24720,24480,24480,
     9  24504,24528,24480,24216,24336,24168,24264,24024,23904,23568/
            data (jy(i),i= 1101, 1200)/
     +  23352,23208,22920,22656,22368,25104,25296,25368,25248,25440,
     1  26112,26352,27696,27984,27984,28272,28512,32976,32304,32112,
     2  31680,31584,31392,31320,31296,31200,30888,30792,30408,30144,
     3  29856,29352,45672,45096,44304,44064,43920,43440,42888,42000,
     4  41832,41400,41232,40896,40728,40392,39288,38904,38640,38376,
     5  38112,37584,37272,37032,36792,36744,36672,36552,35736,35472,
     6  35256,35040,34584,52392,52176,52176,52272,52416,52728,56568,
     7  56424,56544,56472,56472,56544,56472,56616,56568,56592,56712,
     8  56832,57096,57264,57288,57192,57288,57312,57480,57480,57336,
     9  57360,57288,57312,57288,57216,57072,57024,56904,56856,56856/
            data (jy(i),i= 1201, 1300)/
     +  56928,56928,57120,57144,57504,57432,57168,57216,57144,57216,
     1  57192,57024,56832,56808,56832,56952,56952,56760,56736,56160,
     2  55824,55920,55992,56016,56184,56184,56328,61920,61464,61512,
     3  61080,61152,60672,60744,61632,62040,62472,62568,38352,38136,
     4  38160,38400,38472,38568,38688,38904,39048,38928,38976,39216,
     5  39144,39216,39192,39792,39624,39672,39504,39432,39360,39384,
     6  39168,38064,38064,37848,39552,39504,39528,39648,39648,39408,
     7  39288,39192,38928,38904,39024,39096,39480,39360,39096,38904,
     8  38736,38784,38664,38472,38400,38424,38256,38112,37872,37800,
     9  37824,37248,37128,37032,37200,37200,37032,37104,37224,37224/
            data (jy(i),i= 1301, 1400)/
     +  37224,37056,37032,37440,37464,45504,44160,44136,44040,43992,
     1  43752,43632,43632,43272,43128,42768,42720,42648,42432,42336,
     2  42216,42120,42024,42120,42024,41880,41784,41808,41496,41280,
     3  40920,40704,40416,40416,40560,40488,40248,40176,39984,39888,
     4  39912,39792,40032,39840,39816,40056,39840,39840,39720,45408,
     5  45504,45504,45312,45360,45912,46128,46152,46368,46464,46608,
     6  46776,46824,46872,46752,46776,46968,47136,47304,47880,48048,
     7  48480,48792,49176,49224,49224,49368,49488,49680,49824,50664,
     8  50832,51216,51360,51504,51936,51888,51744,51792,51792,52152,
     9  52440,52512,36792,36888,37008,37128,37104,36792,36792,36672/
            data (jy(i),i= 1401, 1500)/
     +  36552,36600,36552,36432,36360,36408,36480,36456,36552,36576,
     1  36648,36816,36720,36504,36648,36744,37248,37368,37464,37704,
     2  37776,37872,37968,37800,37848,37968,38208,38088,37824,37872,
     3  37488,37440,19104,19128,23976,23928,52152,49944,49944,50064,
     4  50064,50208,50184,50304,50304,50616,50616,50760,50760,50928,
     5  50904,60000,59904,59784,59592,59208,58848,58584,58296,58032,
     6  57888,57840,57408,57216,57000,56928,56544,56472,61800,62064,
     7  61944,61656,61368,61176,61080,61104,61008,60912,60816,60480,
     8  60360,60192,56208,56136,55992,55608,55464,55200,54936,54960,
     9  54696,54120,54048,53880,53712,53688,53592,53208,53016,52848/
            data (jy(i),i= 1501, 1600)/
     +  52824,30816,36912,36840,36888,36744,36816,36792,37032,37032,
     1  37200,37176,37056,37104,37008,37032,36912,49656,49776,44880,
     2  44856,44976,44976,45144,45144,45288,45312,45432,45432,45576,
     3  45576,45720,45720,48120,48072,48240,48240,48384,48384,48504,
     4  48504,48648,48648,48816,48816,48960,48960,49392,49320,49512,
     5  49512,49656,20016,20016,16152,16152,36936,37032,37176,37704,
     6  37848,38040,38088,38280,38304,38400,38520,38640,38712,38808,
     7  38952,39168,39216,39360,39648,39720,40104,40704,40848,40968,
     8  41088,41112,41184,41664,41856,42000,42144,43080,44256,60384,
     9  36600,36480,36528,36432,36096,35976,35904,35784,35688,35616/
            data (jy(i),i= 1601, 1700)/
     +  35160,35016,35016,34944,34896,34728,34776,34680,34728,34632,
     1  34608,34488,34464,34512,34680,34704,34608,34704,34776,35184,
     2  35376,35448,35280,35208,35520,35664,35592,35712,35712,35640,
     3  35448,35208,35040,34968,34992,35160,24984,24984,44232,43896,
     4  43584,43080,42816,42552,42600,42696,42960,43104,43128,43320,
     5  43296,43152,43176,43296,43728,44160,44736,44880,44976,45288,
     6  45264,45624,45624,59424,22128,20088,20088,19968,44424,35112,
     7  34944,34680,34368,34104,33648,33312,33096,33000,32688,32184,
     8  31824,31416,31200,31080,31056,30576,30312,30216,30000,29640,
     9  28320,23040,45336,41472,41448,40584,40560,37608,37488,37536/
            data (jy(i),i= 1701, 1800)/
     +  37176,37176,36624,36456,36264,35856,35688,35568,35424,35256,
     1  45360,45600,45624,45336,45288,44976,44952,44688,44760,45000,
     2  44904,29184,28992,28824,28512,28560,28536,28416,28368,28272,
     3  28080,27960,27912,27816,27552,27504,27408,27216,27120,26688,
     4  26640,26688,26520,26592,26472,26352,26328,26160,26208,25968,
     5  25824,25848,25680,25656,34680,34728,34632,34464,34536,34440,
     6  34440,34296,34368,34344,34152,34320,34608,34680,34608,34704,
     7  34728,34944,34944,35040,34992,35184,49632,49560,52344,57912,
     8  58056,58296,58728,59112,59232,59328,59256,59424,59424,59472,
     9  59376,59376,59472,59592,59568,59640,59616,22104,22416,22416/
            data (jy(i),i= 1801, 1900)/
     +  53328,20904,34656,34872,34848,34872,34920,35160,35280,35376,
     1  35208,35280,35088,34968,34944,35160,35184,35016,35088,34920,
     2  34992,34944,34752,34704,34776,34920,34872,34920,34920,35016,
     3  35088,35232,35184,34896,34272,22416,29856,29952,30192,30504,
     4  30600,30600,30696,30912,31080,31248,31968,32304,32496,49080,
     5  49656,49056,48792,48576,48120,47856,47592,47304,46368,46056,
     6  58032,58056,58128,58104,57984,58008,57888,57960,57672,57744,
     7  57816,57912,57720,57504,57240,56880,56736,56544,56232,45864,
     8  45504,45312,60600,60456,60408,60312,59904,59424,59208,58944,
     9  58800,58320,65255,65135,65183,64967,64703,64295,64223,63983/
            data (jy(i),i= 1901, 2000)/
     +  63983,63911,63599,63407,63263,63143,63095,62448,62256,61992,
     1  61440,61272,61224,61008,60816,49056,49152,49368,49464,50496,
     2  50544,50544,50592,50520,50712,50592,50640,50760,51048,51864,
     3  52296,66455,66263,65831,65519,65351,65375,56184,55944,55680,
     4  55560,55368,55176,55056,55104,54912,54864,54720,62759,62711,
     5  62568,62112,62088,61920,61896,61752,61728,61560,61536,60648,
     6  63671,64103,63887,64055,64031,64343,64343,65279,29064,29952,
     7  21960,20952,20928,20976,54720,54336,54168,54192,53808,53520,
     8  52728,52392,29064,34344,18312,60024,59904,58968,58920,58008,
     9  57840,57936,53064,53016,52776,46368,33672,33744,34440,34272/
            data (jy(i),i= 2001, 2100)/
     +  34344,25440,25632,25488,25512,25416,25392,25464,25464,25584,
     1  25584,25824,25848,25968,26040,26136,26352,26616,26760,27024,
     2  27120,27168,27240,27504,27600,27648,27936,28224,28416,28560,
     3  28464,28536,28704,28896,27672,27864,27960,27888,28464,28608,
     4  28848,24384,24312,24360,24456,24480,24432,24960,25008,25080,
     5  20640,20472,20496,20856,21168,20856,23112,23160,23016,16128,
     6  16224,16128,16104,26136,26208,26184,26136,25512,25608,25752,
     7  25632,25680,25728,25704,25872,25800,25872,25896,25848,25656,
     8  25560,25488,25536,25416,25920,25848,25680,25512,25872,26088,
     9  26088,26064,25944,24096,24360,24456,24552,24696,24600,24480/
            data (jy(i),i= 2101, 2200)/
     +  24528,24480,24648,24384,24408,24336,24360,24168,24144,24312,
     1  24336,24264,24288,24216,24072,24120,24192,24816,24744,24696,
     2  24744,27384,27432,27408,27576,27528,27528,27624,27552,27576,
     3  27864,28008,27600,27432,27360,27288,27360,27456,27600,27552,
     4  27384,27384,27480,27480,27240,27192,27096,27000,26928,27000,
     5  26904,27024,27048,27264,27288,27120,27072,27240,27216,26856,
     6  26928,27120,27264,26976,27144,27120,27024,26928,27096,27168,
     7  27168,26976,27096,27048,27048,26904,26904,26760,26880,26760,
     8  26640,26640,26688,26640,26616,26568,26472,26520,26616,26544,
     9  26592,26640,26760,25656,25728,25632,25728,25728,25656,25536/
            data (jy(i),i= 2201, 2300)/
     +  25392,25416,25704,25752,25704,25776,25872,25848,25704,25416,
     1  25368,25392,25488,28224,28272,28464,28320,24072,24192,24048,
     2  23952,11328,11280,11304,25896,25896,26112,26088,26160,26304,
     3  26424,26472,26496,26376,26616,26928,27000,27024,26832,26664,
     4  26640,26592,26472,26256,26160,26016,26112,26112,26040,25920,
     5  25992,25944,25584,25440,25440,25512,26016,26280,26448,26664,
     6  26568,26736,26736,26808,26784,26928,27000,26928,26976,26880,
     7  27120,27432,27768,27936,27960,28104,28152,28104,27936,27936,
     8  27744,27552,27456,27480,27240,27024,26952,26784,26688,26760,
     9  26736,26496,26304,26424,26280,26376,26304,26136,26016,25824/
            data (jy(i),i= 2301, 2400)/
     +  25728,25584,25440,25176,25248,25680,25656,25584,25656,24792,
     1  25056,24984,25080,24840,24792,24840,24696,24744,25656,25584,
     2  25584,25752,25752,24048,24096,24168,24120,24312,24312,24384,
     3  24384,24456,24432,24576,24432,24600,24504,24552,24648,24576,
     4  24720,24792,24744,24720,24816,24864,24840,24960,24864,24912,
     5  24936,24840,24672,24672,24528,24576,24312,24408,24360,24456,
     6  24456,24504,24336,24288,24264,24192,24120,23976,23976,24072,
     7  24120,24144,23976,23928,23808,23712,23640,23760,23712,23592,
     8  23472,23472,23544,23808,23808,24000,23976,24024,24072,24240,
     9  24120,23904,25512,25584,25632,25656,25704,25728,25656,25896/
            data (jy(i),i= 2401, 2500)/
     +  25680,25776,25752,25512,25512,25368,25128,25056,24888,24744,
     1  24768,24840,24792,24888,25152,26280,26088,25992,26040,25968,
     2  26016,26136,26400,26544,26472,22584,22632,22584,22392,22440,
     3  22536,22488,22512,22608,22560,22656,22824,22896,22824,22872,
     4  23040,23232,23496,23544,23448,23448,23568,23664,23736,23784,
     5  23712,23472,23400,23520,23520,23664,23808,23808,23856,23832,
     6  23352,23328,23136,23088,23136,23040,23064,22992,22920,22632,
     7  22440,22464,22344,22368,22488,22512,22440,22368,22392,22464,
     8  22464,22536,22488,22224,22176,22176,22344,22368,22272,22392,
     9  22320,22344,22296,22272,23952,23880,23928,23856,23784,23688/
            data (jy(i),i= 2501, 2600)/
     +  23616,23736,23736,23664,23640,23520,23640,23568,23424,23376,
     1  23352,23520,23880,23856,23976,23928,24288,24432,25368,25200,
     2  24960,24888,24960,24840,24744,24744,24696,24624,24504,24432,
     3  24384,24288,24264,24216,24120,24192,24216,24384,24432,24528,
     4  24504,24336,24240,24264,24168,26208,26208,25992,26160,26304,
     5  26256,26160,25584,25704,25824,26064,26256,26208,26040,25896,
     6  25776,25704,25536,25488,25512,23256,23232,23088,23304,23280,
     7  23496,23496,23544,23496,22128,22128,21936,22080,22320,22320,
     8  22152,22416,22392,22440,22368,22320,22152,22560,22464,22464,
     9  22632,26472,26424,26400,26472,22608,22512,22440,22824,22728/
            data (jy(i),i= 2601, 2650)/
     +  23208,23232,23280,23304,25824,25656,25656,25920,25920,22944,
     1  22992,23280,23376,23424,23328,23784,23904,23976,24120,24432,
     2  24240,24264,24360,24288,24120,24216,24168,24288,24216,24648,
     3  24768,24696,16416,16392,16344,16584,16560,16752,16800,16728,
     4  16728,16440,16440,16560,16488,16392,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +     26,   28,   29,   30,   31,   32,   33,   34,   35,   36,
     1     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     2     47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
     3     57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
     4     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     5     77,   78,   79,   80,   81,   82,   83,   84,   85,   86,
     6     87,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     7     97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
     8    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     9    117,  118,  119,  120,  121,  122,  123,  124,  125,  126/
            data (jb1(i),i=  101,  200)/
     +    127,  128,  129,  130,  131,  132,  133,  134,  135,  141,
     1    140,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     2    152,  153,  154,  155,  141,    3,   11,    2,    1,    4,
     3      1,    5,  162,  163,  164,  165,  166,  167,  168,  169,
     4    170,  171,  172,  173,  174,  175,  176,  177,  178,  179,
     5    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     6    190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
     7    200,  201,    4,    5,  203,  204,  205,  206,  207,  208,
     8    209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
     9    219,  220,  221,  222,  223,  224,  225,  226,  227,  228/
            data (jb1(i),i=  201,  300)/
     +    229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
     1    239,  240,  241,  242,  243,  244,  245,  246,  247,  248,
     2    249,  250,  251,  252,  253,  254,  255,  256,  257,  258,
     3    259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
     4    269,  270,  271,  272,    7,    6,    7,    8,   13,  275,
     5    276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
     6    286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
     7    296,  297,  298,  299,  300,  301,  302,  303,  304,  305,
     8    306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
     9    316,  317,  318,  319,  320,  321,  322,  323,  324,  325/
            data (jb1(i),i=  301,  400)/
     +    326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
     1    336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
     2    346,  347,  348,  349,  350,  351,  352,  353,  354,  355,
     3    356,  357,  358,  359,  360,  361,  362,  363,  364,  365,
     4    366,  367,   10,  369,  370,    6,   12,  372,  373,  374,
     5    375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
     6    385,  386,  387,  388,  389,  368,   14,  391,  392,  393,
     7    394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
     8    404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
     9    414,  415,  416,  417,  418,  419,  420,  421,  422,  423/
            data (jb1(i),i=  401,  500)/
     +    424,  425,  426,    9,   10,  428,  429,  430,  431,  432,
     1    433,  434,  435,  436,  437,  438,  439,  440,  441,  442,
     2    443,  444,  445,  446,  447,  448,  449,  450,    9,   20,
     3    452,  453,  454,  455,  456,  457,  458,  459,  460,  461,
     4    462,  463,  464,  465,  466,  467,  468,  469,  470,  471,
     5    472,  473,  474,  475,  476,  477,  478,  479,  480,  481,
     6    482,  483,  484,  485,  486,  487,  488,  489,  490,  491,
     7    492,  493,  494,  495,  496,  497,  498,  499,  500,  501,
     8    502,  503,  504,  505,  506,  507,  508,  509,  510,  511,
     9    512,  513,  514,  515,  516,  517,  518,  519,  520,  521/
            data (jb1(i),i=  501,  600)/
     +    522,  523,  524,  525,  526,  527,  528,  529,  530,  531,
     1    532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
     2     15,  543,  544,  545,  546,  547,  548,  549,  550,  551,
     3    552,  553,  554,  555,  556,  557,  558,  559,  560,  561,
     4    562,  563,  564,  565,  566,  567,  568,  569,  570,  571,
     5    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     6    582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
     7    592,  593,  594,  595,  596,  597,  598,  599,  600,  601,
     8    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     9    612,  613,  614,  615,  616,  617,  618,  619,  620,  621/
            data (jb1(i),i=  601,  700)/
     +    622,  623,  624,  625,  626,  627,  628,  629,  630,  631,
     1    632,  633,  634,  635,  636,  637,  638,   13,   16,  640,
     2    641,  642,  643,  644,  645,  646,  647,  648,  649,  650,
     3    651,  652,  653,   12,  542,  655,  656,  657,  658,  659,
     4    660,  661,  662,  663,  664,  665,  666,  667,  668,  669,
     5    670,  671,  672,  673,  674,  675,   18,   11,   17,   19,
     6     15,  678,  679,  680,  681,  682,  683,  684,  685,  686,
     7    687,  688,  689,  690,  691,  692,  693,  694,  695,  696,
     8    697,  698,  699,  700,  701,  702,  703,  704,  705,  706,
     9    707,  708,  709,  710,   20,   23,  712,  713,  714,  715/
            data (jb1(i),i=  701,  800)/
     +    716,  717,  718,  719,  720,  721,  722,  723,  724,  725,
     1    726,  727,  728,  729,  730,  731,  732,  733,  734,  735,
     2    736,  737,  738,   14,   23,  740,  741,  742,  743,  744,
     3    745,  746,  747,  748,  749,  750,  751,  752,  753,  754,
     4    755,  756,  757,  758,  759,  760,  761,  762,  763,  764,
     5    765,  766,   25,   16,  768,  769,  770,  771,  772,  773,
     6    774,  775,  776,  777,  778,  779,  780,  781,  782,  783,
     7    784,  785,  786,  787,  788,  789,  790,  791,  792,  793,
     8    794,  795,  796,  797,  798,  799,  800,  801,  802,  803,
     9    804,  805,  806,  807,  808,  809,  810,  811,  812,  813/
            data (jb1(i),i=  801,  900)/
     +    814,  815,  816,  817,  818,  819,  820,  821,  822,  823,
     1    824,  825,  826,  827,  828,  829,  830,  831,  832,  833,
     2    834,  835,  836,  837,  838,   26,   18,  840,  841,  842,
     3    843,  844,  845,  846,  847,  848,  849,  850,  851,  852,
     4    853,  854,  855,  856,  857,  858,  859,  860,  861,  862,
     5    863,  864,  865,  866,  867,  868,  869,  870,  871,  872,
     6    873,  874,  875,  876,  877,  878,  879,  880,  881,  882,
     7    883,   17,   19,  885,  886,  887,  888,  889,  890,  891,
     8    892,  893,  894,  895,  896,  897,  898,  899,  900,  901,
     9    902,  903,  904,  905,  906,  907,  908,  909,  910,  911/
            data (jb1(i),i=  901, 1000)/
     +    912,  913,  914,  915,  916,  917,  918,  919,  920,  921,
     1    922,  923,  924,  925,  926,  927,   22,   22,  929,  930,
     2    931,  932,  933,  934,  935,  936,  937,  938,  939,  940,
     3    941,  942,  943,  944,  945,  946,  947,  948,  949,  950,
     4    951,  952,  953,  954,  955,  956,  957,  958,  959,  960,
     5    961,  962,  963,  964,  965,  966,  967,  968,  969,  970,
     6    971,  972,  973,  974,  975,  976,  977,  978,  979,  980,
     7     24,   24,  982,  983,  984,  985,  986,  987,  988,  989,
     8    990,  991,  992,  993,  994,  995,  996,  997,  998,  999,
     9   1000, 1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009/
            data (jb1(i),i= 1001, 1100)/
     +   1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019,
     1   1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029,
     2   1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039,
     3   1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049,
     4   1050, 1051, 1052, 1053,   25,   21,  139, 1055, 1056, 1057,
     5   1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065,  136,   27,
     6   1067, 1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076,
     7   1077, 1078, 1079, 1080, 1081, 1082,  138,  137,  137,  159,
     8   1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093,
     9   1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103/
            data (jb1(i),i= 1101, 1200)/
     +   1104,  139,  159, 1106, 1107, 1108, 1109, 1110, 1111, 1112,
     1   1113, 1114, 1115, 1116,  158,  157, 1118, 1119, 1120, 1121,
     2   1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     3    158,  143, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140,
     4   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150,
     5   1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160,
     6   1161, 1162,  157,    1, 1164, 1165, 1166, 1167, 1168,    2,
     7   1170, 1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179,
     8   1180, 1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189,
     9   1190, 1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199/
            data (jb1(i),i= 1201, 1300)/
     +   1200, 1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209,
     1   1210, 1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219,
     2   1220, 1221, 1222, 1223, 1224, 1225, 1226,    3, 1228, 1229,
     3   1230, 1231, 1232, 1233, 1234, 1235, 1236, 1237,    4, 1239,
     4   1240, 1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249,
     5   1250, 1251, 1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259,
     6   1260, 1261, 1262, 1263, 1264, 1265, 1266, 1267, 1268, 1269,
     7   1270, 1271, 1272, 1273, 1274, 1275, 1261, 1265, 1277, 1278,
     8   1279, 1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288,
     9   1289, 1290, 1291, 1292, 1293, 1294, 1295, 1296, 1297, 1298/
            data (jb1(i),i= 1301, 1400)/
     +   1299, 1300, 1301, 1302, 1303, 1304, 1306, 1307, 1308, 1309,
     1   1310, 1311, 1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319,
     2   1320, 1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329,
     3   1330, 1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339,
     4   1340, 1341, 1342, 1343, 1344, 1345, 1346, 1347, 1348, 1265,
     5   1305,    7,    9, 1238, 1306, 1350, 1351, 1352, 1353, 1354,
     6   1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1364,
     7   1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374,
     8   1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384,
     9   1385, 1386, 1387, 1388, 1389, 1390, 1391, 1169, 1393, 1394/
            data (jb1(i),i= 1401, 1500)/
     +   1395, 1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404,
     1   1405, 1406, 1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414,
     2   1415, 1416, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424,
     3   1425, 1426, 1427, 1428, 1429, 1430, 1431, 1305,   12, 1433,
     4   1434, 1435, 1436, 1389, 1438, 1439, 1440, 1441, 1442, 1443,
     5   1444, 1445, 1446, 1447, 1448, 1449, 1450, 1388, 1452, 1453,
     6   1454, 1455, 1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463,
     7   1464, 1465, 1466, 1467, 1227, 1238, 1469, 1470, 1471, 1472,
     8   1473, 1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481, 1452,
     9   1227, 1483, 1484, 1485, 1486, 1487, 1488, 1489, 1490, 1491/
            data (jb1(i),i= 1501, 1600)/
     +   1492, 1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1169,
     1   1393, 1502, 1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510,
     2   1511, 1512, 1513, 1514, 1515, 1516, 1393, 1518, 1438, 1520,
     3   1521, 1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530,
     4   1531, 1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540,
     5   1541, 1542, 1543, 1544, 1545, 1546, 1547, 1548, 1549, 1550,
     6   1551, 1518, 1553, 1554, 1553, 1555, 1556, 1503, 1557, 1558,
     7   1559, 1560, 1561, 1562, 1563, 1564, 1565, 1566, 1567, 1568,
     8   1569, 1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577, 1578,
     9   1579, 1580, 1581, 1582, 1583, 1584, 1585, 1586, 1587, 1588/
            data (jb1(i),i= 1601, 1700)/
     +   1452, 1503, 1591, 1592, 1593, 1594, 1595, 1596, 1597, 1598,
     1   1599, 1600, 1601, 1602, 1603, 1604, 1605, 1606, 1607, 1608,
     2   1609, 1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618,
     3   1619, 1620, 1621, 1622, 1623, 1624, 1625, 1626, 1627, 1628,
     4   1629, 1630, 1631, 1632, 1633, 1634, 1635,   17, 1637, 1637,
     5   1638, 1589, 1639, 1640, 1641, 1642, 1643, 1644, 1645, 1646,
     6   1647, 1648, 1649, 1650, 1651, 1652, 1653, 1654, 1655, 1656,
     7   1657, 1658, 1659, 1660, 1661, 1662, 1306, 1590, 1590, 1637,
     8   1665, 1666, 1667, 1553, 1437, 1520, 1589, 1670, 1671, 1672,
     9   1673, 1674, 1675, 1676, 1677, 1678, 1679, 1680, 1681, 1682/
            data (jb1(i),i= 1701, 1800)/
     +   1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691, 1636,
     1     24, 1665, 1693, 1694, 1695, 1696, 1697, 1698, 1699, 1700,
     2   1701, 1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709, 1636,
     3   1693, 1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719,
     4   1720, 1520, 1722, 1723, 1724, 1725, 1726, 1727, 1728, 1729,
     5   1730, 1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739,
     6   1740, 1741, 1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749,
     7   1750, 1751, 1752, 1753, 1754, 1755, 1756, 1757, 1758, 1759,
     8   1760, 1761, 1762, 1763, 1764, 1765, 1766, 1767, 1768, 1769,
     9   1770, 1771, 1772, 1773, 1774, 1775, 1670, 1777, 1778, 1437/
            data (jb1(i),i= 1801, 1900)/
     +   1780, 1781, 1782, 1783, 1784, 1785, 1786, 1787, 1788, 1789,
     1   1790, 1791, 1792, 1793, 1794, 1795, 1796, 1664, 1665, 1798,
     2   1799, 1777, 1780, 1800, 1802, 1755, 1803, 1804, 1805, 1806,
     3   1807, 1808, 1809, 1810, 1811, 1812, 1813, 1814, 1815, 1816,
     4   1817, 1818, 1819, 1820, 1821, 1822, 1823, 1824, 1825, 1826,
     5   1827, 1828, 1829, 1830, 1831, 1832, 1833, 1834, 1722, 1800,
     6   1722, 1837, 1838, 1839, 1840, 1841, 1842, 1843, 1844, 1845,
     7   1846, 1847, 1848, 1755, 1850, 1777, 1850, 1852, 1853, 1854,
     8   1855, 1856, 1857, 1858, 1859, 1861, 1862, 1863, 1864, 1865,
     9   1866, 1867, 1868, 1869, 1870, 1780, 1861, 1872, 1873, 1874/
            data (jb1(i),i= 1901, 2000)/
     +   1875, 1876, 1877, 1878, 1860, 1880, 1881, 1693, 1883, 1884,
     1   1885, 1886, 1887, 1888, 1889, 1890, 1891, 1861, 1893, 1894,
     2   1895, 1896, 1897, 1898, 1899, 1900, 1901, 1902, 1903, 1904,
     3   1905, 1906, 1907, 1908, 1909, 1910, 1911, 1912, 1913, 1914,
     4   1883, 1850, 1916, 1917, 1918, 1919, 1920, 1921, 1922, 1923,
     5   1924, 1925, 1926, 1927, 1928, 1929, 1930,   27, 1932, 1933,
     6   1934, 1935, 1936, 1893, 1879, 1938, 1939, 1940, 1941, 1942,
     7   1943, 1944, 1945, 1946, 1947,  137, 1949, 1950, 1951, 1952,
     8   1953, 1954, 1955, 1956, 1957, 1958, 1959, 1883,  138, 1961,
     9   1962, 1963, 1964, 1965, 1966, 1967, 1893, 1969, 1835, 1969/
            data (jb1(i),i= 2001, 2100)/
     +   1971, 1802, 1973, 1972, 1948, 1975, 1976, 1977, 1978, 1979,
     1   1980, 1981, 1931, 1969, 1835, 1972,  136, 1971,  140, 1986,
     2   1987, 1988, 1989, 1990, 1991, 1872,  141, 1993, 1994, 1931,
     3   1860, 1984, 1984, 1997, 1998, 1999, 2000, 2001, 1983, 1996,
     4    159, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
     5   2011, 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020,
     6   2021, 2022, 2023, 2024, 2025, 2026, 2027, 2028, 2029, 2030,
     7   2031, 2032, 2033, 1983,    1,    2,    3,    1,    5,    6,
     8      5,    8,    9,   10,   11,   12,    8,   14,   15,   14,
     9     17,   18,   19,   20,   21,   17,   23,   24,   23,   26/
            data (jb1(i),i= 2101, 2200)/
     +     27,   28,   26,   30,   31,   32,   30,   34,   35,   36,
     1     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     2     47,   48,   49,   34,   51,   52,   53,   54,   55,   56,
     3     57,   58,   51,   60,   61,   62,   63,   64,   65,   66,
     4     67,   68,   69,   70,   71,   72,   73,   60,   75,   76,
     5     77,   78,   79,   80,   81,   82,   75,   84,   85,   86,
     6     84,   88,   89,   90,   91,   92,   93,   94,   95,   96,
     7     97,   98,   99,  100,  101,  102,  103,  104,  105,  106,
     8    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     9    117,  118,  119,  120,   88,  122,  123,  124,  122,  126/
            data (jb1(i),i= 2201, 2300)/
     +    127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
     1    137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
     2    147,  148,  149,  150,  151,  152,  153,  154,  155,  156,
     3    157,  158,  126,  160,  161,  162,  163,  164,  165,  166,
     4    167,  168,  169,  170,  171,  172,  173,  174,  175,  176,
     5    177,  178,  160,  180,  181,  182,  180,  184,  185,  186,
     6    184,  188,  189,  188,  191,  192,  193,  194,  195,  196,
     7    197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
     8    207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
     9    217,  218,  219,  220,  221,  222,  223,  224,  225,  226/
            data (jb1(i),i= 2301, 2400)/
     +    227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
     1    237,  238,  239,  240,  241,  242,  243,  244,  245,  246,
     2    247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
     3    257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
     4    267,  268,  269,  270,  191,  272,  273,  274,  272,  276,
     5    277,  278,  279,  280,  281,  282,  283,  276,  285,  286,
     6    287,  288,  285,  290,  291,  292,  293,  294,  295,  296,
     7    297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
     8    307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
     9    317,  318,  319,  320,  321,  322,  323,  324,  325,  326/
            data (jb1(i),i= 2401, 2500)/
     +    327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
     1    337,  290,  339,  340,  341,  342,  343,  344,  345,  346,
     2    347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
     3    357,  339,  359,  360,  361,  362,  363,  364,  365,  366,
     4    367,  368,  369,  370,  371,  359,  373,  374,  375,  376,
     5    377,  378,  379,  380,  373,  382,  383,  384,  385,  386,
     6    387,  388,  389,  390,  382,  392,  393,  394,  395,  396,
     7    397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
     8    407,  408,  409,  410,  411,  412,  413,  414,  415,  416,
     9    417,  418,  419,  420,  421,  422,  423,  424,  425,  426/
            data (jb1(i),i= 2501, 2600)/
     +    427,  428,  429,  430,  431,  432,  433,  434,  435,  436,
     1    437,  438,  439,  440,  441,  442,  443,  444,  445,  446,
     2    447,  448,  392,  450,  451,  452,  453,  454,  455,  456,
     3    457,  458,  459,  450,  461,  462,  463,  464,  465,  466,
     4    467,  468,  469,  470,  471,  472,  473,  474,  475,  476,
     5    477,  478,  479,  480,  481,  482,  483,  484,  485,  486,
     6    487,  488,  489,  490,  491,  492,  493,  494,  495,  496,
     7    497,  498,  499,  500,  501,  502,  503,  504,  505,  506,
     8    507,  508,  509,  510,  461,  512,  513,  514,  515,  516,
     9    517,  512,  519,  520,  521,  522,  523,  524,  525,  526/
            data (jb1(i),i= 2601, 2690)/
     +    527,  528,  529,  530,  519,  532,  533,  534,  535,  536,
     1    537,  538,  539,  532,  541,  542,  543,  544,  545,  546,
     2    547,  548,  549,  550,  551,  552,  541,  554,  555,  556,
     3    554,  558,  559,  560,  558,  562,  563,  564,  565,  562,
     4    567,  568,  569,  567,  571,  572,  573,  574,  571,  576,
     5    577,  578,  579,  580,  576,  582,  583,  582,  585,  586,
     6    585,  588,  589,  590,  591,  592,  593,  594,  588,  596,
     7    597,  596,  599,  600,  601,  602,  603,  604,  605,  606,
     8    607,  608,  609,  610,  611,  599,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     28,   29,   30,   31,   32,   33,   34,   35,   36,   37,
     1     38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
     2     48,   49,   50,   51,   52,   53,   54,   55,   56,   57,
     3     58,   59,   60,   61,   62,   63,   64,   65,   66,   67,
     4     68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
     5     78,   79,   80,   81,   82,   83,   84,   85,   86,   87,
     6     88,   89,   90,   91,   92,   93,   94,   95,   96,   97,
     7     98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
     8    108,  109,  110,  111,  112,  113,  114,  115,  116,  117,
     9    118,  119,  120,  121,  122,  123,  124,  125,  126,  127/
            data (jb2(i),i=  101,  200)/
     +    128,  129,  130,  131,  132,  133,  134,  135,  136,  142,
     1    142,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     2    153,  154,  155,  156,  156,  160,  160,    3,    2,  161,
     3    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     4    171,  172,  173,  174,  175,  176,  177,  178,  179,  180,
     5    181,  182,  183,  184,  185,  186,  187,  188,  189,  190,
     6    191,  192,  193,  194,  195,  196,  197,  198,  199,  200,
     7    201,  202,  202,  203,  204,  205,  206,  207,  208,  209,
     8    210,  211,  212,  213,  214,  215,  216,  217,  218,  219,
     9    220,  221,  222,  223,  224,  225,  226,  227,  228,  229/
            data (jb2(i),i=  201,  300)/
     +    230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
     1    240,  241,  242,  243,  244,  245,  246,  247,  248,  249,
     2    250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
     3    260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
     4    270,  271,  272,  273,  273,    8,  274,  274,  275,  276,
     5    277,  278,  279,  280,  281,  282,  283,  284,  285,  286,
     6    287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
     7    297,  298,  299,  300,  301,  302,  303,  304,  305,  306,
     8    307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
     9    317,  318,  319,  320,  321,  322,  323,  324,  325,  326/
            data (jb2(i),i=  301,  400)/
     +    327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
     1    337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
     2    347,  348,  349,  350,  351,  352,  353,  354,  355,  356,
     3    357,  358,  359,  360,  361,  362,  363,  364,  365,  366,
     4    367,  368,  369,  370,  371,  371,  372,  373,  374,  375,
     5    376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
     6    386,  387,  388,  389,  390,  390,  391,  392,  393,  394,
     7    395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
     8    405,  406,  407,  408,  409,  410,  411,  412,  413,  414,
     9    415,  416,  417,  418,  419,  420,  421,  422,  423,  424/
            data (jb2(i),i=  401,  500)/
     +    425,  426,  427,  427,  428,  429,  430,  431,  432,  433,
     1    434,  435,  436,  437,  438,  439,  440,  441,  442,  443,
     2    444,  445,  446,  447,  448,  449,  450,  451,  451,  452,
     3    453,  454,  455,  456,  457,  458,  459,  460,  461,  462,
     4    463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
     5    473,  474,  475,  476,  477,  478,  479,  480,  481,  482,
     6    483,  484,  485,  486,  487,  488,  489,  490,  491,  492,
     7    493,  494,  495,  496,  497,  498,  499,  500,  501,  502,
     8    503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
     9    513,  514,  515,  516,  517,  518,  519,  520,  521,  522/
            data (jb2(i),i=  501,  600)/
     +    523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
     1    533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
     2    543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
     3    553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
     4    563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
     5    573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
     6    583,  584,  585,  586,  587,  588,  589,  590,  591,  592,
     7    593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
     8    603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
     9    613,  614,  615,  616,  617,  618,  619,  620,  621,  622/
            data (jb2(i),i=  601,  700)/
     +    623,  624,  625,  626,  627,  628,  629,  630,  631,  632,
     1    633,  634,  635,  636,  637,  638,  639,  639,  640,  641,
     2    642,  643,  644,  645,  646,  647,  648,  649,  650,  651,
     3    652,  653,  654,  654,  655,  656,  657,  658,  659,  660,
     4    661,  662,  663,  664,  665,  666,  667,  668,  669,  670,
     5    671,  672,  673,  674,  675,  676,  676,   21,  677,  677,
     6    678,  679,  680,  681,  682,  683,  684,  685,  686,  687,
     7    688,  689,  690,  691,  692,  693,  694,  695,  696,  697,
     8    698,  699,  700,  701,  702,  703,  704,  705,  706,  707,
     9    708,  709,  710,  711,  711,  712,  713,  714,  715,  716/
            data (jb2(i),i=  701,  800)/
     +    717,  718,  719,  720,  721,  722,  723,  724,  725,  726,
     1    727,  728,  729,  730,  731,  732,  733,  734,  735,  736,
     2    737,  738,  739,  739,  740,  741,  742,  743,  744,  745,
     3    746,  747,  748,  749,  750,  751,  752,  753,  754,  755,
     4    756,  757,  758,  759,  760,  761,  762,  763,  764,  765,
     5    766,  767,  767,  768,  769,  770,  771,  772,  773,  774,
     6    775,  776,  777,  778,  779,  780,  781,  782,  783,  784,
     7    785,  786,  787,  788,  789,  790,  791,  792,  793,  794,
     8    795,  796,  797,  798,  799,  800,  801,  802,  803,  804,
     9    805,  806,  807,  808,  809,  810,  811,  812,  813,  814/
            data (jb2(i),i=  801,  900)/
     +    815,  816,  817,  818,  819,  820,  821,  822,  823,  824,
     1    825,  826,  827,  828,  829,  830,  831,  832,  833,  834,
     2    835,  836,  837,  838,  839,  839,  840,  841,  842,  843,
     3    844,  845,  846,  847,  848,  849,  850,  851,  852,  853,
     4    854,  855,  856,  857,  858,  859,  860,  861,  862,  863,
     5    864,  865,  866,  867,  868,  869,  870,  871,  872,  873,
     6    874,  875,  876,  877,  878,  879,  880,  881,  882,  883,
     7    884,  884,  885,  886,  887,  888,  889,  890,  891,  892,
     8    893,  894,  895,  896,  897,  898,  899,  900,  901,  902,
     9    903,  904,  905,  906,  907,  908,  909,  910,  911,  912/
            data (jb2(i),i=  901, 1000)/
     +    913,  914,  915,  916,  917,  918,  919,  920,  921,  922,
     1    923,  924,  925,  926,  927,  928,  928,  929,  930,  931,
     2    932,  933,  934,  935,  936,  937,  938,  939,  940,  941,
     3    942,  943,  944,  945,  946,  947,  948,  949,  950,  951,
     4    952,  953,  954,  955,  956,  957,  958,  959,  960,  961,
     5    962,  963,  964,  965,  966,  967,  968,  969,  970,  971,
     6    972,  973,  974,  975,  976,  977,  978,  979,  980,  981,
     7    981,  982,  983,  984,  985,  986,  987,  988,  989,  990,
     8    991,  992,  993,  994,  995,  996,  997,  998,  999, 1000,
     9   1001, 1002, 1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010/
            data (jb2(i),i= 1001, 1100)/
     +   1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020,
     1   1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030,
     2   1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040,
     3   1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050,
     4   1051, 1052, 1053, 1054, 1054,   27, 1055, 1056, 1057, 1058,
     5   1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1066, 1067,
     6   1068, 1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1077,
     7   1078, 1079, 1080, 1081, 1082, 1083, 1083,  138,  140, 1084,
     8   1085, 1086, 1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094,
     9   1095, 1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104/
            data (jb2(i),i= 1101, 1200)/
     +   1105, 1105, 1106, 1107, 1108, 1109, 1110, 1111, 1112, 1113,
     1   1114, 1115, 1116, 1117, 1117, 1118, 1119, 1120, 1121, 1122,
     2   1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131, 1132,
     3   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141,
     4   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151,
     5   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     6   1162, 1163, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170,
     7   1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180,
     8   1181, 1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190,
     9   1191, 1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200/
            data (jb2(i),i= 1201, 1300)/
     +   1201, 1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210,
     1   1211, 1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220,
     2   1221, 1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230,
     3   1231, 1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240,
     4   1241, 1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250,
     5   1251, 1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260,
     6   1261, 1262, 1263, 1264,    5, 1266, 1267, 1268, 1269, 1270,
     7   1271, 1272, 1273, 1274, 1275, 1276, 1276, 1277, 1278, 1279,
     8   1280, 1281, 1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289,
     9   1290, 1291, 1292, 1293, 1294, 1295, 1296, 1297, 1298, 1299/
            data (jb2(i),i= 1301, 1400)/
     +   1300, 1301, 1302, 1303, 1304, 1305, 1307, 1308, 1309, 1310,
     1   1311, 1312, 1313, 1314, 1315, 1316, 1317, 1318, 1319, 1320,
     2   1321, 1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330,
     3   1331, 1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340,
     4   1341, 1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1349,
     5      6,    8,   10,   11, 1350, 1351, 1352, 1353, 1354, 1355,
     6   1356, 1357, 1358, 1359, 1360, 1361, 1362, 1363, 1364, 1365,
     7   1366, 1367, 1368, 1369, 1370, 1371, 1372, 1373, 1374, 1375,
     8   1376, 1377, 1378, 1379, 1380, 1381, 1382, 1383, 1384, 1385,
     9   1386, 1387, 1388, 1389, 1390, 1391, 1392, 1392, 1394, 1395/
            data (jb2(i),i= 1401, 1500)/
     +   1396, 1397, 1398, 1399, 1400, 1401, 1402, 1403, 1404, 1405,
     1   1406, 1407, 1408, 1409, 1410, 1411, 1412, 1413, 1414, 1415,
     2   1416, 1417, 1418, 1419, 1420, 1421, 1422, 1423, 1424, 1425,
     3   1426, 1427, 1428, 1429, 1430, 1431, 1432, 1432, 1433, 1434,
     4   1435, 1436,   13, 1437, 1439, 1440, 1441, 1442, 1443, 1444,
     5   1445, 1446, 1447, 1448, 1449, 1450, 1451, 1451, 1453, 1454,
     6   1455, 1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463, 1464,
     7   1465, 1466, 1467, 1468, 1468, 1469, 1470, 1471, 1472, 1473,
     8   1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482, 1482,
     9   1483, 1484, 1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492/
            data (jb2(i),i= 1501, 1600)/
     +   1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1501,
     1   1502,   14, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511,
     2   1512, 1513, 1514, 1515, 1516, 1517, 1517, 1519, 1519, 1521,
     3   1522, 1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530, 1531,
     4   1532, 1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541,
     5   1542, 1543, 1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551,
     6   1552, 1552, 1554,   15, 1555, 1556,   16, 1557, 1558, 1559,
     7   1560, 1561, 1562, 1563, 1564, 1565, 1566, 1567, 1568, 1569,
     8   1570, 1571, 1572, 1573, 1574, 1575, 1576, 1577, 1578, 1579,
     9   1580, 1581, 1582, 1583, 1584, 1585, 1586, 1587, 1588, 1589/
            data (jb2(i),i= 1601, 1700)/
     +   1590, 1591, 1592, 1593, 1594, 1595, 1596, 1597, 1598, 1599,
     1   1600, 1601, 1602, 1603, 1604, 1605, 1606, 1607, 1608, 1609,
     2   1610, 1611, 1612, 1613, 1614, 1615, 1616, 1617, 1618, 1619,
     3   1620, 1621, 1622, 1623, 1624, 1625, 1626, 1627, 1628, 1629,
     4   1630, 1631, 1632, 1633, 1634, 1635, 1636,   18,   19, 1638,
     5     20, 1639, 1640, 1641, 1642, 1643, 1644, 1645, 1646, 1647,
     6   1648, 1649, 1650, 1651, 1652, 1653, 1654, 1655, 1656, 1657,
     7   1658, 1659, 1660, 1661, 1662, 1663, 1663,   21, 1664,   22,
     8   1666, 1667, 1668, 1668, 1664, 1669, 1669, 1671, 1672, 1673,
     9   1674, 1675, 1676, 1677, 1678, 1679, 1680, 1681, 1682, 1683/
            data (jb2(i),i= 1701, 1800)/
     +   1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691,   23, 1670,
     1   1692, 1692, 1694, 1695, 1696, 1697, 1698, 1699, 1700, 1701,
     2   1702, 1703, 1704, 1705, 1706, 1707, 1708, 1709, 1710, 1710,
     3   1711, 1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719, 1720,
     4   1721, 1721, 1723, 1724, 1725, 1726, 1727, 1728, 1729, 1730,
     5   1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740,
     6   1741, 1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749, 1750,
     7   1751, 1752, 1753, 1754,   25, 1756, 1757, 1758, 1759, 1760,
     8   1761, 1762, 1763, 1764, 1765, 1766, 1767, 1768, 1769, 1770,
     9   1771, 1772, 1773, 1774, 1775, 1776, 1776, 1778, 1779, 1779/
            data (jb2(i),i= 1801, 1900)/
     +   1781, 1782, 1783, 1784, 1785, 1786, 1787, 1788, 1789, 1790,
     1   1791, 1792, 1793, 1794, 1795, 1796, 1797, 1797, 1798, 1799,
     2   1800, 1801, 1801, 1802,   26, 1803, 1804, 1805, 1806, 1807,
     3   1808, 1809, 1810, 1811, 1812, 1813, 1814, 1815, 1816, 1817,
     4   1818, 1819, 1820, 1821, 1822, 1823, 1824, 1825, 1826, 1827,
     5   1828, 1829, 1830, 1831, 1832, 1833, 1834, 1835, 1836, 1836,
     6   1837, 1838, 1839, 1840, 1841, 1842, 1843, 1844, 1845, 1846,
     7   1847, 1848, 1849, 1849, 1851, 1851, 1852, 1853, 1854, 1855,
     8   1856, 1857, 1858, 1859, 1860, 1862, 1863, 1864, 1865, 1866,
     9   1867, 1868, 1869, 1870, 1871, 1871, 1872, 1873, 1874, 1875/
            data (jb2(i),i= 1901, 2000)/
     +   1876, 1877, 1878, 1879, 1880, 1881, 1882, 1882, 1884, 1885,
     1   1886, 1887, 1888, 1889, 1890, 1891, 1892, 1892, 1894, 1895,
     2   1896, 1897, 1898, 1899, 1900, 1901, 1902, 1903, 1904, 1905,
     3   1906, 1907, 1908, 1909, 1910, 1911, 1912, 1913, 1914, 1915,
     4   1915, 1916, 1917, 1918, 1919, 1920, 1921, 1922, 1923, 1924,
     5   1925, 1926, 1927, 1928, 1929, 1930, 1931, 1932, 1933, 1934,
     6   1935, 1936, 1937, 1937, 1938, 1939, 1940, 1941, 1942, 1943,
     7   1944, 1945, 1946, 1947, 1948, 1949, 1950, 1951, 1952, 1953,
     8   1954, 1955, 1956, 1957, 1958, 1959, 1960, 1960, 1961, 1962,
     9   1963, 1964, 1965, 1966, 1967, 1968, 1968, 1970, 1970, 1971/
            data (jb2(i),i= 2001, 2100)/
     +   1972, 1973, 1974, 1974, 1975, 1976, 1977, 1978, 1979, 1980,
     1   1981, 1982, 1982, 1983, 1984, 1985, 1985,  139, 1986, 1987,
     2   1988, 1989, 1990, 1991, 1992, 1992, 1993, 1994, 1995, 1995,
     3   1996, 1996, 1997, 1998, 1999, 2000, 2001,  157,  158,  143,
     4   2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011,
     5   2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021,
     6   2022, 2023, 2024, 2025, 2026, 2027, 2028, 2029, 2030, 2031,
     7   2032, 2033, 2034, 2034,    2,    3,    4,    4,    6,    7,
     8      7,    9,   10,   11,   12,   13,   13,   15,   16,   16,
     9     18,   19,   20,   21,   22,   22,   24,   25,   25,   27/
            data (jb2(i),i= 2101, 2200)/
     +     28,   29,   29,   31,   32,   33,   33,   35,   36,   37,
     1     38,   39,   40,   41,   42,   43,   44,   45,   46,   47,
     2     48,   49,   50,   50,   52,   53,   54,   55,   56,   57,
     3     58,   59,   59,   61,   62,   63,   64,   65,   66,   67,
     4     68,   69,   70,   71,   72,   73,   74,   74,   76,   77,
     5     78,   79,   80,   81,   82,   83,   83,   85,   86,   87,
     6     87,   89,   90,   91,   92,   93,   94,   95,   96,   97,
     7     98,   99,  100,  101,  102,  103,  104,  105,  106,  107,
     8    108,  109,  110,  111,  112,  113,  114,  115,  116,  117,
     9    118,  119,  120,  121,  121,  123,  124,  125,  125,  127/
            data (jb2(i),i= 2201, 2300)/
     +    128,  129,  130,  131,  132,  133,  134,  135,  136,  137,
     1    138,  139,  140,  141,  142,  143,  144,  145,  146,  147,
     2    148,  149,  150,  151,  152,  153,  154,  155,  156,  157,
     3    158,  159,  159,  161,  162,  163,  164,  165,  166,  167,
     4    168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
     5    178,  179,  179,  181,  182,  183,  183,  185,  186,  187,
     6    187,  189,  190,  190,  192,  193,  194,  195,  196,  197,
     7    198,  199,  200,  201,  202,  203,  204,  205,  206,  207,
     8    208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
     9    218,  219,  220,  221,  222,  223,  224,  225,  226,  227/
            data (jb2(i),i= 2301, 2400)/
     +    228,  229,  230,  231,  232,  233,  234,  235,  236,  237,
     1    238,  239,  240,  241,  242,  243,  244,  245,  246,  247,
     2    248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
     3    258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
     4    268,  269,  270,  271,  271,  273,  274,  275,  275,  277,
     5    278,  279,  280,  281,  282,  283,  284,  284,  286,  287,
     6    288,  289,  289,  291,  292,  293,  294,  295,  296,  297,
     7    298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
     8    308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
     9    318,  319,  320,  321,  322,  323,  324,  325,  326,  327/
            data (jb2(i),i= 2401, 2500)/
     +    328,  329,  330,  331,  332,  333,  334,  335,  336,  337,
     1    338,  338,  340,  341,  342,  343,  344,  345,  346,  347,
     2    348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
     3    358,  358,  360,  361,  362,  363,  364,  365,  366,  367,
     4    368,  369,  370,  371,  372,  372,  374,  375,  376,  377,
     5    378,  379,  380,  381,  381,  383,  384,  385,  386,  387,
     6    388,  389,  390,  391,  391,  393,  394,  395,  396,  397,
     7    398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
     8    408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     9    418,  419,  420,  421,  422,  423,  424,  425,  426,  427/
            data (jb2(i),i= 2501, 2600)/
     +    428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
     1    438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
     2    448,  449,  449,  451,  452,  453,  454,  455,  456,  457,
     3    458,  459,  460,  460,  462,  463,  464,  465,  466,  467,
     4    468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
     5    478,  479,  480,  481,  482,  483,  484,  485,  486,  487,
     6    488,  489,  490,  491,  492,  493,  494,  495,  496,  497,
     7    498,  499,  500,  501,  502,  503,  504,  505,  506,  507,
     8    508,  509,  510,  511,  511,  513,  514,  515,  516,  517,
     9    518,  518,  520,  521,  522,  523,  524,  525,  526,  527/
            data (jb2(i),i= 2601, 2690)/
     +    528,  529,  530,  531,  531,  533,  534,  535,  536,  537,
     1    538,  539,  540,  540,  542,  543,  544,  545,  546,  547,
     2    548,  549,  550,  551,  552,  553,  553,  555,  556,  557,
     3    557,  559,  560,  561,  561,  563,  564,  565,  566,  566,
     4    568,  569,  570,  570,  572,  573,  574,  575,  575,  577,
     5    578,  579,  580,  581,  581,  583,  584,  584,  586,  587,
     6    587,  589,  590,  591,  592,  593,  594,  595,  595,  597,
     7    598,  598,  600,  601,  602,  603,  604,  605,  606,  607,
     8    608,  609,  610,  611,  612,  612,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine wv(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1800) :: jx,jy
            integer(kind=iknd), save, dimension(1860) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'west virginia '/
            data jrot,ipart/0,1/
            data kv/   1,1801,   0,   0,   0/
            data kb/   1,1855,   0,   0,   0/
            data iib/ 615,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  26208,27288,27312,25704,25200,27312,27360,24240,28272,47616,
     1  48840,23112,34800,51960,50040,21456,52032,54024,18912,45720,
     2  39720,37632,47400,15144,42000,13488,36192,10416, 7488,33096,
     3   8232,29544,24048,13152,18912,26376,26376,26544,26304,26232,
     4  26064,25872,25848,26256,26496,26712,26976,27264,26232,26424,
     5  26400,26496,26496,26328,26328,25992,25824,25488,25464,25176,
     6  25224,25128,25152,24912,25008,24984,24912,24672,24528,24504,
     7  24672,24672,24312,24312,23928,23880,23928,24288,24240,23952,
     8  23904,23784,23688,23328,47688,47712,47784,47712,47784,47928,
     9  47976,47928,48120,48072,47784,47736,47880,48216,48336,48312/
            data (jx(i),i=  101,  200)/
     +  48024,47952,47976,48216,48408,48528,48552,48456,48552,48720,
     1  48720,49584,49680,49992,49920,50208,50424,51192,51576,47496,
     2  47304,47160,46680,46440,46392,46296,46080,53808,53952,53976,
     3  53880,53808,53616,53592,53376,53424,53784,53880,53928,53880,
     4  53400,53352,53400,53304,53016,52824,52776,52872,52872,52776,
     5  52680,52560,52416,52176,21768,54264,54432,54600,54576,54288,
     6  54504,54288,54432,54264,54360,54696,54768,54936,54792,54864,
     7  54744,54840,55128,54984,54648,54648,54480,54192,54120,39912,
     8  39912,40296,40464,40608,40680,40800,40776,40872,40992,41016,
     9  41136,41160,41328,41280,41376,41328,41448,41400,41544,41736/
            data (jx(i),i=  201,  300)/
     +  41808,41880,41952,42072,42240,42552,42840,42816,42984,43008,
     1  43104,43224,43320,43344,43464,43440,43608,43656,43824,43896,
     2  44184,44208,44064,44208,44352,44328,44376,44496,44616,44664,
     3  44568,44544,44688,44856,45000,44928,44688,44592,44688,44880,
     4  44952,45072,45528,21288,20976,20808,20568,20448,20112,19872,
     5  19128,37608,39528,39432,39336,39144,39024,39024,38952,38712,
     6  38568,38280,38232,37992,37848,37776,47568,47832,47976,48144,
     7  48408,48192,48168,48072,48384,48360,48216,48240,48744,48984,
     8  48720,48888,48744,48840,18792,18672,18456,18288,18096,17952,
     9  17688,17208,17112,16944,16536,16128,15816,15696,15720,15432/
            data (jx(i),i=  301,  400)/
     +  15120,15216,15216,14904,14568,14520,14616,14976,15000,14808,
     1  15000,15000,14928,14784,14520,14376,14208,14160,14064,13728,
     2  46776,46968,46512,46248,46032,45816,45408,45360,45384,45312,
     3  45120,44928,44736,44520,43920,42624,42504,42360,42312,42048,
     4  13320,13608,13272,13176,12864,12696,12600,12432,12264,12144,
     5  11736,11376,11208,11184,11232,11184,10992,10608,10440,10416,
     6  10632,10776,10680,10872,10824,10704,41736,41688,41760,41688,
     7  41568,41424,41280,41112,41016,40608,40584,40392,40296,40224,
     8  39888,39888,39624,39504,37896,37704,37272, 9936, 9672, 9456,
     9   9288, 8856, 8424,36000,36024,35952,35928,36000,35832,35688/
            data (jx(i),i=  401,  500)/
     +  35664,35760,35736,35376,35352,35376,35280,35088,35016,34920,
     1  34584,34584,34776,34776,34560,34512,34224,33936,33504,33504,
     2  33264,33288,33408, 7224, 6936, 6696, 6576, 6528, 6768, 6696,
     3   6744, 6648, 6432, 6384, 6384, 6528, 6384, 6288, 6072, 6048,
     4   6072, 6240, 6288, 6456, 6576, 6600, 6936, 7080, 7272, 7248,
     5   7536, 7584, 7800, 7776, 7608, 7704, 7488, 7536, 7392, 7608,
     6   7536, 7680, 7680, 7776, 8208, 8232, 8328, 8184, 8256,32952,
     7  32712,31920,31320,31032,30864,30864,30720,30432,30408,30504,
     8  30336,30120,30048,30144,29832,29496,30480,30096,29448,29568,
     9  29352,29640,29760,29880,29712,29520,29112,28992,28536,28176/
            data (jx(i),i=  501,  600)/
     +  27888,27744,27744,27672,27552,27096,25944,25320,24912,24792,
     1  24624,24240, 8400, 8400, 8568, 8664, 9000, 9048, 9168, 9192,
     2   9096, 9312, 9096, 9216, 9312, 9432, 9384, 9432, 9384, 9432,
     3   9504, 9600, 9840,10056,10176,10248,10320,10536,10560,10512,
     4  10560,10656,10704,10632,10776,10728,10872,10872,11064,11160,
     5  11160,10968,11112,11352,11424,11640,11784,11976,12000,12096,
     6  12240,12312,12408,12504,12744,12792,12744,12984,13008,13128,
     7  19392,20256,20952,21336,22704,22824,22992,23616,24120,23784,
     8  23976,23952,18816,18552,18384,18312,18048,17640,17520,17400,
     9  16872,15648,15216,15024,14952,14832,14448,14208,13920,13872/
            data (jx(i),i=  601,  700)/
     +  13776,13752,13632,13464,13128,13056,13176,13056,13056,12552,
     1  12456,12528,12768,12912,12912,26688,26592,28536,28584,28488,
     2  28464,28560,28440,28416,28344,48408,27600,27624,27792,27840,
     3  27672,27672,27552,27720,27744,27864,28032,28032,28176,28080,
     4  28368,28464,28632,28824,29040,30936,31200,31368,31416,32040,
     5  32064,32040,32112,32328,32304,32376,32520,32832,33120,23688,
     6  24096,24072,24288,24336,24480,24504,24648,24744,24744,25128,
     7  25224,25320,25368,25392,25656,25800,25848,26064,26352,33552,
     8  33480,34560,34584,34800,27096,27360,27384,27552,26544,26592,
     9  26712,26784,26904,51648,51360,51336,51000,50856,50544,50328/
            data (jx(i),i=  701,  800)/
     +  50232,50184,29784,30528,31272,31392,31632,32256,32400,22488,
     1  22320,22008,22056,21744,21600,21552,33552,52104,52056,52104,
     2  52128,52464,52440,52584,52536,52656,52680,52656,52728,52680,
     3  52896,52848,53016,53688,53808,26256,26184,25968,25944,25800,
     4  25704,25632,25584,25416,25248,24288,23688,23664,23736,23760,
     5  23520,23424,23352,23208,23136,23160,22992,22704,22608,33456,
     6  33432,33384,33264,33144,33024,32952,32928,33024,33024,33168,
     7  33192,33120,33216,33096,33216,33168,33000,33120,33072,33168,
     8  32976,32904,32808,32664,32280,31032,30864,20184,20256,20304,
     9  20424,20664,20688,20856,21168,21264,21480,21744,22032,22224/
            data (jx(i),i=  801,  900)/
     +  22248,22320,18984,19104,19176,19296,19368,19320,19392,19968,
     1  19992,34464,35664,37416,37632,45456,45288,45096,45000,44808,
     2  44664,44496,44400,44136,44016,43944,43800,43632,43248,43104,
     3  42864,42600,40080,41112,30456,30528,30528,30648,33792,33888,
     4  34008,34008,34176,34416,37848,38088,38280,38400,38592,38664,
     5  38784,38880,38904,39216,39432,39576,39360,39384,39288,39216,
     6  39240,38976,39360,39504,39528,39456,39360,39408,39408,39312,
     7  39216,39072,20040,19920,19824,19656,19584,19632,34344,34368,
     8  34248,34296,34272,34176,34296,26616,26640,26784,26904,27000,
     9  26976,27024,27072,27264,27216,27288,27240,27120,27000,26928/
            data (jx(i),i=  901, 1000)/
     +  26880,26928,27048,27072,27024,26640,26760,26760,26544,26520,
     1  26640,26736,26736,26880,26904,27192,27072,27144,27144,27048,
     2  27144,43440,45120,45528,45720,45888,46080,46248,46440,46800,
     3  30264,30288,24456,23424,26808,27216,27840,27984,29544,30168,
     4  30048,25296,26256,25992,25920,25776,25656,25536,34536,34560,
     5  34656,34632,34824,34776,34800,34704,37536,37872,38616,38784,
     6  38976,20976,20808,20640,20448,20352,20328,20208,20088,20088,
     7  19872,19992,19968,19824,19848,19728,19584,19272,19488,19440,
     8  19440,19560,18600,18384,17040,16800,22248,22512,22656,22752,
     9  22752,22872,22968,23496,23616,23616,23736,23880,23952,24048/
            data (jx(i),i= 1001, 1100)/
     +  24024,24240,24264,24456,21096,21432,21480,21648,21984,22224,
     1  39072,34248,34032,33960,33624,31704,30432,30552,30864,31272,
     2  31848,31944,31968,32088,31992,32040,32016,31848,31920,31704,
     3  39456,41256,17304,17232,17328,17112,17232,17424,17400,17496,
     4  17568,19848,19896,19800,19800,25392,26496,39000,38760,38472,
     5  38232,38088,37992,38112,37752,37392,37464,37440,37248,37344,
     6  37320,37512,37560,37272,37032,36912,36600,36672,36408,36360,
     7  17664,17904,18072,18456,19152,19512,41736,41712,41856,42072,
     8  41688,41736,41640,41760,41712,41856,41856,42000,41952,42120,
     9  42120,42192,42120,42480,42432,28008,28056,28152,28128,28008/
            data (jx(i),i= 1101, 1200)/
     +  27936,27792,27744,27840,27288,27192,27120,27000,26736,26592,
     1  28656,28464,28704,28728,28872,28920,29136,29160,29112,29376,
     2  29208,29400,28536,28512,28392,28152,26160,26016,25968,25872,
     3  25800,22728,22272,22440,22536,22488,22536,22464,22536,22440,
     4  22248,22248,22008,22152,22272,22344,22368,22440,22584,29784,
     5  30216,31296,31608,31512,31680,31608,29640,29424,29256,29256,
     6  29136,29064,28920,13560,14688,14448,14832,22272,15096,15600,
     7  27504,26064,17496,17304,17376,17232,17112,17352,21744,21744,
     8  21528,21312,21216,21000,21000,20904,20952,20832,20880,20832,
     9  20856,20616,20544,20472,20496,20352,20328,20400,20328,20400/
            data (jx(i),i= 1201, 1300)/
     +  20352,20424,20400,20304,20208,20112,20208,20136,20208,20160,
     1  20016,20088,19992,19992,19896,19872,36408,36288,36456,36384,
     2  36240,16248,16800,20640,21264,30168,30768,17544,17832,17952,
     3  19272,19560,19848,20448,23784,24696,24768,24792,24960,25104,
     4  25200,25248,25320,25344,25440,22824,22800,22872,22872,23112,
     5  23280,23424,23472,23664,13008,11928,12000,36264,36336,36264,
     6  36168,36024,35856,35832,35640,35568,35496,35304,35232,35184,
     7  35304,35088,35064,34824,34680,34512,34200,34176,34056,34032,
     8  32352,31440,12072,29328,29112,29040,25800,26184,25968,26328,
     9  26424,28248,13368,13536,15312,15240,15168,15024,15096,15048/
            data (jx(i),i= 1301, 1400)/
     +  15168,15288,12120,12024,12216,12360,12360,12576,12624,12720,
     1  20232,23496,24408,24336,19752, 9864, 9960,10032,10080,10032,
     2  10080,10416,10416,10368,10512,10512,10704,10776,10824,11088,
     3  11328,11544,11760,11904, 9648, 9408, 9384, 9456, 9528, 9744,
     4   9696, 9600, 9648, 9528, 9504, 9408, 9312, 9192, 9192, 9072,
     5  23784,23808,23736,23736,23688,23592,23472,23496,23376,23184,
     6  23064,23112,23040,22896,22896,22800,22704,22512,22488,22416,
     7  22344,22224,22272,22248,22128,21960,22032,21864,21888,21864,
     8  21720,21480,21216,21024,20856,20688,20688,20616,20352,20352,
     9  13536,13632,14040,14184,14400,14544,14544,14472,14520,14448/
            data (jx(i),i= 1401, 1500)/
     +  14544,14400,14520,14304,14352,14184,14208,27696,25488,28992,
     1  30024,30456,30600,30648,30984,31608,14112,13992,13680,13608,
     2  13608,13512,13584,13536,13248,13176,13176,13080,12984,13032,
     3  12768,12792,12984,13320,13464,13200,14304,14496,14400,14400,
     4  14640,14688,14808,14952,15024,15144,15312,15264,15360,15552,
     5  15648,16080,16104,16032,16104,16056,16152,16104,16224,16320,
     6  16488,16464,16656,16848,17040,17112,17064,17184,17352,17376,
     7  17184,17136,17328,17352,17496,17664,17688,17784,17784,17928,
     8  17856,18024,18000,12960,12576,12144,12024,10560,18744,19296,
     9  19440,18000,18168,18240,18336,18432, 9408, 9840, 9696, 9768/
            data (jx(i),i= 1501, 1600)/
     +   9696, 9768, 9672, 9624, 9864, 9792, 9888,10104,10080,10176,
     1  10176,10416,10440,10368,10560,10416,10464,10032,18984,19056,
     2  19272,19320,19584,19536,19608,19560,19584,21888,21840,21576,
     3  21696,22008,22104,21984,22032,22296,22920,23160,23760,23664,
     4  23928,24264,24336,24600,24456,24456,24312,24312,24360,24600,
     5  24648,24768,24768,24912,24504,25128,24552, 8376, 8496, 8448,
     6  17760,17664,17520,17472,17424,17304,17112,16968,16824,16920,
     7  16920,16992,16872,16896,16992,17208,17328,17256,17376,16416,
     8  16296,16200,16032,15912,15816,15720,15312,15144,15168,15024,
     9  15024,14760,14760,14688,14880,14904,14664,14472,14328,14304/
            data (jx(i),i= 1601, 1700)/
     +  13800,13512,13344,13440,13344,13104,12984,12720,12672,17208,
     1  16800,16680,16680,25080,25944,25992,27552,27912,28200,28704,
     2  28752,28728,28800,28848,28848,28896,28992,29064,29136,29160,
     3  29256,29208,29280,23352,23400,23664,23616,23376,23352,23640,
     4  23736,23832,23832,23616,23592,23472,23328,23112,22776,22752,
     5  22848,21960,21912,21648,16104,15936,15792,15576,15408,15048,
     6  14880,14832,15456,15312,15048,14976,14760,14664,14640,14472,
     7  14424,10512,10656,10584,10728,10848,11208,11256,11160,11232,
     8  11304,10992,11112,11088,11400,11376,11424,11352,11280,11376,
     9  11424,11544,11496,11592,11520,11568,11616,11856,11856,12000/
            data (jx(i),i= 1701, 1800)/
     +  12024,12096,12192,12216,12360,12480,12528,12624,12840,12912,
     1  13008,13080,13224,13320,13320,13440,13656,13776,13944,14112,
     2  14160,14280,14400,14448,14280,14280,14208,14064,14088,13896,
     3  13872,13728,13584,13512,13344,13272,20352,20088,19872,19464,
     4  19416,19416,18384,18144,17928,17640,17592,21144,20784,20640,
     5  20544,20592,20448,25920,24648,19488,19224,18792,18696,18576,
     6  18360,18264,18192,18024,18000,17928,17736,17520,17256,17136,
     7  16920,16656,16608,16512,16344,16272,16128,15960,15936,15648,
     8  15576,15624,15480,15408,15120,14856,14784,14496,14448,14256,
     9  14136,14160,14064,14040,19968,19800,19488,19584,19680,19608/
            data (jy(i),i=    1,  100)/
     +  53016,53088,50040,50352,48408,48216,44400,44376,44424,42144,
     1  41520,42912,44496,43632,40608,41136,39072,42072,39528,42360,
     2  39552,37944,36648,36384,32328,33696,30072,30048,27792,23304,
     3  20616,18432,15144,16248,13944,53160,53520,54024,54456,54816,
     4  55104,55296,55464,55896,55968,55824,56016,56112,52944,52752,
     5  52464,52176,52008,51624,51384,51096,50496,49944,49296,48960,
     6  48624,48144,47616,47304,46920,46800,46776,46896,46872,46728,
     7  46416,46296,45984,45432,45048,44952,44784,44280,44184,43968,
     8  43464,43128,43056,43056,42264,42384,42432,42600,42600,42432,
     9  42504,42624,42552,42672,42840,43056,43080,42936,43008,43128/
            data (jy(i),i=  101,  200)/
     +  43320,43416,43512,43488,43344,43344,43392,43584,43608,43584,
     1  43752,43488,43752,44064,44232,44304,44520,44328,44088,42192,
     2  42144,42240,42144,42264,42384,42336,42384,42144,42336,42504,
     3  42528,42360,42312,42600,42840,42888,42960,43056,43200,43440,
     4  43608,43584,43416,43368,43440,43632,43608,43488,43272,43200,
     5  43464,43464,43344,43368,41592,42000,42120,42120,42048,41880,
     6  41664,41640,41448,41376,41280,41232,41160,40728,40656,40344,
     7  40104,40008,39912,39792,39024,38808,38544,37488,37440,39672,
     8  39888,40008,40344,40320,40440,40320,40512,40728,40536,40704,
     9  40752,40872,40896,41040,41160,41280,41328,41472,41424,41520/
            data (jy(i),i=  201,  300)/
     +  41424,41520,41520,41352,41352,41112,41040,41328,41424,41592,
     1  41664,41664,41808,41976,42024,42096,42120,42312,42480,42648,
     2  42648,42744,42936,43200,43248,43464,43584,43632,43752,43728,
     3  43608,43440,43392,43464,43344,43248,43248,43176,42960,42888,
     4  42960,42696,42432,40872,40800,40704,40440,40128,40152,40080,
     5  39600,44520,39168,39168,39240,39192,39120,39000,38928,38808,
     6  38664,38328,38184,38016,38016,37896,36864,36960,37104,37440,
     7  37704,37872,38016,38088,38592,38736,38808,38880,39600,40032,
     8  40152,40512,40776,40992,39576,39696,40272,40392,40416,40320,
     9  39984,39720,39600,38616,38736,38760,38640,38448,38064,37968/
            data (jy(i),i=  301,  400)/
     +  37536,36984,36576,36240,36288,36192,35856,35472,35184,34752,
     1  34416,34296,34224,34248,34488,34536,34368,34032,33864,33600,
     2  35928,35760,35064,35280,35016,34584,34248,34248,34560,34608,
     3  34488,34224,34080,33696,32400,33504,33144,33024,32760,32688,
     4  33936,34344,35112,35184,35160,35496,35568,35616,35544,35160,
     5  34896,34128,33960,33792,33480,33216,33000,32808,32640,32376,
     6  32184,31584,31200,30408,30264,30120,31776,31512,31320,31008,
     7  30960,31008,30816,30456,30048,29304,28920,28656,28584,28392,
     8  28104,27960,27864,27840,28368,28848,29568,30120,29904,28680,
     9  28224,28080,28104,29784,29688,29568,29256,29064,29016,28776/
            data (jy(i),i=  401,  500)/
     +  28512,28344,28008,27432,27264,27120,27024,27048,27000,26784,
     1  26448,26376,26088,25896,25800,25680,25536,25200,24816,24432,
     2  24120,23928,23832,27696,27672,27768,27888,27048,26664,26280,
     3  25848,25704,25656,25584,25464,25272,24792,24720,24720,24648,
     4  24336,24288,24120,24072,23904,23712,23448,22968,22656,22560,
     5  22512,22344,22296,22224,22152,21984,21840,21744,21648,21600,
     6  21480,21408,21288,21432,21048,20904,20832,20760,20688,22920,
     7  22416,21696,21024,20856,20544,20400,20328,19920,19800,19632,
     8  19584,19320,19128,18936,18552,18408,17688,17280,16896,16632,
     9  16512,16416,16560,16488,16176,16056,15888,15720,15480,15192/
            data (jy(i),i=  501,  600)/
     +  15120,15288,15528,15744,15792,15648,14904,14568,14400,14640,
     1  14712,15072,20352,20112,20184,19992,19800,19656,19632,19608,
     2  19512,19488,19224,19104,18816,18720,18624,18504,18384,18408,
     3  18288,18384,18144,18168,18072,17784,17712,17736,17808,17976,
     4  18024,18024,17784,17664,17640,17496,17496,17280,17328,17160,
     5  17040,16968,16776,16872,16776,16800,16584,16488,16680,16584,
     6  16584,16512,16632,16584,16680,16632,16560,16488,16272,16320,
     7  13392,12648,13032,13152,13512,13392,13392,13680,14112,14544,
     8  14880,15000,13776,13632,13200,13128,13104,12840,12912,12624,
     9  12312,12264,12696,12744,13008,13176,13296,13224,13344,13560/
            data (jy(i),i=  601,  700)/
     +  13608,13752,13896,13920,14304,14520,14904,15048,15264,15528,
     1  15768,15864,15984,15984,16080,53088,50232,43320,43464,43584,
     2  43728,43872,44088,44328,44280,41664,41160,41328,41376,41616,
     3  41832,42024,42312,42648,42792,42840,42840,43008,43080,43248,
     4  43392,43248,43248,43272,43032,43008,42672,42600,42456,41904,
     5  41832,41784,41712,41688,41568,41472,41472,41160,41016,42576,
     6  42864,42696,42552,42240,42360,42264,42264,42168,42024,41760,
     7  41472,41448,41376,41232,41208,41280,41112,41160,40944,40800,
     8  41400,43224,43680,44184,40680,40752,41040,41064,40824,40920,
     9  40944,40728,40800,43344,43272,43104,43224,43200,42240,41352/
            data (jy(i),i=  701,  800)/
     +  41232,40872,40704,40224,40344,40464,40128,40368,40608,39648,
     1  41136,41232,41112,41112,40992,41112,39072,39144,39240,39264,
     2  39360,39768,39864,40080,40152,40128,40152,40272,40320,40392,
     3  40464,40560,40584,41304,41496,40848,40872,40800,40728,40656,
     4  40680,40632,40704,40656,40224,39576,38952,39336,39456,39720,
     5  40008,40008,40080,40128,39936,39840,39528,39624,39528,39072,
     6  38928,39000,38952,39048,38832,38832,38712,38664,38544,38448,
     7  38376,38352,38208,38136,37992,38016,37920,38040,38160,38232,
     8  38640,38664,38520,38568,38400,38208,38304,38616,38616,38928,
     9  39096,39072,39168,39072,39192,39144,39288,39384,39312,39528/
            data (jy(i),i=  801,  900)/
     +  39648,39600,39336,39384,39264,39312,39288,39144,39000,38976,
     1  38784,38208,38736,38064,37800,41928,41784,41400,41376,41160,
     2  41160,40848,40488,40032,39960,39744,39648,39672,39192,38928,
     3  38760,38472,39456,39384,40032,39984,38640,38592,39024,38904,
     4  38712,38424,38328,38304,37608,37776,37800,37728,37776,37944,
     5  37968,37872,37992,38064,37992,37800,37584,37464,37440,37320,
     6  37032,36480,36312,36312,36240,35904,35808,35712,35568,35472,
     7  35088,34872,38616,38496,38136,37992,37680,37536,38040,37872,
     8  37704,37608,37320,36912,36720,37320,37512,37416,37464,37536,
     9  37608,37632,37560,37704,37728,37848,37872,37944,37920,37992/
            data (jy(i),i=  901, 1000)/
     +  38136,38160,38088,38184,38256,38568,38712,38808,38832,38904,
     1  39072,39120,39216,39264,39384,39792,39888,39960,40104,40368,
     2  40440,37968,37392,37368,37272,37104,37128,37032,37320,37200,
     3  37368,36624,36552,38688,37296,37080,37056,36984,36504,36648,
     4  36480,36384,36960,36984,36840,36720,36432,36336,36648,36552,
     5  36528,36456,36240,36120,35904,35736,34944,35040,34968,34800,
     6  34776,35568,35688,35664,35736,35664,35568,35664,35640,35880,
     7  35928,36048,36528,36552,36648,36864,36840,37032,37224,37248,
     8  37344,37392,36936,36936,35784,35520,35208,35280,35424,35424,
     9  35496,35496,35640,35808,35904,35976,36000,36120,36072,36168/
            data (jy(i),i= 1001, 1100)/
     +  36240,36240,36312,36456,35664,35736,35592,35400,35280,35304,
     1  34800,36552,36432,36240,34920,34560,36432,36456,36336,35688,
     2  35688,35640,35496,35352,35256,35136,34920,34824,34704,34608,
     3  34392,32976,35256,35064,34920,34728,34488,34344,34248,34224,
     4  34128,34368,34272,34224,34104,35280,33984,34584,34320,34296,
     5  34440,34416,34344,34032,33888,33912,33672,33552,33264,33216,
     6  32952,32760,32616,32088,31848,31584,31224,31008,31056,30960,
     7  34248,34272,34440,34176,33864,34032,33720,34008,34152,34464,
     8  35376,35712,35952,36240,36312,36384,36528,36648,36720,36912,
     9  37080,37200,37320,37920,37992,31872,32112,32280,32352,32328/
            data (jy(i),i= 1101, 1200)/
     +  32568,32568,32616,33048,33456,33336,33336,33504,33408,33864,
     1  31728,32232,33600,33744,33768,33960,34248,34368,34464,34656,
     2  35136,35400,31728,31656,31752,31728,33720,33768,33672,33840,
     3  33816,31584,35016,34848,34680,34632,34320,34152,33216,32904,
     4  32808,32712,32520,32232,32136,32184,32088,32112,31992,31320,
     5  31968,31992,33216,33888,34200,34344,31224,31200,31536,31632,
     6  31656,31752,31800,33504,31824,31584,31152,30936,31200,30456,
     7  30696,29136,33984,33912,32880,31560,30984,30264,30240,30360,
     8  30576,30480,30576,30648,30840,30864,31008,31104,31296,31680,
     9  31800,32232,32256,32376,32424,32472,32568,32616,32712,32856/
            data (jy(i),i= 1201, 1300)/
     +  32952,32952,33168,33288,33240,33336,33432,33480,33600,33696,
     1  33792,33864,33936,34032,34008,34080,30888,30624,30408,30312,
     2  30240,29520,29832,29136,29640,27384,29112,29808,29424,29448,
     3  29304,29256,29088,29208,28848,29520,29544,29424,29352,29112,
     4  29112,29208,29184,29256,29256,30384,30240,30192,30000,29976,
     5  29832,29616,29328,29256,30864,30240,28536,30960,31224,31248,
     6  31176,31344,31224,30984,31032,31224,31248,31152,31200,31272,
     7  31608,31752,31896,31944,31728,31176,30456,30216,30024,29568,
     8  28320,28512,27264,26736,26856,25320,28848,27840,27672,26928,
     9  27072,25848,26616,27552,28416,28872,28920,29208,29496,29904/
            data (jy(i),i= 1301, 1400)/
     +  30120,30072,26736,26160,26040,26040,25944,25896,26016,26040,
     1  25776,27696,28512,28704,28440,25416,25728,25704,25776,25848,
     2  25944,26184,26352,26472,26448,26568,26784,26832,26784,26880,
     3  26880,27144,27168,27288,25464,25800,25968,26256,26256,26376,
     4  26496,26496,26616,26616,26712,26760,26664,26664,26544,26424,
     5  23736,23832,23928,24144,24144,24000,24120,24240,24240,24384,
     6  24600,24888,24984,25008,25128,25200,25248,25248,25032,25008,
     7  25152,25248,25440,25512,25296,25272,25152,25152,24936,24936,
     8  25056,25176,25440,25320,25392,25392,25488,25608,25704,25776,
     9  26592,26496,26472,26592,26496,26040,25944,25896,25776,25752/
            data (jy(i),i= 1401, 1500)/
     +  25656,25488,25272,25392,25272,25320,25152,25296,23424,23880,
     1  23040,23016,22920,23016,22920,23160,25152,24768,24768,24720,
     2  24552,24432,24288,24288,24432,24408,24264,24192,24048,23832,
     3  23472,23136,22968,22920,22848,22824,24888,24744,24912,25104,
     4  25152,25392,25392,25296,25032,24984,25128,25248,25320,25368,
     5  25248,25272,25128,25056,24888,24816,24768,24696,24648,24720,
     6  24696,24624,24336,24216,24216,24168,23952,23976,23880,23760,
     7  23640,23400,23328,23232,23184,23280,23208,23160,23064,22824,
     8  22632,22464,22248,22752,22800,22656,22656,22176,22008,24816,
     9  24792,22128,22008,22056,22008,22104,21816,25200,25104,24936/
            data (jy(i),i= 1501, 1600)/
     +  24720,24648,24552,24312,24192,24000,23832,23760,23496,23472,
     1  23400,23352,23256,23184,23112,22848,22800,22536,22056,22128,
     2  21984,21792,21696,21552,21168,21096,21000,20832,20664,20616,
     3  20520,20616,20568,20424,20328,20256,20328,20136,23496,23424,
     4  23184,23112,23256,23256,23136,23016,22968,22872,22800,22752,
     5  22632,22536,22296,22224,21744,20688,20736,20760,20568,20520,
     6  22272,22176,22248,22320,22296,22128,22032,21840,21504,21384,
     7  21192,21096,20784,20448,20232,20232,20136,19896,19776,19752,
     8  19920,19920,20232,20304,20256,20280,20016,20112,20208,20256,
     9  20424,20616,20688,20784,20976,21216,21624,21648,21792,21768/
            data (jy(i),i= 1601, 1700)/
     +  21840,21840,21936,21984,22152,22176,22128,22248,22368,19752,
     1  19416,19488,19608,20352,19392,18960,18504,18528,18432,18792,
     2  18768,18672,18696,18648,18504,18456,18504,18480,18600,18768,
     3  18696,18552,18456,20016,19800,19560,19392,19176,19104,18912,
     4  18600,18504,18384,18264,18456,18624,18624,18792,18768,18672,
     5  18528,17832,17424,17184,19608,19632,19560,19560,19416,19440,
     6  19368,19296,18624,18624,18408,18432,18312,18336,18264,18240,
     7  18048,22032,21888,21840,21672,21336,21168,21000,20928,20688,
     8  20640,20424,20280,20088,19920,19800,19536,19512,19296,19296,
     9  19200,19176,19080,19032,18960,18936,18672,18744,18672,18696/
            data (jy(i),i= 1701, 1800)/
     +  18600,18576,18408,18240,18192,17904,18096,18216,18240,18312,
     1  18288,18384,18408,18384,18288,18144,18240,18384,18192,18264,
     2  18168,18096,18120,17568,17496,17352,17328,17064,16944,16872,
     3  16680,16560,16584,16464,16464,16296,16152,16392,16416,16632,
     4  16824,17160,19056,19296,19680,19656,19728,17256,17040,17040,
     5  16824,16536,16176,18576,16368,15048,15192,15312,15504,15576,
     6  15480,15528,15408,15552,15744,15840,15840,15720,15744,15864,
     7  15936,15912,15960,15912,16320,16344,16224,16272,16344,16296,
     8  16248,16104,16104,16008,15984,16176,16104,16104,16200,16176,
     9  16272,16488,16560,16680,15984,15648,15432,15288,15000,14928/
            data (jb1(i),i=    1,  100)/
     +      1,   36,   37,   38,   39,   40,   41,   42,   43,   44,
     1     45,   46,   47,    2,    1,   49,   50,   51,   52,   53,
     2     54,   55,   56,    4,    2,    4,   58,   59,   60,    5,
     3      3,    9,    7,    6,    5,   62,   63,   64,   65,   66,
     4     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     5      8,    8,   78,   79,   80,   81,   82,   83,   12,   10,
     6     85,   86,   87,   88,   89,   90,   91,   92,   93,   94,
     7     95,   96,   97,   98,   99,  100,  101,  102,  103,  104,
     8    105,  106,  107,  108,  109,  110,  111,  112,  113,  114,
     9    115,  116,  117,  118,   14,   10,  120,  121,  122,  123/
            data (jb1(i),i=  101,  200)/
     +    124,  125,  126,   20,   18,  128,  129,  130,  131,  132,
     1    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     2    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     3    153,   14,   12,   16,   11,   18,  156,  157,  158,  159,
     4    160,  161,  162,  163,  164,  165,  166,  167,  168,  169,
     5    170,  171,  172,  173,  174,  175,  176,  177,  178,   17,
     6     21,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     7    189,  190,  191,  192,  193,  194,  195,  196,  197,  198,
     8    199,  200,  201,  202,  203,  204,  205,  206,  207,  208,
     9    209,  210,  211,  212,  213,  214,  215,  216,  217,  218/
            data (jb1(i),i=  201,  300)/
     +    219,  220,  221,  222,  223,  224,  225,  226,  227,  228,
     1    229,  230,  231,  232,  233,  234,  235,  236,  237,  238,
     2    239,  240,  241,  242,   20,   16,  244,  245,  246,  247,
     3    248,  249,  250,   19,   15,   22,   13,   21,  253,  254,
     4    255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
     5    265,   22,   23,  267,  268,  269,  270,  271,  272,  273,
     6    274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
     7     11,   19,  285,  286,  287,  288,  289,  290,  291,  292,
     8    293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
     9     24,   24,  304,  305,  306,  307,  308,  309,  310,  311/
            data (jb1(i),i=  301,  400)/
     +    312,  313,  314,  315,  316,  317,  318,  319,   26,   23,
     1    321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
     2    331,  332,  333,  334,  335,  336,  337,  338,  339,   25,
     3     26,  341,  342,  343,  344,  345,  346,  347,  348,  349,
     4    350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
     5    360,  361,  362,  363,  364,  365,   28,   25,  367,  368,
     6    369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
     7    379,  380,  381,  382,  383,  384,  385,  386,   27,   28,
     8    388,  389,  390,  391,  392,   29,   27,  394,  395,  396,
     9    397,  398,  399,  400,  401,  402,  403,  404,  405,  406/
            data (jb1(i),i=  401,  500)/
     +    407,  408,  409,  410,  411,  412,  413,  414,  415,  416,
     1    417,  418,  419,  420,  421,  422,   30,   29,  424,  425,
     2    426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
     3    436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
     4    446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
     5    456,  457,  458,  459,  460,  461,  462,  463,  464,  465,
     6    466,  467,  468,   31,   30,  470,  471,  472,  473,  474,
     7    475,  476,  477,  478,  479,  480,  481,  482,  483,  484,
     8     32,   32,  486,  487,  488,  489,  490,  491,  492,  493,
     9    494,  495,  496,  497,  498,  499,  500,  501,  502,  503/
            data (jb1(i),i=  501,  600)/
     +    504,  505,  506,  507,  508,  509,  510,  511,   33,   31,
     1    513,  514,  515,  516,  517,  518,  519,  520,  521,  522,
     2    523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
     3    533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
     4    543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
     5    553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
     6    563,  564,  565,  566,  567,  568,  569,   34,   35,  571,
     7    572,  573,  574,  575,  576,  577,  578,  579,  580,  581,
     8     33,   35,  583,  584,  585,  586,  587,  588,  589,  590,
     9    591,  592,  593,  594,  595,  596,  597,  598,  599,  600/
            data (jb1(i),i=  601,  700)/
     +    601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
     1    611,  612,  613,  614,   34,    1,  616,    3,  617,    5,
     2      7,  618,  619,  620,  621,  622,  623,  624,  625,   10,
     3    626,  627,  628,  629,  630,  631,  632,  633,  634,  635,
     4    636,  637,  638,  639,  640,  641,  618,  618,  643,  644,
     5    645,  646,  647,  648,  649,  650,  651,  652,  653,  654,
     6    655,  656,  657,  658,   12,  660,  661,  662,  663,  664,
     7    665,  666,  667,  668,  669,  670,  671,  672,  673,  674,
     8    675,  676,  677,  678,  680,  681,  682,  683,  684,  659,
     9    685,  686,  687,  627,  679,  689,  690,  691,  692,  685/
            data (jb1(i),i=  701,  800)/
     +     14,  694,  695,  696,  697,  698,  699,  700,  701,  702,
     1    627,  703,  704,  705,  706,  707,  708,  659,  710,  711,
     2    712,  713,  714,  715,  716,  680,   17,  718,  719,  720,
     3    721,  722,  723,  724,  725,  726,  727,  728,  729,  730,
     4    731,  732,  733,  734,  735,  679,  736,  737,  738,  739,
     5    740,  741,  742,  743,  744,  745,  746,  747,  748,  749,
     6    750,  751,  752,  753,  754,  755,  756,  757,  758,  710,
     7    717,  760,  761,  762,  763,  764,  765,  766,  767,  768,
     8    769,  770,  771,  772,  773,  774,  775,  776,  777,  778,
     9    779,  780,  781,  782,  783,  784,  785,  786,  788,  789/
            data (jb1(i),i=  801,  900)/
     +    790,  791,  792,  793,  794,  795,  796,  797,  798,  799,
     1    800,  801,  710,   19,  803,  804,  805,  806,  807,  808,
     2    809,  810,  788,  812,  813,  814,   20,  816,  817,  818,
     3    819,  820,  821,  822,  823,  824,  825,  826,  827,  828,
     4    829,  830,  831,   21,  833,  832,  704,  835,  836,  837,
     5    787,  717,  839,  840,  841,  842,  843,  812,  815,  815,
     6    845,  846,  847,  848,  849,  850,  851,  852,  853,  854,
     7    855,  856,  857,  858,  859,  860,  861,  862,  863,  864,
     8    865,  866,  867,  868,  869,  870,  871,  788,  873,  874,
     9    875,  876,  877,  812,  879,  880,  881,  882,  883,  884/
            data (jb1(i),i=  901, 1000)/
     +    886,  887,  888,  889,  890,  891,  892,  893,  894,  895,
     1    896,  897,  898,  899,  900,  901,  902,  903,  904,  905,
     2    906,  907,  908,  909,  910,  911,  912,  913,  914,  915,
     3    916,  917,  918,  919,  920,  685,  832,  922,  923,  924,
     4    925,  926,  927,  928,  929,  930,  787,  931,  933,  747,
     5    886,  935,  936,  937,  938,  932,  940,  939,  933,  886,
     6    943,  944,  945,  946,  947,  942,  885,  949,  950,  951,
     7    952,  953,  954,  955,  956,  957,  958,  959,  960,  872,
     8    962,  963,  964,  965,  966,  967,  968,  969,  970,  971,
     9    972,  973,  974,  975,  976,  977,  978,  979,  980,  981/
            data (jb1(i),i= 1001, 1100)/
     +    878,  878,  983,  984,  985,  986,  987,  988,  989,  990,
     1    991,  992,  993,  994,  995,  996,  997,  998,  999, 1000,
     2   1001, 1002, 1003,  933,  962, 1005, 1006, 1007, 1008, 1009,
     3    987,  872,  885, 1012, 1013, 1014, 1015,  932, 1017, 1018,
     4   1019, 1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028,
     5   1029, 1016, 1011, 1031,  986, 1033, 1034, 1035, 1036, 1037,
     6   1038, 1039, 1040,  962, 1042, 1043, 1044,  942, 1046, 1011,
     7   1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057,
     8   1058, 1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067,
     9   1068, 1069, 1041, 1071, 1072, 1073, 1074, 1075, 1045, 1032/
            data (jb1(i),i= 1101, 1200)/
     +   1077, 1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086,
     1   1087, 1088, 1089, 1090, 1091, 1092, 1093, 1094,  832, 1032,
     2   1096, 1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105,
     3   1106, 1107, 1108, 1109, 1047, 1111, 1112, 1113, 1114, 1115,
     4   1116, 1117, 1118, 1119, 1120, 1121,  939, 1111, 1123, 1124,
     5   1125, 1096, 1047, 1127, 1128, 1129, 1130, 1131,  987, 1133,
     6   1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142, 1143,
     7   1144, 1145, 1146, 1147, 1148, 1132, 1150, 1151, 1152, 1153,
     8   1154, 1155, 1016, 1150, 1157, 1158, 1159, 1160, 1161, 1162,
     9   1111,   26, 1164, 1165, 1166, 1132, 1167, 1169, 1096, 1171/
            data (jb1(i),i= 1201, 1300)/
     +   1041, 1173, 1174, 1175, 1176, 1177, 1168, 1179, 1180, 1181,
     1   1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191,
     2   1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201,
     3   1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211,
     4   1212, 1213, 1214, 1215, 1045, 1070, 1217, 1218, 1219, 1220,
     5   1221, 1170, 1222, 1178, 1224, 1179, 1226, 1150, 1178, 1228,
     6   1229, 1230, 1231, 1232, 1233, 1224, 1235, 1236, 1237, 1238,
     7   1239, 1240, 1241, 1242, 1243, 1244, 1172, 1168, 1246, 1247,
     8   1248, 1249, 1250, 1251, 1252, 1253, 1235, 1167, 1255, 1256,
     9   1257, 1070, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265/
            data (jb1(i),i= 1301, 1400)/
     +   1266, 1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275,
     1   1276, 1277, 1278, 1279, 1280, 1281, 1226, 1257, 1226, 1284,
     2   1285, 1172, 1287, 1288, 1289, 1290, 1291, 1293, 1294, 1295,
     3   1296, 1297, 1298, 1299, 1300, 1301, 1170, 1283, 1303, 1304,
     4   1305, 1306, 1307, 1308, 1309, 1293, 1311, 1312, 1313, 1235,
     5   1224, 1311, 1316, 1317, 1318, 1319, 1320, 1321, 1322, 1323,
     6   1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333,
     7   1283, 1316, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342,
     8   1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1286, 1351,
     9   1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361/
            data (jb1(i),i= 1401, 1500)/
     +   1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371,
     1   1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381,
     2   1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1311, 1293,
     3   1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400,
     4   1401, 1402, 1403, 1404, 1405, 1406, 1292, 1408, 1351, 1286,
     5   1410, 1411, 1412, 1413, 1414, 1415, 1416, 1407, 1417, 1418,
     6   1419, 1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428,
     7   1429, 1430, 1431, 1432, 1433, 1434, 1435, 1407, 1437, 1438,
     8   1439, 1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447, 1448,
     9   1449, 1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458/
            data (jb1(i),i= 1501, 1600)/
     +   1459, 1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468,
     1   1469, 1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478,
     2   1479, 1480, 1481, 1482, 1436, 1484, 1485, 1486, 1487, 1489,
     3   1490, 1311, 1483, 1492, 1493, 1494, 1495, 1489, 1488, 1316,
     4   1498, 1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507,
     5   1508, 1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517,
     6   1497, 1489, 1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526,
     7   1527, 1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536,
     8   1537, 1351, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546,
     9   1547, 1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556/
            data (jb1(i),i= 1601, 1700)/
     +   1538, 1497, 1558, 1559, 1560, 1483, 1561, 1562, 1563, 1564,
     1   1565, 1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573, 1574,
     2   1575, 1576, 1577, 1578, 1580, 1581, 1582, 1583, 1584, 1585,
     3   1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, 1595,
     4   1596, 1597, 1598, 1599, 1600, 1601, 1602, 1603, 1604, 1605,
     5   1606, 1607, 1608, 1436, 1579, 1610, 1611, 1612, 1580, 1557,
     6   1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622, 1623,
     7   1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631, 1632, 1633,
     8   1538, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641, 1642,
     9   1643, 1644, 1645, 1646, 1647, 1648, 1649, 1650, 1651, 1652/
            data (jb1(i),i= 1701, 1800)/
     +   1653, 1580, 1655, 1656, 1657, 1658, 1659, 1660, 1661, 1662,
     1   1663, 1664, 1665, 1666, 1667, 1668, 1669, 1670, 1488, 1672,
     2   1673, 1674, 1675, 1676, 1677, 1678, 1679, 1680, 1681, 1682,
     3   1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691, 1692,
     4   1693, 1694, 1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702,
     5   1703, 1704, 1705, 1706, 1707, 1708, 1709, 1710, 1711, 1712,
     6   1713, 1714, 1715, 1716, 1717, 1718, 1719, 1720, 1721, 1722,
     7   1671, 1671, 1724, 1725, 1726, 1727, 1728, 1729, 1730, 1654,
     8   1731, 1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740,
     9   1741, 1742, 1743, 1744, 1745, 1746, 1579, 1654, 1748, 1749/
            data (jb1(i),i= 1801, 1860)/
     +   1750, 1751, 1752, 1737, 1616, 1754,   33, 1756, 1757, 1758,
     1   1759, 1760, 1761, 1762, 1763, 1764, 1765, 1766, 1767, 1768,
     2   1769, 1770, 1771, 1772, 1773, 1774, 1775, 1776, 1777, 1778,
     3   1779, 1780, 1781, 1782, 1783, 1784, 1785, 1786, 1787, 1788,
     4   1789, 1790, 1791, 1792, 1793, 1731, 1737, 1795, 1796, 1797,
     5   1798, 1799, 1756, 1756,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +     36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     1     46,   47,   48,   48,   49,   50,   51,   52,   53,   54,
     2     55,   56,   57,   57,    3,   58,   59,   60,   61,   61,
     3      6,   13,    9,    7,   62,   63,   64,   65,   66,   67,
     4     68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
     5     77,   78,   79,   80,   81,   82,   83,   84,   84,   85,
     6     86,   87,   88,   89,   90,   91,   92,   93,   94,   95,
     7     96,   97,   98,   99,  100,  101,  102,  103,  104,  105,
     8    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     9    116,  117,  118,  119,  119,  120,  121,  122,  123,  124/
            data (jb2(i),i=  101,  200)/
     +    125,  126,  127,  127,  128,  129,  130,  131,  132,  133,
     1    134,  135,  136,  137,  138,  139,  140,  141,  142,  143,
     2    144,  145,  146,  147,  148,  149,  150,  151,  152,  153,
     3    154,  154,  155,  155,   15,  156,  157,  158,  159,  160,
     4    161,  162,  163,  164,  165,  166,  167,  168,  169,  170,
     5    171,  172,  173,  174,  175,  176,  177,  178,  179,  179,
     6    180,  181,  182,  183,  184,  185,  186,  187,  188,  189,
     7    190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
     8    200,  201,  202,  203,  204,  205,  206,  207,  208,  209,
     9    210,  211,  212,  213,  214,  215,  216,  217,  218,  219/
            data (jb2(i),i=  201,  300)/
     +    220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
     1    230,  231,  232,  233,  234,  235,  236,  237,  238,  239,
     2    240,  241,  242,  243,  243,  244,  245,  246,  247,  248,
     3    249,  250,  251,  251,   17,  252,  252,  253,  254,  255,
     4    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     5    266,  266,  267,  268,  269,  270,  271,  272,  273,  274,
     6    275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
     7    284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
     8    294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
     9    303,  304,  305,  306,  307,  308,  309,  310,  311,  312/
            data (jb2(i),i=  301,  400)/
     +    313,  314,  315,  316,  317,  318,  319,  320,  320,  321,
     1    322,  323,  324,  325,  326,  327,  328,  329,  330,  331,
     2    332,  333,  334,  335,  336,  337,  338,  339,  340,  340,
     3    341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
     4    351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
     5    361,  362,  363,  364,  365,  366,  366,  367,  368,  369,
     6    370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
     7    380,  381,  382,  383,  384,  385,  386,  387,  387,  388,
     8    389,  390,  391,  392,  393,  393,  394,  395,  396,  397,
     9    398,  399,  400,  401,  402,  403,  404,  405,  406,  407/
            data (jb2(i),i=  401,  500)/
     +    408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
     1    418,  419,  420,  421,  422,  423,  423,  424,  425,  426,
     2    427,  428,  429,  430,  431,  432,  433,  434,  435,  436,
     3    437,  438,  439,  440,  441,  442,  443,  444,  445,  446,
     4    447,  448,  449,  450,  451,  452,  453,  454,  455,  456,
     5    457,  458,  459,  460,  461,  462,  463,  464,  465,  466,
     6    467,  468,  469,  469,  470,  471,  472,  473,  474,  475,
     7    476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
     8    485,  486,  487,  488,  489,  490,  491,  492,  493,  494,
     9    495,  496,  497,  498,  499,  500,  501,  502,  503,  504/
            data (jb2(i),i=  501,  600)/
     +    505,  506,  507,  508,  509,  510,  511,  512,  512,  513,
     1    514,  515,  516,  517,  518,  519,  520,  521,  522,  523,
     2    524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
     3    534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
     4    544,  545,  546,  547,  548,  549,  550,  551,  552,  553,
     5    554,  555,  556,  557,  558,  559,  560,  561,  562,  563,
     6    564,  565,  566,  567,  568,  569,  570,  570,  571,  572,
     7    573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
     8    582,  583,  584,  585,  586,  587,  588,  589,  590,  591,
     9    592,  593,  594,  595,  596,  597,  598,  599,  600,  601/
            data (jb2(i),i=  601,  700)/
     +    602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
     1    612,  613,  614,  615,  615,  616,    2,  617,    4,    6,
     2      8,  619,  620,  621,  622,  623,  624,  625,    9,  626,
     3     11,  628,  629,  630,  631,  632,  633,  634,  635,  636,
     4    637,  638,  639,  640,  641,  642,  642,  643,  644,  645,
     5    646,  647,  648,  649,  650,  651,  652,  653,  654,  655,
     6    656,  657,  658,  659,  660,  661,  662,  663,  664,  665,
     7    666,  667,  668,  669,  670,  671,  672,  673,  674,  675,
     8    676,  677,  678,  679,  681,  682,  683,  684,   13,  680,
     9    686,  687,  688,  688,  689,  690,  691,  692,  693,  693/
            data (jb2(i),i=  701,  800)/
     +    694,  695,  696,  697,  698,  699,  700,  701,  702,   15,
     1    703,  704,  705,  706,  707,  708,  709,  709,  711,  712,
     2    713,  714,  715,  716,   16,  717,  718,  719,  720,  721,
     3    722,  723,  724,  725,  726,  727,  728,  729,  730,  731,
     4    732,  733,  734,  735,   18,  736,  737,  738,  739,  740,
     5    741,  742,  743,  744,  745,  746,  747,  748,  749,  750,
     6    751,  752,  753,  754,  755,  756,  757,  758,  759,  759,
     7    760,  761,  762,  763,  764,  765,  766,  767,  768,  769,
     8    770,  771,  772,  773,  774,  775,  776,  777,  778,  779,
     9    780,  781,  782,  783,  784,  785,  786,  787,  789,  790/
            data (jb2(i),i=  801,  900)/
     +    791,  792,  793,  794,  795,  796,  797,  798,  799,  800,
     1    801,  802,  802,  803,  804,  805,  806,  807,  808,  809,
     2    810,  811,  811,  813,  814,  815,  816,  817,  818,  819,
     3    820,  821,  822,  823,  824,  825,  826,  827,  828,  829,
     4    830,  831,  832,  833,  834,  834,  835,  836,  837,  838,
     5    838,  839,  840,  841,  842,  843,  844,  844,   22,  845,
     6    846,  847,  848,  849,  850,  851,  852,  853,  854,  855,
     7    856,  857,  858,  859,  860,  861,  862,  863,  864,  865,
     8    866,  867,  868,  869,  870,  871,  872,  873,  874,  875,
     9    876,  877,  878,  879,  880,  881,  882,  883,  884,  885/
            data (jb2(i),i=  901, 1000)/
     +    887,  888,  889,  890,  891,  892,  893,  894,  895,  896,
     1    897,  898,  899,  900,  901,  902,  903,  904,  905,  906,
     2    907,  908,  909,  910,  911,  912,  913,  914,  915,  916,
     3    917,  918,  919,  920,  921,  921,  922,  923,  924,  925,
     4    926,  927,  928,  929,  930,   23,  931,  932,  934,  934,
     5    935,  936,  937,  938,  939,  940,  941,  941,  942,  943,
     6    944,  945,  946,  947,  948,  948,  949,  950,  951,  952,
     7    953,  954,  955,  956,  957,  958,  959,  960,  961,  961,
     8    963,  964,  965,  966,  967,  968,  969,  970,  971,  972,
     9    973,  974,  975,  976,  977,  978,  979,  980,  981,  982/
            data (jb2(i),i= 1001, 1100)/
     +    982,  983,  984,  985,  986,   24,  988,  989,  990,  991,
     1    992,  993,  994,  995,  996,  997,  998,  999, 1000, 1001,
     2   1002, 1003, 1004, 1004, 1005, 1006, 1007, 1008, 1009, 1010,
     3   1010, 1011, 1012, 1013, 1014, 1015, 1016, 1017, 1018, 1019,
     4   1020, 1021, 1022, 1023, 1024, 1025, 1026, 1027, 1028, 1029,
     5   1030, 1030, 1031, 1032, 1033, 1034, 1035, 1036, 1037, 1038,
     6   1039, 1040, 1041, 1042, 1043, 1044, 1045, 1046, 1047, 1048,
     7   1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056, 1057, 1058,
     8   1059, 1060, 1061, 1062, 1063, 1064, 1065, 1066, 1067, 1068,
     9   1069, 1070, 1071, 1072, 1073, 1074, 1075, 1076, 1076, 1077/
            data (jb2(i),i= 1101, 1200)/
     +   1078, 1079, 1080, 1081, 1082, 1083, 1084, 1085, 1086, 1087,
     1   1088, 1089, 1090, 1091, 1092, 1093, 1094, 1095, 1095,   25,
     2   1097, 1098, 1099, 1100, 1101, 1102, 1103, 1104, 1105, 1106,
     3   1107, 1108, 1109, 1110, 1110, 1112, 1113, 1114, 1115, 1116,
     4   1117, 1118, 1119, 1120, 1121, 1122, 1122, 1123, 1124, 1125,
     5   1126, 1126, 1127, 1128, 1129, 1130, 1131, 1132, 1133, 1134,
     6   1135, 1136, 1137, 1138, 1139, 1140, 1141, 1142, 1143, 1144,
     7   1145, 1146, 1147, 1148, 1149, 1149, 1151, 1152, 1153, 1154,
     8   1155, 1156, 1156, 1157, 1158, 1159, 1160, 1161, 1162, 1163,
     9   1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171, 1172/
            data (jb2(i),i= 1201, 1300)/
     +   1173, 1174, 1175, 1176, 1177, 1178, 1179, 1180, 1181, 1182,
     1   1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191, 1192,
     2   1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202,
     3   1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212,
     4   1213, 1214, 1215, 1216, 1216, 1217, 1218, 1219, 1220, 1221,
     5     27, 1222, 1223, 1223, 1225, 1225, 1227, 1227, 1228, 1229,
     6   1230, 1231, 1232, 1233, 1234, 1234, 1236, 1237, 1238, 1239,
     7   1240, 1241, 1242, 1243, 1244, 1245, 1245, 1246, 1247, 1248,
     8   1249, 1250, 1251, 1252, 1253, 1254, 1254, 1255, 1256, 1257,
     9     28, 1258, 1259, 1260, 1261, 1262, 1263, 1264, 1265, 1266/
            data (jb2(i),i= 1301, 1400)/
     +   1267, 1268, 1269, 1270, 1271, 1272, 1273, 1274, 1275, 1276,
     1   1277, 1278, 1279, 1280, 1281, 1282, 1282, 1283, 1284, 1285,
     2   1286, 1287, 1288, 1289, 1290, 1291, 1292, 1294, 1295, 1296,
     3   1297, 1298, 1299, 1300, 1301, 1302, 1302, 1303, 1304, 1305,
     4   1306, 1307, 1308, 1309, 1310, 1310, 1312, 1313, 1314, 1314,
     5   1315, 1315, 1317, 1318, 1319, 1320, 1321, 1322, 1323, 1324,
     6   1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332, 1333, 1334,
     7   1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342, 1343,
     8   1344, 1345, 1346, 1347, 1348, 1349, 1350,   29, 1292, 1352,
     9   1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362/
            data (jb2(i),i= 1401, 1500)/
     +   1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371, 1372,
     1   1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381, 1382,
     2   1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1390, 1391,
     3   1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400, 1401,
     4   1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409, 1409, 1410,
     5   1411, 1412, 1413, 1414, 1415, 1416,   30, 1417, 1418, 1419,
     6   1420, 1421, 1422, 1423, 1424, 1425, 1426, 1427, 1428, 1429,
     7   1430, 1431, 1432, 1433, 1434, 1435, 1436, 1437, 1438, 1439,
     8   1440, 1441, 1442, 1443, 1444, 1445, 1446, 1447, 1448, 1449,
     9   1450, 1451, 1452, 1453, 1454, 1455, 1456, 1457, 1458, 1459/
            data (jb2(i),i= 1501, 1600)/
     +   1460, 1461, 1462, 1463, 1464, 1465, 1466, 1467, 1468, 1469,
     1   1470, 1471, 1472, 1473, 1474, 1475, 1476, 1477, 1478, 1479,
     2   1480, 1481, 1482, 1483, 1484, 1485, 1486, 1487, 1488, 1490,
     3   1491, 1491, 1492, 1493, 1494, 1495, 1496, 1496, 1497, 1498,
     4   1499, 1500, 1501, 1502, 1503, 1504, 1505, 1506, 1507, 1508,
     5   1509, 1510, 1511, 1512, 1513, 1514, 1515, 1516, 1517, 1518,
     6   1518, 1519, 1520, 1521, 1522, 1523, 1524, 1525, 1526, 1527,
     7   1528, 1529, 1530, 1531, 1532, 1533, 1534, 1535, 1536, 1537,
     8   1538, 1539, 1540, 1541, 1542, 1543, 1544, 1545, 1546, 1547,
     9   1548, 1549, 1550, 1551, 1552, 1553, 1554, 1555, 1556, 1557/
            data (jb2(i),i= 1601, 1700)/
     +   1557, 1558, 1559, 1560,   31, 1561, 1562, 1563, 1564, 1565,
     1   1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573, 1574, 1575,
     2   1576, 1577, 1578, 1579, 1581, 1582, 1583, 1584, 1585, 1586,
     3   1587, 1588, 1589, 1590, 1591, 1592, 1593, 1594, 1595, 1596,
     4   1597, 1598, 1599, 1600, 1601, 1602, 1603, 1604, 1605, 1606,
     5   1607, 1608, 1609, 1609, 1610, 1611, 1612, 1613, 1613, 1614,
     6   1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622, 1623, 1624,
     7   1625, 1626, 1627, 1628, 1629, 1630, 1631, 1632, 1633,   32,
     8   1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641, 1642, 1643,
     9   1644, 1645, 1646, 1647, 1648, 1649, 1650, 1651, 1652, 1653/
            data (jb2(i),i= 1701, 1800)/
     +   1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661, 1662, 1663,
     1   1664, 1665, 1666, 1667, 1668, 1669, 1670, 1671, 1672, 1673,
     2   1674, 1675, 1676, 1677, 1678, 1679, 1680, 1681, 1682, 1683,
     3   1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691, 1692, 1693,
     4   1694, 1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702, 1703,
     5   1704, 1705, 1706, 1707, 1708, 1709, 1710, 1711, 1712, 1713,
     6   1714, 1715, 1716, 1717, 1718, 1719, 1720, 1721, 1722, 1723,
     7   1723, 1724, 1725, 1726, 1727, 1728, 1729, 1730, 1731,   33,
     8   1732, 1733, 1734, 1735, 1736,   34, 1738, 1739, 1740, 1741,
     9   1742, 1743, 1744, 1745, 1746, 1747, 1747, 1748, 1749, 1750/
            data (jb2(i),i= 1801, 1860)/
     +   1751, 1752, 1753, 1753, 1754, 1755, 1755, 1757, 1758, 1759,
     1   1760, 1761, 1762, 1763, 1764, 1765, 1766, 1767, 1768, 1769,
     2   1770, 1771, 1772, 1773, 1774, 1775, 1776, 1777, 1778, 1779,
     3   1780, 1781, 1782, 1783, 1784, 1785, 1786, 1787, 1788, 1789,
     4   1790, 1791, 1792, 1793, 1794, 1794, 1795, 1796, 1797, 1798,
     5   1799, 1800, 1800,   35,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine wi(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(1130) :: jx,jy
            integer(kind=iknd), save, dimension(1200) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'wisconsin     '/
            data jrot,ipart/0,2/
            data kv/   1, 845,1126,   0,   0/
            data kb/   1, 916,1197,   0,   0/
            data iib/ 521, 281,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  16632,16776,17328,17544,17712,17832,17736,17832,18216,18456,
     1  18888,19056,19272,19392,19464,19344,19272,19512,19584,19704,
     2  19776,19824,19800,19920,20088,20160,20352,20472,20592,20880,
     3  21096,21456,21600,21768,21864,22152,22200,22152,22296,22344,
     4  22440,22512,22560,22728,22824,22752,22632,22656,22560,22560,
     5  22440,22296,22224,22128,22032,21960,21816,21792,22080,21840,
     6  21624,21576,21336,21384,21576,24672,22968,22848,22776,22440,
     7  21960,21672,16416,16224,15912,15168,14712,14232,14160,14160,
     8  14040,13464,13008,12960,13272,13056,12360,12336,12240,12024,
     9  11928,11688,11568,11520,11688,11736,11520,11496,10992,10848/
            data (jx(i),i=  101,  200)/
     +  10896,29544,28032,28008,27696,27648,27504,27504,27264,27192,
     1  26784,26712,26424,26424,26256,26088,25824,25560,25392,25128,
     2  25032,37536,44688,39576, 6192,47664, 7224, 7176,48072,51024,
     3  46032,10848,49896,47904,12792,17136,48696,18240,19656,48432,
     4  20160,47856,20688,48648,49008,44904,40920,35928,31944,26952,
     5  36312,38208,38280,38544,38664,38760,38784,38856,38952,39144,
     6  39264,39240,39408,39720,39720,39984,40104,40176,40368,40488,
     7  40680,40872,41112,41304,41712,41904,42024,42312,42432,42552,
     8  42768,42984,43128,43344,43464,43608,44064,44304,44232,44256,
     9  44520,44064,44064,44352,10896,10704,10560,10488,10512,10416/
            data (jx(i),i=  201,  300)/
     +  10296,10008, 9864, 9720, 9504, 9312, 9096, 9000, 8856, 8856,
     1   7992, 7872, 7848, 7512, 7416, 7344, 7152, 7224, 7080, 6984,
     2   6720, 6360,45168,45288,45240,45456,46152,46344,46704,46728,
     3  46968,46920,46632,46608,47016,46992,46896,46656,46632,46848,
     4  46896,47088,46944,46872,46536,46488,46608,46344,46416,46464,
     5  46656,46800,47064,47400,47544,47664,47880,48192,48264,48168,
     6  47976,47856,47832,47736,47760,47640,47688,48144,48384,48744,
     7  48984,48936,48792,48696,48720,48672,48552,48624,48528,48480,
     8  48216, 6216, 6312, 6720, 7104, 7272, 7464, 7488, 7680, 7824,
     9   7992, 8112, 8088, 7704, 7680, 7608, 7200, 7272, 7224, 7272/
            data (jx(i),i=  301,  400)/
     +   7176, 7104, 7248, 7272, 7272, 7128, 7176, 7152, 6888, 6864,
     1   7344, 7320, 7176,51240,51384,51024,50760,50472,50352,50280,
     2  50328,50448,50424,50328,49944,49704,49776,49704,49560,49488,
     3  49392,49392,49320,49368,49440,49416,49200,48960,48144,48192,
     4  47208,47040,47016,47160,47112,47112,47040,46896,46608,46512,
     5  46344,46368,46248,46008,46032,45960, 7176, 7008, 6864, 6840,
     6   6888, 7416, 7680, 7968, 8352, 8376, 8832, 8952, 8976, 9168,
     7   9312, 9792,10224,10440,46032,45888,45960,45888,45888,45816,
     8  45936,46176,46176,46080,45912,45840,45864,45696,45624,45696,
     9  45840,45744,45864,45816,45888,46320,46584,46800,46800,46680/
            data (jx(i),i=  401,  500)/
     +  46848,47040,47112,47232,47496,47808,50880,50544,50328,50136,
     1  50064,10944,11040,11544,11760,13008,13200,13704,14064,14160,
     2  14064,14304,14400,14376,14592,14784,15024,15504,15768,15864,
     3  16200,16872,49944,50280,50232,49968,49440,49200,49200,48960,
     4  17472,17664,18024,18696,18816,19080,19248,19464,19608,19752,
     5  48672,48792,49080,49008,49008,49056,48912,48456,19560,19560,
     6  19656,19608,19920,19848,20064,19944,47664,47688,47808,47880,
     7  48312,48480,20232,20112,20160,20712,21072,21312,21408,20904,
     8  20688,20472,20520,47976,47832,48096,48192,47952,47880,48384,
     9  48480,48432,20688,20784,20808,20880,21168,21288,21384,21408/
            data (jx(i),i=  501,  600)/
     +  21528,21648,21792,21864,22512,22704,23016,24504,24696,24960,
     1  25176,25224,25152,48960,49272,49128,49152,48888,48960,49008,
     2  49104,26712,26640,25656,25632,24648,24528,21648,21648,21600,
     3  21672,21672,16752,16632,12792,29688,28776,13008,12960,12816,
     4  23736,21720,16944,16872,16848,16776,37608,36696,36744,28824,
     5  34728,34752,35736,35712,23832,41808,44736,39576,39648,39816,
     6  36984,42000,28944,12024, 9024, 9048,12024,33936,33888,40008,
     7  37968,38016,40080,40416,40464,29040,23928,21936,21960,17016,
     8  42984,43080,44064,44088,44664,44712,46152,46176,47664,16008,
     9  17016,12072,41736,41856,37752,37704,34128,29136,35808,35760/
            data (jx(i),i=  601,  700)/
     +  27888,27912,26976,22056,39840,39792,37800,22128,16224,16032,
     1  16152,12264,12240,12072,43800,43824,43968,44088,44088,36000,
     2  30936,27096,16248,12312,44016,44448,44664,43968,43896,43872,
     3  41064,41016,22200,20208,17256,16272,12312,27192,48096,22200,
     4  23208,23232,13320,13128,13032,12936,12912,45888,47160,47112,
     5  42936,40176,40008,38976,36216,33144,31008,31968,32112,30696,
     6  27288,27336,26304,22392,22296,22104,21912,21912,20448,20400,
     7  20304,20472,17328,17016,16728,16680,16752,16632,16680,17088,
     8  17136,17280,17232,17016,39120,36840,33264,43128,46152,19032,
     9  19032,18912,18912,19176,19392,19536,19656,19872,20064,20064/
            data (jx(i),i=  701,  800)/
     +  20304,45144,45120,39192,43152,27480,22536,26496,22416,39336,
     1  43344,43416,36360,36288,36336,36408,36480,36936,36912,36720,
     2  36648,36624,36888,38328,37320,37344,33408,31872,31848,31656,
     3  31512,31488,31368,31320,31200,30312,30216,30408,30408,30192,
     4  29904,29976,29808,29712,29736,29832,29808,30096,30144,30360,
     5  30480,30552,30528,30648,30720,30552,30672,30528,30744,27528,
     6  46392,45384,27552,24624,24576,38496,38448,38496,32544,35568,
     7  35568,31944,31920,32064,32448,32328,32376,32688,32808,33144,
     8  33336,33456,33528,33168,32856,32664,32520,32496,46440,46344,
     9  46512,43488,43368,43512,42456,38544,32640,32616,32280,31872/
            data (jx(i),i=  801,  900)/
     +  31632,28536,28680,28416,28080,27912,27768,27432,26688,25680,
     1  24720,31512,31248,31080,30408,30240,29880,29808,29568,28968,
     2  28824,24528,24216,24096,23640,23232,22440,22152,21528,21408,
     3  20928,46608,44664,42672,40704,38712,35712,31776,35712,31800,
     4  26856,44808,45792,45744,53688,53688,53760,53664,53736,53712,
     5  53568,53496,53352,53280,53208,53160,53304,53256,53256,53304,
     6  53400,53256,53064,52992,52968,53040,53256,53304,53232,53160,
     7  53016,52920,52920,53088,53088,52992,52920,52776,52728,52728,
     8  52656,52464,52296,52296,52416,52440,52104,52224,51720,51624,
     9  51408,51216,51096,51048,50808,50736,50544,50856,51000,51048/
            data (jx(i),i=  901, 1000)/
     +  51144,51264,51360,51432,51432,51576,51552,51720,51696,51840,
     1  51840,52032,52152,52224,52248,52296,52392,52440,52608,52560,
     2  52656,52728,52944,52944,52992,53160,53304,53352,53664,53760,
     3  49800,49728,49752,49800,51504,51552,51528,50880,50880,50736,
     4  50664,50568,50568,50592,50976,50904,54696,54672,54552,54504,
     5  54552,54504,54240,54096,54024,53928,53808,53808,53928,53784,
     6  53856,53928,54000,54024,54096,54384,54552,54624,54648,54720,
     7  53904,53952,53832,53856,54120,54024,54144,54312,54336,54264,
     8  54960,54936,54768,54768,22752,22800,22968,23064,22992,22872,
     9  22584,22752,22656,22392,23376,23208,23208,23448,23472,25176/
            data (jx(i),i= 1001, 1100)/
     +  24816,24672,24792,24984,25176,24216,24000,23832,23520,23016,
     1  23016,22536,22608,22560,22752,23112,23352,23568,23616,23472,
     2  23448,24192,24264,20688,20664,20712,20520,20592,20616,20544,
     3  23304,23256,23088,22848,22704,22776,22944,24408,24456,24552,
     4  24696,24504,23712,23592,23568,23760,23928,24072,24240,24360,
     5  24408,24480,22896,22872,22920,22968,23640,23616,23544,23568,
     6  23640,23544,23544,23448,23256,23208,23232,23304,23376,24312,
     7  24384,24216,24192,24120,24240,22800,22656,22560,22608,22752,
     8  22800,22848,25008,25056,25248,25464,25536,25512,25200,25080,
     9  23784,23760,23880,23952,23808,23376,23424,23400,23184,23088/
            data (jx(i),i= 1101, 1130)/
     +  23208,21960,21888,21768,21936,21984,22368,22440,22512,22488,
     1  21360,21432,21336,21288,21024,20976,21096,21360,23376,23448,
     2  23520,23664,23712,23640,23472,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  56352,56328,56544,56640,56808,56736,56640,56640,57048,57216,
     1  57336,57624,57720,57888,57816,57720,57552,57408,57528,57576,
     2  57744,57720,57600,57552,57624,57864,57816,57864,58152,58272,
     3  58584,58464,58608,58656,58824,58752,58632,58512,58464,58560,
     4  58536,58464,58248,58200,57984,57936,57936,57768,57600,57432,
     5  57240,57072,56904,56832,56832,56616,56520,56400,55824,55560,
     6  55464,55008,54672,54552,54504,55056,56064,55848,55392,54960,
     7  54720,54504,56352,56304,56112,55848,55608,55584,55488,55584,
     8  55560,55416,55728,55680,55464,55440,56160,56256,56256,56112,
     9  55872,55896,55776,55656,55608,55512,55296,55128,55128,55296/
            data (jy(i),i=  101,  200)/
     +  49488,51552,51912,52152,52752,52992,53160,53280,53616,53808,
     1  53808,53976,53928,54216,54336,54168,54120,54432,54360,54480,
     2  54840,49320,46392,48744,43584,37200,38640,34680,33960,34128,
     3  33840,31032,30072,33600,29544,25272,25008,24792,21864,21000,
     4  18456,16968,13584,13008,11040, 8832, 8592, 8448, 8328, 8160,
     5  49968,48984,48888,48792,48936,48912,48744,48816,48768,48888,
     6  48792,48720,48768,48576,48480,48432,48504,48816,48720,48816,
     7  48816,48888,48576,48720,48456,48504,48624,48456,48264,48312,
     8  48216,48360,48240,48192,48264,48240,47976,47880,47760,47592,
     9  47400,46848,46728,46464,48480,48432,48312,48120,47976,47808/
            data (jy(i),i=  201,  300)/
     +  47784,47928,47904,47808,47376,47376,47472,47424,47280,47088,
     1  46776,46656,46584,46344,46152,45888,45720,45480,45240,44928,
     2  44640,44424,46584,46416,46320,46176,46152,45864,45696,45576,
     3  45360,45288,45144,45024,44544,44112,44016,44064,43968,43800,
     4  43512,43224,43128,42936,42576,42456,42216,41592,41568,41736,
     5  41448,41592,41640,41592,41712,41904,42096,41880,41664,41280,
     6  41016,40656,40392,40320,40056,39912,39624,39312,38904,38856,
     7  38664,38688,38592,38280,37584,37464,37464,37416,37416,37320,
     8  37344,42792,42720,42648,42720,42624,42432,42096,41880,41592,
     9  41472,41328,40800,40368,40056,39888,39528,39288,39096,38760/
            data (jy(i),i=  301,  400)/
     +  34824,35088,35232,35376,35712,36048,36528,36624,36840,37008,
     1  37536,38160,38400,34632,35472,35760,35880,36384,36408,36384,
     2  36480,36480,36552,36552,36096,36240,36096,36024,36096,35784,
     3  35688,35808,35736,35952,35976,36024,36024,35832,34512,34200,
     4  37032,36768,36600,36264,36240,36120,36144,35736,35496,35088,
     5  34800,34752,34680,34248,34128,34128,34320,33840,33600,33432,
     6  33336,33024,32808,32448,32112,31872,31656,31512,31344,31392,
     7  31320,31320,31200,31224,33768,33768,33696,33696,33456,33336,
     8  33072,32880,32760,32952,33048,33216,32616,32640,32520,32568,
     9  32472,32424,32280,32232,32280,32136,32184,32592,32712,32712/
            data (jy(i),i=  401,  500)/
     +  32832,33168,33216,33216,33432,33504,33696,33240,32592,31560,
     1  30552,30912,30480,29976,29832,29448,29280,29064,28704,28488,
     2  28224,28056,27768,27504,27168,27024,26736,26472,26400,26136,
     3  25944,25320,29688,28872,28392,27936,27648,27408,26808,26400,
     4  25224,25104,25008,24336,24072,23784,23472,23184,22656,22464,
     5  24792,24024,23520,23472,23184,22680,22176,21264,21288,21144,
     6  21024,20712,20256,19824,19464,18792,17520,17784,18264,19032,
     7  19848,20376,18192,17784,17664,17472,17184,16680,16560,15888,
     8  15312,15144,14088,16704,16152,15840,15600,15216,14952,14376,
     9  13728,13560,13368,13176,12600,12480,12288,11880,11784,11352/
            data (jy(i),i=  501,  600)/
     +  10824,10680,10632,10512,10080,10080, 9936, 9600, 9360, 8688,
     1   8448, 8256, 8136,12600,12336,12048,11640,10344,10080, 9360,
     2   9048,47808,49752,49752,50736,50688,54576,52584,51240,51096,
     3  50832,49632,49536,53520,49488,47904,47880,43584,47520,47520,
     4  47712,47664,43632,47400,47544,47568,48264,48216,47232,46920,
     5  47208,46752,46776,47232,43800,45528,45600,48384,48384,45456,
     6  42360,41592,43008,43584,43584,44568,44544,42240,43224,41496,
     7  42384,41400,39528,39528,38544,41040,40824,40800,39792,39696,
     8  41616,39648,39672,38736,38760,37728,37800,37464,37512,38712,
     9  38712,38664,38592,35616,37392,38400,38232,38064,37296,38304/
            data (jy(i),i=  601,  700)/
     +  38016,37032,36984,36816,35520,36504,36408,34848,34704,37704,
     1  37728,34656,37656,37680,35688,34704,33792,33792,33648,33336,
     2  33144,33024,32736,32688,32640,32688,28752,33552,33552,33768,
     3  32544,33552,31848,31824,31752,31728,31032,30048,29952,30864,
     4  30888,29904,31704,31512,30744,30480,30144,28824,28896,29880,
     5  28680,28536,32496,28464,28344,28224,31176,31224,28200,28176,
     6  28056,26976,27000,26880,26760,26736,26544,25872,25944,27840,
     7  27840,25824,27768,27480,27432,27264,27072,26928,26832,26592,
     8  26280,26064,25824,25440,25512,25392,25224,25200,24840,24816,
     9  24984,25176,25368,25728,25728,25824,25704,25608,25920,26016/
            data (jy(i),i=  701,  800)/
     +  26016,24768,25320,24504,24672,22152,21936,22056,25872,21504,
     1  21696,20688,21480,22776,22848,22872,22824,22872,23424,23304,
     2  23376,24144,24168,21456,21528,21408,21360,21264,21552,21696,
     3  21960,22128,22248,22560,22800,23856,24360,24456,24696,25248,
     4  25416,25560,25800,26136,26376,26520,26640,26832,27144,27192,
     5  27048,27168,27312,27312,27384,27528,27600,27768,27936,21120,
     6  20856,20808,20112,18528,20016,17496,18504,18504,17328,17472,
     7  17328,21192,21048,20832,20784,20520,20424,20400,20472,20400,
     8  20424,20352,18360,18120,18072,17736,17568,17424,16872,18864,
     9  18864,16728,18720,18720,16704,16512,17208,17112,16680,16656/
            data (jy(i),i=  801,  900)/
     +  16272,20160,15720,15816,16080,16032,16176,16200,16056,16128,
     1  15672,16152,16176,16056,16152,16104,15792,15552,15720,15744,
     2  15672,15672,15336,15120,14928,14592,14376,14016,13656,13608,
     3  13632,12888,12768,12672,12576,12504,12384,12360,12480,11832,
     4  11664,10152,10200,10872,41064,40896,40824,40728,40632,40512,
     5  40464,40608,40704,40656,40824,40800,40488,40416,39912,39792,
     6  39720,39552,39816,39768,39648,39456,39336,39024,39048,38904,
     7  39072,39048,38928,38808,38664,38616,38760,38784,38736,38472,
     8  38136,38016,37584,37344,37224,37128,36816,36480,36096,35736,
     9  35520,35664,35832,35784,35904,36528,36744,37728,37992,38016/
            data (jy(i),i=  901, 1000)/
     +  38280,38472,38400,38424,38712,38904,39336,39384,39816,39912,
     1  39816,39792,39672,39672,40008,40080,40080,40152,40152,40488,
     2  40896,40920,40872,41328,41400,41256,41280,41424,41400,41232,
     3  38424,38424,38376,38376,39720,39744,39768,40128,40248,40104,
     4  40152,40080,39936,39840,39648,39768,42480,42336,42288,42096,
     5  41976,41904,41928,42120,42096,41904,41952,42144,42096,42456,
     6  42792,42864,42840,42624,42744,42816,42792,42648,42696,42648,
     7  41616,41496,41544,41640,41736,41880,41904,41616,41472,41640,
     8  42768,42984,42984,42720,57360,57360,57528,57696,57840,57768,
     9  56136,56016,56160,56160,57936,57936,58008,58080,58008,58200/
            data (jy(i),i= 1001, 1100)/
     +  58056,57888,57840,57912,58128,57624,57864,57864,57480,57120,
     1  57024,56832,56640,56448,56448,56808,56808,56880,57000,57000,
     2  57240,57504,57576,58560,58512,58536,58584,58632,58536,58512,
     3  58368,58584,58800,58872,58704,58464,58296,58512,58560,58560,
     4  58848,58968,58656,58464,58320,58248,58416,58344,58464,58392,
     5  58272,58296,60000,60144,60168,60048,59688,59760,59736,59592,
     6  59616,59880,59928,59808,59784,59688,59520,59496,59736,59304,
     7  59448,59640,59784,59664,59304,59544,59664,59496,59304,59232,
     8  59256,59424,59232,59304,59352,59592,60024,60240,60192,60048,
     9  59232,59400,59376,59304,59184,59256,59280,59328,59376,59112/
            data (jy(i),i= 1101, 1130)/
     +  59112,59112,59064,59136,58968,59016,58920,59016,59040,58920,
     1  58968,59112,59280,59160,59088,58992,58800,58800,58752,58728,
     2  58776,58944,59064,59088,58968,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    5,    6,    7,    8,    9,   10,
     1     11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
     2     21,   22,   23,   24,   25,   26,   27,   28,   29,   30,
     3     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     4     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     5     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     61,   62,   63,   64,   66,   67,   68,   69,   70,   71,
     7     65,    1,   73,   74,   75,   76,   77,   78,   79,   80,
     8     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     9     91,   92,   93,   94,   95,   96,   97,   98,   99,  100/
            data (jb1(i),i=  101,  200)/
     +    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     1    112,  113,  114,  115,  116,  117,  118,  119,  120,   66,
     2    102,  122,  122,  152,  153,  154,  155,  156,  157,  158,
     3    159,  160,  161,  162,  124,  124,  164,  165,  166,  167,
     4    168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
     5    178,  179,  180,  181,  182,  183,  184,  185,  186,  187,
     6    188,  189,  190,  191,  192,  193,  123,  101,  195,  196,
     7    197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
     8    207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
     9    217,  218,  219,  220,  221,  125,  123,  223,  224,  225/
            data (jb1(i),i=  201,  300)/
     +    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     1    236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
     2    246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
     3    256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
     4    266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
     5    276,  277,  278,  279,  280,  126,  125,  282,  283,  284,
     6    285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
     7    295,  296,  297,  298,  299,  127,  128,  301,  302,  303,
     8    304,  305,  306,  307,  308,  309,  310,  311,  312,  127,
     9    130,  314,  315,  316,  317,  318,  319,  320,  321,  322/
            data (jb1(i),i=  301,  400)/
     +    323,  324,  325,  326,  327,  328,  329,  330,  331,  332,
     1    333,  334,  335,  336,  337,  338,  339,  129,  126,  341,
     2    342,  343,  344,  345,  346,  347,  348,  349,  350,  351,
     3    352,  353,  354,  355,  131,  129,  128,  357,  358,  359,
     4    360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
     5    370,  371,  372,  373,  132,  131,  375,  376,  377,  378,
     6    379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
     7    389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
     8    399,  400,  401,  402,  403,  404,  405,  134,  130,  407,
     9    408,  409,  410,  133,  132,  412,  413,  414,  135,  135/
            data (jb1(i),i=  401,  500)/
     +    416,  417,  418,  419,  420,  421,  422,  423,  424,  425,
     1    426,  427,  428,  429,  430,  431,  136,  133,  433,  434,
     2    435,  436,  437,  438,  439,  137,  136,  441,  442,  138,
     3    138,  444,  445,  446,  447,  448,  449,  139,  137,  451,
     4    452,  453,  454,  455,  456,  457,  140,  139,  459,  460,
     5    461,  462,  463,  464,  465,  141,  142,  467,  468,  469,
     6    470,  471,  140,  141,  473,  474,  475,  476,  477,  478,
     7    479,  480,  481,  482,  143,  142,  484,  485,  486,  487,
     8    488,  489,  490,  491,  144,  143,  493,  494,  495,  496,
     9    497,  498,  499,  500,  501,  502,  503,  504,  505,  506/
            data (jb1(i),i=  501,  600)/
     +    507,  508,  509,  510,  511,  512,  150,  144,  514,  515,
     1    516,  145,  145,  518,  519,  520,  146,  146,  147,  148,
     2    149,  522,  523,  524,  525,  526,   66,   65,  528,  529,
     3    530,  531,  532,  533,    1,  533,  101,  102,  536,  538,
     4    539,  535,  522,  522,  532,  541,  543,  544,  545,  533,
     5    122,  547,  548,  550,  551,  552,  553,  549,  537,  541,
     6    556,  557,  124,  558,  559,  556,  549,  556,  550,  543,
     7    538,  538,  125,  565,  566,  564,  561,  563,  568,  562,
     8    561,  571,  570,  570,  573,  574,  563,  576,  555,  577,
     9    578,  579,  543,  562,  581,  582,  583,  584,  585,  586/
            data (jb1(i),i=  601,  700)/
     +    587,  588,  589,  590,  580,  590,  564,  592,  575,  593,
     1    595,  575,  568,  597,  576,  595,  599,  597,  598,  601,
     2    602,  603,  579,  594,  605,  606,  595,  604,  608,  590,
     3    610,  609,  612,  613,  592,  612,  129,  594,  615,  616,
     4    617,  618,  619,  599,  620,  621,  603,  609,  623,  612,
     5    625,  626,  625,  628,  629,  617,  625,  620,  631,  608,
     6    633,  634,  635,  623,  132,  624,  622,  639,  639,  633,
     7    640,  641,  638,  636,  643,  644,  645,  646,  647,  648,
     8    649,  639,  627,  627,  651,  631,  652,  652,  654,  620,
     9    655,  621,  657,  658,  656,  659,  660,  638,  661,  662/
            data (jb1(i),i=  701,  800)/
     +    663,  664,  665,  666,  667,  669,  670,  634,  668,  669,
     1    635,  673,  674,  675,  676,  677,  678,  679,  680,  681,
     2    682,  683,  684,  654,  685,  686,  656,  651,  689,  648,
     3    138,  690,  691,  692,  693,  694,  695,  696,  697,  698,
     4    699,  700,  669,  689,  688,  702,  704,  688,  685,  662,
     5    707,  706,  707,  668,  707,  710,  711,  704,  713,  714,
     6    715,  716,  717,  718,  719,  720,  721,  722,  686,  710,
     7    713,  725,  724,  713,  687,  727,  728,  729,  730,  731,
     8    732,  733,  734,  735,  736,  737,  738,  739,  740,  741,
     9    742,  743,  744,  745,  746,  747,  748,  749,  750,  751/
            data (jb1(i),i=  801,  900)/
     +    752,  753,  754,  755,  756,  757,  758,  660,  728,  706,
     1    761,  761,  702,  712,  760,  764,  763,  764,  766,  767,
     2    724,  769,  770,  766,  728,  772,  773,  774,  775,  776,
     3    777,  778,  779,  780,  781,  782,  783,  784,  785,  786,
     4    787,  769,  789,  789,  790,  761,  789,  792,  793,  712,
     5    792,  795,  766,  769,  797,  798,  799,  800,  763,  802,
     6    803,  804,  805,  806,  807,  808,  809,  810,  764,  801,
     7    812,  813,  814,  815,  816,  817,  818,  819,  820,  803,
     8    811,  822,  823,  824,  825,  826,  827,  828,  829,  830,
     9    831,  832,  789,  832,  833,  795,  834,  835,  796,  836/
            data (jb1(i),i=  901, 1000)/
     +    838,  837,  801,  838,  840,  809,  842,  843,  844,  833,
     1    842,  835,  837,  840,  841,    1,    2,    3,    4,    5,
     2      6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
     3     16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
     4     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     5     36,   37,   38,   39,   40,   41,   42,   43,   44,   45,
     6     46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
     7     56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
     8     66,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     9     76,   77,   78,   79,   80,   81,   82,   83,   84,   85/
            data (jb1(i),i= 1001, 1100)/
     +      1,   87,   88,   89,   87,   91,   92,   91,   94,   95,
     1     96,   97,   98,   99,  100,  101,   94,  103,  104,  105,
     2    106,  107,  108,  109,  110,  111,  112,  113,  114,  115,
     3    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     4    103,  127,  128,  129,  127,  131,  132,  133,  134,  135,
     5    131,  137,  138,  139,  137,  141,  142,  143,  144,  145,
     6    141,  147,  148,  149,  147,  151,  152,  153,  154,  151,
     7    156,  157,  158,  159,  160,  156,  162,  163,  164,  165,
     8    166,  167,  168,  169,  170,  171,  172,  173,  174,  175,
     9    176,  177,  178,  162,  180,  181,  180,  183,  184,  185/
            data (jb1(i),i= 1101, 1200)/
     +    183,  187,  188,  189,  190,  191,  192,  187,  194,  195,
     1    196,  197,  198,  199,  200,  201,  202,  203,  204,  205,
     2    206,  207,  194,  209,  210,  211,  209,  213,  214,  215,
     3    216,  213,  218,  219,  220,  221,  222,  223,  224,  218,
     4    226,  227,  228,  229,  230,  226,  232,  233,  234,  235,
     5    236,  237,  232,  239,  240,  241,  242,  243,  244,  245,
     6    239,  247,  248,  249,  250,  247,  252,  253,  254,  255,
     7    256,  252,  258,  259,  260,  261,  258,  263,  264,  265,
     8    263,  267,  268,  269,  270,  271,  272,  273,  267,  275,
     9    276,  277,  278,  279,  280,  275,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   67,   68,   69,   70,   71,   72,
     7     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   97,   98,   99,  100,  101/
            data (jb2(i),i=  101,  200)/
     +    103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
     1    113,  114,  115,  116,  117,  118,  119,  120,  121,  121,
     2    151,  151,  152,  153,  154,  155,  156,  157,  158,  159,
     3    160,  161,  162,  163,  163,  164,  165,  166,  167,  168,
     4    169,  170,  171,  172,  173,  174,  175,  176,  177,  178,
     5    179,  180,  181,  182,  183,  184,  185,  186,  187,  188,
     6    189,  190,  191,  192,  193,  194,  194,  195,  196,  197,
     7    198,  199,  200,  201,  202,  203,  204,  205,  206,  207,
     8    208,  209,  210,  211,  212,  213,  214,  215,  216,  217,
     9    218,  219,  220,  221,  222,  222,  223,  224,  225,  226/
            data (jb2(i),i=  201,  300)/
     +    227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
     1    237,  238,  239,  240,  241,  242,  243,  244,  245,  246,
     2    247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
     3    257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
     4    267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
     5    277,  278,  279,  280,  281,  281,  282,  283,  284,  285,
     6    286,  287,  288,  289,  290,  291,  292,  293,  294,  295,
     7    296,  297,  298,  299,  300,  300,  301,  302,  303,  304,
     8    305,  306,  307,  308,  309,  310,  311,  312,  313,  313,
     9    314,  315,  316,  317,  318,  319,  320,  321,  322,  323/
            data (jb2(i),i=  301,  400)/
     +    324,  325,  326,  327,  328,  329,  330,  331,  332,  333,
     1    334,  335,  336,  337,  338,  339,  340,  340,  341,  342,
     2    343,  344,  345,  346,  347,  348,  349,  350,  351,  352,
     3    353,  354,  355,  356,  356,  134,  357,  358,  359,  360,
     4    361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
     5    371,  372,  373,  374,  374,  375,  376,  377,  378,  379,
     6    380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
     7    390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
     8    400,  401,  402,  403,  404,  405,  406,  406,  407,  408,
     9    409,  410,  411,  411,  412,  413,  414,  415,  415,  416/
            data (jb2(i),i=  401,  500)/
     +    417,  418,  419,  420,  421,  422,  423,  424,  425,  426,
     1    427,  428,  429,  430,  431,  432,  432,  433,  434,  435,
     2    436,  437,  438,  439,  440,  440,  441,  442,  443,  443,
     3    444,  445,  446,  447,  448,  449,  450,  450,  451,  452,
     4    453,  454,  455,  456,  457,  458,  458,  459,  460,  461,
     5    462,  463,  464,  465,  466,  466,  467,  468,  469,  470,
     6    471,  472,  472,  473,  474,  475,  476,  477,  478,  479,
     7    480,  481,  482,  483,  483,  484,  485,  486,  487,  488,
     8    489,  490,  491,  492,  492,  493,  494,  495,  496,  497,
     9    498,  499,  500,  501,  502,  503,  504,  505,  506,  507/
            data (jb2(i),i=  501,  600)/
     +    508,  509,  510,  511,  512,  513,  513,  514,  515,  516,
     1    517,  517,  518,  519,  520,  521,  521,  147,  148,  149,
     2    150,  523,  524,  525,  526,  527,  527,  528,  529,  530,
     3    531,  532,  533,  534,  534,  535,  535,  536,  537,  539,
     4    540,  540,  537,  541,  542,  542,  544,  545,  546,  546,
     5    547,  548,  549,  551,  552,  553,  554,  554,  550,  555,
     6    557,  123,  558,  559,  560,  560,  561,  562,  563,  555,
     7    543,  564,  565,  566,  567,  567,  568,  569,  569,  570,
     8    571,  572,  572,  573,  574,  575,  576,  577,  577,  578,
     9    579,  580,  580,  581,  582,  583,  584,  585,  586,  587/
            data (jb2(i),i=  601,  700)/
     +    588,  589,  126,  591,  591,  592,  592,  127,  593,  594,
     1    596,  596,  597,  598,  598,  599,  600,  600,  601,  602,
     2    603,  604,  604,  605,  606,  607,  607,  608,  609,  610,
     3    611,  611,  613,  614,  614,  128,  130,  615,  616,  617,
     4    618,  619,  131,  620,  621,  622,  622,  623,  624,  624,
     5    626,  627,  628,  629,  630,  630,  631,  632,  632,  633,
     6    634,  635,  636,  636,  637,  637,  638,  133,  134,  640,
     7    641,  642,  642,  643,  644,  645,  646,  647,  135,  649,
     8    650,  650,  648,  651,  652,  653,  653,  654,  655,  655,
     9    656,  657,  658,  659,  659,  660,  661,  661,  662,  663/
            data (jb2(i),i=  701,  800)/
     +    664,  665,  666,  667,  668,  670,  671,  671,  672,  672,
     1    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     2    683,  684,  136,  685,  686,  687,  687,  688,  137,  689,
     3    690,  691,  692,  693,  694,  695,  696,  697,  698,  699,
     4    700,  701,  701,  702,  703,  703,  705,  705,  704,  706,
     5    708,  708,  709,  709,  139,  711,  712,  710,  714,  715,
     6    716,  717,  718,  719,  720,  721,  722,  723,  723,  724,
     7    725,  726,  726,  727,  727,  728,  729,  730,  731,  732,
     8    733,  734,  735,  736,  737,  738,  739,  740,  741,  742,
     9    743,  744,  745,  746,  747,  748,  749,  750,  751,  752/
            data (jb2(i),i=  801,  900)/
     +    753,  754,  755,  756,  757,  758,  759,  759,  760,  760,
     1    140,  762,  762,  762,  763,  765,  765,  141,  767,  768,
     2    768,  770,  771,  771,  772,  773,  774,  775,  776,  777,
     3    778,  779,  780,  781,  782,  783,  784,  785,  786,  787,
     4    788,  788,  142,  790,  791,  791,  792,  793,  794,  794,
     5    795,  796,  796,  797,  798,  799,  800,  801,  802,  803,
     6    804,  805,  806,  807,  808,  809,  810,  811,  811,  812,
     7    813,  814,  815,  816,  817,  818,  819,  820,  821,  821,
     8    822,  823,  824,  825,  826,  827,  828,  829,  830,  831,
     9    143,  144,  832,  833,  834,  834,  835,  836,  836,  837/
            data (jb2(i),i=  901, 1000)/
     +    839,  839,  838,  840,  841,  841,  843,  844,  145,  842,
     1    146,  147,  148,  149,  150,    2,    3,    4,    5,    6,
     2      7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
     3     17,   18,   19,   20,   21,   22,   23,   24,   25,   26,
     4     27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
     5     37,   38,   39,   40,   41,   42,   43,   44,   45,   46,
     6     47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
     7     57,   58,   59,   60,   61,   62,   63,   64,   65,   66,
     8     67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     9     77,   78,   79,   80,   81,   82,   83,   84,   85,   86/
            data (jb2(i),i= 1001, 1100)/
     +     86,   88,   89,   90,   90,   92,   93,   93,   95,   96,
     1     97,   98,   99,  100,  101,  102,  102,  104,  105,  106,
     2    107,  108,  109,  110,  111,  112,  113,  114,  115,  116,
     3    117,  118,  119,  120,  121,  122,  123,  124,  125,  126,
     4    126,  128,  129,  130,  130,  132,  133,  134,  135,  136,
     5    136,  138,  139,  140,  140,  142,  143,  144,  145,  146,
     6    146,  148,  149,  150,  150,  152,  153,  154,  155,  155,
     7    157,  158,  159,  160,  161,  161,  163,  164,  165,  166,
     8    167,  168,  169,  170,  171,  172,  173,  174,  175,  176,
     9    177,  178,  179,  179,  181,  182,  182,  184,  185,  186/
            data (jb2(i),i= 1101, 1200)/
     +    186,  188,  189,  190,  191,  192,  193,  193,  195,  196,
     1    197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
     2    207,  208,  208,  210,  211,  212,  212,  214,  215,  216,
     3    217,  217,  219,  220,  221,  222,  223,  224,  225,  225,
     4    227,  228,  229,  230,  231,  231,  233,  234,  235,  236,
     5    237,  238,  238,  240,  241,  242,  243,  244,  245,  246,
     6    246,  248,  249,  250,  251,  251,  253,  254,  255,  256,
     7    257,  257,  259,  260,  261,  262,  262,  264,  265,  266,
     8    266,  268,  269,  270,  271,  272,  273,  274,  274,  276,
     9    277,  278,  279,  280,  281,  281,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine wy(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(340) :: jx,jy
            integer(kind=iknd), save, dimension(370) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'wyoming       '/
            data jrot,ipart/0,1/
            data kv/   1, 340,   0,   0,   0/
            data kb/   1, 362,   0,   0,   0/
            data iib/  30,   0,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +   8448, 8664,10488,10944,12936,13152,14280,14736,24672,29448,
     1  41808,35352,54792,54696,47904,42432,42360, 7584,54864,54984,
     2   6408,39216,28032,12984,46584,55080,10536, 6048,21024,55128,
     3  24792,24648,24792,24672,24792,24624,41784,41856,41784,47976,
     4  47952,47904,47928,47976,47976,47928,32760,32688,32400,32400,
     5  32304,31968,31944,31680,31704,31392,31272,31104,31056,30888,
     6  30672,30744,30384,30240,30264,29856,29832,29928,29616,29712,
     7  29544,29520,38496,41784,41712,41688,41688,41760,41712,41640,
     8  41592,10992,10920,12864,12888,13080,13176,13296,13320,13272,
     9  13392,13392,13368,13272,13296,13416,13656,13704,13680,13824/
            data (jx(i),i=  101,  200)/
     +  13896,13944,14184,14304,14424,14328,14448,14328,14352,14592,
     1  14760,14640,34224,34248,34008,34176,34080,33936,33912,33912,
     2  33648,33216,33216,32976,33048,33000,32856,29400,24744,47928,
     3  47928,19560,21072,21072,22248,22272,23112,23136,30960,31008,
     4  30216,30240,28632,28656,27048,27072,26280,26304,25488,25512,
     5  25104,25152,34272,34320,34224,34296,19488,19152,19104,18936,
     6  18936,18744,18720,18576,18504,18384,18288,18216,18024,17784,
     7  17640,17592,17328,17280,17160,17208,17160,16776,16584,16464,
     8  16224,15912,15888,15912,16128,16056,16152,15936,15936,15864,
     9  15984,15960,15888,15696,15456,15288,14976,14784,14352,30960/
            data (jx(i),i=  201,  300)/
     +  27192,27168,25944,25944,25152,25152,24336,24360,23568,23568,
     1  22776,22800,21984,22008,20400,20448,20304,20064,19920,19920,
     2  19776,19776,16416,16344,16464,16560,16680,16752,16728,16848,
     3  16776,16824,16872,17040,17136,17448,17592,17448,17520,17496,
     4  17880,18528,18624,18696,18984,18984,19176,19368,19464,19704,
     5  19752,19584,19512,19656,19776,20064,20280,20640,20544,20736,
     6  20640,10632,10680,12288,12336,14304,31392,34272,41280,49176,
     7  31176,31032,31128,31416,31464,31560,31416,31536,31368,49224,
     8  49152, 8352, 8352, 9096, 9072,41112,10344,10080,10032,10272,
     9  10104,10440,10344,13704,50880,46560,46560,38376,46248,46248/
            data (jx(i),i=  301,  340)/
     +  46128,46128,45984,45984,45864,45864,44808,44400,44400,44280,
     1  44280,44544,44544,44688,44664,31128,39240,41016,46560,46608,
     2  46632,46584,28128,28032,28104,31104,31224,31080,13416,13632,
     3  13536,13320,13200,13200,13320,13320,13200,50928,50928,    0/
            data (jy(i),i=    1,  100)/
     +  50352,53472,53352,53232,53088,53136,53040,53088,52536,52344,
     1  52008,52128,44424,52008,51984,52032,51984,37824,38160,29880,
     2  21744,15000,15288,15936,14904,20184,16032,16368,15528,14952,
     3  44760,44784,48072,48072,51216,51216,50832,50832,48000,44376,
     4  44376,48648,50016,50016,50880,50880,48120,48432,48552,48624,
     5  48552,48648,48864,48864,49128,49392,49464,49440,49344,49320,
     6  49368,49584,49680,49824,50160,50376,50448,50616,51216,51456,
     7  51744,52200,47976,47592,47592,45528,44328,44328,41112,41112,
     8  38064,50160,49392,49272,49008,48912,48984,48888,48816,48792,
     9  48696,48552,48240,48216,47712,47640,47280,47136,46824,46824/
            data (jy(i),i=  101,  200)/
     +  46584,46632,46464,45816,45648,45552,45456,45408,45168,45024,
     1  45000,43824,44400,45960,46176,46344,46704,46656,46704,47088,
     2  47208,47256,47592,47760,47904,47952,47952,44568,43968,38064,
     3  42168,41736,41712,42504,42456,43248,43224,44040,38352,39696,
     4  39720,40512,40560,41376,41448,41712,41736,42264,42312,43128,
     5  43152,43968,38256,41208,41208,44400,41928,42096,42432,42552,
     6  42648,42768,42864,42936,43104,43080,42960,42960,43176,43008,
     7  43104,42936,42840,42576,42408,42144,42120,42072,42024,41904,
     8  41832,42120,42192,42264,42384,42528,42696,42840,43032,43056,
     9  43248,43344,43248,43200,43248,43344,43296,43752,38808,38088/
            data (jy(i),i=  201,  300)/
     +  38232,38112,38160,38280,38304,38568,38616,38904,38952,39336,
     1  39384,39624,39648,39816,39912,40632,40728,41256,41280,41376,
     2  41472,41616,38664,37776,37728,37800,37824,37728,37392,37152,
     3  36936,36120,35952,35808,35472,35184,34848,34800,34632,34464,
     4  34296,33672,33648,33696,33192,32976,32832,32520,32424,32352,
     5  32256,32208,32040,31968,32016,31776,31296,31296,28872,28848,
     6  27288,36840,37440,37320,38136,37992,38328,38208,38064,38088,
     7  28440,28440,31680,31680,33960,34896,34896,38088,38088,29832,
     8  34536,37800,37584,37560,36936,28224,32688,32712,32040,32040,
     9  29592,29568,27984,27720,29832,29784,28176,28248,28176,27936/
            data (jy(i),i=  301,  340)/
     +  27936,27672,27672,27168,27168,26880,26880,26880,27024,27024,
     1  27696,27696,27960,27960,28176,26832,18624,18624,25008,25008,
     2  23520,21000,18960,18960,21360,21264,25248,25248,21288,24480,
     3  24480,19968,19968,19824,19824,19680,19680,20952,20160,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    5,    6,    7,    8,    9,   11,
     1     10,   13,   14,   15,   16,   11,    1,   13,   19,   18,
     2     20,   24,   27,   21,   23,   24,   22,   22,   26,   25,
     3     31,   32,   33,   34,   35,    9,   11,   37,   38,   40,
     4     41,   42,   43,   44,   45,   15,   47,   48,   49,   50,
     5     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     7     71,   10,   39,   47,   39,   74,   75,   76,   77,   78,
     8     79,   80,    1,   82,   83,   84,   85,   86,   87,   88,
     9     89,   90,   91,   92,   93,   94,   95,   96,   97,   98/
            data (jb1(i),i=  101,  200)/
     +     99,  100,  101,  102,  103,  104,  105,  106,  107,  108,
     1    109,  110,  111,  113,  114,  115,  116,  117,  118,  119,
     2    120,  121,  122,  123,  124,  125,  126,   47,  113,   31,
     3     13,   31,  130,   40,  132,  133,  134,  135,  136,  137,
     4    129,  139,  140,  141,  142,  143,  144,  145,  146,  147,
     5    148,  149,  150,  151,  129,  153,  154,  155,  113,  132,
     6    157,  158,  159,  160,  161,  162,  163,  164,  165,  166,
     7    167,  168,  169,  170,  171,  172,  173,  174,  175,  176,
     8    177,  178,  179,  180,  181,  182,  183,  184,  185,  186,
     9    187,  188,  189,  190,  191,  192,  193,  194,  195,  196/
            data (jb1(i),i=  201,  300)/
     +    197,  112,  112,  139,  200,  201,  202,  203,  204,  205,
     1    206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
     2    216,  217,  218,  219,  220,  221,  132,  199,  223,  224,
     3    225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
     4    235,  236,  237,  238,  239,  240,  241,  242,  243,  244,
     5    245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
     6    255,  256,  257,  258,  259,  260,  262,  263,  264,  265,
     7    199,  139,  153,  153,  268,   19,  271,  272,  273,  274,
     8    275,  276,  277,  278,  267,   81,   81,  130,  280,  270,
     9     18,  282,  283,  284,  262,  269,  262,  287,  288,  289/
            data (jb1(i),i=  301,  370)/
     +    290,  291,  292,  293,   20,  280,  280,  296,  286,  271,
     1    297,  299,  300,  301,  302,  303,  304,  305,  306,  307,
     2    308,  309,  310,  311,  312,  313,  314,  286,  271,   22,
     3    317,  286,  261,  297,  319,  320,  321,  261,   23,  323,
     4    324,  325,  326,  327,  316,  329,  330,  294,   21,  329,
     5    332,  333,  334,  335,  336,  337,  295,  322,  322,   26,
     6    338,    0,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   10,   12,
     1     12,   14,   15,   16,   17,   17,   18,   19,   20,   21,
     2     26,   27,   28,   28,   29,   29,   23,   25,   30,   30,
     3     32,   33,   34,   35,   36,   36,   37,   38,   39,   41,
     4     42,   43,   44,   45,   46,   46,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   72,   73,   73,   74,   75,   76,   77,   78,   79,
     8     80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
     9     90,   91,   92,   93,   94,   95,   96,   97,   98,   99/
            data (jb2(i),i=  101,  200)/
     +    100,  101,  102,  103,  104,  105,  106,  107,  108,  109,
     1    110,  111,  112,  114,  115,  116,  117,  118,  119,  120,
     2    121,  122,  123,  124,  125,  126,  127,  127,  128,  128,
     3     40,  129,  131,  131,  133,  134,  135,  136,  137,  138,
     4    138,  140,  141,  142,  143,  144,  145,  146,  147,  148,
     5    149,  150,  151,  152,  152,  154,  155,  156,  156,  157,
     6    158,  159,  160,  161,  162,  163,  164,  165,  166,  167,
     7    168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
     8    178,  179,  180,  181,  182,  183,  184,  185,  186,  187,
     9    188,  189,  190,  191,  192,  193,  194,  195,  196,  197/
            data (jb2(i),i=  201,  300)/
     +    198,  198,  199,  200,  201,  202,  203,  204,  205,  206,
     1    207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
     2    217,  218,  219,  220,  221,  222,  222,  223,  224,  225,
     3    226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
     4    236,  237,  238,  239,  240,  241,  242,  243,  244,  245,
     5    246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
     6    256,  257,  258,  259,  260,  261,  263,  264,  265,  266,
     7    266,  267,  267,  268,  269,  270,  272,  273,  274,  275,
     8    276,  277,  278,  279,  279,  130,  269,  270,  281,  281,
     9    282,  283,  284,  285,  285,  286,  287,  288,  289,  290/
            data (jb2(i),i=  301,  370)/
     +    291,  292,  293,  294,  295,  295,  296,  297,  298,  298,
     1    299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
     2    309,  310,  311,  312,  313,  314,  315,  315,  316,  317,
     3    318,  318,  294,  319,  320,  321,  322,  316,  323,  324,
     4    325,  326,  327,  328,  328,  330,  331,  331,  329,  332,
     5    333,  334,  335,  336,  337,   24,  338,  338,   25,  339,
     6    339,    0,    0,    0,    0,    0,    0,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
c-----------------------------------------------------------------------
c
c            piecewise lagrange triangle multi grid package
c
c                  edition 13.0 - - - september, 2018
c
c-----------------------------------------------------------------------
        subroutine us(state,irot,npart,jv,jb,ib,ix,iy,ib1,ib2)
cx
            use mthdef
            implicit real(kind=rknd) (a-h,o-z)
            implicit integer(kind=iknd) (i-n)
            integer(kind=iknd), dimension(*) :: jv,jb,ib,ix,iy,ib1,ib2
            integer(kind=iknd), save, dimension(5) :: kv,kb,iib
            integer(kind=iknd), save, dimension(6700) :: jx,jy
            integer(kind=iknd), save, dimension(6750) :: jb1,jb2
            integer(kind=iknd), save :: jrot,ipart
            character(len=80) :: state
            character(len=80), save :: istate
cy
            data istate/'united states '/
            data jrot,ipart/0,2/
            data kv/   1,6291,6693,   0,   0/
            data kb/   1,6346,6748,   0,   0/
            data iib/2119, 402,   0,   0,   0/
            data (jx(i),i=    1,  100)/
     +  30456,31584,32520,33048,34368,35040,35568,36648,37368,18456,
     1  19776,20424,22296,23208,23736,24984,26256,27312,28392,29448,
     2  17496,38184,39336,39456,39456,39792,39936,39936,40056,40200,
     3  40344,40392,40800,40824,40872,41136,41184,41184,41352,41568,
     4  41712,41928,42024,42048,41976,41952,42168,42216,42192,42312,
     5  42408,42384,42408,42552,42648,42720,42912,42984,43008,43128,
     6  43128,43488,43680,43848,43992,44160,44184,44592,44712,44760,
     7  44856,45000,45240,45144,45120,44760,44256,43752,43296,42960,
     8  42672,42552,42456,42480,42552,42672,42768,42864,43224,43944,
     9  44040,44040,43896,44088,44304,44448,10248,10128, 9984, 9888/
            data (jx(i),i=  101,  200)/
     +   9696, 9624, 9504, 9672, 9696, 9624, 9816, 9744, 9792, 9768,
     1   9816, 9936, 9888, 9720, 9672, 9696, 9696, 9744, 9720, 9768,
     2   9792,10056, 9864, 9864, 9768, 9696, 9744, 9744, 9696, 9720,
     3   9744, 9696, 9600, 9600, 9648, 9696, 9840,10320,10896,11184,
     4  11352,11352,11448,11520,11472,11544,11544,11424,11376,11376,
     5  11328,11232,11112,10944,10848,10992,11208,10968,10896,11040,
     6  11184,11376,11424,11568,11616,11688,11688,11520,11496,11544,
     7  11520,11568,11472,11472,11424,11424,11400,11376,11376,11280,
     8  11400,11376,11256,11208,11232,11184,11136,11232,11208,11112,
     9  10848,10824,10872,10968,11136,11184,11208,11352,11448,11448/
            data (jx(i),i=  201,  300)/
     +  11544,11592,11544,11568,11688,11712,11664,11712,11712,11760,
     1  11928,12000,12024,11928,11928,11856,11832,11904,11784,11784,
     2  11832,11928,11976,11832,11736,11736,11832,11880,11928,11928,
     3  12024,11976,11976,12000,11832,11832,11760,11856,11856,13704,
     4  15696,16320,17088,47448,44832,44976,45072,45480,45648,45744,
     5  45864,45936,45984,46224,46248,46368,46368,46440,46440,46416,
     6  46464,46728,46728,46872,47016,47280,47616,47880,48000,48144,
     7  48264,48384,48552,48864,48912,49152,49536,49800,50088,50016,
     8  50064,50016,50064,50160,50304,50472,50544,50688,50808,50976,
     9  50880,50928,51048,51144,51120,51216,51312,51312,51096,50832/
            data (jx(i),i=  301,  400)/
     +  50688,50544,50472,50448,50328,50088,49752,49608,49464,49272,
     1  49200,49200,49032,48840,48792,48768,48672,48576,48600,48552,
     2  48504,48432,48408,48528,48336,48192,47976,47832,47784,47544,
     3  47544,64464,64464,64512,64512,64464,64536,64608,64776,64800,
     4  62568,62736,63408,64056,65832,64920,65064,65064,65064,65040,
     5  65064,65256,65112,65232,65376,65328,65448,65448,65376,65376,
     6  65352,65400,65328,65376,65496,65472,65448,65928,66144,66216,
     7  66384,66720,66840,66864,66984,67512,67968,67992,67968,68016,
     8  67992,68040,68088,68136,68256,68448,68496,68424,68544,68520,
     9  68592,68712,68784,68904,68928,69072,69024,69216,69216,69048/
            data (jx(i),i=  401,  500)/
     +  68952,68856,68688,68664,68472,68424,68400,68328,68328,68304,
     1  68328,68256,68160,68040,67944,67848,67752,67824,67800,67584,
     2  67512,67488,67512,67488,67392,67368,67368,67416,67440,67320,
     3  67344,67320,67344,67224,67152,67080,67008,66984,66888,66792,
     4  66768,66792,66696,66696,66768,66744,66696,66600,66624,66600,
     5  66528,66696,66672,66648,66600,66552,66576,66504,66480,66456,
     6  66432,66312,66264,66312,66192,66216,66144,66072,66000,65760,
     7  65784,65760,65784,65856,65952,65928,47472,47544,47520,47520,
     8  47400,47304,47304,47160,47184,47136,47184,47136,47136,47208,
     9  47256,47304,47400,47448,47544,47616,47616,47736,47808,47880/
            data (jx(i),i=  501,  600)/
     +  47832,47736,47688,47736,47592,47544,47592,47520,47496,47424,
     1  47448,47472,47448,47520,47544,47640,47592,47616,56448,56760,
     2  56856,57048,57144,57312,57192,57240,57168,57024,57048,56976,
     3  57600,58104,58392,58584,58800,59280,59472,59496,59568,59712,
     4  59952,59976,59928,59856,59880,59952,59928,59832,59736,59664,
     5  60120,60192,60552,60888,61128,61872, 7728, 7608, 7608, 7656,
     6   7752, 7752, 7680, 7800, 8040, 8016, 8232, 8328, 8496, 8712,
     7   8928, 8952, 9120, 9264, 9312, 9360, 9408, 9432, 9384, 9432,
     8   9432, 9480, 9480, 9576, 9600, 9744, 9768, 9744, 9816, 9840,
     9   9888,10080,10200,55680,48768,48984,49080,49200,49296,49320/
            data (jx(i),i=  601,  700)/
     +  49200,48960,48840,48936,48936,48888,48912,48816,48936,49032,
     1  49056,49008,49176,49176,49152,49176,49464,49632,49680,49608,
     2  49656,49776,49848,49896,49872,49872,49944,50160,50256,50328,
     3  50160,50088,50136,50232,50232,50472,50760,50928,51048,51120,
     4  51168,51360,51528,51600,51744,51840,51840,51960,51936,51960,
     5  52080,51936,51960,51936,51984,52104,52176,52176,52152,51984,
     6  51960,51960,51840,51672,51624,51648,51912,51960,52080,52128,
     7  52152,52248,52272,52656,52800,52896,53040,53088,53280,53424,
     8  53376,53400,53376,53232,53232,53136,53040,53064,52992,53016,
     9  52968,52800,52728,52752,52488,47592,47688,47808,47904,48000/
            data (jx(i),i=  701,  800)/
     +  65880,65928,48072,48120,48096,48168,48336,48648,66072,66240,
     1  66216,66048,66000,65928,65904,66024,66048,66120,66192,66312,
     2  66456,66552,66600,66744,66912,66840,66984,67152,67152,67008,
     3  66816,66936,67032,67176,67272,67272,66816,66792,66576,66552,
     4  66528,66336,66264,66192,66072,66000,52848,53040,53280,53280,
     5  52992,53160,53376,53568,53784,54144,54192,54456,54696,54816,
     6  55200,65832,65712,65688,65736,65688,65736,65712,65472,65328,
     7  64896,64824,64752,64776,64632,64200,64032,63480,63360,63360,
     8  63240,63168,63048,63048,63024,63000,62928,62952,63024,63120,
     9  63312,63312,63264,63288,63288,63192,63240,63216,63240,63192/
            data (jx(i),i=  801,  900)/
     +  63120,63120,63024,63048,63000,63024,62832,62880,62880,62736,
     1  62664,62688,62568,62616,62568,62448,62328,61944,61780,61776,
     2  60264,62640,62664,61776,61896,62040,62112,62208,62232,62424,
     3  62544,62688,62664,62592,62616,62496,62424,62424,62136,61872,
     4  61968,61800,61848,61824,61896,61776,61776,61752,61704,61656,
     5  61608,61584,61272,61248,61344,61272,61536,61512,61512,61464,
     6  61392,61320,61248,61200,61152,61128,61176,61296,61320,61344,
     7  61368,61344,61344,61224,61296,61176,61152,61152,61224,61296,
     8  61512,61368,61368,61320,61248,61200,61152,61080,60936,60936,
     9  60792,60696,60744,60744,60720,60744,60768,60936,60936,60888/
            data (jx(i),i=  901, 1000)/
     +  60936,61008,61176,61176,61152,61104,61008,60864,61272,61344,
     1  61008,60792,60624,60600,60528,60456,60216,60168,60144,62256,
     2  62280,62184,62256,62160,62136,62208,62088,62088,62016,62040,
     3  61992,61896,61944,61896,61896,61920,61920,61944,62040,62040,
     4  62112,62112,62040,62136,62088,62040,62064,62112,62232,62136,
     5  60192,60192,60144,60096,60072,60144,60120,60216,60408,60504,
     6  60600,61008,61080,61080,61056,61128,61320,61464,61488,61416,
     7  61440,61392,61440,61440,61224,61128,61056,60864,60816,60936,
     8  61008,61176,61488,61464,61248,61368,61440,61608,61584,61560,
     9  61512,61368,61344,61416,61440,61368,61464,61392,61128,61080/
            data (jx(i),i= 1001, 1100)/
     +  61128,61224,61440,61488,61488,61536,61560,61632,61512,61656,
     1  61656,61560,61512,61368,61368,61320,61248,61248,61200,61128,
     2  61080,61008,60936,60912,60912,60840,60912,61032,61104,61152,
     3  61176,61224,61320,61296,61344,61440,61416,61464,61464,61392,
     4  61392,61440,61560,61608,61632,61584,61584,61680,61704,61656,
     5  61680,61776,61800,61872,62016,62256,62232,62232,62160,62160,
     6  62492,62856,62616,62568,62472,62088,62040,62184,62184,62160,
     7  62232,62232,62256,62472,62496,62424,62304,62256,62256,62184,
     8  62280,62256,61968,61944,62088,62064,61944,61872,61920,61680,
     9  61776,61656,61584,61488,61512,61464,61392,61392,61272,61080/
            data (jx(i),i= 1101, 1200)/
     +  61320,61368,61344,61344,61464,61416,61464,61800,61848,62040,
     1  62184,62256,62256,62304,62160,62256,62352,62328,62520,62616,
     2  62688,62640,62496,62376,62232,61848,61800,61872,61872,61776,
     3  61824,61656,61680,61608,61104,61272,61632,61752,61776,61824,
     4  61872,61752,61800,61800,61752,61560,61416,61416,61296,61224,
     5  61224,61344,61488,61800,61776,61920,62016,62064,62136,62160,
     6  62184,62040,61896,61392,61248,61296,61272,60864,60816,60792,
     7  60792,60648,60552,60528,60504,60432,60480,60408,59760,15528,
     8  13824,12552,12528,12576,12600,12528,12456,12456,12504,12480,
     9  12408,12240,11736,11568,11496,11376,11352,11424,11424,11304/
            data (jx(i),i= 1201, 1300)/
     +  11016,10824,10536,10512,10296,10176, 9840, 9696, 9552, 9168,
     1   9144, 9000, 9096, 9072, 9144, 9072, 9120, 9192, 9192, 8952,
     2   8952, 9024, 9024, 8880, 8784, 8640, 8616, 8520, 8328, 8160,
     3   8184, 8256, 8280, 8376, 8496, 8472, 8400, 8184, 8088, 7992,
     4   7896, 7968, 7944, 7896, 7968, 7992, 8112, 8160, 8112, 8088,
     5   8352, 8472, 8352, 8328, 8208, 8256, 8184, 8208, 8304, 8664,
     6   8976, 9048, 9072, 8904, 8784, 8712, 8400, 8400, 8352, 8328,
     7   8376, 8376, 8256, 8208, 8136, 8088, 8136, 8088, 8136, 8064,
     8   8064, 7992, 7848, 7824, 7728, 7608, 7560, 7512, 7632, 7632,
     9   7560, 7536, 7392, 7224, 7056, 7152, 7128, 7272, 7296, 7272/
            data (jx(i),i= 1301, 1400)/
     +   7152, 7104, 6888, 6936, 6912, 7440, 7440, 7608, 7680, 7680,
     1   7608, 7656,57072,59712,59760,59472,59328,59208,59208,59184,
     2  59064,59160,59136,58992,59064,59088,58944,58752,58704,58752,
     3  58752,58584,58392,58488,58392,58344,58296,58344,58440,58440,
     4  58320,58080,57984,57912,57840,57792,57864,57768,57672,57696,
     5  57552,57552,57768,57840,57816,57624,57552,57456,57384,57384,
     6  57336,57288,57360,57432,57336,25416,24480,23352,23256,22224,
     7  20472,19680,19344,17064,15336,15384,57360,57264,57288,57072,
     8  57024,57000,57000,56976,56952,56880,56952,56976,56976,57024,
     9  57072,57216,57192,57120,57048,57024,57072,56904,57120,57072/
            data (jx(i),i= 1401, 1500)/
     +  57000,57024,57096,57072,56976,56904,56856,56880,56880,57000,
     1  56928,56736,56760,56832,56736,56808,56784,56832,56784,56856,
     2  56832,49440,48216,49464,49392,49248,49248,48984,48744,49008,
     3  49032,48840,48792,48648,48552,48312,48216,48144,48000,47856,
     4  47616,47544,47592,47112,47112,47040,46992,47064,46944,46920,
     5  46752,41424,46536,46512,46272,46080,45888,45792,45672,45696,
     6  45864,46080,46224,46344,46464,46536,46560,46632,46656,46560,
     7  46416,46440,46584,46584,46704,46752,46752,46920,46920,47016,
     8  46944,46992,46968,47040,46968,46896,46824,46680,46752,46728,
     9  46872,46920,46752,46656,46632,46704,46584,46560,46608,46536/
            data (jx(i),i= 1501, 1600)/
     +  46848,46848,47064,47112,47208,47208,47304,47400,47400,47520,
     1  47448,47544,47496,47400,47424,47376,47400,47256,47256,47088,
     2  47232,47160,47136,47064,47064,46968,46968,46920,46752,46776,
     3  46536,46584,46488,46488,46296,46296,46248,46104,46080,46056,
     4  45984,46032,46224,46200,46224,46200,46224,46128,46176,46224,
     5  46176,45984,45936,45960,45912,45912,45816,45768,45744,45696,
     6  45672,45480,45528,45480,45432,45456,45408,45408,45288,45288,
     7  45192,45144,45096,45240,45216,45120,45072,44880,44856,44712,
     8  44640,44424,44280,44256,44136,44160,43848,43824,43872,43896,
     9  43896,43728,43704,43512,43512,43416,43608,43320,42912,42096/
            data (jx(i),i= 1601, 1700)/
     +  41472,41376,41256,41376,41304,41304,41184,41328,41040,40680,
     1  40656,40248,40152,40128,40248,40392,40488,40536,40464,40440,
     2  40416,40128,40224,40224,40176,40056,39984,39936,39720,39792,
     3  39864,39840,39960,39864,39912,39912,39960,39960,39984,39984,
     4  39912,39768,39648,39648,39600,39528,39168,38976,38976,38832,
     5  38640,38616,38952,38304,38568,38592,38256,38256,38352,38256,
     6  38376,38280,38184,38208,38136,38088,37920,37992,37968,37944,
     7  37896,37896,37824,37824,37800,37728,37704,37776,37776,37824,
     8  37920,37824,37896,37944,38064,37704,37656,37656,37608,37536,
     9  37488,27312,27192,27192,27120,26928,26880,26832,26808,26712/
            data (jx(i),i= 1701, 1800)/
     +  26688,26520,26472,26280,26016,25776,25608,37536,37584,37560,
     1  37464,37536,37536,37536,37560,37512,37320,37368,37296,37334,
     2  37296,37224,37224,37080,37080,37032,37056,36912,36936,36912,
     3  36960,37104,37224,37224,37104,37008,36936,36984,36888,36792,
     4  36816,36624,36600,36576,36600,36624,36744,36744,36840,36936,
     5  36816,36696,36600,36576,36552,36456,36264,36360,36216,36528,
     6  36696,36576,36600,36504,36504,36576,36648,36672,36600,36672,
     7  36744,36768,36888,36864,36936,37008,36816,36816,36720,36720,
     8  36648,36432,36456,36408,36360,36072,35856,35784,35784,35640,
     9  35520,35544,35520,35472,35448,35400,35304,35256,35112,34992/
            data (jx(i),i= 1801, 1900)/
     +  34824,34704,34656,34440,34464,34368,34368,34224,34080,34080,
     1  34008,34032,34008,33912,33984,33936,33912,33696,33576,33504,
     2  33432,33360,33240,33072,33072,32976,32976,32904,32880,32928,
     3  32832,32856,32736,32640,32568,32544,32424,32400,32136,32064,
     4  31824,31848,31776,31776,31704,31632,31656,31608,31584,31488,
     5  31488,31440,31344,31200,31152,31128,30984,30936,30816,30504,
     6  30432,30408,30264,30192,30168,30072,30024,29856,29808,29736,
     7  29688,29736,29568,29352,29208,29184,29112,29064,28944,28872,
     8  28632,28608,28560,28584,28560,28248,28104,28056,27840,27648,
     9  27624,27504,27504,27528,27504,27384,27384,27336,56880,56880/
            data (jx(i),i= 1901, 2000)/
     +  56976,56952,57000,57048,57264,57264,57384,57408,57624,57648,
     1  58152,58200,58104,58080,58296,58728,58704,58752,58872,58968,
     2  59184,59256,59208,59112,59064,59136,59208,59328,59448,59400,
     3  59520,59592,59616,59568,59448,59448,59496,59376,59376,59208,
     4  59040,58800,58656,58464,58416,58368,58392,58584,58680,58728,
     5  58632,58392,58176,58248,58152,57768,57528,57528,57384,57336,
     6  57264,57240,57120,57072,57120,57168,57288,57144,57096,57000,
     7  56880,56904,56904,56832,56952,56976,56952,56928,56760,56616,
     8  56568,56616,56736,56784,56592,56496,56424,56472,56520,56448,
     9  56232,56208,56232,56160,56184,56136,55968,56016,55992,55968/
            data (jx(i),i= 2001, 2100)/
     +  56208,56184,56088,56016,56088,56112,56016,56136,56112,56280,
     1  56256,56160,56160,56136,56064,55920,55920,55848,55872,55848,
     2  55920,55824,56040,55968,55968,55920,55752,55872,55848,55680,
     3  55728,55800,55800,55728,55776,55776,55608,55512,55200,55152,
     4  55056,55080,55008,54912,54720,54648,54456,54288,53856,53736,
     5  53640,53520,53376,53376,53280,53304,53424,53424,53256,52800,
     6  52704,52632,52344,52152,52080,52056,52104,52080,52152,52224,
     7  52224,52104,51768,51840,51960,52032,52008,52080,52080,52056,
     8  51984,51888,51648,51696,51768,51816,51624,51576,51456,51480,
     9  51576,51624,51288,50760,50616,50760,50952,50928,51096,51096/
            data (jx(i),i= 2101, 2200)/
     +  50952,50760,50664,50472,50256,49752,50064,49944,49968,49944,
     1  49896,49800,49752,49776,49632,49464,49464,49536,49536,17448,
     2  17208,17184,16992,16968,16944,16752,16728,16728,16680,16728,
     3  16728,16752,16752,16776,16728,16680,16704,16728,30432,30408,
     4  30360,30288,30288,30216,30192,30168,30120,37368,37416,37416,
     5  37416,37416,37440,37440,37464,37464,37488,37464,37488,37488,
     6  37464,37440,37440,37416,37440,37416,37440,37416,37440,37440,
     7  37440,37464,37464,37464,37416,37440,37440,37440,37440,37464,
     8  37440,37464,37440,37464,37440,37464,37440,37464,37440,37464,
     9  37440,37440,37464,37440,37464,37464,37488,37488,37512,37536/
            data (jx(i),i= 2201, 2300)/
     +  37560,37560,37584,37608,37584,37608,37656,37656,37680,37704,
     1  37728,37728,37728,37704,37728,37704,37728,37704,37728,37728,
     2  37728,37728,37728,37728,37728,37728,37752,37728,37752,37752,
     3  37752,37728,37752,37752,37776,37776,37776,37800,37824,37800,
     4  37800,37776,37776,37776,37776,37776,37776,37800,37824,37824,
     5  37848,37848,37872,37920,37944,37968,37968,37992,37992,37992,
     6  38016,37992,38016,37992,37296,36504,36480,35712,35424,34680,
     7  34512,33840,32280,31296,31248,16152,16032,15648,15624,14616,
     8  14544,14424,14376,14256,14184,14112,14040,13968,13920,13848,
     9  13680,13656,13512,13416,13320,13272,13176,13008,12960,12888/
            data (jx(i),i= 2301, 2400)/
     +  12840,12792,12744,12576,12504,12480,12456,12384,12336,12288,
     1  12240,12216,12216,12216,12144,12120,12072,12000,11976,11904,
     2  11712,11664,11616,11520,11472,11424,11376,11304,11112,11040,
     3  10992,10920,10800,10728,10680,10632,10632,10656,10656,10680,
     4  10680,10680,10680,10632,10632,10584,10512,10464,10392,10344,
     5  10296,44472,44544,44544,44592,44592,44640,44712,44736,44760,
     6  44760,44976,45840,45960,46032,46176,46176,46200,46248,46272,
     7  46296,46344,46368,46392,46416,46440,46464,46488,46512,46536,
     8  46584,46632,46680,46704,46752,46800,46824,46872,46896,46920,
     9  46920,46968,46896,46896,46944,46992,47040,47064,47184,47208/
            data (jx(i),i= 2401, 2500)/
     +  47256,47256,47280,47232,47232,47280,47304,47280,47232,47256,
     1  47280,47256,47232,47232,47208,47232,47256,47256,47328,47400,
     2  47448,47448,47400,47400,47400,47400,47376,47400,30120,30048,
     3  30024,30000,28968,28920,27936,27672,25944,25560,25176,23928,
     4  23712,23304,23256,22608,22536,22488,22440,22416,22416,22392,
     5  22368,22344,22320,22344,22296,22296,22272,22272,22272,22224,
     6  22200,22176,22128,22080,22080,22104,22104,22080,22032,22056,
     7  22032,22032,22080,22080,22056,22032,21960,21912,21840,21792,
     8  21744,21720,21696,21648,21576,21528,21480,21432,21384,21360,
     9  21288,21264,21264,21240,21192,21144,21120,21096,21024,21000/
            data (jx(i),i= 2501, 2600)/
     +  20952,20904,20784,20736,20712,20664,20640,20592,20592,20592,
     1  20568,20544,20520,20472,20424,20400,20424,20400,20424,20400,
     2  20400,20376,20400,20400,20376,20376,20352,20352,20256,20232,
     3  20160,20136,20136,20064,20040,20016,20016,20040,20064,20088,
     4  20064,20088,20064,20064,20016,20040,19992,19968,19992,19968,
     5  19968,19920,19896,19896,19848,19872,19848,19824,19872,19872,
     6  19848,19800,19848,19824,19800,19752,19752,19752,19752,19704,
     7  19704,19656,19656,19632,19608,19560,19512,19488,19464,19440,
     8  19392,19368,19344,19272,19248,19224,19176,19176,19152,19128,
     9  19080,19056,19080,19080,19152,19128,19152,19128,19128,19104/
            data (jx(i),i= 2601, 2700)/
     +  19176,19200,19224,19248,19296,19320,19296,19296,19320,19320,
     1  19248,19272,19248,19272,19296,19272,19248,19248,19272,19296,
     2  19344,19344,19320,19320,19368,19416,19440,19464,19440,19512,
     3  19512,19536,19560,19560,19512,19464,19416,19344,19272,19248,
     4  19272,19248,19224,19152,19128,19152,19128,19080,19056,19032,
     5  18984,19008,19032,18984,18960,18936,18912,18912,18864,18840,
     6  18816,18816,18720,18720,18696,18624,18624,18552,18528,18504,
     7  18456,18432,18408,18336,18336,18360,18432,18456,18456,18408,
     8  18408,18360,18432,18432,18408,18408,18384,18384,18336,18336,
     9  18312,18288,18264,18216,18192,18168,18240,18312,43776,43776/
            data (jx(i),i= 2701, 2800)/
     +  43776,43728,43728,43728,43680,43584,43536,43416,43368,43344,
     1  43296,43176,43080,43032,42984,42984,42960,42936,42792,42672,
     2  42624,42576,42552,42528,42336,42240,42216,42096,42024,42048,
     3  42048,42048,42072,42072,42048,42048,42000,42072,42072,42048,
     4  42048,42048,42096,42120,42144,42144,42144,42120,42072,42024,
     5  41952,41904,41880,41904,41952,42000,42024,42048,42072,42120,
     6  42240,42264,42312,42360,42432,42456,42504,42504,42480,37968,
     7  37968,37896,37728,37704,37704,37776,37824,37872,37944,38040,
     8  38088,38112,38112,38112,38112,38112,38112,38112,38112,38088,
     9  43368,43224,42864,42456,42336,41832,41808,41304,41136,40800/
            data (jx(i),i= 2801, 2900)/
     +  40512,40272,39840,39768,39240,39168,38736,38520,65808,65808,
     1  65688,65688,65592,65568,65568,65568,65544,65544,65544,65544,
     2  65520,65424,65232,65088,29784,29832,29832,29880,29904,29904,
     3  29952,63360,63312,63312,63288,63192,63144,63096,63072,63072,
     4  63048,63048,62976,62976,62928,62904,62928,62952,62928,62904,
     5  62880,62832,62808,62808,62760,62760,62784,62760,62784,62784,
     6  62832,62784,62808,62808,62712,62664,62640,62664,62640,62664,
     7  62616,62640,62592,62568,62592,62568,64440,64488,64512,64464,
     8  64464,64440,64488,64512,64536,64560,64584,64536,64536,64560,
     9  64560,64536,64512,64512,64512,64488,64416,64392,64368,64344/
            data (jx(i),i= 2901, 3000)/
     +  64248,64248,64200,64152,64152,64176,64176,64200,64224,64200,
     1  64224,64224,64200,64200,64176,64176,64224,64200,64200,64152,
     2  64176,64152,64152,64104,64080,64080,64032,64032,64056,64080,
     3  64056,64080,64080,64104,64080,64080,64128,64128,64128,64128,
     4  64128,64104,64080,64104,64080,64104,64152,64152,64200,64224,
     5  64224,63720,63624,65904,65832,65808,65712,65688,65616,65568,
     6  65568,65520,65520,65496,64824,64800,64416,44496,44496,44496,
     7  44472,44424,44376,44208,44184,44088,44016,43992,43968,43920,
     8  43896,43872,43872,43968,43968,43944,43848,43824,43800,43776,
     9  37944,37968,37944,37992,38016,38016,38016,37968,37968,37992/
            data (jx(i),i= 3001, 3100)/
     +  37968,37992,38064,38088,38088,38088,38064,38016,38040,38016,
     1  38040,37992,37992,37992,37968,37944,37944,37896,37896,37896,
     2  37968,37992,38040,38064,38040,38064,38064,38112,47184,47064,
     3  46608,46560,46368,45912,45864,45384,45288,44736,38040,37992,
     4  37944,37920,37896,37896,37800,37800,37824,37824,37800,37704,
     5  37704,37584,37536,37512,37536,37512,37488,37344,37320,37272,
     6  37248,37224,37200,37152,37080,36984,36960,36936,36864,36792,
     7  36744,36696,36648,36624,36600,36528,36528,36480,36432,36408,
     8  36360,36264,36264,36240,36216,36072,35976,35904,35856,35040,
     9  34728,34008,32880,31944,31176,30936,30384,63336,63312,63336/
            data (jx(i),i= 3101, 3200)/
     +  65160,65160,64848,64800,64392,64320,64320,64296,64128,64128,
     1  64080,64056,63864,63816,21984,22080,22200,22248,22296,22392,
     2  21480,20832,20760,19848,18696,15456,15936,15960,15960,15984,
     3  16008,16008,16032,16056,16056,16080,16080,16152,16104,16128,
     4  16152,16224,16200,16152,16152,16152,16104,16080,16056,16032,
     5  15984,15960,15936,15936,15960,15936,15960,15960,15984,16008,
     6  16080,16080,16104,16176,16200,16248,16344,16392,16416,16464,
     7  16512,16512,16536,16512,16512,16512,16584,16608,16608,16632,
     8  16680,16752,16800,16944,16968,17064,17088,17064,17064,17040,
     9  16944,16896,16824,16824,16776,16752,18456,17616,16632,15480/
            data (jx(i),i= 3201, 3300)/
     +  14184,12984,12936,12240,11304,10680, 9792, 8784, 8472, 8136,
     1  65832,65760,65736,65712,65712,65712,65712,65664,65616,65616,
     2  65496,51048,51480,51504,52056,52176,49104,49440,49608,49920,
     3  50064,50472,50592,50976,51024,66000,62232,62208,62160,62160,
     4  62136,62088,62016,61992,61968,61920,61896,61824,61800,61752,
     5  61728,61752,61728,61728,61704,61656,61656,61680,61632,61608,
     6  61584,61560,61464,61416,61368,61344,61296,61176,60504,60456,
     7  60000,59616,59568,58872,58728,58224,58104,57432,57288,56688,
     8  56520,65280,65304,65304,65352,65328,65352,29736,29664,29640,
     9  29616,29616,29568,63408,63456,63480,63504,63600,63360,63480/
            data (jx(i),i= 3301, 3400)/
     +  23976,22920,22848,21768,21816,21888,28584,28200,27168,27024,
     1  26424,25920,25248,63168,63192,63216,63216,63216,63216,62832,
     2  62784,62616,55968,55920,55920,55872,55800,55776,55704,38856,
     3  38856,38856,38736,38760,38760,38784,38784,38760,38736,38736,
     4  38736,38736,38736,38736,38688,38688,38688,38664,38688,38712,
     5  38712,38664,38664,38664,38640,38592,38568,38592,38592,38544,
     6  38496,38496,38496,38472,38472,38448,38448,38496,38472,38472,
     7  38496,38448,38424,38424,38424,38376,38376,38328,38328,38304,
     8  38280,38208,38184,38208,38232,38208,38184,38160,38112,38136,
     9  38136,38160,38160,44472,44496,44544,44592,44664,44712,44736/
            data (jx(i),i= 3401, 3500)/
     +  44760,44760,44808,44856,44976,45024,45048,45048,45072,45072,
     1  45072,45024,44976,44928,44904,44880,44880,44880,44808,44784,
     2  44760,44664,44616,44544,44496,44424,44352,44232,44160,44136,
     3  44112,44088,44064,44064,44112,44160,44208,44232,44232,44256,
     4  44232,44160,44112,44112,44088,44064,44040,43968,43920,43800,
     5  43752,43752,43800,43800,43800,43824,43800,43776,43728,43704,
     6  43680,43680,43632,43632,43632,43584,43560,43536,43536,43440,
     7  43440,43416,43392,43152,42888,42696,42360,42288,41856,41544,
     8  41328,41088,40824,40584,40296,40128,39816,39480,39288,38856,
     9  38880,38928,38952,38976,38976,38952,38928,39000,39000,39024/
            data (jx(i),i= 3501, 3600)/
     +  39024,39000,38976,39048,39096,39168,39192,39192,39240,39264,
     1  39288,39264,39264,39288,39312,39336,39360,31704,31752,31752,
     2  31776,31776,31800,31152,31128,30312,30096,38832,38592,38304,
     3  38064,37680,37560,37032,36528,36384,36024,35736,35496,35112,
     4  34968,34464,33840,33816,33216,33192,32544,32448,62136,62136,
     5  62112,62088,62088,62040,62016,61992,61992,61968,61944,61920,
     6  61872,61848,61848,61944,61944,61968,61968,61944,61944,61944,
     7  61920,61872,61848,61872,61848,61896,61872,61872,61896,61896,
     8  61896,61920,61992,62040,62064,62064,62088,62136,62160,62208,
     9  62232,62256,62280,62328,62376,62520,62544,62520,62448,62400/
            data (jx(i),i= 3601, 3700)/
     +  62328,62304,62232,62208,62208,62160,62136,62136,62160,62160,
     1  62112,62064,62040,61944,61872,61800,61680,61608,61560,61512,
     2  61488,57336,57024,56856,56280,56160,56112,56088,56064,56016,
     3  55992,61080,60984,60600,60360,60120,59880,59616,59592,58896,
     4  58632,58584,58080,57960,57432,61824,61824,61824,61848,61872,
     5  61896,57456,57480,57504,57552,57600,57648,57648,57672,57768,
     6  57768,57816,57840,57840,57864,57864,57888,57984,57984,58080,
     7  58104,58128,58104,58128,58128,58152,58176,58200,58200,58176,
     8  58176,58224,58248,58296,58320,58344,58368,58416,58488,58512,
     9  58536,58536,58584,58512,58536,58584,58536,58608,58608,58632/
            data (jx(i),i= 3701, 3800)/
     +  58632,58728,58728,58752,58752,58776,58800,58920,58992,59040,
     1  59064,59112,59088,59112,59136,59160,59160,59208,59232,59208,
     2  59184,59160,59208,59208,59232,59232,59256,59256,59232,59256,
     3  59328,59280,59304,59280,59304,59304,59352,59376,59376,59376,
     4  59376,59376,59424,51072,51072,51096,51096,51144,51144,51192,
     5  51216,51240,51240,51288,51288,51312,51336,51360,51384,51384,
     6  51408,60192,60144,60048,60024,59928,59904,59808,59784,59760,
     7  59712,59688,59736,59736,59736,59688,59640,59592,59544,59472,
     8  60264,60312,60456,60312,60336,60312,60312,60264,60240,60264,
     9  60288,60288,60336,62328,61944,61896,61872,61800,61680,61656/
            data (jx(i),i= 3801, 3900)/
     +  61632,61608,61704,54072,54048,53976,53928,53880,53808,53784,
     1  53736,53712,53688,53688,53664,53640,53568,53520,53496,53424,
     2  53400,53352,53280,53256,53232,53208,53208,53184,53136,53040,
     3  52992,52944,52848,52824,52824,52824,52776,52752,52680,52656,
     4  52584,52560,52488,52440,52344,52296,52200,52128,52104,52080,
     5  52032,52008,51960,51912,51864,51864,51840,51768,51744,51672,
     6  51624,51576,51480,51432,55920,55872,55848,55824,55824,55872,
     7  55896,55920,55896,55896,55920,55944,55944,55920,55896,55872,
     8  55872,55848,55872,55848,55848,55848,55824,55800,55800,55824,
     9  55824,55800,55824,55776,55776,55824,55824,55800,55776,55776/
            data (jx(i),i= 3901, 4000)/
     +  55752,55728,55680,55632,55560,55560,55488,55464,55440,55440,
     1  55368,55320,55272,55200,55176,55176,55080,55080,55080,54960,
     2  54936,54936,54912,54888,54912,54912,54864,54840,54816,54840,
     3  54888,54888,54912,54912,54840,54840,54816,54792,54768,54744,
     4  54768,54720,54672,54648,54576,54576,54552,54528,54504,54504,
     5  54456,54432,54480,54480,54504,54504,54480,54408,54384,54384,
     6  54360,54288,54264,54192,54120,54096,62160,47856,47808,47808,
     7  47808,47760,47736,47808,47808,47760,47808,47784,47808,47808,
     8  47808,47784,47784,47856,47880,47808,47808,47856,47880,47904,
     9  47904,47832,47832,47880,47904,47904,47928,47928,47952,47976/
            data (jx(i),i= 4001, 4100)/
     +  48000,48048,48072,48096,48072,48144,48144,48192,48192,48144,
     1  48168,48192,48216,48192,48192,48240,48288,48312,48312,48312,
     2  48312,48264,48240,48264,48264,48264,48240,48192,48216,48192,
     3  48168,48144,48144,48096,48096,48096,48120,48144,48168,48168,
     4  48144,48144,48144,48120,48144,48216,48192,48192,48168,48120,
     5  48096,48096,48072,48024,48024,48000,51384,51336,51336,51360,
     6  51384,51408,51384,51360,51360,51384,51456,51480,51480,51432,
     7  51456,51264,51216,51168,51120,51072,51024,50952,50880,50784,
     8  50736,50736,50784,50808,50784,50760,50712,50592,50568,50568,
     9  50544,50472,50424,50400,50352,50352,50280,50304,50280,50256/
            data (jx(i),i= 4101, 4200)/
     +  50208,50160,50160,50088,49992,49920,49872,49848,49848,49776,
     1  49752,49728,49728,49776,49800,49800,49728,49728,49656,49632,
     2  49680,49680,49656,49608,49608,49584,49584,49608,49608,49584,
     3  49536,49512,49512,49488,49464,49440,49464,49440,49416,49368,
     4  49344,49272,49248,49200,49176,49128,49080,49032,49008,48984,
     5  48960,48912,48888,48864,48792,48744,48696,48600,48528,48480,
     6  48360,48336,48360,48384,48360,48312,48264,48264,48240,48216,
     7  48192,48096,48072,48024,47976,47976,47976,48000,48000,47976,
     8  47952,47904,54960,54936,54888,54864,54864,54816,54744,54768,
     9  54720,54696,54672,54624,54552,54504,54504,54480,54408,54360/
            data (jx(i),i= 4201, 4300)/
     +  54336,54264,54264,54288,54288,54216,54120,54048,54048,54096,
     1  54096,54072,54096,54120,54120,54120,54072,59376,59376,59352,
     2  59352,59352,59088,58824,58776,58680,58704,58680,58704,58704,
     3  58656,58680,58656,58656,58680,58656,58656,58608,58584,58560,
     4  58536,58560,58560,58512,58464,58464,58440,58392,58392,58368,
     5  58368,58320,58296,58248,58104,58056,58032,58032,58032,58032,
     6  57984,57912,57864,57816,57624,57552,57408,57384,57408,57384,
     7  57408,57360,57360,57336,57288,57288,57312,57312,57264,57192,
     8  57192,57192,57192,57168,57168,57144,57072,57024,57024,56976,
     9  56976,56976,56928,56928,56904,56904,56856,56856,56856,56856/
            data (jx(i),i= 4301, 4400)/
     +  56928,56976,56952,56856,56856,56880,56904,56904,56856,56832,
     1  56808,56760,56712,56688,56688,56664,56616,56568,56448,56424,
     2  56400,56400,56376,56352,56328,56280,56256,56304,56280,56208,
     3  56160,56136,56112,55968,55872,55776,55704,55680,55656,55584,
     4  55560,55560,55512,55368,55320,55272,55272,55200,55176,55152,
     5  55128,55128,55080,55032,55032,54960,54960,54984,55008,39456,
     6  39480,39504,39552,39600,39648,39696,39696,39768,39792,39792,
     7  39816,39840,39840,39840,39792,39816,39864,39864,39840,39816,
     8  39768,39768,39744,39696,39672,39672,39600,39600,39672,39672,
     9  39744,39768,39816,39840,39840,39840,39864,39912,39936,39984/
            data (jx(i),i= 4401, 4500)/
     +  40032,40104,40128,40176,40200,40176,40176,40176,40176,40176,
     1  40176,40200,40200,40200,40200,40200,40200,40200,40200,23928,
     2  23832,23736,23712,23688,23520,23472,23472,23424,23376,23256,
     3  18456,18216,18168,18072,17856,17832,17712,17592,17424,22152,
     4  21600,21576,21264,20568,19536,19176,18768,30336,30240,29184,
     5  27816,27744,27144,26832,26256,25800,25776,25176,25104,24048,
     6  31680,31632,31632,31608,31608,31560,31560,31536,31512,31488,
     7  31464,39720,39672,39288,39144,38832,38640,38568,37968,37704,
     8  37248,36864,36456,36096,35808,35592,35040,34536,34416,33864,
     9  33768,33120,32760,32616,32040,31488,47832,47760,47736,47736/
            data (jx(i),i= 4501, 4600)/
     +  47784,47856,47832,47592,47520,47448,47400,47376,47376,47448,
     1  47472,47448,47424,47376,47328,47256,47184,47112,47112,46968,
     2  46872,46800,46728,46680,46632,46608,46608,46680,46584,46560,
     3  46536,46512,46488,46464,46440,46512,46512,46488,46464,46368,
     4  46368,46320,46296,46248,46248,46224,46200,46200,46200,46248,
     5  46272,46272,46248,46200,46152,46152,46152,46152,46152,46080,
     6  45984,45960,45936,45888,45744,45720,45696,45648,45600,45624,
     7  45552,45504,45432,45408,45312,45264,45216,45168,45120,45120,
     8  45120,45144,45168,45216,45216,45240,45312,45288,45264,45288,
     9  45312,45336,45360,45360,45336,45216,45168,45120,45000,44952/
            data (jx(i),i= 4601, 4700)/
     +  44880,44832,44760,44712,44664,44664,44688,44640,44640,44616,
     1  44616,44568,44472,44376,44256,44232,44184,44112,44064,43920,
     2  43872,43848,43848,43752,43752,43776,43776,43752,43704,43680,
     3  43680,43680,43680,43704,54624,54552,54504,54336,54336,54168,
     4  54168,54192,54168,54168,54072,54024,54024,54024,53928,53832,
     5  53808,53736,53760,53736,53664,53520,53448,53448,53376,53304,
     6  53160,53136,55488,55512,55296,55200,55176,54912,54840,54744,
     7  54384,54096,53952,53688,53640,53616,53376,61968,61728,61536,
     8  61464,61056,60744,60576,60072,59904,59736,59424,59256,58944,
     9  58872,58464,58368,58032,57792,57432,57408,56952,56736,56472/
            data (jx(i),i= 4701, 4800)/
     +  56400,55872,46368,46416,46464,46488,46536,46584,46608,46632,
     1  46656,46656,46608,46608,46632,46656,46704,46704,46656,46632,
     2  46632,46680,46704,46704,46296,46248,46200,46200,46200,46248,
     3  46272,46296,46320,46296,53112,52824,52752,52464,52440,51840,
     4  51816,51576,51264,51216,51048,50640,50424,50160,49896,49800,
     5  49488,49128,49080,48816,48456,48408,48216,48192,47952,48000,
     6  48000,48000,47472,47448,47088,47064,46464,30288,40224,40200,
     7  40200,46344,46320,46296,46272,46224,46272,46272,46248,46176,
     8  46152,46176,46248,46248,46152,46104,46080,46080,46104,46176,
     9  46200,46200,46104,46104,46104,46056,45768,45384,45288,45336/
            data (jx(i),i= 4801, 4900)/
     +  45384,45408,45432,45432,45456,45528,45552,45576,45624,45648,
     1  45624,45648,45624,45600,45552,45552,45552,45528,45504,45432,
     2  45000,44736,44352,44016,43968,43680,43176,43152,42696,42408,
     3  42312,41784,41736,41424,41112,40848,45432,45456,45576,45600,
     4  45576,45600,45624,45696,45720,45720,45696,45720,45672,45648,
     5  45600,45576,45600,45648,45672,45648,45672,45696,45672,45648,
     6  45624,45600,45576,45576,45600,45648,45672,45696,45720,45768,
     7  45720,45720,45720,45768,45816,45840,45864,45816,45816,45912,
     8  45936,45936,45912,45888,45840,45816,45816,45864,45912,45960,
     9  45984,45984,46032,46056,46104,46032,46008,46056,46080,46128/
            data (jx(i),i= 4901, 5000)/
     +  46152,46152,46128,46080,47976,47784,47760,47280,47232,47016,
     1  46776,46608,46224,46152,17400,17232,17232,17136,17088,16992,
     2  16968,16896,16896,16896,16872,16824,16752,16728,16656,16560,
     3  16536,16416,16392,16392,16392,16368,16392,16416,16416,16392,
     4  16368,16344,16368,16368,16368,16368,16344,16320,16320,16368,
     5  16368,16368,16368,16344,16320,16272,16248,16296,16248,16248,
     6  15264,15024,13824,13176,12648,12000,11832,11616,11328,11232,
     7  11256,11280,11280,11352,11376,11472,11976,51096,50784,50256,
     8  50232,49680,49608,49176,49152,48696,48240,47976,52632,52632,
     9  52704,52752,52848,52920,52944,52920,52944,52944,52992,53040/
            data (jx(i),i= 5001, 5100)/
     +  53064,53136,53184,53304,53376,53448,53520,53568,53640,53688,
     1  53736,53784,53784,53808,53856,53904,53928,54000,54096,54120,
     2  54168,54144,54168,54216,54288,54312,54312,54312,54456,54504,
     3  54504,54504,54528,54576,54624,54648,54720,54768,54816,54888,
     4  54936,55008,55056,55104,55176,55248,55272,55344,55464,55488,
     5  55464,55440,55488,55464,52272,52104,52056,51864,51504,51384,
     6  51264,54096,53592,53568,53088,53040,52872,59640,59064,58536,
     7  58248,58224,57936,57456,57168,56880,56880,56808,56712,56664,
     8  56544,56520,56544,56520,56520,56184,56136,55656,55536,55416,
     9  55128,55032,54984,54960,54936,54912,54864,54816,54744,54696/
            data (jx(i),i= 5101, 5200)/
     +  54600,54576,54576,54552,54480,54336,54192,40224,40296,40320,
     1  40392,40416,40464,40464,40464,40440,40440,40440,40440,40416,
     2  40392,40392,40344,40344,40368,40344,40320,40296,40296,40272,
     3  40272,40224,40224,40200,40176,40200,40200,40176,40152,40080,
     4  40080,40056,40080,40032,40032,40008,39984,39936,39912,39888,
     5  39888,39864,39840,39840,39816,39816,39792,39744,39720,39720,
     6  39696,39696,39672,39672,39672,39648,39624,39624,39600,39480,
     7  39456,39456,39432,39432,39408,39360,39360,39216,39192,39168,
     8  39144,39096,39072,39024,39024,39000,38928,38856,38832,38832,
     9  38832,38808,38760,38736,38640,38616,38592,38544,38544,38520/
            data (jx(i),i= 5201, 5300)/
     +  38472,38448,38400,38376,38400,38376,38376,38352,38304,38232,
     1  38208,38208,38184,38136,38112,38064,37968,37968,37944,37896,
     2  37848,37824,37848,37752,37752,37728,37704,37656,37608,37584,
     3  37536,37512,37488,37488,37488,37440,37440,37392,37368,37368,
     4  37344,37320,37272,37248,37248,37296,37248,37248,37248,37200,
     5  37152,37128,37104,37104,37152,37152,37128,37104,37056,37056,
     6  37032,37008,36960,36960,36936,36912,36840,36792,36792,36768,
     7  36720,36672,36648,36624,36624,36528,36504,36456,36432,36384,
     8  36312,36288,36240,36192,36168,36168,36192,36168,36192,36192,
     9  36144,36096,36072,36024,36000,36024,36000,35976,35928,35808/
            data (jx(i),i= 5301, 5400)/
     +  35736,35712,35664,35664,35640,35616,35592,35520,35448,35448,
     1  35400,35376,35328,35304,35280,35184,35160,35064,34992,34920,
     2  34872,34824,34776,34704,34704,34680,34680,34680,34632,34608,
     3  34536,34488,34464,34464,34440,34392,34344,34320,34272,34224,
     4  34224,34200,34104,33984,33936,33888,33864,33816,33792,33768,
     5  33744,33744,33768,33768,33792,33792,33816,33816,33840,33840,
     6  33192,32712,32544,31920,31440,31272,40488,40488,40464,40488,
     7  40536,40560,40560,40536,40560,40632,40656,40656,40680,40680,
     8  40728,40752,40728,40776,40776,40824,40824,40896,40920,40944,
     9  40992,40992,40992,44544,44544,44544,44592,44592,44544,44496/
            data (jx(i),i= 5401, 5500)/
     +  44496,44520,44592,44616,44616,44616,44664,44664,44664,44616,
     1  44592,44568,44544,44544,44592,44616,44640,44640,44616,44592,
     2  44592,44544,44496,44472,44544,44568,44568,44544,44496,44496,
     3  44496,44496,44448,44472,44472,44448,44424,44424,44472,44496,
     4  44520,44496,44448,44424,44424,44496,44544,44592,44640,44640,
     5  44616,44568,44544,44520,44520,44520,44568,44616,44640,44664,
     6  44688,44712,44688,44640,44616,44616,44664,44592,44568,44592,
     7  44640,44664,44664,44688,44712,44712,44712,44736,44808,44832,
     8  44784,44736,44712,44736,44856,44880,44904,44880,44760,44736,
     9  44736,44832,44856,44856,44880,44904,44952,44952,44928,44952/
            data (jx(i),i= 5501, 5600)/
     +  45024,45024,45024,45048,45072,45072,45120,45144,45168,45144,
     1  45144,45168,45192,45192,45144,45120,45144,45144,45192,45168,
     2  45192,45216,45264,45264,45216,45192,45168,45192,45216,45216,
     3  45216,45216,45240,45288,45288,45264,45288,45240,45240,45288,
     4  45312,45288,45312,45336,45408,45432,45456,45456,45456,45504,
     5  45528,45528,45504,45456,44424,44208,44184,43416,42624,42288,
     6  41976,41688,41640,41280,16224,16224,16200,16200,16248,16272,
     7  16296,16320,16344,16368,16368,16392,16416,16392,16392,16440,
     8  16464,16488,16512,16608,16632,16656,16656,16608,16488,16440,
     9  16368,16272,16248,16224,16104,16080,16104,16056,16080,16056/
            data (jx(i),i= 5601, 5700)/
     +  16056,16056,16056,16008,16008,16008,15960,15984,15888,15864,
     1  15840,15816,15792,15696,15720,15672,15720,15696,15720,15696,
     2  15648,15648,15672,15696,15720,15744,15816,15840,15912,15888,
     3  15864,15792,15768,15768,15744,15720,15720,15720,15672,15672,
     4  15576,15552,54096,54096,54072,54072,54072,54048,54048,54024,
     5  54000,53976,53952,53952,53952,53928,53928,53880,53856,53880,
     6  53832,53856,53856,53928,54000,54096,54096,54120,54168,54216,
     7  54240,54312,54336,54432,54480,54504,54528,54552,54600,54624,
     8  54648,54672,54672,54792,54864,54888,54912,54984,55080,55128,
     9  55152,55200,55272,55272,55320,55368,55416,55440,55464,55512/
            data (jx(i),i= 5701, 5800)/
     +  55536,55608,55656,55680,55704,55728,55776,55800,55800,55824,
     1  55800,55824,55800,55800,55848,55848,55872,55896,55920,55920,
     2  55944,55944,55920,55992,55992,56016,56040,56064,56064,56088,
     3  56136,56256,56280,56328,56352,56400,56424,56424,56400,56448,
     4  56472,56448,56472,56496,56520,56544,56520,56544,56544,56568,
     5  56544,56568,56568,56592,56592,56592,56640,56664,56664,56688,
     6  56736,56784,56784,56832,56880,56904,56928,56928,56952,56976,
     7  57000,57024,57000,57000,57048,57048,25320,25320,25296,25320,
     8  25320,25296,25344,25632,26112,27456,27528,28584,28632,28944,
     9  29424,29760,29784,29808,29880,29928,29952,29976,30024,30096/
            data (jx(i),i= 5801, 5900)/
     +  30096,30120,30168,30192,30216,30264,23064,22872,22800,22656,
     1  22560,22464,22416,51144,51240,51240,51264,51360,51456,51504,
     2  51528,51624,51672,51696,51816,51816,51912,51960,52008,51984,
     3  52008,52032,52032,52056,52056,52080,52080,52104,52200,52224,
     4  52248,52248,52224,52248,52224,52224,52320,52368,52344,52320,
     5  52344,52320,52272,52296,52224,52224,52176,52200,52200,52176,
     6  52200,52176,52152,52128,52152,52176,52176,52176,52248,52296,
     7  52296,52272,52272,52248,52272,52272,52248,52272,52272,52272,
     8  52320,52344,52392,52416,51816,51120,50928,50688,50280,50184,
     9  49704,49152,49176,49128,49152,49248,49272,49368,49416,49440/
            data (jx(i),i= 5901, 6000)/
     +  49464,49440,49416,48144,48120,48096,48048,48000,47976,47976,
     1  47976,48000,48024,48024,48024,48048,48048,48072,48072,48096,
     2  48096,48096,48120,48096,48048,56808,56736,56736,56688,56592,
     3  56544,56520,56496,56472,56376,56328,56328,56280,56256,56256,
     4  56208,56208,56184,56184,56232,56256,56256,56232,56232,56256,
     5  56232,56088,56064,56040,56016,55992,55968,55992,55752,55680,
     6  55536,55392,54840,54624,54600,54216,54072,53736,53640,53376,
     7  53256,52632,52608,52560,52560,52536,52536,52512,52464,52464,
     8  52416,46680,46704,46680,46656,46656,46680,46680,46656,46632,
     9  46632,46584,46584,46584,46560,46560,46536,46536,46512,46488/
            data (jx(i),i= 6001, 6100)/
     +  46464,46440,46392,46416,46392,46368,46368,46344,46368,46368,
     1  46392,46368,46392,46416,46416,46440,46416,46440,46440,46464,
     2  46440,46464,46464,46464,46488,46488,46488,46464,46344,45816,
     3  45696,45456,45432,45096,44808,44640,44088,44160,44184,44160,
     4  44088,44112,44112,44064,44040,44064,44160,44208,44232,44208,
     5  44160,44160,44184,44232,44256,44256,44256,44208,44208,44208,
     6  44256,44304,44328,44304,44208,44184,44184,44208,44256,44328,
     7  44352,44352,44376,44352,44400,44352,44376,44400,44448,44472,
     8  44496,44520,44496,44520,44568,44616,44664,44712,44712,44688,
     9  44616,44616,44640,44688,44712,44712,44760,44784,44784,44760/
            data (jx(i),i= 6101, 6200)/
     +  44736,44736,44736,44688,44664,44592,44592,44592,44640,44664,
     1  44688,44712,44736,44832,44832,44808,44808,44832,44880,44928,
     2  44880,44808,44784,44760,44808,44832,44784,44736,44712,44616,
     3  44616,44664,44736,44760,44784,44784,44688,44688,44688,44736,
     4  44760,44760,44736,44712,44688,44640,44592,44592,44688,44640,
     5  44592,44568,44568,44640,44640,44616,44592,44568,44592,44568,
     6  44544,44496,44496,44544,40992,40992,41016,41016,41016,41064,
     7  41064,41088,41112,41136,41160,41160,41184,41208,41232,41232,
     8  41280,41304,41280,41304,41304,41328,41304,41328,41304,41304,
     9  41280,41280,41280,41328,41352,41376,41400,41424,41400,41376/
            data (jx(i),i= 6201, 6300)/
     +  41376,41400,41424,41424,41448,41448,41448,41472,41472,41520,
     1  41472,41448,41496,41520,41544,41544,41568,41568,41568,41592,
     2  41616,41664,41664,41640,41664,41640,41640,41616,41592,41616,
     3  41616,41640,41640,41664,41616,41592,41592,41592,41592,41616,
     4  41640,41640,41640,41616,41616,41592,41592,41592,41616,41592,
     5  41616,41616,41616,41616,41592,41592,41592,41520,41520,41496,
     6  41496,41496,41520,41496,41448,41448,41448,41472,41472,41472,
     7  41496,41472,41496,41448,41424,41424,41424,41424,41448,41496,
     8  41472,41472,41496,41496,41496,41520,41520,41520,41496,41496,
     9  45648,45600,45576,45624,46272,46152,45888,45768,46488,46416/
            data (jx(i),i= 6301, 6400)/
     +  46272,46272,46344,46416,46632,47064,47160,47136,46944,46656,
     1  47880,47808,47760,47808,47880,47928,47976,48072,48120,48168,
     2  48192,48168,48096,48144,48072,48120,48072,48096,48048,48000,
     3  48024,47976,51648,51600,51408,51360,51336,51360,51408,51456,
     4  51528,51528,51480,51552,51624,51696,51744,51720,68064,67968,
     5  67944,67968,67944,68064,68184,68064,67272,67128,67128,67248,
     6  67320,67340,67320,67272,67296,67272,67392,67416,66528,66432,
     7  66480,66504,66504,66576,66648,66648,66672,66720,66696,66768,
     8  66816,66552,65832,65880,65928,65952,65904,64032,63984,63984,
     9  64032,64248,64416,64516,64536,64536,64344,64272,62976,62976/
            data (jx(i),i= 6401, 6500)/
     +  63024,63120,63144,63096,63024,63312,63480,63456,63360,63288,
     1  63360,63216,63168,63216,63264,63432,63408,63576,63696,63744,
     2  63984,64056,64176,64608,64896,64920,64872,64824,64704,64656,
     3  64800,64944,65040,65208,65328,65400,65352,64776,63840,63480,
     4  62568,62544,62520,62448,62472,62496,62544,62568,62592,62616,
     5  62664,62640,61056,61056,61104,61176,61200,61152,61152,61128,
     6  61080,61104,61104,61080,61104,62784,62856,63028,63000,62952,
     7  62880,63024,63048,62520,62544,62688,62774,62736,62616,62016,
     8  61992,62016,62064,62112,62160,62232,62088,57432,57456,57504,
     9  57600,56928,56880,56880,56832,56832,56904,56928,58488,58440/
            data (jx(i),i= 6501, 6600)/
     +  58464,58440,58344,58320,58200,58176,58248,58200,58368,58224,
     1  58464,58560,58512,58320,58320,58368,58440,58392,58416,59208,
     2  59472,59496,59448,59568,59472,56904,56832,56760,56832,56880,
     3  56952,49680,49656,49632,49632,49728,49824,49920,50064,50184,
     4  50256,50472,50568,50592,50568,50304,50256,50184,45000,45000,
     5  44928,44952,44904,44928,44832,44832,44976,45000,45072,45034,
     6  45038,45024,45024,45072,45048,44822,44640,44544,44592,44688,
     7  44736,44784,44760,44736,44784,44784,44808,43896,43656,43800,
     8  43992,44064,43992,44016,39720,39960,40152,40176,37464,37512,
     9  37608,37872,37968,38016,38040,37200,37224,37320,37296,37344/
            data (jx(i),i= 6601, 6700)/
     +  37416,37464,37440,36744,36744,36816,36936,36912,36984,37032,
     1  37152,37104,37176,36960,36768,36984,36960,36936,36912,36888,
     2  36864,36820,36768,36744,36720,36720,36744,36744,36744,36768,
     3  36840,36936,36970,37008,11064,10992,10920,10968,10968,11160,
     4  11352,11184,11184,11088,11064,11328,11376, 9888, 9744, 9696,
     5   9720, 9672, 9744, 9960,10080,10128,10104, 9408, 9336, 9288,
     6   9528, 9576,11808,11760,11760,11688,11640,11616,11568,11616,
     7  11712,11784,11832,11808,11736,11592,11712,11736,11784,11880,
     8  11880,11448,11328,11280,11280,11328,11376,11448,11424,11472,
     9  11424,11400,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jy(i),i=    1,  100)/
     +  48480,48384,48336,48288,48240,48216,48192,48168,48144,50136,
     1  49872,49752,49440,49296,49224,49056,48888,48768,48648,48552,
     2  50328,48144,48144,48144,48672,48600,47976,47832,47736,47736,
     3  47736,47664,47616,47496,47472,47496,47520,47592,47664,47640,
     4  47664,47544,47544,47496,47472,47424,47400,47352,47280,47088,
     5  47136,47208,47280,47304,47304,47160,47088,47088,46968,46968,
     6  46872,46944,47112,47208,46968,47040,46992,47040,47016,46920,
     7  46896,46944,46920,46896,46848,46656,46464,46080,45576,45288,
     8  45072,44904,44880,44880,44856,45000,44928,44928,45048,45360,
     9  45312,45264,44832,44928,44856,44832,47904,48120,48144,48216/
            data (jy(i),i=  101,  200)/
     +  48192,48312,48288,48792,48696,48432,48408,48528,48576,48720,
     1  48792,48840,48888,48888,48912,49008,49176,49176,49128,49032,
     2  49128,49176,49224,49320,49368,49224,49560,49704,49824,50088,
     3  50256,50520,50640,51048,51144,51360,51288,50856,50616,50592,
     4  50472,50424,50496,50496,50424,50160,50088,50040,50040,50112,
     5  50088,49896,49824,49656,49512,49488,49560,49498,49536,49704,
     6  49824,49824,49968,50064,50184,50112,49896,49848,49656,49680,
     7  49584,49560,49416,49392,49344,49272,49224,49296,49248,49320,
     8  49440,49440,49392,49296,49224,49152,49272,49392,49440,49368,
     9  49320,49128,49128,49032,49104,49032,49056,49128,49272,49296/
            data (jy(i),i=  201,  300)/
     +  49200,49224,49248,49272,49296,49344,49536,49656,49752,49896,
     1  50112,50112,50160,50376,50520,50544,50400,50280,50424,50520,
     2  50592,50544,50592,50808,50832,50952,50976,50856,50856,51000,
     3  51024,51096,51216,51264,51384,51552,51624,51600,51672,51192,
     4  50712,50568,50424,42984,45024,45144,45240,45312,45408,45528,
     5  45528,45576,45696,45888,45744,45720,45624,45576,45480,45360,
     6  45288,45528,45456,45480,45504,45408,44976,44976,45048,44928,
     7  45000,44904,45120,45312,45288,45384,45384,45528,45576,45456,
     8  45264,45192,45144,45168,45120,45192,45096,45216,45240,44928,
     9  44856,44808,44832,44784,44712,44640,44616,44544,44544,44544/
            data (jy(i),i=  301,  400)/
     +  44496,44568,44568,44304,44328,44496,44568,44568,44376,44352,
     1  44328,44256,44304,44280,44208,44112,43992,43968,43920,43896,
     2  43776,43800,43872,44040,44040,43872,43824,43608,43416,43032,
     3  42960,45528,45576,45672,45816,45840,45864,45960,45912,46032,
     4  45072,45096,45240,45408,43056,46104,45960,46056,46176,46200,
     5  46272,46272,46416,46656,46776,46872,47064,47136,47136,47280,
     6  47280,47400,47448,47688,47856,48048,48240,49464,49488,49248,
     7  49200,49440,49464,49584,49608,49320,47808,47760,47712,47640,
     8  47592,47424,47424,47448,47376,47400,47304,47256,47112,46968,
     9  46848,46800,46896,46896,46848,46656,46560,46488,46416,46176/
            data (jy(i),i=  401,  500)/
     +  46152,46176,46008,45912,45864,45840,45696,45720,45768,45720,
     1  45576,45552,45672,45672,45552,45576,45456,45312,45264,45312,
     2  45264,45384,45552,45600,45672,45744,45648,45600,45504,45384,
     3  45144,45096,44856,44640,44616,44688,44688,44472,44400,44376,
     4  44568,44640,44496,44424,44280,44232,44256,44592,44616,44664,
     5  44544,44208,44160,44184,44328,44352,44232,44184,44208,44280,
     6  44280,44160,43992,43848,43752,43608,43464,43440,43056,43056,
     7  43008,42984,42960,43008,42984,42696,42960,42936,42888,42792,
     8  42744,42672,42600,42360,42312,42240,42192,42216,42144,42096,
     9  42120,42240,42288,42336,42552,42600,42552,42648,42552,42528/
            data (jy(i),i=  501,  600)/
     +  42360,42144,41856,41640,41496,41208,40896,40704,40584,40440,
     1  40200,40032,39960,39864,39696,39600,39456,39192,39912,40176,
     2  40296,40464,40656,40824,41064,41136,41184,41208,41280,41448,
     3  41712,41784,41784,41688,41784,41880,42000,41976,42120,42264,
     4  42408,42528,42576,42792,42912,42960,43056,43128,43080,43128,
     5  43656,43848,44352,44616,44736,44880,42432,42624,42840,43104,
     6  43248,43344,43680,43848,44232,44280,44472,44664,44976,45552,
     7  46080,46296,46560,46920,47184,47208,47136,47160,47280,47472,
     8  47568,47712,47808,47880,48168,48000,48024,48120,48120,48048,
     9  48048,48096,47904,39384,38232,38472,38784,38976,39240,39744/
            data (jy(i),i=  601,  700)/
     +  40248,40728,40992,41160,41232,41400,41400,41544,41736,42000,
     1  42240,42504,42552,42624,42720,42792,42960,43272,43248,42936,
     2  42672,42672,42816,43032,43320,43416,43488,43584,43584,43656,
     3  43704,43848,43944,44040,44112,44208,44040,44088,44040,43968,
     4  43872,43872,43776,43800,43728,43752,43704,43632,43608,43560,
     5  43392,43320,43248,43248,43128,43056,42840,42576,42312,42192,
     6  42048,41904,41784,41712,41640,41328,41208,41232,41424,41400,
     7  41448,41616,41760,41976,41952,41880,41640,41496,40776,40488,
     8  40392,40200,40008,39984,40032,40032,39960,39936,39744,39696,
     9  39552,39432,39168,39048,38568,38928,38712,38592,38280,38112/
            data (jy(i),i=  701,  800)/
     +  40968,40944,38040,38064,38040,37992,37992,38160,42432,42456,
     1  42360,42264,42096,42048,41832,41784,41832,41856,41856,41736,
     2  41496,41472,41304,41232,41256,41208,41256,41400,41520,41688,
     3  41736,41784,41736,41592,41400,41256,41064,40992,40896,40920,
     4  41184,40968,40968,40776,40704,40632,38472,38376,38400,38352,
     5  38232,38232,38280,38232,38304,38472,38472,38472,38736,38880,
     6  39120,40920,40992,41016,40920,40848,40608,40464,40320,40272,
     7  40104,40104,40200,40080,40008,39936,39720,39360,39192,39096,
     8  39024,38880,38760,38856,38808,38664,38544,38472,38448,38496,
     9  38352,38016,38016,37992,37944,37920,37920,37680,37440,37296/
            data (jy(i),i=  801,  900)/
     +  37200,37128,37128,37080,36960,36912,36720,36720,36672,36312,
     1  36240,36192,36192,36408,36504,36504,36456,36672,36792,36912,
     2  35256,35424,35448,36744,36624,36504,36240,36168,36096,35928,
     3  35928,35448,35256,35304,35160,35040,34824,34752,34632,34584,
     4  34776,34872,34944,34968,35016,34992,35136,35160,34992,34992,
     5  35040,34944,35136,35208,35328,35376,35400,35472,35424,35448,
     6  35568,35568,35616,35616,35472,35496,35712,35640,35664,35832,
     7  35832,35904,35880,35928,36144,36096,36144,36240,36432,36504,
     8  36576,36576,36696,36744,36816,36768,36552,36480,36480,36240,
     9  36240,36240,36216,36168,36144,36096,36168,36072,35784,35544/
            data (jy(i),i=  901, 1000)/
     +  35472,35208,35064,34992,34944,34968,35064,35088,34824,34584,
     1  34776,34752,34968,34824,34848,34968,34872,34896,35016,34248,
     2  34224,34080,34056,34032,33960,33936,33888,33816,33720,33384,
     3  33360,33600,33888,33864,33936,33984,34032,34032,34224,34344,
     4  34416,34464,34560,34584,32544,32592,32544,32544,32568,32784,
     5  35208,35280,35256,35016,34920,34824,34800,34800,34896,34776,
     6  34680,34632,34584,34512,34464,34488,34440,34368,34320,34224,
     7  34128,34080,34056,33984,33984,34128,34176,34296,34296,34152,
     8  34128,33960,33888,33840,33840,33816,33816,33672,33576,33576,
     9  33648,33720,33672,33672,33624,33600,33504,33432,33624,33624/
            data (jy(i),i= 1001, 1100)/
     +  33552,33456,33384,33288,33336,33312,33360,33288,33240,33216,
     1  33144,33072,33024,33144,33192,33216,33264,33336,33408,33408,
     2  33336,33384,33384,33480,33408,33360,33312,33336,33288,33360,
     3  33288,33144,33120,33072,33120,33072,32976,33000,32976,32880,
     4  32808,32928,33000,33024,32952,32904,32880,32880,32856,33024,
     5  33048,33048,33000,33048,33072,32568,32544,32448,32448,32496,
     6  32136,31560,31896,31896,32136,32472,32448,32376,32352,32352,
     7  32280,32376,32280,31968,31920,31944,32136,32136,32184,32208,
     8  32040,32016,32160,32136,31992,31944,31944,31992,31848,31776,
     9  31752,31656,31632,31704,31680,31680,31824,32016,32088,32112/
            data (jy(i),i= 1101, 1200)/
     +  32040,31968,31920,31800,31584,31512,31512,31632,31584,31680,
     1  31680,31632,31392,31296,31296,31272,31296,31608,31704,31632,
     2  31344,31224,31272,30912,30792,30816,30864,30960,31032,31056,
     3  31008,30936,30816,30768,30888,30744,30696,30600,30648,30648,
     4  30576,30456,30408,30288,30216,30120,30168,30240,30240,30216,
     5  30192,30192,30048,30072,30144,30192,30264,30168,30192,30240,
     6  30192,29928,29808,29688,29760,29640,29616,29232,29184,29184,
     7  29160,28968,28800,28608,28584,28776,28488,28368,28200,26904,
     8  27072,27216,27480,27312,27408,27528,27456,27696,27744,28080,
     9  28272,28536,29160,29256,29160,29232,29304,29328,29448,29688/
            data (jy(i),i= 1201, 1300)/
     +  29736,29808,30024,30168,30432,30504,30576,30696,30744,30792,
     1  30912,31032,31200,31296,31416,31488,31584,31728,31824,31992,
     2  32064,32184,32280,32352,32640,32736,32952,33096,33576,33816,
     3  34224,34296,34224,34272,34488,34536,34728,34752,34872,35040,
     4  35280,35424,35616,35688,35952,36048,36072,35928,35904,35784,
     5  35472,35448,35544,35904,36000,36144,36192,36288,36312,36288,
     6  36168,36240,36360,36240,36288,36408,36384,36504,36600,36576,
     7  36528,36432,36552,36504,36504,36576,36480,36384,36312,36264,
     8  36120,36120,36288,36264,36456,36528,36480,36504,36696,36912,
     9  36936,37152,37368,37728,38016,38160,38640,38904,39096,39312/
            data (jy(i),i= 1301, 1400)/
     +  39600,39768,40056,40152,40320,40992,41208,41448,41640,42048,
     1  42144,42216,25200,28176,28152,27912,27672,27456,27288,27312,
     2  27240,27096,27024,27024,27000,26952,26808,26784,26712,26640,
     3  26592,26424,26400,26616,26496,26568,26544,26400,26304,26232,
     4  26112,26016,25920,25920,26112,26112,25896,25896,25944,25872,
     5  25872,25848,25776,25704,25608,25512,25536,25632,25776,25824,
     6  25824,25848,25656,25464,25176,24120,24216,24360,23712,23856,
     7  24072,24192,24384,25632,26592,26760,25104,25008,24912,24860,
     8  24912,24888,24912,24936,24888,24936,24864,24912,24864,24888,
     9  24840,24816,24744,24648,24744,24720,24648,24720,24528,24456/
            data (jy(i),i= 1401, 1500)/
     +  24504,24384,24336,24264,24072,24072,24024,23952,24000,23976,
     1  23832,23784,23736,23664,23712,23592,23544,23520,23400,23256,
     2  23160,21984,21768,21936,21816,21744,21696,21600,21576,21672,
     3  21696,21864,22152,22320,21720,21792,21720,21672,21744,21672,
     4  21792,21768,21744,21576,21672,21672,21648,21600,21480,21408,
     5  21384,20904,21360,21432,21480,21600,21600,21504,21312,21192,
     6  21144,21144,21168,21312,21240,21336,21264,21336,21288,21192,
     7  21096,21024,21048,20952,20928,20976,21120,21192,21096,21048,
     8  21048,20904,20880,20832,20808,20880,20760,20784,20688,20688,
     9  20640,20592,20640,20688,20664,20568,20592,20592,20544,20544/
            data (jy(i),i= 1501, 1600)/
     +  20352,20256,20280,20184,20208,20136,20208,20136,20016,20040,
     1  19968,19944,19848,19920,19848,19800,19752,19896,19800,19608,
     2  19920,19968,19848,19848,19920,20016,20064,20040,20088,20160,
     3  20136,20208,20280,20352,20328,20376,20352,20448,20400,20496,
     4  20424,20352,20280,20256,20184,20160,20088,20112,19944,19968,
     5  19896,19776,19896,19992,20016,19992,20088,20016,20088,20136,
     6  20064,20040,19992,19920,19968,19848,19872,19800,19776,19824,
     7  19848,19800,19848,19920,19968,19968,20088,20088,20040,20160,
     8  20280,20352,20304,20472,20472,20640,20568,20640,20688,20664,
     9  20736,20736,20688,20568,20640,20616,20400,20304,20352,20616/
            data (jy(i),i= 1601, 1700)/
     +  20544,20496,20616,20688,20880,20832,20640,20424,20424,20256,
     1  20232,20064,19968,19992,20136,20208,20184,20256,20232,20232,
     2  20280,20208,20400,20520,20592,20544,20400,20424,20592,20472,
     3  20424,20256,20160,20112,20112,20064,20040,20088,20016,19896,
     4  19920,19728,19728,19608,19584,19416,19152,19056,19080,19080,
     5  19008,18912,19032,18720,18864,18936,18840,18864,18888,18912,
     6  19104,19008,18960,19032,18912,18888,18816,18864,18960,18864,
     7  18888,18936,18936,19008,19032,19032,18984,18912,18816,18840,
     8  18744,18696,18672,18720,18648,18456,18504,18576,18600,18696,
     9  18672,22176,22296,22368,22368,22560,22560,22608,22584,22656/
            data (jy(i),i= 1701, 1800)/
     +  22728,22872,23016,23136,23496,23640,24024,18648,18600,18576,
     1  18600,18528,18480,18408,18360,18336,18192,18384,18336,18288,
     2  18192,18216,18312,18216,18264,18264,18192,18120,18096,18072,
     3  18096,18096,18168,18048,17904,17760,17784,17784,17856,17808,
     4  17856,17832,17856,17832,17808,17784,17784,17712,17616,17592,
     5  17400,17064,17064,17232,17112,17040,17208,17040,17040,16944,
     6  16992,16728,16608,16584,16392,16320,16056,15936,15864,15744,
     7  15696,15456,15288,15192,15216,15120,15144,15096,15072,14976,
     8  14976,15096,15144,15144,15240,15288,15288,15264,15312,15288,
     9  15360,15384,15408,15384,15456,15432,15528,15504,15600,15576/
            data (jy(i),i= 1801, 1900)/
     +  15768,15744,15792,15840,15936,16032,16080,16464,16608,16680,
     1  16728,16968,17064,17136,17376,17400,17544,17640,17808,17832,
     2  18096,18120,18360,18432,18480,18552,18600,18696,18816,18864,
     3  18912,18984,19104,19440,19464,19704,19824,19944,20136,20280,
     4  20376,20520,20448,20568,20568,20688,20736,20712,20760,20736,
     5  20808,20736,20736,20784,20784,20832,20784,20832,20808,20952,
     6  20904,20808,20832,20784,20832,20784,20784,20496,20328,20256,
     7  20136,20064,20040,19752,19800,19776,19872,19848,19896,20016,
     8  20088,20160,20160,20232,20208,20328,20448,20568,20688,20880,
     9  21072,21216,21432,21552,21696,21864,21912,21936,22992,22920/
            data (jy(i),i= 1901, 2000)/
     +  22800,22680,22656,22512,22056,21936,21816,21720,21408,21288,
     1  20544,20496,20544,20544,20016,19320,19248,19296,19104,18912,
     2  18528,18408,18456,18480,18480,18432,18432,18312,18144,18144,
     3  17904,17232,16728,16416,16200,16008,15888,15672,15576,15576,
     4  15480,15480,15384,15360,15408,15552,15624,15504,15504,15552,
     5  15648,15720,16104,16152,16272,16392,16368,16464,16608,16848,
     6  16920,17064,17088,17136,17184,17328,17448,17376,17208,17136,
     7  17400,17472,17616,17688,17760,17856,17856,17784,17712,17784,
     8  17808,17760,17664,17496,17568,17688,17736,17688,17616,17688,
     9  18072,18096,18024,18096,18192,18264,18360,18408,18408,18432/
            data (jy(i),i= 2001, 2100)/
     +  18408,18456,18432,18456,18504,18552,18504,18576,18624,18864,
     1  19032,19056,18888,18912,19056,19152,19128,19176,19128,19080,
     2  19080,19032,18960,18912,18720,18696,18864,18696,18648,18864,
     3  19344,19728,20088,20256,20280,20376,20520,20712,20712,20832,
     4  20880,20928,20928,21048,21144,21360,21432,21672,21840,21864,
     5  21840,21864,21792,21648,21672,21624,21624,21552,21576,21264,
     6  21288,21192,21144,21096,21216,21336,21360,21240,21120,21144,
     7  21288,21432,21648,21672,21576,21576,21600,21576,21600,21624,
     8  21600,21720,21768,21864,21864,21960,21888,21912,21888,21816,
     9  21816,21696,21864,21984,21984,22008,22008,22056,22008,22056/
            data (jy(i),i= 2101, 2200)/
     +  22128,22080,22128,22008,21984,21840,22032,22080,22200,22200,
     1  21984,22152,22128,22008,21840,21768,21888,21936,21960,50112,
     2  49008,48912,48048,47904,47712,46920,46752,46704,46656,46632,
     3  46584,46488,46416,46368,46272,46248,46224,46128,47976,47616,
     4  47064,46200,46104,45144,45000,44616,44136,48048,47976,47904,
     5  47880,47856,47832,47808,47784,47760,47736,47712,47688,47616,
     6  47616,47592,47568,47568,47544,47520,47520,47496,47496,47472,
     7  47352,47352,47328,47304,47280,47280,47256,47232,47184,47184,
     8  47160,47160,47136,47136,47112,47088,47064,47064,47040,47016,
     9  47016,46968,46968,46944,46944,46896,46872,46824,46800,46656/
            data (jy(i),i= 2201, 2300)/
     +  46608,46560,46536,46488,46464,46440,46392,46320,46272,46176,
     1  46152,46104,46080,46056,46008,45960,45936,45888,45888,45864,
     2  45816,45792,45744,45720,45672,45648,45552,45528,45432,45408,
     3  45360,45312,45312,45264,45264,45240,45216,45216,45192,45120,
     4  45096,45048,44976,44880,44856,44784,44760,44736,44712,44568,
     5  44544,44496,44472,44400,44376,44352,44232,44184,44160,44136,
     6  44016,43920,43800,43776,43800,43800,43800,43824,43848,43872,
     7  43872,43896,43992,44040,44064,46248,46272,46368,46368,46584,
     8  46560,46536,46536,46584,46584,46584,46584,46608,46608,46560,
     9  46584,46584,46584,46560,46536,46512,46512,46512,46536,46632/
            data (jy(i),i= 2301, 2400)/
     +  46632,46632,46608,46584,46560,46584,46584,46608,46608,46584,
     1  46584,46608,46656,46680,46704,46752,46776,46776,46776,46848,
     2  46848,46848,46872,46872,46824,46848,46824,46800,46800,46800,
     3  46848,46872,46944,46968,47016,47064,47184,47232,47280,47352,
     4  47376,47424,47496,47616,47688,47760,47856,47904,47928,47904,
     5  47880,44808,44808,44784,44784,44760,44760,44664,44616,44568,
     6  44520,44496,44328,44256,44232,44160,44184,44184,44208,44184,
     7  44184,44160,44160,44184,44184,44208,44208,44184,44184,44184,
     8  44160,44184,44136,44136,44160,44136,44136,44112,44112,44088,
     9  44064,44040,43968,43944,43920,43896,43920,43896,43872,43824/
            data (jy(i),i= 2401, 2500)/
     +  43824,43800,43776,43752,43728,43680,43656,43608,43608,43584,
     1  43512,43464,43440,43392,43320,43320,43296,43320,43320,43368,
     2  43344,43320,43200,43176,43152,43104,43104,43056,44064,43104,
     3  42792,42792,42888,42888,42984,43008,43200,43248,43296,43440,
     4  43488,43536,43536,43632,43176,42888,42912,42936,42984,43008,
     5  43056,43056,43104,43128,43176,43224,43224,43272,43296,43296,
     6  43320,43272,43296,43296,43272,43248,43224,43200,43200,43176,
     7  43128,43080,43080,43056,43056,43032,43080,43080,43104,43080,
     8  43080,43080,43056,43152,43152,43128,43128,43128,43128,43152,
     9  43176,43176,43200,43224,43200,43176,43128,43080,43080,43128/
            data (jy(i),i= 2501, 2600)/
     +  43128,43152,43176,43200,43200,43176,43152,43128,43080,43032,
     1  43032,43056,43080,43128,43176,43176,43200,43248,43272,43320,
     2  43344,43392,43440,43512,43560,43584,43608,43656,43752,43752,
     3  43704,43704,43752,43800,43824,43944,43968,43968,43968,44040,
     4  44088,44112,44136,44160,44184,44208,44208,44232,44256,44280,
     5  44328,44376,44448,44472,44544,44640,44688,44736,44784,44808,
     6  44832,44832,44928,44952,44976,45000,45024,45048,45072,45096,
     7  45120,45120,45096,45072,45072,45000,45000,44976,44976,44952,
     8  44976,44928,44904,44880,44880,44928,44952,45000,45024,45024,
     9  45048,45048,45120,45144,45192,45216,45240,45288,45312,45360/
            data (jy(i),i= 2601, 2700)/
     +  45408,45456,45432,45456,45432,45480,45528,45552,45600,45624,
     1  45648,45672,45696,45744,45768,45816,45840,45864,45888,45888,
     2  45888,45960,46008,46032,46056,46200,46224,46248,46344,46344,
     3  46368,46464,46512,46560,46584,46560,46536,46584,46584,46620,
     4  46632,46704,46704,46680,46680,46752,46776,46800,46824,46848,
     5  46920,46968,46992,47040,47088,47088,47112,47208,47256,47304,
     6  47304,47352,47448,47544,47568,47592,47616,47640,47664,47712,
     7  47784,47808,47832,47880,47904,47904,47904,47904,47928,47952,
     8  48000,48024,48096,48144,48168,48264,48288,48336,48360,48432,
     9  48456,48504,48528,48624,48696,48720,49032,49440,40416,40488/
            data (jy(i),i= 2701, 2800)/
     +  40560,40656,40728,40824,40896,41040,41088,41160,41160,41160,
     1  41208,41304,41376,41472,41520,41544,41592,41616,41688,41712,
     2  41736,41784,41856,41880,41904,41952,42000,42096,42144,42264,
     3  42312,42360,42384,42408,42504,42528,42600,42648,42720,42768,
     4  42792,42912,42960,43008,43056,43128,43152,43176,43272,43296,
     5  43296,43320,43416,43512,43536,43584,43704,43704,43776,43800,
     6  43872,43920,43920,43968,43968,44016,44040,44160,44544,43632,
     7  43608,43512,43392,43320,43296,43200,43104,43032,43008,42984,
     8  42912,42888,42840,42408,42168,41928,41784,41304,40800,40296,
     9  40392,40392,40368,40368,40344,40344,40344,40320,40320,40320/
            data (jy(i),i= 2801, 2900)/
     +  40320,40296,40296,40296,40296,40296,40296,40296,43104,43224,
     1  43248,43296,43368,43392,43464,43512,43560,43584,43608,43632,
     2  43632,43944,44616,45168,39936,40632,40656,41160,41568,41616,
     3  42192,41928,42000,42048,42192,42720,43008,43056,43080,43104,
     4  43128,43152,43104,43032,43056,43128,43248,43320,43344,43368,
     5  43488,43512,43632,43656,43704,43728,43800,43824,43896,43920,
     6  44040,44184,44232,44280,44424,44472,44520,44544,44568,44616,
     7  44664,44784,44808,44832,44952,45024,45456,45408,45360,45216,
     8  45168,45096,45024,45000,44976,44928,44904,44856,44832,44832,
     9  44784,44736,44736,44712,44688,44640,44592,44568,44520,44496/
            data (jy(i),i= 2901, 3000)/
     +  44472,44448,44448,44400,44328,44304,44232,44184,44136,44112,
     1  44112,44088,44016,43968,43944,43920,43896,43872,43824,43776,
     2  43656,43608,43584,43536,43488,43344,43296,43200,43176,43056,
     3  43008,42984,42936,42912,42792,42696,42648,42576,42528,42480,
     4  42432,42408,42384,42336,42240,42192,42168,42144,42120,42120,
     5  42096,42000,41976,42696,42720,42696,42624,42552,42552,42528,
     6  42432,42408,42384,42336,42192,42192,42120,39024,39048,39096,
     7  39096,39192,39216,39240,39240,39288,39336,39384,39504,39600,
     8  39696,39816,39912,40080,40104,40152,40200,40224,40296,40368,
     9  40296,40272,40200,40152,40128,40104,40032,40008,39960,39936/
            data (jy(i),i= 3001, 3100)/
     +  39936,39912,39888,39888,39768,39696,39672,39648,39600,39552,
     1  39504,39456,39432,39360,39336,39336,39288,39264,39216,39168,
     2  39096,39096,39048,38976,38976,38952,38880,38856,39168,39144,
     3  39120,39120,39096,39072,39072,39048,39048,39024,38856,38904,
     4  38880,38880,38904,38928,39024,39048,39072,39096,39096,39120,
     5  39168,39192,39192,39192,39240,39240,39240,39264,39288,39312,
     6  39360,39384,39384,39384,39408,39384,39384,39384,39384,39408,
     7  39360,39384,39384,39384,39408,39384,39360,39312,39288,39264,
     8  39264,39336,39360,39360,39384,39432,39504,39528,39600,39624,
     9  39648,39672,39720,39768,39816,39840,39888,40896,40920,41568/
            data (jy(i),i= 3101, 3200)/
     +  41232,41256,41184,41184,41088,41088,41064,41064,41040,40992,
     1  40968,41016,40992,40968,39384,40104,40824,41208,41544,42192,
     2  39456,39552,39552,39720,39912,40536,42912,43008,43080,43128,
     3  43128,43152,43152,43176,43200,43248,43296,43344,43440,43464,
     4  43464,43536,43584,43632,43656,43704,43704,43680,43704,43752,
     5  43728,43752,43800,43824,43872,43944,43992,44064,44064,44112,
     6  44136,44160,44184,44328,44352,44400,44424,44496,44520,44544,
     7  44616,44664,44688,44688,44712,44736,44784,44808,44832,44856,
     8  44880,45048,45144,45312,45360,45432,45480,45576,45648,45696,
     9  45768,45840,45840,45888,45984,46104,39960,40104,40296,40536/
            data (jy(i),i= 3201, 3300)/
     +  40800,41064,41088,41232,41472,41640,41880,42144,42216,42312,
     1  41016,41040,41040,41088,41160,41184,41208,41184,41304,41352,
     2  41328,38376,38424,38424,38496,38520,38280,38304,38328,38352,
     3  38352,38400,38400,38448,38448,40920,39624,39648,39672,39720,
     4  39720,39720,39720,39720,39744,39768,39744,39816,39840,39888,
     5  39912,39936,40056,40080,40128,40128,40152,40200,40224,40224,
     6  40224,40248,40224,40344,40344,40392,40392,40368,40224,40224,
     7  40128,40056,40056,39912,39888,39816,39792,39672,39648,39552,
     8  39528,40848,40728,40680,40416,40392,40296,39384,38496,38064,
     9  37872,37632,37080,40344,40128,39912,39816,39720,39504,39384/
            data (jy(i),i= 3301, 3400)/
     +  37656,37776,37800,37944,38328,38784,37152,37176,37272,37296,
     1  37368,37416,37488,38928,39000,39144,39216,39264,39312,39408,
     2  39432,39480,37464,37776,37824,38160,38664,38688,39192,36120,
     3  36144,36192,36312,36408,36480,36504,36552,36672,36696,36744,
     4  36792,36864,36936,36960,36984,37008,37032,37128,37152,37104,
     5  37128,37200,37272,37368,37392,37392,37416,37440,37464,37464,
     6  37464,37512,37536,37560,37656,37680,37704,37728,37752,37776,
     7  37848,37944,37992,38040,38088,38112,38136,38136,38184,38208,
     8  38328,38376,38448,38472,38520,38544,38568,38616,38640,38688,
     9  38736,38784,38808,39000,38976,38952,38904,38856,38808,38784/
            data (jy(i),i= 3401, 3500)/
     +  38688,38640,38616,38592,38544,38496,38472,38400,38352,38304,
     1  38208,38040,37992,37968,37896,37800,37728,37704,37680,37632,
     2  37608,37608,37584,37512,37488,37488,37488,37440,37440,37440,
     3  37392,37296,37200,37152,37080,37056,37032,36984,36936,36768,
     4  36720,36648,36576,36480,36408,36360,36336,36312,36288,36240,
     5  36192,36168,36120,36096,36024,35952,35928,35928,35904,35928,
     6  35928,35952,35952,36000,36024,36024,36048,36096,36120,36144,
     7  36192,36216,36240,36216,36192,36192,36168,36168,36144,36120,
     8  36120,36120,36096,36096,36096,36096,36096,36096,36096,36048,
     9  36024,36024,36072,36072,36024,36000,35952,35832,35784,35760/
            data (jy(i),i= 3501, 3600)/
     +  35736,35736,35712,35712,35640,35592,35568,35520,35448,35424,
     1  35400,35376,35328,35328,35304,35304,35256,35472,35976,36096,
     2  36480,36552,36912,36960,36960,37008,37032,35256,35256,35256,
     3  35256,35256,35256,35280,35280,35280,35280,35304,35304,35304,
     4  35328,35352,35352,35376,35400,35400,35424,35424,39552,39528,
     5  39504,39408,39384,39288,39216,39192,39168,39144,39096,39048,
     6  39024,39000,38976,38904,38880,38856,38832,38808,38784,38736,
     7  38712,38712,38664,38616,38568,38544,38520,38496,38472,38424,
     8  38400,38400,38424,38400,38376,38280,38232,38208,38232,38232,
     9  38136,38136,38112,38088,38040,37968,37920,37872,37848,37776/
            data (jy(i),i= 3601, 3700)/
     +  37728,37704,37656,37608,37584,37584,37560,37512,37464,37440,
     1  37440,37368,37368,37344,37272,37296,37296,37272,37248,37152,
     2  37080,36336,36288,36264,36168,36144,36480,36576,36792,37128,
     3  37224,37008,36984,36912,36864,36816,36768,36720,36720,36600,
     4  36552,36552,36456,36432,36336,37128,37152,37176,37200,37224,
     5  37248,35592,35616,35616,35712,35760,35760,35808,35856,35928,
     6  35952,35976,36024,36048,36048,36072,36072,36024,36072,36168,
     7  36240,36240,36264,36312,36336,36360,36336,36336,36312,36288,
     8  36264,36264,36240,36216,36240,36216,36240,36216,36240,36240,
     9  36264,36288,36288,36336,36336,36336,36384,36384,36408,36408/
            data (jy(i),i= 3701, 3800)/
     +  36432,36408,36456,36480,36504,36504,36552,36528,36480,36432,
     1  36456,36432,36480,36480,36456,36456,36480,36480,36432,36432,
     2  36408,36408,36384,36336,36384,36360,36384,36360,36336,36336,
     3  36336,36312,36288,36288,36264,36240,36240,36216,36168,36144,
     4  36120,36096,36096,38136,37968,37776,37728,37344,37272,36984,
     5  36768,36432,36384,35952,35808,35544,35304,35232,34944,34920,
     6  34632,35664,35712,35712,35784,35808,35808,35808,35808,35832,
     7  35856,35904,35952,36000,36024,36048,36072,36096,36096,36096,
     8  35784,35736,35664,35472,35520,35544,35592,35616,35664,35304,
     9  35352,35376,35376,35376,35304,35448,35568,35832,36264,36408/
            data (jy(i),i= 3801, 3900)/
     +  36480,36600,36960,33960,34032,34080,34128,34128,34128,34152,
     1  34176,34248,34296,34344,34392,34392,34344,34320,34272,34248,
     2  34176,34152,34176,34128,34128,34104,34128,34152,34200,34200,
     3  34224,34224,34200,34176,34128,34104,34104,34104,34128,34200,
     4  34200,34248,34272,34296,34248,34248,34272,34296,34392,34440,
     5  34488,34584,34608,34608,34608,34656,34704,34680,34680,34632,
     6  34632,34632,34704,34656,37416,37416,37416,37368,37344,37296,
     7  37248,37224,37104,37080,37080,36984,36936,36888,36792,36768,
     8  36744,36576,36480,36432,36408,36384,36384,36384,36360,36336,
     9  36312,36264,36240,36144,36120,36096,36072,36048,36000,35952/
            data (jy(i),i= 3901, 4000)/
     +  35928,35928,35880,35808,35736,35688,35640,35616,35592,35568,
     1  35544,35496,35472,35544,35568,35544,35472,35424,35328,35328,
     2  35304,35256,35232,35184,35112,35064,35040,35016,35016,34968,
     3  34944,34872,34824,34800,34848,34824,34752,34728,34728,34752,
     4  34800,34872,34872,34896,34896,34872,34848,34800,34728,34632,
     5  34584,34536,34440,34392,34344,34272,34248,34272,34248,34080,
     6  34032,34008,34008,33960,33936,33936,34680,32448,32448,32472,
     7  32496,32520,32568,32568,32592,32616,32616,32664,32688,32736,
     8  32760,32784,32808,32832,32856,32856,32880,32904,32928,32952,
     9  32976,33024,33072,33168,33168,33144,33168,33192,33192,33144/
            data (jy(i),i= 4001, 4100)/
     +  33240,33288,33336,33384,33408,33432,33480,33480,33504,33528,
     1  33576,33600,33624,33648,33672,33720,33744,33816,33864,33888,
     2  33912,34008,34008,34056,34104,34152,34176,34200,34200,34296,
     3  34320,34320,34344,34344,34368,34392,34440,34488,34488,34560,
     4  34560,34608,34632,34632,34680,34704,34896,35088,35472,35880,
     5  36336,36360,36720,37080,37320,37512,34632,34584,34560,34536,
     6  34512,34464,34416,34392,34368,34344,34344,34344,34296,34248,
     7  34200,34152,34128,34104,34056,34008,34008,34080,34056,34056,
     8  34032,33984,33816,33792,33768,33720,33648,33600,33504,33456,
     9  33384,33336,33360,33360,33336,33288,33192,33024,32976,32952/
            data (jy(i),i= 4101, 4200)/
     +  32928,32904,32880,32928,32928,32952,32976,33000,33096,33144,
     1  33168,33168,33120,33096,33096,33072,33048,33024,33048,33024,
     2  33000,32976,32952,32952,32928,32880,32856,32784,32760,32760,
     3  32760,32736,32640,32640,32640,32640,32712,32736,32712,32688,
     4  32688,32808,32832,32808,32760,32736,32712,32712,32688,32544,
     5  32496,32496,32544,32568,32568,32592,32640,32688,32688,32640,
     6  32712,32640,32592,32568,32544,32496,32520,32592,32616,32592,
     7  32592,32568,32568,32616,32616,32592,32544,32496,32448,32448,
     8  32400,32424,32784,32808,32784,32808,32760,32808,32808,32856,
     9  32856,32904,32880,32928,32928,33048,33072,33096,33120,33216/
            data (jy(i),i= 4201, 4300)/
     +  33240,33264,33288,33312,33360,33408,33528,33576,33600,33624,
     1  33648,33696,33720,33744,33792,33816,33888,36048,35976,35904,
     2  35832,35808,35952,36096,36144,36168,36072,36024,36024,36000,
     3  35880,35856,35808,35784,35760,35712,35664,35664,35616,35568,
     4  35520,35520,35496,35424,35448,35400,35352,35304,35352,35352,
     5  35328,35256,35184,35088,35184,35112,35088,35040,34968,34896,
     6  34896,34608,34536,34512,34536,34656,34704,34632,34584,34560,
     7  34464,34392,34344,34344,34272,34248,34224,34200,34176,34056,
     8  34032,33984,33960,33888,33840,33768,33720,33648,33624,33576,
     9  33552,33528,33480,33432,33408,33360,33288,33264,33240,33216/
            data (jy(i),i= 4301, 4400)/
     +  33240,33216,33168,33120,33072,33072,33072,33048,33000,32976,
     1  32952,32904,32880,32904,32928,32952,32928,32904,32784,32784,
     2  32784,32760,32784,32784,32808,32808,32760,32712,32688,32640,
     3  32616,32640,32592,32568,32496,32568,32616,32568,32520,32472,
     4  32472,32448,32400,32376,32400,32424,32448,32472,32448,32448,
     5  32496,32520,32520,32568,32640,32688,32712,32736,32760,35184,
     6  35184,35136,35136,35064,35064,35088,35112,35112,35112,35040,
     7  35016,35016,34992,34968,34944,34920,34920,34896,34872,34872,
     8  34896,34872,34800,34776,34728,34656,34632,34584,34512,34488,
     9  34464,34416,34368,34368,34320,34296,34224,34200,34128,34104/
            data (jy(i),i= 4401, 4500)/
     +  34080,34080,34056,34056,34032,33984,33888,33600,33456,33072,
     1  32952,32472,32424,31920,31872,31464,31416,31032,30936,37176,
     2  36528,35736,35520,35304,34056,33696,33576,33192,32832,31920,
     3  38496,37224,36936,36432,35208,35040,34440,33672,32808,32064,
     4  32136,32160,32208,32304,32448,32520,32592,31224,31224,31296,
     5  31416,31416,31488,31512,31560,31608,31632,31680,31704,31824,
     6  34848,34224,34080,33600,33480,32976,32952,32208,32064,31704,
     7  31128,30936,30936,30936,30936,30936,30936,30936,30936,30936,
     8  30936,30936,30960,30960,30960,30960,30984,31008,31008,31032,
     9  31032,31056,31080,31080,31104,31128,32328,32280,32232,32184/
            data (jy(i),i= 4501, 4600)/
     +  32112,32016,31968,31896,31848,31848,31824,31656,31608,31536,
     1  31464,31392,31344,31344,31344,31392,31416,31416,31440,31512,
     2  31512,31512,31464,31344,31320,31272,31224,31176,31176,31224,
     3  31248,31296,31320,31296,31272,31224,31200,31176,31200,31248,
     4  31320,31368,31416,31488,31536,31536,31560,31608,31632,31656,
     5  31680,31752,31824,31872,31992,32040,32088,32136,32160,32184,
     6  32232,32280,32304,32352,32448,32424,32400,32400,32448,32520,
     7  32520,32544,32616,32640,32688,32736,32784,32808,32880,33000,
     8  33072,33120,33168,33288,33312,33360,33432,33504,33552,33600,
     9  33672,33696,33720,33768,33792,33864,33888,33888,33936,33912/
            data (jy(i),i= 4601, 4700)/
     +  33816,33792,33792,33864,34008,34056,34104,34176,34248,34296,
     1  34320,34392,34464,34536,34584,34632,34704,34728,34800,34920,
     2  34968,35016,35088,35160,35208,35232,35256,35280,35376,35448,
     3  35568,35664,35736,35808,32424,32352,32328,32232,32208,32064,
     4  32040,32016,32016,31968,31920,31848,31800,31728,31680,31656,
     5  31656,31536,31488,31488,31464,31416,31368,31344,31320,31320,
     6  31224,31200,31488,31512,31488,31488,31464,31416,31416,31392,
     7  31344,31320,31296,31248,31248,31272,31224,32520,32472,32424,
     8  32424,32352,32280,32256,32160,32136,32112,32040,31992,31944,
     9  31944,31872,31872,31800,31776,31704,31704,31656,31632,31584/
            data (jy(i),i= 4701, 4800)/
     +  31584,31512,30456,30624,30648,30624,30576,30552,30576,30648,
     1  30696,30720,30768,30792,30840,30840,30864,30888,30912,30936,
     2  30960,31008,31128,31152,30432,30432,30456,30504,30528,30528,
     3  30528,30504,30480,30456,31176,31152,31152,31128,31128,31056,
     4  31056,31056,31032,31032,31008,30984,30960,30960,30936,30936,
     5  30912,30864,30864,30840,30816,30792,30792,30816,30816,30672,
     6  30624,30552,30528,30528,30504,30504,30456,30504,30216,30456,
     7  30600,30384,30360,30384,30408,30360,30288,30240,30216,30216,
     8  30192,30168,30120,30096,30072,30072,30072,30048,30024,29976,
     9  29928,29904,29856,29832,29736,29712,29688,29664,29640,29808/
            data (jy(i),i= 4801, 4900)/
     +  29832,29832,29880,29904,29928,29952,29976,30048,30072,30120,
     1  30144,30216,30240,30264,30264,30288,30336,30336,30384,30384,
     2  30360,30336,30312,30312,30312,30288,30288,30288,30264,30240,
     3  30240,30240,30240,30216,30216,30216,28224,28296,28296,28344,
     4  28392,28416,28440,28416,28464,28488,28512,28560,28608,28632,
     5  28608,28632,28680,28704,28728,28776,28800,28824,28848,28848,
     6  28824,28800,28800,28848,28872,28920,28920,28848,28848,28896,
     7  28992,29016,29040,29064,29016,29016,29040,29088,29112,29160,
     8  29184,29232,29232,29208,29232,29280,29304,29352,29328,29352,
     9  29376,29424,29448,29424,29472,29520,29544,29592,29592,29544/
            data (jy(i),i= 4901, 5000)/
     +  29568,29592,29616,29664,28392,28392,28392,28344,28344,28320,
     1  28320,28296,28272,28272,32592,31704,31680,31584,31464,31464,
     2  31464,31536,31584,31608,31656,31680,31656,31656,31728,31704,
     3  31728,31680,31656,31632,31584,31536,31416,31368,31344,31320,
     4  31200,31152,31104,31032,30984,30936,30888,30840,30744,30600,
     5  30528,30408,30336,30288,30288,30288,30264,30216,30168,30096,
     6  31464,31800,33456,34320,35088,36000,36216,36528,36912,37056,
     7  37152,37200,37272,37488,37680,38064,40104,28656,28608,28584,
     8  28584,28536,28512,28488,28488,28464,28440,28416,28800,29136,
     9  29208,29184,29208,29256,29280,29328,29400,29448,29520,29568/
            data (jy(i),i= 5001, 5100)/
     +  29616,29640,29688,29712,29736,29736,29736,29808,29856,29904,
     1  29904,29952,29976,30000,30024,30072,30096,30120,30120,30144,
     2  30264,30360,30384,30384,30360,30408,30456,30480,30576,30576,
     3  30528,30504,30456,30456,30480,30504,30648,30672,30720,30720,
     4  30768,30768,30720,30720,30768,30984,31032,31104,31104,31128,
     5  31152,31200,31320,31392,28776,28752,28752,28728,28680,28680,
     6  28656,28992,28920,28920,28872,28848,28824,28272,28704,29088,
     7  29304,29304,29256,29184,29160,29112,29280,29376,29448,29496,
     8  29376,29424,29472,29520,29544,29520,29496,29472,29448,29448,
     9  29400,29400,29376,29400,29376,29400,29352,29352,29304,29304/
            data (jy(i),i= 5101, 5200)/
     +  29232,29232,29208,29184,29160,29112,29040,30192,29736,29664,
     1  29160,28992,28632,27960,27672,27360,26904,26544,26088,26088,
     2  26088,26112,26088,26112,26112,26136,26112,26112,26136,26160,
     3  26136,26160,26136,26136,26136,26160,26184,26184,26160,26184,
     4  26208,26208,26232,26232,26256,26232,26256,26256,26280,26304,
     5  26328,26352,26352,26376,26400,26424,26400,26424,26424,26448,
     6  26472,26496,26448,26472,26496,26496,26496,26520,26520,26568,
     7  26520,26472,26496,26448,26448,26472,26424,26424,26448,26448,
     8  26472,26472,26520,26520,26496,26496,26448,26472,26448,26424,
     9  26400,26424,26376,26376,26448,26448,26424,26424,26400,26376/
            data (jy(i),i= 5201, 5300)/
     +  26376,26352,26376,26352,26352,26328,26280,26256,26256,26280,
     1  26256,26208,26184,26184,26232,26304,26280,26304,26352,26352,
     2  26376,26424,26472,26496,26472,26400,26376,26376,26424,26424,
     3  26400,26424,26448,26496,26544,26568,26544,26520,26544,26448,
     4  26400,26376,26400,26400,26376,26352,26352,26256,26232,26232,
     5  26232,26256,26352,26376,26400,26424,26472,26496,26472,26448,
     6  26424,26448,26472,26424,26424,26376,26376,26400,26472,26496,
     7  26496,26496,26496,26520,26592,26616,26592,26544,26544,26472,
     8  26424,26424,26448,26472,26496,26520,26544,26568,26568,26592,
     9  26640,26616,26616,26640,26736,26832,26856,26832,26808,26832/
            data (jy(i),i= 5301, 5400)/
     +  26856,26856,26808,26784,26760,26736,26736,26736,26808,26856,
     1  26880,26880,26856,26880,26856,26856,26880,26904,26952,26976,
     2  26952,26976,26952,26976,27000,27048,27120,27144,27216,27240,
     3  27264,27336,27312,27264,27216,27216,27240,27264,27288,27288,
     4  27240,27216,27240,27336,27432,27456,27504,27552,27552,27528,
     5  27528,27792,28200,28416,28752,29040,29424,29664,30288,30312,
     6  30312,30336,30360,30384,30432,30432,26088,26064,26040,26040,
     7  26016,26040,26016,25992,25968,26016,25992,26016,26040,26016,
     8  26064,26064,26016,26016,26040,26064,26016,26040,26064,26040,
     9  26016,25608,25224,25320,25344,25368,25368,25392,25440,25464/
            data (jy(i),i= 5401, 5500)/
     +  25512,25512,25488,25512,25536,25632,25656,25704,25728,25728,
     1  25656,25680,25776,25824,25872,25896,25920,25968,25968,25968,
     2  25896,25872,25872,25896,25944,25944,25968,26016,26040,26016,
     3  25968,25944,25944,26016,26040,26040,26064,26112,26112,26112,
     4  26160,26184,26232,26256,26304,26304,26256,26232,26256,26304,
     5  26328,26304,26304,26328,26376,26400,26400,26424,26400,26376,
     6  26400,26424,26424,26448,26496,26520,26640,26688,26712,26736,
     7  26712,26712,26688,26664,26688,26712,26736,26760,26784,26880,
     8  26880,26904,26952,27000,26952,26952,26976,27012,27048,27096,
     9  27120,27072,27096,27168,27192,27192,27168,27216,27288,27288/
            data (jy(i),i= 5501, 5600)/
     +  27312,27288,27216,27216,27240,27288,27360,27384,27432,27480,
     1  27528,27528,27552,27576,27648,27672,27696,27792,27768,27720,
     2  27696,27696,27744,27792,27792,27792,27912,27936,27912,27888,
     3  27864,27816,27816,27840,27864,27936,27960,28008,28056,28056,
     4  28032,27984,27984,27984,28032,28008,28008,28032,28056,28080,
     5  28128,28152,28152,28200,25320,25296,25296,25272,25248,25248,
     6  25248,25224,25224,25224,30096,30024,30000,29928,29856,29736,
     7  29736,29712,29664,29520,29496,29472,29400,29304,29280,29256,
     8  29232,29208,29184,29112,29064,29016,28968,28968,28872,28848,
     9  28824,28776,28752,28680,28608,28608,28560,28464,28440,28416/
            data (jy(i),i= 5601, 5700)/
     +  28344,28296,28248,28224,28200,28128,28080,28032,27984,27960,
     1  27936,27888,27864,27888,27792,27720,27672,27624,27600,27528,
     2  27456,27432,27336,27336,27312,27312,27312,27288,27216,27144,
     3  27024,26976,26952,26928,26928,26928,26904,26880,26904,26880,
     4  26928,26928,28968,28920,28944,28920,28896,28896,28872,28848,
     5  28824,28824,28800,28776,28752,28752,28704,28680,28656,28608,
     6  28560,28536,28512,28488,28416,28416,28392,28368,28344,28320,
     7  28272,28248,28272,28272,28248,28200,28128,28104,28032,28032,
     8  27960,27912,27864,27792,27696,27672,27600,27552,27504,27480,
     9  27480,27456,27408,27384,27360,27264,27240,27168,27168,27144/
            data (jy(i),i= 5701, 5800)/
     +  27144,27120,27096,27072,27048,27024,27000,26976,26952,26928,
     1  26904,26856,26856,26832,26832,26808,26808,26784,26784,26760,
     2  26736,26712,26688,26664,26640,26664,26664,26640,26592,26568,
     3  26544,26496,26496,26472,26448,26424,26400,26352,26328,26256,
     4  26256,26232,26232,26184,26184,26184,26160,26136,26112,26064,
     5  26064,26040,25992,25968,25920,25872,25848,25848,25824,25824,
     6  25824,25800,25776,25752,25680,25632,25584,25560,25512,25536,
     7  25512,25440,25416,25368,25320,25200,24168,24216,24288,24312,
     8  24408,24408,24432,24408,24360,24240,24240,24144,24144,24120,
     9  24072,24048,24168,24792,25416,26016,26280,26664,27360,27984/
            data (jy(i),i= 5801, 5900)/
     +  28296,28608,29256,29424,29856,30504,30480,28992,28488,27336,
     1  26496,25896,25416,28464,28128,28080,27984,27672,27384,27192,
     2  27120,26760,26544,26448,26040,26016,25656,25584,25536,25512,
     3  25488,25488,25416,25392,25344,25320,25296,25272,25176,25104,
     4  25056,25008,25008,24984,24936,24912,24864,24840,24816,24816,
     5  24792,24768,24744,24720,24696,24672,24624,24576,24528,24504,
     6  24456,24408,24288,24216,24120,24048,24024,23976,23904,23808,
     7  23760,23688,23640,23520,23472,23448,23400,23328,23280,23256,
     8  23232,23184,23136,23016,22968,22872,22872,22848,22800,22800,
     9  22776,22728,22656,22536,22488,22416,22368,22320,22296,22272/
            data (jy(i),i= 5901, 6000)/
     +  22200,22104,22056,22272,22632,22800,23256,23640,23904,24384,
     1  24504,24912,25392,25488,25920,26280,26592,27048,27096,27432,
     2  27624,27792,28248,28248,28296,23136,23160,23136,23160,23160,
     3  23184,23184,23160,23208,23208,23256,23232,23232,23184,23160,
     4  23184,23136,23112,22968,22896,22872,22728,22680,22656,22584,
     5  22560,22536,22536,22608,22704,22728,22776,22824,22800,22800,
     6  22800,22776,22752,22752,22752,22728,22704,22704,22680,22680,
     7  22680,22632,22680,22680,22704,22752,22800,22872,22920,22968,
     8  22992,21456,21456,21480,21528,21552,21576,21600,21624,21624,
     9  21648,21672,21744,21768,21768,21792,21792,21816,21816,21840/
            data (jy(i),i= 6001, 6100)/
     +  21888,21888,21984,22032,22032,22056,22104,22104,22128,22152,
     1  22152,22224,22248,22248,22272,22272,22320,22320,22392,22392,
     2  22416,22416,22464,22488,22488,22512,22536,22536,22536,22512,
     3  22488,22488,22464,22464,22440,22440,22416,22464,22488,22536,
     4  22584,22656,22728,22752,22800,22800,22800,22824,22848,22872,
     5  22920,22944,22968,22944,22968,22992,23016,23064,23160,23184,
     6  23184,23232,23256,23280,23280,23304,23328,23352,23328,23328,
     7  23352,23448,23496,23496,23520,23520,23568,23640,23664,23616,
     8  23592,23616,23664,23688,23736,23856,23856,23904,23928,23928,
     9  23952,24000,24000,23952,23952,24000,24024,24072,24120,24120/
            data (jy(i),i= 6101, 6200)/
     +  24144,24096,24072,24096,24072,24072,24120,24168,24192,24168,
     1  24216,24216,24240,24192,24264,24288,24312,24312,24312,24432,
     2  24384,24384,24408,24456,24480,24504,24528,24504,24504,24576,
     3  24624,24648,24576,24576,24576,24600,24648,24672,24696,24720,
     4  24768,24792,24792,24744,24744,24720,24792,24816,24912,24936,
     5  24936,24960,25080,25128,25248,25296,25296,25272,25224,25176,
     6  25176,25176,25200,25296,25032,24744,24312,24048,23736,23736,
     7  23712,23688,23640,23616,23616,23592,23616,23568,23544,23496,
     8  23472,23448,23400,23376,23352,23352,23304,23256,23256,23208,
     9  23208,23160,23136,23088,23088,23088,23064,23064,23040,23040/
            data (jy(i),i= 6201, 6300)/
     +  23016,22992,22992,22968,22968,22944,22920,22896,22872,22872,
     1  22800,22776,22752,22728,22728,22680,22656,22608,22584,22584,
     2  22608,22608,22584,22584,22560,22560,22512,22488,22488,22464,
     3  22440,22440,22416,22392,22344,22368,22344,22320,22296,22296,
     4  22272,22248,22224,22224,22200,22200,22176,22152,22128,22104,
     5  22104,22080,22056,22008,21960,21912,21888,21864,21816,21816,
     6  21792,21768,21744,21744,21744,21720,21672,21648,21624,21600,
     7  21576,21552,21528,21528,21480,21432,21408,21384,21336,21312,
     8  21240,21216,21168,21144,21120,21120,21096,21072,21024,20976,
     9  46704,46728,46776,46848,47232,47040,46896,46752,45576,45744/
            data (jy(i),i= 6301, 6400)/
     +  45768,45912,45984,46080,46224,46296,46224,46200,46128,45888,
     1  42528,42576,42696,42840,42912,43080,43056,43272,43272,43272,
     2  43200,43176,43200,43056,43056,42984,42984,42912,42936,42816,
     3  42744,42648,44520,44568,44520,44616,44568,44640,44592,44664,
     4  44688,44736,44736,44784,44760,44664,44640,44544,45264,45312,
     5  45456,45504,45552,45600,45456,45360,40632,40632,40680,40680,
     6  40752,40776,40776,40710,40800,40848,40728,40680,40512,40584,
     7  40584,40560,40656,40776,40824,40752,40800,40752,40728,40728,
     8  40656,40584,40584,40848,40872,40656,40656,38942,38928,38952,
     9  38952,39072,39192,39260,39264,39240,39120,39072,38544,38592/
            data (jy(i),i= 6401, 6500)/
     +  38712,38784,38712,38616,38544,38688,38808,38832,38832,38784,
     1  38736,38688,38784,38928,39024,39048,39120,39240,39240,39312,
     2  39336,39432,39480,39600,39912,39912,39840,39720,39600,39504,
     3  39552,39744,39768,39768,39912,39912,39840,39384,38952,38784,
     4  34800,34704,34584,34560,34584,34632,34800,34824,34896,35064,
     5  35246,34944,35712,35880,36000,35928,35856,35880,35808,35904,
     6  35880,35856,35808,35832,35760,30672,30744,30864,31272,31416,
     7  31536,31344,30768,30432,30504,30624,30672,30624,30552,29640,
     8  29664,29688,29808,29904,30000,30096,29808,25248,25464,25512,
     9  25440,23160,23184,23376,23400,23424,23520,23496,20064,20064/
            data (jy(i),i= 6501, 6600)/
     +  20256,20328,20352,20304,20328,20424,20448,20496,20400,20568,
     1  20328,20160,19680,19992,20280,20328,20280,20064,19896,15216,
     2  15624,15720,15744,15840,15552,17088,17304,17352,17376,17208,
     3  17112,21792,21792,21792,21816,21816,21840,21864,21912,21936,
     4  21960,21984,21984,21984,21960,21960,21936,21912,19848,19920,
     5  19896,19968,19944,19848,19896,19992,20016,20040,19968,19944,
     6  19992,19992,19896,19920,19848,19896,19944,20064,20016,20112,
     7  19992,20040,19992,19968,19968,19920,19944,20232,20376,20472,
     8  20376,20376,20304,20256,19584,19824,19944,19896,18120,18264,
     9  18288,18480,18480,18576,18504,17808,17904,18000,18024,18096/
            data (jy(i),i= 6601, 6700)/
     +  18216,18168,18096,16920,17016,17232,17424,17544,17472,17616,
     1  17760,17760,17784,17424,17016,15288,15552,15696,15792,15864,
     2  15960,16056,16200,16368,16512,16776,16896,16752,16536,16320,
     3  16032,15792,15552,15312,27936,28080,28272,28296,28224,27936,
     4  28608,28680,28800,28848,28920,28776,28632,29904,29952,30024,
     5  30048,30096,30120,29976,30000,29952,29928,29928,29976,30120,
     6  30120,29952,50064,50112,50208,50208,50304,50520,50592,50664,
     7  50808,50808,50688,50640,50664,50592,50544,50352,50352,50256,
     8  50136,50952,51048,51120,51168,51264,51216,51120,51096,51072,
     9  51072,51048,    0,    0,    0,    0,    0,    0,    0,    0/
            data (jb1(i),i=    1,  100)/
     +      1,    2,    3,    4,    5,    6,    7,    8,   10,   11,
     1     12,   13,   14,   15,   16,   17,   18,   19,    1,   10,
     2      9,   22,   23,   24,   25,   26,   27,   28,   29,   30,
     3     31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
     4     41,   42,   43,   44,   45,   46,   47,   48,   49,   50,
     5     51,   52,   53,   54,   55,   56,   57,   58,   59,   60,
     6     61,   62,   63,   64,   65,   66,   67,   68,   69,   70,
     7     71,   72,   73,   74,   75,   76,   77,   78,   79,   80,
     8     81,   82,   83,   84,   85,   86,   87,   88,   89,   90,
     9     91,   92,   93,   94,   95,   97,   98,   99,  100,  101/
            data (jb1(i),i=  101,  200)/
     +    102,  103,  104,  105,  106,  107,  108,  109,  110,  111,
     1    112,  113,  114,  115,  116,  117,  118,  119,  120,  121,
     2    122,  123,  124,  125,  126,  127,  128,  129,  130,  131,
     3    132,  133,  134,  135,  136,  137,  138,  139,  140,  141,
     4    142,  143,  144,  145,  146,  147,  148,  149,  150,  151,
     5    152,  153,  154,  155,  156,  157,  158,  159,  160,  161,
     6    162,  163,  164,  165,  166,  167,  168,  169,  170,  171,
     7    172,  173,  174,  175,  176,  177,  178,  179,  180,  181,
     8    182,  183,  184,  185,  186,  187,  188,  189,  190,  191,
     9    192,  193,  194,  195,  196,  197,  198,  199,  200,  201/
            data (jb1(i),i=  201,  300)/
     +    202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
     1    212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
     2    222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
     3    232,  233,  234,  235,  236,  237,  238,  239,  240,  241,
     4    242,   21,   96,  245,  246,  247,  248,  249,  250,  251,
     5    252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
     6    262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
     7    272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
     8    282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
     9    292,  293,  294,  295,  296,  297,  298,  299,  300,  301/
            data (jb1(i),i=  301,  400)/
     +    302,  303,  304,  305,  306,  307,  308,  309,  310,  311,
     1    312,  313,  314,  315,  316,  317,  318,  319,  320,  321,
     2    322,  323,  324,  325,  326,  327,  328,  329,  330,  244,
     3    332,  333,  334,  335,  336,  337,  338,  339,  341,  342,
     4    343,  332,  340,  346,  347,  348,  349,  350,  351,  352,
     5    353,  354,  355,  356,  357,  358,  359,  360,  361,  362,
     6    363,  364,  365,  366,  367,  368,  369,  370,  371,  372,
     7    373,  374,  375,  376,  377,  378,  379,  380,  381,  382,
     8    383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
     9    393,  394,  395,  396,  397,  398,  399,  400,  401,  402/
            data (jb1(i),i=  401,  500)/
     +    403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
     1    413,  414,  415,  416,  417,  418,  419,  420,  421,  422,
     2    423,  424,  425,  426,  427,  428,  429,  430,  431,  432,
     3    433,  434,  435,  436,  437,  438,  439,  440,  441,  442,
     4    443,  444,  445,  446,  447,  448,  449,  450,  451,  452,
     5    453,  454,  455,  456,  457,  458,  459,  460,  461,  462,
     6    463,  464,  465,  466,  467,  468,  345,  345,  470,  471,
     7    472,  473,  474,  475,  244,  477,  478,  479,  480,  481,
     8    482,  483,  484,  485,  486,  487,  488,  489,  490,  491,
     9    492,  493,  494,  495,  496,  497,  498,  499,  500,  501/
            data (jb1(i),i=  501,  600)/
     +    502,  503,  504,  505,  506,  507,  508,  509,  510,  511,
     1    512,  513,  514,  515,  516,  517,  519,  520,  521,  522,
     2    523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
     3    533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
     4    543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
     5    553,  554,  555,  341,  557,  558,  559,  560,  561,  562,
     6    563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
     7    573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
     8    583,  584,  585,  586,  587,  588,  589,  590,  591,  592,
     9     97,  519,  595,  596,  597,  598,  599,  600,  601,  602/
            data (jb1(i),i=  601,  700)/
     +    603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
     1    613,  614,  615,  616,  617,  618,  619,  620,  621,  622,
     2    623,  624,  625,  626,  627,  628,  629,  630,  631,  632,
     3    633,  634,  635,  636,  637,  638,  639,  640,  641,  642,
     4    643,  644,  645,  646,  647,  648,  649,  650,  651,  652,
     5    653,  654,  655,  656,  657,  658,  659,  660,  661,  662,
     6    663,  664,  665,  666,  667,  668,  669,  670,  671,  672,
     7    673,  674,  675,  676,  677,  678,  679,  680,  681,  682,
     8    683,  684,  685,  686,  687,  688,  689,  690,  691,  692,
     9    693,  694,  518,  696,  697,  698,  699,  701,  700,  703/
            data (jb1(i),i=  701,  800)/
     +    704,  705,  706,  707,  595,  476,  709,  710,  711,  712,
     1    713,  714,  715,  716,  717,  718,  719,  720,  721,  722,
     2    723,  724,  725,  726,  727,  728,  729,  730,  731,  732,
     3    733,  734,  735,  736,  737,  738,  739,  740,  741,  742,
     4    743,  744,  745,  702,  695,  747,  748,  749,  750,  751,
     5    752,  753,  754,  755,  756,  757,  758,  759,  760,  594,
     6    701,  762,  763,  764,  765,  766,  767,  768,  769,  770,
     7    771,  772,  773,  774,  775,  776,  777,  778,  779,  780,
     8    781,  782,  783,  784,  785,  786,  787,  788,  789,  790,
     9    791,  792,  793,  794,  795,  796,  797,  798,  799,  800/
            data (jb1(i),i=  801,  900)/
     +    801,  802,  803,  804,  805,  806,  807,  808,  809,  810,
     1    811,  812,  813,  814,  815,  816,  817,  818,  819,  822,
     2    820,  824,  825,  826,  827,  828,  829,  830,  831,  832,
     3    823,  822,  834,  835,  836,  837,  839,  840,  841,  842,
     4    843,  844,  845,  846,  847,  848,  849,  850,  851,  852,
     5    853,  854,  855,  856,  857,  858,  859,  860,  861,  862,
     6    863,  864,  865,  866,  867,  868,  869,  870,  871,  872,
     7    873,  874,  875,  876,  877,  878,  879,  880,  881,  882,
     8    883,  884,  885,  886,  887,  888,  889,  890,  891,  892,
     9    893,  894,  895,  896,  897,  898,  899,  900,  901,  902/
            data (jb1(i),i=  901, 1000)/
     +    903,  904,  905,  906,  907,  908,  909,  910,  911,  912,
     1    913,  914,  915,  916,  917,  918,  821,  838,  920,  921,
     2    922,  923,  924,  925,  926,  927,  928,  929,  930,  931,
     3    932,  933,  934,  935,  936,  937,  938,  939,  940,  941,
     4    942,  943,  839,  945,  946,  949,  948,  821,  951,  952,
     5    953,  954,  955,  956,  957,  958,  959,  960,  961,  962,
     6    963,  964,  965,  966,  967,  968,  969,  970,  971,  972,
     7    973,  974,  975,  976,  977,  978,  979,  980,  981,  982,
     8    983,  984,  985,  986,  987,  988,  989,  990,  991,  992,
     9    993,  994,  995,  996,  997,  998,  999, 1000, 1001, 1002/
            data (jb1(i),i= 1001, 1100)/
     +   1003, 1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012,
     1   1013, 1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022,
     2   1023, 1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032,
     3   1033, 1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042,
     4   1043, 1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052,
     5   1053, 1054, 1055,  948, 1057, 1058, 1059,  945, 1056, 1061,
     6   1062, 1063, 1064,  949,  947, 1066, 1067, 1068, 1069, 1070,
     7   1071, 1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080,
     8   1081, 1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090,
     9   1091, 1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100/
            data (jb1(i),i= 1101, 1200)/
     +   1101, 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110,
     1   1111, 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120,
     2   1121, 1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130,
     3   1131, 1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140,
     4   1141, 1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150,
     5   1151, 1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160,
     6   1161, 1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170,
     7   1171, 1172, 1173, 1174, 1175, 1176, 1177, 1178, 1180, 1181,
     8   1182, 1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191,
     9   1192, 1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201/
            data (jb1(i),i= 1201, 1300)/
     +   1202, 1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211,
     1   1212, 1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221,
     2   1222, 1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231,
     3   1232, 1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240, 1241,
     4   1242, 1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251,
     5   1252, 1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261,
     6   1262, 1263, 1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271,
     7   1272, 1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281,
     8   1282, 1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291,
     9   1292, 1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301/
            data (jb1(i),i= 1301, 1400)/
     +   1302, 1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311,
     1    557, 1179, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321,
     2   1322, 1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331,
     3   1332, 1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341,
     4   1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351,
     5   1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361,
     6   1362, 1363, 1364, 1313, 1366, 1367, 1368, 1369, 1370, 1371,
     7   1372, 1373, 1374, 1375, 1180, 1313, 1377, 1378, 1379, 1380,
     8   1381, 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390,
     9   1391, 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400/
            data (jb1(i),i= 1401, 1500)/
     +   1401, 1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409, 1410,
     1   1411, 1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419, 1420,
     2   1422, 1424, 1425, 1426, 1427, 1428, 1429, 1430, 1431, 1432,
     3   1433, 1434, 1435, 1423, 1423, 1437, 1438, 1439, 1440, 1441,
     4   1442, 1443, 1444, 1445, 1446, 1447, 1448, 1449, 1450, 1451,
     5   1453, 1454, 1455, 1456, 1457, 1458, 1459, 1460, 1461, 1462,
     6   1463, 1464, 1465, 1466, 1467, 1468, 1469, 1470, 1471, 1472,
     7   1473, 1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482,
     8   1483, 1484, 1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492,
     9   1493, 1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502/
            data (jb1(i),i= 1501, 1600)/
     +   1503, 1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512,
     1   1513, 1514, 1515, 1516, 1517, 1518, 1519, 1520, 1521, 1522,
     2   1523, 1524, 1525, 1526, 1527, 1528, 1529, 1530, 1531, 1532,
     3   1533, 1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542,
     4   1543, 1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552,
     5   1553, 1554, 1555, 1556, 1557, 1558, 1559, 1560, 1561, 1562,
     6   1563, 1564, 1565, 1566, 1567, 1568, 1569, 1570, 1571, 1572,
     7   1573, 1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582,
     8   1583, 1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592,
     9   1593, 1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601, 1602/
            data (jb1(i),i= 1601, 1700)/
     +   1603, 1452, 1452, 1605, 1606, 1607, 1608, 1609, 1610, 1611,
     1   1612, 1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621,
     2   1622, 1623, 1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631,
     3   1632, 1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641,
     4   1642, 1643, 1644, 1645, 1646, 1647, 1648, 1649, 1650, 1651,
     5   1652, 1653, 1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661,
     6   1662, 1663, 1664, 1665, 1666, 1667, 1668, 1669, 1670, 1671,
     7   1672, 1673, 1674, 1675, 1676, 1677, 1678, 1679, 1680, 1681,
     8   1682, 1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1692,
     9   1693, 1694, 1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702/
            data (jb1(i),i= 1701, 1800)/
     +   1703, 1704, 1705, 1706, 1366, 1691, 1708, 1709, 1710, 1711,
     1   1712, 1713, 1714, 1715, 1716, 1717, 1718, 1719, 1720, 1721,
     2   1722, 1723, 1724, 1725, 1726, 1727, 1728, 1729, 1730, 1731,
     3   1732, 1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740, 1741,
     4   1742, 1743, 1744, 1745, 1746, 1747, 1748, 1749, 1750, 1751,
     5   1752, 1753, 1754, 1755, 1756, 1757, 1758, 1759, 1760, 1761,
     6   1762, 1763, 1764, 1765, 1766, 1767, 1768, 1769, 1770, 1771,
     7   1772, 1773, 1774, 1775, 1776, 1777, 1778, 1779, 1780, 1781,
     8   1782, 1783, 1784, 1785, 1786, 1787, 1788, 1789, 1790, 1791,
     9   1792, 1793, 1794, 1795, 1796, 1797, 1798, 1799, 1800, 1801/
            data (jb1(i),i= 1801, 1900)/
     +   1802, 1803, 1804, 1805, 1806, 1807, 1808, 1809, 1810, 1811,
     1   1812, 1813, 1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821,
     2   1822, 1823, 1824, 1825, 1826, 1827, 1828, 1829, 1830, 1831,
     3   1832, 1833, 1834, 1835, 1836, 1837, 1838, 1839, 1840, 1841,
     4   1842, 1843, 1844, 1845, 1846, 1847, 1848, 1849, 1850, 1851,
     5   1852, 1853, 1854, 1855, 1856, 1857, 1858, 1859, 1860, 1861,
     6   1862, 1863, 1864, 1865, 1866, 1867, 1868, 1869, 1870, 1871,
     7   1872, 1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881,
     8   1882, 1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890, 1891,
     9   1892, 1893, 1894, 1895, 1896, 1897, 1692, 1421, 1899, 1900/
            data (jb1(i),i= 1901, 2000)/
     +   1901, 1902, 1903, 1904, 1905, 1906, 1907, 1908, 1909, 1910,
     1   1911, 1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920,
     2   1921, 1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929, 1930,
     3   1931, 1932, 1933, 1934, 1935, 1936, 1937, 1938, 1939, 1940,
     4   1941, 1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950,
     5   1951, 1952, 1953, 1954, 1955, 1956, 1957, 1958, 1959, 1960,
     6   1961, 1962, 1963, 1964, 1965, 1966, 1967, 1968, 1969, 1970,
     7   1971, 1972, 1973, 1974, 1975, 1976, 1977, 1978, 1979, 1980,
     8   1981, 1982, 1983, 1984, 1985, 1986, 1987, 1988, 1989, 1990,
     9   1991, 1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000/
            data (jb1(i),i= 2001, 2100)/
     +   2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010,
     1   2011, 2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020,
     2   2021, 2022, 2023, 2024, 2025, 2026, 2027, 2028, 2029, 2030,
     3   2031, 2032, 2033, 2034, 2035, 2036, 2037, 2038, 2039, 2040,
     4   2041, 2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049, 2050,
     5   2051, 2052, 2053, 2054, 2055, 2056, 2057, 2058, 2059, 2060,
     6   2061, 2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069, 2070,
     7   2071, 2072, 2073, 2074, 2075, 2076, 2077, 2078, 2079, 2080,
     8   2081, 2082, 2083, 2084, 2085, 2086, 2087, 2088, 2089, 2090,
     9   2091, 2092, 2093, 2094, 2095, 2096, 2097, 2098, 2099, 2100/
            data (jb1(i),i= 2101, 2200)/
     +   2101, 2102, 2103, 2104, 2105, 2106, 2107, 2108, 2109, 2110,
     1   2111, 2112, 2113, 2114, 2115, 2116, 2117, 2118, 1422,   21,
     2   2120, 2121, 2122, 2123, 2124, 2125, 2126, 2127, 2128, 2129,
     3   2130, 2131, 2132, 2133, 2134, 2135, 2136, 2137,    1, 2139,
     4   2140, 2141, 2142, 2143, 2144, 2145, 2146,    9, 2148, 2149,
     5   2150, 2151, 2152, 2153, 2154, 2155, 2156, 2157, 2158, 2159,
     6   2160, 2161, 2162, 2163, 2164, 2165, 2166, 2167, 2168, 2169,
     7   2170, 2171, 2172, 2173, 2174, 2175, 2176, 2177, 2178, 2179,
     8   2180, 2181, 2182, 2183, 2184, 2185, 2186, 2187, 2188, 2189,
     9   2190, 2191, 2192, 2193, 2194, 2195, 2196, 2197, 2198, 2199/
            data (jb1(i),i= 2201, 2300)/
     +   2200, 2201, 2202, 2203, 2204, 2205, 2206, 2207, 2208, 2209,
     1   2210, 2211, 2212, 2213, 2214, 2215, 2216, 2217, 2218, 2219,
     2   2220, 2221, 2222, 2223, 2224, 2225, 2226, 2227, 2228, 2229,
     3   2230, 2231, 2232, 2233, 2234, 2235, 2236, 2237, 2238, 2239,
     4   2240, 2241, 2242, 2243, 2244, 2245, 2246, 2247, 2248, 2249,
     5   2250, 2251, 2252, 2253, 2254, 2255, 2256, 2257, 2258, 2259,
     6   2260, 2261, 2262, 2263, 2264, 2265, 2266, 2267, 2268, 2269,
     7   2270, 2271, 2272, 2273, 2274, 2147, 2138, 2276, 2277, 2278,
     8   2279, 2280, 2281, 2282, 2283, 2284, 2285, 2286, 2287, 2288,
     9   2289, 2290, 2291, 2292, 2293, 2294, 2295, 2296, 2297, 2298/
            data (jb1(i),i= 2301, 2400)/
     +   2299, 2300, 2301, 2302, 2303, 2304, 2305, 2306, 2307, 2308,
     1   2309, 2310, 2311, 2312, 2313, 2314, 2315, 2316, 2317, 2318,
     2   2319, 2320, 2321, 2322, 2323, 2324, 2325, 2326, 2327, 2328,
     3   2329, 2330, 2331, 2332, 2333, 2334, 2335, 2336, 2337, 2338,
     4   2339, 2340, 2341, 2342, 2343, 2344, 2345, 2346, 2347, 2348,
     5   2349, 2350,   97,   96, 2352, 2353, 2354, 2355, 2356, 2357,
     6   2358, 2359, 2360, 2361, 2362, 2363, 2364, 2365, 2366, 2367,
     7   2368, 2369, 2370, 2371, 2372, 2373, 2374, 2375, 2376, 2377,
     8   2378, 2379, 2380, 2381, 2382, 2383, 2384, 2385, 2386, 2387,
     9   2388, 2389, 2390, 2391, 2392, 2393, 2394, 2395, 2396, 2397/
            data (jb1(i),i= 2401, 2500)/
     +   2398, 2399, 2400, 2401, 2402, 2403, 2404, 2405, 2406, 2407,
     1   2408, 2409, 2410, 2411, 2412, 2413, 2414, 2415, 2416, 2417,
     2   2418, 2419, 2420, 2421, 2422, 2423, 2424, 2425, 2426, 2427,
     3   2428, 2147, 2429, 2430, 2431, 2432, 2433, 2434, 2435, 2436,
     4   2437, 2438, 2439, 2440, 2441, 2442, 2443, 2444, 2445, 2446,
     5   2447, 2448, 2449, 2450, 2451, 2452, 2453, 2454, 2455, 2456,
     6   2457, 2458, 2459, 2460, 2461, 2462, 2463, 2464, 2465, 2466,
     7   2467, 2468, 2469, 2470, 2471, 2472, 2473, 2474, 2475, 2476,
     8   2477, 2478, 2479, 2480, 2481, 2482, 2483, 2484, 2485, 2486,
     9   2487, 2488, 2489, 2490, 2491, 2492, 2493, 2494, 2495, 2496/
            data (jb1(i),i= 2501, 2600)/
     +   2497, 2498, 2499, 2500, 2501, 2502, 2503, 2504, 2505, 2506,
     1   2507, 2508, 2509, 2510, 2511, 2512, 2513, 2514, 2515, 2516,
     2   2517, 2518, 2519, 2520, 2521, 2522, 2523, 2524, 2525, 2526,
     3   2527, 2528, 2529, 2530, 2531, 2532, 2533, 2534, 2535, 2536,
     4   2537, 2538, 2539, 2540, 2541, 2542, 2543, 2544, 2545, 2546,
     5   2547, 2548, 2549, 2550, 2551, 2552, 2553, 2554, 2555, 2556,
     6   2557, 2558, 2559, 2560, 2561, 2562, 2563, 2564, 2565, 2566,
     7   2567, 2568, 2569, 2570, 2571, 2572, 2573, 2574, 2575, 2576,
     8   2577, 2578, 2579, 2580, 2581, 2582, 2583, 2584, 2585, 2586,
     9   2587, 2588, 2589, 2590, 2591, 2592, 2593, 2594, 2595, 2596/
            data (jb1(i),i= 2601, 2700)/
     +   2597, 2598, 2599, 2600, 2601, 2602, 2603, 2604, 2605, 2606,
     1   2607, 2608, 2609, 2610, 2611, 2612, 2613, 2614, 2615, 2616,
     2   2617, 2618, 2619, 2620, 2621, 2622, 2623, 2624, 2625, 2626,
     3   2627, 2628, 2629, 2630, 2631, 2632, 2633, 2634, 2635, 2636,
     4   2637, 2638, 2639, 2640, 2641, 2642, 2643, 2644, 2645, 2646,
     5   2647, 2648, 2649, 2650, 2651, 2652, 2653, 2654, 2655, 2656,
     6   2657, 2658, 2659, 2660, 2661, 2662, 2663, 2664, 2665, 2666,
     7   2667, 2668, 2669, 2670, 2671, 2672, 2673, 2674, 2675, 2676,
     8   2677, 2678, 2679, 2680, 2681, 2682, 2683, 2684, 2685, 2686,
     9   2687, 2688, 2689, 2690, 2691, 2692, 2693, 2694, 2695, 2696/
            data (jb1(i),i= 2701, 2800)/
     +   2697,   10, 2699, 2700, 2701, 2702, 2703, 2704, 2705, 2706,
     1   2707, 2708, 2709, 2710, 2711, 2712, 2713, 2714, 2715, 2716,
     2   2717, 2718, 2719, 2720, 2721, 2722, 2723, 2724, 2725, 2726,
     3   2727, 2728, 2729, 2730, 2731, 2732, 2733, 2734, 2735, 2736,
     4   2737, 2738, 2739, 2740, 2741, 2742, 2743, 2744, 2745, 2746,
     5   2747, 2748, 2749, 2750, 2751, 2752, 2753, 2754, 2755, 2756,
     6   2757, 2758, 2759, 2760, 2761, 2762, 2763, 2764, 2765, 2766,
     7   2767, 2768,   84, 2264, 2770, 2771, 2772, 2773, 2774, 2775,
     8   2776, 2777, 2778, 2779, 2780, 2781, 2782, 2783, 2784, 2785,
     9   2786, 2787, 2788, 2789, 2699, 2791, 2792, 2793, 2794, 2795/
            data (jb1(i),i= 2801, 2900)/
     +   2796, 2797, 2798, 2799, 2800, 2801, 2802, 2803, 2804, 2805,
     1   2806, 2807, 2790,  345, 2809, 2810, 2811, 2812, 2813, 2814,
     2   2815, 2816, 2817, 2818, 2819, 2820, 2821, 2822, 2823,  340,
     3   2825, 2826, 2827, 2828, 2829, 2830, 2432, 2832, 2833, 2834,
     4   2835, 2836, 2837, 2838, 2839, 2840, 2841, 2842, 2843, 2844,
     5   2845, 2846, 2847, 2848, 2849, 2850, 2851, 2852, 2853, 2854,
     6   2855, 2856, 2857, 2858, 2859, 2860, 2861, 2862, 2863, 2864,
     7   2865, 2866, 2867, 2868, 2869, 2870, 2871, 2872, 2873, 2874,
     8   2875,  341,  332, 2877, 2878, 2879, 2880, 2881, 2882, 2883,
     9   2884, 2885, 2886, 2887, 2888, 2889, 2890, 2891, 2892, 2893/
            data (jb1(i),i= 2901, 3000)/
     +   2894, 2895, 2896, 2897, 2898, 2899, 2900, 2901, 2902, 2903,
     1   2904, 2905, 2906, 2907, 2908, 2909, 2910, 2911, 2912, 2913,
     2   2914, 2915, 2916, 2917, 2918, 2919, 2920, 2921, 2922, 2923,
     3   2924, 2925, 2926, 2927, 2928, 2929, 2930, 2931, 2932, 2933,
     4   2934, 2935, 2936, 2937, 2938, 2939, 2940, 2941, 2942, 2943,
     5   2944, 2945, 2946, 2947, 2948, 2949, 2950, 2951, 2952, 2832,
     6    476, 2954, 2955, 2956, 2957, 2958, 2959, 2960, 2961, 2962,
     7   2963, 2964, 2965, 2966, 2951, 2968, 2969, 2970, 2971, 2972,
     8   2973, 2974, 2975, 2976, 2977, 2978, 2979, 2980, 2981, 2982,
     9   2983, 2984, 2985, 2986, 2987, 2988, 2989, 2699, 2790, 2991/
            data (jb1(i),i= 3001, 3100)/
     +   2992, 2993, 2994, 2995, 2996, 2997, 2998, 2999, 3000, 3001,
     1   3002, 3003, 3004, 3005, 3006, 3007, 3008, 3009, 3010, 3011,
     2   3012, 3013, 3014, 3015, 3016, 3017, 3018, 3019, 3020, 3021,
     3   3022, 3023, 3024, 3025, 3026, 3027,  518, 3029, 3030, 3031,
     4   3032, 3033, 3034, 3035, 3036, 3037, 2968, 3028, 3039, 3040,
     5   3041, 3042, 3043, 3044, 3045, 3046, 3047, 3048, 3049, 3050,
     6   3051, 3052, 3053, 3054, 3055, 3056, 3057, 3058, 3059, 3060,
     7   3061, 3062, 3063, 3064, 3065, 3066, 3067, 3068, 3069, 3070,
     8   3071, 3072, 3073, 3074, 3075, 3076, 3077, 3078, 3079, 3080,
     9   3081, 3082, 3083, 3084, 3085, 3086, 3087, 3088, 3089, 3090/
            data (jb1(i),i= 3101, 3200)/
     +   3091, 3092, 3093, 3094, 3095, 3096, 2825, 3098, 3099, 2832,
     1   3101, 3102, 3103, 3104, 3105, 3106, 3107, 3108, 3109, 3110,
     2   3111, 3112, 3113, 3098, 3115, 3116, 3117, 3118, 3119, 2446,
     3   3115, 3121, 3122, 3123, 3124, 3126, 3127, 3128, 3129, 3130,
     4   3131, 3132, 3133, 3134, 3135, 3136, 3137, 3138, 3139, 3140,
     5   3141, 3142, 3143, 3144, 3145, 3146, 3147, 3148, 3149, 3150,
     6   3151, 3152, 3153, 3154, 3155, 3156, 3157, 3158, 3159, 3160,
     7   3161, 3162, 3163, 3164, 3165, 3166, 3167, 3168, 3169, 3170,
     8   3171, 3172, 3173, 3174, 3175, 3176, 3177, 3178, 3179, 3180,
     9   3181, 3182, 3183, 3184, 3185, 3186, 3187, 3188, 3189, 3190/
            data (jb1(i),i= 3201, 3300)/
     +   3191, 3192, 3193, 3194, 3195, 2138, 3125, 3197, 3198, 3199,
     1   3126, 3126, 3201, 3202, 3203, 3204, 3205, 3206, 3207, 3208,
     2   3209,  557,  701, 3211, 3212, 3213, 3214, 3215, 3216, 3217,
     3   3218, 3219, 3220, 3101, 3222, 3223, 3224, 3225,  695,  595,
     4   3227, 3228, 3229, 3230, 3231, 3232, 3233, 3234, 3222,  745,
     5    702, 3237, 3238, 3239, 3240, 3241, 3242, 3243, 3244, 3245,
     6   3246, 3247, 3248, 3249, 3250, 3251, 3252, 3253, 3254, 3255,
     7   3256, 3257, 3258, 3259, 3260, 3261, 3262, 3263, 3264, 3265,
     8   3266, 3267, 3268, 3269, 3270, 3271, 3272, 3273, 3274, 3275,
     9   3276, 3277, 3278, 3279, 3280,  519, 3101, 3282, 3283, 3284/
            data (jb1(i),i= 3301, 3400)/
     +   3285, 3286,  770, 2825, 3288, 3289, 3290, 3291, 3292, 3098,
     1   3294, 3295, 3296, 3297, 3298, 3299,  778, 3301, 3302, 3303,
     2   3304, 3305, 3115, 3293, 3307, 3308, 3309, 3310, 3311, 3312,
     3   3301,  782, 3314, 3315, 3316, 3317, 3318, 3319, 3320, 3321,
     4   3237, 3323, 3324, 3325, 3326, 3327, 3328,  594, 3330, 3331,
     5   3332, 3333, 3334, 3335, 3336, 3337, 3338, 3339, 3340, 3341,
     6   3342, 3343, 3344, 3345, 3346, 3347, 3348, 3349, 3350, 3351,
     7   3352, 3353, 3354, 3355, 3356, 3357, 3358, 3359, 3360, 3361,
     8   3362, 3363, 3364, 3365, 3366, 3367, 3368, 3369, 3370, 3371,
     9   3372, 3373, 3374, 3375, 3376, 3377, 3378, 3379, 3380, 3381/
            data (jb1(i),i= 3401, 3500)/
     +   3382, 3383, 3384, 3385, 3386, 3387, 3388, 3389, 3390, 3391,
     1   3392, 3028, 2968, 3394, 3395, 3396, 3397, 3398, 3399, 3400,
     2   3401, 3402, 3403, 3404, 3405, 3406, 3407, 3408, 3409, 3410,
     3   3411, 3412, 3413, 3414, 3415, 3416, 3417, 3418, 3419, 3420,
     4   3421, 3422, 3423, 3424, 3425, 3426, 3427, 3428, 3429, 3430,
     5   3431, 3432, 3433, 3434, 3435, 3436, 3437, 3438, 3439, 3440,
     6   3441, 3442, 3443, 3444, 3445, 3446, 3447, 3448, 3449, 3450,
     7   3451, 3452, 3453, 3454, 3455, 3456, 3457, 3458, 3459, 3460,
     8   3461, 3462, 3463, 3464, 3465, 3466, 3467, 3468, 3469, 3470,
     9   3471, 3472, 3473, 3474, 3475, 3476, 3477, 3478, 3479, 3480/
            data (jb1(i),i= 3501, 3600)/
     +   3481, 3482, 3483, 3484, 3485, 3486, 3487, 3488, 3330, 3330,
     1   3490, 3491, 3492, 3493, 3494, 3495, 3496, 3497, 3498, 3499,
     2   3500, 3501, 3502, 3503, 3504, 3505, 3506, 3507, 3508, 3509,
     3   3510, 3511, 3512, 3513, 3514, 3515, 3516, 3518, 3519, 3520,
     4   3521, 3522, 3523, 3524, 3525, 3526, 3293, 3517, 3528, 3529,
     5   3530, 3531, 3532, 3533, 3534, 3535, 3536, 3537, 3538, 3539,
     6   3540, 3541, 3542, 3543, 3544, 3545, 3546, 3547, 3518, 3237,
     7   3549, 3550, 3551, 3552, 3553, 3554, 3555, 3556, 3557, 3558,
     8   3559, 3560, 3561, 3562, 3563, 3564, 3565, 3566, 3567, 3568,
     9   3569, 3570, 3571, 3572, 3573, 3574, 3575, 3576, 3577, 3578/
            data (jb1(i),i= 3601, 3700)/
     +   3579, 3580, 3581, 3582, 3583, 3584, 3585, 3586, 3587, 3588,
     1   3589, 3590, 3591, 3592, 3593, 3594, 3595, 3596, 3597, 3598,
     2   3599, 3600, 3601, 3602, 3603, 3604, 3605, 3606, 3607, 3608,
     3   3609, 3610, 3611, 3612, 3613, 3614, 3615, 3616, 3617, 3618,
     4   3619, 3620, 3622, 3623, 3624, 3625, 3626, 3627, 3628, 3629,
     5   3630, 3323, 3621, 3632, 3633, 3634, 3635, 3636, 3637, 3638,
     6   3639, 3640, 3641, 3642, 3643, 3644, 3622, 3646, 3647, 3648,
     7   3649, 3650, 3615, 3622, 3652, 3653, 3654, 3655, 3656, 3657,
     8   3658, 3659, 3660, 3661, 3662, 3663, 3664, 3665, 3666, 3667,
     9   3668, 3669, 3670, 3671, 3672, 3673, 3674, 3675, 3676, 3677/
            data (jb1(i),i= 3701, 3800)/
     +   3678, 3679, 3680, 3681, 3682, 3683, 3684, 3685, 3686, 3687,
     1   3688, 3689, 3690, 3691, 3692, 3693, 3694, 3695, 3696, 3697,
     2   3698, 3699, 3700, 3701, 3702, 3703, 3704, 3705, 3706, 3707,
     3   3708, 3709, 3710, 3711, 3712, 3713, 3714, 3715, 3716, 3717,
     4   3718, 3719, 3720, 3721, 3722, 3723, 3724, 3725, 3726, 3727,
     5   3728, 3729, 3730, 3731, 3732, 3733, 3734, 3735, 3736, 3737,
     6   3738, 3739, 3740, 3741, 3742, 3222, 3744, 3745, 3746, 3747,
     7   3748, 3749, 3750, 3751, 3752, 3753, 3754, 3755, 3756, 3757,
     8   3758, 3759, 3760, 3762, 3763, 3764, 3765, 3766, 3767, 3768,
     9   3769, 3770, 3771, 3772, 3773, 3774, 3775, 3776, 3777, 3778/
            data (jb1(i),i= 3801, 3900)/
     +   3779, 3743, 3762, 3781, 3782, 3783, 3784, 3785, 3786, 3787,
     1   3788, 3762,  821, 3790, 3791, 3792, 3784,  822, 3794, 3795,
     2   3796, 3797, 3798, 3799, 3800, 3801, 3621, 3646,  820,  823,
     3   3804, 3805, 3806, 3807, 3808, 3809, 3810, 3811, 3812, 3813,
     4   3814, 3815, 3816, 3817, 3818, 3819, 3820, 3821, 3822, 3823,
     5   3824, 3825, 3826, 3827, 3828, 3829, 3830, 3831, 3832, 3833,
     6   3834, 3835, 3836, 3837, 3838, 3839, 3840, 3841, 3842, 3843,
     7   3844, 3845, 3846, 3847, 3848, 3849, 3850, 3851, 3852, 3853,
     8   3854, 3855, 3856, 3857, 3858, 3859, 3860, 3861, 3862, 3863,
     9   3761, 3323, 3865, 3866, 3867, 3868, 3869, 3870, 3871, 3872/
            data (jb1(i),i= 3901, 4000)/
     +   3873, 3874, 3875, 3876, 3877, 3878, 3879, 3880, 3881, 3882,
     1   3883, 3884, 3885, 3886, 3887, 3888, 3889, 3890, 3891, 3892,
     2   3893, 3894, 3895, 3896, 3897, 3898, 3899, 3900, 3901, 3902,
     3   3903, 3904, 3905, 3906, 3907, 3908, 3909, 3910, 3911, 3912,
     4   3913, 3914, 3915, 3916, 3917, 3918, 3919, 3920, 3921, 3922,
     5   3923, 3924, 3925, 3926, 3927, 3928, 3929, 3930, 3931, 3932,
     6   3933, 3934, 3935, 3936, 3937, 3938, 3939, 3940, 3941, 3942,
     7   3943, 3944, 3945, 3946, 3947, 3948, 3949, 3950, 3951, 3952,
     8   3953, 3954, 3955, 3956, 3957, 3958, 3959, 3960, 3961, 3962,
     9   3963, 3964, 3965, 3804,  838, 3967, 3968, 3969, 3970, 3971/
            data (jb1(i),i= 4001, 4100)/
     +   3972, 3973, 3974, 3975, 3976, 3977, 3978, 3979, 3980, 3981,
     1   3982, 3983, 3984, 3985, 3986, 3987, 3988, 3989, 3990, 3991,
     2   3992, 3993, 3994, 3995, 3996, 3997, 3998, 3999, 4000, 4001,
     3   4002, 4003, 4004, 4005, 4006, 4007, 4008, 4009, 4010, 4011,
     4   4012, 4013, 4014, 4015, 4016, 4017, 4018, 4019, 4020, 4021,
     5   4022, 4023, 4024, 4025, 4026, 4027, 4028, 4029, 4030, 4031,
     6   4032, 4033, 4034, 4035, 4036, 4037, 4038, 4039, 4040, 4041,
     7   4042, 4043, 4044, 4045, 4046, 4047, 4048, 4049, 4050, 4051,
     8   4052, 4053, 4054, 4055,  700, 3761, 4057, 4058, 4059, 4060,
     9   4061, 4062, 4063, 4064, 4065, 4066, 4067, 4068, 4069, 4070/
            data (jb1(i),i= 4101, 4200)/
     +   4071, 4072, 4073, 4074, 4075, 4076, 4077, 4078, 4079, 4080,
     1   4081, 4082, 4083, 4084, 4085, 4086, 4087, 4088, 4089, 4090,
     2   4091, 4092, 4093, 4094, 4095, 4096, 4097, 4098, 4099, 4100,
     3   4101, 4102, 4103, 4104, 4105, 4106, 4107, 4108, 4109, 4110,
     4   4111, 4112, 4113, 4114, 4115, 4116, 4117, 4118, 4119, 4120,
     5   4121, 4122, 4123, 4124, 4125, 4126, 4127, 4128, 4129, 4130,
     6   4131, 4132, 4133, 4134, 4135, 4136, 4137, 4138, 4139, 4140,
     7   4141, 4142, 4143, 4144, 4145, 4146, 4147, 4148, 4149, 4150,
     8   4151, 4152, 4153, 4154, 4155, 4156, 4157, 4158, 4159, 4160,
     9   4161, 4162, 4163, 4164, 4165, 4166, 4167, 4168, 4169, 4170/
            data (jb1(i),i= 4201, 4300)/
     +   4171, 4172, 4173, 4174, 4175, 4176, 4177, 4178, 4179, 4180,
     1   4181, 3968, 4183, 4184, 4185, 4186, 4187, 4188, 4189, 4190,
     2   4191, 4192, 4193, 4194, 4195, 4196, 4197, 4198, 4199, 4200,
     3   4201, 4202, 4203, 4204, 4205, 4206, 4207, 4208, 4209, 4210,
     4   4211, 4212, 4213, 4214, 4215, 4216, 3804, 3743, 4218, 4219,
     5   4220, 4221, 4222, 4223, 4224, 4225, 4226, 4227, 4228, 4229,
     6   4230, 4231, 4232, 4233, 4234, 4235, 4236, 4237, 4238, 4239,
     7   4240, 4241, 4242, 4243, 4244, 4245, 4246, 4247, 4248, 4249,
     8   4250, 4251, 4252, 4253, 4254, 4255, 4256, 4257, 4258, 4259,
     9   4260, 4261, 4262, 4263, 4264, 4265, 4266, 4267, 4268, 4269/
            data (jb1(i),i= 4301, 4400)/
     +   4270, 4271, 4272, 4273, 4274, 4275, 4276, 4277, 4278, 4279,
     1   4280, 4281, 4282, 4283, 4284, 4285, 4286, 4287, 4288, 4289,
     2   4290, 4291, 4292, 4293, 4294, 4295, 4296, 4297, 4298, 4299,
     3   4300, 4301, 4302, 4303, 4304, 4305, 4306, 4307, 4308, 4309,
     4   4310, 4311, 4312, 4313, 4314, 4315, 4316, 4317, 4318, 4319,
     5   4320, 4321, 4322, 4323, 4324, 4325, 4326, 4327, 4328, 4329,
     6   4330, 4331, 4332, 4333, 4334, 4335, 4336, 4337, 4338, 4339,
     7   4340, 4341, 4342, 4343, 4344, 4345, 4346, 4347, 4348, 4349,
     8   4350, 4351, 4352, 4353, 4354, 4355, 4356, 4357, 4358, 4183,
     9   3517, 4360, 4361, 4362, 4363, 4364, 4365, 4366, 4367, 4368/
            data (jb1(i),i= 4401, 4500)/
     +   4369, 4370, 4371, 4372, 4373, 4374, 4375, 4376, 4377, 4378,
     1   4379, 4380, 4381, 4382, 4383, 4384, 4385, 4386, 4387, 4388,
     2   4389, 4390, 4391, 4392, 4393, 4394, 4395, 4396, 4397, 4398,
     3   4399, 4400, 4401, 4402, 4403, 4404, 4405, 4406, 4407, 4408,
     4   4409, 4410, 4411, 4412, 4413, 4414, 4415, 4416, 4417, 4418,
     5   3301, 4420, 4421, 4422, 4423, 4424, 4425, 4426, 4427, 4428,
     6   4429, 3125, 4431, 4432, 4433, 4434, 4435, 4436, 4437, 4438,
     7   4430, 4440, 4441, 4442, 4443, 4444, 4445, 4446, 4439, 4448,
     8   4449, 4450, 4451, 4452, 4453, 4454, 4455, 4456, 4457, 4458,
     9   4459, 4430, 3518, 4461, 4462, 4463, 4464, 4465, 4466, 4467/
            data (jb1(i),i= 4501, 4600)/
     +   4468, 4469, 4470, 4448, 4419, 4472, 4473, 4474, 4475, 4476,
     1   4477, 4478, 4479, 4480, 4481, 4482, 4483, 4484, 4485, 4486,
     2   4487, 4488, 4489, 4490, 4491, 4492, 4493, 4494, 4495, 4471,
     3   3968, 4497, 4498, 4499, 4500, 4501, 4502, 4503, 4504, 4505,
     4   4506, 4507, 4508, 4509, 4510, 4511, 4512, 4513, 4514, 4515,
     5   4516, 4517, 4518, 4519, 4520, 4521, 4522, 4523, 4524, 4525,
     6   4526, 4527, 4528, 4529, 4530, 4531, 4532, 4533, 4534, 4535,
     7   4536, 4537, 4538, 4539, 4540, 4541, 4542, 4543, 4544, 4545,
     8   4546, 4547, 4548, 4549, 4550, 4551, 4552, 4553, 4554, 4555,
     9   4556, 4557, 4558, 4559, 4560, 4561, 4562, 4563, 4564, 4565/
            data (jb1(i),i= 4601, 4700)/
     +   4566, 4567, 4568, 4569, 4570, 4571, 4572, 4573, 4574, 4575,
     1   4576, 4577, 4578, 4579, 4580, 4581, 4582, 4583, 4584, 4585,
     2   4586, 4587, 4588, 4589, 4590, 4591, 4592, 4593, 4594, 4595,
     3   4596, 4597, 4598, 4599, 4600, 4601, 4602, 4603, 4604, 4605,
     4   4606, 4607, 4608, 4609, 4610, 4611, 4612, 4613, 4614, 4615,
     5   4616, 4617, 4618, 4619, 4620, 4621, 4622, 4623, 4624, 4625,
     6   4626, 4627, 4628, 4629, 4630, 4631, 4632, 4633, 3459, 4183,
     7   4635, 4636, 4637, 4638, 4639, 4640, 4641, 4642, 4643, 4644,
     8   4645, 4646, 4647, 4648, 4649, 4650, 4651, 4652, 4653, 4654,
     9   4655, 4656, 4657, 4658, 4659, 4660, 4661, 4663, 4664, 4665/
            data (jb1(i),i= 4701, 4800)/
     +   4666, 4667, 4668, 4669, 4670, 4671, 4672, 4673, 4674, 4675,
     1   4676, 4662,  945,  949,  947, 4678, 4679, 4680, 4681, 4682,
     2   4683, 4684, 4685, 4686, 4687, 4688, 4689, 4690, 4691, 4692,
     3   4693, 4694, 4695, 4696, 4697, 4698, 4699, 4700, 4701, 4663,
     4   4703, 4704, 4705, 4706, 4707, 4708, 4709, 4710, 4711, 4712,
     5   4713, 4714, 4715, 4716, 4717, 4718, 4719, 4720, 4721, 4722,
     6   4723, 4528, 4725, 4726, 4727, 4728, 4729, 4730, 4731, 4732,
     7   4733, 4725, 4662, 4735, 4736, 4737, 4738, 4739, 4740, 4741,
     8   4742, 4743, 4744, 4745, 4746, 4747, 4748, 4749, 4750, 4751,
     9   4752, 4753, 4754, 4755, 4756, 4757, 4758, 4759, 4760, 4761/
            data (jb1(i),i= 4801, 4900)/
     +   4762, 4763, 4764, 4765, 4766, 4703, 4448, 4769, 4770, 4419,
     1   4703, 4772, 4773, 4725, 4726, 4775, 4776, 4777, 4778, 4779,
     2   4780, 4781, 4782, 4783, 4784, 4785, 4786, 4787, 4788, 4789,
     3   4790, 4791, 4792, 4793, 4794, 4795, 4796, 4797, 4798, 4799,
     4   4800, 4801, 4802, 4803, 4804, 4805, 4806, 4807, 4808, 4809,
     5   4810, 4811, 4812, 4813, 4814, 4815, 4816, 4817, 4818, 4819,
     6   4820, 4821, 4822, 4823, 4824, 4825, 4826, 4827, 4828, 4829,
     7   4830, 4831, 4832, 4833, 4834, 4835, 4769, 4837, 4838, 4839,
     8   4840, 4841, 4842, 4843, 4844, 4845, 4846, 4847, 4848, 4849,
     9   4850, 4851, 4852, 4853, 4854, 4855, 4856, 4857, 4858, 4859/
            data (jb1(i),i= 4901, 5000)/
     +   4860, 4861, 4862, 4863, 4864, 4865, 4866, 4867, 4868, 4869,
     1   4870, 4871, 4872, 4873, 4874, 4875, 4876, 4877, 4878, 4879,
     2   4880, 4881, 4882, 4883, 4884, 4885, 4886, 4887, 4888, 4889,
     3   4890, 4891, 4892, 4893, 4894, 4895, 4896, 4897, 4898, 4899,
     4   4900, 4901, 4902, 4903, 4796, 4905, 4906, 4907, 4908, 4909,
     5   4910, 4911, 4912, 4913, 4837, 4439, 4915, 4916, 4917, 4918,
     6   4919, 4920, 4921, 4922, 4923, 4924, 4925, 4926, 4927, 4928,
     7   4929, 4930, 4931, 4932, 4933, 4934, 4935, 4936, 4937, 4938,
     8   4939, 4940, 4941, 4942, 4943, 4944, 4945, 4946, 4947, 4948,
     9   4949, 4950, 4951, 4952, 4953, 4954, 4955, 4956, 4957, 4958/
            data (jb1(i),i= 5001, 5100)/
     +   4959, 4960, 4961, 4962, 4963, 4964, 4965, 4966, 4967, 4968,
     1   4969, 4970, 4971, 4972, 4973, 4974, 4975, 4976, 3204, 4978,
     2   4979, 4980, 4981, 4982, 4983, 4984, 4985, 4986, 4987, 4905,
     3   4989, 4990, 4991, 4992, 4993, 4994, 4995, 4996, 4997, 4998,
     4   4999, 5000, 5001, 5002, 5003, 5004, 5005, 5006, 5007, 5008,
     5   5009, 5010, 5011, 5012, 5013, 5014, 5015, 5016, 5017, 5018,
     6   5019, 5020, 5021, 5022, 5023, 5024, 5025, 5026, 5027, 5028,
     7   5029, 5030, 5031, 5032, 5033, 5034, 5035, 5036, 5037, 5038,
     8   5039, 5040, 5041, 5042, 5043, 5044, 5045, 5046, 5047, 5048,
     9   5049, 5050, 5051, 5052, 5053, 4663, 4989, 5055, 5056, 5057/
            data (jb1(i),i= 5101, 5200)/
     +   5058, 5059, 5060, 4978, 5062, 5063, 5064, 5065, 5066, 4989,
     1   1179, 5068, 5069, 5070, 5071, 5072, 5073, 5074, 5075, 5076,
     2   5077, 5078, 5079, 5080, 5081, 5082, 5083, 5084, 5085, 5086,
     3   5087, 5088, 5089, 5090, 5091, 5092, 5093, 5094, 5095, 5096,
     4   5097, 5098, 5099, 5100, 5101, 5102, 5103, 5104, 5105, 5106,
     5   5062, 4769, 5108, 5109, 5110, 5111, 5112, 5113, 5114, 5115,
     6   5116, 5117, 5118, 5119, 5120, 5121, 5122, 5123, 5124, 5125,
     7   5126, 5127, 5128, 5129, 5130, 5131, 5132, 5133, 5134, 5135,
     8   5136, 5137, 5138, 5139, 5140, 5141, 5142, 5143, 5144, 5145,
     9   5146, 5147, 5148, 5149, 5150, 5151, 5152, 5153, 5154, 5155/
            data (jb1(i),i= 5201, 5300)/
     +   5156, 5157, 5158, 5159, 5160, 5161, 5162, 5163, 5164, 5165,
     1   5166, 5167, 5168, 5169, 5170, 5171, 5172, 5173, 5174, 5175,
     2   5176, 5177, 5178, 5179, 5180, 5181, 5182, 5183, 5184, 5185,
     3   5186, 5187, 5188, 5189, 5190, 5191, 5192, 5193, 5194, 5195,
     4   5196, 5197, 5198, 5199, 5200, 5201, 5202, 5203, 5204, 5205,
     5   5206, 5207, 5208, 5209, 5210, 5211, 5212, 5213, 5214, 5215,
     6   5216, 5217, 5218, 5219, 5220, 5221, 5222, 5223, 5224, 5225,
     7   5226, 5227, 5228, 5229, 5230, 5231, 5232, 5233, 5234, 5235,
     8   5236, 5237, 5238, 5239, 5240, 5241, 5242, 5243, 5244, 5245,
     9   5246, 5247, 5248, 5249, 5250, 5251, 5252, 5253, 5254, 5255/
            data (jb1(i),i= 5301, 5400)/
     +   5256, 5257, 5258, 5259, 5260, 5261, 5262, 5263, 5264, 5265,
     1   5266, 5267, 5268, 5269, 5270, 5271, 5272, 5273, 5274, 5275,
     2   5276, 5277, 5278, 5279, 5280, 5281, 5282, 5283, 5284, 5285,
     3   5286, 5287, 5288, 5289, 5290, 5291, 5292, 5293, 5294, 5295,
     4   5296, 5297, 5298, 5299, 5300, 5301, 5302, 5303, 5304, 5305,
     5   5306, 5307, 5308, 5309, 5310, 5311, 5312, 5313, 5314, 5315,
     6   5316, 5317, 5318, 5319, 5320, 5321, 5322, 5323, 5324, 5325,
     7   5326, 5327, 5328, 5329, 5330, 5331, 5332, 5333, 5334, 5335,
     8   5336, 5337, 5338, 5339, 5340, 5341, 5342, 5343, 5344, 5345,
     9   5346, 5347, 5348, 5349, 5350, 5351, 5352, 5353, 5354, 5355/
            data (jb1(i),i= 5401, 5500)/
     +   5356, 5357, 5358, 5359, 5360, 5361, 5362, 5363, 5364, 5365,
     1   4768, 5119, 5367, 5368, 5369, 5370, 5371, 5372, 5373, 5374,
     2   5375, 5376, 5377, 5378, 5379, 5380, 5381, 5382, 5383, 5384,
     3   5385, 5386, 5387, 5388, 5389, 5390, 5391, 5392, 5394, 5395,
     4   5396, 5397, 5398, 5399, 5400, 5401, 5402, 5403, 5404, 5405,
     5   5406, 5407, 5408, 5409, 5410, 5411, 5412, 5413, 5414, 5415,
     6   5416, 5417, 5418, 5419, 5420, 5421, 5422, 5423, 5424, 5425,
     7   5426, 5427, 5428, 5429, 5430, 5431, 5432, 5433, 5434, 5435,
     8   5436, 5437, 5438, 5439, 5440, 5441, 5442, 5443, 5444, 5445,
     9   5446, 5447, 5448, 5449, 5450, 5451, 5452, 5453, 5454, 5455/
            data (jb1(i),i= 5501, 5600)/
     +   5456, 5457, 5458, 5459, 5460, 5461, 5462, 5463, 5464, 5465,
     1   5466, 5467, 5468, 5469, 5470, 5471, 5472, 5473, 5474, 5475,
     2   5476, 5477, 5478, 5479, 5480, 5481, 5482, 5483, 5484, 5485,
     3   5486, 5487, 5488, 5489, 5490, 5491, 5492, 5493, 5494, 5495,
     4   5496, 5497, 5498, 5499, 5500, 5501, 5502, 5503, 5504, 5505,
     5   5506, 5507, 5508, 5509, 5510, 5511, 5512, 5513, 5514, 5515,
     6   5516, 5517, 5518, 5519, 5520, 5521, 5522, 5523, 5524, 5525,
     7   5526, 5527, 5528, 5529, 5530, 5531, 5532, 5533, 5534, 5535,
     8   5536, 5537, 5538, 5539, 5540, 5541, 5542, 5543, 5544, 5545,
     9   5546, 5547, 5548, 5549, 5550, 5551, 5552, 5553, 4837, 5394/
            data (jb1(i),i= 5601, 5700)/
     +   5555, 5556, 5557, 5558, 5559, 5560, 5561, 5562, 5563, 5393,
     1   4960, 5565, 5566, 5567, 5568, 5569, 5570, 5571, 5572, 5573,
     2   5574, 5575, 5576, 5577, 5578, 5579, 5580, 5581, 5582, 5583,
     3   5584, 5585, 5586, 5587, 5588, 5589, 5590, 5591, 5592, 5593,
     4   5594, 5595, 5596, 5597, 5598, 5599, 5600, 5601, 5602, 5603,
     5   5604, 5605, 5606, 5607, 5608, 5609, 5610, 5611, 5612, 5613,
     6   5614, 5615, 5616, 5617, 5618, 5619, 5620, 5621, 5622, 5623,
     7   5624, 5625, 5626, 5627, 5628, 5629, 5630, 5631, 5632, 5633,
     8   5634, 5635, 5636, 5637, 5638, 5639, 5640, 5641, 5642, 5062,
     9   5643, 5644, 5645, 5646, 5647, 5648, 5649, 5650, 5651, 5652/
            data (jb1(i),i= 5701, 5800)/
     +   5653, 5654, 5655, 5656, 5657, 5658, 5659, 5660, 5661, 5662,
     1   5663, 5664, 5665, 5666, 5667, 5668, 5669, 5670, 5671, 5672,
     2   5673, 5674, 5675, 5676, 5677, 5678, 5679, 5680, 5681, 5682,
     3   5683, 5684, 5685, 5686, 5687, 5688, 5689, 5690, 5691, 5692,
     4   5693, 5694, 5695, 5696, 5697, 5698, 5699, 5700, 5701, 5702,
     5   5703, 5704, 5705, 5706, 5707, 5708, 5709, 5710, 5711, 5712,
     6   5713, 5714, 5715, 5716, 5717, 5718, 5719, 5720, 5721, 5722,
     7   5723, 5724, 5725, 5726, 5727, 5728, 5729, 5730, 5731, 5732,
     8   5733, 5734, 5735, 5736, 5737, 5738, 5739, 5740, 5741, 5742,
     9   5743, 5744, 5745, 5746, 5747, 5748, 5749, 5750, 5751, 5752/
            data (jb1(i),i= 5801, 5900)/
     +   5753, 5754, 5755, 5756, 5757, 5758, 5759, 5760, 5761, 5762,
     1   5763, 5764, 5765, 5766, 5767, 5768, 5769, 5770, 5771, 5772,
     2   5773, 5774, 5775, 5776, 1366, 5777, 5778, 5779, 5780, 5781,
     3   5782, 5783, 5784, 5785, 5786, 5787, 5788, 5789, 5790, 5791,
     4   5792, 5793, 5794, 5795, 5796, 5797, 5798, 5799, 5800, 5801,
     5   5802, 5803, 5804, 5805, 4768, 4430, 5807, 5808, 5809, 5810,
     6   5811, 5812, 1370, 4978, 5814, 5815, 5816, 5817, 5818, 5819,
     7   5820, 5821, 5822, 5823, 5824, 5825, 5826, 5827, 5828, 5829,
     8   5830, 5831, 5832, 5833, 5834, 5835, 5836, 5837, 5838, 5839,
     9   5840, 5841, 5842, 5843, 5844, 5845, 5846, 5847, 5848, 5849/
            data (jb1(i),i= 5901, 6000)/
     +   5850, 5851, 5852, 5853, 5854, 5855, 5856, 5857, 5858, 5859,
     1   5860, 5861, 5862, 5863, 5864, 5865, 5866, 5867, 5868, 5869,
     2   5870, 5871, 5872, 5873, 5874, 5875, 5876, 5877, 5878, 5879,
     3   5880, 5881, 5882, 5883, 5884, 5885, 5886, 5887, 5888, 5889,
     4   5890, 5891, 5892, 5893, 5894, 5895, 5896, 5897, 5898, 5899,
     5   5900, 5901, 5902, 5903, 1423, 5904, 5905, 5906, 5907, 5908,
     6   5909, 5910, 5911, 5912, 5913, 5914, 5915, 5916, 5917, 5918,
     7   5919, 5920, 5921, 5922, 5923, 5924, 4905, 1421, 5926, 5927,
     8   5928, 5929, 5930, 5931, 5932, 5933, 5934, 5935, 5936, 5937,
     9   5938, 5939, 5940, 5941, 5942, 5943, 5944, 5945, 5946, 5947/
            data (jb1(i),i= 6001, 6100)/
     +   5948, 5949, 5950, 5951, 5952, 5953, 5954, 5955, 5956, 5957,
     1   5958, 5959, 5960, 5961, 5962, 5963, 5964, 5965, 5966, 5967,
     2   5968, 5969, 5970, 5971, 5972, 5973, 5974, 5975, 5976, 5977,
     3   5978, 5979, 5980, 5884, 1451, 5982, 5983, 5984, 5985, 5986,
     4   5987, 5988, 5989, 5990, 5991, 5992, 5993, 5994, 5995, 5996,
     5   5997, 5998, 5999, 6000, 6001, 6002, 6003, 6004, 6005, 6006,
     6   6007, 6008, 6009, 6010, 6011, 6012, 6013, 6014, 6015, 6016,
     7   6017, 6018, 6019, 6020, 6021, 6022, 6023, 6024, 6025, 6026,
     8   6027, 6028, 6029, 6030, 6031, 6032, 6033, 6034, 6035, 6036,
     9   6037, 6038, 6039, 6040, 6041, 6042, 6043, 6044, 6045, 6046/
            data (jb1(i),i= 6101, 6200)/
     +   6047, 6048, 6049, 6050, 6051, 6052, 6053, 6054, 6055, 6056,
     1   6057, 6058, 6059, 6060, 6061, 6062, 6063, 6064, 6065, 6066,
     2   6067, 6068, 6069, 6070, 6071, 6072, 6073, 6074, 6075, 6076,
     3   6077, 6078, 6079, 6080, 6081, 6082, 6083, 6084, 6085, 6086,
     4   6087, 6088, 6089, 6090, 6091, 6092, 6093, 6094, 6095, 6096,
     5   6097, 6098, 6099, 6100, 6101, 6102, 6103, 6104, 6105, 6106,
     6   6107, 6108, 6109, 6110, 6111, 6112, 6113, 6114, 6115, 6116,
     7   6117, 6118, 6119, 6120, 6121, 6122, 6123, 6124, 6125, 6126,
     8   6127, 6128, 6129, 6130, 6131, 6132, 6133, 6134, 6135, 6136,
     9   6137, 6138, 6139, 6140, 6141, 6142, 6143, 6144, 6145, 6146/
            data (jb1(i),i= 6201, 6300)/
     +   6147, 6148, 6149, 6150, 6151, 6152, 6153, 6154, 6155, 6156,
     1   6157, 6158, 6159, 6160, 6161, 6162, 6163, 5394, 5393, 6165,
     2   6166, 6167, 6168, 6169, 6170, 6171, 6172, 6173, 6174, 6175,
     3   6176, 6177, 6178, 6179, 6180, 6181, 6182, 6183, 6184, 6185,
     4   6186, 6187, 6188, 6189, 6190, 6191, 6192, 6193, 6194, 6195,
     5   6196, 6197, 6198, 6199, 6200, 6201, 6202, 6203, 6204, 6205,
     6   6206, 6207, 6208, 6209, 6210, 6211, 6212, 6213, 6214, 6215,
     7   6216, 6217, 6218, 6219, 6220, 6221, 6222, 6223, 6224, 6225,
     8   6226, 6227, 6228, 6229, 6230, 6231, 6232, 6233, 6234, 6235,
     9   6236, 6237, 6238, 6239, 6240, 6241, 6242, 6243, 6244, 6245/
            data (jb1(i),i= 6301, 6400)/
     +   6246, 6247, 6248, 6249, 6250, 6251, 6252, 6253, 6254, 6255,
     1   6256, 6257, 6258, 6259, 6260, 6261, 6262, 6263, 6264, 6265,
     2   6266, 6267, 6268, 6269, 6270, 6271, 6272, 6273, 6274, 6275,
     3   6276, 6277, 6278, 6279, 6280, 6281, 6282, 6283, 6284, 6285,
     4   6286, 6287, 6288, 6289, 6290,    1,    2,    3,    4,    5,
     5      6,    7,    1,    9,   10,   11,   12,   13,   14,   15,
     6     16,   17,   18,   19,    9,   21,   22,   23,   24,   25,
     7     26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
     8     36,   37,   38,   39,   40,   41,   21,   43,   44,   45,
     9     46,   47,   48,   49,   50,   51,   52,   53,   54,   55/
            data (jb1(i),i= 6401, 6500)/
     +     56,   57,   43,   59,   60,   61,   62,   63,   64,   65,
     1     59,   67,   68,   69,   70,   71,   72,   73,   74,   75,
     2     76,   77,   67,   79,   80,   81,   82,   83,   84,   85,
     3     86,   87,   88,   89,   90,   91,   79,   93,   94,   95,
     4     96,   93,   98,   99,  100,  101,  102,  103,  104,  105,
     5    106,  107,   98,  109,  110,  111,  112,  113,  114,  109,
     6    116,  117,  118,  119,  120,  121,  122,  123,  124,  125,
     7    126,  127,  128,  129,  130,  131,  132,  133,  134,  135,
     8    136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
     9    146,  147,  148,  149,  116,  151,  152,  153,  154,  155/
            data (jb1(i),i= 6501, 6600)/
     +    156,  157,  158,  159,  160,  161,  151,  163,  164,  165,
     1    166,  167,  168,  169,  170,  171,  172,  173,  174,  163,
     2    176,  177,  178,  179,  180,  181,  182,  176,  184,  185,
     3    186,  187,  188,  184,  190,  191,  192,  193,  194,  195,
     4    196,  190,  198,  199,  200,  198,  202,  203,  204,  205,
     5    206,  207,  202,  209,  210,  211,  212,  213,  214,  215,
     6    216,  217,  218,  219,  220,  221,  209,  223,  224,  225,
     7    226,  227,  228,  223,  230,  231,  232,  233,  234,  230,
     8    236,  237,  238,  239,  240,  236,  242,  243,  244,  245,
     9    246,  247,  248,  249,  250,  251,  252,  253,  254,  255/
            data (jb1(i),i= 6601, 6700)/
     +    256,  257,  242,  259,  260,  261,  262,  263,  264,  265,
     1    266,  267,  268,  269,  270,  271,  272,  273,  274,  259,
     2    276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
     3    286,  276,  288,  289,  290,  291,  292,  293,  288,  295,
     4    296,  297,  295,  299,  300,  301,  302,  303,  304,  299,
     5    306,  307,  308,  309,  310,  311,  312,  306,  314,  315,
     6    316,  317,  318,  319,  320,  321,  322,  323,  324,  314,
     7    326,  327,  328,  329,  330,  331,  332,  333,  334,  335,
     8    336,  337,  338,  339,  340,  341,  342,  343,  326,  345,
     9    346,  347,  348,  349,  345,  351,  352,  353,  354,  355/
            data (jb1(i),i= 6701, 6750)/
     +    356,  351,  358,  359,  360,  361,  362,  363,  364,  365,
     1    366,  358,  368,  369,  370,  371,  368,  373,  374,  375,
     2    376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
     3    386,  387,  388,  389,  390,  373,  392,  393,  394,  395,
     4    396,  397,  398,  399,  400,  401,  392,    0,    0,    0/
            data (jb2(i),i=    1,  100)/
     +      2,    3,    4,    5,    6,    7,    8,    9,   11,   12,
     1     13,   14,   15,   16,   17,   18,   19,   20,   20,   21,
     2     22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
     3     32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
     4     42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
     5     52,   53,   54,   55,   56,   57,   58,   59,   60,   61,
     6     62,   63,   64,   65,   66,   67,   68,   69,   70,   71,
     7     72,   73,   74,   75,   76,   77,   78,   79,   80,   81,
     8     82,   83,   84,   85,   86,   87,   88,   89,   90,   91,
     9     92,   93,   94,   95,   96,   98,   99,  100,  101,  102/
            data (jb2(i),i=  101,  200)/
     +    103,  104,  105,  106,  107,  108,  109,  110,  111,  112,
     1    113,  114,  115,  116,  117,  118,  119,  120,  121,  122,
     2    123,  124,  125,  126,  127,  128,  129,  130,  131,  132,
     3    133,  134,  135,  136,  137,  138,  139,  140,  141,  142,
     4    143,  144,  145,  146,  147,  148,  149,  150,  151,  152,
     5    153,  154,  155,  156,  157,  158,  159,  160,  161,  162,
     6    163,  164,  165,  166,  167,  168,  169,  170,  171,  172,
     7    173,  174,  175,  176,  177,  178,  179,  180,  181,  182,
     8    183,  184,  185,  186,  187,  188,  189,  190,  191,  192,
     9    193,  194,  195,  196,  197,  198,  199,  200,  201,  202/
            data (jb2(i),i=  201,  300)/
     +    203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
     1    213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
     2    223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
     3    233,  234,  235,  236,  237,  238,  239,  240,  241,  242,
     4    243,  243,  245,  246,  247,  248,  249,  250,  251,  252,
     5    253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
     6    263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
     7    273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
     8    283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
     9    293,  294,  295,  296,  297,  298,  299,  300,  301,  302/
            data (jb2(i),i=  301,  400)/
     +    303,  304,  305,  306,  307,  308,  309,  310,  311,  312,
     1    313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
     2    323,  324,  325,  326,  327,  328,  329,  330,  331,  331,
     3    333,  334,  335,  336,  337,  338,  339,  340,  342,  343,
     4    344,  344,  346,  347,  348,  349,  350,  351,  352,  353,
     5    354,  355,  356,  357,  358,  359,  360,  361,  362,  363,
     6    364,  365,  366,  367,  368,  369,  370,  371,  372,  373,
     7    374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
     8    384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
     9    394,  395,  396,  397,  398,  399,  400,  401,  402,  403/
            data (jb2(i),i=  401,  500)/
     +    404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
     1    414,  415,  416,  417,  418,  419,  420,  421,  422,  423,
     2    424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
     3    434,  435,  436,  437,  438,  439,  440,  441,  442,  443,
     4    444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
     5    454,  455,  456,  457,  458,  459,  460,  461,  462,  463,
     6    464,  465,  466,  467,  468,  469,  469,  470,  471,  472,
     7    473,  474,  475,  476,  477,  478,  479,  480,  481,  482,
     8    483,  484,  485,  486,  487,  488,  489,  490,  491,  492,
     9    493,  494,  495,  496,  497,  498,  499,  500,  501,  502/
            data (jb2(i),i=  501,  600)/
     +    503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
     1    513,  514,  515,  516,  517,  518,  520,  521,  522,  523,
     2    524,  525,  526,  527,  528,  529,  530,  531,  532,  533,
     3    534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
     4    544,  545,  546,  547,  548,  549,  550,  551,  552,  553,
     5    554,  555,  556,  556,  558,  559,  560,  561,  562,  563,
     6    564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
     7    574,  575,  576,  577,  578,  579,  580,  581,  582,  583,
     8    584,  585,  586,  587,  588,  589,  590,  591,  592,  593,
     9    593,  594,  596,  597,  598,  599,  600,  601,  602,  603/
            data (jb2(i),i=  601,  700)/
     +    604,  605,  606,  607,  608,  609,  610,  611,  612,  613,
     1    614,  615,  616,  617,  618,  619,  620,  621,  622,  623,
     2    624,  625,  626,  627,  628,  629,  630,  631,  632,  633,
     3    634,  635,  636,  637,  638,  639,  640,  641,  642,  643,
     4    644,  645,  646,  647,  648,  649,  650,  651,  652,  653,
     5    654,  655,  656,  657,  658,  659,  660,  661,  662,  663,
     6    664,  665,  666,  667,  668,  669,  670,  671,  672,  673,
     7    674,  675,  676,  677,  678,  679,  680,  681,  682,  683,
     8    684,  685,  686,  687,  688,  689,  690,  691,  692,  693,
     9    694,  695,  696,  697,  698,  699,  700,  702,  703,  704/
            data (jb2(i),i=  701,  800)/
     +    705,  706,  707,  708,  708,  709,  710,  711,  712,  713,
     1    714,  715,  716,  717,  718,  719,  720,  721,  722,  723,
     2    724,  725,  726,  727,  728,  729,  730,  731,  732,  733,
     3    734,  735,  736,  737,  738,  739,  740,  741,  742,  743,
     4    744,  745,  746,  746,  747,  748,  749,  750,  751,  752,
     5    753,  754,  755,  756,  757,  758,  759,  760,  761,  761,
     6    762,  763,  764,  765,  766,  767,  768,  769,  770,  771,
     7    772,  773,  774,  775,  776,  777,  778,  779,  780,  781,
     8    782,  783,  784,  785,  786,  787,  788,  789,  790,  791,
     9    792,  793,  794,  795,  796,  797,  798,  799,  800,  801/
            data (jb2(i),i=  801,  900)/
     +    802,  803,  804,  805,  806,  807,  808,  809,  810,  811,
     1    812,  813,  814,  815,  816,  817,  818,  819,  820,  823,
     2    824,  825,  826,  827,  828,  829,  830,  831,  832,  833,
     3    833,  834,  835,  836,  837,  838,  840,  841,  842,  843,
     4    844,  845,  846,  847,  848,  849,  850,  851,  852,  853,
     5    854,  855,  856,  857,  858,  859,  860,  861,  862,  863,
     6    864,  865,  866,  867,  868,  869,  870,  871,  872,  873,
     7    874,  875,  876,  877,  878,  879,  880,  881,  882,  883,
     8    884,  885,  886,  887,  888,  889,  890,  891,  892,  893,
     9    894,  895,  896,  897,  898,  899,  900,  901,  902,  903/
            data (jb2(i),i=  901, 1000)/
     +    904,  905,  906,  907,  908,  909,  910,  911,  912,  913,
     1    914,  915,  916,  917,  918,  919,  919,  920,  921,  922,
     2    923,  924,  925,  926,  927,  928,  929,  930,  931,  932,
     3    933,  934,  935,  936,  937,  938,  939,  940,  941,  942,
     4    943,  944,  944,  946,  947,  950,  950,  951,  952,  953,
     5    954,  955,  956,  957,  958,  959,  960,  961,  962,  963,
     6    964,  965,  966,  967,  968,  969,  970,  971,  972,  973,
     7    974,  975,  976,  977,  978,  979,  980,  981,  982,  983,
     8    984,  985,  986,  987,  988,  989,  990,  991,  992,  993,
     9    994,  995,  996,  997,  998,  999, 1000, 1001, 1002, 1003/
            data (jb2(i),i= 1001, 1100)/
     +   1004, 1005, 1006, 1007, 1008, 1009, 1010, 1011, 1012, 1013,
     1   1014, 1015, 1016, 1017, 1018, 1019, 1020, 1021, 1022, 1023,
     2   1024, 1025, 1026, 1027, 1028, 1029, 1030, 1031, 1032, 1033,
     3   1034, 1035, 1036, 1037, 1038, 1039, 1040, 1041, 1042, 1043,
     4   1044, 1045, 1046, 1047, 1048, 1049, 1050, 1051, 1052, 1053,
     5   1054, 1055, 1056, 1057, 1058, 1059, 1060, 1060, 1061, 1062,
     6   1063, 1064, 1065, 1065, 1066, 1067, 1068, 1069, 1070, 1071,
     7   1072, 1073, 1074, 1075, 1076, 1077, 1078, 1079, 1080, 1081,
     8   1082, 1083, 1084, 1085, 1086, 1087, 1088, 1089, 1090, 1091,
     9   1092, 1093, 1094, 1095, 1096, 1097, 1098, 1099, 1100, 1101/
            data (jb2(i),i= 1101, 1200)/
     +   1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110, 1111,
     1   1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121,
     2   1122, 1123, 1124, 1125, 1126, 1127, 1128, 1129, 1130, 1131,
     3   1132, 1133, 1134, 1135, 1136, 1137, 1138, 1139, 1140, 1141,
     4   1142, 1143, 1144, 1145, 1146, 1147, 1148, 1149, 1150, 1151,
     5   1152, 1153, 1154, 1155, 1156, 1157, 1158, 1159, 1160, 1161,
     6   1162, 1163, 1164, 1165, 1166, 1167, 1168, 1169, 1170, 1171,
     7   1172, 1173, 1174, 1175, 1176, 1177, 1178, 1179, 1181, 1182,
     8   1183, 1184, 1185, 1186, 1187, 1188, 1189, 1190, 1191, 1192,
     9   1193, 1194, 1195, 1196, 1197, 1198, 1199, 1200, 1201, 1202/
            data (jb2(i),i= 1201, 1300)/
     +   1203, 1204, 1205, 1206, 1207, 1208, 1209, 1210, 1211, 1212,
     1   1213, 1214, 1215, 1216, 1217, 1218, 1219, 1220, 1221, 1222,
     2   1223, 1224, 1225, 1226, 1227, 1228, 1229, 1230, 1231, 1232,
     3   1233, 1234, 1235, 1236, 1237, 1238, 1239, 1240, 1241, 1242,
     4   1243, 1244, 1245, 1246, 1247, 1248, 1249, 1250, 1251, 1252,
     5   1253, 1254, 1255, 1256, 1257, 1258, 1259, 1260, 1261, 1262,
     6   1263, 1264, 1265, 1266, 1267, 1268, 1269, 1270, 1271, 1272,
     7   1273, 1274, 1275, 1276, 1277, 1278, 1279, 1280, 1281, 1282,
     8   1283, 1284, 1285, 1286, 1287, 1288, 1289, 1290, 1291, 1292,
     9   1293, 1294, 1295, 1296, 1297, 1298, 1299, 1300, 1301, 1302/
            data (jb2(i),i= 1301, 1400)/
     +   1303, 1304, 1305, 1306, 1307, 1308, 1309, 1310, 1311, 1312,
     1   1312, 1314, 1315, 1316, 1317, 1318, 1319, 1320, 1321, 1322,
     2   1323, 1324, 1325, 1326, 1327, 1328, 1329, 1330, 1331, 1332,
     3   1333, 1334, 1335, 1336, 1337, 1338, 1339, 1340, 1341, 1342,
     4   1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351, 1352,
     5   1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361, 1362,
     6   1363, 1364, 1365, 1365, 1367, 1368, 1369, 1370, 1371, 1372,
     7   1373, 1374, 1375, 1376, 1376, 1377, 1378, 1379, 1380, 1381,
     8   1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391,
     9   1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400, 1401/
            data (jb2(i),i= 1401, 1500)/
     +   1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409, 1410, 1411,
     1   1412, 1413, 1414, 1415, 1416, 1417, 1418, 1419, 1420, 1421,
     2   1424, 1425, 1426, 1427, 1428, 1429, 1430, 1431, 1432, 1433,
     3   1434, 1435, 1436, 1436, 1437, 1438, 1439, 1440, 1441, 1442,
     4   1443, 1444, 1445, 1446, 1447, 1448, 1449, 1450, 1451, 1453,
     5   1454, 1455, 1456, 1457, 1458, 1459, 1460, 1461, 1462, 1463,
     6   1464, 1465, 1466, 1467, 1468, 1469, 1470, 1471, 1472, 1473,
     7   1474, 1475, 1476, 1477, 1478, 1479, 1480, 1481, 1482, 1483,
     8   1484, 1485, 1486, 1487, 1488, 1489, 1490, 1491, 1492, 1493,
     9   1494, 1495, 1496, 1497, 1498, 1499, 1500, 1501, 1502, 1503/
            data (jb2(i),i= 1501, 1600)/
     +   1504, 1505, 1506, 1507, 1508, 1509, 1510, 1511, 1512, 1513,
     1   1514, 1515, 1516, 1517, 1518, 1519, 1520, 1521, 1522, 1523,
     2   1524, 1525, 1526, 1527, 1528, 1529, 1530, 1531, 1532, 1533,
     3   1534, 1535, 1536, 1537, 1538, 1539, 1540, 1541, 1542, 1543,
     4   1544, 1545, 1546, 1547, 1548, 1549, 1550, 1551, 1552, 1553,
     5   1554, 1555, 1556, 1557, 1558, 1559, 1560, 1561, 1562, 1563,
     6   1564, 1565, 1566, 1567, 1568, 1569, 1570, 1571, 1572, 1573,
     7   1574, 1575, 1576, 1577, 1578, 1579, 1580, 1581, 1582, 1583,
     8   1584, 1585, 1586, 1587, 1588, 1589, 1590, 1591, 1592, 1593,
     9   1594, 1595, 1596, 1597, 1598, 1599, 1600, 1601, 1602, 1603/
            data (jb2(i),i= 1601, 1700)/
     +   1604, 1604, 1605, 1606, 1607, 1608, 1609, 1610, 1611, 1612,
     1   1613, 1614, 1615, 1616, 1617, 1618, 1619, 1620, 1621, 1622,
     2   1623, 1624, 1625, 1626, 1627, 1628, 1629, 1630, 1631, 1632,
     3   1633, 1634, 1635, 1636, 1637, 1638, 1639, 1640, 1641, 1642,
     4   1643, 1644, 1645, 1646, 1647, 1648, 1649, 1650, 1651, 1652,
     5   1653, 1654, 1655, 1656, 1657, 1658, 1659, 1660, 1661, 1662,
     6   1663, 1664, 1665, 1666, 1667, 1668, 1669, 1670, 1671, 1672,
     7   1673, 1674, 1675, 1676, 1677, 1678, 1679, 1680, 1681, 1682,
     8   1683, 1684, 1685, 1686, 1687, 1688, 1689, 1690, 1691, 1693,
     9   1694, 1695, 1696, 1697, 1698, 1699, 1700, 1701, 1702, 1703/
            data (jb2(i),i= 1701, 1800)/
     +   1704, 1705, 1706, 1707, 1707, 1708, 1709, 1710, 1711, 1712,
     1   1713, 1714, 1715, 1716, 1717, 1718, 1719, 1720, 1721, 1722,
     2   1723, 1724, 1725, 1726, 1727, 1728, 1729, 1730, 1731, 1732,
     3   1733, 1734, 1735, 1736, 1737, 1738, 1739, 1740, 1741, 1742,
     4   1743, 1744, 1745, 1746, 1747, 1748, 1749, 1750, 1751, 1752,
     5   1753, 1754, 1755, 1756, 1757, 1758, 1759, 1760, 1761, 1762,
     6   1763, 1764, 1765, 1766, 1767, 1768, 1769, 1770, 1771, 1772,
     7   1773, 1774, 1775, 1776, 1777, 1778, 1779, 1780, 1781, 1782,
     8   1783, 1784, 1785, 1786, 1787, 1788, 1789, 1790, 1791, 1792,
     9   1793, 1794, 1795, 1796, 1797, 1798, 1799, 1800, 1801, 1802/
            data (jb2(i),i= 1801, 1900)/
     +   1803, 1804, 1805, 1806, 1807, 1808, 1809, 1810, 1811, 1812,
     1   1813, 1814, 1815, 1816, 1817, 1818, 1819, 1820, 1821, 1822,
     2   1823, 1824, 1825, 1826, 1827, 1828, 1829, 1830, 1831, 1832,
     3   1833, 1834, 1835, 1836, 1837, 1838, 1839, 1840, 1841, 1842,
     4   1843, 1844, 1845, 1846, 1847, 1848, 1849, 1850, 1851, 1852,
     5   1853, 1854, 1855, 1856, 1857, 1858, 1859, 1860, 1861, 1862,
     6   1863, 1864, 1865, 1866, 1867, 1868, 1869, 1870, 1871, 1872,
     7   1873, 1874, 1875, 1876, 1877, 1878, 1879, 1880, 1881, 1882,
     8   1883, 1884, 1885, 1886, 1887, 1888, 1889, 1890, 1891, 1892,
     9   1893, 1894, 1895, 1896, 1897, 1898, 1898, 1899, 1900, 1901/
            data (jb2(i),i= 1901, 2000)/
     +   1902, 1903, 1904, 1905, 1906, 1907, 1908, 1909, 1910, 1911,
     1   1912, 1913, 1914, 1915, 1916, 1917, 1918, 1919, 1920, 1921,
     2   1922, 1923, 1924, 1925, 1926, 1927, 1928, 1929, 1930, 1931,
     3   1932, 1933, 1934, 1935, 1936, 1937, 1938, 1939, 1940, 1941,
     4   1942, 1943, 1944, 1945, 1946, 1947, 1948, 1949, 1950, 1951,
     5   1952, 1953, 1954, 1955, 1956, 1957, 1958, 1959, 1960, 1961,
     6   1962, 1963, 1964, 1965, 1966, 1967, 1968, 1969, 1970, 1971,
     7   1972, 1973, 1974, 1975, 1976, 1977, 1978, 1979, 1980, 1981,
     8   1982, 1983, 1984, 1985, 1986, 1987, 1988, 1989, 1990, 1991,
     9   1992, 1993, 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001/
            data (jb2(i),i= 2001, 2100)/
     +   2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009, 2010, 2011,
     1   2012, 2013, 2014, 2015, 2016, 2017, 2018, 2019, 2020, 2021,
     2   2022, 2023, 2024, 2025, 2026, 2027, 2028, 2029, 2030, 2031,
     3   2032, 2033, 2034, 2035, 2036, 2037, 2038, 2039, 2040, 2041,
     4   2042, 2043, 2044, 2045, 2046, 2047, 2048, 2049, 2050, 2051,
     5   2052, 2053, 2054, 2055, 2056, 2057, 2058, 2059, 2060, 2061,
     6   2062, 2063, 2064, 2065, 2066, 2067, 2068, 2069, 2070, 2071,
     7   2072, 2073, 2074, 2075, 2076, 2077, 2078, 2079, 2080, 2081,
     8   2082, 2083, 2084, 2085, 2086, 2087, 2088, 2089, 2090, 2091,
     9   2092, 2093, 2094, 2095, 2096, 2097, 2098, 2099, 2100, 2101/
            data (jb2(i),i= 2101, 2200)/
     +   2102, 2103, 2104, 2105, 2106, 2107, 2108, 2109, 2110, 2111,
     1   2112, 2113, 2114, 2115, 2116, 2117, 2118, 2119, 2119, 2120,
     2   2121, 2122, 2123, 2124, 2125, 2126, 2127, 2128, 2129, 2130,
     3   2131, 2132, 2133, 2134, 2135, 2136, 2137, 2138, 2139, 2140,
     4   2141, 2142, 2143, 2144, 2145, 2146, 2147, 2148, 2149, 2150,
     5   2151, 2152, 2153, 2154, 2155, 2156, 2157, 2158, 2159, 2160,
     6   2161, 2162, 2163, 2164, 2165, 2166, 2167, 2168, 2169, 2170,
     7   2171, 2172, 2173, 2174, 2175, 2176, 2177, 2178, 2179, 2180,
     8   2181, 2182, 2183, 2184, 2185, 2186, 2187, 2188, 2189, 2190,
     9   2191, 2192, 2193, 2194, 2195, 2196, 2197, 2198, 2199, 2200/
            data (jb2(i),i= 2201, 2300)/
     +   2201, 2202, 2203, 2204, 2205, 2206, 2207, 2208, 2209, 2210,
     1   2211, 2212, 2213, 2214, 2215, 2216, 2217, 2218, 2219, 2220,
     2   2221, 2222, 2223, 2224, 2225, 2226, 2227, 2228, 2229, 2230,
     3   2231, 2232, 2233, 2234, 2235, 2236, 2237, 2238, 2239, 2240,
     4   2241, 2242, 2243, 2244, 2245, 2246, 2247, 2248, 2249, 2250,
     5   2251, 2252, 2253, 2254, 2255, 2256, 2257, 2258, 2259, 2260,
     6   2261, 2262, 2263, 2264, 2265, 2266, 2267, 2268, 2269, 2270,
     7   2271, 2272, 2273, 2274, 2275, 2275, 2276, 2277, 2278, 2279,
     8   2280, 2281, 2282, 2283, 2284, 2285, 2286, 2287, 2288, 2289,
     9   2290, 2291, 2292, 2293, 2294, 2295, 2296, 2297, 2298, 2299/
            data (jb2(i),i= 2301, 2400)/
     +   2300, 2301, 2302, 2303, 2304, 2305, 2306, 2307, 2308, 2309,
     1   2310, 2311, 2312, 2313, 2314, 2315, 2316, 2317, 2318, 2319,
     2   2320, 2321, 2322, 2323, 2324, 2325, 2326, 2327, 2328, 2329,
     3   2330, 2331, 2332, 2333, 2334, 2335, 2336, 2337, 2338, 2339,
     4   2340, 2341, 2342, 2343, 2344, 2345, 2346, 2347, 2348, 2349,
     5   2350, 2351, 2351, 2352, 2353, 2354, 2355, 2356, 2357, 2358,
     6   2359, 2360, 2361, 2362, 2363, 2364, 2365, 2366, 2367, 2368,
     7   2369, 2370, 2371, 2372, 2373, 2374, 2375, 2376, 2377, 2378,
     8   2379, 2380, 2381, 2382, 2383, 2384, 2385, 2386, 2387, 2388,
     9   2389, 2390, 2391, 2392, 2393, 2394, 2395, 2396, 2397, 2398/
            data (jb2(i),i= 2401, 2500)/
     +   2399, 2400, 2401, 2402, 2403, 2404, 2405, 2406, 2407, 2408,
     1   2409, 2410, 2411, 2412, 2413, 2414, 2415, 2416, 2417, 2418,
     2   2419, 2420, 2421, 2422, 2423, 2424, 2425, 2426, 2427, 2428,
     3    244, 2429, 2430, 2431, 2432, 2433, 2434, 2435, 2436, 2437,
     4   2438, 2439, 2440, 2441, 2442, 2443, 2444, 2445, 2446, 2447,
     5   2448, 2449, 2450, 2451, 2452, 2453, 2454, 2455, 2456, 2457,
     6   2458, 2459, 2460, 2461, 2462, 2463, 2464, 2465, 2466, 2467,
     7   2468, 2469, 2470, 2471, 2472, 2473, 2474, 2475, 2476, 2477,
     8   2478, 2479, 2480, 2481, 2482, 2483, 2484, 2485, 2486, 2487,
     9   2488, 2489, 2490, 2491, 2492, 2493, 2494, 2495, 2496, 2497/
            data (jb2(i),i= 2501, 2600)/
     +   2498, 2499, 2500, 2501, 2502, 2503, 2504, 2505, 2506, 2507,
     1   2508, 2509, 2510, 2511, 2512, 2513, 2514, 2515, 2516, 2517,
     2   2518, 2519, 2520, 2521, 2522, 2523, 2524, 2525, 2526, 2527,
     3   2528, 2529, 2530, 2531, 2532, 2533, 2534, 2535, 2536, 2537,
     4   2538, 2539, 2540, 2541, 2542, 2543, 2544, 2545, 2546, 2547,
     5   2548, 2549, 2550, 2551, 2552, 2553, 2554, 2555, 2556, 2557,
     6   2558, 2559, 2560, 2561, 2562, 2563, 2564, 2565, 2566, 2567,
     7   2568, 2569, 2570, 2571, 2572, 2573, 2574, 2575, 2576, 2577,
     8   2578, 2579, 2580, 2581, 2582, 2583, 2584, 2585, 2586, 2587,
     9   2588, 2589, 2590, 2591, 2592, 2593, 2594, 2595, 2596, 2597/
            data (jb2(i),i= 2601, 2700)/
     +   2598, 2599, 2600, 2601, 2602, 2603, 2604, 2605, 2606, 2607,
     1   2608, 2609, 2610, 2611, 2612, 2613, 2614, 2615, 2616, 2617,
     2   2618, 2619, 2620, 2621, 2622, 2623, 2624, 2625, 2626, 2627,
     3   2628, 2629, 2630, 2631, 2632, 2633, 2634, 2635, 2636, 2637,
     4   2638, 2639, 2640, 2641, 2642, 2643, 2644, 2645, 2646, 2647,
     5   2648, 2649, 2650, 2651, 2652, 2653, 2654, 2655, 2656, 2657,
     6   2658, 2659, 2660, 2661, 2662, 2663, 2664, 2665, 2666, 2667,
     7   2668, 2669, 2670, 2671, 2672, 2673, 2674, 2675, 2676, 2677,
     8   2678, 2679, 2680, 2681, 2682, 2683, 2684, 2685, 2686, 2687,
     9   2688, 2689, 2690, 2691, 2692, 2693, 2694, 2695, 2696, 2697/
            data (jb2(i),i= 2701, 2800)/
     +   2698, 2698, 2700, 2701, 2702, 2703, 2704, 2705, 2706, 2707,
     1   2708, 2709, 2710, 2711, 2712, 2713, 2714, 2715, 2716, 2717,
     2   2718, 2719, 2720, 2721, 2722, 2723, 2724, 2725, 2726, 2727,
     3   2728, 2729, 2730, 2731, 2732, 2733, 2734, 2735, 2736, 2737,
     4   2738, 2739, 2740, 2741, 2742, 2743, 2744, 2745, 2746, 2747,
     5   2748, 2749, 2750, 2751, 2752, 2753, 2754, 2755, 2756, 2757,
     6   2758, 2759, 2760, 2761, 2762, 2763, 2764, 2765, 2766, 2767,
     7   2768, 2769, 2769, 2770, 2771, 2772, 2773, 2774, 2775, 2776,
     8   2777, 2778, 2779, 2780, 2781, 2782, 2783, 2784, 2785, 2786,
     9   2787, 2788, 2789, 2790, 2791, 2792, 2793, 2794, 2795, 2796/
            data (jb2(i),i= 2801, 2900)/
     +   2797, 2798, 2799, 2800, 2801, 2802, 2803, 2804, 2805, 2806,
     1   2807, 2808, 2808, 2809, 2810, 2811, 2812, 2813, 2814, 2815,
     2   2816, 2817, 2818, 2819, 2820, 2821, 2822, 2823, 2824, 2824,
     3   2826, 2827, 2828, 2829, 2830, 2831, 2831, 2833, 2834, 2835,
     4   2836, 2837, 2838, 2839, 2840, 2841, 2842, 2843, 2844, 2845,
     5   2846, 2847, 2848, 2849, 2850, 2851, 2852, 2853, 2854, 2855,
     6   2856, 2857, 2858, 2859, 2860, 2861, 2862, 2863, 2864, 2865,
     7   2866, 2867, 2868, 2869, 2870, 2871, 2872, 2873, 2874, 2875,
     8   2876, 2876, 2877, 2878, 2879, 2880, 2881, 2882, 2883, 2884,
     9   2885, 2886, 2887, 2888, 2889, 2890, 2891, 2892, 2893, 2894/
            data (jb2(i),i= 2901, 3000)/
     +   2895, 2896, 2897, 2898, 2899, 2900, 2901, 2902, 2903, 2904,
     1   2905, 2906, 2907, 2908, 2909, 2910, 2911, 2912, 2913, 2914,
     2   2915, 2916, 2917, 2918, 2919, 2920, 2921, 2922, 2923, 2924,
     3   2925, 2926, 2927, 2928, 2929, 2930, 2931, 2932, 2933, 2934,
     4   2935, 2936, 2937, 2938, 2939, 2940, 2941, 2942, 2943, 2944,
     5   2945, 2946, 2947, 2948, 2949, 2950, 2951, 2952, 2953, 2953,
     6   2954, 2955, 2956, 2957, 2958, 2959, 2960, 2961, 2962, 2963,
     7   2964, 2965, 2966, 2967, 2967, 2969, 2970, 2971, 2972, 2973,
     8   2974, 2975, 2976, 2977, 2978, 2979, 2980, 2981, 2982, 2983,
     9   2984, 2985, 2986, 2987, 2988, 2989, 2990, 2990, 2991, 2992/
            data (jb2(i),i= 3001, 3100)/
     +   2993, 2994, 2995, 2996, 2997, 2998, 2999, 3000, 3001, 3002,
     1   3003, 3004, 3005, 3006, 3007, 3008, 3009, 3010, 3011, 3012,
     2   3013, 3014, 3015, 3016, 3017, 3018, 3019, 3020, 3021, 3022,
     3   3023, 3024, 3025, 3026, 3027, 3028, 3029, 3030, 3031, 3032,
     4   3033, 3034, 3035, 3036, 3037, 3038, 3038, 3039, 3040, 3041,
     5   3042, 3043, 3044, 3045, 3046, 3047, 3048, 3049, 3050, 3051,
     6   3052, 3053, 3054, 3055, 3056, 3057, 3058, 3059, 3060, 3061,
     7   3062, 3063, 3064, 3065, 3066, 3067, 3068, 3069, 3070, 3071,
     8   3072, 3073, 3074, 3075, 3076, 3077, 3078, 3079, 3080, 3081,
     9   3082, 3083, 3084, 3085, 3086, 3087, 3088, 3089, 3090, 3091/
            data (jb2(i),i= 3101, 3200)/
     +   3092, 3093, 3094, 3095, 3096, 3097, 3097, 3099, 3100, 3100,
     1   3102, 3103, 3104, 3105, 3106, 3107, 3108, 3109, 3110, 3111,
     2   3112, 3113, 3114, 3114, 3116, 3117, 3118, 3119, 3120, 3120,
     3   3121, 3122, 3123, 3124, 3125, 3127, 3128, 3129, 3130, 3131,
     4   3132, 3133, 3134, 3135, 3136, 3137, 3138, 3139, 3140, 3141,
     5   3142, 3143, 3144, 3145, 3146, 3147, 3148, 3149, 3150, 3151,
     6   3152, 3153, 3154, 3155, 3156, 3157, 3158, 3159, 3160, 3161,
     7   3162, 3163, 3164, 3165, 3166, 3167, 3168, 3169, 3170, 3171,
     8   3172, 3173, 3174, 3175, 3176, 3177, 3178, 3179, 3180, 3181,
     9   3182, 3183, 3184, 3185, 3186, 3187, 3188, 3189, 3190, 3191/
            data (jb2(i),i= 3201, 3300)/
     +   3192, 3193, 3194, 3195, 3196, 3196, 3197, 3198, 3199, 3200,
     1   3200, 3201, 3202, 3203, 3204, 3205, 3206, 3207, 3208, 3209,
     2   3210, 3210, 3211, 3212, 3213, 3214, 3215, 3216, 3217, 3218,
     3   3219, 3220, 3221, 3221, 3223, 3224, 3225, 3226, 3226, 3227,
     4   3228, 3229, 3230, 3231, 3232, 3233, 3234, 3235, 3235, 3236,
     5   3236, 3238, 3239, 3240, 3241, 3242, 3243, 3244, 3245, 3246,
     6   3247, 3248, 3249, 3250, 3251, 3252, 3253, 3254, 3255, 3256,
     7   3257, 3258, 3259, 3260, 3261, 3262, 3263, 3264, 3265, 3266,
     8   3267, 3268, 3269, 3270, 3271, 3272, 3273, 3274, 3275, 3276,
     9   3277, 3278, 3279, 3280, 3281, 3281, 3282, 3283, 3284, 3285/
            data (jb2(i),i= 3301, 3400)/
     +   3286, 3287, 3287, 3288, 3289, 3290, 3291, 3292, 3293, 3294,
     1   3295, 3296, 3297, 3298, 3299, 3300, 3300, 3302, 3303, 3304,
     2   3305, 3306, 3306, 3307, 3308, 3309, 3310, 3311, 3312, 3313,
     3   3313, 3314, 3315, 3316, 3317, 3318, 3319, 3320, 3321, 3322,
     4   3322, 3324, 3325, 3326, 3327, 3328, 3329, 3329, 3331, 3332,
     5   3333, 3334, 3335, 3336, 3337, 3338, 3339, 3340, 3341, 3342,
     6   3343, 3344, 3345, 3346, 3347, 3348, 3349, 3350, 3351, 3352,
     7   3353, 3354, 3355, 3356, 3357, 3358, 3359, 3360, 3361, 3362,
     8   3363, 3364, 3365, 3366, 3367, 3368, 3369, 3370, 3371, 3372,
     9   3373, 3374, 3375, 3376, 3377, 3378, 3379, 3380, 3381, 3382/
            data (jb2(i),i= 3401, 3500)/
     +   3383, 3384, 3385, 3386, 3387, 3388, 3389, 3390, 3391, 3392,
     1   3393, 3393, 3394, 3395, 3396, 3397, 3398, 3399, 3400, 3401,
     2   3402, 3403, 3404, 3405, 3406, 3407, 3408, 3409, 3410, 3411,
     3   3412, 3413, 3414, 3415, 3416, 3417, 3418, 3419, 3420, 3421,
     4   3422, 3423, 3424, 3425, 3426, 3427, 3428, 3429, 3430, 3431,
     5   3432, 3433, 3434, 3435, 3436, 3437, 3438, 3439, 3440, 3441,
     6   3442, 3443, 3444, 3445, 3446, 3447, 3448, 3449, 3450, 3451,
     7   3452, 3453, 3454, 3455, 3456, 3457, 3458, 3459, 3460, 3461,
     8   3462, 3463, 3464, 3465, 3466, 3467, 3468, 3469, 3470, 3471,
     9   3472, 3473, 3474, 3475, 3476, 3477, 3478, 3479, 3480, 3481/
            data (jb2(i),i= 3501, 3600)/
     +   3482, 3483, 3484, 3485, 3486, 3487, 3488, 3489, 3489, 3490,
     1   3491, 3492, 3493, 3494, 3495, 3496, 3497, 3498, 3499, 3500,
     2   3501, 3502, 3503, 3504, 3505, 3506, 3507, 3508, 3509, 3510,
     3   3511, 3512, 3513, 3514, 3515, 3516, 3517, 3519, 3520, 3521,
     4   3522, 3523, 3524, 3525, 3526, 3527, 3527, 3528, 3529, 3530,
     5   3531, 3532, 3533, 3534, 3535, 3536, 3537, 3538, 3539, 3540,
     6   3541, 3542, 3543, 3544, 3545, 3546, 3547, 3548, 3548, 3549,
     7   3550, 3551, 3552, 3553, 3554, 3555, 3556, 3557, 3558, 3559,
     8   3560, 3561, 3562, 3563, 3564, 3565, 3566, 3567, 3568, 3569,
     9   3570, 3571, 3572, 3573, 3574, 3575, 3576, 3577, 3578, 3579/
            data (jb2(i),i= 3601, 3700)/
     +   3580, 3581, 3582, 3583, 3584, 3585, 3586, 3587, 3588, 3589,
     1   3590, 3591, 3592, 3593, 3594, 3595, 3596, 3597, 3598, 3599,
     2   3600, 3601, 3602, 3603, 3604, 3605, 3606, 3607, 3608, 3609,
     3   3610, 3611, 3612, 3613, 3614, 3615, 3616, 3617, 3618, 3619,
     4   3620, 3621, 3623, 3624, 3625, 3626, 3627, 3628, 3629, 3630,
     5   3631, 3631, 3632, 3633, 3634, 3635, 3636, 3637, 3638, 3639,
     6   3640, 3641, 3642, 3643, 3644, 3645, 3645, 3647, 3648, 3649,
     7   3650, 3651, 3651, 3652, 3653, 3654, 3655, 3656, 3657, 3658,
     8   3659, 3660, 3661, 3662, 3663, 3664, 3665, 3666, 3667, 3668,
     9   3669, 3670, 3671, 3672, 3673, 3674, 3675, 3676, 3677, 3678/
            data (jb2(i),i= 3701, 3800)/
     +   3679, 3680, 3681, 3682, 3683, 3684, 3685, 3686, 3687, 3688,
     1   3689, 3690, 3691, 3692, 3693, 3694, 3695, 3696, 3697, 3698,
     2   3699, 3700, 3701, 3702, 3703, 3704, 3705, 3706, 3707, 3708,
     3   3709, 3710, 3711, 3712, 3713, 3714, 3715, 3716, 3717, 3718,
     4   3719, 3720, 3721, 3722, 3723, 3724, 3725, 3726, 3727, 3728,
     5   3729, 3730, 3731, 3732, 3733, 3734, 3735, 3736, 3737, 3738,
     6   3739, 3740, 3741, 3742, 3743, 3744, 3745, 3746, 3747, 3748,
     7   3749, 3750, 3751, 3752, 3753, 3754, 3755, 3756, 3757, 3758,
     8   3759, 3760, 3761, 3763, 3764, 3765, 3766, 3767, 3768, 3769,
     9   3770, 3771, 3772, 3773, 3774, 3775, 3776, 3777, 3778, 3779/
            data (jb2(i),i= 3801, 3900)/
     +   3780, 3780, 3781, 3782, 3783, 3784, 3785, 3786, 3787, 3788,
     1   3789, 3789, 3790, 3791, 3792, 3793, 3793, 3794, 3795, 3796,
     2   3797, 3798, 3799, 3800, 3801, 3802, 3802, 3803, 3803,  832,
     3   3805, 3806, 3807, 3808, 3809, 3810, 3811, 3812, 3813, 3814,
     4   3815, 3816, 3817, 3818, 3819, 3820, 3821, 3822, 3823, 3824,
     5   3825, 3826, 3827, 3828, 3829, 3830, 3831, 3832, 3833, 3834,
     6   3835, 3836, 3837, 3838, 3839, 3840, 3841, 3842, 3843, 3844,
     7   3845, 3846, 3847, 3848, 3849, 3850, 3851, 3852, 3853, 3854,
     8   3855, 3856, 3857, 3858, 3859, 3860, 3861, 3862, 3863, 3864,
     9   3864, 3865, 3866, 3867, 3868, 3869, 3870, 3871, 3872, 3873/
            data (jb2(i),i= 3901, 4000)/
     +   3874, 3875, 3876, 3877, 3878, 3879, 3880, 3881, 3882, 3883,
     1   3884, 3885, 3886, 3887, 3888, 3889, 3890, 3891, 3892, 3893,
     2   3894, 3895, 3896, 3897, 3898, 3899, 3900, 3901, 3902, 3903,
     3   3904, 3905, 3906, 3907, 3908, 3909, 3910, 3911, 3912, 3913,
     4   3914, 3915, 3916, 3917, 3918, 3919, 3920, 3921, 3922, 3923,
     5   3924, 3925, 3926, 3927, 3928, 3929, 3930, 3931, 3932, 3933,
     6   3934, 3935, 3936, 3937, 3938, 3939, 3940, 3941, 3942, 3943,
     7   3944, 3945, 3946, 3947, 3948, 3949, 3950, 3951, 3952, 3953,
     8   3954, 3955, 3956, 3957, 3958, 3959, 3960, 3961, 3962, 3963,
     9   3964, 3965, 3966, 3966, 3967,  839, 3969, 3970, 3971, 3972/
            data (jb2(i),i= 4001, 4100)/
     +   3973, 3974, 3975, 3976, 3977, 3978, 3979, 3980, 3981, 3982,
     1   3983, 3984, 3985, 3986, 3987, 3988, 3989, 3990, 3991, 3992,
     2   3993, 3994, 3995, 3996, 3997, 3998, 3999, 4000, 4001, 4002,
     3   4003, 4004, 4005, 4006, 4007, 4008, 4009, 4010, 4011, 4012,
     4   4013, 4014, 4015, 4016, 4017, 4018, 4019, 4020, 4021, 4022,
     5   4023, 4024, 4025, 4026, 4027, 4028, 4029, 4030, 4031, 4032,
     6   4033, 4034, 4035, 4036, 4037, 4038, 4039, 4040, 4041, 4042,
     7   4043, 4044, 4045, 4046, 4047, 4048, 4049, 4050, 4051, 4052,
     8   4053, 4054, 4055, 4056, 4056, 4057, 4058, 4059, 4060, 4061,
     9   4062, 4063, 4064, 4065, 4066, 4067, 4068, 4069, 4070, 4071/
            data (jb2(i),i= 4101, 4200)/
     +   4072, 4073, 4074, 4075, 4076, 4077, 4078, 4079, 4080, 4081,
     1   4082, 4083, 4084, 4085, 4086, 4087, 4088, 4089, 4090, 4091,
     2   4092, 4093, 4094, 4095, 4096, 4097, 4098, 4099, 4100, 4101,
     3   4102, 4103, 4104, 4105, 4106, 4107, 4108, 4109, 4110, 4111,
     4   4112, 4113, 4114, 4115, 4116, 4117, 4118, 4119, 4120, 4121,
     5   4122, 4123, 4124, 4125, 4126, 4127, 4128, 4129, 4130, 4131,
     6   4132, 4133, 4134, 4135, 4136, 4137, 4138, 4139, 4140, 4141,
     7   4142, 4143, 4144, 4145, 4146, 4147, 4148, 4149, 4150, 4151,
     8   4152, 4153, 4154, 4155, 4156, 4157, 4158, 4159, 4160, 4161,
     9   4162, 4163, 4164, 4165, 4166, 4167, 4168, 4169, 4170, 4171/
            data (jb2(i),i= 4201, 4300)/
     +   4172, 4173, 4174, 4175, 4176, 4177, 4178, 4179, 4180, 4181,
     1   4182, 4182, 4184, 4185, 4186, 4187, 4188, 4189, 4190, 4191,
     2   4192, 4193, 4194, 4195, 4196, 4197, 4198, 4199, 4200, 4201,
     3   4202, 4203, 4204, 4205, 4206, 4207, 4208, 4209, 4210, 4211,
     4   4212, 4213, 4214, 4215, 4216, 4217, 4217, 4218, 4219, 4220,
     5   4221, 4222, 4223, 4224, 4225, 4226, 4227, 4228, 4229, 4230,
     6   4231, 4232, 4233, 4234, 4235, 4236, 4237, 4238, 4239, 4240,
     7   4241, 4242, 4243, 4244, 4245, 4246, 4247, 4248, 4249, 4250,
     8   4251, 4252, 4253, 4254, 4255, 4256, 4257, 4258, 4259, 4260,
     9   4261, 4262, 4263, 4264, 4265, 4266, 4267, 4268, 4269, 4270/
            data (jb2(i),i= 4301, 4400)/
     +   4271, 4272, 4273, 4274, 4275, 4276, 4277, 4278, 4279, 4280,
     1   4281, 4282, 4283, 4284, 4285, 4286, 4287, 4288, 4289, 4290,
     2   4291, 4292, 4293, 4294, 4295, 4296, 4297, 4298, 4299, 4300,
     3   4301, 4302, 4303, 4304, 4305, 4306, 4307, 4308, 4309, 4310,
     4   4311, 4312, 4313, 4314, 4315, 4316, 4317, 4318, 4319, 4320,
     5   4321, 4322, 4323, 4324, 4325, 4326, 4327, 4328, 4329, 4330,
     6   4331, 4332, 4333, 4334, 4335, 4336, 4337, 4338, 4339, 4340,
     7   4341, 4342, 4343, 4344, 4345, 4346, 4347, 4348, 4349, 4350,
     8   4351, 4352, 4353, 4354, 4355, 4356, 4357, 4358, 4359, 4359,
     9   4360, 4361, 4362, 4363, 4364, 4365, 4366, 4367, 4368, 4369/
            data (jb2(i),i= 4401, 4500)/
     +   4370, 4371, 4372, 4373, 4374, 4375, 4376, 4377, 4378, 4379,
     1   4380, 4381, 4382, 4383, 4384, 4385, 4386, 4387, 4388, 4389,
     2   4390, 4391, 4392, 4393, 4394, 4395, 4396, 4397, 4398, 4399,
     3   4400, 4401, 4402, 4403, 4404, 4405, 4406, 4407, 4408, 4409,
     4   4410, 4411, 4412, 4413, 4414, 4415, 4416, 4417, 4418, 4419,
     5   4420, 4421, 4422, 4423, 4424, 4425, 4426, 4427, 4428, 4429,
     6   4430, 4431, 4432, 4433, 4434, 4435, 4436, 4437, 4438, 4439,
     7   4440, 4441, 4442, 4443, 4444, 4445, 4446, 4447, 4447, 4449,
     8   4450, 4451, 4452, 4453, 4454, 4455, 4456, 4457, 4458, 4459,
     9   4460, 4460, 4461, 4462, 4463, 4464, 4465, 4466, 4467, 4468/
            data (jb2(i),i= 4501, 4600)/
     +   4469, 4470, 4471, 4471, 4472, 4473, 4474, 4475, 4476, 4477,
     1   4478, 4479, 4480, 4481, 4482, 4483, 4484, 4485, 4486, 4487,
     2   4488, 4489, 4490, 4491, 4492, 4493, 4494, 4495, 4496, 4496,
     3   4497, 4498, 4499, 4500, 4501, 4502, 4503, 4504, 4505, 4506,
     4   4507, 4508, 4509, 4510, 4511, 4512, 4513, 4514, 4515, 4516,
     5   4517, 4518, 4519, 4520, 4521, 4522, 4523, 4524, 4525, 4526,
     6   4527, 4528, 4529, 4530, 4531, 4532, 4533, 4534, 4535, 4536,
     7   4537, 4538, 4539, 4540, 4541, 4542, 4543, 4544, 4545, 4546,
     8   4547, 4548, 4549, 4550, 4551, 4552, 4553, 4554, 4555, 4556,
     9   4557, 4558, 4559, 4560, 4561, 4562, 4563, 4564, 4565, 4566/
            data (jb2(i),i= 4601, 4700)/
     +   4567, 4568, 4569, 4570, 4571, 4572, 4573, 4574, 4575, 4576,
     1   4577, 4578, 4579, 4580, 4581, 4582, 4583, 4584, 4585, 4586,
     2   4587, 4588, 4589, 4590, 4591, 4592, 4593, 4594, 4595, 4596,
     3   4597, 4598, 4599, 4600, 4601, 4602, 4603, 4604, 4605, 4606,
     4   4607, 4608, 4609, 4610, 4611, 4612, 4613, 4614, 4615, 4616,
     5   4617, 4618, 4619, 4620, 4621, 4622, 4623, 4624, 4625, 4626,
     6   4627, 4628, 4629, 4630, 4631, 4632, 4633, 4634, 4634, 4635,
     7   4636, 4637, 4638, 4639, 4640, 4641, 4642, 4643, 4644, 4645,
     8   4646, 4647, 4648, 4649, 4650, 4651, 4652, 4653, 4654, 4655,
     9   4656, 4657, 4658, 4659, 4660, 4661, 4662, 4664, 4665, 4666/
            data (jb2(i),i= 4701, 4800)/
     +   4667, 4668, 4669, 4670, 4671, 4672, 4673, 4674, 4675, 4676,
     1   4677, 4677,  948, 1056, 4678, 4679, 4680, 4681, 4682, 4683,
     2   4684, 4685, 4686, 4687, 4688, 4689, 4690, 4691, 4692, 4693,
     3   4694, 4695, 4696, 4697, 4698, 4699, 4700, 4701, 4702, 4702,
     4   4704, 4705, 4706, 4707, 4708, 4709, 4710, 4711, 4712, 4713,
     5   4714, 4715, 4716, 4717, 4718, 4719, 4720, 4721, 4722, 4723,
     6   4724, 4724, 4726, 4727, 4728, 4729, 4730, 4731, 4732, 4733,
     7   4734, 4734, 4735, 4736, 4737, 4738, 4739, 4740, 4741, 4742,
     8   4743, 4744, 4745, 4746, 4747, 4748, 4749, 4750, 4751, 4752,
     9   4753, 4754, 4755, 4756, 4757, 4758, 4759, 4760, 4761, 4762/
            data (jb2(i),i= 4801, 4900)/
     +   4763, 4764, 4765, 4766, 4767, 4767, 4768, 4770, 4771, 4771,
     1   4772, 4773, 4774, 4774, 4775, 4776, 4777, 4778, 4779, 4780,
     2   4781, 4782, 4783, 4784, 4785, 4786, 4787, 4788, 4789, 4790,
     3   4791, 4792, 4793, 4794, 4795, 4796, 4797, 4798, 4799, 4800,
     4   4801, 4802, 4803, 4804, 4805, 4806, 4807, 4808, 4809, 4810,
     5   4811, 4812, 4813, 4814, 4815, 4816, 4817, 4818, 4819, 4820,
     6   4821, 4822, 4823, 4824, 4825, 4826, 4827, 4828, 4829, 4830,
     7   4831, 4832, 4833, 4834, 4835, 4836, 4836, 4838, 4839, 4840,
     8   4841, 4842, 4843, 4844, 4845, 4846, 4847, 4848, 4849, 4850,
     9   4851, 4852, 4853, 4854, 4855, 4856, 4857, 4858, 4859, 4860/
            data (jb2(i),i= 4901, 5000)/
     +   4861, 4862, 4863, 4864, 4865, 4866, 4867, 4868, 4869, 4870,
     1   4871, 4872, 4873, 4874, 4875, 4876, 4877, 4878, 4879, 4880,
     2   4881, 4882, 4883, 4884, 4885, 4886, 4887, 4888, 4889, 4890,
     3   4891, 4892, 4893, 4894, 4895, 4896, 4897, 4898, 4899, 4900,
     4   4901, 4902, 4903, 4904, 4904, 4906, 4907, 4908, 4909, 4910,
     5   4911, 4912, 4913, 4914, 4914, 4915, 4916, 4917, 4918, 4919,
     6   4920, 4921, 4922, 4923, 4924, 4925, 4926, 4927, 4928, 4929,
     7   4930, 4931, 4932, 4933, 4934, 4935, 4936, 4937, 4938, 4939,
     8   4940, 4941, 4942, 4943, 4944, 4945, 4946, 4947, 4948, 4949,
     9   4950, 4951, 4952, 4953, 4954, 4955, 4956, 4957, 4958, 4959/
            data (jb2(i),i= 5001, 5100)/
     +   4960, 4961, 4962, 4963, 4964, 4965, 4966, 4967, 4968, 4969,
     1   4970, 4971, 4972, 4973, 4974, 4975, 4976, 4977, 4977, 4979,
     2   4980, 4981, 4982, 4983, 4984, 4985, 4986, 4987, 4988, 4988,
     3   4990, 4991, 4992, 4993, 4994, 4995, 4996, 4997, 4998, 4999,
     4   5000, 5001, 5002, 5003, 5004, 5005, 5006, 5007, 5008, 5009,
     5   5010, 5011, 5012, 5013, 5014, 5015, 5016, 5017, 5018, 5019,
     6   5020, 5021, 5022, 5023, 5024, 5025, 5026, 5027, 5028, 5029,
     7   5030, 5031, 5032, 5033, 5034, 5035, 5036, 5037, 5038, 5039,
     8   5040, 5041, 5042, 5043, 5044, 5045, 5046, 5047, 5048, 5049,
     9   5050, 5051, 5052, 5053, 5054, 5054, 5055, 5056, 5057, 5058/
            data (jb2(i),i= 5101, 5200)/
     +   5059, 5060, 5061, 5061, 5063, 5064, 5065, 5066, 5067, 5067,
     1   5068, 5069, 5070, 5071, 5072, 5073, 5074, 5075, 5076, 5077,
     2   5078, 5079, 5080, 5081, 5082, 5083, 5084, 5085, 5086, 5087,
     3   5088, 5089, 5090, 5091, 5092, 5093, 5094, 5095, 5096, 5097,
     4   5098, 5099, 5100, 5101, 5102, 5103, 5104, 5105, 5106, 5107,
     5   5107, 5108, 5109, 5110, 5111, 5112, 5113, 5114, 5115, 5116,
     6   5117, 5118, 5119, 5120, 5121, 5122, 5123, 5124, 5125, 5126,
     7   5127, 5128, 5129, 5130, 5131, 5132, 5133, 5134, 5135, 5136,
     8   5137, 5138, 5139, 5140, 5141, 5142, 5143, 5144, 5145, 5146,
     9   5147, 5148, 5149, 5150, 5151, 5152, 5153, 5154, 5155, 5156/
            data (jb2(i),i= 5201, 5300)/
     +   5157, 5158, 5159, 5160, 5161, 5162, 5163, 5164, 5165, 5166,
     1   5167, 5168, 5169, 5170, 5171, 5172, 5173, 5174, 5175, 5176,
     2   5177, 5178, 5179, 5180, 5181, 5182, 5183, 5184, 5185, 5186,
     3   5187, 5188, 5189, 5190, 5191, 5192, 5193, 5194, 5195, 5196,
     4   5197, 5198, 5199, 5200, 5201, 5202, 5203, 5204, 5205, 5206,
     5   5207, 5208, 5209, 5210, 5211, 5212, 5213, 5214, 5215, 5216,
     6   5217, 5218, 5219, 5220, 5221, 5222, 5223, 5224, 5225, 5226,
     7   5227, 5228, 5229, 5230, 5231, 5232, 5233, 5234, 5235, 5236,
     8   5237, 5238, 5239, 5240, 5241, 5242, 5243, 5244, 5245, 5246,
     9   5247, 5248, 5249, 5250, 5251, 5252, 5253, 5254, 5255, 5256/
            data (jb2(i),i= 5301, 5400)/
     +   5257, 5258, 5259, 5260, 5261, 5262, 5263, 5264, 5265, 5266,
     1   5267, 5268, 5269, 5270, 5271, 5272, 5273, 5274, 5275, 5276,
     2   5277, 5278, 5279, 5280, 5281, 5282, 5283, 5284, 5285, 5286,
     3   5287, 5288, 5289, 5290, 5291, 5292, 5293, 5294, 5295, 5296,
     4   5297, 5298, 5299, 5300, 5301, 5302, 5303, 5304, 5305, 5306,
     5   5307, 5308, 5309, 5310, 5311, 5312, 5313, 5314, 5315, 5316,
     6   5317, 5318, 5319, 5320, 5321, 5322, 5323, 5324, 5325, 5326,
     7   5327, 5328, 5329, 5330, 5331, 5332, 5333, 5334, 5335, 5336,
     8   5337, 5338, 5339, 5340, 5341, 5342, 5343, 5344, 5345, 5346,
     9   5347, 5348, 5349, 5350, 5351, 5352, 5353, 5354, 5355, 5356/
            data (jb2(i),i= 5401, 5500)/
     +   5357, 5358, 5359, 5360, 5361, 5362, 5363, 5364, 5365, 5366,
     1   5366, 5367, 5368, 5369, 5370, 5371, 5372, 5373, 5374, 5375,
     2   5376, 5377, 5378, 5379, 5380, 5381, 5382, 5383, 5384, 5385,
     3   5386, 5387, 5388, 5389, 5390, 5391, 5392, 5393, 5395, 5396,
     4   5397, 5398, 5399, 5400, 5401, 5402, 5403, 5404, 5405, 5406,
     5   5407, 5408, 5409, 5410, 5411, 5412, 5413, 5414, 5415, 5416,
     6   5417, 5418, 5419, 5420, 5421, 5422, 5423, 5424, 5425, 5426,
     7   5427, 5428, 5429, 5430, 5431, 5432, 5433, 5434, 5435, 5436,
     8   5437, 5438, 5439, 5440, 5441, 5442, 5443, 5444, 5445, 5446,
     9   5447, 5448, 5449, 5450, 5451, 5452, 5453, 5454, 5455, 5456/
            data (jb2(i),i= 5501, 5600)/
     +   5457, 5458, 5459, 5460, 5461, 5462, 5463, 5464, 5465, 5466,
     1   5467, 5468, 5469, 5470, 5471, 5472, 5473, 5474, 5475, 5476,
     2   5477, 5478, 5479, 5480, 5481, 5482, 5483, 5484, 5485, 5486,
     3   5487, 5488, 5489, 5490, 5491, 5492, 5493, 5494, 5495, 5496,
     4   5497, 5498, 5499, 5500, 5501, 5502, 5503, 5504, 5505, 5506,
     5   5507, 5508, 5509, 5510, 5511, 5512, 5513, 5514, 5515, 5516,
     6   5517, 5518, 5519, 5520, 5521, 5522, 5523, 5524, 5525, 5526,
     7   5527, 5528, 5529, 5530, 5531, 5532, 5533, 5534, 5535, 5536,
     8   5537, 5538, 5539, 5540, 5541, 5542, 5543, 5544, 5545, 5546,
     9   5547, 5548, 5549, 5550, 5551, 5552, 5553, 5554, 5554, 5555/
            data (jb2(i),i= 5601, 5700)/
     +   5556, 5557, 5558, 5559, 5560, 5561, 5562, 5563, 5564, 5564,
     1   5565, 5566, 5567, 5568, 5569, 5570, 5571, 5572, 5573, 5574,
     2   5575, 5576, 5577, 5578, 5579, 5580, 5581, 5582, 5583, 5584,
     3   5585, 5586, 5587, 5588, 5589, 5590, 5591, 5592, 5593, 5594,
     4   5595, 5596, 5597, 5598, 5599, 5600, 5601, 5602, 5603, 5604,
     5   5605, 5606, 5607, 5608, 5609, 5610, 5611, 5612, 5613, 5614,
     6   5615, 5616, 5617, 5618, 5619, 5620, 5621, 5622, 5623, 5624,
     7   5625, 5626, 5627, 5628, 5629, 5630, 5631, 5632, 5633, 5634,
     8   5635, 5636, 5637, 5638, 5639, 5640, 5641, 5642, 1180, 5643,
     9   5644, 5645, 5646, 5647, 5648, 5649, 5650, 5651, 5652, 5653/
            data (jb2(i),i= 5701, 5800)/
     +   5654, 5655, 5656, 5657, 5658, 5659, 5660, 5661, 5662, 5663,
     1   5664, 5665, 5666, 5667, 5668, 5669, 5670, 5671, 5672, 5673,
     2   5674, 5675, 5676, 5677, 5678, 5679, 5680, 5681, 5682, 5683,
     3   5684, 5685, 5686, 5687, 5688, 5689, 5690, 5691, 5692, 5693,
     4   5694, 5695, 5696, 5697, 5698, 5699, 5700, 5701, 5702, 5703,
     5   5704, 5705, 5706, 5707, 5708, 5709, 5710, 5711, 5712, 5713,
     6   5714, 5715, 5716, 5717, 5718, 5719, 5720, 5721, 5722, 5723,
     7   5724, 5725, 5726, 5727, 5728, 5729, 5730, 5731, 5732, 5733,
     8   5734, 5735, 5736, 5737, 5738, 5739, 5740, 5741, 5742, 5743,
     9   5744, 5745, 5746, 5747, 5748, 5749, 5750, 5751, 5752, 5753/
            data (jb2(i),i= 5801, 5900)/
     +   5754, 5755, 5756, 5757, 5758, 5759, 5760, 5761, 5762, 5763,
     1   5764, 5765, 5766, 5767, 5768, 5769, 5770, 5771, 5772, 5773,
     2   5774, 5775, 5776, 1313, 5777, 5778, 5779, 5780, 5781, 5782,
     3   5783, 5784, 5785, 5786, 5787, 5788, 5789, 5790, 5791, 5792,
     4   5793, 5794, 5795, 5796, 5797, 5798, 5799, 5800, 5801, 5802,
     5   5803, 5804, 5805, 5806, 5806, 5807, 5808, 5809, 5810, 5811,
     6   5812, 5813, 5813, 5814, 5815, 5816, 5817, 5818, 5819, 5820,
     7   5821, 5822, 5823, 5824, 5825, 5826, 5827, 5828, 5829, 5830,
     8   5831, 5832, 5833, 5834, 5835, 5836, 5837, 5838, 5839, 5840,
     9   5841, 5842, 5843, 5844, 5845, 5846, 5847, 5848, 5849, 5850/
            data (jb2(i),i= 5901, 6000)/
     +   5851, 5852, 5853, 5854, 5855, 5856, 5857, 5858, 5859, 5860,
     1   5861, 5862, 5863, 5864, 5865, 5866, 5867, 5868, 5869, 5870,
     2   5871, 5872, 5873, 5874, 5875, 5876, 5877, 5878, 5879, 5880,
     3   5881, 5882, 5883, 5884, 5885, 5886, 5887, 5888, 5889, 5890,
     4   5891, 5892, 5893, 5894, 5895, 5896, 5897, 5898, 5899, 5900,
     5   5901, 5902, 5903, 1422, 5904, 5905, 5906, 5907, 5908, 5909,
     6   5910, 5911, 5912, 5913, 5914, 5915, 5916, 5917, 5918, 5919,
     7   5920, 5921, 5922, 5923, 5924, 5925, 5925, 5926, 5927, 5928,
     8   5929, 5930, 5931, 5932, 5933, 5934, 5935, 5936, 5937, 5938,
     9   5939, 5940, 5941, 5942, 5943, 5944, 5945, 5946, 5947, 5948/
            data (jb2(i),i= 6001, 6100)/
     +   5949, 5950, 5951, 5952, 5953, 5954, 5955, 5956, 5957, 5958,
     1   5959, 5960, 5961, 5962, 5963, 5964, 5965, 5966, 5967, 5968,
     2   5969, 5970, 5971, 5972, 5973, 5974, 5975, 5976, 5977, 5978,
     3   5979, 5980, 5981, 5981, 5982, 5983, 5984, 5985, 5986, 5987,
     4   5988, 5989, 5990, 5991, 5992, 5993, 5994, 5995, 5996, 5997,
     5   5998, 5999, 6000, 6001, 6002, 6003, 6004, 6005, 6006, 6007,
     6   6008, 6009, 6010, 6011, 6012, 6013, 6014, 6015, 6016, 6017,
     7   6018, 6019, 6020, 6021, 6022, 6023, 6024, 6025, 6026, 6027,
     8   6028, 6029, 6030, 6031, 6032, 6033, 6034, 6035, 6036, 6037,
     9   6038, 6039, 6040, 6041, 6042, 6043, 6044, 6045, 6046, 6047/
            data (jb2(i),i= 6101, 6200)/
     +   6048, 6049, 6050, 6051, 6052, 6053, 6054, 6055, 6056, 6057,
     1   6058, 6059, 6060, 6061, 6062, 6063, 6064, 6065, 6066, 6067,
     2   6068, 6069, 6070, 6071, 6072, 6073, 6074, 6075, 6076, 6077,
     3   6078, 6079, 6080, 6081, 6082, 6083, 6084, 6085, 6086, 6087,
     4   6088, 6089, 6090, 6091, 6092, 6093, 6094, 6095, 6096, 6097,
     5   6098, 6099, 6100, 6101, 6102, 6103, 6104, 6105, 6106, 6107,
     6   6108, 6109, 6110, 6111, 6112, 6113, 6114, 6115, 6116, 6117,
     7   6118, 6119, 6120, 6121, 6122, 6123, 6124, 6125, 6126, 6127,
     8   6128, 6129, 6130, 6131, 6132, 6133, 6134, 6135, 6136, 6137,
     9   6138, 6139, 6140, 6141, 6142, 6143, 6144, 6145, 6146, 6147/
            data (jb2(i),i= 6201, 6300)/
     +   6148, 6149, 6150, 6151, 6152, 6153, 6154, 6155, 6156, 6157,
     1   6158, 6159, 6160, 6161, 6162, 6163, 6164, 6164, 6165, 6166,
     2   6167, 6168, 6169, 6170, 6171, 6172, 6173, 6174, 6175, 6176,
     3   6177, 6178, 6179, 6180, 6181, 6182, 6183, 6184, 6185, 6186,
     4   6187, 6188, 6189, 6190, 6191, 6192, 6193, 6194, 6195, 6196,
     5   6197, 6198, 6199, 6200, 6201, 6202, 6203, 6204, 6205, 6206,
     6   6207, 6208, 6209, 6210, 6211, 6212, 6213, 6214, 6215, 6216,
     7   6217, 6218, 6219, 6220, 6221, 6222, 6223, 6224, 6225, 6226,
     8   6227, 6228, 6229, 6230, 6231, 6232, 6233, 6234, 6235, 6236,
     9   6237, 6238, 6239, 6240, 6241, 6242, 6243, 6244, 6245, 6246/
            data (jb2(i),i= 6301, 6400)/
     +   6247, 6248, 6249, 6250, 6251, 6252, 6253, 6254, 6255, 6256,
     1   6257, 6258, 6259, 6260, 6261, 6262, 6263, 6264, 6265, 6266,
     2   6267, 6268, 6269, 6270, 6271, 6272, 6273, 6274, 6275, 6276,
     3   6277, 6278, 6279, 6280, 6281, 6282, 6283, 6284, 6285, 6286,
     4   6287, 6288, 6289, 6290, 1452,    2,    3,    4,    5,    6,
     5      7,    8,    8,   10,   11,   12,   13,   14,   15,   16,
     6     17,   18,   19,   20,   20,   22,   23,   24,   25,   26,
     7     27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
     8     37,   38,   39,   40,   41,   42,   42,   44,   45,   46,
     9     47,   48,   49,   50,   51,   52,   53,   54,   55,   56/
            data (jb2(i),i= 6401, 6500)/
     +     57,   58,   58,   60,   61,   62,   63,   64,   65,   66,
     1     66,   68,   69,   70,   71,   72,   73,   74,   75,   76,
     2     77,   78,   78,   80,   81,   82,   83,   84,   85,   86,
     3     87,   88,   89,   90,   91,   92,   92,   94,   95,   96,
     4     97,   97,   99,  100,  101,  102,  103,  104,  105,  106,
     5    107,  108,  108,  110,  111,  112,  113,  114,  115,  115,
     6    117,  118,  119,  120,  121,  122,  123,  124,  125,  126,
     7    127,  128,  129,  130,  131,  132,  133,  134,  135,  136,
     8    137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
     9    147,  148,  149,  150,  150,  152,  153,  154,  155,  156/
            data (jb2(i),i= 6501, 6600)/
     +    157,  158,  159,  160,  161,  162,  162,  164,  165,  166,
     1    167,  168,  169,  170,  171,  172,  173,  174,  175,  175,
     2    177,  178,  179,  180,  181,  182,  183,  183,  185,  186,
     3    187,  188,  189,  189,  191,  192,  193,  194,  195,  196,
     4    197,  197,  199,  200,  201,  201,  203,  204,  205,  206,
     5    207,  208,  208,  210,  211,  212,  213,  214,  215,  216,
     6    217,  218,  219,  220,  221,  222,  222,  224,  225,  226,
     7    227,  228,  229,  229,  231,  232,  233,  234,  235,  235,
     8    237,  238,  239,  240,  241,  241,  243,  244,  245,  246,
     9    247,  248,  249,  250,  251,  252,  253,  254,  255,  256/
            data (jb2(i),i= 6601, 6700)/
     +    257,  258,  258,  260,  261,  262,  263,  264,  265,  266,
     1    267,  268,  269,  270,  271,  272,  273,  274,  275,  275,
     2    277,  278,  279,  280,  281,  282,  283,  284,  285,  286,
     3    287,  287,  289,  290,  291,  292,  293,  294,  294,  296,
     4    297,  298,  298,  300,  301,  302,  303,  304,  305,  305,
     5    307,  308,  309,  310,  311,  312,  313,  313,  315,  316,
     6    317,  318,  319,  320,  321,  322,  323,  324,  325,  325,
     7    327,  328,  329,  330,  331,  332,  333,  334,  335,  336,
     8    337,  338,  339,  340,  341,  342,  343,  344,  344,  346,
     9    347,  348,  349,  350,  350,  352,  353,  354,  355,  356/
            data (jb2(i),i= 6701, 6750)/
     +    357,  357,  359,  360,  361,  362,  363,  364,  365,  366,
     1    367,  367,  369,  370,  371,  372,  372,  374,  375,  376,
     2    377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
     3    387,  388,  389,  390,  391,  391,  393,  394,  395,  396,
     4    397,  398,  399,  400,  401,  402,  402,    0,    0,    0/
c
        state=istate
        irot=jrot
        npart=ipart
        do i=1,5
            jv(i)=kv(i)
            jb(i)=kb(i)
            ib(i)=iib(i)
        enddo
        do i=1,jv(npart+1)-1
            ix(i)=jx(i)
            iy(i)=jy(i)
        enddo
        do i=1,jb(npart+1)-1
            ib1(i)=jb1(i)
            ib2(i)=jb2(i)
        enddo
        return
        end
